/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_d0gd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|gd) integrals */

void d12hrr_order_d0gd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][6][10] = int_stack + 168;
 Libderiv->deriv_classes[2][6][9] = int_stack + 336;
 Libderiv->deriv_classes[2][6][8] = int_stack + 504;
 Libderiv->deriv_classes[2][6][7] = int_stack + 672;
 Libderiv->dvrr_classes[2][5] = int_stack + 840;
 Libderiv->deriv_classes[2][6][6] = int_stack + 966;
 Libderiv->deriv_classes[2][6][2] = int_stack + 1134;
 Libderiv->deriv_classes[2][6][1] = int_stack + 1302;
 Libderiv->deriv_classes[2][6][0] = int_stack + 1470;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 1638;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 1728;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 1854;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 2022;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 2112;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 2238;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 2406;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 2496;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 2622;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 2790;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 2880;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 3006;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 3174;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 3264;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 3390;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 3558;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 3648;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 3774;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 3942;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 4032;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 4158;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 4326;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 4416;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 4542;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 4710;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 4800;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 4926;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 5094;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 5184;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 5310;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 5478;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 5568;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 5694;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 5862;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 5952;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 6078;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 6246;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 6336;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 6462;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 6630;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 6720;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 6846;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 7014;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 7104;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 7230;
 Libderiv->deriv_classes[2][4][11] = int_stack + 7398;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 7488;
 Libderiv->deriv_classes[2][5][11] = int_stack + 7578;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 7704;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 7830;
 Libderiv->deriv_classes[2][4][10] = int_stack + 7998;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 8088;
 Libderiv->deriv_classes[2][5][10] = int_stack + 8178;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 8304;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 8430;
 Libderiv->deriv_classes[2][4][9] = int_stack + 8598;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 8688;
 Libderiv->deriv_classes[2][5][9] = int_stack + 8778;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 8904;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 9030;
 Libderiv->deriv_classes[2][4][8] = int_stack + 9198;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 9288;
 Libderiv->deriv_classes[2][5][8] = int_stack + 9378;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 9504;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 9630;
 Libderiv->deriv_classes[2][4][7] = int_stack + 9798;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 9888;
 Libderiv->deriv_classes[2][5][7] = int_stack + 9978;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 10104;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 10230;
 Libderiv->dvrr_classes[2][4] = int_stack + 10398;
 Libderiv->deriv_classes[2][4][6] = int_stack + 10488;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 10578;
 Libderiv->deriv_classes[2][5][6] = int_stack + 10668;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 10794;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 10920;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 11088;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 11178;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 11304;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 11472;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 11562;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 11688;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 11856;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 11946;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 12072;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 12240;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 12330;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 12456;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 12624;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 12714;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 12840;
 Libderiv->deriv_classes[2][4][2] = int_stack + 13008;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 13098;
 Libderiv->deriv_classes[2][5][2] = int_stack + 13188;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 13314;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 13440;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 13608;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 13698;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 13824;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 13992;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 14082;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 14208;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 14376;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 14466;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 14592;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 14760;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 14850;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 14976;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 15144;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 15234;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 15360;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 15528;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 15618;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 15744;
 Libderiv->deriv_classes[2][4][1] = int_stack + 15912;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 16002;
 Libderiv->deriv_classes[2][5][1] = int_stack + 16092;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 16218;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 16344;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 16512;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 16602;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 16728;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 16896;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 16986;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 17112;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 17280;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 17370;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 17496;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 17664;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 17754;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 17880;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 18048;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 18138;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 18264;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 18432;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 18522;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 18648;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 18816;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 18906;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 19032;
 Libderiv->deriv_classes[2][4][0] = int_stack + 19200;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 19290;
 Libderiv->deriv_classes[2][5][0] = int_stack + 19380;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 19506;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 19632;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 19800;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 19890;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 20016;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 20184;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 20274;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 20400;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 20568;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 20658;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 20784;
 memset(int_stack,0,167616);

 Libderiv->dvrr_stack = int_stack + 38610;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_d0gd(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+20952,int_stack+840,int_stack+10398,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21222,int_stack+7578,int_stack+7398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10398,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21492,int_stack+0,int_stack+7578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21870,int_stack+8178,int_stack+7998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10398, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22140,int_stack+168,int_stack+8178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+8778,int_stack+8598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10398, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22518,int_stack+336,int_stack+8778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22896,int_stack+9378,int_stack+9198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23166,int_stack+504,int_stack+9378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+270,int_stack+9978,int_stack+9798, 0.0, zero_stack, 1.0, int_stack+10398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23544,int_stack+672,int_stack+9978, 0.0, zero_stack, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+540,int_stack+10668,int_stack+10488, 1.0, int_stack+10398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+23922,int_stack+966,int_stack+10668, 1.0, int_stack+840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+810,int_stack+13188,int_stack+13008,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+24300,int_stack+1134,int_stack+13188,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+24678,int_stack+16092,int_stack+15912,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+24948,int_stack+1302,int_stack+16092,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1080,int_stack+19380,int_stack+19200,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+25326,int_stack+1470,int_stack+19380,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+1728,int_stack+1638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7398,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25704,int_stack+1854,int_stack+1728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7578,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1620,int_stack+2112,int_stack+2022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7398, 1.0, int_stack+7998,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26082,int_stack+2238,int_stack+2112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7578, 1.0, int_stack+8178,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1890,int_stack+2496,int_stack+2406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+7998, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26460,int_stack+2622,int_stack+2496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8178, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2160,int_stack+2880,int_stack+2790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7398, 0.0, zero_stack, 1.0, int_stack+8598,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2430,int_stack+3006,int_stack+2880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7578, 0.0, zero_stack, 1.0, int_stack+8778,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2808,int_stack+3264,int_stack+3174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7998, 1.0, int_stack+8598, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+26838,int_stack+3390,int_stack+3264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8178, 1.0, int_stack+8778, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3078,int_stack+3648,int_stack+3558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8598, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+27216,int_stack+3774,int_stack+3648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+8778, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3348,int_stack+4032,int_stack+3942, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7398, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9198,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3618,int_stack+4158,int_stack+4032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7578, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9378,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3996,int_stack+4416,int_stack+4326, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7998, 0.0, zero_stack, 1.0, int_stack+9198, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+27594,int_stack+4542,int_stack+4416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8178, 0.0, zero_stack, 1.0, int_stack+9378, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4266,int_stack+4800,int_stack+4710, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8598, 1.0, int_stack+9198, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+27972,int_stack+4926,int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8778, 1.0, int_stack+9378, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4536,int_stack+5184,int_stack+5094, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4806,int_stack+5310,int_stack+5184, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+9378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5184,int_stack+5568,int_stack+5478, 0.0, zero_stack, 1.0, int_stack+7398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9798,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28350,int_stack+5694,int_stack+5568, 0.0, zero_stack, 1.0, int_stack+7578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9978,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5454,int_stack+5952,int_stack+5862, 0.0, zero_stack, 1.0, int_stack+7998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9798, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+28728,int_stack+6078,int_stack+5952, 0.0, zero_stack, 1.0, int_stack+8178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9978, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5724,int_stack+6336,int_stack+6246, 0.0, zero_stack, 1.0, int_stack+8598, 0.0, zero_stack, 1.0, int_stack+9798, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29106,int_stack+6462,int_stack+6336, 0.0, zero_stack, 1.0, int_stack+8778, 0.0, zero_stack, 1.0, int_stack+9978, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5994,int_stack+6720,int_stack+6630, 0.0, zero_stack, 1.0, int_stack+9198, 1.0, int_stack+9798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+6264,int_stack+6846,int_stack+6720, 0.0, zero_stack, 1.0, int_stack+9378, 1.0, int_stack+9978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6642,int_stack+7104,int_stack+7014, 0.0, zero_stack, 2.0, int_stack+9798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29484,int_stack+7230,int_stack+7104, 0.0, zero_stack, 2.0, int_stack+9978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6912,int_stack+7704,int_stack+7488, 1.0, int_stack+7398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10488,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7182,int_stack+7830,int_stack+7704, 1.0, int_stack+7578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10668,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7560,int_stack+8304,int_stack+8088, 1.0, int_stack+7998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10488, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+29862,int_stack+8430,int_stack+8304, 1.0, int_stack+8178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10668, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7830,int_stack+8904,int_stack+8688, 1.0, int_stack+8598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10488, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8100,int_stack+9030,int_stack+8904, 1.0, int_stack+8778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10668, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8478,int_stack+9504,int_stack+9288, 1.0, int_stack+9198, 0.0, zero_stack, 1.0, int_stack+10488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+8748,int_stack+9630,int_stack+9504, 1.0, int_stack+9378, 0.0, zero_stack, 1.0, int_stack+10668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9126,int_stack+10104,int_stack+9888, 1.0, int_stack+9798, 1.0, int_stack+10488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9396,int_stack+10230,int_stack+10104, 1.0, int_stack+9978, 1.0, int_stack+10668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9774,int_stack+10794,int_stack+10578, 2.0, int_stack+10488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10044,int_stack+10920,int_stack+10794, 2.0, int_stack+10668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10422,int_stack+11178,int_stack+11088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13008,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10692,int_stack+11304,int_stack+11178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13188,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11070,int_stack+11562,int_stack+11472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13008, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30240,int_stack+11688,int_stack+11562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13188, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11340,int_stack+11946,int_stack+11856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13008, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30618,int_stack+12072,int_stack+11946, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13188, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11610,int_stack+12330,int_stack+12240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11880,int_stack+12456,int_stack+12330, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12258,int_stack+12714,int_stack+12624, 0.0, zero_stack, 1.0, int_stack+13008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30996,int_stack+12840,int_stack+12714, 0.0, zero_stack, 1.0, int_stack+13188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12528,int_stack+13314,int_stack+13098, 1.0, int_stack+13008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12798,int_stack+13440,int_stack+13314, 1.0, int_stack+13188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+13176,int_stack+13698,int_stack+13608,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+31374,int_stack+13824,int_stack+13698,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13446,int_stack+14082,int_stack+13992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15912,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31752,int_stack+14208,int_stack+14082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13716,int_stack+14466,int_stack+14376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15912, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13986,int_stack+14592,int_stack+14466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14364,int_stack+14850,int_stack+14760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15912, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32130,int_stack+14976,int_stack+14850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14634,int_stack+15234,int_stack+15144, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32508,int_stack+15360,int_stack+15234, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14904,int_stack+15618,int_stack+15528, 0.0, zero_stack, 1.0, int_stack+15912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15174,int_stack+15744,int_stack+15618, 0.0, zero_stack, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15552,int_stack+16218,int_stack+16002, 1.0, int_stack+15912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+32886,int_stack+16344,int_stack+16218, 1.0, int_stack+16092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+15822,int_stack+16602,int_stack+16512,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+16092,int_stack+16728,int_stack+16602,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+16470,int_stack+16986,int_stack+16896,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+33264,int_stack+17112,int_stack+16986,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16740,int_stack+17370,int_stack+17280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19200,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33642,int_stack+17496,int_stack+17370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19380,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17010,int_stack+17754,int_stack+17664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19200, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+17280,int_stack+17880,int_stack+17754, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19380, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17658,int_stack+18138,int_stack+18048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19200, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34020,int_stack+18264,int_stack+18138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19380, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17928,int_stack+18522,int_stack+18432, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34398,int_stack+18648,int_stack+18522, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18198,int_stack+18906,int_stack+18816, 0.0, zero_stack, 1.0, int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+18468,int_stack+19032,int_stack+18906, 0.0, zero_stack, 1.0, int_stack+19380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18846,int_stack+19506,int_stack+19290, 1.0, int_stack+19200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+34776,int_stack+19632,int_stack+19506, 1.0, int_stack+19380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+19116,int_stack+19890,int_stack+19800,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+19386,int_stack+20016,int_stack+19890,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+19764,int_stack+20274,int_stack+20184,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+35154,int_stack+20400,int_stack+20274,6);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+20034,int_stack+20658,int_stack+20568,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+35532,int_stack+20784,int_stack+20658,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20304,int_stack+21492,int_stack+21222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20952,6);
     Libderiv->ABCD[11] = int_stack + 20304;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+35910,int_stack+22140,int_stack+21870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20952, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 35910;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36450,int_stack+22518,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20952, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 36450;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22140,int_stack+23166,int_stack+22896, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 22140;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36990,int_stack+23544,int_stack+270, 0.0, zero_stack, 1.0, int_stack+20952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 36990;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+23166,int_stack+23922,int_stack+540, 1.0, int_stack+20952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 23166;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+23706,int_stack+24300,int_stack+810,6);
     Libderiv->ABCD[2] = int_stack + 23706;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+37530,int_stack+24948,int_stack+24678,6);
     Libderiv->ABCD[1] = int_stack + 37530;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+38070,int_stack+25326,int_stack+1080,6);
     Libderiv->ABCD[0] = int_stack + 38070;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+24948,int_stack+25704,int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21222,6);
     Libderiv->ABCD[155] = int_stack + 24948;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+25488,int_stack+26082,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21222, 1.0, int_stack+21870,6);
     Libderiv->ABCD[143] = int_stack + 25488;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1350,int_stack+26460,int_stack+1890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+21870, 0.0, zero_stack,6);
     Libderiv->ABCD[142] = int_stack + 1350;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+26028,int_stack+2430,int_stack+2160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21222, 0.0, zero_stack, 1.0, int_stack+0,6);
     Libderiv->ABCD[131] = int_stack + 26028;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1890,int_stack+26838,int_stack+2808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21870, 1.0, int_stack+0, 0.0, zero_stack,6);
     Libderiv->ABCD[130] = int_stack + 1890;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2430,int_stack+27216,int_stack+3078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[129] = int_stack + 2430;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+26568,int_stack+3618,int_stack+3348, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21222, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22896,6);
     Libderiv->ABCD[119] = int_stack + 26568;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2970,int_stack+27594,int_stack+3996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21870, 0.0, zero_stack, 1.0, int_stack+22896, 0.0, zero_stack,6);
     Libderiv->ABCD[118] = int_stack + 2970;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+3510,int_stack+27972,int_stack+4266, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+22896, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[117] = int_stack + 3510;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27108,int_stack+4806,int_stack+4536, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+22896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[116] = int_stack + 27108;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4050,int_stack+28350,int_stack+5184, 0.0, zero_stack, 1.0, int_stack+21222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270,6);
     Libderiv->ABCD[107] = int_stack + 4050;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4590,int_stack+28728,int_stack+5454, 0.0, zero_stack, 1.0, int_stack+21870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack,6);
     Libderiv->ABCD[106] = int_stack + 4590;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5130,int_stack+29106,int_stack+5724, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[105] = int_stack + 5130;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27648,int_stack+6264,int_stack+5994, 0.0, zero_stack, 1.0, int_stack+22896, 1.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[104] = int_stack + 27648;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5670,int_stack+29484,int_stack+6642, 0.0, zero_stack, 2.0, int_stack+270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[103] = int_stack + 5670;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6210,int_stack+7182,int_stack+6912, 1.0, int_stack+21222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540,6);
     Libderiv->ABCD[95] = int_stack + 6210;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6750,int_stack+29862,int_stack+7560, 1.0, int_stack+21870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack,6);
     Libderiv->ABCD[94] = int_stack + 6750;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7290,int_stack+8100,int_stack+7830, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[93] = int_stack + 7290;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7830,int_stack+8748,int_stack+8478, 1.0, int_stack+22896, 0.0, zero_stack, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[92] = int_stack + 7830;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8370,int_stack+9396,int_stack+9126, 1.0, int_stack+270, 1.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[91] = int_stack + 8370;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+10044,int_stack+9774, 2.0, int_stack+540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[90] = int_stack + 0;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8910,int_stack+10692,int_stack+10422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810,6);
     Libderiv->ABCD[47] = int_stack + 8910;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9450,int_stack+30240,int_stack+11070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack,6);
     Libderiv->ABCD[46] = int_stack + 9450;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9990,int_stack+30618,int_stack+11340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[45] = int_stack + 9990;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10530,int_stack+11880,int_stack+11610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[44] = int_stack + 10530;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11070,int_stack+30996,int_stack+12258, 0.0, zero_stack, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[43] = int_stack + 11070;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11610,int_stack+12798,int_stack+12528, 1.0, int_stack+810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[42] = int_stack + 11610;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+540,int_stack+31374,int_stack+13176,6);
     Libderiv->ABCD[38] = int_stack + 540;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12150,int_stack+31752,int_stack+13446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24678,6);
     Libderiv->ABCD[35] = int_stack + 12150;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12690,int_stack+13986,int_stack+13716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24678, 0.0, zero_stack,6);
     Libderiv->ABCD[34] = int_stack + 12690;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13230,int_stack+32130,int_stack+14364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24678, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[33] = int_stack + 13230;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13770,int_stack+32508,int_stack+14634, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[32] = int_stack + 13770;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14310,int_stack+15174,int_stack+14904, 0.0, zero_stack, 1.0, int_stack+24678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[31] = int_stack + 14310;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14850,int_stack+32886,int_stack+15552, 1.0, int_stack+24678, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[30] = int_stack + 14850;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+28188,int_stack+16092,int_stack+15822,6);
     Libderiv->ABCD[26] = int_stack + 28188;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+15390,int_stack+33264,int_stack+16470,6);
     Libderiv->ABCD[25] = int_stack + 15390;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+15930,int_stack+33642,int_stack+16740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080,6);
     Libderiv->ABCD[23] = int_stack + 15930;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+16470,int_stack+17280,int_stack+17010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack,6);
     Libderiv->ABCD[22] = int_stack + 16470;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17010,int_stack+34020,int_stack+17658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[21] = int_stack + 17010;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+28728,int_stack+34398,int_stack+17928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[20] = int_stack + 28728;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17550,int_stack+18468,int_stack+18198, 0.0, zero_stack, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[19] = int_stack + 17550;
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18090,int_stack+34776,int_stack+18846, 1.0, int_stack+1080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[18] = int_stack + 18090;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+29268,int_stack+19386,int_stack+19116,6);
     Libderiv->ABCD[14] = int_stack + 29268;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+18630,int_stack+35154,int_stack+19764,6);
     Libderiv->ABCD[13] = int_stack + 18630;
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+19170,int_stack+35532,int_stack+20034,6);
     Libderiv->ABCD[12] = int_stack + 19170;

}
