/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_fpgp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|gp) integrals */

void d12hrr_order_fpgp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][5][10] = int_stack + 315;
 Libderiv->deriv_classes[4][5][9] = int_stack + 630;
 Libderiv->deriv_classes[4][5][8] = int_stack + 945;
 Libderiv->deriv_classes[4][5][7] = int_stack + 1260;
 Libderiv->dvrr_classes[4][4] = int_stack + 1575;
 Libderiv->deriv_classes[4][5][6] = int_stack + 1800;
 Libderiv->deriv_classes[4][5][2] = int_stack + 2115;
 Libderiv->deriv_classes[4][5][1] = int_stack + 2430;
 Libderiv->dvrr_classes[3][5] = int_stack + 2745;
 Libderiv->deriv_classes[4][5][0] = int_stack + 2955;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 3270;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 3420;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 3630;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 3855;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 4170;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 4320;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 4530;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 4755;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 5070;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 5220;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 5430;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 5655;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 5970;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 6120;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 6330;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 6555;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 6870;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 7020;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 7230;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 7455;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 7770;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 7920;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 8130;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 8355;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 8670;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 8820;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 9030;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 9255;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 9570;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 9720;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 9930;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 10155;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 10470;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 10620;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 10830;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 11055;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 11370;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 11520;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 11730;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 11955;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 12270;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 12420;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 12630;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 12855;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 13170;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 13320;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 13530;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 13755;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 14070;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 14220;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 14430;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 14655;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 14970;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 15120;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 15330;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 15555;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 15870;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 16020;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 16230;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 16455;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 16770;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 16920;
 Libderiv->deriv_classes[4][4][11] = int_stack + 17130;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 17355;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 17580;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 17895;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 18045;
 Libderiv->deriv_classes[4][4][10] = int_stack + 18255;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 18480;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 18705;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 19020;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 19170;
 Libderiv->deriv_classes[4][4][9] = int_stack + 19380;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 19605;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 19830;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 20145;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 20295;
 Libderiv->deriv_classes[4][4][8] = int_stack + 20505;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 20730;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 20955;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 21270;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 21420;
 Libderiv->deriv_classes[4][4][7] = int_stack + 21630;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 21855;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 22080;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 22395;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 22545;
 Libderiv->deriv_classes[4][4][6] = int_stack + 22755;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 22980;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 23205;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 23520;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 23670;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 23880;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 24105;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 24420;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 24570;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 24780;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 25005;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 25320;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 25470;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 25680;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 25905;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 26220;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 26370;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 26580;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 26805;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 27120;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 27270;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 27480;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 27705;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 28020;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 28170;
 Libderiv->deriv_classes[4][4][2] = int_stack + 28380;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 28605;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 28830;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 29145;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 29295;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 29505;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 29730;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 30045;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 30195;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 30405;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 30630;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 30945;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 31095;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 31305;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 31530;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 31845;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 31995;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 32205;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 32430;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 32745;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 32895;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 33105;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 33330;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 33645;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 33795;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 34005;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 34230;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 34545;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 34695;
 Libderiv->deriv_classes[4][4][1] = int_stack + 34905;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 35130;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 35355;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 35670;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 35820;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 36030;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 36255;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 36570;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 36720;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 36930;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 37155;
 Libderiv->deriv_classes[3][4][11] = int_stack + 37470;
 Libderiv->deriv_classes[3][5][11] = int_stack + 37620;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 37830;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 37980;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 38190;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 38415;
 Libderiv->deriv_classes[3][4][10] = int_stack + 38730;
 Libderiv->deriv_classes[3][5][10] = int_stack + 38880;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 39090;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 39240;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 39450;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 39675;
 Libderiv->deriv_classes[3][4][9] = int_stack + 39990;
 Libderiv->deriv_classes[3][5][9] = int_stack + 40140;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 40350;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 40500;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 40710;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 40935;
 Libderiv->deriv_classes[3][4][8] = int_stack + 41250;
 Libderiv->deriv_classes[3][5][8] = int_stack + 41400;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 41610;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 41760;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 41970;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 42195;
 Libderiv->deriv_classes[3][4][7] = int_stack + 42510;
 Libderiv->deriv_classes[3][5][7] = int_stack + 42660;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 42870;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 43020;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 43230;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 43455;
 Libderiv->dvrr_classes[3][4] = int_stack + 43770;
 Libderiv->deriv_classes[3][4][6] = int_stack + 43920;
 Libderiv->deriv_classes[3][5][6] = int_stack + 44070;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 44280;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 44430;
 Libderiv->deriv_classes[4][4][0] = int_stack + 44640;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 44865;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 45090;
 Libderiv->deriv_classes[3][4][2] = int_stack + 45405;
 Libderiv->deriv_classes[3][5][2] = int_stack + 45555;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 45765;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 45915;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 46125;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 46350;
 Libderiv->deriv_classes[3][4][1] = int_stack + 46665;
 Libderiv->deriv_classes[3][5][1] = int_stack + 46815;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 47025;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 47175;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 47385;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 47610;
 Libderiv->deriv_classes[3][4][0] = int_stack + 47925;
 Libderiv->deriv_classes[3][5][0] = int_stack + 48075;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 48285;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 48435;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 48645;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 48870;
 memset(int_stack,0,393480);

 Libderiv->dvrr_stack = int_stack + 79335;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_fpgp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+49185,int_stack+37620,int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43770,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+49635,int_stack+0,int_stack+17130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50310,int_stack+38880,int_stack+38730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43770, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50760,int_stack+315,int_stack+18255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+40140,int_stack+39990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43770, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+51435,int_stack+630,int_stack+19380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+450,int_stack+41400,int_stack+41250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+52110,int_stack+945,int_stack+20505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+52785,int_stack+42660,int_stack+42510, 0.0, zero_stack, 1.0, int_stack+43770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+53235,int_stack+1260,int_stack+21630, 0.0, zero_stack, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+900,int_stack+44070,int_stack+43920, 1.0, int_stack+43770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+53910,int_stack+1800,int_stack+22755, 1.0, int_stack+1575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+2745,int_stack+43770,10);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+54585,int_stack+45555,int_stack+45405,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+55035,int_stack+2115,int_stack+28380,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1800,int_stack+46815,int_stack+46665,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+55710,int_stack+2430,int_stack+34905,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+2250,int_stack+48075,int_stack+47925,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+56385,int_stack+2955,int_stack+44640,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2700,int_stack+3420,int_stack+3270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+37470,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+57060,int_stack+3855,int_stack+3630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+17130,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3150,int_stack+4320,int_stack+4170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37470, 1.0, int_stack+38730,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3600,int_stack+4755,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17130, 1.0, int_stack+18255,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4275,int_stack+5220,int_stack+5070, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+38730, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4725,int_stack+5655,int_stack+5430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+18255, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5400,int_stack+6120,int_stack+5970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37470, 0.0, zero_stack, 1.0, int_stack+39990,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+57735,int_stack+6555,int_stack+6330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17130, 0.0, zero_stack, 1.0, int_stack+19380,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5850,int_stack+7020,int_stack+6870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38730, 1.0, int_stack+39990, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6300,int_stack+7455,int_stack+7230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18255, 1.0, int_stack+19380, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6975,int_stack+7920,int_stack+7770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+39990, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7425,int_stack+8355,int_stack+8130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+19380, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8100,int_stack+8820,int_stack+8670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+41250,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+58410,int_stack+9255,int_stack+9030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17130, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20505,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+8550,int_stack+9720,int_stack+9570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38730, 0.0, zero_stack, 1.0, int_stack+41250, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9000,int_stack+10155,int_stack+9930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+18255, 0.0, zero_stack, 1.0, int_stack+20505, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9675,int_stack+10620,int_stack+10470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39990, 1.0, int_stack+41250, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10125,int_stack+11055,int_stack+10830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19380, 1.0, int_stack+20505, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+10800,int_stack+11520,int_stack+11370, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+41250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+59085,int_stack+11955,int_stack+11730, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+20505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11250,int_stack+12420,int_stack+12270, 0.0, zero_stack, 1.0, int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42510,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+11700,int_stack+12855,int_stack+12630, 0.0, zero_stack, 1.0, int_stack+17130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21630,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12375,int_stack+13320,int_stack+13170, 0.0, zero_stack, 1.0, int_stack+38730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42510, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12825,int_stack+13755,int_stack+13530, 0.0, zero_stack, 1.0, int_stack+18255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21630, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13500,int_stack+14220,int_stack+14070, 0.0, zero_stack, 1.0, int_stack+39990, 0.0, zero_stack, 1.0, int_stack+42510, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+59760,int_stack+14655,int_stack+14430, 0.0, zero_stack, 1.0, int_stack+19380, 0.0, zero_stack, 1.0, int_stack+21630, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13950,int_stack+15120,int_stack+14970, 0.0, zero_stack, 1.0, int_stack+41250, 1.0, int_stack+42510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14400,int_stack+15555,int_stack+15330, 0.0, zero_stack, 1.0, int_stack+20505, 1.0, int_stack+21630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15075,int_stack+16020,int_stack+15870, 0.0, zero_stack, 2.0, int_stack+42510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+15525,int_stack+16455,int_stack+16230, 0.0, zero_stack, 2.0, int_stack+21630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16200,int_stack+16920,int_stack+16770, 1.0, int_stack+37470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43920,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+60435,int_stack+17580,int_stack+17355, 1.0, int_stack+17130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22755,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+16650,int_stack+18045,int_stack+17895, 1.0, int_stack+38730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43920, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17100,int_stack+18705,int_stack+18480, 1.0, int_stack+18255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22755, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+17775,int_stack+19170,int_stack+19020, 1.0, int_stack+39990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43920, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18225,int_stack+19830,int_stack+19605, 1.0, int_stack+19380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22755, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+18900,int_stack+20295,int_stack+20145, 1.0, int_stack+41250, 0.0, zero_stack, 1.0, int_stack+43920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19350,int_stack+20955,int_stack+20730, 1.0, int_stack+20505, 0.0, zero_stack, 1.0, int_stack+22755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20025,int_stack+21420,int_stack+21270, 1.0, int_stack+42510, 1.0, int_stack+43920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+20475,int_stack+22080,int_stack+21855, 1.0, int_stack+21630, 1.0, int_stack+22755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21150,int_stack+22545,int_stack+22395, 2.0, int_stack+43920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+21600,int_stack+23205,int_stack+22980, 2.0, int_stack+22755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+43770,int_stack+23670,int_stack+23520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45405,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22275,int_stack+24105,int_stack+23880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28380,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22950,int_stack+24570,int_stack+24420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45405, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+23400,int_stack+25005,int_stack+24780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28380, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24075,int_stack+25470,int_stack+25320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45405, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24525,int_stack+25905,int_stack+25680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28380, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25200,int_stack+26370,int_stack+26220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+25650,int_stack+26805,int_stack+26580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+28380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26325,int_stack+27270,int_stack+27120, 0.0, zero_stack, 1.0, int_stack+45405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26775,int_stack+27705,int_stack+27480, 0.0, zero_stack, 1.0, int_stack+28380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+27450,int_stack+28170,int_stack+28020, 1.0, int_stack+45405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+61110,int_stack+28830,int_stack+28605, 1.0, int_stack+28380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+27900,int_stack+29295,int_stack+29145,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+28350,int_stack+29730,int_stack+29505,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+29025,int_stack+30195,int_stack+30045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46665,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+29475,int_stack+30630,int_stack+30405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34905,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+30150,int_stack+31095,int_stack+30945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46665, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+30600,int_stack+31530,int_stack+31305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34905, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+31275,int_stack+31995,int_stack+31845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46665, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+61785,int_stack+32430,int_stack+32205, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34905, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+31725,int_stack+32895,int_stack+32745, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32175,int_stack+33330,int_stack+33105, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+32850,int_stack+33795,int_stack+33645, 0.0, zero_stack, 1.0, int_stack+46665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33300,int_stack+34230,int_stack+34005, 0.0, zero_stack, 1.0, int_stack+34905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+33975,int_stack+34695,int_stack+34545, 1.0, int_stack+46665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+62460,int_stack+35355,int_stack+35130, 1.0, int_stack+34905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+34425,int_stack+35820,int_stack+35670,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+34875,int_stack+36255,int_stack+36030,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+35550,int_stack+36720,int_stack+36570,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+36000,int_stack+37155,int_stack+36930,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+36675,int_stack+37980,int_stack+37830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47925,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+37125,int_stack+38415,int_stack+38190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44640,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+37800,int_stack+39240,int_stack+39090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47925, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38250,int_stack+39675,int_stack+39450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44640, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+38925,int_stack+40500,int_stack+40350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47925, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+39375,int_stack+40935,int_stack+40710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+40050,int_stack+41760,int_stack+41610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+40500,int_stack+42195,int_stack+41970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+44640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41175,int_stack+43020,int_stack+42870, 0.0, zero_stack, 1.0, int_stack+47925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41625,int_stack+43455,int_stack+43230, 0.0, zero_stack, 1.0, int_stack+44640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42300,int_stack+44430,int_stack+44280, 1.0, int_stack+47925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+42750,int_stack+45090,int_stack+44865, 1.0, int_stack+44640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+44220,int_stack+45915,int_stack+45765,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+44670,int_stack+46350,int_stack+46125,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+45345,int_stack+47175,int_stack+47025,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+45795,int_stack+47610,int_stack+47385,15);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+46470,int_stack+48435,int_stack+48285,10);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+46920,int_stack+48870,int_stack+48645,15);
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+47595,int_stack+49635,int_stack+49185,45);
     Libderiv->ABCD[11] = int_stack + 47595;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+63135,int_stack+50760,int_stack+50310,45);
     Libderiv->ABCD[10] = int_stack + 63135;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+64485,int_stack+51435,int_stack+0,45);
     Libderiv->ABCD[9] = int_stack + 64485;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+50760,int_stack+52110,int_stack+450,45);
     Libderiv->ABCD[8] = int_stack + 50760;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+65835,int_stack+53235,int_stack+52785,45);
     Libderiv->ABCD[7] = int_stack + 65835;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+67185,int_stack+53910,int_stack+900,45);
     Libderiv->ABCD[6] = int_stack + 67185;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+53235,int_stack+55035,int_stack+54585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[2] = int_stack + 53235;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+68535,int_stack+55710,int_stack+1800, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[1] = int_stack + 68535;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+55035,int_stack+56385,int_stack+2250, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[0] = int_stack + 55035;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+69885,int_stack+57060,int_stack+2700,45);
     Libderiv->ABCD[155] = int_stack + 69885;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+56385,int_stack+3600,int_stack+3150,45);
     Libderiv->ABCD[143] = int_stack + 56385;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2700,int_stack+4725,int_stack+4275,45);
     Libderiv->ABCD[142] = int_stack + 2700;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+4050,int_stack+57735,int_stack+5400,45);
     Libderiv->ABCD[131] = int_stack + 4050;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+71235,int_stack+6300,int_stack+5850,45);
     Libderiv->ABCD[130] = int_stack + 71235;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+5400,int_stack+7425,int_stack+6975,45);
     Libderiv->ABCD[129] = int_stack + 5400;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+6750,int_stack+58410,int_stack+8100,45);
     Libderiv->ABCD[119] = int_stack + 6750;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+57735,int_stack+9000,int_stack+8550,45);
     Libderiv->ABCD[118] = int_stack + 57735;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+8100,int_stack+10125,int_stack+9675,45);
     Libderiv->ABCD[117] = int_stack + 8100;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+9450,int_stack+59085,int_stack+10800,45);
     Libderiv->ABCD[116] = int_stack + 9450;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+72585,int_stack+11700,int_stack+11250,45);
     Libderiv->ABCD[107] = int_stack + 72585;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+10800,int_stack+12825,int_stack+12375,45);
     Libderiv->ABCD[106] = int_stack + 10800;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12150,int_stack+59760,int_stack+13500,45);
     Libderiv->ABCD[105] = int_stack + 12150;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+59085,int_stack+14400,int_stack+13950,45);
     Libderiv->ABCD[104] = int_stack + 59085;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+13500,int_stack+15525,int_stack+15075,45);
     Libderiv->ABCD[103] = int_stack + 13500;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+14850,int_stack+60435,int_stack+16200,45);
     Libderiv->ABCD[95] = int_stack + 14850;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+73935,int_stack+17100,int_stack+16650,45);
     Libderiv->ABCD[94] = int_stack + 73935;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+16200,int_stack+18225,int_stack+17775,45);
     Libderiv->ABCD[93] = int_stack + 16200;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+17550,int_stack+19350,int_stack+18900,45);
     Libderiv->ABCD[92] = int_stack + 17550;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+75285,int_stack+20475,int_stack+20025,45);
     Libderiv->ABCD[91] = int_stack + 75285;
 /*--- compute (fp|gp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+18900,int_stack+21600,int_stack+21150,45);
     Libderiv->ABCD[90] = int_stack + 18900;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+20250,int_stack+22275,int_stack+43770, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[47] = int_stack + 20250;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+21600,int_stack+23400,int_stack+22950, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+50310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[46] = int_stack + 21600;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+76635,int_stack+24525,int_stack+24075, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[45] = int_stack + 76635;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+22950,int_stack+25650,int_stack+25200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[44] = int_stack + 22950;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+24300,int_stack+26775,int_stack+26325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+52785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[43] = int_stack + 24300;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+25650,int_stack+61110,int_stack+27450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[42] = int_stack + 25650;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+60435,int_stack+28350,int_stack+27900, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+54585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[38] = int_stack + 60435;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+27000,int_stack+29475,int_stack+29025, 0.0, zero_stack, 1.0, int_stack+49185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[35] = int_stack + 27000;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+28350,int_stack+30600,int_stack+30150, 0.0, zero_stack, 1.0, int_stack+50310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[34] = int_stack + 28350;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+29700,int_stack+61785,int_stack+31275, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[33] = int_stack + 29700;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+77985,int_stack+32175,int_stack+31725, 0.0, zero_stack, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[32] = int_stack + 77985;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+31050,int_stack+33300,int_stack+32850, 0.0, zero_stack, 1.0, int_stack+52785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[31] = int_stack + 31050;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+32400,int_stack+62460,int_stack+33975, 0.0, zero_stack, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[30] = int_stack + 32400;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+61785,int_stack+34875,int_stack+34425, 0.0, zero_stack, 1.0, int_stack+54585, 1.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[26] = int_stack + 61785;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+33750,int_stack+36000,int_stack+35550, 0.0, zero_stack, 2.0, int_stack+1800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[25] = int_stack + 33750;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+35100,int_stack+37125,int_stack+36675, 1.0, int_stack+49185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[23] = int_stack + 35100;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+36450,int_stack+38250,int_stack+37800, 1.0, int_stack+50310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[22] = int_stack + 36450;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+48945,int_stack+39375,int_stack+38925, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[21] = int_stack + 48945;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+37800,int_stack+40500,int_stack+40050, 1.0, int_stack+450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[20] = int_stack + 37800;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+39150,int_stack+41625,int_stack+41175, 1.0, int_stack+52785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[19] = int_stack + 39150;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+40500,int_stack+42750,int_stack+42300, 1.0, int_stack+900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[18] = int_stack + 40500;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+44670,int_stack+44220, 1.0, int_stack+54585, 0.0, zero_stack, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[14] = int_stack + 0;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+41850,int_stack+45795,int_stack+45345, 1.0, int_stack+1800, 1.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[13] = int_stack + 41850;
 /*--- compute (fp|gp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+43200,int_stack+46920,int_stack+46470, 2.0, int_stack+2250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
     Libderiv->ABCD[12] = int_stack + 43200;

}
