/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* This machine-generated function computes a quartet of |ld) first derivative ERIs */

void d1hrr3_build_ld(const double *CD, double *vp, const double *I0, const double *I1,
        double c2, const double *I2, double c3, const double *I3, double c4, const double *I4,
        double c5, const double *I5, double c6, const double *I6, double c7, const double *I7, int ab_num)
{
  int ab;
  const double CD0 = CD[0];
  const double CD1 = CD[1];
  const double CD2 = CD[2];
  for(ab=0;ab<ab_num;ab++) {
    *(vp++) = I0[0] + CD0*I1[0] + c2*I2[0] - c5*I5[0];
    *(vp++) = I0[1] + CD0*I1[1] + c2*I2[1] - c5*I5[1];
    *(vp++) = I0[2] + CD0*I1[2] + c2*I2[2] - c5*I5[2];
    *(vp++) = I0[4] + CD1*I1[1] + c3*I3[1] - c6*I6[1];
    *(vp++) = I0[5] + CD1*I1[2] + c3*I3[2] - c6*I6[2];
    *(vp++) = I0[8] + CD2*I1[2] + c4*I4[2] - c7*I7[2];
    *(vp++) = I0[3] + CD0*I1[3] + c2*I2[3] - c5*I5[3];
    *(vp++) = I0[4] + CD0*I1[4] + c2*I2[4] - c5*I5[4];
    *(vp++) = I0[5] + CD0*I1[5] + c2*I2[5] - c5*I5[5];
    *(vp++) = I0[10] + CD1*I1[4] + c3*I3[4] - c6*I6[4];
    *(vp++) = I0[11] + CD1*I1[5] + c3*I3[5] - c6*I6[5];
    *(vp++) = I0[14] + CD2*I1[5] + c4*I4[5] - c7*I7[5];
    *(vp++) = I0[6] + CD0*I1[6] + c2*I2[6] - c5*I5[6];
    *(vp++) = I0[7] + CD0*I1[7] + c2*I2[7] - c5*I5[7];
    *(vp++) = I0[8] + CD0*I1[8] + c2*I2[8] - c5*I5[8];
    *(vp++) = I0[13] + CD1*I1[7] + c3*I3[7] - c6*I6[7];
    *(vp++) = I0[14] + CD1*I1[8] + c3*I3[8] - c6*I6[8];
    *(vp++) = I0[17] + CD2*I1[8] + c4*I4[8] - c7*I7[8];
    *(vp++) = I0[9] + CD0*I1[9] + c2*I2[9] - c5*I5[9];
    *(vp++) = I0[10] + CD0*I1[10] + c2*I2[10] - c5*I5[10];
    *(vp++) = I0[11] + CD0*I1[11] + c2*I2[11] - c5*I5[11];
    *(vp++) = I0[19] + CD1*I1[10] + c3*I3[10] - c6*I6[10];
    *(vp++) = I0[20] + CD1*I1[11] + c3*I3[11] - c6*I6[11];
    *(vp++) = I0[23] + CD2*I1[11] + c4*I4[11] - c7*I7[11];
    *(vp++) = I0[12] + CD0*I1[12] + c2*I2[12] - c5*I5[12];
    *(vp++) = I0[13] + CD0*I1[13] + c2*I2[13] - c5*I5[13];
    *(vp++) = I0[14] + CD0*I1[14] + c2*I2[14] - c5*I5[14];
    *(vp++) = I0[22] + CD1*I1[13] + c3*I3[13] - c6*I6[13];
    *(vp++) = I0[23] + CD1*I1[14] + c3*I3[14] - c6*I6[14];
    *(vp++) = I0[26] + CD2*I1[14] + c4*I4[14] - c7*I7[14];
    *(vp++) = I0[15] + CD0*I1[15] + c2*I2[15] - c5*I5[15];
    *(vp++) = I0[16] + CD0*I1[16] + c2*I2[16] - c5*I5[16];
    *(vp++) = I0[17] + CD0*I1[17] + c2*I2[17] - c5*I5[17];
    *(vp++) = I0[25] + CD1*I1[16] + c3*I3[16] - c6*I6[16];
    *(vp++) = I0[26] + CD1*I1[17] + c3*I3[17] - c6*I6[17];
    *(vp++) = I0[29] + CD2*I1[17] + c4*I4[17] - c7*I7[17];
    *(vp++) = I0[18] + CD0*I1[18] + c2*I2[18] - c5*I5[18];
    *(vp++) = I0[19] + CD0*I1[19] + c2*I2[19] - c5*I5[19];
    *(vp++) = I0[20] + CD0*I1[20] + c2*I2[20] - c5*I5[20];
    *(vp++) = I0[31] + CD1*I1[19] + c3*I3[19] - c6*I6[19];
    *(vp++) = I0[32] + CD1*I1[20] + c3*I3[20] - c6*I6[20];
    *(vp++) = I0[35] + CD2*I1[20] + c4*I4[20] - c7*I7[20];
    *(vp++) = I0[21] + CD0*I1[21] + c2*I2[21] - c5*I5[21];
    *(vp++) = I0[22] + CD0*I1[22] + c2*I2[22] - c5*I5[22];
    *(vp++) = I0[23] + CD0*I1[23] + c2*I2[23] - c5*I5[23];
    *(vp++) = I0[34] + CD1*I1[22] + c3*I3[22] - c6*I6[22];
    *(vp++) = I0[35] + CD1*I1[23] + c3*I3[23] - c6*I6[23];
    *(vp++) = I0[38] + CD2*I1[23] + c4*I4[23] - c7*I7[23];
    *(vp++) = I0[24] + CD0*I1[24] + c2*I2[24] - c5*I5[24];
    *(vp++) = I0[25] + CD0*I1[25] + c2*I2[25] - c5*I5[25];
    *(vp++) = I0[26] + CD0*I1[26] + c2*I2[26] - c5*I5[26];
    *(vp++) = I0[37] + CD1*I1[25] + c3*I3[25] - c6*I6[25];
    *(vp++) = I0[38] + CD1*I1[26] + c3*I3[26] - c6*I6[26];
    *(vp++) = I0[41] + CD2*I1[26] + c4*I4[26] - c7*I7[26];
    *(vp++) = I0[27] + CD0*I1[27] + c2*I2[27] - c5*I5[27];
    *(vp++) = I0[28] + CD0*I1[28] + c2*I2[28] - c5*I5[28];
    *(vp++) = I0[29] + CD0*I1[29] + c2*I2[29] - c5*I5[29];
    *(vp++) = I0[40] + CD1*I1[28] + c3*I3[28] - c6*I6[28];
    *(vp++) = I0[41] + CD1*I1[29] + c3*I3[29] - c6*I6[29];
    *(vp++) = I0[44] + CD2*I1[29] + c4*I4[29] - c7*I7[29];
    *(vp++) = I0[30] + CD0*I1[30] + c2*I2[30] - c5*I5[30];
    *(vp++) = I0[31] + CD0*I1[31] + c2*I2[31] - c5*I5[31];
    *(vp++) = I0[32] + CD0*I1[32] + c2*I2[32] - c5*I5[32];
    *(vp++) = I0[46] + CD1*I1[31] + c3*I3[31] - c6*I6[31];
    *(vp++) = I0[47] + CD1*I1[32] + c3*I3[32] - c6*I6[32];
    *(vp++) = I0[50] + CD2*I1[32] + c4*I4[32] - c7*I7[32];
    *(vp++) = I0[33] + CD0*I1[33] + c2*I2[33] - c5*I5[33];
    *(vp++) = I0[34] + CD0*I1[34] + c2*I2[34] - c5*I5[34];
    *(vp++) = I0[35] + CD0*I1[35] + c2*I2[35] - c5*I5[35];
    *(vp++) = I0[49] + CD1*I1[34] + c3*I3[34] - c6*I6[34];
    *(vp++) = I0[50] + CD1*I1[35] + c3*I3[35] - c6*I6[35];
    *(vp++) = I0[53] + CD2*I1[35] + c4*I4[35] - c7*I7[35];
    *(vp++) = I0[36] + CD0*I1[36] + c2*I2[36] - c5*I5[36];
    *(vp++) = I0[37] + CD0*I1[37] + c2*I2[37] - c5*I5[37];
    *(vp++) = I0[38] + CD0*I1[38] + c2*I2[38] - c5*I5[38];
    *(vp++) = I0[52] + CD1*I1[37] + c3*I3[37] - c6*I6[37];
    *(vp++) = I0[53] + CD1*I1[38] + c3*I3[38] - c6*I6[38];
    *(vp++) = I0[56] + CD2*I1[38] + c4*I4[38] - c7*I7[38];
    *(vp++) = I0[39] + CD0*I1[39] + c2*I2[39] - c5*I5[39];
    *(vp++) = I0[40] + CD0*I1[40] + c2*I2[40] - c5*I5[40];
    *(vp++) = I0[41] + CD0*I1[41] + c2*I2[41] - c5*I5[41];
    *(vp++) = I0[55] + CD1*I1[40] + c3*I3[40] - c6*I6[40];
    *(vp++) = I0[56] + CD1*I1[41] + c3*I3[41] - c6*I6[41];
    *(vp++) = I0[59] + CD2*I1[41] + c4*I4[41] - c7*I7[41];
    *(vp++) = I0[42] + CD0*I1[42] + c2*I2[42] - c5*I5[42];
    *(vp++) = I0[43] + CD0*I1[43] + c2*I2[43] - c5*I5[43];
    *(vp++) = I0[44] + CD0*I1[44] + c2*I2[44] - c5*I5[44];
    *(vp++) = I0[58] + CD1*I1[43] + c3*I3[43] - c6*I6[43];
    *(vp++) = I0[59] + CD1*I1[44] + c3*I3[44] - c6*I6[44];
    *(vp++) = I0[62] + CD2*I1[44] + c4*I4[44] - c7*I7[44];
    *(vp++) = I0[45] + CD0*I1[45] + c2*I2[45] - c5*I5[45];
    *(vp++) = I0[46] + CD0*I1[46] + c2*I2[46] - c5*I5[46];
    *(vp++) = I0[47] + CD0*I1[47] + c2*I2[47] - c5*I5[47];
    *(vp++) = I0[64] + CD1*I1[46] + c3*I3[46] - c6*I6[46];
    *(vp++) = I0[65] + CD1*I1[47] + c3*I3[47] - c6*I6[47];
    *(vp++) = I0[68] + CD2*I1[47] + c4*I4[47] - c7*I7[47];
    *(vp++) = I0[48] + CD0*I1[48] + c2*I2[48] - c5*I5[48];
    *(vp++) = I0[49] + CD0*I1[49] + c2*I2[49] - c5*I5[49];
    *(vp++) = I0[50] + CD0*I1[50] + c2*I2[50] - c5*I5[50];
    *(vp++) = I0[67] + CD1*I1[49] + c3*I3[49] - c6*I6[49];
    *(vp++) = I0[68] + CD1*I1[50] + c3*I3[50] - c6*I6[50];
    *(vp++) = I0[71] + CD2*I1[50] + c4*I4[50] - c7*I7[50];
    *(vp++) = I0[51] + CD0*I1[51] + c2*I2[51] - c5*I5[51];
    *(vp++) = I0[52] + CD0*I1[52] + c2*I2[52] - c5*I5[52];
    *(vp++) = I0[53] + CD0*I1[53] + c2*I2[53] - c5*I5[53];
    *(vp++) = I0[70] + CD1*I1[52] + c3*I3[52] - c6*I6[52];
    *(vp++) = I0[71] + CD1*I1[53] + c3*I3[53] - c6*I6[53];
    *(vp++) = I0[74] + CD2*I1[53] + c4*I4[53] - c7*I7[53];
    *(vp++) = I0[54] + CD0*I1[54] + c2*I2[54] - c5*I5[54];
    *(vp++) = I0[55] + CD0*I1[55] + c2*I2[55] - c5*I5[55];
    *(vp++) = I0[56] + CD0*I1[56] + c2*I2[56] - c5*I5[56];
    *(vp++) = I0[73] + CD1*I1[55] + c3*I3[55] - c6*I6[55];
    *(vp++) = I0[74] + CD1*I1[56] + c3*I3[56] - c6*I6[56];
    *(vp++) = I0[77] + CD2*I1[56] + c4*I4[56] - c7*I7[56];
    *(vp++) = I0[57] + CD0*I1[57] + c2*I2[57] - c5*I5[57];
    *(vp++) = I0[58] + CD0*I1[58] + c2*I2[58] - c5*I5[58];
    *(vp++) = I0[59] + CD0*I1[59] + c2*I2[59] - c5*I5[59];
    *(vp++) = I0[76] + CD1*I1[58] + c3*I3[58] - c6*I6[58];
    *(vp++) = I0[77] + CD1*I1[59] + c3*I3[59] - c6*I6[59];
    *(vp++) = I0[80] + CD2*I1[59] + c4*I4[59] - c7*I7[59];
    *(vp++) = I0[60] + CD0*I1[60] + c2*I2[60] - c5*I5[60];
    *(vp++) = I0[61] + CD0*I1[61] + c2*I2[61] - c5*I5[61];
    *(vp++) = I0[62] + CD0*I1[62] + c2*I2[62] - c5*I5[62];
    *(vp++) = I0[79] + CD1*I1[61] + c3*I3[61] - c6*I6[61];
    *(vp++) = I0[80] + CD1*I1[62] + c3*I3[62] - c6*I6[62];
    *(vp++) = I0[83] + CD2*I1[62] + c4*I4[62] - c7*I7[62];
    *(vp++) = I0[63] + CD0*I1[63] + c2*I2[63] - c5*I5[63];
    *(vp++) = I0[64] + CD0*I1[64] + c2*I2[64] - c5*I5[64];
    *(vp++) = I0[65] + CD0*I1[65] + c2*I2[65] - c5*I5[65];
    *(vp++) = I0[85] + CD1*I1[64] + c3*I3[64] - c6*I6[64];
    *(vp++) = I0[86] + CD1*I1[65] + c3*I3[65] - c6*I6[65];
    *(vp++) = I0[89] + CD2*I1[65] + c4*I4[65] - c7*I7[65];
    *(vp++) = I0[66] + CD0*I1[66] + c2*I2[66] - c5*I5[66];
    *(vp++) = I0[67] + CD0*I1[67] + c2*I2[67] - c5*I5[67];
    *(vp++) = I0[68] + CD0*I1[68] + c2*I2[68] - c5*I5[68];
    *(vp++) = I0[88] + CD1*I1[67] + c3*I3[67] - c6*I6[67];
    *(vp++) = I0[89] + CD1*I1[68] + c3*I3[68] - c6*I6[68];
    *(vp++) = I0[92] + CD2*I1[68] + c4*I4[68] - c7*I7[68];
    *(vp++) = I0[69] + CD0*I1[69] + c2*I2[69] - c5*I5[69];
    *(vp++) = I0[70] + CD0*I1[70] + c2*I2[70] - c5*I5[70];
    *(vp++) = I0[71] + CD0*I1[71] + c2*I2[71] - c5*I5[71];
    *(vp++) = I0[91] + CD1*I1[70] + c3*I3[70] - c6*I6[70];
    *(vp++) = I0[92] + CD1*I1[71] + c3*I3[71] - c6*I6[71];
    *(vp++) = I0[95] + CD2*I1[71] + c4*I4[71] - c7*I7[71];
    *(vp++) = I0[72] + CD0*I1[72] + c2*I2[72] - c5*I5[72];
    *(vp++) = I0[73] + CD0*I1[73] + c2*I2[73] - c5*I5[73];
    *(vp++) = I0[74] + CD0*I1[74] + c2*I2[74] - c5*I5[74];
    *(vp++) = I0[94] + CD1*I1[73] + c3*I3[73] - c6*I6[73];
    *(vp++) = I0[95] + CD1*I1[74] + c3*I3[74] - c6*I6[74];
    *(vp++) = I0[98] + CD2*I1[74] + c4*I4[74] - c7*I7[74];
    *(vp++) = I0[75] + CD0*I1[75] + c2*I2[75] - c5*I5[75];
    *(vp++) = I0[76] + CD0*I1[76] + c2*I2[76] - c5*I5[76];
    *(vp++) = I0[77] + CD0*I1[77] + c2*I2[77] - c5*I5[77];
    *(vp++) = I0[97] + CD1*I1[76] + c3*I3[76] - c6*I6[76];
    *(vp++) = I0[98] + CD1*I1[77] + c3*I3[77] - c6*I6[77];
    *(vp++) = I0[101] + CD2*I1[77] + c4*I4[77] - c7*I7[77];
    *(vp++) = I0[78] + CD0*I1[78] + c2*I2[78] - c5*I5[78];
    *(vp++) = I0[79] + CD0*I1[79] + c2*I2[79] - c5*I5[79];
    *(vp++) = I0[80] + CD0*I1[80] + c2*I2[80] - c5*I5[80];
    *(vp++) = I0[100] + CD1*I1[79] + c3*I3[79] - c6*I6[79];
    *(vp++) = I0[101] + CD1*I1[80] + c3*I3[80] - c6*I6[80];
    *(vp++) = I0[104] + CD2*I1[80] + c4*I4[80] - c7*I7[80];
    *(vp++) = I0[81] + CD0*I1[81] + c2*I2[81] - c5*I5[81];
    *(vp++) = I0[82] + CD0*I1[82] + c2*I2[82] - c5*I5[82];
    *(vp++) = I0[83] + CD0*I1[83] + c2*I2[83] - c5*I5[83];
    *(vp++) = I0[103] + CD1*I1[82] + c3*I3[82] - c6*I6[82];
    *(vp++) = I0[104] + CD1*I1[83] + c3*I3[83] - c6*I6[83];
    *(vp++) = I0[107] + CD2*I1[83] + c4*I4[83] - c7*I7[83];
    *(vp++) = I0[84] + CD0*I1[84] + c2*I2[84] - c5*I5[84];
    *(vp++) = I0[85] + CD0*I1[85] + c2*I2[85] - c5*I5[85];
    *(vp++) = I0[86] + CD0*I1[86] + c2*I2[86] - c5*I5[86];
    *(vp++) = I0[109] + CD1*I1[85] + c3*I3[85] - c6*I6[85];
    *(vp++) = I0[110] + CD1*I1[86] + c3*I3[86] - c6*I6[86];
    *(vp++) = I0[113] + CD2*I1[86] + c4*I4[86] - c7*I7[86];
    *(vp++) = I0[87] + CD0*I1[87] + c2*I2[87] - c5*I5[87];
    *(vp++) = I0[88] + CD0*I1[88] + c2*I2[88] - c5*I5[88];
    *(vp++) = I0[89] + CD0*I1[89] + c2*I2[89] - c5*I5[89];
    *(vp++) = I0[112] + CD1*I1[88] + c3*I3[88] - c6*I6[88];
    *(vp++) = I0[113] + CD1*I1[89] + c3*I3[89] - c6*I6[89];
    *(vp++) = I0[116] + CD2*I1[89] + c4*I4[89] - c7*I7[89];
    *(vp++) = I0[90] + CD0*I1[90] + c2*I2[90] - c5*I5[90];
    *(vp++) = I0[91] + CD0*I1[91] + c2*I2[91] - c5*I5[91];
    *(vp++) = I0[92] + CD0*I1[92] + c2*I2[92] - c5*I5[92];
    *(vp++) = I0[115] + CD1*I1[91] + c3*I3[91] - c6*I6[91];
    *(vp++) = I0[116] + CD1*I1[92] + c3*I3[92] - c6*I6[92];
    *(vp++) = I0[119] + CD2*I1[92] + c4*I4[92] - c7*I7[92];
    *(vp++) = I0[93] + CD0*I1[93] + c2*I2[93] - c5*I5[93];
    *(vp++) = I0[94] + CD0*I1[94] + c2*I2[94] - c5*I5[94];
    *(vp++) = I0[95] + CD0*I1[95] + c2*I2[95] - c5*I5[95];
    *(vp++) = I0[118] + CD1*I1[94] + c3*I3[94] - c6*I6[94];
    *(vp++) = I0[119] + CD1*I1[95] + c3*I3[95] - c6*I6[95];
    *(vp++) = I0[122] + CD2*I1[95] + c4*I4[95] - c7*I7[95];
    *(vp++) = I0[96] + CD0*I1[96] + c2*I2[96] - c5*I5[96];
    *(vp++) = I0[97] + CD0*I1[97] + c2*I2[97] - c5*I5[97];
    *(vp++) = I0[98] + CD0*I1[98] + c2*I2[98] - c5*I5[98];
    *(vp++) = I0[121] + CD1*I1[97] + c3*I3[97] - c6*I6[97];
    *(vp++) = I0[122] + CD1*I1[98] + c3*I3[98] - c6*I6[98];
    *(vp++) = I0[125] + CD2*I1[98] + c4*I4[98] - c7*I7[98];
    *(vp++) = I0[99] + CD0*I1[99] + c2*I2[99] - c5*I5[99];
    *(vp++) = I0[100] + CD0*I1[100] + c2*I2[100] - c5*I5[100];
    *(vp++) = I0[101] + CD0*I1[101] + c2*I2[101] - c5*I5[101];
    *(vp++) = I0[124] + CD1*I1[100] + c3*I3[100] - c6*I6[100];
    *(vp++) = I0[125] + CD1*I1[101] + c3*I3[101] - c6*I6[101];
    *(vp++) = I0[128] + CD2*I1[101] + c4*I4[101] - c7*I7[101];
    *(vp++) = I0[102] + CD0*I1[102] + c2*I2[102] - c5*I5[102];
    *(vp++) = I0[103] + CD0*I1[103] + c2*I2[103] - c5*I5[103];
    *(vp++) = I0[104] + CD0*I1[104] + c2*I2[104] - c5*I5[104];
    *(vp++) = I0[127] + CD1*I1[103] + c3*I3[103] - c6*I6[103];
    *(vp++) = I0[128] + CD1*I1[104] + c3*I3[104] - c6*I6[104];
    *(vp++) = I0[131] + CD2*I1[104] + c4*I4[104] - c7*I7[104];
    *(vp++) = I0[105] + CD0*I1[105] + c2*I2[105] - c5*I5[105];
    *(vp++) = I0[106] + CD0*I1[106] + c2*I2[106] - c5*I5[106];
    *(vp++) = I0[107] + CD0*I1[107] + c2*I2[107] - c5*I5[107];
    *(vp++) = I0[130] + CD1*I1[106] + c3*I3[106] - c6*I6[106];
    *(vp++) = I0[131] + CD1*I1[107] + c3*I3[107] - c6*I6[107];
    *(vp++) = I0[134] + CD2*I1[107] + c4*I4[107] - c7*I7[107];
    *(vp++) = I0[108] + CD0*I1[108] + c2*I2[108] - c5*I5[108];
    *(vp++) = I0[109] + CD0*I1[109] + c2*I2[109] - c5*I5[109];
    *(vp++) = I0[110] + CD0*I1[110] + c2*I2[110] - c5*I5[110];
    *(vp++) = I0[136] + CD1*I1[109] + c3*I3[109] - c6*I6[109];
    *(vp++) = I0[137] + CD1*I1[110] + c3*I3[110] - c6*I6[110];
    *(vp++) = I0[140] + CD2*I1[110] + c4*I4[110] - c7*I7[110];
    *(vp++) = I0[111] + CD0*I1[111] + c2*I2[111] - c5*I5[111];
    *(vp++) = I0[112] + CD0*I1[112] + c2*I2[112] - c5*I5[112];
    *(vp++) = I0[113] + CD0*I1[113] + c2*I2[113] - c5*I5[113];
    *(vp++) = I0[139] + CD1*I1[112] + c3*I3[112] - c6*I6[112];
    *(vp++) = I0[140] + CD1*I1[113] + c3*I3[113] - c6*I6[113];
    *(vp++) = I0[143] + CD2*I1[113] + c4*I4[113] - c7*I7[113];
    *(vp++) = I0[114] + CD0*I1[114] + c2*I2[114] - c5*I5[114];
    *(vp++) = I0[115] + CD0*I1[115] + c2*I2[115] - c5*I5[115];
    *(vp++) = I0[116] + CD0*I1[116] + c2*I2[116] - c5*I5[116];
    *(vp++) = I0[142] + CD1*I1[115] + c3*I3[115] - c6*I6[115];
    *(vp++) = I0[143] + CD1*I1[116] + c3*I3[116] - c6*I6[116];
    *(vp++) = I0[146] + CD2*I1[116] + c4*I4[116] - c7*I7[116];
    *(vp++) = I0[117] + CD0*I1[117] + c2*I2[117] - c5*I5[117];
    *(vp++) = I0[118] + CD0*I1[118] + c2*I2[118] - c5*I5[118];
    *(vp++) = I0[119] + CD0*I1[119] + c2*I2[119] - c5*I5[119];
    *(vp++) = I0[145] + CD1*I1[118] + c3*I3[118] - c6*I6[118];
    *(vp++) = I0[146] + CD1*I1[119] + c3*I3[119] - c6*I6[119];
    *(vp++) = I0[149] + CD2*I1[119] + c4*I4[119] - c7*I7[119];
    *(vp++) = I0[120] + CD0*I1[120] + c2*I2[120] - c5*I5[120];
    *(vp++) = I0[121] + CD0*I1[121] + c2*I2[121] - c5*I5[121];
    *(vp++) = I0[122] + CD0*I1[122] + c2*I2[122] - c5*I5[122];
    *(vp++) = I0[148] + CD1*I1[121] + c3*I3[121] - c6*I6[121];
    *(vp++) = I0[149] + CD1*I1[122] + c3*I3[122] - c6*I6[122];
    *(vp++) = I0[152] + CD2*I1[122] + c4*I4[122] - c7*I7[122];
    *(vp++) = I0[123] + CD0*I1[123] + c2*I2[123] - c5*I5[123];
    *(vp++) = I0[124] + CD0*I1[124] + c2*I2[124] - c5*I5[124];
    *(vp++) = I0[125] + CD0*I1[125] + c2*I2[125] - c5*I5[125];
    *(vp++) = I0[151] + CD1*I1[124] + c3*I3[124] - c6*I6[124];
    *(vp++) = I0[152] + CD1*I1[125] + c3*I3[125] - c6*I6[125];
    *(vp++) = I0[155] + CD2*I1[125] + c4*I4[125] - c7*I7[125];
    *(vp++) = I0[126] + CD0*I1[126] + c2*I2[126] - c5*I5[126];
    *(vp++) = I0[127] + CD0*I1[127] + c2*I2[127] - c5*I5[127];
    *(vp++) = I0[128] + CD0*I1[128] + c2*I2[128] - c5*I5[128];
    *(vp++) = I0[154] + CD1*I1[127] + c3*I3[127] - c6*I6[127];
    *(vp++) = I0[155] + CD1*I1[128] + c3*I3[128] - c6*I6[128];
    *(vp++) = I0[158] + CD2*I1[128] + c4*I4[128] - c7*I7[128];
    *(vp++) = I0[129] + CD0*I1[129] + c2*I2[129] - c5*I5[129];
    *(vp++) = I0[130] + CD0*I1[130] + c2*I2[130] - c5*I5[130];
    *(vp++) = I0[131] + CD0*I1[131] + c2*I2[131] - c5*I5[131];
    *(vp++) = I0[157] + CD1*I1[130] + c3*I3[130] - c6*I6[130];
    *(vp++) = I0[158] + CD1*I1[131] + c3*I3[131] - c6*I6[131];
    *(vp++) = I0[161] + CD2*I1[131] + c4*I4[131] - c7*I7[131];
    *(vp++) = I0[132] + CD0*I1[132] + c2*I2[132] - c5*I5[132];
    *(vp++) = I0[133] + CD0*I1[133] + c2*I2[133] - c5*I5[133];
    *(vp++) = I0[134] + CD0*I1[134] + c2*I2[134] - c5*I5[134];
    *(vp++) = I0[160] + CD1*I1[133] + c3*I3[133] - c6*I6[133];
    *(vp++) = I0[161] + CD1*I1[134] + c3*I3[134] - c6*I6[134];
    *(vp++) = I0[164] + CD2*I1[134] + c4*I4[134] - c7*I7[134];
    I0 += 165;
    I1 += 135;
    I2 += 135;
    I3 += 135;
    I4 += 135;
    I5 += 135;
    I6 += 135;
    I7 += 135;
  }
}
