/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_d0ii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (d0|ii) integrals */

void d1hrr_order_d0ii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][11] = int_stack + 168;
 Libderiv->deriv_classes[2][8][11] = int_stack + 384;
 Libderiv->deriv_classes[2][9][11] = int_stack + 654;
 Libderiv->deriv_classes[2][10][11] = int_stack + 984;
 Libderiv->deriv_classes[2][11][11] = int_stack + 1380;
 Libderiv->deriv_classes[2][12][11] = int_stack + 1848;
 Libderiv->deriv_classes[2][6][10] = int_stack + 2394;
 Libderiv->deriv_classes[2][7][10] = int_stack + 2562;
 Libderiv->deriv_classes[2][8][10] = int_stack + 2778;
 Libderiv->deriv_classes[2][9][10] = int_stack + 3048;
 Libderiv->deriv_classes[2][10][10] = int_stack + 3378;
 Libderiv->deriv_classes[2][11][10] = int_stack + 3774;
 Libderiv->deriv_classes[2][12][10] = int_stack + 4242;
 Libderiv->deriv_classes[2][6][9] = int_stack + 4788;
 Libderiv->deriv_classes[2][7][9] = int_stack + 4956;
 Libderiv->deriv_classes[2][8][9] = int_stack + 5172;
 Libderiv->deriv_classes[2][9][9] = int_stack + 5442;
 Libderiv->deriv_classes[2][10][9] = int_stack + 5772;
 Libderiv->deriv_classes[2][11][9] = int_stack + 6168;
 Libderiv->deriv_classes[2][12][9] = int_stack + 6636;
 Libderiv->deriv_classes[2][6][8] = int_stack + 7182;
 Libderiv->deriv_classes[2][7][8] = int_stack + 7350;
 Libderiv->deriv_classes[2][8][8] = int_stack + 7566;
 Libderiv->deriv_classes[2][9][8] = int_stack + 7836;
 Libderiv->deriv_classes[2][10][8] = int_stack + 8166;
 Libderiv->deriv_classes[2][11][8] = int_stack + 8562;
 Libderiv->deriv_classes[2][12][8] = int_stack + 9030;
 Libderiv->deriv_classes[2][6][7] = int_stack + 9576;
 Libderiv->deriv_classes[2][7][7] = int_stack + 9744;
 Libderiv->deriv_classes[2][8][7] = int_stack + 9960;
 Libderiv->deriv_classes[2][9][7] = int_stack + 10230;
 Libderiv->deriv_classes[2][10][7] = int_stack + 10560;
 Libderiv->deriv_classes[2][11][7] = int_stack + 10956;
 Libderiv->deriv_classes[2][12][7] = int_stack + 11424;
 Libderiv->dvrr_classes[2][6] = int_stack + 11970;
 Libderiv->deriv_classes[2][6][6] = int_stack + 12138;
 Libderiv->dvrr_classes[2][7] = int_stack + 12306;
 Libderiv->deriv_classes[2][7][6] = int_stack + 12522;
 Libderiv->dvrr_classes[2][8] = int_stack + 12738;
 Libderiv->deriv_classes[2][8][6] = int_stack + 13008;
 Libderiv->dvrr_classes[2][9] = int_stack + 13278;
 Libderiv->deriv_classes[2][9][6] = int_stack + 13608;
 Libderiv->dvrr_classes[2][10] = int_stack + 13938;
 Libderiv->deriv_classes[2][10][6] = int_stack + 14334;
 Libderiv->dvrr_classes[2][11] = int_stack + 14730;
 Libderiv->deriv_classes[2][11][6] = int_stack + 15198;
 Libderiv->deriv_classes[2][12][6] = int_stack + 15666;
 Libderiv->deriv_classes[2][6][2] = int_stack + 16212;
 Libderiv->deriv_classes[2][7][2] = int_stack + 16380;
 Libderiv->deriv_classes[2][8][2] = int_stack + 16596;
 Libderiv->deriv_classes[2][9][2] = int_stack + 16866;
 Libderiv->deriv_classes[2][10][2] = int_stack + 17196;
 Libderiv->deriv_classes[2][11][2] = int_stack + 17592;
 Libderiv->deriv_classes[2][12][2] = int_stack + 18060;
 Libderiv->deriv_classes[2][6][1] = int_stack + 18606;
 Libderiv->deriv_classes[2][7][1] = int_stack + 18774;
 Libderiv->deriv_classes[2][8][1] = int_stack + 18990;
 Libderiv->deriv_classes[2][9][1] = int_stack + 19260;
 Libderiv->deriv_classes[2][10][1] = int_stack + 19590;
 Libderiv->deriv_classes[2][11][1] = int_stack + 19986;
 Libderiv->deriv_classes[2][12][1] = int_stack + 20454;
 Libderiv->deriv_classes[2][6][0] = int_stack + 21000;
 Libderiv->deriv_classes[2][7][0] = int_stack + 21168;
 Libderiv->deriv_classes[2][8][0] = int_stack + 21384;
 Libderiv->deriv_classes[2][9][0] = int_stack + 21654;
 Libderiv->deriv_classes[2][10][0] = int_stack + 21984;
 Libderiv->deriv_classes[2][11][0] = int_stack + 22380;
 Libderiv->deriv_classes[2][12][0] = int_stack + 22848;
 memset(int_stack,0,187152);

 Libderiv->dvrr_stack = int_stack + 97782;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_d0ii(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23394,int_stack+12306,int_stack+11970,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+23898,int_stack+12738,int_stack+12306,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+24546,int_stack+23898,int_stack+23394,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+25554,int_stack+13278,int_stack+12738,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+26364,int_stack+25554,int_stack+23898,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+27660,int_stack+26364,int_stack+24546,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+29340,int_stack+13938,int_stack+13278,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+30330,int_stack+29340,int_stack+25554,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+31950,int_stack+30330,int_stack+26364,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+34110,int_stack+31950,int_stack+27660,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+36630,int_stack+14730,int_stack+13938,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+37818,int_stack+36630,int_stack+29340,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+39798,int_stack+37818,int_stack+30330,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+42498,int_stack+39798,int_stack+31950,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+45738,int_stack+42498,int_stack+34110,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+49266,int_stack+168,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11970,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+49770,int_stack+384,int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12306,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+50418,int_stack+49770,int_stack+49266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23394,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+51426,int_stack+654,int_stack+384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12738,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+52236,int_stack+51426,int_stack+49770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23898,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+53532,int_stack+52236,int_stack+50418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24546,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+49266,int_stack+984,int_stack+654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13278,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+55212,int_stack+49266,int_stack+51426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25554,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+56832,int_stack+55212,int_stack+52236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26364,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+50256,int_stack+56832,int_stack+53532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27660,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+52776,int_stack+1380,int_stack+984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13938,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+58992,int_stack+52776,int_stack+49266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29340,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+60972,int_stack+58992,int_stack+55212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30330,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+63672,int_stack+60972,int_stack+56832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31950,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+53964,int_stack+63672,int_stack+50256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34110,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+49266,int_stack+1848,int_stack+1380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14730,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+49266,int_stack+52776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36630,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+49266,int_stack+0,int_stack+58992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37818,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+66912,int_stack+49266,int_stack+60972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39798,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+49266,int_stack+66912,int_stack+63672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42498,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2562,int_stack+2394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11970, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+2778,int_stack+2562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12306, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+504,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23394, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+57492,int_stack+3048,int_stack+2778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12738, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58302,int_stack+57492,int_stack+504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23898, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+59598,int_stack+58302,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24546, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+3378,int_stack+3048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13278, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+990,int_stack+0,int_stack+57492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25554, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+61278,int_stack+990,int_stack+58302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26364, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+63438,int_stack+61278,int_stack+59598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27660, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+57492,int_stack+3774,int_stack+3378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13938, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+58680,int_stack+57492,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29340, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+65958,int_stack+58680,int_stack+990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30330, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+0,int_stack+65958,int_stack+61278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31950, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+68658,int_stack+0,int_stack+63438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34110, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+60660,int_stack+4242,int_stack+3774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14730, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+62064,int_stack+60660,int_stack+57492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36630, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+72186,int_stack+62064,int_stack+58680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37818, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+57492,int_stack+72186,int_stack+65958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39798, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+61542,int_stack+57492,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42498, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+4956,int_stack+4788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11970, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+5172,int_stack+4956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12306, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+504,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23394, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2160,int_stack+5442,int_stack+5172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12738, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2970,int_stack+2160,int_stack+504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23898, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+57492,int_stack+2970,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24546, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+5772,int_stack+5442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13278, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+59172,int_stack+0,int_stack+2160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25554, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+72186,int_stack+59172,int_stack+2970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26364, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+990,int_stack+72186,int_stack+57492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27660, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+57492,int_stack+6168,int_stack+5772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13938, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+3510,int_stack+57492,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29340, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+74346,int_stack+3510,int_stack+59172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30330, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+77046,int_stack+74346,int_stack+72186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31950, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+80286,int_stack+77046,int_stack+990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34110, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+72186,int_stack+6636,int_stack+6168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14730, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+72186,int_stack+57492, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36630, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+57492,int_stack+0,int_stack+3510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37818, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+0,int_stack+57492,int_stack+74346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39798, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+72186,int_stack+0,int_stack+77046, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42498, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+7350,int_stack+7182, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+504,int_stack+7566,int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1152,int_stack+504,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2160,int_stack+7836,int_stack+7566, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2970,int_stack+2160,int_stack+504, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+23898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4266,int_stack+2970,int_stack+1152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+24546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+8166,int_stack+7836, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+5946,int_stack+0,int_stack+2160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+57492,int_stack+5946,int_stack+2970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+990,int_stack+57492,int_stack+4266, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+3510,int_stack+8562,int_stack+8166, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+13938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+76722,int_stack+3510,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+29340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+83814,int_stack+76722,int_stack+5946, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+30330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+4698,int_stack+83814,int_stack+57492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+31950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+57492,int_stack+4698,int_stack+990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+0,int_stack+9030,int_stack+8562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+66078,int_stack+0,int_stack+3510, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+36630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+0,int_stack+66078,int_stack+76722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+86514,int_stack+0,int_stack+83814, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+0,int_stack+86514,int_stack+4698, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+83814,int_stack+9744,int_stack+9576, 0.0, zero_stack, 1.0, int_stack+11970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+84318,int_stack+9960,int_stack+9744, 0.0, zero_stack, 1.0, int_stack+12306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+84966,int_stack+84318,int_stack+83814, 0.0, zero_stack, 1.0, int_stack+23394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+85974,int_stack+10230,int_stack+9960, 0.0, zero_stack, 1.0, int_stack+12738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+86784,int_stack+85974,int_stack+84318, 0.0, zero_stack, 1.0, int_stack+23898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+88080,int_stack+86784,int_stack+84966, 0.0, zero_stack, 1.0, int_stack+24546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+83814,int_stack+10560,int_stack+10230, 0.0, zero_stack, 1.0, int_stack+13278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4536,int_stack+83814,int_stack+85974, 0.0, zero_stack, 1.0, int_stack+25554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+6156,int_stack+4536,int_stack+86784, 0.0, zero_stack, 1.0, int_stack+26364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+84804,int_stack+6156,int_stack+88080, 0.0, zero_stack, 1.0, int_stack+27660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+87324,int_stack+10956,int_stack+10560, 0.0, zero_stack, 1.0, int_stack+13938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+88512,int_stack+87324,int_stack+83814, 0.0, zero_stack, 1.0, int_stack+29340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+76722,int_stack+88512,int_stack+4536, 0.0, zero_stack, 1.0, int_stack+30330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+90492,int_stack+76722,int_stack+6156, 0.0, zero_stack, 1.0, int_stack+31950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+4536,int_stack+90492,int_stack+84804, 0.0, zero_stack, 1.0, int_stack+34110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+8064,int_stack+11424,int_stack+10956, 0.0, zero_stack, 1.0, int_stack+14730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+9468,int_stack+8064,int_stack+87324, 0.0, zero_stack, 1.0, int_stack+36630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+83814,int_stack+9468,int_stack+88512, 0.0, zero_stack, 1.0, int_stack+37818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+93732,int_stack+83814,int_stack+76722, 0.0, zero_stack, 1.0, int_stack+39798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+83814,int_stack+93732,int_stack+90492, 0.0, zero_stack, 1.0, int_stack+42498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+76722,int_stack+12522,int_stack+12138, 1.0, int_stack+11970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+77226,int_stack+13008,int_stack+12522, 1.0, int_stack+12306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77874,int_stack+77226,int_stack+76722, 1.0, int_stack+23394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+78882,int_stack+13608,int_stack+13008, 1.0, int_stack+12738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+88350,int_stack+78882,int_stack+77226, 1.0, int_stack+23898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+89646,int_stack+88350,int_stack+77874, 1.0, int_stack+24546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+23394,int_stack+14334,int_stack+13608, 1.0, int_stack+13278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+76722,int_stack+23394,int_stack+78882, 1.0, int_stack+25554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+91326,int_stack+76722,int_stack+88350, 1.0, int_stack+26364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+24384,int_stack+91326,int_stack+89646, 1.0, int_stack+27660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+88350,int_stack+15198,int_stack+14334, 1.0, int_stack+13938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+26904,int_stack+88350,int_stack+23394, 1.0, int_stack+29340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+93486,int_stack+26904,int_stack+76722, 1.0, int_stack+30330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+76722,int_stack+93486,int_stack+91326, 1.0, int_stack+31950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+89538,int_stack+76722,int_stack+24384, 1.0, int_stack+34110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+23394,int_stack+15666,int_stack+15198, 1.0, int_stack+14730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+28884,int_stack+23394,int_stack+88350, 1.0, int_stack+36630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+23394,int_stack+28884,int_stack+26904, 1.0, int_stack+37818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+26694,int_stack+23394,int_stack+93486, 1.0, int_stack+39798, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+30744,int_stack+26694,int_stack+76722, 1.0, int_stack+42498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+76722,int_stack+16380,int_stack+16212,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+77226,int_stack+16596,int_stack+16380,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+77874,int_stack+77226,int_stack+76722,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+78882,int_stack+16866,int_stack+16596,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+23394,int_stack+78882,int_stack+77226,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+24690,int_stack+23394,int_stack+77874,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+76722,int_stack+17196,int_stack+16866,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+26370,int_stack+76722,int_stack+78882,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+77712,int_stack+26370,int_stack+23394,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+27990,int_stack+77712,int_stack+24690,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+88350,int_stack+17592,int_stack+17196,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+23394,int_stack+88350,int_stack+76722,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+35280,int_stack+23394,int_stack+26370,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+37980,int_stack+35280,int_stack+77712,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+76722,int_stack+37980,int_stack+27990,6);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+25374,int_stack+18060,int_stack+17592,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+26778,int_stack+25374,int_stack+88350,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+41220,int_stack+26778,int_stack+23394,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+23394,int_stack+41220,int_stack+35280,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+93066,int_stack+23394,int_stack+37980,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23394,int_stack+18774,int_stack+18606,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+23898,int_stack+18990,int_stack+18774,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+24546,int_stack+23898,int_stack+23394,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+25554,int_stack+19260,int_stack+18990,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+26364,int_stack+25554,int_stack+23898,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+27660,int_stack+26364,int_stack+24546,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+23394,int_stack+19590,int_stack+19260,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+35280,int_stack+23394,int_stack+25554,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+36900,int_stack+35280,int_stack+26364,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+24384,int_stack+36900,int_stack+27660,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+88350,int_stack+19986,int_stack+19590,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+26904,int_stack+88350,int_stack+23394,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+39060,int_stack+26904,int_stack+35280,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+41760,int_stack+39060,int_stack+36900,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+35280,int_stack+41760,int_stack+24384,6);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+23394,int_stack+20454,int_stack+19986,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+8064,int_stack+23394,int_stack+88350,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+23394,int_stack+8064,int_stack+26904,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+26694,int_stack+23394,int_stack+39060,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+8064,int_stack+26694,int_stack+41760,6);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23394,int_stack+21168,int_stack+21000,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+23898,int_stack+21384,int_stack+21168,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+24546,int_stack+23898,int_stack+23394,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+25554,int_stack+21654,int_stack+21384,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+26364,int_stack+25554,int_stack+23898,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+27660,int_stack+26364,int_stack+24546,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+23394,int_stack+21984,int_stack+21654,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+12600,int_stack+23394,int_stack+25554,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+14220,int_stack+12600,int_stack+26364,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+24384,int_stack+14220,int_stack+27660,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+88350,int_stack+22380,int_stack+21984,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+26904,int_stack+88350,int_stack+23394,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+16380,int_stack+26904,int_stack+12600,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+19080,int_stack+16380,int_stack+14220,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+12600,int_stack+19080,int_stack+24384,6);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+23394,int_stack+22848,int_stack+22380,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+38808,int_stack+23394,int_stack+88350,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+22320,int_stack+38808,int_stack+26904,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+38808,int_stack+22320,int_stack+16380,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+22320,int_stack+38808,int_stack+19080,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+38808,int_stack+49266,int_stack+53964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45738,6);
     Libderiv->ABCD[11] = int_stack + 38808;
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+49266,int_stack+61542,int_stack+68658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45738, 0.0, zero_stack,6);
     Libderiv->ABCD[10] = int_stack + 49266;
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+16128,int_stack+72186,int_stack+80286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45738, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[9] = int_stack + 16128;
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+61020,int_stack+0,int_stack+57492, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[8] = int_stack + 61020;
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+53970,int_stack+83814,int_stack+4536, 0.0, zero_stack, 1.0, int_stack+45738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[7] = int_stack + 53970;
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+0,int_stack+30744,int_stack+89538, 1.0, int_stack+45738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+43512,int_stack+93066,int_stack+76722,6);
     Libderiv->ABCD[2] = int_stack + 43512;
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+26856,int_stack+8064,int_stack+35280,6);
     Libderiv->ABCD[1] = int_stack + 26856;
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+4704,int_stack+22320,int_stack+12600,6);
     Libderiv->ABCD[0] = int_stack + 4704;

}
