/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ddh0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|h0) integrals */

void d1hrr_order_ddh0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][5][11] = int_stack + 126;
 Libderiv->deriv_classes[4][5][11] = int_stack + 336;
 Libderiv->deriv_classes[2][5][10] = int_stack + 651;
 Libderiv->deriv_classes[3][5][10] = int_stack + 777;
 Libderiv->deriv_classes[4][5][10] = int_stack + 987;
 Libderiv->deriv_classes[2][5][9] = int_stack + 1302;
 Libderiv->deriv_classes[3][5][9] = int_stack + 1428;
 Libderiv->deriv_classes[4][5][9] = int_stack + 1638;
 Libderiv->deriv_classes[2][5][8] = int_stack + 1953;
 Libderiv->deriv_classes[3][5][8] = int_stack + 2079;
 Libderiv->deriv_classes[4][5][8] = int_stack + 2289;
 Libderiv->deriv_classes[2][5][7] = int_stack + 2604;
 Libderiv->deriv_classes[3][5][7] = int_stack + 2730;
 Libderiv->deriv_classes[4][5][7] = int_stack + 2940;
 Libderiv->deriv_classes[2][5][6] = int_stack + 3255;
 Libderiv->deriv_classes[3][5][6] = int_stack + 3381;
 Libderiv->deriv_classes[4][5][6] = int_stack + 3591;
 Libderiv->deriv_classes[2][5][2] = int_stack + 3906;
 Libderiv->deriv_classes[3][5][2] = int_stack + 4032;
 Libderiv->deriv_classes[4][5][2] = int_stack + 4242;
 Libderiv->deriv_classes[2][5][1] = int_stack + 4557;
 Libderiv->deriv_classes[3][5][1] = int_stack + 4683;
 Libderiv->deriv_classes[4][5][1] = int_stack + 4893;
 Libderiv->dvrr_classes[2][5] = int_stack + 5208;
 Libderiv->deriv_classes[2][5][0] = int_stack + 5334;
 Libderiv->dvrr_classes[3][5] = int_stack + 5460;
 Libderiv->deriv_classes[3][5][0] = int_stack + 5670;
 Libderiv->deriv_classes[4][5][0] = int_stack + 5880;
 memset(int_stack,0,49560);

 Libderiv->dvrr_stack = int_stack + 10353;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ddh0(Libderiv, Data);
   Data++;
 }

 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+6195,int_stack+126,int_stack+0,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+6573,int_stack+336,int_stack+126,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+777,int_stack+651,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+7203,int_stack+987,int_stack+777,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+378,int_stack+1428,int_stack+1302,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+756,int_stack+1638,int_stack+1428,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1386,int_stack+2079,int_stack+1953,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+7833,int_stack+2289,int_stack+2079,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+1764,int_stack+2730,int_stack+2604,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+8463,int_stack+2940,int_stack+2730,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+2142,int_stack+3381,int_stack+3255,21);
 /*--- compute (fp|h0) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+2520,int_stack+3591,int_stack+3381,21);
 /*--- compute (dp|h0) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3150,int_stack+5460,int_stack+5208,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+3528,int_stack+4032,int_stack+3906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+9093,int_stack+4242,int_stack+4032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+3906,int_stack+4683,int_stack+4557, 0.0, zero_stack, 1.0, int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+9723,int_stack+4893,int_stack+4683, 0.0, zero_stack, 1.0, int_stack+5460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dp|h0) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+4284,int_stack+5670,int_stack+5334, 1.0, int_stack+5208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (fp|h0) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+4662,int_stack+5880,int_stack+5670, 1.0, int_stack+5460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+5292,int_stack+6573,int_stack+6195,21);
     Libderiv->ABCD[11] = int_stack + 5292;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+6048,int_stack+7203,int_stack+0,21);
     Libderiv->ABCD[10] = int_stack + 6048;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+6804,int_stack+756,int_stack+378,21);
     Libderiv->ABCD[9] = int_stack + 6804;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+0,int_stack+7833,int_stack+1386,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+756,int_stack+8463,int_stack+1764,21);
     Libderiv->ABCD[7] = int_stack + 756;
 /*--- compute (dd|h0) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+7560,int_stack+2520,int_stack+2142,21);
     Libderiv->ABCD[6] = int_stack + 7560;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+1512,int_stack+9093,int_stack+3528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[2] = int_stack + 1512;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+2268,int_stack+9723,int_stack+3906, 0.0, zero_stack, 1.0, int_stack+3150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[1] = int_stack + 2268;
 /*--- compute (dd|h0) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+3528,int_stack+4662,int_stack+4284, 1.0, int_stack+3150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[0] = int_stack + 3528;

}
