/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_f0if(Libderiv_t *, prim_data *);

  /* Computes derivatives of (f0|if) integrals */

void d1hrr_order_f0if(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][6][11] = int_stack + 0;
 Libderiv->deriv_classes[3][7][11] = int_stack + 280;
 Libderiv->deriv_classes[3][8][11] = int_stack + 640;
 Libderiv->deriv_classes[3][9][11] = int_stack + 1090;
 Libderiv->deriv_classes[3][6][10] = int_stack + 1640;
 Libderiv->deriv_classes[3][7][10] = int_stack + 1920;
 Libderiv->deriv_classes[3][8][10] = int_stack + 2280;
 Libderiv->deriv_classes[3][9][10] = int_stack + 2730;
 Libderiv->deriv_classes[3][6][9] = int_stack + 3280;
 Libderiv->deriv_classes[3][7][9] = int_stack + 3560;
 Libderiv->deriv_classes[3][8][9] = int_stack + 3920;
 Libderiv->deriv_classes[3][9][9] = int_stack + 4370;
 Libderiv->deriv_classes[3][6][8] = int_stack + 4920;
 Libderiv->deriv_classes[3][7][8] = int_stack + 5200;
 Libderiv->deriv_classes[3][8][8] = int_stack + 5560;
 Libderiv->deriv_classes[3][9][8] = int_stack + 6010;
 Libderiv->deriv_classes[3][6][7] = int_stack + 6560;
 Libderiv->deriv_classes[3][7][7] = int_stack + 6840;
 Libderiv->deriv_classes[3][8][7] = int_stack + 7200;
 Libderiv->deriv_classes[3][9][7] = int_stack + 7650;
 Libderiv->dvrr_classes[3][6] = int_stack + 8200;
 Libderiv->deriv_classes[3][6][6] = int_stack + 8480;
 Libderiv->dvrr_classes[3][7] = int_stack + 8760;
 Libderiv->deriv_classes[3][7][6] = int_stack + 9120;
 Libderiv->dvrr_classes[3][8] = int_stack + 9480;
 Libderiv->deriv_classes[3][8][6] = int_stack + 9930;
 Libderiv->deriv_classes[3][9][6] = int_stack + 10380;
 Libderiv->deriv_classes[3][6][2] = int_stack + 10930;
 Libderiv->deriv_classes[3][7][2] = int_stack + 11210;
 Libderiv->deriv_classes[3][8][2] = int_stack + 11570;
 Libderiv->deriv_classes[3][9][2] = int_stack + 12020;
 Libderiv->deriv_classes[3][6][1] = int_stack + 12570;
 Libderiv->deriv_classes[3][7][1] = int_stack + 12850;
 Libderiv->deriv_classes[3][8][1] = int_stack + 13210;
 Libderiv->deriv_classes[3][9][1] = int_stack + 13660;
 Libderiv->deriv_classes[3][6][0] = int_stack + 14210;
 Libderiv->deriv_classes[3][7][0] = int_stack + 14490;
 Libderiv->deriv_classes[3][8][0] = int_stack + 14850;
 Libderiv->deriv_classes[3][9][0] = int_stack + 15300;
 memset(int_stack,0,126800);

 Libderiv->dvrr_stack = int_stack + 44480;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_f0if(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+15850,int_stack+8760,int_stack+8200,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+16690,int_stack+9480,int_stack+8760,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+17770,int_stack+16690,int_stack+15850,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19450,int_stack+280,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8200,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20290,int_stack+640,int_stack+280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8760,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21370,int_stack+20290,int_stack+19450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15850,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+1090,int_stack+640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9480,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+24400,int_stack+23050,int_stack+20290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16690,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23050,int_stack+1920,int_stack+1640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8200, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19450,int_stack+2280,int_stack+1920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8760, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+19450,int_stack+23050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15850, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+2730,int_stack+2280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9480, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+26560,int_stack+23050,int_stack+19450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16690, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19450,int_stack+3560,int_stack+3280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8200, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20290,int_stack+3920,int_stack+3560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8760, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1680,int_stack+20290,int_stack+19450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15850, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+4370,int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+28720,int_stack+23050,int_stack+20290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16690, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23050,int_stack+5200,int_stack+4920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19450,int_stack+5560,int_stack+5200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3360,int_stack+19450,int_stack+23050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+15850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+6010,int_stack+5560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+30880,int_stack+23050,int_stack+19450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19450,int_stack+6840,int_stack+6560, 0.0, zero_stack, 1.0, int_stack+8200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+20290,int_stack+7200,int_stack+6840, 0.0, zero_stack, 1.0, int_stack+8760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5040,int_stack+20290,int_stack+19450, 0.0, zero_stack, 1.0, int_stack+15850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+7650,int_stack+7200, 0.0, zero_stack, 1.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+33040,int_stack+23050,int_stack+20290, 0.0, zero_stack, 1.0, int_stack+16690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23050,int_stack+9120,int_stack+8480, 1.0, int_stack+8200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19450,int_stack+9930,int_stack+9120, 1.0, int_stack+8760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+6720,int_stack+19450,int_stack+23050, 1.0, int_stack+15850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+10380,int_stack+9930, 1.0, int_stack+9480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+8400,int_stack+23050,int_stack+19450, 1.0, int_stack+16690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+19450,int_stack+11210,int_stack+10930,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+20290,int_stack+11570,int_stack+11210,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+15850,int_stack+20290,int_stack+19450,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+12020,int_stack+11570,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+35200,int_stack+23050,int_stack+20290,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+23050,int_stack+12850,int_stack+12570,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+19450,int_stack+13210,int_stack+12850,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+10560,int_stack+19450,int_stack+23050,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+13660,int_stack+13210,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+37360,int_stack+23050,int_stack+19450,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+19450,int_stack+14490,int_stack+14210,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+20290,int_stack+14850,int_stack+14490,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+12240,int_stack+20290,int_stack+19450,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+23050,int_stack+15300,int_stack+14850,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+39520,int_stack+23050,int_stack+20290,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+41680,int_stack+24400,int_stack+21370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17770,10);
     Libderiv->ABCD[11] = int_stack + 41680;
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+19450,int_stack+26560,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17770, 0.0, zero_stack,10);
     Libderiv->ABCD[10] = int_stack + 19450;
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+22250,int_stack+28720,int_stack+1680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17770, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[9] = int_stack + 22250;
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+30880,int_stack+3360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25050,int_stack+33040,int_stack+5040, 0.0, zero_stack, 1.0, int_stack+17770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[7] = int_stack + 25050;
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2800,int_stack+8400,int_stack+6720, 1.0, int_stack+17770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
     Libderiv->ABCD[6] = int_stack + 2800;
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+5600,int_stack+35200,int_stack+15850,10);
     Libderiv->ABCD[2] = int_stack + 5600;
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+27850,int_stack+37360,int_stack+10560,10);
     Libderiv->ABCD[1] = int_stack + 27850;
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+8400,int_stack+39520,int_stack+12240,10);
     Libderiv->ABCD[0] = int_stack + 8400;

}
