/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_fdhd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fd|hd) integrals */

void d1hrr_order_fdhd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][6][11] = int_stack + 210;
 Libderiv->deriv_classes[3][7][11] = int_stack + 490;
 Libderiv->deriv_classes[4][5][11] = int_stack + 850;
 Libderiv->deriv_classes[4][6][11] = int_stack + 1165;
 Libderiv->deriv_classes[4][7][11] = int_stack + 1585;
 Libderiv->deriv_classes[5][5][11] = int_stack + 2125;
 Libderiv->deriv_classes[5][6][11] = int_stack + 2566;
 Libderiv->deriv_classes[5][7][11] = int_stack + 3154;
 Libderiv->deriv_classes[3][5][10] = int_stack + 3910;
 Libderiv->deriv_classes[3][6][10] = int_stack + 4120;
 Libderiv->deriv_classes[3][7][10] = int_stack + 4400;
 Libderiv->deriv_classes[4][5][10] = int_stack + 4760;
 Libderiv->deriv_classes[4][6][10] = int_stack + 5075;
 Libderiv->deriv_classes[4][7][10] = int_stack + 5495;
 Libderiv->deriv_classes[5][5][10] = int_stack + 6035;
 Libderiv->deriv_classes[5][6][10] = int_stack + 6476;
 Libderiv->deriv_classes[5][7][10] = int_stack + 7064;
 Libderiv->deriv_classes[3][5][9] = int_stack + 7820;
 Libderiv->deriv_classes[3][6][9] = int_stack + 8030;
 Libderiv->deriv_classes[3][7][9] = int_stack + 8310;
 Libderiv->deriv_classes[4][5][9] = int_stack + 8670;
 Libderiv->deriv_classes[4][6][9] = int_stack + 8985;
 Libderiv->deriv_classes[4][7][9] = int_stack + 9405;
 Libderiv->deriv_classes[5][5][9] = int_stack + 9945;
 Libderiv->deriv_classes[5][6][9] = int_stack + 10386;
 Libderiv->deriv_classes[5][7][9] = int_stack + 10974;
 Libderiv->deriv_classes[3][5][8] = int_stack + 11730;
 Libderiv->deriv_classes[3][6][8] = int_stack + 11940;
 Libderiv->deriv_classes[3][7][8] = int_stack + 12220;
 Libderiv->deriv_classes[4][5][8] = int_stack + 12580;
 Libderiv->deriv_classes[4][6][8] = int_stack + 12895;
 Libderiv->deriv_classes[4][7][8] = int_stack + 13315;
 Libderiv->deriv_classes[5][5][8] = int_stack + 13855;
 Libderiv->deriv_classes[5][6][8] = int_stack + 14296;
 Libderiv->deriv_classes[5][7][8] = int_stack + 14884;
 Libderiv->deriv_classes[3][5][7] = int_stack + 15640;
 Libderiv->deriv_classes[3][6][7] = int_stack + 15850;
 Libderiv->deriv_classes[3][7][7] = int_stack + 16130;
 Libderiv->deriv_classes[4][5][7] = int_stack + 16490;
 Libderiv->deriv_classes[4][6][7] = int_stack + 16805;
 Libderiv->deriv_classes[4][7][7] = int_stack + 17225;
 Libderiv->deriv_classes[5][5][7] = int_stack + 17765;
 Libderiv->deriv_classes[5][6][7] = int_stack + 18206;
 Libderiv->deriv_classes[5][7][7] = int_stack + 18794;
 Libderiv->deriv_classes[3][5][6] = int_stack + 19550;
 Libderiv->deriv_classes[3][6][6] = int_stack + 19760;
 Libderiv->deriv_classes[3][7][6] = int_stack + 20040;
 Libderiv->deriv_classes[4][5][6] = int_stack + 20400;
 Libderiv->deriv_classes[4][6][6] = int_stack + 20715;
 Libderiv->deriv_classes[4][7][6] = int_stack + 21135;
 Libderiv->dvrr_classes[5][5] = int_stack + 21675;
 Libderiv->deriv_classes[5][5][6] = int_stack + 22116;
 Libderiv->dvrr_classes[5][6] = int_stack + 22557;
 Libderiv->deriv_classes[5][6][6] = int_stack + 23145;
 Libderiv->deriv_classes[5][7][6] = int_stack + 23733;
 Libderiv->deriv_classes[3][5][2] = int_stack + 24489;
 Libderiv->deriv_classes[3][6][2] = int_stack + 24699;
 Libderiv->deriv_classes[3][7][2] = int_stack + 24979;
 Libderiv->deriv_classes[4][5][2] = int_stack + 25339;
 Libderiv->deriv_classes[4][6][2] = int_stack + 25654;
 Libderiv->deriv_classes[4][7][2] = int_stack + 26074;
 Libderiv->deriv_classes[5][5][2] = int_stack + 26614;
 Libderiv->deriv_classes[5][6][2] = int_stack + 27055;
 Libderiv->deriv_classes[5][7][2] = int_stack + 27643;
 Libderiv->deriv_classes[3][5][1] = int_stack + 28399;
 Libderiv->deriv_classes[3][6][1] = int_stack + 28609;
 Libderiv->deriv_classes[3][7][1] = int_stack + 28889;
 Libderiv->deriv_classes[4][5][1] = int_stack + 29249;
 Libderiv->deriv_classes[4][6][1] = int_stack + 29564;
 Libderiv->deriv_classes[4][7][1] = int_stack + 29984;
 Libderiv->deriv_classes[5][5][1] = int_stack + 30524;
 Libderiv->deriv_classes[5][6][1] = int_stack + 30965;
 Libderiv->deriv_classes[5][7][1] = int_stack + 31553;
 Libderiv->dvrr_classes[3][5] = int_stack + 32309;
 Libderiv->dvrr_classes[3][6] = int_stack + 32519;
 Libderiv->dvrr_classes[3][7] = int_stack + 32799;
 Libderiv->deriv_classes[3][5][0] = int_stack + 33159;
 Libderiv->deriv_classes[3][6][0] = int_stack + 33369;
 Libderiv->deriv_classes[3][7][0] = int_stack + 33649;
 Libderiv->dvrr_classes[4][5] = int_stack + 34009;
 Libderiv->dvrr_classes[4][6] = int_stack + 34324;
 Libderiv->dvrr_classes[4][7] = int_stack + 34744;
 Libderiv->deriv_classes[4][5][0] = int_stack + 35284;
 Libderiv->deriv_classes[4][6][0] = int_stack + 35599;
 Libderiv->deriv_classes[4][7][0] = int_stack + 36019;
 Libderiv->deriv_classes[5][5][0] = int_stack + 36559;
 Libderiv->deriv_classes[5][6][0] = int_stack + 37000;
 Libderiv->deriv_classes[5][7][0] = int_stack + 37588;
 memset(int_stack,0,306752);

 Libderiv->dvrr_stack = int_stack + 121903;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_fdhd(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+38344,int_stack+32519,int_stack+32309,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+38974,int_stack+210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32309,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+39604,int_stack+490,int_stack+210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32519,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+40444,int_stack+39604,int_stack+38974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38344,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+38974,int_stack+34324,int_stack+34009,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41704,int_stack+1165,int_stack+850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34009,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42649,int_stack+1585,int_stack+1165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34324,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+42649,int_stack+41704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38974,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+41704,int_stack+0,int_stack+40444,126);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+39919,int_stack+22557,int_stack+21675,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45484,int_stack+2566,int_stack+2125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21675,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46807,int_stack+3154,int_stack+2566, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22557,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+48571,int_stack+46807,int_stack+45484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39919,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+51217,int_stack+48571,int_stack+0,126);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+4120,int_stack+3910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32309, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+630,int_stack+4400,int_stack+4120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32519, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1470,int_stack+630,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38344, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+5075,int_stack+4760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34009, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2730,int_stack+5495,int_stack+5075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34324, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3990,int_stack+2730,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38974, 0.0, zero_stack,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+45484,int_stack+3990,int_stack+1470,126);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+6476,int_stack+6035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21675, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323,int_stack+7064,int_stack+6476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22557, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+56887,int_stack+1323,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39919, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+59533,int_stack+56887,int_stack+3990,126);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+8030,int_stack+7820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32309, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57517,int_stack+8310,int_stack+8030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32519, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+57517,int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38344, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+8985,int_stack+8670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34009, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57832,int_stack+9405,int_stack+8985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34324, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1260,int_stack+57832,int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38974, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+3150,int_stack+1260,int_stack+0,126);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+10386,int_stack+9945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21675, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+6930,int_stack+10974,int_stack+10386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22557, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8694,int_stack+6930,int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39919, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+65203,int_stack+8694,int_stack+1260,126);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+11940,int_stack+11730, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57517,int_stack+12220,int_stack+11940, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+32519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6930,int_stack+57517,int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+12895,int_stack+12580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57832,int_stack+13315,int_stack+12895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+34324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8190,int_stack+57832,int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+70873,int_stack+8190,int_stack+6930,126);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+14296,int_stack+13855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10080,int_stack+14884,int_stack+14296, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+11844,int_stack+10080,int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+74653,int_stack+11844,int_stack+8190,126);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+15850,int_stack+15640, 0.0, zero_stack, 1.0, int_stack+32309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57517,int_stack+16130,int_stack+15850, 0.0, zero_stack, 1.0, int_stack+32519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6930,int_stack+57517,int_stack+56887, 0.0, zero_stack, 1.0, int_stack+38344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+16805,int_stack+16490, 0.0, zero_stack, 1.0, int_stack+34009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57832,int_stack+17225,int_stack+16805, 0.0, zero_stack, 1.0, int_stack+34324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+8190,int_stack+57832,int_stack+56887, 0.0, zero_stack, 1.0, int_stack+38974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+10080,int_stack+8190,int_stack+6930,126);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+18206,int_stack+17765, 0.0, zero_stack, 1.0, int_stack+21675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+13860,int_stack+18794,int_stack+18206, 0.0, zero_stack, 1.0, int_stack+22557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15624,int_stack+13860,int_stack+56887, 0.0, zero_stack, 1.0, int_stack+39919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+80323,int_stack+15624,int_stack+8190,126);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+19760,int_stack+19550, 1.0, int_stack+32309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57517,int_stack+20040,int_stack+19760, 1.0, int_stack+32519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+13860,int_stack+57517,int_stack+56887, 1.0, int_stack+38344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+20715,int_stack+20400, 1.0, int_stack+34009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+57832,int_stack+21135,int_stack+20715, 1.0, int_stack+34324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+15120,int_stack+57832,int_stack+56887, 1.0, int_stack+38974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+17010,int_stack+15120,int_stack+13860,126);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56887,int_stack+23145,int_stack+22116, 1.0, int_stack+21675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+20790,int_stack+23733,int_stack+23145, 1.0, int_stack+22557, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6930,int_stack+20790,int_stack+56887, 1.0, int_stack+39919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|hd) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+85993,int_stack+6930,int_stack+15120,126);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6930,int_stack+32799,int_stack+32519,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+7770,int_stack+6930,int_stack+38344,10);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39919,int_stack+34744,int_stack+34324,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+56887,int_stack+39919,int_stack+38974,15);
 /*--- compute (fp|hd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+91663,int_stack+56887,int_stack+7770,126);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+38344,int_stack+24699,int_stack+24489,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6930,int_stack+24979,int_stack+24699,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38974,int_stack+6930,int_stack+38344,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+40234,int_stack+25654,int_stack+25339,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20790,int_stack+26074,int_stack+25654,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+22050,int_stack+20790,int_stack+40234,15);
 /*--- compute (fp|hd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+95443,int_stack+22050,int_stack+38974, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+38344,int_stack+27055,int_stack+26614,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39667,int_stack+27643,int_stack+27055,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+23940,int_stack+39667,int_stack+38344,21);
 /*--- compute (gp|hd) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+99223,int_stack+23940,int_stack+22050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+38344,int_stack+28609,int_stack+28399,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6930,int_stack+28889,int_stack+28609,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+38974,int_stack+6930,int_stack+38344,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+40234,int_stack+29564,int_stack+29249,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+20790,int_stack+29984,int_stack+29564,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+22050,int_stack+20790,int_stack+40234,15);
 /*--- compute (fp|hd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+23940,int_stack+22050,int_stack+38974, 0.0, zero_stack, 1.0, int_stack+7770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+38344,int_stack+30965,int_stack+30524,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39667,int_stack+31553,int_stack+30965,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+27720,int_stack+39667,int_stack+38344,21);
 /*--- compute (gp|hd) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+104893,int_stack+27720,int_stack+22050, 0.0, zero_stack, 1.0, int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+27720,int_stack+33369,int_stack+33159,10);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6930,int_stack+33649,int_stack+33369,10);
 /*--- compute (f0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+28350,int_stack+6930,int_stack+27720,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+29610,int_stack+35599,int_stack+35284,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+30555,int_stack+36019,int_stack+35599,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+31815,int_stack+30555,int_stack+29610,15);
 /*--- compute (fp|hd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+110563,int_stack+31815,int_stack+28350, 1.0, int_stack+7770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+27720,int_stack+37000,int_stack+36559,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+29043,int_stack+37588,int_stack+37000,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6930,int_stack+29043,int_stack+27720,21);
 /*--- compute (gp|hd) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+33705,int_stack+6930,int_stack+31815, 1.0, int_stack+56887, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
 /*--- compute (fd|hd) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+114343,int_stack+51217,int_stack+41704,126);
     Libderiv->ABCD[11] = int_stack + 114343;
 /*--- compute (fd|hd) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+49264,int_stack+59533,int_stack+45484,126);
     Libderiv->ABCD[10] = int_stack + 49264;
 /*--- compute (fd|hd) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+39375,int_stack+65203,int_stack+3150,126);
     Libderiv->ABCD[9] = int_stack + 39375;
 /*--- compute (fd|hd) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+0,int_stack+74653,int_stack+70873,126);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (fd|hd) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+56824,int_stack+80323,int_stack+10080,126);
     Libderiv->ABCD[7] = int_stack + 56824;
 /*--- compute (fd|hd) ---*/
   hrr1_build_fd(Libderiv->AB,int_stack+7560,int_stack+85993,int_stack+17010,126);
     Libderiv->ABCD[6] = int_stack + 7560;
 /*--- compute (fd|hd) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+15120,int_stack+99223,int_stack+95443, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+91663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[2] = int_stack + 15120;
 /*--- compute (fd|hd) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+95443,int_stack+104893,int_stack+23940, 0.0, zero_stack, 1.0, int_stack+91663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[1] = int_stack + 95443;
 /*--- compute (fd|hd) ---*/
   d1hrr1_build_fd(Libderiv->AB,int_stack+103003,int_stack+33705,int_stack+110563, 1.0, int_stack+91663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,126);
     Libderiv->ABCD[0] = int_stack + 103003;

}
