/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_fphp(Libderiv_t *, prim_data *);

  /* Computes derivatives of (fp|hp) integrals */

void d1hrr_order_fphp(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[3][5][11] = int_stack + 0;
 Libderiv->deriv_classes[3][6][11] = int_stack + 210;
 Libderiv->deriv_classes[4][5][11] = int_stack + 490;
 Libderiv->deriv_classes[4][6][11] = int_stack + 805;
 Libderiv->deriv_classes[3][5][10] = int_stack + 1225;
 Libderiv->deriv_classes[3][6][10] = int_stack + 1435;
 Libderiv->deriv_classes[4][5][10] = int_stack + 1715;
 Libderiv->deriv_classes[4][6][10] = int_stack + 2030;
 Libderiv->deriv_classes[3][5][9] = int_stack + 2450;
 Libderiv->deriv_classes[3][6][9] = int_stack + 2660;
 Libderiv->deriv_classes[4][5][9] = int_stack + 2940;
 Libderiv->deriv_classes[4][6][9] = int_stack + 3255;
 Libderiv->deriv_classes[3][5][8] = int_stack + 3675;
 Libderiv->deriv_classes[3][6][8] = int_stack + 3885;
 Libderiv->deriv_classes[4][5][8] = int_stack + 4165;
 Libderiv->deriv_classes[4][6][8] = int_stack + 4480;
 Libderiv->deriv_classes[3][5][7] = int_stack + 4900;
 Libderiv->deriv_classes[3][6][7] = int_stack + 5110;
 Libderiv->deriv_classes[4][5][7] = int_stack + 5390;
 Libderiv->deriv_classes[4][6][7] = int_stack + 5705;
 Libderiv->deriv_classes[3][5][6] = int_stack + 6125;
 Libderiv->deriv_classes[3][6][6] = int_stack + 6335;
 Libderiv->dvrr_classes[4][5] = int_stack + 6615;
 Libderiv->deriv_classes[4][5][6] = int_stack + 6930;
 Libderiv->deriv_classes[4][6][6] = int_stack + 7245;
 Libderiv->deriv_classes[3][5][2] = int_stack + 7665;
 Libderiv->deriv_classes[3][6][2] = int_stack + 7875;
 Libderiv->deriv_classes[4][5][2] = int_stack + 8155;
 Libderiv->deriv_classes[4][6][2] = int_stack + 8470;
 Libderiv->deriv_classes[3][5][1] = int_stack + 8890;
 Libderiv->deriv_classes[3][6][1] = int_stack + 9100;
 Libderiv->deriv_classes[4][5][1] = int_stack + 9380;
 Libderiv->deriv_classes[4][6][1] = int_stack + 9695;
 Libderiv->dvrr_classes[3][5] = int_stack + 10115;
 Libderiv->dvrr_classes[3][6] = int_stack + 10325;
 Libderiv->deriv_classes[3][5][0] = int_stack + 10605;
 Libderiv->deriv_classes[3][6][0] = int_stack + 10815;
 Libderiv->deriv_classes[4][5][0] = int_stack + 11095;
 Libderiv->deriv_classes[4][6][0] = int_stack + 11410;
 memset(int_stack,0,94640);

 Libderiv->dvrr_stack = int_stack + 20020;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_fphp(Libderiv, Data);
   Data++;
 }

 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+11830,int_stack+210,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10115,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12460,int_stack+805,int_stack+490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+1435,int_stack+1225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10115, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+630,int_stack+2030,int_stack+1715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1575,int_stack+2660,int_stack+2450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10115, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13405,int_stack+3255,int_stack+2940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+3885,int_stack+3675, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+10115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2835,int_stack+4480,int_stack+4165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3780,int_stack+5110,int_stack+4900, 0.0, zero_stack, 1.0, int_stack+10115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+5705,int_stack+5390, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5355,int_stack+6335,int_stack+6125, 1.0, int_stack+10115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14350,int_stack+7245,int_stack+6930, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5985,int_stack+10325,int_stack+10115,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+6615,int_stack+7875,int_stack+7665,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+15295,int_stack+8470,int_stack+8155,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7245,int_stack+9100,int_stack+8890,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+7875,int_stack+9695,int_stack+9380,15);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+8820,int_stack+10815,int_stack+10605,10);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+9450,int_stack+11410,int_stack+11095,15);
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+16240,int_stack+12460,int_stack+11830,63);
     Libderiv->ABCD[11] = int_stack + 16240;
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+10395,int_stack+630,int_stack+0,63);
     Libderiv->ABCD[10] = int_stack + 10395;
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+18130,int_stack+13405,int_stack+1575,63);
     Libderiv->ABCD[9] = int_stack + 18130;
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+0,int_stack+2835,int_stack+2205,63);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+1890,int_stack+4410,int_stack+3780,63);
     Libderiv->ABCD[7] = int_stack + 1890;
 /*--- compute (fp|hp) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+12285,int_stack+14350,int_stack+5355,63);
     Libderiv->ABCD[6] = int_stack + 12285;
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+3780,int_stack+15295,int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[2] = int_stack + 3780;
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+14175,int_stack+7875,int_stack+7245, 0.0, zero_stack, 1.0, int_stack+5985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[1] = int_stack + 14175;
 /*--- compute (fp|hp) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+6615,int_stack+9450,int_stack+8820, 1.0, int_stack+5985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,63);
     Libderiv->ABCD[0] = int_stack + 6615;

}
