/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_g0ip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (g0|ip) integrals */

void d1hrr_order_g0ip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][6][11] = int_stack + 0;
 Libderiv->deriv_classes[4][7][11] = int_stack + 420;
 Libderiv->deriv_classes[4][6][10] = int_stack + 960;
 Libderiv->deriv_classes[4][7][10] = int_stack + 1380;
 Libderiv->deriv_classes[4][6][9] = int_stack + 1920;
 Libderiv->deriv_classes[4][7][9] = int_stack + 2340;
 Libderiv->deriv_classes[4][6][8] = int_stack + 2880;
 Libderiv->deriv_classes[4][7][8] = int_stack + 3300;
 Libderiv->deriv_classes[4][6][7] = int_stack + 3840;
 Libderiv->deriv_classes[4][7][7] = int_stack + 4260;
 Libderiv->dvrr_classes[4][6] = int_stack + 4800;
 Libderiv->deriv_classes[4][6][6] = int_stack + 5220;
 Libderiv->deriv_classes[4][7][6] = int_stack + 5640;
 Libderiv->deriv_classes[4][6][2] = int_stack + 6180;
 Libderiv->deriv_classes[4][7][2] = int_stack + 6600;
 Libderiv->deriv_classes[4][6][1] = int_stack + 7140;
 Libderiv->deriv_classes[4][7][1] = int_stack + 7560;
 Libderiv->deriv_classes[4][6][0] = int_stack + 8100;
 Libderiv->deriv_classes[4][7][0] = int_stack + 8520;
 memset(int_stack,0,72480);

 Libderiv->dvrr_stack = int_stack + 12840;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_g0ip(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+9060,int_stack+420,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4800,15);
     Libderiv->ABCD[11] = int_stack + 9060;
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+10320,int_stack+1380,int_stack+960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4800, 0.0, zero_stack,15);
     Libderiv->ABCD[10] = int_stack + 10320;
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2340,int_stack+1920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4800, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1260,int_stack+3300,int_stack+2880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[8] = int_stack + 1260;
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2520,int_stack+4260,int_stack+3840, 0.0, zero_stack, 1.0, int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[7] = int_stack + 2520;
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+11580,int_stack+5640,int_stack+5220, 1.0, int_stack+4800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
     Libderiv->ABCD[6] = int_stack + 11580;
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3780,int_stack+6600,int_stack+6180,15);
     Libderiv->ABCD[2] = int_stack + 3780;
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+5040,int_stack+7560,int_stack+7140,15);
     Libderiv->ABCD[1] = int_stack + 5040;
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+6300,int_stack+8520,int_stack+8100,15);
     Libderiv->ABCD[0] = int_stack + 6300;

}
