/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_gphf(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gp|hf) integrals */

void d1hrr_order_gphf(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][5][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][11] = int_stack + 315;
 Libderiv->deriv_classes[4][7][11] = int_stack + 735;
 Libderiv->deriv_classes[4][8][11] = int_stack + 1275;
 Libderiv->deriv_classes[5][5][11] = int_stack + 1950;
 Libderiv->deriv_classes[5][6][11] = int_stack + 2391;
 Libderiv->deriv_classes[5][7][11] = int_stack + 2979;
 Libderiv->deriv_classes[5][8][11] = int_stack + 3735;
 Libderiv->deriv_classes[4][5][10] = int_stack + 4680;
 Libderiv->deriv_classes[4][6][10] = int_stack + 4995;
 Libderiv->deriv_classes[4][7][10] = int_stack + 5415;
 Libderiv->deriv_classes[4][8][10] = int_stack + 5955;
 Libderiv->deriv_classes[5][5][10] = int_stack + 6630;
 Libderiv->deriv_classes[5][6][10] = int_stack + 7071;
 Libderiv->deriv_classes[5][7][10] = int_stack + 7659;
 Libderiv->deriv_classes[5][8][10] = int_stack + 8415;
 Libderiv->deriv_classes[4][5][9] = int_stack + 9360;
 Libderiv->deriv_classes[4][6][9] = int_stack + 9675;
 Libderiv->deriv_classes[4][7][9] = int_stack + 10095;
 Libderiv->deriv_classes[4][8][9] = int_stack + 10635;
 Libderiv->deriv_classes[5][5][9] = int_stack + 11310;
 Libderiv->deriv_classes[5][6][9] = int_stack + 11751;
 Libderiv->deriv_classes[5][7][9] = int_stack + 12339;
 Libderiv->deriv_classes[5][8][9] = int_stack + 13095;
 Libderiv->deriv_classes[4][5][8] = int_stack + 14040;
 Libderiv->deriv_classes[4][6][8] = int_stack + 14355;
 Libderiv->deriv_classes[4][7][8] = int_stack + 14775;
 Libderiv->deriv_classes[4][8][8] = int_stack + 15315;
 Libderiv->deriv_classes[5][5][8] = int_stack + 15990;
 Libderiv->deriv_classes[5][6][8] = int_stack + 16431;
 Libderiv->deriv_classes[5][7][8] = int_stack + 17019;
 Libderiv->deriv_classes[5][8][8] = int_stack + 17775;
 Libderiv->deriv_classes[4][5][7] = int_stack + 18720;
 Libderiv->deriv_classes[4][6][7] = int_stack + 19035;
 Libderiv->deriv_classes[4][7][7] = int_stack + 19455;
 Libderiv->deriv_classes[4][8][7] = int_stack + 19995;
 Libderiv->deriv_classes[5][5][7] = int_stack + 20670;
 Libderiv->deriv_classes[5][6][7] = int_stack + 21111;
 Libderiv->deriv_classes[5][7][7] = int_stack + 21699;
 Libderiv->deriv_classes[5][8][7] = int_stack + 22455;
 Libderiv->deriv_classes[4][5][6] = int_stack + 23400;
 Libderiv->deriv_classes[4][6][6] = int_stack + 23715;
 Libderiv->deriv_classes[4][7][6] = int_stack + 24135;
 Libderiv->deriv_classes[4][8][6] = int_stack + 24675;
 Libderiv->dvrr_classes[5][5] = int_stack + 25350;
 Libderiv->deriv_classes[5][5][6] = int_stack + 25791;
 Libderiv->dvrr_classes[5][6] = int_stack + 26232;
 Libderiv->deriv_classes[5][6][6] = int_stack + 26820;
 Libderiv->dvrr_classes[5][7] = int_stack + 27408;
 Libderiv->deriv_classes[5][7][6] = int_stack + 28164;
 Libderiv->deriv_classes[5][8][6] = int_stack + 28920;
 Libderiv->deriv_classes[4][5][2] = int_stack + 29865;
 Libderiv->deriv_classes[4][6][2] = int_stack + 30180;
 Libderiv->deriv_classes[4][7][2] = int_stack + 30600;
 Libderiv->deriv_classes[4][8][2] = int_stack + 31140;
 Libderiv->deriv_classes[5][5][2] = int_stack + 31815;
 Libderiv->deriv_classes[5][6][2] = int_stack + 32256;
 Libderiv->deriv_classes[5][7][2] = int_stack + 32844;
 Libderiv->deriv_classes[5][8][2] = int_stack + 33600;
 Libderiv->deriv_classes[4][5][1] = int_stack + 34545;
 Libderiv->deriv_classes[4][6][1] = int_stack + 34860;
 Libderiv->deriv_classes[4][7][1] = int_stack + 35280;
 Libderiv->deriv_classes[4][8][1] = int_stack + 35820;
 Libderiv->deriv_classes[5][5][1] = int_stack + 36495;
 Libderiv->deriv_classes[5][6][1] = int_stack + 36936;
 Libderiv->deriv_classes[5][7][1] = int_stack + 37524;
 Libderiv->deriv_classes[5][8][1] = int_stack + 38280;
 Libderiv->dvrr_classes[4][5] = int_stack + 39225;
 Libderiv->dvrr_classes[4][6] = int_stack + 39540;
 Libderiv->dvrr_classes[4][7] = int_stack + 39960;
 Libderiv->dvrr_classes[4][8] = int_stack + 40500;
 Libderiv->deriv_classes[4][5][0] = int_stack + 41175;
 Libderiv->deriv_classes[4][6][0] = int_stack + 41490;
 Libderiv->deriv_classes[4][7][0] = int_stack + 41910;
 Libderiv->deriv_classes[4][8][0] = int_stack + 42450;
 Libderiv->deriv_classes[5][5][0] = int_stack + 43125;
 Libderiv->deriv_classes[5][6][0] = int_stack + 43566;
 Libderiv->deriv_classes[5][7][0] = int_stack + 44154;
 Libderiv->deriv_classes[5][8][0] = int_stack + 44910;
 memset(int_stack,0,366840);

 Libderiv->dvrr_stack = int_stack + 126648;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_gphf(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+45855,int_stack+39540,int_stack+39225,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+46800,int_stack+39960,int_stack+39540,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+48060,int_stack+46800,int_stack+45855,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+49950,int_stack+315,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39225,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+50895,int_stack+735,int_stack+315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39540,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+52155,int_stack+50895,int_stack+49950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45855,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+54045,int_stack+1275,int_stack+735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39960,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+55665,int_stack+54045,int_stack+50895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46800,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+58185,int_stack+55665,int_stack+52155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48060,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+49950,int_stack+26232,int_stack+25350,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+51273,int_stack+27408,int_stack+26232,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+53037,int_stack+51273,int_stack+49950,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+55683,int_stack+2391,int_stack+1950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25350,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+2979,int_stack+2391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26232,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+61335,int_stack+0,int_stack+55683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49950,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+55683,int_stack+3735,int_stack+2979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27408,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+63981,int_stack+55683,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51273,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+63981,int_stack+61335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53037,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+61335,int_stack+4995,int_stack+4680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39225, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+62280,int_stack+5415,int_stack+4995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39540, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+63540,int_stack+62280,int_stack+61335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45855, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+65430,int_stack+5955,int_stack+5415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39960, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+67050,int_stack+65430,int_stack+62280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46800, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+69570,int_stack+67050,int_stack+63540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48060, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+61335,int_stack+7071,int_stack+6630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25350, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+62658,int_stack+7659,int_stack+7071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26232, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+64422,int_stack+62658,int_stack+61335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49950, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+67068,int_stack+8415,int_stack+7659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27408, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4410,int_stack+67068,int_stack+62658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51273, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+72720,int_stack+4410,int_stack+64422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53037, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+9675,int_stack+9360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39225, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5355,int_stack+10095,int_stack+9675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39540, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6615,int_stack+5355,int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45855, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61335,int_stack+10635,int_stack+10095, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39960, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+8505,int_stack+61335,int_stack+5355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46800, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+61335,int_stack+8505,int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48060, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+64485,int_stack+11751,int_stack+11310, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25350, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+65808,int_stack+12339,int_stack+11751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26232, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4410,int_stack+65808,int_stack+64485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49950, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+7056,int_stack+13095,int_stack+12339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27408, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+9324,int_stack+7056,int_stack+65808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51273, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+64485,int_stack+9324,int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53037, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+14355,int_stack+14040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5355,int_stack+14775,int_stack+14355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+6615,int_stack+5355,int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+8505,int_stack+15315,int_stack+14775, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+10125,int_stack+8505,int_stack+5355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+46800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+12645,int_stack+10125,int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+16431,int_stack+15990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+25350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5733,int_stack+17019,int_stack+16431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7497,int_stack+5733,int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10143,int_stack+17775,int_stack+17019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+27408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+77130,int_stack+10143,int_stack+5733, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+51273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+80658,int_stack+77130,int_stack+7497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+53037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+77130,int_stack+19035,int_stack+18720, 0.0, zero_stack, 1.0, int_stack+39225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+78075,int_stack+19455,int_stack+19035, 0.0, zero_stack, 1.0, int_stack+39540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4410,int_stack+78075,int_stack+77130, 0.0, zero_stack, 1.0, int_stack+45855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6300,int_stack+19995,int_stack+19455, 0.0, zero_stack, 1.0, int_stack+39960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7920,int_stack+6300,int_stack+78075, 0.0, zero_stack, 1.0, int_stack+46800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+77130,int_stack+7920,int_stack+4410, 0.0, zero_stack, 1.0, int_stack+48060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+21111,int_stack+20670, 0.0, zero_stack, 1.0, int_stack+25350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+5733,int_stack+21699,int_stack+21111, 0.0, zero_stack, 1.0, int_stack+26232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+7497,int_stack+5733,int_stack+4410, 0.0, zero_stack, 1.0, int_stack+49950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+10143,int_stack+22455,int_stack+21699, 0.0, zero_stack, 1.0, int_stack+27408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15795,int_stack+10143,int_stack+5733, 0.0, zero_stack, 1.0, int_stack+51273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+85068,int_stack+15795,int_stack+7497, 0.0, zero_stack, 1.0, int_stack+53037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15795,int_stack+23715,int_stack+23400, 1.0, int_stack+39225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16740,int_stack+24135,int_stack+23715, 1.0, int_stack+39540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18000,int_stack+16740,int_stack+15795, 1.0, int_stack+45855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19890,int_stack+24675,int_stack+24135, 1.0, int_stack+39960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21510,int_stack+19890,int_stack+16740, 1.0, int_stack+46800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+4410,int_stack+21510,int_stack+18000, 1.0, int_stack+48060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+15795,int_stack+26820,int_stack+25791, 1.0, int_stack+25350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17118,int_stack+28164,int_stack+26820, 1.0, int_stack+26232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+18882,int_stack+17118,int_stack+15795, 1.0, int_stack+49950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+21528,int_stack+28920,int_stack+28164, 1.0, int_stack+27408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+23796,int_stack+21528,int_stack+17118, 1.0, int_stack+51273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+7560,int_stack+23796,int_stack+18882, 1.0, int_stack+53037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+49950,int_stack+40500,int_stack+39960,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+51570,int_stack+49950,int_stack+46800,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+54090,int_stack+51570,int_stack+48060,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57240,int_stack+30180,int_stack+29865,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+15795,int_stack+30600,int_stack+30180,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+17055,int_stack+15795,int_stack+57240,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+18945,int_stack+31140,int_stack+30600,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+20565,int_stack+18945,int_stack+15795,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+23085,int_stack+20565,int_stack+17055,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+15795,int_stack+32256,int_stack+31815,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+17118,int_stack+32844,int_stack+32256,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+18882,int_stack+17118,int_stack+15795,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+26235,int_stack+33600,int_stack+32844,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+28503,int_stack+26235,int_stack+17118,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+45855,int_stack+28503,int_stack+18882,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57240,int_stack+34860,int_stack+34545,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+26235,int_stack+35280,int_stack+34860,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+27495,int_stack+26235,int_stack+57240,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+29385,int_stack+35820,int_stack+35280,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+31005,int_stack+29385,int_stack+26235,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+15795,int_stack+31005,int_stack+27495,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26235,int_stack+36936,int_stack+36495,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+27558,int_stack+37524,int_stack+36936,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+29322,int_stack+27558,int_stack+26235,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+31968,int_stack+38280,int_stack+37524,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+34236,int_stack+31968,int_stack+27558,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+89478,int_stack+34236,int_stack+29322,21);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+57240,int_stack+41490,int_stack+41175,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+26235,int_stack+41910,int_stack+41490,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+27495,int_stack+26235,int_stack+57240,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+29385,int_stack+42450,int_stack+41910,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+31005,int_stack+29385,int_stack+26235,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+33525,int_stack+31005,int_stack+27495,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+26235,int_stack+43566,int_stack+43125,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+27558,int_stack+44154,int_stack+43566,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+29322,int_stack+27558,int_stack+26235,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+36675,int_stack+44910,int_stack+44154,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+38943,int_stack+36675,int_stack+27558,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+93888,int_stack+38943,int_stack+29322,21);
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+98298,int_stack+0,int_stack+58185,210);
     Libderiv->ABCD[11] = int_stack + 98298;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+107748,int_stack+72720,int_stack+69570,210);
     Libderiv->ABCD[10] = int_stack + 107748;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+117198,int_stack+64485,int_stack+61335,210);
     Libderiv->ABCD[9] = int_stack + 117198;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+57240,int_stack+80658,int_stack+12645,210);
     Libderiv->ABCD[8] = int_stack + 57240;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+66690,int_stack+85068,int_stack+77130,210);
     Libderiv->ABCD[7] = int_stack + 66690;
 /*--- compute (gp|hf) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+76140,int_stack+7560,int_stack+4410,210);
     Libderiv->ABCD[6] = int_stack + 76140;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+0,int_stack+45855,int_stack+23085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+54090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[2] = int_stack + 0;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+36675,int_stack+89478,int_stack+15795, 0.0, zero_stack, 1.0, int_stack+54090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[1] = int_stack + 36675;
 /*--- compute (gp|hf) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+9450,int_stack+93888,int_stack+33525, 1.0, int_stack+54090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,210);
     Libderiv->ABCD[0] = int_stack + 9450;

}
