/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_h0hg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (h0|hg) integrals */

void d1hrr_order_h0hg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][11] = int_stack + 441;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1029;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1785;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2730;
 Libderiv->deriv_classes[5][5][10] = int_stack + 3885;
 Libderiv->deriv_classes[5][6][10] = int_stack + 4326;
 Libderiv->deriv_classes[5][7][10] = int_stack + 4914;
 Libderiv->deriv_classes[5][8][10] = int_stack + 5670;
 Libderiv->deriv_classes[5][9][10] = int_stack + 6615;
 Libderiv->deriv_classes[5][5][9] = int_stack + 7770;
 Libderiv->deriv_classes[5][6][9] = int_stack + 8211;
 Libderiv->deriv_classes[5][7][9] = int_stack + 8799;
 Libderiv->deriv_classes[5][8][9] = int_stack + 9555;
 Libderiv->deriv_classes[5][9][9] = int_stack + 10500;
 Libderiv->deriv_classes[5][5][8] = int_stack + 11655;
 Libderiv->deriv_classes[5][6][8] = int_stack + 12096;
 Libderiv->deriv_classes[5][7][8] = int_stack + 12684;
 Libderiv->deriv_classes[5][8][8] = int_stack + 13440;
 Libderiv->deriv_classes[5][9][8] = int_stack + 14385;
 Libderiv->deriv_classes[5][5][7] = int_stack + 15540;
 Libderiv->deriv_classes[5][6][7] = int_stack + 15981;
 Libderiv->deriv_classes[5][7][7] = int_stack + 16569;
 Libderiv->deriv_classes[5][8][7] = int_stack + 17325;
 Libderiv->deriv_classes[5][9][7] = int_stack + 18270;
 Libderiv->dvrr_classes[5][5] = int_stack + 19425;
 Libderiv->deriv_classes[5][5][6] = int_stack + 19866;
 Libderiv->dvrr_classes[5][6] = int_stack + 20307;
 Libderiv->deriv_classes[5][6][6] = int_stack + 20895;
 Libderiv->dvrr_classes[5][7] = int_stack + 21483;
 Libderiv->deriv_classes[5][7][6] = int_stack + 22239;
 Libderiv->dvrr_classes[5][8] = int_stack + 22995;
 Libderiv->deriv_classes[5][8][6] = int_stack + 23940;
 Libderiv->deriv_classes[5][9][6] = int_stack + 24885;
 Libderiv->deriv_classes[5][5][2] = int_stack + 26040;
 Libderiv->deriv_classes[5][6][2] = int_stack + 26481;
 Libderiv->deriv_classes[5][7][2] = int_stack + 27069;
 Libderiv->deriv_classes[5][8][2] = int_stack + 27825;
 Libderiv->deriv_classes[5][9][2] = int_stack + 28770;
 Libderiv->deriv_classes[5][5][1] = int_stack + 29925;
 Libderiv->deriv_classes[5][6][1] = int_stack + 30366;
 Libderiv->deriv_classes[5][7][1] = int_stack + 30954;
 Libderiv->deriv_classes[5][8][1] = int_stack + 31710;
 Libderiv->deriv_classes[5][9][1] = int_stack + 32655;
 Libderiv->deriv_classes[5][5][0] = int_stack + 33810;
 Libderiv->deriv_classes[5][6][0] = int_stack + 34251;
 Libderiv->deriv_classes[5][7][0] = int_stack + 34839;
 Libderiv->deriv_classes[5][8][0] = int_stack + 35595;
 Libderiv->deriv_classes[5][9][0] = int_stack + 36540;
 memset(int_stack,0,301560);

 Libderiv->dvrr_stack = int_stack + 127869;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_h0hg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+37695,int_stack+20307,int_stack+19425,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39018,int_stack+21483,int_stack+20307,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+40782,int_stack+39018,int_stack+37695,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+43428,int_stack+22995,int_stack+21483,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+45696,int_stack+43428,int_stack+39018,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+49224,int_stack+45696,int_stack+40782,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+53634,int_stack+441,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19425,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+54957,int_stack+1029,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20307,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+56721,int_stack+54957,int_stack+53634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37695,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+59367,int_stack+1785,int_stack+1029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21483,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+61635,int_stack+59367,int_stack+54957, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39018,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65163,int_stack+61635,int_stack+56721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40782,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+53634,int_stack+2730,int_stack+1785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22995,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+69573,int_stack+53634,int_stack+59367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43428,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+53634,int_stack+69573,int_stack+61635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45696,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69573,int_stack+4326,int_stack+3885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19425, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70896,int_stack+4914,int_stack+4326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20307, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+59514,int_stack+70896,int_stack+69573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37695, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72660,int_stack+5670,int_stack+4914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21483, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+0,int_stack+72660,int_stack+70896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39018, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+74928,int_stack+0,int_stack+59514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40782, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+59514,int_stack+6615,int_stack+5670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22995, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+79338,int_stack+59514,int_stack+72660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43428, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+83874,int_stack+79338,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45696, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+8211,int_stack+7770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19425, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323,int_stack+8799,int_stack+8211, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20307, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3087,int_stack+1323,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37695, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5733,int_stack+9555,int_stack+8799, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21483, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+79338,int_stack+5733,int_stack+1323, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39018, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+59514,int_stack+79338,int_stack+3087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40782, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+10500,int_stack+9555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22995, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+69573,int_stack+0,int_stack+5733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43428, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+69573,int_stack+79338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45696, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+79338,int_stack+12096,int_stack+11655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+19425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+80661,int_stack+12684,int_stack+12096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+20307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+69573,int_stack+80661,int_stack+79338, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72219,int_stack+13440,int_stack+12684, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+21483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5880,int_stack+72219,int_stack+80661, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+39018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+79338,int_stack+5880,int_stack+69573, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9408,int_stack+14385,int_stack+13440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+22995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+89754,int_stack+9408,int_stack+72219, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9408,int_stack+89754,int_stack+5880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5880,int_stack+15981,int_stack+15540, 0.0, zero_stack, 1.0, int_stack+19425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+7203,int_stack+16569,int_stack+15981, 0.0, zero_stack, 1.0, int_stack+20307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+89754,int_stack+7203,int_stack+5880, 0.0, zero_stack, 1.0, int_stack+37695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+92400,int_stack+17325,int_stack+16569, 0.0, zero_stack, 1.0, int_stack+21483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+69573,int_stack+92400,int_stack+7203, 0.0, zero_stack, 1.0, int_stack+39018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+94668,int_stack+69573,int_stack+89754, 0.0, zero_stack, 1.0, int_stack+40782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+5880,int_stack+18270,int_stack+17325, 0.0, zero_stack, 1.0, int_stack+22995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+99078,int_stack+5880,int_stack+92400, 0.0, zero_stack, 1.0, int_stack+43428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+103614,int_stack+99078,int_stack+69573, 0.0, zero_stack, 1.0, int_stack+45696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69573,int_stack+20895,int_stack+19866, 1.0, int_stack+19425, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+70896,int_stack+22239,int_stack+20895, 1.0, int_stack+20307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+99078,int_stack+70896,int_stack+69573, 1.0, int_stack+37695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+72660,int_stack+23940,int_stack+22239, 1.0, int_stack+21483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5880,int_stack+72660,int_stack+70896, 1.0, int_stack+39018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+89754,int_stack+5880,int_stack+99078, 1.0, int_stack+40782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+99078,int_stack+24885,int_stack+23940, 1.0, int_stack+22995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+37695,int_stack+99078,int_stack+72660, 1.0, int_stack+43428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15288,int_stack+37695,int_stack+5880, 1.0, int_stack+45696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5880,int_stack+26481,int_stack+26040,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7203,int_stack+27069,int_stack+26481,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+37695,int_stack+7203,int_stack+5880,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+40341,int_stack+27825,int_stack+27069,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+42609,int_stack+40341,int_stack+7203,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+99078,int_stack+42609,int_stack+37695,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5880,int_stack+28770,int_stack+27825,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+69573,int_stack+5880,int_stack+40341,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+21168,int_stack+69573,int_stack+42609,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+69573,int_stack+30366,int_stack+29925,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+70896,int_stack+30954,int_stack+30366,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+5880,int_stack+70896,int_stack+69573,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+72660,int_stack+31710,int_stack+30954,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+37695,int_stack+72660,int_stack+70896,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+41223,int_stack+37695,int_stack+5880,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+5880,int_stack+32655,int_stack+31710,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+27048,int_stack+5880,int_stack+72660,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+109494,int_stack+27048,int_stack+37695,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+37695,int_stack+34251,int_stack+33810,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+39018,int_stack+34839,int_stack+34251,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+27048,int_stack+39018,int_stack+37695,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+29694,int_stack+35595,int_stack+34839,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+5880,int_stack+29694,int_stack+39018,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+69573,int_stack+5880,int_stack+27048,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+37695,int_stack+36540,int_stack+35595,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+31962,int_stack+37695,int_stack+29694,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+115374,int_stack+31962,int_stack+5880,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+27048,int_stack+53634,int_stack+65163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49224,21);
     Libderiv->ABCD[11] = int_stack + 27048;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+33663,int_stack+83874,int_stack+74928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49224, 0.0, zero_stack,21);
     Libderiv->ABCD[10] = int_stack + 33663;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+121254,int_stack+0,int_stack+59514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49224, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[9] = int_stack + 121254;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+0,int_stack+9408,int_stack+79338, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+49224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+6615,int_stack+103614,int_stack+94668, 0.0, zero_stack, 1.0, int_stack+49224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[7] = int_stack + 6615;
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+53634,int_stack+15288,int_stack+89754, 1.0, int_stack+49224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[6] = int_stack + 53634;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+13230,int_stack+21168,int_stack+99078,21);
     Libderiv->ABCD[2] = int_stack + 13230;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+19845,int_stack+109494,int_stack+41223,21);
     Libderiv->ABCD[1] = int_stack + 19845;
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+60249,int_stack+115374,int_stack+69573,21);
     Libderiv->ABCD[0] = int_stack + 60249;

}
