/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hdif(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hd|if) integrals */

void d1hrr_order_hdif(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[6][6][11] = int_stack + 3444;
 Libderiv->deriv_classes[6][7][11] = int_stack + 4228;
 Libderiv->deriv_classes[6][8][11] = int_stack + 5236;
 Libderiv->deriv_classes[6][9][11] = int_stack + 6496;
 Libderiv->deriv_classes[7][6][11] = int_stack + 8036;
 Libderiv->deriv_classes[7][7][11] = int_stack + 9044;
 Libderiv->deriv_classes[7][8][11] = int_stack + 10340;
 Libderiv->deriv_classes[7][9][11] = int_stack + 11960;
 Libderiv->deriv_classes[5][6][10] = int_stack + 13940;
 Libderiv->deriv_classes[5][7][10] = int_stack + 14528;
 Libderiv->deriv_classes[5][8][10] = int_stack + 15284;
 Libderiv->deriv_classes[5][9][10] = int_stack + 16229;
 Libderiv->deriv_classes[6][6][10] = int_stack + 17384;
 Libderiv->deriv_classes[6][7][10] = int_stack + 18168;
 Libderiv->deriv_classes[6][8][10] = int_stack + 19176;
 Libderiv->deriv_classes[6][9][10] = int_stack + 20436;
 Libderiv->deriv_classes[7][6][10] = int_stack + 21976;
 Libderiv->deriv_classes[7][7][10] = int_stack + 22984;
 Libderiv->deriv_classes[7][8][10] = int_stack + 24280;
 Libderiv->deriv_classes[7][9][10] = int_stack + 25900;
 Libderiv->deriv_classes[5][6][9] = int_stack + 27880;
 Libderiv->deriv_classes[5][7][9] = int_stack + 28468;
 Libderiv->deriv_classes[5][8][9] = int_stack + 29224;
 Libderiv->deriv_classes[5][9][9] = int_stack + 30169;
 Libderiv->deriv_classes[6][6][9] = int_stack + 31324;
 Libderiv->deriv_classes[6][7][9] = int_stack + 32108;
 Libderiv->deriv_classes[6][8][9] = int_stack + 33116;
 Libderiv->deriv_classes[6][9][9] = int_stack + 34376;
 Libderiv->deriv_classes[7][6][9] = int_stack + 35916;
 Libderiv->deriv_classes[7][7][9] = int_stack + 36924;
 Libderiv->deriv_classes[7][8][9] = int_stack + 38220;
 Libderiv->deriv_classes[7][9][9] = int_stack + 39840;
 Libderiv->deriv_classes[5][6][8] = int_stack + 41820;
 Libderiv->deriv_classes[5][7][8] = int_stack + 42408;
 Libderiv->deriv_classes[5][8][8] = int_stack + 43164;
 Libderiv->deriv_classes[5][9][8] = int_stack + 44109;
 Libderiv->deriv_classes[6][6][8] = int_stack + 45264;
 Libderiv->deriv_classes[6][7][8] = int_stack + 46048;
 Libderiv->deriv_classes[6][8][8] = int_stack + 47056;
 Libderiv->deriv_classes[6][9][8] = int_stack + 48316;
 Libderiv->deriv_classes[7][6][8] = int_stack + 49856;
 Libderiv->deriv_classes[7][7][8] = int_stack + 50864;
 Libderiv->deriv_classes[7][8][8] = int_stack + 52160;
 Libderiv->deriv_classes[7][9][8] = int_stack + 53780;
 Libderiv->deriv_classes[5][6][7] = int_stack + 55760;
 Libderiv->deriv_classes[5][7][7] = int_stack + 56348;
 Libderiv->deriv_classes[5][8][7] = int_stack + 57104;
 Libderiv->deriv_classes[5][9][7] = int_stack + 58049;
 Libderiv->deriv_classes[6][6][7] = int_stack + 59204;
 Libderiv->deriv_classes[6][7][7] = int_stack + 59988;
 Libderiv->deriv_classes[6][8][7] = int_stack + 60996;
 Libderiv->deriv_classes[6][9][7] = int_stack + 62256;
 Libderiv->deriv_classes[7][6][7] = int_stack + 63796;
 Libderiv->deriv_classes[7][7][7] = int_stack + 64804;
 Libderiv->deriv_classes[7][8][7] = int_stack + 66100;
 Libderiv->deriv_classes[7][9][7] = int_stack + 67720;
 Libderiv->deriv_classes[5][6][6] = int_stack + 69700;
 Libderiv->deriv_classes[5][7][6] = int_stack + 70288;
 Libderiv->deriv_classes[5][8][6] = int_stack + 71044;
 Libderiv->deriv_classes[5][9][6] = int_stack + 71989;
 Libderiv->deriv_classes[6][6][6] = int_stack + 73144;
 Libderiv->deriv_classes[6][7][6] = int_stack + 73928;
 Libderiv->deriv_classes[6][8][6] = int_stack + 74936;
 Libderiv->deriv_classes[6][9][6] = int_stack + 76196;
 Libderiv->dvrr_classes[7][6] = int_stack + 77736;
 Libderiv->deriv_classes[7][6][6] = int_stack + 78744;
 Libderiv->dvrr_classes[7][7] = int_stack + 79752;
 Libderiv->deriv_classes[7][7][6] = int_stack + 81048;
 Libderiv->dvrr_classes[7][8] = int_stack + 82344;
 Libderiv->deriv_classes[7][8][6] = int_stack + 83964;
 Libderiv->deriv_classes[7][9][6] = int_stack + 85584;
 Libderiv->deriv_classes[5][6][2] = int_stack + 87564;
 Libderiv->deriv_classes[5][7][2] = int_stack + 88152;
 Libderiv->deriv_classes[5][8][2] = int_stack + 88908;
 Libderiv->deriv_classes[5][9][2] = int_stack + 89853;
 Libderiv->deriv_classes[6][6][2] = int_stack + 91008;
 Libderiv->deriv_classes[6][7][2] = int_stack + 91792;
 Libderiv->deriv_classes[6][8][2] = int_stack + 92800;
 Libderiv->deriv_classes[6][9][2] = int_stack + 94060;
 Libderiv->deriv_classes[7][6][2] = int_stack + 95600;
 Libderiv->deriv_classes[7][7][2] = int_stack + 96608;
 Libderiv->deriv_classes[7][8][2] = int_stack + 97904;
 Libderiv->deriv_classes[7][9][2] = int_stack + 99524;
 Libderiv->deriv_classes[5][6][1] = int_stack + 101504;
 Libderiv->deriv_classes[5][7][1] = int_stack + 102092;
 Libderiv->deriv_classes[5][8][1] = int_stack + 102848;
 Libderiv->deriv_classes[5][9][1] = int_stack + 103793;
 Libderiv->deriv_classes[6][6][1] = int_stack + 104948;
 Libderiv->deriv_classes[6][7][1] = int_stack + 105732;
 Libderiv->deriv_classes[6][8][1] = int_stack + 106740;
 Libderiv->deriv_classes[6][9][1] = int_stack + 108000;
 Libderiv->deriv_classes[7][6][1] = int_stack + 109540;
 Libderiv->deriv_classes[7][7][1] = int_stack + 110548;
 Libderiv->deriv_classes[7][8][1] = int_stack + 111844;
 Libderiv->deriv_classes[7][9][1] = int_stack + 113464;
 Libderiv->dvrr_classes[5][6] = int_stack + 115444;
 Libderiv->dvrr_classes[5][7] = int_stack + 116032;
 Libderiv->dvrr_classes[5][8] = int_stack + 116788;
 Libderiv->dvrr_classes[5][9] = int_stack + 117733;
 Libderiv->deriv_classes[5][6][0] = int_stack + 118888;
 Libderiv->deriv_classes[5][7][0] = int_stack + 119476;
 Libderiv->deriv_classes[5][8][0] = int_stack + 120232;
 Libderiv->deriv_classes[5][9][0] = int_stack + 121177;
 Libderiv->dvrr_classes[6][6] = int_stack + 122332;
 Libderiv->dvrr_classes[6][7] = int_stack + 123116;
 Libderiv->dvrr_classes[6][8] = int_stack + 124124;
 Libderiv->dvrr_classes[6][9] = int_stack + 125384;
 Libderiv->deriv_classes[6][6][0] = int_stack + 126924;
 Libderiv->deriv_classes[6][7][0] = int_stack + 127708;
 Libderiv->deriv_classes[6][8][0] = int_stack + 128716;
 Libderiv->deriv_classes[6][9][0] = int_stack + 129976;
 Libderiv->deriv_classes[7][6][0] = int_stack + 131516;
 Libderiv->deriv_classes[7][7][0] = int_stack + 132524;
 Libderiv->deriv_classes[7][8][0] = int_stack + 133820;
 Libderiv->deriv_classes[7][9][0] = int_stack + 135440;
 memset(int_stack,0,1099360);

 Libderiv->dvrr_stack = int_stack + 500619;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hdif(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+137420,int_stack+116032,int_stack+115444,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+139184,int_stack+116788,int_stack+116032,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+141452,int_stack+139184,int_stack+137420,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+144980,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115444,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+146744,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116032,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+149012,int_stack+146744,int_stack+144980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137420,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+152540,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116788,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+155375,int_stack+152540,int_stack+146744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139184,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+159911,int_stack+155375,int_stack+149012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141452,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+144980,int_stack+123116,int_stack+122332,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+147332,int_stack+124124,int_stack+123116,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+150356,int_stack+147332,int_stack+144980,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+155060,int_stack+4228,int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122332,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+5236,int_stack+4228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123116,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+165791,int_stack+0,int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144980,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+155060,int_stack+6496,int_stack+5236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124124,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+170495,int_stack+155060,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147332,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+0,int_stack+170495,int_stack+165791, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150356,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+165791,int_stack+0,int_stack+159911,280);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+155060,int_stack+79752,int_stack+77736,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+158084,int_stack+82344,int_stack+79752,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+183431,int_stack+158084,int_stack+155060,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+161972,int_stack+9044,int_stack+8036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77736,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+189479,int_stack+10340,int_stack+9044, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79752,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+193367,int_stack+189479,int_stack+161972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155060,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+199415,int_stack+11960,int_stack+10340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82344,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+204275,int_stack+199415,int_stack+189479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158084,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+212051,int_stack+204275,int_stack+193367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183431,36);
 /*--- compute (ip|if) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+222131,int_stack+212051,int_stack+0,280);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+14528,int_stack+13940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115444, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1764,int_stack+15284,int_stack+14528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116032, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+4032,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137420, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+7560,int_stack+16229,int_stack+15284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116788, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+10395,int_stack+7560,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139184, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+189479,int_stack+10395,int_stack+4032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141452, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+18168,int_stack+17384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122332, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2352,int_stack+19176,int_stack+18168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123116, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+5376,int_stack+2352,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144980, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+10080,int_stack+20436,int_stack+19176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124124, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+13860,int_stack+10080,int_stack+2352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147332, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+195359,int_stack+13860,int_stack+5376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150356, 0.0, zero_stack,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+0,int_stack+195359,int_stack+189479,280);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+189479,int_stack+22984,int_stack+21976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77736, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17640,int_stack+24280,int_stack+22984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79752, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+203199,int_stack+17640,int_stack+189479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155060, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+189479,int_stack+25900,int_stack+24280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82344, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+209247,int_stack+189479,int_stack+17640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158084, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+17640,int_stack+209247,int_stack+203199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183431, 0.0, zero_stack,36);
 /*--- compute (ip|if) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+245651,int_stack+17640,int_stack+195359,280);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17640,int_stack+28468,int_stack+27880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115444, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+19404,int_stack+29224,int_stack+28468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116032, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21672,int_stack+19404,int_stack+17640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+25200,int_stack+30169,int_stack+29224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116788, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+189479,int_stack+25200,int_stack+19404, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139184, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+25200,int_stack+189479,int_stack+21672, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141452, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+189479,int_stack+32108,int_stack+31324, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122332, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+191831,int_stack+33116,int_stack+32108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123116, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+194855,int_stack+191831,int_stack+189479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144980, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+199559,int_stack+34376,int_stack+33116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124124, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+203339,int_stack+199559,int_stack+191831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147332, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+209387,int_stack+203339,int_stack+194855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150356, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+189479,int_stack+209387,int_stack+25200,280);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+217227,int_stack+36924,int_stack+35916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77736, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17640,int_stack+38220,int_stack+36924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79752, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+21528,int_stack+17640,int_stack+217227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+217227,int_stack+39840,int_stack+38220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82344, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+27576,int_stack+217227,int_stack+17640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158084, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+269171,int_stack+27576,int_stack+21528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183431, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|if) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+17640,int_stack+269171,int_stack+209387,280);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269171,int_stack+42408,int_stack+41820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+270935,int_stack+43164,int_stack+42408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+273203,int_stack+270935,int_stack+269171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+276731,int_stack+44109,int_stack+43164, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+207119,int_stack+276731,int_stack+270935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+139184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+211655,int_stack+207119,int_stack+273203, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+207119,int_stack+46048,int_stack+45264, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+269171,int_stack+47056,int_stack+46048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+272195,int_stack+269171,int_stack+207119, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+207119,int_stack+48316,int_stack+47056, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41160,int_stack+207119,int_stack+269171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+147332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+276899,int_stack+41160,int_stack+272195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+284739,int_stack+276899,int_stack+211655,280);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+41160,int_stack+50864,int_stack+49856, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+77736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+44184,int_stack+52160,int_stack+50864, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+79752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+269171,int_stack+44184,int_stack+41160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+207119,int_stack+53780,int_stack+52160, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+211979,int_stack+207119,int_stack+44184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+158084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+41160,int_stack+211979,int_stack+269171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+183431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|if) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+302379,int_stack+41160,int_stack+276899,280);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+41160,int_stack+56348,int_stack+55760, 0.0, zero_stack, 1.0, int_stack+115444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+42924,int_stack+57104,int_stack+56348, 0.0, zero_stack, 1.0, int_stack+116032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+45192,int_stack+42924,int_stack+41160, 0.0, zero_stack, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48720,int_stack+58049,int_stack+57104, 0.0, zero_stack, 1.0, int_stack+116788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+51555,int_stack+48720,int_stack+42924, 0.0, zero_stack, 1.0, int_stack+139184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+269171,int_stack+51555,int_stack+45192, 0.0, zero_stack, 1.0, int_stack+141452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+41160,int_stack+59988,int_stack+59204, 0.0, zero_stack, 1.0, int_stack+122332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+43512,int_stack+60996,int_stack+59988, 0.0, zero_stack, 1.0, int_stack+123116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46536,int_stack+43512,int_stack+41160, 0.0, zero_stack, 1.0, int_stack+144980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+51240,int_stack+62256,int_stack+60996, 0.0, zero_stack, 1.0, int_stack+124124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+55020,int_stack+51240,int_stack+43512, 0.0, zero_stack, 1.0, int_stack+147332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+275051,int_stack+55020,int_stack+46536, 0.0, zero_stack, 1.0, int_stack+150356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+41160,int_stack+275051,int_stack+269171,280);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+269171,int_stack+64804,int_stack+63796, 0.0, zero_stack, 1.0, int_stack+77736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+58800,int_stack+66100,int_stack+64804, 0.0, zero_stack, 1.0, int_stack+79752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+207119,int_stack+58800,int_stack+269171, 0.0, zero_stack, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+269171,int_stack+67720,int_stack+66100, 0.0, zero_stack, 1.0, int_stack+82344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+213167,int_stack+269171,int_stack+58800, 0.0, zero_stack, 1.0, int_stack+158084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+58800,int_stack+213167,int_stack+207119, 0.0, zero_stack, 1.0, int_stack+183431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|if) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+325899,int_stack+58800,int_stack+275051,280);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+58800,int_stack+70288,int_stack+69700, 1.0, int_stack+115444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+60564,int_stack+71044,int_stack+70288, 1.0, int_stack+116032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+62832,int_stack+60564,int_stack+58800, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+66360,int_stack+71989,int_stack+71044, 1.0, int_stack+116788, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+207119,int_stack+66360,int_stack+60564, 1.0, int_stack+139184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+66360,int_stack+207119,int_stack+62832, 1.0, int_stack+141452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+207119,int_stack+73928,int_stack+73144, 1.0, int_stack+122332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+209471,int_stack+74936,int_stack+73928, 1.0, int_stack+123116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+212495,int_stack+209471,int_stack+207119, 1.0, int_stack+144980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+217199,int_stack+76196,int_stack+74936, 1.0, int_stack+124124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58800,int_stack+217199,int_stack+209471, 1.0, int_stack+147332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+269171,int_stack+58800,int_stack+212495, 1.0, int_stack+150356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+349419,int_stack+269171,int_stack+66360,280);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+58800,int_stack+81048,int_stack+78744, 1.0, int_stack+77736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+61824,int_stack+83964,int_stack+81048, 1.0, int_stack+79752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+65712,int_stack+61824,int_stack+58800, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+71760,int_stack+85584,int_stack+83964, 1.0, int_stack+82344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+76620,int_stack+71760,int_stack+61824, 1.0, int_stack+158084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+155060,int_stack+76620,int_stack+65712, 1.0, int_stack+183431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|if) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+58800,int_stack+155060,int_stack+269171,280);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+269171,int_stack+117733,int_stack+116788,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+272006,int_stack+269171,int_stack+139184,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+276542,int_stack+272006,int_stack+141452,21);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+269171,int_stack+125384,int_stack+124124,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+183431,int_stack+269171,int_stack+147332,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+155060,int_stack+183431,int_stack+150356,28);
 /*--- compute (hp|if) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+137420,int_stack+155060,int_stack+276542,280);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+183431,int_stack+88152,int_stack+87564,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+185195,int_stack+88908,int_stack+88152,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+269171,int_stack+185195,int_stack+183431,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+272699,int_stack+89853,int_stack+88908,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+82320,int_stack+272699,int_stack+185195,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+183431,int_stack+82320,int_stack+269171,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+269171,int_stack+91792,int_stack+91008,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+271523,int_stack+92800,int_stack+91792,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+82320,int_stack+271523,int_stack+269171,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+87024,int_stack+94060,int_stack+92800,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+207119,int_stack+87024,int_stack+271523,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+87024,int_stack+207119,int_stack+82320,28);
 /*--- compute (hp|if) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+367059,int_stack+87024,int_stack+183431, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+183431,int_stack+96608,int_stack+95600,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+82320,int_stack+97904,int_stack+96608,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+207119,int_stack+82320,int_stack+183431,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+183431,int_stack+99524,int_stack+97904,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+213167,int_stack+183431,int_stack+82320,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+384699,int_stack+213167,int_stack+207119,36);
 /*--- compute (ip|if) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+394779,int_stack+384699,int_stack+87024, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+384699,int_stack+102092,int_stack+101504,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+386463,int_stack+102848,int_stack+102092,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+388731,int_stack+386463,int_stack+384699,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+207119,int_stack+103793,int_stack+102848,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+209954,int_stack+207119,int_stack+386463,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+214490,int_stack+209954,int_stack+388731,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+207119,int_stack+105732,int_stack+104948,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+209471,int_stack+106740,int_stack+105732,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+384699,int_stack+209471,int_stack+207119,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+389403,int_stack+108000,int_stack+106740,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+183431,int_stack+389403,int_stack+209471,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+82320,int_stack+183431,int_stack+384699,28);
 /*--- compute (hp|if) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+90160,int_stack+82320,int_stack+214490, 0.0, zero_stack, 1.0, int_stack+276542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+384699,int_stack+110548,int_stack+109540,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+387723,int_stack+111844,int_stack+110548,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+183431,int_stack+387723,int_stack+384699,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+207119,int_stack+113464,int_stack+111844,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+211979,int_stack+207119,int_stack+387723,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+384699,int_stack+211979,int_stack+183431,36);
 /*--- compute (ip|if) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+418299,int_stack+384699,int_stack+82320, 0.0, zero_stack, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+82320,int_stack+119476,int_stack+118888,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+84084,int_stack+120232,int_stack+119476,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+86352,int_stack+84084,int_stack+82320,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+384699,int_stack+121177,int_stack+120232,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+387534,int_stack+384699,int_stack+84084,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+183431,int_stack+387534,int_stack+86352,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+384699,int_stack+127708,int_stack+126924,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+387051,int_stack+128716,int_stack+127708,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+390075,int_stack+387051,int_stack+384699,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+82320,int_stack+129976,int_stack+128716,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+207119,int_stack+82320,int_stack+387051,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+82320,int_stack+207119,int_stack+390075,28);
 /*--- compute (hp|if) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+107800,int_stack+82320,int_stack+183431, 1.0, int_stack+276542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+183431,int_stack+132524,int_stack+131516,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+207119,int_stack+133820,int_stack+132524,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+211007,int_stack+207119,int_stack+183431,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+183431,int_stack+135440,int_stack+133820,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+384699,int_stack+183431,int_stack+207119,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+125440,int_stack+384699,int_stack+211007,36);
 /*--- compute (ip|if) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+441819,int_stack+125440,int_stack+82320, 1.0, int_stack+155060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
 /*--- compute (hd|if) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+465339,int_stack+222131,int_stack+165791,280);
     Libderiv->ABCD[11] = int_stack + 465339;
 /*--- compute (hd|if) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+207119,int_stack+245651,int_stack+0,280);
     Libderiv->ABCD[10] = int_stack + 207119;
 /*--- compute (hd|if) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+242399,int_stack+17640,int_stack+189479,280);
     Libderiv->ABCD[9] = int_stack + 242399;
 /*--- compute (hd|if) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+0,int_stack+302379,int_stack+284739,280);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (hd|if) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+155060,int_stack+325899,int_stack+41160,280);
     Libderiv->ABCD[7] = int_stack + 155060;
 /*--- compute (hd|if) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+277679,int_stack+58800,int_stack+349419,280);
     Libderiv->ABCD[6] = int_stack + 277679;
 /*--- compute (hd|if) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+35280,int_stack+394779,int_stack+367059, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
     Libderiv->ABCD[2] = int_stack + 35280;
 /*--- compute (hd|if) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+312959,int_stack+418299,int_stack+90160, 0.0, zero_stack, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
     Libderiv->ABCD[1] = int_stack + 312959;
 /*--- compute (hd|if) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+70560,int_stack+441819,int_stack+107800, 1.0, int_stack+137420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,280);
     Libderiv->ABCD[0] = int_stack + 70560;

}
