/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hfhg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hf|hg) integrals */

void d1hrr_order_hfhg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][5][11] = int_stack + 0;
 Libderiv->deriv_classes[5][6][11] = int_stack + 441;
 Libderiv->deriv_classes[5][7][11] = int_stack + 1029;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1785;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2730;
 Libderiv->deriv_classes[6][5][11] = int_stack + 3885;
 Libderiv->deriv_classes[6][6][11] = int_stack + 4473;
 Libderiv->deriv_classes[6][7][11] = int_stack + 5257;
 Libderiv->deriv_classes[6][8][11] = int_stack + 6265;
 Libderiv->deriv_classes[6][9][11] = int_stack + 7525;
 Libderiv->deriv_classes[7][5][11] = int_stack + 9065;
 Libderiv->deriv_classes[7][6][11] = int_stack + 9821;
 Libderiv->deriv_classes[7][7][11] = int_stack + 10829;
 Libderiv->deriv_classes[7][8][11] = int_stack + 12125;
 Libderiv->deriv_classes[7][9][11] = int_stack + 13745;
 Libderiv->deriv_classes[8][5][11] = int_stack + 15725;
 Libderiv->deriv_classes[8][6][11] = int_stack + 16670;
 Libderiv->deriv_classes[8][7][11] = int_stack + 17930;
 Libderiv->deriv_classes[8][8][11] = int_stack + 19550;
 Libderiv->deriv_classes[8][9][11] = int_stack + 21575;
 Libderiv->deriv_classes[5][5][10] = int_stack + 24050;
 Libderiv->deriv_classes[5][6][10] = int_stack + 24491;
 Libderiv->deriv_classes[5][7][10] = int_stack + 25079;
 Libderiv->deriv_classes[5][8][10] = int_stack + 25835;
 Libderiv->deriv_classes[5][9][10] = int_stack + 26780;
 Libderiv->deriv_classes[6][5][10] = int_stack + 27935;
 Libderiv->deriv_classes[6][6][10] = int_stack + 28523;
 Libderiv->deriv_classes[6][7][10] = int_stack + 29307;
 Libderiv->deriv_classes[6][8][10] = int_stack + 30315;
 Libderiv->deriv_classes[6][9][10] = int_stack + 31575;
 Libderiv->deriv_classes[7][5][10] = int_stack + 33115;
 Libderiv->deriv_classes[7][6][10] = int_stack + 33871;
 Libderiv->deriv_classes[7][7][10] = int_stack + 34879;
 Libderiv->deriv_classes[7][8][10] = int_stack + 36175;
 Libderiv->deriv_classes[7][9][10] = int_stack + 37795;
 Libderiv->deriv_classes[8][5][10] = int_stack + 39775;
 Libderiv->deriv_classes[8][6][10] = int_stack + 40720;
 Libderiv->deriv_classes[8][7][10] = int_stack + 41980;
 Libderiv->deriv_classes[8][8][10] = int_stack + 43600;
 Libderiv->deriv_classes[8][9][10] = int_stack + 45625;
 Libderiv->deriv_classes[5][5][9] = int_stack + 48100;
 Libderiv->deriv_classes[5][6][9] = int_stack + 48541;
 Libderiv->deriv_classes[5][7][9] = int_stack + 49129;
 Libderiv->deriv_classes[5][8][9] = int_stack + 49885;
 Libderiv->deriv_classes[5][9][9] = int_stack + 50830;
 Libderiv->deriv_classes[6][5][9] = int_stack + 51985;
 Libderiv->deriv_classes[6][6][9] = int_stack + 52573;
 Libderiv->deriv_classes[6][7][9] = int_stack + 53357;
 Libderiv->deriv_classes[6][8][9] = int_stack + 54365;
 Libderiv->deriv_classes[6][9][9] = int_stack + 55625;
 Libderiv->deriv_classes[7][5][9] = int_stack + 57165;
 Libderiv->deriv_classes[7][6][9] = int_stack + 57921;
 Libderiv->deriv_classes[7][7][9] = int_stack + 58929;
 Libderiv->deriv_classes[7][8][9] = int_stack + 60225;
 Libderiv->deriv_classes[7][9][9] = int_stack + 61845;
 Libderiv->deriv_classes[8][5][9] = int_stack + 63825;
 Libderiv->deriv_classes[8][6][9] = int_stack + 64770;
 Libderiv->deriv_classes[8][7][9] = int_stack + 66030;
 Libderiv->deriv_classes[8][8][9] = int_stack + 67650;
 Libderiv->deriv_classes[8][9][9] = int_stack + 69675;
 Libderiv->deriv_classes[5][5][8] = int_stack + 72150;
 Libderiv->deriv_classes[5][6][8] = int_stack + 72591;
 Libderiv->deriv_classes[5][7][8] = int_stack + 73179;
 Libderiv->deriv_classes[5][8][8] = int_stack + 73935;
 Libderiv->deriv_classes[5][9][8] = int_stack + 74880;
 Libderiv->deriv_classes[6][5][8] = int_stack + 76035;
 Libderiv->deriv_classes[6][6][8] = int_stack + 76623;
 Libderiv->deriv_classes[6][7][8] = int_stack + 77407;
 Libderiv->deriv_classes[6][8][8] = int_stack + 78415;
 Libderiv->deriv_classes[6][9][8] = int_stack + 79675;
 Libderiv->deriv_classes[7][5][8] = int_stack + 81215;
 Libderiv->deriv_classes[7][6][8] = int_stack + 81971;
 Libderiv->deriv_classes[7][7][8] = int_stack + 82979;
 Libderiv->deriv_classes[7][8][8] = int_stack + 84275;
 Libderiv->deriv_classes[7][9][8] = int_stack + 85895;
 Libderiv->deriv_classes[8][5][8] = int_stack + 87875;
 Libderiv->deriv_classes[8][6][8] = int_stack + 88820;
 Libderiv->deriv_classes[8][7][8] = int_stack + 90080;
 Libderiv->deriv_classes[8][8][8] = int_stack + 91700;
 Libderiv->deriv_classes[8][9][8] = int_stack + 93725;
 Libderiv->deriv_classes[5][5][7] = int_stack + 96200;
 Libderiv->deriv_classes[5][6][7] = int_stack + 96641;
 Libderiv->deriv_classes[5][7][7] = int_stack + 97229;
 Libderiv->deriv_classes[5][8][7] = int_stack + 97985;
 Libderiv->deriv_classes[5][9][7] = int_stack + 98930;
 Libderiv->deriv_classes[6][5][7] = int_stack + 100085;
 Libderiv->deriv_classes[6][6][7] = int_stack + 100673;
 Libderiv->deriv_classes[6][7][7] = int_stack + 101457;
 Libderiv->deriv_classes[6][8][7] = int_stack + 102465;
 Libderiv->deriv_classes[6][9][7] = int_stack + 103725;
 Libderiv->deriv_classes[7][5][7] = int_stack + 105265;
 Libderiv->deriv_classes[7][6][7] = int_stack + 106021;
 Libderiv->deriv_classes[7][7][7] = int_stack + 107029;
 Libderiv->deriv_classes[7][8][7] = int_stack + 108325;
 Libderiv->deriv_classes[7][9][7] = int_stack + 109945;
 Libderiv->deriv_classes[8][5][7] = int_stack + 111925;
 Libderiv->deriv_classes[8][6][7] = int_stack + 112870;
 Libderiv->deriv_classes[8][7][7] = int_stack + 114130;
 Libderiv->deriv_classes[8][8][7] = int_stack + 115750;
 Libderiv->deriv_classes[8][9][7] = int_stack + 117775;
 Libderiv->deriv_classes[5][5][6] = int_stack + 120250;
 Libderiv->deriv_classes[5][6][6] = int_stack + 120691;
 Libderiv->deriv_classes[5][7][6] = int_stack + 121279;
 Libderiv->deriv_classes[5][8][6] = int_stack + 122035;
 Libderiv->deriv_classes[5][9][6] = int_stack + 122980;
 Libderiv->deriv_classes[6][5][6] = int_stack + 124135;
 Libderiv->deriv_classes[6][6][6] = int_stack + 124723;
 Libderiv->deriv_classes[6][7][6] = int_stack + 125507;
 Libderiv->deriv_classes[6][8][6] = int_stack + 126515;
 Libderiv->deriv_classes[6][9][6] = int_stack + 127775;
 Libderiv->deriv_classes[7][5][6] = int_stack + 129315;
 Libderiv->deriv_classes[7][6][6] = int_stack + 130071;
 Libderiv->deriv_classes[7][7][6] = int_stack + 131079;
 Libderiv->deriv_classes[7][8][6] = int_stack + 132375;
 Libderiv->deriv_classes[7][9][6] = int_stack + 133995;
 Libderiv->dvrr_classes[8][5] = int_stack + 135975;
 Libderiv->deriv_classes[8][5][6] = int_stack + 136920;
 Libderiv->dvrr_classes[8][6] = int_stack + 137865;
 Libderiv->deriv_classes[8][6][6] = int_stack + 139125;
 Libderiv->dvrr_classes[8][7] = int_stack + 140385;
 Libderiv->deriv_classes[8][7][6] = int_stack + 142005;
 Libderiv->dvrr_classes[8][8] = int_stack + 143625;
 Libderiv->deriv_classes[8][8][6] = int_stack + 145650;
 Libderiv->deriv_classes[8][9][6] = int_stack + 147675;
 Libderiv->deriv_classes[5][5][2] = int_stack + 150150;
 Libderiv->deriv_classes[5][6][2] = int_stack + 150591;
 Libderiv->deriv_classes[5][7][2] = int_stack + 151179;
 Libderiv->deriv_classes[5][8][2] = int_stack + 151935;
 Libderiv->deriv_classes[5][9][2] = int_stack + 152880;
 Libderiv->deriv_classes[6][5][2] = int_stack + 154035;
 Libderiv->deriv_classes[6][6][2] = int_stack + 154623;
 Libderiv->deriv_classes[6][7][2] = int_stack + 155407;
 Libderiv->deriv_classes[6][8][2] = int_stack + 156415;
 Libderiv->deriv_classes[6][9][2] = int_stack + 157675;
 Libderiv->deriv_classes[7][5][2] = int_stack + 159215;
 Libderiv->deriv_classes[7][6][2] = int_stack + 159971;
 Libderiv->deriv_classes[7][7][2] = int_stack + 160979;
 Libderiv->deriv_classes[7][8][2] = int_stack + 162275;
 Libderiv->deriv_classes[7][9][2] = int_stack + 163895;
 Libderiv->deriv_classes[8][5][2] = int_stack + 165875;
 Libderiv->deriv_classes[8][6][2] = int_stack + 166820;
 Libderiv->deriv_classes[8][7][2] = int_stack + 168080;
 Libderiv->deriv_classes[8][8][2] = int_stack + 169700;
 Libderiv->deriv_classes[8][9][2] = int_stack + 171725;
 Libderiv->deriv_classes[5][5][1] = int_stack + 174200;
 Libderiv->deriv_classes[5][6][1] = int_stack + 174641;
 Libderiv->deriv_classes[5][7][1] = int_stack + 175229;
 Libderiv->deriv_classes[5][8][1] = int_stack + 175985;
 Libderiv->deriv_classes[5][9][1] = int_stack + 176930;
 Libderiv->deriv_classes[6][5][1] = int_stack + 178085;
 Libderiv->deriv_classes[6][6][1] = int_stack + 178673;
 Libderiv->deriv_classes[6][7][1] = int_stack + 179457;
 Libderiv->deriv_classes[6][8][1] = int_stack + 180465;
 Libderiv->deriv_classes[6][9][1] = int_stack + 181725;
 Libderiv->deriv_classes[7][5][1] = int_stack + 183265;
 Libderiv->deriv_classes[7][6][1] = int_stack + 184021;
 Libderiv->deriv_classes[7][7][1] = int_stack + 185029;
 Libderiv->deriv_classes[7][8][1] = int_stack + 186325;
 Libderiv->deriv_classes[7][9][1] = int_stack + 187945;
 Libderiv->deriv_classes[8][5][1] = int_stack + 189925;
 Libderiv->deriv_classes[8][6][1] = int_stack + 190870;
 Libderiv->deriv_classes[8][7][1] = int_stack + 192130;
 Libderiv->deriv_classes[8][8][1] = int_stack + 193750;
 Libderiv->deriv_classes[8][9][1] = int_stack + 195775;
 Libderiv->dvrr_classes[5][5] = int_stack + 198250;
 Libderiv->dvrr_classes[5][6] = int_stack + 198691;
 Libderiv->dvrr_classes[5][7] = int_stack + 199279;
 Libderiv->dvrr_classes[5][8] = int_stack + 200035;
 Libderiv->dvrr_classes[5][9] = int_stack + 200980;
 Libderiv->deriv_classes[5][5][0] = int_stack + 202135;
 Libderiv->deriv_classes[5][6][0] = int_stack + 202576;
 Libderiv->deriv_classes[5][7][0] = int_stack + 203164;
 Libderiv->deriv_classes[5][8][0] = int_stack + 203920;
 Libderiv->deriv_classes[5][9][0] = int_stack + 204865;
 Libderiv->dvrr_classes[6][5] = int_stack + 206020;
 Libderiv->dvrr_classes[6][6] = int_stack + 206608;
 Libderiv->dvrr_classes[6][7] = int_stack + 207392;
 Libderiv->dvrr_classes[6][8] = int_stack + 208400;
 Libderiv->dvrr_classes[6][9] = int_stack + 209660;
 Libderiv->deriv_classes[6][5][0] = int_stack + 211200;
 Libderiv->deriv_classes[6][6][0] = int_stack + 211788;
 Libderiv->deriv_classes[6][7][0] = int_stack + 212572;
 Libderiv->deriv_classes[6][8][0] = int_stack + 213580;
 Libderiv->deriv_classes[6][9][0] = int_stack + 214840;
 Libderiv->dvrr_classes[7][5] = int_stack + 216380;
 Libderiv->dvrr_classes[7][6] = int_stack + 217136;
 Libderiv->dvrr_classes[7][7] = int_stack + 218144;
 Libderiv->dvrr_classes[7][8] = int_stack + 219440;
 Libderiv->dvrr_classes[7][9] = int_stack + 221060;
 Libderiv->deriv_classes[7][5][0] = int_stack + 223040;
 Libderiv->deriv_classes[7][6][0] = int_stack + 223796;
 Libderiv->deriv_classes[7][7][0] = int_stack + 224804;
 Libderiv->deriv_classes[7][8][0] = int_stack + 226100;
 Libderiv->deriv_classes[7][9][0] = int_stack + 227720;
 Libderiv->deriv_classes[8][5][0] = int_stack + 229700;
 Libderiv->deriv_classes[8][6][0] = int_stack + 230645;
 Libderiv->deriv_classes[8][7][0] = int_stack + 231905;
 Libderiv->deriv_classes[8][8][0] = int_stack + 233525;
 Libderiv->deriv_classes[8][9][0] = int_stack + 235550;
 memset(int_stack,0,1904200);

 Libderiv->dvrr_stack = int_stack + 1199039;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hfhg(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+238025,int_stack+198691,int_stack+198250,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+239348,int_stack+199279,int_stack+198691,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+241112,int_stack+239348,int_stack+238025,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+243758,int_stack+200035,int_stack+199279,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+246026,int_stack+243758,int_stack+239348,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+249554,int_stack+246026,int_stack+241112,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+253964,int_stack+441,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198250,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+255287,int_stack+1029,int_stack+441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198691,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+257051,int_stack+255287,int_stack+253964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238025,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+259697,int_stack+1785,int_stack+1029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199279,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+261965,int_stack+259697,int_stack+255287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239348,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+265493,int_stack+261965,int_stack+257051, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241112,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+253964,int_stack+2730,int_stack+1785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200035,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+269903,int_stack+253964,int_stack+259697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243758,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+253964,int_stack+269903,int_stack+261965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246026,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+269903,int_stack+253964,int_stack+265493, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249554,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+253964,int_stack+206608,int_stack+206020,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+255728,int_stack+207392,int_stack+206608,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+258080,int_stack+255728,int_stack+253964,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+261608,int_stack+208400,int_stack+207392,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+264632,int_stack+261608,int_stack+255728,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+276518,int_stack+264632,int_stack+258080,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+4473,int_stack+3885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206020,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1764,int_stack+5257,int_stack+4473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206608,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+282398,int_stack+1764,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253964,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+285926,int_stack+6265,int_stack+5257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207392,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+288950,int_stack+285926,int_stack+1764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255728,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+288950,int_stack+282398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258080,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+293654,int_stack+7525,int_stack+6265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208400,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+297434,int_stack+293654,int_stack+285926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261608,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+303482,int_stack+297434,int_stack+288950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264632,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+282398,int_stack+303482,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276518,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+291218,int_stack+282398,int_stack+269903,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+217136,int_stack+216380,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2268,int_stack+218144,int_stack+217136,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+269336,int_stack+2268,int_stack+0,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+311063,int_stack+219440,int_stack+218144,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+314951,int_stack+311063,int_stack+2268,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+320999,int_stack+314951,int_stack+269336,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5292,int_stack+9821,int_stack+9065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216380,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+328559,int_stack+10829,int_stack+9821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217136,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+331583,int_stack+328559,int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5292,int_stack+12125,int_stack+10829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218144,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+336119,int_stack+5292,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+342167,int_stack+336119,int_stack+331583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269336,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328559,int_stack+13745,int_stack+12125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219440,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+349727,int_stack+328559,int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311063,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+5292,int_stack+349727,int_stack+336119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314951,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+328559,int_stack+5292,int_stack+342167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320999,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+339899,int_stack+328559,int_stack+282398,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+366359,int_stack+339899,int_stack+291218,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+282398,int_stack+137865,int_stack+135975,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+285233,int_stack+140385,int_stack+137865,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+289013,int_stack+285233,int_stack+282398,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+294683,int_stack+143625,int_stack+140385,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+299543,int_stack+294683,int_stack+285233,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+5292,int_stack+299543,int_stack+289013,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+307103,int_stack+16670,int_stack+15725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135975,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+406049,int_stack+17930,int_stack+16670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137865,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+409829,int_stack+406049,int_stack+307103, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282398,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+415499,int_stack+19550,int_stack+17930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140385,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+420359,int_stack+415499,int_stack+406049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285233,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+427919,int_stack+420359,int_stack+409829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289013,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+406049,int_stack+21575,int_stack+19550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143625,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+437369,int_stack+406049,int_stack+415499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294683,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+406049,int_stack+437369,int_stack+420359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299543,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+437369,int_stack+406049,int_stack+427919, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5292,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+451544,int_stack+437369,int_stack+328559,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+485564,int_stack+451544,int_stack+339899,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+328559,int_stack+24491,int_stack+24050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198250, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+329882,int_stack+25079,int_stack+24491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198691, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273872,int_stack+329882,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238025, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+331646,int_stack+25835,int_stack+25079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199279, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333914,int_stack+331646,int_stack+329882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239348, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+337442,int_stack+333914,int_stack+273872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241112, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328559,int_stack+26780,int_stack+25835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200035, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+341852,int_stack+328559,int_stack+331646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243758, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+346388,int_stack+341852,int_stack+333914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246026, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+328559,int_stack+346388,int_stack+337442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249554, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+335174,int_stack+28523,int_stack+27935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206020, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+336938,int_stack+29307,int_stack+28523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206608, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+339290,int_stack+336938,int_stack+335174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253964, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+342818,int_stack+30315,int_stack+29307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207392, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+345842,int_stack+342818,int_stack+336938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255728, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+350546,int_stack+345842,int_stack+339290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258080, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+335174,int_stack+31575,int_stack+30315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208400, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+356426,int_stack+335174,int_stack+342818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261608, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+335174,int_stack+356426,int_stack+345842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264632, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+356426,int_stack+335174,int_stack+350546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276518, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+335174,int_stack+356426,int_stack+328559,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+328559,int_stack+33871,int_stack+33115, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216380, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+330827,int_stack+34879,int_stack+33871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217136, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+406049,int_stack+330827,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+410585,int_stack+36175,int_stack+34879, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218144, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414473,int_stack+410585,int_stack+330827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+420521,int_stack+414473,int_stack+406049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269336, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328559,int_stack+37795,int_stack+36175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219440, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+428081,int_stack+328559,int_stack+410585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311063, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+435857,int_stack+428081,int_stack+414473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314951, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+406049,int_stack+435857,int_stack+420521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320999, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+417389,int_stack+406049,int_stack+356426,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+443849,int_stack+417389,int_stack+335174,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+328559,int_stack+40720,int_stack+39775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135975, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+331394,int_stack+41980,int_stack+40720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137865, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+335174,int_stack+331394,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282398, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+340844,int_stack+43600,int_stack+41980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140385, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+345704,int_stack+340844,int_stack+331394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285233, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+353264,int_stack+345704,int_stack+335174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289013, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328559,int_stack+45625,int_stack+43600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143625, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+14742,int_stack+328559,int_stack+340844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294683, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+328559,int_stack+14742,int_stack+345704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299543, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14742,int_stack+328559,int_stack+353264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+328559,int_stack+14742,int_stack+406049,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+538484,int_stack+328559,int_stack+417389,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+328559,int_stack+48541,int_stack+48100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198250, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+329882,int_stack+49129,int_stack+48541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198691, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273872,int_stack+329882,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238025, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+331646,int_stack+49885,int_stack+49129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199279, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+333914,int_stack+331646,int_stack+329882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239348, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+337442,int_stack+333914,int_stack+273872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241112, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328559,int_stack+50830,int_stack+49885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200035, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+341852,int_stack+328559,int_stack+331646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243758, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+346388,int_stack+341852,int_stack+333914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246026, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+328559,int_stack+346388,int_stack+337442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249554, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+335174,int_stack+52573,int_stack+51985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206020, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+336938,int_stack+53357,int_stack+52573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206608, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+339290,int_stack+336938,int_stack+335174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253964, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+342818,int_stack+54365,int_stack+53357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207392, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+345842,int_stack+342818,int_stack+336938, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255728, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+350546,int_stack+345842,int_stack+339290, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258080, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+335174,int_stack+55625,int_stack+54365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208400, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+356426,int_stack+335174,int_stack+342818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261608, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+335174,int_stack+356426,int_stack+345842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264632, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+356426,int_stack+335174,int_stack+350546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276518, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+335174,int_stack+356426,int_stack+328559,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+328559,int_stack+57921,int_stack+57165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216380, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+330827,int_stack+58929,int_stack+57921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217136, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+406049,int_stack+330827,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+410585,int_stack+60225,int_stack+58929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218144, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+414473,int_stack+410585,int_stack+330827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+420521,int_stack+414473,int_stack+406049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269336, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+328559,int_stack+61845,int_stack+60225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219440, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+428081,int_stack+328559,int_stack+410585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311063, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+14742,int_stack+428081,int_stack+414473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314951, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+428081,int_stack+14742,int_stack+420521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320999, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+14742,int_stack+428081,int_stack+356426,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+591404,int_stack+14742,int_stack+335174,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41202,int_stack+64770,int_stack+63825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135975, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+44037,int_stack+66030,int_stack+64770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137865, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+47817,int_stack+44037,int_stack+41202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282398, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+53487,int_stack+67650,int_stack+66030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140385, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+58347,int_stack+53487,int_stack+44037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285233, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+328559,int_stack+58347,int_stack+47817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289013, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+41202,int_stack+69675,int_stack+67650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143625, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+338009,int_stack+41202,int_stack+53487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294683, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+41202,int_stack+338009,int_stack+58347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299543, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+338009,int_stack+41202,int_stack+328559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+631094,int_stack+338009,int_stack+428081,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+665114,int_stack+631094,int_stack+14742,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14742,int_stack+72591,int_stack+72150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16065,int_stack+73179,int_stack+72591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+198691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273872,int_stack+16065,int_stack+14742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+17829,int_stack+73935,int_stack+73179, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20097,int_stack+17829,int_stack+16065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+23625,int_stack+20097,int_stack+273872, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14742,int_stack+74880,int_stack+73935, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+200035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+28035,int_stack+14742,int_stack+17829, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+32571,int_stack+28035,int_stack+20097, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14742,int_stack+32571,int_stack+23625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+249554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+21357,int_stack+76623,int_stack+76035, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+23121,int_stack+77407,int_stack+76623, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+25473,int_stack+23121,int_stack+21357, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+253964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+29001,int_stack+78415,int_stack+77407, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+32025,int_stack+29001,int_stack+23121, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+36729,int_stack+32025,int_stack+25473, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21357,int_stack+79675,int_stack+78415, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+208400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+42609,int_stack+21357,int_stack+29001, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+21357,int_stack+42609,int_stack+32025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+42609,int_stack+21357,int_stack+36729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+21357,int_stack+42609,int_stack+14742,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14742,int_stack+81971,int_stack+81215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+216380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17010,int_stack+82979,int_stack+81971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+51429,int_stack+17010,int_stack+14742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+55965,int_stack+84275,int_stack+82979, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+218144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+59853,int_stack+55965,int_stack+17010, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+65901,int_stack+59853,int_stack+51429, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+14742,int_stack+85895,int_stack+84275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+73461,int_stack+14742,int_stack+55965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+631094,int_stack+73461,int_stack+59853, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+73461,int_stack+631094,int_stack+65901, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+631094,int_stack+73461,int_stack+42609,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+718034,int_stack+631094,int_stack+21357,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+657554,int_stack+88820,int_stack+87875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+660389,int_stack+90080,int_stack+88820, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+14742,int_stack+660389,int_stack+657554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+84801,int_stack+91700,int_stack+90080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+140385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+20412,int_stack+84801,int_stack+660389, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+27972,int_stack+20412,int_stack+14742, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+657554,int_stack+93725,int_stack+91700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+37422,int_stack+657554,int_stack+84801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+294683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+47142,int_stack+37422,int_stack+20412, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+328559,int_stack+47142,int_stack+27972, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+14742,int_stack+328559,int_stack+73461,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+757724,int_stack+14742,int_stack+631094,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+631094,int_stack+96641,int_stack+96200, 0.0, zero_stack, 1.0, int_stack+198250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+632417,int_stack+97229,int_stack+96641, 0.0, zero_stack, 1.0, int_stack+198691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273872,int_stack+632417,int_stack+631094, 0.0, zero_stack, 1.0, int_stack+238025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+634181,int_stack+97985,int_stack+97229, 0.0, zero_stack, 1.0, int_stack+199279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+636449,int_stack+634181,int_stack+632417, 0.0, zero_stack, 1.0, int_stack+239348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+639977,int_stack+636449,int_stack+273872, 0.0, zero_stack, 1.0, int_stack+241112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+631094,int_stack+98930,int_stack+97985, 0.0, zero_stack, 1.0, int_stack+200035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+644387,int_stack+631094,int_stack+634181, 0.0, zero_stack, 1.0, int_stack+243758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+648923,int_stack+644387,int_stack+636449, 0.0, zero_stack, 1.0, int_stack+246026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+631094,int_stack+648923,int_stack+639977, 0.0, zero_stack, 1.0, int_stack+249554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+637709,int_stack+100673,int_stack+100085, 0.0, zero_stack, 1.0, int_stack+206020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+639473,int_stack+101457,int_stack+100673, 0.0, zero_stack, 1.0, int_stack+206608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+641825,int_stack+639473,int_stack+637709, 0.0, zero_stack, 1.0, int_stack+253964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+645353,int_stack+102465,int_stack+101457, 0.0, zero_stack, 1.0, int_stack+207392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+648377,int_stack+645353,int_stack+639473, 0.0, zero_stack, 1.0, int_stack+255728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+653081,int_stack+648377,int_stack+641825, 0.0, zero_stack, 1.0, int_stack+258080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+637709,int_stack+103725,int_stack+102465, 0.0, zero_stack, 1.0, int_stack+208400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+658961,int_stack+637709,int_stack+645353, 0.0, zero_stack, 1.0, int_stack+261608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+637709,int_stack+658961,int_stack+648377, 0.0, zero_stack, 1.0, int_stack+264632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+14742,int_stack+637709,int_stack+653081, 0.0, zero_stack, 1.0, int_stack+276518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+637709,int_stack+14742,int_stack+631094,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+631094,int_stack+106021,int_stack+105265, 0.0, zero_stack, 1.0, int_stack+216380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+633362,int_stack+107029,int_stack+106021, 0.0, zero_stack, 1.0, int_stack+217136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+657554,int_stack+633362,int_stack+631094, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+23562,int_stack+108325,int_stack+107029, 0.0, zero_stack, 1.0, int_stack+218144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+27450,int_stack+23562,int_stack+633362, 0.0, zero_stack, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+33498,int_stack+27450,int_stack+657554, 0.0, zero_stack, 1.0, int_stack+269336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+657554,int_stack+109945,int_stack+108325, 0.0, zero_stack, 1.0, int_stack+219440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+41058,int_stack+657554,int_stack+23562, 0.0, zero_stack, 1.0, int_stack+311063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+48834,int_stack+41058,int_stack+27450, 0.0, zero_stack, 1.0, int_stack+314951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+58914,int_stack+48834,int_stack+33498, 0.0, zero_stack, 1.0, int_stack+320999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+23562,int_stack+58914,int_stack+14742,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+70254,int_stack+23562,int_stack+637709,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+14742,int_stack+112870,int_stack+111925, 0.0, zero_stack, 1.0, int_stack+135975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+17577,int_stack+114130,int_stack+112870, 0.0, zero_stack, 1.0, int_stack+137865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+50022,int_stack+17577,int_stack+14742, 0.0, zero_stack, 1.0, int_stack+282398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+631094,int_stack+115750,int_stack+114130, 0.0, zero_stack, 1.0, int_stack+140385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+635954,int_stack+631094,int_stack+17577, 0.0, zero_stack, 1.0, int_stack+285233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+643514,int_stack+635954,int_stack+50022, 0.0, zero_stack, 1.0, int_stack+289013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+50022,int_stack+117775,int_stack+115750, 0.0, zero_stack, 1.0, int_stack+143625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+652964,int_stack+50022,int_stack+631094, 0.0, zero_stack, 1.0, int_stack+294683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+328559,int_stack+652964,int_stack+635954, 0.0, zero_stack, 1.0, int_stack+299543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+341159,int_stack+328559,int_stack+643514, 0.0, zero_stack, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+631094,int_stack+341159,int_stack+58914,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+810644,int_stack+631094,int_stack+23562,315);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+631094,int_stack+120691,int_stack+120250, 1.0, int_stack+198250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+632417,int_stack+121279,int_stack+120691, 1.0, int_stack+198691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+273872,int_stack+632417,int_stack+631094, 1.0, int_stack+238025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+634181,int_stack+122035,int_stack+121279, 1.0, int_stack+199279, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+636449,int_stack+634181,int_stack+632417, 1.0, int_stack+239348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+639977,int_stack+636449,int_stack+273872, 1.0, int_stack+241112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+238025,int_stack+122980,int_stack+122035, 1.0, int_stack+200035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+644387,int_stack+238025,int_stack+634181, 1.0, int_stack+243758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+648923,int_stack+644387,int_stack+636449, 1.0, int_stack+246026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+631094,int_stack+648923,int_stack+639977, 1.0, int_stack+249554, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+238025,int_stack+124723,int_stack+124135, 1.0, int_stack+206020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+239789,int_stack+125507,int_stack+124723, 1.0, int_stack+206608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+637709,int_stack+239789,int_stack+238025, 1.0, int_stack+253964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+641237,int_stack+126515,int_stack+125507, 1.0, int_stack+207392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+644261,int_stack+641237,int_stack+239789, 1.0, int_stack+255728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+648965,int_stack+644261,int_stack+637709, 1.0, int_stack+258080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+253964,int_stack+127775,int_stack+126515, 1.0, int_stack+208400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+654845,int_stack+253964,int_stack+641237, 1.0, int_stack+261608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+328559,int_stack+654845,int_stack+644261, 1.0, int_stack+264632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+654845,int_stack+328559,int_stack+648965, 1.0, int_stack+276518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+328559,int_stack+654845,int_stack+631094,315);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+631094,int_stack+130071,int_stack+129315, 1.0, int_stack+216380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+633362,int_stack+131079,int_stack+130071, 1.0, int_stack+217136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+636386,int_stack+633362,int_stack+631094, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+640922,int_stack+132375,int_stack+131079, 1.0, int_stack+218144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+644810,int_stack+640922,int_stack+633362, 1.0, int_stack+2268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+348404,int_stack+644810,int_stack+636386, 1.0, int_stack+269336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+269336,int_stack+133995,int_stack+132375, 1.0, int_stack+219440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+631094,int_stack+269336,int_stack+640922, 1.0, int_stack+311063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+355964,int_stack+631094,int_stack+644810, 1.0, int_stack+314951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+631094,int_stack+355964,int_stack+348404, 1.0, int_stack+320999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+14742,int_stack+631094,int_stack+654845,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+863564,int_stack+14742,int_stack+328559,315);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+328559,int_stack+139125,int_stack+136920, 1.0, int_stack+135975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+331394,int_stack+142005,int_stack+139125, 1.0, int_stack+137865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+335174,int_stack+331394,int_stack+328559, 1.0, int_stack+282398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+340844,int_stack+145650,int_stack+142005, 1.0, int_stack+140385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+345704,int_stack+340844,int_stack+331394, 1.0, int_stack+285233, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+353264,int_stack+345704,int_stack+335174, 1.0, int_stack+289013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+282398,int_stack+147675,int_stack+145650, 1.0, int_stack+143625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+328559,int_stack+282398,int_stack+340844, 1.0, int_stack+294683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+282398,int_stack+328559,int_stack+345704, 1.0, int_stack+299543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+328559,int_stack+282398,int_stack+353264, 1.0, int_stack+5292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hg) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+109944,int_stack+328559,int_stack+631094,315);
 /*--- compute (id|hg) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+903254,int_stack+109944,int_stack+14742,315);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+109944,int_stack+200980,int_stack+200035,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+112779,int_stack+109944,int_stack+243758,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+117315,int_stack+112779,int_stack+246026,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+109944,int_stack+117315,int_stack+249554,21);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+116559,int_stack+209660,int_stack+208400,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+120339,int_stack+116559,int_stack+261608,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+126387,int_stack+120339,int_stack+264632,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+116559,int_stack+126387,int_stack+276518,28);
 /*--- compute (hp|hg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+125379,int_stack+116559,int_stack+109944,315);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+145224,int_stack+221060,int_stack+219440,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+631094,int_stack+145224,int_stack+311063,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+638870,int_stack+631094,int_stack+314951,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+648950,int_stack+638870,int_stack+320999,36);
 /*--- compute (ip|hg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+0,int_stack+648950,int_stack+116559,315);
 /*--- compute (hd|hg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+26460,int_stack+0,int_stack+125379,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+631094,int_stack+150591,int_stack+150150,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+632417,int_stack+151179,int_stack+150591,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+634181,int_stack+632417,int_stack+631094,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+636827,int_stack+151935,int_stack+151179,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+639095,int_stack+636827,int_stack+632417,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+642623,int_stack+639095,int_stack+634181,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+631094,int_stack+152880,int_stack+151935,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+145224,int_stack+631094,int_stack+636827,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+631094,int_stack+145224,int_stack+639095,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+145224,int_stack+631094,int_stack+642623,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+631094,int_stack+154623,int_stack+154035,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+632858,int_stack+155407,int_stack+154623,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+635210,int_stack+632858,int_stack+631094,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+638738,int_stack+156415,int_stack+155407,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+641762,int_stack+638738,int_stack+632858,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+216380,int_stack+641762,int_stack+635210,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+631094,int_stack+157675,int_stack+156415,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+151839,int_stack+631094,int_stack+638738,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+631094,int_stack+151839,int_stack+641762,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+638934,int_stack+631094,int_stack+216380,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+238025,int_stack+638934,int_stack+145224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145224,int_stack+159971,int_stack+159215,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+147492,int_stack+160979,int_stack+159971,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+150516,int_stack+147492,int_stack+145224,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+155052,int_stack+162275,int_stack+160979,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+216380,int_stack+155052,int_stack+147492,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+631094,int_stack+216380,int_stack+150516,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+145224,int_stack+163895,int_stack+162275,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+257870,int_stack+145224,int_stack+155052,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+145224,int_stack+257870,int_stack+216380,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+257870,int_stack+145224,int_stack+631094,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+269210,int_stack+257870,int_stack+638934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hd|hg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+295670,int_stack+269210,int_stack+238025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+238025,int_stack+166820,int_stack+165875,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+240860,int_stack+168080,int_stack+166820,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+244640,int_stack+240860,int_stack+238025,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+250310,int_stack+169700,int_stack+168080,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+631094,int_stack+250310,int_stack+240860,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+638654,int_stack+631094,int_stack+244640,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+238025,int_stack+171725,int_stack+169700,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+145224,int_stack+238025,int_stack+250310,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+238025,int_stack+145224,int_stack+631094,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+145224,int_stack+238025,int_stack+638654,45);
 /*--- compute (kp|hg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+406049,int_stack+145224,int_stack+257870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (id|hg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+956174,int_stack+406049,int_stack+269210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+406049,int_stack+174641,int_stack+174200,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+407372,int_stack+175229,int_stack+174641,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+409136,int_stack+407372,int_stack+406049,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+411782,int_stack+175985,int_stack+175229,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+414050,int_stack+411782,int_stack+407372,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+417578,int_stack+414050,int_stack+409136,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+406049,int_stack+176930,int_stack+175985,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+421988,int_stack+406049,int_stack+411782,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+406049,int_stack+421988,int_stack+414050,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+421988,int_stack+406049,int_stack+417578,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+406049,int_stack+178673,int_stack+178085,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+407813,int_stack+179457,int_stack+178673,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+410165,int_stack+407813,int_stack+406049,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+413693,int_stack+180465,int_stack+179457,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+416717,int_stack+413693,int_stack+407813,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+428603,int_stack+416717,int_stack+410165,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+406049,int_stack+181725,int_stack+180465,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+434483,int_stack+406049,int_stack+413693,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+406049,int_stack+434483,int_stack+416717,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+434483,int_stack+406049,int_stack+428603,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+145224,int_stack+434483,int_stack+421988, 0.0, zero_stack, 1.0, int_stack+109944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+406049,int_stack+184021,int_stack+183265,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+408317,int_stack+185029,int_stack+184021,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+411341,int_stack+408317,int_stack+406049,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+415877,int_stack+186325,int_stack+185029,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+419765,int_stack+415877,int_stack+408317,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+425813,int_stack+419765,int_stack+411341,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+406049,int_stack+187945,int_stack+186325,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+165069,int_stack+406049,int_stack+415877,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+406049,int_stack+165069,int_stack+419765,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+165069,int_stack+406049,int_stack+425813,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+406049,int_stack+165069,int_stack+434483, 0.0, zero_stack, 1.0, int_stack+116559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hd|hg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+238025,int_stack+406049,int_stack+145224, 0.0, zero_stack, 1.0, int_stack+125379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+145224,int_stack+190870,int_stack+189925,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+148059,int_stack+192130,int_stack+190870,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+151839,int_stack+148059,int_stack+145224,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+157509,int_stack+193750,int_stack+192130,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+432509,int_stack+157509,int_stack+148059,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+176409,int_stack+432509,int_stack+151839,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+145224,int_stack+195775,int_stack+193750,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+185859,int_stack+145224,int_stack+157509,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+145224,int_stack+185859,int_stack+432509,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+185859,int_stack+145224,int_stack+176409,45);
 /*--- compute (kp|hg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+1009094,int_stack+185859,int_stack+165069, 0.0, zero_stack, 1.0, int_stack+648950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (id|hg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+145224,int_stack+1009094,int_stack+406049, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+406049,int_stack+202576,int_stack+202135,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+407372,int_stack+203164,int_stack+202576,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+409136,int_stack+407372,int_stack+406049,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+411782,int_stack+203920,int_stack+203164,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+414050,int_stack+411782,int_stack+407372,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+417578,int_stack+414050,int_stack+409136,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+406049,int_stack+204865,int_stack+203920,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+421988,int_stack+406049,int_stack+411782,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+406049,int_stack+421988,int_stack+414050,21);
 /*--- compute (h0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+421988,int_stack+406049,int_stack+417578,21);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+406049,int_stack+211788,int_stack+211200,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+407813,int_stack+212572,int_stack+211788,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+410165,int_stack+407813,int_stack+406049,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+413693,int_stack+213580,int_stack+212572,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+416717,int_stack+413693,int_stack+407813,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+428603,int_stack+416717,int_stack+410165,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+406049,int_stack+214840,int_stack+213580,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+434483,int_stack+406049,int_stack+413693,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+406049,int_stack+434483,int_stack+416717,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+434483,int_stack+406049,int_stack+428603,28);
 /*--- compute (hp|hg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1009094,int_stack+434483,int_stack+421988, 1.0, int_stack+109944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+109944,int_stack+223796,int_stack+223040,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+112212,int_stack+224804,int_stack+223796,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+406049,int_stack+112212,int_stack+109944,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+410585,int_stack+226100,int_stack+224804,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+414473,int_stack+410585,int_stack+112212,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+420521,int_stack+414473,int_stack+406049,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+109944,int_stack+227720,int_stack+226100,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1028939,int_stack+109944,int_stack+410585,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+198144,int_stack+1028939,int_stack+414473,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+1028939,int_stack+198144,int_stack+420521,36);
 /*--- compute (ip|hg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+198144,int_stack+1028939,int_stack+434483, 1.0, int_stack+116559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hd|hg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1040279,int_stack+198144,int_stack+1009094, 1.0, int_stack+125379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1009094,int_stack+230645,int_stack+229700,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1011929,int_stack+231905,int_stack+230645,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1015709,int_stack+1011929,int_stack+1009094,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1021379,int_stack+233525,int_stack+231905,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+224604,int_stack+1021379,int_stack+1011929,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+109944,int_stack+224604,int_stack+1015709,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1009094,int_stack+235550,int_stack+233525,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+119394,int_stack+1009094,int_stack+1021379,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1009094,int_stack+119394,int_stack+224604,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+119394,int_stack+1009094,int_stack+109944,45);
 /*--- compute (kp|hg) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+406049,int_stack+119394,int_stack+1028939, 1.0, int_stack+648950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (id|hg) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1079969,int_stack+406049,int_stack+198144, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1132889,int_stack+485564,int_stack+366359,315);
     Libderiv->ABCD[11] = int_stack + 1132889;
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+335360,int_stack+538484,int_stack+443849,315);
     Libderiv->ABCD[10] = int_stack + 335360;
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+401510,int_stack+665114,int_stack+591404,315);
     Libderiv->ABCD[9] = int_stack + 401510;
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+467660,int_stack+757724,int_stack+718034,315);
     Libderiv->ABCD[8] = int_stack + 467660;
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+533810,int_stack+810644,int_stack+70254,315);
     Libderiv->ABCD[7] = int_stack + 533810;
 /*--- compute (hf|hg) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+599960,int_stack+903254,int_stack+863564,315);
     Libderiv->ABCD[6] = int_stack + 599960;
 /*--- compute (hf|hg) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+666110,int_stack+956174,int_stack+295670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+26460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[2] = int_stack + 666110;
 /*--- compute (hf|hg) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+732260,int_stack+145224,int_stack+238025, 0.0, zero_stack, 1.0, int_stack+26460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[1] = int_stack + 732260;
 /*--- compute (hf|hg) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+798410,int_stack+1079969,int_stack+1040279, 1.0, int_stack+26460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,315);
     Libderiv->ABCD[0] = int_stack + 798410;

}
