/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_i0ip(Libderiv_t *, prim_data *);

  /* Computes derivatives of (i0|ip) integrals */

void d1hrr_order_i0ip(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][7][11] = int_stack + 784;
 Libderiv->deriv_classes[6][6][10] = int_stack + 1792;
 Libderiv->deriv_classes[6][7][10] = int_stack + 2576;
 Libderiv->deriv_classes[6][6][9] = int_stack + 3584;
 Libderiv->deriv_classes[6][7][9] = int_stack + 4368;
 Libderiv->deriv_classes[6][6][8] = int_stack + 5376;
 Libderiv->deriv_classes[6][7][8] = int_stack + 6160;
 Libderiv->deriv_classes[6][6][7] = int_stack + 7168;
 Libderiv->deriv_classes[6][7][7] = int_stack + 7952;
 Libderiv->dvrr_classes[6][6] = int_stack + 8960;
 Libderiv->deriv_classes[6][6][6] = int_stack + 9744;
 Libderiv->deriv_classes[6][7][6] = int_stack + 10528;
 Libderiv->deriv_classes[6][6][2] = int_stack + 11536;
 Libderiv->deriv_classes[6][7][2] = int_stack + 12320;
 Libderiv->deriv_classes[6][6][1] = int_stack + 13328;
 Libderiv->deriv_classes[6][7][1] = int_stack + 14112;
 Libderiv->deriv_classes[6][6][0] = int_stack + 15120;
 Libderiv->deriv_classes[6][7][0] = int_stack + 15904;
 memset(int_stack,0,135296);

 Libderiv->dvrr_stack = int_stack + 23968;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_i0ip(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+16912,int_stack+784,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960,28);
     Libderiv->ABCD[11] = int_stack + 16912;
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+19264,int_stack+2576,int_stack+1792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack,28);
     Libderiv->ABCD[10] = int_stack + 19264;
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+4368,int_stack+3584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[9] = int_stack + 0;
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2352,int_stack+6160,int_stack+5376, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[8] = int_stack + 2352;
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4704,int_stack+7952,int_stack+7168, 0.0, zero_stack, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[7] = int_stack + 4704;
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21616,int_stack+10528,int_stack+9744, 1.0, int_stack+8960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
     Libderiv->ABCD[6] = int_stack + 21616;
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+7056,int_stack+12320,int_stack+11536,28);
     Libderiv->ABCD[2] = int_stack + 7056;
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+9408,int_stack+14112,int_stack+13328,28);
     Libderiv->ABCD[1] = int_stack + 9408;
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+11760,int_stack+15904,int_stack+15120,28);
     Libderiv->ABCD[0] = int_stack + 11760;

}
