/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_p0hd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (p0|hd) integrals */

void d1hrr_order_p0hd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[1][6][11] = int_stack + 63;
 Libderiv->deriv_classes[1][7][11] = int_stack + 147;
 Libderiv->deriv_classes[1][5][10] = int_stack + 255;
 Libderiv->deriv_classes[1][6][10] = int_stack + 318;
 Libderiv->deriv_classes[1][7][10] = int_stack + 402;
 Libderiv->deriv_classes[1][5][9] = int_stack + 510;
 Libderiv->deriv_classes[1][6][9] = int_stack + 573;
 Libderiv->deriv_classes[1][7][9] = int_stack + 657;
 Libderiv->deriv_classes[1][5][8] = int_stack + 765;
 Libderiv->deriv_classes[1][6][8] = int_stack + 828;
 Libderiv->deriv_classes[1][7][8] = int_stack + 912;
 Libderiv->deriv_classes[1][5][7] = int_stack + 1020;
 Libderiv->deriv_classes[1][6][7] = int_stack + 1083;
 Libderiv->deriv_classes[1][7][7] = int_stack + 1167;
 Libderiv->dvrr_classes[1][5] = int_stack + 1275;
 Libderiv->deriv_classes[1][5][6] = int_stack + 1338;
 Libderiv->dvrr_classes[1][6] = int_stack + 1401;
 Libderiv->deriv_classes[1][6][6] = int_stack + 1485;
 Libderiv->deriv_classes[1][7][6] = int_stack + 1569;
 Libderiv->deriv_classes[1][5][2] = int_stack + 1677;
 Libderiv->deriv_classes[1][6][2] = int_stack + 1740;
 Libderiv->deriv_classes[1][7][2] = int_stack + 1824;
 Libderiv->deriv_classes[1][5][1] = int_stack + 1932;
 Libderiv->deriv_classes[1][6][1] = int_stack + 1995;
 Libderiv->deriv_classes[1][7][1] = int_stack + 2079;
 Libderiv->deriv_classes[1][5][0] = int_stack + 2187;
 Libderiv->deriv_classes[1][6][0] = int_stack + 2250;
 Libderiv->deriv_classes[1][7][0] = int_stack + 2334;
 memset(int_stack,0,19536);

 Libderiv->dvrr_stack = int_stack + 4962;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_p0hd(Libderiv, Data);
   Data++;
 }

 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2442,int_stack+1401,int_stack+1275,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2631,int_stack+63,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1275,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2820,int_stack+147,int_stack+63, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+318,int_stack+255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1275, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3072,int_stack+402,int_stack+318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+189,int_stack+573,int_stack+510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1275, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3324,int_stack+657,int_stack+573, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+378,int_stack+828,int_stack+765, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+567,int_stack+912,int_stack+828, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+819,int_stack+1083,int_stack+1020, 0.0, zero_stack, 1.0, int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3576,int_stack+1167,int_stack+1083, 0.0, zero_stack, 1.0, int_stack+1401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1008,int_stack+1485,int_stack+1338, 1.0, int_stack+1275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+3828,int_stack+1569,int_stack+1485, 1.0, int_stack+1401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1197,int_stack+1740,int_stack+1677,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1386,int_stack+1824,int_stack+1740,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1638,int_stack+1995,int_stack+1932,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4080,int_stack+2079,int_stack+1995,3);
 /*--- compute (p0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1827,int_stack+2250,int_stack+2187,3);
 /*--- compute (p0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4332,int_stack+2334,int_stack+2250,3);
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2016,int_stack+2820,int_stack+2631, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2442,3);
     Libderiv->ABCD[11] = int_stack + 2016;
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2631,int_stack+3072,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2442, 0.0, zero_stack,3);
     Libderiv->ABCD[10] = int_stack + 2631;
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+4584,int_stack+3324,int_stack+189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2442, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[9] = int_stack + 4584;
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+0,int_stack+567,int_stack+378, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[8] = int_stack + 0;
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+378,int_stack+3576,int_stack+819, 0.0, zero_stack, 1.0, int_stack+2442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[7] = int_stack + 378;
 /*--- compute (p0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3009,int_stack+3828,int_stack+1008, 1.0, int_stack+2442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,3);
     Libderiv->ABCD[6] = int_stack + 3009;
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+756,int_stack+1386,int_stack+1197,3);
     Libderiv->ABCD[2] = int_stack + 756;
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1134,int_stack+4080,int_stack+1638,3);
     Libderiv->ABCD[1] = int_stack + 1134;
 /*--- compute (p0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3387,int_stack+4332,int_stack+1827,3);
     Libderiv->ABCD[0] = int_stack + 3387;

}
