/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_pph0(Libderiv_t *, prim_data *);

  /* Computes derivatives of (pp|h0) integrals */

void d1hrr_order_pph0(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[1][5][11] = int_stack + 0;
 Libderiv->deriv_classes[2][5][11] = int_stack + 63;
 Libderiv->deriv_classes[1][5][10] = int_stack + 189;
 Libderiv->deriv_classes[2][5][10] = int_stack + 252;
 Libderiv->deriv_classes[1][5][9] = int_stack + 378;
 Libderiv->deriv_classes[2][5][9] = int_stack + 441;
 Libderiv->deriv_classes[1][5][8] = int_stack + 567;
 Libderiv->deriv_classes[2][5][8] = int_stack + 630;
 Libderiv->deriv_classes[1][5][7] = int_stack + 756;
 Libderiv->deriv_classes[2][5][7] = int_stack + 819;
 Libderiv->deriv_classes[1][5][6] = int_stack + 945;
 Libderiv->deriv_classes[2][5][6] = int_stack + 1008;
 Libderiv->deriv_classes[1][5][2] = int_stack + 1134;
 Libderiv->deriv_classes[2][5][2] = int_stack + 1197;
 Libderiv->deriv_classes[1][5][1] = int_stack + 1323;
 Libderiv->deriv_classes[2][5][1] = int_stack + 1386;
 Libderiv->dvrr_classes[1][5] = int_stack + 1512;
 Libderiv->deriv_classes[1][5][0] = int_stack + 1575;
 Libderiv->deriv_classes[2][5][0] = int_stack + 1638;
 memset(int_stack,0,14112);

 Libderiv->dvrr_stack = int_stack + 1953;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_pph0(Libderiv, Data);
   Data++;
 }

 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+1764,int_stack+63,int_stack+0,21);
     Libderiv->ABCD[11] = int_stack + 1764;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+0,int_stack+252,int_stack+189,21);
     Libderiv->ABCD[10] = int_stack + 0;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+189,int_stack+441,int_stack+378,21);
     Libderiv->ABCD[9] = int_stack + 189;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+378,int_stack+630,int_stack+567,21);
     Libderiv->ABCD[8] = int_stack + 378;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+567,int_stack+819,int_stack+756,21);
     Libderiv->ABCD[7] = int_stack + 567;
 /*--- compute (pp|h0) ---*/
   hrr1_build_pp(Libderiv->AB,int_stack+756,int_stack+1008,int_stack+945,21);
     Libderiv->ABCD[6] = int_stack + 756;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+945,int_stack+1197,int_stack+1134, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[2] = int_stack + 945;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+1134,int_stack+1386,int_stack+1323, 0.0, zero_stack, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[1] = int_stack + 1134;
 /*--- compute (pp|h0) ---*/
   d1hrr1_build_pp(Libderiv->AB,int_stack+1323,int_stack+1638,int_stack+1575, 1.0, int_stack+1512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
     Libderiv->ABCD[0] = int_stack + 1323;

}
