/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_00kd(Libint_t*, prim_data*);

  /* Computes quartets of (00|kd) integrals */

REALTYPE *hrr_order_00kd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[0][7] = int_stack + 0;
 Libint->vrr_classes[0][8] = int_stack + 36;
 Libint->vrr_classes[0][9] = int_stack + 81;
 memset(int_stack,0,136*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 136;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_00kd(Libint, Data);
   Data++;
 }
 /*--- compute (00|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+136,int_stack+36,int_stack+0,1);
 /*--- compute (00|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+244,int_stack+81,int_stack+36,1);
 /*--- compute (00|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+379,int_stack+244,int_stack+136,1);
 return int_stack+379;}
