/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_d0li(Libint_t*, prim_data*);

  /* Computes quartets of (d0|li) integrals */

REALTYPE *hrr_order_d0li(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[2][14] = int_stack + 2640;
 memset(int_stack,0,3360*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3360;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_d0li(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+3360,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+4170,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+5160,int_stack+4170,int_stack+3360,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6780,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+7968,int_stack+6780,int_stack+4170,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+9948,int_stack+7968,int_stack+5160,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3360,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12648,int_stack+3360,int_stack+6780,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+15024,int_stack+12648,int_stack+7968,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+4764,int_stack+15024,int_stack+9948,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+8814,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18324,int_stack+8814,int_stack+3360,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21132,int_stack+18324,int_stack+12648,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+25092,int_stack+21132,int_stack+15024,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+10452,int_stack+25092,int_stack+4764,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3360,int_stack+2640,int_stack+2010,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5250,int_stack+3360,int_stack+8814,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+5250,int_stack+18324,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+30042,int_stack+0,int_stack+21132,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+30042,int_stack+25092,6);
 /*--- compute (d0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+16122,int_stack+0,int_stack+10452,6);
 return int_stack+16122;}
