/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddid(Libint_t*, prim_data*);

  /* Computes quartets of (dd|id) integrals */

REALTYPE *hrr_order_ddid(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][6] = int_stack + 0;
 Libint->vrr_classes[2][7] = int_stack + 168;
 Libint->vrr_classes[2][8] = int_stack + 384;
 Libint->vrr_classes[3][6] = int_stack + 654;
 Libint->vrr_classes[3][7] = int_stack + 934;
 Libint->vrr_classes[3][8] = int_stack + 1294;
 Libint->vrr_classes[4][6] = int_stack + 1744;
 Libint->vrr_classes[4][7] = int_stack + 2164;
 Libint->vrr_classes[4][8] = int_stack + 2704;
 memset(int_stack,0,3379*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 3379;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddid(Libint, Data);
   Data++;
 }
 /*--- compute (d0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+3379,int_stack+168,int_stack+0,6);
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3883,int_stack+384,int_stack+168,6);
 /*--- compute (d0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+4531,int_stack+3883,int_stack+3379,6);
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+3379,int_stack+934,int_stack+654,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+5539,int_stack+1294,int_stack+934,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+0,int_stack+5539,int_stack+3379,10);
 /*--- compute (dp|id) ---*/
 hrr1_build_dp(Libint->AB,int_stack+5539,int_stack+0,int_stack+4531,168);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+3379,int_stack+2164,int_stack+1744,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8563,int_stack+2704,int_stack+2164,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10183,int_stack+8563,int_stack+3379,15);
 /*--- compute (fp|id) ---*/
 hrr1_build_fp(Libint->AB,int_stack+12703,int_stack+10183,int_stack+0,168);
 /*--- compute (dd|id) ---*/
 hrr1_build_dd(Libint->AB,int_stack+17743,int_stack+12703,int_stack+5539,168);
 return int_stack+17743;}
