/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddig(Libint_t*, prim_data*);

  /* Computes quartets of (dd|ig) integrals */

REALTYPE *hrr_order_ddig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][6] = int_stack + 0;
 Libint->vrr_classes[2][7] = int_stack + 168;
 Libint->vrr_classes[2][8] = int_stack + 384;
 Libint->vrr_classes[2][9] = int_stack + 654;
 Libint->vrr_classes[2][10] = int_stack + 984;
 Libint->vrr_classes[3][6] = int_stack + 1380;
 Libint->vrr_classes[3][7] = int_stack + 1660;
 Libint->vrr_classes[3][8] = int_stack + 2020;
 Libint->vrr_classes[3][9] = int_stack + 2470;
 Libint->vrr_classes[3][10] = int_stack + 3020;
 Libint->vrr_classes[4][6] = int_stack + 3680;
 Libint->vrr_classes[4][7] = int_stack + 4100;
 Libint->vrr_classes[4][8] = int_stack + 4640;
 Libint->vrr_classes[4][9] = int_stack + 5315;
 Libint->vrr_classes[4][10] = int_stack + 6140;
 memset(int_stack,0,7130*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7130;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddig(Libint, Data);
   Data++;
 }
 /*--- compute (d0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+7130,int_stack+168,int_stack+0,6);
 /*--- compute (d0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7634,int_stack+384,int_stack+168,6);
 /*--- compute (d0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8282,int_stack+7634,int_stack+7130,6);
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9290,int_stack+654,int_stack+384,6);
 /*--- compute (d0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10100,int_stack+9290,int_stack+7634,6);
 /*--- compute (d0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+11396,int_stack+10100,int_stack+8282,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7130,int_stack+984,int_stack+654,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+13076,int_stack+7130,int_stack+9290,6);
 /*--- compute (d0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7130,int_stack+13076,int_stack+10100,6);
 /*--- compute (d0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+13076,int_stack+7130,int_stack+11396,6);
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+7130,int_stack+1660,int_stack+1380,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7970,int_stack+2020,int_stack+1660,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+9050,int_stack+7970,int_stack+7130,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+10730,int_stack+2470,int_stack+2020,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+10730,int_stack+7970,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+15596,int_stack+0,int_stack+9050,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7130,int_stack+3020,int_stack+2470,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+18396,int_stack+7130,int_stack+10730,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7130,int_stack+18396,int_stack+0,10);
 /*--- compute (f0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+18396,int_stack+7130,int_stack+15596,10);
 /*--- compute (dp|ig) ---*/
 hrr1_build_dp(Libint->AB,int_stack+22596,int_stack+18396,int_stack+13076,420);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+7130,int_stack+4100,int_stack+3680,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+8390,int_stack+4640,int_stack+4100,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10010,int_stack+8390,int_stack+7130,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+12530,int_stack+5315,int_stack+4640,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+14555,int_stack+12530,int_stack+8390,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+14555,int_stack+10010,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7130,int_stack+6140,int_stack+5315,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+30156,int_stack+7130,int_stack+12530,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+4200,int_stack+30156,int_stack+14555,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+9600,int_stack+4200,int_stack+0,15);
 /*--- compute (fp|ig) ---*/
 hrr1_build_fp(Libint->AB,int_stack+30156,int_stack+9600,int_stack+18396,420);
 /*--- compute (dd|ig) ---*/
 hrr1_build_dd(Libint->AB,int_stack+0,int_stack+30156,int_stack+22596,420);
 return int_stack+0;}
