/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ddlh(Libint_t*, prim_data*);

  /* Computes quartets of (dd|lh) integrals */

REALTYPE *hrr_order_ddlh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[2][8] = int_stack + 0;
 Libint->vrr_classes[2][9] = int_stack + 270;
 Libint->vrr_classes[2][10] = int_stack + 600;
 Libint->vrr_classes[2][11] = int_stack + 996;
 Libint->vrr_classes[2][12] = int_stack + 1464;
 Libint->vrr_classes[2][13] = int_stack + 2010;
 Libint->vrr_classes[3][8] = int_stack + 2640;
 Libint->vrr_classes[3][9] = int_stack + 3090;
 Libint->vrr_classes[3][10] = int_stack + 3640;
 Libint->vrr_classes[3][11] = int_stack + 4300;
 Libint->vrr_classes[3][12] = int_stack + 5080;
 Libint->vrr_classes[3][13] = int_stack + 5990;
 Libint->vrr_classes[4][8] = int_stack + 7040;
 Libint->vrr_classes[4][9] = int_stack + 7715;
 Libint->vrr_classes[4][10] = int_stack + 8540;
 Libint->vrr_classes[4][11] = int_stack + 9530;
 Libint->vrr_classes[4][12] = int_stack + 10700;
 Libint->vrr_classes[4][13] = int_stack + 12065;
 memset(int_stack,0,13640*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 13640;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ddlh(Libint, Data);
   Data++;
 }
 /*--- compute (d0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13640,int_stack+270,int_stack+0,6);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14450,int_stack+600,int_stack+270,6);
 /*--- compute (d0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+15440,int_stack+14450,int_stack+13640,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17060,int_stack+996,int_stack+600,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+18248,int_stack+17060,int_stack+14450,6);
 /*--- compute (d0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+20228,int_stack+18248,int_stack+15440,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13640,int_stack+1464,int_stack+996,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+22928,int_stack+13640,int_stack+17060,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+25304,int_stack+22928,int_stack+18248,6);
 /*--- compute (d0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+15044,int_stack+25304,int_stack+20228,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+19094,int_stack+2010,int_stack+1464,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+28604,int_stack+19094,int_stack+13640,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+31412,int_stack+28604,int_stack+22928,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+19094,int_stack+31412,int_stack+25304,6);
 /*--- compute (d0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+24044,int_stack+19094,int_stack+15044,6);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13640,int_stack+3090,int_stack+2640,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+14990,int_stack+3640,int_stack+3090,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16640,int_stack+14990,int_stack+13640,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19340,int_stack+4300,int_stack+3640,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+29714,int_stack+19340,int_stack+14990,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+33014,int_stack+29714,int_stack+16640,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13640,int_stack+5080,int_stack+4300,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+13640,int_stack+19340,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+15980,int_stack+0,int_stack+29714,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+37514,int_stack+15980,int_stack+33014,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+29714,int_stack+5990,int_stack+5080,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+32444,int_stack+29714,int_stack+13640,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+44264,int_stack+32444,int_stack+0,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+50864,int_stack+44264,int_stack+15980,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+13640,int_stack+50864,int_stack+37514,10);
 /*--- compute (dp|lh) ---*/
 hrr1_build_dp(Libint->AB,int_stack+29714,int_stack+13640,int_stack+24044,945);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+7715,int_stack+7040,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2025,int_stack+8540,int_stack+7715,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+23090,int_stack+2025,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4500,int_stack+9530,int_stack+8540,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46724,int_stack+4500,int_stack+2025,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51674,int_stack+46724,int_stack+23090,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23090,int_stack+10700,int_stack+9530,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58424,int_stack+23090,int_stack+4500,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+58424,int_stack+46724,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+64364,int_stack+0,int_stack+51674,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+46724,int_stack+12065,int_stack+10700,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+50819,int_stack+46724,int_stack+23090,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+74489,int_stack+50819,int_stack+58424,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+46724,int_stack+74489,int_stack+0,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+74489,int_stack+46724,int_stack+64364,15);
 /*--- compute (fp|lh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+88664,int_stack+74489,int_stack+13640,945);
 /*--- compute (dd|lh) ---*/
 hrr1_build_dd(Libint->AB,int_stack+46724,int_stack+88664,int_stack+29714,945);
 return int_stack+46724;}
