/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_f0ll(Libint_t*, prim_data*);

  /* Computes quartets of (f0|ll) integrals */

REALTYPE *hrr_order_f0ll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[3][14] = int_stack + 4400;
 Libint->vrr_classes[3][15] = int_stack + 5600;
 Libint->vrr_classes[3][16] = int_stack + 6960;
 memset(int_stack,0,8490*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 8490;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_f0ll(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+8490,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9840,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+11490,int_stack+9840,int_stack+8490,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14190,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16170,int_stack+14190,int_stack+9840,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+19470,int_stack+16170,int_stack+11490,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+8490,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23970,int_stack+8490,int_stack+14190,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+27930,int_stack+23970,int_stack+16170,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+10830,int_stack+27930,int_stack+19470,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+17580,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+33430,int_stack+17580,int_stack+8490,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+38110,int_stack+33430,int_stack+23970,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+44710,int_stack+38110,int_stack+27930,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+20310,int_stack+44710,int_stack+10830,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+8490,int_stack+4400,int_stack+3350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+11640,int_stack+8490,int_stack+17580,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+52960,int_stack+11640,int_stack+33430,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+60760,int_stack+52960,int_stack+38110,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+29760,int_stack+60760,int_stack+44710,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+70660,int_stack+29760,int_stack+20310,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+17100,int_stack+5600,int_stack+4400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+20700,int_stack+17100,int_stack+8490,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+41310,int_stack+20700,int_stack+11640,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+83260,int_stack+41310,int_stack+52960,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+94960,int_stack+83260,int_stack+60760,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+50410,int_stack+94960,int_stack+29760,10);
 /*--- compute (f0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+108820,int_stack+50410,int_stack+70660,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+8490,int_stack+6960,int_stack+5600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+27000,int_stack+8490,int_stack+17100,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+65810,int_stack+27000,int_stack+20700,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+65810,int_stack+41310,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+65810,int_stack+0,int_stack+83260,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+65810,int_stack+94960,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+65810,int_stack+0,int_stack+50410,10);
 /*--- compute (f0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+65810,int_stack+108820,10);
 return int_stack+0;}
