/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_f0ml(Libint_t*, prim_data*);

  /* Computes quartets of (f0|ml) integrals */

REALTYPE *hrr_order_f0ml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[3][16] = int_stack + 6510;
 Libint->vrr_classes[3][17] = int_stack + 8040;
 memset(int_stack,0,9750*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9750;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_f0ml(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9750,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11400,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13380,int_stack+11400,int_stack+9750,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16680,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19020,int_stack+16680,int_stack+11400,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+22980,int_stack+19020,int_stack+13380,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9750,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+28480,int_stack+9750,int_stack+16680,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+33160,int_stack+28480,int_stack+19020,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12480,int_stack+33160,int_stack+22980,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+20730,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+39760,int_stack+20730,int_stack+9750,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+45220,int_stack+39760,int_stack+28480,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+53020,int_stack+45220,int_stack+33160,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+23880,int_stack+53020,int_stack+12480,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+9750,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+13350,int_stack+9750,int_stack+20730,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+62920,int_stack+13350,int_stack+39760,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+72020,int_stack+62920,int_stack+45220,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+35430,int_stack+72020,int_stack+53020,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+83720,int_stack+35430,int_stack+23880,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+19650,int_stack+6510,int_stack+5150,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+23730,int_stack+19650,int_stack+9750,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+49290,int_stack+23730,int_stack+13350,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+99120,int_stack+49290,int_stack+62920,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+112770,int_stack+99120,int_stack+72020,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+59790,int_stack+112770,int_stack+35430,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+129150,int_stack+59790,int_stack+83720,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+9750,int_stack+8040,int_stack+6510,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+30930,int_stack+9750,int_stack+19650,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+78270,int_stack+30930,int_stack+23730,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+78270,int_stack+49290,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+78270,int_stack+0,int_stack+99120,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+78270,int_stack+112770,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+78270,int_stack+0,int_stack+59790,10);
 /*--- compute (f0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+78270,int_stack+129150,10);
 return int_stack+0;}
