/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdki(Libint_t*, prim_data*);

  /* Computes quartets of (fd|ki) integrals */

REALTYPE *hrr_order_fdki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[3][13] = int_stack + 3710;
 Libint->vrr_classes[4][7] = int_stack + 4760;
 Libint->vrr_classes[4][8] = int_stack + 5300;
 Libint->vrr_classes[4][9] = int_stack + 5975;
 Libint->vrr_classes[4][10] = int_stack + 6800;
 Libint->vrr_classes[4][11] = int_stack + 7790;
 Libint->vrr_classes[4][12] = int_stack + 8960;
 Libint->vrr_classes[4][13] = int_stack + 10325;
 Libint->vrr_classes[5][7] = int_stack + 11900;
 Libint->vrr_classes[5][8] = int_stack + 12656;
 Libint->vrr_classes[5][9] = int_stack + 13601;
 Libint->vrr_classes[5][10] = int_stack + 14756;
 Libint->vrr_classes[5][11] = int_stack + 16142;
 Libint->vrr_classes[5][12] = int_stack + 17780;
 Libint->vrr_classes[5][13] = int_stack + 19691;
 memset(int_stack,0,21896*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 21896;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdki(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+21896,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+22976,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+24326,int_stack+22976,int_stack+21896,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+26486,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+28136,int_stack+26486,int_stack+22976,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+30836,int_stack+28136,int_stack+24326,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21896,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+34436,int_stack+21896,int_stack+26486,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37736,int_stack+34436,int_stack+28136,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+23876,int_stack+37736,int_stack+30836,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+29276,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42236,int_stack+29276,int_stack+21896,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+46196,int_stack+42236,int_stack+34436,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+51696,int_stack+46196,int_stack+37736,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+31616,int_stack+51696,int_stack+23876,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21896,int_stack+3710,int_stack+2800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+21896,int_stack+29276,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21896,int_stack+0,int_stack+42236,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+58446,int_stack+21896,int_stack+46196,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+21896,int_stack+58446,int_stack+51696,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+39176,int_stack+21896,int_stack+31616,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+21896,int_stack+5300,int_stack+4760,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+23516,int_stack+5975,int_stack+5300,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+25541,int_stack+23516,int_stack+21896,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28781,int_stack+6800,int_stack+5975,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+31256,int_stack+28781,int_stack+23516,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+31256,int_stack+25541,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21896,int_stack+7790,int_stack+6800,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49256,int_stack+21896,int_stack+28781,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+54206,int_stack+49256,int_stack+31256,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+24866,int_stack+54206,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+8960,int_stack+7790,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+32966,int_stack+0,int_stack+21896,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+60956,int_stack+32966,int_stack+49256,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+69206,int_stack+60956,int_stack+54206,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+49256,int_stack+69206,int_stack+24866,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+21896,int_stack+10325,int_stack+8960,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3510,int_stack+21896,int_stack+0,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21896,int_stack+3510,int_stack+32966,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+79331,int_stack+21896,int_stack+60956,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+21896,int_stack+79331,int_stack+69206,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+60596,int_stack+21896,int_stack+49256,15);
 /*--- compute (fp|ki) ---*/
 hrr1_build_fp(Libint->AB,int_stack+75716,int_stack+60596,int_stack+39176,1008);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+21896,int_stack+12656,int_stack+11900,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+24164,int_stack+13601,int_stack+12656,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+26999,int_stack+24164,int_stack+21896,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+31535,int_stack+14756,int_stack+13601,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35000,int_stack+31535,int_stack+24164,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+40670,int_stack+35000,int_stack+26999,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+21896,int_stack+16142,int_stack+14756,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48230,int_stack+21896,int_stack+31535,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+48230,int_stack+35000,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+26054,int_stack+0,int_stack+40670,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+37394,int_stack+17780,int_stack+16142,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+9450,int_stack+37394,int_stack+21896,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+105956,int_stack+9450,int_stack+48230,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+42308,int_stack+105956,int_stack+0,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+117506,int_stack+42308,int_stack+26054,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+19691,int_stack+17780,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+17766,int_stack+0,int_stack+37394,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+27594,int_stack+17766,int_stack+9450,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+27594,int_stack+105956,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+17325,int_stack+0,int_stack+42308,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+37170,int_stack+17325,int_stack+117506,21);
 /*--- compute (gp|ki) ---*/
 hrr1_build_gp(Libint->AB,int_stack+105956,int_stack+37170,int_stack+60596,1008);
 /*--- compute (fd|ki) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+105956,int_stack+75716,1008);
 return int_stack+0;}
