/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdkk(Libint_t*, prim_data*);

  /* Computes quartets of (fd|kk) integrals */

REALTYPE *hrr_order_fdkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[3][13] = int_stack + 3710;
 Libint->vrr_classes[3][14] = int_stack + 4760;
 Libint->vrr_classes[4][7] = int_stack + 5960;
 Libint->vrr_classes[4][8] = int_stack + 6500;
 Libint->vrr_classes[4][9] = int_stack + 7175;
 Libint->vrr_classes[4][10] = int_stack + 8000;
 Libint->vrr_classes[4][11] = int_stack + 8990;
 Libint->vrr_classes[4][12] = int_stack + 10160;
 Libint->vrr_classes[4][13] = int_stack + 11525;
 Libint->vrr_classes[4][14] = int_stack + 13100;
 Libint->vrr_classes[5][7] = int_stack + 14900;
 Libint->vrr_classes[5][8] = int_stack + 15656;
 Libint->vrr_classes[5][9] = int_stack + 16601;
 Libint->vrr_classes[5][10] = int_stack + 17756;
 Libint->vrr_classes[5][11] = int_stack + 19142;
 Libint->vrr_classes[5][12] = int_stack + 20780;
 Libint->vrr_classes[5][13] = int_stack + 22691;
 Libint->vrr_classes[5][14] = int_stack + 24896;
 memset(int_stack,0,27416*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 27416;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdkk(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27416,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+28496,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+29846,int_stack+28496,int_stack+27416,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32006,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+33656,int_stack+32006,int_stack+28496,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+36356,int_stack+33656,int_stack+29846,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27416,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+39956,int_stack+27416,int_stack+32006,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+43256,int_stack+39956,int_stack+33656,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+29396,int_stack+43256,int_stack+36356,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+34796,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+47756,int_stack+34796,int_stack+27416,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+51716,int_stack+47756,int_stack+39956,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+57216,int_stack+51716,int_stack+43256,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+37136,int_stack+57216,int_stack+29396,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27416,int_stack+3710,int_stack+2800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+63966,int_stack+27416,int_stack+34796,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30146,int_stack+63966,int_stack+47756,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+68646,int_stack+30146,int_stack+51716,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+44696,int_stack+68646,int_stack+57216,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+76896,int_stack+44696,int_stack+37136,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+36746,int_stack+4760,int_stack+3710,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+54146,int_stack+36746,int_stack+27416,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+36746,int_stack+54146,int_stack+63966,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+54146,int_stack+36746,int_stack+30146,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+27416,int_stack+54146,int_stack+68646,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+54146,int_stack+27416,int_stack+44696,10);
 /*--- compute (f0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+27416,int_stack+54146,int_stack+76896,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+40376,int_stack+6500,int_stack+5960,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41996,int_stack+7175,int_stack+6500,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44021,int_stack+41996,int_stack+40376,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47261,int_stack+8000,int_stack+7175,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49736,int_stack+47261,int_stack+41996,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+53786,int_stack+49736,int_stack+44021,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40376,int_stack+8990,int_stack+8000,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59186,int_stack+40376,int_stack+47261,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+64136,int_stack+59186,int_stack+49736,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+43346,int_stack+64136,int_stack+53786,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+51446,int_stack+10160,int_stack+8990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+70886,int_stack+51446,int_stack+40376,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+76826,int_stack+70886,int_stack+59186,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+76826,int_stack+64136,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+54956,int_stack+0,int_stack+43346,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+40376,int_stack+11525,int_stack+10160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85076,int_stack+40376,int_stack+51446,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+44471,int_stack+85076,int_stack+70886,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92096,int_stack+44471,int_stack+76826,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+66296,int_stack+92096,int_stack+0,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+104471,int_stack+66296,int_stack+54956,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+13100,int_stack+11525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4725,int_stack+0,int_stack+40376,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+54371,int_stack+4725,int_stack+85076,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+54371,int_stack+44471,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+40376,int_stack+0,int_stack+92096,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+80471,int_stack+40376,int_stack+66296,15);
 /*--- compute (g0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+40376,int_stack+80471,int_stack+104471,15);
 /*--- compute (fp|kk) ---*/
 hrr1_build_fp(Libint->AB,int_stack+59816,int_stack+40376,int_stack+27416,1296);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27416,int_stack+15656,int_stack+14900,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29684,int_stack+16601,int_stack+15656,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32519,int_stack+29684,int_stack+27416,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+98696,int_stack+17756,int_stack+16601,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+102161,int_stack+98696,int_stack+29684,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+107831,int_stack+102161,int_stack+32519,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27416,int_stack+19142,int_stack+17756,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+31574,int_stack+27416,int_stack+98696,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+0,int_stack+31574,int_stack+102161,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+115391,int_stack+0,int_stack+107831,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98696,int_stack+20780,int_stack+19142,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+103610,int_stack+98696,int_stack+27416,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+126731,int_stack+103610,int_stack+31574,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+138281,int_stack+126731,int_stack+0,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+138281,int_stack+115391,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27416,int_stack+22691,int_stack+20780,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+111926,int_stack+27416,int_stack+98696,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+152456,int_stack+111926,int_stack+103610,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+166316,int_stack+152456,int_stack+126731,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+183641,int_stack+166316,int_stack+138281,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+121754,int_stack+183641,int_stack+0,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+24896,int_stack+22691,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+27416,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+18081,int_stack+6615,int_stack+111926,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+98696,int_stack+18081,int_stack+152456,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+98696,int_stack+166316,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+142922,int_stack+0,int_stack+183641,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+0,int_stack+142922,int_stack+121754,21);
 /*--- compute (gp|kk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+98696,int_stack+0,int_stack+40376,1296);
 /*--- compute (fd|kk) ---*/
 hrr1_build_fd(Libint->AB,int_stack+157016,int_stack+98696,int_stack+59816,1296);
 return int_stack+157016;}
