/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fdnn(Libint_t*, prim_data*);

  /* Computes quartets of (fd|nn) integrals */

REALTYPE *hrr_order_fdnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][10] = int_stack + 0;
 Libint->vrr_classes[3][11] = int_stack + 660;
 Libint->vrr_classes[3][12] = int_stack + 1440;
 Libint->vrr_classes[3][13] = int_stack + 2350;
 Libint->vrr_classes[3][14] = int_stack + 3400;
 Libint->vrr_classes[3][15] = int_stack + 4600;
 Libint->vrr_classes[3][16] = int_stack + 5960;
 Libint->vrr_classes[3][17] = int_stack + 7490;
 Libint->vrr_classes[3][18] = int_stack + 9200;
 Libint->vrr_classes[3][19] = int_stack + 11100;
 Libint->vrr_classes[3][20] = int_stack + 13200;
 Libint->vrr_classes[4][10] = int_stack + 15510;
 Libint->vrr_classes[4][11] = int_stack + 16500;
 Libint->vrr_classes[4][12] = int_stack + 17670;
 Libint->vrr_classes[4][13] = int_stack + 19035;
 Libint->vrr_classes[4][14] = int_stack + 20610;
 Libint->vrr_classes[4][15] = int_stack + 22410;
 Libint->vrr_classes[4][16] = int_stack + 24450;
 Libint->vrr_classes[4][17] = int_stack + 26745;
 Libint->vrr_classes[4][18] = int_stack + 29310;
 Libint->vrr_classes[4][19] = int_stack + 32160;
 Libint->vrr_classes[4][20] = int_stack + 35310;
 Libint->vrr_classes[5][10] = int_stack + 38775;
 Libint->vrr_classes[5][11] = int_stack + 40161;
 Libint->vrr_classes[5][12] = int_stack + 41799;
 Libint->vrr_classes[5][13] = int_stack + 43710;
 Libint->vrr_classes[5][14] = int_stack + 45915;
 Libint->vrr_classes[5][15] = int_stack + 48435;
 Libint->vrr_classes[5][16] = int_stack + 51291;
 Libint->vrr_classes[5][17] = int_stack + 54504;
 Libint->vrr_classes[5][18] = int_stack + 58095;
 Libint->vrr_classes[5][19] = int_stack + 62085;
 Libint->vrr_classes[5][20] = int_stack + 66495;
 memset(int_stack,0,71346*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 71346;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fdnn(Libint, Data);
   Data++;
 }
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71346,int_stack+660,int_stack+0,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73326,int_stack+1440,int_stack+660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+75666,int_stack+73326,int_stack+71346,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+79626,int_stack+2350,int_stack+1440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+82356,int_stack+79626,int_stack+73326,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+87036,int_stack+82356,int_stack+75666,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+71346,int_stack+3400,int_stack+2350,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+93636,int_stack+71346,int_stack+79626,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+74496,int_stack+93636,int_stack+82356,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+99096,int_stack+74496,int_stack+87036,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+82296,int_stack+4600,int_stack+3400,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85896,int_stack+82296,int_stack+71346,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+108996,int_stack+85896,int_stack+93636,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+118096,int_stack+108996,int_stack+74496,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+129796,int_stack+118096,int_stack+99096,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+71346,int_stack+5960,int_stack+4600,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+92196,int_stack+71346,int_stack+82296,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+143656,int_stack+92196,int_stack+85896,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+75426,int_stack+143656,int_stack+108996,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+99396,int_stack+75426,int_stack+118096,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+154156,int_stack+99396,int_stack+129796,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+115776,int_stack+7490,int_stack+5960,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+120366,int_stack+115776,int_stack+71346,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+128526,int_stack+120366,int_stack+92196,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+172636,int_stack+128526,int_stack+143656,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+188386,int_stack+172636,int_stack+75426,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+71346,int_stack+188386,int_stack+99396,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+207496,int_stack+71346,int_stack+154156,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+93186,int_stack+9200,int_stack+7490,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+98316,int_stack+93186,int_stack+115776,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+140526,int_stack+98316,int_stack+120366,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+107496,int_stack+140526,int_stack+128526,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+231256,int_stack+107496,int_stack+172636,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+154126,int_stack+231256,int_stack+188386,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+253306,int_stack+154126,int_stack+71346,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+281386,int_stack+253306,int_stack+207496,10);
 /*--- compute (f0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+71346,int_stack+11100,int_stack+9200,10);
 /*--- compute (f0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77046,int_stack+71346,int_stack+93186,10);
 /*--- compute (f0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+179606,int_stack+77046,int_stack+98316,10);
 /*--- compute (f0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+194906,int_stack+179606,int_stack+140526,10);
 /*--- compute (f0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+125496,int_stack+194906,int_stack+107496,10);
 /*--- compute (f0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+87306,int_stack+125496,int_stack+231256,10);
 /*--- compute (f0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+215306,int_stack+87306,int_stack+154126,10);
 /*--- compute (f0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+311086,int_stack+215306,int_stack+253306,10);
 /*--- compute (f0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+346186,int_stack+311086,int_stack+281386,10);
 /*--- compute (f0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+116706,int_stack+13200,int_stack+11100,10);
 /*--- compute (f0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+150696,int_stack+116706,int_stack+71346,10);
 /*--- compute (f0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+162096,int_stack+150696,int_stack+77046,10);
 /*--- compute (f0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+248066,int_stack+162096,int_stack+179606,10);
 /*--- compute (f0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+150696,int_stack+248066,int_stack+194906,10);
 /*--- compute (f0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+248066,int_stack+150696,int_stack+125496,10);
 /*--- compute (f0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+116706,int_stack+248066,int_stack+87306,10);
 /*--- compute (f0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+248066,int_stack+116706,int_stack+215306,10);
 /*--- compute (f0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+71346,int_stack+248066,int_stack+311086,10);
 /*--- compute (f0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+114246,int_stack+71346,int_stack+346186,10);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+71346,int_stack+16500,int_stack+15510,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+74316,int_stack+17670,int_stack+16500,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+77826,int_stack+74316,int_stack+71346,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+83766,int_stack+19035,int_stack+17670,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+87861,int_stack+83766,int_stack+74316,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+94881,int_stack+87861,int_stack+77826,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+71346,int_stack+20610,int_stack+19035,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+104781,int_stack+71346,int_stack+83766,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76071,int_stack+104781,int_stack+87861,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+157806,int_stack+76071,int_stack+94881,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+87771,int_stack+22410,int_stack+20610,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+93171,int_stack+87771,int_stack+71346,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+172656,int_stack+93171,int_stack+104781,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+186306,int_stack+172656,int_stack+76071,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+203856,int_stack+186306,int_stack+157806,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+157806,int_stack+24450,int_stack+22410,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+71346,int_stack+157806,int_stack+87771,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+224646,int_stack+71346,int_stack+93171,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+82146,int_stack+224646,int_stack+172656,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+240396,int_stack+82146,int_stack+186306,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+163926,int_stack+240396,int_stack+203856,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+191646,int_stack+26745,int_stack+24450,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+198531,int_stack+191646,int_stack+157806,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+264966,int_stack+198531,int_stack+71346,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+282966,int_stack+264966,int_stack+224646,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+210771,int_stack+282966,int_stack+82146,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+71346,int_stack+210771,int_stack+240396,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+306591,int_stack+71346,int_stack+163926,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+104106,int_stack+29310,int_stack+26745,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+157806,int_stack+104106,int_stack+191646,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+171576,int_stack+157806,int_stack+198531,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+342231,int_stack+171576,int_stack+264966,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+239436,int_stack+342231,int_stack+282966,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+369231,int_stack+239436,int_stack+210771,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+191976,int_stack+369231,int_stack+71346,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+407451,int_stack+191976,int_stack+306591,15);
 /*--- compute (g0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+71346,int_stack+32160,int_stack+29310,15);
 /*--- compute (g0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+79896,int_stack+71346,int_stack+104106,15);
 /*--- compute (g0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+272511,int_stack+79896,int_stack+157806,15);
 /*--- compute (g0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+295461,int_stack+272511,int_stack+171576,15);
 /*--- compute (g0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+452001,int_stack+295461,int_stack+342231,15);
 /*--- compute (g0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+489801,int_stack+452001,int_stack+239436,15);
 /*--- compute (g0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+533901,int_stack+489801,int_stack+369231,15);
 /*--- compute (g0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+326061,int_stack+533901,int_stack+191976,15);
 /*--- compute (g0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+157806,int_stack+326061,int_stack+407451,15);
 /*--- compute (g0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+212256,int_stack+35310,int_stack+32160,15);
 /*--- compute (g0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+221706,int_stack+212256,int_stack+71346,15);
 /*--- compute (g0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+238806,int_stack+221706,int_stack+79896,15);
 /*--- compute (g0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+71346,int_stack+238806,int_stack+272511,15);
 /*--- compute (g0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+212256,int_stack+71346,int_stack+295461,15);
 /*--- compute (g0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+255096,int_stack+212256,int_stack+452001,15);
 /*--- compute (g0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+378711,int_stack+255096,int_stack+489801,15);
 /*--- compute (g0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+212256,int_stack+378711,int_stack+533901,15);
 /*--- compute (g0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+378711,int_stack+212256,int_stack+326061,15);
 /*--- compute (g0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+212256,int_stack+378711,int_stack+157806,15);
 /*--- compute (fp|nn) ---*/
 hrr1_build_fp(Libint->AB,int_stack+277596,int_stack+212256,int_stack+114246,4356);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+408276,int_stack+40161,int_stack+38775,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+412434,int_stack+41799,int_stack+40161,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+417348,int_stack+412434,int_stack+408276,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+425664,int_stack+43710,int_stack+41799,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+431397,int_stack+425664,int_stack+412434,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+441225,int_stack+431397,int_stack+417348,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+408276,int_stack+45915,int_stack+43710,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+455085,int_stack+408276,int_stack+425664,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+414891,int_stack+455085,int_stack+431397,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+466551,int_stack+414891,int_stack+441225,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+431271,int_stack+48435,int_stack+45915,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+438831,int_stack+431271,int_stack+408276,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+487341,int_stack+438831,int_stack+455085,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+506451,int_stack+487341,int_stack+414891,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+531021,int_stack+506451,int_stack+466551,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+408276,int_stack+51291,int_stack+48435,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+452061,int_stack+408276,int_stack+431271,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+560127,int_stack+452061,int_stack+438831,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+416844,int_stack+560127,int_stack+487341,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+467181,int_stack+416844,int_stack+506451,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+71346,int_stack+467181,int_stack+531021,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+501579,int_stack+54504,int_stack+51291,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+511218,int_stack+501579,int_stack+408276,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+528354,int_stack+511218,int_stack+452061,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+110154,int_stack+528354,int_stack+560127,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+143229,int_stack+110154,int_stack+416844,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+408276,int_stack+143229,int_stack+467181,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+408276,int_stack+71346,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+71346,int_stack+58095,int_stack+54504,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+82119,int_stack+71346,int_stack+501579,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+454140,int_stack+82119,int_stack+511218,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+482700,int_stack+454140,int_stack+528354,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+520500,int_stack+482700,int_stack+110154,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+566805,int_stack+520500,int_stack+143229,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+101397,int_stack+566805,int_stack+408276,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+620313,int_stack+101397,int_stack+0,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+62085,int_stack+58095,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+11970,int_stack+0,int_stack+71346,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+408276,int_stack+11970,int_stack+82119,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+160365,int_stack+408276,int_stack+454140,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+682683,int_stack+160365,int_stack+482700,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+440406,int_stack+682683,int_stack+520500,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+735603,int_stack+440406,int_stack+566805,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+502146,int_stack+735603,int_stack+101397,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+71346,int_stack+502146,int_stack+620313,21);
 /*--- compute (h0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+33516,int_stack+66495,int_stack+62085,21);
 /*--- compute (h0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+46746,int_stack+33516,int_stack+0,21);
 /*--- compute (h0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+575856,int_stack+46746,int_stack+11970,21);
 /*--- compute (h0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+0,int_stack+575856,int_stack+408276,21);
 /*--- compute (h0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+575856,int_stack+0,int_stack+160365,21);
 /*--- compute (h0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+0,int_stack+575856,int_stack+682683,21);
 /*--- compute (h0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+575856,int_stack+0,int_stack+440406,21);
 /*--- compute (h0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+408276,int_stack+575856,int_stack+735603,21);
 /*--- compute (h0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+575856,int_stack+408276,int_stack+502146,21);
 /*--- compute (h0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+408276,int_stack+575856,int_stack+71346,21);
 /*--- compute (gp|nn) ---*/
 hrr1_build_gp(Libint->AB,int_stack+499752,int_stack+408276,int_stack+212256,4356);
 /*--- compute (fd|nn) ---*/
 hrr1_build_fd(Libint->AB,int_stack+0,int_stack+499752,int_stack+277596,4356);
 return int_stack+0;}
