/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffig(Libint_t*, prim_data*);

  /* Computes quartets of (ff|ig) integrals */

REALTYPE *hrr_order_ffig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[3][8] = int_stack + 640;
 Libint->vrr_classes[3][9] = int_stack + 1090;
 Libint->vrr_classes[3][10] = int_stack + 1640;
 Libint->vrr_classes[4][6] = int_stack + 2300;
 Libint->vrr_classes[4][7] = int_stack + 2720;
 Libint->vrr_classes[4][8] = int_stack + 3260;
 Libint->vrr_classes[4][9] = int_stack + 3935;
 Libint->vrr_classes[4][10] = int_stack + 4760;
 Libint->vrr_classes[5][6] = int_stack + 5750;
 Libint->vrr_classes[5][7] = int_stack + 6338;
 Libint->vrr_classes[5][8] = int_stack + 7094;
 Libint->vrr_classes[5][9] = int_stack + 8039;
 Libint->vrr_classes[5][10] = int_stack + 9194;
 Libint->vrr_classes[6][6] = int_stack + 10580;
 Libint->vrr_classes[6][7] = int_stack + 11364;
 Libint->vrr_classes[6][8] = int_stack + 12372;
 Libint->vrr_classes[6][9] = int_stack + 13632;
 Libint->vrr_classes[6][10] = int_stack + 15172;
 memset(int_stack,0,17020*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 17020;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffig(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17020,int_stack+280,int_stack+0,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+17860,int_stack+640,int_stack+280,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+18940,int_stack+17860,int_stack+17020,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+20620,int_stack+1090,int_stack+640,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+21970,int_stack+20620,int_stack+17860,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+24130,int_stack+21970,int_stack+18940,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17020,int_stack+1640,int_stack+1090,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+26930,int_stack+17020,int_stack+20620,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17020,int_stack+26930,int_stack+21970,10);
 /*--- compute (f0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+26930,int_stack+17020,int_stack+24130,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17020,int_stack+2720,int_stack+2300,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+18280,int_stack+3260,int_stack+2720,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+19900,int_stack+18280,int_stack+17020,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+22420,int_stack+3935,int_stack+3260,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+22420,int_stack+18280,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+31130,int_stack+0,int_stack+19900,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17020,int_stack+4760,int_stack+3935,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+35330,int_stack+17020,int_stack+22420,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17020,int_stack+35330,int_stack+0,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+35330,int_stack+17020,int_stack+31130,15);
 /*--- compute (fp|ig) ---*/
 hrr1_build_fp(Libint->AB,int_stack+41630,int_stack+35330,int_stack+26930,420);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+17020,int_stack+6338,int_stack+5750,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+18784,int_stack+7094,int_stack+6338,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+21052,int_stack+18784,int_stack+17020,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+24580,int_stack+8039,int_stack+7094,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+27415,int_stack+24580,int_stack+18784,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+0,int_stack+27415,int_stack+21052,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+17020,int_stack+9194,int_stack+8039,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54230,int_stack+17020,int_stack+24580,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17020,int_stack+54230,int_stack+27415,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+24580,int_stack+17020,int_stack+0,21);
 /*--- compute (gp|ig) ---*/
 hrr1_build_gp(Libint->AB,int_stack+54230,int_stack+24580,int_stack+35330,420);
 /*--- compute (fd|ig) ---*/
 hrr1_build_fd(Libint->AB,int_stack+73130,int_stack+54230,int_stack+41630,420);
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+11364,int_stack+10580,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+2352,int_stack+12372,int_stack+11364,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+5376,int_stack+2352,int_stack+0,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+17020,int_stack+13632,int_stack+12372,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33400,int_stack+17020,int_stack+2352,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+39448,int_stack+33400,int_stack+5376,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+15172,int_stack+13632,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+4620,int_stack+0,int_stack+17020,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+12180,int_stack+4620,int_stack+33400,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+0,int_stack+12180,int_stack+39448,28);
 /*--- compute (hp|ig) ---*/
 hrr1_build_hp(Libint->AB,int_stack+98330,int_stack+0,int_stack+24580,420);
 /*--- compute (gd|ig) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+98330,int_stack+54230,420);
 /*--- compute (ff|ig) ---*/
 hrr1_build_ff(Libint->AB,int_stack+98330,int_stack+0,int_stack+73130,420);
 return int_stack+98330;}
