/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ffmm(Libint_t*, prim_data*);

  /* Computes quartets of (ff|mm) integrals */

REALTYPE *hrr_order_ffmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[3][14] = int_stack + 3950;
 Libint->vrr_classes[3][15] = int_stack + 5150;
 Libint->vrr_classes[3][16] = int_stack + 6510;
 Libint->vrr_classes[3][17] = int_stack + 8040;
 Libint->vrr_classes[3][18] = int_stack + 9750;
 Libint->vrr_classes[4][9] = int_stack + 11650;
 Libint->vrr_classes[4][10] = int_stack + 12475;
 Libint->vrr_classes[4][11] = int_stack + 13465;
 Libint->vrr_classes[4][12] = int_stack + 14635;
 Libint->vrr_classes[4][13] = int_stack + 16000;
 Libint->vrr_classes[4][14] = int_stack + 17575;
 Libint->vrr_classes[4][15] = int_stack + 19375;
 Libint->vrr_classes[4][16] = int_stack + 21415;
 Libint->vrr_classes[4][17] = int_stack + 23710;
 Libint->vrr_classes[4][18] = int_stack + 26275;
 Libint->vrr_classes[5][9] = int_stack + 29125;
 Libint->vrr_classes[5][10] = int_stack + 30280;
 Libint->vrr_classes[5][11] = int_stack + 31666;
 Libint->vrr_classes[5][12] = int_stack + 33304;
 Libint->vrr_classes[5][13] = int_stack + 35215;
 Libint->vrr_classes[5][14] = int_stack + 37420;
 Libint->vrr_classes[5][15] = int_stack + 39940;
 Libint->vrr_classes[5][16] = int_stack + 42796;
 Libint->vrr_classes[5][17] = int_stack + 46009;
 Libint->vrr_classes[5][18] = int_stack + 49600;
 Libint->vrr_classes[6][9] = int_stack + 53590;
 Libint->vrr_classes[6][10] = int_stack + 55130;
 Libint->vrr_classes[6][11] = int_stack + 56978;
 Libint->vrr_classes[6][12] = int_stack + 59162;
 Libint->vrr_classes[6][13] = int_stack + 61710;
 Libint->vrr_classes[6][14] = int_stack + 64650;
 Libint->vrr_classes[6][15] = int_stack + 68010;
 Libint->vrr_classes[6][16] = int_stack + 71818;
 Libint->vrr_classes[6][17] = int_stack + 76102;
 Libint->vrr_classes[6][18] = int_stack + 80890;
 memset(int_stack,0,86210*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 86210;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ffmm(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86210,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+87860,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+89840,int_stack+87860,int_stack+86210,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93140,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95480,int_stack+93140,int_stack+87860,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+99440,int_stack+95480,int_stack+89840,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86210,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+104940,int_stack+86210,int_stack+93140,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109620,int_stack+104940,int_stack+95480,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+88940,int_stack+109620,int_stack+99440,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+97190,int_stack+3950,int_stack+2900,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+116220,int_stack+97190,int_stack+86210,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+121680,int_stack+116220,int_stack+104940,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+129480,int_stack+121680,int_stack+109620,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+100340,int_stack+129480,int_stack+88940,10);
 /*--- compute (f0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+86210,int_stack+5150,int_stack+3950,10);
 /*--- compute (f0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+89810,int_stack+86210,int_stack+97190,10);
 /*--- compute (f0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+139380,int_stack+89810,int_stack+116220,10);
 /*--- compute (f0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+148480,int_stack+139380,int_stack+121680,10);
 /*--- compute (f0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+111890,int_stack+148480,int_stack+129480,10);
 /*--- compute (f0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+160180,int_stack+111890,int_stack+100340,10);
 /*--- compute (f0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+96110,int_stack+6510,int_stack+5150,10);
 /*--- compute (f0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+100190,int_stack+96110,int_stack+86210,10);
 /*--- compute (f0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+125750,int_stack+100190,int_stack+89810,10);
 /*--- compute (f0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+175580,int_stack+125750,int_stack+139380,10);
 /*--- compute (f0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+189230,int_stack+175580,int_stack+148480,10);
 /*--- compute (f0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+136250,int_stack+189230,int_stack+111890,10);
 /*--- compute (f0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+205610,int_stack+136250,int_stack+160180,10);
 /*--- compute (f0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+86210,int_stack+8040,int_stack+6510,10);
 /*--- compute (f0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+107390,int_stack+86210,int_stack+96110,10);
 /*--- compute (f0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+154730,int_stack+107390,int_stack+100190,10);
 /*--- compute (f0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+90800,int_stack+154730,int_stack+125750,10);
 /*--- compute (f0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+115550,int_stack+90800,int_stack+175580,10);
 /*--- compute (f0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+166730,int_stack+115550,int_stack+189230,10);
 /*--- compute (f0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+225410,int_stack+166730,int_stack+136250,10);
 /*--- compute (f0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+249170,int_stack+225410,int_stack+205610,10);
 /*--- compute (f0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+134660,int_stack+9750,int_stack+8040,10);
 /*--- compute (f0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+139790,int_stack+134660,int_stack+86210,10);
 /*--- compute (f0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+188570,int_stack+139790,int_stack+107390,10);
 /*--- compute (f0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+134660,int_stack+188570,int_stack+154730,10);
 /*--- compute (f0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+188570,int_stack+134660,int_stack+90800,10);
 /*--- compute (f0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+134660,int_stack+188570,int_stack+115550,10);
 /*--- compute (f0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+188570,int_stack+134660,int_stack+166730,10);
 /*--- compute (f0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+86210,int_stack+188570,int_stack+225410,10);
 /*--- compute (f0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+115910,int_stack+86210,int_stack+249170,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86210,int_stack+12475,int_stack+11650,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88685,int_stack+13465,int_stack+12475,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+91655,int_stack+88685,int_stack+86210,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+96605,int_stack+14635,int_stack+13465,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+100115,int_stack+96605,int_stack+88685,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+106055,int_stack+100115,int_stack+91655,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86210,int_stack+16000,int_stack+14635,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146160,int_stack+86210,int_stack+96605,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+153180,int_stack+146160,int_stack+100115,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+90305,int_stack+153180,int_stack+106055,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+102680,int_stack+17575,int_stack+16000,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+107405,int_stack+102680,int_stack+86210,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+163080,int_stack+107405,int_stack+146160,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+174780,int_stack+163080,int_stack+153180,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+189630,int_stack+174780,int_stack+90305,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+146160,int_stack+19375,int_stack+17575,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+151560,int_stack+146160,int_stack+102680,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+86210,int_stack+151560,int_stack+107405,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+206955,int_stack+86210,int_stack+163080,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+224505,int_stack+206955,int_stack+174780,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+161010,int_stack+224505,int_stack+189630,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+184110,int_stack+21415,int_stack+19375,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+190230,int_stack+184110,int_stack+146160,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+99860,int_stack+190230,int_stack+151560,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+245295,int_stack+99860,int_stack+86210,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+265770,int_stack+245295,int_stack+206955,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+290340,int_stack+265770,int_stack+224505,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+201030,int_stack+290340,int_stack+161010,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+86210,int_stack+23710,int_stack+21415,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+146160,int_stack+86210,int_stack+184110,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+158400,int_stack+146160,int_stack+190230,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+176400,int_stack+158400,int_stack+99860,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+318060,int_stack+176400,int_stack+245295,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+230730,int_stack+318060,int_stack+265770,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+346725,int_stack+230730,int_stack+290340,15);
 /*--- compute (g0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+263490,int_stack+346725,int_stack+201030,15);
 /*--- compute (g0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+93095,int_stack+26275,int_stack+23710,15);
 /*--- compute (g0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+100790,int_stack+93095,int_stack+86210,15);
 /*--- compute (g0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+200025,int_stack+100790,int_stack+146160,15);
 /*--- compute (g0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+86210,int_stack+200025,int_stack+158400,15);
 /*--- compute (g0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+382365,int_stack+86210,int_stack+176400,15);
 /*--- compute (g0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+146160,int_stack+382365,int_stack+318060,15);
 /*--- compute (g0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+184380,int_stack+146160,int_stack+230730,15);
 /*--- compute (g0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+300615,int_stack+184380,int_stack+346725,15);
 /*--- compute (g0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+146160,int_stack+300615,int_stack+263490,15);
 /*--- compute (fp|mm) ---*/
 hrr1_build_fp(Libint->AB,int_stack+191535,int_stack+146160,int_stack+115910,3025);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+282285,int_stack+30280,int_stack+29125,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+285750,int_stack+31666,int_stack+30280,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+289908,int_stack+285750,int_stack+282285,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+296838,int_stack+33304,int_stack+31666,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+301752,int_stack+296838,int_stack+285750,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+310068,int_stack+301752,int_stack+289908,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+282285,int_stack+35215,int_stack+33304,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+321618,int_stack+282285,int_stack+296838,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+331446,int_stack+321618,int_stack+301752,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+288018,int_stack+331446,int_stack+310068,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+305343,int_stack+37420,int_stack+35215,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+345306,int_stack+305343,int_stack+282285,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+356772,int_stack+345306,int_stack+321618,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+373152,int_stack+356772,int_stack+331446,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+311958,int_stack+373152,int_stack+288018,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+282285,int_stack+39940,int_stack+37420,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+289845,int_stack+282285,int_stack+305343,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+393942,int_stack+289845,int_stack+345306,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+86210,int_stack+393942,int_stack+356772,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+336213,int_stack+86210,int_stack+373152,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+110780,int_stack+336213,int_stack+311958,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+303075,int_stack+42796,int_stack+39940,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+311643,int_stack+303075,int_stack+282285,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+365319,int_stack+311643,int_stack+289845,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+365319,int_stack+393942,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+387369,int_stack+0,int_stack+86210,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+421767,int_stack+387369,int_stack+336213,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+460575,int_stack+421767,int_stack+110780,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+86210,int_stack+46009,int_stack+42796,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+95849,int_stack+86210,int_stack+303075,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+112985,int_stack+95849,int_stack+311643,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+282285,int_stack+112985,int_stack+365319,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+315360,int_stack+282285,int_stack+0,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+315360,int_stack+387369,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+355491,int_stack+0,int_stack+421767,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+405387,int_stack+355491,int_stack+460575,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+457362,int_stack+49600,int_stack+46009,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+468135,int_stack+457362,int_stack+86210,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+487413,int_stack+468135,int_stack+95849,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+515973,int_stack+487413,int_stack+112985,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+86210,int_stack+515973,int_stack+282285,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+457362,int_stack+86210,int_stack+315360,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+86210,int_stack+457362,int_stack+0,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+457362,int_stack+86210,int_stack+355491,21);
 /*--- compute (h0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+282285,int_stack+457362,int_stack+405387,21);
 /*--- compute (gp|mm) ---*/
 hrr1_build_gp(Libint->AB,int_stack+345810,int_stack+282285,int_stack+146160,3025);
 /*--- compute (fd|mm) ---*/
 hrr1_build_fd(Libint->AB,int_stack+481935,int_stack+345810,int_stack+191535,3025);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+86210,int_stack+55130,int_stack+53590,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+90830,int_stack+56978,int_stack+55130,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+96374,int_stack+90830,int_stack+86210,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+105614,int_stack+59162,int_stack+56978,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+112166,int_stack+105614,int_stack+90830,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+123254,int_stack+112166,int_stack+96374,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86210,int_stack+61710,int_stack+59162,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138654,int_stack+86210,int_stack+105614,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+151758,int_stack+138654,int_stack+112166,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+93854,int_stack+151758,int_stack+123254,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+116954,int_stack+64650,int_stack+61710,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+170238,int_stack+116954,int_stack+86210,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+185526,int_stack+170238,int_stack+138654,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+207366,int_stack+185526,int_stack+151758,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+125774,int_stack+207366,int_stack+93854,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+86210,int_stack+68010,int_stack+64650,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96290,int_stack+86210,int_stack+116954,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+235086,int_stack+96290,int_stack+170238,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+235086,int_stack+185526,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+158114,int_stack+0,int_stack+207366,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+663435,int_stack+158114,int_stack+125774,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+113930,int_stack+71818,int_stack+68010,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+125354,int_stack+113930,int_stack+86210,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+196922,int_stack+125354,int_stack+96290,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+32760,int_stack+196922,int_stack+235086,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+226322,int_stack+32760,int_stack+0,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+706555,int_stack+226322,int_stack+158114,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+758299,int_stack+706555,int_stack+663435,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+663435,int_stack+76102,int_stack+71818,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+676287,int_stack+663435,int_stack+113930,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+86210,int_stack+676287,int_stack+125354,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+119810,int_stack+86210,int_stack+196922,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+163910,int_stack+119810,int_stack+32760,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+163910,int_stack+226322,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+813739,int_stack+0,int_stack+706555,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+880267,int_stack+813739,int_stack+758299,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+699135,int_stack+80890,int_stack+76102,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+713499,int_stack+699135,int_stack+663435,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+739203,int_stack+713499,int_stack+676287,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+663435,int_stack+739203,int_stack+86210,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+713835,int_stack+663435,int_stack+119810,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+61152,int_stack+713835,int_stack+163910,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+663435,int_stack+61152,int_stack+0,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+663435,int_stack+813739,28);
 /*--- compute (i0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+663435,int_stack+0,int_stack+880267,28);
 /*--- compute (hp|mm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+0,int_stack+663435,int_stack+282285,3025);
 /*--- compute (gd|mm) ---*/
 hrr1_build_gd(Libint->AB,int_stack+663435,int_stack+0,int_stack+345810,3025);
 /*--- compute (ff|mm) ---*/
 hrr1_build_ff(Libint->AB,int_stack+0,int_stack+663435,int_stack+481935,3025);
 return int_stack+0;}
