/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpig(Libint_t*, prim_data*);

  /* Computes quartets of (fp|ig) integrals */

REALTYPE *hrr_order_fpig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][6] = int_stack + 0;
 Libint->vrr_classes[3][7] = int_stack + 280;
 Libint->vrr_classes[3][8] = int_stack + 640;
 Libint->vrr_classes[3][9] = int_stack + 1090;
 Libint->vrr_classes[3][10] = int_stack + 1640;
 Libint->vrr_classes[4][6] = int_stack + 2300;
 Libint->vrr_classes[4][7] = int_stack + 2720;
 Libint->vrr_classes[4][8] = int_stack + 3260;
 Libint->vrr_classes[4][9] = int_stack + 3935;
 Libint->vrr_classes[4][10] = int_stack + 4760;
 memset(int_stack,0,5750*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5750;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpig(Libint, Data);
   Data++;
 }
 /*--- compute (f0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+5750,int_stack+280,int_stack+0,10);
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+6590,int_stack+640,int_stack+280,10);
 /*--- compute (f0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+7670,int_stack+6590,int_stack+5750,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+9350,int_stack+1090,int_stack+640,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+10700,int_stack+9350,int_stack+6590,10);
 /*--- compute (f0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+12860,int_stack+10700,int_stack+7670,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5750,int_stack+1640,int_stack+1090,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+15660,int_stack+5750,int_stack+9350,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+5750,int_stack+15660,int_stack+10700,10);
 /*--- compute (f0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+15660,int_stack+5750,int_stack+12860,10);
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+5750,int_stack+2720,int_stack+2300,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+7010,int_stack+3260,int_stack+2720,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8630,int_stack+7010,int_stack+5750,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11150,int_stack+3935,int_stack+3260,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+11150,int_stack+7010,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+19860,int_stack+0,int_stack+8630,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5750,int_stack+4760,int_stack+3935,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+24060,int_stack+5750,int_stack+11150,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+3240,int_stack+24060,int_stack+0,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+8640,int_stack+3240,int_stack+19860,15);
 /*--- compute (fp|ig) ---*/
 hrr1_build_fp(Libint->AB,int_stack+19860,int_stack+8640,int_stack+15660,420);
 return int_stack+19860;}
