/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpkk(Libint_t*, prim_data*);

  /* Computes quartets of (fp|kk) integrals */

REALTYPE *hrr_order_fpkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][7] = int_stack + 0;
 Libint->vrr_classes[3][8] = int_stack + 360;
 Libint->vrr_classes[3][9] = int_stack + 810;
 Libint->vrr_classes[3][10] = int_stack + 1360;
 Libint->vrr_classes[3][11] = int_stack + 2020;
 Libint->vrr_classes[3][12] = int_stack + 2800;
 Libint->vrr_classes[3][13] = int_stack + 3710;
 Libint->vrr_classes[3][14] = int_stack + 4760;
 Libint->vrr_classes[4][7] = int_stack + 5960;
 Libint->vrr_classes[4][8] = int_stack + 6500;
 Libint->vrr_classes[4][9] = int_stack + 7175;
 Libint->vrr_classes[4][10] = int_stack + 8000;
 Libint->vrr_classes[4][11] = int_stack + 8990;
 Libint->vrr_classes[4][12] = int_stack + 10160;
 Libint->vrr_classes[4][13] = int_stack + 11525;
 Libint->vrr_classes[4][14] = int_stack + 13100;
 memset(int_stack,0,14900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 14900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpkk(Libint, Data);
   Data++;
 }
 /*--- compute (f0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+14900,int_stack+360,int_stack+0,10);
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15980,int_stack+810,int_stack+360,10);
 /*--- compute (f0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+17330,int_stack+15980,int_stack+14900,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+19490,int_stack+1360,int_stack+810,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+21140,int_stack+19490,int_stack+15980,10);
 /*--- compute (f0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+23840,int_stack+21140,int_stack+17330,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+14900,int_stack+2020,int_stack+1360,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+27440,int_stack+14900,int_stack+19490,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+30740,int_stack+27440,int_stack+21140,10);
 /*--- compute (f0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+16880,int_stack+30740,int_stack+23840,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+22280,int_stack+2800,int_stack+2020,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+35240,int_stack+22280,int_stack+14900,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+39200,int_stack+35240,int_stack+27440,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+44700,int_stack+39200,int_stack+30740,10);
 /*--- compute (f0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+24620,int_stack+44700,int_stack+16880,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+14900,int_stack+3710,int_stack+2800,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+51450,int_stack+14900,int_stack+22280,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+17630,int_stack+51450,int_stack+35240,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+56130,int_stack+17630,int_stack+39200,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+32180,int_stack+56130,int_stack+44700,10);
 /*--- compute (f0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+64380,int_stack+32180,int_stack+24620,10);
 /*--- compute (f0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+24230,int_stack+4760,int_stack+3710,10);
 /*--- compute (f0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+41630,int_stack+24230,int_stack+14900,10);
 /*--- compute (f0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24230,int_stack+41630,int_stack+51450,10);
 /*--- compute (f0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+41630,int_stack+24230,int_stack+17630,10);
 /*--- compute (f0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+14900,int_stack+41630,int_stack+56130,10);
 /*--- compute (f0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+41630,int_stack+14900,int_stack+32180,10);
 /*--- compute (f0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+14900,int_stack+41630,int_stack+64380,10);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+27860,int_stack+6500,int_stack+5960,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+29480,int_stack+7175,int_stack+6500,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+31505,int_stack+29480,int_stack+27860,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+34745,int_stack+8000,int_stack+7175,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+37220,int_stack+34745,int_stack+29480,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+41270,int_stack+37220,int_stack+31505,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+27860,int_stack+8990,int_stack+8000,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+46670,int_stack+27860,int_stack+34745,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+51620,int_stack+46670,int_stack+37220,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+30830,int_stack+51620,int_stack+41270,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38930,int_stack+10160,int_stack+8990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58370,int_stack+38930,int_stack+27860,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+64310,int_stack+58370,int_stack+46670,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+64310,int_stack+51620,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+42440,int_stack+0,int_stack+30830,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+27860,int_stack+11525,int_stack+10160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72560,int_stack+27860,int_stack+38930,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+31955,int_stack+72560,int_stack+58370,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+79580,int_stack+31955,int_stack+64310,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+53780,int_stack+79580,int_stack+0,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+91955,int_stack+53780,int_stack+42440,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+13100,int_stack+11525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4725,int_stack+0,int_stack+27860,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+41855,int_stack+4725,int_stack+72560,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+41855,int_stack+31955,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+27860,int_stack+0,int_stack+79580,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+67955,int_stack+27860,int_stack+53780,15);
 /*--- compute (g0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+27860,int_stack+67955,int_stack+91955,15);
 /*--- compute (fp|kk) ---*/
 hrr1_build_fp(Libint->AB,int_stack+47300,int_stack+27860,int_stack+14900,1296);
 return int_stack+47300;}
