/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fplh(Libint_t*, prim_data*);

  /* Computes quartets of (fp|lh) integrals */

REALTYPE *hrr_order_fplh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][8] = int_stack + 0;
 Libint->vrr_classes[3][9] = int_stack + 450;
 Libint->vrr_classes[3][10] = int_stack + 1000;
 Libint->vrr_classes[3][11] = int_stack + 1660;
 Libint->vrr_classes[3][12] = int_stack + 2440;
 Libint->vrr_classes[3][13] = int_stack + 3350;
 Libint->vrr_classes[4][8] = int_stack + 4400;
 Libint->vrr_classes[4][9] = int_stack + 5075;
 Libint->vrr_classes[4][10] = int_stack + 5900;
 Libint->vrr_classes[4][11] = int_stack + 6890;
 Libint->vrr_classes[4][12] = int_stack + 8060;
 Libint->vrr_classes[4][13] = int_stack + 9425;
 memset(int_stack,0,11000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fplh(Libint, Data);
   Data++;
 }
 /*--- compute (f0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11000,int_stack+450,int_stack+0,10);
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12350,int_stack+1000,int_stack+450,10);
 /*--- compute (f0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+14000,int_stack+12350,int_stack+11000,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+16700,int_stack+1660,int_stack+1000,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+18680,int_stack+16700,int_stack+12350,10);
 /*--- compute (f0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+21980,int_stack+18680,int_stack+14000,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+11000,int_stack+2440,int_stack+1660,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+26480,int_stack+11000,int_stack+16700,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+30440,int_stack+26480,int_stack+18680,10);
 /*--- compute (f0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+13340,int_stack+30440,int_stack+21980,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+20090,int_stack+3350,int_stack+2440,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+35940,int_stack+20090,int_stack+11000,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+40620,int_stack+35940,int_stack+26480,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+20090,int_stack+40620,int_stack+30440,10);
 /*--- compute (f0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+28340,int_stack+20090,int_stack+13340,10);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+11000,int_stack+5075,int_stack+4400,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+13025,int_stack+5900,int_stack+5075,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+15500,int_stack+13025,int_stack+11000,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19550,int_stack+6890,int_stack+5900,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+22520,int_stack+19550,int_stack+13025,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+37790,int_stack+22520,int_stack+15500,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+11000,int_stack+8060,int_stack+6890,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+11000,int_stack+19550,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+44540,int_stack+0,int_stack+22520,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+14510,int_stack+44540,int_stack+37790,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+37790,int_stack+9425,int_stack+8060,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+52790,int_stack+37790,int_stack+11000,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+59810,int_stack+52790,int_stack+0,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+59810,int_stack+44540,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+37790,int_stack+0,int_stack+14510,15);
 /*--- compute (fp|lh) ---*/
 hrr1_build_fp(Libint->AB,int_stack+51965,int_stack+37790,int_stack+28340,945);
 return int_stack+51965;}
