/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpmf(Libint_t*, prim_data*);

  /* Computes quartets of (fp|mf) integrals */

REALTYPE *hrr_order_fpmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[4][9] = int_stack + 2900;
 Libint->vrr_classes[4][10] = int_stack + 3725;
 Libint->vrr_classes[4][11] = int_stack + 4715;
 Libint->vrr_classes[4][12] = int_stack + 5885;
 memset(int_stack,0,7250*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 7250;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpmf(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7250,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+8900,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10880,int_stack+8900,int_stack+7250,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+14180,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+16520,int_stack+14180,int_stack+8900,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+20480,int_stack+16520,int_stack+10880,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7250,int_stack+3725,int_stack+2900,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9725,int_stack+4715,int_stack+3725,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+12695,int_stack+9725,int_stack+7250,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+5885,int_stack+4715,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3510,int_stack+0,int_stack+9725,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+25980,int_stack+3510,int_stack+12695,15);
 /*--- compute (fp|mf) ---*/
 hrr1_build_fp(Libint->AB,int_stack+0,int_stack+25980,int_stack+20480,550);
 return int_stack+0;}
