/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_fpmg(Libint_t*, prim_data*);

  /* Computes quartets of (fp|mg) integrals */

REALTYPE *hrr_order_fpmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[3][9] = int_stack + 0;
 Libint->vrr_classes[3][10] = int_stack + 550;
 Libint->vrr_classes[3][11] = int_stack + 1210;
 Libint->vrr_classes[3][12] = int_stack + 1990;
 Libint->vrr_classes[3][13] = int_stack + 2900;
 Libint->vrr_classes[4][9] = int_stack + 3950;
 Libint->vrr_classes[4][10] = int_stack + 4775;
 Libint->vrr_classes[4][11] = int_stack + 5765;
 Libint->vrr_classes[4][12] = int_stack + 6935;
 Libint->vrr_classes[4][13] = int_stack + 8300;
 memset(int_stack,0,9875*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9875;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_fpmg(Libint, Data);
   Data++;
 }
 /*--- compute (f0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9875,int_stack+550,int_stack+0,10);
 /*--- compute (f0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+11525,int_stack+1210,int_stack+550,10);
 /*--- compute (f0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13505,int_stack+11525,int_stack+9875,10);
 /*--- compute (f0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+16805,int_stack+1990,int_stack+1210,10);
 /*--- compute (f0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+19145,int_stack+16805,int_stack+11525,10);
 /*--- compute (f0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+23105,int_stack+19145,int_stack+13505,10);
 /*--- compute (f0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9875,int_stack+2900,int_stack+1990,10);
 /*--- compute (f0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+28605,int_stack+9875,int_stack+16805,10);
 /*--- compute (f0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+9875,int_stack+28605,int_stack+19145,10);
 /*--- compute (f0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28605,int_stack+9875,int_stack+23105,10);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+9875,int_stack+4775,int_stack+3950,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12350,int_stack+5765,int_stack+4775,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+15320,int_stack+12350,int_stack+9875,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20270,int_stack+6935,int_stack+5765,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+20270,int_stack+12350,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+36855,int_stack+0,int_stack+15320,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+9875,int_stack+8300,int_stack+6935,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+45105,int_stack+9875,int_stack+20270,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5940,int_stack+45105,int_stack+0,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15840,int_stack+5940,int_stack+36855,15);
 /*--- compute (fp|mg) ---*/
 hrr1_build_fp(Libint->AB,int_stack+36855,int_stack+15840,int_stack+28605,825);
 return int_stack+36855;}
