/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdkk(Libint_t*, prim_data*);

  /* Computes quartets of (gd|kk) integrals */

REALTYPE *hrr_order_gdkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[4][13] = int_stack + 5565;
 Libint->vrr_classes[4][14] = int_stack + 7140;
 Libint->vrr_classes[5][7] = int_stack + 8940;
 Libint->vrr_classes[5][8] = int_stack + 9696;
 Libint->vrr_classes[5][9] = int_stack + 10641;
 Libint->vrr_classes[5][10] = int_stack + 11796;
 Libint->vrr_classes[5][11] = int_stack + 13182;
 Libint->vrr_classes[5][12] = int_stack + 14820;
 Libint->vrr_classes[5][13] = int_stack + 16731;
 Libint->vrr_classes[5][14] = int_stack + 18936;
 Libint->vrr_classes[6][7] = int_stack + 21456;
 Libint->vrr_classes[6][8] = int_stack + 22464;
 Libint->vrr_classes[6][9] = int_stack + 23724;
 Libint->vrr_classes[6][10] = int_stack + 25264;
 Libint->vrr_classes[6][11] = int_stack + 27112;
 Libint->vrr_classes[6][12] = int_stack + 29296;
 Libint->vrr_classes[6][13] = int_stack + 31844;
 Libint->vrr_classes[6][14] = int_stack + 34784;
 memset(int_stack,0,38144*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 38144;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdkk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+38144,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+39764,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+41789,int_stack+39764,int_stack+38144,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+45029,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+47504,int_stack+45029,int_stack+39764,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+51554,int_stack+47504,int_stack+41789,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38144,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+56954,int_stack+38144,int_stack+45029,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+61904,int_stack+56954,int_stack+47504,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+41114,int_stack+61904,int_stack+51554,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+49214,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+68654,int_stack+49214,int_stack+38144,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+74594,int_stack+68654,int_stack+56954,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+82844,int_stack+74594,int_stack+61904,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+52724,int_stack+82844,int_stack+41114,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+38144,int_stack+5565,int_stack+4200,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+92969,int_stack+38144,int_stack+49214,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42239,int_stack+92969,int_stack+68654,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+99989,int_stack+42239,int_stack+74594,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+64064,int_stack+99989,int_stack+82844,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+112364,int_stack+64064,int_stack+52724,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+52139,int_stack+7140,int_stack+5565,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+78239,int_stack+52139,int_stack+38144,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+52139,int_stack+78239,int_stack+92969,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+78239,int_stack+52139,int_stack+42239,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+38144,int_stack+78239,int_stack+99989,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+78239,int_stack+38144,int_stack+64064,15);
 /*--- compute (g0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+38144,int_stack+78239,int_stack+112364,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+57584,int_stack+9696,int_stack+8940,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+59852,int_stack+10641,int_stack+9696,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+62687,int_stack+59852,int_stack+57584,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+67223,int_stack+11796,int_stack+10641,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+70688,int_stack+67223,int_stack+59852,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+76358,int_stack+70688,int_stack+62687,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+57584,int_stack+13182,int_stack+11796,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+83918,int_stack+57584,int_stack+67223,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+90848,int_stack+83918,int_stack+70688,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+61742,int_stack+90848,int_stack+76358,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+73082,int_stack+14820,int_stack+13182,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+100298,int_stack+73082,int_stack+57584,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+108614,int_stack+100298,int_stack+83918,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+108614,int_stack+90848,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+77996,int_stack+0,int_stack+61742,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+57584,int_stack+16731,int_stack+14820,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+120164,int_stack+57584,int_stack+73082,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+63317,int_stack+120164,int_stack+100298,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+129992,int_stack+63317,int_stack+108614,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+93872,int_stack+129992,int_stack+0,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+147317,int_stack+93872,int_stack+77996,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+18936,int_stack+16731,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+6615,int_stack+0,int_stack+57584,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+77177,int_stack+6615,int_stack+120164,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+77177,int_stack+63317,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+57584,int_stack+0,int_stack+129992,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+113717,int_stack+57584,int_stack+93872,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+57584,int_stack+113717,int_stack+147317,21);
 /*--- compute (gp|kk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+84800,int_stack+57584,int_stack+38144,1296);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+38144,int_stack+22464,int_stack+21456,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+41168,int_stack+23724,int_stack+22464,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+44948,int_stack+41168,int_stack+38144,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+50996,int_stack+25264,int_stack+23724,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+143120,int_stack+50996,int_stack+41168,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+150680,int_stack+143120,int_stack+44948,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+38144,int_stack+27112,int_stack+25264,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+38144,int_stack+50996,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+43688,int_stack+0,int_stack+143120,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+9240,int_stack+43688,int_stack+150680,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+143120,int_stack+29296,int_stack+27112,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+149672,int_stack+143120,int_stack+38144,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+160760,int_stack+149672,int_stack+0,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+176160,int_stack+160760,int_stack+43688,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+195060,int_stack+176160,int_stack+9240,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+31844,int_stack+29296,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7644,int_stack+0,int_stack+143120,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+38144,int_stack+7644,int_stack+149672,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+216228,int_stack+38144,int_stack+160760,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+143120,int_stack+216228,int_stack+176160,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+239328,int_stack+143120,int_stack+195060,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+169580,int_stack+34784,int_stack+31844,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+178400,int_stack+169580,int_stack+0,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+193688,int_stack+178400,int_stack+7644,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+193688,int_stack+38144,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169580,int_stack+0,int_stack+216228,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+169580,int_stack+143120,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+143120,int_stack+0,int_stack+239328,28);
 /*--- compute (hp|kk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+179408,int_stack+143120,int_stack+57584,1296);
 /*--- compute (gd|kk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+261056,int_stack+179408,int_stack+84800,1296);
 return int_stack+261056;}
