/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gdnk(Libint_t*, prim_data*);

  /* Computes quartets of (gd|nk) integrals */

REALTYPE *hrr_order_gdnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[4][11] = int_stack + 990;
 Libint->vrr_classes[4][12] = int_stack + 2160;
 Libint->vrr_classes[4][13] = int_stack + 3525;
 Libint->vrr_classes[4][14] = int_stack + 5100;
 Libint->vrr_classes[4][15] = int_stack + 6900;
 Libint->vrr_classes[4][16] = int_stack + 8940;
 Libint->vrr_classes[4][17] = int_stack + 11235;
 Libint->vrr_classes[5][10] = int_stack + 13800;
 Libint->vrr_classes[5][11] = int_stack + 15186;
 Libint->vrr_classes[5][12] = int_stack + 16824;
 Libint->vrr_classes[5][13] = int_stack + 18735;
 Libint->vrr_classes[5][14] = int_stack + 20940;
 Libint->vrr_classes[5][15] = int_stack + 23460;
 Libint->vrr_classes[5][16] = int_stack + 26316;
 Libint->vrr_classes[5][17] = int_stack + 29529;
 Libint->vrr_classes[6][10] = int_stack + 33120;
 Libint->vrr_classes[6][11] = int_stack + 34968;
 Libint->vrr_classes[6][12] = int_stack + 37152;
 Libint->vrr_classes[6][13] = int_stack + 39700;
 Libint->vrr_classes[6][14] = int_stack + 42640;
 Libint->vrr_classes[6][15] = int_stack + 46000;
 Libint->vrr_classes[6][16] = int_stack + 49808;
 Libint->vrr_classes[6][17] = int_stack + 54092;
 memset(int_stack,0,58880*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 58880;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gdnk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58880,int_stack+990,int_stack+0,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+61850,int_stack+2160,int_stack+990,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+65360,int_stack+61850,int_stack+58880,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+71300,int_stack+3525,int_stack+2160,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+75395,int_stack+71300,int_stack+61850,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+82415,int_stack+75395,int_stack+65360,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+58880,int_stack+5100,int_stack+3525,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+92315,int_stack+58880,int_stack+71300,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+63605,int_stack+92315,int_stack+75395,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+100505,int_stack+63605,int_stack+82415,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+75305,int_stack+6900,int_stack+5100,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+80705,int_stack+75305,int_stack+58880,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+115355,int_stack+80705,int_stack+92315,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+129005,int_stack+115355,int_stack+63605,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+146555,int_stack+129005,int_stack+100505,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+58880,int_stack+8940,int_stack+6900,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+90155,int_stack+58880,int_stack+75305,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+167345,int_stack+90155,int_stack+80705,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+65000,int_stack+167345,int_stack+115355,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+100955,int_stack+65000,int_stack+129005,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+183095,int_stack+100955,int_stack+146555,15);
 /*--- compute (g0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+125525,int_stack+11235,int_stack+8940,15);
 /*--- compute (g0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+132410,int_stack+125525,int_stack+58880,15);
 /*--- compute (g0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+144650,int_stack+132410,int_stack+90155,15);
 /*--- compute (g0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+210815,int_stack+144650,int_stack+167345,15);
 /*--- compute (g0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+125525,int_stack+210815,int_stack+65000,15);
 /*--- compute (g0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+58880,int_stack+125525,int_stack+100955,15);
 /*--- compute (g0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+91640,int_stack+58880,int_stack+183095,15);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58880,int_stack+15186,int_stack+13800,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63038,int_stack+16824,int_stack+15186,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+67952,int_stack+63038,int_stack+58880,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+76268,int_stack+18735,int_stack+16824,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+127280,int_stack+76268,int_stack+63038,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+137108,int_stack+127280,int_stack+67952,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+58880,int_stack+20940,int_stack+18735,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+150968,int_stack+58880,int_stack+76268,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+65495,int_stack+150968,int_stack+127280,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+162434,int_stack+65495,int_stack+137108,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+127280,int_stack+23460,int_stack+20940,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+134840,int_stack+127280,int_stack+58880,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+183224,int_stack+134840,int_stack+150968,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+202334,int_stack+183224,int_stack+65495,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+58880,int_stack+202334,int_stack+162434,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+148070,int_stack+26316,int_stack+23460,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+156638,int_stack+148070,int_stack+127280,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+156638,int_stack+134840,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+226904,int_stack+0,int_stack+183224,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+255569,int_stack+226904,int_stack+202334,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+171758,int_stack+255569,int_stack+58880,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+58880,int_stack+29529,int_stack+26316,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+68519,int_stack+58880,int_stack+148070,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+127280,int_stack+68519,int_stack+156638,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+289967,int_stack+127280,int_stack+0,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+127280,int_stack+289967,int_stack+226904,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+289967,int_stack+127280,int_stack+255569,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+210566,int_stack+289967,int_stack+171758,21);
 /*--- compute (gp|nk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+260462,int_stack+210566,int_stack+91640,2376);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+34968,int_stack+33120,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5544,int_stack+37152,int_stack+34968,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+12096,int_stack+5544,int_stack+0,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+23184,int_stack+39700,int_stack+37152,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+58880,int_stack+23184,int_stack+5544,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+71984,int_stack+58880,int_stack+12096,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+42640,int_stack+39700,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+90464,int_stack+0,int_stack+23184,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+8820,int_stack+90464,int_stack+58880,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+105752,int_stack+8820,int_stack+71984,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+58880,int_stack+46000,int_stack+42640,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+68960,int_stack+58880,int_stack+0,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+133472,int_stack+68960,int_stack+90464,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+158952,int_stack+133472,int_stack+8820,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+158952,int_stack+105752,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+86600,int_stack+49808,int_stack+46000,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+98024,int_stack+86600,int_stack+58880,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+367382,int_stack+98024,int_stack+68960,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+396782,int_stack+367382,int_stack+133472,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+435002,int_stack+396782,int_stack+158952,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+118184,int_stack+435002,int_stack+0,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+54092,int_stack+49808,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+12852,int_stack+0,int_stack+86600,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+35700,int_stack+12852,int_stack+98024,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+69300,int_stack+35700,int_stack+367382,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+69300,int_stack+396782,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+367382,int_stack+0,int_stack+435002,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+367382,int_stack+118184,28);
 /*--- compute (hp|nk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+367382,int_stack+0,int_stack+210566,2376);
 /*--- compute (gd|nk) ---*/
 hrr1_build_gd(Libint->AB,int_stack+0,int_stack+367382,int_stack+260462,2376);
 return int_stack+0;}
