/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggki(Libint_t*, prim_data*);

  /* Computes quartets of (gg|ki) integrals */

REALTYPE *hrr_order_ggki(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][7] = int_stack + 0;
 Libint->vrr_classes[4][8] = int_stack + 540;
 Libint->vrr_classes[4][9] = int_stack + 1215;
 Libint->vrr_classes[4][10] = int_stack + 2040;
 Libint->vrr_classes[4][11] = int_stack + 3030;
 Libint->vrr_classes[4][12] = int_stack + 4200;
 Libint->vrr_classes[4][13] = int_stack + 5565;
 Libint->vrr_classes[5][7] = int_stack + 7140;
 Libint->vrr_classes[5][8] = int_stack + 7896;
 Libint->vrr_classes[5][9] = int_stack + 8841;
 Libint->vrr_classes[5][10] = int_stack + 9996;
 Libint->vrr_classes[5][11] = int_stack + 11382;
 Libint->vrr_classes[5][12] = int_stack + 13020;
 Libint->vrr_classes[5][13] = int_stack + 14931;
 Libint->vrr_classes[6][7] = int_stack + 17136;
 Libint->vrr_classes[6][8] = int_stack + 18144;
 Libint->vrr_classes[6][9] = int_stack + 19404;
 Libint->vrr_classes[6][10] = int_stack + 20944;
 Libint->vrr_classes[6][11] = int_stack + 22792;
 Libint->vrr_classes[6][12] = int_stack + 24976;
 Libint->vrr_classes[6][13] = int_stack + 27524;
 Libint->vrr_classes[7][7] = int_stack + 30464;
 Libint->vrr_classes[7][8] = int_stack + 31760;
 Libint->vrr_classes[7][9] = int_stack + 33380;
 Libint->vrr_classes[7][10] = int_stack + 35360;
 Libint->vrr_classes[7][11] = int_stack + 37736;
 Libint->vrr_classes[7][12] = int_stack + 40544;
 Libint->vrr_classes[7][13] = int_stack + 43820;
 Libint->vrr_classes[8][7] = int_stack + 47600;
 Libint->vrr_classes[8][8] = int_stack + 49220;
 Libint->vrr_classes[8][9] = int_stack + 51245;
 Libint->vrr_classes[8][10] = int_stack + 53720;
 Libint->vrr_classes[8][11] = int_stack + 56690;
 Libint->vrr_classes[8][12] = int_stack + 60200;
 Libint->vrr_classes[8][13] = int_stack + 64295;
 memset(int_stack,0,69020*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 69020;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggki(Libint, Data);
   Data++;
 }
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+69020,int_stack+540,int_stack+0,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+70640,int_stack+1215,int_stack+540,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+72665,int_stack+70640,int_stack+69020,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+75905,int_stack+2040,int_stack+1215,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+78380,int_stack+75905,int_stack+70640,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+82430,int_stack+78380,int_stack+72665,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69020,int_stack+3030,int_stack+2040,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+87830,int_stack+69020,int_stack+75905,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+92780,int_stack+87830,int_stack+78380,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+71990,int_stack+92780,int_stack+82430,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+80090,int_stack+4200,int_stack+3030,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+99530,int_stack+80090,int_stack+69020,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+105470,int_stack+99530,int_stack+87830,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+113720,int_stack+105470,int_stack+92780,15);
 /*--- compute (g0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+83600,int_stack+113720,int_stack+71990,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+69020,int_stack+5565,int_stack+4200,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+69020,int_stack+80090,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+69020,int_stack+0,int_stack+99530,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+123845,int_stack+69020,int_stack+105470,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+69020,int_stack+123845,int_stack+113720,15);
 /*--- compute (g0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+94940,int_stack+69020,int_stack+83600,15);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+69020,int_stack+7896,int_stack+7140,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+71288,int_stack+8841,int_stack+7896,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+74123,int_stack+71288,int_stack+69020,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+78659,int_stack+9996,int_stack+8841,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+82124,int_stack+78659,int_stack+71288,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+82124,int_stack+74123,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69020,int_stack+11382,int_stack+9996,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+87794,int_stack+69020,int_stack+78659,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+110060,int_stack+87794,int_stack+82124,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+73178,int_stack+110060,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+13020,int_stack+11382,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+119510,int_stack+0,int_stack+69020,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+127826,int_stack+119510,int_stack+87794,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+139376,int_stack+127826,int_stack+110060,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+153551,int_stack+139376,int_stack+73178,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+110060,int_stack+14931,int_stack+13020,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+69020,int_stack+110060,int_stack+0,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+69020,int_stack+119510,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+69020,int_stack+0,int_stack+127826,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+110060,int_stack+69020,int_stack+139376,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+69020,int_stack+110060,int_stack+153551,21);
 /*--- compute (gp|ki) ---*/
 hrr1_build_gp(Libint->AB,int_stack+110060,int_stack+69020,int_stack+94940,1008);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+155420,int_stack+18144,int_stack+17136,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+158444,int_stack+19404,int_stack+18144,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+162224,int_stack+158444,int_stack+155420,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90188,int_stack+20944,int_stack+19404,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+94808,int_stack+90188,int_stack+158444,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+94808,int_stack+162224,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+155420,int_stack+22792,int_stack+20944,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+10080,int_stack+155420,int_stack+90188,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+160964,int_stack+10080,int_stack+94808,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+90188,int_stack+160964,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+24976,int_stack+22792,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+173564,int_stack+0,int_stack+155420,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+184652,int_stack+173564,int_stack+10080,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+200052,int_stack+184652,int_stack+160964,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+218952,int_stack+200052,int_stack+90188,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+90188,int_stack+27524,int_stack+24976,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+155420,int_stack+90188,int_stack+0,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+155420,int_stack+173564,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+155420,int_stack+0,int_stack+184652,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+155420,int_stack+200052,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+155420,int_stack+0,int_stack+218952,28);
 /*--- compute (hp|ki) ---*/
 hrr1_build_hp(Libint->AB,int_stack+183644,int_stack+155420,int_stack+69020,1008);
 /*--- compute (gd|ki) ---*/
 hrr1_build_gd(Libint->AB,int_stack+247148,int_stack+183644,int_stack+110060,1008);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+69020,int_stack+31760,int_stack+30464,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+72908,int_stack+33380,int_stack+31760,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+77768,int_stack+72908,int_stack+69020,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+85544,int_stack+35360,int_stack+33380,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+91484,int_stack+85544,int_stack+72908,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+101204,int_stack+91484,int_stack+77768,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+69020,int_stack+37736,int_stack+35360,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+114164,int_stack+69020,int_stack+85544,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+126044,int_stack+114164,int_stack+91484,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+76148,int_stack+126044,int_stack+101204,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+95588,int_stack+40544,int_stack+37736,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+95588,int_stack+69020,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+14256,int_stack+0,int_stack+114164,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+337868,int_stack+14256,int_stack+126044,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+104012,int_stack+337868,int_stack+76148,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+69020,int_stack+43820,int_stack+40544,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+131228,int_stack+69020,int_stack+95588,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+69020,int_stack+131228,int_stack+0,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+362168,int_stack+69020,int_stack+14256,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+69020,int_stack+362168,int_stack+337868,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+337868,int_stack+69020,int_stack+104012,36);
 /*--- compute (ip|ki) ---*/
 hrr1_build_ip(Libint->AB,int_stack+69020,int_stack+337868,int_stack+155420,1008);
 /*--- compute (hd|ki) ---*/
 hrr1_build_hd(Libint->AB,int_stack+374156,int_stack+69020,int_stack+183644,1008);
 /*--- compute (gf|ki) ---*/
 hrr1_build_gf(Libint->AB,int_stack+501164,int_stack+374156,int_stack+247148,1008);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+153692,int_stack+49220,int_stack+47600,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+158552,int_stack+51245,int_stack+49220,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+164627,int_stack+158552,int_stack+153692,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+174347,int_stack+53720,int_stack+51245,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+181772,int_stack+174347,int_stack+158552,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+193922,int_stack+181772,int_stack+164627,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+153692,int_stack+56690,int_stack+53720,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+210122,int_stack+153692,int_stack+174347,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+224972,int_stack+210122,int_stack+181772,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+162602,int_stack+224972,int_stack+193922,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+186902,int_stack+60200,int_stack+56690,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+245222,int_stack+186902,int_stack+153692,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+263042,int_stack+245222,int_stack+210122,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+287792,int_stack+263042,int_stack+224972,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+197432,int_stack+287792,int_stack+162602,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+153692,int_stack+64295,int_stack+60200,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+153692,int_stack+186902,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+153692,int_stack+0,int_stack+245222,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+153692,int_stack+263042,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+153692,int_stack+0,int_stack+287792,45);
 /*--- compute (l0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+0,int_stack+153692,int_stack+197432,45);
 /*--- compute (kp|ki) ---*/
 hrr1_build_kp(Libint->AB,int_stack+153692,int_stack+0,int_stack+337868,1008);
 /*--- compute (id|ki) ---*/
 hrr1_build_id(Libint->AB,int_stack+652364,int_stack+153692,int_stack+69020,1008);
 /*--- compute (hf|ki) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+652364,int_stack+374156,1008);
 /*--- compute (gg|ki) ---*/
 hrr1_build_gg(Libint->AB,int_stack+211680,int_stack+0,int_stack+501164,1008);
 return int_stack+211680;}
