/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggll(Libint_t*, prim_data*);

  /* Computes quartets of (gg|ll) integrals */

REALTYPE *hrr_order_ggll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][8] = int_stack + 0;
 Libint->vrr_classes[4][9] = int_stack + 675;
 Libint->vrr_classes[4][10] = int_stack + 1500;
 Libint->vrr_classes[4][11] = int_stack + 2490;
 Libint->vrr_classes[4][12] = int_stack + 3660;
 Libint->vrr_classes[4][13] = int_stack + 5025;
 Libint->vrr_classes[4][14] = int_stack + 6600;
 Libint->vrr_classes[4][15] = int_stack + 8400;
 Libint->vrr_classes[4][16] = int_stack + 10440;
 Libint->vrr_classes[5][8] = int_stack + 12735;
 Libint->vrr_classes[5][9] = int_stack + 13680;
 Libint->vrr_classes[5][10] = int_stack + 14835;
 Libint->vrr_classes[5][11] = int_stack + 16221;
 Libint->vrr_classes[5][12] = int_stack + 17859;
 Libint->vrr_classes[5][13] = int_stack + 19770;
 Libint->vrr_classes[5][14] = int_stack + 21975;
 Libint->vrr_classes[5][15] = int_stack + 24495;
 Libint->vrr_classes[5][16] = int_stack + 27351;
 Libint->vrr_classes[6][8] = int_stack + 30564;
 Libint->vrr_classes[6][9] = int_stack + 31824;
 Libint->vrr_classes[6][10] = int_stack + 33364;
 Libint->vrr_classes[6][11] = int_stack + 35212;
 Libint->vrr_classes[6][12] = int_stack + 37396;
 Libint->vrr_classes[6][13] = int_stack + 39944;
 Libint->vrr_classes[6][14] = int_stack + 42884;
 Libint->vrr_classes[6][15] = int_stack + 46244;
 Libint->vrr_classes[6][16] = int_stack + 50052;
 Libint->vrr_classes[7][8] = int_stack + 54336;
 Libint->vrr_classes[7][9] = int_stack + 55956;
 Libint->vrr_classes[7][10] = int_stack + 57936;
 Libint->vrr_classes[7][11] = int_stack + 60312;
 Libint->vrr_classes[7][12] = int_stack + 63120;
 Libint->vrr_classes[7][13] = int_stack + 66396;
 Libint->vrr_classes[7][14] = int_stack + 70176;
 Libint->vrr_classes[7][15] = int_stack + 74496;
 Libint->vrr_classes[7][16] = int_stack + 79392;
 Libint->vrr_classes[8][8] = int_stack + 84900;
 Libint->vrr_classes[8][9] = int_stack + 86925;
 Libint->vrr_classes[8][10] = int_stack + 89400;
 Libint->vrr_classes[8][11] = int_stack + 92370;
 Libint->vrr_classes[8][12] = int_stack + 95880;
 Libint->vrr_classes[8][13] = int_stack + 99975;
 Libint->vrr_classes[8][14] = int_stack + 104700;
 Libint->vrr_classes[8][15] = int_stack + 110100;
 Libint->vrr_classes[8][16] = int_stack + 116220;
 memset(int_stack,0,123105*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 123105;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggll(Libint, Data);
   Data++;
 }
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123105,int_stack+675,int_stack+0,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+125130,int_stack+1500,int_stack+675,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+127605,int_stack+125130,int_stack+123105,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131655,int_stack+2490,int_stack+1500,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+134625,int_stack+131655,int_stack+125130,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+139575,int_stack+134625,int_stack+127605,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123105,int_stack+3660,int_stack+2490,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+146325,int_stack+123105,int_stack+131655,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+152265,int_stack+146325,int_stack+134625,15);
 /*--- compute (g0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+126615,int_stack+152265,int_stack+139575,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+136740,int_stack+5025,int_stack+3660,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+160515,int_stack+136740,int_stack+123105,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+167535,int_stack+160515,int_stack+146325,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+177435,int_stack+167535,int_stack+152265,15);
 /*--- compute (g0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+140835,int_stack+177435,int_stack+126615,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+123105,int_stack+6600,int_stack+5025,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+127830,int_stack+123105,int_stack+136740,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+189810,int_stack+127830,int_stack+160515,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+201510,int_stack+189810,int_stack+167535,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+155010,int_stack+201510,int_stack+177435,15);
 /*--- compute (g0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+216360,int_stack+155010,int_stack+140835,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+136020,int_stack+8400,int_stack+6600,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+141420,int_stack+136020,int_stack+123105,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+172335,int_stack+141420,int_stack+127830,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+235260,int_stack+172335,int_stack+189810,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+252810,int_stack+235260,int_stack+201510,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+185985,int_stack+252810,int_stack+155010,15);
 /*--- compute (g0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+273600,int_stack+185985,int_stack+216360,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+123105,int_stack+10440,int_stack+8400,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+150870,int_stack+123105,int_stack+136020,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+123105,int_stack+150870,int_stack+141420,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+138855,int_stack+123105,int_stack+172335,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+159330,int_stack+138855,int_stack+235260,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+123105,int_stack+159330,int_stack+252810,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+150825,int_stack+123105,int_stack+185985,15);
 /*--- compute (g0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+180525,int_stack+150825,int_stack+273600,15);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123105,int_stack+13680,int_stack+12735,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+125940,int_stack+14835,int_stack+13680,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+129405,int_stack+125940,int_stack+123105,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+135075,int_stack+16221,int_stack+14835,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139233,int_stack+135075,int_stack+125940,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+146163,int_stack+139233,int_stack+129405,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123105,int_stack+17859,int_stack+16221,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+155613,int_stack+123105,int_stack+135075,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+163929,int_stack+155613,int_stack+139233,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+128019,int_stack+163929,int_stack+146163,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+142194,int_stack+19770,int_stack+17859,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+210900,int_stack+142194,int_stack+123105,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+220728,int_stack+210900,int_stack+155613,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+234588,int_stack+220728,int_stack+163929,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+147927,int_stack+234588,int_stack+128019,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+123105,int_stack+21975,int_stack+19770,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+129720,int_stack+123105,int_stack+142194,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+251913,int_stack+129720,int_stack+210900,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+268293,int_stack+251913,int_stack+220728,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+289083,int_stack+268293,int_stack+234588,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+210900,int_stack+289083,int_stack+147927,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+237360,int_stack+24495,int_stack+21975,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+141186,int_stack+237360,int_stack+123105,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+154416,int_stack+141186,int_stack+129720,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+313338,int_stack+154416,int_stack+251913,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+337908,int_stack+313338,int_stack+268293,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+244920,int_stack+337908,int_stack+289083,21);
 /*--- compute (h0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+277260,int_stack+244920,int_stack+210900,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+210900,int_stack+27351,int_stack+24495,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+219468,int_stack+210900,int_stack+237360,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+219468,int_stack+141186,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+210900,int_stack+0,int_stack+154416,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+123105,int_stack+210900,int_stack+313338,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+367014,int_stack+123105,int_stack+337908,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+123105,int_stack+367014,int_stack+244920,21);
 /*--- compute (h0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+210900,int_stack+123105,int_stack+277260,21);
 /*--- compute (gp|ll) ---*/
 hrr1_build_gp(Libint->AB,int_stack+253425,int_stack+210900,int_stack+180525,2025);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+123105,int_stack+31824,int_stack+30564,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+126885,int_stack+33364,int_stack+31824,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+131505,int_stack+126885,int_stack+123105,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+139065,int_stack+35212,int_stack+33364,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+144609,int_stack+139065,int_stack+126885,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+153849,int_stack+144609,int_stack+131505,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+123105,int_stack+37396,int_stack+35212,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+166449,int_stack+123105,int_stack+139065,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+177537,int_stack+166449,int_stack+144609,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+129657,int_stack+177537,int_stack+153849,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+148557,int_stack+39944,int_stack+37396,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+192937,int_stack+148557,int_stack+123105,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+344550,int_stack+192937,int_stack+166449,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+363030,int_stack+344550,int_stack+177537,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+156201,int_stack+363030,int_stack+129657,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+123105,int_stack+42884,int_stack+39944,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+131925,int_stack+123105,int_stack+148557,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+131925,int_stack+192937,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+182661,int_stack+0,int_stack+344550,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+386130,int_stack+182661,int_stack+363030,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+344550,int_stack+386130,int_stack+156201,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+147213,int_stack+46244,int_stack+42884,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+157293,int_stack+147213,int_stack+123105,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+418470,int_stack+157293,int_stack+131925,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+443950,int_stack+418470,int_stack+0,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+443950,int_stack+182661,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+476710,int_stack+0,int_stack+386130,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+519830,int_stack+476710,int_stack+344550,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+344550,int_stack+50052,int_stack+46244,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+355974,int_stack+344550,int_stack+147213,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+376134,int_stack+355974,int_stack+157293,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+123105,int_stack+376134,int_stack+418470,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+344550,int_stack+123105,int_stack+443950,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+123105,int_stack+344550,int_stack+0,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+344550,int_stack+123105,int_stack+476710,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+123105,int_stack+344550,int_stack+519830,28);
 /*--- compute (hp|ll) ---*/
 hrr1_build_hp(Libint->AB,int_stack+344550,int_stack+123105,int_stack+210900,2025);
 /*--- compute (gd|ll) ---*/
 hrr1_build_gd(Libint->AB,int_stack+472125,int_stack+344550,int_stack+253425,2025);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+179805,int_stack+55956,int_stack+54336,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+184665,int_stack+57936,int_stack+55956,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+190605,int_stack+184665,int_stack+179805,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+200325,int_stack+60312,int_stack+57936,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+207453,int_stack+200325,int_stack+184665,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+219333,int_stack+207453,int_stack+190605,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+179805,int_stack+63120,int_stack+60312,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+235533,int_stack+179805,int_stack+200325,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+249789,int_stack+235533,int_stack+207453,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+188229,int_stack+249789,int_stack+219333,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+212529,int_stack+66396,int_stack+63120,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+269589,int_stack+212529,int_stack+179805,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+286437,int_stack+269589,int_stack+235533,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+310197,int_stack+286437,int_stack+249789,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+222357,int_stack+310197,int_stack+188229,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+179805,int_stack+70176,int_stack+66396,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+191145,int_stack+179805,int_stack+212529,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+191145,int_stack+269589,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+28080,int_stack+0,int_stack+286437,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+256377,int_stack+28080,int_stack+310197,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+297957,int_stack+256377,int_stack+222357,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+210801,int_stack+74496,int_stack+70176,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+223761,int_stack+210801,int_stack+179805,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+654375,int_stack+223761,int_stack+191145,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+687135,int_stack+654375,int_stack+0,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+729255,int_stack+687135,int_stack+28080,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+729255,int_stack+256377,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+779151,int_stack+0,int_stack+297957,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+55440,int_stack+79392,int_stack+74496,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+179805,int_stack+55440,int_stack+210801,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+246441,int_stack+179805,int_stack+223761,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+179805,int_stack+246441,int_stack+654375,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+228945,int_stack+179805,int_stack+687135,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+654375,int_stack+228945,int_stack+729255,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+179805,int_stack+654375,int_stack+0,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+179805,int_stack+779151,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+654375,int_stack+0,int_stack+123105,2025);
 /*--- compute (hd|ll) ---*/
 hrr1_build_hd(Libint->AB,int_stack+824475,int_stack+654375,int_stack+344550,2025);
 /*--- compute (gf|ll) ---*/
 hrr1_build_gf(Libint->AB,int_stack+123105,int_stack+824475,int_stack+472125,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+426855,int_stack+86925,int_stack+84900,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+432930,int_stack+89400,int_stack+86925,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+440355,int_stack+432930,int_stack+426855,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+452505,int_stack+92370,int_stack+89400,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+461415,int_stack+452505,int_stack+432930,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+476265,int_stack+461415,int_stack+440355,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+426855,int_stack+95880,int_stack+92370,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+496515,int_stack+426855,int_stack+452505,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+514335,int_stack+496515,int_stack+461415,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+437385,int_stack+514335,int_stack+476265,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+467760,int_stack+99975,int_stack+95880,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+539085,int_stack+467760,int_stack+426855,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+560145,int_stack+539085,int_stack+496515,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+589845,int_stack+560145,int_stack+514335,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+480045,int_stack+589845,int_stack+437385,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+426855,int_stack+104700,int_stack+99975,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+441030,int_stack+426855,int_stack+467760,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1079625,int_stack+441030,int_stack+539085,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1114725,int_stack+1079625,int_stack+560145,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+522570,int_stack+1114725,int_stack+589845,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+574545,int_stack+522570,int_stack+480045,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+465600,int_stack+110100,int_stack+104700,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+481800,int_stack+465600,int_stack+426855,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1159275,int_stack+481800,int_stack+441030,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1200225,int_stack+1159275,int_stack+1079625,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1252875,int_stack+1200225,int_stack+1114725,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1079625,int_stack+1252875,int_stack+522570,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1315245,int_stack+1079625,int_stack+574545,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+426855,int_stack+116220,int_stack+110100,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+510150,int_stack+426855,int_stack+465600,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+426855,int_stack+510150,int_stack+481800,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+474105,int_stack+426855,int_stack+1159275,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+535530,int_stack+474105,int_stack+1200225,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+426855,int_stack+535530,int_stack+1252875,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+510015,int_stack+426855,int_stack+1079625,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+1079625,int_stack+510015,int_stack+1315245,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+426855,int_stack+1079625,int_stack+0,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+1079625,int_stack+426855,int_stack+654375,2025);
 /*--- compute (hf|ll) ---*/
 hrr1_build_hf(Libint->AB,int_stack+1419825,int_stack+1079625,int_stack+824475,2025);
 /*--- compute (gg|ll) ---*/
 hrr1_build_gg(Libint->AB,int_stack+426855,int_stack+1419825,int_stack+123105,2025);
 return int_stack+426855;}
