/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ggn0(Libint_t*, prim_data*);

  /* Computes quartets of (gg|n0) integrals */

REALTYPE *hrr_order_ggn0(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][10] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 990;
 Libint->vrr_classes[6][10] = int_stack + 2376;
 Libint->vrr_classes[7][10] = int_stack + 4224;
 Libint->vrr_classes[8][10] = int_stack + 6600;
 memset(int_stack,0,9570*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 9570;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ggn0(Libint, Data);
   Data++;
 }
 /*--- compute (gp|n0) ---*/
 hrr1_build_gp(Libint->AB,int_stack+9570,int_stack+990,int_stack+0,66);
 /*--- compute (hp|n0) ---*/
 hrr1_build_hp(Libint->AB,int_stack+12540,int_stack+2376,int_stack+990,66);
 /*--- compute (gd|n0) ---*/
 hrr1_build_gd(Libint->AB,int_stack+16698,int_stack+12540,int_stack+9570,66);
 /*--- compute (ip|n0) ---*/
 hrr1_build_ip(Libint->AB,int_stack+22638,int_stack+4224,int_stack+2376,66);
 /*--- compute (hd|n0) ---*/
 hrr1_build_hd(Libint->AB,int_stack+28182,int_stack+22638,int_stack+12540,66);
 /*--- compute (gf|n0) ---*/
 hrr1_build_gf(Libint->AB,int_stack+36498,int_stack+28182,int_stack+16698,66);
 /*--- compute (kp|n0) ---*/
 hrr1_build_kp(Libint->AB,int_stack+9570,int_stack+6600,int_stack+4224,66);
 /*--- compute (id|n0) ---*/
 hrr1_build_id(Libint->AB,int_stack+46398,int_stack+9570,int_stack+22638,66);
 /*--- compute (hf|n0) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+46398,int_stack+28182,66);
 /*--- compute (gg|n0) ---*/
 hrr1_build_gg(Libint->AB,int_stack+13860,int_stack+0,int_stack+36498,66);
 return int_stack+13860;}
