/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpih(Libint_t*, prim_data*);

  /* Computes quartets of (gp|ih) integrals */

REALTYPE *hrr_order_gpih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][6] = int_stack + 0;
 Libint->vrr_classes[4][7] = int_stack + 420;
 Libint->vrr_classes[4][8] = int_stack + 960;
 Libint->vrr_classes[4][9] = int_stack + 1635;
 Libint->vrr_classes[4][10] = int_stack + 2460;
 Libint->vrr_classes[4][11] = int_stack + 3450;
 Libint->vrr_classes[5][6] = int_stack + 4620;
 Libint->vrr_classes[5][7] = int_stack + 5208;
 Libint->vrr_classes[5][8] = int_stack + 5964;
 Libint->vrr_classes[5][9] = int_stack + 6909;
 Libint->vrr_classes[5][10] = int_stack + 8064;
 Libint->vrr_classes[5][11] = int_stack + 9450;
 memset(int_stack,0,11088*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11088;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpih(Libint, Data);
   Data++;
 }
 /*--- compute (g0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11088,int_stack+420,int_stack+0,15);
 /*--- compute (g0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12348,int_stack+960,int_stack+420,15);
 /*--- compute (g0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+13968,int_stack+12348,int_stack+11088,15);
 /*--- compute (g0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16488,int_stack+1635,int_stack+960,15);
 /*--- compute (g0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+18513,int_stack+16488,int_stack+12348,15);
 /*--- compute (g0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+21753,int_stack+18513,int_stack+13968,15);
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+11088,int_stack+2460,int_stack+1635,15);
 /*--- compute (g0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+25953,int_stack+11088,int_stack+16488,15);
 /*--- compute (g0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+30003,int_stack+25953,int_stack+18513,15);
 /*--- compute (g0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+13563,int_stack+30003,int_stack+21753,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19863,int_stack+3450,int_stack+2460,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+35403,int_stack+19863,int_stack+11088,15);
 /*--- compute (g0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+40353,int_stack+35403,int_stack+25953,15);
 /*--- compute (g0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+19863,int_stack+40353,int_stack+30003,15);
 /*--- compute (g0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+27963,int_stack+19863,int_stack+13563,15);
 /*--- compute (h0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+11088,int_stack+5208,int_stack+4620,21);
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+12852,int_stack+5964,int_stack+5208,21);
 /*--- compute (h0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+15120,int_stack+12852,int_stack+11088,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+18648,int_stack+6909,int_stack+5964,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+21483,int_stack+18648,int_stack+12852,21);
 /*--- compute (h0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+36783,int_stack+21483,int_stack+15120,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+11088,int_stack+8064,int_stack+6909,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+11088,int_stack+18648,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+42663,int_stack+0,int_stack+21483,21);
 /*--- compute (h0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+14553,int_stack+42663,int_stack+36783,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+36783,int_stack+9450,int_stack+8064,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+50223,int_stack+36783,int_stack+11088,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+57153,int_stack+50223,int_stack+0,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+57153,int_stack+42663,21);
 /*--- compute (h0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+36783,int_stack+0,int_stack+14553,21);
 /*--- compute (gp|ih) ---*/
 hrr1_build_gp(Libint->AB,int_stack+0,int_stack+36783,int_stack+27963,588);
 return int_stack+0;}
