/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_gpmk(Libint_t*, prim_data*);

  /* Computes quartets of (gp|mk) integrals */

REALTYPE *hrr_order_gpmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[4][9] = int_stack + 0;
 Libint->vrr_classes[4][10] = int_stack + 825;
 Libint->vrr_classes[4][11] = int_stack + 1815;
 Libint->vrr_classes[4][12] = int_stack + 2985;
 Libint->vrr_classes[4][13] = int_stack + 4350;
 Libint->vrr_classes[4][14] = int_stack + 5925;
 Libint->vrr_classes[4][15] = int_stack + 7725;
 Libint->vrr_classes[4][16] = int_stack + 9765;
 Libint->vrr_classes[5][9] = int_stack + 12060;
 Libint->vrr_classes[5][10] = int_stack + 13215;
 Libint->vrr_classes[5][11] = int_stack + 14601;
 Libint->vrr_classes[5][12] = int_stack + 16239;
 Libint->vrr_classes[5][13] = int_stack + 18150;
 Libint->vrr_classes[5][14] = int_stack + 20355;
 Libint->vrr_classes[5][15] = int_stack + 22875;
 Libint->vrr_classes[5][16] = int_stack + 25731;
 memset(int_stack,0,28944*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 28944;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_gpmk(Libint, Data);
   Data++;
 }
 /*--- compute (g0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28944,int_stack+825,int_stack+0,15);
 /*--- compute (g0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31419,int_stack+1815,int_stack+825,15);
 /*--- compute (g0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+34389,int_stack+31419,int_stack+28944,15);
 /*--- compute (g0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+39339,int_stack+2985,int_stack+1815,15);
 /*--- compute (g0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+42849,int_stack+39339,int_stack+31419,15);
 /*--- compute (g0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+48789,int_stack+42849,int_stack+34389,15);
 /*--- compute (g0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+28944,int_stack+4350,int_stack+2985,15);
 /*--- compute (g0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+57039,int_stack+28944,int_stack+39339,15);
 /*--- compute (g0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+64059,int_stack+57039,int_stack+42849,15);
 /*--- compute (g0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+33039,int_stack+64059,int_stack+48789,15);
 /*--- compute (g0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+45414,int_stack+5925,int_stack+4350,15);
 /*--- compute (g0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+73959,int_stack+45414,int_stack+28944,15);
 /*--- compute (g0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+82149,int_stack+73959,int_stack+57039,15);
 /*--- compute (g0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+93849,int_stack+82149,int_stack+64059,15);
 /*--- compute (g0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+50139,int_stack+93849,int_stack+33039,15);
 /*--- compute (g0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+28944,int_stack+7725,int_stack+5925,15);
 /*--- compute (g0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+34344,int_stack+28944,int_stack+45414,15);
 /*--- compute (g0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+108699,int_stack+34344,int_stack+73959,15);
 /*--- compute (g0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+122349,int_stack+108699,int_stack+82149,15);
 /*--- compute (g0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+67464,int_stack+122349,int_stack+93849,15);
 /*--- compute (g0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+139899,int_stack+67464,int_stack+50139,15);
 /*--- compute (g0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+43794,int_stack+9765,int_stack+7725,15);
 /*--- compute (g0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+49914,int_stack+43794,int_stack+28944,15);
 /*--- compute (g0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+88254,int_stack+49914,int_stack+34344,15);
 /*--- compute (g0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+28944,int_stack+88254,int_stack+108699,15);
 /*--- compute (g0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+88254,int_stack+28944,int_stack+122349,15);
 /*--- compute (g0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+28944,int_stack+88254,int_stack+67464,15);
 /*--- compute (g0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+56664,int_stack+28944,int_stack+139899,15);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+28944,int_stack+13215,int_stack+12060,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+32409,int_stack+14601,int_stack+13215,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+36567,int_stack+32409,int_stack+28944,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43497,int_stack+16239,int_stack+14601,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+86364,int_stack+43497,int_stack+32409,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+94680,int_stack+86364,int_stack+36567,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+28944,int_stack+18150,int_stack+16239,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+106230,int_stack+28944,int_stack+43497,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+34677,int_stack+106230,int_stack+86364,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+116058,int_stack+34677,int_stack+94680,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+86364,int_stack+20355,int_stack+18150,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+92979,int_stack+86364,int_stack+28944,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+133383,int_stack+92979,int_stack+106230,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+149763,int_stack+133383,int_stack+34677,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+28944,int_stack+149763,int_stack+116058,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+104445,int_stack+22875,int_stack+20355,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+112005,int_stack+104445,int_stack+86364,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+112005,int_stack+92979,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+170553,int_stack+0,int_stack+133383,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+195123,int_stack+170553,int_stack+149763,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+125235,int_stack+195123,int_stack+28944,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+28944,int_stack+25731,int_stack+22875,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37512,int_stack+28944,int_stack+104445,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+86364,int_stack+37512,int_stack+112005,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+19110,int_stack+86364,int_stack+0,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+86364,int_stack+19110,int_stack+170553,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+86364,int_stack+195123,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+157575,int_stack+0,int_stack+125235,21);
 /*--- compute (gp|mk) ---*/
 hrr1_build_gp(Libint->AB,int_stack+199155,int_stack+157575,int_stack+56664,1980);
 return int_stack+199155;}
