/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdkd(Libint_t*, prim_data*);

  /* Computes quartets of (hd|kd) integrals */

REALTYPE *hrr_order_hdkd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[6][7] = int_stack + 2856;
 Libint->vrr_classes[6][8] = int_stack + 3864;
 Libint->vrr_classes[6][9] = int_stack + 5124;
 Libint->vrr_classes[7][7] = int_stack + 6664;
 Libint->vrr_classes[7][8] = int_stack + 7960;
 Libint->vrr_classes[7][9] = int_stack + 9580;
 memset(int_stack,0,11560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 11560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdkd(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11560,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+13828,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16663,int_stack+13828,int_stack+11560,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11560,int_stack+3864,int_stack+2856,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+5124,int_stack+3864,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+21199,int_stack+0,int_stack+11560,28);
 /*--- compute (hp|kd) ---*/
 hrr1_build_hp(Libint->AB,int_stack+27247,int_stack+21199,int_stack+16663,216);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+11560,int_stack+7960,int_stack+6664,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+15448,int_stack+9580,int_stack+7960,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+0,int_stack+15448,int_stack+11560,36);
 /*--- compute (ip|kd) ---*/
 hrr1_build_ip(Libint->AB,int_stack+40855,int_stack+0,int_stack+21199,216);
 /*--- compute (hd|kd) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+40855,int_stack+27247,216);
 return int_stack+0;}
