/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdkk(Libint_t*, prim_data*);

  /* Computes quartets of (hd|kk) integrals */

REALTYPE *hrr_order_hdkk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][7] = int_stack + 0;
 Libint->vrr_classes[5][8] = int_stack + 756;
 Libint->vrr_classes[5][9] = int_stack + 1701;
 Libint->vrr_classes[5][10] = int_stack + 2856;
 Libint->vrr_classes[5][11] = int_stack + 4242;
 Libint->vrr_classes[5][12] = int_stack + 5880;
 Libint->vrr_classes[5][13] = int_stack + 7791;
 Libint->vrr_classes[5][14] = int_stack + 9996;
 Libint->vrr_classes[6][7] = int_stack + 12516;
 Libint->vrr_classes[6][8] = int_stack + 13524;
 Libint->vrr_classes[6][9] = int_stack + 14784;
 Libint->vrr_classes[6][10] = int_stack + 16324;
 Libint->vrr_classes[6][11] = int_stack + 18172;
 Libint->vrr_classes[6][12] = int_stack + 20356;
 Libint->vrr_classes[6][13] = int_stack + 22904;
 Libint->vrr_classes[6][14] = int_stack + 25844;
 Libint->vrr_classes[7][7] = int_stack + 29204;
 Libint->vrr_classes[7][8] = int_stack + 30500;
 Libint->vrr_classes[7][9] = int_stack + 32120;
 Libint->vrr_classes[7][10] = int_stack + 34100;
 Libint->vrr_classes[7][11] = int_stack + 36476;
 Libint->vrr_classes[7][12] = int_stack + 39284;
 Libint->vrr_classes[7][13] = int_stack + 42560;
 Libint->vrr_classes[7][14] = int_stack + 46340;
 memset(int_stack,0,50660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 50660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdkk(Libint, Data);
   Data++;
 }
 /*--- compute (h0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+50660,int_stack+756,int_stack+0,21);
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+52928,int_stack+1701,int_stack+756,21);
 /*--- compute (h0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+55763,int_stack+52928,int_stack+50660,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+60299,int_stack+2856,int_stack+1701,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+63764,int_stack+60299,int_stack+52928,21);
 /*--- compute (h0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+69434,int_stack+63764,int_stack+55763,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50660,int_stack+4242,int_stack+2856,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+76994,int_stack+50660,int_stack+60299,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83924,int_stack+76994,int_stack+63764,21);
 /*--- compute (h0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+54818,int_stack+83924,int_stack+69434,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66158,int_stack+5880,int_stack+4242,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+93374,int_stack+66158,int_stack+50660,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+101690,int_stack+93374,int_stack+76994,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+113240,int_stack+101690,int_stack+83924,21);
 /*--- compute (h0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+71072,int_stack+113240,int_stack+54818,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+50660,int_stack+7791,int_stack+5880,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+127415,int_stack+50660,int_stack+66158,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56393,int_stack+127415,int_stack+93374,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+137243,int_stack+56393,int_stack+101690,21);
 /*--- compute (h0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+86948,int_stack+137243,int_stack+113240,21);
 /*--- compute (h0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+154568,int_stack+86948,int_stack+71072,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+70253,int_stack+9996,int_stack+7791,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+106793,int_stack+70253,int_stack+50660,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+70253,int_stack+106793,int_stack+127415,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+106793,int_stack+70253,int_stack+56393,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+50660,int_stack+106793,int_stack+137243,21);
 /*--- compute (h0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+106793,int_stack+50660,int_stack+86948,21);
 /*--- compute (h0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+50660,int_stack+106793,int_stack+154568,21);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+77876,int_stack+13524,int_stack+12516,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+80900,int_stack+14784,int_stack+13524,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+84680,int_stack+80900,int_stack+77876,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+90728,int_stack+16324,int_stack+14784,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+95348,int_stack+90728,int_stack+80900,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+102908,int_stack+95348,int_stack+84680,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+77876,int_stack+18172,int_stack+16324,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+112988,int_stack+77876,int_stack+90728,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+122228,int_stack+112988,int_stack+95348,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+83420,int_stack+122228,int_stack+102908,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+98540,int_stack+20356,int_stack+18172,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+134828,int_stack+98540,int_stack+77876,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+145916,int_stack+134828,int_stack+112988,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+145916,int_stack+122228,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+105092,int_stack+0,int_stack+83420,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+77876,int_stack+22904,int_stack+20356,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+161316,int_stack+77876,int_stack+98540,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+85520,int_stack+161316,int_stack+134828,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+174420,int_stack+85520,int_stack+145916,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+126260,int_stack+174420,int_stack+0,28);
 /*--- compute (i0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+197520,int_stack+126260,int_stack+105092,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+25844,int_stack+22904,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+8820,int_stack+0,int_stack+77876,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+104000,int_stack+8820,int_stack+161316,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+104000,int_stack+85520,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+77876,int_stack+0,int_stack+174420,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+152720,int_stack+77876,int_stack+126260,28);
 /*--- compute (i0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+77876,int_stack+152720,int_stack+197520,28);
 /*--- compute (hp|kk) ---*/
 hrr1_build_hp(Libint->AB,int_stack+114164,int_stack+77876,int_stack+50660,1296);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+50660,int_stack+30500,int_stack+29204,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+54548,int_stack+32120,int_stack+30500,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+59408,int_stack+54548,int_stack+50660,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+67184,int_stack+34100,int_stack+32120,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+195812,int_stack+67184,int_stack+54548,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+205532,int_stack+195812,int_stack+59408,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+50660,int_stack+36476,int_stack+34100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+50660,int_stack+67184,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+57788,int_stack+0,int_stack+195812,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+11880,int_stack+57788,int_stack+205532,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195812,int_stack+39284,int_stack+36476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+204236,int_stack+195812,int_stack+50660,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+218492,int_stack+204236,int_stack+0,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+238292,int_stack+218492,int_stack+57788,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+50660,int_stack+238292,int_stack+11880,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+42560,int_stack+39284,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+9828,int_stack+0,int_stack+195812,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+262592,int_stack+9828,int_stack+204236,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+286352,int_stack+262592,int_stack+218492,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+195812,int_stack+286352,int_stack+238292,36);
 /*--- compute (k0|ki) ---*/
 hrr3_build_ki(Libint->CD,int_stack+316052,int_stack+195812,int_stack+50660,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+50660,int_stack+46340,int_stack+42560,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+229832,int_stack+50660,int_stack+0,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+26676,int_stack+229832,int_stack+9828,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+352340,int_stack+26676,int_stack+262592,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+229832,int_stack+352340,int_stack+286352,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+0,int_stack+229832,int_stack+195812,36);
 /*--- compute (k0|kk) ---*/
 hrr3_build_kk(Libint->CD,int_stack+195812,int_stack+0,int_stack+316052,36);
 /*--- compute (ip|kk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+242468,int_stack+195812,int_stack+77876,1296);
 /*--- compute (hd|kk) ---*/
 hrr1_build_hd(Libint->AB,int_stack+351332,int_stack+242468,int_stack+114164,1296);
 return int_stack+351332;}
