/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hdng(Libint_t*, prim_data*);

  /* Computes quartets of (hd|ng) integrals */

REALTYPE *hrr_order_hdng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[6][10] = int_stack + 9660;
 Libint->vrr_classes[6][11] = int_stack + 11508;
 Libint->vrr_classes[6][12] = int_stack + 13692;
 Libint->vrr_classes[6][13] = int_stack + 16240;
 Libint->vrr_classes[6][14] = int_stack + 19180;
 Libint->vrr_classes[7][10] = int_stack + 22540;
 Libint->vrr_classes[7][11] = int_stack + 24916;
 Libint->vrr_classes[7][12] = int_stack + 27724;
 Libint->vrr_classes[7][13] = int_stack + 31000;
 Libint->vrr_classes[7][14] = int_stack + 34780;
 memset(int_stack,0,39100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 39100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hdng(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39100,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43258,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48172,int_stack+43258,int_stack+39100,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+56488,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+62221,int_stack+56488,int_stack+43258,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+72049,int_stack+62221,int_stack+48172,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39100,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+85909,int_stack+39100,int_stack+56488,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+39100,int_stack+85909,int_stack+62221,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+85909,int_stack+39100,int_stack+72049,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39100,int_stack+11508,int_stack+9660,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44644,int_stack+13692,int_stack+11508,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51196,int_stack+44644,int_stack+39100,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62284,int_stack+16240,int_stack+13692,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+69928,int_stack+62284,int_stack+44644,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+106699,int_stack+69928,int_stack+51196,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39100,int_stack+19180,int_stack+16240,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+39100,int_stack+62284,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+39100,int_stack+0,int_stack+69928,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+125179,int_stack+39100,int_stack+106699,28);
 /*--- compute (hp|ng) ---*/
 hrr1_build_hp(Libint->AB,int_stack+152899,int_stack+125179,int_stack+85909,990);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+39100,int_stack+24916,int_stack+22540,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+46228,int_stack+27724,int_stack+24916,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+54652,int_stack+46228,int_stack+39100,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+68908,int_stack+31000,int_stack+27724,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+78736,int_stack+68908,int_stack+46228,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+95584,int_stack+78736,int_stack+54652,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+39100,int_stack+34780,int_stack+31000,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+39100,int_stack+68908,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+19656,int_stack+0,int_stack+78736,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+47736,int_stack+19656,int_stack+95584,36);
 /*--- compute (ip|ng) ---*/
 hrr1_build_ip(Libint->AB,int_stack+215269,int_stack+47736,int_stack+125179,990);
 /*--- compute (hd|ng) ---*/
 hrr1_build_hd(Libint->AB,int_stack+0,int_stack+215269,int_stack+152899,990);
 return int_stack+0;}
