/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hflg(Libint_t*, prim_data*);

  /* Computes quartets of (hf|lg) integrals */

REALTYPE *hrr_order_hflg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][8] = int_stack + 0;
 Libint->vrr_classes[5][9] = int_stack + 945;
 Libint->vrr_classes[5][10] = int_stack + 2100;
 Libint->vrr_classes[5][11] = int_stack + 3486;
 Libint->vrr_classes[5][12] = int_stack + 5124;
 Libint->vrr_classes[6][8] = int_stack + 7035;
 Libint->vrr_classes[6][9] = int_stack + 8295;
 Libint->vrr_classes[6][10] = int_stack + 9835;
 Libint->vrr_classes[6][11] = int_stack + 11683;
 Libint->vrr_classes[6][12] = int_stack + 13867;
 Libint->vrr_classes[7][8] = int_stack + 16415;
 Libint->vrr_classes[7][9] = int_stack + 18035;
 Libint->vrr_classes[7][10] = int_stack + 20015;
 Libint->vrr_classes[7][11] = int_stack + 22391;
 Libint->vrr_classes[7][12] = int_stack + 25199;
 Libint->vrr_classes[8][8] = int_stack + 28475;
 Libint->vrr_classes[8][9] = int_stack + 30500;
 Libint->vrr_classes[8][10] = int_stack + 32975;
 Libint->vrr_classes[8][11] = int_stack + 35945;
 Libint->vrr_classes[8][12] = int_stack + 39455;
 memset(int_stack,0,43550*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 43550;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hflg(Libint, Data);
   Data++;
 }
 /*--- compute (h0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43550,int_stack+945,int_stack+0,21);
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+46385,int_stack+2100,int_stack+945,21);
 /*--- compute (h0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+49850,int_stack+46385,int_stack+43550,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+55520,int_stack+3486,int_stack+2100,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+59678,int_stack+55520,int_stack+46385,21);
 /*--- compute (h0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+66608,int_stack+59678,int_stack+49850,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43550,int_stack+5124,int_stack+3486,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+76058,int_stack+43550,int_stack+55520,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+43550,int_stack+76058,int_stack+59678,21);
 /*--- compute (h0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+76058,int_stack+43550,int_stack+66608,21);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43550,int_stack+8295,int_stack+7035,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47330,int_stack+9835,int_stack+8295,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+51950,int_stack+47330,int_stack+43550,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+59510,int_stack+11683,int_stack+9835,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+65054,int_stack+59510,int_stack+47330,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+90233,int_stack+65054,int_stack+51950,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43550,int_stack+13867,int_stack+11683,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+43550,int_stack+59510,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+43550,int_stack+0,int_stack+65054,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+102833,int_stack+43550,int_stack+90233,28);
 /*--- compute (hp|lg) ---*/
 hrr1_build_hp(Libint->AB,int_stack+121733,int_stack+102833,int_stack+76058,675);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43550,int_stack+18035,int_stack+16415,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+48410,int_stack+20015,int_stack+18035,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54350,int_stack+48410,int_stack+43550,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+64070,int_stack+22391,int_stack+20015,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+71198,int_stack+64070,int_stack+48410,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+83078,int_stack+71198,int_stack+54350,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+43550,int_stack+25199,int_stack+22391,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+43550,int_stack+64070,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+43550,int_stack+0,int_stack+71198,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+0,int_stack+43550,int_stack+83078,36);
 /*--- compute (ip|lg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+43550,int_stack+0,int_stack+102833,675);
 /*--- compute (hd|lg) ---*/
 hrr1_build_hd(Libint->AB,int_stack+164258,int_stack+43550,int_stack+121733,675);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+100250,int_stack+30500,int_stack+28475,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+106325,int_stack+32975,int_stack+30500,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+113750,int_stack+106325,int_stack+100250,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+125900,int_stack+35945,int_stack+32975,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+134810,int_stack+125900,int_stack+106325,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+249308,int_stack+134810,int_stack+113750,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+100250,int_stack+39455,int_stack+35945,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+24300,int_stack+100250,int_stack+125900,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+100250,int_stack+24300,int_stack+134810,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+125000,int_stack+100250,int_stack+249308,45);
 /*--- compute (kp|lg) ---*/
 hrr1_build_kp(Libint->AB,int_stack+249308,int_stack+125000,int_stack+0,675);
 /*--- compute (id|lg) ---*/
 hrr1_build_id(Libint->AB,int_stack+322208,int_stack+249308,int_stack+43550,675);
 /*--- compute (hf|lg) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+322208,int_stack+164258,675);
 return int_stack+0;}
