/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfmi(Libint_t*, prim_data*);

  /* Computes quartets of (hf|mi) integrals */

REALTYPE *hrr_order_hfmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[6][9] = int_stack + 13671;
 Libint->vrr_classes[6][10] = int_stack + 15211;
 Libint->vrr_classes[6][11] = int_stack + 17059;
 Libint->vrr_classes[6][12] = int_stack + 19243;
 Libint->vrr_classes[6][13] = int_stack + 21791;
 Libint->vrr_classes[6][14] = int_stack + 24731;
 Libint->vrr_classes[6][15] = int_stack + 28091;
 Libint->vrr_classes[7][9] = int_stack + 31899;
 Libint->vrr_classes[7][10] = int_stack + 33879;
 Libint->vrr_classes[7][11] = int_stack + 36255;
 Libint->vrr_classes[7][12] = int_stack + 39063;
 Libint->vrr_classes[7][13] = int_stack + 42339;
 Libint->vrr_classes[7][14] = int_stack + 46119;
 Libint->vrr_classes[7][15] = int_stack + 50439;
 Libint->vrr_classes[8][9] = int_stack + 55335;
 Libint->vrr_classes[8][10] = int_stack + 57810;
 Libint->vrr_classes[8][11] = int_stack + 60780;
 Libint->vrr_classes[8][12] = int_stack + 64290;
 Libint->vrr_classes[8][13] = int_stack + 68385;
 Libint->vrr_classes[8][14] = int_stack + 73110;
 Libint->vrr_classes[8][15] = int_stack + 78510;
 memset(int_stack,0,84630*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 84630;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfmi(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+84630,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+88095,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+92253,int_stack+88095,int_stack+84630,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+99183,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+104097,int_stack+99183,int_stack+88095,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+112413,int_stack+104097,int_stack+92253,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+84630,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+123963,int_stack+84630,int_stack+99183,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+133791,int_stack+123963,int_stack+104097,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+90363,int_stack+133791,int_stack+112413,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+107688,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+147651,int_stack+107688,int_stack+84630,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+159117,int_stack+147651,int_stack+123963,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+175497,int_stack+159117,int_stack+133791,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+114303,int_stack+175497,int_stack+90363,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+84630,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+92190,int_stack+84630,int_stack+107688,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+196287,int_stack+92190,int_stack+147651,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+84630,int_stack+196287,int_stack+159117,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+138558,int_stack+84630,int_stack+175497,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+167664,int_stack+138558,int_stack+114303,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+84630,int_stack+15211,int_stack+13671,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+89250,int_stack+17059,int_stack+15211,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+94794,int_stack+89250,int_stack+84630,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104034,int_stack+19243,int_stack+17059,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+110586,int_stack+104034,int_stack+89250,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+121674,int_stack+110586,int_stack+94794,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+84630,int_stack+21791,int_stack+19243,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+137074,int_stack+84630,int_stack+104034,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+137074,int_stack+110586,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+92274,int_stack+0,int_stack+121674,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115374,int_stack+24731,int_stack+21791,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+150178,int_stack+115374,int_stack+84630,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+200004,int_stack+150178,int_stack+137074,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+221844,int_stack+200004,int_stack+0,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+249564,int_stack+221844,int_stack+92274,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+28091,int_stack+24731,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+10080,int_stack+0,int_stack+115374,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+84630,int_stack+10080,int_stack+150178,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+110110,int_stack+84630,int_stack+200004,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+281904,int_stack+110110,int_stack+221844,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+200004,int_stack+281904,int_stack+249564,28);
 /*--- compute (hp|mi) ---*/
 hrr1_build_hp(Libint->AB,int_stack+243124,int_stack+200004,int_stack+167664,1540);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+84630,int_stack+33879,int_stack+31899,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+90570,int_stack+36255,int_stack+33879,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+97698,int_stack+90570,int_stack+84630,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+109578,int_stack+39063,int_stack+36255,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+118002,int_stack+109578,int_stack+90570,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+132258,int_stack+118002,int_stack+97698,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+84630,int_stack+42339,int_stack+39063,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+152058,int_stack+84630,int_stack+109578,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+168906,int_stack+152058,int_stack+118002,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+94458,int_stack+168906,int_stack+132258,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+124158,int_stack+46119,int_stack+42339,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+124158,int_stack+84630,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+340144,int_stack+0,int_stack+152058,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+368224,int_stack+340144,int_stack+168906,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+135498,int_stack+368224,int_stack+94458,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+84630,int_stack+50439,int_stack+46119,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+97590,int_stack+84630,int_stack+124158,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+19656,int_stack+97590,int_stack+0,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+84630,int_stack+19656,int_stack+340144,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+84630,int_stack+368224,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+340144,int_stack+0,int_stack+135498,36);
 /*--- compute (ip|mi) ---*/
 hrr1_build_ip(Libint->AB,int_stack+395584,int_stack+340144,int_stack+200004,1540);
 /*--- compute (hd|mi) ---*/
 hrr1_build_hd(Libint->AB,int_stack+524944,int_stack+395584,int_stack+243124,1540);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+57810,int_stack+55335,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+60780,int_stack+57810,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31185,int_stack+64290,int_stack+60780,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41715,int_stack+31185,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84630,int_stack+41715,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+68385,int_stack+64290,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+109380,int_stack+0,int_stack+31185,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+130440,int_stack+109380,int_stack+41715,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12285,int_stack+130440,int_stack+84630,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+84630,int_stack+73110,int_stack+68385,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+160140,int_stack+84630,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+184710,int_stack+160140,int_stack+109380,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+219810,int_stack+184710,int_stack+130440,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+98805,int_stack+219810,int_stack+12285,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+78510,int_stack+73110,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+16200,int_stack+0,int_stack+84630,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+44550,int_stack+16200,int_stack+160140,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+264360,int_stack+44550,int_stack+184710,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+264360,int_stack+219810,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+150780,int_stack+0,int_stack+98805,45);
 /*--- compute (kp|mi) ---*/
 hrr1_build_kp(Libint->AB,int_stack+718984,int_stack+150780,int_stack+340144,1540);
 /*--- compute (id|mi) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+718984,int_stack+395584,1540);
 /*--- compute (hf|mi) ---*/
 hrr1_build_hf(Libint->AB,int_stack+718984,int_stack+0,int_stack+524944,1540);
 return int_stack+718984;}
