/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hfml(Libint_t*, prim_data*);

  /* Computes quartets of (hf|ml) integrals */

REALTYPE *hrr_order_hfml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][9] = int_stack + 0;
 Libint->vrr_classes[5][10] = int_stack + 1155;
 Libint->vrr_classes[5][11] = int_stack + 2541;
 Libint->vrr_classes[5][12] = int_stack + 4179;
 Libint->vrr_classes[5][13] = int_stack + 6090;
 Libint->vrr_classes[5][14] = int_stack + 8295;
 Libint->vrr_classes[5][15] = int_stack + 10815;
 Libint->vrr_classes[5][16] = int_stack + 13671;
 Libint->vrr_classes[5][17] = int_stack + 16884;
 Libint->vrr_classes[6][9] = int_stack + 20475;
 Libint->vrr_classes[6][10] = int_stack + 22015;
 Libint->vrr_classes[6][11] = int_stack + 23863;
 Libint->vrr_classes[6][12] = int_stack + 26047;
 Libint->vrr_classes[6][13] = int_stack + 28595;
 Libint->vrr_classes[6][14] = int_stack + 31535;
 Libint->vrr_classes[6][15] = int_stack + 34895;
 Libint->vrr_classes[6][16] = int_stack + 38703;
 Libint->vrr_classes[6][17] = int_stack + 42987;
 Libint->vrr_classes[7][9] = int_stack + 47775;
 Libint->vrr_classes[7][10] = int_stack + 49755;
 Libint->vrr_classes[7][11] = int_stack + 52131;
 Libint->vrr_classes[7][12] = int_stack + 54939;
 Libint->vrr_classes[7][13] = int_stack + 58215;
 Libint->vrr_classes[7][14] = int_stack + 61995;
 Libint->vrr_classes[7][15] = int_stack + 66315;
 Libint->vrr_classes[7][16] = int_stack + 71211;
 Libint->vrr_classes[7][17] = int_stack + 76719;
 Libint->vrr_classes[8][9] = int_stack + 82875;
 Libint->vrr_classes[8][10] = int_stack + 85350;
 Libint->vrr_classes[8][11] = int_stack + 88320;
 Libint->vrr_classes[8][12] = int_stack + 91830;
 Libint->vrr_classes[8][13] = int_stack + 95925;
 Libint->vrr_classes[8][14] = int_stack + 100650;
 Libint->vrr_classes[8][15] = int_stack + 106050;
 Libint->vrr_classes[8][16] = int_stack + 112170;
 Libint->vrr_classes[8][17] = int_stack + 119055;
 memset(int_stack,0,126750*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 126750;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hfml(Libint, Data);
   Data++;
 }
 /*--- compute (h0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+126750,int_stack+1155,int_stack+0,21);
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+130215,int_stack+2541,int_stack+1155,21);
 /*--- compute (h0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+134373,int_stack+130215,int_stack+126750,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+141303,int_stack+4179,int_stack+2541,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+146217,int_stack+141303,int_stack+130215,21);
 /*--- compute (h0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+154533,int_stack+146217,int_stack+134373,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126750,int_stack+6090,int_stack+4179,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+166083,int_stack+126750,int_stack+141303,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+175911,int_stack+166083,int_stack+146217,21);
 /*--- compute (h0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+132483,int_stack+175911,int_stack+154533,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149808,int_stack+8295,int_stack+6090,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+189771,int_stack+149808,int_stack+126750,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+201237,int_stack+189771,int_stack+166083,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+217617,int_stack+201237,int_stack+175911,21);
 /*--- compute (h0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+156423,int_stack+217617,int_stack+132483,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+126750,int_stack+10815,int_stack+8295,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+134310,int_stack+126750,int_stack+149808,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+238407,int_stack+134310,int_stack+189771,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+257517,int_stack+238407,int_stack+201237,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+180678,int_stack+257517,int_stack+217617,21);
 /*--- compute (h0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+282087,int_stack+180678,int_stack+156423,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+147540,int_stack+13671,int_stack+10815,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+156108,int_stack+147540,int_stack+126750,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+209784,int_stack+156108,int_stack+134310,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+314427,int_stack+209784,int_stack+238407,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+343092,int_stack+314427,int_stack+257517,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+231834,int_stack+343092,int_stack+180678,21);
 /*--- compute (h0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+377490,int_stack+231834,int_stack+282087,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+126750,int_stack+16884,int_stack+13671,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+171228,int_stack+126750,int_stack+147540,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+126750,int_stack+171228,int_stack+156108,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+151950,int_stack+126750,int_stack+209784,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+185025,int_stack+151950,int_stack+314427,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+126750,int_stack+185025,int_stack+343092,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+172614,int_stack+126750,int_stack+231834,21);
 /*--- compute (h0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+222510,int_stack+172614,int_stack+377490,21);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+126750,int_stack+22015,int_stack+20475,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131370,int_stack+23863,int_stack+22015,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+136914,int_stack+131370,int_stack+126750,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+146154,int_stack+26047,int_stack+23863,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+152706,int_stack+146154,int_stack+131370,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+163794,int_stack+152706,int_stack+136914,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126750,int_stack+28595,int_stack+26047,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+179194,int_stack+126750,int_stack+146154,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+192298,int_stack+179194,int_stack+152706,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+134394,int_stack+192298,int_stack+163794,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+157494,int_stack+31535,int_stack+28595,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+274485,int_stack+157494,int_stack+126750,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+289773,int_stack+274485,int_stack+179194,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+311613,int_stack+289773,int_stack+192298,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+166314,int_stack+311613,int_stack+134394,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+126750,int_stack+34895,int_stack+31535,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+136830,int_stack+126750,int_stack+157494,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+339333,int_stack+136830,int_stack+274485,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+364813,int_stack+339333,int_stack+289773,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+397573,int_stack+364813,int_stack+311613,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+274485,int_stack+397573,int_stack+166314,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+317605,int_stack+38703,int_stack+34895,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+154470,int_stack+317605,int_stack+126750,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+174630,int_stack+154470,int_stack+136830,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+174630,int_stack+339333,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+436381,int_stack+0,int_stack+364813,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+329029,int_stack+436381,int_stack+397573,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+380773,int_stack+329029,int_stack+274485,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+274485,int_stack+42987,int_stack+38703,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+287337,int_stack+274485,int_stack+317605,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+482245,int_stack+287337,int_stack+154470,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+274485,int_stack+482245,int_stack+174630,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+126750,int_stack+274485,int_stack+0,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+482245,int_stack+126750,int_stack+436381,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+126750,int_stack+482245,int_stack+329029,28);
 /*--- compute (i0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+274485,int_stack+126750,int_stack+380773,28);
 /*--- compute (hp|ml) ---*/
 hrr1_build_hp(Libint->AB,int_stack+343785,int_stack+274485,int_stack+222510,2475);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+126750,int_stack+49755,int_stack+47775,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+132690,int_stack+52131,int_stack+49755,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+139818,int_stack+132690,int_stack+126750,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+151698,int_stack+54939,int_stack+52131,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+160122,int_stack+151698,int_stack+132690,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+174378,int_stack+160122,int_stack+139818,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126750,int_stack+58215,int_stack+54939,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+194178,int_stack+126750,int_stack+151698,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+211026,int_stack+194178,int_stack+160122,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+136578,int_stack+211026,int_stack+174378,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+166278,int_stack+61995,int_stack+58215,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234786,int_stack+166278,int_stack+126750,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+234786,int_stack+194178,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+499710,int_stack+0,int_stack+211026,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+177618,int_stack+499710,int_stack+136578,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+126750,int_stack+66315,int_stack+61995,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+139710,int_stack+126750,int_stack+166278,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+28080,int_stack+139710,int_stack+234786,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+219198,int_stack+28080,int_stack+0,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+535350,int_stack+219198,int_stack+499710,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+585246,int_stack+535350,int_stack+177618,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+499710,int_stack+71211,int_stack+66315,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+499710,int_stack+126750,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+162390,int_stack+0,int_stack+139710,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+640686,int_stack+162390,int_stack+28080,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+689826,int_stack+640686,int_stack+219198,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+200190,int_stack+689826,int_stack+535350,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+748794,int_stack+200190,int_stack+585246,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+126750,int_stack+76719,int_stack+71211,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+514398,int_stack+126750,int_stack+499710,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+543774,int_stack+514398,int_stack+0,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+543774,int_stack+162390,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+499710,int_stack+0,int_stack+640686,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+499710,int_stack+689826,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+499710,int_stack+0,int_stack+200190,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+585246,int_stack+499710,int_stack+748794,36);
 /*--- compute (ip|ml) ---*/
 hrr1_build_ip(Libint->AB,int_stack+674346,int_stack+585246,int_stack+274485,2475);
 /*--- compute (hd|ml) ---*/
 hrr1_build_hd(Libint->AB,int_stack+882246,int_stack+674346,int_stack+343785,2475);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+85350,int_stack+82875,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+88320,int_stack+85350,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16335,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+31185,int_stack+91830,int_stack+88320,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+41715,int_stack+31185,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+59535,int_stack+41715,int_stack+16335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+95925,int_stack+91830,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+126750,int_stack+0,int_stack+31185,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+147810,int_stack+126750,int_stack+41715,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+12285,int_stack+147810,int_stack+59535,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+49410,int_stack+100650,int_stack+95925,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+63585,int_stack+49410,int_stack+0,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+177510,int_stack+63585,int_stack+126750,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+212610,int_stack+177510,int_stack+147810,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+257160,int_stack+212610,int_stack+12285,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+126750,int_stack+106050,int_stack+100650,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+142950,int_stack+126750,int_stack+49410,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+142950,int_stack+63585,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+40950,int_stack+0,int_stack+177510,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+309135,int_stack+40950,int_stack+212610,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+171300,int_stack+309135,int_stack+257160,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+240600,int_stack+112170,int_stack+106050,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+258960,int_stack+240600,int_stack+126750,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+371505,int_stack+258960,int_stack+142950,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+418755,int_stack+371505,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+480180,int_stack+418755,int_stack+40950,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+480180,int_stack+309135,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1194096,int_stack+0,int_stack+171300,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+83160,int_stack+119055,int_stack+112170,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+103815,int_stack+83160,int_stack+240600,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+140535,int_stack+103815,int_stack+258960,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+194535,int_stack+140535,int_stack+371505,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+83160,int_stack+194535,int_stack+418755,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+169155,int_stack+83160,int_stack+480180,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+267435,int_stack+169155,int_stack+0,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+267435,int_stack+1194096,45);
 /*--- compute (kp|ml) ---*/
 hrr1_build_kp(Libint->AB,int_stack+111375,int_stack+0,int_stack+585246,2475);
 /*--- compute (id|ml) ---*/
 hrr1_build_id(Libint->AB,int_stack+1194096,int_stack+111375,int_stack+674346,2475);
 /*--- compute (hf|ml) ---*/
 hrr1_build_hf(Libint->AB,int_stack+0,int_stack+1194096,int_stack+882246,2475);
 return int_stack+0;}
