/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hgnf(Libint_t*, prim_data*);

  /* Computes quartets of (hg|nf) integrals */

REALTYPE *hrr_order_hgnf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[6][10] = int_stack + 7140;
 Libint->vrr_classes[6][11] = int_stack + 8988;
 Libint->vrr_classes[6][12] = int_stack + 11172;
 Libint->vrr_classes[6][13] = int_stack + 13720;
 Libint->vrr_classes[7][10] = int_stack + 16660;
 Libint->vrr_classes[7][11] = int_stack + 19036;
 Libint->vrr_classes[7][12] = int_stack + 21844;
 Libint->vrr_classes[7][13] = int_stack + 25120;
 Libint->vrr_classes[8][10] = int_stack + 28900;
 Libint->vrr_classes[8][11] = int_stack + 31870;
 Libint->vrr_classes[8][12] = int_stack + 35380;
 Libint->vrr_classes[8][13] = int_stack + 39475;
 Libint->vrr_classes[9][10] = int_stack + 44200;
 Libint->vrr_classes[9][11] = int_stack + 47830;
 Libint->vrr_classes[9][12] = int_stack + 52120;
 Libint->vrr_classes[9][13] = int_stack + 57125;
 memset(int_stack,0,62900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 62900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hgnf(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62900,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+67058,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+71972,int_stack+67058,int_stack+62900,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+80288,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+86021,int_stack+80288,int_stack+67058,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+95849,int_stack+86021,int_stack+71972,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62900,int_stack+8988,int_stack+7140,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+68444,int_stack+11172,int_stack+8988,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+74996,int_stack+68444,int_stack+62900,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86084,int_stack+13720,int_stack+11172,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+86084,int_stack+68444,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+109709,int_stack+0,int_stack+74996,28);
 /*--- compute (hp|nf) ---*/
 hrr1_build_hp(Libint->AB,int_stack+128189,int_stack+109709,int_stack+95849,660);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+19036,int_stack+16660,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7128,int_stack+21844,int_stack+19036,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+62900,int_stack+7128,int_stack+0,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+77156,int_stack+25120,int_stack+21844,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+86984,int_stack+77156,int_stack+7128,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+86984,int_stack+62900,36);
 /*--- compute (ip|nf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+169769,int_stack+0,int_stack+109709,660);
 /*--- compute (hd|nf) ---*/
 hrr1_build_hd(Libint->AB,int_stack+225209,int_stack+169769,int_stack+128189,660);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+62900,int_stack+31870,int_stack+28900,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+71810,int_stack+35380,int_stack+31870,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+82340,int_stack+71810,int_stack+62900,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+100160,int_stack+39475,int_stack+35380,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+112445,int_stack+100160,int_stack+71810,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+133505,int_stack+112445,int_stack+82340,45);
 /*--- compute (kp|nf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+308369,int_stack+133505,int_stack+0,660);
 /*--- compute (id|nf) ---*/
 hrr1_build_id(Libint->AB,int_stack+379649,int_stack+308369,int_stack+169769,660);
 /*--- compute (hf|nf) ---*/
 hrr1_build_hf(Libint->AB,int_stack+490529,int_stack+379649,int_stack+225209,660);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+47830,int_stack+44200,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10890,int_stack+52120,int_stack+47830,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+23760,int_stack+10890,int_stack+0,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+62900,int_stack+57125,int_stack+52120,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+77915,int_stack+62900,int_stack+10890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+163205,int_stack+77915,int_stack+23760,55);
 /*--- compute (lp|nf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+0,int_stack+163205,int_stack+133505,660);
 /*--- compute (kd|nf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+89100,int_stack+0,int_stack+308369,660);
 /*--- compute (if|nf) ---*/
 hrr1_build_if(Libint->AB,int_stack+629129,int_stack+89100,int_stack+379649,660);
 /*--- compute (hg|nf) ---*/
 hrr1_build_hg(Libint->AB,int_stack+0,int_stack+629129,int_stack+490529,660);
 return int_stack+0;}
