/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_hhnm(Libint_t*, prim_data*);

  /* Computes quartets of (hh|nm) integrals */

REALTYPE *hrr_order_hhnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[5][10] = int_stack + 0;
 Libint->vrr_classes[5][11] = int_stack + 1386;
 Libint->vrr_classes[5][12] = int_stack + 3024;
 Libint->vrr_classes[5][13] = int_stack + 4935;
 Libint->vrr_classes[5][14] = int_stack + 7140;
 Libint->vrr_classes[5][15] = int_stack + 9660;
 Libint->vrr_classes[5][16] = int_stack + 12516;
 Libint->vrr_classes[5][17] = int_stack + 15729;
 Libint->vrr_classes[5][18] = int_stack + 19320;
 Libint->vrr_classes[5][19] = int_stack + 23310;
 Libint->vrr_classes[6][10] = int_stack + 27720;
 Libint->vrr_classes[6][11] = int_stack + 29568;
 Libint->vrr_classes[6][12] = int_stack + 31752;
 Libint->vrr_classes[6][13] = int_stack + 34300;
 Libint->vrr_classes[6][14] = int_stack + 37240;
 Libint->vrr_classes[6][15] = int_stack + 40600;
 Libint->vrr_classes[6][16] = int_stack + 44408;
 Libint->vrr_classes[6][17] = int_stack + 48692;
 Libint->vrr_classes[6][18] = int_stack + 53480;
 Libint->vrr_classes[6][19] = int_stack + 58800;
 Libint->vrr_classes[7][10] = int_stack + 64680;
 Libint->vrr_classes[7][11] = int_stack + 67056;
 Libint->vrr_classes[7][12] = int_stack + 69864;
 Libint->vrr_classes[7][13] = int_stack + 73140;
 Libint->vrr_classes[7][14] = int_stack + 76920;
 Libint->vrr_classes[7][15] = int_stack + 81240;
 Libint->vrr_classes[7][16] = int_stack + 86136;
 Libint->vrr_classes[7][17] = int_stack + 91644;
 Libint->vrr_classes[7][18] = int_stack + 97800;
 Libint->vrr_classes[7][19] = int_stack + 104640;
 Libint->vrr_classes[8][10] = int_stack + 112200;
 Libint->vrr_classes[8][11] = int_stack + 115170;
 Libint->vrr_classes[8][12] = int_stack + 118680;
 Libint->vrr_classes[8][13] = int_stack + 122775;
 Libint->vrr_classes[8][14] = int_stack + 127500;
 Libint->vrr_classes[8][15] = int_stack + 132900;
 Libint->vrr_classes[8][16] = int_stack + 139020;
 Libint->vrr_classes[8][17] = int_stack + 145905;
 Libint->vrr_classes[8][18] = int_stack + 153600;
 Libint->vrr_classes[8][19] = int_stack + 162150;
 Libint->vrr_classes[9][10] = int_stack + 171600;
 Libint->vrr_classes[9][11] = int_stack + 175230;
 Libint->vrr_classes[9][12] = int_stack + 179520;
 Libint->vrr_classes[9][13] = int_stack + 184525;
 Libint->vrr_classes[9][14] = int_stack + 190300;
 Libint->vrr_classes[9][15] = int_stack + 196900;
 Libint->vrr_classes[9][16] = int_stack + 204380;
 Libint->vrr_classes[9][17] = int_stack + 212795;
 Libint->vrr_classes[9][18] = int_stack + 222200;
 Libint->vrr_classes[9][19] = int_stack + 232650;
 Libint->vrr_classes[10][10] = int_stack + 244200;
 Libint->vrr_classes[10][11] = int_stack + 248556;
 Libint->vrr_classes[10][12] = int_stack + 253704;
 Libint->vrr_classes[10][13] = int_stack + 259710;
 Libint->vrr_classes[10][14] = int_stack + 266640;
 Libint->vrr_classes[10][15] = int_stack + 274560;
 Libint->vrr_classes[10][16] = int_stack + 283536;
 Libint->vrr_classes[10][17] = int_stack + 293634;
 Libint->vrr_classes[10][18] = int_stack + 304920;
 Libint->vrr_classes[10][19] = int_stack + 317460;
 memset(int_stack,0,331320*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 331320;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_hhnm(Libint, Data);
   Data++;
 }
 /*--- compute (h0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+331320,int_stack+1386,int_stack+0,21);
 /*--- compute (h0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+335478,int_stack+3024,int_stack+1386,21);
 /*--- compute (h0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+340392,int_stack+335478,int_stack+331320,21);
 /*--- compute (h0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+348708,int_stack+4935,int_stack+3024,21);
 /*--- compute (h0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+354441,int_stack+348708,int_stack+335478,21);
 /*--- compute (h0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+364269,int_stack+354441,int_stack+340392,21);
 /*--- compute (h0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+331320,int_stack+7140,int_stack+4935,21);
 /*--- compute (h0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+378129,int_stack+331320,int_stack+348708,21);
 /*--- compute (h0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+337935,int_stack+378129,int_stack+354441,21);
 /*--- compute (h0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+389595,int_stack+337935,int_stack+364269,21);
 /*--- compute (h0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+354315,int_stack+9660,int_stack+7140,21);
 /*--- compute (h0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+361875,int_stack+354315,int_stack+331320,21);
 /*--- compute (h0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+410385,int_stack+361875,int_stack+378129,21);
 /*--- compute (h0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+429495,int_stack+410385,int_stack+337935,21);
 /*--- compute (h0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+454065,int_stack+429495,int_stack+389595,21);
 /*--- compute (h0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+331320,int_stack+12516,int_stack+9660,21);
 /*--- compute (h0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+375105,int_stack+331320,int_stack+354315,21);
 /*--- compute (h0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+483171,int_stack+375105,int_stack+361875,21);
 /*--- compute (h0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+339888,int_stack+483171,int_stack+410385,21);
 /*--- compute (h0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+390225,int_stack+339888,int_stack+429495,21);
 /*--- compute (h0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+505221,int_stack+390225,int_stack+454065,21);
 /*--- compute (h0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+424623,int_stack+15729,int_stack+12516,21);
 /*--- compute (h0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+434262,int_stack+424623,int_stack+331320,21);
 /*--- compute (h0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+451398,int_stack+434262,int_stack+375105,21);
 /*--- compute (h0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+544029,int_stack+451398,int_stack+483171,21);
 /*--- compute (h0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+577104,int_stack+544029,int_stack+339888,21);
 /*--- compute (h0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+331320,int_stack+577104,int_stack+390225,21);
 /*--- compute (h0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+617235,int_stack+331320,int_stack+505221,21);
 /*--- compute (h0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+377184,int_stack+19320,int_stack+15729,21);
 /*--- compute (h0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+387957,int_stack+377184,int_stack+424623,21);
 /*--- compute (h0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+476598,int_stack+387957,int_stack+434262,21);
 /*--- compute (h0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+407235,int_stack+476598,int_stack+451398,21);
 /*--- compute (h0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+667131,int_stack+407235,int_stack+544029,21);
 /*--- compute (h0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+505158,int_stack+667131,int_stack+577104,21);
 /*--- compute (h0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+713436,int_stack+505158,int_stack+331320,21);
 /*--- compute (h0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+772404,int_stack+713436,int_stack+617235,21);
 /*--- compute (h0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+331320,int_stack+23310,int_stack+19320,21);
 /*--- compute (h0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+343290,int_stack+331320,int_stack+377184,21);
 /*--- compute (h0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+558666,int_stack+343290,int_stack+387957,21);
 /*--- compute (h0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+331320,int_stack+558666,int_stack+476598,21);
 /*--- compute (h0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+558666,int_stack+331320,int_stack+407235,21);
 /*--- compute (h0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+331320,int_stack+558666,int_stack+667131,21);
 /*--- compute (h0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+558666,int_stack+331320,int_stack+505158,21);
 /*--- compute (h0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+331320,int_stack+558666,int_stack+713436,21);
 /*--- compute (h0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+405030,int_stack+331320,int_stack+772404,21);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+331320,int_stack+29568,int_stack+27720,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+336864,int_stack+31752,int_stack+29568,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+343416,int_stack+336864,int_stack+331320,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+354504,int_stack+34300,int_stack+31752,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+362148,int_stack+354504,int_stack+336864,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+375252,int_stack+362148,int_stack+343416,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+331320,int_stack+37240,int_stack+34300,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+481260,int_stack+331320,int_stack+354504,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+340140,int_stack+481260,int_stack+362148,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+496548,int_stack+340140,int_stack+375252,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+361980,int_stack+40600,int_stack+37240,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+372060,int_stack+361980,int_stack+331320,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+524268,int_stack+372060,int_stack+481260,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+549748,int_stack+524268,int_stack+340140,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+582508,int_stack+549748,int_stack+496548,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+481260,int_stack+44408,int_stack+40600,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+492684,int_stack+481260,int_stack+361980,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+331320,int_stack+492684,int_stack+372060,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+360720,int_stack+331320,int_stack+524268,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+621316,int_stack+360720,int_stack+549748,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+512844,int_stack+621316,int_stack+582508,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+564588,int_stack+48692,int_stack+44408,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+577440,int_stack+564588,int_stack+481260,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+667180,int_stack+577440,int_stack+492684,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+700780,int_stack+667180,int_stack+331320,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+744880,int_stack+700780,int_stack+360720,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+331320,int_stack+744880,int_stack+621316,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+600288,int_stack+331320,int_stack+512844,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+481260,int_stack+53480,int_stack+48692,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+495624,int_stack+481260,int_stack+564588,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+521328,int_stack+495624,int_stack+577440,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+521328,int_stack+667180,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+798388,int_stack+0,int_stack+700780,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+666816,int_stack+798388,int_stack+744880,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+860128,int_stack+666816,int_stack+331320,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+938752,int_stack+860128,int_stack+600288,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+331320,int_stack+58800,int_stack+53480,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+347280,int_stack+331320,int_stack+481260,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+559408,int_stack+347280,int_stack+495624,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+331320,int_stack+559408,int_stack+521328,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+481260,int_stack+331320,int_stack+0,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+551820,int_stack+481260,int_stack+798388,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+738160,int_stack+551820,int_stack+666816,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+481260,int_stack+738160,int_stack+860128,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+579540,int_stack+481260,int_stack+938752,28);
 /*--- compute (hp|nm) ---*/
 hrr1_build_hp(Libint->AB,int_stack+681180,int_stack+579540,int_stack+405030,3630);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+909870,int_stack+67056,int_stack+64680,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+916998,int_stack+69864,int_stack+67056,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+925422,int_stack+916998,int_stack+909870,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+939678,int_stack+73140,int_stack+69864,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+949506,int_stack+939678,int_stack+916998,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+966354,int_stack+949506,int_stack+925422,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+909870,int_stack+76920,int_stack+73140,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+990114,int_stack+909870,int_stack+939678,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+921210,int_stack+990114,int_stack+949506,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+921210,int_stack+966354,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+949290,int_stack+81240,int_stack+76920,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+962250,int_stack+949290,int_stack+909870,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+35640,int_stack+962250,int_stack+990114,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+331320,int_stack+35640,int_stack+921210,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+373440,int_stack+331320,int_stack+0,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+86136,int_stack+81240,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+909870,int_stack+0,int_stack+949290,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+423336,int_stack+909870,int_stack+962250,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+935790,int_stack+423336,int_stack+35640,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+14688,int_stack+935790,int_stack+331320,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+461136,int_stack+14688,int_stack+373440,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+331320,int_stack+91644,int_stack+86136,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+347844,int_stack+331320,int_stack+0,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+377220,int_stack+347844,int_stack+909870,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+984930,int_stack+377220,int_stack+423336,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1041630,int_stack+984930,int_stack+935790,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1110426,int_stack+1041630,int_stack+14688,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1110426,int_stack+461136,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+909870,int_stack+97800,int_stack+91644,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+928338,int_stack+909870,int_stack+331320,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+420420,int_stack+928338,int_stack+347844,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+469380,int_stack+420420,int_stack+377220,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+331320,int_stack+469380,int_stack+984930,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1189050,int_stack+331320,int_stack+1041630,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+961386,int_stack+1189050,int_stack+1110426,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1062474,int_stack+961386,int_stack+0,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+104640,int_stack+97800,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+20520,int_stack+0,int_stack+909870,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1280778,int_stack+20520,int_stack+928338,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1280778,int_stack+420420,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1280778,int_stack+0,int_stack+469380,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+1280778,int_stack+331320,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+331320,int_stack+0,int_stack+1189050,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+449256,int_stack+331320,int_stack+961386,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+909870,int_stack+449256,int_stack+1062474,36);
 /*--- compute (ip|nm) ---*/
 hrr1_build_ip(Libint->AB,int_stack+1040550,int_stack+909870,int_stack+579540,3630);
 /*--- compute (hd|nm) ---*/
 hrr1_build_hd(Libint->AB,int_stack+1345470,int_stack+1040550,int_stack+681180,3630);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+331320,int_stack+115170,int_stack+112200,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+340230,int_stack+118680,int_stack+115170,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+350760,int_stack+340230,int_stack+331320,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+368580,int_stack+122775,int_stack+118680,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+380865,int_stack+368580,int_stack+340230,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+401925,int_stack+380865,int_stack+350760,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+331320,int_stack+127500,int_stack+122775,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+431625,int_stack+331320,int_stack+368580,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+345495,int_stack+431625,int_stack+380865,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+456195,int_stack+345495,int_stack+401925,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+380595,int_stack+132900,int_stack+127500,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+396795,int_stack+380595,int_stack+331320,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+500745,int_stack+396795,int_stack+431625,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+541695,int_stack+500745,int_stack+345495,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+594345,int_stack+541695,int_stack+456195,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+331320,int_stack+139020,int_stack+132900,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+425145,int_stack+331320,int_stack+380595,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+656715,int_stack+425145,int_stack+396795,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+349680,int_stack+656715,int_stack+500745,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+457545,int_stack+349680,int_stack+541695,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+703965,int_stack+457545,int_stack+594345,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+531255,int_stack+145905,int_stack+139020,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+551910,int_stack+531255,int_stack+331320,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+588630,int_stack+551910,int_stack+425145,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+787125,int_stack+588630,int_stack+656715,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+787125,int_stack+349680,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+331320,int_stack+0,int_stack+457545,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1802850,int_stack+331320,int_stack+703965,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+429600,int_stack+153600,int_stack+145905,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+452685,int_stack+429600,int_stack+531255,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+642630,int_stack+452685,int_stack+551910,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+493995,int_stack+642630,int_stack+588630,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1909770,int_stack+493995,int_stack+787125,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+703830,int_stack+1909770,int_stack+0,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+703830,int_stack+331320,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2008995,int_stack+0,int_stack+1802850,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1802850,int_stack+162150,int_stack+153600,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1828500,int_stack+1802850,int_stack+429600,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+331320,int_stack+1828500,int_stack+452685,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1802850,int_stack+331320,int_stack+642630,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+331320,int_stack+1802850,int_stack+493995,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+444720,int_stack+331320,int_stack+1909770,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1802850,int_stack+444720,int_stack+703830,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+331320,int_stack+1802850,int_stack+0,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+331320,int_stack+2008995,45);
 /*--- compute (kp|nm) ---*/
 hrr1_build_kp(Libint->AB,int_stack+331320,int_stack+0,int_stack+909870,3630);
 /*--- compute (id|nm) ---*/
 hrr1_build_id(Libint->AB,int_stack+1802850,int_stack+331320,int_stack+1040550,3630);
 /*--- compute (hf|nm) ---*/
 hrr1_build_hf(Libint->AB,int_stack+2412690,int_stack+1802850,int_stack+1345470,3630);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+723360,int_stack+175230,int_stack+171600,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+734250,int_stack+179520,int_stack+175230,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+747120,int_stack+734250,int_stack+723360,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+768900,int_stack+184525,int_stack+179520,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+783915,int_stack+768900,int_stack+734250,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+809655,int_stack+783915,int_stack+747120,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+723360,int_stack+190300,int_stack+184525,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+845955,int_stack+723360,int_stack+768900,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+740685,int_stack+845955,int_stack+783915,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+875985,int_stack+740685,int_stack+809655,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+783585,int_stack+196900,int_stack+190300,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+803385,int_stack+783585,int_stack+723360,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+930435,int_stack+803385,int_stack+845955,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+980485,int_stack+930435,int_stack+740685,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1044835,int_stack+980485,int_stack+875985,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+723360,int_stack+204380,int_stack+196900,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+838035,int_stack+723360,int_stack+783585,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1121065,int_stack+838035,int_stack+803385,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+745800,int_stack+1121065,int_stack+930435,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+877635,int_stack+745800,int_stack+980485,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1178815,int_stack+877635,int_stack+1044835,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+967725,int_stack+212795,int_stack+204380,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+992970,int_stack+967725,int_stack+723360,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1037850,int_stack+992970,int_stack+838035,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1280455,int_stack+1037850,int_stack+1121065,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1367080,int_stack+1280455,int_stack+745800,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+723360,int_stack+1367080,int_stack+877635,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1472185,int_stack+723360,int_stack+1178815,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+843480,int_stack+222200,int_stack+212795,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+871695,int_stack+843480,int_stack+967725,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1103850,int_stack+871695,int_stack+992970,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+922185,int_stack+1103850,int_stack+1037850,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1602865,int_stack+922185,int_stack+1280455,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1178650,int_stack+1602865,int_stack+1367080,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3174990,int_stack+1178650,int_stack+723360,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3329430,int_stack+3174990,int_stack+1472185,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+723360,int_stack+232650,int_stack+222200,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+754710,int_stack+723360,int_stack+843480,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1318790,int_stack+754710,int_stack+871695,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+723360,int_stack+1318790,int_stack+1103850,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1318790,int_stack+723360,int_stack+922185,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+723360,int_stack+1318790,int_stack+1602865,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1318790,int_stack+723360,int_stack+1178650,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+723360,int_stack+1318790,int_stack+3174990,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+916410,int_stack+723360,int_stack+3329430,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1116060,int_stack+916410,int_stack+0,3630);
 /*--- compute (kd|nm) ---*/
 hrr1_build_kd(Libint->AB,int_stack+3174990,int_stack+1116060,int_stack+331320,3630);
 /*--- compute (if|nm) ---*/
 hrr1_build_if(Libint->AB,int_stack+3959070,int_stack+3174990,int_stack+1802850,3630);
 /*--- compute (hg|nm) ---*/
 hrr1_build_hg(Libint->AB,int_stack+4975470,int_stack+3959070,int_stack+2412690,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+331320,int_stack+248556,int_stack+244200,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+344388,int_stack+253704,int_stack+248556,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+359832,int_stack+344388,int_stack+331320,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+385968,int_stack+259710,int_stack+253704,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+403986,int_stack+385968,int_stack+344388,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+434874,int_stack+403986,int_stack+359832,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+331320,int_stack+266640,int_stack+259710,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+478434,int_stack+331320,int_stack+385968,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+352110,int_stack+478434,int_stack+403986,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+514470,int_stack+352110,int_stack+434874,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+403590,int_stack+274560,int_stack+266640,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+427350,int_stack+403590,int_stack+331320,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+579810,int_stack+427350,int_stack+478434,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+639870,int_stack+579810,int_stack+352110,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+717090,int_stack+639870,int_stack+514470,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+331320,int_stack+283536,int_stack+274560,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+468930,int_stack+331320,int_stack+403590,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+808566,int_stack+468930,int_stack+427350,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+358248,int_stack+808566,int_stack+579810,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+516450,int_stack+358248,int_stack+639870,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+516450,int_stack+717090,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+624558,int_stack+293634,int_stack+283536,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+654852,int_stack+624558,int_stack+331320,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+708708,int_stack+654852,int_stack+468930,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+121968,int_stack+708708,int_stack+808566,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+787908,int_stack+121968,int_stack+358248,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+331320,int_stack+787908,int_stack+516450,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1606110,int_stack+331320,int_stack+0,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+304920,int_stack+293634,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+33858,int_stack+0,int_stack+624558,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+475464,int_stack+33858,int_stack+654852,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+565224,int_stack+475464,int_stack+708708,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1762926,int_stack+565224,int_stack+121968,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+94446,int_stack+1762926,int_stack+787908,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+684024,int_stack+94446,int_stack+331320,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1908456,int_stack+684024,int_stack+1606110,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1606110,int_stack+317460,int_stack+304920,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1643730,int_stack+1606110,int_stack+0,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+262614,int_stack+1643730,int_stack+33858,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1606110,int_stack+262614,int_stack+475464,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+262614,int_stack+1606110,int_stack+565224,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+428934,int_stack+262614,int_stack+1762926,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1606110,int_stack+428934,int_stack+94446,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+1606110,int_stack+684024,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1606110,int_stack+0,int_stack+1908456,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+1606110,int_stack+916410,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1606110,int_stack+0,int_stack+1116060,3630);
 /*--- compute (kf|nm) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+1606110,int_stack+3174990,3630);
 /*--- compute (ig|nm) ---*/
 hrr1_build_ig(Libint->AB,int_stack+1306800,int_stack+0,int_stack+3959070,3630);
 /*--- compute (hh|nm) ---*/
 hrr1_build_hh(Libint->AB,int_stack+2831400,int_stack+1306800,int_stack+4975470,3630);
 return int_stack+2831400;}
