/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_idih(Libint_t*, prim_data*);

  /* Computes quartets of (id|ih) integrals */

REALTYPE *hrr_order_idih(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[7][6] = int_stack + 8624;
 Libint->vrr_classes[7][7] = int_stack + 9632;
 Libint->vrr_classes[7][8] = int_stack + 10928;
 Libint->vrr_classes[7][9] = int_stack + 12548;
 Libint->vrr_classes[7][10] = int_stack + 14528;
 Libint->vrr_classes[7][11] = int_stack + 16904;
 Libint->vrr_classes[8][6] = int_stack + 19712;
 Libint->vrr_classes[8][7] = int_stack + 20972;
 Libint->vrr_classes[8][8] = int_stack + 22592;
 Libint->vrr_classes[8][9] = int_stack + 24617;
 Libint->vrr_classes[8][10] = int_stack + 27092;
 Libint->vrr_classes[8][11] = int_stack + 30062;
 memset(int_stack,0,33572*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 33572;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_idih(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33572,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+35924,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+38948,int_stack+35924,int_stack+33572,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+43652,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+47432,int_stack+43652,int_stack+35924,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+53480,int_stack+47432,int_stack+38948,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33572,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+61320,int_stack+33572,int_stack+43652,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+68880,int_stack+61320,int_stack+47432,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+38192,int_stack+68880,int_stack+53480,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+49952,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+78960,int_stack+49952,int_stack+33572,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+88200,int_stack+78960,int_stack+61320,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+49952,int_stack+88200,int_stack+68880,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+65072,int_stack+49952,int_stack+38192,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+33572,int_stack+9632,int_stack+8624,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+36596,int_stack+10928,int_stack+9632,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+40484,int_stack+36596,int_stack+33572,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+46532,int_stack+12548,int_stack+10928,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+51392,int_stack+46532,int_stack+36596,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+81536,int_stack+51392,int_stack+40484,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+33572,int_stack+14528,int_stack+12548,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+33572,int_stack+46532,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+91616,int_stack+0,int_stack+51392,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+39512,int_stack+91616,int_stack+81536,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+81536,int_stack+16904,int_stack+14528,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+104576,int_stack+81536,int_stack+33572,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+116456,int_stack+104576,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+116456,int_stack+91616,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+81536,int_stack+0,int_stack+39512,36);
 /*--- compute (ip|ih) ---*/
 hrr1_build_ip(Libint->AB,int_stack+102704,int_stack+81536,int_stack+65072,588);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+20972,int_stack+19712,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+3780,int_stack+22592,int_stack+20972,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+8640,int_stack+3780,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+16200,int_stack+24617,int_stack+22592,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+33572,int_stack+16200,int_stack+3780,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+43292,int_stack+33572,int_stack+8640,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+27092,int_stack+24617,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+55892,int_stack+0,int_stack+16200,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+7425,int_stack+55892,int_stack+33572,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+152096,int_stack+7425,int_stack+43292,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+33572,int_stack+30062,int_stack+27092,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+170996,int_stack+33572,int_stack+0,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+23625,int_stack+170996,int_stack+55892,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+43875,int_stack+23625,int_stack+7425,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+43875,int_stack+152096,45);
 /*--- compute (kp|ih) ---*/
 hrr1_build_kp(Libint->AB,int_stack+152096,int_stack+0,int_stack+81536,588);
 /*--- compute (id|ih) ---*/
 hrr1_build_id(Libint->AB,int_stack+0,int_stack+152096,int_stack+102704,588);
 return int_stack+0;}
