/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifmd(Libint_t*, prim_data*);

  /* Computes quartets of (if|md) integrals */

REALTYPE *hrr_order_ifmd(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[7][9] = int_stack + 5572;
 Libint->vrr_classes[7][10] = int_stack + 7552;
 Libint->vrr_classes[7][11] = int_stack + 9928;
 Libint->vrr_classes[8][9] = int_stack + 12736;
 Libint->vrr_classes[8][10] = int_stack + 15211;
 Libint->vrr_classes[8][11] = int_stack + 18181;
 Libint->vrr_classes[9][9] = int_stack + 21691;
 Libint->vrr_classes[9][10] = int_stack + 24716;
 Libint->vrr_classes[9][11] = int_stack + 28346;
 memset(int_stack,0,32636*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 32636;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifmd(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32636,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+37256,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42800,int_stack+37256,int_stack+32636,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32636,int_stack+7552,int_stack+5572,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+9928,int_stack+7552,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+52040,int_stack+0,int_stack+32636,36);
 /*--- compute (ip|md) ---*/
 hrr1_build_ip(Libint->AB,int_stack+63920,int_stack+52040,int_stack+42800,330);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32636,int_stack+15211,int_stack+12736,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+40061,int_stack+18181,int_stack+15211,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+0,int_stack+40061,int_stack+32636,45);
 /*--- compute (kp|md) ---*/
 hrr1_build_kp(Libint->AB,int_stack+91640,int_stack+0,int_stack+52040,330);
 /*--- compute (id|md) ---*/
 hrr1_build_id(Libint->AB,int_stack+127280,int_stack+91640,int_stack+63920,330);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+32636,int_stack+24716,int_stack+21691,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+41711,int_stack+28346,int_stack+24716,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+52601,int_stack+41711,int_stack+32636,55);
 /*--- compute (lp|md) ---*/
 hrr1_build_lp(Libint->AB,int_stack+182720,int_stack+52601,int_stack+0,330);
 /*--- compute (kd|md) ---*/
 hrr1_build_kd(Libint->AB,int_stack+0,int_stack+182720,int_stack+91640,330);
 /*--- compute (if|md) ---*/
 hrr1_build_if(Libint->AB,int_stack+182720,int_stack+0,int_stack+127280,330);
 return int_stack+182720;}
