/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ifmf(Libint_t*, prim_data*);

  /* Computes quartets of (if|mf) integrals */

REALTYPE *hrr_order_ifmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[7][9] = int_stack + 8120;
 Libint->vrr_classes[7][10] = int_stack + 10100;
 Libint->vrr_classes[7][11] = int_stack + 12476;
 Libint->vrr_classes[7][12] = int_stack + 15284;
 Libint->vrr_classes[8][9] = int_stack + 18560;
 Libint->vrr_classes[8][10] = int_stack + 21035;
 Libint->vrr_classes[8][11] = int_stack + 24005;
 Libint->vrr_classes[8][12] = int_stack + 27515;
 Libint->vrr_classes[9][9] = int_stack + 31610;
 Libint->vrr_classes[9][10] = int_stack + 34635;
 Libint->vrr_classes[9][11] = int_stack + 38265;
 Libint->vrr_classes[9][12] = int_stack + 42555;
 memset(int_stack,0,47560*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47560;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ifmf(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47560,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+52180,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+57724,int_stack+52180,int_stack+47560,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+66964,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73516,int_stack+66964,int_stack+52180,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+84604,int_stack+73516,int_stack+57724,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47560,int_stack+10100,int_stack+8120,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+53500,int_stack+12476,int_stack+10100,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+60628,int_stack+53500,int_stack+47560,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72508,int_stack+15284,int_stack+12476,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+72508,int_stack+53500,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+100004,int_stack+0,int_stack+60628,36);
 /*--- compute (ip|mf) ---*/
 hrr1_build_ip(Libint->AB,int_stack+119804,int_stack+100004,int_stack+84604,550);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+21035,int_stack+18560,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+7425,int_stack+24005,int_stack+21035,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+47560,int_stack+7425,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+62410,int_stack+27515,int_stack+24005,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72940,int_stack+62410,int_stack+7425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+72940,int_stack+47560,45);
 /*--- compute (kp|mf) ---*/
 hrr1_build_kp(Libint->AB,int_stack+166004,int_stack+0,int_stack+100004,550);
 /*--- compute (id|mf) ---*/
 hrr1_build_id(Libint->AB,int_stack+225404,int_stack+166004,int_stack+119804,550);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47560,int_stack+34635,int_stack+31610,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+56635,int_stack+38265,int_stack+34635,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67525,int_stack+56635,int_stack+47560,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85675,int_stack+42555,int_stack+38265,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98545,int_stack+85675,int_stack+56635,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120325,int_stack+98545,int_stack+67525,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+24750,int_stack+120325,int_stack+0,550);
 /*--- compute (kd|mf) ---*/
 hrr1_build_kd(Libint->AB,int_stack+317804,int_stack+24750,int_stack+166004,550);
 /*--- compute (if|mf) ---*/
 hrr1_build_if(Libint->AB,int_stack+0,int_stack+317804,int_stack+225404,550);
 return int_stack+0;}
