/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igii(Libint_t*, prim_data*);

  /* Computes quartets of (ig|ii) integrals */

REALTYPE *hrr_order_igii(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][6] = int_stack + 0;
 Libint->vrr_classes[6][7] = int_stack + 784;
 Libint->vrr_classes[6][8] = int_stack + 1792;
 Libint->vrr_classes[6][9] = int_stack + 3052;
 Libint->vrr_classes[6][10] = int_stack + 4592;
 Libint->vrr_classes[6][11] = int_stack + 6440;
 Libint->vrr_classes[6][12] = int_stack + 8624;
 Libint->vrr_classes[7][6] = int_stack + 11172;
 Libint->vrr_classes[7][7] = int_stack + 12180;
 Libint->vrr_classes[7][8] = int_stack + 13476;
 Libint->vrr_classes[7][9] = int_stack + 15096;
 Libint->vrr_classes[7][10] = int_stack + 17076;
 Libint->vrr_classes[7][11] = int_stack + 19452;
 Libint->vrr_classes[7][12] = int_stack + 22260;
 Libint->vrr_classes[8][6] = int_stack + 25536;
 Libint->vrr_classes[8][7] = int_stack + 26796;
 Libint->vrr_classes[8][8] = int_stack + 28416;
 Libint->vrr_classes[8][9] = int_stack + 30441;
 Libint->vrr_classes[8][10] = int_stack + 32916;
 Libint->vrr_classes[8][11] = int_stack + 35886;
 Libint->vrr_classes[8][12] = int_stack + 39396;
 Libint->vrr_classes[9][6] = int_stack + 43491;
 Libint->vrr_classes[9][7] = int_stack + 45031;
 Libint->vrr_classes[9][8] = int_stack + 47011;
 Libint->vrr_classes[9][9] = int_stack + 49486;
 Libint->vrr_classes[9][10] = int_stack + 52511;
 Libint->vrr_classes[9][11] = int_stack + 56141;
 Libint->vrr_classes[9][12] = int_stack + 60431;
 Libint->vrr_classes[10][6] = int_stack + 65436;
 Libint->vrr_classes[10][7] = int_stack + 67284;
 Libint->vrr_classes[10][8] = int_stack + 69660;
 Libint->vrr_classes[10][9] = int_stack + 72630;
 Libint->vrr_classes[10][10] = int_stack + 76260;
 Libint->vrr_classes[10][11] = int_stack + 80616;
 Libint->vrr_classes[10][12] = int_stack + 85764;
 memset(int_stack,0,91770*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 91770;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igii(Libint, Data);
   Data++;
 }
 /*--- compute (i0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+91770,int_stack+784,int_stack+0,28);
 /*--- compute (i0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+94122,int_stack+1792,int_stack+784,28);
 /*--- compute (i0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+97146,int_stack+94122,int_stack+91770,28);
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+101850,int_stack+3052,int_stack+1792,28);
 /*--- compute (i0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+105630,int_stack+101850,int_stack+94122,28);
 /*--- compute (i0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+111678,int_stack+105630,int_stack+97146,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91770,int_stack+4592,int_stack+3052,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+119518,int_stack+91770,int_stack+101850,28);
 /*--- compute (i0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+127078,int_stack+119518,int_stack+105630,28);
 /*--- compute (i0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+96390,int_stack+127078,int_stack+111678,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+108150,int_stack+6440,int_stack+4592,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+137158,int_stack+108150,int_stack+91770,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+146398,int_stack+137158,int_stack+119518,28);
 /*--- compute (i0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+158998,int_stack+146398,int_stack+127078,28);
 /*--- compute (i0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+113694,int_stack+158998,int_stack+96390,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+91770,int_stack+8624,int_stack+6440,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+91770,int_stack+108150,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+91770,int_stack+0,int_stack+137158,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+174118,int_stack+91770,int_stack+146398,28);
 /*--- compute (i0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+91770,int_stack+174118,int_stack+158998,28);
 /*--- compute (i0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+130158,int_stack+91770,int_stack+113694,28);
 /*--- compute (k0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+91770,int_stack+12180,int_stack+11172,36);
 /*--- compute (k0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+94794,int_stack+13476,int_stack+12180,36);
 /*--- compute (k0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+98682,int_stack+94794,int_stack+91770,36);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+104730,int_stack+15096,int_stack+13476,36);
 /*--- compute (k0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+109590,int_stack+104730,int_stack+94794,36);
 /*--- compute (k0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+117366,int_stack+109590,int_stack+98682,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91770,int_stack+17076,int_stack+15096,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+91770,int_stack+104730,36);
 /*--- compute (k0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+152110,int_stack+0,int_stack+109590,36);
 /*--- compute (k0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+97710,int_stack+152110,int_stack+117366,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+112830,int_stack+19452,int_stack+17076,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+165070,int_stack+112830,int_stack+91770,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+176950,int_stack+165070,int_stack+0,36);
 /*--- compute (k0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+176950,int_stack+152110,36);
 /*--- compute (k0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+193150,int_stack+0,int_stack+97710,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+152110,int_stack+22260,int_stack+19452,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91770,int_stack+152110,int_stack+112830,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+106026,int_stack+91770,int_stack+165070,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+152110,int_stack+106026,int_stack+176950,36);
 /*--- compute (k0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+91770,int_stack+152110,int_stack+0,36);
 /*--- compute (k0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+152110,int_stack+91770,int_stack+193150,36);
 /*--- compute (ip|ii) ---*/
 hrr1_build_ip(Libint->AB,int_stack+180334,int_stack+152110,int_stack+130158,784);
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+91770,int_stack+26796,int_stack+25536,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+95550,int_stack+28416,int_stack+26796,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+100410,int_stack+95550,int_stack+91770,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+107970,int_stack+30441,int_stack+28416,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+114045,int_stack+107970,int_stack+95550,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+123765,int_stack+114045,int_stack+100410,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91770,int_stack+32916,int_stack+30441,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+136365,int_stack+91770,int_stack+107970,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+136365,int_stack+114045,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+99195,int_stack+0,int_stack+123765,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+118095,int_stack+35886,int_stack+32916,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+16200,int_stack+118095,int_stack+91770,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+246190,int_stack+16200,int_stack+136365,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+127005,int_stack+246190,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+266440,int_stack+127005,int_stack+99195,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+39396,int_stack+35886,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+91770,int_stack+0,int_stack+118095,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+292900,int_stack+91770,int_stack+16200,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+91770,int_stack+292900,int_stack+246190,45);
 /*--- compute (l0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+91770,int_stack+127005,45);
 /*--- compute (l0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+91770,int_stack+0,int_stack+266440,45);
 /*--- compute (kp|ii) ---*/
 hrr1_build_kp(Libint->AB,int_stack+246190,int_stack+91770,int_stack+152110,784);
 /*--- compute (id|ii) ---*/
 hrr1_build_id(Libint->AB,int_stack+330862,int_stack+246190,int_stack+180334,784);
 /*--- compute (m0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+0,int_stack+45031,int_stack+43491,55);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+4620,int_stack+47011,int_stack+45031,55);
 /*--- compute (m0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+10560,int_stack+4620,int_stack+0,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+19800,int_stack+49486,int_stack+47011,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+27225,int_stack+19800,int_stack+4620,55);
 /*--- compute (m0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+127050,int_stack+27225,int_stack+10560,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+52511,int_stack+49486,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+142450,int_stack+0,int_stack+19800,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+157300,int_stack+142450,int_stack+27225,55);
 /*--- compute (m0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+9075,int_stack+157300,int_stack+127050,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+127050,int_stack+56141,int_stack+52511,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+32175,int_stack+127050,int_stack+0,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+177100,int_stack+32175,int_stack+142450,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+201850,int_stack+177100,int_stack+157300,55);
 /*--- compute (m0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+137940,int_stack+201850,int_stack+9075,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+60431,int_stack+56141,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+462574,int_stack+0,int_stack+127050,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+462574,int_stack+32175,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+462574,int_stack+0,int_stack+177100,55);
 /*--- compute (m0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+0,int_stack+462574,int_stack+201850,55);
 /*--- compute (m0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+170280,int_stack+0,int_stack+137940,55);
 /*--- compute (lp|ii) ---*/
 hrr1_build_lp(Libint->AB,int_stack+462574,int_stack+170280,int_stack+91770,784);
 /*--- compute (kd|ii) ---*/
 hrr1_build_kd(Libint->AB,int_stack+568414,int_stack+462574,int_stack+246190,784);
 /*--- compute (if|ii) ---*/
 hrr1_build_if(Libint->AB,int_stack+737758,int_stack+568414,int_stack+330862,784);
 /*--- compute (n0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+91770,int_stack+67284,int_stack+65436,66);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+97314,int_stack+69660,int_stack+67284,66);
 /*--- compute (n0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+104442,int_stack+97314,int_stack+91770,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+115530,int_stack+72630,int_stack+69660,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+124440,int_stack+115530,int_stack+97314,66);
 /*--- compute (n0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+138696,int_stack+124440,int_stack+104442,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+91770,int_stack+76260,int_stack+72630,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+91770,int_stack+115530,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+17820,int_stack+0,int_stack+124440,66);
 /*--- compute (n0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+102660,int_stack+17820,int_stack+138696,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+130380,int_stack+80616,int_stack+76260,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+143448,int_stack+130380,int_stack+91770,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+41580,int_stack+143448,int_stack+0,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+213400,int_stack+41580,int_stack+17820,66);
 /*--- compute (n0|ih) ---*/
 hrr3_build_ih(Libint->CD,int_stack+0,int_stack+213400,int_stack+102660,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+91770,int_stack+85764,int_stack+80616,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+249040,int_stack+91770,int_stack+130380,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+71280,int_stack+249040,int_stack+143448,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+249040,int_stack+71280,int_stack+41580,66);
 /*--- compute (n0|kh) ---*/
 hrr3_build_kh(Libint->CD,int_stack+293590,int_stack+249040,int_stack+213400,66);
 /*--- compute (n0|ii) ---*/
 hrr3_build_ii(Libint->CD,int_stack+213400,int_stack+293590,int_stack+0,66);
 /*--- compute (mp|ii) ---*/
 hrr1_build_mp(Libint->AB,int_stack+0,int_stack+213400,int_stack+170280,784);
 /*--- compute (ld|ii) ---*/
 hrr1_build_ld(Libint->AB,int_stack+129360,int_stack+0,int_stack+462574,784);
 /*--- compute (kf|ii) ---*/
 hrr1_build_kf(Libint->AB,int_stack+957278,int_stack+129360,int_stack+568414,784);
 /*--- compute (ig|ii) ---*/
 hrr1_build_ig(Libint->AB,int_stack+0,int_stack+957278,int_stack+737758,784);
 return int_stack+0;}
