/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_igll(Libint_t*, prim_data*);

  /* Computes quartets of (ig|ll) integrals */

REALTYPE *hrr_order_igll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][8] = int_stack + 0;
 Libint->vrr_classes[6][9] = int_stack + 1260;
 Libint->vrr_classes[6][10] = int_stack + 2800;
 Libint->vrr_classes[6][11] = int_stack + 4648;
 Libint->vrr_classes[6][12] = int_stack + 6832;
 Libint->vrr_classes[6][13] = int_stack + 9380;
 Libint->vrr_classes[6][14] = int_stack + 12320;
 Libint->vrr_classes[6][15] = int_stack + 15680;
 Libint->vrr_classes[6][16] = int_stack + 19488;
 Libint->vrr_classes[7][8] = int_stack + 23772;
 Libint->vrr_classes[7][9] = int_stack + 25392;
 Libint->vrr_classes[7][10] = int_stack + 27372;
 Libint->vrr_classes[7][11] = int_stack + 29748;
 Libint->vrr_classes[7][12] = int_stack + 32556;
 Libint->vrr_classes[7][13] = int_stack + 35832;
 Libint->vrr_classes[7][14] = int_stack + 39612;
 Libint->vrr_classes[7][15] = int_stack + 43932;
 Libint->vrr_classes[7][16] = int_stack + 48828;
 Libint->vrr_classes[8][8] = int_stack + 54336;
 Libint->vrr_classes[8][9] = int_stack + 56361;
 Libint->vrr_classes[8][10] = int_stack + 58836;
 Libint->vrr_classes[8][11] = int_stack + 61806;
 Libint->vrr_classes[8][12] = int_stack + 65316;
 Libint->vrr_classes[8][13] = int_stack + 69411;
 Libint->vrr_classes[8][14] = int_stack + 74136;
 Libint->vrr_classes[8][15] = int_stack + 79536;
 Libint->vrr_classes[8][16] = int_stack + 85656;
 Libint->vrr_classes[9][8] = int_stack + 92541;
 Libint->vrr_classes[9][9] = int_stack + 95016;
 Libint->vrr_classes[9][10] = int_stack + 98041;
 Libint->vrr_classes[9][11] = int_stack + 101671;
 Libint->vrr_classes[9][12] = int_stack + 105961;
 Libint->vrr_classes[9][13] = int_stack + 110966;
 Libint->vrr_classes[9][14] = int_stack + 116741;
 Libint->vrr_classes[9][15] = int_stack + 123341;
 Libint->vrr_classes[9][16] = int_stack + 130821;
 Libint->vrr_classes[10][8] = int_stack + 139236;
 Libint->vrr_classes[10][9] = int_stack + 142206;
 Libint->vrr_classes[10][10] = int_stack + 145836;
 Libint->vrr_classes[10][11] = int_stack + 150192;
 Libint->vrr_classes[10][12] = int_stack + 155340;
 Libint->vrr_classes[10][13] = int_stack + 161346;
 Libint->vrr_classes[10][14] = int_stack + 168276;
 Libint->vrr_classes[10][15] = int_stack + 176196;
 Libint->vrr_classes[10][16] = int_stack + 185172;
 memset(int_stack,0,195270*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 195270;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_igll(Libint, Data);
   Data++;
 }
 /*--- compute (i0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+195270,int_stack+1260,int_stack+0,28);
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+199050,int_stack+2800,int_stack+1260,28);
 /*--- compute (i0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+203670,int_stack+199050,int_stack+195270,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+211230,int_stack+4648,int_stack+2800,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+216774,int_stack+211230,int_stack+199050,28);
 /*--- compute (i0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+226014,int_stack+216774,int_stack+203670,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195270,int_stack+6832,int_stack+4648,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+238614,int_stack+195270,int_stack+211230,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+249702,int_stack+238614,int_stack+216774,28);
 /*--- compute (i0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+201822,int_stack+249702,int_stack+226014,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+220722,int_stack+9380,int_stack+6832,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+265102,int_stack+220722,int_stack+195270,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+278206,int_stack+265102,int_stack+238614,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+296686,int_stack+278206,int_stack+249702,28);
 /*--- compute (i0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+228366,int_stack+296686,int_stack+201822,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+195270,int_stack+12320,int_stack+9380,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+204090,int_stack+195270,int_stack+220722,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+319786,int_stack+204090,int_stack+265102,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+341626,int_stack+319786,int_stack+278206,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+254826,int_stack+341626,int_stack+296686,28);
 /*--- compute (i0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+369346,int_stack+254826,int_stack+228366,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+219378,int_stack+15680,int_stack+12320,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+229458,int_stack+219378,int_stack+195270,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+287166,int_stack+229458,int_stack+204090,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+404626,int_stack+287166,int_stack+319786,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+437386,int_stack+404626,int_stack+341626,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+312646,int_stack+437386,int_stack+254826,28);
 /*--- compute (i0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+476194,int_stack+312646,int_stack+369346,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+195270,int_stack+19488,int_stack+15680,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+247098,int_stack+195270,int_stack+219378,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+195270,int_stack+247098,int_stack+229458,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+224670,int_stack+195270,int_stack+287166,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+262890,int_stack+224670,int_stack+404626,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+195270,int_stack+262890,int_stack+437386,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+247014,int_stack+195270,int_stack+312646,28);
 /*--- compute (i0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+302454,int_stack+247014,int_stack+476194,28);
 /*--- compute (k0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+195270,int_stack+25392,int_stack+23772,36);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+200130,int_stack+27372,int_stack+25392,36);
 /*--- compute (k0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+206070,int_stack+200130,int_stack+195270,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+215790,int_stack+29748,int_stack+27372,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+222918,int_stack+215790,int_stack+200130,36);
 /*--- compute (k0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+234798,int_stack+222918,int_stack+206070,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195270,int_stack+32556,int_stack+29748,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+250998,int_stack+195270,int_stack+215790,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+265254,int_stack+250998,int_stack+222918,36);
 /*--- compute (k0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+203694,int_stack+265254,int_stack+234798,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+227994,int_stack+35832,int_stack+32556,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+285054,int_stack+227994,int_stack+195270,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+359154,int_stack+285054,int_stack+250998,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+382914,int_stack+359154,int_stack+265254,36);
 /*--- compute (k0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+237822,int_stack+382914,int_stack+203694,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+195270,int_stack+39612,int_stack+35832,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+206610,int_stack+195270,int_stack+227994,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+412614,int_stack+206610,int_stack+285054,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+440694,int_stack+412614,int_stack+359154,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+476334,int_stack+440694,int_stack+382914,36);
 /*--- compute (k0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+359154,int_stack+476334,int_stack+237822,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+226266,int_stack+43932,int_stack+39612,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+239226,int_stack+226266,int_stack+195270,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+261906,int_stack+239226,int_stack+206610,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+261906,int_stack+412614,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+517914,int_stack+0,int_stack+440694,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+404514,int_stack+517914,int_stack+476334,36);
 /*--- compute (k0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+567810,int_stack+404514,int_stack+359154,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+359154,int_stack+48828,int_stack+43932,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+373842,int_stack+359154,int_stack+226266,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+195270,int_stack+373842,int_stack+239226,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+459954,int_stack+195270,int_stack+261906,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+195270,int_stack+459954,int_stack+0,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+626130,int_stack+195270,int_stack+517914,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+195270,int_stack+626130,int_stack+404514,36);
 /*--- compute (k0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+359154,int_stack+195270,int_stack+567810,36);
 /*--- compute (ip|ll) ---*/
 hrr1_build_ip(Libint->AB,int_stack+432054,int_stack+359154,int_stack+302454,2025);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+195270,int_stack+56361,int_stack+54336,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+201345,int_stack+58836,int_stack+56361,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+208770,int_stack+201345,int_stack+195270,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+220920,int_stack+61806,int_stack+58836,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+229830,int_stack+220920,int_stack+201345,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+244680,int_stack+229830,int_stack+208770,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195270,int_stack+65316,int_stack+61806,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+264930,int_stack+195270,int_stack+220920,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+282750,int_stack+264930,int_stack+229830,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+205800,int_stack+282750,int_stack+244680,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+236175,int_stack+69411,int_stack+65316,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+307500,int_stack+236175,int_stack+195270,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+328560,int_stack+307500,int_stack+264930,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+0,int_stack+328560,int_stack+282750,45);
 /*--- compute (l0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+248460,int_stack+0,int_stack+205800,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+195270,int_stack+74136,int_stack+69411,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+209445,int_stack+195270,int_stack+236175,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37125,int_stack+209445,int_stack+307500,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+602154,int_stack+37125,int_stack+328560,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+290985,int_stack+602154,int_stack+0,45);
 /*--- compute (l0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+646704,int_stack+290985,int_stack+248460,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+79536,int_stack+74136,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+234015,int_stack+0,int_stack+195270,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+703404,int_stack+234015,int_stack+209445,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+744354,int_stack+703404,int_stack+37125,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+16200,int_stack+744354,int_stack+602154,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+797004,int_stack+16200,int_stack+290985,45);
 /*--- compute (l0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+262365,int_stack+797004,int_stack+646704,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+602154,int_stack+85656,int_stack+79536,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+620514,int_stack+602154,int_stack+0,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+652914,int_stack+620514,int_stack+234015,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+195270,int_stack+652914,int_stack+703404,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+602154,int_stack+195270,int_stack+744354,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+675864,int_stack+602154,int_stack+16200,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+675864,int_stack+797004,45);
 /*--- compute (l0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+602154,int_stack+0,int_stack+262365,45);
 /*--- compute (kp|ll) ---*/
 hrr1_build_kp(Libint->AB,int_stack+693279,int_stack+602154,int_stack+359154,2025);
 /*--- compute (id|ll) ---*/
 hrr1_build_id(Libint->AB,int_stack+911979,int_stack+693279,int_stack+432054,2025);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+95016,int_stack+92541,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+7425,int_stack+98041,int_stack+95016,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+16500,int_stack+7425,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31350,int_stack+101671,int_stack+98041,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+42240,int_stack+31350,int_stack+7425,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+60390,int_stack+42240,int_stack+16500,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+105961,int_stack+101671,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+195270,int_stack+0,int_stack+31350,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+217050,int_stack+195270,int_stack+42240,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+12870,int_stack+217050,int_stack+60390,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+49995,int_stack+110966,int_stack+105961,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+65010,int_stack+49995,int_stack+0,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+247300,int_stack+65010,int_stack+195270,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+283600,int_stack+247300,int_stack+217050,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+195270,int_stack+283600,int_stack+12870,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+116741,int_stack+110966,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+17325,int_stack+0,int_stack+49995,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+328975,int_stack+17325,int_stack+65010,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+47355,int_stack+328975,int_stack+247300,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+371875,int_stack+47355,int_stack+283600,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+247245,int_stack+371875,int_stack+195270,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+195270,int_stack+123341,int_stack+116741,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+435400,int_stack+195270,int_stack+0,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+470050,int_stack+435400,int_stack+17325,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+520100,int_stack+470050,int_stack+328975,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1252179,int_stack+520100,int_stack+47355,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+1252179,int_stack+371875,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+316545,int_stack+0,int_stack+247245,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+84700,int_stack+130821,int_stack+123341,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+215070,int_stack+84700,int_stack+195270,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+254670,int_stack+215070,int_stack+435400,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1328409,int_stack+254670,int_stack+470050,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+195270,int_stack+1328409,int_stack+520100,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+405645,int_stack+195270,int_stack+1252179,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1252179,int_stack+405645,int_stack+0,55);
 /*--- compute (m0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1252179,int_stack+316545,55);
 /*--- compute (lp|ll) ---*/
 hrr1_build_lp(Libint->AB,int_stack+195270,int_stack+0,int_stack+602154,2025);
 /*--- compute (kd|ll) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1252179,int_stack+195270,int_stack+693279,2025);
 /*--- compute (if|ll) ---*/
 hrr1_build_if(Libint->AB,int_stack+1689579,int_stack+1252179,int_stack+911979,2025);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+111375,int_stack+142206,int_stack+139236,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+120285,int_stack+145836,int_stack+142206,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+468645,int_stack+120285,int_stack+111375,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+131175,int_stack+150192,int_stack+145836,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+486465,int_stack+131175,int_stack+120285,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+508245,int_stack+486465,int_stack+468645,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+468645,int_stack+155340,int_stack+150192,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+537945,int_stack+468645,int_stack+131175,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+111375,int_stack+537945,int_stack+486465,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+564081,int_stack+111375,int_stack+508245,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+484089,int_stack+161346,int_stack+155340,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+502107,int_stack+484089,int_stack+468645,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+608631,int_stack+502107,int_stack+537945,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+652191,int_stack+608631,int_stack+111375,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+706641,int_stack+652191,int_stack+564081,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111375,int_stack+168276,int_stack+161346,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+132165,int_stack+111375,int_stack+484089,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+532995,int_stack+132165,int_stack+502107,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+769011,int_stack+532995,int_stack+608631,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+834351,int_stack+769011,int_stack+652191,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+584475,int_stack+834351,int_stack+706641,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+468645,int_stack+176196,int_stack+168276,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+667635,int_stack+468645,int_stack+111375,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+910581,int_stack+667635,int_stack+132165,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+970641,int_stack+910581,int_stack+532995,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+492405,int_stack+970641,int_stack+769011,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+709215,int_stack+492405,int_stack+834351,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1047861,int_stack+709215,int_stack+584475,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+111375,int_stack+185172,int_stack+176196,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+138303,int_stack+111375,int_stack+468645,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+583881,int_stack+138303,int_stack+667635,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+810855,int_stack+583881,int_stack+910581,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+583881,int_stack+810855,int_stack+970641,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+810855,int_stack+583881,int_stack+492405,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+468645,int_stack+810855,int_stack+709215,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+599325,int_stack+468645,int_stack+1047861,66);
 /*--- compute (mp|ll) ---*/
 hrr1_build_mp(Libint->AB,int_stack+732975,int_stack+599325,int_stack+0,2025);
 /*--- compute (ld|ll) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2256579,int_stack+732975,int_stack+195270,2025);
 /*--- compute (kf|ll) ---*/
 hrr1_build_kf(Libint->AB,int_stack+0,int_stack+2256579,int_stack+1252179,2025);
 /*--- compute (ig|ll) ---*/
 hrr1_build_ig(Libint->AB,int_stack+729000,int_stack+0,int_stack+1689579,2025);
 return int_stack+729000;}
