/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihmk(Libint_t*, prim_data*);

  /* Computes quartets of (ih|mk) integrals */

REALTYPE *hrr_order_ihmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[6][14] = int_stack + 11060;
 Libint->vrr_classes[6][15] = int_stack + 14420;
 Libint->vrr_classes[6][16] = int_stack + 18228;
 Libint->vrr_classes[7][9] = int_stack + 22512;
 Libint->vrr_classes[7][10] = int_stack + 24492;
 Libint->vrr_classes[7][11] = int_stack + 26868;
 Libint->vrr_classes[7][12] = int_stack + 29676;
 Libint->vrr_classes[7][13] = int_stack + 32952;
 Libint->vrr_classes[7][14] = int_stack + 36732;
 Libint->vrr_classes[7][15] = int_stack + 41052;
 Libint->vrr_classes[7][16] = int_stack + 45948;
 Libint->vrr_classes[8][9] = int_stack + 51456;
 Libint->vrr_classes[8][10] = int_stack + 53931;
 Libint->vrr_classes[8][11] = int_stack + 56901;
 Libint->vrr_classes[8][12] = int_stack + 60411;
 Libint->vrr_classes[8][13] = int_stack + 64506;
 Libint->vrr_classes[8][14] = int_stack + 69231;
 Libint->vrr_classes[8][15] = int_stack + 74631;
 Libint->vrr_classes[8][16] = int_stack + 80751;
 Libint->vrr_classes[9][9] = int_stack + 87636;
 Libint->vrr_classes[9][10] = int_stack + 90661;
 Libint->vrr_classes[9][11] = int_stack + 94291;
 Libint->vrr_classes[9][12] = int_stack + 98581;
 Libint->vrr_classes[9][13] = int_stack + 103586;
 Libint->vrr_classes[9][14] = int_stack + 109361;
 Libint->vrr_classes[9][15] = int_stack + 115961;
 Libint->vrr_classes[9][16] = int_stack + 123441;
 Libint->vrr_classes[10][9] = int_stack + 131856;
 Libint->vrr_classes[10][10] = int_stack + 135486;
 Libint->vrr_classes[10][11] = int_stack + 139842;
 Libint->vrr_classes[10][12] = int_stack + 144990;
 Libint->vrr_classes[10][13] = int_stack + 150996;
 Libint->vrr_classes[10][14] = int_stack + 157926;
 Libint->vrr_classes[10][15] = int_stack + 165846;
 Libint->vrr_classes[10][16] = int_stack + 174822;
 Libint->vrr_classes[11][9] = int_stack + 184920;
 Libint->vrr_classes[11][10] = int_stack + 189210;
 Libint->vrr_classes[11][11] = int_stack + 194358;
 Libint->vrr_classes[11][12] = int_stack + 200442;
 Libint->vrr_classes[11][13] = int_stack + 207540;
 Libint->vrr_classes[11][14] = int_stack + 215730;
 Libint->vrr_classes[11][15] = int_stack + 225090;
 Libint->vrr_classes[11][16] = int_stack + 235698;
 memset(int_stack,0,247632*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 247632;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihmk(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+247632,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+252252,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+257796,int_stack+252252,int_stack+247632,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+267036,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+273588,int_stack+267036,int_stack+252252,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+284676,int_stack+273588,int_stack+257796,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+247632,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+300076,int_stack+247632,int_stack+267036,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+313180,int_stack+300076,int_stack+273588,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+255276,int_stack+313180,int_stack+284676,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+278376,int_stack+11060,int_stack+8120,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+331660,int_stack+278376,int_stack+247632,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+346948,int_stack+331660,int_stack+300076,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+368788,int_stack+346948,int_stack+313180,28);
 /*--- compute (i0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+287196,int_stack+368788,int_stack+255276,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+247632,int_stack+14420,int_stack+11060,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+257712,int_stack+247632,int_stack+278376,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+396508,int_stack+257712,int_stack+331660,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+421988,int_stack+396508,int_stack+346948,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+319536,int_stack+421988,int_stack+368788,28);
 /*--- compute (i0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+454748,int_stack+319536,int_stack+287196,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+275352,int_stack+18228,int_stack+14420,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+286776,int_stack+275352,int_stack+247632,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+358344,int_stack+286776,int_stack+257712,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+247632,int_stack+358344,int_stack+396508,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+358344,int_stack+247632,int_stack+421988,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+247632,int_stack+358344,int_stack+319536,28);
 /*--- compute (i0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+299376,int_stack+247632,int_stack+454748,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+247632,int_stack+24492,int_stack+22512,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+253572,int_stack+26868,int_stack+24492,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+260700,int_stack+253572,int_stack+247632,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+272580,int_stack+29676,int_stack+26868,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+281004,int_stack+272580,int_stack+253572,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+354816,int_stack+281004,int_stack+260700,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+247632,int_stack+32952,int_stack+29676,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+374616,int_stack+247632,int_stack+272580,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+391464,int_stack+374616,int_stack+281004,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+257460,int_stack+391464,int_stack+354816,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+354816,int_stack+36732,int_stack+32952,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+415224,int_stack+354816,int_stack+247632,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+434880,int_stack+415224,int_stack+374616,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+434880,int_stack+391464,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+366156,int_stack+0,int_stack+257460,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+247632,int_stack+41052,int_stack+36732,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+260592,int_stack+247632,int_stack+354816,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+462960,int_stack+260592,int_stack+415224,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+495720,int_stack+462960,int_stack+434880,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+407736,int_stack+495720,int_stack+0,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+537840,int_stack+407736,int_stack+366156,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+45948,int_stack+41052,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+14688,int_stack+0,int_stack+247632,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+354816,int_stack+14688,int_stack+260592,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+247632,int_stack+354816,int_stack+462960,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+593280,int_stack+247632,int_stack+495720,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+457632,int_stack+593280,int_stack+407736,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+354816,int_stack+457632,int_stack+537840,36);
 /*--- compute (ip|mk) ---*/
 hrr1_build_ip(Libint->AB,int_stack+426096,int_stack+354816,int_stack+299376,1980);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+247632,int_stack+53931,int_stack+51456,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+255057,int_stack+56901,int_stack+53931,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+263967,int_stack+255057,int_stack+247632,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+278817,int_stack+60411,int_stack+56901,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+289347,int_stack+278817,int_stack+255057,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+307167,int_stack+289347,int_stack+263967,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+247632,int_stack+64506,int_stack+60411,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+331917,int_stack+247632,int_stack+278817,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+592416,int_stack+331917,int_stack+289347,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+259917,int_stack+592416,int_stack+307167,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+297042,int_stack+69231,int_stack+64506,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+622116,int_stack+297042,int_stack+247632,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+622116,int_stack+331917,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+646686,int_stack+0,int_stack+592416,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+691236,int_stack+646686,int_stack+259917,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+592416,int_stack+74631,int_stack+69231,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+247632,int_stack+592416,int_stack+297042,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+275982,int_stack+247632,int_stack+622116,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+743211,int_stack+275982,int_stack+0,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+743211,int_stack+646686,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+608616,int_stack+0,int_stack+691236,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+677916,int_stack+80751,int_stack+74631,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+696276,int_stack+677916,int_stack+592416,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+795861,int_stack+696276,int_stack+247632,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+677916,int_stack+795861,int_stack+275982,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+247632,int_stack+677916,int_stack+743211,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+677916,int_stack+247632,int_stack+0,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+247632,int_stack+677916,int_stack+608616,45);
 /*--- compute (kp|mk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+592416,int_stack+247632,int_stack+354816,1980);
 /*--- compute (id|mk) ---*/
 hrr1_build_id(Libint->AB,int_stack+806256,int_stack+592416,int_stack+426096,1980);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+90661,int_stack+87636,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+9075,int_stack+94291,int_stack+90661,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+19965,int_stack+9075,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+38115,int_stack+98581,int_stack+94291,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+50985,int_stack+38115,int_stack+9075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+336732,int_stack+50985,int_stack+19965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+103586,int_stack+98581,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72765,int_stack+0,int_stack+38115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+366982,int_stack+72765,int_stack+50985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+15015,int_stack+366982,int_stack+336732,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+336732,int_stack+109361,int_stack+103586,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+403282,int_stack+336732,int_stack+0,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+433312,int_stack+403282,int_stack+72765,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+476212,int_stack+433312,int_stack+366982,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1138896,int_stack+476212,int_stack+15015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+115961,int_stack+109361,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+336732,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+336732,int_stack+19800,int_stack+403282,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1202421,int_stack+336732,int_stack+433312,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+386782,int_stack+1202421,int_stack+476212,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+463012,int_stack+386782,int_stack+1138896,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1138896,int_stack+123441,int_stack+115961,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1161336,int_stack+1138896,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+54450,int_stack+1161336,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1266771,int_stack+54450,int_stack+336732,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+1266771,int_stack+1202421,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1138896,int_stack+0,int_stack+386782,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+0,int_stack+1138896,int_stack+463012,55);
 /*--- compute (lp|mk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1138896,int_stack+0,int_stack+247632,1980);
 /*--- compute (kd|mk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1406196,int_stack+1138896,int_stack+592416,1980);
 /*--- compute (if|mk) ---*/
 hrr1_build_if(Libint->AB,int_stack+247632,int_stack+1406196,int_stack+806256,1980);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+802032,int_stack+135486,int_stack+131856,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+812922,int_stack+139842,int_stack+135486,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+825990,int_stack+812922,int_stack+802032,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+847770,int_stack+144990,int_stack+139842,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+863214,int_stack+847770,int_stack+812922,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+889350,int_stack+863214,int_stack+825990,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+802032,int_stack+150996,int_stack+144990,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+925650,int_stack+802032,int_stack+847770,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+956538,int_stack+925650,int_stack+863214,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+820050,int_stack+956538,int_stack+889350,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+874500,int_stack+157926,int_stack+150996,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1000098,int_stack+874500,int_stack+802032,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1036134,int_stack+1000098,int_stack+925650,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1833876,int_stack+1036134,int_stack+956538,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+895290,int_stack+1833876,int_stack+820050,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+802032,int_stack+165846,int_stack+157926,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+825792,int_stack+802032,int_stack+874500,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1899216,int_stack+825792,int_stack+1000098,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1959276,int_stack+1899216,int_stack+1036134,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+971520,int_stack+1959276,int_stack+1833876,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2036496,int_stack+971520,int_stack+895290,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1833876,int_stack+174822,int_stack+165846,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+867372,int_stack+1833876,int_stack+802032,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1062996,int_stack+867372,int_stack+825792,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+802032,int_stack+1062996,int_stack+1899216,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1833876,int_stack+802032,int_stack+1959276,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+802032,int_stack+1833876,int_stack+971520,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1833876,int_stack+802032,int_stack+2036496,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+802032,int_stack+1833876,int_stack+0,1980);
 /*--- compute (ld|mk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1964556,int_stack+802032,int_stack+1138896,1980);
 /*--- compute (kf|mk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2499156,int_stack+1964556,int_stack+1406196,1980);
 /*--- compute (ig|mk) ---*/
 hrr1_build_ig(Libint->AB,int_stack+3211956,int_stack+2499156,int_stack+247632,1980);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+247632,int_stack+189210,int_stack+184920,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+260502,int_stack+194358,int_stack+189210,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+275946,int_stack+260502,int_stack+247632,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+301686,int_stack+200442,int_stack+194358,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+319938,int_stack+301686,int_stack+260502,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+350826,int_stack+319938,int_stack+275946,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+247632,int_stack+207540,int_stack+200442,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+393726,int_stack+247632,int_stack+301686,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+430230,int_stack+393726,int_stack+319938,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+268926,int_stack+430230,int_stack+350826,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+333276,int_stack+215730,int_stack+207540,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+481710,int_stack+333276,int_stack+247632,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+524298,int_stack+481710,int_stack+393726,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+585138,int_stack+524298,int_stack+430230,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+357846,int_stack+585138,int_stack+268926,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+247632,int_stack+225090,int_stack+215730,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+275712,int_stack+247632,int_stack+333276,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+662358,int_stack+275712,int_stack+481710,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+662358,int_stack+524298,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+447936,int_stack+0,int_stack+585138,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+91260,int_stack+447936,int_stack+357846,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+324852,int_stack+235698,int_stack+225090,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+356676,int_stack+324852,int_stack+247632,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+556044,int_stack+356676,int_stack+275712,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+211380,int_stack+556044,int_stack+662358,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+556044,int_stack+211380,int_stack+0,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+211380,int_stack+556044,int_stack+447936,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+355524,int_stack+211380,int_stack+91260,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1128732,int_stack+355524,int_stack+1833876,1980);
 /*--- compute (md|mk) ---*/
 hrr1_build_md(Libint->AB,int_stack+0,int_stack+1128732,int_stack+802032,1980);
 /*--- compute (lf|mk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+653400,int_stack+0,int_stack+1964556,1980);
 /*--- compute (kg|mk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+4043556,int_stack+653400,int_stack+2499156,1980);
 /*--- compute (ih|mk) ---*/
 hrr1_build_ih(Libint->AB,int_stack+0,int_stack+4043556,int_stack+3211956,1980);
 return int_stack+0;}
