/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ihng(Libint_t*, prim_data*);

  /* Computes quartets of (ih|ng) integrals */

REALTYPE *hrr_order_ihng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[7][10] = int_stack + 12880;
 Libint->vrr_classes[7][11] = int_stack + 15256;
 Libint->vrr_classes[7][12] = int_stack + 18064;
 Libint->vrr_classes[7][13] = int_stack + 21340;
 Libint->vrr_classes[7][14] = int_stack + 25120;
 Libint->vrr_classes[8][10] = int_stack + 29440;
 Libint->vrr_classes[8][11] = int_stack + 32410;
 Libint->vrr_classes[8][12] = int_stack + 35920;
 Libint->vrr_classes[8][13] = int_stack + 40015;
 Libint->vrr_classes[8][14] = int_stack + 44740;
 Libint->vrr_classes[9][10] = int_stack + 50140;
 Libint->vrr_classes[9][11] = int_stack + 53770;
 Libint->vrr_classes[9][12] = int_stack + 58060;
 Libint->vrr_classes[9][13] = int_stack + 63065;
 Libint->vrr_classes[9][14] = int_stack + 68840;
 Libint->vrr_classes[10][10] = int_stack + 75440;
 Libint->vrr_classes[10][11] = int_stack + 79796;
 Libint->vrr_classes[10][12] = int_stack + 84944;
 Libint->vrr_classes[10][13] = int_stack + 90950;
 Libint->vrr_classes[10][14] = int_stack + 97880;
 Libint->vrr_classes[11][10] = int_stack + 105800;
 Libint->vrr_classes[11][11] = int_stack + 110948;
 Libint->vrr_classes[11][12] = int_stack + 117032;
 Libint->vrr_classes[11][13] = int_stack + 124130;
 Libint->vrr_classes[11][14] = int_stack + 132320;
 memset(int_stack,0,141680*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 141680;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ihng(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141680,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+147224,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+153776,int_stack+147224,int_stack+141680,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+164864,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+172508,int_stack+164864,int_stack+147224,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+185612,int_stack+172508,int_stack+153776,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+141680,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+204092,int_stack+141680,int_stack+164864,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+141680,int_stack+204092,int_stack+172508,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+204092,int_stack+141680,int_stack+185612,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141680,int_stack+15256,int_stack+12880,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+148808,int_stack+18064,int_stack+15256,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+157232,int_stack+148808,int_stack+141680,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+171488,int_stack+21340,int_stack+18064,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+181316,int_stack+171488,int_stack+148808,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+231812,int_stack+181316,int_stack+157232,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+141680,int_stack+25120,int_stack+21340,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+141680,int_stack+171488,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+141680,int_stack+0,int_stack+181316,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+255572,int_stack+141680,int_stack+231812,36);
 /*--- compute (ip|ng) ---*/
 hrr1_build_ip(Libint->AB,int_stack+291212,int_stack+255572,int_stack+204092,990);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141680,int_stack+32410,int_stack+29440,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+150590,int_stack+35920,int_stack+32410,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+161120,int_stack+150590,int_stack+141680,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+178940,int_stack+40015,int_stack+35920,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+191225,int_stack+178940,int_stack+150590,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+212285,int_stack+191225,int_stack+161120,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+141680,int_stack+44740,int_stack+40015,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+141680,int_stack+178940,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+141680,int_stack+0,int_stack+191225,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+141680,int_stack+212285,45);
 /*--- compute (kp|ng) ---*/
 hrr1_build_kp(Libint->AB,int_stack+141680,int_stack+0,int_stack+255572,990);
 /*--- compute (id|ng) ---*/
 hrr1_build_id(Libint->AB,int_stack+374372,int_stack+141680,int_stack+291212,990);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+248600,int_stack+53770,int_stack+50140,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+259490,int_stack+58060,int_stack+53770,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+272360,int_stack+259490,int_stack+248600,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+294140,int_stack+63065,int_stack+58060,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+309155,int_stack+294140,int_stack+259490,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+334895,int_stack+309155,int_stack+272360,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+248600,int_stack+68840,int_stack+63065,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+44550,int_stack+248600,int_stack+294140,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+248600,int_stack+44550,int_stack+309155,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+540692,int_stack+248600,int_stack+334895,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+595142,int_stack+540692,int_stack+0,990);
 /*--- compute (kd|ng) ---*/
 hrr1_build_kd(Libint->AB,int_stack+728792,int_stack+595142,int_stack+141680,990);
 /*--- compute (if|ng) ---*/
 hrr1_build_if(Libint->AB,int_stack+942632,int_stack+728792,int_stack+374372,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141680,int_stack+79796,int_stack+75440,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+154748,int_stack+84944,int_stack+79796,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+170192,int_stack+154748,int_stack+141680,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+196328,int_stack+90950,int_stack+84944,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+214346,int_stack+196328,int_stack+154748,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+245234,int_stack+214346,int_stack+170192,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+141680,int_stack+97880,int_stack+90950,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+288794,int_stack+141680,int_stack+196328,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+141680,int_stack+288794,int_stack+214346,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+288794,int_stack+141680,int_stack+245234,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+354134,int_stack+288794,int_stack+540692,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1219832,int_stack+354134,int_stack+595142,990);
 /*--- compute (kf|ng) ---*/
 hrr1_build_kf(Libint->AB,int_stack+1487132,int_stack+1219832,int_stack+728792,990);
 /*--- compute (ig|ng) ---*/
 hrr1_build_ig(Libint->AB,int_stack+517484,int_stack+1487132,int_stack+942632,990);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+141680,int_stack+110948,int_stack+105800,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+157124,int_stack+117032,int_stack+110948,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+175376,int_stack+157124,int_stack+141680,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+206264,int_stack+124130,int_stack+117032,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+227558,int_stack+206264,int_stack+157124,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+933284,int_stack+227558,int_stack+175376,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+141680,int_stack+132320,int_stack+124130,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+984764,int_stack+141680,int_stack+206264,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1027352,int_stack+984764,int_stack+227558,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1088192,int_stack+1027352,int_stack+933284,78);
 /*--- compute (np|ng) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+1088192,int_stack+288794,990);
 /*--- compute (md|ng) ---*/
 hrr1_build_md(Libint->AB,int_stack+1843532,int_stack+0,int_stack+354134,990);
 /*--- compute (lf|ng) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+1843532,int_stack+1219832,990);
 /*--- compute (kg|ng) ---*/
 hrr1_build_kg(Libint->AB,int_stack+933284,int_stack+0,int_stack+1487132,990);
 /*--- compute (ih|ng) ---*/
 hrr1_build_ih(Libint->AB,int_stack+1467884,int_stack+933284,int_stack+517484,990);
 return int_stack+1467884;}
