/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipmg(Libint_t*, prim_data*);

  /* Computes quartets of (ip|mg) integrals */

REALTYPE *hrr_order_ipmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][9] = int_stack + 0;
 Libint->vrr_classes[6][10] = int_stack + 1540;
 Libint->vrr_classes[6][11] = int_stack + 3388;
 Libint->vrr_classes[6][12] = int_stack + 5572;
 Libint->vrr_classes[6][13] = int_stack + 8120;
 Libint->vrr_classes[7][9] = int_stack + 11060;
 Libint->vrr_classes[7][10] = int_stack + 13040;
 Libint->vrr_classes[7][11] = int_stack + 15416;
 Libint->vrr_classes[7][12] = int_stack + 18224;
 Libint->vrr_classes[7][13] = int_stack + 21500;
 memset(int_stack,0,25280*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 25280;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipmg(Libint, Data);
   Data++;
 }
 /*--- compute (i0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25280,int_stack+1540,int_stack+0,28);
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+29900,int_stack+3388,int_stack+1540,28);
 /*--- compute (i0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+35444,int_stack+29900,int_stack+25280,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+44684,int_stack+5572,int_stack+3388,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51236,int_stack+44684,int_stack+29900,28);
 /*--- compute (i0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+62324,int_stack+51236,int_stack+35444,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+25280,int_stack+8120,int_stack+5572,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+77724,int_stack+25280,int_stack+44684,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25280,int_stack+77724,int_stack+51236,28);
 /*--- compute (i0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+77724,int_stack+25280,int_stack+62324,28);
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+25280,int_stack+13040,int_stack+11060,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+31220,int_stack+15416,int_stack+13040,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38348,int_stack+31220,int_stack+25280,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+50228,int_stack+18224,int_stack+15416,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58652,int_stack+50228,int_stack+31220,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+100824,int_stack+58652,int_stack+38348,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+25280,int_stack+21500,int_stack+18224,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+25280,int_stack+50228,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+16848,int_stack+0,int_stack+58652,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+40608,int_stack+16848,int_stack+100824,36);
 /*--- compute (ip|mg) ---*/
 hrr1_build_ip(Libint->AB,int_stack+100824,int_stack+40608,int_stack+77724,825);
 return int_stack+100824;}
