/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ipnn(Libint_t*, prim_data*);

  /* Computes quartets of (ip|nn) integrals */

REALTYPE *hrr_order_ipnn(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[6][10] = int_stack + 0;
 Libint->vrr_classes[6][11] = int_stack + 1848;
 Libint->vrr_classes[6][12] = int_stack + 4032;
 Libint->vrr_classes[6][13] = int_stack + 6580;
 Libint->vrr_classes[6][14] = int_stack + 9520;
 Libint->vrr_classes[6][15] = int_stack + 12880;
 Libint->vrr_classes[6][16] = int_stack + 16688;
 Libint->vrr_classes[6][17] = int_stack + 20972;
 Libint->vrr_classes[6][18] = int_stack + 25760;
 Libint->vrr_classes[6][19] = int_stack + 31080;
 Libint->vrr_classes[6][20] = int_stack + 36960;
 Libint->vrr_classes[7][10] = int_stack + 43428;
 Libint->vrr_classes[7][11] = int_stack + 45804;
 Libint->vrr_classes[7][12] = int_stack + 48612;
 Libint->vrr_classes[7][13] = int_stack + 51888;
 Libint->vrr_classes[7][14] = int_stack + 55668;
 Libint->vrr_classes[7][15] = int_stack + 59988;
 Libint->vrr_classes[7][16] = int_stack + 64884;
 Libint->vrr_classes[7][17] = int_stack + 70392;
 Libint->vrr_classes[7][18] = int_stack + 76548;
 Libint->vrr_classes[7][19] = int_stack + 83388;
 Libint->vrr_classes[7][20] = int_stack + 90948;
 memset(int_stack,0,99264*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 99264;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ipnn(Libint, Data);
   Data++;
 }
 /*--- compute (i0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+99264,int_stack+1848,int_stack+0,28);
 /*--- compute (i0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+104808,int_stack+4032,int_stack+1848,28);
 /*--- compute (i0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111360,int_stack+104808,int_stack+99264,28);
 /*--- compute (i0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+122448,int_stack+6580,int_stack+4032,28);
 /*--- compute (i0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+130092,int_stack+122448,int_stack+104808,28);
 /*--- compute (i0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+143196,int_stack+130092,int_stack+111360,28);
 /*--- compute (i0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99264,int_stack+9520,int_stack+6580,28);
 /*--- compute (i0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+161676,int_stack+99264,int_stack+122448,28);
 /*--- compute (i0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+108084,int_stack+161676,int_stack+130092,28);
 /*--- compute (i0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+176964,int_stack+108084,int_stack+143196,28);
 /*--- compute (i0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+129924,int_stack+12880,int_stack+9520,28);
 /*--- compute (i0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+140004,int_stack+129924,int_stack+99264,28);
 /*--- compute (i0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+204684,int_stack+140004,int_stack+161676,28);
 /*--- compute (i0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+230164,int_stack+204684,int_stack+108084,28);
 /*--- compute (i0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+262924,int_stack+230164,int_stack+176964,28);
 /*--- compute (i0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+99264,int_stack+16688,int_stack+12880,28);
 /*--- compute (i0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+157644,int_stack+99264,int_stack+129924,28);
 /*--- compute (i0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+301732,int_stack+157644,int_stack+140004,28);
 /*--- compute (i0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110688,int_stack+301732,int_stack+204684,28);
 /*--- compute (i0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+177804,int_stack+110688,int_stack+230164,28);
 /*--- compute (i0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+331132,int_stack+177804,int_stack+262924,28);
 /*--- compute (i0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+223668,int_stack+20972,int_stack+16688,28);
 /*--- compute (i0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+236520,int_stack+223668,int_stack+99264,28);
 /*--- compute (i0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+259368,int_stack+236520,int_stack+157644,28);
 /*--- compute (i0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+382876,int_stack+259368,int_stack+301732,28);
 /*--- compute (i0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+426976,int_stack+382876,int_stack+110688,28);
 /*--- compute (i0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+99264,int_stack+426976,int_stack+177804,28);
 /*--- compute (i0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+480484,int_stack+99264,int_stack+331132,28);
 /*--- compute (i0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+160416,int_stack+25760,int_stack+20972,28);
 /*--- compute (i0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+174780,int_stack+160416,int_stack+223668,28);
 /*--- compute (i0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+292968,int_stack+174780,int_stack+236520,28);
 /*--- compute (i0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+200484,int_stack+292968,int_stack+259368,28);
 /*--- compute (i0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+547012,int_stack+200484,int_stack+382876,28);
 /*--- compute (i0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+331048,int_stack+547012,int_stack+426976,28);
 /*--- compute (i0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+608752,int_stack+331048,int_stack+99264,28);
 /*--- compute (i0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+687376,int_stack+608752,int_stack+480484,28);
 /*--- compute (i0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+99264,int_stack+31080,int_stack+25760,28);
 /*--- compute (i0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+115224,int_stack+99264,int_stack+160416,28);
 /*--- compute (i0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+402392,int_stack+115224,int_stack+174780,28);
 /*--- compute (i0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+445232,int_stack+402392,int_stack+292968,28);
 /*--- compute (i0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+250884,int_stack+445232,int_stack+200484,28);
 /*--- compute (i0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+143952,int_stack+250884,int_stack+547012,28);
 /*--- compute (i0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+502352,int_stack+143952,int_stack+331048,28);
 /*--- compute (i0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+770536,int_stack+502352,int_stack+608752,28);
 /*--- compute (i0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+868816,int_stack+770536,int_stack+687376,28);
 /*--- compute (i0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+226272,int_stack+36960,int_stack+31080,28);
 /*--- compute (i0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+321444,int_stack+226272,int_stack+99264,28);
 /*--- compute (i0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+353364,int_stack+321444,int_stack+115224,28);
 /*--- compute (i0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+594080,int_stack+353364,int_stack+402392,28);
 /*--- compute (i0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+321444,int_stack+594080,int_stack+445232,28);
 /*--- compute (i0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+594080,int_stack+321444,int_stack+250884,28);
 /*--- compute (i0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+226272,int_stack+594080,int_stack+143952,28);
 /*--- compute (i0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+594080,int_stack+226272,int_stack+502352,28);
 /*--- compute (i0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+99264,int_stack+594080,int_stack+770536,28);
 /*--- compute (i0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+219384,int_stack+99264,int_stack+868816,28);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+99264,int_stack+45804,int_stack+43428,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+106392,int_stack+48612,int_stack+45804,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+114816,int_stack+106392,int_stack+99264,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+129072,int_stack+51888,int_stack+48612,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+138900,int_stack+129072,int_stack+106392,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+155748,int_stack+138900,int_stack+114816,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99264,int_stack+55668,int_stack+51888,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+179508,int_stack+99264,int_stack+129072,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+110604,int_stack+179508,int_stack+138900,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+341352,int_stack+110604,int_stack+155748,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+138684,int_stack+59988,int_stack+55668,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+151644,int_stack+138684,int_stack+99264,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+376992,int_stack+151644,int_stack+179508,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+174324,int_stack+376992,int_stack+110604,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+409752,int_stack+174324,int_stack+341352,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341352,int_stack+64884,int_stack+59988,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+99264,int_stack+341352,int_stack+138684,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+459648,int_stack+99264,int_stack+151644,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+125184,int_stack+459648,int_stack+376992,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+497448,int_stack+125184,int_stack+174324,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+556416,int_stack+497448,int_stack+409752,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+174324,int_stack+70392,int_stack+64884,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+356040,int_stack+174324,int_stack+341352,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+385416,int_stack+356040,int_stack+99264,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+622944,int_stack+385416,int_stack+459648,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+428616,int_stack+622944,int_stack+125184,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+679644,int_stack+428616,int_stack+497448,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+758268,int_stack+679644,int_stack+556416,36);
 /*--- compute (k0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+99264,int_stack+76548,int_stack+70392,36);
 /*--- compute (k0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+117732,int_stack+99264,int_stack+174324,36);
 /*--- compute (k0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+150780,int_stack+117732,int_stack+356040,36);
 /*--- compute (k0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+497412,int_stack+150780,int_stack+385416,36);
 /*--- compute (k0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+341352,int_stack+497412,int_stack+622944,36);
 /*--- compute (k0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+562212,int_stack+341352,int_stack+428616,36);
 /*--- compute (k0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+843804,int_stack+562212,int_stack+679644,36);
 /*--- compute (k0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+944892,int_stack+843804,int_stack+758268,36);
 /*--- compute (k0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+420732,int_stack+83388,int_stack+76548,36);
 /*--- compute (k0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+441252,int_stack+420732,int_stack+99264,36);
 /*--- compute (k0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+653940,int_stack+441252,int_stack+117732,36);
 /*--- compute (k0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+709020,int_stack+653940,int_stack+150780,36);
 /*--- compute (k0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+99264,int_stack+709020,int_stack+497412,36);
 /*--- compute (k0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1051812,int_stack+99264,int_stack+341352,36);
 /*--- compute (k0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1157652,int_stack+1051812,int_stack+562212,36);
 /*--- compute (k0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+478188,int_stack+1157652,int_stack+843804,36);
 /*--- compute (k0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+782460,int_stack+478188,int_stack+944892,36);
 /*--- compute (k0|yp) ---*/
 hrr3_build_yp(Libint->CD,int_stack+341352,int_stack+90948,int_stack+83388,36);
 /*--- compute (k0|xd) ---*/
 hrr3_build_xd(Libint->CD,int_stack+364032,int_stack+341352,int_stack+420732,36);
 /*--- compute (k0|wf) ---*/
 hrr3_build_wf(Libint->CD,int_stack+913140,int_stack+364032,int_stack+441252,36);
 /*--- compute (k0|vg) ---*/
 hrr3_build_vg(Libint->CD,int_stack+341352,int_stack+913140,int_stack+653940,36);
 /*--- compute (k0|uh) ---*/
 hrr3_build_uh(Libint->CD,int_stack+913140,int_stack+341352,int_stack+709020,36);
 /*--- compute (k0|ti) ---*/
 hrr3_build_ti(Libint->CD,int_stack+341352,int_stack+913140,int_stack+99264,36);
 /*--- compute (k0|rk) ---*/
 hrr3_build_rk(Libint->CD,int_stack+913140,int_stack+341352,int_stack+1051812,36);
 /*--- compute (k0|ql) ---*/
 hrr3_build_ql(Libint->CD,int_stack+604548,int_stack+913140,int_stack+1157652,36);
 /*--- compute (k0|om) ---*/
 hrr3_build_om(Libint->CD,int_stack+913140,int_stack+604548,int_stack+478188,36);
 /*--- compute (k0|nn) ---*/
 hrr3_build_nn(Libint->CD,int_stack+1067580,int_stack+913140,int_stack+782460,36);
 /*--- compute (ip|nn) ---*/
 hrr1_build_ip(Libint->AB,int_stack+341352,int_stack+1067580,int_stack+219384,4356);
 return int_stack+341352;}
