/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_k0ml(Libint_t*, prim_data*);

  /* Computes quartets of (k0|ml) integrals */

REALTYPE *hrr_order_k0ml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][9] = int_stack + 0;
 Libint->vrr_classes[7][10] = int_stack + 1980;
 Libint->vrr_classes[7][11] = int_stack + 4356;
 Libint->vrr_classes[7][12] = int_stack + 7164;
 Libint->vrr_classes[7][13] = int_stack + 10440;
 Libint->vrr_classes[7][14] = int_stack + 14220;
 Libint->vrr_classes[7][15] = int_stack + 18540;
 Libint->vrr_classes[7][16] = int_stack + 23436;
 Libint->vrr_classes[7][17] = int_stack + 28944;
 memset(int_stack,0,35100*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 35100;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_k0ml(Libint, Data);
   Data++;
 }
 /*--- compute (k0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+35100,int_stack+1980,int_stack+0,36);
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+41040,int_stack+4356,int_stack+1980,36);
 /*--- compute (k0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+48168,int_stack+41040,int_stack+35100,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+60048,int_stack+7164,int_stack+4356,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+68472,int_stack+60048,int_stack+41040,36);
 /*--- compute (k0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+82728,int_stack+68472,int_stack+48168,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+35100,int_stack+10440,int_stack+7164,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+102528,int_stack+35100,int_stack+60048,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+119376,int_stack+102528,int_stack+68472,36);
 /*--- compute (k0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+44928,int_stack+119376,int_stack+82728,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+74628,int_stack+14220,int_stack+10440,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+143136,int_stack+74628,int_stack+35100,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+162792,int_stack+143136,int_stack+102528,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+190872,int_stack+162792,int_stack+119376,36);
 /*--- compute (k0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+85968,int_stack+190872,int_stack+44928,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+35100,int_stack+18540,int_stack+14220,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48060,int_stack+35100,int_stack+74628,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+226512,int_stack+48060,int_stack+143136,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+259272,int_stack+226512,int_stack+162792,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+127548,int_stack+259272,int_stack+190872,36);
 /*--- compute (k0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+301392,int_stack+127548,int_stack+85968,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+70740,int_stack+23436,int_stack+18540,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+85428,int_stack+70740,int_stack+35100,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+177444,int_stack+85428,int_stack+48060,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+356832,int_stack+177444,int_stack+226512,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+405972,int_stack+356832,int_stack+259272,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+215244,int_stack+405972,int_stack+127548,36);
 /*--- compute (k0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+464940,int_stack+215244,int_stack+301392,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+35100,int_stack+28944,int_stack+23436,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+111348,int_stack+35100,int_stack+70740,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+281772,int_stack+111348,int_stack+85428,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+281772,int_stack+177444,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+281772,int_stack+0,int_stack+356832,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+281772,int_stack+405972,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+281772,int_stack+0,int_stack+215244,36);
 /*--- compute (k0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+281772,int_stack+464940,36);
 return int_stack+0;}
