/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_khnk(Libint_t*, prim_data*);

  /* Computes quartets of (kh|nk) integrals */

REALTYPE *hrr_order_khnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[7][17] = int_stack + 26964;
 Libint->vrr_classes[8][10] = int_stack + 33120;
 Libint->vrr_classes[8][11] = int_stack + 36090;
 Libint->vrr_classes[8][12] = int_stack + 39600;
 Libint->vrr_classes[8][13] = int_stack + 43695;
 Libint->vrr_classes[8][14] = int_stack + 48420;
 Libint->vrr_classes[8][15] = int_stack + 53820;
 Libint->vrr_classes[8][16] = int_stack + 59940;
 Libint->vrr_classes[8][17] = int_stack + 66825;
 Libint->vrr_classes[9][10] = int_stack + 74520;
 Libint->vrr_classes[9][11] = int_stack + 78150;
 Libint->vrr_classes[9][12] = int_stack + 82440;
 Libint->vrr_classes[9][13] = int_stack + 87445;
 Libint->vrr_classes[9][14] = int_stack + 93220;
 Libint->vrr_classes[9][15] = int_stack + 99820;
 Libint->vrr_classes[9][16] = int_stack + 107300;
 Libint->vrr_classes[9][17] = int_stack + 115715;
 Libint->vrr_classes[10][10] = int_stack + 125120;
 Libint->vrr_classes[10][11] = int_stack + 129476;
 Libint->vrr_classes[10][12] = int_stack + 134624;
 Libint->vrr_classes[10][13] = int_stack + 140630;
 Libint->vrr_classes[10][14] = int_stack + 147560;
 Libint->vrr_classes[10][15] = int_stack + 155480;
 Libint->vrr_classes[10][16] = int_stack + 164456;
 Libint->vrr_classes[10][17] = int_stack + 174554;
 Libint->vrr_classes[11][10] = int_stack + 185840;
 Libint->vrr_classes[11][11] = int_stack + 190988;
 Libint->vrr_classes[11][12] = int_stack + 197072;
 Libint->vrr_classes[11][13] = int_stack + 204170;
 Libint->vrr_classes[11][14] = int_stack + 212360;
 Libint->vrr_classes[11][15] = int_stack + 221720;
 Libint->vrr_classes[11][16] = int_stack + 232328;
 Libint->vrr_classes[11][17] = int_stack + 244262;
 Libint->vrr_classes[12][10] = int_stack + 257600;
 Libint->vrr_classes[12][11] = int_stack + 263606;
 Libint->vrr_classes[12][12] = int_stack + 270704;
 Libint->vrr_classes[12][13] = int_stack + 278985;
 Libint->vrr_classes[12][14] = int_stack + 288540;
 Libint->vrr_classes[12][15] = int_stack + 299460;
 Libint->vrr_classes[12][16] = int_stack + 311836;
 Libint->vrr_classes[12][17] = int_stack + 325759;
 memset(int_stack,0,341320*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 341320;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_khnk(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+341320,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+348448,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+356872,int_stack+348448,int_stack+341320,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+371128,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+380956,int_stack+371128,int_stack+348448,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+397804,int_stack+380956,int_stack+356872,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341320,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+421564,int_stack+341320,int_stack+371128,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+352660,int_stack+421564,int_stack+380956,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+441220,int_stack+352660,int_stack+397804,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+380740,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+393700,int_stack+380740,int_stack+341320,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+476860,int_stack+393700,int_stack+421564,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+509620,int_stack+476860,int_stack+352660,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+551740,int_stack+509620,int_stack+441220,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341320,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+416380,int_stack+341320,int_stack+380740,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+601636,int_stack+416380,int_stack+393700,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+356008,int_stack+601636,int_stack+476860,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+442300,int_stack+356008,int_stack+509620,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+639436,int_stack+442300,int_stack+551740,36);
 /*--- compute (k0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+501268,int_stack+26964,int_stack+21456,36);
 /*--- compute (k0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+517792,int_stack+501268,int_stack+341320,36);
 /*--- compute (k0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+547168,int_stack+517792,int_stack+416380,36);
 /*--- compute (k0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+705964,int_stack+547168,int_stack+601636,36);
 /*--- compute (k0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+501268,int_stack+705964,int_stack+356008,36);
 /*--- compute (k0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+341320,int_stack+501268,int_stack+442300,36);
 /*--- compute (k0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+419944,int_stack+341320,int_stack+639436,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+341320,int_stack+36090,int_stack+33120,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+350230,int_stack+39600,int_stack+36090,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+360760,int_stack+350230,int_stack+341320,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+378580,int_stack+43695,int_stack+39600,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+390865,int_stack+378580,int_stack+350230,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+505480,int_stack+390865,int_stack+360760,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341320,int_stack+48420,int_stack+43695,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+535180,int_stack+341320,int_stack+378580,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+355495,int_stack+535180,int_stack+390865,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+559750,int_stack+355495,int_stack+505480,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+505480,int_stack+53820,int_stack+48420,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+390595,int_stack+505480,int_stack+341320,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+604300,int_stack+390595,int_stack+535180,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+645250,int_stack+604300,int_stack+355495,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+697900,int_stack+645250,int_stack+559750,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341320,int_stack+59940,int_stack+53820,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+521680,int_stack+341320,int_stack+505480,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+554080,int_stack+521680,int_stack+390595,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+760270,int_stack+554080,int_stack+604300,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+821695,int_stack+760270,int_stack+645250,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+601330,int_stack+821695,int_stack+697900,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+359680,int_stack+66825,int_stack+59940,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+380335,int_stack+359680,int_stack+341320,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+684490,int_stack+380335,int_stack+521680,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+341320,int_stack+684490,int_stack+554080,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+505480,int_stack+341320,int_stack+760270,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+684490,int_stack+505480,int_stack+821695,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+782770,int_stack+684490,int_stack+601330,45);
 /*--- compute (kp|nk) ---*/
 hrr1_build_kp(Libint->AB,int_stack+505480,int_stack+782770,int_stack+419944,2376);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+762088,int_stack+78150,int_stack+74520,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+341320,int_stack+82440,int_stack+78150,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+354190,int_stack+341320,int_stack+762088,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+762088,int_stack+87445,int_stack+82440,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+375970,int_stack+762088,int_stack+341320,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+401710,int_stack+375970,int_stack+354190,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341320,int_stack+93220,int_stack+87445,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+438010,int_stack+341320,int_stack+762088,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+438010,int_stack+375970,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+889690,int_stack+0,int_stack+401710,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+762088,int_stack+99820,int_stack+93220,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+358645,int_stack+762088,int_stack+341320,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+42900,int_stack+358645,int_stack+438010,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+393295,int_stack+42900,int_stack+0,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+944140,int_stack+393295,int_stack+889690,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+889690,int_stack+107300,int_stack+99820,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+889690,int_stack+762088,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1020370,int_stack+0,int_stack+358645,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1078120,int_stack+1020370,int_stack+42900,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1153195,int_stack+1078120,int_stack+393295,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+341320,int_stack+1153195,int_stack+944140,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+912130,int_stack+115715,int_stack+107300,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+937375,int_stack+912130,int_stack+889690,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+39600,int_stack+937375,int_stack+0,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+889690,int_stack+39600,int_stack+1020370,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+889690,int_stack+1078120,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+889690,int_stack+0,int_stack+1153195,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1009810,int_stack+889690,int_stack+341320,55);
 /*--- compute (lp|nk) ---*/
 hrr1_build_lp(Libint->AB,int_stack+1140490,int_stack+1009810,int_stack+782770,2376);
 /*--- compute (kd|nk) ---*/
 hrr1_build_kd(Libint->AB,int_stack+1461250,int_stack+1140490,int_stack+505480,2376);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+341320,int_stack+129476,int_stack+125120,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+354388,int_stack+134624,int_stack+129476,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+369832,int_stack+354388,int_stack+341320,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+395968,int_stack+140630,int_stack+134624,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+413986,int_stack+395968,int_stack+354388,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+444874,int_stack+413986,int_stack+369832,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+341320,int_stack+147560,int_stack+140630,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+488434,int_stack+341320,int_stack+395968,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+362110,int_stack+488434,int_stack+413986,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+524470,int_stack+362110,int_stack+444874,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+413590,int_stack+155480,int_stack+147560,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+437350,int_stack+413590,int_stack+341320,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+589810,int_stack+437350,int_stack+488434,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+649870,int_stack+589810,int_stack+362110,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+727090,int_stack+649870,int_stack+524470,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341320,int_stack+164456,int_stack+155480,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+478930,int_stack+341320,int_stack+413590,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+818566,int_stack+478930,int_stack+437350,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+368248,int_stack+818566,int_stack+589810,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+526450,int_stack+368248,int_stack+649870,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+526450,int_stack+727090,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+634558,int_stack+174554,int_stack+164456,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+664852,int_stack+634558,int_stack+341320,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+718708,int_stack+664852,int_stack+478930,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+887866,int_stack+718708,int_stack+818566,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+634558,int_stack+887866,int_stack+368248,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+341320,int_stack+634558,int_stack+526450,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+485464,int_stack+341320,int_stack+0,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1974466,int_stack+485464,int_stack+1009810,2376);
 /*--- compute (ld|nk) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2366506,int_stack+1974466,int_stack+1140490,2376);
 /*--- compute (kf|nk) ---*/
 hrr1_build_kf(Libint->AB,int_stack+3008026,int_stack+2366506,int_stack+1461250,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+190988,int_stack+185840,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+197072,int_stack+190988,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+204170,int_stack+197072,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+212360,int_stack+204170,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341320,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+341320,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+383908,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+221720,int_stack+212360,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+642280,int_stack+113490,int_stack+341320,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+713260,int_stack+642280,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+804520,int_stack+713260,int_stack+383908,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341320,int_stack+232328,int_stack+221720,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+373144,int_stack+341320,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+373144,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+81900,int_stack+0,int_stack+642280,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+912628,int_stack+81900,int_stack+713260,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+642280,int_stack+912628,int_stack+804520,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+786424,int_stack+244262,int_stack+232328,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+822226,int_stack+786424,int_stack+341320,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1040392,int_stack+822226,int_stack+373144,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+341320,int_stack+1040392,int_stack+0,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1040392,int_stack+341320,int_stack+81900,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1040392,int_stack+912628,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+786424,int_stack+0,int_stack+642280,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+971752,int_stack+786424,int_stack+485464,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+3863386,int_stack+971752,int_stack+1974466,2376);
 /*--- compute (lf|nk) ---*/
 hrr1_build_lf(Libint->AB,int_stack+4647466,int_stack+3863386,int_stack+2366506,2376);
 /*--- compute (kg|nk) ---*/
 hrr1_build_kg(Libint->AB,int_stack+1442200,int_stack+4647466,int_stack+3008026,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+263606,int_stack+257600,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+270704,int_stack+263606,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+278985,int_stack+270704,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+288540,int_stack+278985,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+202839,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+202839,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+341320,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+299460,int_stack+288540,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+431410,int_stack+132405,int_stack+202839,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+189735,int_stack+431410,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+514220,int_stack+189735,int_stack+341320,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+341320,int_stack+311836,int_stack+299460,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+341320,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+640346,int_stack+0,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+65520,int_stack+640346,int_stack+431410,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2725240,int_stack+65520,int_stack+189735,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2874298,int_stack+2725240,int_stack+514220,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+189735,int_stack+325759,int_stack+311836,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+231504,int_stack+189735,int_stack+341320,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+305760,int_stack+231504,int_stack+0,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+414960,int_stack+305760,int_stack+640346,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+189735,int_stack+414960,int_stack+65520,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+363636,int_stack+189735,int_stack+2725240,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+363636,int_stack+2874298,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+2725240,int_stack+0,int_stack+786424,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+2725240,int_stack+971752,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5716666,int_stack+0,int_stack+3863386,2376);
 /*--- compute (lg|nk) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2725240,int_stack+5716666,int_stack+4647466,2376);
 /*--- compute (kh|nk) ---*/
 hrr1_build_kh(Libint->AB,int_stack+4329040,int_stack+2725240,int_stack+1442200,2376);
 return int_stack+4329040;}
