/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_kini(Libint_t*, prim_data*);

  /* Computes quartets of (ki|ni) integrals */

REALTYPE *hrr_order_kini(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[7][10] = int_stack + 0;
 Libint->vrr_classes[7][11] = int_stack + 2376;
 Libint->vrr_classes[7][12] = int_stack + 5184;
 Libint->vrr_classes[7][13] = int_stack + 8460;
 Libint->vrr_classes[7][14] = int_stack + 12240;
 Libint->vrr_classes[7][15] = int_stack + 16560;
 Libint->vrr_classes[7][16] = int_stack + 21456;
 Libint->vrr_classes[8][10] = int_stack + 26964;
 Libint->vrr_classes[8][11] = int_stack + 29934;
 Libint->vrr_classes[8][12] = int_stack + 33444;
 Libint->vrr_classes[8][13] = int_stack + 37539;
 Libint->vrr_classes[8][14] = int_stack + 42264;
 Libint->vrr_classes[8][15] = int_stack + 47664;
 Libint->vrr_classes[8][16] = int_stack + 53784;
 Libint->vrr_classes[9][10] = int_stack + 60669;
 Libint->vrr_classes[9][11] = int_stack + 64299;
 Libint->vrr_classes[9][12] = int_stack + 68589;
 Libint->vrr_classes[9][13] = int_stack + 73594;
 Libint->vrr_classes[9][14] = int_stack + 79369;
 Libint->vrr_classes[9][15] = int_stack + 85969;
 Libint->vrr_classes[9][16] = int_stack + 93449;
 Libint->vrr_classes[10][10] = int_stack + 101864;
 Libint->vrr_classes[10][11] = int_stack + 106220;
 Libint->vrr_classes[10][12] = int_stack + 111368;
 Libint->vrr_classes[10][13] = int_stack + 117374;
 Libint->vrr_classes[10][14] = int_stack + 124304;
 Libint->vrr_classes[10][15] = int_stack + 132224;
 Libint->vrr_classes[10][16] = int_stack + 141200;
 Libint->vrr_classes[11][10] = int_stack + 151298;
 Libint->vrr_classes[11][11] = int_stack + 156446;
 Libint->vrr_classes[11][12] = int_stack + 162530;
 Libint->vrr_classes[11][13] = int_stack + 169628;
 Libint->vrr_classes[11][14] = int_stack + 177818;
 Libint->vrr_classes[11][15] = int_stack + 187178;
 Libint->vrr_classes[11][16] = int_stack + 197786;
 Libint->vrr_classes[12][10] = int_stack + 209720;
 Libint->vrr_classes[12][11] = int_stack + 215726;
 Libint->vrr_classes[12][12] = int_stack + 222824;
 Libint->vrr_classes[12][13] = int_stack + 231105;
 Libint->vrr_classes[12][14] = int_stack + 240660;
 Libint->vrr_classes[12][15] = int_stack + 251580;
 Libint->vrr_classes[12][16] = int_stack + 263956;
 Libint->vrr_classes[13][10] = int_stack + 277879;
 Libint->vrr_classes[13][11] = int_stack + 284809;
 Libint->vrr_classes[13][12] = int_stack + 292999;
 Libint->vrr_classes[13][13] = int_stack + 302554;
 Libint->vrr_classes[13][14] = int_stack + 313579;
 Libint->vrr_classes[13][15] = int_stack + 326179;
 Libint->vrr_classes[13][16] = int_stack + 340459;
 memset(int_stack,0,356524*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 356524;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_kini(Libint, Data);
   Data++;
 }
 /*--- compute (k0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356524,int_stack+2376,int_stack+0,36);
 /*--- compute (k0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+363652,int_stack+5184,int_stack+2376,36);
 /*--- compute (k0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+372076,int_stack+363652,int_stack+356524,36);
 /*--- compute (k0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+386332,int_stack+8460,int_stack+5184,36);
 /*--- compute (k0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+396160,int_stack+386332,int_stack+363652,36);
 /*--- compute (k0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+413008,int_stack+396160,int_stack+372076,36);
 /*--- compute (k0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356524,int_stack+12240,int_stack+8460,36);
 /*--- compute (k0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+436768,int_stack+356524,int_stack+386332,36);
 /*--- compute (k0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+367864,int_stack+436768,int_stack+396160,36);
 /*--- compute (k0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+456424,int_stack+367864,int_stack+413008,36);
 /*--- compute (k0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+395944,int_stack+16560,int_stack+12240,36);
 /*--- compute (k0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+408904,int_stack+395944,int_stack+356524,36);
 /*--- compute (k0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+492064,int_stack+408904,int_stack+436768,36);
 /*--- compute (k0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+524824,int_stack+492064,int_stack+367864,36);
 /*--- compute (k0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+566944,int_stack+524824,int_stack+456424,36);
 /*--- compute (k0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+356524,int_stack+21456,int_stack+16560,36);
 /*--- compute (k0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+431584,int_stack+356524,int_stack+395944,36);
 /*--- compute (k0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+356524,int_stack+431584,int_stack+408904,36);
 /*--- compute (k0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+394324,int_stack+356524,int_stack+492064,36);
 /*--- compute (k0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+443464,int_stack+394324,int_stack+524824,36);
 /*--- compute (k0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+356524,int_stack+443464,int_stack+566944,36);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+423052,int_stack+29934,int_stack+26964,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+431962,int_stack+33444,int_stack+29934,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+442492,int_stack+431962,int_stack+423052,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+460312,int_stack+37539,int_stack+33444,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+472597,int_stack+460312,int_stack+431962,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+493657,int_stack+472597,int_stack+442492,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+423052,int_stack+42264,int_stack+37539,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+523357,int_stack+423052,int_stack+460312,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+437227,int_stack+523357,int_stack+472597,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+547927,int_stack+437227,int_stack+493657,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+472327,int_stack+47664,int_stack+42264,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+488527,int_stack+472327,int_stack+423052,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+488527,int_stack+523357,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+592477,int_stack+0,int_stack+437227,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+645127,int_stack+592477,int_stack+547927,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+423052,int_stack+53784,int_stack+47664,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+516877,int_stack+423052,int_stack+472327,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+423052,int_stack+516877,int_stack+488527,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+470302,int_stack+423052,int_stack+0,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+707497,int_stack+470302,int_stack+592477,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+423052,int_stack+707497,int_stack+645127,45);
 /*--- compute (kp|ni) ---*/
 hrr1_build_kp(Libint->AB,int_stack+506212,int_stack+423052,int_stack+356524,1848);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356524,int_stack+64299,int_stack+60669,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+367414,int_stack+68589,int_stack+64299,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+380284,int_stack+367414,int_stack+356524,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+402064,int_stack+73594,int_stack+68589,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+402064,int_stack+367414,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+25740,int_stack+0,int_stack+380284,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356524,int_stack+79369,int_stack+73594,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+705796,int_stack+356524,int_stack+402064,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+373849,int_stack+705796,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+735826,int_stack+373849,int_stack+25740,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+85969,int_stack+79369,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+19800,int_stack+0,int_stack+356524,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+790276,int_stack+19800,int_stack+705796,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+840326,int_stack+790276,int_stack+373849,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+904676,int_stack+840326,int_stack+735826,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+705796,int_stack+93449,int_stack+85969,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+728236,int_stack+705796,int_stack+0,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+356524,int_stack+728236,int_stack+19800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+356524,int_stack+790276,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+705796,int_stack+0,int_stack+840326,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+705796,int_stack+904676,55);
 /*--- compute (lp|ni) ---*/
 hrr1_build_lp(Libint->AB,int_stack+705796,int_stack+0,int_stack+423052,1848);
 /*--- compute (kd|ni) ---*/
 hrr1_build_kd(Libint->AB,int_stack+955276,int_stack+705796,int_stack+506212,1848);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356524,int_stack+106220,int_stack+101864,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+369592,int_stack+111368,int_stack+106220,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+385036,int_stack+369592,int_stack+356524,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+411172,int_stack+117374,int_stack+111368,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+429190,int_stack+411172,int_stack+369592,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+460078,int_stack+429190,int_stack+385036,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356524,int_stack+124304,int_stack+117374,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+503638,int_stack+356524,int_stack+411172,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+377314,int_stack+503638,int_stack+429190,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+539674,int_stack+377314,int_stack+460078,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+428794,int_stack+132224,int_stack+124304,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+452554,int_stack+428794,int_stack+356524,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+605014,int_stack+452554,int_stack+503638,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1354444,int_stack+605014,int_stack+377314,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1431664,int_stack+1354444,int_stack+539674,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+356524,int_stack+141200,int_stack+132224,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+494134,int_stack+356524,int_stack+428794,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+356524,int_stack+494134,int_stack+452554,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+425824,int_stack+356524,int_stack+605014,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+515914,int_stack+425824,int_stack+1354444,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+356524,int_stack+515914,int_stack+1431664,66);
 /*--- compute (mp|ni) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1354444,int_stack+356524,int_stack+0,1848);
 /*--- compute (ld|ni) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1659364,int_stack+1354444,int_stack+705796,1848);
 /*--- compute (kf|ni) ---*/
 hrr1_build_kf(Libint->AB,int_stack+2158324,int_stack+1659364,int_stack+955276,1848);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+156446,int_stack+151298,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+162530,int_stack+156446,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+169628,int_stack+162530,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+478492,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+177818,int_stack+169628,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+122382,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+122382,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+529972,int_stack+24570,int_stack+478492,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+478492,int_stack+187178,int_stack+177818,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+607192,int_stack+478492,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+656332,int_stack+607192,int_stack+122382,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+85410,int_stack+656332,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+727312,int_stack+85410,int_stack+529972,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+197786,int_stack+187178,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+506572,int_stack+0,int_stack+478492,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+506572,int_stack+607192,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+478492,int_stack+0,int_stack+656332,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+584962,int_stack+478492,int_stack+85410,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+584962,int_stack+727312,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+478492,int_stack+0,int_stack+356524,1848);
 /*--- compute (md|ni) ---*/
 hrr1_build_md(Libint->AB,int_stack+2823604,int_stack+478492,int_stack+1354444,1848);
 /*--- compute (lf|ni) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3433444,int_stack+2823604,int_stack+1659364,1848);
 /*--- compute (kg|ni) ---*/
 hrr1_build_kg(Libint->AB,int_stack+844396,int_stack+3433444,int_stack+2158324,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+356524,int_stack+215726,int_stack+209720,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+374542,int_stack+222824,int_stack+215726,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+395836,int_stack+374542,int_stack+356524,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+431872,int_stack+231105,int_stack+222824,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1842316,int_stack+431872,int_stack+374542,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1884904,int_stack+1842316,int_stack+395836,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+356524,int_stack+240660,int_stack+231105,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1944964,int_stack+356524,int_stack+431872,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+385189,int_stack+1944964,int_stack+1842316,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1994650,int_stack+385189,int_stack+1884904,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1842316,int_stack+251580,int_stack+240660,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1875076,int_stack+1842316,int_stack+356524,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2084740,int_stack+1875076,int_stack+1944964,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2167550,int_stack+2084740,int_stack+385189,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2274020,int_stack+2167550,int_stack+1994650,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+356524,int_stack+263956,int_stack+251580,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+393652,int_stack+356524,int_stack+1842316,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1932406,int_stack+393652,int_stack+1875076,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2400146,int_stack+1932406,int_stack+2084740,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1842316,int_stack+2400146,int_stack+2167550,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2400146,int_stack+1842316,int_stack+2274020,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+1842316,int_stack+2400146,int_stack+0,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4265044,int_stack+1842316,int_stack+478492,1848);
 /*--- compute (mf|ni) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4996852,int_stack+4265044,int_stack+2823604,1848);
 /*--- compute (lg|ni) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6013252,int_stack+4996852,int_stack+3433444,1848);
 /*--- compute (kh|ni) ---*/
 hrr1_build_kh(Libint->AB,int_stack+2568314,int_stack+6013252,int_stack+844396,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+284809,int_stack+277879,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+20790,int_stack+292999,int_stack+284809,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+45360,int_stack+20790,int_stack+0,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+86940,int_stack+302554,int_stack+292999,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+115605,int_stack+86940,int_stack+20790,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+164745,int_stack+115605,int_stack+45360,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+313579,int_stack+302554,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234045,int_stack+0,int_stack+86940,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+33075,int_stack+234045,int_stack+115605,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2274748,int_stack+33075,int_stack+164745,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+114975,int_stack+326179,int_stack+313579,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+152775,int_stack+114975,int_stack+0,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3965402,int_stack+152775,int_stack+234045,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4060952,int_stack+3965402,int_stack+33075,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+356524,int_stack+4060952,int_stack+2274748,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2274748,int_stack+340459,int_stack+326179,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2317588,int_stack+2274748,int_stack+114975,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+2317588,int_stack+152775,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+110250,int_stack+0,int_stack+3965402,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+502054,int_stack+110250,int_stack+4060952,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3965402,int_stack+502054,int_stack+356524,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+0,int_stack+3965402,int_stack+2400146,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+504504,int_stack+0,int_stack+1842316,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+7260652,int_stack+504504,int_stack+4265044,1848);
 /*--- compute (mg|ni) ---*/
 hrr1_build_mg(Libint->AB,int_stack+0,int_stack+7260652,int_stack+4996852,1848);
 /*--- compute (lh|ni) ---*/
 hrr1_build_lh(Libint->AB,int_stack+3965402,int_stack+0,int_stack+6013252,1848);
 /*--- compute (ki|ni) ---*/
 hrr1_build_ki(Libint->AB,int_stack+0,int_stack+3965402,int_stack+2568314,1848);
 return int_stack+0;}
