/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_l0ig(Libint_t*, prim_data*);

  /* Computes quartets of (l0|ig) integrals */

REALTYPE *hrr_order_l0ig(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][6] = int_stack + 0;
 Libint->vrr_classes[8][7] = int_stack + 1260;
 Libint->vrr_classes[8][8] = int_stack + 2880;
 Libint->vrr_classes[8][9] = int_stack + 4905;
 Libint->vrr_classes[8][10] = int_stack + 7380;
 memset(int_stack,0,10350*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 10350;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_l0ig(Libint, Data);
   Data++;
 }
 /*--- compute (l0|ip) ---*/
 hrr3_build_ip(Libint->CD,int_stack+10350,int_stack+1260,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+14130,int_stack+2880,int_stack+1260,45);
 /*--- compute (l0|id) ---*/
 hrr3_build_id(Libint->CD,int_stack+18990,int_stack+14130,int_stack+10350,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+26550,int_stack+4905,int_stack+2880,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+32625,int_stack+26550,int_stack+14130,45);
 /*--- compute (l0|if) ---*/
 hrr3_build_if(Libint->CD,int_stack+42345,int_stack+32625,int_stack+18990,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+10350,int_stack+7380,int_stack+4905,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+54945,int_stack+10350,int_stack+26550,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+54945,int_stack+32625,45);
 /*--- compute (l0|ig) ---*/
 hrr3_build_ig(Libint->CD,int_stack+16200,int_stack+0,int_stack+42345,45);
 return int_stack+16200;}
