/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ldng(Libint_t*, prim_data*);

  /* Computes quartets of (ld|ng) integrals */

REALTYPE *hrr_order_ldng(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[9][10] = int_stack + 20700;
 Libint->vrr_classes[9][11] = int_stack + 24330;
 Libint->vrr_classes[9][12] = int_stack + 28620;
 Libint->vrr_classes[9][13] = int_stack + 33625;
 Libint->vrr_classes[9][14] = int_stack + 39400;
 Libint->vrr_classes[10][10] = int_stack + 46000;
 Libint->vrr_classes[10][11] = int_stack + 50356;
 Libint->vrr_classes[10][12] = int_stack + 55504;
 Libint->vrr_classes[10][13] = int_stack + 61510;
 Libint->vrr_classes[10][14] = int_stack + 68440;
 memset(int_stack,0,76360*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 76360;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ldng(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+76360,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85270,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+95800,int_stack+85270,int_stack+76360,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+113620,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+125905,int_stack+113620,int_stack+85270,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+146965,int_stack+125905,int_stack+95800,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+76360,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+176665,int_stack+76360,int_stack+113620,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76360,int_stack+176665,int_stack+125905,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+176665,int_stack+76360,int_stack+146965,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+76360,int_stack+24330,int_stack+20700,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+87250,int_stack+28620,int_stack+24330,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+100120,int_stack+87250,int_stack+76360,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+121900,int_stack+33625,int_stack+28620,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+136915,int_stack+121900,int_stack+87250,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+221215,int_stack+136915,int_stack+100120,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+76360,int_stack+39400,int_stack+33625,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+0,int_stack+76360,int_stack+121900,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+76360,int_stack+0,int_stack+136915,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+119260,int_stack+76360,int_stack+221215,55);
 /*--- compute (lp|ng) ---*/
 hrr1_build_lp(Libint->AB,int_stack+221215,int_stack+119260,int_stack+176665,990);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+76360,int_stack+50356,int_stack+46000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+89428,int_stack+55504,int_stack+50356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+89428,int_stack+76360,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+26136,int_stack+61510,int_stack+55504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+173710,int_stack+26136,int_stack+89428,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+354865,int_stack+173710,int_stack+0,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+68440,int_stack+61510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+44154,int_stack+0,int_stack+26136,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+398425,int_stack+44154,int_stack+173710,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+398425,int_stack+354865,66);
 /*--- compute (mp|ng) ---*/
 hrr1_build_mp(Libint->AB,int_stack+354865,int_stack+0,int_stack+119260,990);
 /*--- compute (ld|ng) ---*/
 hrr1_build_ld(Libint->AB,int_stack+518215,int_stack+354865,int_stack+221215,990);
 return int_stack+518215;}
