/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfkg(Libint_t*, prim_data*);

  /* Computes quartets of (lf|kg) integrals */

REALTYPE *hrr_order_lfkg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][7] = int_stack + 0;
 Libint->vrr_classes[8][8] = int_stack + 1620;
 Libint->vrr_classes[8][9] = int_stack + 3645;
 Libint->vrr_classes[8][10] = int_stack + 6120;
 Libint->vrr_classes[8][11] = int_stack + 9090;
 Libint->vrr_classes[9][7] = int_stack + 12600;
 Libint->vrr_classes[9][8] = int_stack + 14580;
 Libint->vrr_classes[9][9] = int_stack + 17055;
 Libint->vrr_classes[9][10] = int_stack + 20080;
 Libint->vrr_classes[9][11] = int_stack + 23710;
 Libint->vrr_classes[10][7] = int_stack + 28000;
 Libint->vrr_classes[10][8] = int_stack + 30376;
 Libint->vrr_classes[10][9] = int_stack + 33346;
 Libint->vrr_classes[10][10] = int_stack + 36976;
 Libint->vrr_classes[10][11] = int_stack + 41332;
 Libint->vrr_classes[11][7] = int_stack + 46480;
 Libint->vrr_classes[11][8] = int_stack + 49288;
 Libint->vrr_classes[11][9] = int_stack + 52798;
 Libint->vrr_classes[11][10] = int_stack + 57088;
 Libint->vrr_classes[11][11] = int_stack + 62236;
 memset(int_stack,0,68320*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 68320;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfkg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+68320,int_stack+1620,int_stack+0,45);
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+73180,int_stack+3645,int_stack+1620,45);
 /*--- compute (l0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+79255,int_stack+73180,int_stack+68320,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+88975,int_stack+6120,int_stack+3645,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+96400,int_stack+88975,int_stack+73180,45);
 /*--- compute (l0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+108550,int_stack+96400,int_stack+79255,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68320,int_stack+9090,int_stack+6120,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+124750,int_stack+68320,int_stack+88975,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+68320,int_stack+124750,int_stack+96400,45);
 /*--- compute (l0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+124750,int_stack+68320,int_stack+108550,45);
 /*--- compute (m0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+68320,int_stack+14580,int_stack+12600,55);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+74260,int_stack+17055,int_stack+14580,55);
 /*--- compute (m0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+81685,int_stack+74260,int_stack+68320,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+93565,int_stack+20080,int_stack+17055,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+102640,int_stack+93565,int_stack+74260,55);
 /*--- compute (m0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+0,int_stack+102640,int_stack+81685,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68320,int_stack+23710,int_stack+20080,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149050,int_stack+68320,int_stack+93565,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+68320,int_stack+149050,int_stack+102640,55);
 /*--- compute (m0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+93070,int_stack+68320,int_stack+0,55);
 /*--- compute (lp|kg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+149050,int_stack+93070,int_stack+124750,540);
 /*--- compute (n0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+0,int_stack+30376,int_stack+28000,66);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+7128,int_stack+33346,int_stack+30376,66);
 /*--- compute (n0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+16038,int_stack+7128,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+68320,int_stack+36976,int_stack+33346,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+122770,int_stack+68320,int_stack+7128,66);
 /*--- compute (n0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+221950,int_stack+122770,int_stack+16038,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+41332,int_stack+36976,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+13068,int_stack+0,int_stack+68320,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+245710,int_stack+13068,int_stack+122770,66);
 /*--- compute (n0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+0,int_stack+245710,int_stack+221950,66);
 /*--- compute (mp|kg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+221950,int_stack+0,int_stack+93070,540);
 /*--- compute (ld|kg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+311050,int_stack+221950,int_stack+149050,540);
 /*--- compute (o0|kp) ---*/
 hrr3_build_kp(Libint->CD,int_stack+68320,int_stack+49288,int_stack+46480,78);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+76744,int_stack+52798,int_stack+49288,78);
 /*--- compute (o0|kd) ---*/
 hrr3_build_kd(Libint->CD,int_stack+87274,int_stack+76744,int_stack+68320,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+104122,int_stack+57088,int_stack+52798,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+116992,int_stack+104122,int_stack+76744,78);
 /*--- compute (o0|kf) ---*/
 hrr3_build_kf(Libint->CD,int_stack+138052,int_stack+116992,int_stack+87274,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+68320,int_stack+62236,int_stack+57088,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+166132,int_stack+68320,int_stack+104122,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+35640,int_stack+166132,int_stack+116992,78);
 /*--- compute (o0|kg) ---*/
 hrr3_build_kg(Libint->CD,int_stack+166132,int_stack+35640,int_stack+138052,78);
 /*--- compute (np|kg) ---*/
 hrr1_build_np(Libint->AB,int_stack+35640,int_stack+166132,int_stack+0,540);
 /*--- compute (md|kg) ---*/
 hrr1_build_md(Libint->AB,int_stack+456850,int_stack+35640,int_stack+221950,540);
 /*--- compute (lf|kg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+456850,int_stack+311050,540);
 return int_stack+0;}
