/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lfmf(Libint_t*, prim_data*);

  /* Computes quartets of (lf|mf) integrals */

REALTYPE *hrr_order_lfmf(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[9][9] = int_stack + 13050;
 Libint->vrr_classes[9][10] = int_stack + 16075;
 Libint->vrr_classes[9][11] = int_stack + 19705;
 Libint->vrr_classes[9][12] = int_stack + 23995;
 Libint->vrr_classes[10][9] = int_stack + 29000;
 Libint->vrr_classes[10][10] = int_stack + 32630;
 Libint->vrr_classes[10][11] = int_stack + 36986;
 Libint->vrr_classes[10][12] = int_stack + 42134;
 Libint->vrr_classes[11][9] = int_stack + 48140;
 Libint->vrr_classes[11][10] = int_stack + 52430;
 Libint->vrr_classes[11][11] = int_stack + 57578;
 Libint->vrr_classes[11][12] = int_stack + 63662;
 memset(int_stack,0,70760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 70760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lfmf(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+70760,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+78185,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+87095,int_stack+78185,int_stack+70760,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+101945,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+112475,int_stack+101945,int_stack+78185,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+130295,int_stack+112475,int_stack+87095,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+70760,int_stack+16075,int_stack+13050,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+79835,int_stack+19705,int_stack+16075,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+90725,int_stack+79835,int_stack+70760,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+108875,int_stack+23995,int_stack+19705,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+108875,int_stack+79835,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+155045,int_stack+0,int_stack+90725,55);
 /*--- compute (lp|mf) ---*/
 hrr1_build_lp(Libint->AB,int_stack+185295,int_stack+155045,int_stack+130295,550);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+32630,int_stack+29000,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+36986,int_stack+32630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+70760,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+92540,int_stack+42134,int_stack+36986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+107984,int_stack+92540,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+107984,int_stack+70760,66);
 /*--- compute (mp|mf) ---*/
 hrr1_build_mp(Libint->AB,int_stack+259545,int_stack+0,int_stack+155045,550);
 /*--- compute (ld|mf) ---*/
 hrr1_build_ld(Libint->AB,int_stack+350295,int_stack+259545,int_stack+185295,550);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+70760,int_stack+52430,int_stack+48140,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+83630,int_stack+57578,int_stack+52430,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+99074,int_stack+83630,int_stack+70760,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+124814,int_stack+63662,int_stack+57578,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+143066,int_stack+124814,int_stack+83630,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+173954,int_stack+143066,int_stack+99074,78);
 /*--- compute (np|mf) ---*/
 hrr1_build_np(Libint->AB,int_stack+36300,int_stack+173954,int_stack+0,550);
 /*--- compute (md|mf) ---*/
 hrr1_build_md(Libint->AB,int_stack+498795,int_stack+36300,int_stack+259545,550);
 /*--- compute (lf|mf) ---*/
 hrr1_build_lf(Libint->AB,int_stack+0,int_stack+498795,int_stack+350295,550);
 return int_stack+0;}
