/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lglg(Libint_t*, prim_data*);

  /* Computes quartets of (lg|lg) integrals */

REALTYPE *hrr_order_lglg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][8] = int_stack + 0;
 Libint->vrr_classes[8][9] = int_stack + 2025;
 Libint->vrr_classes[8][10] = int_stack + 4500;
 Libint->vrr_classes[8][11] = int_stack + 7470;
 Libint->vrr_classes[8][12] = int_stack + 10980;
 Libint->vrr_classes[9][8] = int_stack + 15075;
 Libint->vrr_classes[9][9] = int_stack + 17550;
 Libint->vrr_classes[9][10] = int_stack + 20575;
 Libint->vrr_classes[9][11] = int_stack + 24205;
 Libint->vrr_classes[9][12] = int_stack + 28495;
 Libint->vrr_classes[10][8] = int_stack + 33500;
 Libint->vrr_classes[10][9] = int_stack + 36470;
 Libint->vrr_classes[10][10] = int_stack + 40100;
 Libint->vrr_classes[10][11] = int_stack + 44456;
 Libint->vrr_classes[10][12] = int_stack + 49604;
 Libint->vrr_classes[11][8] = int_stack + 55610;
 Libint->vrr_classes[11][9] = int_stack + 59120;
 Libint->vrr_classes[11][10] = int_stack + 63410;
 Libint->vrr_classes[11][11] = int_stack + 68558;
 Libint->vrr_classes[11][12] = int_stack + 74642;
 Libint->vrr_classes[12][8] = int_stack + 81740;
 Libint->vrr_classes[12][9] = int_stack + 85835;
 Libint->vrr_classes[12][10] = int_stack + 90840;
 Libint->vrr_classes[12][11] = int_stack + 96846;
 Libint->vrr_classes[12][12] = int_stack + 103944;
 memset(int_stack,0,112225*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 112225;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lglg(Libint, Data);
   Data++;
 }
 /*--- compute (l0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112225,int_stack+2025,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+118300,int_stack+4500,int_stack+2025,45);
 /*--- compute (l0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+125725,int_stack+118300,int_stack+112225,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+137875,int_stack+7470,int_stack+4500,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+146785,int_stack+137875,int_stack+118300,45);
 /*--- compute (l0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+161635,int_stack+146785,int_stack+125725,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+112225,int_stack+10980,int_stack+7470,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+181885,int_stack+112225,int_stack+137875,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+112225,int_stack+181885,int_stack+146785,45);
 /*--- compute (l0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+181885,int_stack+112225,int_stack+161635,45);
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112225,int_stack+17550,int_stack+15075,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+119650,int_stack+20575,int_stack+17550,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+128725,int_stack+119650,int_stack+112225,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+143575,int_stack+24205,int_stack+20575,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+154465,int_stack+143575,int_stack+119650,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+212260,int_stack+154465,int_stack+128725,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+112225,int_stack+28495,int_stack+24205,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+112225,int_stack+143575,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+112225,int_stack+0,int_stack+154465,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+142475,int_stack+112225,int_stack+212260,55);
 /*--- compute (lp|lg) ---*/
 hrr1_build_lp(Libint->AB,int_stack+212260,int_stack+142475,int_stack+181885,675);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112225,int_stack+36470,int_stack+33500,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+121135,int_stack+40100,int_stack+36470,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+0,int_stack+121135,int_stack+112225,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17820,int_stack+44456,int_stack+40100,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+179600,int_stack+17820,int_stack+121135,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+112225,int_stack+179600,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+49604,int_stack+44456,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+303385,int_stack+0,int_stack+17820,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+303385,int_stack+179600,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+303385,int_stack+0,int_stack+112225,66);
 /*--- compute (mp|lg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+347935,int_stack+303385,int_stack+142475,675);
 /*--- compute (ld|lg) ---*/
 hrr1_build_ld(Libint->AB,int_stack+459310,int_stack+347935,int_stack+212260,675);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112225,int_stack+59120,int_stack+55610,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+122755,int_stack+63410,int_stack+59120,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+135625,int_stack+122755,int_stack+112225,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+156685,int_stack+68558,int_stack+63410,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+172129,int_stack+156685,int_stack+122755,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+197869,int_stack+172129,int_stack+135625,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+112225,int_stack+74642,int_stack+68558,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+232969,int_stack+112225,int_stack+156685,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+112225,int_stack+232969,int_stack+172129,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+232969,int_stack+112225,int_stack+197869,78);
 /*--- compute (np|lg) ---*/
 hrr1_build_np(Libint->AB,int_stack+641560,int_stack+232969,int_stack+303385,675);
 /*--- compute (md|lg) ---*/
 hrr1_build_md(Libint->AB,int_stack+775210,int_stack+641560,int_stack+347935,675);
 /*--- compute (lf|lg) ---*/
 hrr1_build_lf(Libint->AB,int_stack+997960,int_stack+775210,int_stack+459310,675);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+112225,int_stack+85835,int_stack+81740,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+124510,int_stack+90840,int_stack+85835,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+139525,int_stack+124510,int_stack+112225,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+164095,int_stack+96846,int_stack+90840,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+182113,int_stack+164095,int_stack+124510,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+285619,int_stack+182113,int_stack+139525,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+112225,int_stack+103944,int_stack+96846,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+326569,int_stack+112225,int_stack+164095,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+362605,int_stack+326569,int_stack+182113,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+412655,int_stack+362605,int_stack+285619,91);
 /*--- compute (op|lg) ---*/
 hrr1_build_op(Libint->AB,int_stack+474080,int_stack+412655,int_stack+232969,675);
 /*--- compute (nd|lg) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+474080,int_stack+641560,675);
 /*--- compute (mf|lg) ---*/
 hrr1_build_mf(Libint->AB,int_stack+267300,int_stack+0,int_stack+775210,675);
 /*--- compute (lg|lg) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1301710,int_stack+267300,int_stack+997960,675);
 return int_stack+1301710;}
