/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgmh(Libint_t*, prim_data*);

  /* Computes quartets of (lg|mh) integrals */

REALTYPE *hrr_order_lgmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[9][9] = int_stack + 23175;
 Libint->vrr_classes[9][10] = int_stack + 26200;
 Libint->vrr_classes[9][11] = int_stack + 29830;
 Libint->vrr_classes[9][12] = int_stack + 34120;
 Libint->vrr_classes[9][13] = int_stack + 39125;
 Libint->vrr_classes[9][14] = int_stack + 44900;
 Libint->vrr_classes[10][9] = int_stack + 51500;
 Libint->vrr_classes[10][10] = int_stack + 55130;
 Libint->vrr_classes[10][11] = int_stack + 59486;
 Libint->vrr_classes[10][12] = int_stack + 64634;
 Libint->vrr_classes[10][13] = int_stack + 70640;
 Libint->vrr_classes[10][14] = int_stack + 77570;
 Libint->vrr_classes[11][9] = int_stack + 85490;
 Libint->vrr_classes[11][10] = int_stack + 89780;
 Libint->vrr_classes[11][11] = int_stack + 94928;
 Libint->vrr_classes[11][12] = int_stack + 101012;
 Libint->vrr_classes[11][13] = int_stack + 108110;
 Libint->vrr_classes[11][14] = int_stack + 116300;
 Libint->vrr_classes[12][9] = int_stack + 125660;
 Libint->vrr_classes[12][10] = int_stack + 130665;
 Libint->vrr_classes[12][11] = int_stack + 136671;
 Libint->vrr_classes[12][12] = int_stack + 143769;
 Libint->vrr_classes[12][13] = int_stack + 152050;
 Libint->vrr_classes[12][14] = int_stack + 161605;
 memset(int_stack,0,172525*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 172525;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgmh(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+172525,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+179950,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+188860,int_stack+179950,int_stack+172525,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+203710,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+214240,int_stack+203710,int_stack+179950,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+232060,int_stack+214240,int_stack+188860,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+172525,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+256810,int_stack+172525,int_stack+203710,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+277870,int_stack+256810,int_stack+214240,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+184810,int_stack+277870,int_stack+232060,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+221935,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+307570,int_stack+221935,int_stack+172525,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+332140,int_stack+307570,int_stack+256810,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+221935,int_stack+332140,int_stack+277870,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+266485,int_stack+221935,int_stack+184810,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+172525,int_stack+26200,int_stack+23175,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+181600,int_stack+29830,int_stack+26200,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+192490,int_stack+181600,int_stack+172525,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+210640,int_stack+34120,int_stack+29830,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+223510,int_stack+210640,int_stack+181600,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+318460,int_stack+223510,int_stack+192490,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+172525,int_stack+39125,int_stack+34120,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+172525,int_stack+210640,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+348710,int_stack+0,int_stack+223510,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+187540,int_stack+348710,int_stack+318460,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+318460,int_stack+44900,int_stack+39125,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+232915,int_stack+318460,int_stack+172525,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+385010,int_stack+232915,int_stack+0,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+427910,int_stack+385010,int_stack+348710,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+318460,int_stack+427910,int_stack+187540,55);
 /*--- compute (lp|mh) ---*/
 hrr1_build_lp(Libint->AB,int_stack+381985,int_stack+318460,int_stack+266485,1155);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+55130,int_stack+51500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+10890,int_stack+59486,int_stack+55130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+23958,int_stack+10890,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+172525,int_stack+64634,int_stack+59486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+187969,int_stack+172525,int_stack+10890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+214105,int_stack+187969,int_stack+23958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+70640,int_stack+64634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+18018,int_stack+0,int_stack+172525,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+250405,int_stack+18018,int_stack+187969,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+537910,int_stack+250405,int_stack+214105,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+172525,int_stack+77570,int_stack+70640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+193315,int_stack+172525,int_stack+0,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+592360,int_stack+193315,int_stack+18018,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+592360,int_stack+250405,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+172525,int_stack+0,int_stack+537910,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+537910,int_stack+172525,int_stack+318460,1155);
 /*--- compute (ld|mh) ---*/
 hrr1_build_ld(Libint->AB,int_stack+728485,int_stack+537910,int_stack+381985,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+89780,int_stack+85490,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+94928,int_stack+89780,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+101012,int_stack+94928,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+248755,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+279643,int_stack+248755,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+108110,int_stack+101012,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+322543,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+21294,int_stack+322543,int_stack+248755,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+359047,int_stack+21294,int_stack+279643,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+248755,int_stack+116300,int_stack+108110,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+273325,int_stack+248755,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+423397,int_stack+273325,int_stack+322543,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+248755,int_stack+423397,int_stack+21294,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+423397,int_stack+248755,int_stack+359047,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+1040335,int_stack+423397,int_stack+172525,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+1269025,int_stack+1040335,int_stack+537910,1155);
 /*--- compute (lf|mh) ---*/
 hrr1_build_lf(Libint->AB,int_stack+1650175,int_stack+1269025,int_stack+728485,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+172525,int_stack+130665,int_stack+125660,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187540,int_stack+136671,int_stack+130665,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+205558,int_stack+187540,int_stack+172525,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+235588,int_stack+143769,int_stack+136671,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+256882,int_stack+235588,int_stack+187540,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+292918,int_stack+256882,int_stack+205558,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+172525,int_stack+152050,int_stack+143769,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+342968,int_stack+172525,int_stack+235588,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+513487,int_stack+342968,int_stack+256882,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+197368,int_stack+513487,int_stack+292918,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+272443,int_stack+161605,int_stack+152050,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+573547,int_stack+272443,int_stack+172525,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+623233,int_stack+573547,int_stack+342968,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+272443,int_stack+623233,int_stack+513487,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+513487,int_stack+272443,int_stack+197368,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+618592,int_stack+513487,int_stack+423397,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+618592,int_stack+1040335,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+457380,int_stack+0,int_stack+1269025,1155);
 /*--- compute (lg|mh) ---*/
 hrr1_build_lg(Libint->AB,int_stack+2169925,int_stack+457380,int_stack+1650175,1155);
 return int_stack+2169925;}
