/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lgnm(Libint_t*, prim_data*);

  /* Computes quartets of (lg|nm) integrals */

REALTYPE *hrr_order_lgnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[8][19] = int_stack + 49950;
 Libint->vrr_classes[9][10] = int_stack + 59400;
 Libint->vrr_classes[9][11] = int_stack + 63030;
 Libint->vrr_classes[9][12] = int_stack + 67320;
 Libint->vrr_classes[9][13] = int_stack + 72325;
 Libint->vrr_classes[9][14] = int_stack + 78100;
 Libint->vrr_classes[9][15] = int_stack + 84700;
 Libint->vrr_classes[9][16] = int_stack + 92180;
 Libint->vrr_classes[9][17] = int_stack + 100595;
 Libint->vrr_classes[9][18] = int_stack + 110000;
 Libint->vrr_classes[9][19] = int_stack + 120450;
 Libint->vrr_classes[10][10] = int_stack + 132000;
 Libint->vrr_classes[10][11] = int_stack + 136356;
 Libint->vrr_classes[10][12] = int_stack + 141504;
 Libint->vrr_classes[10][13] = int_stack + 147510;
 Libint->vrr_classes[10][14] = int_stack + 154440;
 Libint->vrr_classes[10][15] = int_stack + 162360;
 Libint->vrr_classes[10][16] = int_stack + 171336;
 Libint->vrr_classes[10][17] = int_stack + 181434;
 Libint->vrr_classes[10][18] = int_stack + 192720;
 Libint->vrr_classes[10][19] = int_stack + 205260;
 Libint->vrr_classes[11][10] = int_stack + 219120;
 Libint->vrr_classes[11][11] = int_stack + 224268;
 Libint->vrr_classes[11][12] = int_stack + 230352;
 Libint->vrr_classes[11][13] = int_stack + 237450;
 Libint->vrr_classes[11][14] = int_stack + 245640;
 Libint->vrr_classes[11][15] = int_stack + 255000;
 Libint->vrr_classes[11][16] = int_stack + 265608;
 Libint->vrr_classes[11][17] = int_stack + 277542;
 Libint->vrr_classes[11][18] = int_stack + 290880;
 Libint->vrr_classes[11][19] = int_stack + 305700;
 Libint->vrr_classes[12][10] = int_stack + 322080;
 Libint->vrr_classes[12][11] = int_stack + 328086;
 Libint->vrr_classes[12][12] = int_stack + 335184;
 Libint->vrr_classes[12][13] = int_stack + 343465;
 Libint->vrr_classes[12][14] = int_stack + 353020;
 Libint->vrr_classes[12][15] = int_stack + 363940;
 Libint->vrr_classes[12][16] = int_stack + 376316;
 Libint->vrr_classes[12][17] = int_stack + 390239;
 Libint->vrr_classes[12][18] = int_stack + 405800;
 Libint->vrr_classes[12][19] = int_stack + 423090;
 memset(int_stack,0,442200*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 442200;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lgnm(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+442200,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+451110,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+461640,int_stack+451110,int_stack+442200,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+479460,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+491745,int_stack+479460,int_stack+451110,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+512805,int_stack+491745,int_stack+461640,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+442200,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+542505,int_stack+442200,int_stack+479460,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+456375,int_stack+542505,int_stack+491745,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+567075,int_stack+456375,int_stack+512805,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+491475,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+507675,int_stack+491475,int_stack+442200,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+611625,int_stack+507675,int_stack+542505,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+652575,int_stack+611625,int_stack+456375,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+705225,int_stack+652575,int_stack+567075,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+442200,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+536025,int_stack+442200,int_stack+491475,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+767595,int_stack+536025,int_stack+507675,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+460560,int_stack+767595,int_stack+611625,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+568425,int_stack+460560,int_stack+652575,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+814845,int_stack+568425,int_stack+705225,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+642135,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+662790,int_stack+642135,int_stack+442200,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+699510,int_stack+662790,int_stack+536025,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+898005,int_stack+699510,int_stack+767595,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+968880,int_stack+898005,int_stack+460560,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+442200,int_stack+968880,int_stack+568425,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1054875,int_stack+442200,int_stack+814845,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+540480,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+563565,int_stack+540480,int_stack+642135,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+753510,int_stack+563565,int_stack+662790,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+604875,int_stack+753510,int_stack+699510,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1161795,int_stack+604875,int_stack+898005,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+814710,int_stack+1161795,int_stack+968880,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1261020,int_stack+814710,int_stack+442200,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1387380,int_stack+1261020,int_stack+1054875,45);
 /*--- compute (l0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+442200,int_stack+49950,int_stack+41400,45);
 /*--- compute (l0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+467850,int_stack+442200,int_stack+540480,45);
 /*--- compute (l0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+929370,int_stack+467850,int_stack+563565,45);
 /*--- compute (l0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+442200,int_stack+929370,int_stack+753510,45);
 /*--- compute (l0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+929370,int_stack+442200,int_stack+604875,45);
 /*--- compute (l0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+442200,int_stack+929370,int_stack+1161795,45);
 /*--- compute (l0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+929370,int_stack+442200,int_stack+814710,45);
 /*--- compute (l0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+442200,int_stack+929370,int_stack+1261020,45);
 /*--- compute (l0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+600150,int_stack+442200,int_stack+1387380,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+442200,int_stack+63030,int_stack+59400,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+453090,int_stack+67320,int_stack+63030,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+465960,int_stack+453090,int_stack+442200,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+487740,int_stack+72325,int_stack+67320,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+502755,int_stack+487740,int_stack+453090,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+528495,int_stack+502755,int_stack+465960,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+442200,int_stack+78100,int_stack+72325,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+564795,int_stack+442200,int_stack+487740,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+459525,int_stack+564795,int_stack+502755,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+763500,int_stack+459525,int_stack+528495,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+502425,int_stack+84700,int_stack+78100,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+522225,int_stack+502425,int_stack+442200,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+817950,int_stack+522225,int_stack+564795,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+868000,int_stack+817950,int_stack+459525,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+932350,int_stack+868000,int_stack+763500,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+763500,int_stack+92180,int_stack+84700,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+442200,int_stack+763500,int_stack+502425,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1008580,int_stack+442200,int_stack+522225,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+481800,int_stack+1008580,int_stack+817950,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1066330,int_stack+481800,int_stack+868000,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+785940,int_stack+1066330,int_stack+932350,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+887580,int_stack+100595,int_stack+92180,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+912825,int_stack+887580,int_stack+763500,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1156420,int_stack+912825,int_stack+442200,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1222420,int_stack+1156420,int_stack+1008580,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+957705,int_stack+1222420,int_stack+481800,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+442200,int_stack+957705,int_stack+1066330,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1309045,int_stack+442200,int_stack+785940,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+562320,int_stack+110000,int_stack+100595,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+763500,int_stack+562320,int_stack+887580,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+813990,int_stack+763500,int_stack+912825,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+813990,int_stack+1156420,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1062810,int_stack+0,int_stack+1222420,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1439725,int_stack+1062810,int_stack+957705,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+888790,int_stack+1439725,int_stack+442200,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1579865,int_stack+888790,int_stack+1309045,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+442200,int_stack+120450,int_stack+110000,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+473550,int_stack+442200,int_stack+562320,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1184085,int_stack+473550,int_stack+763500,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+442200,int_stack+1184085,int_stack+813990,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1184085,int_stack+442200,int_stack+0,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1743215,int_stack+1184085,int_stack+1062810,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1043230,int_stack+1743215,int_stack+1439725,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1223410,int_stack+1043230,int_stack+888790,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+763500,int_stack+1223410,int_stack+1579865,55);
 /*--- compute (lp|nm) ---*/
 hrr1_build_lp(Libint->AB,int_stack+963150,int_stack+763500,int_stack+600150,3630);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+136356,int_stack+132000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+13068,int_stack+141504,int_stack+136356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+28512,int_stack+13068,int_stack+0,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+54648,int_stack+147510,int_stack+141504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+72666,int_stack+54648,int_stack+13068,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+103554,int_stack+72666,int_stack+28512,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+154440,int_stack+147510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+442200,int_stack+0,int_stack+54648,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+20790,int_stack+442200,int_stack+72666,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+478236,int_stack+20790,int_stack+103554,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+72270,int_stack+162360,int_stack+154440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+96030,int_stack+72270,int_stack+0,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+543576,int_stack+96030,int_stack+442200,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+603636,int_stack+543576,int_stack+20790,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1453200,int_stack+603636,int_stack+478236,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+442200,int_stack+171336,int_stack+162360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+469128,int_stack+442200,int_stack+72270,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+469128,int_stack+96030,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+69300,int_stack+0,int_stack+543576,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1544676,int_stack+69300,int_stack+603636,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+516648,int_stack+1544676,int_stack+1453200,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1453200,int_stack+181434,int_stack+171336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1483494,int_stack+1453200,int_stack+442200,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+638616,int_stack+1483494,int_stack+469128,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1652784,int_stack+638616,int_stack+0,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1756734,int_stack+1652784,int_stack+69300,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1756734,int_stack+1544676,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1882860,int_stack+0,int_stack+516648,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+144144,int_stack+192720,int_stack+181434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+442200,int_stack+144144,int_stack+1453200,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+502788,int_stack+442200,int_stack+1483494,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1453200,int_stack+502788,int_stack+638616,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+592548,int_stack+1453200,int_stack+1652784,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1572000,int_stack+592548,int_stack+1756734,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2039676,int_stack+1572000,int_stack+0,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2225004,int_stack+2039676,int_stack+1882860,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+205260,int_stack+192720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+37620,int_stack+0,int_stack+144144,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+105336,int_stack+37620,int_stack+442200,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1740168,int_stack+105336,int_stack+502788,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+1740168,int_stack+1453200,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1740168,int_stack+0,int_stack+592548,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+1740168,int_stack+1572000,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1453200,int_stack+0,int_stack+2039676,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1684860,int_stack+1453200,int_stack+2225004,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1924440,int_stack+1684860,int_stack+763500,3630);
 /*--- compute (ld|nm) ---*/
 hrr1_build_ld(Libint->AB,int_stack+2523390,int_stack+1924440,int_stack+963150,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+224268,int_stack+219120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+230352,int_stack+224268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+237450,int_stack+230352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+245640,int_stack+237450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173862,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+173862,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+442200,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+255000,int_stack+245640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+519420,int_stack+113490,int_stack+173862,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+162630,int_stack+519420,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+590400,int_stack+162630,int_stack+442200,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+442200,int_stack+265608,int_stack+255000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+442200,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+698508,int_stack+0,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+56160,int_stack+698508,int_stack+519420,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+780408,int_stack+56160,int_stack+162630,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+908172,int_stack+780408,int_stack+590400,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+162630,int_stack+277542,int_stack+265608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+198432,int_stack+162630,int_stack+442200,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+442200,int_stack+198432,int_stack+0,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+535800,int_stack+442200,int_stack+698508,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1052316,int_stack+535800,int_stack+56160,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1201374,int_stack+1052316,int_stack+780408,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+658650,int_stack+1201374,int_stack+908172,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+290880,int_stack+277542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+40014,int_stack+0,int_stack+162630,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+843978,int_stack+40014,int_stack+198432,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+111618,int_stack+843978,int_stack+442200,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1371726,int_stack+111618,int_stack+535800,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+442200,int_stack+1371726,int_stack+1052316,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+950058,int_stack+442200,int_stack+1201374,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3503490,int_stack+950058,int_stack+658650,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+640944,int_stack+305700,int_stack+290880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+685404,int_stack+640944,int_stack+0,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1169082,int_stack+685404,int_stack+40014,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+640944,int_stack+1169082,int_stack+843978,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1169082,int_stack+640944,int_stack+111618,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+640944,int_stack+1169082,int_stack+1371726,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1169082,int_stack+640944,int_stack+442200,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+442200,int_stack+1169082,int_stack+950058,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+715980,int_stack+442200,int_stack+3503490,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+3503490,int_stack+715980,int_stack+1684860,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+4222230,int_stack+3503490,int_stack+1924440,3630);
 /*--- compute (lf|nm) ---*/
 hrr1_build_lf(Libint->AB,int_stack+5420130,int_stack+4222230,int_stack+2523390,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+442200,int_stack+328086,int_stack+322080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+460218,int_stack+335184,int_stack+328086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+481512,int_stack+460218,int_stack+442200,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+517548,int_stack+343465,int_stack+335184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+542391,int_stack+517548,int_stack+460218,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+584979,int_stack+542391,int_stack+481512,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+442200,int_stack+353020,int_stack+343465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+645039,int_stack+442200,int_stack+517548,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+470865,int_stack+645039,int_stack+542391,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+999120,int_stack+470865,int_stack+584979,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+541845,int_stack+363940,int_stack+353020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+574605,int_stack+541845,int_stack+442200,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1089210,int_stack+574605,int_stack+645039,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1172020,int_stack+1089210,int_stack+470865,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1278490,int_stack+1172020,int_stack+999120,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+999120,int_stack+376316,int_stack+363940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+442200,int_stack+999120,int_stack+541845,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1404616,int_stack+442200,int_stack+574605,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+507720,int_stack+1404616,int_stack+1089210,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1500166,int_stack+507720,int_stack+1172020,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1036248,int_stack+1500166,int_stack+1278490,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1204416,int_stack+390239,int_stack+376316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1246185,int_stack+1204416,int_stack+999120,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1649224,int_stack+1246185,int_stack+442200,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1758424,int_stack+1649224,int_stack+1404616,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1320441,int_stack+1758424,int_stack+507720,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+442200,int_stack+1320441,int_stack+1500166,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1901749,int_stack+442200,int_stack+1036248,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+640944,int_stack+405800,int_stack+390239,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+999120,int_stack+640944,int_stack+1204416,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1082658,int_stack+999120,int_stack+1246185,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2117965,int_stack+1082658,int_stack+1649224,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1494342,int_stack+2117965,int_stack+1758424,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2281765,int_stack+1494342,int_stack+1320441,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1206418,int_stack+2281765,int_stack+442200,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2513633,int_stack+1206418,int_stack+1901749,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+442200,int_stack+423090,int_stack+405800,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+494070,int_stack+442200,int_stack+640944,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1694997,int_stack+494070,int_stack+999120,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1834227,int_stack+1694997,int_stack+1082658,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2783903,int_stack+1834227,int_stack+2117965,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1694997,int_stack+2783903,int_stack+1494342,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2783903,int_stack+1694997,int_stack+2281765,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3082019,int_stack+2783903,int_stack+1206418,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+999120,int_stack+3082019,int_stack+2513633,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1329450,int_stack+999120,int_stack+715980,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+7053630,int_stack+1329450,int_stack+3503490,3630);
 /*--- compute (mf|nm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+0,int_stack+7053630,int_stack+4222230,3630);
 /*--- compute (lg|nm) ---*/
 hrr1_build_lg(Libint->AB,int_stack+1996500,int_stack+0,int_stack+5420130,3630);
 return int_stack+1996500;}
