/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_liml(Libint_t*, prim_data*);

  /* Computes quartets of (li|ml) integrals */

REALTYPE *hrr_order_liml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][9] = int_stack + 0;
 Libint->vrr_classes[8][10] = int_stack + 2475;
 Libint->vrr_classes[8][11] = int_stack + 5445;
 Libint->vrr_classes[8][12] = int_stack + 8955;
 Libint->vrr_classes[8][13] = int_stack + 13050;
 Libint->vrr_classes[8][14] = int_stack + 17775;
 Libint->vrr_classes[8][15] = int_stack + 23175;
 Libint->vrr_classes[8][16] = int_stack + 29295;
 Libint->vrr_classes[8][17] = int_stack + 36180;
 Libint->vrr_classes[9][9] = int_stack + 43875;
 Libint->vrr_classes[9][10] = int_stack + 46900;
 Libint->vrr_classes[9][11] = int_stack + 50530;
 Libint->vrr_classes[9][12] = int_stack + 54820;
 Libint->vrr_classes[9][13] = int_stack + 59825;
 Libint->vrr_classes[9][14] = int_stack + 65600;
 Libint->vrr_classes[9][15] = int_stack + 72200;
 Libint->vrr_classes[9][16] = int_stack + 79680;
 Libint->vrr_classes[9][17] = int_stack + 88095;
 Libint->vrr_classes[10][9] = int_stack + 97500;
 Libint->vrr_classes[10][10] = int_stack + 101130;
 Libint->vrr_classes[10][11] = int_stack + 105486;
 Libint->vrr_classes[10][12] = int_stack + 110634;
 Libint->vrr_classes[10][13] = int_stack + 116640;
 Libint->vrr_classes[10][14] = int_stack + 123570;
 Libint->vrr_classes[10][15] = int_stack + 131490;
 Libint->vrr_classes[10][16] = int_stack + 140466;
 Libint->vrr_classes[10][17] = int_stack + 150564;
 Libint->vrr_classes[11][9] = int_stack + 161850;
 Libint->vrr_classes[11][10] = int_stack + 166140;
 Libint->vrr_classes[11][11] = int_stack + 171288;
 Libint->vrr_classes[11][12] = int_stack + 177372;
 Libint->vrr_classes[11][13] = int_stack + 184470;
 Libint->vrr_classes[11][14] = int_stack + 192660;
 Libint->vrr_classes[11][15] = int_stack + 202020;
 Libint->vrr_classes[11][16] = int_stack + 212628;
 Libint->vrr_classes[11][17] = int_stack + 224562;
 Libint->vrr_classes[12][9] = int_stack + 237900;
 Libint->vrr_classes[12][10] = int_stack + 242905;
 Libint->vrr_classes[12][11] = int_stack + 248911;
 Libint->vrr_classes[12][12] = int_stack + 256009;
 Libint->vrr_classes[12][13] = int_stack + 264290;
 Libint->vrr_classes[12][14] = int_stack + 273845;
 Libint->vrr_classes[12][15] = int_stack + 284765;
 Libint->vrr_classes[12][16] = int_stack + 297141;
 Libint->vrr_classes[12][17] = int_stack + 311064;
 Libint->vrr_classes[13][9] = int_stack + 326625;
 Libint->vrr_classes[13][10] = int_stack + 332400;
 Libint->vrr_classes[13][11] = int_stack + 339330;
 Libint->vrr_classes[13][12] = int_stack + 347520;
 Libint->vrr_classes[13][13] = int_stack + 357075;
 Libint->vrr_classes[13][14] = int_stack + 368100;
 Libint->vrr_classes[13][15] = int_stack + 380700;
 Libint->vrr_classes[13][16] = int_stack + 394980;
 Libint->vrr_classes[13][17] = int_stack + 411045;
 Libint->vrr_classes[14][9] = int_stack + 429000;
 Libint->vrr_classes[14][10] = int_stack + 435600;
 Libint->vrr_classes[14][11] = int_stack + 443520;
 Libint->vrr_classes[14][12] = int_stack + 452880;
 Libint->vrr_classes[14][13] = int_stack + 463800;
 Libint->vrr_classes[14][14] = int_stack + 476400;
 Libint->vrr_classes[14][15] = int_stack + 490800;
 Libint->vrr_classes[14][16] = int_stack + 507120;
 Libint->vrr_classes[14][17] = int_stack + 525480;
 memset(int_stack,0,546000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 546000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_liml(Libint, Data);
   Data++;
 }
 /*--- compute (l0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+546000,int_stack+2475,int_stack+0,45);
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+553425,int_stack+5445,int_stack+2475,45);
 /*--- compute (l0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+562335,int_stack+553425,int_stack+546000,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+577185,int_stack+8955,int_stack+5445,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+587715,int_stack+577185,int_stack+553425,45);
 /*--- compute (l0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+605535,int_stack+587715,int_stack+562335,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+546000,int_stack+13050,int_stack+8955,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+630285,int_stack+546000,int_stack+577185,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+651345,int_stack+630285,int_stack+587715,45);
 /*--- compute (l0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+558285,int_stack+651345,int_stack+605535,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+595410,int_stack+17775,int_stack+13050,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+681045,int_stack+595410,int_stack+546000,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+705615,int_stack+681045,int_stack+630285,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+740715,int_stack+705615,int_stack+651345,45);
 /*--- compute (l0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+609585,int_stack+740715,int_stack+558285,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+546000,int_stack+23175,int_stack+17775,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+562200,int_stack+546000,int_stack+595410,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+785265,int_stack+562200,int_stack+681045,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+826215,int_stack+785265,int_stack+705615,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+661560,int_stack+826215,int_stack+740715,45);
 /*--- compute (l0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+878865,int_stack+661560,int_stack+609585,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+590550,int_stack+29295,int_stack+23175,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+608910,int_stack+590550,int_stack+546000,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+723930,int_stack+608910,int_stack+562200,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+948165,int_stack+723930,int_stack+785265,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1009590,int_stack+948165,int_stack+826215,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+771180,int_stack+1009590,int_stack+661560,45);
 /*--- compute (l0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1083300,int_stack+771180,int_stack+878865,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+546000,int_stack+36180,int_stack+29295,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+641310,int_stack+546000,int_stack+590550,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+546000,int_stack+641310,int_stack+608910,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+600000,int_stack+546000,int_stack+723930,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+670875,int_stack+600000,int_stack+948165,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+546000,int_stack+670875,int_stack+1009590,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+644280,int_stack+546000,int_stack+771180,45);
 /*--- compute (l0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+751200,int_stack+644280,int_stack+1083300,45);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+546000,int_stack+46900,int_stack+43875,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+555075,int_stack+50530,int_stack+46900,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+565965,int_stack+555075,int_stack+546000,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+584115,int_stack+54820,int_stack+50530,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+596985,int_stack+584115,int_stack+555075,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+618765,int_stack+596985,int_stack+565965,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+546000,int_stack+59825,int_stack+54820,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+649015,int_stack+546000,int_stack+584115,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+674755,int_stack+649015,int_stack+596985,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+561015,int_stack+674755,int_stack+618765,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+606390,int_stack+65600,int_stack+59825,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+711055,int_stack+606390,int_stack+546000,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+862575,int_stack+711055,int_stack+649015,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+905475,int_stack+862575,int_stack+674755,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+623715,int_stack+905475,int_stack+561015,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+546000,int_stack+72200,int_stack+65600,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+565800,int_stack+546000,int_stack+606390,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+959925,int_stack+565800,int_stack+711055,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1009975,int_stack+959925,int_stack+862575,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1074325,int_stack+1009975,int_stack+905475,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+862575,int_stack+1074325,int_stack+623715,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+600450,int_stack+79680,int_stack+72200,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+622890,int_stack+600450,int_stack+546000,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+662490,int_stack+622890,int_stack+565800,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+662490,int_stack+959925,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1150555,int_stack+0,int_stack+1009975,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+947275,int_stack+1150555,int_stack+1074325,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1240645,int_stack+947275,int_stack+862575,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+862575,int_stack+88095,int_stack+79680,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+887820,int_stack+862575,int_stack+600450,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+546000,int_stack+887820,int_stack+622890,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1048915,int_stack+546000,int_stack+662490,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+546000,int_stack+1048915,int_stack+0,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1349545,int_stack+546000,int_stack+1150555,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+546000,int_stack+1349545,int_stack+947275,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+862575,int_stack+546000,int_stack+1240645,55);
 /*--- compute (lp|ml) ---*/
 hrr1_build_lp(Libint->AB,int_stack+998700,int_stack+862575,int_stack+751200,2475);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+546000,int_stack+101130,int_stack+97500,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+556890,int_stack+105486,int_stack+101130,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+569958,int_stack+556890,int_stack+546000,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+591738,int_stack+110634,int_stack+105486,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+607182,int_stack+591738,int_stack+556890,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+633318,int_stack+607182,int_stack+569958,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+546000,int_stack+116640,int_stack+110634,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+669618,int_stack+546000,int_stack+591738,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+700506,int_stack+669618,int_stack+607182,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+564018,int_stack+700506,int_stack+633318,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+618468,int_stack+123570,int_stack+116640,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+744066,int_stack+618468,int_stack+546000,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+780102,int_stack+744066,int_stack+669618,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+780102,int_stack+700506,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+639258,int_stack+0,int_stack+564018,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+546000,int_stack+131490,int_stack+123570,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+569760,int_stack+546000,int_stack+618468,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+65340,int_stack+569760,int_stack+744066,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1332825,int_stack+65340,int_stack+780102,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+715488,int_stack+1332825,int_stack+0,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1410045,int_stack+715488,int_stack+639258,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+140466,int_stack+131490,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+611340,int_stack+0,int_stack+546000,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1511685,int_stack+611340,int_stack+569760,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1580985,int_stack+1511685,int_stack+65340,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+26928,int_stack+1580985,int_stack+1332825,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1671075,int_stack+26928,int_stack+715488,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+658860,int_stack+1671075,int_stack+1410045,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1332825,int_stack+150564,int_stack+140466,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1363119,int_stack+1332825,int_stack+0,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1416975,int_stack+1363119,int_stack+611340,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+546000,int_stack+1416975,int_stack+1511685,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1332825,int_stack+546000,int_stack+1580985,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1458951,int_stack+1332825,int_stack+26928,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1458951,int_stack+1671075,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1332825,int_stack+0,int_stack+658860,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1496175,int_stack+1332825,int_stack+862575,2475);
 /*--- compute (ld|ml) ---*/
 hrr1_build_ld(Libint->AB,int_stack+1904550,int_stack+1496175,int_stack+998700,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+166140,int_stack+161850,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+171288,int_stack+166140,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+54054,int_stack+177372,int_stack+171288,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+72306,int_stack+54054,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+103194,int_stack+72306,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+184470,int_stack+177372,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+146094,int_stack+0,int_stack+54054,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+546000,int_stack+146094,int_stack+72306,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+21294,int_stack+546000,int_stack+103194,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+85644,int_stack+192660,int_stack+184470,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+597480,int_stack+85644,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+640068,int_stack+597480,int_stack+146094,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+110214,int_stack+640068,int_stack+546000,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+700908,int_stack+110214,int_stack+21294,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+546000,int_stack+202020,int_stack+192660,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+546000,int_stack+85644,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+790998,int_stack+0,int_stack+597480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+861978,int_stack+790998,int_stack+640068,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+574080,int_stack+861978,int_stack+110214,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+49140,int_stack+574080,int_stack+700908,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+682188,int_stack+212628,int_stack+202020,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+714012,int_stack+682188,int_stack+546000,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+953238,int_stack+714012,int_stack+0,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1035138,int_stack+953238,int_stack+790998,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1141608,int_stack+1035138,int_stack+861978,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+770172,int_stack+1141608,int_stack+574080,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2572800,int_stack+770172,int_stack+49140,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+224562,int_stack+212628,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+35802,int_stack+0,int_stack+682188,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+99450,int_stack+35802,int_stack+714012,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+546000,int_stack+99450,int_stack+953238,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+546000,int_stack+1035138,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+546000,int_stack+0,int_stack+1141608,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+546000,int_stack+770172,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+546000,int_stack+0,int_stack+2572800,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+739050,int_stack+546000,int_stack+1332825,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+2572800,int_stack+739050,int_stack+1496175,2475);
 /*--- compute (lf|ml) ---*/
 hrr1_build_lf(Libint->AB,int_stack+3389550,int_stack+2572800,int_stack+1904550,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+242905,int_stack+237900,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+248911,int_stack+242905,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+256009,int_stack+248911,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120393,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+264290,int_stack+256009,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+170443,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1229100,int_stack+170443,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+1229100,int_stack+120393,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+99918,int_stack+273845,int_stack+264290,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+213031,int_stack+99918,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1289160,int_stack+213031,int_stack+170443,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1360140,int_stack+1289160,int_stack+1229100,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1450230,int_stack+1360140,int_stack+24843,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1229100,int_stack+284765,int_stack+273845,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+1229100,int_stack+99918,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+57330,int_stack+0,int_stack+213031,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+140140,int_stack+57330,int_stack+1289160,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1555335,int_stack+140140,int_stack+1360140,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1261860,int_stack+1555335,int_stack+1450230,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1402000,int_stack+297141,int_stack+284765,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1439128,int_stack+1402000,int_stack+1229100,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1681461,int_stack+1439128,int_stack+0,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1777011,int_stack+1681461,int_stack+57330,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1901226,int_stack+1777011,int_stack+140140,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1901226,int_stack+1555335,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2050284,int_stack+0,int_stack+1261860,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+168168,int_stack+311064,int_stack+297141,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+209937,int_stack+168168,int_stack+1402000,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1229100,int_stack+209937,int_stack+1439128,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+168168,int_stack+1229100,int_stack+1681461,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1229100,int_stack+168168,int_stack+1777011,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1403001,int_stack+1229100,int_stack+1901226,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1601745,int_stack+1403001,int_stack+0,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+1601745,int_stack+2050284,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+1229100,int_stack+0,int_stack+546000,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4503300,int_stack+1229100,int_stack+739050,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5483400,int_stack+4503300,int_stack+2572800,2475);
 /*--- compute (lg|ml) ---*/
 hrr1_build_lg(Libint->AB,int_stack+6844650,int_stack+5483400,int_stack+3389550,2475);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+546000,int_stack+332400,int_stack+326625,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+563325,int_stack+339330,int_stack+332400,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+584115,int_stack+563325,int_stack+546000,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+618765,int_stack+347520,int_stack+339330,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+643335,int_stack+618765,int_stack+563325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+684915,int_stack+643335,int_stack+584115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+546000,int_stack+357075,int_stack+347520,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+742665,int_stack+546000,int_stack+618765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+791805,int_stack+742665,int_stack+643335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+574665,int_stack+791805,int_stack+684915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+661290,int_stack+368100,int_stack+357075,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+861105,int_stack+661290,int_stack+546000,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+918435,int_stack+861105,int_stack+742665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1000335,int_stack+918435,int_stack+791805,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+694365,int_stack+1000335,int_stack+574665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+546000,int_stack+380700,int_stack+368100,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+583800,int_stack+546000,int_stack+661290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1104285,int_stack+583800,int_stack+861105,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+225225,int_stack+1104285,int_stack+918435,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+815640,int_stack+225225,int_stack+1000335,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1808250,int_stack+815640,int_stack+694365,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+649950,int_stack+394980,int_stack+380700,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+692790,int_stack+649950,int_stack+546000,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+961170,int_stack+692790,int_stack+583800,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1969950,int_stack+961170,int_stack+1104285,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2113275,int_stack+1969950,int_stack+225225,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2285265,int_stack+2113275,int_stack+815640,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2479305,int_stack+2285265,int_stack+1808250,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1808250,int_stack+411045,int_stack+394980,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1856445,int_stack+1808250,int_stack+649950,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+225225,int_stack+1856445,int_stack+692790,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+546000,int_stack+225225,int_stack+961170,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+225225,int_stack+546000,int_stack+1969950,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+546000,int_stack+225225,int_stack+2113275,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+775320,int_stack+546000,int_stack+2285265,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1808250,int_stack+775320,int_stack+2479305,105);
 /*--- compute (qp|ml) ---*/
 hrr1_build_qp(Libint->AB,int_stack+546000,int_stack+1808250,int_stack+0,2475);
 /*--- compute (od|ml) ---*/
 hrr1_build_od(Libint->AB,int_stack+2068125,int_stack+546000,int_stack+1229100,2475);
 /*--- compute (nf|ml) ---*/
 hrr1_build_nf(Libint->AB,int_stack+8515275,int_stack+2068125,int_stack+4503300,2475);
 /*--- compute (mg|ml) ---*/
 hrr1_build_mg(Libint->AB,int_stack+3226425,int_stack+8515275,int_stack+5483400,2475);
 /*--- compute (lh|ml) ---*/
 hrr1_build_lh(Libint->AB,int_stack+10148775,int_stack+3226425,int_stack+6844650,2475);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+435600,int_stack+429000,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+19800,int_stack+443520,int_stack+435600,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+43560,int_stack+19800,int_stack+0,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+83160,int_stack+452880,int_stack+443520,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+111240,int_stack+83160,int_stack+19800,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+158760,int_stack+111240,int_stack+43560,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+463800,int_stack+452880,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+224760,int_stack+0,int_stack+83160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+280920,int_stack+224760,int_stack+111240,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+32760,int_stack+280920,int_stack+158760,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+131760,int_stack+476400,int_stack+463800,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+360120,int_stack+131760,int_stack+0,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1221675,int_stack+360120,int_stack+224760,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1315275,int_stack+1221675,int_stack+280920,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+169560,int_stack+1315275,int_stack+32760,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+490800,int_stack+476400,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+131760,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1434075,int_stack+43200,int_stack+360120,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+308160,int_stack+1434075,int_stack+1221675,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1543275,int_stack+308160,int_stack+1315275,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1221675,int_stack+1543275,int_stack+169560,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+118800,int_stack+507120,int_stack+490800,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+167760,int_stack+118800,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5268300,int_stack+167760,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5394300,int_stack+5268300,int_stack+1434075,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5558100,int_stack+5394300,int_stack+308160,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254160,int_stack+5558100,int_stack+1543275,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1406475,int_stack+254160,int_stack+1221675,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1221675,int_stack+525480,int_stack+507120,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1276755,int_stack+1221675,int_stack+118800,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1276755,int_stack+167760,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5754660,int_stack+0,int_stack+5268300,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+5754660,int_stack+5394300,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+5754660,int_stack+0,int_stack+5558100,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+6016740,int_stack+5754660,int_stack+254160,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+6016740,int_stack+1406475,120);
 /*--- compute (rp|ml) ---*/
 hrr1_build_rp(Libint->AB,int_stack+5268300,int_stack+0,int_stack+1808250,2475);
 /*--- compute (qd|ml) ---*/
 hrr1_build_qd(Libint->AB,int_stack+6047925,int_stack+5268300,int_stack+546000,2475);
 /*--- compute (of|ml) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+6047925,int_stack+2068125,2475);
 /*--- compute (ng|ml) ---*/
 hrr1_build_ng(Libint->AB,int_stack+5268300,int_stack+0,int_stack+8515275,2475);
 /*--- compute (mh|ml) ---*/
 hrr1_build_mh(Libint->AB,int_stack+0,int_stack+5268300,int_stack+3226425,2475);
 /*--- compute (li|ml) ---*/
 hrr1_build_li(Libint->AB,int_stack+2858625,int_stack+0,int_stack+10148775,2475);
 return int_stack+2858625;}
