/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_lpnl(Libint_t*, prim_data*);

  /* Computes quartets of (lp|nl) integrals */

REALTYPE *hrr_order_lpnl(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[8][10] = int_stack + 0;
 Libint->vrr_classes[8][11] = int_stack + 2970;
 Libint->vrr_classes[8][12] = int_stack + 6480;
 Libint->vrr_classes[8][13] = int_stack + 10575;
 Libint->vrr_classes[8][14] = int_stack + 15300;
 Libint->vrr_classes[8][15] = int_stack + 20700;
 Libint->vrr_classes[8][16] = int_stack + 26820;
 Libint->vrr_classes[8][17] = int_stack + 33705;
 Libint->vrr_classes[8][18] = int_stack + 41400;
 Libint->vrr_classes[9][10] = int_stack + 49950;
 Libint->vrr_classes[9][11] = int_stack + 53580;
 Libint->vrr_classes[9][12] = int_stack + 57870;
 Libint->vrr_classes[9][13] = int_stack + 62875;
 Libint->vrr_classes[9][14] = int_stack + 68650;
 Libint->vrr_classes[9][15] = int_stack + 75250;
 Libint->vrr_classes[9][16] = int_stack + 82730;
 Libint->vrr_classes[9][17] = int_stack + 91145;
 Libint->vrr_classes[9][18] = int_stack + 100550;
 memset(int_stack,0,111000*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 111000;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_lpnl(Libint, Data);
   Data++;
 }
 /*--- compute (l0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+111000,int_stack+2970,int_stack+0,45);
 /*--- compute (l0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+119910,int_stack+6480,int_stack+2970,45);
 /*--- compute (l0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+130440,int_stack+119910,int_stack+111000,45);
 /*--- compute (l0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+148260,int_stack+10575,int_stack+6480,45);
 /*--- compute (l0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+160545,int_stack+148260,int_stack+119910,45);
 /*--- compute (l0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+181605,int_stack+160545,int_stack+130440,45);
 /*--- compute (l0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111000,int_stack+15300,int_stack+10575,45);
 /*--- compute (l0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+211305,int_stack+111000,int_stack+148260,45);
 /*--- compute (l0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+125175,int_stack+211305,int_stack+160545,45);
 /*--- compute (l0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+235875,int_stack+125175,int_stack+181605,45);
 /*--- compute (l0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+160275,int_stack+20700,int_stack+15300,45);
 /*--- compute (l0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+176475,int_stack+160275,int_stack+111000,45);
 /*--- compute (l0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+280425,int_stack+176475,int_stack+211305,45);
 /*--- compute (l0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+321375,int_stack+280425,int_stack+125175,45);
 /*--- compute (l0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+374025,int_stack+321375,int_stack+235875,45);
 /*--- compute (l0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+111000,int_stack+26820,int_stack+20700,45);
 /*--- compute (l0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+204825,int_stack+111000,int_stack+160275,45);
 /*--- compute (l0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+436395,int_stack+204825,int_stack+176475,45);
 /*--- compute (l0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+129360,int_stack+436395,int_stack+280425,45);
 /*--- compute (l0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+237225,int_stack+129360,int_stack+321375,45);
 /*--- compute (l0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+483645,int_stack+237225,int_stack+374025,45);
 /*--- compute (l0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+310935,int_stack+33705,int_stack+26820,45);
 /*--- compute (l0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+331590,int_stack+310935,int_stack+111000,45);
 /*--- compute (l0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+368310,int_stack+331590,int_stack+204825,45);
 /*--- compute (l0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+566805,int_stack+368310,int_stack+436395,45);
 /*--- compute (l0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+637680,int_stack+566805,int_stack+129360,45);
 /*--- compute (l0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+111000,int_stack+637680,int_stack+237225,45);
 /*--- compute (l0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+723675,int_stack+111000,int_stack+483645,45);
 /*--- compute (l0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+209280,int_stack+41400,int_stack+33705,45);
 /*--- compute (l0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+232365,int_stack+209280,int_stack+310935,45);
 /*--- compute (l0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+422310,int_stack+232365,int_stack+331590,45);
 /*--- compute (l0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+209280,int_stack+422310,int_stack+368310,45);
 /*--- compute (l0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+290280,int_stack+209280,int_stack+566805,45);
 /*--- compute (l0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+389505,int_stack+290280,int_stack+637680,45);
 /*--- compute (l0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+209280,int_stack+389505,int_stack+111000,45);
 /*--- compute (l0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+335640,int_stack+209280,int_stack+723675,45);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+111000,int_stack+53580,int_stack+49950,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+121890,int_stack+57870,int_stack+53580,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+134760,int_stack+121890,int_stack+111000,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+156540,int_stack+62875,int_stack+57870,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+171555,int_stack+156540,int_stack+121890,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+197295,int_stack+171555,int_stack+134760,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+111000,int_stack+68650,int_stack+62875,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+233595,int_stack+111000,int_stack+156540,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+128325,int_stack+233595,int_stack+171555,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+263625,int_stack+128325,int_stack+197295,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+171225,int_stack+75250,int_stack+68650,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+191025,int_stack+171225,int_stack+111000,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+469290,int_stack+191025,int_stack+233595,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+519340,int_stack+469290,int_stack+128325,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+583690,int_stack+519340,int_stack+263625,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+111000,int_stack+82730,int_stack+75250,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+225675,int_stack+111000,int_stack+171225,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+265275,int_stack+225675,int_stack+191025,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+133440,int_stack+265275,int_stack+469290,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+659920,int_stack+133440,int_stack+519340,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+469290,int_stack+659920,int_stack+583690,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+570930,int_stack+91145,int_stack+82730,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+596175,int_stack+570930,int_stack+111000,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+750010,int_stack+596175,int_stack+225675,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+750010,int_stack+265275,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+208515,int_stack+0,int_stack+133440,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+816010,int_stack+208515,int_stack+659920,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+936130,int_stack+816010,int_stack+469290,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+469290,int_stack+100550,int_stack+91145,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+497505,int_stack+469290,int_stack+570930,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+641055,int_stack+497505,int_stack+596175,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+469290,int_stack+641055,int_stack+750010,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+568290,int_stack+469290,int_stack+0,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+568290,int_stack+208515,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+140140,int_stack+0,int_stack+816010,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+469290,int_stack+140140,int_stack+936130,55);
 /*--- compute (lp|nl) ---*/
 hrr1_build_lp(Libint->AB,int_stack+632640,int_stack+469290,int_stack+335640,2970);
 return int_stack+632640;}
