/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdlk(Libint_t*, prim_data*);

  /* Computes quartets of (md|lk) integrals */

REALTYPE *hrr_order_mdlk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][8] = int_stack + 0;
 Libint->vrr_classes[9][9] = int_stack + 2475;
 Libint->vrr_classes[9][10] = int_stack + 5500;
 Libint->vrr_classes[9][11] = int_stack + 9130;
 Libint->vrr_classes[9][12] = int_stack + 13420;
 Libint->vrr_classes[9][13] = int_stack + 18425;
 Libint->vrr_classes[9][14] = int_stack + 24200;
 Libint->vrr_classes[9][15] = int_stack + 30800;
 Libint->vrr_classes[10][8] = int_stack + 38280;
 Libint->vrr_classes[10][9] = int_stack + 41250;
 Libint->vrr_classes[10][10] = int_stack + 44880;
 Libint->vrr_classes[10][11] = int_stack + 49236;
 Libint->vrr_classes[10][12] = int_stack + 54384;
 Libint->vrr_classes[10][13] = int_stack + 60390;
 Libint->vrr_classes[10][14] = int_stack + 67320;
 Libint->vrr_classes[10][15] = int_stack + 75240;
 Libint->vrr_classes[11][8] = int_stack + 84216;
 Libint->vrr_classes[11][9] = int_stack + 87726;
 Libint->vrr_classes[11][10] = int_stack + 92016;
 Libint->vrr_classes[11][11] = int_stack + 97164;
 Libint->vrr_classes[11][12] = int_stack + 103248;
 Libint->vrr_classes[11][13] = int_stack + 110346;
 Libint->vrr_classes[11][14] = int_stack + 118536;
 Libint->vrr_classes[11][15] = int_stack + 127896;
 memset(int_stack,0,138504*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 138504;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdlk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+138504,int_stack+2475,int_stack+0,55);
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+145929,int_stack+5500,int_stack+2475,55);
 /*--- compute (m0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+155004,int_stack+145929,int_stack+138504,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+169854,int_stack+9130,int_stack+5500,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+180744,int_stack+169854,int_stack+145929,55);
 /*--- compute (m0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+198894,int_stack+180744,int_stack+155004,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+138504,int_stack+13420,int_stack+9130,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+223644,int_stack+138504,int_stack+169854,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+245424,int_stack+223644,int_stack+180744,55);
 /*--- compute (m0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+151374,int_stack+245424,int_stack+198894,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+188499,int_stack+18425,int_stack+13420,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+275674,int_stack+188499,int_stack+138504,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+301414,int_stack+275674,int_stack+223644,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+337714,int_stack+301414,int_stack+245424,55);
 /*--- compute (m0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+203514,int_stack+337714,int_stack+151374,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+138504,int_stack+24200,int_stack+18425,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+155829,int_stack+138504,int_stack+188499,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+383089,int_stack+155829,int_stack+275674,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+425989,int_stack+383089,int_stack+301414,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+255489,int_stack+425989,int_stack+337714,55);
 /*--- compute (m0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+480439,int_stack+255489,int_stack+203514,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+185859,int_stack+30800,int_stack+24200,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+205659,int_stack+185859,int_stack+138504,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+319014,int_stack+205659,int_stack+155829,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+138504,int_stack+319014,int_stack+383089,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+319014,int_stack+138504,int_stack+425989,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+138504,int_stack+319014,int_stack+255489,55);
 /*--- compute (m0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+223204,int_stack+138504,int_stack+480439,55);
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+138504,int_stack+41250,int_stack+38280,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+147414,int_stack+44880,int_stack+41250,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+158304,int_stack+147414,int_stack+138504,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+176124,int_stack+49236,int_stack+44880,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+189192,int_stack+176124,int_stack+147414,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+312304,int_stack+189192,int_stack+158304,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+138504,int_stack+54384,int_stack+49236,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+342004,int_stack+138504,int_stack+176124,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+368140,int_stack+342004,int_stack+189192,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+153948,int_stack+368140,int_stack+312304,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+312304,int_stack+60390,int_stack+54384,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+404440,int_stack+312304,int_stack+138504,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+435328,int_stack+404440,int_stack+342004,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+478888,int_stack+435328,int_stack+368140,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+330322,int_stack+478888,int_stack+153948,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+138504,int_stack+67320,int_stack+60390,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+159294,int_stack+138504,int_stack+312304,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+0,int_stack+159294,int_stack+404440,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+533338,int_stack+0,int_stack+435328,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+392692,int_stack+533338,int_stack+478888,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+598678,int_stack+392692,int_stack+330322,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+312304,int_stack+75240,int_stack+67320,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+336064,int_stack+312304,int_stack+138504,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+468922,int_stack+336064,int_stack+159294,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+138504,int_stack+468922,int_stack+0,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+681838,int_stack+138504,int_stack+533338,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+468922,int_stack+681838,int_stack+392692,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+312304,int_stack+468922,int_stack+598678,66);
 /*--- compute (mp|lk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+419224,int_stack+312304,int_stack+223204,1620);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+138504,int_stack+87726,int_stack+84216,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149034,int_stack+92016,int_stack+87726,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+161904,int_stack+149034,int_stack+138504,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+182964,int_stack+97164,int_stack+92016,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+198408,int_stack+182964,int_stack+149034,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+224148,int_stack+198408,int_stack+161904,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+138504,int_stack+103248,int_stack+97164,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+259248,int_stack+138504,int_stack+182964,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+0,int_stack+259248,int_stack+198408,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+156756,int_stack+0,int_stack+224148,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+209406,int_stack+110346,int_stack+103248,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+42900,int_stack+209406,int_stack+138504,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+686524,int_stack+42900,int_stack+259248,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+230700,int_stack+686524,int_stack+0,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+738004,int_stack+230700,int_stack+156756,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+118536,int_stack+110346,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+138504,int_stack+0,int_stack+209406,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+811714,int_stack+138504,int_stack+42900,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+24570,int_stack+811714,int_stack+686524,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+872554,int_stack+24570,int_stack+230700,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+181092,int_stack+872554,int_stack+738004,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+686524,int_stack+127896,int_stack+118536,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+714604,int_stack+686524,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+962644,int_stack+714604,int_stack+138504,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+686524,int_stack+962644,int_stack+811714,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+962644,int_stack+686524,int_stack+24570,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+686524,int_stack+962644,int_stack+872554,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+806644,int_stack+686524,int_stack+181092,78);
 /*--- compute (np|lk) ---*/
 hrr1_build_np(Libint->AB,int_stack+933004,int_stack+806644,int_stack+312304,1620);
 /*--- compute (md|lk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1253764,int_stack+933004,int_stack+419224,1620);
 return int_stack+1253764;}
