/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mdnk(Libint_t*, prim_data*);

  /* Computes quartets of (md|nk) integrals */

REALTYPE *hrr_order_mdnk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 Libint->vrr_classes[10][14] = int_stack + 73040;
 Libint->vrr_classes[10][15] = int_stack + 80960;
 Libint->vrr_classes[10][16] = int_stack + 89936;
 Libint->vrr_classes[10][17] = int_stack + 100034;
 Libint->vrr_classes[11][10] = int_stack + 111320;
 Libint->vrr_classes[11][11] = int_stack + 116468;
 Libint->vrr_classes[11][12] = int_stack + 122552;
 Libint->vrr_classes[11][13] = int_stack + 129650;
 Libint->vrr_classes[11][14] = int_stack + 137840;
 Libint->vrr_classes[11][15] = int_stack + 147200;
 Libint->vrr_classes[11][16] = int_stack + 157808;
 Libint->vrr_classes[11][17] = int_stack + 169742;
 memset(int_stack,0,183080*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 183080;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mdnk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183080,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+193970,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+206840,int_stack+193970,int_stack+183080,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+228620,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+243635,int_stack+228620,int_stack+193970,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+269375,int_stack+243635,int_stack+206840,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+183080,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+305675,int_stack+183080,int_stack+228620,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+200405,int_stack+305675,int_stack+243635,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+335705,int_stack+200405,int_stack+269375,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+243305,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+263105,int_stack+243305,int_stack+183080,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+390155,int_stack+263105,int_stack+305675,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+440205,int_stack+390155,int_stack+200405,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+504555,int_stack+440205,int_stack+335705,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+183080,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+297755,int_stack+183080,int_stack+243305,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+580785,int_stack+297755,int_stack+263105,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+205520,int_stack+580785,int_stack+390155,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+337355,int_stack+205520,int_stack+440205,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+638535,int_stack+337355,int_stack+504555,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+427445,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+452690,int_stack+427445,int_stack+183080,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+497570,int_stack+452690,int_stack+297755,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+740175,int_stack+497570,int_stack+580785,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+427445,int_stack+740175,int_stack+205520,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+183080,int_stack+427445,int_stack+337355,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+303200,int_stack+183080,int_stack+638535,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+183080,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+196148,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+211592,int_stack+196148,int_stack+183080,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+237728,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+255746,int_stack+237728,int_stack+196148,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+433880,int_stack+255746,int_stack+211592,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+183080,int_stack+73040,int_stack+66110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+477440,int_stack+183080,int_stack+237728,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+203870,int_stack+477440,int_stack+255746,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+513476,int_stack+203870,int_stack+433880,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+433880,int_stack+80960,int_stack+73040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+255350,int_stack+433880,int_stack+183080,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+578816,int_stack+255350,int_stack+477440,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+638876,int_stack+578816,int_stack+203870,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+716096,int_stack+638876,int_stack+513476,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+183080,int_stack+89936,int_stack+80960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+457640,int_stack+183080,int_stack+433880,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+505160,int_stack+457640,int_stack+255350,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+210008,int_stack+505160,int_stack+578816,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+807572,int_stack+210008,int_stack+638876,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+574460,int_stack+807572,int_stack+716096,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+696428,int_stack+100034,int_stack+89936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+726722,int_stack+696428,int_stack+183080,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+726722,int_stack+457640,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+696428,int_stack+0,int_stack+505160,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+433880,int_stack+696428,int_stack+210008,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+915680,int_stack+433880,int_stack+807572,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+696428,int_stack+915680,int_stack+574460,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+853244,int_stack+696428,int_stack+303200,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+116468,int_stack+111320,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+122552,int_stack+116468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+129650,int_stack+122552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+183080,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137840,int_stack+129650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+234560,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+234560,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+277148,int_stack+24570,int_stack+183080,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+183080,int_stack+147200,int_stack+137840,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+183080,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+354368,int_stack+85410,int_stack+234560,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+425348,int_stack+354368,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+516608,int_stack+425348,int_stack+277148,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+157808,int_stack+147200,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+211160,int_stack+0,int_stack+183080,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+267320,int_stack+211160,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+267320,int_stack+354368,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1245284,int_stack+31824,int_stack+425348,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+349220,int_stack+1245284,int_stack+516608,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+493364,int_stack+169742,int_stack+157808,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+138294,int_stack+493364,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+493364,int_stack+138294,int_stack+211160,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+138294,int_stack+493364,int_stack+267320,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+493364,int_stack+138294,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+493364,int_stack+1245284,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+493364,int_stack+0,int_stack+349220,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+0,int_stack+493364,int_stack+696428,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1245284,int_stack+0,int_stack+853244,2376);
 return int_stack+1245284;}
