/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mfmh(Libint_t*, prim_data*);

  /* Computes quartets of (mf|mh) integrals */

REALTYPE *hrr_order_mfmh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[10][9] = int_stack + 28325;
 Libint->vrr_classes[10][10] = int_stack + 31955;
 Libint->vrr_classes[10][11] = int_stack + 36311;
 Libint->vrr_classes[10][12] = int_stack + 41459;
 Libint->vrr_classes[10][13] = int_stack + 47465;
 Libint->vrr_classes[10][14] = int_stack + 54395;
 Libint->vrr_classes[11][9] = int_stack + 62315;
 Libint->vrr_classes[11][10] = int_stack + 66605;
 Libint->vrr_classes[11][11] = int_stack + 71753;
 Libint->vrr_classes[11][12] = int_stack + 77837;
 Libint->vrr_classes[11][13] = int_stack + 84935;
 Libint->vrr_classes[11][14] = int_stack + 93125;
 Libint->vrr_classes[12][9] = int_stack + 102485;
 Libint->vrr_classes[12][10] = int_stack + 107490;
 Libint->vrr_classes[12][11] = int_stack + 113496;
 Libint->vrr_classes[12][12] = int_stack + 120594;
 Libint->vrr_classes[12][13] = int_stack + 128875;
 Libint->vrr_classes[12][14] = int_stack + 138430;
 memset(int_stack,0,149350*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 149350;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mfmh(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149350,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+158425,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+169315,int_stack+158425,int_stack+149350,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+187465,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+200335,int_stack+187465,int_stack+158425,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+222115,int_stack+200335,int_stack+169315,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149350,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+252365,int_stack+149350,int_stack+187465,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+278105,int_stack+252365,int_stack+200335,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+164365,int_stack+278105,int_stack+222115,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+209740,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+314405,int_stack+209740,int_stack+149350,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+344435,int_stack+314405,int_stack+252365,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+209740,int_stack+344435,int_stack+278105,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+264190,int_stack+209740,int_stack+164365,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+149350,int_stack+31955,int_stack+28325,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+160240,int_stack+36311,int_stack+31955,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+173308,int_stack+160240,int_stack+149350,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+195088,int_stack+41459,int_stack+36311,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+210532,int_stack+195088,int_stack+160240,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+327715,int_stack+210532,int_stack+173308,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149350,int_stack+47465,int_stack+41459,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+149350,int_stack+195088,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+364015,int_stack+0,int_stack+210532,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+167368,int_stack+364015,int_stack+327715,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+327715,int_stack+54395,int_stack+47465,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+221818,int_stack+327715,int_stack+149350,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+407575,int_stack+221818,int_stack+0,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+459055,int_stack+407575,int_stack+364015,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+327715,int_stack+459055,int_stack+167368,66);
 /*--- compute (mp|mh) ---*/
 hrr1_build_mp(Libint->AB,int_stack+403945,int_stack+327715,int_stack+264190,1155);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+66605,int_stack+62315,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+12870,int_stack+71753,int_stack+66605,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+28314,int_stack+12870,int_stack+0,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+149350,int_stack+77837,int_stack+71753,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+167602,int_stack+149350,int_stack+12870,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+198490,int_stack+167602,int_stack+28314,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+84935,int_stack+77837,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+21294,int_stack+0,int_stack+149350,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+241390,int_stack+21294,int_stack+167602,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+594520,int_stack+241390,int_stack+198490,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149350,int_stack+93125,int_stack+84935,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+173920,int_stack+149350,int_stack+0,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+658870,int_stack+173920,int_stack+21294,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+0,int_stack+658870,int_stack+241390,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+149350,int_stack+0,int_stack+594520,78);
 /*--- compute (np|mh) ---*/
 hrr1_build_np(Libint->AB,int_stack+594520,int_stack+149350,int_stack+327715,1155);
 /*--- compute (md|mh) ---*/
 hrr1_build_md(Libint->AB,int_stack+823210,int_stack+594520,int_stack+403945,1155);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+107490,int_stack+102485,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+15015,int_stack+113496,int_stack+107490,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+33033,int_stack+15015,int_stack+0,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+63063,int_stack+120594,int_stack+113496,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+84357,int_stack+63063,int_stack+15015,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+239440,int_stack+84357,int_stack+33033,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+128875,int_stack+120594,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+289490,int_stack+0,int_stack+63063,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+332078,int_stack+289490,int_stack+84357,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+24843,int_stack+332078,int_stack+239440,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+239440,int_stack+138430,int_stack+128875,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+392138,int_stack+239440,int_stack+0,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+441824,int_stack+392138,int_stack+289490,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+239440,int_stack+441824,int_stack+332078,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+329530,int_stack+239440,int_stack+24843,91);
 /*--- compute (op|mh) ---*/
 hrr1_build_op(Libint->AB,int_stack+1204360,int_stack+329530,int_stack+149350,1155);
 /*--- compute (nd|mh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+0,int_stack+1204360,int_stack+594520,1155);
 /*--- compute (mf|mh) ---*/
 hrr1_build_mf(Libint->AB,int_stack+1204360,int_stack+0,int_stack+823210,1155);
 return int_stack+1204360;}
