/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_miml(Libint_t*, prim_data*);

  /* Computes quartets of (mi|ml) integrals */

REALTYPE *hrr_order_miml(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[9][17] = int_stack + 44220;
 Libint->vrr_classes[10][9] = int_stack + 53625;
 Libint->vrr_classes[10][10] = int_stack + 57255;
 Libint->vrr_classes[10][11] = int_stack + 61611;
 Libint->vrr_classes[10][12] = int_stack + 66759;
 Libint->vrr_classes[10][13] = int_stack + 72765;
 Libint->vrr_classes[10][14] = int_stack + 79695;
 Libint->vrr_classes[10][15] = int_stack + 87615;
 Libint->vrr_classes[10][16] = int_stack + 96591;
 Libint->vrr_classes[10][17] = int_stack + 106689;
 Libint->vrr_classes[11][9] = int_stack + 117975;
 Libint->vrr_classes[11][10] = int_stack + 122265;
 Libint->vrr_classes[11][11] = int_stack + 127413;
 Libint->vrr_classes[11][12] = int_stack + 133497;
 Libint->vrr_classes[11][13] = int_stack + 140595;
 Libint->vrr_classes[11][14] = int_stack + 148785;
 Libint->vrr_classes[11][15] = int_stack + 158145;
 Libint->vrr_classes[11][16] = int_stack + 168753;
 Libint->vrr_classes[11][17] = int_stack + 180687;
 Libint->vrr_classes[12][9] = int_stack + 194025;
 Libint->vrr_classes[12][10] = int_stack + 199030;
 Libint->vrr_classes[12][11] = int_stack + 205036;
 Libint->vrr_classes[12][12] = int_stack + 212134;
 Libint->vrr_classes[12][13] = int_stack + 220415;
 Libint->vrr_classes[12][14] = int_stack + 229970;
 Libint->vrr_classes[12][15] = int_stack + 240890;
 Libint->vrr_classes[12][16] = int_stack + 253266;
 Libint->vrr_classes[12][17] = int_stack + 267189;
 Libint->vrr_classes[13][9] = int_stack + 282750;
 Libint->vrr_classes[13][10] = int_stack + 288525;
 Libint->vrr_classes[13][11] = int_stack + 295455;
 Libint->vrr_classes[13][12] = int_stack + 303645;
 Libint->vrr_classes[13][13] = int_stack + 313200;
 Libint->vrr_classes[13][14] = int_stack + 324225;
 Libint->vrr_classes[13][15] = int_stack + 336825;
 Libint->vrr_classes[13][16] = int_stack + 351105;
 Libint->vrr_classes[13][17] = int_stack + 367170;
 Libint->vrr_classes[14][9] = int_stack + 385125;
 Libint->vrr_classes[14][10] = int_stack + 391725;
 Libint->vrr_classes[14][11] = int_stack + 399645;
 Libint->vrr_classes[14][12] = int_stack + 409005;
 Libint->vrr_classes[14][13] = int_stack + 419925;
 Libint->vrr_classes[14][14] = int_stack + 432525;
 Libint->vrr_classes[14][15] = int_stack + 446925;
 Libint->vrr_classes[14][16] = int_stack + 463245;
 Libint->vrr_classes[14][17] = int_stack + 481605;
 Libint->vrr_classes[15][9] = int_stack + 502125;
 Libint->vrr_classes[15][10] = int_stack + 509605;
 Libint->vrr_classes[15][11] = int_stack + 518581;
 Libint->vrr_classes[15][12] = int_stack + 529189;
 Libint->vrr_classes[15][13] = int_stack + 541565;
 Libint->vrr_classes[15][14] = int_stack + 555845;
 Libint->vrr_classes[15][15] = int_stack + 572165;
 Libint->vrr_classes[15][16] = int_stack + 590661;
 Libint->vrr_classes[15][17] = int_stack + 611469;
 memset(int_stack,0,634725*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 634725;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_miml(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+634725,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+643800,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+654690,int_stack+643800,int_stack+634725,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+672840,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+685710,int_stack+672840,int_stack+643800,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+707490,int_stack+685710,int_stack+654690,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+634725,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+737740,int_stack+634725,int_stack+672840,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+763480,int_stack+737740,int_stack+685710,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+649740,int_stack+763480,int_stack+707490,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+695115,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+799780,int_stack+695115,int_stack+634725,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+829810,int_stack+799780,int_stack+737740,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+872710,int_stack+829810,int_stack+763480,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+712440,int_stack+872710,int_stack+649740,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+634725,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+654525,int_stack+634725,int_stack+695115,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+927160,int_stack+654525,int_stack+799780,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+977210,int_stack+927160,int_stack+829810,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+775965,int_stack+977210,int_stack+872710,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1041560,int_stack+775965,int_stack+712440,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+689175,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+711615,int_stack+689175,int_stack+634725,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+852195,int_stack+711615,int_stack+654525,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1126260,int_stack+852195,int_stack+927160,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1201335,int_stack+1126260,int_stack+977210,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+909945,int_stack+1201335,int_stack+775965,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1291425,int_stack+909945,int_stack+1041560,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+634725,int_stack+44220,int_stack+35805,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+751215,int_stack+634725,int_stack+689175,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+634725,int_stack+751215,int_stack+711615,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+700725,int_stack+634725,int_stack+852195,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+787350,int_stack+700725,int_stack+1126260,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+634725,int_stack+787350,int_stack+1201335,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+754845,int_stack+634725,int_stack+909945,55);
 /*--- compute (m0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+885525,int_stack+754845,int_stack+1291425,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+634725,int_stack+57255,int_stack+53625,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+645615,int_stack+61611,int_stack+57255,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+658683,int_stack+645615,int_stack+634725,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+680463,int_stack+66759,int_stack+61611,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+695907,int_stack+680463,int_stack+645615,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+722043,int_stack+695907,int_stack+658683,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+634725,int_stack+72765,int_stack+66759,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+758343,int_stack+634725,int_stack+680463,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+789231,int_stack+758343,int_stack+695907,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+652743,int_stack+789231,int_stack+722043,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+707193,int_stack+79695,int_stack+72765,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+832791,int_stack+707193,int_stack+634725,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1021650,int_stack+832791,int_stack+758343,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1073130,int_stack+1021650,int_stack+789231,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+727983,int_stack+1073130,int_stack+652743,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+634725,int_stack+87615,int_stack+79695,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+658485,int_stack+634725,int_stack+707193,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1138470,int_stack+658485,int_stack+832791,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+804213,int_stack+1138470,int_stack+1021650,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1198530,int_stack+804213,int_stack+1073130,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1021650,int_stack+1198530,int_stack+727983,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+700065,int_stack+96591,int_stack+87615,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+726993,int_stack+700065,int_stack+634725,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1290006,int_stack+726993,int_stack+658485,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1290006,int_stack+1138470,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1359306,int_stack+0,int_stack+804213,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1467414,int_stack+1359306,int_stack+1198530,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1123290,int_stack+1467414,int_stack+1021650,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1021650,int_stack+106689,int_stack+96591,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1051944,int_stack+1021650,int_stack+700065,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+634725,int_stack+1051944,int_stack+726993,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+713925,int_stack+634725,int_stack+1290006,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1589382,int_stack+713925,int_stack+0,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+634725,int_stack+1589382,int_stack+1359306,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1253970,int_stack+634725,int_stack+1467414,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+634725,int_stack+1253970,int_stack+1123290,66);
 /*--- compute (mp|ml) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1021650,int_stack+634725,int_stack+885525,2475);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+798075,int_stack+122265,int_stack+117975,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+810945,int_stack+127413,int_stack+122265,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+826389,int_stack+810945,int_stack+798075,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+852129,int_stack+133497,int_stack+127413,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+870381,int_stack+852129,int_stack+810945,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+901269,int_stack+870381,int_stack+826389,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+798075,int_stack+140595,int_stack+133497,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+944169,int_stack+798075,int_stack+852129,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+944169,int_stack+870381,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+819369,int_stack+0,int_stack+901269,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+883719,int_stack+148785,int_stack+140595,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+51480,int_stack+883719,int_stack+798075,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1430025,int_stack+51480,int_stack+944169,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+908289,int_stack+1430025,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1490865,int_stack+908289,int_stack+819369,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+158145,int_stack+148785,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+798075,int_stack+0,int_stack+883719,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1580955,int_stack+798075,int_stack+51480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+28080,int_stack+1580955,int_stack+1430025,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1651935,int_stack+28080,int_stack+908289,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+847215,int_stack+1651935,int_stack+1490865,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1430025,int_stack+168753,int_stack+158145,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1461849,int_stack+1430025,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1760043,int_stack+1461849,int_stack+798075,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1841943,int_stack+1760043,int_stack+1580955,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1518009,int_stack+1841943,int_stack+28080,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1518009,int_stack+1651935,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1948413,int_stack+0,int_stack+847215,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+798075,int_stack+180687,int_stack+168753,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+833877,int_stack+798075,int_stack+1430025,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+897525,int_stack+833877,int_stack+1461849,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2102853,int_stack+897525,int_stack+1760043,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+798075,int_stack+2102853,int_stack+1841943,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1645773,int_stack+798075,int_stack+1518009,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+798075,int_stack+1645773,int_stack+0,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+798075,int_stack+1948413,78);
 /*--- compute (np|ml) ---*/
 hrr1_build_np(Libint->AB,int_stack+1430025,int_stack+0,int_stack+634725,2475);
 /*--- compute (md|ml) ---*/
 hrr1_build_md(Libint->AB,int_stack+1920075,int_stack+1430025,int_stack+1021650,2475);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+634725,int_stack+199030,int_stack+194025,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+649740,int_stack+205036,int_stack+199030,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+667758,int_stack+649740,int_stack+634725,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+697788,int_stack+212134,int_stack+205036,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+719082,int_stack+697788,int_stack+649740,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+755118,int_stack+719082,int_stack+667758,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+634725,int_stack+220415,int_stack+212134,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+805168,int_stack+634725,int_stack+697788,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+847756,int_stack+805168,int_stack+719082,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+659568,int_stack+847756,int_stack+755118,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+734643,int_stack+229970,int_stack+220415,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+907816,int_stack+734643,int_stack+634725,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+957502,int_stack+907816,int_stack+805168,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1028482,int_stack+957502,int_stack+847756,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+763308,int_stack+1028482,int_stack+659568,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+634725,int_stack+240890,int_stack+229970,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+667485,int_stack+634725,int_stack+734643,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1118572,int_stack+667485,int_stack+907816,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1201382,int_stack+1118572,int_stack+957502,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+868413,int_stack+1201382,int_stack+1028482,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+2736825,int_stack+868413,int_stack+763308,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+724815,int_stack+253266,int_stack+240890,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+761943,int_stack+724815,int_stack+634725,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+994539,int_stack+761943,int_stack+667485,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2876965,int_stack+994539,int_stack+1118572,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3001180,int_stack+2876965,int_stack+1201382,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1090089,int_stack+3001180,int_stack+868413,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3150238,int_stack+1090089,int_stack+2736825,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2736825,int_stack+267189,int_stack+253266,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2778594,int_stack+2736825,int_stack+724815,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+634725,int_stack+2778594,int_stack+761943,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+743925,int_stack+634725,int_stack+994539,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+887250,int_stack+743925,int_stack+2876965,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+634725,int_stack+887250,int_stack+3001180,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+833469,int_stack+634725,int_stack+1090089,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1049685,int_stack+833469,int_stack+3150238,91);
 /*--- compute (op|ml) ---*/
 hrr1_build_op(Libint->AB,int_stack+2736825,int_stack+1049685,int_stack+0,2475);
 /*--- compute (nd|ml) ---*/
 hrr1_build_nd(Libint->AB,int_stack+3315975,int_stack+2736825,int_stack+1430025,2475);
 /*--- compute (mf|ml) ---*/
 hrr1_build_mf(Libint->AB,int_stack+4296075,int_stack+3315975,int_stack+1920075,2475);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+288525,int_stack+282750,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+295455,int_stack+288525,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+303645,int_stack+295455,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+313200,int_stack+303645,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+634725,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+634725,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+324225,int_stack+313200,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+245805,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+704025,int_stack+245805,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+785925,int_stack+704025,int_stack+634725,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+889875,int_stack+785925,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+634725,int_stack+336825,int_stack+324225,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+634725,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+66150,int_stack+0,int_stack+245805,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+161700,int_stack+66150,int_stack+704025,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1274910,int_stack+161700,int_stack+785925,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+672525,int_stack+1274910,int_stack+889875,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+834225,int_stack+351105,int_stack+336825,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+877065,int_stack+834225,int_stack+634725,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1420440,int_stack+877065,int_stack+0,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1530690,int_stack+1420440,int_stack+66150,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1674015,int_stack+1530690,int_stack+161700,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1674015,int_stack+1274910,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1846005,int_stack+0,int_stack+672525,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1274910,int_stack+367170,int_stack+351105,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1323105,int_stack+1274910,int_stack+834225,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+194040,int_stack+1323105,int_stack+877065,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+634725,int_stack+194040,int_stack+1420440,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1274910,int_stack+634725,int_stack+1530690,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+634725,int_stack+1274910,int_stack+1674015,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1274910,int_stack+634725,int_stack+0,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+1274910,int_stack+1846005,105);
 /*--- compute (qp|ml) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1274910,int_stack+0,int_stack+1049685,2475);
 /*--- compute (od|ml) ---*/
 hrr1_build_od(Libint->AB,int_stack+5657325,int_stack+1274910,int_stack+2736825,2475);
 /*--- compute (nf|ml) ---*/
 hrr1_build_nf(Libint->AB,int_stack+6815625,int_stack+5657325,int_stack+3315975,2475);
 /*--- compute (mg|ml) ---*/
 hrr1_build_mg(Libint->AB,int_stack+1950585,int_stack+6815625,int_stack+4296075,2475);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+3992460,int_stack+391725,int_stack+385125,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4012260,int_stack+399645,int_stack+391725,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+4036020,int_stack+4012260,int_stack+3992460,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4075620,int_stack+409005,int_stack+399645,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4103700,int_stack+4075620,int_stack+4012260,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+4151220,int_stack+4103700,int_stack+4036020,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+3992460,int_stack+419925,int_stack+409005,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+4217220,int_stack+3992460,int_stack+4075620,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4273380,int_stack+4217220,int_stack+4103700,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+4025220,int_stack+4273380,int_stack+4151220,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4124220,int_stack+432525,int_stack+419925,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+4352580,int_stack+4124220,int_stack+3992460,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4418100,int_stack+4352580,int_stack+4217220,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+4511700,int_stack+4418100,int_stack+4273380,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+4162020,int_stack+4511700,int_stack+4025220,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+3992460,int_stack+446925,int_stack+432525,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4035660,int_stack+3992460,int_stack+4124220,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+4630500,int_stack+4035660,int_stack+4352580,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4739700,int_stack+4630500,int_stack+4418100,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4300620,int_stack+4739700,int_stack+4511700,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4880100,int_stack+4300620,int_stack+4162020,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+4111260,int_stack+463245,int_stack+446925,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+4160220,int_stack+4111260,int_stack+3992460,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4466940,int_stack+4160220,int_stack+4035660,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5064900,int_stack+4466940,int_stack+4630500,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5228700,int_stack+5064900,int_stack+4739700,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+4592940,int_stack+5228700,int_stack+4300620,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+634725,int_stack+4592940,int_stack+4880100,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3992460,int_stack+481605,int_stack+463245,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4246620,int_stack+3992460,int_stack+4111260,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3992460,int_stack+4246620,int_stack+4160220,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4136460,int_stack+3992460,int_stack+4466940,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4325460,int_stack+4136460,int_stack+5064900,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+3992460,int_stack+4325460,int_stack+5228700,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4254540,int_stack+3992460,int_stack+4592940,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4539660,int_stack+4254540,int_stack+634725,120);
 /*--- compute (rp|ml) ---*/
 hrr1_build_rp(Libint->AB,int_stack+4836660,int_stack+4539660,int_stack+0,2475);
 /*--- compute (qd|ml) ---*/
 hrr1_build_qd(Libint->AB,int_stack+8449125,int_stack+4836660,int_stack+1274910,2475);
 /*--- compute (of|ml) ---*/
 hrr1_build_of(Libint->AB,int_stack+9800475,int_stack+8449125,int_stack+5657325,2475);
 /*--- compute (ng|ml) ---*/
 hrr1_build_ng(Libint->AB,int_stack+11730975,int_stack+9800475,int_stack+6815625,2475);
 /*--- compute (mh|ml) ---*/
 hrr1_build_mh(Libint->AB,int_stack+14181225,int_stack+11730975,int_stack+1950585,2475);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+509605,int_stack+502125,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+22440,int_stack+518581,int_stack+509605,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+49368,int_stack+22440,int_stack+0,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+94248,int_stack+529189,int_stack+518581,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+126072,int_stack+94248,int_stack+22440,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+179928,int_stack+126072,int_stack+49368,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+541565,int_stack+529189,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+254728,int_stack+0,int_stack+94248,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+318376,int_stack+254728,int_stack+126072,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+37128,int_stack+318376,int_stack+179928,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+149328,int_stack+555845,int_stack+541565,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+408136,int_stack+149328,int_stack+0,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+634725,int_stack+408136,int_stack+254728,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+740805,int_stack+634725,int_stack+318376,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+192168,int_stack+740805,int_stack+37128,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+572165,int_stack+555845,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48960,int_stack+0,int_stack+149328,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+875445,int_stack+48960,int_stack+408136,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+349248,int_stack+875445,int_stack+634725,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+999205,int_stack+349248,int_stack+740805,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+634725,int_stack+999205,int_stack+192168,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+134640,int_stack+590661,int_stack+572165,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+190128,int_stack+134640,int_stack+0,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1187701,int_stack+190128,int_stack+48960,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1330501,int_stack+1187701,int_stack+875445,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1516141,int_stack+1330501,int_stack+349248,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+288048,int_stack+1516141,int_stack+999205,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+844165,int_stack+288048,int_stack+634725,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+634725,int_stack+611469,int_stack+590661,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+697149,int_stack+634725,int_stack+134640,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+697149,int_stack+190128,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+539376,int_stack+0,int_stack+1187701,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+539376,int_stack+1330501,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+539376,int_stack+0,int_stack+1516141,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1113445,int_stack+539376,int_stack+288048,136);
 /*--- compute (u0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+0,int_stack+1113445,int_stack+844165,136);
 /*--- compute (tp|ml) ---*/
 hrr1_build_tp(Libint->AB,int_stack+336600,int_stack+0,int_stack+4539660,2475);
 /*--- compute (rd|ml) ---*/
 hrr1_build_rd(Libint->AB,int_stack+1227600,int_stack+336600,int_stack+4836660,2475);
 /*--- compute (qf|ml) ---*/
 hrr1_build_qf(Libint->AB,int_stack+2786850,int_stack+1227600,int_stack+8449125,2475);
 /*--- compute (og|ml) ---*/
 hrr1_build_og(Libint->AB,int_stack+5039100,int_stack+2786850,int_stack+9800475,2475);
 /*--- compute (nh|ml) ---*/
 hrr1_build_nh(Libint->AB,int_stack+0,int_stack+5039100,int_stack+11730975,2475);
 /*--- compute (mi|ml) ---*/
 hrr1_build_mi(Libint->AB,int_stack+3430350,int_stack+0,int_stack+14181225,2475);
 return int_stack+3430350;}
