/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mkmk(Libint_t*, prim_data*);

  /* Computes quartets of (mk|mk) integrals */

REALTYPE *hrr_order_mkmk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[9][14] = int_stack + 21725;
 Libint->vrr_classes[9][15] = int_stack + 28325;
 Libint->vrr_classes[9][16] = int_stack + 35805;
 Libint->vrr_classes[10][9] = int_stack + 44220;
 Libint->vrr_classes[10][10] = int_stack + 47850;
 Libint->vrr_classes[10][11] = int_stack + 52206;
 Libint->vrr_classes[10][12] = int_stack + 57354;
 Libint->vrr_classes[10][13] = int_stack + 63360;
 Libint->vrr_classes[10][14] = int_stack + 70290;
 Libint->vrr_classes[10][15] = int_stack + 78210;
 Libint->vrr_classes[10][16] = int_stack + 87186;
 Libint->vrr_classes[11][9] = int_stack + 97284;
 Libint->vrr_classes[11][10] = int_stack + 101574;
 Libint->vrr_classes[11][11] = int_stack + 106722;
 Libint->vrr_classes[11][12] = int_stack + 112806;
 Libint->vrr_classes[11][13] = int_stack + 119904;
 Libint->vrr_classes[11][14] = int_stack + 128094;
 Libint->vrr_classes[11][15] = int_stack + 137454;
 Libint->vrr_classes[11][16] = int_stack + 148062;
 Libint->vrr_classes[12][9] = int_stack + 159996;
 Libint->vrr_classes[12][10] = int_stack + 165001;
 Libint->vrr_classes[12][11] = int_stack + 171007;
 Libint->vrr_classes[12][12] = int_stack + 178105;
 Libint->vrr_classes[12][13] = int_stack + 186386;
 Libint->vrr_classes[12][14] = int_stack + 195941;
 Libint->vrr_classes[12][15] = int_stack + 206861;
 Libint->vrr_classes[12][16] = int_stack + 219237;
 Libint->vrr_classes[13][9] = int_stack + 233160;
 Libint->vrr_classes[13][10] = int_stack + 238935;
 Libint->vrr_classes[13][11] = int_stack + 245865;
 Libint->vrr_classes[13][12] = int_stack + 254055;
 Libint->vrr_classes[13][13] = int_stack + 263610;
 Libint->vrr_classes[13][14] = int_stack + 274635;
 Libint->vrr_classes[13][15] = int_stack + 287235;
 Libint->vrr_classes[13][16] = int_stack + 301515;
 Libint->vrr_classes[14][9] = int_stack + 317580;
 Libint->vrr_classes[14][10] = int_stack + 324180;
 Libint->vrr_classes[14][11] = int_stack + 332100;
 Libint->vrr_classes[14][12] = int_stack + 341460;
 Libint->vrr_classes[14][13] = int_stack + 352380;
 Libint->vrr_classes[14][14] = int_stack + 364980;
 Libint->vrr_classes[14][15] = int_stack + 379380;
 Libint->vrr_classes[14][16] = int_stack + 395700;
 Libint->vrr_classes[15][9] = int_stack + 414060;
 Libint->vrr_classes[15][10] = int_stack + 421540;
 Libint->vrr_classes[15][11] = int_stack + 430516;
 Libint->vrr_classes[15][12] = int_stack + 441124;
 Libint->vrr_classes[15][13] = int_stack + 453500;
 Libint->vrr_classes[15][14] = int_stack + 467780;
 Libint->vrr_classes[15][15] = int_stack + 484100;
 Libint->vrr_classes[15][16] = int_stack + 502596;
 Libint->vrr_classes[16][9] = int_stack + 523404;
 Libint->vrr_classes[16][10] = int_stack + 531819;
 Libint->vrr_classes[16][11] = int_stack + 541917;
 Libint->vrr_classes[16][12] = int_stack + 553851;
 Libint->vrr_classes[16][13] = int_stack + 567774;
 Libint->vrr_classes[16][14] = int_stack + 583839;
 Libint->vrr_classes[16][15] = int_stack + 602199;
 Libint->vrr_classes[16][16] = int_stack + 623007;
 memset(int_stack,0,646416*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 646416;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mkmk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+646416,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+655491,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+666381,int_stack+655491,int_stack+646416,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+684531,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+697401,int_stack+684531,int_stack+655491,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+719181,int_stack+697401,int_stack+666381,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+646416,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+749431,int_stack+646416,int_stack+684531,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+775171,int_stack+749431,int_stack+697401,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+661431,int_stack+775171,int_stack+719181,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+706806,int_stack+21725,int_stack+15950,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+811471,int_stack+706806,int_stack+646416,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+841501,int_stack+811471,int_stack+749431,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+884401,int_stack+841501,int_stack+775171,55);
 /*--- compute (m0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+724131,int_stack+884401,int_stack+661431,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+646416,int_stack+28325,int_stack+21725,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+666216,int_stack+646416,int_stack+706806,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+938851,int_stack+666216,int_stack+811471,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+988901,int_stack+938851,int_stack+841501,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+787656,int_stack+988901,int_stack+884401,55);
 /*--- compute (m0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1053251,int_stack+787656,int_stack+724131,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+700866,int_stack+35805,int_stack+28325,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+723306,int_stack+700866,int_stack+646416,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+863886,int_stack+723306,int_stack+666216,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+646416,int_stack+863886,int_stack+938851,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+863886,int_stack+646416,int_stack+988901,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+646416,int_stack+863886,int_stack+787656,55);
 /*--- compute (m0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+748056,int_stack+646416,int_stack+1053251,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+646416,int_stack+47850,int_stack+44220,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+657306,int_stack+52206,int_stack+47850,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+670374,int_stack+657306,int_stack+646416,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+692154,int_stack+57354,int_stack+52206,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+707598,int_stack+692154,int_stack+657306,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+856956,int_stack+707598,int_stack+670374,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+646416,int_stack+63360,int_stack+57354,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+893256,int_stack+646416,int_stack+692154,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+924144,int_stack+893256,int_stack+707598,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+664434,int_stack+924144,int_stack+856956,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+856956,int_stack+70290,int_stack+63360,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+967704,int_stack+856956,int_stack+646416,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1003740,int_stack+967704,int_stack+893256,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1055220,int_stack+1003740,int_stack+924144,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+877746,int_stack+1055220,int_stack+664434,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+646416,int_stack+78210,int_stack+70290,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+670176,int_stack+646416,int_stack+856956,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+670176,int_stack+967704,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1120560,int_stack+0,int_stack+1003740,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+953976,int_stack+1120560,int_stack+1055220,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1197780,int_stack+953976,int_stack+877746,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+856956,int_stack+87186,int_stack+78210,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+883884,int_stack+856956,int_stack+646416,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1045452,int_stack+883884,int_stack+670176,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+646416,int_stack+1045452,int_stack+0,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1299420,int_stack+646416,int_stack+1120560,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1045452,int_stack+1299420,int_stack+953976,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+856956,int_stack+1045452,int_stack+1197780,66);
 /*--- compute (mp|mk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+987636,int_stack+856956,int_stack+748056,1980);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+646416,int_stack+101574,int_stack+97284,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+659286,int_stack+106722,int_stack+101574,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+674730,int_stack+659286,int_stack+646416,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+700470,int_stack+112806,int_stack+106722,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+718722,int_stack+700470,int_stack+659286,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+749610,int_stack+718722,int_stack+674730,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+646416,int_stack+119904,int_stack+112806,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+792510,int_stack+646416,int_stack+700470,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+792510,int_stack+718722,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+667710,int_stack+0,int_stack+749610,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+732060,int_stack+128094,int_stack+119904,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+51480,int_stack+732060,int_stack+646416,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1314336,int_stack+51480,int_stack+792510,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+756630,int_stack+1314336,int_stack+0,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1375176,int_stack+756630,int_stack+667710,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+137454,int_stack+128094,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+646416,int_stack+0,int_stack+732060,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1465266,int_stack+646416,int_stack+51480,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+28080,int_stack+1465266,int_stack+1314336,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1536246,int_stack+28080,int_stack+756630,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+695556,int_stack+1536246,int_stack+1375176,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1314336,int_stack+148062,int_stack+137454,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1346160,int_stack+1314336,int_stack+0,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1644354,int_stack+1346160,int_stack+646416,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1314336,int_stack+1644354,int_stack+1465266,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1644354,int_stack+1314336,int_stack+28080,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1314336,int_stack+1644354,int_stack+1536246,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1458480,int_stack+1314336,int_stack+695556,78);
 /*--- compute (np|mk) ---*/
 hrr1_build_np(Libint->AB,int_stack+1612920,int_stack+1458480,int_stack+856956,1980);
 /*--- compute (md|mk) ---*/
 hrr1_build_md(Libint->AB,int_stack+2004960,int_stack+1612920,int_stack+987636,1980);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+646416,int_stack+165001,int_stack+159996,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+661431,int_stack+171007,int_stack+165001,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+679449,int_stack+661431,int_stack+646416,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+709479,int_stack+178105,int_stack+171007,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+730773,int_stack+709479,int_stack+661431,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+766809,int_stack+730773,int_stack+679449,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+646416,int_stack+186386,int_stack+178105,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+816859,int_stack+646416,int_stack+709479,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+859447,int_stack+816859,int_stack+730773,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+671259,int_stack+859447,int_stack+766809,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+746334,int_stack+195941,int_stack+186386,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+919507,int_stack+746334,int_stack+646416,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+969193,int_stack+919507,int_stack+816859,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1040173,int_stack+969193,int_stack+859447,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+774999,int_stack+1040173,int_stack+671259,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+646416,int_stack+206861,int_stack+195941,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+679176,int_stack+646416,int_stack+746334,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1130263,int_stack+679176,int_stack+919507,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1213073,int_stack+1130263,int_stack+969193,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+880104,int_stack+1213073,int_stack+1040173,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+0,int_stack+880104,int_stack+774999,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+736506,int_stack+219237,int_stack+206861,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+773634,int_stack+736506,int_stack+646416,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1006230,int_stack+773634,int_stack+679176,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+646416,int_stack+1006230,int_stack+1130263,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1006230,int_stack+646416,int_stack+1213073,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+646416,int_stack+1006230,int_stack+880104,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+814584,int_stack+646416,int_stack+0,91);
 /*--- compute (op|mk) ---*/
 hrr1_build_op(Libint->AB,int_stack+994764,int_stack+814584,int_stack+1458480,1980);
 /*--- compute (nd|mk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2658360,int_stack+994764,int_stack+1612920,1980);
 /*--- compute (mf|mk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3442440,int_stack+2658360,int_stack+2004960,1980);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+238935,int_stack+233160,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+245865,int_stack+238935,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+254055,int_stack+245865,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+263610,int_stack+254055,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+646416,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+646416,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+274635,int_stack+263610,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+715716,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1458084,int_stack+715716,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+148365,int_stack+1458084,int_stack+646416,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1539984,int_stack+148365,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+646416,int_stack+287235,int_stack+274635,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+646416,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1661259,int_stack+0,int_stack+715716,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+684216,int_stack+1661259,int_stack+1458084,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1756809,int_stack+684216,int_stack+148365,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+66150,int_stack+1756809,int_stack+1539984,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1458084,int_stack+301515,int_stack+287235,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1500924,int_stack+1458084,int_stack+646416,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1902339,int_stack+1500924,int_stack+0,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1458084,int_stack+1902339,int_stack+1661259,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1902339,int_stack+1458084,int_stack+684216,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1458084,int_stack+1902339,int_stack+1756809,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1652124,int_stack+1458084,int_stack+66150,105);
 /*--- compute (qp|mk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1860024,int_stack+1652124,int_stack+814584,1980);
 /*--- compute (od|mk) ---*/
 hrr1_build_od(Libint->AB,int_stack+4531440,int_stack+1860024,int_stack+994764,1980);
 /*--- compute (nf|mk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5458080,int_stack+4531440,int_stack+2658360,1980);
 /*--- compute (mg|mk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6764880,int_stack+5458080,int_stack+3442440,1980);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2400564,int_stack+324180,int_stack+317580,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2420364,int_stack+332100,int_stack+324180,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2444124,int_stack+2420364,int_stack+2400564,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2483724,int_stack+341460,int_stack+332100,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2511804,int_stack+2483724,int_stack+2420364,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2559324,int_stack+2511804,int_stack+2444124,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2400564,int_stack+352380,int_stack+341460,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2625324,int_stack+2400564,int_stack+2483724,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2681484,int_stack+2625324,int_stack+2511804,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2433324,int_stack+2681484,int_stack+2559324,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2532324,int_stack+364980,int_stack+352380,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2760684,int_stack+2532324,int_stack+2400564,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2826204,int_stack+2760684,int_stack+2625324,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2919804,int_stack+2826204,int_stack+2681484,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+2570124,int_stack+2919804,int_stack+2433324,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2400564,int_stack+379380,int_stack+364980,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2443764,int_stack+2400564,int_stack+2532324,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3038604,int_stack+2443764,int_stack+2760684,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3147804,int_stack+3038604,int_stack+2826204,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2708724,int_stack+3147804,int_stack+2919804,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+3288204,int_stack+2708724,int_stack+2570124,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2519364,int_stack+395700,int_stack+379380,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2568324,int_stack+2519364,int_stack+2400564,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2875044,int_stack+2568324,int_stack+2443764,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2400564,int_stack+2875044,int_stack+3038604,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2875044,int_stack+2400564,int_stack+3147804,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2400564,int_stack+2875044,int_stack+2708724,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2622324,int_stack+2400564,int_stack+3288204,120);
 /*--- compute (rp|mk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2859924,int_stack+2622324,int_stack+1652124,1980);
 /*--- compute (qd|mk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+646416,int_stack+2859924,int_stack+1860024,1980);
 /*--- compute (of|mk) ---*/
 hrr1_build_of(Libint->AB,int_stack+8398380,int_stack+646416,int_stack+4531440,1980);
 /*--- compute (ng|mk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+3483624,int_stack+8398380,int_stack+5458080,1980);
 /*--- compute (mh|mk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+9942780,int_stack+3483624,int_stack+6764880,1980);
 /*--- compute (u0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5443824,int_stack+421540,int_stack+414060,136);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+5466264,int_stack+430516,int_stack+421540,136);
 /*--- compute (u0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+5493192,int_stack+5466264,int_stack+5443824,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+5538072,int_stack+441124,int_stack+430516,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+5569896,int_stack+5538072,int_stack+5466264,136);
 /*--- compute (u0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5623752,int_stack+5569896,int_stack+5493192,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5443824,int_stack+453500,int_stack+441124,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+5698552,int_stack+5443824,int_stack+5538072,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+5762200,int_stack+5698552,int_stack+5569896,136);
 /*--- compute (u0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+5480952,int_stack+5762200,int_stack+5623752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5593152,int_stack+467780,int_stack+453500,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+5851960,int_stack+5593152,int_stack+5443824,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+5926216,int_stack+5851960,int_stack+5698552,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+6032296,int_stack+5926216,int_stack+5762200,136);
 /*--- compute (u0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+5635992,int_stack+6032296,int_stack+5480952,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5443824,int_stack+484100,int_stack+467780,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+5492784,int_stack+5443824,int_stack+5593152,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+6166936,int_stack+5492784,int_stack+5851960,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+6290696,int_stack+6166936,int_stack+5926216,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+5793072,int_stack+6290696,int_stack+6032296,136);
 /*--- compute (u0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+6449816,int_stack+5793072,int_stack+5635992,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+5578464,int_stack+502596,int_stack+484100,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+5633952,int_stack+5578464,int_stack+5443824,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+5981568,int_stack+5633952,int_stack+5492784,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+5443824,int_stack+5981568,int_stack+6166936,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+5981568,int_stack+5443824,int_stack+6290696,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5443824,int_stack+5981568,int_stack+5793072,136);
 /*--- compute (u0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+5695152,int_stack+5443824,int_stack+6449816,136);
 /*--- compute (tp|mk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5964432,int_stack+5695152,int_stack+2622324,1980);
 /*--- compute (rd|mk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6677232,int_stack+5964432,int_stack+2859924,1980);
 /*--- compute (qf|mk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+12229680,int_stack+6677232,int_stack+646416,1980);
 /*--- compute (og|mk) ---*/
 hrr1_build_og(Libint->AB,int_stack+646416,int_stack+12229680,int_stack+8398380,1980);
 /*--- compute (nh|mk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+14031480,int_stack+646416,int_stack+3483624,1980);
 /*--- compute (mi|mk) ---*/
 hrr1_build_mi(Libint->AB,int_stack+16775760,int_stack+14031480,int_stack+9942780,1980);
 /*--- compute (v0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2963016,int_stack+531819,int_stack+523404,153);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2988261,int_stack+541917,int_stack+531819,153);
 /*--- compute (v0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3018555,int_stack+2988261,int_stack+2963016,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3069045,int_stack+553851,int_stack+541917,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3104847,int_stack+3069045,int_stack+2988261,153);
 /*--- compute (v0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+3165435,int_stack+3104847,int_stack+3018555,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2963016,int_stack+567774,int_stack+553851,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+3249585,int_stack+2963016,int_stack+3069045,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+3321189,int_stack+3249585,int_stack+3104847,153);
 /*--- compute (v0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+3004785,int_stack+3321189,int_stack+3165435,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+3131010,int_stack+583839,int_stack+567774,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3422169,int_stack+3131010,int_stack+2963016,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+3505707,int_stack+3422169,int_stack+3249585,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3625047,int_stack+3505707,int_stack+3321189,153);
 /*--- compute (v0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+3179205,int_stack+3625047,int_stack+3004785,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2963016,int_stack+602199,int_stack+583839,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3018096,int_stack+2963016,int_stack+3131010,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3776517,int_stack+3018096,int_stack+3422169,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3915747,int_stack+3776517,int_stack+3505707,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3355920,int_stack+3915747,int_stack+3625047,153);
 /*--- compute (v0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+4094757,int_stack+3355920,int_stack+3179205,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3114486,int_stack+623007,int_stack+602199,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3176910,int_stack+3114486,int_stack+2963016,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3567978,int_stack+3176910,int_stack+3018096,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2963016,int_stack+3567978,int_stack+3776517,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3567978,int_stack+2963016,int_stack+3915747,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2963016,int_stack+3567978,int_stack+3355920,153);
 /*--- compute (v0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+3245760,int_stack+2963016,int_stack+4094757,153);
 /*--- compute (up|mk) ---*/
 hrr1_build_up(Libint->AB,int_stack+3548700,int_stack+3245760,int_stack+5695152,1980);
 /*--- compute (td|mk) ---*/
 hrr1_build_td(Libint->AB,int_stack+4356540,int_stack+3548700,int_stack+5964432,1980);
 /*--- compute (rf|mk) ---*/
 hrr1_build_rf(Libint->AB,int_stack+7924632,int_stack+4356540,int_stack+6677232,1980);
 /*--- compute (qg|mk) ---*/
 hrr1_build_qg(Libint->AB,int_stack+2963016,int_stack+7924632,int_stack+12229680,1980);
 /*--- compute (oh|mk) ---*/
 hrr1_build_oh(Libint->AB,int_stack+5665716,int_stack+2963016,int_stack+646416,1980);
 /*--- compute (ni|mk) ---*/
 hrr1_build_ni(Libint->AB,int_stack+8908956,int_stack+5665716,int_stack+14031480,1980);
 /*--- compute (mk|mk) ---*/
 hrr1_build_mk(Libint->AB,int_stack+12567996,int_stack+8908956,int_stack+16775760,1980);
 return int_stack+12567996;}
