/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mknk(Libint_t*, prim_data*);

  /* Computes quartets of (mk|nk) integrals */

REALTYPE *hrr_order_mknk(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[10][10] = int_stack + 50600;
 Libint->vrr_classes[10][11] = int_stack + 54956;
 Libint->vrr_classes[10][12] = int_stack + 60104;
 Libint->vrr_classes[10][13] = int_stack + 66110;
 Libint->vrr_classes[10][14] = int_stack + 73040;
 Libint->vrr_classes[10][15] = int_stack + 80960;
 Libint->vrr_classes[10][16] = int_stack + 89936;
 Libint->vrr_classes[10][17] = int_stack + 100034;
 Libint->vrr_classes[11][10] = int_stack + 111320;
 Libint->vrr_classes[11][11] = int_stack + 116468;
 Libint->vrr_classes[11][12] = int_stack + 122552;
 Libint->vrr_classes[11][13] = int_stack + 129650;
 Libint->vrr_classes[11][14] = int_stack + 137840;
 Libint->vrr_classes[11][15] = int_stack + 147200;
 Libint->vrr_classes[11][16] = int_stack + 157808;
 Libint->vrr_classes[11][17] = int_stack + 169742;
 Libint->vrr_classes[12][10] = int_stack + 183080;
 Libint->vrr_classes[12][11] = int_stack + 189086;
 Libint->vrr_classes[12][12] = int_stack + 196184;
 Libint->vrr_classes[12][13] = int_stack + 204465;
 Libint->vrr_classes[12][14] = int_stack + 214020;
 Libint->vrr_classes[12][15] = int_stack + 224940;
 Libint->vrr_classes[12][16] = int_stack + 237316;
 Libint->vrr_classes[12][17] = int_stack + 251239;
 Libint->vrr_classes[13][10] = int_stack + 266800;
 Libint->vrr_classes[13][11] = int_stack + 273730;
 Libint->vrr_classes[13][12] = int_stack + 281920;
 Libint->vrr_classes[13][13] = int_stack + 291475;
 Libint->vrr_classes[13][14] = int_stack + 302500;
 Libint->vrr_classes[13][15] = int_stack + 315100;
 Libint->vrr_classes[13][16] = int_stack + 329380;
 Libint->vrr_classes[13][17] = int_stack + 345445;
 Libint->vrr_classes[14][10] = int_stack + 363400;
 Libint->vrr_classes[14][11] = int_stack + 371320;
 Libint->vrr_classes[14][12] = int_stack + 380680;
 Libint->vrr_classes[14][13] = int_stack + 391600;
 Libint->vrr_classes[14][14] = int_stack + 404200;
 Libint->vrr_classes[14][15] = int_stack + 418600;
 Libint->vrr_classes[14][16] = int_stack + 434920;
 Libint->vrr_classes[14][17] = int_stack + 453280;
 Libint->vrr_classes[15][10] = int_stack + 473800;
 Libint->vrr_classes[15][11] = int_stack + 482776;
 Libint->vrr_classes[15][12] = int_stack + 493384;
 Libint->vrr_classes[15][13] = int_stack + 505760;
 Libint->vrr_classes[15][14] = int_stack + 520040;
 Libint->vrr_classes[15][15] = int_stack + 536360;
 Libint->vrr_classes[15][16] = int_stack + 554856;
 Libint->vrr_classes[15][17] = int_stack + 575664;
 Libint->vrr_classes[16][10] = int_stack + 598920;
 Libint->vrr_classes[16][11] = int_stack + 609018;
 Libint->vrr_classes[16][12] = int_stack + 620952;
 Libint->vrr_classes[16][13] = int_stack + 634875;
 Libint->vrr_classes[16][14] = int_stack + 650940;
 Libint->vrr_classes[16][15] = int_stack + 669300;
 Libint->vrr_classes[16][16] = int_stack + 690108;
 Libint->vrr_classes[16][17] = int_stack + 713517;
 memset(int_stack,0,739680*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 739680;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mknk(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+739680,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+750570,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+763440,int_stack+750570,int_stack+739680,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+785220,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+800235,int_stack+785220,int_stack+750570,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+825975,int_stack+800235,int_stack+763440,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+739680,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+862275,int_stack+739680,int_stack+785220,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+757005,int_stack+862275,int_stack+800235,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+892305,int_stack+757005,int_stack+825975,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+799905,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+819705,int_stack+799905,int_stack+739680,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+946755,int_stack+819705,int_stack+862275,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+996805,int_stack+946755,int_stack+757005,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1061155,int_stack+996805,int_stack+892305,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+739680,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+854355,int_stack+739680,int_stack+799905,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1137385,int_stack+854355,int_stack+819705,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+762120,int_stack+1137385,int_stack+946755,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+893955,int_stack+762120,int_stack+996805,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1195135,int_stack+893955,int_stack+1061155,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+984045,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1009290,int_stack+984045,int_stack+739680,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1054170,int_stack+1009290,int_stack+854355,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1296775,int_stack+1054170,int_stack+1137385,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+984045,int_stack+1296775,int_stack+762120,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+739680,int_stack+984045,int_stack+893955,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+859800,int_stack+739680,int_stack+1195135,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+739680,int_stack+54956,int_stack+50600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+752748,int_stack+60104,int_stack+54956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+768192,int_stack+752748,int_stack+739680,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+794328,int_stack+66110,int_stack+60104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+812346,int_stack+794328,int_stack+752748,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+990480,int_stack+812346,int_stack+768192,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+739680,int_stack+73040,int_stack+66110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1034040,int_stack+739680,int_stack+794328,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+760470,int_stack+1034040,int_stack+812346,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1070076,int_stack+760470,int_stack+990480,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+990480,int_stack+80960,int_stack+73040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+811950,int_stack+990480,int_stack+739680,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1135416,int_stack+811950,int_stack+1034040,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1195476,int_stack+1135416,int_stack+760470,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1272696,int_stack+1195476,int_stack+1070076,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+739680,int_stack+89936,int_stack+80960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1014240,int_stack+739680,int_stack+990480,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1061760,int_stack+1014240,int_stack+811950,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+766608,int_stack+1061760,int_stack+1135416,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1364172,int_stack+766608,int_stack+1195476,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1131060,int_stack+1364172,int_stack+1272696,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1253028,int_stack+100034,int_stack+89936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1283322,int_stack+1253028,int_stack+739680,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+0,int_stack+1283322,int_stack+1014240,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1253028,int_stack+0,int_stack+1061760,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+990480,int_stack+1253028,int_stack+766608,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1472280,int_stack+990480,int_stack+1364172,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1253028,int_stack+1472280,int_stack+1131060,66);
 /*--- compute (mp|nk) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1409844,int_stack+1253028,int_stack+859800,2376);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+116468,int_stack+111320,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+122552,int_stack+116468,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+129650,int_stack+122552,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+739680,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+137840,int_stack+129650,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+791160,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+791160,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+833748,int_stack+24570,int_stack+739680,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+739680,int_stack+147200,int_stack+137840,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+85410,int_stack+739680,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+910968,int_stack+85410,int_stack+791160,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+981948,int_stack+910968,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1073208,int_stack+981948,int_stack+833748,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+157808,int_stack+147200,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+767760,int_stack+0,int_stack+739680,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+823920,int_stack+767760,int_stack+85410,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+31824,int_stack+823920,int_stack+910968,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1801884,int_stack+31824,int_stack+981948,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+905820,int_stack+1801884,int_stack+1073208,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1049964,int_stack+169742,int_stack+157808,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1085766,int_stack+1049964,int_stack+0,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1149414,int_stack+1085766,int_stack+767760,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1929648,int_stack+1149414,int_stack+823920,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1049964,int_stack+1929648,int_stack+31824,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1049964,int_stack+1801884,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1801884,int_stack+0,int_stack+905820,78);
 /*--- compute (np|nk) ---*/
 hrr1_build_np(Libint->AB,int_stack+739680,int_stack+1801884,int_stack+1253028,2376);
 /*--- compute (md|nk) ---*/
 hrr1_build_md(Libint->AB,int_stack+1987212,int_stack+739680,int_stack+1409844,2376);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+189086,int_stack+183080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+18018,int_stack+196184,int_stack+189086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+39312,int_stack+18018,int_stack+0,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+75348,int_stack+204465,int_stack+196184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+100191,int_stack+75348,int_stack+18018,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+142779,int_stack+100191,int_stack+39312,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+214020,int_stack+204465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1210128,int_stack+0,int_stack+75348,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+28665,int_stack+1210128,int_stack+100191,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1259814,int_stack+28665,int_stack+142779,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+99645,int_stack+224940,int_stack+214020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+132405,int_stack+99645,int_stack+0,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1349904,int_stack+132405,int_stack+1210128,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1432714,int_stack+1349904,int_stack+28665,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1539184,int_stack+1432714,int_stack+1259814,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1210128,int_stack+237316,int_stack+224940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1247256,int_stack+1210128,int_stack+99645,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1247256,int_stack+132405,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+95550,int_stack+0,int_stack+1349904,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2771292,int_stack+95550,int_stack+1432714,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1312776,int_stack+2771292,int_stack+1539184,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1480944,int_stack+251239,int_stack+237316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1522713,int_stack+1480944,int_stack+1210128,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1596969,int_stack+1522713,int_stack+1247256,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2920350,int_stack+1596969,int_stack+0,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1480944,int_stack+2920350,int_stack+95550,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+1480944,int_stack+2771292,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2771292,int_stack+0,int_stack+1312776,91);
 /*--- compute (op|nk) ---*/
 hrr1_build_op(Libint->AB,int_stack+1210128,int_stack+2771292,int_stack+1801884,2376);
 /*--- compute (nd|nk) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2987508,int_stack+1210128,int_stack+739680,2376);
 /*--- compute (mf|nk) ---*/
 hrr1_build_mf(Libint->AB,int_stack+3928404,int_stack+2987508,int_stack+1987212,2376);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+739680,int_stack+273730,int_stack+266800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+760470,int_stack+281920,int_stack+273730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+785040,int_stack+760470,int_stack+739680,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+826620,int_stack+291475,int_stack+281920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+855285,int_stack+826620,int_stack+760470,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+904425,int_stack+855285,int_stack+785040,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+739680,int_stack+302500,int_stack+291475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+973725,int_stack+739680,int_stack+826620,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+772755,int_stack+973725,int_stack+855285,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1031055,int_stack+772755,int_stack+904425,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+854655,int_stack+315100,int_stack+302500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+892455,int_stack+854655,int_stack+739680,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+892455,int_stack+973725,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+95550,int_stack+0,int_stack+772755,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1766112,int_stack+95550,int_stack+1031055,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+739680,int_stack+329380,int_stack+315100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+958605,int_stack+739680,int_stack+854655,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1034205,int_stack+958605,int_stack+892455,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+782520,int_stack+1034205,int_stack+0,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1911642,int_stack+782520,int_stack+95550,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1911642,int_stack+1766112,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1766112,int_stack+345445,int_stack+329380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1814307,int_stack+1766112,int_stack+739680,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+194040,int_stack+1814307,int_stack+958605,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2083632,int_stack+194040,int_stack+1034205,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+925845,int_stack+2083632,int_stack+782520,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2083632,int_stack+925845,int_stack+1911642,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2312952,int_stack+2083632,int_stack+0,105);
 /*--- compute (qp|nk) ---*/
 hrr1_build_qp(Libint->AB,int_stack+5235204,int_stack+2312952,int_stack+2771292,2376);
 /*--- compute (od|nk) ---*/
 hrr1_build_od(Libint->AB,int_stack+5883852,int_stack+5235204,int_stack+1210128,2376);
 /*--- compute (nf|nk) ---*/
 hrr1_build_nf(Libint->AB,int_stack+739680,int_stack+5883852,int_stack+2987508,2376);
 /*--- compute (mg|nk) ---*/
 hrr1_build_mg(Libint->AB,int_stack+6995820,int_stack+739680,int_stack+3928404,2376);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+371320,int_stack+363400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+23760,int_stack+380680,int_stack+371320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+51840,int_stack+23760,int_stack+0,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+99360,int_stack+391600,int_stack+380680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+132120,int_stack+99360,int_stack+23760,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+188280,int_stack+132120,int_stack+51840,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+404200,int_stack+391600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+267480,int_stack+0,int_stack+99360,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+37800,int_stack+267480,int_stack+132120,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2562432,int_stack+37800,int_stack+188280,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+131400,int_stack+418600,int_stack+404200,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+174600,int_stack+131400,int_stack+0,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2681232,int_stack+174600,int_stack+267480,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+250200,int_stack+2681232,int_stack+37800,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2790432,int_stack+250200,int_stack+2562432,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2562432,int_stack+434920,int_stack+418600,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+0,int_stack+2562432,int_stack+131400,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2956752,int_stack+0,int_stack+174600,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+86400,int_stack+2956752,int_stack+2681232,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3082752,int_stack+86400,int_stack+250200,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3279312,int_stack+3082752,int_stack+2790432,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+250200,int_stack+453280,int_stack+434920,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+305280,int_stack+250200,int_stack+2562432,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2562432,int_stack+305280,int_stack+0,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2706432,int_stack+2562432,int_stack+2956752,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3501072,int_stack+2706432,int_stack+86400,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2562432,int_stack+3501072,int_stack+3082752,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3501072,int_stack+2562432,int_stack+3279312,120);
 /*--- compute (rp|nk) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2562432,int_stack+3501072,int_stack+2312952,2376);
 /*--- compute (qd|nk) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3786192,int_stack+2562432,int_stack+5235204,2376);
 /*--- compute (of|nk) ---*/
 hrr1_build_of(Libint->AB,int_stack+8956020,int_stack+3786192,int_stack+5883852,2376);
 /*--- compute (ng|nk) ---*/
 hrr1_build_ng(Libint->AB,int_stack+10809300,int_stack+8956020,int_stack+739680,2376);
 /*--- compute (mh|nk) ---*/
 hrr1_build_mh(Libint->AB,int_stack+13161540,int_stack+10809300,int_stack+6995820,2376);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+739680,int_stack+482776,int_stack+473800,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+766608,int_stack+493384,int_stack+482776,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+798432,int_stack+766608,int_stack+739680,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+852288,int_stack+505760,int_stack+493384,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+889416,int_stack+852288,int_stack+766608,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+953064,int_stack+889416,int_stack+798432,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+739680,int_stack+520040,int_stack+505760,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1042824,int_stack+739680,int_stack+852288,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+782520,int_stack+1042824,int_stack+889416,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1117080,int_stack+782520,int_stack+953064,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+888600,int_stack+536360,int_stack+520040,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+937560,int_stack+888600,int_stack+739680,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1251720,int_stack+937560,int_stack+1042824,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1375480,int_stack+1251720,int_stack+782520,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1534600,int_stack+1375480,int_stack+1117080,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+739680,int_stack+554856,int_stack+536360,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1023240,int_stack+739680,int_stack+888600,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1723096,int_stack+1023240,int_stack+937560,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+795168,int_stack+1723096,int_stack+1251720,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1121160,int_stack+795168,int_stack+1375480,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1865896,int_stack+1121160,int_stack+1534600,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1343928,int_stack+575664,int_stack+554856,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1406352,int_stack+1343928,int_stack+739680,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1517328,int_stack+1406352,int_stack+1023240,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2117224,int_stack+1517328,int_stack+1723096,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1343928,int_stack+2117224,int_stack+795168,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2117224,int_stack+1343928,int_stack+1121160,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+739680,int_stack+2117224,int_stack+1865896,136);
 /*--- compute (tp|nk) ---*/
 hrr1_build_tp(Libint->AB,int_stack+1062816,int_stack+739680,int_stack+3501072,2376);
 /*--- compute (rd|nk) ---*/
 hrr1_build_rd(Libint->AB,int_stack+5083488,int_stack+1062816,int_stack+2562432,2376);
 /*--- compute (qf|nk) ---*/
 hrr1_build_qf(Libint->AB,int_stack+6580368,int_stack+5083488,int_stack+3786192,2376);
 /*--- compute (og|nk) ---*/
 hrr1_build_og(Libint->AB,int_stack+1918176,int_stack+6580368,int_stack+8956020,2376);
 /*--- compute (nh|nk) ---*/
 hrr1_build_nh(Libint->AB,int_stack+15905820,int_stack+1918176,int_stack+10809300,2376);
 /*--- compute (mi|nk) ---*/
 hrr1_build_mi(Libint->AB,int_stack+8742528,int_stack+15905820,int_stack+13161540,2376);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+4698096,int_stack+609018,int_stack+598920,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4728390,int_stack+620952,int_stack+609018,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4764192,int_stack+4728390,int_stack+4698096,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+4824780,int_stack+634875,int_stack+620952,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+4866549,int_stack+4824780,int_stack+4728390,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+4938153,int_stack+4866549,int_stack+4764192,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+4698096,int_stack+650940,int_stack+634875,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+12401568,int_stack+4698096,int_stack+4824780,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+4746291,int_stack+12401568,int_stack+4866549,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+12485106,int_stack+4746291,int_stack+4938153,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+4865631,int_stack+669300,int_stack+650940,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+4920711,int_stack+4865631,int_stack+4698096,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+12636576,int_stack+4920711,int_stack+12401568,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+12775806,int_stack+12636576,int_stack+4746291,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+12954816,int_stack+12775806,int_stack+12485106,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+12401568,int_stack+690108,int_stack+669300,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+12463992,int_stack+12401568,int_stack+4865631,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4698096,int_stack+12463992,int_stack+4920711,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+4858746,int_stack+4698096,int_stack+12636576,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+13166874,int_stack+4858746,int_stack+12775806,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+12574152,int_stack+13166874,int_stack+12954816,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+12856896,int_stack+713517,int_stack+690108,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+12927123,int_stack+12856896,int_stack+12401568,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+13417488,int_stack+12927123,int_stack+12463992,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+12856896,int_stack+13417488,int_stack+4698096,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+13417488,int_stack+12856896,int_stack+4858746,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+4698096,int_stack+13417488,int_stack+13166874,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+12856896,int_stack+4698096,int_stack+12574152,153);
 /*--- compute (up|nk) ---*/
 hrr1_build_up(Libint->AB,int_stack+13220424,int_stack+12856896,int_stack+739680,2376);
 /*--- compute (td|nk) ---*/
 hrr1_build_td(Libint->AB,int_stack+14189832,int_stack+13220424,int_stack+1062816,2376);
 /*--- compute (rf|nk) ---*/
 hrr1_build_rf(Libint->AB,int_stack+19198956,int_stack+14189832,int_stack+5083488,2376);
 /*--- compute (qg|nk) ---*/
 hrr1_build_qg(Libint->AB,int_stack+12401568,int_stack+19198956,int_stack+6580368,2376);
 /*--- compute (oh|nk) ---*/
 hrr1_build_oh(Libint->AB,int_stack+4698096,int_stack+12401568,int_stack+1918176,2376);
 /*--- compute (ni|nk) ---*/
 hrr1_build_ni(Libint->AB,int_stack+0,int_stack+4698096,int_stack+15905820,2376);
 /*--- compute (mk|nk) ---*/
 hrr1_build_mk(Libint->AB,int_stack+12401568,int_stack+0,int_stack+8742528,2376);
 return int_stack+12401568;}
