/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mknm(Libint_t*, prim_data*);

  /* Computes quartets of (mk|nm) integrals */

REALTYPE *hrr_order_mknm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][10] = int_stack + 0;
 Libint->vrr_classes[9][11] = int_stack + 3630;
 Libint->vrr_classes[9][12] = int_stack + 7920;
 Libint->vrr_classes[9][13] = int_stack + 12925;
 Libint->vrr_classes[9][14] = int_stack + 18700;
 Libint->vrr_classes[9][15] = int_stack + 25300;
 Libint->vrr_classes[9][16] = int_stack + 32780;
 Libint->vrr_classes[9][17] = int_stack + 41195;
 Libint->vrr_classes[9][18] = int_stack + 50600;
 Libint->vrr_classes[9][19] = int_stack + 61050;
 Libint->vrr_classes[10][10] = int_stack + 72600;
 Libint->vrr_classes[10][11] = int_stack + 76956;
 Libint->vrr_classes[10][12] = int_stack + 82104;
 Libint->vrr_classes[10][13] = int_stack + 88110;
 Libint->vrr_classes[10][14] = int_stack + 95040;
 Libint->vrr_classes[10][15] = int_stack + 102960;
 Libint->vrr_classes[10][16] = int_stack + 111936;
 Libint->vrr_classes[10][17] = int_stack + 122034;
 Libint->vrr_classes[10][18] = int_stack + 133320;
 Libint->vrr_classes[10][19] = int_stack + 145860;
 Libint->vrr_classes[11][10] = int_stack + 159720;
 Libint->vrr_classes[11][11] = int_stack + 164868;
 Libint->vrr_classes[11][12] = int_stack + 170952;
 Libint->vrr_classes[11][13] = int_stack + 178050;
 Libint->vrr_classes[11][14] = int_stack + 186240;
 Libint->vrr_classes[11][15] = int_stack + 195600;
 Libint->vrr_classes[11][16] = int_stack + 206208;
 Libint->vrr_classes[11][17] = int_stack + 218142;
 Libint->vrr_classes[11][18] = int_stack + 231480;
 Libint->vrr_classes[11][19] = int_stack + 246300;
 Libint->vrr_classes[12][10] = int_stack + 262680;
 Libint->vrr_classes[12][11] = int_stack + 268686;
 Libint->vrr_classes[12][12] = int_stack + 275784;
 Libint->vrr_classes[12][13] = int_stack + 284065;
 Libint->vrr_classes[12][14] = int_stack + 293620;
 Libint->vrr_classes[12][15] = int_stack + 304540;
 Libint->vrr_classes[12][16] = int_stack + 316916;
 Libint->vrr_classes[12][17] = int_stack + 330839;
 Libint->vrr_classes[12][18] = int_stack + 346400;
 Libint->vrr_classes[12][19] = int_stack + 363690;
 Libint->vrr_classes[13][10] = int_stack + 382800;
 Libint->vrr_classes[13][11] = int_stack + 389730;
 Libint->vrr_classes[13][12] = int_stack + 397920;
 Libint->vrr_classes[13][13] = int_stack + 407475;
 Libint->vrr_classes[13][14] = int_stack + 418500;
 Libint->vrr_classes[13][15] = int_stack + 431100;
 Libint->vrr_classes[13][16] = int_stack + 445380;
 Libint->vrr_classes[13][17] = int_stack + 461445;
 Libint->vrr_classes[13][18] = int_stack + 479400;
 Libint->vrr_classes[13][19] = int_stack + 499350;
 Libint->vrr_classes[14][10] = int_stack + 521400;
 Libint->vrr_classes[14][11] = int_stack + 529320;
 Libint->vrr_classes[14][12] = int_stack + 538680;
 Libint->vrr_classes[14][13] = int_stack + 549600;
 Libint->vrr_classes[14][14] = int_stack + 562200;
 Libint->vrr_classes[14][15] = int_stack + 576600;
 Libint->vrr_classes[14][16] = int_stack + 592920;
 Libint->vrr_classes[14][17] = int_stack + 611280;
 Libint->vrr_classes[14][18] = int_stack + 631800;
 Libint->vrr_classes[14][19] = int_stack + 654600;
 Libint->vrr_classes[15][10] = int_stack + 679800;
 Libint->vrr_classes[15][11] = int_stack + 688776;
 Libint->vrr_classes[15][12] = int_stack + 699384;
 Libint->vrr_classes[15][13] = int_stack + 711760;
 Libint->vrr_classes[15][14] = int_stack + 726040;
 Libint->vrr_classes[15][15] = int_stack + 742360;
 Libint->vrr_classes[15][16] = int_stack + 760856;
 Libint->vrr_classes[15][17] = int_stack + 781664;
 Libint->vrr_classes[15][18] = int_stack + 804920;
 Libint->vrr_classes[15][19] = int_stack + 830760;
 Libint->vrr_classes[16][10] = int_stack + 859320;
 Libint->vrr_classes[16][11] = int_stack + 869418;
 Libint->vrr_classes[16][12] = int_stack + 881352;
 Libint->vrr_classes[16][13] = int_stack + 895275;
 Libint->vrr_classes[16][14] = int_stack + 911340;
 Libint->vrr_classes[16][15] = int_stack + 929700;
 Libint->vrr_classes[16][16] = int_stack + 950508;
 Libint->vrr_classes[16][17] = int_stack + 973917;
 Libint->vrr_classes[16][18] = int_stack + 1000080;
 Libint->vrr_classes[16][19] = int_stack + 1029150;
 memset(int_stack,0,1061280*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1061280;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mknm(Libint, Data);
   Data++;
 }
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1061280,int_stack+3630,int_stack+0,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1072170,int_stack+7920,int_stack+3630,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1085040,int_stack+1072170,int_stack+1061280,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1106820,int_stack+12925,int_stack+7920,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1121835,int_stack+1106820,int_stack+1072170,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1147575,int_stack+1121835,int_stack+1085040,55);
 /*--- compute (m0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1061280,int_stack+18700,int_stack+12925,55);
 /*--- compute (m0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1183875,int_stack+1061280,int_stack+1106820,55);
 /*--- compute (m0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1078605,int_stack+1183875,int_stack+1121835,55);
 /*--- compute (m0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1213905,int_stack+1078605,int_stack+1147575,55);
 /*--- compute (m0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1121505,int_stack+25300,int_stack+18700,55);
 /*--- compute (m0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1141305,int_stack+1121505,int_stack+1061280,55);
 /*--- compute (m0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1268355,int_stack+1141305,int_stack+1183875,55);
 /*--- compute (m0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1318405,int_stack+1268355,int_stack+1078605,55);
 /*--- compute (m0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1382755,int_stack+1318405,int_stack+1213905,55);
 /*--- compute (m0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1061280,int_stack+32780,int_stack+25300,55);
 /*--- compute (m0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1175955,int_stack+1061280,int_stack+1121505,55);
 /*--- compute (m0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1458985,int_stack+1175955,int_stack+1141305,55);
 /*--- compute (m0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1083720,int_stack+1458985,int_stack+1268355,55);
 /*--- compute (m0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1215555,int_stack+1083720,int_stack+1318405,55);
 /*--- compute (m0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1516735,int_stack+1215555,int_stack+1382755,55);
 /*--- compute (m0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1305645,int_stack+41195,int_stack+32780,55);
 /*--- compute (m0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1330890,int_stack+1305645,int_stack+1061280,55);
 /*--- compute (m0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1375770,int_stack+1330890,int_stack+1175955,55);
 /*--- compute (m0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1618375,int_stack+1375770,int_stack+1458985,55);
 /*--- compute (m0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1705000,int_stack+1618375,int_stack+1083720,55);
 /*--- compute (m0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1061280,int_stack+1705000,int_stack+1215555,55);
 /*--- compute (m0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1810105,int_stack+1061280,int_stack+1516735,55);
 /*--- compute (m0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1181400,int_stack+50600,int_stack+41195,55);
 /*--- compute (m0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1209615,int_stack+1181400,int_stack+1305645,55);
 /*--- compute (m0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1441770,int_stack+1209615,int_stack+1330890,55);
 /*--- compute (m0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1260105,int_stack+1441770,int_stack+1375770,55);
 /*--- compute (m0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1940785,int_stack+1260105,int_stack+1618375,55);
 /*--- compute (m0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1516570,int_stack+1940785,int_stack+1705000,55);
 /*--- compute (m0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2062060,int_stack+1516570,int_stack+1061280,55);
 /*--- compute (m0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2216500,int_stack+2062060,int_stack+1810105,55);
 /*--- compute (m0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1061280,int_stack+61050,int_stack+50600,55);
 /*--- compute (m0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1092630,int_stack+1061280,int_stack+1181400,55);
 /*--- compute (m0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1656710,int_stack+1092630,int_stack+1209615,55);
 /*--- compute (m0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1061280,int_stack+1656710,int_stack+1441770,55);
 /*--- compute (m0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1656710,int_stack+1061280,int_stack+1260105,55);
 /*--- compute (m0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1061280,int_stack+1656710,int_stack+1940785,55);
 /*--- compute (m0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1656710,int_stack+1061280,int_stack+1516570,55);
 /*--- compute (m0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1061280,int_stack+1656710,int_stack+2062060,55);
 /*--- compute (m0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1254330,int_stack+1061280,int_stack+2216500,55);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1061280,int_stack+76956,int_stack+72600,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1074348,int_stack+82104,int_stack+76956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1089792,int_stack+1074348,int_stack+1061280,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1115928,int_stack+88110,int_stack+82104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1133946,int_stack+1115928,int_stack+1074348,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1164834,int_stack+1133946,int_stack+1089792,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1061280,int_stack+95040,int_stack+88110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1208394,int_stack+1061280,int_stack+1115928,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1082070,int_stack+1208394,int_stack+1133946,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1453980,int_stack+1082070,int_stack+1164834,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1133550,int_stack+102960,int_stack+95040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1157310,int_stack+1133550,int_stack+1061280,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1519320,int_stack+1157310,int_stack+1208394,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1579380,int_stack+1519320,int_stack+1082070,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1656600,int_stack+1579380,int_stack+1453980,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1453980,int_stack+111936,int_stack+102960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1061280,int_stack+1453980,int_stack+1133550,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1748076,int_stack+1061280,int_stack+1157310,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1108800,int_stack+1748076,int_stack+1519320,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1817376,int_stack+1108800,int_stack+1579380,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1480908,int_stack+1817376,int_stack+1656600,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1602876,int_stack+122034,int_stack+111936,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1633170,int_stack+1602876,int_stack+1453980,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1925484,int_stack+1633170,int_stack+1061280,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2004684,int_stack+1925484,int_stack+1748076,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1687026,int_stack+2004684,int_stack+1108800,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1061280,int_stack+1687026,int_stack+1817376,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2108634,int_stack+1061280,int_stack+1480908,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1205424,int_stack+133320,int_stack+122034,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1453980,int_stack+1205424,int_stack+1602876,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1514568,int_stack+1453980,int_stack+1633170,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1514568,int_stack+1925484,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1813152,int_stack+0,int_stack+2004684,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2265450,int_stack+1813152,int_stack+1687026,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1604328,int_stack+2265450,int_stack+1061280,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+2433618,int_stack+1604328,int_stack+2108634,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1061280,int_stack+145860,int_stack+133320,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1098900,int_stack+1061280,int_stack+1205424,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1958682,int_stack+1098900,int_stack+1453980,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1061280,int_stack+1958682,int_stack+1514568,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1958682,int_stack+1061280,int_stack+0,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2629638,int_stack+1958682,int_stack+1813152,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1789656,int_stack+2629638,int_stack+2265450,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2005872,int_stack+1789656,int_stack+1604328,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1453980,int_stack+2005872,int_stack+2433618,66);
 /*--- compute (mp|nm) ---*/
 hrr1_build_mp(Libint->AB,int_stack+1693560,int_stack+1453980,int_stack+1254330,3630);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+164868,int_stack+159720,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+15444,int_stack+170952,int_stack+164868,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+33696,int_stack+15444,int_stack+0,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+64584,int_stack+178050,int_stack+170952,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+85878,int_stack+64584,int_stack+15444,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+122382,int_stack+85878,int_stack+33696,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+186240,int_stack+178050,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1061280,int_stack+0,int_stack+64584,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+24570,int_stack+1061280,int_stack+85878,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1103868,int_stack+24570,int_stack+122382,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+85410,int_stack+195600,int_stack+186240,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+113490,int_stack+85410,int_stack+0,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1181088,int_stack+113490,int_stack+1061280,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1252068,int_stack+1181088,int_stack+24570,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1343328,int_stack+1252068,int_stack+1103868,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1061280,int_stack+206208,int_stack+195600,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1093104,int_stack+1061280,int_stack+85410,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1093104,int_stack+113490,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+81900,int_stack+0,int_stack+1181088,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2292510,int_stack+81900,int_stack+1252068,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1149264,int_stack+2292510,int_stack+1343328,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1293408,int_stack+218142,int_stack+206208,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1329210,int_stack+1293408,int_stack+1061280,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2420274,int_stack+1329210,int_stack+1093104,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2513874,int_stack+2420274,int_stack+0,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2636724,int_stack+2513874,int_stack+81900,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+2636724,int_stack+2292510,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2785782,int_stack+0,int_stack+1149264,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2292510,int_stack+231480,int_stack+218142,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2332524,int_stack+2292510,int_stack+1293408,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1061280,int_stack+2332524,int_stack+1329210,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1167360,int_stack+1061280,int_stack+2420274,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2971110,int_stack+1167360,int_stack+2513874,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2404128,int_stack+2971110,int_stack+2636724,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3143100,int_stack+2404128,int_stack+0,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3362124,int_stack+3143100,int_stack+2785782,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+246300,int_stack+231480,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+44460,int_stack+0,int_stack+2292510,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+124488,int_stack+44460,int_stack+2332524,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2602872,int_stack+124488,int_stack+1061280,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+2602872,int_stack+1167360,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2602872,int_stack+0,int_stack+2971110,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+2602872,int_stack+2404128,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1061280,int_stack+0,int_stack+3143100,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2292510,int_stack+1061280,int_stack+3362124,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2575650,int_stack+2292510,int_stack+1453980,3630);
 /*--- compute (md|nm) ---*/
 hrr1_build_md(Libint->AB,int_stack+3294390,int_stack+2575650,int_stack+1693560,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1061280,int_stack+268686,int_stack+262680,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1079298,int_stack+275784,int_stack+268686,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1100592,int_stack+1079298,int_stack+1061280,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1136628,int_stack+284065,int_stack+275784,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1161471,int_stack+1136628,int_stack+1079298,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1204059,int_stack+1161471,int_stack+1100592,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1061280,int_stack+293620,int_stack+284065,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1264119,int_stack+1061280,int_stack+1136628,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1089945,int_stack+1264119,int_stack+1161471,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1313805,int_stack+1089945,int_stack+1204059,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1160925,int_stack+304540,int_stack+293620,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1193685,int_stack+1160925,int_stack+1061280,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1403895,int_stack+1193685,int_stack+1264119,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1486705,int_stack+1403895,int_stack+1089945,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1593175,int_stack+1486705,int_stack+1313805,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1061280,int_stack+316916,int_stack+304540,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1251015,int_stack+1061280,int_stack+1160925,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1719301,int_stack+1251015,int_stack+1193685,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1098408,int_stack+1719301,int_stack+1403895,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1316535,int_stack+1098408,int_stack+1486705,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1814851,int_stack+1316535,int_stack+1593175,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1465593,int_stack+330839,int_stack+316916,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1507362,int_stack+1465593,int_stack+1061280,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1581618,int_stack+1507362,int_stack+1251015,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1983019,int_stack+1581618,int_stack+1719301,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+0,int_stack+1983019,int_stack+1098408,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1061280,int_stack+0,int_stack+1316535,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4492290,int_stack+1061280,int_stack+1814851,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1260024,int_stack+346400,int_stack+330839,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1306707,int_stack+1260024,int_stack+1465593,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1690818,int_stack+1306707,int_stack+1507362,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1390245,int_stack+1690818,int_stack+1581618,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4708506,int_stack+1390245,int_stack+1983019,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1814578,int_stack+4708506,int_stack+0,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+1814578,int_stack+1061280,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4909161,int_stack+0,int_stack+4492290,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+4492290,int_stack+363690,int_stack+346400,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+4544160,int_stack+4492290,int_stack+1260024,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1061280,int_stack+4544160,int_stack+1306707,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+4492290,int_stack+1061280,int_stack+1690818,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1061280,int_stack+4492290,int_stack+1390245,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1290600,int_stack+1061280,int_stack+4708506,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4492290,int_stack+1290600,int_stack+1814578,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1061280,int_stack+4492290,int_stack+0,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+1061280,int_stack+4909161,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+1061280,int_stack+0,int_stack+2292510,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4492290,int_stack+1061280,int_stack+2575650,3630);
 /*--- compute (mf|nm) ---*/
 hrr1_build_mf(Libint->AB,int_stack+5929770,int_stack+4492290,int_stack+3294390,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1910700,int_stack+389730,int_stack+382800,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1931490,int_stack+397920,int_stack+389730,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1956060,int_stack+1931490,int_stack+1910700,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1997640,int_stack+407475,int_stack+397920,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2026305,int_stack+1997640,int_stack+1931490,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2075445,int_stack+2026305,int_stack+1956060,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1910700,int_stack+418500,int_stack+407475,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2144745,int_stack+1910700,int_stack+1997640,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1943775,int_stack+2144745,int_stack+2026305,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2202075,int_stack+1943775,int_stack+2075445,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2025675,int_stack+431100,int_stack+418500,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2063475,int_stack+2025675,int_stack+1910700,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2306025,int_stack+2063475,int_stack+2144745,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2401575,int_stack+2306025,int_stack+1943775,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2524425,int_stack+2401575,int_stack+2202075,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1910700,int_stack+445380,int_stack+431100,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2129625,int_stack+1910700,int_stack+2025675,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2669955,int_stack+2129625,int_stack+2063475,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1953540,int_stack+2669955,int_stack+2306025,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2205225,int_stack+1953540,int_stack+2401575,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2780205,int_stack+2205225,int_stack+2524425,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2377215,int_stack+461445,int_stack+445380,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2425410,int_stack+2377215,int_stack+1910700,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2511090,int_stack+2425410,int_stack+2129625,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2974245,int_stack+2511090,int_stack+2669955,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3139620,int_stack+2974245,int_stack+1953540,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1910700,int_stack+3139620,int_stack+2205225,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3340275,int_stack+1910700,int_stack+2780205,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2140020,int_stack+479400,int_stack+461445,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2193885,int_stack+2140020,int_stack+2377215,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2637090,int_stack+2193885,int_stack+2425410,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2290275,int_stack+2637090,int_stack+2511090,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3589755,int_stack+2290275,int_stack+2974245,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2779890,int_stack+3589755,int_stack+3139620,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3821280,int_stack+2779890,int_stack+1910700,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4116120,int_stack+3821280,int_stack+3340275,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1910700,int_stack+499350,int_stack+479400,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1970550,int_stack+1910700,int_stack+2140020,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3047430,int_stack+1970550,int_stack+2193885,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1910700,int_stack+3047430,int_stack+2637090,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3047430,int_stack+1910700,int_stack+2290275,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1910700,int_stack+3047430,int_stack+3589755,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3047430,int_stack+1910700,int_stack+2779890,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1910700,int_stack+3047430,int_stack+3821280,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2279250,int_stack+1910700,int_stack+4116120,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2660400,int_stack+2279250,int_stack+0,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+7926270,int_stack+2660400,int_stack+1061280,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+9625110,int_stack+7926270,int_stack+4492290,3630);
 /*--- compute (mg|nm) ---*/
 hrr1_build_mg(Libint->AB,int_stack+12020910,int_stack+9625110,int_stack+5929770,3630);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1061280,int_stack+529320,int_stack+521400,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1085040,int_stack+538680,int_stack+529320,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1113120,int_stack+1085040,int_stack+1061280,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1160640,int_stack+549600,int_stack+538680,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1193400,int_stack+1160640,int_stack+1085040,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1249560,int_stack+1193400,int_stack+1113120,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1061280,int_stack+562200,int_stack+549600,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1328760,int_stack+1061280,int_stack+1160640,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1099080,int_stack+1328760,int_stack+1193400,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1394280,int_stack+1099080,int_stack+1249560,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1192680,int_stack+576600,int_stack+562200,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1235880,int_stack+1192680,int_stack+1061280,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1513080,int_stack+1235880,int_stack+1328760,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1622280,int_stack+1513080,int_stack+1099080,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1762680,int_stack+1622280,int_stack+1394280,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1061280,int_stack+592920,int_stack+576600,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1311480,int_stack+1061280,int_stack+1192680,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1929000,int_stack+1311480,int_stack+1235880,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1110240,int_stack+1929000,int_stack+1513080,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1397880,int_stack+1110240,int_stack+1622280,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2055000,int_stack+1397880,int_stack+1762680,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1594440,int_stack+611280,int_stack+592920,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1649520,int_stack+1594440,int_stack+1061280,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1747440,int_stack+1649520,int_stack+1311480,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+1747440,int_stack+1929000,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+189000,int_stack+0,int_stack+1110240,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1061280,int_stack+189000,int_stack+1397880,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3651390,int_stack+1061280,int_stack+2055000,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1323360,int_stack+631800,int_stack+611280,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1384920,int_stack+1323360,int_stack+1594440,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1891440,int_stack+1384920,int_stack+1649520,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1495080,int_stack+1891440,int_stack+1747440,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3936510,int_stack+1495080,int_stack+0,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+4201110,int_stack+3936510,int_stack+189000,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+4201110,int_stack+1061280,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4506870,int_stack+0,int_stack+3651390,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+3651390,int_stack+654600,int_stack+631800,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+3719790,int_stack+3651390,int_stack+1323360,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1061280,int_stack+3719790,int_stack+1384920,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+3651390,int_stack+1061280,int_stack+1891440,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1061280,int_stack+3651390,int_stack+1495080,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1363680,int_stack+1061280,int_stack+3936510,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3651390,int_stack+1363680,int_stack+4201110,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1061280,int_stack+3651390,int_stack+0,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+1061280,int_stack+4506870,120);
 /*--- compute (rp|nm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+1061280,int_stack+0,int_stack+2279250,3630);
 /*--- compute (qd|nm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+3651390,int_stack+1061280,int_stack+2660400,3630);
 /*--- compute (of|nm) ---*/
 hrr1_build_of(Libint->AB,int_stack+15015660,int_stack+3651390,int_stack+7926270,3630);
 /*--- compute (ng|nm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+5633370,int_stack+15015660,int_stack+9625110,3630);
 /*--- compute (mh|nm) ---*/
 hrr1_build_mh(Libint->AB,int_stack+17847060,int_stack+5633370,int_stack+12020910,3630);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2204730,int_stack+688776,int_stack+679800,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2231658,int_stack+699384,int_stack+688776,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2263482,int_stack+2231658,int_stack+2204730,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2317338,int_stack+711760,int_stack+699384,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2354466,int_stack+2317338,int_stack+2231658,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2418114,int_stack+2354466,int_stack+2263482,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2204730,int_stack+726040,int_stack+711760,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2507874,int_stack+2204730,int_stack+2317338,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2247570,int_stack+2507874,int_stack+2354466,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2582130,int_stack+2247570,int_stack+2418114,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2353650,int_stack+742360,int_stack+726040,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2402610,int_stack+2353650,int_stack+2204730,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2716770,int_stack+2402610,int_stack+2507874,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2840530,int_stack+2716770,int_stack+2247570,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2999650,int_stack+2840530,int_stack+2582130,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2204730,int_stack+760856,int_stack+742360,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2488290,int_stack+2204730,int_stack+2353650,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3188146,int_stack+2488290,int_stack+2402610,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2260218,int_stack+3188146,int_stack+2716770,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2586210,int_stack+2260218,int_stack+2840530,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3330946,int_stack+2586210,int_stack+2999650,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2808978,int_stack+781664,int_stack+760856,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2871402,int_stack+2808978,int_stack+2204730,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2982378,int_stack+2871402,int_stack+2488290,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+435600,int_stack+2982378,int_stack+3188146,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+9227070,int_stack+435600,int_stack+2260218,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2204730,int_stack+9227070,int_stack+2586210,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+9486966,int_stack+2204730,int_stack+3330946,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2501754,int_stack+804920,int_stack+781664,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2571522,int_stack+2501754,int_stack+2808978,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3145578,int_stack+2571522,int_stack+2871402,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2696370,int_stack+3145578,int_stack+2982378,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3330538,int_stack+2696370,int_stack+435600,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+435600,int_stack+3330538,int_stack+9227070,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+9810102,int_stack+435600,int_stack+2204730,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+10191990,int_stack+9810102,int_stack+9486966,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+2204730,int_stack+830760,int_stack+804920,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+2282250,int_stack+2204730,int_stack+2501754,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+9227070,int_stack+2282250,int_stack+2571522,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2204730,int_stack+9227070,int_stack+3145578,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+9227070,int_stack+2204730,int_stack+2696370,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2204730,int_stack+9227070,int_stack+3330538,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+9227070,int_stack+2204730,int_stack+435600,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2204730,int_stack+9227070,int_stack+9810102,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+9227070,int_stack+2204730,int_stack+10191990,136);
 /*--- compute (tp|nm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+2204730,int_stack+9227070,int_stack+0,3630);
 /*--- compute (rd|nm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+9720750,int_stack+2204730,int_stack+1061280,3630);
 /*--- compute (qf|nm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+22039710,int_stack+9720750,int_stack+3651390,3630);
 /*--- compute (og|nm) ---*/
 hrr1_build_og(Libint->AB,int_stack+25343010,int_stack+22039710,int_stack+15015660,3630);
 /*--- compute (nh|nm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+12007650,int_stack+25343010,int_stack+5633370,3630);
 /*--- compute (mi|nm) ---*/
 hrr1_build_mi(Libint->AB,int_stack+3511530,int_stack+12007650,int_stack+17847060,3630);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1061280,int_stack+869418,int_stack+859320,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1091574,int_stack+881352,int_stack+869418,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1127376,int_stack+1091574,int_stack+1061280,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1187964,int_stack+895275,int_stack+881352,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1229733,int_stack+1187964,int_stack+1091574,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1301337,int_stack+1229733,int_stack+1127376,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1061280,int_stack+911340,int_stack+895275,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1402317,int_stack+1061280,int_stack+1187964,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1109475,int_stack+1402317,int_stack+1229733,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1485855,int_stack+1109475,int_stack+1301337,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1228815,int_stack+929700,int_stack+911340,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1283895,int_stack+1228815,int_stack+1061280,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1637325,int_stack+1283895,int_stack+1402317,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1776555,int_stack+1637325,int_stack+1109475,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1955565,int_stack+1776555,int_stack+1485855,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1061280,int_stack+950508,int_stack+929700,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1380285,int_stack+1061280,int_stack+1228815,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+0,int_stack+1380285,int_stack+1283895,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1123704,int_stack+0,int_stack+1637325,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1490445,int_stack+1123704,int_stack+1776555,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+160650,int_stack+1490445,int_stack+1955565,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+1741059,int_stack+973917,int_stack+950508,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+1811286,int_stack+1741059,int_stack+1061280,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1936134,int_stack+1811286,int_stack+1380285,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+443394,int_stack+1936134,int_stack+0,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+17038830,int_stack+443394,int_stack+1123704,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1061280,int_stack+17038830,int_stack+1490445,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+17331213,int_stack+1061280,int_stack+160650,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+1000080,int_stack+973917,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+78489,int_stack+0,int_stack+1741059,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+218943,int_stack+78489,int_stack+1811286,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1395432,int_stack+218943,int_stack+1936134,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1670832,int_stack+1395432,int_stack+443394,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+427023,int_stack+1670832,int_stack+17038830,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+17694741,int_stack+427023,int_stack+1061280,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+18124365,int_stack+17694741,int_stack+17331213,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1061280,int_stack+1029150,int_stack+1000080,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1148490,int_stack+1061280,int_stack+0,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+17038830,int_stack+1148490,int_stack+78489,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+17272920,int_stack+17038830,int_stack+218943,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+17272920,int_stack+1395432,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+17038830,int_stack+0,int_stack+1670832,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+816867,int_stack+17038830,int_stack+427023,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+17038830,int_stack+816867,int_stack+17694741,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+17038830,int_stack+18124365,153);
 /*--- compute (up|nm) ---*/
 hrr1_build_up(Libint->AB,int_stack+17038830,int_stack+0,int_stack+9227070,3630);
 /*--- compute (td|nm) ---*/
 hrr1_build_td(Libint->AB,int_stack+18519870,int_stack+17038830,int_stack+2204730,3630);
 /*--- compute (rf|nm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+29590110,int_stack+18519870,int_stack+9720750,3630);
 /*--- compute (qg|nm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+17038830,int_stack+29590110,int_stack+22039710,3630);
 /*--- compute (oh|nm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+29590110,int_stack+17038830,int_stack+25343010,3630);
 /*--- compute (ni|nm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+17038830,int_stack+29590110,int_stack+12007650,3630);
 /*--- compute (mk|nm) ---*/
 hrr1_build_mk(Libint->AB,int_stack+23747070,int_stack+17038830,int_stack+3511530,3630);
 return int_stack+23747070;}
