/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_mpmg(Libint_t*, prim_data*);

  /* Computes quartets of (mp|mg) integrals */

REALTYPE *hrr_order_mpmg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[9][9] = int_stack + 0;
 Libint->vrr_classes[9][10] = int_stack + 3025;
 Libint->vrr_classes[9][11] = int_stack + 6655;
 Libint->vrr_classes[9][12] = int_stack + 10945;
 Libint->vrr_classes[9][13] = int_stack + 15950;
 Libint->vrr_classes[10][9] = int_stack + 21725;
 Libint->vrr_classes[10][10] = int_stack + 25355;
 Libint->vrr_classes[10][11] = int_stack + 29711;
 Libint->vrr_classes[10][12] = int_stack + 34859;
 Libint->vrr_classes[10][13] = int_stack + 40865;
 memset(int_stack,0,47795*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 47795;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_mpmg(Libint, Data);
   Data++;
 }
 /*--- compute (m0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47795,int_stack+3025,int_stack+0,55);
 /*--- compute (m0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+56870,int_stack+6655,int_stack+3025,55);
 /*--- compute (m0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+67760,int_stack+56870,int_stack+47795,55);
 /*--- compute (m0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+85910,int_stack+10945,int_stack+6655,55);
 /*--- compute (m0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+98780,int_stack+85910,int_stack+56870,55);
 /*--- compute (m0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+120560,int_stack+98780,int_stack+67760,55);
 /*--- compute (m0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+47795,int_stack+15950,int_stack+10945,55);
 /*--- compute (m0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+150810,int_stack+47795,int_stack+85910,55);
 /*--- compute (m0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+47795,int_stack+150810,int_stack+98780,55);
 /*--- compute (m0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+150810,int_stack+47795,int_stack+120560,55);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+47795,int_stack+25355,int_stack+21725,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+58685,int_stack+29711,int_stack+25355,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+71753,int_stack+58685,int_stack+47795,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+93533,int_stack+34859,int_stack+29711,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+108977,int_stack+93533,int_stack+58685,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+196185,int_stack+108977,int_stack+71753,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+47795,int_stack+40865,int_stack+34859,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+47795,int_stack+93533,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+30888,int_stack+0,int_stack+108977,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+74448,int_stack+30888,int_stack+196185,66);
 /*--- compute (mp|mg) ---*/
 hrr1_build_mp(Libint->AB,int_stack+196185,int_stack+74448,int_stack+150810,825);
 return int_stack+196185;}
