/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nflh(Libint_t*, prim_data*);

  /* Computes quartets of (nf|lh) integrals */

REALTYPE *hrr_order_nflh(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[11][8] = int_stack + 29040;
 Libint->vrr_classes[11][9] = int_stack + 32550;
 Libint->vrr_classes[11][10] = int_stack + 36840;
 Libint->vrr_classes[11][11] = int_stack + 41988;
 Libint->vrr_classes[11][12] = int_stack + 48072;
 Libint->vrr_classes[11][13] = int_stack + 55170;
 Libint->vrr_classes[12][8] = int_stack + 63360;
 Libint->vrr_classes[12][9] = int_stack + 67455;
 Libint->vrr_classes[12][10] = int_stack + 72460;
 Libint->vrr_classes[12][11] = int_stack + 78466;
 Libint->vrr_classes[12][12] = int_stack + 85564;
 Libint->vrr_classes[12][13] = int_stack + 93845;
 Libint->vrr_classes[13][8] = int_stack + 103400;
 Libint->vrr_classes[13][9] = int_stack + 108125;
 Libint->vrr_classes[13][10] = int_stack + 113900;
 Libint->vrr_classes[13][11] = int_stack + 120830;
 Libint->vrr_classes[13][12] = int_stack + 129020;
 Libint->vrr_classes[13][13] = int_stack + 138575;
 memset(int_stack,0,149600*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 149600;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nflh(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+149600,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+158510,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+169400,int_stack+158510,int_stack+149600,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+187220,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+200288,int_stack+187220,int_stack+158510,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+222068,int_stack+200288,int_stack+169400,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+149600,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+251768,int_stack+149600,int_stack+187220,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+277904,int_stack+251768,int_stack+200288,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+165044,int_stack+277904,int_stack+222068,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+209594,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+314204,int_stack+209594,int_stack+149600,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+345092,int_stack+314204,int_stack+251768,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+209594,int_stack+345092,int_stack+277904,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+264044,int_stack+209594,int_stack+165044,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+149600,int_stack+32550,int_stack+29040,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+160130,int_stack+36840,int_stack+32550,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+173000,int_stack+160130,int_stack+149600,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+194060,int_stack+41988,int_stack+36840,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+209504,int_stack+194060,int_stack+160130,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+326414,int_stack+209504,int_stack+173000,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+149600,int_stack+48072,int_stack+41988,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+0,int_stack+149600,int_stack+194060,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+361514,int_stack+0,int_stack+209504,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+167852,int_stack+361514,int_stack+326414,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+326414,int_stack+55170,int_stack+48072,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+220502,int_stack+326414,int_stack+149600,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+404414,int_stack+220502,int_stack+0,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+455894,int_stack+404414,int_stack+361514,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+326414,int_stack+455894,int_stack+167852,78);
 /*--- compute (np|lh) ---*/
 hrr1_build_np(Libint->AB,int_stack+400124,int_stack+326414,int_stack+264044,945);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+0,int_stack+67455,int_stack+63360,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+12285,int_stack+72460,int_stack+67455,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+27300,int_stack+12285,int_stack+0,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+51870,int_stack+78466,int_stack+72460,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+149600,int_stack+51870,int_stack+12285,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+179630,int_stack+149600,int_stack+27300,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+0,int_stack+85564,int_stack+78466,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+220580,int_stack+0,int_stack+51870,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+21294,int_stack+220580,int_stack+149600,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+256616,int_stack+21294,int_stack+179630,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+149600,int_stack+93845,int_stack+85564,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+174443,int_stack+149600,int_stack+0,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+587234,int_stack+174443,int_stack+220580,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+149600,int_stack+587234,int_stack+21294,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+0,int_stack+149600,int_stack+256616,91);
 /*--- compute (op|lh) ---*/
 hrr1_build_op(Libint->AB,int_stack+587234,int_stack+0,int_stack+326414,945);
 /*--- compute (nd|lh) ---*/
 hrr1_build_nd(Libint->AB,int_stack+808364,int_stack+587234,int_stack+400124,945);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+149600,int_stack+108125,int_stack+103400,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+163775,int_stack+113900,int_stack+108125,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+181100,int_stack+163775,int_stack+149600,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+209450,int_stack+120830,int_stack+113900,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+230240,int_stack+209450,int_stack+163775,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+264890,int_stack+230240,int_stack+181100,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+149600,int_stack+129020,int_stack+120830,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+312140,int_stack+149600,int_stack+209450,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+353720,int_stack+312140,int_stack+230240,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+174170,int_stack+353720,int_stack+264890,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+245045,int_stack+138575,int_stack+129020,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+411470,int_stack+245045,int_stack+149600,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+460610,int_stack+411470,int_stack+312140,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+245045,int_stack+460610,int_stack+353720,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+331670,int_stack+245045,int_stack+174170,105);
 /*--- compute (qp|lh) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1182584,int_stack+331670,int_stack+0,945);
 /*--- compute (od|lh) ---*/
 hrr1_build_od(Libint->AB,int_stack+0,int_stack+1182584,int_stack+587234,945);
 /*--- compute (nf|lh) ---*/
 hrr1_build_nf(Libint->AB,int_stack+1182584,int_stack+0,int_stack+808364,945);
 return int_stack+1182584;}
