/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nfll(Libint_t*, prim_data*);

  /* Computes quartets of (nf|ll) integrals */

REALTYPE *hrr_order_nfll(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][8] = int_stack + 0;
 Libint->vrr_classes[10][9] = int_stack + 2970;
 Libint->vrr_classes[10][10] = int_stack + 6600;
 Libint->vrr_classes[10][11] = int_stack + 10956;
 Libint->vrr_classes[10][12] = int_stack + 16104;
 Libint->vrr_classes[10][13] = int_stack + 22110;
 Libint->vrr_classes[10][14] = int_stack + 29040;
 Libint->vrr_classes[10][15] = int_stack + 36960;
 Libint->vrr_classes[10][16] = int_stack + 45936;
 Libint->vrr_classes[11][8] = int_stack + 56034;
 Libint->vrr_classes[11][9] = int_stack + 59544;
 Libint->vrr_classes[11][10] = int_stack + 63834;
 Libint->vrr_classes[11][11] = int_stack + 68982;
 Libint->vrr_classes[11][12] = int_stack + 75066;
 Libint->vrr_classes[11][13] = int_stack + 82164;
 Libint->vrr_classes[11][14] = int_stack + 90354;
 Libint->vrr_classes[11][15] = int_stack + 99714;
 Libint->vrr_classes[11][16] = int_stack + 110322;
 Libint->vrr_classes[12][8] = int_stack + 122256;
 Libint->vrr_classes[12][9] = int_stack + 126351;
 Libint->vrr_classes[12][10] = int_stack + 131356;
 Libint->vrr_classes[12][11] = int_stack + 137362;
 Libint->vrr_classes[12][12] = int_stack + 144460;
 Libint->vrr_classes[12][13] = int_stack + 152741;
 Libint->vrr_classes[12][14] = int_stack + 162296;
 Libint->vrr_classes[12][15] = int_stack + 173216;
 Libint->vrr_classes[12][16] = int_stack + 185592;
 Libint->vrr_classes[13][8] = int_stack + 199515;
 Libint->vrr_classes[13][9] = int_stack + 204240;
 Libint->vrr_classes[13][10] = int_stack + 210015;
 Libint->vrr_classes[13][11] = int_stack + 216945;
 Libint->vrr_classes[13][12] = int_stack + 225135;
 Libint->vrr_classes[13][13] = int_stack + 234690;
 Libint->vrr_classes[13][14] = int_stack + 245715;
 Libint->vrr_classes[13][15] = int_stack + 258315;
 Libint->vrr_classes[13][16] = int_stack + 272595;
 memset(int_stack,0,288660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 288660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nfll(Libint, Data);
   Data++;
 }
 /*--- compute (n0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+288660,int_stack+2970,int_stack+0,66);
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+297570,int_stack+6600,int_stack+2970,66);
 /*--- compute (n0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+308460,int_stack+297570,int_stack+288660,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+326280,int_stack+10956,int_stack+6600,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+339348,int_stack+326280,int_stack+297570,66);
 /*--- compute (n0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+361128,int_stack+339348,int_stack+308460,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+288660,int_stack+16104,int_stack+10956,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+390828,int_stack+288660,int_stack+326280,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+416964,int_stack+390828,int_stack+339348,66);
 /*--- compute (n0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+304104,int_stack+416964,int_stack+361128,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+348654,int_stack+22110,int_stack+16104,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+453264,int_stack+348654,int_stack+288660,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+484152,int_stack+453264,int_stack+390828,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+527712,int_stack+484152,int_stack+416964,66);
 /*--- compute (n0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+366672,int_stack+527712,int_stack+304104,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+288660,int_stack+29040,int_stack+22110,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+309450,int_stack+288660,int_stack+348654,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+582162,int_stack+309450,int_stack+453264,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+633642,int_stack+582162,int_stack+484152,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+429042,int_stack+633642,int_stack+527712,66);
 /*--- compute (n0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+698982,int_stack+429042,int_stack+366672,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+345486,int_stack+36960,int_stack+29040,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+369246,int_stack+345486,int_stack+288660,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+505272,int_stack+369246,int_stack+309450,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+782142,int_stack+505272,int_stack+582162,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+859362,int_stack+782142,int_stack+633642,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+565332,int_stack+859362,int_stack+429042,66);
 /*--- compute (n0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+950838,int_stack+565332,int_stack+698982,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+288660,int_stack+45936,int_stack+36960,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+410826,int_stack+288660,int_stack+345486,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+288660,int_stack+410826,int_stack+369246,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+357960,int_stack+288660,int_stack+505272,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+448050,int_stack+357960,int_stack+782142,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+288660,int_stack+448050,int_stack+859362,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+410628,int_stack+288660,int_stack+565332,66);
 /*--- compute (n0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+541308,int_stack+410628,int_stack+950838,66);
 /*--- compute (o0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+288660,int_stack+59544,int_stack+56034,78);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+299190,int_stack+63834,int_stack+59544,78);
 /*--- compute (o0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+312060,int_stack+299190,int_stack+288660,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+333120,int_stack+68982,int_stack+63834,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+348564,int_stack+333120,int_stack+299190,78);
 /*--- compute (o0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+374304,int_stack+348564,int_stack+312060,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+288660,int_stack+75066,int_stack+68982,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+409404,int_stack+288660,int_stack+333120,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+440292,int_stack+409404,int_stack+348564,78);
 /*--- compute (o0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+306912,int_stack+440292,int_stack+374304,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+359562,int_stack+82164,int_stack+75066,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+483192,int_stack+359562,int_stack+288660,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+674958,int_stack+483192,int_stack+409404,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+726438,int_stack+674958,int_stack+440292,78);
 /*--- compute (o0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+380856,int_stack+726438,int_stack+306912,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+288660,int_stack+90354,int_stack+82164,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+313230,int_stack+288660,int_stack+359562,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+790788,int_stack+313230,int_stack+483192,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+454566,int_stack+790788,int_stack+674958,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+851628,int_stack+454566,int_stack+726438,78);
 /*--- compute (o0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+674958,int_stack+851628,int_stack+380856,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+355818,int_stack+99714,int_stack+90354,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+383898,int_stack+355818,int_stack+288660,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+941718,int_stack+383898,int_stack+313230,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+0,int_stack+941718,int_stack+790788,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1012698,int_stack+0,int_stack+454566,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1120806,int_stack+1012698,int_stack+851628,78);
 /*--- compute (o0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+773238,int_stack+1120806,int_stack+674958,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+674958,int_stack+110322,int_stack+99714,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+706782,int_stack+674958,int_stack+355818,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+288660,int_stack+706782,int_stack+383898,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+370560,int_stack+288660,int_stack+941718,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1240926,int_stack+370560,int_stack+0,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+288660,int_stack+1240926,int_stack+1012698,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+899598,int_stack+288660,int_stack+1120806,78);
 /*--- compute (o0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+288660,int_stack+899598,int_stack+773238,78);
 /*--- compute (np|ll) ---*/
 hrr1_build_np(Libint->AB,int_stack+674958,int_stack+288660,int_stack+541308,2025);
 /*--- compute (q0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+446610,int_stack+126351,int_stack+122256,91);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+458895,int_stack+131356,int_stack+126351,91);
 /*--- compute (q0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+473910,int_stack+458895,int_stack+446610,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+498480,int_stack+137362,int_stack+131356,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+516498,int_stack+498480,int_stack+458895,91);
 /*--- compute (q0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+546528,int_stack+516498,int_stack+473910,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+446610,int_stack+144460,int_stack+137362,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+587478,int_stack+446610,int_stack+498480,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+623514,int_stack+587478,int_stack+516498,91);
 /*--- compute (q0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+467904,int_stack+623514,int_stack+546528,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+529329,int_stack+152741,int_stack+144460,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+529329,int_stack+446610,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42588,int_stack+0,int_stack+587478,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1075908,int_stack+42588,int_stack+623514,91);
 /*--- compute (q0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+554172,int_stack+1075908,int_stack+467904,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+446610,int_stack+162296,int_stack+152741,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+475275,int_stack+446610,int_stack+529329,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1150983,int_stack+475275,int_stack+0,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1221963,int_stack+1150983,int_stack+42588,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+0,int_stack+1221963,int_stack+1075908,91);
 /*--- compute (q0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+1312053,int_stack+0,int_stack+554172,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1075908,int_stack+173216,int_stack+162296,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+105105,int_stack+1075908,int_stack+446610,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+524961,int_stack+105105,int_stack+475275,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1426713,int_stack+524961,int_stack+1150983,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1533183,int_stack+1426713,int_stack+1221963,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1108668,int_stack+1533183,int_stack+0,91);
 /*--- compute (q0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+1659309,int_stack+1108668,int_stack+1312053,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+185592,int_stack+173216,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+37128,int_stack+0,int_stack+1075908,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1248808,int_stack+37128,int_stack+105105,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+1248808,int_stack+524961,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1248808,int_stack+0,int_stack+1426713,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1248808,int_stack+1533183,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1248808,int_stack+0,int_stack+1108668,91);
 /*--- compute (q0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+0,int_stack+1248808,int_stack+1659309,91);
 /*--- compute (op|ll) ---*/
 hrr1_build_op(Libint->AB,int_stack+1075908,int_stack+0,int_stack+288660,2025);
 /*--- compute (nd|ll) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1549758,int_stack+1075908,int_stack+674958,2025);
 /*--- compute (r0|lp) ---*/
 hrr3_build_lp(Libint->CD,int_stack+288660,int_stack+204240,int_stack+199515,105);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+302835,int_stack+210015,int_stack+204240,105);
 /*--- compute (r0|ld) ---*/
 hrr3_build_ld(Libint->CD,int_stack+320160,int_stack+302835,int_stack+288660,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+348510,int_stack+216945,int_stack+210015,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+369300,int_stack+348510,int_stack+302835,105);
 /*--- compute (r0|lf) ---*/
 hrr3_build_lf(Libint->CD,int_stack+403950,int_stack+369300,int_stack+320160,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+288660,int_stack+225135,int_stack+216945,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+451200,int_stack+288660,int_stack+348510,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+492780,int_stack+451200,int_stack+369300,105);
 /*--- compute (r0|lg) ---*/
 hrr3_build_lg(Libint->CD,int_stack+313230,int_stack+492780,int_stack+403950,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+384105,int_stack+234690,int_stack+225135,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+550530,int_stack+384105,int_stack+288660,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+599670,int_stack+550530,int_stack+451200,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+668970,int_stack+599670,int_stack+492780,105);
 /*--- compute (r0|lh) ---*/
 hrr3_build_lh(Libint->CD,int_stack+412770,int_stack+668970,int_stack+313230,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+288660,int_stack+245715,int_stack+234690,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+321735,int_stack+288660,int_stack+384105,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+755595,int_stack+321735,int_stack+550530,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+837495,int_stack+755595,int_stack+599670,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+511995,int_stack+837495,int_stack+668970,105);
 /*--- compute (r0|li) ---*/
 hrr3_build_li(Libint->CD,int_stack+941445,int_stack+511995,int_stack+412770,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+379065,int_stack+258315,int_stack+245715,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+416865,int_stack+379065,int_stack+288660,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+633270,int_stack+416865,int_stack+321735,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2351658,int_stack+633270,int_stack+755595,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2474508,int_stack+2351658,int_stack+837495,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+728820,int_stack+2474508,int_stack+511995,105);
 /*--- compute (r0|lk) ---*/
 hrr3_build_lk(Libint->CD,int_stack+2620038,int_stack+728820,int_stack+941445,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+288660,int_stack+272595,int_stack+258315,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+483015,int_stack+288660,int_stack+379065,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+890520,int_stack+483015,int_stack+416865,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+184275,int_stack+890520,int_stack+633270,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+890520,int_stack+184275,int_stack+2351658,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+184275,int_stack+890520,int_stack+2474508,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2351658,int_stack+184275,int_stack+728820,105);
 /*--- compute (r0|ll) ---*/
 hrr3_build_ll(Libint->CD,int_stack+184275,int_stack+2351658,int_stack+2620038,105);
 /*--- compute (qp|ll) ---*/
 hrr1_build_qp(Libint->AB,int_stack+396900,int_stack+184275,int_stack+0,2025);
 /*--- compute (od|ll) ---*/
 hrr1_build_od(Libint->AB,int_stack+2351658,int_stack+396900,int_stack+1075908,2025);
 /*--- compute (nf|ll) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+2351658,int_stack+1549758,2025);
 return int_stack+0;}
