/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nfni(Libint_t*, prim_data*);

  /* Computes quartets of (nf|ni) integrals */

REALTYPE *hrr_order_nfni(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[11][10] = int_stack + 49434;
 Libint->vrr_classes[11][11] = int_stack + 54582;
 Libint->vrr_classes[11][12] = int_stack + 60666;
 Libint->vrr_classes[11][13] = int_stack + 67764;
 Libint->vrr_classes[11][14] = int_stack + 75954;
 Libint->vrr_classes[11][15] = int_stack + 85314;
 Libint->vrr_classes[11][16] = int_stack + 95922;
 Libint->vrr_classes[12][10] = int_stack + 107856;
 Libint->vrr_classes[12][11] = int_stack + 113862;
 Libint->vrr_classes[12][12] = int_stack + 120960;
 Libint->vrr_classes[12][13] = int_stack + 129241;
 Libint->vrr_classes[12][14] = int_stack + 138796;
 Libint->vrr_classes[12][15] = int_stack + 149716;
 Libint->vrr_classes[12][16] = int_stack + 162092;
 Libint->vrr_classes[13][10] = int_stack + 176015;
 Libint->vrr_classes[13][11] = int_stack + 182945;
 Libint->vrr_classes[13][12] = int_stack + 191135;
 Libint->vrr_classes[13][13] = int_stack + 200690;
 Libint->vrr_classes[13][14] = int_stack + 211715;
 Libint->vrr_classes[13][15] = int_stack + 224315;
 Libint->vrr_classes[13][16] = int_stack + 238595;
 memset(int_stack,0,254660*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 254660;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nfni(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254660,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+267728,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+283172,int_stack+267728,int_stack+254660,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+309308,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+327326,int_stack+309308,int_stack+267728,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+358214,int_stack+327326,int_stack+283172,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254660,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+401774,int_stack+254660,int_stack+309308,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+275450,int_stack+401774,int_stack+327326,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+437810,int_stack+275450,int_stack+358214,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+326930,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+350690,int_stack+326930,int_stack+254660,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+503150,int_stack+350690,int_stack+401774,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+563210,int_stack+503150,int_stack+275450,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+640430,int_stack+563210,int_stack+437810,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+254660,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+392270,int_stack+254660,int_stack+326930,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+254660,int_stack+392270,int_stack+350690,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+323960,int_stack+254660,int_stack+503150,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+414050,int_stack+323960,int_stack+563210,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+254660,int_stack+414050,int_stack+640430,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+376628,int_stack+54582,int_stack+49434,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+392072,int_stack+60666,int_stack+54582,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+410324,int_stack+392072,int_stack+376628,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+441212,int_stack+67764,int_stack+60666,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+462506,int_stack+441212,int_stack+392072,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+499010,int_stack+462506,int_stack+410324,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+376628,int_stack+75954,int_stack+67764,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+550490,int_stack+376628,int_stack+441212,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+401198,int_stack+550490,int_stack+462506,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+593078,int_stack+401198,int_stack+499010,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+462038,int_stack+85314,int_stack+75954,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+490118,int_stack+462038,int_stack+376628,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+490118,int_stack+550490,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+670298,int_stack+0,int_stack+401198,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+761558,int_stack+670298,int_stack+593078,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+376628,int_stack+95922,int_stack+85314,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+539258,int_stack+376628,int_stack+462038,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+376628,int_stack+539258,int_stack+490118,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+458528,int_stack+376628,int_stack+0,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+869666,int_stack+458528,int_stack+670298,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+376628,int_stack+869666,int_stack+761558,78);
 /*--- compute (np|ni) ---*/
 hrr1_build_np(Libint->AB,int_stack+520772,int_stack+376628,int_stack+254660,1848);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254660,int_stack+113862,int_stack+107856,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+272678,int_stack+120960,int_stack+113862,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+293972,int_stack+272678,int_stack+254660,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+330008,int_stack+129241,int_stack+120960,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+330008,int_stack+272678,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+42588,int_stack+0,int_stack+293972,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254660,int_stack+138796,int_stack+129241,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+886676,int_stack+254660,int_stack+330008,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+283325,int_stack+886676,int_stack+0,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+936362,int_stack+283325,int_stack+42588,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+149716,int_stack+138796,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+32760,int_stack+0,int_stack+254660,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1026452,int_stack+32760,int_stack+886676,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1109262,int_stack+1026452,int_stack+283325,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1215732,int_stack+1109262,int_stack+936362,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+886676,int_stack+162092,int_stack+149716,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+923804,int_stack+886676,int_stack+0,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+254660,int_stack+923804,int_stack+32760,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+0,int_stack+254660,int_stack+1026452,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+886676,int_stack+0,int_stack+1109262,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+886676,int_stack+1215732,91);
 /*--- compute (op|ni) ---*/
 hrr1_build_op(Libint->AB,int_stack+886676,int_stack+0,int_stack+376628,1848);
 /*--- compute (nd|ni) ---*/
 hrr1_build_nd(Libint->AB,int_stack+1319108,int_stack+886676,int_stack+520772,1848);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+254660,int_stack+182945,int_stack+176015,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+275450,int_stack+191135,int_stack+182945,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+300020,int_stack+275450,int_stack+254660,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+341600,int_stack+200690,int_stack+191135,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+370265,int_stack+341600,int_stack+275450,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+419405,int_stack+370265,int_stack+300020,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+254660,int_stack+211715,int_stack+200690,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+488705,int_stack+254660,int_stack+341600,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+287735,int_stack+488705,int_stack+370265,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+546035,int_stack+287735,int_stack+419405,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+369635,int_stack+224315,int_stack+211715,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+407435,int_stack+369635,int_stack+254660,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+649985,int_stack+407435,int_stack+488705,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+745535,int_stack+649985,int_stack+287735,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2050916,int_stack+745535,int_stack+546035,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+254660,int_stack+238595,int_stack+224315,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+473585,int_stack+254660,int_stack+369635,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+168168,int_stack+473585,int_stack+407435,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+278418,int_stack+168168,int_stack+649985,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+421743,int_stack+278418,int_stack+745535,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+168168,int_stack+421743,int_stack+2050916,105);
 /*--- compute (qp|ni) ---*/
 hrr1_build_qp(Libint->AB,int_stack+362208,int_stack+168168,int_stack+0,1848);
 /*--- compute (od|ni) ---*/
 hrr1_build_od(Libint->AB,int_stack+2050916,int_stack+362208,int_stack+886676,1848);
 /*--- compute (nf|ni) ---*/
 hrr1_build_nf(Libint->AB,int_stack+0,int_stack+2050916,int_stack+1319108,1848);
 return int_stack+0;}
