/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ngmm(Libint_t*, prim_data*);

  /* Computes quartets of (ng|mm) integrals */

REALTYPE *hrr_order_ngmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[10][18] = int_stack + 64350;
 Libint->vrr_classes[11][9] = int_stack + 76890;
 Libint->vrr_classes[11][10] = int_stack + 81180;
 Libint->vrr_classes[11][11] = int_stack + 86328;
 Libint->vrr_classes[11][12] = int_stack + 92412;
 Libint->vrr_classes[11][13] = int_stack + 99510;
 Libint->vrr_classes[11][14] = int_stack + 107700;
 Libint->vrr_classes[11][15] = int_stack + 117060;
 Libint->vrr_classes[11][16] = int_stack + 127668;
 Libint->vrr_classes[11][17] = int_stack + 139602;
 Libint->vrr_classes[11][18] = int_stack + 152940;
 Libint->vrr_classes[12][9] = int_stack + 167760;
 Libint->vrr_classes[12][10] = int_stack + 172765;
 Libint->vrr_classes[12][11] = int_stack + 178771;
 Libint->vrr_classes[12][12] = int_stack + 185869;
 Libint->vrr_classes[12][13] = int_stack + 194150;
 Libint->vrr_classes[12][14] = int_stack + 203705;
 Libint->vrr_classes[12][15] = int_stack + 214625;
 Libint->vrr_classes[12][16] = int_stack + 227001;
 Libint->vrr_classes[12][17] = int_stack + 240924;
 Libint->vrr_classes[12][18] = int_stack + 256485;
 Libint->vrr_classes[13][9] = int_stack + 273775;
 Libint->vrr_classes[13][10] = int_stack + 279550;
 Libint->vrr_classes[13][11] = int_stack + 286480;
 Libint->vrr_classes[13][12] = int_stack + 294670;
 Libint->vrr_classes[13][13] = int_stack + 304225;
 Libint->vrr_classes[13][14] = int_stack + 315250;
 Libint->vrr_classes[13][15] = int_stack + 327850;
 Libint->vrr_classes[13][16] = int_stack + 342130;
 Libint->vrr_classes[13][17] = int_stack + 358195;
 Libint->vrr_classes[13][18] = int_stack + 376150;
 Libint->vrr_classes[14][9] = int_stack + 396100;
 Libint->vrr_classes[14][10] = int_stack + 402700;
 Libint->vrr_classes[14][11] = int_stack + 410620;
 Libint->vrr_classes[14][12] = int_stack + 419980;
 Libint->vrr_classes[14][13] = int_stack + 430900;
 Libint->vrr_classes[14][14] = int_stack + 443500;
 Libint->vrr_classes[14][15] = int_stack + 457900;
 Libint->vrr_classes[14][16] = int_stack + 474220;
 Libint->vrr_classes[14][17] = int_stack + 492580;
 Libint->vrr_classes[14][18] = int_stack + 513100;
 memset(int_stack,0,535900*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 535900;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ngmm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+535900,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+546790,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+559858,int_stack+546790,int_stack+535900,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+581638,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+597082,int_stack+581638,int_stack+546790,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+623218,int_stack+597082,int_stack+559858,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+535900,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+659518,int_stack+535900,int_stack+581638,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+690406,int_stack+659518,int_stack+597082,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+553918,int_stack+690406,int_stack+623218,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+608368,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+733966,int_stack+608368,int_stack+535900,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+770002,int_stack+733966,int_stack+659518,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+821482,int_stack+770002,int_stack+690406,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+629158,int_stack+821482,int_stack+553918,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+535900,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+559660,int_stack+535900,int_stack+608368,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+886822,int_stack+559660,int_stack+733966,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+946882,int_stack+886822,int_stack+770002,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+705388,int_stack+946882,int_stack+821482,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1024102,int_stack+705388,int_stack+629158,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+601240,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+628168,int_stack+601240,int_stack+535900,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+796864,int_stack+628168,int_stack+559660,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1125742,int_stack+796864,int_stack+886822,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1215832,int_stack+1125742,int_stack+946882,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+866164,int_stack+1215832,int_stack+705388,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1323940,int_stack+866164,int_stack+1024102,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+535900,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+675688,int_stack+535900,int_stack+601240,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+988132,int_stack+675688,int_stack+628168,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+566194,int_stack+988132,int_stack+796864,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+729544,int_stack+566194,int_stack+1125742,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1067332,int_stack+729544,int_stack+1215832,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1454620,int_stack+1067332,int_stack+866164,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1611436,int_stack+1454620,int_stack+1323940,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+855670,int_stack+64350,int_stack+53064,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+889528,int_stack+855670,int_stack+535900,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1211476,int_stack+889528,int_stack+675688,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+855670,int_stack+1211476,int_stack+988132,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1211476,int_stack+855670,int_stack+566194,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+855670,int_stack+1211476,int_stack+729544,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1211476,int_stack+855670,int_stack+1067332,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+535900,int_stack+1211476,int_stack+1454620,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+731920,int_stack+535900,int_stack+1611436,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+535900,int_stack+81180,int_stack+76890,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+548770,int_stack+86328,int_stack+81180,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+564214,int_stack+548770,int_stack+535900,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+589954,int_stack+92412,int_stack+86328,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+608206,int_stack+589954,int_stack+548770,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+639094,int_stack+608206,int_stack+564214,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+535900,int_stack+99510,int_stack+92412,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+681994,int_stack+535900,int_stack+589954,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+931570,int_stack+681994,int_stack+608206,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+557194,int_stack+931570,int_stack+639094,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+621544,int_stack+107700,int_stack+99510,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+983050,int_stack+621544,int_stack+535900,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1025638,int_stack+983050,int_stack+681994,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+646114,int_stack+1025638,int_stack+931570,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1086478,int_stack+646114,int_stack+557194,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+931570,int_stack+117060,int_stack+107700,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+535900,int_stack+931570,int_stack+621544,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1176568,int_stack+535900,int_stack+983050,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+1247548,int_stack+1176568,int_stack+1025638,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+959650,int_stack+1247548,int_stack+646114,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+585040,int_stack+959650,int_stack+1086478,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1067758,int_stack+127668,int_stack+117060,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1099582,int_stack+1067758,int_stack+931570,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1338808,int_stack+1099582,int_stack+535900,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1420708,int_stack+1338808,int_stack+1176568,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1527178,int_stack+1420708,int_stack+1247548,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+1155742,int_stack+1527178,int_stack+959650,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1654942,int_stack+1155742,int_stack+585040,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+535900,int_stack+139602,int_stack+127668,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+571702,int_stack+535900,int_stack+1067758,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+635350,int_stack+571702,int_stack+1099582,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+931570,int_stack+635350,int_stack+1338808,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1809382,int_stack+931570,int_stack+1420708,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1299886,int_stack+1809382,int_stack+1527178,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1958440,int_stack+1299886,int_stack+1155742,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1054420,int_stack+1958440,int_stack+1654942,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1247470,int_stack+152940,int_stack+139602,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1470238,int_stack+1247470,int_stack+535900,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1541842,int_stack+1470238,int_stack+571702,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1647922,int_stack+1541842,int_stack+635350,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1470238,int_stack+1647922,int_stack+931570,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2143768,int_stack+1470238,int_stack+1809382,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1470238,int_stack+2143768,int_stack+1299886,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1689262,int_stack+1470238,int_stack+1958440,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1920922,int_stack+1689262,int_stack+1054420,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+931570,int_stack+1920922,int_stack+731920,3025);
 /*--- compute (q0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+2156872,int_stack+172765,int_stack+167760,91);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2171887,int_stack+178771,int_stack+172765,91);
 /*--- compute (q0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2189905,int_stack+2171887,int_stack+2156872,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2219935,int_stack+185869,int_stack+178771,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2241229,int_stack+2219935,int_stack+2171887,91);
 /*--- compute (q0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+2277265,int_stack+2241229,int_stack+2189905,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2156872,int_stack+194150,int_stack+185869,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1530520,int_stack+2156872,int_stack+2219935,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1573108,int_stack+1530520,int_stack+2241229,91);
 /*--- compute (q0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2181715,int_stack+1573108,int_stack+2277265,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2256790,int_stack+203705,int_stack+194150,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2285455,int_stack+2256790,int_stack+2156872,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1633168,int_stack+2285455,int_stack+1530520,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1704148,int_stack+1633168,int_stack+1573108,91);
 /*--- compute (q0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1794238,int_stack+1704148,int_stack+2181715,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1530520,int_stack+214625,int_stack+203705,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1563280,int_stack+1530520,int_stack+2256790,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2156872,int_stack+1563280,int_stack+2285455,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+535900,int_stack+2156872,int_stack+1633168,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+642370,int_stack+535900,int_stack+1704148,91);
 /*--- compute (q0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+1620610,int_stack+642370,int_stack+1794238,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1760750,int_stack+227001,int_stack+214625,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1797878,int_stack+1760750,int_stack+1530520,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2239682,int_stack+1797878,int_stack+1563280,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+768496,int_stack+2239682,int_stack+2156872,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+0,int_stack+768496,int_stack+535900,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2335232,int_stack+0,int_stack+642370,91);
 /*--- compute (q0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+535900,int_stack+2335232,int_stack+1620610,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+716080,int_stack+240924,int_stack+227001,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2156872,int_stack+716080,int_stack+1760750,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+1530520,int_stack+2156872,int_stack+1797878,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1639720,int_stack+1530520,int_stack+2239682,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2503400,int_stack+1639720,int_stack+768496,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2677301,int_stack+2503400,int_stack+0,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+2677301,int_stack+2335232,91);
 /*--- compute (q0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+2231128,int_stack+0,int_stack+535900,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+535900,int_stack+256485,int_stack+240924,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+582583,int_stack+535900,int_stack+716080,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+666121,int_stack+582583,int_stack+2156872,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2876045,int_stack+666121,int_stack+1530520,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+535900,int_stack+2876045,int_stack+1639720,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+1530520,int_stack+535900,int_stack+2503400,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+535900,int_stack+1530520,int_stack+2677301,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+1530520,int_stack+535900,int_stack+0,91);
 /*--- compute (q0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+535900,int_stack+1530520,int_stack+2231128,91);
 /*--- compute (op|mm) ---*/
 hrr1_build_op(Libint->AB,int_stack+2156872,int_stack+535900,int_stack+1920922,3025);
 /*--- compute (nd|mm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+2864722,int_stack+2156872,int_stack+931570,3025);
 /*--- compute (r0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+0,int_stack+279550,int_stack+273775,105);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+17325,int_stack+286480,int_stack+279550,105);
 /*--- compute (r0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+38115,int_stack+17325,int_stack+0,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+72765,int_stack+294670,int_stack+286480,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+97335,int_stack+72765,int_stack+17325,105);
 /*--- compute (r0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+138915,int_stack+97335,int_stack+38115,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+0,int_stack+304225,int_stack+294670,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+196665,int_stack+0,int_stack+72765,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+811175,int_stack+196665,int_stack+97335,105);
 /*--- compute (r0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+28665,int_stack+811175,int_stack+138915,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+115290,int_stack+315250,int_stack+304225,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+245805,int_stack+115290,int_stack+0,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+880475,int_stack+245805,int_stack+196665,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+962375,int_stack+880475,int_stack+811175,105);
 /*--- compute (r0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1066325,int_stack+962375,int_stack+28665,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+811175,int_stack+327850,int_stack+315250,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+811175,int_stack+115290,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+66150,int_stack+0,int_stack+245805,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+161700,int_stack+66150,int_stack+880475,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+1187600,int_stack+161700,int_stack+962375,105);
 /*--- compute (r0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+848975,int_stack+1187600,int_stack+1066325,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1010675,int_stack+342130,int_stack+327850,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1053515,int_stack+1010675,int_stack+811175,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1333130,int_stack+1053515,int_stack+0,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1443380,int_stack+1333130,int_stack+66150,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1586705,int_stack+1443380,int_stack+161700,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+0,int_stack+1586705,int_stack+1187600,105);
 /*--- compute (r0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1758695,int_stack+0,int_stack+848975,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+194040,int_stack+358195,int_stack+342130,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+242235,int_stack+194040,int_stack+1010675,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+811175,int_stack+242235,int_stack+1053515,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+937175,int_stack+811175,int_stack+1333130,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1102550,int_stack+937175,int_stack+1443380,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1303205,int_stack+1102550,int_stack+1586705,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+4062622,int_stack+1303205,int_stack+0,105);
 /*--- compute (r0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+4312102,int_stack+4062622,int_stack+1758695,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+0,int_stack+376150,int_stack+358195,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+53865,int_stack+0,int_stack+194040,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1532525,int_stack+53865,int_stack+242235,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+0,int_stack+1532525,int_stack+811175,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1532525,int_stack+0,int_stack+937175,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1532525,int_stack+1102550,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1532525,int_stack+0,int_stack+1303205,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1532525,int_stack+4062622,105);
 /*--- compute (r0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+811175,int_stack+0,int_stack+4312102,105);
 /*--- compute (qp|mm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+1128800,int_stack+811175,int_stack+535900,3025);
 /*--- compute (od|mm) ---*/
 hrr1_build_od(Libint->AB,int_stack+4062622,int_stack+1128800,int_stack+2156872,3025);
 /*--- compute (nf|mm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+5478322,int_stack+4062622,int_stack+2864722,3025);
 /*--- compute (t0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+535900,int_stack+402700,int_stack+396100,120);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+555700,int_stack+410620,int_stack+402700,120);
 /*--- compute (t0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+579460,int_stack+555700,int_stack+535900,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+619060,int_stack+419980,int_stack+410620,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+647140,int_stack+619060,int_stack+555700,120);
 /*--- compute (t0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+694660,int_stack+647140,int_stack+579460,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+535900,int_stack+430900,int_stack+419980,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+535900,int_stack+619060,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+56160,int_stack+0,int_stack+647140,120);
 /*--- compute (t0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+568660,int_stack+56160,int_stack+694660,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+667660,int_stack+443500,int_stack+430900,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+705460,int_stack+667660,int_stack+535900,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+135360,int_stack+705460,int_stack+0,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+228960,int_stack+135360,int_stack+56160,120);
 /*--- compute (t0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+1954625,int_stack+228960,int_stack+568660,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+0,int_stack+457900,int_stack+443500,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+43200,int_stack+0,int_stack+667660,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+535900,int_stack+43200,int_stack+705460,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+645100,int_stack+535900,int_stack+135360,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2093225,int_stack+645100,int_stack+228960,120);
 /*--- compute (t0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+118800,int_stack+2093225,int_stack+1954625,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1954625,int_stack+474220,int_stack+457900,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2003585,int_stack+1954625,int_stack+0,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+303600,int_stack+2003585,int_stack+43200,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2259545,int_stack+303600,int_stack+535900,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2423345,int_stack+2259545,int_stack+645100,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+535900,int_stack+2423345,int_stack+2093225,120);
 /*--- compute (t0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+2619905,int_stack+535900,int_stack+118800,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+0,int_stack+492580,int_stack+474220,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+55080,int_stack+0,int_stack+1954625,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+153000,int_stack+55080,int_stack+2003585,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+1954625,int_stack+153000,int_stack+303600,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2857505,int_stack+1954625,int_stack+2259545,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2143625,int_stack+2857505,int_stack+2423345,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3086825,int_stack+2143625,int_stack+535900,120);
 /*--- compute (t0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+3371945,int_stack+3086825,int_stack+2619905,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+535900,int_stack+513100,int_stack+492580,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+597460,int_stack+535900,int_stack+0,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2405705,int_stack+597460,int_stack+55080,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2568905,int_stack+2405705,int_stack+153000,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+0,int_stack+2568905,int_stack+1954625,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2405705,int_stack+0,int_stack+2857505,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+2405705,int_stack+2143625,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+336960,int_stack+0,int_stack+3086825,120);
 /*--- compute (t0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+1954625,int_stack+336960,int_stack+3371945,120);
 /*--- compute (rp|mm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+2317625,int_stack+1954625,int_stack+811175,3025);
 /*--- compute (qd|mm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+7474822,int_stack+2317625,int_stack+1128800,3025);
 /*--- compute (of|mm) ---*/
 hrr1_build_of(Libint->AB,int_stack+0,int_stack+7474822,int_stack+4062622,3025);
 /*--- compute (ng|mm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+2359500,int_stack+0,int_stack+5478322,3025);
 return int_stack+2359500;}
