/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_nmnm(Libint_t*, prim_data*);

  /* Computes quartets of (nm|nm) integrals */

REALTYPE *hrr_order_nmnm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][10] = int_stack + 0;
 Libint->vrr_classes[10][11] = int_stack + 4356;
 Libint->vrr_classes[10][12] = int_stack + 9504;
 Libint->vrr_classes[10][13] = int_stack + 15510;
 Libint->vrr_classes[10][14] = int_stack + 22440;
 Libint->vrr_classes[10][15] = int_stack + 30360;
 Libint->vrr_classes[10][16] = int_stack + 39336;
 Libint->vrr_classes[10][17] = int_stack + 49434;
 Libint->vrr_classes[10][18] = int_stack + 60720;
 Libint->vrr_classes[10][19] = int_stack + 73260;
 Libint->vrr_classes[11][10] = int_stack + 87120;
 Libint->vrr_classes[11][11] = int_stack + 92268;
 Libint->vrr_classes[11][12] = int_stack + 98352;
 Libint->vrr_classes[11][13] = int_stack + 105450;
 Libint->vrr_classes[11][14] = int_stack + 113640;
 Libint->vrr_classes[11][15] = int_stack + 123000;
 Libint->vrr_classes[11][16] = int_stack + 133608;
 Libint->vrr_classes[11][17] = int_stack + 145542;
 Libint->vrr_classes[11][18] = int_stack + 158880;
 Libint->vrr_classes[11][19] = int_stack + 173700;
 Libint->vrr_classes[12][10] = int_stack + 190080;
 Libint->vrr_classes[12][11] = int_stack + 196086;
 Libint->vrr_classes[12][12] = int_stack + 203184;
 Libint->vrr_classes[12][13] = int_stack + 211465;
 Libint->vrr_classes[12][14] = int_stack + 221020;
 Libint->vrr_classes[12][15] = int_stack + 231940;
 Libint->vrr_classes[12][16] = int_stack + 244316;
 Libint->vrr_classes[12][17] = int_stack + 258239;
 Libint->vrr_classes[12][18] = int_stack + 273800;
 Libint->vrr_classes[12][19] = int_stack + 291090;
 Libint->vrr_classes[13][10] = int_stack + 310200;
 Libint->vrr_classes[13][11] = int_stack + 317130;
 Libint->vrr_classes[13][12] = int_stack + 325320;
 Libint->vrr_classes[13][13] = int_stack + 334875;
 Libint->vrr_classes[13][14] = int_stack + 345900;
 Libint->vrr_classes[13][15] = int_stack + 358500;
 Libint->vrr_classes[13][16] = int_stack + 372780;
 Libint->vrr_classes[13][17] = int_stack + 388845;
 Libint->vrr_classes[13][18] = int_stack + 406800;
 Libint->vrr_classes[13][19] = int_stack + 426750;
 Libint->vrr_classes[14][10] = int_stack + 448800;
 Libint->vrr_classes[14][11] = int_stack + 456720;
 Libint->vrr_classes[14][12] = int_stack + 466080;
 Libint->vrr_classes[14][13] = int_stack + 477000;
 Libint->vrr_classes[14][14] = int_stack + 489600;
 Libint->vrr_classes[14][15] = int_stack + 504000;
 Libint->vrr_classes[14][16] = int_stack + 520320;
 Libint->vrr_classes[14][17] = int_stack + 538680;
 Libint->vrr_classes[14][18] = int_stack + 559200;
 Libint->vrr_classes[14][19] = int_stack + 582000;
 Libint->vrr_classes[15][10] = int_stack + 607200;
 Libint->vrr_classes[15][11] = int_stack + 616176;
 Libint->vrr_classes[15][12] = int_stack + 626784;
 Libint->vrr_classes[15][13] = int_stack + 639160;
 Libint->vrr_classes[15][14] = int_stack + 653440;
 Libint->vrr_classes[15][15] = int_stack + 669760;
 Libint->vrr_classes[15][16] = int_stack + 688256;
 Libint->vrr_classes[15][17] = int_stack + 709064;
 Libint->vrr_classes[15][18] = int_stack + 732320;
 Libint->vrr_classes[15][19] = int_stack + 758160;
 Libint->vrr_classes[16][10] = int_stack + 786720;
 Libint->vrr_classes[16][11] = int_stack + 796818;
 Libint->vrr_classes[16][12] = int_stack + 808752;
 Libint->vrr_classes[16][13] = int_stack + 822675;
 Libint->vrr_classes[16][14] = int_stack + 838740;
 Libint->vrr_classes[16][15] = int_stack + 857100;
 Libint->vrr_classes[16][16] = int_stack + 877908;
 Libint->vrr_classes[16][17] = int_stack + 901317;
 Libint->vrr_classes[16][18] = int_stack + 927480;
 Libint->vrr_classes[16][19] = int_stack + 956550;
 Libint->vrr_classes[17][10] = int_stack + 988680;
 Libint->vrr_classes[17][11] = int_stack + 999966;
 Libint->vrr_classes[17][12] = int_stack + 1013304;
 Libint->vrr_classes[17][13] = int_stack + 1028865;
 Libint->vrr_classes[17][14] = int_stack + 1046820;
 Libint->vrr_classes[17][15] = int_stack + 1067340;
 Libint->vrr_classes[17][16] = int_stack + 1090596;
 Libint->vrr_classes[17][17] = int_stack + 1116759;
 Libint->vrr_classes[17][18] = int_stack + 1146000;
 Libint->vrr_classes[17][19] = int_stack + 1178490;
 Libint->vrr_classes[18][10] = int_stack + 1214400;
 Libint->vrr_classes[18][11] = int_stack + 1226940;
 Libint->vrr_classes[18][12] = int_stack + 1241760;
 Libint->vrr_classes[18][13] = int_stack + 1259050;
 Libint->vrr_classes[18][14] = int_stack + 1279000;
 Libint->vrr_classes[18][15] = int_stack + 1301800;
 Libint->vrr_classes[18][16] = int_stack + 1327640;
 Libint->vrr_classes[18][17] = int_stack + 1356710;
 Libint->vrr_classes[18][18] = int_stack + 1389200;
 Libint->vrr_classes[18][19] = int_stack + 1425300;
 Libint->vrr_classes[19][10] = int_stack + 1465200;
 Libint->vrr_classes[19][11] = int_stack + 1479060;
 Libint->vrr_classes[19][12] = int_stack + 1495440;
 Libint->vrr_classes[19][13] = int_stack + 1514550;
 Libint->vrr_classes[19][14] = int_stack + 1536600;
 Libint->vrr_classes[19][15] = int_stack + 1561800;
 Libint->vrr_classes[19][16] = int_stack + 1590360;
 Libint->vrr_classes[19][17] = int_stack + 1622490;
 Libint->vrr_classes[19][18] = int_stack + 1658400;
 Libint->vrr_classes[19][19] = int_stack + 1698300;
 memset(int_stack,0,1742400*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1742400;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_nmnm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1742400,int_stack+4356,int_stack+0,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1755468,int_stack+9504,int_stack+4356,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1770912,int_stack+1755468,int_stack+1742400,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1797048,int_stack+15510,int_stack+9504,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1815066,int_stack+1797048,int_stack+1755468,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1845954,int_stack+1815066,int_stack+1770912,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1742400,int_stack+22440,int_stack+15510,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1889514,int_stack+1742400,int_stack+1797048,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1763190,int_stack+1889514,int_stack+1815066,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1925550,int_stack+1763190,int_stack+1845954,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1814670,int_stack+30360,int_stack+22440,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1838430,int_stack+1814670,int_stack+1742400,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+1990890,int_stack+1838430,int_stack+1889514,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2050950,int_stack+1990890,int_stack+1763190,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2128170,int_stack+2050950,int_stack+1925550,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1742400,int_stack+39336,int_stack+30360,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1880010,int_stack+1742400,int_stack+1814670,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2219646,int_stack+1880010,int_stack+1838430,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1769328,int_stack+2219646,int_stack+1990890,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1927530,int_stack+1769328,int_stack+2050950,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2288946,int_stack+1927530,int_stack+2128170,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2035638,int_stack+49434,int_stack+39336,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2065932,int_stack+2035638,int_stack+1742400,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2119788,int_stack+2065932,int_stack+1880010,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2410914,int_stack+2119788,int_stack+2219646,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2514864,int_stack+2410914,int_stack+1769328,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1742400,int_stack+2514864,int_stack+1927530,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2640990,int_stack+1742400,int_stack+2288946,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1886544,int_stack+60720,int_stack+49434,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1920402,int_stack+1886544,int_stack+2035638,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2198988,int_stack+1920402,int_stack+2065932,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1980990,int_stack+2198988,int_stack+2119788,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2797806,int_stack+1980990,int_stack+2410914,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+2288748,int_stack+2797806,int_stack+2514864,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2943336,int_stack+2288748,int_stack+1742400,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3128664,int_stack+2943336,int_stack+2640990,66);
 /*--- compute (n0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1742400,int_stack+73260,int_stack+60720,66);
 /*--- compute (n0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1780020,int_stack+1742400,int_stack+1886544,66);
 /*--- compute (n0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2456916,int_stack+1780020,int_stack+1920402,66);
 /*--- compute (n0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1742400,int_stack+2456916,int_stack+2198988,66);
 /*--- compute (n0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2456916,int_stack+1742400,int_stack+1980990,66);
 /*--- compute (n0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1742400,int_stack+2456916,int_stack+2797806,66);
 /*--- compute (n0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2456916,int_stack+1742400,int_stack+2288748,66);
 /*--- compute (n0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1742400,int_stack+2456916,int_stack+2943336,66);
 /*--- compute (n0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1974060,int_stack+1742400,int_stack+3128664,66);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1742400,int_stack+92268,int_stack+87120,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1757844,int_stack+98352,int_stack+92268,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1776096,int_stack+1757844,int_stack+1742400,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1806984,int_stack+105450,int_stack+98352,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1828278,int_stack+1806984,int_stack+1757844,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1864782,int_stack+1828278,int_stack+1776096,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1742400,int_stack+113640,int_stack+105450,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1916262,int_stack+1742400,int_stack+1806984,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1766970,int_stack+1916262,int_stack+1828278,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2213640,int_stack+1766970,int_stack+1864782,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1827810,int_stack+123000,int_stack+113640,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1855890,int_stack+1827810,int_stack+1742400,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2290860,int_stack+1855890,int_stack+1916262,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2361840,int_stack+2290860,int_stack+1766970,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2453100,int_stack+2361840,int_stack+2213640,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2213640,int_stack+133608,int_stack+123000,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1742400,int_stack+2213640,int_stack+1827810,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2561208,int_stack+1742400,int_stack+1855890,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1798560,int_stack+2561208,int_stack+2290860,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2643108,int_stack+1798560,int_stack+2361840,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2245464,int_stack+2643108,int_stack+2453100,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2389608,int_stack+145542,int_stack+133608,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2425410,int_stack+2389608,int_stack+2213640,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2770872,int_stack+2425410,int_stack+1742400,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+2864472,int_stack+2770872,int_stack+2561208,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+2489058,int_stack+2864472,int_stack+1798560,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1742400,int_stack+2489058,int_stack+2643108,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+2987322,int_stack+1742400,int_stack+2245464,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+1912752,int_stack+158880,int_stack+145542,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2213640,int_stack+1912752,int_stack+2389608,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2285244,int_stack+2213640,int_stack+2425410,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3172650,int_stack+2285244,int_stack+2770872,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2638116,int_stack+3172650,int_stack+2864472,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3313050,int_stack+2638116,int_stack+2489058,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+2391324,int_stack+3313050,int_stack+1742400,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+3511794,int_stack+2391324,int_stack+2987322,78);
 /*--- compute (o0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1742400,int_stack+173700,int_stack+158880,78);
 /*--- compute (o0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1786860,int_stack+1742400,int_stack+1912752,78);
 /*--- compute (o0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2810106,int_stack+1786860,int_stack+2213640,78);
 /*--- compute (o0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1742400,int_stack+2810106,int_stack+2285244,78);
 /*--- compute (o0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2810106,int_stack+1742400,int_stack+3172650,78);
 /*--- compute (o0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+1742400,int_stack+2810106,int_stack+2638116,78);
 /*--- compute (o0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2610348,int_stack+1742400,int_stack+3313050,78);
 /*--- compute (o0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2865876,int_stack+2610348,int_stack+2391324,78);
 /*--- compute (o0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+2213640,int_stack+2865876,int_stack+3511794,78);
 /*--- compute (np|nm) ---*/
 hrr1_build_np(Libint->AB,int_stack+2496780,int_stack+2213640,int_stack+1974060,3630);
 /*--- compute (q0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1742400,int_stack+196086,int_stack+190080,91);
 /*--- compute (q0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1760418,int_stack+203184,int_stack+196086,91);
 /*--- compute (q0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1781712,int_stack+1760418,int_stack+1742400,91);
 /*--- compute (q0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1817748,int_stack+211465,int_stack+203184,91);
 /*--- compute (q0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1842591,int_stack+1817748,int_stack+1760418,91);
 /*--- compute (q0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1885179,int_stack+1842591,int_stack+1781712,91);
 /*--- compute (q0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1742400,int_stack+221020,int_stack+211465,91);
 /*--- compute (q0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+1945239,int_stack+1742400,int_stack+1817748,91);
 /*--- compute (q0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1771065,int_stack+1945239,int_stack+1842591,91);
 /*--- compute (q0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+1994925,int_stack+1771065,int_stack+1885179,91);
 /*--- compute (q0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1842045,int_stack+231940,int_stack+221020,91);
 /*--- compute (q0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1874805,int_stack+1842045,int_stack+1742400,91);
 /*--- compute (q0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2085015,int_stack+1874805,int_stack+1945239,91);
 /*--- compute (q0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3215520,int_stack+2085015,int_stack+1771065,91);
 /*--- compute (q0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3321990,int_stack+3215520,int_stack+1994925,91);
 /*--- compute (q0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1742400,int_stack+244316,int_stack+231940,91);
 /*--- compute (q0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+1932135,int_stack+1742400,int_stack+1842045,91);
 /*--- compute (q0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3448116,int_stack+1932135,int_stack+1874805,91);
 /*--- compute (q0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1779528,int_stack+3448116,int_stack+2085015,91);
 /*--- compute (q0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1997655,int_stack+1779528,int_stack+3215520,91);
 /*--- compute (q0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3543666,int_stack+1997655,int_stack+3321990,91);
 /*--- compute (q0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3215520,int_stack+258239,int_stack+244316,91);
 /*--- compute (q0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3257289,int_stack+3215520,int_stack+1742400,91);
 /*--- compute (q0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3331545,int_stack+3257289,int_stack+1932135,91);
 /*--- compute (q0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+3331545,int_stack+3448116,91);
 /*--- compute (q0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3711834,int_stack+0,int_stack+1779528,91);
 /*--- compute (q0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1742400,int_stack+3711834,int_stack+1997655,91);
 /*--- compute (q0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1941144,int_stack+1742400,int_stack+3543666,91);
 /*--- compute (q0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2157360,int_stack+273800,int_stack+258239,91);
 /*--- compute (q0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3440745,int_stack+2157360,int_stack+3215520,91);
 /*--- compute (q0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3524283,int_stack+3440745,int_stack+3257289,91);
 /*--- compute (q0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3885735,int_stack+3524283,int_stack+3331545,91);
 /*--- compute (q0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+3215520,int_stack+3885735,int_stack+0,91);
 /*--- compute (q0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+3215520,int_stack+3711834,91);
 /*--- compute (q0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4049535,int_stack+0,int_stack+1742400,91);
 /*--- compute (q0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+4305063,int_stack+4049535,int_stack+1941144,91);
 /*--- compute (q0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1742400,int_stack+291090,int_stack+273800,91);
 /*--- compute (q0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1794270,int_stack+1742400,int_stack+2157360,91);
 /*--- compute (q0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1887636,int_stack+1794270,int_stack+3440745,91);
 /*--- compute (q0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+2026866,int_stack+1887636,int_stack+3524283,91);
 /*--- compute (q0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1742400,int_stack+2026866,int_stack+3885735,91);
 /*--- compute (q0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3416175,int_stack+1742400,int_stack+3215520,91);
 /*--- compute (q0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+1742400,int_stack+3416175,int_stack+0,91);
 /*--- compute (q0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3215520,int_stack+1742400,int_stack+4049535,91);
 /*--- compute (q0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+1742400,int_stack+3215520,int_stack+4305063,91);
 /*--- compute (op|nm) ---*/
 hrr1_build_op(Libint->AB,int_stack+3215520,int_stack+1742400,int_stack+2213640,3630);
 /*--- compute (nd|nm) ---*/
 hrr1_build_nd(Libint->AB,int_stack+4064940,int_stack+3215520,int_stack+2496780,3630);
 /*--- compute (r0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2072730,int_stack+317130,int_stack+310200,105);
 /*--- compute (r0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+2093520,int_stack+325320,int_stack+317130,105);
 /*--- compute (r0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+2118090,int_stack+2093520,int_stack+2072730,105);
 /*--- compute (r0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+2159670,int_stack+334875,int_stack+325320,105);
 /*--- compute (r0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+2188335,int_stack+2159670,int_stack+2093520,105);
 /*--- compute (r0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2237475,int_stack+2188335,int_stack+2118090,105);
 /*--- compute (r0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+2072730,int_stack+345900,int_stack+334875,105);
 /*--- compute (r0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2306775,int_stack+2072730,int_stack+2159670,105);
 /*--- compute (r0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+2105805,int_stack+2306775,int_stack+2188335,105);
 /*--- compute (r0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2364105,int_stack+2105805,int_stack+2237475,105);
 /*--- compute (r0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+2187705,int_stack+358500,int_stack+345900,105);
 /*--- compute (r0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2225505,int_stack+2187705,int_stack+2072730,105);
 /*--- compute (r0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2468055,int_stack+2225505,int_stack+2306775,105);
 /*--- compute (r0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2563605,int_stack+2468055,int_stack+2105805,105);
 /*--- compute (r0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2686455,int_stack+2563605,int_stack+2364105,105);
 /*--- compute (r0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+2072730,int_stack+372780,int_stack+358500,105);
 /*--- compute (r0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2291655,int_stack+2072730,int_stack+2187705,105);
 /*--- compute (r0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+2831985,int_stack+2291655,int_stack+2225505,105);
 /*--- compute (r0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+2115570,int_stack+2831985,int_stack+2468055,105);
 /*--- compute (r0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2367255,int_stack+2115570,int_stack+2563605,105);
 /*--- compute (r0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+2942235,int_stack+2367255,int_stack+2686455,105);
 /*--- compute (r0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2539245,int_stack+388845,int_stack+372780,105);
 /*--- compute (r0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2587440,int_stack+2539245,int_stack+2072730,105);
 /*--- compute (r0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2673120,int_stack+2587440,int_stack+2291655,105);
 /*--- compute (r0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+0,int_stack+2673120,int_stack+2831985,105);
 /*--- compute (r0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+165375,int_stack+0,int_stack+2115570,105);
 /*--- compute (r0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+2072730,int_stack+165375,int_stack+2367255,105);
 /*--- compute (r0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+5502420,int_stack+2072730,int_stack+2942235,105);
 /*--- compute (r0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2302050,int_stack+406800,int_stack+388845,105);
 /*--- compute (r0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2355915,int_stack+2302050,int_stack+2539245,105);
 /*--- compute (r0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+2799120,int_stack+2355915,int_stack+2587440,105);
 /*--- compute (r0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2452305,int_stack+2799120,int_stack+2673120,105);
 /*--- compute (r0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+2941920,int_stack+2452305,int_stack+0,105);
 /*--- compute (r0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+5751900,int_stack+2941920,int_stack+165375,105);
 /*--- compute (r0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+0,int_stack+5751900,int_stack+2072730,105);
 /*--- compute (r0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6019440,int_stack+0,int_stack+5502420,105);
 /*--- compute (r0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+5502420,int_stack+426750,int_stack+406800,105);
 /*--- compute (r0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+5562270,int_stack+5502420,int_stack+2302050,105);
 /*--- compute (r0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+2072730,int_stack+5562270,int_stack+2355915,105);
 /*--- compute (r0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+5502420,int_stack+2072730,int_stack+2799120,105);
 /*--- compute (r0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+2072730,int_stack+5502420,int_stack+2452305,105);
 /*--- compute (r0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2337330,int_stack+2072730,int_stack+2941920,105);
 /*--- compute (r0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+2646030,int_stack+2337330,int_stack+5751900,105);
 /*--- compute (r0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+2072730,int_stack+2646030,int_stack+0,105);
 /*--- compute (r0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+2072730,int_stack+6019440,105);
 /*--- compute (qp|nm) ---*/
 hrr1_build_qp(Libint->AB,int_stack+2072730,int_stack+0,int_stack+1742400,3630);
 /*--- compute (od|nm) ---*/
 hrr1_build_od(Libint->AB,int_stack+5502420,int_stack+2072730,int_stack+3215520,3630);
 /*--- compute (nf|nm) ---*/
 hrr1_build_nf(Libint->AB,int_stack+7201260,int_stack+5502420,int_stack+4064940,3630);
 /*--- compute (t0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1742400,int_stack+456720,int_stack+448800,120);
 /*--- compute (t0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1766160,int_stack+466080,int_stack+456720,120);
 /*--- compute (t0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1794240,int_stack+1766160,int_stack+1742400,120);
 /*--- compute (t0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1841760,int_stack+477000,int_stack+466080,120);
 /*--- compute (t0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1874520,int_stack+1841760,int_stack+1766160,120);
 /*--- compute (t0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+1930680,int_stack+1874520,int_stack+1794240,120);
 /*--- compute (t0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1742400,int_stack+489600,int_stack+477000,120);
 /*--- compute (t0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+3063720,int_stack+1742400,int_stack+1841760,120);
 /*--- compute (t0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1780200,int_stack+3063720,int_stack+1874520,120);
 /*--- compute (t0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+3129240,int_stack+1780200,int_stack+1930680,120);
 /*--- compute (t0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1873800,int_stack+504000,int_stack+489600,120);
 /*--- compute (t0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+1917000,int_stack+1873800,int_stack+1742400,120);
 /*--- compute (t0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3248040,int_stack+1917000,int_stack+3063720,120);
 /*--- compute (t0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+3357240,int_stack+3248040,int_stack+1780200,120);
 /*--- compute (t0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+3497640,int_stack+3357240,int_stack+3129240,120);
 /*--- compute (t0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+3063720,int_stack+520320,int_stack+504000,120);
 /*--- compute (t0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+3112680,int_stack+3063720,int_stack+1873800,120);
 /*--- compute (t0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+1742400,int_stack+3112680,int_stack+1917000,120);
 /*--- compute (t0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1868400,int_stack+1742400,int_stack+3248040,120);
 /*--- compute (t0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+3663960,int_stack+1868400,int_stack+3357240,120);
 /*--- compute (t0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3199080,int_stack+3663960,int_stack+3497640,120);
 /*--- compute (t0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+3420840,int_stack+538680,int_stack+520320,120);
 /*--- compute (t0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+3475920,int_stack+3420840,int_stack+3063720,120);
 /*--- compute (t0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+3860520,int_stack+3475920,int_stack+3112680,120);
 /*--- compute (t0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+4004520,int_stack+3860520,int_stack+1742400,120);
 /*--- compute (t0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+4193520,int_stack+4004520,int_stack+1868400,120);
 /*--- compute (t0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1742400,int_stack+4193520,int_stack+3663960,120);
 /*--- compute (t0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+3573840,int_stack+1742400,int_stack+3199080,120);
 /*--- compute (t0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2004480,int_stack+559200,int_stack+538680,120);
 /*--- compute (t0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+3063720,int_stack+2004480,int_stack+3420840,120);
 /*--- compute (t0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3173880,int_stack+3063720,int_stack+3475920,120);
 /*--- compute (t0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+3337080,int_stack+3173880,int_stack+3860520,120);
 /*--- compute (t0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4422840,int_stack+3337080,int_stack+4004520,120);
 /*--- compute (t0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3858960,int_stack+4422840,int_stack+4193520,120);
 /*--- compute (t0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+4687440,int_stack+3858960,int_stack+1742400,120);
 /*--- compute (t0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+5024400,int_stack+4687440,int_stack+3573840,120);
 /*--- compute (t0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+1742400,int_stack+582000,int_stack+559200,120);
 /*--- compute (t0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+1810800,int_stack+1742400,int_stack+2004480,120);
 /*--- compute (t0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+3553080,int_stack+1810800,int_stack+3063720,120);
 /*--- compute (t0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+1742400,int_stack+3553080,int_stack+3173880,120);
 /*--- compute (t0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+3553080,int_stack+1742400,int_stack+3337080,120);
 /*--- compute (t0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+3063720,int_stack+3553080,int_stack+4422840,120);
 /*--- compute (t0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+3416520,int_stack+3063720,int_stack+3858960,120);
 /*--- compute (t0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+3809640,int_stack+3416520,int_stack+4687440,120);
 /*--- compute (t0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+3063720,int_stack+3809640,int_stack+5024400,120);
 /*--- compute (rp|nm) ---*/
 hrr1_build_rp(Libint->AB,int_stack+3499320,int_stack+3063720,int_stack+0,3630);
 /*--- compute (qd|nm) ---*/
 hrr1_build_qd(Libint->AB,int_stack+9597060,int_stack+3499320,int_stack+2072730,3630);
 /*--- compute (of|nm) ---*/
 hrr1_build_of(Libint->AB,int_stack+11579040,int_stack+9597060,int_stack+5502420,3630);
 /*--- compute (ng|nm) ---*/
 hrr1_build_ng(Libint->AB,int_stack+14410440,int_stack+11579040,int_stack+7201260,3630);
 /*--- compute (u0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+616176,int_stack+607200,136);
 /*--- compute (u0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+26928,int_stack+626784,int_stack+616176,136);
 /*--- compute (u0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+58752,int_stack+26928,int_stack+0,136);
 /*--- compute (u0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+112608,int_stack+639160,int_stack+626784,136);
 /*--- compute (u0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+149736,int_stack+112608,int_stack+26928,136);
 /*--- compute (u0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+213384,int_stack+149736,int_stack+58752,136);
 /*--- compute (u0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+653440,int_stack+639160,136);
 /*--- compute (u0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+303144,int_stack+0,int_stack+112608,136);
 /*--- compute (u0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+42840,int_stack+303144,int_stack+149736,136);
 /*--- compute (u0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+377400,int_stack+42840,int_stack+213384,136);
 /*--- compute (u0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+148920,int_stack+669760,int_stack+653440,136);
 /*--- compute (u0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+197880,int_stack+148920,int_stack+0,136);
 /*--- compute (u0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+512040,int_stack+197880,int_stack+303144,136);
 /*--- compute (u0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+4642770,int_stack+512040,int_stack+42840,136);
 /*--- compute (u0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+4801890,int_stack+4642770,int_stack+377400,136);
 /*--- compute (u0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+688256,int_stack+669760,136);
 /*--- compute (u0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+283560,int_stack+0,int_stack+148920,136);
 /*--- compute (u0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+4990386,int_stack+283560,int_stack+197880,136);
 /*--- compute (u0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+55488,int_stack+4990386,int_stack+512040,136);
 /*--- compute (u0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+381480,int_stack+55488,int_stack+4642770,136);
 /*--- compute (u0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+5133186,int_stack+381480,int_stack+4801890,136);
 /*--- compute (u0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+4642770,int_stack+709064,int_stack+688256,136);
 /*--- compute (u0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+4705194,int_stack+4642770,int_stack+0,136);
 /*--- compute (u0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+4816170,int_stack+4705194,int_stack+283560,136);
 /*--- compute (u0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+5384514,int_stack+4816170,int_stack+4990386,136);
 /*--- compute (u0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+5598714,int_stack+5384514,int_stack+55488,136);
 /*--- compute (u0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+5598714,int_stack+381480,136);
 /*--- compute (u0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+297024,int_stack+0,int_stack+5133186,136);
 /*--- compute (u0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+620160,int_stack+732320,int_stack+709064,136);
 /*--- compute (u0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+4979370,int_stack+620160,int_stack+4642770,136);
 /*--- compute (u0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+5104218,int_stack+4979370,int_stack+4705194,136);
 /*--- compute (u0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+5858610,int_stack+5104218,int_stack+4816170,136);
 /*--- compute (u0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+4642770,int_stack+5858610,int_stack+5384514,136);
 /*--- compute (u0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+6103410,int_stack+4642770,int_stack+5598714,136);
 /*--- compute (u0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+5289178,int_stack+6103410,int_stack+0,136);
 /*--- compute (u0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+6449938,int_stack+5289178,int_stack+297024,136);
 /*--- compute (u0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+758160,int_stack+732320,136);
 /*--- compute (u0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+77520,int_stack+0,int_stack+620160,136);
 /*--- compute (u0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+217056,int_stack+77520,int_stack+4979370,136);
 /*--- compute (u0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+425136,int_stack+217056,int_stack+5104218,136);
 /*--- compute (u0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+425136,int_stack+5858610,136);
 /*--- compute (u0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+342720,int_stack+0,int_stack+4642770,136);
 /*--- compute (u0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+4642770,int_stack+342720,int_stack+6103410,136);
 /*--- compute (u0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+4642770,int_stack+5289178,136);
 /*--- compute (u0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+4642770,int_stack+0,int_stack+6449938,136);
 /*--- compute (tp|nm) ---*/
 hrr1_build_tp(Libint->AB,int_stack+5136450,int_stack+4642770,int_stack+3063720,3630);
 /*--- compute (rd|nm) ---*/
 hrr1_build_rd(Libint->AB,int_stack+6443250,int_stack+5136450,int_stack+3499320,3630);
 /*--- compute (qf|nm) ---*/
 hrr1_build_qf(Libint->AB,int_stack+18004140,int_stack+6443250,int_stack+9597060,3630);
 /*--- compute (og|nm) ---*/
 hrr1_build_og(Libint->AB,int_stack+21307440,int_stack+18004140,int_stack+11579040,3630);
 /*--- compute (nh|nm) ---*/
 hrr1_build_nh(Libint->AB,int_stack+8730150,int_stack+21307440,int_stack+14410440,3630);
 /*--- compute (v0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+796818,int_stack+786720,153);
 /*--- compute (v0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+30294,int_stack+808752,int_stack+796818,153);
 /*--- compute (v0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+66096,int_stack+30294,int_stack+0,153);
 /*--- compute (v0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+126684,int_stack+822675,int_stack+808752,153);
 /*--- compute (v0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+168453,int_stack+126684,int_stack+30294,153);
 /*--- compute (v0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+240057,int_stack+168453,int_stack+66096,153);
 /*--- compute (v0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+838740,int_stack+822675,153);
 /*--- compute (v0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+341037,int_stack+0,int_stack+126684,153);
 /*--- compute (v0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48195,int_stack+341037,int_stack+168453,153);
 /*--- compute (v0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+424575,int_stack+48195,int_stack+240057,153);
 /*--- compute (v0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167535,int_stack+857100,int_stack+838740,153);
 /*--- compute (v0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+222615,int_stack+167535,int_stack+0,153);
 /*--- compute (v0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+576045,int_stack+222615,int_stack+341037,153);
 /*--- compute (v0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+13761330,int_stack+576045,int_stack+48195,153);
 /*--- compute (v0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+13940340,int_stack+13761330,int_stack+424575,153);
 /*--- compute (v0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+877908,int_stack+857100,153);
 /*--- compute (v0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+319005,int_stack+0,int_stack+167535,153);
 /*--- compute (v0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+715275,int_stack+319005,int_stack+222615,153);
 /*--- compute (v0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+62424,int_stack+715275,int_stack+576045,153);
 /*--- compute (v0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+429165,int_stack+62424,int_stack+13761330,153);
 /*--- compute (v0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+14152398,int_stack+429165,int_stack+13940340,153);
 /*--- compute (v0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+13761330,int_stack+901317,int_stack+877908,153);
 /*--- compute (v0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+13831557,int_stack+13761330,int_stack+0,153);
 /*--- compute (v0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+13956405,int_stack+13831557,int_stack+319005,153);
 /*--- compute (v0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+14435142,int_stack+13956405,int_stack+715275,153);
 /*--- compute (v0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+14676117,int_stack+14435142,int_stack+62424,153);
 /*--- compute (v0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+14676117,int_stack+429165,153);
 /*--- compute (v0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+334152,int_stack+0,int_stack+14152398,153);
 /*--- compute (v0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+697680,int_stack+927480,int_stack+901317,153);
 /*--- compute (v0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+776169,int_stack+697680,int_stack+13761330,153);
 /*--- compute (v0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+14140005,int_stack+776169,int_stack+13831557,153);
 /*--- compute (v0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+14968500,int_stack+14140005,int_stack+13956405,153);
 /*--- compute (v0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+13761330,int_stack+14968500,int_stack+14435142,153);
 /*--- compute (v0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+15243900,int_stack+13761330,int_stack+14676117,153);
 /*--- compute (v0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+14348085,int_stack+15243900,int_stack+0,153);
 /*--- compute (v0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+15633744,int_stack+14348085,int_stack+334152,153);
 /*--- compute (v0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+956550,int_stack+927480,153);
 /*--- compute (v0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+87210,int_stack+0,int_stack+697680,153);
 /*--- compute (v0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+244188,int_stack+87210,int_stack+776169,153);
 /*--- compute (v0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+478278,int_stack+244188,int_stack+14140005,153);
 /*--- compute (v0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+0,int_stack+478278,int_stack+14968500,153);
 /*--- compute (v0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+385560,int_stack+0,int_stack+13761330,153);
 /*--- compute (v0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+13761330,int_stack+385560,int_stack+15243900,153);
 /*--- compute (v0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+13761330,int_stack+14348085,153);
 /*--- compute (v0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+13761330,int_stack+0,int_stack+15633744,153);
 /*--- compute (up|nm) ---*/
 hrr1_build_up(Libint->AB,int_stack+14316720,int_stack+13761330,int_stack+4642770,3630);
 /*--- compute (td|nm) ---*/
 hrr1_build_td(Libint->AB,int_stack+1742400,int_stack+14316720,int_stack+5136450,3630);
 /*--- compute (rf|nm) ---*/
 hrr1_build_rf(Libint->AB,int_stack+25554540,int_stack+1742400,int_stack+6443250,3630);
 /*--- compute (qg|nm) ---*/
 hrr1_build_qg(Libint->AB,int_stack+29366040,int_stack+25554540,int_stack+18004140,3630);
 /*--- compute (oh|nm) ---*/
 hrr1_build_oh(Libint->AB,int_stack+34320990,int_stack+29366040,int_stack+21307440,3630);
 /*--- compute (ni|nm) ---*/
 hrr1_build_ni(Libint->AB,int_stack+15797760,int_stack+34320990,int_stack+8730150,3630);
 /*--- compute (w0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+0,int_stack+999966,int_stack+988680,171);
 /*--- compute (w0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+33858,int_stack+1013304,int_stack+999966,171);
 /*--- compute (w0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+73872,int_stack+33858,int_stack+0,171);
 /*--- compute (w0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+141588,int_stack+1028865,int_stack+1013304,171);
 /*--- compute (w0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+188271,int_stack+141588,int_stack+33858,171);
 /*--- compute (w0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+268299,int_stack+188271,int_stack+73872,171);
 /*--- compute (w0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+0,int_stack+1046820,int_stack+1028865,171);
 /*--- compute (w0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+381159,int_stack+0,int_stack+141588,171);
 /*--- compute (w0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+53865,int_stack+381159,int_stack+188271,171);
 /*--- compute (w0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+474525,int_stack+53865,int_stack+268299,171);
 /*--- compute (w0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+187245,int_stack+1067340,int_stack+1046820,171);
 /*--- compute (w0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+248805,int_stack+187245,int_stack+0,171);
 /*--- compute (w0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+643815,int_stack+248805,int_stack+381159,171);
 /*--- compute (w0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+799425,int_stack+643815,int_stack+53865,171);
 /*--- compute (w0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+22506000,int_stack+799425,int_stack+474525,171);
 /*--- compute (w0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+0,int_stack+1090596,int_stack+1067340,171);
 /*--- compute (w0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+356535,int_stack+0,int_stack+187245,171);
 /*--- compute (w0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+22743006,int_stack+356535,int_stack+248805,171);
 /*--- compute (w0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+69768,int_stack+22743006,int_stack+643815,171);
 /*--- compute (w0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+479655,int_stack+69768,int_stack+799425,171);
 /*--- compute (w0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+759753,int_stack+479655,int_stack+22506000,171);
 /*--- compute (w0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+22506000,int_stack+1116759,int_stack+1090596,171);
 /*--- compute (w0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+22584489,int_stack+22506000,int_stack+0,171);
 /*--- compute (w0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+22922556,int_stack+22584489,int_stack+356535,171);
 /*--- compute (w0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+23127756,int_stack+22922556,int_stack+22743006,171);
 /*--- compute (w0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+23397081,int_stack+23127756,int_stack+69768,171);
 /*--- compute (w0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+0,int_stack+23397081,int_stack+479655,171);
 /*--- compute (w0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+23723862,int_stack+0,int_stack+759753,171);
 /*--- compute (w0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+373464,int_stack+1146000,int_stack+1116759,171);
 /*--- compute (w0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+461187,int_stack+373464,int_stack+22506000,171);
 /*--- compute (w0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+618165,int_stack+461187,int_stack+22584489,171);
 /*--- compute (w0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+22506000,int_stack+618165,int_stack+22922556,171);
 /*--- compute (w0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+24130158,int_stack+22506000,int_stack+23127756,171);
 /*--- compute (w0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+22813800,int_stack+24130158,int_stack+23397081,171);
 /*--- compute (w0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+24507213,int_stack+22813800,int_stack+0,171);
 /*--- compute (w0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+24987381,int_stack+24507213,int_stack+23723862,171);
 /*--- compute (w0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1178490,int_stack+1146000,171);
 /*--- compute (w0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+97470,int_stack+0,int_stack+373464,171);
 /*--- compute (w0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+23249508,int_stack+97470,int_stack+461187,171);
 /*--- compute (w0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+23249508,int_stack+618165,171);
 /*--- compute (w0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+23249508,int_stack+0,int_stack+22506000,171);
 /*--- compute (w0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+0,int_stack+23249508,int_stack+24130158,171);
 /*--- compute (w0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+23249508,int_stack+0,int_stack+22813800,171);
 /*--- compute (w0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+0,int_stack+23249508,int_stack+24507213,171);
 /*--- compute (w0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+22506000,int_stack+0,int_stack+24987381,171);
 /*--- compute (vp|nm) ---*/
 hrr1_build_vp(Libint->AB,int_stack+23126730,int_stack+22506000,int_stack+13761330,3630);
 /*--- compute (ud|nm) ---*/
 hrr1_build_ud(Libint->AB,int_stack+4356000,int_stack+23126730,int_stack+14316720,3630);
 /*--- compute (tf|nm) ---*/
 hrr1_build_tf(Libint->AB,int_stack+7318080,int_stack+4356000,int_stack+1742400,3630);
 /*--- compute (rg|nm) ---*/
 hrr1_build_rg(Libint->AB,int_stack+40266930,int_stack+7318080,int_stack+25554540,3630);
 /*--- compute (qh|nm) ---*/
 hrr1_build_qh(Libint->AB,int_stack+45984180,int_stack+40266930,int_stack+29366040,3630);
 /*--- compute (oi|nm) ---*/
 hrr1_build_oi(Libint->AB,int_stack+24792900,int_stack+45984180,int_stack+34320990,3630);
 /*--- compute (nk|nm) ---*/
 hrr1_build_nk(Libint->AB,int_stack+52921110,int_stack+24792900,int_stack+15797760,3630);
 /*--- compute (x0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1742400,int_stack+1226940,int_stack+1214400,190);
 /*--- compute (x0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+1780020,int_stack+1241760,int_stack+1226940,190);
 /*--- compute (x0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+1824480,int_stack+1780020,int_stack+1742400,190);
 /*--- compute (x0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1899720,int_stack+1259050,int_stack+1241760,190);
 /*--- compute (x0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+1951590,int_stack+1899720,int_stack+1780020,190);
 /*--- compute (x0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+2040510,int_stack+1951590,int_stack+1824480,190);
 /*--- compute (x0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+1742400,int_stack+1279000,int_stack+1259050,190);
 /*--- compute (x0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+2165910,int_stack+1742400,int_stack+1899720,190);
 /*--- compute (x0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+1802250,int_stack+2165910,int_stack+1951590,190);
 /*--- compute (x0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+2269650,int_stack+1802250,int_stack+2040510,190);
 /*--- compute (x0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1950450,int_stack+1301800,int_stack+1279000,190);
 /*--- compute (x0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+2018850,int_stack+1950450,int_stack+1742400,190);
 /*--- compute (x0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+2457750,int_stack+2018850,int_stack+2165910,190);
 /*--- compute (x0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+2630650,int_stack+2457750,int_stack+1802250,190);
 /*--- compute (x0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+2852950,int_stack+2630650,int_stack+2269650,190);
 /*--- compute (x0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+1742400,int_stack+1327640,int_stack+1301800,190);
 /*--- compute (x0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+2138550,int_stack+1742400,int_stack+1950450,190);
 /*--- compute (x0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+3116290,int_stack+2138550,int_stack+2018850,190);
 /*--- compute (x0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1819920,int_stack+3116290,int_stack+2457750,190);
 /*--- compute (x0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+2275350,int_stack+1819920,int_stack+2630650,190);
 /*--- compute (x0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+3315790,int_stack+2275350,int_stack+2852950,190);
 /*--- compute (x0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+2586570,int_stack+1356710,int_stack+1327640,190);
 /*--- compute (x0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+2673780,int_stack+2586570,int_stack+1742400,190);
 /*--- compute (x0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+2828820,int_stack+2673780,int_stack+2138550,190);
 /*--- compute (x0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+3666910,int_stack+2828820,int_stack+3116290,190);
 /*--- compute (x0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+3966160,int_stack+3666910,int_stack+1819920,190);
 /*--- compute (x0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+1742400,int_stack+3966160,int_stack+2275350,190);
 /*--- compute (x0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+0,int_stack+1742400,int_stack+3315790,190);
 /*--- compute (x0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+2157360,int_stack+1389200,int_stack+1356710,190);
 /*--- compute (x0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+2254830,int_stack+2157360,int_stack+2586570,190);
 /*--- compute (x0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+3056820,int_stack+2254830,int_stack+2673780,190);
 /*--- compute (x0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+2429250,int_stack+3056820,int_stack+2828820,190);
 /*--- compute (x0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+451440,int_stack+2429250,int_stack+3666910,190);
 /*--- compute (x0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+3315220,int_stack+451440,int_stack+3966160,190);
 /*--- compute (x0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+3799340,int_stack+3315220,int_stack+1742400,190);
 /*--- compute (x0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+32720820,int_stack+3799340,int_stack+0,190);
 /*--- compute (x0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+0,int_stack+1425300,int_stack+1389200,190);
 /*--- compute (x0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+108300,int_stack+0,int_stack+2157360,190);
 /*--- compute (x0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+1742400,int_stack+108300,int_stack+2254830,190);
 /*--- compute (x0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+0,int_stack+1742400,int_stack+3056820,190);
 /*--- compute (x0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+1742400,int_stack+0,int_stack+2429250,190);
 /*--- compute (x0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+2221200,int_stack+1742400,int_stack+451440,190);
 /*--- compute (x0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+0,int_stack+2221200,int_stack+3315220,190);
 /*--- compute (x0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+1742400,int_stack+0,int_stack+3799340,190);
 /*--- compute (x0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+0,int_stack+1742400,int_stack+32720820,190);
 /*--- compute (wp|nm) ---*/
 hrr1_build_wp(Libint->AB,int_stack+32720820,int_stack+0,int_stack+22506000,3630);
 /*--- compute (vd|nm) ---*/
 hrr1_build_vd(Libint->AB,int_stack+34583010,int_stack+32720820,int_stack+23126730,3630);
 /*--- compute (uf|nm) ---*/
 hrr1_build_uf(Libint->AB,int_stack+11674080,int_stack+34583010,int_stack+4356000,3630);
 /*--- compute (tg|nm) ---*/
 hrr1_build_tg(Libint->AB,int_stack+16610880,int_stack+11674080,int_stack+7318080,3630);
 /*--- compute (rh|nm) ---*/
 hrr1_build_rh(Libint->AB,int_stack+1742400,int_stack+16610880,int_stack+40266930,3630);
 /*--- compute (qi|nm) ---*/
 hrr1_build_qi(Libint->AB,int_stack+61545990,int_stack+1742400,int_stack+45984180,3630);
 /*--- compute (ok|nm) ---*/
 hrr1_build_ok(Libint->AB,int_stack+37915350,int_stack+61545990,int_stack+24792900,3630);
 /*--- compute (nl|nm) ---*/
 hrr1_build_nl(Libint->AB,int_stack+70795230,int_stack+37915350,int_stack+52921110,3630);
 /*--- compute (y0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+48108390,int_stack+1479060,int_stack+1465200,210);
 /*--- compute (y0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+48149970,int_stack+1495440,int_stack+1479060,210);
 /*--- compute (y0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+48199110,int_stack+48149970,int_stack+48108390,210);
 /*--- compute (y0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+48282270,int_stack+1514550,int_stack+1495440,210);
 /*--- compute (y0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+48339600,int_stack+48282270,int_stack+48149970,210);
 /*--- compute (y0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+48437880,int_stack+48339600,int_stack+48199110,210);
 /*--- compute (y0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+48108390,int_stack+1536600,int_stack+1514550,210);
 /*--- compute (y0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+48576480,int_stack+48108390,int_stack+48282270,210);
 /*--- compute (y0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+48174540,int_stack+48576480,int_stack+48339600,210);
 /*--- compute (y0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+48691140,int_stack+48174540,int_stack+48437880,210);
 /*--- compute (y0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+48338340,int_stack+1561800,int_stack+1536600,210);
 /*--- compute (y0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+48413940,int_stack+48338340,int_stack+48108390,210);
 /*--- compute (y0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+48899040,int_stack+48413940,int_stack+48576480,210);
 /*--- compute (y0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+49090140,int_stack+48899040,int_stack+48174540,210);
 /*--- compute (y0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+49335840,int_stack+49090140,int_stack+48691140,210);
 /*--- compute (y0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+48108390,int_stack+1590360,int_stack+1561800,210);
 /*--- compute (y0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+48546240,int_stack+48108390,int_stack+48338340,210);
 /*--- compute (y0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+49626900,int_stack+48546240,int_stack+48413940,210);
 /*--- compute (y0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+48194070,int_stack+49626900,int_stack+48899040,210);
 /*--- compute (y0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+48697440,int_stack+48194070,int_stack+49090140,210);
 /*--- compute (y0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+49847400,int_stack+48697440,int_stack+49335840,210);
 /*--- compute (y0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+49041420,int_stack+1622490,int_stack+1590360,210);
 /*--- compute (y0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+49137810,int_stack+49041420,int_stack+48108390,210);
 /*--- compute (y0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+49309170,int_stack+49137810,int_stack+48546240,210);
 /*--- compute (y0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+50235480,int_stack+49309170,int_stack+49626900,210);
 /*--- compute (y0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+50566230,int_stack+50235480,int_stack+48194070,210);
 /*--- compute (y0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+48108390,int_stack+50566230,int_stack+48697440,210);
 /*--- compute (y0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+50967540,int_stack+48108390,int_stack+49847400,210);
 /*--- compute (y0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+48567030,int_stack+1658400,int_stack+1622490,210);
 /*--- compute (y0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+48674760,int_stack+48567030,int_stack+49041420,210);
 /*--- compute (y0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+49561170,int_stack+48674760,int_stack+49137810,210);
 /*--- compute (y0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+48867540,int_stack+49561170,int_stack+49309170,210);
 /*--- compute (y0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+51466500,int_stack+48867540,int_stack+50235480,210);
 /*--- compute (y0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+49846770,int_stack+51466500,int_stack+50566230,210);
 /*--- compute (y0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+51929550,int_stack+49846770,int_stack+48108390,210);
 /*--- compute (y0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+52519230,int_stack+51929550,int_stack+50967540,210);
 /*--- compute (y0|xp) ---*/
 hrr3_build_xp(Libint->CD,int_stack+48108390,int_stack+1698300,int_stack+1658400,210);
 /*--- compute (y0|wd) ---*/
 hrr3_build_wd(Libint->CD,int_stack+48228090,int_stack+48108390,int_stack+48567030,210);
 /*--- compute (y0|vf) ---*/
 hrr3_build_vf(Libint->CD,int_stack+50381850,int_stack+48228090,int_stack+48674760,210);
 /*--- compute (y0|ug) ---*/
 hrr3_build_ug(Libint->CD,int_stack+48108390,int_stack+50381850,int_stack+49561170,210);
 /*--- compute (y0|th) ---*/
 hrr3_build_th(Libint->CD,int_stack+50381850,int_stack+48108390,int_stack+48867540,210);
 /*--- compute (y0|ri) ---*/
 hrr3_build_ri(Libint->CD,int_stack+48108390,int_stack+50381850,int_stack+51466500,210);
 /*--- compute (y0|qk) ---*/
 hrr3_build_qk(Libint->CD,int_stack+50381850,int_stack+48108390,int_stack+49846770,210);
 /*--- compute (y0|ol) ---*/
 hrr3_build_ol(Libint->CD,int_stack+48108390,int_stack+50381850,int_stack+51929550,210);
 /*--- compute (y0|nm) ---*/
 hrr3_build_nm(Libint->CD,int_stack+48845490,int_stack+48108390,int_stack+52519230,210);
 /*--- compute (xp|nm) ---*/
 hrr1_build_xp(Libint->AB,int_stack+49607790,int_stack+48845490,int_stack+0,3630);
 /*--- compute (wd|nm) ---*/
 hrr1_build_wd(Libint->AB,int_stack+51676890,int_stack+49607790,int_stack+32720820,3630);
 /*--- compute (vf|nm) ---*/
 hrr1_build_vf(Libint->AB,int_stack+55401270,int_stack+51676890,int_stack+34583010,3630);
 /*--- compute (ug|nm) ---*/
 hrr1_build_ug(Libint->AB,int_stack+23144880,int_stack+55401270,int_stack+11674080,3630);
 /*--- compute (th|nm) ---*/
 hrr1_build_th(Libint->AB,int_stack+48108390,int_stack+23144880,int_stack+16610880,3630);
 /*--- compute (ri|nm) ---*/
 hrr1_build_ri(Libint->AB,int_stack+9746550,int_stack+48108390,int_stack+1742400,3630);
 /*--- compute (qk|nm) ---*/
 hrr1_build_qk(Libint->AB,int_stack+48108390,int_stack+9746550,int_stack+61545990,3630);
 /*--- compute (ol|nm) ---*/
 hrr1_build_ol(Libint->AB,int_stack+0,int_stack+48108390,int_stack+37915350,3630);
 /*--- compute (nm|nm) ---*/
 hrr1_build_nm(Libint->AB,int_stack+12741300,int_stack+0,int_stack+70795230,3630);
 return int_stack+12741300;}
