/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_npmm(Libint_t*, prim_data*);

  /* Computes quartets of (np|mm) integrals */

REALTYPE *hrr_order_npmm(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[10][9] = int_stack + 0;
 Libint->vrr_classes[10][10] = int_stack + 3630;
 Libint->vrr_classes[10][11] = int_stack + 7986;
 Libint->vrr_classes[10][12] = int_stack + 13134;
 Libint->vrr_classes[10][13] = int_stack + 19140;
 Libint->vrr_classes[10][14] = int_stack + 26070;
 Libint->vrr_classes[10][15] = int_stack + 33990;
 Libint->vrr_classes[10][16] = int_stack + 42966;
 Libint->vrr_classes[10][17] = int_stack + 53064;
 Libint->vrr_classes[10][18] = int_stack + 64350;
 Libint->vrr_classes[11][9] = int_stack + 76890;
 Libint->vrr_classes[11][10] = int_stack + 81180;
 Libint->vrr_classes[11][11] = int_stack + 86328;
 Libint->vrr_classes[11][12] = int_stack + 92412;
 Libint->vrr_classes[11][13] = int_stack + 99510;
 Libint->vrr_classes[11][14] = int_stack + 107700;
 Libint->vrr_classes[11][15] = int_stack + 117060;
 Libint->vrr_classes[11][16] = int_stack + 127668;
 Libint->vrr_classes[11][17] = int_stack + 139602;
 Libint->vrr_classes[11][18] = int_stack + 152940;
 memset(int_stack,0,167760*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 167760;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_npmm(Libint, Data);
   Data++;
 }
 /*--- compute (n0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+167760,int_stack+3630,int_stack+0,66);
 /*--- compute (n0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+178650,int_stack+7986,int_stack+3630,66);
 /*--- compute (n0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+191718,int_stack+178650,int_stack+167760,66);
 /*--- compute (n0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+213498,int_stack+13134,int_stack+7986,66);
 /*--- compute (n0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+228942,int_stack+213498,int_stack+178650,66);
 /*--- compute (n0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+255078,int_stack+228942,int_stack+191718,66);
 /*--- compute (n0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+167760,int_stack+19140,int_stack+13134,66);
 /*--- compute (n0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+291378,int_stack+167760,int_stack+213498,66);
 /*--- compute (n0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+322266,int_stack+291378,int_stack+228942,66);
 /*--- compute (n0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+185778,int_stack+322266,int_stack+255078,66);
 /*--- compute (n0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+240228,int_stack+26070,int_stack+19140,66);
 /*--- compute (n0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+365826,int_stack+240228,int_stack+167760,66);
 /*--- compute (n0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+401862,int_stack+365826,int_stack+291378,66);
 /*--- compute (n0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+453342,int_stack+401862,int_stack+322266,66);
 /*--- compute (n0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+261018,int_stack+453342,int_stack+185778,66);
 /*--- compute (n0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+167760,int_stack+33990,int_stack+26070,66);
 /*--- compute (n0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+191520,int_stack+167760,int_stack+240228,66);
 /*--- compute (n0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+518682,int_stack+191520,int_stack+365826,66);
 /*--- compute (n0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+578742,int_stack+518682,int_stack+401862,66);
 /*--- compute (n0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+337248,int_stack+578742,int_stack+453342,66);
 /*--- compute (n0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+655962,int_stack+337248,int_stack+261018,66);
 /*--- compute (n0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+233100,int_stack+42966,int_stack+33990,66);
 /*--- compute (n0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+260028,int_stack+233100,int_stack+167760,66);
 /*--- compute (n0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+428724,int_stack+260028,int_stack+191520,66);
 /*--- compute (n0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+757602,int_stack+428724,int_stack+518682,66);
 /*--- compute (n0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+847692,int_stack+757602,int_stack+578742,66);
 /*--- compute (n0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+498024,int_stack+847692,int_stack+337248,66);
 /*--- compute (n0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+955800,int_stack+498024,int_stack+655962,66);
 /*--- compute (n0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+167760,int_stack+53064,int_stack+42966,66);
 /*--- compute (n0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+307548,int_stack+167760,int_stack+233100,66);
 /*--- compute (n0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+619992,int_stack+307548,int_stack+260028,66);
 /*--- compute (n0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+198054,int_stack+619992,int_stack+428724,66);
 /*--- compute (n0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+361404,int_stack+198054,int_stack+757602,66);
 /*--- compute (n0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+699192,int_stack+361404,int_stack+847692,66);
 /*--- compute (n0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1086480,int_stack+699192,int_stack+498024,66);
 /*--- compute (n0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+1243296,int_stack+1086480,int_stack+955800,66);
 /*--- compute (n0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+487530,int_stack+64350,int_stack+53064,66);
 /*--- compute (n0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+521388,int_stack+487530,int_stack+167760,66);
 /*--- compute (n0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+843336,int_stack+521388,int_stack+307548,66);
 /*--- compute (n0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+487530,int_stack+843336,int_stack+619992,66);
 /*--- compute (n0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+843336,int_stack+487530,int_stack+198054,66);
 /*--- compute (n0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+487530,int_stack+843336,int_stack+361404,66);
 /*--- compute (n0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+843336,int_stack+487530,int_stack+699192,66);
 /*--- compute (n0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+167760,int_stack+843336,int_stack+1086480,66);
 /*--- compute (n0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+363780,int_stack+167760,int_stack+1243296,66);
 /*--- compute (o0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+167760,int_stack+81180,int_stack+76890,78);
 /*--- compute (o0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+180630,int_stack+86328,int_stack+81180,78);
 /*--- compute (o0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+196074,int_stack+180630,int_stack+167760,78);
 /*--- compute (o0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+221814,int_stack+92412,int_stack+86328,78);
 /*--- compute (o0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+240066,int_stack+221814,int_stack+180630,78);
 /*--- compute (o0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+270954,int_stack+240066,int_stack+196074,78);
 /*--- compute (o0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+167760,int_stack+99510,int_stack+92412,78);
 /*--- compute (o0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+313854,int_stack+167760,int_stack+221814,78);
 /*--- compute (o0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+563430,int_stack+313854,int_stack+240066,78);
 /*--- compute (o0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+189054,int_stack+563430,int_stack+270954,78);
 /*--- compute (o0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+253404,int_stack+107700,int_stack+99510,78);
 /*--- compute (o0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+614910,int_stack+253404,int_stack+167760,78);
 /*--- compute (o0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+657498,int_stack+614910,int_stack+313854,78);
 /*--- compute (o0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+277974,int_stack+657498,int_stack+563430,78);
 /*--- compute (o0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+718338,int_stack+277974,int_stack+189054,78);
 /*--- compute (o0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+563430,int_stack+117060,int_stack+107700,78);
 /*--- compute (o0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+167760,int_stack+563430,int_stack+253404,78);
 /*--- compute (o0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+808428,int_stack+167760,int_stack+614910,78);
 /*--- compute (o0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+879408,int_stack+808428,int_stack+657498,78);
 /*--- compute (o0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+591510,int_stack+879408,int_stack+277974,78);
 /*--- compute (o0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+216900,int_stack+591510,int_stack+718338,78);
 /*--- compute (o0|up) ---*/
 hrr3_build_up(Libint->CD,int_stack+699618,int_stack+127668,int_stack+117060,78);
 /*--- compute (o0|td) ---*/
 hrr3_build_td(Libint->CD,int_stack+731442,int_stack+699618,int_stack+563430,78);
 /*--- compute (o0|rf) ---*/
 hrr3_build_rf(Libint->CD,int_stack+970668,int_stack+731442,int_stack+167760,78);
 /*--- compute (o0|qg) ---*/
 hrr3_build_qg(Libint->CD,int_stack+1052568,int_stack+970668,int_stack+808428,78);
 /*--- compute (o0|oh) ---*/
 hrr3_build_oh(Libint->CD,int_stack+1159038,int_stack+1052568,int_stack+879408,78);
 /*--- compute (o0|ni) ---*/
 hrr3_build_ni(Libint->CD,int_stack+787602,int_stack+1159038,int_stack+591510,78);
 /*--- compute (o0|mk) ---*/
 hrr3_build_mk(Libint->CD,int_stack+1286802,int_stack+787602,int_stack+216900,78);
 /*--- compute (o0|vp) ---*/
 hrr3_build_vp(Libint->CD,int_stack+167760,int_stack+139602,int_stack+127668,78);
 /*--- compute (o0|ud) ---*/
 hrr3_build_ud(Libint->CD,int_stack+203562,int_stack+167760,int_stack+699618,78);
 /*--- compute (o0|tf) ---*/
 hrr3_build_tf(Libint->CD,int_stack+267210,int_stack+203562,int_stack+731442,78);
 /*--- compute (o0|rg) ---*/
 hrr3_build_rg(Libint->CD,int_stack+563430,int_stack+267210,int_stack+970668,78);
 /*--- compute (o0|qh) ---*/
 hrr3_build_qh(Libint->CD,int_stack+1441242,int_stack+563430,int_stack+1052568,78);
 /*--- compute (o0|oi) ---*/
 hrr3_build_oi(Libint->CD,int_stack+931746,int_stack+1441242,int_stack+1159038,78);
 /*--- compute (o0|nk) ---*/
 hrr3_build_nk(Libint->CD,int_stack+1590300,int_stack+931746,int_stack+787602,78);
 /*--- compute (o0|ml) ---*/
 hrr3_build_ml(Libint->CD,int_stack+686280,int_stack+1590300,int_stack+1286802,78);
 /*--- compute (o0|wp) ---*/
 hrr3_build_wp(Libint->CD,int_stack+879330,int_stack+152940,int_stack+139602,78);
 /*--- compute (o0|vd) ---*/
 hrr3_build_vd(Libint->CD,int_stack+1102098,int_stack+879330,int_stack+167760,78);
 /*--- compute (o0|uf) ---*/
 hrr3_build_uf(Libint->CD,int_stack+1173702,int_stack+1102098,int_stack+203562,78);
 /*--- compute (o0|tg) ---*/
 hrr3_build_tg(Libint->CD,int_stack+1279782,int_stack+1173702,int_stack+267210,78);
 /*--- compute (o0|rh) ---*/
 hrr3_build_rh(Libint->CD,int_stack+1102098,int_stack+1279782,int_stack+563430,78);
 /*--- compute (o0|qi) ---*/
 hrr3_build_qi(Libint->CD,int_stack+0,int_stack+1102098,int_stack+1441242,78);
 /*--- compute (o0|ok) ---*/
 hrr3_build_ok(Libint->CD,int_stack+1102098,int_stack+0,int_stack+931746,78);
 /*--- compute (o0|nl) ---*/
 hrr3_build_nl(Libint->CD,int_stack+0,int_stack+1102098,int_stack+1590300,78);
 /*--- compute (o0|mm) ---*/
 hrr3_build_mm(Libint->CD,int_stack+879330,int_stack+0,int_stack+686280,78);
 /*--- compute (np|mm) ---*/
 hrr1_build_np(Libint->AB,int_stack+1115280,int_stack+879330,int_stack+363780,3025);
 return int_stack+1115280;}
