/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0mg(Libint_t*, prim_data*);

  /* Computes quartets of (p0|mg) integrals */

REALTYPE *hrr_order_p0mg(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 memset(int_stack,0,1185*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1185;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0mg(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1185,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+1680,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+2274,int_stack+1680,int_stack+1185,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+3264,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+3966,int_stack+3264,int_stack+1680,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5154,int_stack+3966,int_stack+2274,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1185,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+6804,int_stack+1185,int_stack+3264,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+0,int_stack+6804,int_stack+3966,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+1980,int_stack+0,int_stack+5154,3);
 return int_stack+1980;}
