/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_p0mi(Libint_t*, prim_data*);

  /* Computes quartets of (p0|mi) integrals */

REALTYPE *hrr_order_p0mi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 Libint->vrr_classes[1][14] = int_stack + 1185;
 Libint->vrr_classes[1][15] = int_stack + 1545;
 memset(int_stack,0,1953*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 1953;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_p0mi(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+1953,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+2448,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+3042,int_stack+2448,int_stack+1953,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+4032,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+4734,int_stack+4032,int_stack+2448,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+5922,int_stack+4734,int_stack+3042,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+1953,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+7572,int_stack+1953,int_stack+4032,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+8976,int_stack+7572,int_stack+4734,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+2772,int_stack+8976,int_stack+5922,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+5247,int_stack+1185,int_stack+870,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+10956,int_stack+5247,int_stack+1953,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+12594,int_stack+10956,int_stack+7572,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+14934,int_stack+12594,int_stack+8976,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+6192,int_stack+14934,int_stack+2772,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+1953,int_stack+1545,int_stack+1185,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+3033,int_stack+1953,int_stack+5247,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+0,int_stack+3033,int_stack+10956,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+17904,int_stack+0,int_stack+12594,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+17904,int_stack+14934,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+9657,int_stack+0,int_stack+6192,3);
 return int_stack+9657;}
