/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include "libint.h"
#include "hrr_header.h"

extern void vrr_order_ppmi(Libint_t*, prim_data*);

  /* Computes quartets of (pp|mi) integrals */

REALTYPE *hrr_order_ppmi(Libint_t *Libint, int num_prim_comb)
{
 prim_data *Data = Libint->PrimQuartet;
 REALTYPE *int_stack = Libint->int_stack;
 int i;

 Libint->vrr_classes[1][9] = int_stack + 0;
 Libint->vrr_classes[1][10] = int_stack + 165;
 Libint->vrr_classes[1][11] = int_stack + 363;
 Libint->vrr_classes[1][12] = int_stack + 597;
 Libint->vrr_classes[1][13] = int_stack + 870;
 Libint->vrr_classes[1][14] = int_stack + 1185;
 Libint->vrr_classes[1][15] = int_stack + 1545;
 Libint->vrr_classes[2][9] = int_stack + 1953;
 Libint->vrr_classes[2][10] = int_stack + 2283;
 Libint->vrr_classes[2][11] = int_stack + 2679;
 Libint->vrr_classes[2][12] = int_stack + 3147;
 Libint->vrr_classes[2][13] = int_stack + 3693;
 Libint->vrr_classes[2][14] = int_stack + 4323;
 Libint->vrr_classes[2][15] = int_stack + 5043;
 memset(int_stack,0,5859*sizeof(REALTYPE));

 Libint->vrr_stack = int_stack + 5859;
 for(i=0;i<num_prim_comb;i++) {
   vrr_order_ppmi(Libint, Data);
   Data++;
 }
 /*--- compute (p0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5859,int_stack+165,int_stack+0,3);
 /*--- compute (p0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6354,int_stack+363,int_stack+165,3);
 /*--- compute (p0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+6948,int_stack+6354,int_stack+5859,3);
 /*--- compute (p0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+7938,int_stack+597,int_stack+363,3);
 /*--- compute (p0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+8640,int_stack+7938,int_stack+6354,3);
 /*--- compute (p0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+9828,int_stack+8640,int_stack+6948,3);
 /*--- compute (p0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5859,int_stack+870,int_stack+597,3);
 /*--- compute (p0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+11478,int_stack+5859,int_stack+7938,3);
 /*--- compute (p0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+12882,int_stack+11478,int_stack+8640,3);
 /*--- compute (p0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+6678,int_stack+12882,int_stack+9828,3);
 /*--- compute (p0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+9153,int_stack+1185,int_stack+870,3);
 /*--- compute (p0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+14862,int_stack+9153,int_stack+5859,3);
 /*--- compute (p0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+16500,int_stack+14862,int_stack+11478,3);
 /*--- compute (p0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+18840,int_stack+16500,int_stack+12882,3);
 /*--- compute (p0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+10098,int_stack+18840,int_stack+6678,3);
 /*--- compute (p0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+5859,int_stack+1545,int_stack+1185,3);
 /*--- compute (p0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+6939,int_stack+5859,int_stack+9153,3);
 /*--- compute (p0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+21810,int_stack+6939,int_stack+14862,3);
 /*--- compute (p0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+5859,int_stack+21810,int_stack+16500,3);
 /*--- compute (p0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+13563,int_stack+5859,int_stack+18840,3);
 /*--- compute (p0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+17721,int_stack+13563,int_stack+10098,3);
 /*--- compute (d0|mp) ---*/
 hrr3_build_mp(Libint->CD,int_stack+5859,int_stack+2283,int_stack+1953,6);
 /*--- compute (d0|np) ---*/
 hrr3_build_np(Libint->CD,int_stack+6849,int_stack+2679,int_stack+2283,6);
 /*--- compute (d0|md) ---*/
 hrr3_build_md(Libint->CD,int_stack+8037,int_stack+6849,int_stack+5859,6);
 /*--- compute (d0|op) ---*/
 hrr3_build_op(Libint->CD,int_stack+10017,int_stack+3147,int_stack+2679,6);
 /*--- compute (d0|nd) ---*/
 hrr3_build_nd(Libint->CD,int_stack+11421,int_stack+10017,int_stack+6849,6);
 /*--- compute (d0|mf) ---*/
 hrr3_build_mf(Libint->CD,int_stack+13797,int_stack+11421,int_stack+8037,6);
 /*--- compute (d0|qp) ---*/
 hrr3_build_qp(Libint->CD,int_stack+5859,int_stack+3693,int_stack+3147,6);
 /*--- compute (d0|od) ---*/
 hrr3_build_od(Libint->CD,int_stack+0,int_stack+5859,int_stack+10017,6);
 /*--- compute (d0|nf) ---*/
 hrr3_build_nf(Libint->CD,int_stack+22341,int_stack+0,int_stack+11421,6);
 /*--- compute (d0|mg) ---*/
 hrr3_build_mg(Libint->CD,int_stack+7497,int_stack+22341,int_stack+13797,6);
 /*--- compute (d0|rp) ---*/
 hrr3_build_rp(Libint->CD,int_stack+12447,int_stack+4323,int_stack+3693,6);
 /*--- compute (d0|qd) ---*/
 hrr3_build_qd(Libint->CD,int_stack+14337,int_stack+12447,int_stack+5859,6);
 /*--- compute (d0|of) ---*/
 hrr3_build_of(Libint->CD,int_stack+26301,int_stack+14337,int_stack+0,6);
 /*--- compute (d0|ng) ---*/
 hrr3_build_ng(Libint->CD,int_stack+30981,int_stack+26301,int_stack+22341,6);
 /*--- compute (d0|mh) ---*/
 hrr3_build_mh(Libint->CD,int_stack+36921,int_stack+30981,int_stack+7497,6);
 /*--- compute (d0|tp) ---*/
 hrr3_build_tp(Libint->CD,int_stack+22341,int_stack+5043,int_stack+4323,6);
 /*--- compute (d0|rd) ---*/
 hrr3_build_rd(Libint->CD,int_stack+0,int_stack+22341,int_stack+12447,6);
 /*--- compute (d0|qf) ---*/
 hrr3_build_qf(Libint->CD,int_stack+3780,int_stack+0,int_stack+14337,6);
 /*--- compute (d0|og) ---*/
 hrr3_build_og(Libint->CD,int_stack+9240,int_stack+3780,int_stack+26301,6);
 /*--- compute (d0|nh) ---*/
 hrr3_build_nh(Libint->CD,int_stack+0,int_stack+9240,int_stack+30981,6);
 /*--- compute (d0|mi) ---*/
 hrr3_build_mi(Libint->CD,int_stack+8316,int_stack+0,int_stack+36921,6);
 /*--- compute (pp|mi) ---*/
 hrr1_build_pp(Libint->AB,int_stack+22341,int_stack+8316,int_stack+17721,1540);
 return int_stack+22341;}
