/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (d0|ih) integrals */

void vrr_order_d0ih(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+21, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+24, vrr_stack+65, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+30, vrr_stack+71, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+50, vrr_stack+81, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+12, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+6, vrr_stack+15, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+117, vrr_stack+40, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+127, vrr_stack+50, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+96, NULL, NULL, vrr_stack+50);
 _BUILD_00i0(Data,vrr_stack+226, vrr_stack+142, vrr_stack+96, vrr_stack+127, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+40, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+43, vrr_stack+40, vrr_stack+0, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+254, vrr_stack+43, vrr_stack+6, vrr_stack+40, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+264, vrr_stack+254, vrr_stack+117, vrr_stack+43, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+279, vrr_stack+264, vrr_stack+127, vrr_stack+254, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+300, vrr_stack+279, vrr_stack+142, vrr_stack+264, vrr_stack+127, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+117, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+65, vrr_stack+117, vrr_stack+21, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+123, vrr_stack+71, vrr_stack+40, vrr_stack+24, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+254, vrr_stack+81, vrr_stack+123, vrr_stack+30, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+6, vrr_stack+96, vrr_stack+254, vrr_stack+50, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+328, vrr_stack+226, vrr_stack+6, NULL, NULL, vrr_stack+96);
 _BUILD_p0i0(Data,vrr_stack+412, vrr_stack+300, vrr_stack+226, NULL, NULL, vrr_stack+142);
 _BUILD_00k0(Data,vrr_stack+496, vrr_stack+226, vrr_stack+6, vrr_stack+142, vrr_stack+96, NULL);
 _BUILD_00k0(Data,vrr_stack+532, vrr_stack+300, vrr_stack+226, vrr_stack+279, vrr_stack+142, NULL);
 _BUILD_00p0(Data,vrr_stack+50, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+0, vrr_stack+50, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+53, vrr_stack+117, vrr_stack+34, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+138, vrr_stack+40, vrr_stack+53, vrr_stack+65, vrr_stack+117, NULL);
 _BUILD_00h0(Data,vrr_stack+275, vrr_stack+123, vrr_stack+138, vrr_stack+71, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+568, vrr_stack+254, vrr_stack+275, vrr_stack+81, vrr_stack+123, NULL);
 _BUILD_00k0(Data,vrr_stack+596, vrr_stack+6, vrr_stack+568, vrr_stack+96, vrr_stack+254, NULL);
 _BUILD_p0k0(Data,vrr_stack+632, vrr_stack+496, vrr_stack+596, NULL, NULL, vrr_stack+6);
 _BUILD_p0k0(Data,vrr_stack+740, vrr_stack+532, vrr_stack+496, NULL, NULL, vrr_stack+226);
 _BUILD_00l0(Data,vrr_stack+63, vrr_stack+496, vrr_stack+596, vrr_stack+226, vrr_stack+6, NULL);
 _BUILD_00l0(Data,vrr_stack+848, vrr_stack+532, vrr_stack+496, vrr_stack+300, vrr_stack+226, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+108, vrr_stack+50, vrr_stack+3, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+153, vrr_stack+34, vrr_stack+108, vrr_stack+0, vrr_stack+50, NULL);
 _BUILD_00g0(Data,vrr_stack+893, vrr_stack+53, vrr_stack+153, vrr_stack+117, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+908, vrr_stack+138, vrr_stack+893, vrr_stack+40, vrr_stack+53, NULL);
 _BUILD_00i0(Data,vrr_stack+929, vrr_stack+275, vrr_stack+908, vrr_stack+123, vrr_stack+138, NULL);
 _BUILD_00k0(Data,vrr_stack+957, vrr_stack+568, vrr_stack+929, vrr_stack+254, vrr_stack+275, NULL);
 _BUILD_00l0(Data,vrr_stack+993, vrr_stack+596, vrr_stack+957, vrr_stack+6, vrr_stack+568, NULL);
 _BUILD_p0l0(Data,vrr_stack+1038, vrr_stack+63, vrr_stack+993, NULL, NULL, vrr_stack+596);
 _BUILD_p0l0(Data,vrr_stack+1173, vrr_stack+848, vrr_stack+63, NULL, NULL, vrr_stack+496);
 _BUILD_00m0(Data,vrr_stack+1308, vrr_stack+63, vrr_stack+993, vrr_stack+496, vrr_stack+596, NULL);
 _BUILD_00m0(Data,vrr_stack+1363, vrr_stack+848, vrr_stack+63, vrr_stack+532, vrr_stack+496, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+108, vrr_stack+6, vrr_stack+50, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+12, vrr_stack+153, vrr_stack+40, vrr_stack+34, vrr_stack+108, NULL);
 _BUILD_00h0(Data,vrr_stack+254, vrr_stack+893, vrr_stack+12, vrr_stack+53, vrr_stack+153, NULL);
 _BUILD_00i0(Data,vrr_stack+1418, vrr_stack+908, vrr_stack+254, vrr_stack+138, vrr_stack+893, NULL);
 _BUILD_00k0(Data,vrr_stack+114, vrr_stack+929, vrr_stack+1418, vrr_stack+275, vrr_stack+908, NULL);
 _BUILD_00l0(Data,vrr_stack+1446, vrr_stack+957, vrr_stack+114, vrr_stack+568, vrr_stack+929, NULL);
 _BUILD_00m0(Data,vrr_stack+1491, vrr_stack+993, vrr_stack+1446, vrr_stack+596, vrr_stack+957, NULL);
 _BUILD_p0m0(Data,vrr_stack+1546, vrr_stack+1308, vrr_stack+1491, NULL, NULL, vrr_stack+993);
 _BUILD_p0m0(Data,vrr_stack+1711, vrr_stack+1363, vrr_stack+1308, NULL, NULL, vrr_stack+63);
 _BUILD_00n0(Data,vrr_stack+1876, vrr_stack+1308, vrr_stack+1491, vrr_stack+63, vrr_stack+993, NULL);
 _BUILD_00n0(Data,vrr_stack+1942, vrr_stack+1363, vrr_stack+1308, vrr_stack+848, vrr_stack+63, NULL);
 _BUILD_00p0(Data,vrr_stack+150, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+568, vrr_stack+0, vrr_stack+150, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+574, vrr_stack+6, vrr_stack+568, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+584, vrr_stack+40, vrr_stack+574, vrr_stack+108, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+599, vrr_stack+12, vrr_stack+584, vrr_stack+153, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+2008, vrr_stack+254, vrr_stack+599, vrr_stack+893, vrr_stack+12, NULL);
 _BUILD_00k0(Data,vrr_stack+2036, vrr_stack+1418, vrr_stack+2008, vrr_stack+908, vrr_stack+254, NULL);
 _BUILD_00l0(Data,vrr_stack+2072, vrr_stack+114, vrr_stack+2036, vrr_stack+929, vrr_stack+1418, NULL);
 _BUILD_00m0(Data,vrr_stack+893, vrr_stack+1446, vrr_stack+2072, vrr_stack+957, vrr_stack+114, NULL);
 _BUILD_00n0(Data,vrr_stack+2117, vrr_stack+1491, vrr_stack+893, vrr_stack+993, vrr_stack+1446, NULL);
 _BUILD_p0n0(Data,vrr_stack+2183, vrr_stack+1876, vrr_stack+2117, NULL, NULL, vrr_stack+1491);
 _BUILD_p0n0(Data,vrr_stack+2381, vrr_stack+1942, vrr_stack+1876, NULL, NULL, vrr_stack+1308);
 _BUILD_00o0(Data,vrr_stack+948, vrr_stack+1876, vrr_stack+2117, vrr_stack+1308, vrr_stack+1491, NULL);
 _BUILD_00o0(Data,vrr_stack+2579, vrr_stack+1942, vrr_stack+1876, vrr_stack+1363, vrr_stack+1308, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+108, vrr_stack+150, vrr_stack+3, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+153, vrr_stack+568, vrr_stack+108, vrr_stack+0, vrr_stack+150, NULL);
 _BUILD_00g0(Data,vrr_stack+275, vrr_stack+574, vrr_stack+153, vrr_stack+6, vrr_stack+568, NULL);
 _BUILD_00h0(Data,vrr_stack+2657, vrr_stack+584, vrr_stack+275, vrr_stack+40, vrr_stack+574, NULL);
 _BUILD_00i0(Data,vrr_stack+27, vrr_stack+599, vrr_stack+2657, vrr_stack+12, vrr_stack+584, NULL);
 _BUILD_00k0(Data,vrr_stack+2657, vrr_stack+2008, vrr_stack+27, vrr_stack+254, vrr_stack+599, NULL);
 _BUILD_00l0(Data,vrr_stack+254, vrr_stack+2036, vrr_stack+2657, vrr_stack+1418, vrr_stack+2008, NULL);
 _BUILD_00m0(Data,vrr_stack+2657, vrr_stack+2072, vrr_stack+254, vrr_stack+114, vrr_stack+2036, NULL);
 _BUILD_00n0(Data,vrr_stack+2712, vrr_stack+893, vrr_stack+2657, vrr_stack+1446, vrr_stack+2072, NULL);
 _BUILD_00o0(Data,vrr_stack+2008, vrr_stack+2117, vrr_stack+2712, vrr_stack+1491, vrr_stack+893, NULL);
 _BUILD_p0o0(Data,vrr_stack+2657, vrr_stack+948, vrr_stack+2008, NULL, NULL, vrr_stack+2117);
 _BUILD_p0o0(Data,vrr_stack+2891, vrr_stack+2579, vrr_stack+948, NULL, NULL, vrr_stack+1876);
 _BUILD_d0i0(Data,vrr_stack+2008, vrr_stack+412, vrr_stack+328, vrr_stack+300, vrr_stack+226, vrr_stack+163);
   tmp = vrr_stack + 2008;
   target_ptr = Libint->vrr_classes[2][6];
   for(i=0;i<168;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0k0(Data,vrr_stack+3125, vrr_stack+740, vrr_stack+632, vrr_stack+532, vrr_stack+496, vrr_stack+328);
   tmp = vrr_stack + 3125;
   target_ptr = Libint->vrr_classes[2][7];
   for(i=0;i<216;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0l0(Data,vrr_stack+3341, vrr_stack+1173, vrr_stack+1038, vrr_stack+848, vrr_stack+63, vrr_stack+632);
   tmp = vrr_stack + 3341;
   target_ptr = Libint->vrr_classes[2][8];
   for(i=0;i<270;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0m0(Data,vrr_stack+3611, vrr_stack+1711, vrr_stack+1546, vrr_stack+1363, vrr_stack+1308, vrr_stack+1038);
   tmp = vrr_stack + 3611;
   target_ptr = Libint->vrr_classes[2][9];
   for(i=0;i<330;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0n0(Data,vrr_stack+0, vrr_stack+2381, vrr_stack+2183, vrr_stack+1942, vrr_stack+1876, vrr_stack+1546);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[2][10];
   for(i=0;i<396;i++)
     target_ptr[i] += tmp[i];
 _BUILD_d0o0(Data,vrr_stack+396, vrr_stack+2891, vrr_stack+2657, vrr_stack+2579, vrr_stack+948, vrr_stack+2183);
   tmp = vrr_stack + 396;
   target_ptr = Libint->vrr_classes[2][11];
   for(i=0;i<468;i++)
     target_ptr[i] += tmp[i];

}

