/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fp|ml) integrals */

void vrr_order_fpml(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+6, Data->F+7, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+15, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+6, vrr_stack+3, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+9, vrr_stack+50, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+21, vrr_stack+56, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+66, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+117, vrr_stack+50, vrr_stack+15, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+127, vrr_stack+56, vrr_stack+117, vrr_stack+9, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+66, vrr_stack+127, vrr_stack+21, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+96, vrr_stack+142, vrr_stack+81, vrr_stack+66, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+21, vrr_stack+31, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+191, vrr_stack+24, vrr_stack+34, vrr_stack+21, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+201, vrr_stack+191, vrr_stack+40, vrr_stack+24, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+216, vrr_stack+201, vrr_stack+81, vrr_stack+191, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+237, vrr_stack+216, vrr_stack+96, vrr_stack+201, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+265, vrr_stack+237, vrr_stack+163, NULL, NULL, vrr_stack+96);
 _BUILD_00k0(Data,vrr_stack+349, vrr_stack+237, vrr_stack+163, vrr_stack+216, vrr_stack+96, NULL);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+21, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+84, vrr_stack+24, vrr_stack+81, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+385, vrr_stack+30, vrr_stack+191, vrr_stack+84, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+400, vrr_stack+385, vrr_stack+201, vrr_stack+30, vrr_stack+191, NULL);
 _BUILD_00i0(Data,vrr_stack+421, vrr_stack+400, vrr_stack+216, vrr_stack+385, vrr_stack+201, NULL);
 _BUILD_00k0(Data,vrr_stack+449, vrr_stack+421, vrr_stack+237, vrr_stack+400, vrr_stack+216, NULL);
 _BUILD_00p0(Data,vrr_stack+191, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+191, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+90, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+194, vrr_stack+117, vrr_stack+40, vrr_stack+50, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+209, vrr_stack+127, vrr_stack+194, vrr_stack+56, vrr_stack+117, NULL);
 _BUILD_00i0(Data,vrr_stack+485, vrr_stack+142, vrr_stack+209, vrr_stack+66, vrr_stack+127, NULL);
 _BUILD_00k0(Data,vrr_stack+513, vrr_stack+163, vrr_stack+485, vrr_stack+96, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+549, vrr_stack+349, vrr_stack+513, NULL, NULL, vrr_stack+163);
 _BUILD_p0k0(Data,vrr_stack+657, vrr_stack+449, vrr_stack+349, NULL, NULL, vrr_stack+237);
 _BUILD_d0k0(Data,vrr_stack+765, vrr_stack+657, vrr_stack+549, vrr_stack+449, vrr_stack+349, vrr_stack+265);
 _BUILD_00l0(Data,vrr_stack+265, vrr_stack+349, vrr_stack+513, vrr_stack+237, vrr_stack+163, NULL);
 _BUILD_00l0(Data,vrr_stack+981, vrr_stack+449, vrr_stack+349, vrr_stack+421, vrr_stack+237, NULL);
 _BUILD_p0l0(Data,vrr_stack+1026, vrr_stack+981, vrr_stack+265, NULL, NULL, vrr_stack+349);
 _BUILD_00p0(Data,vrr_stack+310, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+313, vrr_stack+310, vrr_stack+81, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+319, vrr_stack+313, vrr_stack+84, vrr_stack+310, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+329, vrr_stack+319, vrr_stack+30, vrr_stack+313, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+96, vrr_stack+329, vrr_stack+385, vrr_stack+319, vrr_stack+30, NULL);
 _BUILD_00i0(Data,vrr_stack+50, vrr_stack+96, vrr_stack+400, vrr_stack+329, vrr_stack+385, NULL);
 _BUILD_00k0(Data,vrr_stack+1161, vrr_stack+50, vrr_stack+421, vrr_stack+96, vrr_stack+400, NULL);
 _BUILD_00l0(Data,vrr_stack+1197, vrr_stack+1161, vrr_stack+449, vrr_stack+50, vrr_stack+421, NULL);
 _BUILD_p0l0(Data,vrr_stack+1242, vrr_stack+1197, vrr_stack+981, NULL, NULL, vrr_stack+449);
 _BUILD_00p0(Data,vrr_stack+385, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+388, vrr_stack+191, vrr_stack+385, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+394, vrr_stack+90, vrr_stack+388, vrr_stack+0, vrr_stack+191, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+40, vrr_stack+394, vrr_stack+15, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+15, vrr_stack+194, vrr_stack+0, vrr_stack+117, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+404, vrr_stack+209, vrr_stack+15, vrr_stack+127, vrr_stack+194, NULL);
 _BUILD_00k0(Data,vrr_stack+1377, vrr_stack+485, vrr_stack+404, vrr_stack+142, vrr_stack+209, NULL);
 _BUILD_00l0(Data,vrr_stack+117, vrr_stack+513, vrr_stack+1377, vrr_stack+163, vrr_stack+485, NULL);
 _BUILD_p0l0(Data,vrr_stack+1413, vrr_stack+265, vrr_stack+117, NULL, NULL, vrr_stack+513);
 _BUILD_d0l0(Data,vrr_stack+1548, vrr_stack+1026, vrr_stack+1413, vrr_stack+981, vrr_stack+265, vrr_stack+549);
 _BUILD_d0l0(Data,vrr_stack+1818, vrr_stack+1242, vrr_stack+1026, vrr_stack+1197, vrr_stack+981, vrr_stack+657);
 _BUILD_f0l0(Data,vrr_stack+2088, vrr_stack+1818, vrr_stack+1548, vrr_stack+1242, vrr_stack+1026, vrr_stack+765);
 _BUILD_00m0(Data,vrr_stack+549, vrr_stack+981, vrr_stack+265, vrr_stack+449, vrr_stack+349, NULL);
 _BUILD_00m0(Data,vrr_stack+604, vrr_stack+1197, vrr_stack+981, vrr_stack+1161, vrr_stack+449, NULL);
 _BUILD_00m0(Data,vrr_stack+659, vrr_stack+265, vrr_stack+117, vrr_stack+349, vrr_stack+513, NULL);
 _BUILD_p0m0(Data,vrr_stack+714, vrr_stack+549, vrr_stack+659, NULL, NULL, vrr_stack+265);
 _BUILD_p0m0(Data,vrr_stack+2538, vrr_stack+604, vrr_stack+549, NULL, NULL, vrr_stack+981);
 _BUILD_d0m0(Data,vrr_stack+2703, vrr_stack+2538, vrr_stack+714, vrr_stack+604, vrr_stack+549, vrr_stack+1026);
 _BUILD_00p0(Data,vrr_stack+1026, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1029, vrr_stack+1026, vrr_stack+310, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+1035, vrr_stack+1029, vrr_stack+313, vrr_stack+1026, vrr_stack+310, NULL);
 _BUILD_00g0(Data,vrr_stack+1045, vrr_stack+1035, vrr_stack+319, vrr_stack+1029, vrr_stack+313, NULL);
 _BUILD_00h0(Data,vrr_stack+1060, vrr_stack+1045, vrr_stack+329, vrr_stack+1035, vrr_stack+319, NULL);
 _BUILD_00i0(Data,vrr_stack+1081, vrr_stack+1060, vrr_stack+96, vrr_stack+1045, vrr_stack+329, NULL);
 _BUILD_00k0(Data,vrr_stack+310, vrr_stack+1081, vrr_stack+50, vrr_stack+1060, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+1026, vrr_stack+310, vrr_stack+1161, vrr_stack+1081, vrr_stack+50, NULL);
 _BUILD_00m0(Data,vrr_stack+1071, vrr_stack+1026, vrr_stack+1197, vrr_stack+310, vrr_stack+1161, NULL);
 _BUILD_p0m0(Data,vrr_stack+3033, vrr_stack+1071, vrr_stack+604, NULL, NULL, vrr_stack+1197);
 _BUILD_d0m0(Data,vrr_stack+3198, vrr_stack+3033, vrr_stack+2538, vrr_stack+1071, vrr_stack+604, vrr_stack+1242);
 _BUILD_00p0(Data,vrr_stack+1242, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1245, vrr_stack+385, vrr_stack+1242, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+1251, vrr_stack+388, vrr_stack+1245, vrr_stack+191, vrr_stack+385, NULL);
 _BUILD_00g0(Data,vrr_stack+1261, vrr_stack+394, vrr_stack+1251, vrr_stack+90, vrr_stack+388, NULL);
 _BUILD_00h0(Data,vrr_stack+1276, vrr_stack+0, vrr_stack+1261, vrr_stack+40, vrr_stack+394, NULL);
 _BUILD_00i0(Data,vrr_stack+1297, vrr_stack+15, vrr_stack+1276, vrr_stack+194, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1325, vrr_stack+404, vrr_stack+1297, vrr_stack+209, vrr_stack+15, NULL);
 _BUILD_00l0(Data,vrr_stack+310, vrr_stack+1377, vrr_stack+1325, vrr_stack+485, vrr_stack+404, NULL);
 _BUILD_00m0(Data,vrr_stack+1126, vrr_stack+117, vrr_stack+310, vrr_stack+513, vrr_stack+1377, NULL);
 _BUILD_p0m0(Data,vrr_stack+3528, vrr_stack+659, vrr_stack+1126, NULL, NULL, vrr_stack+117);
 _BUILD_d0m0(Data,vrr_stack+3693, vrr_stack+714, vrr_stack+3528, vrr_stack+549, vrr_stack+659, vrr_stack+1413);
 _BUILD_f0m0(Data,vrr_stack+4023, vrr_stack+2703, vrr_stack+3693, vrr_stack+2538, vrr_stack+714, vrr_stack+1548);
 _BUILD_f0m0(Data,vrr_stack+4573, vrr_stack+3198, vrr_stack+2703, vrr_stack+3033, vrr_stack+2538, vrr_stack+1818);
   tmp = vrr_stack + 4573;
   target_ptr = Libint->vrr_classes[3][9];
   for(i=0;i<550;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+3033, vrr_stack+549, vrr_stack+659, vrr_stack+981, vrr_stack+265, NULL);
 _BUILD_00n0(Data,vrr_stack+3099, vrr_stack+604, vrr_stack+549, vrr_stack+1197, vrr_stack+981, NULL);
 _BUILD_00n0(Data,vrr_stack+1413, vrr_stack+659, vrr_stack+1126, vrr_stack+265, vrr_stack+117, NULL);
 _BUILD_p0n0(Data,vrr_stack+1479, vrr_stack+3033, vrr_stack+1413, NULL, NULL, vrr_stack+659);
 _BUILD_p0n0(Data,vrr_stack+1677, vrr_stack+3099, vrr_stack+3033, NULL, NULL, vrr_stack+549);
 _BUILD_d0n0(Data,vrr_stack+5123, vrr_stack+1677, vrr_stack+1479, vrr_stack+3099, vrr_stack+3033, vrr_stack+714);
 _BUILD_00n0(Data,vrr_stack+714, vrr_stack+1071, vrr_stack+604, vrr_stack+1026, vrr_stack+1197, NULL);
 _BUILD_p0n0(Data,vrr_stack+780, vrr_stack+714, vrr_stack+3099, NULL, NULL, vrr_stack+604);
 _BUILD_d0n0(Data,vrr_stack+5519, vrr_stack+780, vrr_stack+1677, vrr_stack+714, vrr_stack+3099, vrr_stack+2538);
 _BUILD_00p0(Data,vrr_stack+2538, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2541, vrr_stack+1242, vrr_stack+2538, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+2547, vrr_stack+1245, vrr_stack+2541, vrr_stack+385, vrr_stack+1242, NULL);
 _BUILD_00g0(Data,vrr_stack+2557, vrr_stack+1251, vrr_stack+2547, vrr_stack+388, vrr_stack+1245, NULL);
 _BUILD_00h0(Data,vrr_stack+2572, vrr_stack+1261, vrr_stack+2557, vrr_stack+394, vrr_stack+1251, NULL);
 _BUILD_00i0(Data,vrr_stack+2593, vrr_stack+1276, vrr_stack+2572, vrr_stack+0, vrr_stack+1261, NULL);
 _BUILD_00k0(Data,vrr_stack+2621, vrr_stack+1297, vrr_stack+2593, vrr_stack+15, vrr_stack+1276, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+1325, vrr_stack+2621, vrr_stack+404, vrr_stack+1297, NULL);
 _BUILD_00m0(Data,vrr_stack+45, vrr_stack+310, vrr_stack+0, vrr_stack+1377, vrr_stack+1325, NULL);
 _BUILD_00n0(Data,vrr_stack+978, vrr_stack+1126, vrr_stack+45, vrr_stack+117, vrr_stack+310, NULL);
 _BUILD_p0n0(Data,vrr_stack+100, vrr_stack+1413, vrr_stack+978, NULL, NULL, vrr_stack+1126);
 _BUILD_d0n0(Data,vrr_stack+5915, vrr_stack+1479, vrr_stack+100, vrr_stack+3033, vrr_stack+1413, vrr_stack+3528);
 _BUILD_f0n0(Data,vrr_stack+6311, vrr_stack+5123, vrr_stack+5915, vrr_stack+1677, vrr_stack+1479, vrr_stack+3693);
 _BUILD_f0n0(Data,vrr_stack+6971, vrr_stack+5519, vrr_stack+5123, vrr_stack+780, vrr_stack+1677, vrr_stack+2703);
   tmp = vrr_stack + 6971;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+780, vrr_stack+3033, vrr_stack+1413, vrr_stack+549, vrr_stack+659, NULL);
 _BUILD_00o0(Data,vrr_stack+858, vrr_stack+3099, vrr_stack+3033, vrr_stack+604, vrr_stack+549, NULL);
 _BUILD_00o0(Data,vrr_stack+3528, vrr_stack+1413, vrr_stack+978, vrr_stack+659, vrr_stack+1126, NULL);
 _BUILD_p0o0(Data,vrr_stack+3606, vrr_stack+780, vrr_stack+3528, NULL, NULL, vrr_stack+1413);
 _BUILD_p0o0(Data,vrr_stack+355, vrr_stack+858, vrr_stack+780, NULL, NULL, vrr_stack+3033);
 _BUILD_d0o0(Data,vrr_stack+7631, vrr_stack+355, vrr_stack+3606, vrr_stack+858, vrr_stack+780, vrr_stack+1479);
 _BUILD_00o0(Data,vrr_stack+1479, vrr_stack+714, vrr_stack+3099, vrr_stack+1071, vrr_stack+604, NULL);
 _BUILD_p0o0(Data,vrr_stack+8099, vrr_stack+1479, vrr_stack+858, NULL, NULL, vrr_stack+3099);
 _BUILD_d0o0(Data,vrr_stack+8333, vrr_stack+8099, vrr_stack+355, vrr_stack+1479, vrr_stack+858, vrr_stack+1677);
 _BUILD_00p0(Data,vrr_stack+1557, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1560, vrr_stack+2538, vrr_stack+1557, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+1566, vrr_stack+2541, vrr_stack+1560, vrr_stack+1242, vrr_stack+2538, NULL);
 _BUILD_00g0(Data,vrr_stack+1576, vrr_stack+2547, vrr_stack+1566, vrr_stack+1245, vrr_stack+2541, NULL);
 _BUILD_00h0(Data,vrr_stack+1591, vrr_stack+2557, vrr_stack+1576, vrr_stack+1251, vrr_stack+2547, NULL);
 _BUILD_00i0(Data,vrr_stack+1612, vrr_stack+2572, vrr_stack+1591, vrr_stack+1261, vrr_stack+2557, NULL);
 _BUILD_00k0(Data,vrr_stack+1640, vrr_stack+2593, vrr_stack+1612, vrr_stack+1276, vrr_stack+2572, NULL);
 _BUILD_00l0(Data,vrr_stack+1676, vrr_stack+2621, vrr_stack+1640, vrr_stack+1297, vrr_stack+2593, NULL);
 _BUILD_00m0(Data,vrr_stack+1721, vrr_stack+0, vrr_stack+1676, vrr_stack+1325, vrr_stack+2621, NULL);
 _BUILD_00n0(Data,vrr_stack+1776, vrr_stack+45, vrr_stack+1721, vrr_stack+310, vrr_stack+0, NULL);
 _BUILD_00o0(Data,vrr_stack+1842, vrr_stack+978, vrr_stack+1776, vrr_stack+1126, vrr_stack+45, NULL);
 _BUILD_p0o0(Data,vrr_stack+1044, vrr_stack+3528, vrr_stack+1842, NULL, NULL, vrr_stack+978);
 _BUILD_d0o0(Data,vrr_stack+8801, vrr_stack+3606, vrr_stack+1044, vrr_stack+780, vrr_stack+3528, vrr_stack+100);
 _BUILD_f0o0(Data,vrr_stack+9269, vrr_stack+7631, vrr_stack+8801, vrr_stack+355, vrr_stack+3606, vrr_stack+5915);
 _BUILD_f0o0(Data,vrr_stack+10049, vrr_stack+8333, vrr_stack+7631, vrr_stack+8099, vrr_stack+355, vrr_stack+5123);
   tmp = vrr_stack + 10049;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+8099, vrr_stack+780, vrr_stack+3528, vrr_stack+3033, vrr_stack+1413, NULL);
 _BUILD_00q0(Data,vrr_stack+8190, vrr_stack+858, vrr_stack+780, vrr_stack+3099, vrr_stack+3033, NULL);
 _BUILD_00q0(Data,vrr_stack+5915, vrr_stack+3528, vrr_stack+1842, vrr_stack+1413, vrr_stack+978, NULL);
 _BUILD_p0q0(Data,vrr_stack+6006, vrr_stack+8099, vrr_stack+5915, NULL, NULL, vrr_stack+3528);
 _BUILD_p0q0(Data,vrr_stack+10829, vrr_stack+8190, vrr_stack+8099, NULL, NULL, vrr_stack+780);
 _BUILD_d0q0(Data,vrr_stack+11102, vrr_stack+10829, vrr_stack+6006, vrr_stack+8190, vrr_stack+8099, vrr_stack+3606);
 _BUILD_00q0(Data,vrr_stack+3606, vrr_stack+1479, vrr_stack+858, vrr_stack+714, vrr_stack+3099, NULL);
 _BUILD_p0q0(Data,vrr_stack+3697, vrr_stack+3606, vrr_stack+8190, NULL, NULL, vrr_stack+858);
 _BUILD_d0q0(Data,vrr_stack+11648, vrr_stack+3697, vrr_stack+10829, vrr_stack+3606, vrr_stack+8190, vrr_stack+355);
 _BUILD_00p0(Data,vrr_stack+3970, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3973, vrr_stack+1557, vrr_stack+3970, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+3979, vrr_stack+1560, vrr_stack+3973, vrr_stack+2538, vrr_stack+1557, NULL);
 _BUILD_00g0(Data,vrr_stack+3989, vrr_stack+1566, vrr_stack+3979, vrr_stack+2541, vrr_stack+1560, NULL);
 _BUILD_00h0(Data,vrr_stack+3033, vrr_stack+1576, vrr_stack+3989, vrr_stack+2547, vrr_stack+1566, NULL);
 _BUILD_00i0(Data,vrr_stack+3054, vrr_stack+1591, vrr_stack+3033, vrr_stack+2557, vrr_stack+1576, NULL);
 _BUILD_00k0(Data,vrr_stack+3082, vrr_stack+1612, vrr_stack+3054, vrr_stack+2572, vrr_stack+1591, NULL);
 _BUILD_00l0(Data,vrr_stack+2538, vrr_stack+1640, vrr_stack+3082, vrr_stack+2593, vrr_stack+1612, NULL);
 _BUILD_00m0(Data,vrr_stack+3118, vrr_stack+1676, vrr_stack+2538, vrr_stack+2621, vrr_stack+1640, NULL);
 _BUILD_00n0(Data,vrr_stack+2583, vrr_stack+1721, vrr_stack+3118, vrr_stack+0, vrr_stack+1676, NULL);
 _BUILD_00o0(Data,vrr_stack+100, vrr_stack+1776, vrr_stack+2583, vrr_stack+45, vrr_stack+1721, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+1842, vrr_stack+100, vrr_stack+978, vrr_stack+1776, NULL);
 _BUILD_p0q0(Data,vrr_stack+178, vrr_stack+5915, vrr_stack+0, NULL, NULL, vrr_stack+1842);
 _BUILD_d0q0(Data,vrr_stack+12194, vrr_stack+6006, vrr_stack+178, vrr_stack+8099, vrr_stack+5915, vrr_stack+1044);
 _BUILD_f0q0(Data,vrr_stack+12740, vrr_stack+11102, vrr_stack+12194, vrr_stack+10829, vrr_stack+6006, vrr_stack+8801);
 _BUILD_f0q0(Data,vrr_stack+13650, vrr_stack+11648, vrr_stack+11102, vrr_stack+3697, vrr_stack+10829, vrr_stack+7631);
   tmp = vrr_stack + 13650;
   target_ptr = Libint->vrr_classes[3][12];
   for(i=0;i<910;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3697, vrr_stack+8099, vrr_stack+5915, vrr_stack+780, vrr_stack+3528, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3802, vrr_stack+8190, vrr_stack+8099, vrr_stack+858, vrr_stack+780, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8801, vrr_stack+5915, vrr_stack+0, vrr_stack+3528, vrr_stack+1842, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8906, vrr_stack+3697, vrr_stack+8801, NULL, NULL, vrr_stack+5915);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+451, vrr_stack+3802, vrr_stack+3697, NULL, NULL, vrr_stack+8099);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+14560, vrr_stack+451, vrr_stack+8906, vrr_stack+3802, vrr_stack+3697, vrr_stack+6006);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+6006, vrr_stack+3606, vrr_stack+8190, vrr_stack+1479, vrr_stack+858, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+766, vrr_stack+6006, vrr_stack+3802, NULL, NULL, vrr_stack+8190);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15190, vrr_stack+766, vrr_stack+451, vrr_stack+6006, vrr_stack+3802, vrr_stack+10829);
 _BUILD_00p0(Data,vrr_stack+10829, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+10832, vrr_stack+3970, vrr_stack+10829, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+10838, vrr_stack+3973, vrr_stack+10832, vrr_stack+1557, vrr_stack+3970, NULL);
 _BUILD_00g0(Data,vrr_stack+10848, vrr_stack+3979, vrr_stack+10838, vrr_stack+1560, vrr_stack+3973, NULL);
 _BUILD_00h0(Data,vrr_stack+10863, vrr_stack+3989, vrr_stack+10848, vrr_stack+1566, vrr_stack+3979, NULL);
 _BUILD_00i0(Data,vrr_stack+10884, vrr_stack+3033, vrr_stack+10863, vrr_stack+1576, vrr_stack+3989, NULL);
 _BUILD_00k0(Data,vrr_stack+10912, vrr_stack+3054, vrr_stack+10884, vrr_stack+1591, vrr_stack+3033, NULL);
 _BUILD_00l0(Data,vrr_stack+10948, vrr_stack+3082, vrr_stack+10912, vrr_stack+1612, vrr_stack+3054, NULL);
 _BUILD_00m0(Data,vrr_stack+10993, vrr_stack+2538, vrr_stack+10948, vrr_stack+1640, vrr_stack+3082, NULL);
 _BUILD_00n0(Data,vrr_stack+6111, vrr_stack+3118, vrr_stack+10993, vrr_stack+1676, vrr_stack+2538, NULL);
 _BUILD_00o0(Data,vrr_stack+3528, vrr_stack+2583, vrr_stack+6111, vrr_stack+1721, vrr_stack+3118, NULL);
 _BUILD_00q0(Data,vrr_stack+6177, vrr_stack+100, vrr_stack+3528, vrr_stack+1776, vrr_stack+2583, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1081, vrr_stack+0, vrr_stack+6177, vrr_stack+1842, vrr_stack+100, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1186, vrr_stack+8801, vrr_stack+1081, NULL, NULL, vrr_stack+0);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+15820, vrr_stack+8906, vrr_stack+1186, vrr_stack+3697, vrr_stack+8801, vrr_stack+178);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+16450, vrr_stack+14560, vrr_stack+15820, vrr_stack+451, vrr_stack+8906, vrr_stack+12194);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+17500, vrr_stack+15190, vrr_stack+14560, vrr_stack+766, vrr_stack+451, vrr_stack+11102);
   tmp = vrr_stack + 17500;
   target_ptr = Libint->vrr_classes[3][13];
   for(i=0;i<1050;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+766, vrr_stack+3697, vrr_stack+8801, vrr_stack+8099, vrr_stack+5915, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+886, vrr_stack+3802, vrr_stack+3697, vrr_stack+8190, vrr_stack+8099, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+12194, vrr_stack+8801, vrr_stack+1081, vrr_stack+5915, vrr_stack+0, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+12314, vrr_stack+766, vrr_stack+12194, NULL, NULL, vrr_stack+8801);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1501, vrr_stack+886, vrr_stack+766, NULL, NULL, vrr_stack+3697);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+18550, vrr_stack+1501, vrr_stack+12314, vrr_stack+886, vrr_stack+766, vrr_stack+8906);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8906, vrr_stack+6006, vrr_stack+3802, vrr_stack+3606, vrr_stack+8190, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+19270, vrr_stack+8906, vrr_stack+886, NULL, NULL, vrr_stack+3802);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+19630, vrr_stack+19270, vrr_stack+1501, vrr_stack+8906, vrr_stack+886, vrr_stack+451);
 _BUILD_00p0(Data,vrr_stack+3606, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3609, vrr_stack+10829, vrr_stack+3606, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+3615, vrr_stack+10832, vrr_stack+3609, vrr_stack+3970, vrr_stack+10829, NULL);
 _BUILD_00g0(Data,vrr_stack+3625, vrr_stack+10838, vrr_stack+3615, vrr_stack+3973, vrr_stack+10832, NULL);
 _BUILD_00h0(Data,vrr_stack+3640, vrr_stack+10848, vrr_stack+3625, vrr_stack+3979, vrr_stack+10838, NULL);
 _BUILD_00i0(Data,vrr_stack+3661, vrr_stack+10863, vrr_stack+3640, vrr_stack+3989, vrr_stack+10848, NULL);
 _BUILD_00k0(Data,vrr_stack+9026, vrr_stack+10884, vrr_stack+3661, vrr_stack+3033, vrr_stack+10863, NULL);
 _BUILD_00l0(Data,vrr_stack+9062, vrr_stack+10912, vrr_stack+9026, vrr_stack+3054, vrr_stack+10884, NULL);
 _BUILD_00m0(Data,vrr_stack+9107, vrr_stack+10948, vrr_stack+9062, vrr_stack+3082, vrr_stack+10912, NULL);
 _BUILD_00n0(Data,vrr_stack+12674, vrr_stack+10993, vrr_stack+9107, vrr_stack+2538, vrr_stack+10948, NULL);
 _BUILD_00o0(Data,vrr_stack+3033, vrr_stack+6111, vrr_stack+12674, vrr_stack+3118, vrr_stack+10993, NULL);
 _BUILD_00q0(Data,vrr_stack+5915, vrr_stack+3528, vrr_stack+3033, vrr_stack+2583, vrr_stack+6111, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2538, vrr_stack+6177, vrr_stack+5915, vrr_stack+100, vrr_stack+3528, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8099, vrr_stack+1081, vrr_stack+2538, vrr_stack+0, vrr_stack+6177, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+12194, vrr_stack+8099, NULL, NULL, vrr_stack+1081);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+20350, vrr_stack+12314, vrr_stack+0, vrr_stack+766, vrr_stack+12194, vrr_stack+1186);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+21070, vrr_stack+18550, vrr_stack+20350, vrr_stack+1501, vrr_stack+12314, vrr_stack+15820);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+22270, vrr_stack+19630, vrr_stack+18550, vrr_stack+19270, vrr_stack+1501, vrr_stack+14560);
   tmp = vrr_stack + 22270;
   target_ptr = Libint->vrr_classes[3][14];
   for(i=0;i<1200;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+19270, vrr_stack+766, vrr_stack+12194, vrr_stack+3697, vrr_stack+8801, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+19406, vrr_stack+886, vrr_stack+766, vrr_stack+3802, vrr_stack+3697, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15820, vrr_stack+12194, vrr_stack+8099, vrr_stack+8801, vrr_stack+1081, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15956, vrr_stack+19270, vrr_stack+15820, NULL, NULL, vrr_stack+12194);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+23470, vrr_stack+19406, vrr_stack+19270, NULL, NULL, vrr_stack+766);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+23878, vrr_stack+23470, vrr_stack+15956, vrr_stack+19406, vrr_stack+19270, vrr_stack+12314);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+12314, vrr_stack+8906, vrr_stack+886, vrr_stack+6006, vrr_stack+3802, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+24694, vrr_stack+12314, vrr_stack+19406, NULL, NULL, vrr_stack+886);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25102, vrr_stack+24694, vrr_stack+23470, vrr_stack+12314, vrr_stack+19406, vrr_stack+1501);
 _BUILD_00p0(Data,vrr_stack+6006, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6009, vrr_stack+3606, vrr_stack+6006, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+6015, vrr_stack+3609, vrr_stack+6009, vrr_stack+10829, vrr_stack+3606, NULL);
 _BUILD_00g0(Data,vrr_stack+6025, vrr_stack+3615, vrr_stack+6015, vrr_stack+10832, vrr_stack+3609, NULL);
 _BUILD_00h0(Data,vrr_stack+6040, vrr_stack+3625, vrr_stack+6025, vrr_stack+10838, vrr_stack+3615, NULL);
 _BUILD_00i0(Data,vrr_stack+6061, vrr_stack+3640, vrr_stack+6040, vrr_stack+10848, vrr_stack+3625, NULL);
 _BUILD_00k0(Data,vrr_stack+12450, vrr_stack+3661, vrr_stack+6061, vrr_stack+10863, vrr_stack+3640, NULL);
 _BUILD_00l0(Data,vrr_stack+10829, vrr_stack+9026, vrr_stack+12450, vrr_stack+10884, vrr_stack+3661, NULL);
 _BUILD_00m0(Data,vrr_stack+12486, vrr_stack+9062, vrr_stack+10829, vrr_stack+10912, vrr_stack+9026, NULL);
 _BUILD_00n0(Data,vrr_stack+10874, vrr_stack+9107, vrr_stack+12486, vrr_stack+10948, vrr_stack+9062, NULL);
 _BUILD_00o0(Data,vrr_stack+12541, vrr_stack+12674, vrr_stack+10874, vrr_stack+10993, vrr_stack+9107, NULL);
 _BUILD_00q0(Data,vrr_stack+10940, vrr_stack+3033, vrr_stack+12541, vrr_stack+6111, vrr_stack+12674, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8801, vrr_stack+5915, vrr_stack+10940, vrr_stack+3528, vrr_stack+3033, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+1186, vrr_stack+2538, vrr_stack+8801, vrr_stack+6177, vrr_stack+5915, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6089, vrr_stack+8099, vrr_stack+1186, vrr_stack+1081, vrr_stack+2538, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+1306, vrr_stack+15820, vrr_stack+6089, NULL, NULL, vrr_stack+8099);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+25918, vrr_stack+15956, vrr_stack+1306, vrr_stack+19270, vrr_stack+15820, vrr_stack+0);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+26734, vrr_stack+23878, vrr_stack+25918, vrr_stack+23470, vrr_stack+15956, vrr_stack+20350);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+28094, vrr_stack+25102, vrr_stack+23878, vrr_stack+24694, vrr_stack+23470, vrr_stack+18550);
   tmp = vrr_stack + 28094;
   target_ptr = Libint->vrr_classes[3][15];
   for(i=0;i<1360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+24694, vrr_stack+19270, vrr_stack+15820, vrr_stack+766, vrr_stack+12194, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+24847, vrr_stack+19406, vrr_stack+19270, vrr_stack+886, vrr_stack+766, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+20350, vrr_stack+15820, vrr_stack+6089, vrr_stack+12194, vrr_stack+8099, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+20503, vrr_stack+24694, vrr_stack+20350, NULL, NULL, vrr_stack+15820);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+24847, vrr_stack+24694, NULL, NULL, vrr_stack+19270);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+29454, vrr_stack+0, vrr_stack+20503, vrr_stack+24847, vrr_stack+24694, vrr_stack+15956);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+15956, vrr_stack+12314, vrr_stack+19406, vrr_stack+8906, vrr_stack+886, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+459, vrr_stack+15956, vrr_stack+24847, NULL, NULL, vrr_stack+19406);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+30372, vrr_stack+459, vrr_stack+0, vrr_stack+15956, vrr_stack+24847, vrr_stack+23470);
 _BUILD_00p0(Data,vrr_stack+23470, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+23473, vrr_stack+6006, vrr_stack+23470, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+23479, vrr_stack+6009, vrr_stack+23473, vrr_stack+3606, vrr_stack+6006, NULL);
 _BUILD_00g0(Data,vrr_stack+23489, vrr_stack+6015, vrr_stack+23479, vrr_stack+3609, vrr_stack+6009, NULL);
 _BUILD_00h0(Data,vrr_stack+23504, vrr_stack+6025, vrr_stack+23489, vrr_stack+3615, vrr_stack+6015, NULL);
 _BUILD_00i0(Data,vrr_stack+23525, vrr_stack+6040, vrr_stack+23504, vrr_stack+3625, vrr_stack+6025, NULL);
 _BUILD_00k0(Data,vrr_stack+23553, vrr_stack+6061, vrr_stack+23525, vrr_stack+3640, vrr_stack+6040, NULL);
 _BUILD_00l0(Data,vrr_stack+23589, vrr_stack+12450, vrr_stack+23553, vrr_stack+3661, vrr_stack+6061, NULL);
 _BUILD_00m0(Data,vrr_stack+12619, vrr_stack+10829, vrr_stack+23589, vrr_stack+9026, vrr_stack+12450, NULL);
 _BUILD_00n0(Data,vrr_stack+23634, vrr_stack+12486, vrr_stack+12619, vrr_stack+9062, vrr_stack+10829, NULL);
 _BUILD_00o0(Data,vrr_stack+23700, vrr_stack+10874, vrr_stack+23634, vrr_stack+9107, vrr_stack+12486, NULL);
 _BUILD_00q0(Data,vrr_stack+23778, vrr_stack+12541, vrr_stack+23700, vrr_stack+12674, vrr_stack+10874, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8906, vrr_stack+10940, vrr_stack+23778, vrr_stack+3033, vrr_stack+12541, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+12194, vrr_stack+8801, vrr_stack+8906, vrr_stack+5915, vrr_stack+10940, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+3033, vrr_stack+1186, vrr_stack+12194, vrr_stack+2538, vrr_stack+8801, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+2538, vrr_stack+6089, vrr_stack+3033, vrr_stack+8099, vrr_stack+1186, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3528, vrr_stack+20350, vrr_stack+2538, NULL, NULL, vrr_stack+6089);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+31290, vrr_stack+20503, vrr_stack+3528, vrr_stack+24694, vrr_stack+20350, vrr_stack+1306);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+32208, vrr_stack+29454, vrr_stack+31290, vrr_stack+0, vrr_stack+20503, vrr_stack+25918);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+33738, vrr_stack+30372, vrr_stack+29454, vrr_stack+459, vrr_stack+0, vrr_stack+23878);
   tmp = vrr_stack + 33738;
   target_ptr = Libint->vrr_classes[3][16];
   for(i=0;i<1530;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+459, vrr_stack+24694, vrr_stack+20350, vrr_stack+19270, vrr_stack+15820, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+630, vrr_stack+24847, vrr_stack+24694, vrr_stack+19406, vrr_stack+19270, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+801, vrr_stack+20350, vrr_stack+2538, vrr_stack+15820, vrr_stack+6089, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+25918, vrr_stack+459, vrr_stack+801, NULL, NULL, vrr_stack+20350);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+1306, vrr_stack+630, vrr_stack+459, NULL, NULL, vrr_stack+24694);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+35268, vrr_stack+1306, vrr_stack+25918, vrr_stack+630, vrr_stack+459, vrr_stack+20503);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+20350, vrr_stack+15956, vrr_stack+24847, vrr_stack+12314, vrr_stack+19406, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+20521, vrr_stack+20350, vrr_stack+630, NULL, NULL, vrr_stack+24847);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+36294, vrr_stack+20521, vrr_stack+1306, vrr_stack+20350, vrr_stack+630, vrr_stack+0);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+23470, vrr_stack+0, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+9, vrr_stack+23473, vrr_stack+3, vrr_stack+6006, vrr_stack+23470, NULL);
 _BUILD_00g0(Data,vrr_stack+19, vrr_stack+23479, vrr_stack+9, vrr_stack+6009, vrr_stack+23473, NULL);
 _BUILD_00h0(Data,vrr_stack+34, vrr_stack+23489, vrr_stack+19, vrr_stack+6015, vrr_stack+23479, NULL);
 _BUILD_00i0(Data,vrr_stack+0, vrr_stack+23504, vrr_stack+34, vrr_stack+6025, vrr_stack+23489, NULL);
 _BUILD_00k0(Data,vrr_stack+21034, vrr_stack+23525, vrr_stack+0, vrr_stack+6040, vrr_stack+23504, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+23553, vrr_stack+21034, vrr_stack+6061, vrr_stack+23525, NULL);
 _BUILD_00m0(Data,vrr_stack+45, vrr_stack+23589, vrr_stack+0, vrr_stack+12450, vrr_stack+23553, NULL);
 _BUILD_00n0(Data,vrr_stack+12674, vrr_stack+12619, vrr_stack+45, vrr_stack+10829, vrr_stack+23589, NULL);
 _BUILD_00o0(Data,vrr_stack+0, vrr_stack+23634, vrr_stack+12674, vrr_stack+12486, vrr_stack+12619, NULL);
 _BUILD_00q0(Data,vrr_stack+12619, vrr_stack+23700, vrr_stack+0, vrr_stack+10874, vrr_stack+23634, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+23778, vrr_stack+12619, vrr_stack+12541, vrr_stack+23700, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+105, vrr_stack+8906, vrr_stack+0, vrr_stack+10940, vrr_stack+23778, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+225, vrr_stack+12194, vrr_stack+105, vrr_stack+8801, vrr_stack+8906, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+8801, vrr_stack+3033, vrr_stack+225, vrr_stack+1186, vrr_stack+12194, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+630, vrr_stack+2538, vrr_stack+8801, vrr_stack+6089, vrr_stack+3033, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+12194, vrr_stack+801, vrr_stack+630, NULL, NULL, vrr_stack+2538);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+37320, vrr_stack+25918, vrr_stack+12194, vrr_stack+459, vrr_stack+801, vrr_stack+3528);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+38346, vrr_stack+35268, vrr_stack+37320, vrr_stack+1306, vrr_stack+25918, vrr_stack+31290);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+40056, vrr_stack+36294, vrr_stack+35268, vrr_stack+20521, vrr_stack+1306, vrr_stack+29454);
   tmp = vrr_stack + 40056;
   target_ptr = Libint->vrr_classes[3][17];
   for(i=0;i<1710;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0m0(Data,vrr_stack+31290, vrr_stack+4573, vrr_stack+4023, vrr_stack+3198, vrr_stack+2703, vrr_stack+2088);
   tmp = vrr_stack + 31290;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0n0(Data,vrr_stack+37320, vrr_stack+6971, vrr_stack+6311, vrr_stack+5519, vrr_stack+5123, vrr_stack+4023);
   tmp = vrr_stack + 37320;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0o0(Data,vrr_stack+0, vrr_stack+10049, vrr_stack+9269, vrr_stack+8333, vrr_stack+7631, vrr_stack+6311);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0q0(Data,vrr_stack+1170, vrr_stack+13650, vrr_stack+12740, vrr_stack+11648, vrr_stack+11102, vrr_stack+9269);
   tmp = vrr_stack + 1170;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2535, vrr_stack+17500, vrr_stack+16450, vrr_stack+15190, vrr_stack+14560, vrr_stack+12740);
   tmp = vrr_stack + 2535;
   target_ptr = Libint->vrr_classes[4][13];
   for(i=0;i<1575;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4110, vrr_stack+22270, vrr_stack+21070, vrr_stack+19630, vrr_stack+18550, vrr_stack+16450);
   tmp = vrr_stack + 4110;
   target_ptr = Libint->vrr_classes[4][14];
   for(i=0;i<1800;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+5910, vrr_stack+28094, vrr_stack+26734, vrr_stack+25102, vrr_stack+23878, vrr_stack+21070);
   tmp = vrr_stack + 5910;
   target_ptr = Libint->vrr_classes[4][15];
   for(i=0;i<2040;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+7950, vrr_stack+33738, vrr_stack+32208, vrr_stack+30372, vrr_stack+29454, vrr_stack+26734);
   tmp = vrr_stack + 7950;
   target_ptr = Libint->vrr_classes[4][16];
   for(i=0;i<2295;i++)
     target_ptr[i] += tmp[i];
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+10245, vrr_stack+40056, vrr_stack+38346, vrr_stack+36294, vrr_stack+35268, vrr_stack+32208);
   tmp = vrr_stack + 10245;
   target_ptr = Libint->vrr_classes[4][17];
   for(i=0;i<2565;i++)
     target_ptr[i] += tmp[i];

}

