/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (fp|np) integrals */

void vrr_order_fpnp(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+6, Data->F+7, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+12, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_00p0(Data,vrr_stack+21, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+24, vrr_stack+0, vrr_stack+21, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+30, vrr_stack+6, vrr_stack+24, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+12, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+30, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+3, vrr_stack+12, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+3, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+40, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+21, vrr_stack+12, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+96, vrr_stack+24, vrr_stack+15, vrr_stack+0, vrr_stack+21, NULL);
 _BUILD_00g0(Data,vrr_stack+106, vrr_stack+30, vrr_stack+96, vrr_stack+6, vrr_stack+24, NULL);
 _BUILD_00h0(Data,vrr_stack+121, vrr_stack+50, vrr_stack+106, vrr_stack+40, vrr_stack+30, NULL);
 _BUILD_00h0(Data,vrr_stack+142, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+163, vrr_stack+142, vrr_stack+121, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+12, vrr_stack+0, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+15, vrr_stack+6, vrr_stack+21, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+191, vrr_stack+96, vrr_stack+40, vrr_stack+24, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+206, vrr_stack+106, vrr_stack+191, vrr_stack+30, vrr_stack+96, NULL);
 _BUILD_00i0(Data,vrr_stack+227, vrr_stack+121, vrr_stack+206, vrr_stack+50, vrr_stack+106, NULL);
 _BUILD_00k0(Data,vrr_stack+255, vrr_stack+163, vrr_stack+227, vrr_stack+142, vrr_stack+121, NULL);
 _BUILD_00p0(Data,vrr_stack+50, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+53, vrr_stack+50, vrr_stack+3, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+53, vrr_stack+65, vrr_stack+50, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+291, vrr_stack+21, vrr_stack+71, vrr_stack+53, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+306, vrr_stack+291, vrr_stack+81, vrr_stack+21, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+327, vrr_stack+306, vrr_stack+142, vrr_stack+291, vrr_stack+81, NULL);
 _BUILD_00k0(Data,vrr_stack+59, vrr_stack+327, vrr_stack+163, vrr_stack+306, vrr_stack+142, NULL);
 _BUILD_p0k0(Data,vrr_stack+355, vrr_stack+59, vrr_stack+255, NULL, NULL, vrr_stack+163);
 _BUILD_00l0(Data,vrr_stack+463, vrr_stack+59, vrr_stack+255, vrr_stack+327, vrr_stack+163, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+142, vrr_stack+3, vrr_stack+50, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+148, vrr_stack+142, vrr_stack+53, vrr_stack+3, vrr_stack+50, NULL);
 _BUILD_00g0(Data,vrr_stack+508, vrr_stack+148, vrr_stack+21, vrr_stack+142, vrr_stack+53, NULL);
 _BUILD_00h0(Data,vrr_stack+523, vrr_stack+508, vrr_stack+291, vrr_stack+148, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+544, vrr_stack+523, vrr_stack+306, vrr_stack+508, vrr_stack+291, NULL);
 _BUILD_00k0(Data,vrr_stack+572, vrr_stack+544, vrr_stack+327, vrr_stack+523, vrr_stack+306, NULL);
 _BUILD_00l0(Data,vrr_stack+608, vrr_stack+572, vrr_stack+59, vrr_stack+544, vrr_stack+327, NULL);
 _BUILD_00p0(Data,vrr_stack+291, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+294, vrr_stack+0, vrr_stack+291, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+300, vrr_stack+6, vrr_stack+294, vrr_stack+12, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+310, vrr_stack+40, vrr_stack+300, vrr_stack+15, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+12, vrr_stack+191, vrr_stack+310, vrr_stack+96, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+325, vrr_stack+206, vrr_stack+12, vrr_stack+106, vrr_stack+191, NULL);
 _BUILD_00k0(Data,vrr_stack+653, vrr_stack+227, vrr_stack+325, vrr_stack+121, vrr_stack+206, NULL);
 _BUILD_00l0(Data,vrr_stack+95, vrr_stack+255, vrr_stack+653, vrr_stack+163, vrr_stack+227, NULL);
 _BUILD_p0l0(Data,vrr_stack+689, vrr_stack+463, vrr_stack+95, NULL, NULL, vrr_stack+255);
 _BUILD_p0l0(Data,vrr_stack+824, vrr_stack+608, vrr_stack+463, NULL, NULL, vrr_stack+59);
 _BUILD_d0l0(Data,vrr_stack+959, vrr_stack+824, vrr_stack+689, vrr_stack+608, vrr_stack+463, vrr_stack+355);
 _BUILD_00m0(Data,vrr_stack+353, vrr_stack+463, vrr_stack+95, vrr_stack+59, vrr_stack+255, NULL);
 _BUILD_00m0(Data,vrr_stack+408, vrr_stack+608, vrr_stack+463, vrr_stack+572, vrr_stack+59, NULL);
 _BUILD_p0m0(Data,vrr_stack+1229, vrr_stack+408, vrr_stack+353, NULL, NULL, vrr_stack+463);
 _BUILD_00p0(Data,vrr_stack+33, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+50, vrr_stack+33, vrr_stack+3, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+56, vrr_stack+50, vrr_stack+142, vrr_stack+33, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+66, vrr_stack+56, vrr_stack+148, vrr_stack+50, vrr_stack+142, NULL);
 _BUILD_00h0(Data,vrr_stack+158, vrr_stack+66, vrr_stack+508, vrr_stack+56, vrr_stack+148, NULL);
 _BUILD_00i0(Data,vrr_stack+1394, vrr_stack+158, vrr_stack+523, vrr_stack+66, vrr_stack+508, NULL);
 _BUILD_00k0(Data,vrr_stack+1422, vrr_stack+1394, vrr_stack+544, vrr_stack+158, vrr_stack+523, NULL);
 _BUILD_00l0(Data,vrr_stack+1458, vrr_stack+1422, vrr_stack+572, vrr_stack+1394, vrr_stack+544, NULL);
 _BUILD_00m0(Data,vrr_stack+508, vrr_stack+1458, vrr_stack+608, vrr_stack+1422, vrr_stack+572, NULL);
 _BUILD_p0m0(Data,vrr_stack+1503, vrr_stack+508, vrr_stack+408, NULL, NULL, vrr_stack+608);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+563, vrr_stack+291, vrr_stack+3, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+569, vrr_stack+294, vrr_stack+563, vrr_stack+0, vrr_stack+291, NULL);
 _BUILD_00g0(Data,vrr_stack+579, vrr_stack+300, vrr_stack+569, vrr_stack+6, vrr_stack+294, NULL);
 _BUILD_00h0(Data,vrr_stack+1668, vrr_stack+310, vrr_stack+579, vrr_stack+40, vrr_stack+300, NULL);
 _BUILD_00i0(Data,vrr_stack+1689, vrr_stack+12, vrr_stack+1668, vrr_stack+191, vrr_stack+310, NULL);
 _BUILD_00k0(Data,vrr_stack+1717, vrr_stack+325, vrr_stack+1689, vrr_stack+206, vrr_stack+12, NULL);
 _BUILD_00l0(Data,vrr_stack+179, vrr_stack+653, vrr_stack+1717, vrr_stack+227, vrr_stack+325, NULL);
 _BUILD_00m0(Data,vrr_stack+1753, vrr_stack+95, vrr_stack+179, vrr_stack+255, vrr_stack+653, NULL);
 _BUILD_p0m0(Data,vrr_stack+1808, vrr_stack+353, vrr_stack+1753, NULL, NULL, vrr_stack+95);
 _BUILD_d0m0(Data,vrr_stack+1973, vrr_stack+1229, vrr_stack+1808, vrr_stack+408, vrr_stack+353, vrr_stack+689);
 _BUILD_d0m0(Data,vrr_stack+2303, vrr_stack+1503, vrr_stack+1229, vrr_stack+508, vrr_stack+408, vrr_stack+824);
 _BUILD_f0m0(Data,vrr_stack+2633, vrr_stack+2303, vrr_stack+1973, vrr_stack+1503, vrr_stack+1229, vrr_stack+959);
 _BUILD_00n0(Data,vrr_stack+689, vrr_stack+408, vrr_stack+353, vrr_stack+608, vrr_stack+463, NULL);
 _BUILD_00n0(Data,vrr_stack+755, vrr_stack+508, vrr_stack+408, vrr_stack+1458, vrr_stack+608, NULL);
 _BUILD_00n0(Data,vrr_stack+821, vrr_stack+353, vrr_stack+1753, vrr_stack+463, vrr_stack+95, NULL);
 _BUILD_p0n0(Data,vrr_stack+887, vrr_stack+689, vrr_stack+821, NULL, NULL, vrr_stack+353);
 _BUILD_p0n0(Data,vrr_stack+3183, vrr_stack+755, vrr_stack+689, NULL, NULL, vrr_stack+408);
 _BUILD_d0n0(Data,vrr_stack+3381, vrr_stack+3183, vrr_stack+887, vrr_stack+755, vrr_stack+689, vrr_stack+1229);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+33, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+463, vrr_stack+6, vrr_stack+50, vrr_stack+0, vrr_stack+33, NULL);
 _BUILD_00g0(Data,vrr_stack+33, vrr_stack+463, vrr_stack+56, vrr_stack+6, vrr_stack+50, NULL);
 _BUILD_00h0(Data,vrr_stack+473, vrr_stack+33, vrr_stack+66, vrr_stack+463, vrr_stack+56, NULL);
 _BUILD_00i0(Data,vrr_stack+1085, vrr_stack+473, vrr_stack+158, vrr_stack+33, vrr_stack+66, NULL);
 _BUILD_00k0(Data,vrr_stack+33, vrr_stack+1085, vrr_stack+1394, vrr_stack+473, vrr_stack+158, NULL);
 _BUILD_00l0(Data,vrr_stack+463, vrr_stack+33, vrr_stack+1422, vrr_stack+1085, vrr_stack+1394, NULL);
 _BUILD_00m0(Data,vrr_stack+1085, vrr_stack+463, vrr_stack+1458, vrr_stack+33, vrr_stack+1422, NULL);
 _BUILD_00n0(Data,vrr_stack+1140, vrr_stack+1085, vrr_stack+508, vrr_stack+463, vrr_stack+1458, NULL);
 _BUILD_p0n0(Data,vrr_stack+1206, vrr_stack+1140, vrr_stack+755, NULL, NULL, vrr_stack+508);
 _BUILD_d0n0(Data,vrr_stack+3777, vrr_stack+1206, vrr_stack+3183, vrr_stack+1140, vrr_stack+755, vrr_stack+1503);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+463, vrr_stack+563, vrr_stack+6, vrr_stack+291, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+473, vrr_stack+569, vrr_stack+463, vrr_stack+294, vrr_stack+563, NULL);
 _BUILD_00h0(Data,vrr_stack+33, vrr_stack+579, vrr_stack+473, vrr_stack+300, vrr_stack+569, NULL);
 _BUILD_00i0(Data,vrr_stack+54, vrr_stack+1668, vrr_stack+33, vrr_stack+310, vrr_stack+579, NULL);
 _BUILD_00k0(Data,vrr_stack+1404, vrr_stack+1689, vrr_stack+54, vrr_stack+12, vrr_stack+1668, NULL);
 _BUILD_00l0(Data,vrr_stack+1440, vrr_stack+1717, vrr_stack+1404, vrr_stack+325, vrr_stack+1689, NULL);
 _BUILD_00m0(Data,vrr_stack+1485, vrr_stack+179, vrr_stack+1440, vrr_stack+653, vrr_stack+1717, NULL);
 _BUILD_00n0(Data,vrr_stack+1540, vrr_stack+1753, vrr_stack+1485, vrr_stack+95, vrr_stack+179, NULL);
 _BUILD_p0n0(Data,vrr_stack+4173, vrr_stack+821, vrr_stack+1540, NULL, NULL, vrr_stack+1753);
 _BUILD_d0n0(Data,vrr_stack+4371, vrr_stack+887, vrr_stack+4173, vrr_stack+689, vrr_stack+821, vrr_stack+1808);
 _BUILD_f0n0(Data,vrr_stack+4767, vrr_stack+3381, vrr_stack+4371, vrr_stack+3183, vrr_stack+887, vrr_stack+1973);
 _BUILD_f0n0(Data,vrr_stack+5427, vrr_stack+3777, vrr_stack+3381, vrr_stack+1206, vrr_stack+3183, vrr_stack+2303);
   tmp = vrr_stack + 5427;
   target_ptr = Libint->vrr_classes[3][10];
   for(i=0;i<660;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+1206, vrr_stack+689, vrr_stack+821, vrr_stack+408, vrr_stack+353, NULL);
 _BUILD_00o0(Data,vrr_stack+1284, vrr_stack+755, vrr_stack+689, vrr_stack+508, vrr_stack+408, NULL);
 _BUILD_00o0(Data,vrr_stack+1808, vrr_stack+821, vrr_stack+1540, vrr_stack+353, vrr_stack+1753, NULL);
 _BUILD_p0o0(Data,vrr_stack+1886, vrr_stack+1206, vrr_stack+1808, NULL, NULL, vrr_stack+821);
 _BUILD_p0o0(Data,vrr_stack+2120, vrr_stack+1284, vrr_stack+1206, NULL, NULL, vrr_stack+689);
 _BUILD_d0o0(Data,vrr_stack+6087, vrr_stack+2120, vrr_stack+1886, vrr_stack+1284, vrr_stack+1206, vrr_stack+887);
 _BUILD_00o0(Data,vrr_stack+821, vrr_stack+1140, vrr_stack+755, vrr_stack+1085, vrr_stack+508, NULL);
 _BUILD_p0o0(Data,vrr_stack+899, vrr_stack+821, vrr_stack+1284, NULL, NULL, vrr_stack+755);
 _BUILD_d0o0(Data,vrr_stack+6555, vrr_stack+899, vrr_stack+2120, vrr_stack+821, vrr_stack+1284, vrr_stack+3183);
 _BUILD_00p0(Data,vrr_stack+3183, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3186, vrr_stack+0, vrr_stack+3183, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+3192, vrr_stack+6, vrr_stack+3186, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3202, vrr_stack+463, vrr_stack+3192, vrr_stack+563, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+473, vrr_stack+3202, vrr_stack+569, vrr_stack+463, NULL);
 _BUILD_00i0(Data,vrr_stack+3183, vrr_stack+33, vrr_stack+0, vrr_stack+579, vrr_stack+473, NULL);
 _BUILD_00k0(Data,vrr_stack+3211, vrr_stack+54, vrr_stack+3183, vrr_stack+1668, vrr_stack+33, NULL);
 _BUILD_00l0(Data,vrr_stack+0, vrr_stack+1404, vrr_stack+3211, vrr_stack+1689, vrr_stack+54, NULL);
 _BUILD_00m0(Data,vrr_stack+3183, vrr_stack+1440, vrr_stack+0, vrr_stack+1717, vrr_stack+1404, NULL);
 _BUILD_00n0(Data,vrr_stack+0, vrr_stack+1485, vrr_stack+3183, vrr_stack+179, vrr_stack+1440, NULL);
 _BUILD_00o0(Data,vrr_stack+3183, vrr_stack+1540, vrr_stack+0, vrr_stack+1753, vrr_stack+1485, NULL);
 _BUILD_p0o0(Data,vrr_stack+0, vrr_stack+1808, vrr_stack+3183, NULL, NULL, vrr_stack+1540);
 _BUILD_d0o0(Data,vrr_stack+234, vrr_stack+1886, vrr_stack+0, vrr_stack+1206, vrr_stack+1808, vrr_stack+4173);
 _BUILD_f0o0(Data,vrr_stack+7023, vrr_stack+6087, vrr_stack+234, vrr_stack+2120, vrr_stack+1886, vrr_stack+4371);
 _BUILD_f0o0(Data,vrr_stack+0, vrr_stack+6555, vrr_stack+6087, vrr_stack+899, vrr_stack+2120, vrr_stack+3381);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[3][11];
   for(i=0;i<780;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0n0(Data,vrr_stack+780, vrr_stack+5427, vrr_stack+4767, vrr_stack+3777, vrr_stack+3381, vrr_stack+2633);
   tmp = vrr_stack + 780;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_g0o0(Data,vrr_stack+1770, vrr_stack+0, vrr_stack+7023, vrr_stack+6555, vrr_stack+6087, vrr_stack+4767);
   tmp = vrr_stack + 1770;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];

}

