/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (gf|ii) integrals */

void vrr_order_gfii(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+12, vrr_stack+3, vrr_stack+9, NULL, NULL, Data->F+7);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+3, NULL, NULL, Data->F+6);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+21, vrr_stack+12, vrr_stack+6, vrr_stack+3, vrr_stack+0);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+3, vrr_stack+9, Data->F+6, Data->F+7, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+6, vrr_stack+3, Data->F+5, Data->F+6, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+6, Data->F+4, Data->F+5, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+102, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+105, vrr_stack+9, vrr_stack+102, Data->F+7, Data->F+8, NULL);
 _BUILD_p0d0(Data,vrr_stack+111, vrr_stack+48, vrr_stack+105, NULL, NULL, vrr_stack+9);
 _BUILD_d0d0(Data,vrr_stack+129, vrr_stack+60, vrr_stack+111, vrr_stack+54, vrr_stack+48, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+165, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+201, vrr_stack+165, vrr_stack+129, vrr_stack+84, vrr_stack+60, vrr_stack+30);
 _BUILD_00f0(Data,vrr_stack+12, vrr_stack+54, vrr_stack+48, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00f0(Data,vrr_stack+22, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00f0(Data,vrr_stack+32, vrr_stack+48, vrr_stack+105, vrr_stack+3, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+261, vrr_stack+12, vrr_stack+32, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+291, vrr_stack+22, vrr_stack+12, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+321, vrr_stack+291, vrr_stack+261, vrr_stack+22, vrr_stack+12, vrr_stack+60);
 _BUILD_00p0(Data,vrr_stack+60, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+60, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+63, vrr_stack+3, vrr_stack+78, vrr_stack+60, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+381, vrr_stack+63, vrr_stack+22, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+411, vrr_stack+381, vrr_stack+291, vrr_stack+63, vrr_stack+22, vrr_stack+84);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42, vrr_stack+102, vrr_stack+0, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+105, vrr_stack+42, vrr_stack+9, vrr_stack+102, NULL);
 _BUILD_p0f0(Data,vrr_stack+471, vrr_stack+32, vrr_stack+84, NULL, NULL, vrr_stack+105);
 _BUILD_d0f0(Data,vrr_stack+501, vrr_stack+261, vrr_stack+471, vrr_stack+12, vrr_stack+32, vrr_stack+111);
 _BUILD_f0f0(Data,vrr_stack+561, vrr_stack+321, vrr_stack+501, vrr_stack+291, vrr_stack+261, vrr_stack+129);
 _BUILD_f0f0(Data,vrr_stack+661, vrr_stack+411, vrr_stack+321, vrr_stack+381, vrr_stack+291, vrr_stack+165);
 _BUILD_g0f0(Data,vrr_stack+761, vrr_stack+661, vrr_stack+561, vrr_stack+411, vrr_stack+321, vrr_stack+201);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+12, vrr_stack+32, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+126, vrr_stack+22, vrr_stack+12, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+141, vrr_stack+126, vrr_stack+111, NULL, NULL, vrr_stack+12);
 _BUILD_00g0(Data,vrr_stack+186, vrr_stack+63, vrr_stack+22, vrr_stack+3, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+201, vrr_stack+186, vrr_stack+126, NULL, NULL, vrr_stack+22);
 _BUILD_00g0(Data,vrr_stack+246, vrr_stack+32, vrr_stack+84, vrr_stack+48, vrr_stack+105, NULL);
 _BUILD_p0g0(Data,vrr_stack+911, vrr_stack+111, vrr_stack+246, NULL, NULL, vrr_stack+32);
 _BUILD_d0g0(Data,vrr_stack+956, vrr_stack+141, vrr_stack+911, vrr_stack+126, vrr_stack+111, vrr_stack+261);
 _BUILD_d0g0(Data,vrr_stack+1046, vrr_stack+201, vrr_stack+141, vrr_stack+186, vrr_stack+126, vrr_stack+291);
 _BUILD_f0g0(Data,vrr_stack+1136, vrr_stack+1046, vrr_stack+956, vrr_stack+201, vrr_stack+141, vrr_stack+321);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+261, vrr_stack+9, vrr_stack+60, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+267, vrr_stack+261, vrr_stack+3, vrr_stack+9, vrr_stack+60, NULL);
 _BUILD_00g0(Data,vrr_stack+48, vrr_stack+267, vrr_stack+63, vrr_stack+261, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+277, vrr_stack+48, vrr_stack+186, NULL, NULL, vrr_stack+63);
 _BUILD_d0g0(Data,vrr_stack+1286, vrr_stack+277, vrr_stack+201, vrr_stack+48, vrr_stack+186, vrr_stack+381);
 _BUILD_f0g0(Data,vrr_stack+1376, vrr_stack+1286, vrr_stack+1046, vrr_stack+277, vrr_stack+201, vrr_stack+411);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+322, vrr_stack+0, vrr_stack+3, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+328, vrr_stack+42, vrr_stack+322, vrr_stack+102, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+338, vrr_stack+84, vrr_stack+328, vrr_stack+105, vrr_stack+42, NULL);
 _BUILD_p0g0(Data,vrr_stack+353, vrr_stack+246, vrr_stack+338, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+1526, vrr_stack+911, vrr_stack+353, vrr_stack+111, vrr_stack+246, vrr_stack+471);
 _BUILD_f0g0(Data,vrr_stack+1616, vrr_stack+956, vrr_stack+1526, vrr_stack+141, vrr_stack+911, vrr_stack+501);
 _BUILD_g0g0(Data,vrr_stack+1766, vrr_stack+1136, vrr_stack+1616, vrr_stack+1046, vrr_stack+956, vrr_stack+561);
 _BUILD_g0g0(Data,vrr_stack+398, vrr_stack+1376, vrr_stack+1136, vrr_stack+1286, vrr_stack+1046, vrr_stack+661);
 _BUILD_h0g0(Data,vrr_stack+1991, vrr_stack+398, vrr_stack+1766, vrr_stack+1376, vrr_stack+1136, vrr_stack+761);
 _BUILD_00h0(Data,vrr_stack+623, vrr_stack+126, vrr_stack+111, vrr_stack+22, vrr_stack+12, NULL);
 _BUILD_00h0(Data,vrr_stack+644, vrr_stack+186, vrr_stack+126, vrr_stack+63, vrr_stack+22, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+111, vrr_stack+246, vrr_stack+12, vrr_stack+32, NULL);
 _BUILD_p0h0(Data,vrr_stack+686, vrr_stack+623, vrr_stack+665, NULL, NULL, vrr_stack+111);
 _BUILD_p0h0(Data,vrr_stack+749, vrr_stack+644, vrr_stack+623, NULL, NULL, vrr_stack+126);
 _BUILD_d0h0(Data,vrr_stack+2306, vrr_stack+749, vrr_stack+686, vrr_stack+644, vrr_stack+623, vrr_stack+141);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+48, vrr_stack+186, vrr_stack+267, vrr_stack+63, NULL);
 _BUILD_p0h0(Data,vrr_stack+812, vrr_stack+141, vrr_stack+644, NULL, NULL, vrr_stack+186);
 _BUILD_d0h0(Data,vrr_stack+2432, vrr_stack+812, vrr_stack+749, vrr_stack+141, vrr_stack+644, vrr_stack+201);
 _BUILD_00h0(Data,vrr_stack+63, vrr_stack+246, vrr_stack+338, vrr_stack+32, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+2558, vrr_stack+665, vrr_stack+63, NULL, NULL, vrr_stack+246);
 _BUILD_d0h0(Data,vrr_stack+2621, vrr_stack+686, vrr_stack+2558, vrr_stack+623, vrr_stack+665, vrr_stack+911);
 _BUILD_f0h0(Data,vrr_stack+2747, vrr_stack+2306, vrr_stack+2621, vrr_stack+749, vrr_stack+686, vrr_stack+956);
 _BUILD_f0h0(Data,vrr_stack+2957, vrr_stack+2432, vrr_stack+2306, vrr_stack+812, vrr_stack+749, vrr_stack+1046);
 _BUILD_g0h0(Data,vrr_stack+3167, vrr_stack+2957, vrr_stack+2747, vrr_stack+2432, vrr_stack+2306, vrr_stack+1136);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+6, vrr_stack+9, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+201, vrr_stack+261, vrr_stack+6, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+9, vrr_stack+207, vrr_stack+267, vrr_stack+201, vrr_stack+261, NULL);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+9, vrr_stack+48, vrr_stack+207, vrr_stack+267, NULL);
 _BUILD_p0h0(Data,vrr_stack+875, vrr_stack+217, vrr_stack+141, NULL, NULL, vrr_stack+48);
 _BUILD_d0h0(Data,vrr_stack+938, vrr_stack+875, vrr_stack+812, vrr_stack+217, vrr_stack+141, vrr_stack+277);
 _BUILD_f0h0(Data,vrr_stack+1064, vrr_stack+938, vrr_stack+2432, vrr_stack+875, vrr_stack+812, vrr_stack+1286);
 _BUILD_g0h0(Data,vrr_stack+3482, vrr_stack+1064, vrr_stack+2957, vrr_stack+938, vrr_stack+2432, vrr_stack+1376);
 _BUILD_00p0(Data,vrr_stack+261, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+264, vrr_stack+3, vrr_stack+261, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+270, vrr_stack+322, vrr_stack+264, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+280, vrr_stack+328, vrr_stack+270, vrr_stack+42, vrr_stack+322, NULL);
 _BUILD_00h0(Data,vrr_stack+295, vrr_stack+338, vrr_stack+280, vrr_stack+84, vrr_stack+328, NULL);
 _BUILD_p0h0(Data,vrr_stack+1274, vrr_stack+63, vrr_stack+295, NULL, NULL, vrr_stack+338);
 _BUILD_d0h0(Data,vrr_stack+1337, vrr_stack+2558, vrr_stack+1274, vrr_stack+665, vrr_stack+63, vrr_stack+353);
 _BUILD_f0h0(Data,vrr_stack+3797, vrr_stack+2621, vrr_stack+1337, vrr_stack+686, vrr_stack+2558, vrr_stack+1526);
 _BUILD_g0h0(Data,vrr_stack+4007, vrr_stack+2747, vrr_stack+3797, vrr_stack+2306, vrr_stack+2621, vrr_stack+1616);
 _BUILD_h0h0(Data,vrr_stack+4322, vrr_stack+3167, vrr_stack+4007, vrr_stack+2957, vrr_stack+2747, vrr_stack+1766);
 _BUILD_h0h0(Data,vrr_stack+1463, vrr_stack+3482, vrr_stack+3167, vrr_stack+1064, vrr_stack+2957, vrr_stack+398);
 _BUILD_i0h0(Data,vrr_stack+4763, vrr_stack+1463, vrr_stack+4322, vrr_stack+3482, vrr_stack+3167, vrr_stack+1991);
 _BUILD_00i0(Data,vrr_stack+353, vrr_stack+623, vrr_stack+665, vrr_stack+126, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+381, vrr_stack+644, vrr_stack+623, vrr_stack+186, vrr_stack+126, NULL);
 _BUILD_p0i0(Data,vrr_stack+409, vrr_stack+381, vrr_stack+353, NULL, NULL, vrr_stack+623);
 _BUILD_00i0(Data,vrr_stack+493, vrr_stack+141, vrr_stack+644, vrr_stack+48, vrr_stack+186, NULL);
 _BUILD_p0i0(Data,vrr_stack+521, vrr_stack+493, vrr_stack+381, NULL, NULL, vrr_stack+644);
 _BUILD_00i0(Data,vrr_stack+162, vrr_stack+665, vrr_stack+63, vrr_stack+111, vrr_stack+246, NULL);
 _BUILD_p0i0(Data,vrr_stack+1904, vrr_stack+353, vrr_stack+162, NULL, NULL, vrr_stack+665);
 _BUILD_d0i0(Data,vrr_stack+1988, vrr_stack+409, vrr_stack+1904, vrr_stack+381, vrr_stack+353, vrr_stack+686);
 _BUILD_d0i0(Data,vrr_stack+5351, vrr_stack+521, vrr_stack+409, vrr_stack+493, vrr_stack+381, vrr_stack+749);
 _BUILD_f0i0(Data,vrr_stack+5519, vrr_stack+5351, vrr_stack+1988, vrr_stack+521, vrr_stack+409, vrr_stack+2306);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+217, vrr_stack+141, vrr_stack+9, vrr_stack+48, NULL);
 _BUILD_p0i0(Data,vrr_stack+714, vrr_stack+686, vrr_stack+493, NULL, NULL, vrr_stack+141);
 _BUILD_d0i0(Data,vrr_stack+2156, vrr_stack+714, vrr_stack+521, vrr_stack+686, vrr_stack+493, vrr_stack+812);
 _BUILD_f0i0(Data,vrr_stack+5799, vrr_stack+2156, vrr_stack+5351, vrr_stack+714, vrr_stack+521, vrr_stack+2432);
 _BUILD_00i0(Data,vrr_stack+798, vrr_stack+63, vrr_stack+295, vrr_stack+246, vrr_stack+338, NULL);
 _BUILD_p0i0(Data,vrr_stack+2324, vrr_stack+162, vrr_stack+798, NULL, NULL, vrr_stack+63);
 _BUILD_d0i0(Data,vrr_stack+6079, vrr_stack+1904, vrr_stack+2324, vrr_stack+353, vrr_stack+162, vrr_stack+2558);
 _BUILD_f0i0(Data,vrr_stack+6247, vrr_stack+1988, vrr_stack+6079, vrr_stack+409, vrr_stack+1904, vrr_stack+2621);
 _BUILD_g0i0(Data,vrr_stack+6527, vrr_stack+5519, vrr_stack+6247, vrr_stack+5351, vrr_stack+1988, vrr_stack+2747);
 _BUILD_g0i0(Data,vrr_stack+2408, vrr_stack+5799, vrr_stack+5519, vrr_stack+2156, vrr_stack+5351, vrr_stack+2957);
 _BUILD_h0i0(Data,vrr_stack+6947, vrr_stack+2408, vrr_stack+6527, vrr_stack+5799, vrr_stack+5519, vrr_stack+3167);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+316, vrr_stack+0, vrr_stack+6, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+826, vrr_stack+316, vrr_stack+201, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+836, vrr_stack+826, vrr_stack+207, vrr_stack+316, vrr_stack+201, NULL);
 _BUILD_00h0(Data,vrr_stack+851, vrr_stack+836, vrr_stack+9, vrr_stack+826, vrr_stack+207, NULL);
 _BUILD_00i0(Data,vrr_stack+84, vrr_stack+851, vrr_stack+217, vrr_stack+836, vrr_stack+9, NULL);
 _BUILD_p0i0(Data,vrr_stack+2828, vrr_stack+84, vrr_stack+686, NULL, NULL, vrr_stack+217);
 _BUILD_d0i0(Data,vrr_stack+2912, vrr_stack+2828, vrr_stack+714, vrr_stack+84, vrr_stack+686, vrr_stack+875);
 _BUILD_f0i0(Data,vrr_stack+3080, vrr_stack+2912, vrr_stack+2156, vrr_stack+2828, vrr_stack+714, vrr_stack+938);
 _BUILD_g0i0(Data,vrr_stack+7535, vrr_stack+3080, vrr_stack+5799, vrr_stack+2912, vrr_stack+2156, vrr_stack+1064);
   tmp = vrr_stack + 7535;
   target_ptr = Libint->vrr_classes[4][6];
   for(i=0;i<420;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0i0(Data,vrr_stack+7955, vrr_stack+7535, vrr_stack+2408, vrr_stack+3080, vrr_stack+5799, vrr_stack+3482);
   tmp = vrr_stack + 7955;
   target_ptr = Libint->vrr_classes[5][6];
   for(i=0;i<588;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+316, vrr_stack+261, vrr_stack+0, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+2828, vrr_stack+264, vrr_stack+316, vrr_stack+3, vrr_stack+261, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+270, vrr_stack+2828, vrr_stack+322, vrr_stack+264, NULL);
 _BUILD_00h0(Data,vrr_stack+18, vrr_stack+280, vrr_stack+3, vrr_stack+328, vrr_stack+270, NULL);
 _BUILD_00i0(Data,vrr_stack+2838, vrr_stack+295, vrr_stack+18, vrr_stack+338, vrr_stack+280, NULL);
 _BUILD_p0i0(Data,vrr_stack+2866, vrr_stack+798, vrr_stack+2838, NULL, NULL, vrr_stack+295);
 _BUILD_d0i0(Data,vrr_stack+2950, vrr_stack+2324, vrr_stack+2866, vrr_stack+162, vrr_stack+798, vrr_stack+1274);
 _BUILD_f0i0(Data,vrr_stack+3118, vrr_stack+6079, vrr_stack+2950, vrr_stack+1904, vrr_stack+2324, vrr_stack+1337);
 _BUILD_g0i0(Data,vrr_stack+872, vrr_stack+6247, vrr_stack+3118, vrr_stack+1988, vrr_stack+6079, vrr_stack+3797);
 _BUILD_h0i0(Data,vrr_stack+3398, vrr_stack+6527, vrr_stack+872, vrr_stack+5519, vrr_stack+6247, vrr_stack+4007);
 _BUILD_i0i0(Data,vrr_stack+8543, vrr_stack+6947, vrr_stack+3398, vrr_stack+2408, vrr_stack+6527, vrr_stack+4322);
 _BUILD_i0i0(Data,vrr_stack+9327, vrr_stack+7955, vrr_stack+6947, vrr_stack+7535, vrr_stack+2408, vrr_stack+1463);
   tmp = vrr_stack + 9327;
   target_ptr = Libint->vrr_classes[6][6];
   for(i=0;i<784;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00k0(Data,vrr_stack+7535, vrr_stack+353, vrr_stack+162, vrr_stack+623, vrr_stack+665, NULL);
 _BUILD_00k0(Data,vrr_stack+7571, vrr_stack+381, vrr_stack+353, vrr_stack+644, vrr_stack+623, NULL);
 _BUILD_p0k0(Data,vrr_stack+7607, vrr_stack+7571, vrr_stack+7535, NULL, NULL, vrr_stack+353);
 _BUILD_00k0(Data,vrr_stack+7715, vrr_stack+493, vrr_stack+381, vrr_stack+141, vrr_stack+644, NULL);
 _BUILD_p0k0(Data,vrr_stack+7751, vrr_stack+7715, vrr_stack+7571, NULL, NULL, vrr_stack+381);
 _BUILD_00k0(Data,vrr_stack+7859, vrr_stack+162, vrr_stack+798, vrr_stack+665, vrr_stack+63, NULL);
 _BUILD_p0k0(Data,vrr_stack+3986, vrr_stack+7535, vrr_stack+7859, NULL, NULL, vrr_stack+162);
 _BUILD_d0k0(Data,vrr_stack+4094, vrr_stack+7607, vrr_stack+3986, vrr_stack+7571, vrr_stack+7535, vrr_stack+1904);
 _BUILD_d0k0(Data,vrr_stack+4310, vrr_stack+7751, vrr_stack+7607, vrr_stack+7715, vrr_stack+7571, vrr_stack+409);
 _BUILD_f0k0(Data,vrr_stack+1292, vrr_stack+4310, vrr_stack+4094, vrr_stack+7751, vrr_stack+7607, vrr_stack+1988);
 _BUILD_00k0(Data,vrr_stack+409, vrr_stack+686, vrr_stack+493, vrr_stack+217, vrr_stack+141, NULL);
 _BUILD_p0k0(Data,vrr_stack+4526, vrr_stack+409, vrr_stack+7715, NULL, NULL, vrr_stack+493);
 _BUILD_d0k0(Data,vrr_stack+1652, vrr_stack+4526, vrr_stack+7751, vrr_stack+409, vrr_stack+7715, vrr_stack+521);
 _BUILD_f0k0(Data,vrr_stack+10111, vrr_stack+1652, vrr_stack+4310, vrr_stack+4526, vrr_stack+7751, vrr_stack+5351);
 _BUILD_00k0(Data,vrr_stack+5351, vrr_stack+798, vrr_stack+2838, vrr_stack+63, vrr_stack+295, NULL);
 _BUILD_p0k0(Data,vrr_stack+5387, vrr_stack+7859, vrr_stack+5351, NULL, NULL, vrr_stack+798);
 _BUILD_d0k0(Data,vrr_stack+1868, vrr_stack+3986, vrr_stack+5387, vrr_stack+7535, vrr_stack+7859, vrr_stack+2324);
 _BUILD_f0k0(Data,vrr_stack+10471, vrr_stack+4094, vrr_stack+1868, vrr_stack+7607, vrr_stack+3986, vrr_stack+6079);
 _BUILD_g0k0(Data,vrr_stack+10831, vrr_stack+1292, vrr_stack+10471, vrr_stack+4310, vrr_stack+4094, vrr_stack+6247);
 _BUILD_g0k0(Data,vrr_stack+11371, vrr_stack+10111, vrr_stack+1292, vrr_stack+1652, vrr_stack+4310, vrr_stack+5519);
 _BUILD_h0k0(Data,vrr_stack+11911, vrr_stack+11371, vrr_stack+10831, vrr_stack+10111, vrr_stack+1292, vrr_stack+6527);
 _BUILD_00k0(Data,vrr_stack+6079, vrr_stack+84, vrr_stack+686, vrr_stack+851, vrr_stack+217, NULL);
 _BUILD_p0k0(Data,vrr_stack+6115, vrr_stack+6079, vrr_stack+409, NULL, NULL, vrr_stack+686);
 _BUILD_d0k0(Data,vrr_stack+6223, vrr_stack+6115, vrr_stack+4526, vrr_stack+6079, vrr_stack+409, vrr_stack+714);
 _BUILD_f0k0(Data,vrr_stack+6439, vrr_stack+6223, vrr_stack+1652, vrr_stack+6115, vrr_stack+4526, vrr_stack+2156);
 _BUILD_g0k0(Data,vrr_stack+12667, vrr_stack+6439, vrr_stack+10111, vrr_stack+6223, vrr_stack+1652, vrr_stack+5799);
   tmp = vrr_stack + 12667;
   target_ptr = Libint->vrr_classes[4][7];
   for(i=0;i<540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0k0(Data,vrr_stack+13207, vrr_stack+12667, vrr_stack+11371, vrr_stack+6439, vrr_stack+10111, vrr_stack+2408);
   tmp = vrr_stack + 13207;
   target_ptr = Libint->vrr_classes[5][7];
   for(i=0;i<756;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6115, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6118, vrr_stack+0, vrr_stack+6115, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+6124, vrr_stack+316, vrr_stack+6118, vrr_stack+261, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+6134, vrr_stack+2828, vrr_stack+6124, vrr_stack+264, vrr_stack+316, NULL);
 _BUILD_00h0(Data,vrr_stack+6149, vrr_stack+3, vrr_stack+6134, vrr_stack+270, vrr_stack+2828, NULL);
 _BUILD_00i0(Data,vrr_stack+6170, vrr_stack+18, vrr_stack+6149, vrr_stack+280, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+6198, vrr_stack+2838, vrr_stack+6170, vrr_stack+295, vrr_stack+18, NULL);
 _BUILD_p0k0(Data,vrr_stack+6234, vrr_stack+5351, vrr_stack+6198, NULL, NULL, vrr_stack+2838);
 _BUILD_d0k0(Data,vrr_stack+6342, vrr_stack+5387, vrr_stack+6234, vrr_stack+7859, vrr_stack+5351, vrr_stack+2866);
 _BUILD_f0k0(Data,vrr_stack+6558, vrr_stack+1868, vrr_stack+6342, vrr_stack+3986, vrr_stack+5387, vrr_stack+2950);
 _BUILD_g0k0(Data,vrr_stack+5495, vrr_stack+10471, vrr_stack+6558, vrr_stack+4094, vrr_stack+1868, vrr_stack+3118);
 _BUILD_h0k0(Data,vrr_stack+13963, vrr_stack+10831, vrr_stack+5495, vrr_stack+1292, vrr_stack+10471, vrr_stack+872);
 _BUILD_i0k0(Data,vrr_stack+14719, vrr_stack+11911, vrr_stack+13963, vrr_stack+11371, vrr_stack+10831, vrr_stack+3398);
 _BUILD_i0k0(Data,vrr_stack+2866, vrr_stack+13207, vrr_stack+11911, vrr_stack+12667, vrr_stack+11371, vrr_stack+6947);
   tmp = vrr_stack + 2866;
   target_ptr = Libint->vrr_classes[6][7];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00l0(Data,vrr_stack+39, vrr_stack+7535, vrr_stack+7859, vrr_stack+353, vrr_stack+162, NULL);
 _BUILD_00l0(Data,vrr_stack+12667, vrr_stack+7571, vrr_stack+7535, vrr_stack+381, vrr_stack+353, NULL);
 _BUILD_p0l0(Data,vrr_stack+12712, vrr_stack+12667, vrr_stack+39, NULL, NULL, vrr_stack+7535);
 _BUILD_00l0(Data,vrr_stack+12847, vrr_stack+7715, vrr_stack+7571, vrr_stack+493, vrr_stack+381, NULL);
 _BUILD_p0l0(Data,vrr_stack+12892, vrr_stack+12847, vrr_stack+12667, NULL, NULL, vrr_stack+7571);
 _BUILD_00l0(Data,vrr_stack+13027, vrr_stack+7859, vrr_stack+5351, vrr_stack+162, vrr_stack+798, NULL);
 _BUILD_p0l0(Data,vrr_stack+13072, vrr_stack+39, vrr_stack+13027, NULL, NULL, vrr_stack+7859);
 _BUILD_d0l0(Data,vrr_stack+826, vrr_stack+12712, vrr_stack+13072, vrr_stack+12667, vrr_stack+39, vrr_stack+3986);
 _BUILD_d0l0(Data,vrr_stack+2084, vrr_stack+12892, vrr_stack+12712, vrr_stack+12847, vrr_stack+12667, vrr_stack+7607);
 _BUILD_f0l0(Data,vrr_stack+2354, vrr_stack+2084, vrr_stack+826, vrr_stack+12892, vrr_stack+12712, vrr_stack+4094);
 _BUILD_00l0(Data,vrr_stack+7607, vrr_stack+409, vrr_stack+7715, vrr_stack+686, vrr_stack+493, NULL);
 _BUILD_p0l0(Data,vrr_stack+3874, vrr_stack+7607, vrr_stack+12847, NULL, NULL, vrr_stack+7715);
 _BUILD_d0l0(Data,vrr_stack+4009, vrr_stack+3874, vrr_stack+12892, vrr_stack+7607, vrr_stack+12847, vrr_stack+7751);
 _BUILD_f0l0(Data,vrr_stack+15727, vrr_stack+4009, vrr_stack+2084, vrr_stack+3874, vrr_stack+12892, vrr_stack+4310);
 _BUILD_00l0(Data,vrr_stack+7751, vrr_stack+5351, vrr_stack+6198, vrr_stack+798, vrr_stack+2838, NULL);
 _BUILD_p0l0(Data,vrr_stack+4279, vrr_stack+13027, vrr_stack+7751, NULL, NULL, vrr_stack+5351);
 _BUILD_d0l0(Data,vrr_stack+16177, vrr_stack+13072, vrr_stack+4279, vrr_stack+39, vrr_stack+13027, vrr_stack+5387);
 _BUILD_f0l0(Data,vrr_stack+16447, vrr_stack+826, vrr_stack+16177, vrr_stack+12712, vrr_stack+13072, vrr_stack+1868);
 _BUILD_g0l0(Data,vrr_stack+16897, vrr_stack+2354, vrr_stack+16447, vrr_stack+2084, vrr_stack+826, vrr_stack+10471);
 _BUILD_g0l0(Data,vrr_stack+17572, vrr_stack+15727, vrr_stack+2354, vrr_stack+4009, vrr_stack+2084, vrr_stack+1292);
 _BUILD_h0l0(Data,vrr_stack+18247, vrr_stack+17572, vrr_stack+16897, vrr_stack+15727, vrr_stack+2354, vrr_stack+10831);
 _BUILD_00l0(Data,vrr_stack+10471, vrr_stack+6079, vrr_stack+409, vrr_stack+84, vrr_stack+686, NULL);
 _BUILD_p0l0(Data,vrr_stack+84, vrr_stack+10471, vrr_stack+7607, NULL, NULL, vrr_stack+409);
 _BUILD_d0l0(Data,vrr_stack+10516, vrr_stack+84, vrr_stack+3874, vrr_stack+10471, vrr_stack+7607, vrr_stack+4526);
 _BUILD_f0l0(Data,vrr_stack+10786, vrr_stack+10516, vrr_stack+4009, vrr_stack+84, vrr_stack+3874, vrr_stack+1652);
 _BUILD_g0l0(Data,vrr_stack+1096, vrr_stack+10786, vrr_stack+15727, vrr_stack+10516, vrr_stack+4009, vrr_stack+10111);
   tmp = vrr_stack + 1096;
   target_ptr = Libint->vrr_classes[4][8];
   for(i=0;i<675;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0l0(Data,vrr_stack+19192, vrr_stack+1096, vrr_stack+17572, vrr_stack+10786, vrr_stack+15727, vrr_stack+11371);
   tmp = vrr_stack + 19192;
   target_ptr = Libint->vrr_classes[5][8];
   for(i=0;i<945;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+10111, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+10114, vrr_stack+6115, vrr_stack+10111, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+10120, vrr_stack+6118, vrr_stack+10114, vrr_stack+0, vrr_stack+6115, NULL);
 _BUILD_00g0(Data,vrr_stack+10130, vrr_stack+6124, vrr_stack+10120, vrr_stack+316, vrr_stack+6118, NULL);
 _BUILD_00h0(Data,vrr_stack+10145, vrr_stack+6134, vrr_stack+10130, vrr_stack+2828, vrr_stack+6124, NULL);
 _BUILD_00i0(Data,vrr_stack+10166, vrr_stack+6149, vrr_stack+10145, vrr_stack+3, vrr_stack+6134, NULL);
 _BUILD_00k0(Data,vrr_stack+10194, vrr_stack+6170, vrr_stack+10166, vrr_stack+18, vrr_stack+6149, NULL);
 _BUILD_00l0(Data,vrr_stack+10230, vrr_stack+6198, vrr_stack+10194, vrr_stack+2838, vrr_stack+6170, NULL);
 _BUILD_p0l0(Data,vrr_stack+10275, vrr_stack+7751, vrr_stack+10230, NULL, NULL, vrr_stack+6198);
 _BUILD_d0l0(Data,vrr_stack+10516, vrr_stack+4279, vrr_stack+10275, vrr_stack+13027, vrr_stack+7751, vrr_stack+6234);
 _BUILD_f0l0(Data,vrr_stack+10786, vrr_stack+16177, vrr_stack+10516, vrr_stack+13072, vrr_stack+4279, vrr_stack+6342);
 _BUILD_g0l0(Data,vrr_stack+11236, vrr_stack+16447, vrr_stack+10786, vrr_stack+826, vrr_stack+16177, vrr_stack+6558);
 _BUILD_h0l0(Data,vrr_stack+20137, vrr_stack+16897, vrr_stack+11236, vrr_stack+2354, vrr_stack+16447, vrr_stack+5495);
 _BUILD_i0l0(Data,vrr_stack+21082, vrr_stack+18247, vrr_stack+20137, vrr_stack+17572, vrr_stack+16897, vrr_stack+13963);
 _BUILD_i0l0(Data,vrr_stack+22342, vrr_stack+19192, vrr_stack+18247, vrr_stack+1096, vrr_stack+17572, vrr_stack+11911);
   tmp = vrr_stack + 22342;
   target_ptr = Libint->vrr_classes[6][8];
   for(i=0;i<1260;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00m0(Data,vrr_stack+1096, vrr_stack+39, vrr_stack+13027, vrr_stack+7535, vrr_stack+7859, NULL);
 _BUILD_00m0(Data,vrr_stack+1151, vrr_stack+12667, vrr_stack+39, vrr_stack+7571, vrr_stack+7535, NULL);
 _BUILD_p0m0(Data,vrr_stack+1206, vrr_stack+1151, vrr_stack+1096, NULL, NULL, vrr_stack+39);
 _BUILD_00m0(Data,vrr_stack+1371, vrr_stack+12847, vrr_stack+12667, vrr_stack+7715, vrr_stack+7571, NULL);
 _BUILD_p0m0(Data,vrr_stack+1426, vrr_stack+1371, vrr_stack+1151, NULL, NULL, vrr_stack+12667);
 _BUILD_00m0(Data,vrr_stack+7535, vrr_stack+13027, vrr_stack+7751, vrr_stack+7859, vrr_stack+5351, NULL);
 _BUILD_p0m0(Data,vrr_stack+1591, vrr_stack+1096, vrr_stack+7535, NULL, NULL, vrr_stack+13027);
 _BUILD_d0m0(Data,vrr_stack+13963, vrr_stack+1206, vrr_stack+1591, vrr_stack+1151, vrr_stack+1096, vrr_stack+13072);
 _BUILD_d0m0(Data,vrr_stack+14293, vrr_stack+1426, vrr_stack+1206, vrr_stack+1371, vrr_stack+1151, vrr_stack+12712);
 _BUILD_f0m0(Data,vrr_stack+6234, vrr_stack+14293, vrr_stack+13963, vrr_stack+1426, vrr_stack+1206, vrr_stack+826);
 _BUILD_00m0(Data,vrr_stack+12712, vrr_stack+7607, vrr_stack+12847, vrr_stack+409, vrr_stack+7715, NULL);
 _BUILD_p0m0(Data,vrr_stack+1756, vrr_stack+12712, vrr_stack+1371, NULL, NULL, vrr_stack+12847);
 _BUILD_d0m0(Data,vrr_stack+5387, vrr_stack+1756, vrr_stack+1426, vrr_stack+12712, vrr_stack+1371, vrr_stack+12892);
 _BUILD_f0m0(Data,vrr_stack+445, vrr_stack+5387, vrr_stack+14293, vrr_stack+1756, vrr_stack+1426, vrr_stack+2084);
 _BUILD_00m0(Data,vrr_stack+12892, vrr_stack+7751, vrr_stack+10230, vrr_stack+5351, vrr_stack+6198, NULL);
 _BUILD_p0m0(Data,vrr_stack+1921, vrr_stack+7535, vrr_stack+12892, NULL, NULL, vrr_stack+7751);
 _BUILD_d0m0(Data,vrr_stack+5717, vrr_stack+1591, vrr_stack+1921, vrr_stack+1096, vrr_stack+7535, vrr_stack+4279);
 _BUILD_f0m0(Data,vrr_stack+23602, vrr_stack+13963, vrr_stack+5717, vrr_stack+1206, vrr_stack+1591, vrr_stack+16177);
 _BUILD_g0m0(Data,vrr_stack+24152, vrr_stack+6234, vrr_stack+23602, vrr_stack+14293, vrr_stack+13963, vrr_stack+16447);
 _BUILD_g0m0(Data,vrr_stack+24977, vrr_stack+445, vrr_stack+6234, vrr_stack+5387, vrr_stack+14293, vrr_stack+2354);
 _BUILD_h0m0(Data,vrr_stack+25802, vrr_stack+24977, vrr_stack+24152, vrr_stack+445, vrr_stack+6234, vrr_stack+16897);
 _BUILD_00m0(Data,vrr_stack+16177, vrr_stack+10471, vrr_stack+7607, vrr_stack+6079, vrr_stack+409, NULL);
 _BUILD_p0m0(Data,vrr_stack+16232, vrr_stack+16177, vrr_stack+12712, NULL, NULL, vrr_stack+7607);
 _BUILD_d0m0(Data,vrr_stack+16397, vrr_stack+16232, vrr_stack+1756, vrr_stack+16177, vrr_stack+12712, vrr_stack+3874);
 _BUILD_f0m0(Data,vrr_stack+16727, vrr_stack+16397, vrr_stack+5387, vrr_stack+16232, vrr_stack+1756, vrr_stack+4009);
 _BUILD_g0m0(Data,vrr_stack+3874, vrr_stack+16727, vrr_stack+445, vrr_stack+16397, vrr_stack+5387, vrr_stack+15727);
   tmp = vrr_stack + 3874;
   target_ptr = Libint->vrr_classes[4][9];
   for(i=0;i<825;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0m0(Data,vrr_stack+26957, vrr_stack+3874, vrr_stack+24977, vrr_stack+16727, vrr_stack+445, vrr_stack+17572);
   tmp = vrr_stack + 26957;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+15727, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15730, vrr_stack+10111, vrr_stack+15727, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+15736, vrr_stack+10114, vrr_stack+15730, vrr_stack+6115, vrr_stack+10111, NULL);
 _BUILD_00g0(Data,vrr_stack+15746, vrr_stack+10120, vrr_stack+15736, vrr_stack+6118, vrr_stack+10114, NULL);
 _BUILD_00h0(Data,vrr_stack+15761, vrr_stack+10130, vrr_stack+15746, vrr_stack+6124, vrr_stack+10120, NULL);
 _BUILD_00i0(Data,vrr_stack+15782, vrr_stack+10145, vrr_stack+15761, vrr_stack+6134, vrr_stack+10130, NULL);
 _BUILD_00k0(Data,vrr_stack+5351, vrr_stack+10166, vrr_stack+15782, vrr_stack+6149, vrr_stack+10145, NULL);
 _BUILD_00l0(Data,vrr_stack+15810, vrr_stack+10194, vrr_stack+5351, vrr_stack+6170, vrr_stack+10166, NULL);
 _BUILD_00m0(Data,vrr_stack+15855, vrr_stack+10230, vrr_stack+15810, vrr_stack+6198, vrr_stack+10194, NULL);
 _BUILD_p0m0(Data,vrr_stack+15910, vrr_stack+12892, vrr_stack+15855, NULL, NULL, vrr_stack+10230);
 _BUILD_d0m0(Data,vrr_stack+16232, vrr_stack+1921, vrr_stack+15910, vrr_stack+7535, vrr_stack+12892, vrr_stack+10275);
 _BUILD_f0m0(Data,vrr_stack+16562, vrr_stack+5717, vrr_stack+16232, vrr_stack+1591, vrr_stack+1921, vrr_stack+10516);
 _BUILD_g0m0(Data,vrr_stack+17112, vrr_stack+23602, vrr_stack+16562, vrr_stack+13963, vrr_stack+5717, vrr_stack+10786);
 _BUILD_h0m0(Data,vrr_stack+28112, vrr_stack+24152, vrr_stack+17112, vrr_stack+6234, vrr_stack+23602, vrr_stack+11236);
 _BUILD_i0m0(Data,vrr_stack+29267, vrr_stack+25802, vrr_stack+28112, vrr_stack+24977, vrr_stack+24152, vrr_stack+20137);
 _BUILD_i0m0(Data,vrr_stack+30807, vrr_stack+26957, vrr_stack+25802, vrr_stack+3874, vrr_stack+24977, vrr_stack+18247);
   tmp = vrr_stack + 30807;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+3874, vrr_stack+1096, vrr_stack+7535, vrr_stack+39, vrr_stack+13027, NULL);
 _BUILD_00n0(Data,vrr_stack+3940, vrr_stack+1151, vrr_stack+1096, vrr_stack+12667, vrr_stack+39, NULL);
 _BUILD_p0n0(Data,vrr_stack+4006, vrr_stack+3940, vrr_stack+3874, NULL, NULL, vrr_stack+1096);
 _BUILD_00n0(Data,vrr_stack+4204, vrr_stack+1371, vrr_stack+1151, vrr_stack+12847, vrr_stack+12667, NULL);
 _BUILD_p0n0(Data,vrr_stack+4270, vrr_stack+4204, vrr_stack+3940, NULL, NULL, vrr_stack+1151);
 _BUILD_00n0(Data,vrr_stack+4468, vrr_stack+7535, vrr_stack+12892, vrr_stack+13027, vrr_stack+7751, NULL);
 _BUILD_p0n0(Data,vrr_stack+4534, vrr_stack+3874, vrr_stack+4468, NULL, NULL, vrr_stack+7535);
 _BUILD_d0n0(Data,vrr_stack+20137, vrr_stack+4006, vrr_stack+4534, vrr_stack+3940, vrr_stack+3874, vrr_stack+1591);
 _BUILD_d0n0(Data,vrr_stack+20533, vrr_stack+4270, vrr_stack+4006, vrr_stack+4204, vrr_stack+3940, vrr_stack+1206);
 _BUILD_f0n0(Data,vrr_stack+10516, vrr_stack+20533, vrr_stack+20137, vrr_stack+4270, vrr_stack+4006, vrr_stack+13963);
 _BUILD_00n0(Data,vrr_stack+13963, vrr_stack+12712, vrr_stack+1371, vrr_stack+7607, vrr_stack+12847, NULL);
 _BUILD_p0n0(Data,vrr_stack+14029, vrr_stack+13963, vrr_stack+4204, NULL, NULL, vrr_stack+1371);
 _BUILD_d0n0(Data,vrr_stack+11176, vrr_stack+14029, vrr_stack+4270, vrr_stack+13963, vrr_stack+4204, vrr_stack+1426);
 _BUILD_f0n0(Data,vrr_stack+2086, vrr_stack+11176, vrr_stack+20533, vrr_stack+14029, vrr_stack+4270, vrr_stack+14293);
 _BUILD_00n0(Data,vrr_stack+1426, vrr_stack+12892, vrr_stack+15855, vrr_stack+7751, vrr_stack+10230, NULL);
 _BUILD_p0n0(Data,vrr_stack+1492, vrr_stack+4468, vrr_stack+1426, NULL, NULL, vrr_stack+12892);
 _BUILD_d0n0(Data,vrr_stack+14227, vrr_stack+4534, vrr_stack+1492, vrr_stack+3874, vrr_stack+4468, vrr_stack+1921);
 _BUILD_f0n0(Data,vrr_stack+32347, vrr_stack+20137, vrr_stack+14227, vrr_stack+4006, vrr_stack+4534, vrr_stack+5717);
 _BUILD_g0n0(Data,vrr_stack+33007, vrr_stack+10516, vrr_stack+32347, vrr_stack+20533, vrr_stack+20137, vrr_stack+23602);
 _BUILD_g0n0(Data,vrr_stack+33997, vrr_stack+2086, vrr_stack+10516, vrr_stack+11176, vrr_stack+20533, vrr_stack+6234);
 _BUILD_h0n0(Data,vrr_stack+34987, vrr_stack+33997, vrr_stack+33007, vrr_stack+2086, vrr_stack+10516, vrr_stack+24152);
 _BUILD_00n0(Data,vrr_stack+1690, vrr_stack+16177, vrr_stack+12712, vrr_stack+10471, vrr_stack+7607, NULL);
 _BUILD_p0n0(Data,vrr_stack+23602, vrr_stack+1690, vrr_stack+13963, NULL, NULL, vrr_stack+12712);
 _BUILD_d0n0(Data,vrr_stack+23800, vrr_stack+23602, vrr_stack+14029, vrr_stack+1690, vrr_stack+13963, vrr_stack+1756);
 _BUILD_f0n0(Data,vrr_stack+24196, vrr_stack+23800, vrr_stack+11176, vrr_stack+23602, vrr_stack+14029, vrr_stack+5387);
 _BUILD_g0n0(Data,vrr_stack+5387, vrr_stack+24196, vrr_stack+2086, vrr_stack+23800, vrr_stack+11176, vrr_stack+445);
   tmp = vrr_stack + 5387;
   target_ptr = Libint->vrr_classes[4][10];
   for(i=0;i<990;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0n0(Data,vrr_stack+36373, vrr_stack+5387, vrr_stack+33997, vrr_stack+24196, vrr_stack+2086, vrr_stack+24977);
   tmp = vrr_stack + 36373;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6377, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6380, vrr_stack+15727, vrr_stack+6377, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+6386, vrr_stack+15730, vrr_stack+6380, vrr_stack+10111, vrr_stack+15727, NULL);
 _BUILD_00g0(Data,vrr_stack+6396, vrr_stack+15736, vrr_stack+6386, vrr_stack+10114, vrr_stack+15730, NULL);
 _BUILD_00h0(Data,vrr_stack+6411, vrr_stack+15746, vrr_stack+6396, vrr_stack+10120, vrr_stack+15736, NULL);
 _BUILD_00i0(Data,vrr_stack+6432, vrr_stack+15761, vrr_stack+6411, vrr_stack+10130, vrr_stack+15746, NULL);
 _BUILD_00k0(Data,vrr_stack+6460, vrr_stack+15782, vrr_stack+6432, vrr_stack+10145, vrr_stack+15761, NULL);
 _BUILD_00l0(Data,vrr_stack+12667, vrr_stack+5351, vrr_stack+6460, vrr_stack+10166, vrr_stack+15782, NULL);
 _BUILD_00m0(Data,vrr_stack+10111, vrr_stack+15810, vrr_stack+12667, vrr_stack+10194, vrr_stack+5351, NULL);
 _BUILD_00n0(Data,vrr_stack+6496, vrr_stack+15855, vrr_stack+10111, vrr_stack+10230, vrr_stack+15810, NULL);
 _BUILD_p0n0(Data,vrr_stack+10166, vrr_stack+1426, vrr_stack+6496, NULL, NULL, vrr_stack+15855);
 _BUILD_d0n0(Data,vrr_stack+23602, vrr_stack+1492, vrr_stack+10166, vrr_stack+4468, vrr_stack+1426, vrr_stack+15910);
 _BUILD_f0n0(Data,vrr_stack+23998, vrr_stack+14227, vrr_stack+23602, vrr_stack+4534, vrr_stack+1492, vrr_stack+16232);
 _BUILD_g0n0(Data,vrr_stack+24658, vrr_stack+32347, vrr_stack+23998, vrr_stack+20137, vrr_stack+14227, vrr_stack+16562);
 _BUILD_h0n0(Data,vrr_stack+37759, vrr_stack+33007, vrr_stack+24658, vrr_stack+10516, vrr_stack+32347, vrr_stack+17112);
 _BUILD_i0n0(Data,vrr_stack+16232, vrr_stack+34987, vrr_stack+37759, vrr_stack+33997, vrr_stack+33007, vrr_stack+28112);
 _BUILD_i0n0(Data,vrr_stack+39145, vrr_stack+36373, vrr_stack+34987, vrr_stack+5387, vrr_stack+33997, vrr_stack+25802);
   tmp = vrr_stack + 39145;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+5387, vrr_stack+3874, vrr_stack+4468, vrr_stack+1096, vrr_stack+7535, NULL);
 _BUILD_00o0(Data,vrr_stack+5465, vrr_stack+3940, vrr_stack+3874, vrr_stack+1151, vrr_stack+1096, NULL);
 _BUILD_p0o0(Data,vrr_stack+5543, vrr_stack+5465, vrr_stack+5387, NULL, NULL, vrr_stack+3874);
 _BUILD_00o0(Data,vrr_stack+5777, vrr_stack+4204, vrr_stack+3940, vrr_stack+1371, vrr_stack+1151, NULL);
 _BUILD_p0o0(Data,vrr_stack+5855, vrr_stack+5777, vrr_stack+5465, NULL, NULL, vrr_stack+3940);
 _BUILD_00o0(Data,vrr_stack+6089, vrr_stack+4468, vrr_stack+1426, vrr_stack+7535, vrr_stack+12892, NULL);
 _BUILD_p0o0(Data,vrr_stack+7535, vrr_stack+5387, vrr_stack+6089, NULL, NULL, vrr_stack+4468);
 _BUILD_d0o0(Data,vrr_stack+28112, vrr_stack+5543, vrr_stack+7535, vrr_stack+5465, vrr_stack+5387, vrr_stack+4534);
 _BUILD_d0o0(Data,vrr_stack+28580, vrr_stack+5855, vrr_stack+5543, vrr_stack+5777, vrr_stack+5465, vrr_stack+4006);
 _BUILD_f0o0(Data,vrr_stack+0, vrr_stack+28580, vrr_stack+28112, vrr_stack+5855, vrr_stack+5543, vrr_stack+20137);
 _BUILD_00o0(Data,vrr_stack+20137, vrr_stack+13963, vrr_stack+4204, vrr_stack+12712, vrr_stack+1371, NULL);
 _BUILD_p0o0(Data,vrr_stack+20215, vrr_stack+20137, vrr_stack+5777, NULL, NULL, vrr_stack+4204);
 _BUILD_d0o0(Data,vrr_stack+780, vrr_stack+20215, vrr_stack+5855, vrr_stack+20137, vrr_stack+5777, vrr_stack+4270);
 _BUILD_f0o0(Data,vrr_stack+40993, vrr_stack+780, vrr_stack+28580, vrr_stack+20215, vrr_stack+5855, vrr_stack+20533);
 _BUILD_00o0(Data,vrr_stack+4270, vrr_stack+1426, vrr_stack+6496, vrr_stack+12892, vrr_stack+15855, NULL);
 _BUILD_p0o0(Data,vrr_stack+20449, vrr_stack+6089, vrr_stack+4270, NULL, NULL, vrr_stack+1426);
 _BUILD_d0o0(Data,vrr_stack+41773, vrr_stack+7535, vrr_stack+20449, vrr_stack+5387, vrr_stack+6089, vrr_stack+1492);
 _BUILD_f0o0(Data,vrr_stack+42241, vrr_stack+28112, vrr_stack+41773, vrr_stack+5543, vrr_stack+7535, vrr_stack+14227);
 _BUILD_g0o0(Data,vrr_stack+43021, vrr_stack+0, vrr_stack+42241, vrr_stack+28580, vrr_stack+28112, vrr_stack+32347);
 _BUILD_g0o0(Data,vrr_stack+44191, vrr_stack+40993, vrr_stack+0, vrr_stack+780, vrr_stack+28580, vrr_stack+10516);
 _BUILD_h0o0(Data,vrr_stack+45361, vrr_stack+44191, vrr_stack+43021, vrr_stack+40993, vrr_stack+0, vrr_stack+33007);
 _BUILD_00o0(Data,vrr_stack+32347, vrr_stack+1690, vrr_stack+13963, vrr_stack+16177, vrr_stack+12712, NULL);
 _BUILD_p0o0(Data,vrr_stack+12712, vrr_stack+32347, vrr_stack+20137, NULL, NULL, vrr_stack+13963);
 _BUILD_d0o0(Data,vrr_stack+32425, vrr_stack+12712, vrr_stack+20215, vrr_stack+32347, vrr_stack+20137, vrr_stack+14029);
 _BUILD_f0o0(Data,vrr_stack+32893, vrr_stack+32425, vrr_stack+780, vrr_stack+12712, vrr_stack+20215, vrr_stack+11176);
 _BUILD_g0o0(Data,vrr_stack+10364, vrr_stack+32893, vrr_stack+40993, vrr_stack+32425, vrr_stack+780, vrr_stack+2086);
   tmp = vrr_stack + 10364;
   target_ptr = Libint->vrr_classes[4][11];
   for(i=0;i<1170;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0o0(Data,vrr_stack+46999, vrr_stack+10364, vrr_stack+44191, vrr_stack+32893, vrr_stack+40993, vrr_stack+33997);
   tmp = vrr_stack + 46999;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+32425, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+32428, vrr_stack+6377, vrr_stack+32425, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+32434, vrr_stack+6380, vrr_stack+32428, vrr_stack+15727, vrr_stack+6377, NULL);
 _BUILD_00g0(Data,vrr_stack+32444, vrr_stack+6386, vrr_stack+32434, vrr_stack+15730, vrr_stack+6380, NULL);
 _BUILD_00h0(Data,vrr_stack+32459, vrr_stack+6396, vrr_stack+32444, vrr_stack+15736, vrr_stack+6386, NULL);
 _BUILD_00i0(Data,vrr_stack+32480, vrr_stack+6411, vrr_stack+32459, vrr_stack+15746, vrr_stack+6396, NULL);
 _BUILD_00k0(Data,vrr_stack+32508, vrr_stack+6432, vrr_stack+32480, vrr_stack+15761, vrr_stack+6411, NULL);
 _BUILD_00l0(Data,vrr_stack+15727, vrr_stack+6460, vrr_stack+32508, vrr_stack+15782, vrr_stack+6432, NULL);
 _BUILD_00m0(Data,vrr_stack+32544, vrr_stack+12667, vrr_stack+15727, vrr_stack+5351, vrr_stack+6460, NULL);
 _BUILD_00n0(Data,vrr_stack+32599, vrr_stack+10111, vrr_stack+32544, vrr_stack+15810, vrr_stack+12667, NULL);
 _BUILD_00o0(Data,vrr_stack+15772, vrr_stack+6496, vrr_stack+32599, vrr_stack+15855, vrr_stack+10111, NULL);
 _BUILD_p0o0(Data,vrr_stack+15850, vrr_stack+4270, vrr_stack+15772, NULL, NULL, vrr_stack+6496);
 _BUILD_d0o0(Data,vrr_stack+32665, vrr_stack+20449, vrr_stack+15850, vrr_stack+6089, vrr_stack+4270, vrr_stack+10166);
 _BUILD_f0o0(Data,vrr_stack+33133, vrr_stack+41773, vrr_stack+32665, vrr_stack+7535, vrr_stack+20449, vrr_stack+23602);
 _BUILD_g0o0(Data,vrr_stack+48637, vrr_stack+42241, vrr_stack+33133, vrr_stack+28112, vrr_stack+41773, vrr_stack+23998);
 _BUILD_h0o0(Data,vrr_stack+49807, vrr_stack+43021, vrr_stack+48637, vrr_stack+0, vrr_stack+42241, vrr_stack+24658);
 _BUILD_i0o0(Data,vrr_stack+23602, vrr_stack+45361, vrr_stack+49807, vrr_stack+44191, vrr_stack+43021, vrr_stack+37759);
 _BUILD_i0o0(Data,vrr_stack+51445, vrr_stack+46999, vrr_stack+45361, vrr_stack+10364, vrr_stack+44191, vrr_stack+34987);
   tmp = vrr_stack + 51445;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+37759, vrr_stack+5387, vrr_stack+6089, vrr_stack+3874, vrr_stack+4468, NULL);
 _BUILD_00q0(Data,vrr_stack+37850, vrr_stack+5465, vrr_stack+5387, vrr_stack+3940, vrr_stack+3874, NULL);
 _BUILD_p0q0(Data,vrr_stack+37941, vrr_stack+37850, vrr_stack+37759, NULL, NULL, vrr_stack+5387);
 _BUILD_00q0(Data,vrr_stack+38214, vrr_stack+5777, vrr_stack+5465, vrr_stack+4204, vrr_stack+3940, NULL);
 _BUILD_p0q0(Data,vrr_stack+3874, vrr_stack+38214, vrr_stack+37850, NULL, NULL, vrr_stack+5465);
 _BUILD_00q0(Data,vrr_stack+38305, vrr_stack+6089, vrr_stack+4270, vrr_stack+4468, vrr_stack+1426, NULL);
 _BUILD_p0q0(Data,vrr_stack+38396, vrr_stack+37759, vrr_stack+38305, NULL, NULL, vrr_stack+6089);
 _BUILD_d0q0(Data,vrr_stack+10166, vrr_stack+37941, vrr_stack+38396, vrr_stack+37850, vrr_stack+37759, vrr_stack+7535);
 _BUILD_d0q0(Data,vrr_stack+10712, vrr_stack+3874, vrr_stack+37941, vrr_stack+38214, vrr_stack+37850, vrr_stack+5543);
 _BUILD_f0q0(Data,vrr_stack+33913, vrr_stack+10712, vrr_stack+10166, vrr_stack+3874, vrr_stack+37941, vrr_stack+28112);
 _BUILD_00q0(Data,vrr_stack+37850, vrr_stack+20137, vrr_stack+5777, vrr_stack+13963, vrr_stack+4204, NULL);
 _BUILD_p0q0(Data,vrr_stack+28112, vrr_stack+37850, vrr_stack+38214, NULL, NULL, vrr_stack+5777);
 _BUILD_d0q0(Data,vrr_stack+11258, vrr_stack+28112, vrr_stack+3874, vrr_stack+37850, vrr_stack+38214, vrr_stack+5855);
 _BUILD_f0q0(Data,vrr_stack+5351, vrr_stack+11258, vrr_stack+10712, vrr_stack+28112, vrr_stack+3874, vrr_stack+28580);
 _BUILD_00q0(Data,vrr_stack+38214, vrr_stack+4270, vrr_stack+15772, vrr_stack+1426, vrr_stack+6496, NULL);
 _BUILD_p0q0(Data,vrr_stack+3874, vrr_stack+38305, vrr_stack+38214, NULL, NULL, vrr_stack+4270);
 _BUILD_d0q0(Data,vrr_stack+4147, vrr_stack+38396, vrr_stack+3874, vrr_stack+37759, vrr_stack+38305, vrr_stack+20449);
 _BUILD_f0q0(Data,vrr_stack+1756, vrr_stack+10166, vrr_stack+4147, vrr_stack+37941, vrr_stack+38396, vrr_stack+41773);
 _BUILD_g0q0(Data,vrr_stack+53629, vrr_stack+33913, vrr_stack+1756, vrr_stack+10712, vrr_stack+10166, vrr_stack+42241);
 _BUILD_g0q0(Data,vrr_stack+54994, vrr_stack+5351, vrr_stack+33913, vrr_stack+11258, vrr_stack+10712, vrr_stack+0);
 _BUILD_h0q0(Data,vrr_stack+56359, vrr_stack+54994, vrr_stack+53629, vrr_stack+5351, vrr_stack+33913, vrr_stack+43021);
 _BUILD_00q0(Data,vrr_stack+37759, vrr_stack+32347, vrr_stack+20137, vrr_stack+1690, vrr_stack+13963, NULL);
 _BUILD_p0q0(Data,vrr_stack+37941, vrr_stack+37759, vrr_stack+37850, NULL, NULL, vrr_stack+20137);
 _BUILD_d0q0(Data,vrr_stack+10712, vrr_stack+37941, vrr_stack+28112, vrr_stack+37759, vrr_stack+37850, vrr_stack+20215);
 _BUILD_f0q0(Data,vrr_stack+20137, vrr_stack+10712, vrr_stack+11258, vrr_stack+37941, vrr_stack+28112, vrr_stack+780);
 _BUILD_g0q0(Data,vrr_stack+0, vrr_stack+20137, vrr_stack+5351, vrr_stack+10712, vrr_stack+11258, vrr_stack+40993);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[4][12];
   for(i=0;i<1365;i++)
     target_ptr[i] += tmp[i];
 _BUILD_h0q0(Data,vrr_stack+40993, vrr_stack+0, vrr_stack+54994, vrr_stack+20137, vrr_stack+5351, vrr_stack+44191);
   tmp = vrr_stack + 40993;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+5351, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+5354, vrr_stack+32425, vrr_stack+5351, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+5360, vrr_stack+32428, vrr_stack+5354, vrr_stack+6377, vrr_stack+32425, NULL);
 _BUILD_00g0(Data,vrr_stack+5370, vrr_stack+32434, vrr_stack+5360, vrr_stack+6380, vrr_stack+32428, NULL);
 _BUILD_00h0(Data,vrr_stack+5385, vrr_stack+32444, vrr_stack+5370, vrr_stack+6386, vrr_stack+32434, NULL);
 _BUILD_00i0(Data,vrr_stack+5351, vrr_stack+32459, vrr_stack+5385, vrr_stack+6396, vrr_stack+32444, NULL);
 _BUILD_00k0(Data,vrr_stack+5379, vrr_stack+32480, vrr_stack+5351, vrr_stack+6411, vrr_stack+32459, NULL);
 _BUILD_00l0(Data,vrr_stack+5415, vrr_stack+32508, vrr_stack+5379, vrr_stack+6432, vrr_stack+32480, NULL);
 _BUILD_00m0(Data,vrr_stack+5351, vrr_stack+15727, vrr_stack+5415, vrr_stack+6460, vrr_stack+32508, NULL);
 _BUILD_00n0(Data,vrr_stack+5406, vrr_stack+32544, vrr_stack+5351, vrr_stack+12667, vrr_stack+15727, NULL);
 _BUILD_00o0(Data,vrr_stack+12667, vrr_stack+32599, vrr_stack+5406, vrr_stack+10111, vrr_stack+32544, NULL);
 _BUILD_00q0(Data,vrr_stack+12745, vrr_stack+15772, vrr_stack+12667, vrr_stack+6496, vrr_stack+32599, NULL);
 _BUILD_p0q0(Data,vrr_stack+12836, vrr_stack+38214, vrr_stack+12745, NULL, NULL, vrr_stack+15772);
 _BUILD_d0q0(Data,vrr_stack+5351, vrr_stack+3874, vrr_stack+12836, vrr_stack+38305, vrr_stack+38214, vrr_stack+15850);
 _BUILD_f0q0(Data,vrr_stack+5897, vrr_stack+4147, vrr_stack+5351, vrr_stack+38396, vrr_stack+3874, vrr_stack+32665);
 _BUILD_g0q0(Data,vrr_stack+42904, vrr_stack+1756, vrr_stack+5897, vrr_stack+10166, vrr_stack+4147, vrr_stack+33133);
 _BUILD_h0q0(Data,vrr_stack+58270, vrr_stack+53629, vrr_stack+42904, vrr_stack+33913, vrr_stack+1756, vrr_stack+48637);
 _BUILD_i0q0(Data,vrr_stack+32347, vrr_stack+56359, vrr_stack+58270, vrr_stack+54994, vrr_stack+53629, vrr_stack+49807);
 _BUILD_i0q0(Data,vrr_stack+58270, vrr_stack+40993, vrr_stack+56359, vrr_stack+0, vrr_stack+54994, vrr_stack+45361);
   tmp = vrr_stack + 58270;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0i0(Data,vrr_stack+0, vrr_stack+9327, vrr_stack+8543, vrr_stack+7955, vrr_stack+6947, vrr_stack+4763);
   tmp = vrr_stack + 0;
   target_ptr = Libint->vrr_classes[7][6];
   for(i=0;i<1008;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0k0(Data,vrr_stack+9327, vrr_stack+2866, vrr_stack+14719, vrr_stack+13207, vrr_stack+11911, vrr_stack+8543);
   tmp = vrr_stack + 9327;
   target_ptr = Libint->vrr_classes[7][7];
   for(i=0;i<1296;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0l0(Data,vrr_stack+10623, vrr_stack+22342, vrr_stack+21082, vrr_stack+19192, vrr_stack+18247, vrr_stack+14719);
   tmp = vrr_stack + 10623;
   target_ptr = Libint->vrr_classes[7][8];
   for(i=0;i<1620;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0m0(Data,vrr_stack+12243, vrr_stack+30807, vrr_stack+29267, vrr_stack+26957, vrr_stack+25802, vrr_stack+21082);
   tmp = vrr_stack + 12243;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0n0(Data,vrr_stack+1008, vrr_stack+39145, vrr_stack+16232, vrr_stack+36373, vrr_stack+34987, vrr_stack+29267);
   tmp = vrr_stack + 1008;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0o0(Data,vrr_stack+48637, vrr_stack+51445, vrr_stack+23602, vrr_stack+46999, vrr_stack+45361, vrr_stack+16232);
   tmp = vrr_stack + 48637;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0q0(Data,vrr_stack+51445, vrr_stack+58270, vrr_stack+32347, vrr_stack+40993, vrr_stack+56359, vrr_stack+23602);
   tmp = vrr_stack + 51445;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];

}

