/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hd|mf) integrals */

void vrr_order_hdmf(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00p0(Data,vrr_stack+12, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+0, vrr_stack+12, Data->F+8, Data->F+9, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+15, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+31, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+34, vrr_stack+6, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_p0f0(Data,vrr_stack+50, vrr_stack+40, vrr_stack+21, NULL, NULL, vrr_stack+6);
 _BUILD_00g0(Data,vrr_stack+80, vrr_stack+40, vrr_stack+21, vrr_stack+34, vrr_stack+6, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+3, vrr_stack+31, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+95, vrr_stack+34, vrr_stack+3, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+101, vrr_stack+40, vrr_stack+95, vrr_stack+34, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+12, vrr_stack+31, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+126, vrr_stack+15, vrr_stack+34, vrr_stack+0, vrr_stack+12, NULL);
 _BUILD_00g0(Data,vrr_stack+136, vrr_stack+21, vrr_stack+126, vrr_stack+6, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+151, vrr_stack+80, vrr_stack+136, NULL, NULL, vrr_stack+21);
 _BUILD_p0g0(Data,vrr_stack+196, vrr_stack+111, vrr_stack+80, NULL, NULL, vrr_stack+40);
 _BUILD_d0g0(Data,vrr_stack+241, vrr_stack+196, vrr_stack+151, vrr_stack+111, vrr_stack+80, vrr_stack+50);
 _BUILD_00h0(Data,vrr_stack+50, vrr_stack+80, vrr_stack+136, vrr_stack+40, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+331, vrr_stack+111, vrr_stack+80, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+352, vrr_stack+331, vrr_stack+50, NULL, NULL, vrr_stack+80);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+6, vrr_stack+0, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+6, vrr_stack+95, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+415, vrr_stack+40, vrr_stack+101, vrr_stack+6, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+430, vrr_stack+415, vrr_stack+111, vrr_stack+40, vrr_stack+101, NULL);
 _BUILD_p0h0(Data,vrr_stack+451, vrr_stack+430, vrr_stack+331, NULL, NULL, vrr_stack+111);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+95, vrr_stack+31, vrr_stack+3, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+101, vrr_stack+34, vrr_stack+95, vrr_stack+12, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+514, vrr_stack+126, vrr_stack+101, vrr_stack+15, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+529, vrr_stack+136, vrr_stack+514, vrr_stack+21, vrr_stack+126, NULL);
 _BUILD_p0h0(Data,vrr_stack+550, vrr_stack+50, vrr_stack+529, NULL, NULL, vrr_stack+136);
 _BUILD_d0h0(Data,vrr_stack+613, vrr_stack+352, vrr_stack+550, vrr_stack+331, vrr_stack+50, vrr_stack+151);
 _BUILD_d0h0(Data,vrr_stack+739, vrr_stack+451, vrr_stack+352, vrr_stack+430, vrr_stack+331, vrr_stack+196);
 _BUILD_f0h0(Data,vrr_stack+865, vrr_stack+739, vrr_stack+613, vrr_stack+451, vrr_stack+352, vrr_stack+241);
 _BUILD_00i0(Data,vrr_stack+151, vrr_stack+331, vrr_stack+50, vrr_stack+111, vrr_stack+80, NULL);
 _BUILD_00i0(Data,vrr_stack+179, vrr_stack+430, vrr_stack+331, vrr_stack+415, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+207, vrr_stack+50, vrr_stack+529, vrr_stack+80, vrr_stack+136, NULL);
 _BUILD_p0i0(Data,vrr_stack+235, vrr_stack+151, vrr_stack+207, NULL, NULL, vrr_stack+50);
 _BUILD_p0i0(Data,vrr_stack+1075, vrr_stack+179, vrr_stack+151, NULL, NULL, vrr_stack+331);
 _BUILD_d0i0(Data,vrr_stack+1159, vrr_stack+1075, vrr_stack+235, vrr_stack+179, vrr_stack+151, vrr_stack+352);
 _BUILD_00p0(Data,vrr_stack+352, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+355, vrr_stack+352, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+361, vrr_stack+355, vrr_stack+6, vrr_stack+352, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+361, vrr_stack+40, vrr_stack+355, vrr_stack+6, NULL);
 _BUILD_00h0(Data,vrr_stack+6, vrr_stack+111, vrr_stack+415, vrr_stack+361, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+371, vrr_stack+6, vrr_stack+430, vrr_stack+111, vrr_stack+415, NULL);
 _BUILD_p0i0(Data,vrr_stack+1327, vrr_stack+371, vrr_stack+179, NULL, NULL, vrr_stack+430);
 _BUILD_d0i0(Data,vrr_stack+1411, vrr_stack+1327, vrr_stack+1075, vrr_stack+371, vrr_stack+179, vrr_stack+451);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+451, vrr_stack+3, vrr_stack+0, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+95, vrr_stack+451, vrr_stack+31, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+457, vrr_stack+101, vrr_stack+40, vrr_stack+34, vrr_stack+95, NULL);
 _BUILD_00h0(Data,vrr_stack+472, vrr_stack+514, vrr_stack+457, vrr_stack+126, vrr_stack+101, NULL);
 _BUILD_00i0(Data,vrr_stack+399, vrr_stack+529, vrr_stack+472, vrr_stack+136, vrr_stack+514, NULL);
 _BUILD_p0i0(Data,vrr_stack+1579, vrr_stack+207, vrr_stack+399, NULL, NULL, vrr_stack+529);
 _BUILD_d0i0(Data,vrr_stack+1663, vrr_stack+235, vrr_stack+1579, vrr_stack+151, vrr_stack+207, vrr_stack+550);
 _BUILD_f0i0(Data,vrr_stack+1831, vrr_stack+1159, vrr_stack+1663, vrr_stack+1075, vrr_stack+235, vrr_stack+613);
 _BUILD_f0i0(Data,vrr_stack+2111, vrr_stack+1411, vrr_stack+1159, vrr_stack+1327, vrr_stack+1075, vrr_stack+739);
 _BUILD_g0i0(Data,vrr_stack+2391, vrr_stack+2111, vrr_stack+1831, vrr_stack+1411, vrr_stack+1159, vrr_stack+865);
 _BUILD_00k0(Data,vrr_stack+550, vrr_stack+151, vrr_stack+207, vrr_stack+331, vrr_stack+50, NULL);
 _BUILD_00k0(Data,vrr_stack+586, vrr_stack+179, vrr_stack+151, vrr_stack+430, vrr_stack+331, NULL);
 _BUILD_p0k0(Data,vrr_stack+622, vrr_stack+586, vrr_stack+550, NULL, NULL, vrr_stack+151);
 _BUILD_00k0(Data,vrr_stack+730, vrr_stack+371, vrr_stack+179, vrr_stack+6, vrr_stack+430, NULL);
 _BUILD_p0k0(Data,vrr_stack+766, vrr_stack+730, vrr_stack+586, NULL, NULL, vrr_stack+179);
 _BUILD_00k0(Data,vrr_stack+874, vrr_stack+207, vrr_stack+399, vrr_stack+50, vrr_stack+529, NULL);
 _BUILD_p0k0(Data,vrr_stack+910, vrr_stack+550, vrr_stack+874, NULL, NULL, vrr_stack+207);
 _BUILD_d0k0(Data,vrr_stack+2811, vrr_stack+622, vrr_stack+910, vrr_stack+586, vrr_stack+550, vrr_stack+235);
 _BUILD_d0k0(Data,vrr_stack+3027, vrr_stack+766, vrr_stack+622, vrr_stack+730, vrr_stack+586, vrr_stack+1075);
 _BUILD_f0k0(Data,vrr_stack+3243, vrr_stack+3027, vrr_stack+2811, vrr_stack+766, vrr_stack+622, vrr_stack+1159);
 _BUILD_00p0(Data,vrr_stack+235, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+238, vrr_stack+235, vrr_stack+352, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+244, vrr_stack+238, vrr_stack+355, vrr_stack+235, vrr_stack+352, NULL);
 _BUILD_00g0(Data,vrr_stack+254, vrr_stack+244, vrr_stack+361, vrr_stack+238, vrr_stack+355, NULL);
 _BUILD_00h0(Data,vrr_stack+493, vrr_stack+254, vrr_stack+111, vrr_stack+244, vrr_stack+361, NULL);
 _BUILD_00i0(Data,vrr_stack+269, vrr_stack+493, vrr_stack+6, vrr_stack+254, vrr_stack+111, NULL);
 _BUILD_00k0(Data,vrr_stack+111, vrr_stack+269, vrr_stack+371, vrr_stack+493, vrr_stack+6, NULL);
 _BUILD_p0k0(Data,vrr_stack+1018, vrr_stack+111, vrr_stack+730, NULL, NULL, vrr_stack+371);
 _BUILD_d0k0(Data,vrr_stack+3603, vrr_stack+1018, vrr_stack+766, vrr_stack+111, vrr_stack+730, vrr_stack+1327);
 _BUILD_f0k0(Data,vrr_stack+3819, vrr_stack+3603, vrr_stack+3027, vrr_stack+1018, vrr_stack+766, vrr_stack+1411);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+15, vrr_stack+451, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+25, vrr_stack+40, vrr_stack+15, vrr_stack+95, vrr_stack+451, NULL);
 _BUILD_00h0(Data,vrr_stack+297, vrr_stack+457, vrr_stack+25, vrr_stack+101, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+318, vrr_stack+472, vrr_stack+297, vrr_stack+514, vrr_stack+457, NULL);
 _BUILD_00k0(Data,vrr_stack+50, vrr_stack+399, vrr_stack+318, vrr_stack+529, vrr_stack+472, NULL);
 _BUILD_p0k0(Data,vrr_stack+1126, vrr_stack+874, vrr_stack+50, NULL, NULL, vrr_stack+399);
 _BUILD_d0k0(Data,vrr_stack+1234, vrr_stack+910, vrr_stack+1126, vrr_stack+550, vrr_stack+874, vrr_stack+1579);
 _BUILD_f0k0(Data,vrr_stack+4179, vrr_stack+2811, vrr_stack+1234, vrr_stack+622, vrr_stack+910, vrr_stack+1663);
 _BUILD_g0k0(Data,vrr_stack+4539, vrr_stack+3243, vrr_stack+4179, vrr_stack+3027, vrr_stack+2811, vrr_stack+1831);
 _BUILD_g0k0(Data,vrr_stack+1450, vrr_stack+3819, vrr_stack+3243, vrr_stack+3603, vrr_stack+3027, vrr_stack+2111);
 _BUILD_h0k0(Data,vrr_stack+5079, vrr_stack+1450, vrr_stack+4539, vrr_stack+3819, vrr_stack+3243, vrr_stack+2391);
 _BUILD_00l0(Data,vrr_stack+1990, vrr_stack+586, vrr_stack+550, vrr_stack+179, vrr_stack+151, NULL);
 _BUILD_00l0(Data,vrr_stack+2035, vrr_stack+730, vrr_stack+586, vrr_stack+371, vrr_stack+179, NULL);
 _BUILD_00l0(Data,vrr_stack+2080, vrr_stack+550, vrr_stack+874, vrr_stack+151, vrr_stack+207, NULL);
 _BUILD_p0l0(Data,vrr_stack+2125, vrr_stack+1990, vrr_stack+2080, NULL, NULL, vrr_stack+550);
 _BUILD_p0l0(Data,vrr_stack+2260, vrr_stack+2035, vrr_stack+1990, NULL, NULL, vrr_stack+586);
 _BUILD_d0l0(Data,vrr_stack+2395, vrr_stack+2260, vrr_stack+2125, vrr_stack+2035, vrr_stack+1990, vrr_stack+622);
 _BUILD_00l0(Data,vrr_stack+622, vrr_stack+111, vrr_stack+730, vrr_stack+269, vrr_stack+371, NULL);
 _BUILD_p0l0(Data,vrr_stack+2665, vrr_stack+622, vrr_stack+2035, NULL, NULL, vrr_stack+730);
 _BUILD_d0l0(Data,vrr_stack+5835, vrr_stack+2665, vrr_stack+2260, vrr_stack+622, vrr_stack+2035, vrr_stack+766);
 _BUILD_00l0(Data,vrr_stack+766, vrr_stack+874, vrr_stack+50, vrr_stack+207, vrr_stack+399, NULL);
 _BUILD_p0l0(Data,vrr_stack+6105, vrr_stack+2080, vrr_stack+766, NULL, NULL, vrr_stack+874);
 _BUILD_d0l0(Data,vrr_stack+6240, vrr_stack+2125, vrr_stack+6105, vrr_stack+1990, vrr_stack+2080, vrr_stack+910);
 _BUILD_f0l0(Data,vrr_stack+6510, vrr_stack+2395, vrr_stack+6240, vrr_stack+2260, vrr_stack+2125, vrr_stack+2811);
 _BUILD_f0l0(Data,vrr_stack+6960, vrr_stack+5835, vrr_stack+2395, vrr_stack+2665, vrr_stack+2260, vrr_stack+3027);
 _BUILD_g0l0(Data,vrr_stack+7410, vrr_stack+6960, vrr_stack+6510, vrr_stack+5835, vrr_stack+2395, vrr_stack+3243);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+910, vrr_stack+3, vrr_stack+235, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+916, vrr_stack+910, vrr_stack+238, vrr_stack+3, vrr_stack+235, NULL);
 _BUILD_00g0(Data,vrr_stack+926, vrr_stack+916, vrr_stack+244, vrr_stack+910, vrr_stack+238, NULL);
 _BUILD_00h0(Data,vrr_stack+941, vrr_stack+926, vrr_stack+254, vrr_stack+916, vrr_stack+244, NULL);
 _BUILD_00i0(Data,vrr_stack+962, vrr_stack+941, vrr_stack+493, vrr_stack+926, vrr_stack+254, NULL);
 _BUILD_00k0(Data,vrr_stack+514, vrr_stack+962, vrr_stack+269, vrr_stack+941, vrr_stack+493, NULL);
 _BUILD_00l0(Data,vrr_stack+811, vrr_stack+514, vrr_stack+111, vrr_stack+962, vrr_stack+269, NULL);
 _BUILD_p0l0(Data,vrr_stack+147, vrr_stack+811, vrr_stack+622, NULL, NULL, vrr_stack+111);
 _BUILD_d0l0(Data,vrr_stack+2800, vrr_stack+147, vrr_stack+2665, vrr_stack+811, vrr_stack+622, vrr_stack+1018);
 _BUILD_f0l0(Data,vrr_stack+3070, vrr_stack+2800, vrr_stack+5835, vrr_stack+147, vrr_stack+2665, vrr_stack+3603);
 _BUILD_g0l0(Data,vrr_stack+8085, vrr_stack+3070, vrr_stack+6960, vrr_stack+2800, vrr_stack+5835, vrr_stack+3819);
 _BUILD_00p0(Data,vrr_stack+493, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+496, vrr_stack+6, vrr_stack+493, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+502, vrr_stack+9, vrr_stack+496, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+282, vrr_stack+15, vrr_stack+502, vrr_stack+451, vrr_stack+9, NULL);
 _BUILD_00h0(Data,vrr_stack+990, vrr_stack+25, vrr_stack+282, vrr_stack+40, vrr_stack+15, NULL);
 _BUILD_00i0(Data,vrr_stack+1011, vrr_stack+297, vrr_stack+990, vrr_stack+457, vrr_stack+25, NULL);
 _BUILD_00k0(Data,vrr_stack+1039, vrr_stack+318, vrr_stack+1011, vrr_stack+472, vrr_stack+297, NULL);
 _BUILD_00l0(Data,vrr_stack+1075, vrr_stack+50, vrr_stack+1039, vrr_stack+399, vrr_stack+318, NULL);
 _BUILD_p0l0(Data,vrr_stack+346, vrr_stack+766, vrr_stack+1075, NULL, NULL, vrr_stack+50);
 _BUILD_d0l0(Data,vrr_stack+3520, vrr_stack+6105, vrr_stack+346, vrr_stack+2080, vrr_stack+766, vrr_stack+1126);
 _BUILD_f0l0(Data,vrr_stack+8760, vrr_stack+6240, vrr_stack+3520, vrr_stack+2125, vrr_stack+6105, vrr_stack+1234);
 _BUILD_g0l0(Data,vrr_stack+9210, vrr_stack+6510, vrr_stack+8760, vrr_stack+2395, vrr_stack+6240, vrr_stack+4179);
 _BUILD_h0l0(Data,vrr_stack+9885, vrr_stack+7410, vrr_stack+9210, vrr_stack+6960, vrr_stack+6510, vrr_stack+4539);
 _BUILD_h0l0(Data,vrr_stack+3790, vrr_stack+8085, vrr_stack+7410, vrr_stack+3070, vrr_stack+6960, vrr_stack+1450);
 _BUILD_i0l0(Data,vrr_stack+10830, vrr_stack+3790, vrr_stack+9885, vrr_stack+8085, vrr_stack+7410, vrr_stack+5079);
 _BUILD_00m0(Data,vrr_stack+1120, vrr_stack+1990, vrr_stack+2080, vrr_stack+586, vrr_stack+550, NULL);
 _BUILD_00m0(Data,vrr_stack+1175, vrr_stack+2035, vrr_stack+1990, vrr_stack+730, vrr_stack+586, NULL);
 _BUILD_p0m0(Data,vrr_stack+1230, vrr_stack+1175, vrr_stack+1120, NULL, NULL, vrr_stack+1990);
 _BUILD_00m0(Data,vrr_stack+1395, vrr_stack+622, vrr_stack+2035, vrr_stack+111, vrr_stack+730, NULL);
 _BUILD_p0m0(Data,vrr_stack+1450, vrr_stack+1395, vrr_stack+1175, NULL, NULL, vrr_stack+2035);
 _BUILD_00m0(Data,vrr_stack+1615, vrr_stack+2080, vrr_stack+766, vrr_stack+550, vrr_stack+874, NULL);
 _BUILD_p0m0(Data,vrr_stack+1670, vrr_stack+1120, vrr_stack+1615, NULL, NULL, vrr_stack+2080);
 _BUILD_d0m0(Data,vrr_stack+4735, vrr_stack+1230, vrr_stack+1670, vrr_stack+1175, vrr_stack+1120, vrr_stack+2125);
 _BUILD_d0m0(Data,vrr_stack+5065, vrr_stack+1450, vrr_stack+1230, vrr_stack+1395, vrr_stack+1175, vrr_stack+2260);
 _BUILD_f0m0(Data,vrr_stack+12090, vrr_stack+5065, vrr_stack+4735, vrr_stack+1450, vrr_stack+1230, vrr_stack+2395);
 _BUILD_00m0(Data,vrr_stack+2125, vrr_stack+811, vrr_stack+622, vrr_stack+514, vrr_stack+111, NULL);
 _BUILD_p0m0(Data,vrr_stack+2180, vrr_stack+2125, vrr_stack+1395, NULL, NULL, vrr_stack+622);
 _BUILD_d0m0(Data,vrr_stack+5395, vrr_stack+2180, vrr_stack+1450, vrr_stack+2125, vrr_stack+1395, vrr_stack+2665);
 _BUILD_f0m0(Data,vrr_stack+12640, vrr_stack+5395, vrr_stack+5065, vrr_stack+2180, vrr_stack+1450, vrr_stack+5835);
 _BUILD_00m0(Data,vrr_stack+2345, vrr_stack+766, vrr_stack+1075, vrr_stack+874, vrr_stack+50, NULL);
 _BUILD_p0m0(Data,vrr_stack+2400, vrr_stack+1615, vrr_stack+2345, NULL, NULL, vrr_stack+766);
 _BUILD_d0m0(Data,vrr_stack+5725, vrr_stack+1670, vrr_stack+2400, vrr_stack+1120, vrr_stack+1615, vrr_stack+6105);
 _BUILD_f0m0(Data,vrr_stack+13190, vrr_stack+4735, vrr_stack+5725, vrr_stack+1230, vrr_stack+1670, vrr_stack+6240);
 _BUILD_g0m0(Data,vrr_stack+13740, vrr_stack+12090, vrr_stack+13190, vrr_stack+5065, vrr_stack+4735, vrr_stack+6510);
 _BUILD_g0m0(Data,vrr_stack+6055, vrr_stack+12640, vrr_stack+12090, vrr_stack+5395, vrr_stack+5065, vrr_stack+6960);
 _BUILD_h0m0(Data,vrr_stack+14565, vrr_stack+6055, vrr_stack+13740, vrr_stack+12640, vrr_stack+12090, vrr_stack+7410);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2565, vrr_stack+0, vrr_stack+3, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+2565, vrr_stack+910, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+2571, vrr_stack+40, vrr_stack+916, vrr_stack+2565, vrr_stack+910, NULL);
 _BUILD_00h0(Data,vrr_stack+2586, vrr_stack+2571, vrr_stack+926, vrr_stack+40, vrr_stack+916, NULL);
 _BUILD_00i0(Data,vrr_stack+2607, vrr_stack+2586, vrr_stack+941, vrr_stack+2571, vrr_stack+926, NULL);
 _BUILD_00k0(Data,vrr_stack+2635, vrr_stack+2607, vrr_stack+962, vrr_stack+2586, vrr_stack+941, NULL);
 _BUILD_00l0(Data,vrr_stack+2671, vrr_stack+2635, vrr_stack+514, vrr_stack+2607, vrr_stack+962, NULL);
 _BUILD_00m0(Data,vrr_stack+2565, vrr_stack+2671, vrr_stack+811, vrr_stack+2635, vrr_stack+514, NULL);
 _BUILD_p0m0(Data,vrr_stack+6880, vrr_stack+2565, vrr_stack+2125, NULL, NULL, vrr_stack+811);
 _BUILD_d0m0(Data,vrr_stack+7045, vrr_stack+6880, vrr_stack+2180, vrr_stack+2565, vrr_stack+2125, vrr_stack+147);
 _BUILD_f0m0(Data,vrr_stack+7375, vrr_stack+7045, vrr_stack+5395, vrr_stack+6880, vrr_stack+2180, vrr_stack+2800);
 _BUILD_g0m0(Data,vrr_stack+15720, vrr_stack+7375, vrr_stack+12640, vrr_stack+7045, vrr_stack+5395, vrr_stack+3070);
 _BUILD_h0m0(Data,vrr_stack+16545, vrr_stack+15720, vrr_stack+6055, vrr_stack+7375, vrr_stack+12640, vrr_stack+8085);
   tmp = vrr_stack + 16545;
   target_ptr = Libint->vrr_classes[5][9];
   for(i=0;i<1155;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+6880, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+0, vrr_stack+493, vrr_stack+6880, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+496, vrr_stack+0, vrr_stack+6, vrr_stack+493, NULL);
 _BUILD_00g0(Data,vrr_stack+6883, vrr_stack+502, vrr_stack+40, vrr_stack+9, vrr_stack+496, NULL);
 _BUILD_00h0(Data,vrr_stack+6898, vrr_stack+282, vrr_stack+6883, vrr_stack+15, vrr_stack+502, NULL);
 _BUILD_00i0(Data,vrr_stack+6919, vrr_stack+990, vrr_stack+6898, vrr_stack+25, vrr_stack+282, NULL);
 _BUILD_00k0(Data,vrr_stack+6947, vrr_stack+1011, vrr_stack+6919, vrr_stack+297, vrr_stack+990, NULL);
 _BUILD_00l0(Data,vrr_stack+6983, vrr_stack+1039, vrr_stack+6947, vrr_stack+318, vrr_stack+1011, NULL);
 _BUILD_00m0(Data,vrr_stack+7028, vrr_stack+1075, vrr_stack+6983, vrr_stack+50, vrr_stack+1039, NULL);
 _BUILD_p0m0(Data,vrr_stack+50, vrr_stack+2345, vrr_stack+7028, NULL, NULL, vrr_stack+1075);
 _BUILD_d0m0(Data,vrr_stack+7083, vrr_stack+2400, vrr_stack+50, vrr_stack+1615, vrr_stack+2345, vrr_stack+346);
 _BUILD_f0m0(Data,vrr_stack+7413, vrr_stack+5725, vrr_stack+7083, vrr_stack+1670, vrr_stack+2400, vrr_stack+3520);
 _BUILD_g0m0(Data,vrr_stack+2716, vrr_stack+13190, vrr_stack+7413, vrr_stack+4735, vrr_stack+5725, vrr_stack+8760);
 _BUILD_h0m0(Data,vrr_stack+7963, vrr_stack+13740, vrr_stack+2716, vrr_stack+12090, vrr_stack+13190, vrr_stack+9210);
 _BUILD_i0m0(Data,vrr_stack+17700, vrr_stack+14565, vrr_stack+7963, vrr_stack+6055, vrr_stack+13740, vrr_stack+9885);
 _BUILD_i0m0(Data,vrr_stack+9118, vrr_stack+16545, vrr_stack+14565, vrr_stack+15720, vrr_stack+6055, vrr_stack+3790);
   tmp = vrr_stack + 9118;
   target_ptr = Libint->vrr_classes[6][9];
   for(i=0;i<1540;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00n0(Data,vrr_stack+15720, vrr_stack+1120, vrr_stack+1615, vrr_stack+1990, vrr_stack+2080, NULL);
 _BUILD_00n0(Data,vrr_stack+15786, vrr_stack+1175, vrr_stack+1120, vrr_stack+2035, vrr_stack+1990, NULL);
 _BUILD_p0n0(Data,vrr_stack+15852, vrr_stack+15786, vrr_stack+15720, NULL, NULL, vrr_stack+1120);
 _BUILD_00n0(Data,vrr_stack+16050, vrr_stack+1395, vrr_stack+1175, vrr_stack+622, vrr_stack+2035, NULL);
 _BUILD_p0n0(Data,vrr_stack+16116, vrr_stack+16050, vrr_stack+15786, NULL, NULL, vrr_stack+1175);
 _BUILD_00n0(Data,vrr_stack+16314, vrr_stack+1615, vrr_stack+2345, vrr_stack+2080, vrr_stack+766, NULL);
 _BUILD_p0n0(Data,vrr_stack+3541, vrr_stack+15720, vrr_stack+16314, NULL, NULL, vrr_stack+1615);
 _BUILD_d0n0(Data,vrr_stack+3739, vrr_stack+15852, vrr_stack+3541, vrr_stack+15786, vrr_stack+15720, vrr_stack+1670);
 _BUILD_d0n0(Data,vrr_stack+1670, vrr_stack+16116, vrr_stack+15852, vrr_stack+16050, vrr_stack+15786, vrr_stack+1230);
 _BUILD_f0n0(Data,vrr_stack+19240, vrr_stack+1670, vrr_stack+3739, vrr_stack+16116, vrr_stack+15852, vrr_stack+4735);
 _BUILD_00n0(Data,vrr_stack+1230, vrr_stack+2125, vrr_stack+1395, vrr_stack+811, vrr_stack+622, NULL);
 _BUILD_p0n0(Data,vrr_stack+4135, vrr_stack+1230, vrr_stack+16050, NULL, NULL, vrr_stack+1395);
 _BUILD_d0n0(Data,vrr_stack+4333, vrr_stack+4135, vrr_stack+16116, vrr_stack+1230, vrr_stack+16050, vrr_stack+1450);
 _BUILD_f0n0(Data,vrr_stack+19900, vrr_stack+4333, vrr_stack+1670, vrr_stack+4135, vrr_stack+16116, vrr_stack+5065);
 _BUILD_00n0(Data,vrr_stack+1450, vrr_stack+2345, vrr_stack+7028, vrr_stack+766, vrr_stack+1075, NULL);
 _BUILD_p0n0(Data,vrr_stack+4729, vrr_stack+16314, vrr_stack+1450, NULL, NULL, vrr_stack+2345);
 _BUILD_d0n0(Data,vrr_stack+4927, vrr_stack+3541, vrr_stack+4729, vrr_stack+15720, vrr_stack+16314, vrr_stack+2400);
 _BUILD_f0n0(Data,vrr_stack+20560, vrr_stack+3739, vrr_stack+4927, vrr_stack+15852, vrr_stack+3541, vrr_stack+5725);
 _BUILD_g0n0(Data,vrr_stack+21220, vrr_stack+19240, vrr_stack+20560, vrr_stack+1670, vrr_stack+3739, vrr_stack+13190);
 _BUILD_g0n0(Data,vrr_stack+22210, vrr_stack+19900, vrr_stack+19240, vrr_stack+4333, vrr_stack+1670, vrr_stack+12090);
 _BUILD_h0n0(Data,vrr_stack+23200, vrr_stack+22210, vrr_stack+21220, vrr_stack+19900, vrr_stack+19240, vrr_stack+13740);
 _BUILD_00n0(Data,vrr_stack+12090, vrr_stack+2565, vrr_stack+2125, vrr_stack+2671, vrr_stack+811, NULL);
 _BUILD_p0n0(Data,vrr_stack+12156, vrr_stack+12090, vrr_stack+1230, NULL, NULL, vrr_stack+2125);
 _BUILD_d0n0(Data,vrr_stack+13190, vrr_stack+12156, vrr_stack+4135, vrr_stack+12090, vrr_stack+1230, vrr_stack+2180);
 _BUILD_f0n0(Data,vrr_stack+13586, vrr_stack+13190, vrr_stack+4333, vrr_stack+12156, vrr_stack+4135, vrr_stack+5395);
 _BUILD_g0n0(Data,vrr_stack+24586, vrr_stack+13586, vrr_stack+19900, vrr_stack+13190, vrr_stack+4333, vrr_stack+12640);
 _BUILD_h0n0(Data,vrr_stack+12156, vrr_stack+24586, vrr_stack+22210, vrr_stack+13586, vrr_stack+19900, vrr_stack+6055);
   tmp = vrr_stack + 12156;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+13542, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+13545, vrr_stack+6880, vrr_stack+13542, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+13551, vrr_stack+0, vrr_stack+13545, vrr_stack+493, vrr_stack+6880, NULL);
 _BUILD_00g0(Data,vrr_stack+13561, vrr_stack+40, vrr_stack+13551, vrr_stack+496, vrr_stack+0, NULL);
 _BUILD_00h0(Data,vrr_stack+13576, vrr_stack+6883, vrr_stack+13561, vrr_stack+502, vrr_stack+40, NULL);
 _BUILD_00i0(Data,vrr_stack+13597, vrr_stack+6898, vrr_stack+13576, vrr_stack+282, vrr_stack+6883, NULL);
 _BUILD_00k0(Data,vrr_stack+13625, vrr_stack+6919, vrr_stack+13597, vrr_stack+990, vrr_stack+6898, NULL);
 _BUILD_00l0(Data,vrr_stack+13661, vrr_stack+6947, vrr_stack+13625, vrr_stack+1011, vrr_stack+6919, NULL);
 _BUILD_00m0(Data,vrr_stack+13706, vrr_stack+6983, vrr_stack+13661, vrr_stack+1039, vrr_stack+6947, NULL);
 _BUILD_00n0(Data,vrr_stack+13761, vrr_stack+7028, vrr_stack+13706, vrr_stack+1075, vrr_stack+6983, NULL);
 _BUILD_p0n0(Data,vrr_stack+13827, vrr_stack+1450, vrr_stack+13761, NULL, NULL, vrr_stack+7028);
 _BUILD_d0n0(Data,vrr_stack+14025, vrr_stack+4729, vrr_stack+13827, vrr_stack+16314, vrr_stack+1450, vrr_stack+50);
 _BUILD_f0n0(Data,vrr_stack+50, vrr_stack+4927, vrr_stack+14025, vrr_stack+3541, vrr_stack+4729, vrr_stack+7083);
 _BUILD_g0n0(Data,vrr_stack+5323, vrr_stack+20560, vrr_stack+50, vrr_stack+3739, vrr_stack+4927, vrr_stack+7413);
 _BUILD_h0n0(Data,vrr_stack+25576, vrr_stack+21220, vrr_stack+5323, vrr_stack+19240, vrr_stack+20560, vrr_stack+2716);
 _BUILD_i0n0(Data,vrr_stack+26962, vrr_stack+23200, vrr_stack+25576, vrr_stack+22210, vrr_stack+21220, vrr_stack+7963);
 _BUILD_i0n0(Data,vrr_stack+7083, vrr_stack+12156, vrr_stack+23200, vrr_stack+24586, vrr_stack+22210, vrr_stack+14565);
   tmp = vrr_stack + 7083;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+24586, vrr_stack+15720, vrr_stack+16314, vrr_stack+1120, vrr_stack+1615, NULL);
 _BUILD_00o0(Data,vrr_stack+24664, vrr_stack+15786, vrr_stack+15720, vrr_stack+1175, vrr_stack+1120, NULL);
 _BUILD_p0o0(Data,vrr_stack+24742, vrr_stack+24664, vrr_stack+24586, NULL, NULL, vrr_stack+15720);
 _BUILD_00o0(Data,vrr_stack+24976, vrr_stack+16050, vrr_stack+15786, vrr_stack+1395, vrr_stack+1175, NULL);
 _BUILD_p0o0(Data,vrr_stack+25054, vrr_stack+24976, vrr_stack+24664, NULL, NULL, vrr_stack+15786);
 _BUILD_00o0(Data,vrr_stack+25288, vrr_stack+16314, vrr_stack+1450, vrr_stack+1615, vrr_stack+2345, NULL);
 _BUILD_p0o0(Data,vrr_stack+710, vrr_stack+24586, vrr_stack+25288, NULL, NULL, vrr_stack+16314);
 _BUILD_d0o0(Data,vrr_stack+2620, vrr_stack+24742, vrr_stack+710, vrr_stack+24664, vrr_stack+24586, vrr_stack+3541);
 _BUILD_d0o0(Data,vrr_stack+3088, vrr_stack+25054, vrr_stack+24742, vrr_stack+24976, vrr_stack+24664, vrr_stack+15852);
 _BUILD_f0o0(Data,vrr_stack+28810, vrr_stack+3088, vrr_stack+2620, vrr_stack+25054, vrr_stack+24742, vrr_stack+3739);
 _BUILD_00o0(Data,vrr_stack+15852, vrr_stack+1230, vrr_stack+16050, vrr_stack+2125, vrr_stack+1395, NULL);
 _BUILD_p0o0(Data,vrr_stack+944, vrr_stack+15852, vrr_stack+24976, NULL, NULL, vrr_stack+16050);
 _BUILD_d0o0(Data,vrr_stack+3556, vrr_stack+944, vrr_stack+25054, vrr_stack+15852, vrr_stack+24976, vrr_stack+16116);
 _BUILD_f0o0(Data,vrr_stack+29590, vrr_stack+3556, vrr_stack+3088, vrr_stack+944, vrr_stack+25054, vrr_stack+1670);
 _BUILD_00o0(Data,vrr_stack+16116, vrr_stack+1450, vrr_stack+13761, vrr_stack+2345, vrr_stack+7028, NULL);
 _BUILD_p0o0(Data,vrr_stack+2180, vrr_stack+25288, vrr_stack+16116, NULL, NULL, vrr_stack+1450);
 _BUILD_d0o0(Data,vrr_stack+1516, vrr_stack+710, vrr_stack+2180, vrr_stack+24586, vrr_stack+25288, vrr_stack+4729);
 _BUILD_f0o0(Data,vrr_stack+30370, vrr_stack+2620, vrr_stack+1516, vrr_stack+24742, vrr_stack+710, vrr_stack+4927);
 _BUILD_g0o0(Data,vrr_stack+31150, vrr_stack+28810, vrr_stack+30370, vrr_stack+3088, vrr_stack+2620, vrr_stack+20560);
 _BUILD_g0o0(Data,vrr_stack+32320, vrr_stack+29590, vrr_stack+28810, vrr_stack+3556, vrr_stack+3088, vrr_stack+19240);
 _BUILD_h0o0(Data,vrr_stack+33490, vrr_stack+32320, vrr_stack+31150, vrr_stack+29590, vrr_stack+28810, vrr_stack+21220);
 _BUILD_00o0(Data,vrr_stack+19240, vrr_stack+12090, vrr_stack+1230, vrr_stack+2565, vrr_stack+2125, NULL);
 _BUILD_p0o0(Data,vrr_stack+19318, vrr_stack+19240, vrr_stack+15852, NULL, NULL, vrr_stack+1230);
 _BUILD_d0o0(Data,vrr_stack+20560, vrr_stack+19318, vrr_stack+944, vrr_stack+19240, vrr_stack+15852, vrr_stack+4135);
 _BUILD_f0o0(Data,vrr_stack+21028, vrr_stack+20560, vrr_stack+3556, vrr_stack+19318, vrr_stack+944, vrr_stack+4333);
 _BUILD_g0o0(Data,vrr_stack+4024, vrr_stack+21028, vrr_stack+29590, vrr_stack+20560, vrr_stack+3556, vrr_stack+19900);
 _BUILD_h0o0(Data,vrr_stack+19318, vrr_stack+4024, vrr_stack+32320, vrr_stack+21028, vrr_stack+29590, vrr_stack+22210);
   tmp = vrr_stack + 19318;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+20956, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+20959, vrr_stack+13542, vrr_stack+20956, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+20965, vrr_stack+13545, vrr_stack+20959, vrr_stack+6880, vrr_stack+13542, NULL);
 _BUILD_00g0(Data,vrr_stack+20975, vrr_stack+13551, vrr_stack+20965, vrr_stack+0, vrr_stack+13545, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+13561, vrr_stack+20975, vrr_stack+40, vrr_stack+13551, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+13576, vrr_stack+0, vrr_stack+6883, vrr_stack+13561, NULL);
 _BUILD_00k0(Data,vrr_stack+20990, vrr_stack+13597, vrr_stack+21, vrr_stack+6898, vrr_stack+13576, NULL);
 _BUILD_00l0(Data,vrr_stack+21026, vrr_stack+13625, vrr_stack+20990, vrr_stack+6919, vrr_stack+13597, NULL);
 _BUILD_00m0(Data,vrr_stack+21071, vrr_stack+13661, vrr_stack+21026, vrr_stack+6947, vrr_stack+13625, NULL);
 _BUILD_00n0(Data,vrr_stack+21126, vrr_stack+13706, vrr_stack+21071, vrr_stack+6983, vrr_stack+13661, NULL);
 _BUILD_00o0(Data,vrr_stack+21192, vrr_stack+13761, vrr_stack+21126, vrr_stack+7028, vrr_stack+13706, NULL);
 _BUILD_p0o0(Data,vrr_stack+21270, vrr_stack+16116, vrr_stack+21192, NULL, NULL, vrr_stack+13761);
 _BUILD_d0o0(Data,vrr_stack+21504, vrr_stack+2180, vrr_stack+21270, vrr_stack+25288, vrr_stack+16116, vrr_stack+13827);
 _BUILD_f0o0(Data,vrr_stack+21972, vrr_stack+1516, vrr_stack+21504, vrr_stack+710, vrr_stack+2180, vrr_stack+14025);
 _BUILD_g0o0(Data,vrr_stack+35128, vrr_stack+30370, vrr_stack+21972, vrr_stack+2620, vrr_stack+1516, vrr_stack+50);
 _BUILD_h0o0(Data,vrr_stack+36298, vrr_stack+31150, vrr_stack+35128, vrr_stack+28810, vrr_stack+30370, vrr_stack+5323);
 _BUILD_i0o0(Data,vrr_stack+37936, vrr_stack+33490, vrr_stack+36298, vrr_stack+32320, vrr_stack+31150, vrr_stack+25576);
 _BUILD_i0o0(Data,vrr_stack+40120, vrr_stack+19318, vrr_stack+33490, vrr_stack+4024, vrr_stack+32320, vrr_stack+23200);
   tmp = vrr_stack + 40120;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+4024, vrr_stack+24586, vrr_stack+25288, vrr_stack+15720, vrr_stack+16314, NULL);
 _BUILD_00q0(Data,vrr_stack+4115, vrr_stack+24664, vrr_stack+24586, vrr_stack+15786, vrr_stack+15720, NULL);
 _BUILD_p0q0(Data,vrr_stack+4206, vrr_stack+4115, vrr_stack+4024, NULL, NULL, vrr_stack+24586);
 _BUILD_00q0(Data,vrr_stack+4479, vrr_stack+24976, vrr_stack+24664, vrr_stack+16050, vrr_stack+15786, NULL);
 _BUILD_p0q0(Data,vrr_stack+4570, vrr_stack+4479, vrr_stack+4115, NULL, NULL, vrr_stack+24664);
 _BUILD_00q0(Data,vrr_stack+24586, vrr_stack+25288, vrr_stack+16116, vrr_stack+16314, vrr_stack+1450, NULL);
 _BUILD_p0q0(Data,vrr_stack+4843, vrr_stack+4024, vrr_stack+24586, NULL, NULL, vrr_stack+25288);
 _BUILD_d0q0(Data,vrr_stack+25288, vrr_stack+4206, vrr_stack+4843, vrr_stack+4115, vrr_stack+4024, vrr_stack+710);
 _BUILD_d0q0(Data,vrr_stack+25834, vrr_stack+4570, vrr_stack+4206, vrr_stack+4479, vrr_stack+4115, vrr_stack+24742);
 _BUILD_f0q0(Data,vrr_stack+5116, vrr_stack+25834, vrr_stack+25288, vrr_stack+4570, vrr_stack+4206, vrr_stack+2620);
 _BUILD_00q0(Data,vrr_stack+4115, vrr_stack+15852, vrr_stack+24976, vrr_stack+1230, vrr_stack+16050, NULL);
 _BUILD_p0q0(Data,vrr_stack+26380, vrr_stack+4115, vrr_stack+4479, NULL, NULL, vrr_stack+24976);
 _BUILD_d0q0(Data,vrr_stack+6026, vrr_stack+26380, vrr_stack+4570, vrr_stack+4115, vrr_stack+4479, vrr_stack+25054);
 _BUILD_f0q0(Data,vrr_stack+42304, vrr_stack+6026, vrr_stack+25834, vrr_stack+26380, vrr_stack+4570, vrr_stack+3088);
 _BUILD_00q0(Data,vrr_stack+4479, vrr_stack+16116, vrr_stack+21192, vrr_stack+1450, vrr_stack+13761, NULL);
 _BUILD_p0q0(Data,vrr_stack+4570, vrr_stack+24586, vrr_stack+4479, NULL, NULL, vrr_stack+16116);
 _BUILD_d0q0(Data,vrr_stack+24677, vrr_stack+4843, vrr_stack+4570, vrr_stack+4024, vrr_stack+24586, vrr_stack+2180);
 _BUILD_f0q0(Data,vrr_stack+1984, vrr_stack+25288, vrr_stack+24677, vrr_stack+4206, vrr_stack+4843, vrr_stack+1516);
 _BUILD_g0q0(Data,vrr_stack+43214, vrr_stack+5116, vrr_stack+1984, vrr_stack+25834, vrr_stack+25288, vrr_stack+30370);
 _BUILD_g0q0(Data,vrr_stack+44579, vrr_stack+42304, vrr_stack+5116, vrr_stack+6026, vrr_stack+25834, vrr_stack+28810);
 _BUILD_h0q0(Data,vrr_stack+45944, vrr_stack+44579, vrr_stack+43214, vrr_stack+42304, vrr_stack+5116, vrr_stack+31150);
 _BUILD_00q0(Data,vrr_stack+4024, vrr_stack+19240, vrr_stack+15852, vrr_stack+12090, vrr_stack+1230, NULL);
 _BUILD_p0q0(Data,vrr_stack+4206, vrr_stack+4024, vrr_stack+4115, NULL, NULL, vrr_stack+15852);
 _BUILD_d0q0(Data,vrr_stack+25834, vrr_stack+4206, vrr_stack+26380, vrr_stack+4024, vrr_stack+4115, vrr_stack+944);
 _BUILD_f0q0(Data,vrr_stack+30370, vrr_stack+25834, vrr_stack+6026, vrr_stack+4206, vrr_stack+26380, vrr_stack+3556);
 _BUILD_g0q0(Data,vrr_stack+49, vrr_stack+30370, vrr_stack+42304, vrr_stack+25834, vrr_stack+6026, vrr_stack+29590);
 _BUILD_h0q0(Data,vrr_stack+47855, vrr_stack+49, vrr_stack+44579, vrr_stack+30370, vrr_stack+42304, vrr_stack+32320);
   tmp = vrr_stack + 47855;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+42304, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42307, vrr_stack+20956, vrr_stack+42304, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+42313, vrr_stack+20959, vrr_stack+42307, vrr_stack+13542, vrr_stack+20956, NULL);
 _BUILD_00g0(Data,vrr_stack+42323, vrr_stack+20965, vrr_stack+42313, vrr_stack+13545, vrr_stack+20959, NULL);
 _BUILD_00h0(Data,vrr_stack+42338, vrr_stack+20975, vrr_stack+42323, vrr_stack+13551, vrr_stack+20965, NULL);
 _BUILD_00i0(Data,vrr_stack+42304, vrr_stack+0, vrr_stack+42338, vrr_stack+13561, vrr_stack+20975, NULL);
 _BUILD_00k0(Data,vrr_stack+42332, vrr_stack+21, vrr_stack+42304, vrr_stack+13576, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+13542, vrr_stack+20990, vrr_stack+42332, vrr_stack+13597, vrr_stack+21, NULL);
 _BUILD_00m0(Data,vrr_stack+42304, vrr_stack+21026, vrr_stack+13542, vrr_stack+13625, vrr_stack+20990, NULL);
 _BUILD_00n0(Data,vrr_stack+12090, vrr_stack+21071, vrr_stack+42304, vrr_stack+13661, vrr_stack+21026, NULL);
 _BUILD_00o0(Data,vrr_stack+19240, vrr_stack+21126, vrr_stack+12090, vrr_stack+13706, vrr_stack+21071, NULL);
 _BUILD_00q0(Data,vrr_stack+42304, vrr_stack+21192, vrr_stack+19240, vrr_stack+13761, vrr_stack+21126, NULL);
 _BUILD_p0q0(Data,vrr_stack+42395, vrr_stack+4479, vrr_stack+42304, NULL, NULL, vrr_stack+21192);
 _BUILD_d0q0(Data,vrr_stack+42668, vrr_stack+4570, vrr_stack+42395, vrr_stack+24586, vrr_stack+4479, vrr_stack+21270);
 _BUILD_f0q0(Data,vrr_stack+13542, vrr_stack+24677, vrr_stack+42668, vrr_stack+4843, vrr_stack+4570, vrr_stack+21504);
 _BUILD_g0q0(Data,vrr_stack+28810, vrr_stack+1984, vrr_stack+13542, vrr_stack+25288, vrr_stack+24677, vrr_stack+21972);
 _BUILD_h0q0(Data,vrr_stack+24586, vrr_stack+43214, vrr_stack+28810, vrr_stack+5116, vrr_stack+1984, vrr_stack+35128);
 _BUILD_i0q0(Data,vrr_stack+28810, vrr_stack+45944, vrr_stack+24586, vrr_stack+44579, vrr_stack+43214, vrr_stack+36298);
 _BUILD_i0q0(Data,vrr_stack+35128, vrr_stack+47855, vrr_stack+45944, vrr_stack+49, vrr_stack+44579, vrr_stack+33490);
   tmp = vrr_stack + 35128;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0m0(Data,vrr_stack+24586, vrr_stack+9118, vrr_stack+17700, vrr_stack+16545, vrr_stack+14565, vrr_stack+10830);
   tmp = vrr_stack + 24586;
   target_ptr = Libint->vrr_classes[7][9];
   for(i=0;i<1980;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0n0(Data,vrr_stack+13542, vrr_stack+7083, vrr_stack+26962, vrr_stack+12156, vrr_stack+23200, vrr_stack+17700);
   tmp = vrr_stack + 13542;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0o0(Data,vrr_stack+15918, vrr_stack+40120, vrr_stack+37936, vrr_stack+19318, vrr_stack+33490, vrr_stack+26962);
   tmp = vrr_stack + 15918;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0q0(Data,vrr_stack+40120, vrr_stack+35128, vrr_stack+28810, vrr_stack+47855, vrr_stack+45944, vrr_stack+37936);
   tmp = vrr_stack + 40120;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];

}

