/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (hd|ni) integrals */

void vrr_order_hdni(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+0, vrr_stack+6, Data->F+8, Data->F+9, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+15, vrr_stack+9, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00p0(Data,vrr_stack+31, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+34, vrr_stack+6, vrr_stack+31, Data->F+9, Data->F+10, NULL);
 _BUILD_00f0(Data,vrr_stack+40, vrr_stack+9, vrr_stack+34, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+50, vrr_stack+21, vrr_stack+40, vrr_stack+15, vrr_stack+9, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+0, vrr_stack+3, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+65, vrr_stack+15, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+81, vrr_stack+71, vrr_stack+21, vrr_stack+65, vrr_stack+15, NULL);
 _BUILD_p0g0(Data,vrr_stack+96, vrr_stack+81, vrr_stack+50, NULL, NULL, vrr_stack+21);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+81, vrr_stack+50, vrr_stack+71, vrr_stack+21, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+15, vrr_stack+3, vrr_stack+0, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+162, vrr_stack+15, vrr_stack+65, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+172, vrr_stack+162, vrr_stack+71, vrr_stack+15, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+187, vrr_stack+172, vrr_stack+81, vrr_stack+162, vrr_stack+71, NULL);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+65, vrr_stack+31, vrr_stack+0, Data->F+10, Data->F+11, NULL);
 _BUILD_00f0(Data,vrr_stack+71, vrr_stack+34, vrr_stack+65, vrr_stack+6, vrr_stack+31, NULL);
 _BUILD_00g0(Data,vrr_stack+208, vrr_stack+40, vrr_stack+71, vrr_stack+9, vrr_stack+34, NULL);
 _BUILD_00h0(Data,vrr_stack+223, vrr_stack+50, vrr_stack+208, vrr_stack+21, vrr_stack+40, NULL);
 _BUILD_p0h0(Data,vrr_stack+244, vrr_stack+141, vrr_stack+223, NULL, NULL, vrr_stack+50);
 _BUILD_p0h0(Data,vrr_stack+307, vrr_stack+187, vrr_stack+141, NULL, NULL, vrr_stack+81);
 _BUILD_d0h0(Data,vrr_stack+370, vrr_stack+307, vrr_stack+244, vrr_stack+187, vrr_stack+141, vrr_stack+96);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+141, vrr_stack+223, vrr_stack+81, vrr_stack+50, NULL);
 _BUILD_00i0(Data,vrr_stack+496, vrr_stack+187, vrr_stack+141, vrr_stack+172, vrr_stack+81, NULL);
 _BUILD_p0i0(Data,vrr_stack+524, vrr_stack+496, vrr_stack+96, NULL, NULL, vrr_stack+141);
 _BUILD_00p0(Data,vrr_stack+81, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+84, vrr_stack+81, vrr_stack+3, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+21, vrr_stack+84, vrr_stack+15, vrr_stack+81, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+124, vrr_stack+21, vrr_stack+162, vrr_stack+84, vrr_stack+15, NULL);
 _BUILD_00h0(Data,vrr_stack+608, vrr_stack+124, vrr_stack+172, vrr_stack+21, vrr_stack+162, NULL);
 _BUILD_00i0(Data,vrr_stack+629, vrr_stack+608, vrr_stack+187, vrr_stack+124, vrr_stack+172, NULL);
 _BUILD_p0i0(Data,vrr_stack+657, vrr_stack+629, vrr_stack+496, NULL, NULL, vrr_stack+187);
 _BUILD_00p0(Data,vrr_stack+162, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+90, vrr_stack+0, vrr_stack+162, Data->F+11, Data->F+12, NULL);
 _BUILD_00f0(Data,vrr_stack+165, vrr_stack+65, vrr_stack+90, vrr_stack+31, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+3, vrr_stack+71, vrr_stack+165, vrr_stack+34, vrr_stack+65, NULL);
 _BUILD_00h0(Data,vrr_stack+741, vrr_stack+208, vrr_stack+3, vrr_stack+40, vrr_stack+71, NULL);
 _BUILD_00i0(Data,vrr_stack+762, vrr_stack+223, vrr_stack+741, vrr_stack+50, vrr_stack+208, NULL);
 _BUILD_p0i0(Data,vrr_stack+790, vrr_stack+96, vrr_stack+762, NULL, NULL, vrr_stack+223);
 _BUILD_d0i0(Data,vrr_stack+874, vrr_stack+524, vrr_stack+790, vrr_stack+496, vrr_stack+96, vrr_stack+244);
 _BUILD_d0i0(Data,vrr_stack+1042, vrr_stack+657, vrr_stack+524, vrr_stack+629, vrr_stack+496, vrr_stack+307);
 _BUILD_f0i0(Data,vrr_stack+1210, vrr_stack+1042, vrr_stack+874, vrr_stack+657, vrr_stack+524, vrr_stack+370);
 _BUILD_00k0(Data,vrr_stack+244, vrr_stack+496, vrr_stack+96, vrr_stack+187, vrr_stack+141, NULL);
 _BUILD_00k0(Data,vrr_stack+280, vrr_stack+629, vrr_stack+496, vrr_stack+608, vrr_stack+187, NULL);
 _BUILD_00k0(Data,vrr_stack+316, vrr_stack+96, vrr_stack+762, vrr_stack+141, vrr_stack+223, NULL);
 _BUILD_p0k0(Data,vrr_stack+352, vrr_stack+244, vrr_stack+316, NULL, NULL, vrr_stack+96);
 _BUILD_p0k0(Data,vrr_stack+1490, vrr_stack+280, vrr_stack+244, NULL, NULL, vrr_stack+496);
 _BUILD_d0k0(Data,vrr_stack+1598, vrr_stack+1490, vrr_stack+352, vrr_stack+280, vrr_stack+244, vrr_stack+524);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+524, vrr_stack+18, vrr_stack+81, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+530, vrr_stack+524, vrr_stack+84, vrr_stack+18, vrr_stack+81, NULL);
 _BUILD_00g0(Data,vrr_stack+540, vrr_stack+530, vrr_stack+21, vrr_stack+524, vrr_stack+84, NULL);
 _BUILD_00h0(Data,vrr_stack+555, vrr_stack+540, vrr_stack+124, vrr_stack+530, vrr_stack+21, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+555, vrr_stack+608, vrr_stack+540, vrr_stack+124, NULL);
 _BUILD_00k0(Data,vrr_stack+460, vrr_stack+21, vrr_stack+629, vrr_stack+555, vrr_stack+608, NULL);
 _BUILD_p0k0(Data,vrr_stack+1814, vrr_stack+460, vrr_stack+280, NULL, NULL, vrr_stack+629);
 _BUILD_d0k0(Data,vrr_stack+1922, vrr_stack+1814, vrr_stack+1490, vrr_stack+460, vrr_stack+280, vrr_stack+657);
 _BUILD_00p0(Data,vrr_stack+657, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+660, vrr_stack+162, vrr_stack+657, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+666, vrr_stack+90, vrr_stack+660, vrr_stack+0, vrr_stack+162, NULL);
 _BUILD_00g0(Data,vrr_stack+676, vrr_stack+165, vrr_stack+666, vrr_stack+65, vrr_stack+90, NULL);
 _BUILD_00h0(Data,vrr_stack+691, vrr_stack+3, vrr_stack+676, vrr_stack+71, vrr_stack+165, NULL);
 _BUILD_00i0(Data,vrr_stack+712, vrr_stack+741, vrr_stack+691, vrr_stack+208, vrr_stack+3, NULL);
 _BUILD_00k0(Data,vrr_stack+124, vrr_stack+762, vrr_stack+712, vrr_stack+223, vrr_stack+741, NULL);
 _BUILD_p0k0(Data,vrr_stack+2138, vrr_stack+316, vrr_stack+124, NULL, NULL, vrr_stack+762);
 _BUILD_d0k0(Data,vrr_stack+2246, vrr_stack+352, vrr_stack+2138, vrr_stack+244, vrr_stack+316, vrr_stack+790);
 _BUILD_f0k0(Data,vrr_stack+2462, vrr_stack+1598, vrr_stack+2246, vrr_stack+1490, vrr_stack+352, vrr_stack+874);
 _BUILD_f0k0(Data,vrr_stack+2822, vrr_stack+1922, vrr_stack+1598, vrr_stack+1814, vrr_stack+1490, vrr_stack+1042);
 _BUILD_g0k0(Data,vrr_stack+3182, vrr_stack+2822, vrr_stack+2462, vrr_stack+1922, vrr_stack+1598, vrr_stack+1210);
 _BUILD_00l0(Data,vrr_stack+790, vrr_stack+244, vrr_stack+316, vrr_stack+496, vrr_stack+96, NULL);
 _BUILD_00l0(Data,vrr_stack+835, vrr_stack+280, vrr_stack+244, vrr_stack+629, vrr_stack+496, NULL);
 _BUILD_p0l0(Data,vrr_stack+880, vrr_stack+835, vrr_stack+790, NULL, NULL, vrr_stack+244);
 _BUILD_00l0(Data,vrr_stack+1015, vrr_stack+460, vrr_stack+280, vrr_stack+21, vrr_stack+629, NULL);
 _BUILD_p0l0(Data,vrr_stack+1060, vrr_stack+1015, vrr_stack+835, NULL, NULL, vrr_stack+280);
 _BUILD_00l0(Data,vrr_stack+1195, vrr_stack+316, vrr_stack+124, vrr_stack+96, vrr_stack+762, NULL);
 _BUILD_p0l0(Data,vrr_stack+1240, vrr_stack+790, vrr_stack+1195, NULL, NULL, vrr_stack+316);
 _BUILD_d0l0(Data,vrr_stack+3722, vrr_stack+880, vrr_stack+1240, vrr_stack+835, vrr_stack+790, vrr_stack+352);
 _BUILD_d0l0(Data,vrr_stack+3992, vrr_stack+1060, vrr_stack+880, vrr_stack+1015, vrr_stack+835, vrr_stack+1490);
 _BUILD_f0l0(Data,vrr_stack+4262, vrr_stack+3992, vrr_stack+3722, vrr_stack+1060, vrr_stack+880, vrr_stack+1598);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+352, vrr_stack+0, vrr_stack+18, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+358, vrr_stack+352, vrr_stack+524, vrr_stack+0, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+368, vrr_stack+358, vrr_stack+530, vrr_stack+352, vrr_stack+524, NULL);
 _BUILD_00h0(Data,vrr_stack+383, vrr_stack+368, vrr_stack+540, vrr_stack+358, vrr_stack+530, NULL);
 _BUILD_00i0(Data,vrr_stack+96, vrr_stack+383, vrr_stack+555, vrr_stack+368, vrr_stack+540, NULL);
 _BUILD_00k0(Data,vrr_stack+404, vrr_stack+96, vrr_stack+21, vrr_stack+383, vrr_stack+555, NULL);
 _BUILD_00l0(Data,vrr_stack+496, vrr_stack+404, vrr_stack+460, vrr_stack+96, vrr_stack+21, NULL);
 _BUILD_p0l0(Data,vrr_stack+1375, vrr_stack+496, vrr_stack+1015, NULL, NULL, vrr_stack+460);
 _BUILD_d0l0(Data,vrr_stack+1510, vrr_stack+1375, vrr_stack+1060, vrr_stack+496, vrr_stack+1015, vrr_stack+1814);
 _BUILD_f0l0(Data,vrr_stack+4712, vrr_stack+1510, vrr_stack+3992, vrr_stack+1375, vrr_stack+1060, vrr_stack+1922);
 _BUILD_00p0(Data,vrr_stack+18, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+21, vrr_stack+657, vrr_stack+18, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+27, vrr_stack+660, vrr_stack+21, vrr_stack+162, vrr_stack+657, NULL);
 _BUILD_00g0(Data,vrr_stack+37, vrr_stack+666, vrr_stack+27, vrr_stack+90, vrr_stack+660, NULL);
 _BUILD_00h0(Data,vrr_stack+52, vrr_stack+676, vrr_stack+37, vrr_stack+165, vrr_stack+666, NULL);
 _BUILD_00i0(Data,vrr_stack+541, vrr_stack+691, vrr_stack+52, vrr_stack+3, vrr_stack+676, NULL);
 _BUILD_00k0(Data,vrr_stack+569, vrr_stack+712, vrr_stack+541, vrr_stack+741, vrr_stack+691, NULL);
 _BUILD_00l0(Data,vrr_stack+605, vrr_stack+124, vrr_stack+569, vrr_stack+762, vrr_stack+712, NULL);
 _BUILD_p0l0(Data,vrr_stack+1780, vrr_stack+1195, vrr_stack+605, NULL, NULL, vrr_stack+124);
 _BUILD_d0l0(Data,vrr_stack+5162, vrr_stack+1240, vrr_stack+1780, vrr_stack+790, vrr_stack+1195, vrr_stack+2138);
 _BUILD_f0l0(Data,vrr_stack+5432, vrr_stack+3722, vrr_stack+5162, vrr_stack+880, vrr_stack+1240, vrr_stack+2246);
 _BUILD_g0l0(Data,vrr_stack+5882, vrr_stack+4262, vrr_stack+5432, vrr_stack+3992, vrr_stack+3722, vrr_stack+2462);
 _BUILD_g0l0(Data,vrr_stack+1915, vrr_stack+4712, vrr_stack+4262, vrr_stack+1510, vrr_stack+3992, vrr_stack+2822);
 _BUILD_h0l0(Data,vrr_stack+6557, vrr_stack+1915, vrr_stack+5882, vrr_stack+4712, vrr_stack+4262, vrr_stack+3182);
 _BUILD_00m0(Data,vrr_stack+2590, vrr_stack+835, vrr_stack+790, vrr_stack+280, vrr_stack+244, NULL);
 _BUILD_00m0(Data,vrr_stack+2645, vrr_stack+1015, vrr_stack+835, vrr_stack+460, vrr_stack+280, NULL);
 _BUILD_00m0(Data,vrr_stack+2700, vrr_stack+790, vrr_stack+1195, vrr_stack+244, vrr_stack+316, NULL);
 _BUILD_p0m0(Data,vrr_stack+2755, vrr_stack+2590, vrr_stack+2700, NULL, NULL, vrr_stack+790);
 _BUILD_p0m0(Data,vrr_stack+2920, vrr_stack+2645, vrr_stack+2590, NULL, NULL, vrr_stack+835);
 _BUILD_d0m0(Data,vrr_stack+3085, vrr_stack+2920, vrr_stack+2755, vrr_stack+2645, vrr_stack+2590, vrr_stack+880);
 _BUILD_00m0(Data,vrr_stack+880, vrr_stack+496, vrr_stack+1015, vrr_stack+404, vrr_stack+460, NULL);
 _BUILD_p0m0(Data,vrr_stack+3415, vrr_stack+880, vrr_stack+2645, NULL, NULL, vrr_stack+1015);
 _BUILD_d0m0(Data,vrr_stack+7502, vrr_stack+3415, vrr_stack+2920, vrr_stack+880, vrr_stack+2645, vrr_stack+1060);
 _BUILD_00m0(Data,vrr_stack+1060, vrr_stack+1195, vrr_stack+605, vrr_stack+316, vrr_stack+124, NULL);
 _BUILD_p0m0(Data,vrr_stack+160, vrr_stack+2700, vrr_stack+1060, NULL, NULL, vrr_stack+1195);
 _BUILD_d0m0(Data,vrr_stack+7832, vrr_stack+2755, vrr_stack+160, vrr_stack+2590, vrr_stack+2700, vrr_stack+1240);
 _BUILD_f0m0(Data,vrr_stack+8162, vrr_stack+3085, vrr_stack+7832, vrr_stack+2920, vrr_stack+2755, vrr_stack+3722);
 _BUILD_f0m0(Data,vrr_stack+8712, vrr_stack+7502, vrr_stack+3085, vrr_stack+3415, vrr_stack+2920, vrr_stack+3992);
 _BUILD_g0m0(Data,vrr_stack+9262, vrr_stack+8712, vrr_stack+8162, vrr_stack+7502, vrr_stack+3085, vrr_stack+4262);
 _BUILD_00p0(Data,vrr_stack+1240, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1243, vrr_stack+1240, vrr_stack+0, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+1249, vrr_stack+1243, vrr_stack+352, vrr_stack+1240, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+1249, vrr_stack+358, vrr_stack+1243, vrr_stack+352, NULL);
 _BUILD_00h0(Data,vrr_stack+1259, vrr_stack+0, vrr_stack+368, vrr_stack+1249, vrr_stack+358, NULL);
 _BUILD_00i0(Data,vrr_stack+1280, vrr_stack+1259, vrr_stack+383, vrr_stack+0, vrr_stack+368, NULL);
 _BUILD_00k0(Data,vrr_stack+1308, vrr_stack+1280, vrr_stack+96, vrr_stack+1259, vrr_stack+383, NULL);
 _BUILD_00l0(Data,vrr_stack+1115, vrr_stack+1308, vrr_stack+404, vrr_stack+1280, vrr_stack+96, NULL);
 _BUILD_00m0(Data,vrr_stack+935, vrr_stack+1115, vrr_stack+496, vrr_stack+1308, vrr_stack+404, NULL);
 _BUILD_p0m0(Data,vrr_stack+3580, vrr_stack+935, vrr_stack+880, NULL, NULL, vrr_stack+496);
 _BUILD_d0m0(Data,vrr_stack+3745, vrr_stack+3580, vrr_stack+3415, vrr_stack+935, vrr_stack+880, vrr_stack+1375);
 _BUILD_f0m0(Data,vrr_stack+4075, vrr_stack+3745, vrr_stack+7502, vrr_stack+3580, vrr_stack+3415, vrr_stack+1510);
 _BUILD_g0m0(Data,vrr_stack+10087, vrr_stack+4075, vrr_stack+8712, vrr_stack+3745, vrr_stack+7502, vrr_stack+4712);
 _BUILD_00p0(Data,vrr_stack+15, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1344, vrr_stack+18, vrr_stack+15, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+1350, vrr_stack+21, vrr_stack+1344, vrr_stack+657, vrr_stack+18, NULL);
 _BUILD_00g0(Data,vrr_stack+1360, vrr_stack+27, vrr_stack+1350, vrr_stack+660, vrr_stack+21, NULL);
 _BUILD_00h0(Data,vrr_stack+1375, vrr_stack+37, vrr_stack+1360, vrr_stack+666, vrr_stack+27, NULL);
 _BUILD_00i0(Data,vrr_stack+1396, vrr_stack+52, vrr_stack+1375, vrr_stack+676, vrr_stack+37, NULL);
 _BUILD_00k0(Data,vrr_stack+1424, vrr_stack+541, vrr_stack+1396, vrr_stack+691, vrr_stack+52, NULL);
 _BUILD_00l0(Data,vrr_stack+1460, vrr_stack+569, vrr_stack+1424, vrr_stack+712, vrr_stack+541, NULL);
 _BUILD_00m0(Data,vrr_stack+1505, vrr_stack+605, vrr_stack+1460, vrr_stack+124, vrr_stack+569, NULL);
 _BUILD_p0m0(Data,vrr_stack+1560, vrr_stack+1060, vrr_stack+1505, NULL, NULL, vrr_stack+605);
 _BUILD_d0m0(Data,vrr_stack+4625, vrr_stack+160, vrr_stack+1560, vrr_stack+2700, vrr_stack+1060, vrr_stack+1780);
 _BUILD_f0m0(Data,vrr_stack+10912, vrr_stack+7832, vrr_stack+4625, vrr_stack+2755, vrr_stack+160, vrr_stack+5162);
 _BUILD_g0m0(Data,vrr_stack+11462, vrr_stack+8162, vrr_stack+10912, vrr_stack+3085, vrr_stack+7832, vrr_stack+5432);
 _BUILD_h0m0(Data,vrr_stack+12287, vrr_stack+9262, vrr_stack+11462, vrr_stack+8712, vrr_stack+8162, vrr_stack+5882);
 _BUILD_h0m0(Data,vrr_stack+4955, vrr_stack+10087, vrr_stack+9262, vrr_stack+4075, vrr_stack+8712, vrr_stack+1915);
 _BUILD_i0m0(Data,vrr_stack+13442, vrr_stack+4955, vrr_stack+12287, vrr_stack+10087, vrr_stack+9262, vrr_stack+6557);
 _BUILD_00n0(Data,vrr_stack+1725, vrr_stack+2590, vrr_stack+2700, vrr_stack+835, vrr_stack+790, NULL);
 _BUILD_00n0(Data,vrr_stack+1791, vrr_stack+2645, vrr_stack+2590, vrr_stack+1015, vrr_stack+835, NULL);
 _BUILD_p0n0(Data,vrr_stack+1857, vrr_stack+1791, vrr_stack+1725, NULL, NULL, vrr_stack+2590);
 _BUILD_00n0(Data,vrr_stack+2055, vrr_stack+880, vrr_stack+2645, vrr_stack+496, vrr_stack+1015, NULL);
 _BUILD_p0n0(Data,vrr_stack+2121, vrr_stack+2055, vrr_stack+1791, NULL, NULL, vrr_stack+2645);
 _BUILD_00n0(Data,vrr_stack+2319, vrr_stack+2700, vrr_stack+1060, vrr_stack+790, vrr_stack+1195, NULL);
 _BUILD_p0n0(Data,vrr_stack+2385, vrr_stack+1725, vrr_stack+2319, NULL, NULL, vrr_stack+2700);
 _BUILD_d0n0(Data,vrr_stack+6110, vrr_stack+1857, vrr_stack+2385, vrr_stack+1791, vrr_stack+1725, vrr_stack+2755);
 _BUILD_d0n0(Data,vrr_stack+6506, vrr_stack+2121, vrr_stack+1857, vrr_stack+2055, vrr_stack+1791, vrr_stack+2920);
 _BUILD_f0n0(Data,vrr_stack+14982, vrr_stack+6506, vrr_stack+6110, vrr_stack+2121, vrr_stack+1857, vrr_stack+3085);
 _BUILD_00n0(Data,vrr_stack+2755, vrr_stack+935, vrr_stack+880, vrr_stack+1115, vrr_stack+496, NULL);
 _BUILD_p0n0(Data,vrr_stack+2821, vrr_stack+2755, vrr_stack+2055, NULL, NULL, vrr_stack+880);
 _BUILD_d0n0(Data,vrr_stack+3019, vrr_stack+2821, vrr_stack+2121, vrr_stack+2755, vrr_stack+2055, vrr_stack+3415);
 _BUILD_f0n0(Data,vrr_stack+15642, vrr_stack+3019, vrr_stack+6506, vrr_stack+2821, vrr_stack+2121, vrr_stack+7502);
 _BUILD_00n0(Data,vrr_stack+3415, vrr_stack+1060, vrr_stack+1505, vrr_stack+1195, vrr_stack+605, NULL);
 _BUILD_p0n0(Data,vrr_stack+650, vrr_stack+2319, vrr_stack+3415, NULL, NULL, vrr_stack+1060);
 _BUILD_d0n0(Data,vrr_stack+6902, vrr_stack+2385, vrr_stack+650, vrr_stack+1725, vrr_stack+2319, vrr_stack+160);
 _BUILD_f0n0(Data,vrr_stack+16302, vrr_stack+6110, vrr_stack+6902, vrr_stack+1857, vrr_stack+2385, vrr_stack+7832);
 _BUILD_g0n0(Data,vrr_stack+16962, vrr_stack+14982, vrr_stack+16302, vrr_stack+6506, vrr_stack+6110, vrr_stack+8162);
 _BUILD_g0n0(Data,vrr_stack+7298, vrr_stack+15642, vrr_stack+14982, vrr_stack+3019, vrr_stack+6506, vrr_stack+8712);
 _BUILD_h0n0(Data,vrr_stack+17952, vrr_stack+7298, vrr_stack+16962, vrr_stack+15642, vrr_stack+14982, vrr_stack+9262);
 _BUILD_00p0(Data,vrr_stack+3481, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3484, vrr_stack+3481, vrr_stack+1240, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+3490, vrr_stack+3484, vrr_stack+1243, vrr_stack+3481, vrr_stack+1240, NULL);
 _BUILD_00g0(Data,vrr_stack+3500, vrr_stack+3490, vrr_stack+1249, vrr_stack+3484, vrr_stack+1243, NULL);
 _BUILD_00h0(Data,vrr_stack+3515, vrr_stack+3500, vrr_stack+0, vrr_stack+3490, vrr_stack+1249, NULL);
 _BUILD_00i0(Data,vrr_stack+3536, vrr_stack+3515, vrr_stack+1259, vrr_stack+3500, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+1160, vrr_stack+3536, vrr_stack+1280, vrr_stack+3515, vrr_stack+1259, NULL);
 _BUILD_00l0(Data,vrr_stack+3481, vrr_stack+1160, vrr_stack+1308, vrr_stack+3536, vrr_stack+1280, NULL);
 _BUILD_00m0(Data,vrr_stack+1196, vrr_stack+3481, vrr_stack+1115, vrr_stack+1160, vrr_stack+1308, NULL);
 _BUILD_00n0(Data,vrr_stack+1251, vrr_stack+1196, vrr_stack+935, vrr_stack+3481, vrr_stack+1115, NULL);
 _BUILD_p0n0(Data,vrr_stack+73, vrr_stack+1251, vrr_stack+2755, NULL, NULL, vrr_stack+935);
 _BUILD_d0n0(Data,vrr_stack+8288, vrr_stack+73, vrr_stack+2821, vrr_stack+1251, vrr_stack+2755, vrr_stack+3580);
 _BUILD_f0n0(Data,vrr_stack+8684, vrr_stack+8288, vrr_stack+3019, vrr_stack+73, vrr_stack+2821, vrr_stack+3745);
 _BUILD_g0n0(Data,vrr_stack+19338, vrr_stack+8684, vrr_stack+15642, vrr_stack+8288, vrr_stack+3019, vrr_stack+4075);
 _BUILD_h0n0(Data,vrr_stack+20328, vrr_stack+19338, vrr_stack+7298, vrr_stack+8684, vrr_stack+15642, vrr_stack+10087);
   tmp = vrr_stack + 20328;
   target_ptr = Libint->vrr_classes[5][10];
   for(i=0;i<1386;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+8288, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+8291, vrr_stack+15, vrr_stack+8288, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+8297, vrr_stack+1344, vrr_stack+8291, vrr_stack+18, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+1350, vrr_stack+8297, vrr_stack+21, vrr_stack+1344, NULL);
 _BUILD_00h0(Data,vrr_stack+8307, vrr_stack+1360, vrr_stack+0, vrr_stack+27, vrr_stack+1350, NULL);
 _BUILD_00i0(Data,vrr_stack+8328, vrr_stack+1375, vrr_stack+8307, vrr_stack+37, vrr_stack+1360, NULL);
 _BUILD_00k0(Data,vrr_stack+8356, vrr_stack+1396, vrr_stack+8328, vrr_stack+52, vrr_stack+1375, NULL);
 _BUILD_00l0(Data,vrr_stack+18, vrr_stack+1424, vrr_stack+8356, vrr_stack+541, vrr_stack+1396, NULL);
 _BUILD_00m0(Data,vrr_stack+63, vrr_stack+1460, vrr_stack+18, vrr_stack+569, vrr_stack+1424, NULL);
 _BUILD_00n0(Data,vrr_stack+118, vrr_stack+1505, vrr_stack+63, vrr_stack+605, vrr_stack+1460, NULL);
 _BUILD_p0n0(Data,vrr_stack+184, vrr_stack+3415, vrr_stack+118, NULL, NULL, vrr_stack+1505);
 _BUILD_d0n0(Data,vrr_stack+8392, vrr_stack+650, vrr_stack+184, vrr_stack+2319, vrr_stack+3415, vrr_stack+1560);
 _BUILD_f0n0(Data,vrr_stack+8788, vrr_stack+6902, vrr_stack+8392, vrr_stack+2385, vrr_stack+650, vrr_stack+4625);
 _BUILD_g0n0(Data,vrr_stack+9448, vrr_stack+16302, vrr_stack+8788, vrr_stack+6110, vrr_stack+6902, vrr_stack+10912);
 _BUILD_h0n0(Data,vrr_stack+3481, vrr_stack+16962, vrr_stack+9448, vrr_stack+14982, vrr_stack+16302, vrr_stack+11462);
 _BUILD_i0n0(Data,vrr_stack+10438, vrr_stack+17952, vrr_stack+3481, vrr_stack+7298, vrr_stack+16962, vrr_stack+12287);
 _BUILD_i0n0(Data,vrr_stack+21714, vrr_stack+20328, vrr_stack+17952, vrr_stack+19338, vrr_stack+7298, vrr_stack+4955);
   tmp = vrr_stack + 21714;
   target_ptr = Libint->vrr_classes[6][10];
   for(i=0;i<1848;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+19338, vrr_stack+1725, vrr_stack+2319, vrr_stack+2590, vrr_stack+2700, NULL);
 _BUILD_00o0(Data,vrr_stack+19416, vrr_stack+1791, vrr_stack+1725, vrr_stack+2645, vrr_stack+2590, NULL);
 _BUILD_p0o0(Data,vrr_stack+19494, vrr_stack+19416, vrr_stack+19338, NULL, NULL, vrr_stack+1725);
 _BUILD_00o0(Data,vrr_stack+19728, vrr_stack+2055, vrr_stack+1791, vrr_stack+880, vrr_stack+2645, NULL);
 _BUILD_p0o0(Data,vrr_stack+19806, vrr_stack+19728, vrr_stack+19416, NULL, NULL, vrr_stack+1791);
 _BUILD_00o0(Data,vrr_stack+20040, vrr_stack+2319, vrr_stack+3415, vrr_stack+2700, vrr_stack+1060, NULL);
 _BUILD_p0o0(Data,vrr_stack+382, vrr_stack+19338, vrr_stack+20040, NULL, NULL, vrr_stack+2319);
 _BUILD_d0o0(Data,vrr_stack+12286, vrr_stack+19494, vrr_stack+382, vrr_stack+19416, vrr_stack+19338, vrr_stack+2385);
 _BUILD_d0o0(Data,vrr_stack+12754, vrr_stack+19806, vrr_stack+19494, vrr_stack+19728, vrr_stack+19416, vrr_stack+1857);
 _BUILD_f0o0(Data,vrr_stack+4867, vrr_stack+12754, vrr_stack+12286, vrr_stack+19806, vrr_stack+19494, vrr_stack+6110);
 _BUILD_00o0(Data,vrr_stack+1857, vrr_stack+2755, vrr_stack+2055, vrr_stack+935, vrr_stack+880, NULL);
 _BUILD_p0o0(Data,vrr_stack+2385, vrr_stack+1857, vrr_stack+19728, NULL, NULL, vrr_stack+2055);
 _BUILD_d0o0(Data,vrr_stack+5647, vrr_stack+2385, vrr_stack+19806, vrr_stack+1857, vrr_stack+19728, vrr_stack+2121);
 _BUILD_f0o0(Data,vrr_stack+23562, vrr_stack+5647, vrr_stack+12754, vrr_stack+2385, vrr_stack+19806, vrr_stack+6506);
 _BUILD_00o0(Data,vrr_stack+2121, vrr_stack+3415, vrr_stack+118, vrr_stack+1060, vrr_stack+1505, NULL);
 _BUILD_p0o0(Data,vrr_stack+6115, vrr_stack+20040, vrr_stack+2121, NULL, NULL, vrr_stack+3415);
 _BUILD_d0o0(Data,vrr_stack+6349, vrr_stack+382, vrr_stack+6115, vrr_stack+19338, vrr_stack+20040, vrr_stack+650);
 _BUILD_f0o0(Data,vrr_stack+24342, vrr_stack+12286, vrr_stack+6349, vrr_stack+19494, vrr_stack+382, vrr_stack+6902);
 _BUILD_g0o0(Data,vrr_stack+25122, vrr_stack+4867, vrr_stack+24342, vrr_stack+12754, vrr_stack+12286, vrr_stack+16302);
 _BUILD_g0o0(Data,vrr_stack+26292, vrr_stack+23562, vrr_stack+4867, vrr_stack+5647, vrr_stack+12754, vrr_stack+14982);
 _BUILD_h0o0(Data,vrr_stack+27462, vrr_stack+26292, vrr_stack+25122, vrr_stack+23562, vrr_stack+4867, vrr_stack+16962);
 _BUILD_00o0(Data,vrr_stack+14982, vrr_stack+1251, vrr_stack+2755, vrr_stack+1196, vrr_stack+935, NULL);
 _BUILD_p0o0(Data,vrr_stack+15060, vrr_stack+14982, vrr_stack+1857, NULL, NULL, vrr_stack+2755);
 _BUILD_d0o0(Data,vrr_stack+16302, vrr_stack+15060, vrr_stack+2385, vrr_stack+14982, vrr_stack+1857, vrr_stack+2821);
 _BUILD_f0o0(Data,vrr_stack+16770, vrr_stack+16302, vrr_stack+5647, vrr_stack+15060, vrr_stack+2385, vrr_stack+3019);
 _BUILD_g0o0(Data,vrr_stack+29100, vrr_stack+16770, vrr_stack+23562, vrr_stack+16302, vrr_stack+5647, vrr_stack+15642);
 _BUILD_h0o0(Data,vrr_stack+15060, vrr_stack+29100, vrr_stack+26292, vrr_stack+16770, vrr_stack+23562, vrr_stack+7298);
   tmp = vrr_stack + 15060;
   target_ptr = Libint->vrr_classes[5][11];
   for(i=0;i<1638;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+16698, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+16701, vrr_stack+8288, vrr_stack+16698, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+16707, vrr_stack+8291, vrr_stack+16701, vrr_stack+15, vrr_stack+8288, NULL);
 _BUILD_00g0(Data,vrr_stack+16717, vrr_stack+8297, vrr_stack+16707, vrr_stack+1344, vrr_stack+8291, NULL);
 _BUILD_00h0(Data,vrr_stack+16732, vrr_stack+0, vrr_stack+16717, vrr_stack+1350, vrr_stack+8297, NULL);
 _BUILD_00i0(Data,vrr_stack+16753, vrr_stack+8307, vrr_stack+16732, vrr_stack+1360, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+16781, vrr_stack+8328, vrr_stack+16753, vrr_stack+1375, vrr_stack+8307, NULL);
 _BUILD_00l0(Data,vrr_stack+16817, vrr_stack+8356, vrr_stack+16781, vrr_stack+1396, vrr_stack+8328, NULL);
 _BUILD_00m0(Data,vrr_stack+16862, vrr_stack+18, vrr_stack+16817, vrr_stack+1424, vrr_stack+8356, NULL);
 _BUILD_00n0(Data,vrr_stack+16917, vrr_stack+63, vrr_stack+16862, vrr_stack+1460, vrr_stack+18, NULL);
 _BUILD_00o0(Data,vrr_stack+16983, vrr_stack+118, vrr_stack+16917, vrr_stack+1505, vrr_stack+63, NULL);
 _BUILD_p0o0(Data,vrr_stack+17061, vrr_stack+2121, vrr_stack+16983, NULL, NULL, vrr_stack+118);
 _BUILD_d0o0(Data,vrr_stack+17295, vrr_stack+6115, vrr_stack+17061, vrr_stack+20040, vrr_stack+2121, vrr_stack+184);
 _BUILD_f0o0(Data,vrr_stack+6817, vrr_stack+6349, vrr_stack+17295, vrr_stack+382, vrr_stack+6115, vrr_stack+8392);
 _BUILD_g0o0(Data,vrr_stack+30270, vrr_stack+24342, vrr_stack+6817, vrr_stack+12286, vrr_stack+6349, vrr_stack+8788);
 _BUILD_h0o0(Data,vrr_stack+31440, vrr_stack+25122, vrr_stack+30270, vrr_stack+4867, vrr_stack+24342, vrr_stack+9448);
 _BUILD_i0o0(Data,vrr_stack+33078, vrr_stack+27462, vrr_stack+31440, vrr_stack+26292, vrr_stack+25122, vrr_stack+3481);
 _BUILD_i0o0(Data,vrr_stack+35262, vrr_stack+15060, vrr_stack+27462, vrr_stack+29100, vrr_stack+26292, vrr_stack+17952);
   tmp = vrr_stack + 35262;
   target_ptr = Libint->vrr_classes[6][11];
   for(i=0;i<2184;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+29100, vrr_stack+19338, vrr_stack+20040, vrr_stack+1725, vrr_stack+2319, NULL);
 _BUILD_00q0(Data,vrr_stack+29191, vrr_stack+19416, vrr_stack+19338, vrr_stack+1791, vrr_stack+1725, NULL);
 _BUILD_p0q0(Data,vrr_stack+29282, vrr_stack+29191, vrr_stack+29100, NULL, NULL, vrr_stack+19338);
 _BUILD_00q0(Data,vrr_stack+29555, vrr_stack+19728, vrr_stack+19416, vrr_stack+2055, vrr_stack+1791, NULL);
 _BUILD_p0q0(Data,vrr_stack+29646, vrr_stack+29555, vrr_stack+29191, NULL, NULL, vrr_stack+19416);
 _BUILD_00q0(Data,vrr_stack+29919, vrr_stack+20040, vrr_stack+2121, vrr_stack+2319, vrr_stack+3415, NULL);
 _BUILD_p0q0(Data,vrr_stack+3481, vrr_stack+29100, vrr_stack+29919, NULL, NULL, vrr_stack+20040);
 _BUILD_d0q0(Data,vrr_stack+3754, vrr_stack+29282, vrr_stack+3481, vrr_stack+29191, vrr_stack+29100, vrr_stack+382);
 _BUILD_d0q0(Data,vrr_stack+4300, vrr_stack+29646, vrr_stack+29282, vrr_stack+29555, vrr_stack+29191, vrr_stack+19494);
 _BUILD_f0q0(Data,vrr_stack+8392, vrr_stack+4300, vrr_stack+3754, vrr_stack+29646, vrr_stack+29282, vrr_stack+12286);
 _BUILD_00q0(Data,vrr_stack+12286, vrr_stack+1857, vrr_stack+19728, vrr_stack+2755, vrr_stack+2055, NULL);
 _BUILD_p0q0(Data,vrr_stack+12377, vrr_stack+12286, vrr_stack+29555, NULL, NULL, vrr_stack+19728);
 _BUILD_d0q0(Data,vrr_stack+9302, vrr_stack+12377, vrr_stack+29646, vrr_stack+12286, vrr_stack+29555, vrr_stack+19806);
 _BUILD_f0q0(Data,vrr_stack+184, vrr_stack+9302, vrr_stack+4300, vrr_stack+12377, vrr_stack+29646, vrr_stack+12754);
 _BUILD_00q0(Data,vrr_stack+19806, vrr_stack+2121, vrr_stack+16983, vrr_stack+3415, vrr_stack+118, NULL);
 _BUILD_p0q0(Data,vrr_stack+12650, vrr_stack+29919, vrr_stack+19806, NULL, NULL, vrr_stack+2121);
 _BUILD_d0q0(Data,vrr_stack+9848, vrr_stack+3481, vrr_stack+12650, vrr_stack+29100, vrr_stack+29919, vrr_stack+6115);
 _BUILD_f0q0(Data,vrr_stack+37446, vrr_stack+3754, vrr_stack+9848, vrr_stack+29282, vrr_stack+3481, vrr_stack+6349);
 _BUILD_g0q0(Data,vrr_stack+38356, vrr_stack+8392, vrr_stack+37446, vrr_stack+4300, vrr_stack+3754, vrr_stack+24342);
 _BUILD_g0q0(Data,vrr_stack+39721, vrr_stack+184, vrr_stack+8392, vrr_stack+9302, vrr_stack+4300, vrr_stack+4867);
 _BUILD_h0q0(Data,vrr_stack+41086, vrr_stack+39721, vrr_stack+38356, vrr_stack+184, vrr_stack+8392, vrr_stack+25122);
 _BUILD_00q0(Data,vrr_stack+24342, vrr_stack+14982, vrr_stack+1857, vrr_stack+1251, vrr_stack+2755, NULL);
 _BUILD_p0q0(Data,vrr_stack+24433, vrr_stack+24342, vrr_stack+12286, NULL, NULL, vrr_stack+1857);
 _BUILD_d0q0(Data,vrr_stack+24706, vrr_stack+24433, vrr_stack+12377, vrr_stack+24342, vrr_stack+12286, vrr_stack+2385);
 _BUILD_f0q0(Data,vrr_stack+25252, vrr_stack+24706, vrr_stack+9302, vrr_stack+24433, vrr_stack+12377, vrr_stack+5647);
 _BUILD_g0q0(Data,vrr_stack+4846, vrr_stack+25252, vrr_stack+184, vrr_stack+24706, vrr_stack+9302, vrr_stack+23562);
 _BUILD_h0q0(Data,vrr_stack+42997, vrr_stack+4846, vrr_stack+39721, vrr_stack+25252, vrr_stack+184, vrr_stack+26292);
   tmp = vrr_stack + 42997;
   target_ptr = Libint->vrr_classes[5][12];
   for(i=0;i<1911;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+15, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+23562, vrr_stack+16698, vrr_stack+15, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+23568, vrr_stack+16701, vrr_stack+23562, vrr_stack+8288, vrr_stack+16698, NULL);
 _BUILD_00g0(Data,vrr_stack+23578, vrr_stack+16707, vrr_stack+23568, vrr_stack+8291, vrr_stack+16701, NULL);
 _BUILD_00h0(Data,vrr_stack+23593, vrr_stack+16717, vrr_stack+23578, vrr_stack+8297, vrr_stack+16707, NULL);
 _BUILD_00i0(Data,vrr_stack+23614, vrr_stack+16732, vrr_stack+23593, vrr_stack+0, vrr_stack+16717, NULL);
 _BUILD_00k0(Data,vrr_stack+23642, vrr_stack+16753, vrr_stack+23614, vrr_stack+8307, vrr_stack+16732, NULL);
 _BUILD_00l0(Data,vrr_stack+23678, vrr_stack+16781, vrr_stack+23642, vrr_stack+8328, vrr_stack+16753, NULL);
 _BUILD_00m0(Data,vrr_stack+23723, vrr_stack+16817, vrr_stack+23678, vrr_stack+8356, vrr_stack+16781, NULL);
 _BUILD_00n0(Data,vrr_stack+23778, vrr_stack+16862, vrr_stack+23723, vrr_stack+18, vrr_stack+16817, NULL);
 _BUILD_00o0(Data,vrr_stack+23844, vrr_stack+16917, vrr_stack+23778, vrr_stack+63, vrr_stack+16862, NULL);
 _BUILD_00q0(Data,vrr_stack+18, vrr_stack+16983, vrr_stack+23844, vrr_stack+118, vrr_stack+16917, NULL);
 _BUILD_p0q0(Data,vrr_stack+23922, vrr_stack+19806, vrr_stack+18, NULL, NULL, vrr_stack+16983);
 _BUILD_d0q0(Data,vrr_stack+24433, vrr_stack+12650, vrr_stack+23922, vrr_stack+29919, vrr_stack+19806, vrr_stack+17061);
 _BUILD_f0q0(Data,vrr_stack+24979, vrr_stack+9848, vrr_stack+24433, vrr_stack+3481, vrr_stack+12650, vrr_stack+17295);
 _BUILD_g0q0(Data,vrr_stack+25889, vrr_stack+37446, vrr_stack+24979, vrr_stack+3754, vrr_stack+9848, vrr_stack+6817);
 _BUILD_h0q0(Data,vrr_stack+6211, vrr_stack+38356, vrr_stack+25889, vrr_stack+8392, vrr_stack+37446, vrr_stack+30270);
 _BUILD_i0q0(Data,vrr_stack+44908, vrr_stack+41086, vrr_stack+6211, vrr_stack+39721, vrr_stack+38356, vrr_stack+31440);
 _BUILD_i0q0(Data,vrr_stack+30010, vrr_stack+42997, vrr_stack+41086, vrr_stack+4846, vrr_stack+39721, vrr_stack+27462);
   tmp = vrr_stack + 30010;
   target_ptr = Libint->vrr_classes[6][12];
   for(i=0;i<2548;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4846, vrr_stack+29100, vrr_stack+29919, vrr_stack+19338, vrr_stack+20040, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+4951, vrr_stack+29191, vrr_stack+29100, vrr_stack+19416, vrr_stack+19338, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5056, vrr_stack+4951, vrr_stack+4846, NULL, NULL, vrr_stack+29100);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5371, vrr_stack+29555, vrr_stack+29191, vrr_stack+19728, vrr_stack+19416, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+19338, vrr_stack+5371, vrr_stack+4951, NULL, NULL, vrr_stack+29191);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5476, vrr_stack+29919, vrr_stack+19806, vrr_stack+20040, vrr_stack+2121, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5581, vrr_stack+4846, vrr_stack+5476, NULL, NULL, vrr_stack+29919);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+17061, vrr_stack+5056, vrr_stack+5581, vrr_stack+4951, vrr_stack+4846, vrr_stack+3481);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+1094, vrr_stack+19338, vrr_stack+5056, vrr_stack+5371, vrr_stack+4951, vrr_stack+29282);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2199, vrr_stack+1094, vrr_stack+17061, vrr_stack+19338, vrr_stack+5056, vrr_stack+3754);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+29282, vrr_stack+12286, vrr_stack+29555, vrr_stack+1857, vrr_stack+19728, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+5896, vrr_stack+29282, vrr_stack+5371, NULL, NULL, vrr_stack+29555);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3249, vrr_stack+5896, vrr_stack+19338, vrr_stack+29282, vrr_stack+5371, vrr_stack+29646);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+47456, vrr_stack+3249, vrr_stack+1094, vrr_stack+5896, vrr_stack+19338, vrr_stack+4300);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+29646, vrr_stack+19806, vrr_stack+18, vrr_stack+2121, vrr_stack+16983, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+19897, vrr_stack+5476, vrr_stack+29646, NULL, NULL, vrr_stack+19806);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+3879, vrr_stack+5581, vrr_stack+19897, vrr_stack+4846, vrr_stack+5476, vrr_stack+12650);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+48506, vrr_stack+17061, vrr_stack+3879, vrr_stack+5056, vrr_stack+5581, vrr_stack+9848);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+49556, vrr_stack+2199, vrr_stack+48506, vrr_stack+1094, vrr_stack+17061, vrr_stack+37446);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+51131, vrr_stack+47456, vrr_stack+2199, vrr_stack+3249, vrr_stack+1094, vrr_stack+8392);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+52706, vrr_stack+51131, vrr_stack+49556, vrr_stack+47456, vrr_stack+2199, vrr_stack+38356);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37446, vrr_stack+24342, vrr_stack+12286, vrr_stack+14982, vrr_stack+1857, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37551, vrr_stack+37446, vrr_stack+29282, NULL, NULL, vrr_stack+12286);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37866, vrr_stack+37551, vrr_stack+5896, vrr_stack+37446, vrr_stack+29282, vrr_stack+12377);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12377, vrr_stack+37866, vrr_stack+3249, vrr_stack+37551, vrr_stack+5896, vrr_stack+9302);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+8122, vrr_stack+12377, vrr_stack+47456, vrr_stack+37866, vrr_stack+3249, vrr_stack+184);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+54911, vrr_stack+8122, vrr_stack+51131, vrr_stack+12377, vrr_stack+47456, vrr_stack+39721);
   tmp = vrr_stack + 54911;
   target_ptr = Libint->vrr_classes[5][13];
   for(i=0;i<2205;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+12377, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+12380, vrr_stack+15, vrr_stack+12377, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+12386, vrr_stack+23562, vrr_stack+12380, vrr_stack+16698, vrr_stack+15, NULL);
 _BUILD_00g0(Data,vrr_stack+0, vrr_stack+23568, vrr_stack+12386, vrr_stack+16701, vrr_stack+23562, NULL);
 _BUILD_00h0(Data,vrr_stack+12396, vrr_stack+23578, vrr_stack+0, vrr_stack+16707, vrr_stack+23568, NULL);
 _BUILD_00i0(Data,vrr_stack+12417, vrr_stack+23593, vrr_stack+12396, vrr_stack+16717, vrr_stack+23578, NULL);
 _BUILD_00k0(Data,vrr_stack+12445, vrr_stack+23614, vrr_stack+12417, vrr_stack+16732, vrr_stack+23593, NULL);
 _BUILD_00l0(Data,vrr_stack+16698, vrr_stack+23642, vrr_stack+12445, vrr_stack+16753, vrr_stack+23614, NULL);
 _BUILD_00m0(Data,vrr_stack+12481, vrr_stack+23678, vrr_stack+16698, vrr_stack+16781, vrr_stack+23642, NULL);
 _BUILD_00n0(Data,vrr_stack+16743, vrr_stack+23723, vrr_stack+12481, vrr_stack+16817, vrr_stack+23678, NULL);
 _BUILD_00o0(Data,vrr_stack+14982, vrr_stack+23778, vrr_stack+16743, vrr_stack+16862, vrr_stack+23723, NULL);
 _BUILD_00q0(Data,vrr_stack+16809, vrr_stack+23844, vrr_stack+14982, vrr_stack+16917, vrr_stack+23778, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12536, vrr_stack+18, vrr_stack+16809, vrr_stack+16983, vrr_stack+23844, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12641, vrr_stack+29646, vrr_stack+12536, NULL, NULL, vrr_stack+18);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37551, vrr_stack+19897, vrr_stack+12641, vrr_stack+5476, vrr_stack+29646, vrr_stack+23922);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+38181, vrr_stack+3879, vrr_stack+37551, vrr_stack+5581, vrr_stack+19897, vrr_stack+24433);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+39231, vrr_stack+48506, vrr_stack+38181, vrr_stack+17061, vrr_stack+3879, vrr_stack+24979);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+57116, vrr_stack+49556, vrr_stack+39231, vrr_stack+2199, vrr_stack+48506, vrr_stack+25889);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+24433, vrr_stack+52706, vrr_stack+57116, vrr_stack+51131, vrr_stack+49556, vrr_stack+6211);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+59321, vrr_stack+54911, vrr_stack+52706, vrr_stack+8122, vrr_stack+51131, vrr_stack+41086);
   tmp = vrr_stack + 59321;
   target_ptr = Libint->vrr_classes[6][13];
   for(i=0;i<2940;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6211, vrr_stack+4846, vrr_stack+5476, vrr_stack+29100, vrr_stack+29919, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6331, vrr_stack+4951, vrr_stack+4846, vrr_stack+29191, vrr_stack+29100, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6451, vrr_stack+6331, vrr_stack+6211, NULL, NULL, vrr_stack+4846);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6811, vrr_stack+5371, vrr_stack+4951, vrr_stack+29555, vrr_stack+29191, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6931, vrr_stack+6811, vrr_stack+6331, NULL, NULL, vrr_stack+4951);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+29100, vrr_stack+5476, vrr_stack+29646, vrr_stack+29919, vrr_stack+19806, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7291, vrr_stack+6211, vrr_stack+29100, NULL, NULL, vrr_stack+5476);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+7651, vrr_stack+6451, vrr_stack+7291, vrr_stack+6331, vrr_stack+6211, vrr_stack+5581);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+8371, vrr_stack+6931, vrr_stack+6451, vrr_stack+6811, vrr_stack+6331, vrr_stack+5056);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+9091, vrr_stack+8371, vrr_stack+7651, vrr_stack+6931, vrr_stack+6451, vrr_stack+17061);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+5056, vrr_stack+29282, vrr_stack+5371, vrr_stack+12286, vrr_stack+29555, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23922, vrr_stack+5056, vrr_stack+6811, NULL, NULL, vrr_stack+5371);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+16900, vrr_stack+23922, vrr_stack+6931, vrr_stack+5056, vrr_stack+6811, vrr_stack+19338);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+62261, vrr_stack+16900, vrr_stack+8371, vrr_stack+23922, vrr_stack+6931, vrr_stack+1094);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+19338, vrr_stack+29646, vrr_stack+12536, vrr_stack+19806, vrr_stack+18, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+19458, vrr_stack+29100, vrr_stack+19338, NULL, NULL, vrr_stack+29646);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+109, vrr_stack+7291, vrr_stack+19458, vrr_stack+6211, vrr_stack+29100, vrr_stack+19897);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+829, vrr_stack+7651, vrr_stack+109, vrr_stack+6451, vrr_stack+7291, vrr_stack+3879);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+63461, vrr_stack+9091, vrr_stack+829, vrr_stack+8371, vrr_stack+7651, vrr_stack+48506);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+65261, vrr_stack+62261, vrr_stack+9091, vrr_stack+16900, vrr_stack+8371, vrr_stack+2199);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+67061, vrr_stack+65261, vrr_stack+63461, vrr_stack+62261, vrr_stack+9091, vrr_stack+49556);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+48506, vrr_stack+37446, vrr_stack+29282, vrr_stack+24342, vrr_stack+12286, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+48626, vrr_stack+48506, vrr_stack+5056, NULL, NULL, vrr_stack+29282);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+48986, vrr_stack+48626, vrr_stack+23922, vrr_stack+48506, vrr_stack+5056, vrr_stack+5896);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49706, vrr_stack+48986, vrr_stack+16900, vrr_stack+48626, vrr_stack+23922, vrr_stack+3249);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+2029, vrr_stack+49706, vrr_stack+62261, vrr_stack+48986, vrr_stack+16900, vrr_stack+47456);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+69581, vrr_stack+2029, vrr_stack+65261, vrr_stack+49706, vrr_stack+62261, vrr_stack+51131);
   tmp = vrr_stack + 69581;
   target_ptr = Libint->vrr_classes[5][14];
   for(i=0;i<2520;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+47456, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+47459, vrr_stack+12377, vrr_stack+47456, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+47465, vrr_stack+12380, vrr_stack+47459, vrr_stack+15, vrr_stack+12377, NULL);
 _BUILD_00g0(Data,vrr_stack+47475, vrr_stack+12386, vrr_stack+47465, vrr_stack+23562, vrr_stack+12380, NULL);
 _BUILD_00h0(Data,vrr_stack+47490, vrr_stack+0, vrr_stack+47475, vrr_stack+23568, vrr_stack+12386, NULL);
 _BUILD_00i0(Data,vrr_stack+47511, vrr_stack+12396, vrr_stack+47490, vrr_stack+23578, vrr_stack+0, NULL);
 _BUILD_00k0(Data,vrr_stack+47539, vrr_stack+12417, vrr_stack+47511, vrr_stack+23593, vrr_stack+12396, NULL);
 _BUILD_00l0(Data,vrr_stack+23562, vrr_stack+12445, vrr_stack+47539, vrr_stack+23614, vrr_stack+12417, NULL);
 _BUILD_00m0(Data,vrr_stack+47575, vrr_stack+16698, vrr_stack+23562, vrr_stack+23642, vrr_stack+12445, NULL);
 _BUILD_00n0(Data,vrr_stack+23607, vrr_stack+12481, vrr_stack+47575, vrr_stack+23678, vrr_stack+16698, NULL);
 _BUILD_00o0(Data,vrr_stack+47630, vrr_stack+16743, vrr_stack+23607, vrr_stack+23723, vrr_stack+12481, NULL);
 _BUILD_00q0(Data,vrr_stack+12286, vrr_stack+14982, vrr_stack+47630, vrr_stack+23778, vrr_stack+16743, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+23673, vrr_stack+16809, vrr_stack+12286, vrr_stack+23844, vrr_stack+14982, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+23778, vrr_stack+12536, vrr_stack+23673, vrr_stack+18, vrr_stack+16809, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+47708, vrr_stack+19338, vrr_stack+23778, NULL, NULL, vrr_stack+12536);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+48626, vrr_stack+19458, vrr_stack+47708, vrr_stack+29100, vrr_stack+19338, vrr_stack+12641);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49346, vrr_stack+109, vrr_stack+48626, vrr_stack+7291, vrr_stack+19458, vrr_stack+37551);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+50546, vrr_stack+829, vrr_stack+49346, vrr_stack+7651, vrr_stack+109, vrr_stack+38181);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+72101, vrr_stack+63461, vrr_stack+50546, vrr_stack+9091, vrr_stack+829, vrr_stack+39231);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+37551, vrr_stack+67061, vrr_stack+72101, vrr_stack+65261, vrr_stack+63461, vrr_stack+57116);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+74621, vrr_stack+69581, vrr_stack+67061, vrr_stack+2029, vrr_stack+65261, vrr_stack+52706);
   tmp = vrr_stack + 74621;
   target_ptr = Libint->vrr_classes[6][14];
   for(i=0;i<3360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2029, vrr_stack+6211, vrr_stack+29100, vrr_stack+4846, vrr_stack+5476, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2165, vrr_stack+6331, vrr_stack+6211, vrr_stack+4951, vrr_stack+4846, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2301, vrr_stack+2165, vrr_stack+2029, NULL, NULL, vrr_stack+6211);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2709, vrr_stack+6811, vrr_stack+6331, vrr_stack+5371, vrr_stack+4951, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+2845, vrr_stack+2709, vrr_stack+2165, NULL, NULL, vrr_stack+6331);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+3253, vrr_stack+29100, vrr_stack+19338, vrr_stack+5476, vrr_stack+29646, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+5476, vrr_stack+2029, vrr_stack+3253, NULL, NULL, vrr_stack+29100);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+3389, vrr_stack+2301, vrr_stack+5476, vrr_stack+2165, vrr_stack+2029, vrr_stack+7291);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+4205, vrr_stack+2845, vrr_stack+2301, vrr_stack+2709, vrr_stack+2165, vrr_stack+6451);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+57116, vrr_stack+4205, vrr_stack+3389, vrr_stack+2845, vrr_stack+2301, vrr_stack+7651);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6451, vrr_stack+5056, vrr_stack+6811, vrr_stack+29282, vrr_stack+5371, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7291, vrr_stack+6451, vrr_stack+2709, NULL, NULL, vrr_stack+6811);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+58476, vrr_stack+7291, vrr_stack+2845, vrr_stack+6451, vrr_stack+2709, vrr_stack+6931);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+77981, vrr_stack+58476, vrr_stack+4205, vrr_stack+7291, vrr_stack+2845, vrr_stack+8371);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+6931, vrr_stack+19338, vrr_stack+23778, vrr_stack+29646, vrr_stack+12536, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+7699, vrr_stack+3253, vrr_stack+6931, NULL, NULL, vrr_stack+19338);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+8107, vrr_stack+5476, vrr_stack+7699, vrr_stack+2029, vrr_stack+3253, vrr_stack+19458);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+79341, vrr_stack+3389, vrr_stack+8107, vrr_stack+2301, vrr_stack+5476, vrr_stack+109);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+80701, vrr_stack+57116, vrr_stack+79341, vrr_stack+4205, vrr_stack+3389, vrr_stack+829);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+82741, vrr_stack+77981, vrr_stack+57116, vrr_stack+58476, vrr_stack+4205, vrr_stack+9091);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+84781, vrr_stack+82741, vrr_stack+80701, vrr_stack+77981, vrr_stack+57116, vrr_stack+63461);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+63461, vrr_stack+48506, vrr_stack+5056, vrr_stack+37446, vrr_stack+29282, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+63597, vrr_stack+63461, vrr_stack+6451, NULL, NULL, vrr_stack+5056);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+64005, vrr_stack+63597, vrr_stack+7291, vrr_stack+63461, vrr_stack+6451, vrr_stack+23922);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+8923, vrr_stack+64005, vrr_stack+58476, vrr_stack+63597, vrr_stack+7291, vrr_stack+16900);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+87637, vrr_stack+8923, vrr_stack+77981, vrr_stack+64005, vrr_stack+58476, vrr_stack+62261);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+89677, vrr_stack+87637, vrr_stack+82741, vrr_stack+8923, vrr_stack+77981, vrr_stack+65261);
   tmp = vrr_stack + 89677;
   target_ptr = Libint->vrr_classes[5][15];
   for(i=0;i<2856;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+8923, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+8926, vrr_stack+47456, vrr_stack+8923, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+8932, vrr_stack+47459, vrr_stack+8926, vrr_stack+12377, vrr_stack+47456, NULL);
 _BUILD_00g0(Data,vrr_stack+8942, vrr_stack+47465, vrr_stack+8932, vrr_stack+12380, vrr_stack+47459, NULL);
 _BUILD_00h0(Data,vrr_stack+8957, vrr_stack+47475, vrr_stack+8942, vrr_stack+12386, vrr_stack+47465, NULL);
 _BUILD_00i0(Data,vrr_stack+8978, vrr_stack+47490, vrr_stack+8957, vrr_stack+0, vrr_stack+47475, NULL);
 _BUILD_00k0(Data,vrr_stack+0, vrr_stack+47511, vrr_stack+8978, vrr_stack+12396, vrr_stack+47490, NULL);
 _BUILD_00l0(Data,vrr_stack+36, vrr_stack+47539, vrr_stack+0, vrr_stack+12417, vrr_stack+47511, NULL);
 _BUILD_00m0(Data,vrr_stack+81, vrr_stack+23562, vrr_stack+36, vrr_stack+12445, vrr_stack+47539, NULL);
 _BUILD_00n0(Data,vrr_stack+136, vrr_stack+47575, vrr_stack+81, vrr_stack+16698, vrr_stack+23562, NULL);
 _BUILD_00o0(Data,vrr_stack+202, vrr_stack+23607, vrr_stack+136, vrr_stack+12481, vrr_stack+47575, NULL);
 _BUILD_00q0(Data,vrr_stack+280, vrr_stack+47630, vrr_stack+202, vrr_stack+16743, vrr_stack+23607, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37446, vrr_stack+12286, vrr_stack+280, vrr_stack+14982, vrr_stack+47630, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+371, vrr_stack+23673, vrr_stack+37446, vrr_stack+16809, vrr_stack+12286, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+16698, vrr_stack+23778, vrr_stack+371, vrr_stack+12536, vrr_stack+23673, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+16834, vrr_stack+6931, vrr_stack+16698, NULL, NULL, vrr_stack+23778);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+491, vrr_stack+7699, vrr_stack+16834, vrr_stack+3253, vrr_stack+6931, vrr_stack+47708);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+9006, vrr_stack+8107, vrr_stack+491, vrr_stack+5476, vrr_stack+7699, vrr_stack+48626);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+63597, vrr_stack+79341, vrr_stack+9006, vrr_stack+3389, vrr_stack+8107, vrr_stack+49346);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+92533, vrr_stack+80701, vrr_stack+63597, vrr_stack+57116, vrr_stack+79341, vrr_stack+50546);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48626, vrr_stack+84781, vrr_stack+92533, vrr_stack+82741, vrr_stack+80701, vrr_stack+72101);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+95389, vrr_stack+89677, vrr_stack+84781, vrr_stack+87637, vrr_stack+82741, vrr_stack+67061);
   tmp = vrr_stack + 95389;
   target_ptr = Libint->vrr_classes[6][15];
   for(i=0;i<3808;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87637, vrr_stack+2029, vrr_stack+3253, vrr_stack+6211, vrr_stack+29100, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87790, vrr_stack+2165, vrr_stack+2029, vrr_stack+6331, vrr_stack+6211, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87943, vrr_stack+87790, vrr_stack+87637, NULL, NULL, vrr_stack+2029);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+88402, vrr_stack+2709, vrr_stack+2165, vrr_stack+6811, vrr_stack+6331, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+88555, vrr_stack+88402, vrr_stack+87790, NULL, NULL, vrr_stack+2165);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+89014, vrr_stack+3253, vrr_stack+6931, vrr_stack+29100, vrr_stack+19338, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+29100, vrr_stack+87637, vrr_stack+89014, NULL, NULL, vrr_stack+3253);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+72101, vrr_stack+87943, vrr_stack+29100, vrr_stack+87790, vrr_stack+87637, vrr_stack+5476);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+73019, vrr_stack+88555, vrr_stack+87943, vrr_stack+88402, vrr_stack+87790, vrr_stack+2301);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+99197, vrr_stack+73019, vrr_stack+72101, vrr_stack+88555, vrr_stack+87943, vrr_stack+3389);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87790, vrr_stack+6451, vrr_stack+2709, vrr_stack+5056, vrr_stack+6811, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+3253, vrr_stack+87790, vrr_stack+88402, NULL, NULL, vrr_stack+2709);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+1307, vrr_stack+3253, vrr_stack+88555, vrr_stack+87790, vrr_stack+88402, vrr_stack+2845);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+100727, vrr_stack+1307, vrr_stack+73019, vrr_stack+3253, vrr_stack+88555, vrr_stack+4205);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+88402, vrr_stack+6931, vrr_stack+16698, vrr_stack+19338, vrr_stack+23778, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+88555, vrr_stack+89014, vrr_stack+88402, NULL, NULL, vrr_stack+6931);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+19338, vrr_stack+29100, vrr_stack+88555, vrr_stack+87637, vrr_stack+89014, vrr_stack+7699);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+102257, vrr_stack+72101, vrr_stack+19338, vrr_stack+87943, vrr_stack+29100, vrr_stack+8107);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+103787, vrr_stack+99197, vrr_stack+102257, vrr_stack+73019, vrr_stack+72101, vrr_stack+79341);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+106082, vrr_stack+100727, vrr_stack+99197, vrr_stack+1307, vrr_stack+73019, vrr_stack+57116);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+108377, vrr_stack+106082, vrr_stack+103787, vrr_stack+100727, vrr_stack+99197, vrr_stack+80701);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87637, vrr_stack+63461, vrr_stack+6451, vrr_stack+48506, vrr_stack+5056, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87943, vrr_stack+87637, vrr_stack+87790, NULL, NULL, vrr_stack+6451);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+47708, vrr_stack+87943, vrr_stack+3253, vrr_stack+87637, vrr_stack+87790, vrr_stack+7291);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+73019, vrr_stack+47708, vrr_stack+1307, vrr_stack+87943, vrr_stack+3253, vrr_stack+58476);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+79341, vrr_stack+73019, vrr_stack+100727, vrr_stack+47708, vrr_stack+1307, vrr_stack+77981);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+1307, vrr_stack+79341, vrr_stack+106082, vrr_stack+73019, vrr_stack+100727, vrr_stack+82741);
   tmp = vrr_stack + 1307;
   target_ptr = Libint->vrr_classes[5][16];
   for(i=0;i<3213;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00p0(Data,vrr_stack+100727, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+100730, vrr_stack+8923, vrr_stack+100727, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+100736, vrr_stack+8926, vrr_stack+100730, vrr_stack+47456, vrr_stack+8923, NULL);
 _BUILD_00g0(Data,vrr_stack+100746, vrr_stack+8932, vrr_stack+100736, vrr_stack+47459, vrr_stack+8926, NULL);
 _BUILD_00h0(Data,vrr_stack+100761, vrr_stack+8942, vrr_stack+100746, vrr_stack+47465, vrr_stack+8932, NULL);
 _BUILD_00i0(Data,vrr_stack+100727, vrr_stack+8957, vrr_stack+100761, vrr_stack+47475, vrr_stack+8942, NULL);
 _BUILD_00k0(Data,vrr_stack+100755, vrr_stack+8978, vrr_stack+100727, vrr_stack+47490, vrr_stack+8957, NULL);
 _BUILD_00l0(Data,vrr_stack+47456, vrr_stack+0, vrr_stack+100755, vrr_stack+47511, vrr_stack+8978, NULL);
 _BUILD_00m0(Data,vrr_stack+100727, vrr_stack+36, vrr_stack+47456, vrr_stack+47539, vrr_stack+0, NULL);
 _BUILD_00n0(Data,vrr_stack+47456, vrr_stack+81, vrr_stack+100727, vrr_stack+23562, vrr_stack+36, NULL);
 _BUILD_00o0(Data,vrr_stack+14982, vrr_stack+136, vrr_stack+47456, vrr_stack+47575, vrr_stack+81, NULL);
 _BUILD_00q0(Data,vrr_stack+47456, vrr_stack+202, vrr_stack+14982, vrr_stack+23607, vrr_stack+136, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+23562, vrr_stack+280, vrr_stack+47456, vrr_stack+47630, vrr_stack+202, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+47456, vrr_stack+37446, vrr_stack+23562, vrr_stack+12286, vrr_stack+280, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+12286, vrr_stack+371, vrr_stack+47456, vrr_stack+23673, vrr_stack+37446, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+47456, vrr_stack+16698, vrr_stack+12286, vrr_stack+23778, vrr_stack+371, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+12286, vrr_stack+88402, vrr_stack+47456, NULL, NULL, vrr_stack+16698);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+47456, vrr_stack+88555, vrr_stack+12286, vrr_stack+89014, vrr_stack+88402, vrr_stack+16834);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+100727, vrr_stack+19338, vrr_stack+47456, vrr_stack+29100, vrr_stack+88555, vrr_stack+491);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+4520, vrr_stack+102257, vrr_stack+100727, vrr_stack+72101, vrr_stack+19338, vrr_stack+9006);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+6815, vrr_stack+103787, vrr_stack+4520, vrr_stack+99197, vrr_stack+102257, vrr_stack+63597);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+99197, vrr_stack+108377, vrr_stack+6815, vrr_stack+106082, vrr_stack+103787, vrr_stack+92533);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+4520, vrr_stack+1307, vrr_stack+108377, vrr_stack+79341, vrr_stack+106082, vrr_stack+84781);
   tmp = vrr_stack + 4520;
   target_ptr = Libint->vrr_classes[6][16];
   for(i=0;i<4284;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0n0(Data,vrr_stack+92533, vrr_stack+21714, vrr_stack+10438, vrr_stack+20328, vrr_stack+17952, vrr_stack+13442);
   tmp = vrr_stack + 92533;
   target_ptr = Libint->vrr_classes[7][10];
   for(i=0;i<2376;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0o0(Data,vrr_stack+103481, vrr_stack+35262, vrr_stack+33078, vrr_stack+15060, vrr_stack+27462, vrr_stack+10438);
   tmp = vrr_stack + 103481;
   target_ptr = Libint->vrr_classes[7][11];
   for(i=0;i<2808;i++)
     target_ptr[i] += tmp[i];
 _BUILD_k0q0(Data,vrr_stack+8804, vrr_stack+30010, vrr_stack+44908, vrr_stack+42997, vrr_stack+41086, vrr_stack+33078);
   tmp = vrr_stack + 8804;
   target_ptr = Libint->vrr_classes[7][12];
   for(i=0;i<3276;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+12080, vrr_stack+59321, vrr_stack+24433, vrr_stack+54911, vrr_stack+52706, vrr_stack+44908);
   tmp = vrr_stack + 12080;
   target_ptr = Libint->vrr_classes[7][13];
   for(i=0;i<3780;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+15860, vrr_stack+74621, vrr_stack+37551, vrr_stack+69581, vrr_stack+67061, vrr_stack+24433);
   tmp = vrr_stack + 15860;
   target_ptr = Libint->vrr_classes[7][14];
   for(i=0;i<4320;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+20180, vrr_stack+95389, vrr_stack+48626, vrr_stack+89677, vrr_stack+84781, vrr_stack+37551);
   tmp = vrr_stack + 20180;
   target_ptr = Libint->vrr_classes[7][15];
   for(i=0;i<4896;i++)
     target_ptr[i] += tmp[i];
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+25076, vrr_stack+4520, vrr_stack+99197, vrr_stack+1307, vrr_stack+108377, vrr_stack+48626);
   tmp = vrr_stack + 25076;
   target_ptr = Libint->vrr_classes[7][16];
   for(i=0;i<5508;i++)
     target_ptr[i] += tmp[i];

}

