/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (0s||ds) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _r_build_00d0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4, const REALTYPE *I5)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE loo2p = Data->oo2p;
  REALTYPE oneo4zn;
  REALTYPE oneo2n;
  oneo4zn = 1.0*Data->oo2z*Data->oo2n;
  oneo2n = 1.0*Data->oo2n;
  U20 = Data->U[2][0];
  U21 = Data->U[2][1];
  U22 = Data->U[2][2];
  U10 = Data->U[2][0]*Data->oo2z + Data->U[3][0]*Data->oo2n;
  U11 = Data->U[2][1]*Data->oo2z + Data->U[3][1]*Data->oo2n;
  U12 = Data->U[2][2]*Data->oo2z + Data->U[3][2]*Data->oo2n;

*(vp++) = U20*I0[0] - U10*I3[0] + loo2p*I2[0]
        + (oneo2n)*I1[0] - (oneo4zn)*I4[0];
*(vp++) = U20*I0[1] - U10*I3[1] + loo2p*I2[1];
*(vp++) = U20*I0[2] - U10*I3[2] + loo2p*I2[2];
*(vp++) = U21*I0[1] - U11*I3[1] + loo2p*I2[3]
        + (oneo2n)*I1[0] - (oneo4zn)*I4[0];
*(vp++) = U21*I0[2] - U11*I3[2] + loo2p*I2[4];
*(vp++) = U22*I0[2] - U12*I3[2] + loo2p*I2[5]
        + (oneo2n)*I1[0] - (oneo4zn)*I4[0];

}
