/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ps|[r12,T1]|ls) integrals */

#include <libint/libint.h>
#include "libr12.h"

void _t1_build_p0l0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 2.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[45] - I2[1])
          - U12*(I1[90] - I2[2])
          + (onezboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[46] - I2[3])
          - U12*(I1[91] - I2[4])
          + (onezboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[47] - I2[4])
          - U12*(I1[92] - I2[5])
          + (onezboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[48] - I2[6])
          - U12*(I1[93] - I2[7])
          + (onezboz)*(I3[3] - AC0*I4[3]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[49] - I2[7])
          - U12*(I1[94] - I2[8])
          + (onezboz)*(I3[4] - AC0*I4[4]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[50] - I2[8])
          - U12*(I1[95] - I2[9])
          + (onezboz)*(I3[5] - AC0*I4[5]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[51] - I2[10])
          - U12*(I1[96] - I2[11])
          + (onezboz)*(I3[6] - AC0*I4[6]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[52] - I2[11])
          - U12*(I1[97] - I2[12])
          + (onezboz)*(I3[7] - AC0*I4[7]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[53] - I2[12])
          - U12*(I1[98] - I2[13])
          + (onezboz)*(I3[8] - AC0*I4[8]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[54] - I2[13])
          - U12*(I1[99] - I2[14])
          + (onezboz)*(I3[9] - AC0*I4[9]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[10])
          - U11*(I1[55] - I2[15])
          - U12*(I1[100] - I2[16])
          + (onezboz)*(I3[10] - AC0*I4[10]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[11])
          - U11*(I1[56] - I2[16])
          - U12*(I1[101] - I2[17])
          + (onezboz)*(I3[11] - AC0*I4[11]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[12])
          - U11*(I1[57] - I2[17])
          - U12*(I1[102] - I2[18])
          + (onezboz)*(I3[12] - AC0*I4[12]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[13])
          - U11*(I1[58] - I2[18])
          - U12*(I1[103] - I2[19])
          + (onezboz)*(I3[13] - AC0*I4[13]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[14])
          - U11*(I1[59] - I2[19])
          - U12*(I1[104] - I2[20])
          + (onezboz)*(I3[14] - AC0*I4[14]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[15])
          - U11*(I1[60] - I2[21])
          - U12*(I1[105] - I2[22])
          + (onezboz)*(I3[15] - AC0*I4[15]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[16])
          - U11*(I1[61] - I2[22])
          - U12*(I1[106] - I2[23])
          + (onezboz)*(I3[16] - AC0*I4[16]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[17])
          - U11*(I1[62] - I2[23])
          - U12*(I1[107] - I2[24])
          + (onezboz)*(I3[17] - AC0*I4[17]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[18])
          - U11*(I1[63] - I2[24])
          - U12*(I1[108] - I2[25])
          + (onezboz)*(I3[18] - AC0*I4[18]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[19])
          - U11*(I1[64] - I2[25])
          - U12*(I1[109] - I2[26])
          + (onezboz)*(I3[19] - AC0*I4[19]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[20])
          - U11*(I1[65] - I2[26])
          - U12*(I1[110] - I2[27])
          + (onezboz)*(I3[20] - AC0*I4[20]);
*(vp++) = U0*I0[21]
          - U10*(I1[21] - I2[21])
          - U11*(I1[66] - I2[28])
          - U12*(I1[111] - I2[29])
          + (onezboz)*(I3[21] - AC0*I4[21]);
*(vp++) = U0*I0[22]
          - U10*(I1[22] - I2[22])
          - U11*(I1[67] - I2[29])
          - U12*(I1[112] - I2[30])
          + (onezboz)*(I3[22] - AC0*I4[22]);
*(vp++) = U0*I0[23]
          - U10*(I1[23] - I2[23])
          - U11*(I1[68] - I2[30])
          - U12*(I1[113] - I2[31])
          + (onezboz)*(I3[23] - AC0*I4[23]);
*(vp++) = U0*I0[24]
          - U10*(I1[24] - I2[24])
          - U11*(I1[69] - I2[31])
          - U12*(I1[114] - I2[32])
          + (onezboz)*(I3[24] - AC0*I4[24]);
*(vp++) = U0*I0[25]
          - U10*(I1[25] - I2[25])
          - U11*(I1[70] - I2[32])
          - U12*(I1[115] - I2[33])
          + (onezboz)*(I3[25] - AC0*I4[25]);
*(vp++) = U0*I0[26]
          - U10*(I1[26] - I2[26])
          - U11*(I1[71] - I2[33])
          - U12*(I1[116] - I2[34])
          + (onezboz)*(I3[26] - AC0*I4[26]);
*(vp++) = U0*I0[27]
          - U10*(I1[27] - I2[27])
          - U11*(I1[72] - I2[34])
          - U12*(I1[117] - I2[35])
          + (onezboz)*(I3[27] - AC0*I4[27]);
*(vp++) = U0*I0[28]
          - U10*(I1[28] - I2[28])
          - U11*(I1[73] - I2[36])
          - U12*(I1[118] - I2[37])
          + (onezboz)*(I3[28] - AC0*I4[28]);
*(vp++) = U0*I0[29]
          - U10*(I1[29] - I2[29])
          - U11*(I1[74] - I2[37])
          - U12*(I1[119] - I2[38])
          + (onezboz)*(I3[29] - AC0*I4[29]);
*(vp++) = U0*I0[30]
          - U10*(I1[30] - I2[30])
          - U11*(I1[75] - I2[38])
          - U12*(I1[120] - I2[39])
          + (onezboz)*(I3[30] - AC0*I4[30]);
*(vp++) = U0*I0[31]
          - U10*(I1[31] - I2[31])
          - U11*(I1[76] - I2[39])
          - U12*(I1[121] - I2[40])
          + (onezboz)*(I3[31] - AC0*I4[31]);
*(vp++) = U0*I0[32]
          - U10*(I1[32] - I2[32])
          - U11*(I1[77] - I2[40])
          - U12*(I1[122] - I2[41])
          + (onezboz)*(I3[32] - AC0*I4[32]);
*(vp++) = U0*I0[33]
          - U10*(I1[33] - I2[33])
          - U11*(I1[78] - I2[41])
          - U12*(I1[123] - I2[42])
          + (onezboz)*(I3[33] - AC0*I4[33]);
*(vp++) = U0*I0[34]
          - U10*(I1[34] - I2[34])
          - U11*(I1[79] - I2[42])
          - U12*(I1[124] - I2[43])
          + (onezboz)*(I3[34] - AC0*I4[34]);
*(vp++) = U0*I0[35]
          - U10*(I1[35] - I2[35])
          - U11*(I1[80] - I2[43])
          - U12*(I1[125] - I2[44])
          + (onezboz)*(I3[35] - AC0*I4[35]);
*(vp++) = U0*I0[36]
          - U10*(I1[36] - I2[36])
          - U11*(I1[81] - I2[45])
          - U12*(I1[126] - I2[46])
          + (onezboz)*(I3[36] - AC0*I4[36]);
*(vp++) = U0*I0[37]
          - U10*(I1[37] - I2[37])
          - U11*(I1[82] - I2[46])
          - U12*(I1[127] - I2[47])
          + (onezboz)*(I3[37] - AC0*I4[37]);
*(vp++) = U0*I0[38]
          - U10*(I1[38] - I2[38])
          - U11*(I1[83] - I2[47])
          - U12*(I1[128] - I2[48])
          + (onezboz)*(I3[38] - AC0*I4[38]);
*(vp++) = U0*I0[39]
          - U10*(I1[39] - I2[39])
          - U11*(I1[84] - I2[48])
          - U12*(I1[129] - I2[49])
          + (onezboz)*(I3[39] - AC0*I4[39]);
*(vp++) = U0*I0[40]
          - U10*(I1[40] - I2[40])
          - U11*(I1[85] - I2[49])
          - U12*(I1[130] - I2[50])
          + (onezboz)*(I3[40] - AC0*I4[40]);
*(vp++) = U0*I0[41]
          - U10*(I1[41] - I2[41])
          - U11*(I1[86] - I2[50])
          - U12*(I1[131] - I2[51])
          + (onezboz)*(I3[41] - AC0*I4[41]);
*(vp++) = U0*I0[42]
          - U10*(I1[42] - I2[42])
          - U11*(I1[87] - I2[51])
          - U12*(I1[132] - I2[52])
          + (onezboz)*(I3[42] - AC0*I4[42]);
*(vp++) = U0*I0[43]
          - U10*(I1[43] - I2[43])
          - U11*(I1[88] - I2[52])
          - U12*(I1[133] - I2[53])
          + (onezboz)*(I3[43] - AC0*I4[43]);
*(vp++) = U0*I0[44]
          - U10*(I1[44] - I2[44])
          - U11*(I1[89] - I2[53])
          - U12*(I1[134] - I2[54])
          + (onezboz)*(I3[44] - AC0*I4[44]);
*(vp++) = U0*I0[45]
          - U10*(I1[45] - I2[55])
          - U11*(I1[135] - I2[56])
          - U12*(I1[180] - I2[57])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[46]
          - U10*(I1[46] - I2[56])
          - U11*(I1[136] - I2[58])
          - U12*(I1[181] - I2[59])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[47]
          - U10*(I1[47] - I2[57])
          - U11*(I1[137] - I2[59])
          - U12*(I1[182] - I2[60])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[48]
          - U10*(I1[48] - I2[58])
          - U11*(I1[138] - I2[61])
          - U12*(I1[183] - I2[62])
          + (onezboz)*(I3[6] - AC1*I4[3]);
*(vp++) = U0*I0[49]
          - U10*(I1[49] - I2[59])
          - U11*(I1[139] - I2[62])
          - U12*(I1[184] - I2[63])
          + (onezboz)*(I3[7] - AC1*I4[4]);
*(vp++) = U0*I0[50]
          - U10*(I1[50] - I2[60])
          - U11*(I1[140] - I2[63])
          - U12*(I1[185] - I2[64])
          + (onezboz)*(I3[8] - AC1*I4[5]);
*(vp++) = U0*I0[51]
          - U10*(I1[51] - I2[61])
          - U11*(I1[141] - I2[65])
          - U12*(I1[186] - I2[66])
          + (onezboz)*(I3[10] - AC1*I4[6]);
*(vp++) = U0*I0[52]
          - U10*(I1[52] - I2[62])
          - U11*(I1[142] - I2[66])
          - U12*(I1[187] - I2[67])
          + (onezboz)*(I3[11] - AC1*I4[7]);
*(vp++) = U0*I0[53]
          - U10*(I1[53] - I2[63])
          - U11*(I1[143] - I2[67])
          - U12*(I1[188] - I2[68])
          + (onezboz)*(I3[12] - AC1*I4[8]);
*(vp++) = U0*I0[54]
          - U10*(I1[54] - I2[64])
          - U11*(I1[144] - I2[68])
          - U12*(I1[189] - I2[69])
          + (onezboz)*(I3[13] - AC1*I4[9]);
*(vp++) = U0*I0[55]
          - U10*(I1[55] - I2[65])
          - U11*(I1[145] - I2[70])
          - U12*(I1[190] - I2[71])
          + (onezboz)*(I3[15] - AC1*I4[10]);
*(vp++) = U0*I0[56]
          - U10*(I1[56] - I2[66])
          - U11*(I1[146] - I2[71])
          - U12*(I1[191] - I2[72])
          + (onezboz)*(I3[16] - AC1*I4[11]);
*(vp++) = U0*I0[57]
          - U10*(I1[57] - I2[67])
          - U11*(I1[147] - I2[72])
          - U12*(I1[192] - I2[73])
          + (onezboz)*(I3[17] - AC1*I4[12]);
*(vp++) = U0*I0[58]
          - U10*(I1[58] - I2[68])
          - U11*(I1[148] - I2[73])
          - U12*(I1[193] - I2[74])
          + (onezboz)*(I3[18] - AC1*I4[13]);
*(vp++) = U0*I0[59]
          - U10*(I1[59] - I2[69])
          - U11*(I1[149] - I2[74])
          - U12*(I1[194] - I2[75])
          + (onezboz)*(I3[19] - AC1*I4[14]);
*(vp++) = U0*I0[60]
          - U10*(I1[60] - I2[70])
          - U11*(I1[150] - I2[76])
          - U12*(I1[195] - I2[77])
          + (onezboz)*(I3[21] - AC1*I4[15]);
*(vp++) = U0*I0[61]
          - U10*(I1[61] - I2[71])
          - U11*(I1[151] - I2[77])
          - U12*(I1[196] - I2[78])
          + (onezboz)*(I3[22] - AC1*I4[16]);
*(vp++) = U0*I0[62]
          - U10*(I1[62] - I2[72])
          - U11*(I1[152] - I2[78])
          - U12*(I1[197] - I2[79])
          + (onezboz)*(I3[23] - AC1*I4[17]);
*(vp++) = U0*I0[63]
          - U10*(I1[63] - I2[73])
          - U11*(I1[153] - I2[79])
          - U12*(I1[198] - I2[80])
          + (onezboz)*(I3[24] - AC1*I4[18]);
*(vp++) = U0*I0[64]
          - U10*(I1[64] - I2[74])
          - U11*(I1[154] - I2[80])
          - U12*(I1[199] - I2[81])
          + (onezboz)*(I3[25] - AC1*I4[19]);
*(vp++) = U0*I0[65]
          - U10*(I1[65] - I2[75])
          - U11*(I1[155] - I2[81])
          - U12*(I1[200] - I2[82])
          + (onezboz)*(I3[26] - AC1*I4[20]);
*(vp++) = U0*I0[66]
          - U10*(I1[66] - I2[76])
          - U11*(I1[156] - I2[83])
          - U12*(I1[201] - I2[84])
          + (onezboz)*(I3[28] - AC1*I4[21]);
*(vp++) = U0*I0[67]
          - U10*(I1[67] - I2[77])
          - U11*(I1[157] - I2[84])
          - U12*(I1[202] - I2[85])
          + (onezboz)*(I3[29] - AC1*I4[22]);
*(vp++) = U0*I0[68]
          - U10*(I1[68] - I2[78])
          - U11*(I1[158] - I2[85])
          - U12*(I1[203] - I2[86])
          + (onezboz)*(I3[30] - AC1*I4[23]);
*(vp++) = U0*I0[69]
          - U10*(I1[69] - I2[79])
          - U11*(I1[159] - I2[86])
          - U12*(I1[204] - I2[87])
          + (onezboz)*(I3[31] - AC1*I4[24]);
*(vp++) = U0*I0[70]
          - U10*(I1[70] - I2[80])
          - U11*(I1[160] - I2[87])
          - U12*(I1[205] - I2[88])
          + (onezboz)*(I3[32] - AC1*I4[25]);
*(vp++) = U0*I0[71]
          - U10*(I1[71] - I2[81])
          - U11*(I1[161] - I2[88])
          - U12*(I1[206] - I2[89])
          + (onezboz)*(I3[33] - AC1*I4[26]);
*(vp++) = U0*I0[72]
          - U10*(I1[72] - I2[82])
          - U11*(I1[162] - I2[89])
          - U12*(I1[207] - I2[90])
          + (onezboz)*(I3[34] - AC1*I4[27]);
*(vp++) = U0*I0[73]
          - U10*(I1[73] - I2[83])
          - U11*(I1[163] - I2[91])
          - U12*(I1[208] - I2[92])
          + (onezboz)*(I3[36] - AC1*I4[28]);
*(vp++) = U0*I0[74]
          - U10*(I1[74] - I2[84])
          - U11*(I1[164] - I2[92])
          - U12*(I1[209] - I2[93])
          + (onezboz)*(I3[37] - AC1*I4[29]);
*(vp++) = U0*I0[75]
          - U10*(I1[75] - I2[85])
          - U11*(I1[165] - I2[93])
          - U12*(I1[210] - I2[94])
          + (onezboz)*(I3[38] - AC1*I4[30]);
*(vp++) = U0*I0[76]
          - U10*(I1[76] - I2[86])
          - U11*(I1[166] - I2[94])
          - U12*(I1[211] - I2[95])
          + (onezboz)*(I3[39] - AC1*I4[31]);
*(vp++) = U0*I0[77]
          - U10*(I1[77] - I2[87])
          - U11*(I1[167] - I2[95])
          - U12*(I1[212] - I2[96])
          + (onezboz)*(I3[40] - AC1*I4[32]);
*(vp++) = U0*I0[78]
          - U10*(I1[78] - I2[88])
          - U11*(I1[168] - I2[96])
          - U12*(I1[213] - I2[97])
          + (onezboz)*(I3[41] - AC1*I4[33]);
*(vp++) = U0*I0[79]
          - U10*(I1[79] - I2[89])
          - U11*(I1[169] - I2[97])
          - U12*(I1[214] - I2[98])
          + (onezboz)*(I3[42] - AC1*I4[34]);
*(vp++) = U0*I0[80]
          - U10*(I1[80] - I2[90])
          - U11*(I1[170] - I2[98])
          - U12*(I1[215] - I2[99])
          + (onezboz)*(I3[43] - AC1*I4[35]);
*(vp++) = U0*I0[81]
          - U10*(I1[81] - I2[91])
          - U11*(I1[171] - I2[100])
          - U12*(I1[216] - I2[101])
          + (onezboz)*(I3[45] - AC1*I4[36]);
*(vp++) = U0*I0[82]
          - U10*(I1[82] - I2[92])
          - U11*(I1[172] - I2[101])
          - U12*(I1[217] - I2[102])
          + (onezboz)*(I3[46] - AC1*I4[37]);
*(vp++) = U0*I0[83]
          - U10*(I1[83] - I2[93])
          - U11*(I1[173] - I2[102])
          - U12*(I1[218] - I2[103])
          + (onezboz)*(I3[47] - AC1*I4[38]);
*(vp++) = U0*I0[84]
          - U10*(I1[84] - I2[94])
          - U11*(I1[174] - I2[103])
          - U12*(I1[219] - I2[104])
          + (onezboz)*(I3[48] - AC1*I4[39]);
*(vp++) = U0*I0[85]
          - U10*(I1[85] - I2[95])
          - U11*(I1[175] - I2[104])
          - U12*(I1[220] - I2[105])
          + (onezboz)*(I3[49] - AC1*I4[40]);
*(vp++) = U0*I0[86]
          - U10*(I1[86] - I2[96])
          - U11*(I1[176] - I2[105])
          - U12*(I1[221] - I2[106])
          + (onezboz)*(I3[50] - AC1*I4[41]);
*(vp++) = U0*I0[87]
          - U10*(I1[87] - I2[97])
          - U11*(I1[177] - I2[106])
          - U12*(I1[222] - I2[107])
          + (onezboz)*(I3[51] - AC1*I4[42]);
*(vp++) = U0*I0[88]
          - U10*(I1[88] - I2[98])
          - U11*(I1[178] - I2[107])
          - U12*(I1[223] - I2[108])
          + (onezboz)*(I3[52] - AC1*I4[43]);
*(vp++) = U0*I0[89]
          - U10*(I1[89] - I2[99])
          - U11*(I1[179] - I2[108])
          - U12*(I1[224] - I2[109])
          + (onezboz)*(I3[53] - AC1*I4[44]);
*(vp++) = U0*I0[90]
          - U10*(I1[90] - I2[110])
          - U11*(I1[180] - I2[111])
          - U12*(I1[225] - I2[112])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[91]
          - U10*(I1[91] - I2[111])
          - U11*(I1[181] - I2[113])
          - U12*(I1[226] - I2[114])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[92]
          - U10*(I1[92] - I2[112])
          - U11*(I1[182] - I2[114])
          - U12*(I1[227] - I2[115])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[93]
          - U10*(I1[93] - I2[113])
          - U11*(I1[183] - I2[116])
          - U12*(I1[228] - I2[117])
          + (onezboz)*(I3[7] - AC2*I4[3]);
*(vp++) = U0*I0[94]
          - U10*(I1[94] - I2[114])
          - U11*(I1[184] - I2[117])
          - U12*(I1[229] - I2[118])
          + (onezboz)*(I3[8] - AC2*I4[4]);
*(vp++) = U0*I0[95]
          - U10*(I1[95] - I2[115])
          - U11*(I1[185] - I2[118])
          - U12*(I1[230] - I2[119])
          + (onezboz)*(I3[9] - AC2*I4[5]);
*(vp++) = U0*I0[96]
          - U10*(I1[96] - I2[116])
          - U11*(I1[186] - I2[120])
          - U12*(I1[231] - I2[121])
          + (onezboz)*(I3[11] - AC2*I4[6]);
*(vp++) = U0*I0[97]
          - U10*(I1[97] - I2[117])
          - U11*(I1[187] - I2[121])
          - U12*(I1[232] - I2[122])
          + (onezboz)*(I3[12] - AC2*I4[7]);
*(vp++) = U0*I0[98]
          - U10*(I1[98] - I2[118])
          - U11*(I1[188] - I2[122])
          - U12*(I1[233] - I2[123])
          + (onezboz)*(I3[13] - AC2*I4[8]);
*(vp++) = U0*I0[99]
          - U10*(I1[99] - I2[119])
          - U11*(I1[189] - I2[123])
          - U12*(I1[234] - I2[124])
          + (onezboz)*(I3[14] - AC2*I4[9]);
*(vp++) = U0*I0[100]
          - U10*(I1[100] - I2[120])
          - U11*(I1[190] - I2[125])
          - U12*(I1[235] - I2[126])
          + (onezboz)*(I3[16] - AC2*I4[10]);
*(vp++) = U0*I0[101]
          - U10*(I1[101] - I2[121])
          - U11*(I1[191] - I2[126])
          - U12*(I1[236] - I2[127])
          + (onezboz)*(I3[17] - AC2*I4[11]);
*(vp++) = U0*I0[102]
          - U10*(I1[102] - I2[122])
          - U11*(I1[192] - I2[127])
          - U12*(I1[237] - I2[128])
          + (onezboz)*(I3[18] - AC2*I4[12]);
*(vp++) = U0*I0[103]
          - U10*(I1[103] - I2[123])
          - U11*(I1[193] - I2[128])
          - U12*(I1[238] - I2[129])
          + (onezboz)*(I3[19] - AC2*I4[13]);
*(vp++) = U0*I0[104]
          - U10*(I1[104] - I2[124])
          - U11*(I1[194] - I2[129])
          - U12*(I1[239] - I2[130])
          + (onezboz)*(I3[20] - AC2*I4[14]);
*(vp++) = U0*I0[105]
          - U10*(I1[105] - I2[125])
          - U11*(I1[195] - I2[131])
          - U12*(I1[240] - I2[132])
          + (onezboz)*(I3[22] - AC2*I4[15]);
*(vp++) = U0*I0[106]
          - U10*(I1[106] - I2[126])
          - U11*(I1[196] - I2[132])
          - U12*(I1[241] - I2[133])
          + (onezboz)*(I3[23] - AC2*I4[16]);
*(vp++) = U0*I0[107]
          - U10*(I1[107] - I2[127])
          - U11*(I1[197] - I2[133])
          - U12*(I1[242] - I2[134])
          + (onezboz)*(I3[24] - AC2*I4[17]);
*(vp++) = U0*I0[108]
          - U10*(I1[108] - I2[128])
          - U11*(I1[198] - I2[134])
          - U12*(I1[243] - I2[135])
          + (onezboz)*(I3[25] - AC2*I4[18]);
*(vp++) = U0*I0[109]
          - U10*(I1[109] - I2[129])
          - U11*(I1[199] - I2[135])
          - U12*(I1[244] - I2[136])
          + (onezboz)*(I3[26] - AC2*I4[19]);
*(vp++) = U0*I0[110]
          - U10*(I1[110] - I2[130])
          - U11*(I1[200] - I2[136])
          - U12*(I1[245] - I2[137])
          + (onezboz)*(I3[27] - AC2*I4[20]);
*(vp++) = U0*I0[111]
          - U10*(I1[111] - I2[131])
          - U11*(I1[201] - I2[138])
          - U12*(I1[246] - I2[139])
          + (onezboz)*(I3[29] - AC2*I4[21]);
*(vp++) = U0*I0[112]
          - U10*(I1[112] - I2[132])
          - U11*(I1[202] - I2[139])
          - U12*(I1[247] - I2[140])
          + (onezboz)*(I3[30] - AC2*I4[22]);
*(vp++) = U0*I0[113]
          - U10*(I1[113] - I2[133])
          - U11*(I1[203] - I2[140])
          - U12*(I1[248] - I2[141])
          + (onezboz)*(I3[31] - AC2*I4[23]);
*(vp++) = U0*I0[114]
          - U10*(I1[114] - I2[134])
          - U11*(I1[204] - I2[141])
          - U12*(I1[249] - I2[142])
          + (onezboz)*(I3[32] - AC2*I4[24]);
*(vp++) = U0*I0[115]
          - U10*(I1[115] - I2[135])
          - U11*(I1[205] - I2[142])
          - U12*(I1[250] - I2[143])
          + (onezboz)*(I3[33] - AC2*I4[25]);
*(vp++) = U0*I0[116]
          - U10*(I1[116] - I2[136])
          - U11*(I1[206] - I2[143])
          - U12*(I1[251] - I2[144])
          + (onezboz)*(I3[34] - AC2*I4[26]);
*(vp++) = U0*I0[117]
          - U10*(I1[117] - I2[137])
          - U11*(I1[207] - I2[144])
          - U12*(I1[252] - I2[145])
          + (onezboz)*(I3[35] - AC2*I4[27]);
*(vp++) = U0*I0[118]
          - U10*(I1[118] - I2[138])
          - U11*(I1[208] - I2[146])
          - U12*(I1[253] - I2[147])
          + (onezboz)*(I3[37] - AC2*I4[28]);
*(vp++) = U0*I0[119]
          - U10*(I1[119] - I2[139])
          - U11*(I1[209] - I2[147])
          - U12*(I1[254] - I2[148])
          + (onezboz)*(I3[38] - AC2*I4[29]);
*(vp++) = U0*I0[120]
          - U10*(I1[120] - I2[140])
          - U11*(I1[210] - I2[148])
          - U12*(I1[255] - I2[149])
          + (onezboz)*(I3[39] - AC2*I4[30]);
*(vp++) = U0*I0[121]
          - U10*(I1[121] - I2[141])
          - U11*(I1[211] - I2[149])
          - U12*(I1[256] - I2[150])
          + (onezboz)*(I3[40] - AC2*I4[31]);
*(vp++) = U0*I0[122]
          - U10*(I1[122] - I2[142])
          - U11*(I1[212] - I2[150])
          - U12*(I1[257] - I2[151])
          + (onezboz)*(I3[41] - AC2*I4[32]);
*(vp++) = U0*I0[123]
          - U10*(I1[123] - I2[143])
          - U11*(I1[213] - I2[151])
          - U12*(I1[258] - I2[152])
          + (onezboz)*(I3[42] - AC2*I4[33]);
*(vp++) = U0*I0[124]
          - U10*(I1[124] - I2[144])
          - U11*(I1[214] - I2[152])
          - U12*(I1[259] - I2[153])
          + (onezboz)*(I3[43] - AC2*I4[34]);
*(vp++) = U0*I0[125]
          - U10*(I1[125] - I2[145])
          - U11*(I1[215] - I2[153])
          - U12*(I1[260] - I2[154])
          + (onezboz)*(I3[44] - AC2*I4[35]);
*(vp++) = U0*I0[126]
          - U10*(I1[126] - I2[146])
          - U11*(I1[216] - I2[155])
          - U12*(I1[261] - I2[156])
          + (onezboz)*(I3[46] - AC2*I4[36]);
*(vp++) = U0*I0[127]
          - U10*(I1[127] - I2[147])
          - U11*(I1[217] - I2[156])
          - U12*(I1[262] - I2[157])
          + (onezboz)*(I3[47] - AC2*I4[37]);
*(vp++) = U0*I0[128]
          - U10*(I1[128] - I2[148])
          - U11*(I1[218] - I2[157])
          - U12*(I1[263] - I2[158])
          + (onezboz)*(I3[48] - AC2*I4[38]);
*(vp++) = U0*I0[129]
          - U10*(I1[129] - I2[149])
          - U11*(I1[219] - I2[158])
          - U12*(I1[264] - I2[159])
          + (onezboz)*(I3[49] - AC2*I4[39]);
*(vp++) = U0*I0[130]
          - U10*(I1[130] - I2[150])
          - U11*(I1[220] - I2[159])
          - U12*(I1[265] - I2[160])
          + (onezboz)*(I3[50] - AC2*I4[40]);
*(vp++) = U0*I0[131]
          - U10*(I1[131] - I2[151])
          - U11*(I1[221] - I2[160])
          - U12*(I1[266] - I2[161])
          + (onezboz)*(I3[51] - AC2*I4[41]);
*(vp++) = U0*I0[132]
          - U10*(I1[132] - I2[152])
          - U11*(I1[222] - I2[161])
          - U12*(I1[267] - I2[162])
          + (onezboz)*(I3[52] - AC2*I4[42]);
*(vp++) = U0*I0[133]
          - U10*(I1[133] - I2[153])
          - U11*(I1[223] - I2[162])
          - U12*(I1[268] - I2[163])
          + (onezboz)*(I3[53] - AC2*I4[43]);
*(vp++) = U0*I0[134]
          - U10*(I1[134] - I2[154])
          - U11*(I1[224] - I2[163])
          - U12*(I1[269] - I2[164])
          + (onezboz)*(I3[54] - AC2*I4[44]);

}
