/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_ddgd(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|gd) integrals */

void d12hrr_order_ddgd(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[4][6][11] = int_stack + 0;
 Libderiv->deriv_classes[4][6][10] = int_stack + 420;
 Libderiv->deriv_classes[4][6][9] = int_stack + 840;
 Libderiv->deriv_classes[4][6][8] = int_stack + 1260;
 Libderiv->deriv_classes[4][6][7] = int_stack + 1680;
 Libderiv->dvrr_classes[4][5] = int_stack + 2100;
 Libderiv->deriv_classes[4][6][6] = int_stack + 2415;
 Libderiv->deriv_classes[4][6][2] = int_stack + 2835;
 Libderiv->deriv_classes[4][6][1] = int_stack + 3255;
 Libderiv->dvrr_classes[3][6] = int_stack + 3675;
 Libderiv->deriv_classes[4][6][0] = int_stack + 3955;
 Libderiv->deriv2_classes[2][4][143] = int_stack + 4375;
 Libderiv->deriv2_classes[2][5][143] = int_stack + 4465;
 Libderiv->deriv2_classes[2][6][143] = int_stack + 4591;
 Libderiv->deriv2_classes[3][4][143] = int_stack + 4759;
 Libderiv->deriv2_classes[3][5][143] = int_stack + 4909;
 Libderiv->deriv2_classes[3][6][143] = int_stack + 5119;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 5399;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 5624;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 5939;
 Libderiv->deriv2_classes[2][4][131] = int_stack + 6359;
 Libderiv->deriv2_classes[2][5][131] = int_stack + 6449;
 Libderiv->deriv2_classes[2][6][131] = int_stack + 6575;
 Libderiv->deriv2_classes[3][4][131] = int_stack + 6743;
 Libderiv->deriv2_classes[3][5][131] = int_stack + 6893;
 Libderiv->deriv2_classes[3][6][131] = int_stack + 7103;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 7383;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 7608;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 7923;
 Libderiv->deriv2_classes[2][4][130] = int_stack + 8343;
 Libderiv->deriv2_classes[2][5][130] = int_stack + 8433;
 Libderiv->deriv2_classes[2][6][130] = int_stack + 8559;
 Libderiv->deriv2_classes[3][4][130] = int_stack + 8727;
 Libderiv->deriv2_classes[3][5][130] = int_stack + 8877;
 Libderiv->deriv2_classes[3][6][130] = int_stack + 9087;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 9367;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 9592;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 9907;
 Libderiv->deriv2_classes[2][4][119] = int_stack + 10327;
 Libderiv->deriv2_classes[2][5][119] = int_stack + 10417;
 Libderiv->deriv2_classes[2][6][119] = int_stack + 10543;
 Libderiv->deriv2_classes[3][4][119] = int_stack + 10711;
 Libderiv->deriv2_classes[3][5][119] = int_stack + 10861;
 Libderiv->deriv2_classes[3][6][119] = int_stack + 11071;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 11351;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 11576;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 11891;
 Libderiv->deriv2_classes[2][4][118] = int_stack + 12311;
 Libderiv->deriv2_classes[2][5][118] = int_stack + 12401;
 Libderiv->deriv2_classes[2][6][118] = int_stack + 12527;
 Libderiv->deriv2_classes[3][4][118] = int_stack + 12695;
 Libderiv->deriv2_classes[3][5][118] = int_stack + 12845;
 Libderiv->deriv2_classes[3][6][118] = int_stack + 13055;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 13335;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 13560;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 13875;
 Libderiv->deriv2_classes[2][4][117] = int_stack + 14295;
 Libderiv->deriv2_classes[2][5][117] = int_stack + 14385;
 Libderiv->deriv2_classes[2][6][117] = int_stack + 14511;
 Libderiv->deriv2_classes[3][4][117] = int_stack + 14679;
 Libderiv->deriv2_classes[3][5][117] = int_stack + 14829;
 Libderiv->deriv2_classes[3][6][117] = int_stack + 15039;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 15319;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 15544;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 15859;
 Libderiv->deriv2_classes[2][4][107] = int_stack + 16279;
 Libderiv->deriv2_classes[2][5][107] = int_stack + 16369;
 Libderiv->deriv2_classes[2][6][107] = int_stack + 16495;
 Libderiv->deriv2_classes[3][4][107] = int_stack + 16663;
 Libderiv->deriv2_classes[3][5][107] = int_stack + 16813;
 Libderiv->deriv2_classes[3][6][107] = int_stack + 17023;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 17303;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 17528;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 17843;
 Libderiv->deriv2_classes[2][4][106] = int_stack + 18263;
 Libderiv->deriv2_classes[2][5][106] = int_stack + 18353;
 Libderiv->deriv2_classes[2][6][106] = int_stack + 18479;
 Libderiv->deriv2_classes[3][4][106] = int_stack + 18647;
 Libderiv->deriv2_classes[3][5][106] = int_stack + 18797;
 Libderiv->deriv2_classes[3][6][106] = int_stack + 19007;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 19287;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 19512;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 19827;
 Libderiv->deriv2_classes[2][4][105] = int_stack + 20247;
 Libderiv->deriv2_classes[2][5][105] = int_stack + 20337;
 Libderiv->deriv2_classes[2][6][105] = int_stack + 20463;
 Libderiv->deriv2_classes[3][4][105] = int_stack + 20631;
 Libderiv->deriv2_classes[3][5][105] = int_stack + 20781;
 Libderiv->deriv2_classes[3][6][105] = int_stack + 20991;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 21271;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 21496;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 21811;
 Libderiv->deriv2_classes[2][4][104] = int_stack + 22231;
 Libderiv->deriv2_classes[2][5][104] = int_stack + 22321;
 Libderiv->deriv2_classes[2][6][104] = int_stack + 22447;
 Libderiv->deriv2_classes[3][4][104] = int_stack + 22615;
 Libderiv->deriv2_classes[3][5][104] = int_stack + 22765;
 Libderiv->deriv2_classes[3][6][104] = int_stack + 22975;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 23255;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 23480;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 23795;
 Libderiv->deriv2_classes[2][4][95] = int_stack + 24215;
 Libderiv->deriv2_classes[2][5][95] = int_stack + 24305;
 Libderiv->deriv2_classes[2][6][95] = int_stack + 24431;
 Libderiv->deriv2_classes[3][4][95] = int_stack + 24599;
 Libderiv->deriv2_classes[3][5][95] = int_stack + 24749;
 Libderiv->deriv2_classes[3][6][95] = int_stack + 24959;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 25239;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 25464;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 25779;
 Libderiv->deriv2_classes[2][4][94] = int_stack + 26199;
 Libderiv->deriv2_classes[2][5][94] = int_stack + 26289;
 Libderiv->deriv2_classes[2][6][94] = int_stack + 26415;
 Libderiv->deriv2_classes[3][4][94] = int_stack + 26583;
 Libderiv->deriv2_classes[3][5][94] = int_stack + 26733;
 Libderiv->deriv2_classes[3][6][94] = int_stack + 26943;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 27223;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 27448;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 27763;
 Libderiv->deriv2_classes[2][4][93] = int_stack + 28183;
 Libderiv->deriv2_classes[2][5][93] = int_stack + 28273;
 Libderiv->deriv2_classes[2][6][93] = int_stack + 28399;
 Libderiv->deriv2_classes[3][4][93] = int_stack + 28567;
 Libderiv->deriv2_classes[3][5][93] = int_stack + 28717;
 Libderiv->deriv2_classes[3][6][93] = int_stack + 28927;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 29207;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 29432;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 29747;
 Libderiv->deriv2_classes[2][4][92] = int_stack + 30167;
 Libderiv->deriv2_classes[2][5][92] = int_stack + 30257;
 Libderiv->deriv2_classes[2][6][92] = int_stack + 30383;
 Libderiv->deriv2_classes[3][4][92] = int_stack + 30551;
 Libderiv->deriv2_classes[3][5][92] = int_stack + 30701;
 Libderiv->deriv2_classes[3][6][92] = int_stack + 30911;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 31191;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 31416;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 31731;
 Libderiv->deriv2_classes[2][4][91] = int_stack + 32151;
 Libderiv->deriv2_classes[2][5][91] = int_stack + 32241;
 Libderiv->deriv2_classes[2][6][91] = int_stack + 32367;
 Libderiv->deriv2_classes[3][4][91] = int_stack + 32535;
 Libderiv->deriv2_classes[3][5][91] = int_stack + 32685;
 Libderiv->deriv2_classes[3][6][91] = int_stack + 32895;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 33175;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 33400;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 33715;
 Libderiv->deriv2_classes[2][4][83] = int_stack + 34135;
 Libderiv->deriv2_classes[2][5][83] = int_stack + 34225;
 Libderiv->deriv2_classes[2][6][83] = int_stack + 34351;
 Libderiv->deriv2_classes[3][4][83] = int_stack + 34519;
 Libderiv->deriv2_classes[3][5][83] = int_stack + 34669;
 Libderiv->deriv2_classes[3][6][83] = int_stack + 34879;
 Libderiv->deriv_classes[4][4][11] = int_stack + 35159;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 35384;
 Libderiv->deriv_classes[4][5][11] = int_stack + 35609;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 35924;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 36239;
 Libderiv->deriv2_classes[2][4][82] = int_stack + 36659;
 Libderiv->deriv2_classes[2][5][82] = int_stack + 36749;
 Libderiv->deriv2_classes[2][6][82] = int_stack + 36875;
 Libderiv->deriv2_classes[3][4][82] = int_stack + 37043;
 Libderiv->deriv2_classes[3][5][82] = int_stack + 37193;
 Libderiv->deriv2_classes[3][6][82] = int_stack + 37403;
 Libderiv->deriv_classes[4][4][10] = int_stack + 37683;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 37908;
 Libderiv->deriv_classes[4][5][10] = int_stack + 38133;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 38448;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 38763;
 Libderiv->deriv2_classes[2][4][81] = int_stack + 39183;
 Libderiv->deriv2_classes[2][5][81] = int_stack + 39273;
 Libderiv->deriv2_classes[2][6][81] = int_stack + 39399;
 Libderiv->deriv2_classes[3][4][81] = int_stack + 39567;
 Libderiv->deriv2_classes[3][5][81] = int_stack + 39717;
 Libderiv->deriv2_classes[3][6][81] = int_stack + 39927;
 Libderiv->deriv_classes[4][4][9] = int_stack + 40207;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 40432;
 Libderiv->deriv_classes[4][5][9] = int_stack + 40657;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 40972;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 41287;
 Libderiv->deriv2_classes[2][4][80] = int_stack + 41707;
 Libderiv->deriv2_classes[2][5][80] = int_stack + 41797;
 Libderiv->deriv2_classes[2][6][80] = int_stack + 41923;
 Libderiv->deriv2_classes[3][4][80] = int_stack + 42091;
 Libderiv->deriv2_classes[3][5][80] = int_stack + 42241;
 Libderiv->deriv2_classes[3][6][80] = int_stack + 42451;
 Libderiv->deriv_classes[4][4][8] = int_stack + 42731;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 42956;
 Libderiv->deriv_classes[4][5][8] = int_stack + 43181;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 43496;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 43811;
 Libderiv->deriv2_classes[2][4][79] = int_stack + 44231;
 Libderiv->deriv2_classes[2][5][79] = int_stack + 44321;
 Libderiv->deriv2_classes[2][6][79] = int_stack + 44447;
 Libderiv->deriv2_classes[3][4][79] = int_stack + 44615;
 Libderiv->deriv2_classes[3][5][79] = int_stack + 44765;
 Libderiv->deriv2_classes[3][6][79] = int_stack + 44975;
 Libderiv->deriv_classes[4][4][7] = int_stack + 45255;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 45480;
 Libderiv->deriv_classes[4][5][7] = int_stack + 45705;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 46020;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 46335;
 Libderiv->deriv2_classes[2][4][78] = int_stack + 46755;
 Libderiv->deriv2_classes[2][5][78] = int_stack + 46845;
 Libderiv->deriv2_classes[2][6][78] = int_stack + 46971;
 Libderiv->deriv2_classes[3][4][78] = int_stack + 47139;
 Libderiv->deriv2_classes[3][5][78] = int_stack + 47289;
 Libderiv->deriv2_classes[3][6][78] = int_stack + 47499;
 Libderiv->dvrr_classes[4][4] = int_stack + 47779;
 Libderiv->deriv_classes[4][4][6] = int_stack + 48004;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 48229;
 Libderiv->deriv_classes[4][5][6] = int_stack + 48454;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 48769;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 49084;
 Libderiv->deriv2_classes[2][4][35] = int_stack + 49504;
 Libderiv->deriv2_classes[2][5][35] = int_stack + 49594;
 Libderiv->deriv2_classes[2][6][35] = int_stack + 49720;
 Libderiv->deriv2_classes[3][4][35] = int_stack + 49888;
 Libderiv->deriv2_classes[3][5][35] = int_stack + 50038;
 Libderiv->deriv2_classes[3][6][35] = int_stack + 50248;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 50528;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 50753;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 51068;
 Libderiv->deriv2_classes[2][4][34] = int_stack + 51488;
 Libderiv->deriv2_classes[2][5][34] = int_stack + 51578;
 Libderiv->deriv2_classes[2][6][34] = int_stack + 51704;
 Libderiv->deriv2_classes[3][4][34] = int_stack + 51872;
 Libderiv->deriv2_classes[3][5][34] = int_stack + 52022;
 Libderiv->deriv2_classes[3][6][34] = int_stack + 52232;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 52512;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 52737;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 53052;
 Libderiv->deriv2_classes[2][4][33] = int_stack + 53472;
 Libderiv->deriv2_classes[2][5][33] = int_stack + 53562;
 Libderiv->deriv2_classes[2][6][33] = int_stack + 53688;
 Libderiv->deriv2_classes[3][4][33] = int_stack + 53856;
 Libderiv->deriv2_classes[3][5][33] = int_stack + 54006;
 Libderiv->deriv2_classes[3][6][33] = int_stack + 54216;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 54496;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 54721;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 55036;
 Libderiv->deriv2_classes[2][4][32] = int_stack + 55456;
 Libderiv->deriv2_classes[2][5][32] = int_stack + 55546;
 Libderiv->deriv2_classes[2][6][32] = int_stack + 55672;
 Libderiv->deriv2_classes[3][4][32] = int_stack + 55840;
 Libderiv->deriv2_classes[3][5][32] = int_stack + 55990;
 Libderiv->deriv2_classes[3][6][32] = int_stack + 56200;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 56480;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 56705;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 57020;
 Libderiv->deriv2_classes[2][4][31] = int_stack + 57440;
 Libderiv->deriv2_classes[2][5][31] = int_stack + 57530;
 Libderiv->deriv2_classes[2][6][31] = int_stack + 57656;
 Libderiv->deriv2_classes[3][4][31] = int_stack + 57824;
 Libderiv->deriv2_classes[3][5][31] = int_stack + 57974;
 Libderiv->deriv2_classes[3][6][31] = int_stack + 58184;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 58464;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 58689;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 59004;
 Libderiv->deriv2_classes[2][4][30] = int_stack + 59424;
 Libderiv->deriv2_classes[2][5][30] = int_stack + 59514;
 Libderiv->deriv2_classes[2][6][30] = int_stack + 59640;
 Libderiv->deriv2_classes[3][4][30] = int_stack + 59808;
 Libderiv->deriv2_classes[3][5][30] = int_stack + 59958;
 Libderiv->deriv2_classes[3][6][30] = int_stack + 60168;
 Libderiv->deriv_classes[4][4][2] = int_stack + 60448;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 60673;
 Libderiv->deriv_classes[4][5][2] = int_stack + 60898;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 61213;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 61528;
 Libderiv->deriv2_classes[2][4][26] = int_stack + 61948;
 Libderiv->deriv2_classes[2][5][26] = int_stack + 62038;
 Libderiv->deriv2_classes[2][6][26] = int_stack + 62164;
 Libderiv->deriv2_classes[3][4][26] = int_stack + 62332;
 Libderiv->deriv2_classes[3][5][26] = int_stack + 62482;
 Libderiv->deriv2_classes[3][6][26] = int_stack + 62692;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 62972;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 63197;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 63512;
 Libderiv->deriv2_classes[2][4][23] = int_stack + 63932;
 Libderiv->deriv2_classes[2][5][23] = int_stack + 64022;
 Libderiv->deriv2_classes[2][6][23] = int_stack + 64148;
 Libderiv->deriv2_classes[3][4][23] = int_stack + 64316;
 Libderiv->deriv2_classes[3][5][23] = int_stack + 64466;
 Libderiv->deriv2_classes[3][6][23] = int_stack + 64676;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 64956;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 65181;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 65496;
 Libderiv->deriv2_classes[2][4][22] = int_stack + 65916;
 Libderiv->deriv2_classes[2][5][22] = int_stack + 66006;
 Libderiv->deriv2_classes[2][6][22] = int_stack + 66132;
 Libderiv->deriv2_classes[3][4][22] = int_stack + 66300;
 Libderiv->deriv2_classes[3][5][22] = int_stack + 66450;
 Libderiv->deriv2_classes[3][6][22] = int_stack + 66660;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 66940;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 67165;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 67480;
 Libderiv->deriv2_classes[2][4][21] = int_stack + 67900;
 Libderiv->deriv2_classes[2][5][21] = int_stack + 67990;
 Libderiv->deriv2_classes[2][6][21] = int_stack + 68116;
 Libderiv->deriv2_classes[3][4][21] = int_stack + 68284;
 Libderiv->deriv2_classes[3][5][21] = int_stack + 68434;
 Libderiv->deriv2_classes[3][6][21] = int_stack + 68644;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 68924;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 69149;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 69464;
 Libderiv->deriv2_classes[2][4][20] = int_stack + 69884;
 Libderiv->deriv2_classes[2][5][20] = int_stack + 69974;
 Libderiv->deriv2_classes[2][6][20] = int_stack + 70100;
 Libderiv->deriv2_classes[3][4][20] = int_stack + 70268;
 Libderiv->deriv2_classes[3][5][20] = int_stack + 70418;
 Libderiv->deriv2_classes[3][6][20] = int_stack + 70628;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 70908;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 71133;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 71448;
 Libderiv->deriv2_classes[2][4][19] = int_stack + 71868;
 Libderiv->deriv2_classes[2][5][19] = int_stack + 71958;
 Libderiv->deriv2_classes[2][6][19] = int_stack + 72084;
 Libderiv->deriv2_classes[3][4][19] = int_stack + 72252;
 Libderiv->deriv2_classes[3][5][19] = int_stack + 72402;
 Libderiv->deriv2_classes[3][6][19] = int_stack + 72612;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 72892;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 73117;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 73432;
 Libderiv->deriv2_classes[2][4][18] = int_stack + 73852;
 Libderiv->deriv2_classes[2][5][18] = int_stack + 73942;
 Libderiv->deriv2_classes[2][6][18] = int_stack + 74068;
 Libderiv->deriv2_classes[3][4][18] = int_stack + 74236;
 Libderiv->deriv2_classes[3][5][18] = int_stack + 74386;
 Libderiv->deriv2_classes[3][6][18] = int_stack + 74596;
 Libderiv->deriv_classes[4][4][1] = int_stack + 74876;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 75101;
 Libderiv->deriv_classes[4][5][1] = int_stack + 75326;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 75641;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 75956;
 Libderiv->deriv2_classes[2][4][14] = int_stack + 76376;
 Libderiv->deriv2_classes[2][5][14] = int_stack + 76466;
 Libderiv->deriv2_classes[2][6][14] = int_stack + 76592;
 Libderiv->deriv2_classes[3][4][14] = int_stack + 76760;
 Libderiv->deriv2_classes[3][5][14] = int_stack + 76910;
 Libderiv->deriv2_classes[3][6][14] = int_stack + 77120;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 77400;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 77625;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 77940;
 Libderiv->deriv2_classes[2][4][13] = int_stack + 78360;
 Libderiv->deriv2_classes[2][5][13] = int_stack + 78450;
 Libderiv->deriv2_classes[2][6][13] = int_stack + 78576;
 Libderiv->deriv2_classes[3][4][13] = int_stack + 78744;
 Libderiv->deriv2_classes[3][5][13] = int_stack + 78894;
 Libderiv->deriv2_classes[3][6][13] = int_stack + 79104;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 79384;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 79609;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 79924;
 Libderiv->deriv_classes[2][4][11] = int_stack + 80344;
 Libderiv->deriv_classes[2][5][11] = int_stack + 80434;
 Libderiv->deriv_classes[2][6][11] = int_stack + 80560;
 Libderiv->deriv2_classes[2][4][11] = int_stack + 80728;
 Libderiv->deriv2_classes[2][5][11] = int_stack + 80818;
 Libderiv->deriv2_classes[2][6][11] = int_stack + 80944;
 Libderiv->deriv_classes[3][4][11] = int_stack + 81112;
 Libderiv->deriv_classes[3][5][11] = int_stack + 81262;
 Libderiv->deriv_classes[3][6][11] = int_stack + 81472;
 Libderiv->deriv2_classes[3][4][11] = int_stack + 81752;
 Libderiv->deriv2_classes[3][5][11] = int_stack + 81902;
 Libderiv->deriv2_classes[3][6][11] = int_stack + 82112;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 82392;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 82617;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 82932;
 Libderiv->deriv_classes[2][4][10] = int_stack + 83352;
 Libderiv->deriv_classes[2][5][10] = int_stack + 83442;
 Libderiv->deriv_classes[2][6][10] = int_stack + 83568;
 Libderiv->deriv2_classes[2][4][10] = int_stack + 83736;
 Libderiv->deriv2_classes[2][5][10] = int_stack + 83826;
 Libderiv->deriv2_classes[2][6][10] = int_stack + 83952;
 Libderiv->deriv_classes[3][4][10] = int_stack + 84120;
 Libderiv->deriv_classes[3][5][10] = int_stack + 84270;
 Libderiv->deriv_classes[3][6][10] = int_stack + 84480;
 Libderiv->deriv2_classes[3][4][10] = int_stack + 84760;
 Libderiv->deriv2_classes[3][5][10] = int_stack + 84910;
 Libderiv->deriv2_classes[3][6][10] = int_stack + 85120;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 85400;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 85625;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 85940;
 Libderiv->deriv_classes[2][4][9] = int_stack + 86360;
 Libderiv->deriv_classes[2][5][9] = int_stack + 86450;
 Libderiv->deriv_classes[2][6][9] = int_stack + 86576;
 Libderiv->deriv2_classes[2][4][9] = int_stack + 86744;
 Libderiv->deriv2_classes[2][5][9] = int_stack + 86834;
 Libderiv->deriv2_classes[2][6][9] = int_stack + 86960;
 Libderiv->deriv_classes[3][4][9] = int_stack + 87128;
 Libderiv->deriv_classes[3][5][9] = int_stack + 87278;
 Libderiv->deriv_classes[3][6][9] = int_stack + 87488;
 Libderiv->deriv2_classes[3][4][9] = int_stack + 87768;
 Libderiv->deriv2_classes[3][5][9] = int_stack + 87918;
 Libderiv->deriv2_classes[3][6][9] = int_stack + 88128;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 88408;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 88633;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 88948;
 Libderiv->deriv_classes[2][4][8] = int_stack + 89368;
 Libderiv->deriv_classes[2][5][8] = int_stack + 89458;
 Libderiv->deriv_classes[2][6][8] = int_stack + 89584;
 Libderiv->deriv2_classes[2][4][8] = int_stack + 89752;
 Libderiv->deriv2_classes[2][5][8] = int_stack + 89842;
 Libderiv->deriv2_classes[2][6][8] = int_stack + 89968;
 Libderiv->deriv_classes[3][4][8] = int_stack + 90136;
 Libderiv->deriv_classes[3][5][8] = int_stack + 90286;
 Libderiv->deriv_classes[3][6][8] = int_stack + 90496;
 Libderiv->deriv2_classes[3][4][8] = int_stack + 90776;
 Libderiv->deriv2_classes[3][5][8] = int_stack + 90926;
 Libderiv->deriv2_classes[3][6][8] = int_stack + 91136;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 91416;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 91641;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 91956;
 Libderiv->deriv_classes[2][4][7] = int_stack + 92376;
 Libderiv->deriv_classes[2][5][7] = int_stack + 92466;
 Libderiv->deriv_classes[2][6][7] = int_stack + 92592;
 Libderiv->deriv2_classes[2][4][7] = int_stack + 92760;
 Libderiv->deriv2_classes[2][5][7] = int_stack + 92850;
 Libderiv->deriv2_classes[2][6][7] = int_stack + 92976;
 Libderiv->deriv_classes[3][4][7] = int_stack + 93144;
 Libderiv->deriv_classes[3][5][7] = int_stack + 93294;
 Libderiv->deriv_classes[3][6][7] = int_stack + 93504;
 Libderiv->deriv2_classes[3][4][7] = int_stack + 93784;
 Libderiv->deriv2_classes[3][5][7] = int_stack + 93934;
 Libderiv->deriv2_classes[3][6][7] = int_stack + 94144;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 94424;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 94649;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 94964;
 Libderiv->deriv_classes[2][4][6] = int_stack + 95384;
 Libderiv->deriv_classes[2][5][6] = int_stack + 95474;
 Libderiv->deriv_classes[2][6][6] = int_stack + 95600;
 Libderiv->deriv2_classes[2][4][6] = int_stack + 95768;
 Libderiv->deriv2_classes[2][5][6] = int_stack + 95858;
 Libderiv->deriv2_classes[2][6][6] = int_stack + 95984;
 Libderiv->dvrr_classes[3][4] = int_stack + 96152;
 Libderiv->deriv_classes[3][4][6] = int_stack + 96302;
 Libderiv->dvrr_classes[3][5] = int_stack + 96452;
 Libderiv->deriv_classes[3][5][6] = int_stack + 96662;
 Libderiv->deriv_classes[3][6][6] = int_stack + 96872;
 Libderiv->deriv2_classes[3][4][6] = int_stack + 97152;
 Libderiv->deriv2_classes[3][5][6] = int_stack + 97302;
 Libderiv->deriv2_classes[3][6][6] = int_stack + 97512;
 Libderiv->deriv_classes[4][4][0] = int_stack + 97792;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 98017;
 Libderiv->deriv_classes[4][5][0] = int_stack + 98242;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 98557;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 98872;
 Libderiv->deriv_classes[2][4][2] = int_stack + 99292;
 Libderiv->deriv_classes[2][5][2] = int_stack + 99382;
 Libderiv->deriv_classes[2][6][2] = int_stack + 99508;
 Libderiv->deriv2_classes[2][4][2] = int_stack + 99676;
 Libderiv->deriv2_classes[2][5][2] = int_stack + 99766;
 Libderiv->deriv2_classes[2][6][2] = int_stack + 99892;
 Libderiv->deriv_classes[3][4][2] = int_stack + 100060;
 Libderiv->deriv_classes[3][5][2] = int_stack + 100210;
 Libderiv->deriv_classes[3][6][2] = int_stack + 100420;
 Libderiv->deriv2_classes[3][4][2] = int_stack + 100700;
 Libderiv->deriv2_classes[3][5][2] = int_stack + 100850;
 Libderiv->deriv2_classes[3][6][2] = int_stack + 101060;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 101340;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 101565;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 101880;
 Libderiv->deriv_classes[2][4][1] = int_stack + 102300;
 Libderiv->deriv_classes[2][5][1] = int_stack + 102390;
 Libderiv->deriv_classes[2][6][1] = int_stack + 102516;
 Libderiv->deriv2_classes[2][4][1] = int_stack + 102684;
 Libderiv->deriv2_classes[2][5][1] = int_stack + 102774;
 Libderiv->deriv2_classes[2][6][1] = int_stack + 102900;
 Libderiv->deriv_classes[3][4][1] = int_stack + 103068;
 Libderiv->deriv_classes[3][5][1] = int_stack + 103218;
 Libderiv->deriv_classes[3][6][1] = int_stack + 103428;
 Libderiv->deriv2_classes[3][4][1] = int_stack + 103708;
 Libderiv->deriv2_classes[3][5][1] = int_stack + 103858;
 Libderiv->deriv2_classes[3][6][1] = int_stack + 104068;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 104348;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 104573;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 104888;
 Libderiv->dvrr_classes[2][4] = int_stack + 105308;
 Libderiv->dvrr_classes[2][5] = int_stack + 105398;
 Libderiv->dvrr_classes[2][6] = int_stack + 105524;
 Libderiv->deriv_classes[2][4][0] = int_stack + 105692;
 Libderiv->deriv_classes[2][5][0] = int_stack + 105782;
 Libderiv->deriv_classes[2][6][0] = int_stack + 105908;
 Libderiv->deriv2_classes[2][4][0] = int_stack + 106076;
 Libderiv->deriv2_classes[2][5][0] = int_stack + 106166;
 Libderiv->deriv2_classes[2][6][0] = int_stack + 106292;
 Libderiv->deriv_classes[3][4][0] = int_stack + 106460;
 Libderiv->deriv_classes[3][5][0] = int_stack + 106610;
 Libderiv->deriv_classes[3][6][0] = int_stack + 106820;
 Libderiv->deriv2_classes[3][4][0] = int_stack + 107100;
 Libderiv->deriv2_classes[3][5][0] = int_stack + 107250;
 Libderiv->deriv2_classes[3][6][0] = int_stack + 107460;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 107740;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 107965;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 108280;
 memset(int_stack,0,869600);

 Libderiv->dvrr_stack = int_stack + 257668;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_ddgd(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+108700,int_stack+105398,int_stack+105308,6);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+108970,int_stack+80434,int_stack+80344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105308,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+80560,int_stack+80434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105398,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+109618,int_stack+109240,int_stack+108970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+110158,int_stack+96452,int_stack+96152,10);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+110608,int_stack+81262,int_stack+81112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96152,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+81472,int_stack+81262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96452,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+111688,int_stack+111058,int_stack+110608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+112588,int_stack+111688,int_stack+109618,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+114208,int_stack+2100,int_stack+47779,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+114883,int_stack+35609,int_stack+35159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47779,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+115558,int_stack+0,int_stack+35609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2100,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+116503,int_stack+115558,int_stack+114883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+117853,int_stack+116503,int_stack+111688,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+115558,int_stack+83442,int_stack+83352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105308, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+83568,int_stack+83442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105398, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+115828,int_stack+109240,int_stack+115558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116368,int_stack+84270,int_stack+84120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96152, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+84480,int_stack+84270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96452, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+116818,int_stack+111058,int_stack+116368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+120553,int_stack+116818,int_stack+115828,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+122173,int_stack+38133,int_stack+37683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47779, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+122848,int_stack+420,int_stack+38133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2100, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+123793,int_stack+122848,int_stack+122173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+125143,int_stack+123793,int_stack+116818,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+122848,int_stack+86450,int_stack+86360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105308, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+86576,int_stack+86450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105398, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+123118,int_stack+109240,int_stack+122848, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+123658,int_stack+87278,int_stack+87128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96152, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+87488,int_stack+87278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96452, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+124108,int_stack+111058,int_stack+123658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+127843,int_stack+124108,int_stack+123118,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+40657,int_stack+40207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47779, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+129463,int_stack+840,int_stack+40657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2100, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+130408,int_stack+129463,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+131758,int_stack+130408,int_stack+124108,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+129463,int_stack+89458,int_stack+89368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+89584,int_stack+89458, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+129733,int_stack+109240,int_stack+129463, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+130273,int_stack+90286,int_stack+90136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+90496,int_stack+90286, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+130723,int_stack+111058,int_stack+130273, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+134458,int_stack+130723,int_stack+129733,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+136078,int_stack+43181,int_stack+42731, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+47779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136753,int_stack+1260,int_stack+43181, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+137698,int_stack+136753,int_stack+136078, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+139048,int_stack+137698,int_stack+130723,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+136753,int_stack+92466,int_stack+92376, 0.0, zero_stack, 1.0, int_stack+105308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+92592,int_stack+92466, 0.0, zero_stack, 1.0, int_stack+105398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+137023,int_stack+109240,int_stack+136753, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+137563,int_stack+93294,int_stack+93144, 0.0, zero_stack, 1.0, int_stack+96152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+93504,int_stack+93294, 0.0, zero_stack, 1.0, int_stack+96452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+138013,int_stack+111058,int_stack+137563, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+141748,int_stack+138013,int_stack+137023,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+675,int_stack+45705,int_stack+45255, 0.0, zero_stack, 1.0, int_stack+47779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+143368,int_stack+1680,int_stack+45705, 0.0, zero_stack, 1.0, int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+144313,int_stack+143368,int_stack+675, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+145663,int_stack+144313,int_stack+138013,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+95474,int_stack+95384, 1.0, int_stack+105308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+95600,int_stack+95474, 1.0, int_stack+105398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+143638,int_stack+109240,int_stack+143368, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+96662,int_stack+96302, 1.0, int_stack+96152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+96872,int_stack+96662, 1.0, int_stack+96452, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+144628,int_stack+111058,int_stack+144178, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+148363,int_stack+144628,int_stack+143638,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1350,int_stack+48454,int_stack+48004, 1.0, int_stack+47779, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+2415,int_stack+48454, 1.0, int_stack+2100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150928,int_stack+149983,int_stack+1350, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+152278,int_stack+150928,int_stack+144628,90);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+105524,int_stack+105398,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+114208,int_stack+109240,int_stack+108700,6);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+111058,int_stack+3675,int_stack+96452,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+111058,int_stack+110158,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+154978,int_stack+149983,int_stack+114208,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+108700,int_stack+99382,int_stack+99292,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+99508,int_stack+99382,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+111058,int_stack+109240,int_stack+108700,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+110158,int_stack+100210,int_stack+100060,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+150883,int_stack+100420,int_stack+100210,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+156598,int_stack+150883,int_stack+110158,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+157498,int_stack+156598,int_stack+111058, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+150883,int_stack+60898,int_stack+60448,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+159118,int_stack+2835,int_stack+60898,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+160063,int_stack+159118,int_stack+150883,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+161413,int_stack+160063,int_stack+156598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+102390,int_stack+102300,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+102516,int_stack+102390,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+159388,int_stack+109240,int_stack+159118,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+159928,int_stack+103218,int_stack+103068,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+160378,int_stack+103428,int_stack+103218,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2025,int_stack+160378,int_stack+159928,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+164113,int_stack+2025,int_stack+159388, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+160378,int_stack+75326,int_stack+74876,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+165733,int_stack+3255,int_stack+75326,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+166678,int_stack+165733,int_stack+160378,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+168028,int_stack+166678,int_stack+2025, 0.0, zero_stack, 1.0, int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+165733,int_stack+105782,int_stack+105692,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+105908,int_stack+105782,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+166003,int_stack+109240,int_stack+165733,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+166543,int_stack+106610,int_stack+106460,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+166993,int_stack+106820,int_stack+106610,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2925,int_stack+166993,int_stack+166543,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+170728,int_stack+2925,int_stack+166003, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+114208,int_stack+98242,int_stack+97792,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+166993,int_stack+3955,int_stack+98242,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+166993,int_stack+114208,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+173698,int_stack+172348,int_stack+2925, 1.0, int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+4465,int_stack+4375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80344,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+4591,int_stack+4465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+80434,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+108970,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+4909,int_stack+4759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+81112,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172798,int_stack+5119,int_stack+4909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+81262,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+166993,int_stack+172798,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+110608,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+176398,int_stack+166993,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+5624,int_stack+5399, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35159,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+3825,int_stack+5939,int_stack+5624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+35609,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+4770,int_stack+3825,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+114883,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+178018,int_stack+4770,int_stack+166993,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+166993,int_stack+6449,int_stack+6359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80344, 1.0, int_stack+83352,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+6575,int_stack+6449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80434, 1.0, int_stack+83442,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+167263,int_stack+109240,int_stack+166993, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108970, 1.0, int_stack+115558,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+6893,int_stack+6743, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81112, 1.0, int_stack+84120,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172798,int_stack+7103,int_stack+6893, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81262, 1.0, int_stack+84270,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+172798,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110608, 1.0, int_stack+116368,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+3825,int_stack+149983,int_stack+167263,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+7608,int_stack+7383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35159, 1.0, int_stack+37683,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+166993,int_stack+7923,int_stack+7608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35609, 1.0, int_stack+38133,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+5445,int_stack+166993,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114883, 1.0, int_stack+122173,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+180718,int_stack+5445,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+8433,int_stack+8343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+83352, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+8559,int_stack+8433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+83442, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+115558, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5445,int_stack+8877,int_stack+8727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+84120, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5895,int_stack+9087,int_stack+8877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+84270, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+6525,int_stack+5895,int_stack+5445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+116368, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+7425,int_stack+6525,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+5445,int_stack+9592,int_stack+9367, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+37683, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+9907,int_stack+9592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+38133, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+172348,int_stack+5445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+122173, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+184768,int_stack+183418,int_stack+6525,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+10417,int_stack+10327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80344, 0.0, zero_stack, 1.0, int_stack+86360,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+10543,int_stack+10417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80434, 0.0, zero_stack, 1.0, int_stack+86450,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183688,int_stack+109240,int_stack+183418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108970, 0.0, zero_stack, 1.0, int_stack+122848,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+184228,int_stack+10861,int_stack+10711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81112, 0.0, zero_stack, 1.0, int_stack+87128,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+5445,int_stack+11071,int_stack+10861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81262, 0.0, zero_stack, 1.0, int_stack+87278,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+5445,int_stack+184228, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110608, 0.0, zero_stack, 1.0, int_stack+123658,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+5445,int_stack+149983,int_stack+183688,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+11576,int_stack+11351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35159, 0.0, zero_stack, 1.0, int_stack+40207,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+11891,int_stack+11576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35609, 0.0, zero_stack, 1.0, int_stack+40657,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+9045,int_stack+172348,int_stack+183418, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114883, 0.0, zero_stack, 1.0, int_stack+0,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+187468,int_stack+9045,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+12401,int_stack+12311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83352, 1.0, int_stack+86360, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+12527,int_stack+12401, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83442, 1.0, int_stack+86450, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115558, 1.0, int_stack+122848, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9045,int_stack+12845,int_stack+12695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84120, 1.0, int_stack+87128, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9495,int_stack+13055,int_stack+12845, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84270, 1.0, int_stack+87278, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+10125,int_stack+9495,int_stack+9045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116368, 1.0, int_stack+123658, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+11025,int_stack+10125,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+9045,int_stack+13560,int_stack+13335, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37683, 1.0, int_stack+40207, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183418,int_stack+13875,int_stack+13560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38133, 1.0, int_stack+40657, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+183418,int_stack+9045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122173, 1.0, int_stack+0, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+190168,int_stack+172348,int_stack+10125,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+14385,int_stack+14295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+86360, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+14511,int_stack+14385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+86450, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172618,int_stack+109240,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+122848, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+173158,int_stack+14829,int_stack+14679, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+87128, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+9045,int_stack+15039,int_stack+14829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+87278, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+9045,int_stack+173158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+123658, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+9045,int_stack+149983,int_stack+172618,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+15544,int_stack+15319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+40207, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183418,int_stack+15859,int_stack+15544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+40657, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12645,int_stack+183418,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+192868,int_stack+12645,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+16369,int_stack+16279, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80344, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89368,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+16495,int_stack+16369, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+80434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89458,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108970, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129463,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12645,int_stack+16813,int_stack+16663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81112, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90136,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13095,int_stack+17023,int_stack+16813, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81262, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+90286,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+13725,int_stack+13095,int_stack+12645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130273,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+14625,int_stack+13725,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+12645,int_stack+17528,int_stack+17303, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35159, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+42731,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16245,int_stack+17843,int_stack+17528, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+35609, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+43181,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+16245,int_stack+12645, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114883, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136078,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+195568,int_stack+172348,int_stack+13725,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+18353,int_stack+18263, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83352, 0.0, zero_stack, 1.0, int_stack+89368, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+18479,int_stack+18353, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83442, 0.0, zero_stack, 1.0, int_stack+89458, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172618,int_stack+109240,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115558, 0.0, zero_stack, 1.0, int_stack+129463, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+173158,int_stack+18797,int_stack+18647, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84120, 0.0, zero_stack, 1.0, int_stack+90136, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12645,int_stack+19007,int_stack+18797, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+84270, 0.0, zero_stack, 1.0, int_stack+90286, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+12645,int_stack+173158, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116368, 0.0, zero_stack, 1.0, int_stack+130273, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+12645,int_stack+149983,int_stack+172618,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+19512,int_stack+19287, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+37683, 0.0, zero_stack, 1.0, int_stack+42731, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16245,int_stack+19827,int_stack+19512, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+38133, 0.0, zero_stack, 1.0, int_stack+43181, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+16245,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122173, 0.0, zero_stack, 1.0, int_stack+136078, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+16245,int_stack+183418,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+20337,int_stack+20247, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86360, 1.0, int_stack+89368, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+20463,int_stack+20337, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+86450, 1.0, int_stack+89458, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122848, 1.0, int_stack+129463, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+20781,int_stack+20631, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87128, 1.0, int_stack+90136, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183868,int_stack+20991,int_stack+20781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87278, 1.0, int_stack+90286, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+183868,int_stack+183418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123658, 1.0, int_stack+130273, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+18945,int_stack+172348,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+21496,int_stack+21271, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40207, 1.0, int_stack+42731, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+166993,int_stack+21811,int_stack+21496, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+40657, 1.0, int_stack+43181, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+20565,int_stack+166993,int_stack+183418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+136078, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+198268,int_stack+20565,int_stack+172348,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+22321,int_stack+22231, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+89368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+22447,int_stack+22321, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+89458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172618,int_stack+109240,int_stack+172348, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+129463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+173158,int_stack+22765,int_stack+22615, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+90136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+20565,int_stack+22975,int_stack+22765, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+90286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+20565,int_stack+173158, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+130273, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+20565,int_stack+149983,int_stack+172618,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22185,int_stack+23480,int_stack+23255, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+42731, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+23795,int_stack+23480, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+43181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+172348,int_stack+22185, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+136078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+200968,int_stack+183418,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+24305,int_stack+24215, 0.0, zero_stack, 1.0, int_stack+80344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92376,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+24431,int_stack+24305, 0.0, zero_stack, 1.0, int_stack+80434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92466,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 1.0, int_stack+108970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136753,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+24749,int_stack+24599, 0.0, zero_stack, 1.0, int_stack+81112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93144,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183868,int_stack+24959,int_stack+24749, 0.0, zero_stack, 1.0, int_stack+81262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93294,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+183868,int_stack+183418, 0.0, zero_stack, 1.0, int_stack+110608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137563,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+23085,int_stack+22185,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+25464,int_stack+25239, 0.0, zero_stack, 1.0, int_stack+35159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45255,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+25779,int_stack+25464, 0.0, zero_stack, 1.0, int_stack+35609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45705,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+24705,int_stack+172348,int_stack+183418, 0.0, zero_stack, 1.0, int_stack+114883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+203668,int_stack+24705,int_stack+22185,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22185,int_stack+26289,int_stack+26199, 0.0, zero_stack, 1.0, int_stack+83352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92376, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+26415,int_stack+26289, 0.0, zero_stack, 1.0, int_stack+83442, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+92466, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22455,int_stack+109240,int_stack+22185, 0.0, zero_stack, 1.0, int_stack+115558, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136753, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+24705,int_stack+26733,int_stack+26583, 0.0, zero_stack, 1.0, int_stack+84120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93144, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+25155,int_stack+26943,int_stack+26733, 0.0, zero_stack, 1.0, int_stack+84270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93294, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+25155,int_stack+24705, 0.0, zero_stack, 1.0, int_stack+116368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137563, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+24705,int_stack+149983,int_stack+22455,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26325,int_stack+27448,int_stack+27223, 0.0, zero_stack, 1.0, int_stack+37683, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45255, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183418,int_stack+27763,int_stack+27448, 0.0, zero_stack, 1.0, int_stack+38133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+45705, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+183418,int_stack+26325, 0.0, zero_stack, 1.0, int_stack+122173, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+206368,int_stack+172348,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+28273,int_stack+28183, 0.0, zero_stack, 1.0, int_stack+86360, 0.0, zero_stack, 1.0, int_stack+92376, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+28399,int_stack+28273, 0.0, zero_stack, 1.0, int_stack+86450, 0.0, zero_stack, 1.0, int_stack+92466, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 1.0, int_stack+122848, 0.0, zero_stack, 1.0, int_stack+136753, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+28717,int_stack+28567, 0.0, zero_stack, 1.0, int_stack+87128, 0.0, zero_stack, 1.0, int_stack+93144, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172798,int_stack+28927,int_stack+28717, 0.0, zero_stack, 1.0, int_stack+87278, 0.0, zero_stack, 1.0, int_stack+93294, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+172798,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+123658, 0.0, zero_stack, 1.0, int_stack+137563, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+26325,int_stack+22185,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+29432,int_stack+29207, 0.0, zero_stack, 1.0, int_stack+40207, 0.0, zero_stack, 1.0, int_stack+45255, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+27945,int_stack+29747,int_stack+29432, 0.0, zero_stack, 1.0, int_stack+40657, 0.0, zero_stack, 1.0, int_stack+45705, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+27945,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+209068,int_stack+183418,int_stack+22185,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22185,int_stack+30257,int_stack+30167, 0.0, zero_stack, 1.0, int_stack+89368, 1.0, int_stack+92376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+30383,int_stack+30257, 0.0, zero_stack, 1.0, int_stack+89458, 1.0, int_stack+92466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22455,int_stack+109240,int_stack+22185, 0.0, zero_stack, 1.0, int_stack+129463, 1.0, int_stack+136753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+30701,int_stack+30551, 0.0, zero_stack, 1.0, int_stack+90136, 1.0, int_stack+93144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183868,int_stack+30911,int_stack+30701, 0.0, zero_stack, 1.0, int_stack+90286, 1.0, int_stack+93294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+183868,int_stack+183418, 0.0, zero_stack, 1.0, int_stack+130273, 1.0, int_stack+137563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+27945,int_stack+149983,int_stack+22455,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+31416,int_stack+31191, 0.0, zero_stack, 1.0, int_stack+42731, 1.0, int_stack+45255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+31731,int_stack+31416, 0.0, zero_stack, 1.0, int_stack+43181, 1.0, int_stack+45705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+29565,int_stack+172348,int_stack+183418, 0.0, zero_stack, 1.0, int_stack+136078, 1.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+211768,int_stack+29565,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+32241,int_stack+32151, 0.0, zero_stack, 2.0, int_stack+92376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+32367,int_stack+32241, 0.0, zero_stack, 2.0, int_stack+92466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+150253,int_stack+109240,int_stack+149983, 0.0, zero_stack, 2.0, int_stack+136753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+29565,int_stack+32685,int_stack+32535, 0.0, zero_stack, 2.0, int_stack+93144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+30015,int_stack+32895,int_stack+32685, 0.0, zero_stack, 2.0, int_stack+93294, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+30015,int_stack+29565, 0.0, zero_stack, 2.0, int_stack+137563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+29565,int_stack+22185,int_stack+150253,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+31185,int_stack+33400,int_stack+33175, 0.0, zero_stack, 2.0, int_stack+45255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+31860,int_stack+33715,int_stack+33400, 0.0, zero_stack, 2.0, int_stack+45705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+31860,int_stack+31185, 0.0, zero_stack, 2.0, int_stack+675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+31185,int_stack+183418,int_stack+22185,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22185,int_stack+34225,int_stack+34135, 1.0, int_stack+80344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95384,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+109240,int_stack+34351,int_stack+34225, 1.0, int_stack+80434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95474,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22455,int_stack+109240,int_stack+22185, 1.0, int_stack+108970, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143368,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+108970,int_stack+34669,int_stack+34519, 1.0, int_stack+81112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96302,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+183418,int_stack+34879,int_stack+34669, 1.0, int_stack+81262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96662,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+183418,int_stack+108970, 1.0, int_stack+110608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144178,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+214468,int_stack+149983,int_stack+22455,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+35924,int_stack+35384, 1.0, int_stack+35159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48004,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+33885,int_stack+36239,int_stack+35924, 1.0, int_stack+35609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48454,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+33885,int_stack+183418, 1.0, int_stack+114883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+33885,int_stack+172348,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+36749,int_stack+36659, 1.0, int_stack+83352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95384, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+150253,int_stack+36875,int_stack+36749, 1.0, int_stack+83442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95474, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+150253,int_stack+149983, 1.0, int_stack+115558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143368, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+110608,int_stack+37193,int_stack+37043, 1.0, int_stack+84120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96302, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+37403,int_stack+37193, 1.0, int_stack+84270, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96662, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+149983,int_stack+110608, 1.0, int_stack+116368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144178, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+216088,int_stack+22185,int_stack+172348,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+38448,int_stack+37908, 1.0, int_stack+37683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48004, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+114883,int_stack+38763,int_stack+38448, 1.0, int_stack+38133, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48454, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+114883,int_stack+172348, 1.0, int_stack+122173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+217708,int_stack+183418,int_stack+22185,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+22185,int_stack+39273,int_stack+39183, 1.0, int_stack+86360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95384, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22455,int_stack+39399,int_stack+39273, 1.0, int_stack+86450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95474, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+183418,int_stack+22455,int_stack+22185, 1.0, int_stack+122848, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143368, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+116368,int_stack+39717,int_stack+39567, 1.0, int_stack+87128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96302, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+39927,int_stack+39717, 1.0, int_stack+87278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+96662, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+22185,int_stack+116368, 1.0, int_stack+123658, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144178, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+36585,int_stack+149983,int_stack+183418,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+183418,int_stack+40972,int_stack+40432, 1.0, int_stack+40207, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48004, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+122173,int_stack+41287,int_stack+40972, 1.0, int_stack+40657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+48454, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+122173,int_stack+183418, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+38205,int_stack+172348,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+41797,int_stack+41707, 1.0, int_stack+89368, 0.0, zero_stack, 1.0, int_stack+95384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+150253,int_stack+41923,int_stack+41797, 1.0, int_stack+89458, 0.0, zero_stack, 1.0, int_stack+95474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+150253,int_stack+149983, 1.0, int_stack+129463, 0.0, zero_stack, 1.0, int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+123658,int_stack+42241,int_stack+42091, 1.0, int_stack+90136, 0.0, zero_stack, 1.0, int_stack+96302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+42451,int_stack+42241, 1.0, int_stack+90286, 0.0, zero_stack, 1.0, int_stack+96662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+149983,int_stack+123658, 1.0, int_stack+130273, 0.0, zero_stack, 1.0, int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+40905,int_stack+22185,int_stack+172348,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+43496,int_stack+42956, 1.0, int_stack+42731, 0.0, zero_stack, 1.0, int_stack+48004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+122173,int_stack+43811,int_stack+43496, 1.0, int_stack+43181, 0.0, zero_stack, 1.0, int_stack+48454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+122173,int_stack+0, 1.0, int_stack+136078, 0.0, zero_stack, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+220408,int_stack+172348,int_stack+22185,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+129463,int_stack+44321,int_stack+44231, 1.0, int_stack+92376, 1.0, int_stack+95384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+44447,int_stack+44321, 1.0, int_stack+92466, 1.0, int_stack+95474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+129463, 1.0, int_stack+136753, 1.0, int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+130273,int_stack+44765,int_stack+44615, 1.0, int_stack+93144, 1.0, int_stack+96302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+44975,int_stack+44765, 1.0, int_stack+93294, 1.0, int_stack+96662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+22185,int_stack+130273, 1.0, int_stack+137563, 1.0, int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+42525,int_stack+149983,int_stack+172348,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+46020,int_stack+45480, 1.0, int_stack+45255, 1.0, int_stack+48004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+46335,int_stack+46020, 1.0, int_stack+45705, 1.0, int_stack+48454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+0, 1.0, int_stack+675, 1.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+223108,int_stack+172348,int_stack+149983,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+129463,int_stack+46845,int_stack+46755, 2.0, int_stack+95384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+46971,int_stack+46845, 2.0, int_stack+95474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+149983,int_stack+129463, 2.0, int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+137563,int_stack+47289,int_stack+47139, 2.0, int_stack+96302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+47499,int_stack+47289, 2.0, int_stack+96662, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+149983,int_stack+137563, 2.0, int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+44145,int_stack+22185,int_stack+172348,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+48769,int_stack+48229, 2.0, int_stack+48004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+49084,int_stack+48769, 2.0, int_stack+48454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+136078,int_stack+172348, 2.0, int_stack+1350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+45765,int_stack+0,int_stack+22185,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+49594,int_stack+49504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99292,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+49720,int_stack+49594, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99382,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+22185,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+50038,int_stack+49888, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100060,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+50248,int_stack+50038, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100210,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+22185,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+48465,int_stack+149983,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+50753,int_stack+50528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60448,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+51068,int_stack+50753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60898,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+136078,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150883,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+225808,int_stack+675,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+111688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+51578,int_stack+51488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99292, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+51704,int_stack+51578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99382, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+149983,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+52022,int_stack+51872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100060, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+52232,int_stack+52022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100210, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+149983,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+50085,int_stack+22185,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+115828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+52737,int_stack+52512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60448, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+53052,int_stack+52737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60898, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+136078,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150883, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+228508,int_stack+675,int_stack+22185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+116818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+53562,int_stack+53472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99292, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+53688,int_stack+53562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99382, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+22185,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+54006,int_stack+53856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100060, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+54216,int_stack+54006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100210, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+22185,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+51705,int_stack+149983,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+54721,int_stack+54496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60448, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+55036,int_stack+54721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60898, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+136078,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150883, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+231208,int_stack+675,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+55546,int_stack+55456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+55672,int_stack+55546, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+99382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+149983,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+55990,int_stack+55840, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+56200,int_stack+55990, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+149983,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+53325,int_stack+22185,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+56705,int_stack+56480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+57020,int_stack+56705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+60898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+136078,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+233908,int_stack+675,int_stack+22185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+57530,int_stack+57440, 0.0, zero_stack, 1.0, int_stack+99292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+57656,int_stack+57530, 0.0, zero_stack, 1.0, int_stack+99382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+22185,int_stack+143368, 0.0, zero_stack, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+57974,int_stack+57824, 0.0, zero_stack, 1.0, int_stack+100060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+58184,int_stack+57974, 0.0, zero_stack, 1.0, int_stack+100210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+22185,int_stack+144178, 0.0, zero_stack, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+54945,int_stack+149983,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+137023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+58689,int_stack+58464, 0.0, zero_stack, 1.0, int_stack+60448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+59004,int_stack+58689, 0.0, zero_stack, 1.0, int_stack+60898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+136078,int_stack+0, 0.0, zero_stack, 1.0, int_stack+150883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+56565,int_stack+675,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+59514,int_stack+59424, 1.0, int_stack+99292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+59640,int_stack+59514, 1.0, int_stack+99382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+149983,int_stack+143368, 1.0, int_stack+108700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+59958,int_stack+59808, 1.0, int_stack+100060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+108700,int_stack+60168,int_stack+59958, 1.0, int_stack+100210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+149983,int_stack+108700,int_stack+144178, 1.0, int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+236608,int_stack+149983,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+61213,int_stack+60673, 1.0, int_stack+60448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+61528,int_stack+61213, 1.0, int_stack+60898, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+675,int_stack+136078,int_stack+0, 1.0, int_stack+150883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+238228,int_stack+675,int_stack+149983, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+62038,int_stack+61948,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+149983,int_stack+62164,int_stack+62038,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+150361,int_stack+149983,int_stack+143368,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+62482,int_stack+62332,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+150901,int_stack+62692,int_stack+62482,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+110158,int_stack+150901,int_stack+144178,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+0,int_stack+110158,int_stack+150361, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+111058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+149983,int_stack+63197,int_stack+62972,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+63512,int_stack+63197,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+149983,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+59265,int_stack+172348,int_stack+110158, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+156598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+64022,int_stack+63932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102300,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+64148,int_stack+64022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102390,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+110158,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159118,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+64466,int_stack+64316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103068,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+64676,int_stack+64466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103218,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+110158,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159928,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+149983,int_stack+22185,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+109618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+65181,int_stack+64956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74876,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+65496,int_stack+65181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75326,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160378,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+61965,int_stack+172348,int_stack+22185, 0.0, zero_stack, 1.0, int_stack+111688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+66006,int_stack+65916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102300, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+66132,int_stack+66006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102390, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159118, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+66450,int_stack+66300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103068, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+66660,int_stack+66450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103218, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+110158,int_stack+22185,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159928, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+64665,int_stack+110158,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+115828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+67165,int_stack+66940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74876, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+67480,int_stack+67165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75326, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160378, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+240928,int_stack+172348,int_stack+110158, 0.0, zero_stack, 1.0, int_stack+116818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+67990,int_stack+67900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102300, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+68116,int_stack+67990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102390, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+110158,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159118, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+68434,int_stack+68284, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103068, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+68644,int_stack+68434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103218, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+110158,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159928, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+66285,int_stack+22185,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+123118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+69149,int_stack+68924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74876, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+69464,int_stack+69149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75326, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160378, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+243628,int_stack+172348,int_stack+22185, 0.0, zero_stack, 1.0, int_stack+124108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+69974,int_stack+69884, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+70100,int_stack+69974, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+102390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+143368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+70418,int_stack+70268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+70628,int_stack+70418, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+110158,int_stack+22185,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+159928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+67905,int_stack+110158,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+129733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+71133,int_stack+70908, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+74876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+71448,int_stack+71133, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+160378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+246328,int_stack+172348,int_stack+110158, 0.0, zero_stack, 1.0, int_stack+130723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+71958,int_stack+71868, 0.0, zero_stack, 1.0, int_stack+102300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+72084,int_stack+71958, 0.0, zero_stack, 1.0, int_stack+102390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+110158,int_stack+143368, 0.0, zero_stack, 1.0, int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+72402,int_stack+72252, 0.0, zero_stack, 1.0, int_stack+103068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+72612,int_stack+72402, 0.0, zero_stack, 1.0, int_stack+103218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+110158,int_stack+144178, 0.0, zero_stack, 1.0, int_stack+159928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+69525,int_stack+22185,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+137023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+73117,int_stack+72892, 0.0, zero_stack, 1.0, int_stack+74876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+73432,int_stack+73117, 0.0, zero_stack, 1.0, int_stack+75326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 1.0, int_stack+160378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+71145,int_stack+172348,int_stack+22185, 0.0, zero_stack, 1.0, int_stack+138013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+143368,int_stack+73942,int_stack+73852, 1.0, int_stack+102300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+74068,int_stack+73942, 1.0, int_stack+102390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+143368, 1.0, int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+74386,int_stack+74236, 1.0, int_stack+103068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+74596,int_stack+74386, 1.0, int_stack+103218, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+110158,int_stack+22185,int_stack+144178, 1.0, int_stack+159928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+249028,int_stack+110158,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+143638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+75641,int_stack+75101, 1.0, int_stack+74876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+75956,int_stack+75641, 1.0, int_stack+75326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 1.0, int_stack+160378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+250648,int_stack+172348,int_stack+110158, 0.0, zero_stack, 1.0, int_stack+144628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+76466,int_stack+76376,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+76592,int_stack+76466,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+110158,int_stack+159118,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+76910,int_stack+76760,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+77120,int_stack+76910,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+110158,int_stack+144178,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+73845,int_stack+22185,int_stack+172348, 0.0, zero_stack, 1.0, int_stack+111058, 1.0, int_stack+159388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+77625,int_stack+77400,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+77940,int_stack+77625,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+75465,int_stack+172348,int_stack+22185, 0.0, zero_stack, 1.0, int_stack+156598, 1.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+78450,int_stack+78360,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+78576,int_stack+78450,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+159118,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+78894,int_stack+78744,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+79104,int_stack+78894,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+110158,int_stack+22185,int_stack+144178,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+253348,int_stack+110158,int_stack+172348, 0.0, zero_stack, 2.0, int_stack+159388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+79609,int_stack+79384,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+79924,int_stack+79609,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+254968,int_stack+172348,int_stack+110158, 0.0, zero_stack, 2.0, int_stack+2025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+80818,int_stack+80728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105692,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+80944,int_stack+80818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105782,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+110158,int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165733,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+81902,int_stack+81752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106460,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+110158,int_stack+82112,int_stack+81902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106610,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+110158,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166543,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+78165,int_stack+22185,int_stack+172348, 1.0, int_stack+109618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+82617,int_stack+82392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97792,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+82932,int_stack+82617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98242,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+79785,int_stack+172348,int_stack+22185, 1.0, int_stack+111688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+83826,int_stack+83736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105692, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+83952,int_stack+83826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105782, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165733, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+84910,int_stack+84760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106460, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+85120,int_stack+84910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106610, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+136078,int_stack+22185,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166543, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+108700,int_stack+136078,int_stack+172348, 1.0, int_stack+115828, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+85625,int_stack+85400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97792, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+122173,int_stack+85940,int_stack+85625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98242, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+122173,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+82485,int_stack+172348,int_stack+136078, 1.0, int_stack+116818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+86834,int_stack+86744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105692, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+86960,int_stack+86834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105782, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+136456,int_stack+136078,int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165733, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+87918,int_stack+87768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106460, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+88128,int_stack+87918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106610, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+172348,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166543, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+114883,int_stack+22185,int_stack+136456, 1.0, int_stack+123118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+88633,int_stack+88408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97792, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+88948,int_stack+88633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98242, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+136078,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+85185,int_stack+172348,int_stack+22185, 1.0, int_stack+124108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+89842,int_stack+89752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+89968,int_stack+89842, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+105782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+159118, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+165733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+90926,int_stack+90776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+91136,int_stack+90926, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+136078,int_stack+22185,int_stack+144178, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+122173,int_stack+136078,int_stack+172348, 1.0, int_stack+129733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+91641,int_stack+91416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+97792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+91956,int_stack+91641, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+98242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+123793,int_stack+172348,int_stack+151603, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+87885,int_stack+123793,int_stack+136078, 1.0, int_stack+130723, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+92850,int_stack+92760, 0.0, zero_stack, 1.0, int_stack+105692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+136078,int_stack+92976,int_stack+92850, 0.0, zero_stack, 1.0, int_stack+105782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+136456,int_stack+136078,int_stack+159118, 0.0, zero_stack, 1.0, int_stack+165733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+93934,int_stack+93784, 0.0, zero_stack, 1.0, int_stack+106460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+123793,int_stack+94144,int_stack+93934, 0.0, zero_stack, 1.0, int_stack+106610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+123793,int_stack+144178, 0.0, zero_stack, 1.0, int_stack+166543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+129463,int_stack+22185,int_stack+136456, 1.0, int_stack+137023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+94649,int_stack+94424, 0.0, zero_stack, 1.0, int_stack+97792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+123793,int_stack+94964,int_stack+94649, 0.0, zero_stack, 1.0, int_stack+98242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+123793,int_stack+151603, 0.0, zero_stack, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+90585,int_stack+172348,int_stack+22185, 1.0, int_stack+138013, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+159118,int_stack+95858,int_stack+95768, 1.0, int_stack+105692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+95984,int_stack+95858, 1.0, int_stack+105782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+22185,int_stack+159118, 1.0, int_stack+165733, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+144178,int_stack+97302,int_stack+97152, 1.0, int_stack+106460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22185,int_stack+97512,int_stack+97302, 1.0, int_stack+106610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+123793,int_stack+22185,int_stack+144178, 1.0, int_stack+166543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+136078,int_stack+123793,int_stack+172348, 1.0, int_stack+143638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+151603,int_stack+98557,int_stack+98017, 1.0, int_stack+97792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+98872,int_stack+98557, 1.0, int_stack+98242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+137698,int_stack+172348,int_stack+151603, 1.0, int_stack+114208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+93285,int_stack+137698,int_stack+123793, 1.0, int_stack+144628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+165733,int_stack+99766,int_stack+99676,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+123793,int_stack+99892,int_stack+99766,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+124171,int_stack+123793,int_stack+165733,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+137698,int_stack+100850,int_stack+100700,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+138148,int_stack+101060,int_stack+100850,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+138148,int_stack+137698,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+143368,int_stack+22185,int_stack+124171, 1.0, int_stack+111058, 0.0, zero_stack, 1.0, int_stack+166003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+114208,int_stack+101565,int_stack+101340,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+137698,int_stack+101880,int_stack+101565,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+123793,int_stack+137698,int_stack+114208,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+95985,int_stack+123793,int_stack+22185, 1.0, int_stack+156598, 0.0, zero_stack, 1.0, int_stack+2925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+165733,int_stack+102774,int_stack+102684,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+156598,int_stack+102900,int_stack+102774,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+156598,int_stack+165733,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+156598,int_stack+103858,int_stack+103708,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+123793,int_stack+104068,int_stack+103858,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+137698,int_stack+123793,int_stack+156598,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+110320,int_stack+137698,int_stack+22185, 1.0, int_stack+159388, 1.0, int_stack+166003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+114208,int_stack+104573,int_stack+104348,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+123793,int_stack+104888,int_stack+104573,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+172348,int_stack+123793,int_stack+114208,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+98685,int_stack+172348,int_stack+137698, 1.0, int_stack+2025, 1.0, int_stack+2925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (d0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+165733,int_stack+106166,int_stack+106076,6);
 /*--- compute (d0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+137698,int_stack+106292,int_stack+106166,6);
 /*--- compute (d0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+138076,int_stack+137698,int_stack+165733,6);
 /*--- compute (f0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+172348,int_stack+107250,int_stack+107100,10);
 /*--- compute (f0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+172798,int_stack+107460,int_stack+107250,10);
 /*--- compute (f0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+22185,int_stack+172798,int_stack+172348,10);
 /*--- compute (dp|gd) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+159118,int_stack+22185,int_stack+138076, 2.0, int_stack+166003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+114208,int_stack+107965,int_stack+107740,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+172348,int_stack+108280,int_stack+107965,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+137698,int_stack+172348,int_stack+114208,15);
 /*--- compute (fp|gd) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+101385,int_stack+137698,int_stack+22185, 2.0, int_stack+2925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+104085,int_stack+117853,int_stack+112588,90);
     Libderiv->ABCD[11] = int_stack + 104085;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+116503,int_stack+125143,int_stack+120553,90);
     Libderiv->ABCD[10] = int_stack + 116503;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+123793,int_stack+131758,int_stack+127843,90);
     Libderiv->ABCD[9] = int_stack + 123793;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+131083,int_stack+139048,int_stack+134458,90);
     Libderiv->ABCD[8] = int_stack + 131083;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+137698,int_stack+145663,int_stack+141748,90);
     Libderiv->ABCD[7] = int_stack + 137698;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+144988,int_stack+152278,int_stack+148363,90);
     Libderiv->ABCD[6] = int_stack + 144988;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+151603,int_stack+161413,int_stack+157498, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+154978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[2] = int_stack + 151603;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+160738,int_stack+168028,int_stack+164113, 0.0, zero_stack, 1.0, int_stack+154978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[1] = int_stack + 160738;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+165733,int_stack+173698,int_stack+170728, 1.0, int_stack+154978, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[0] = int_stack + 165733;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+172348,int_stack+178018,int_stack+176398,90);
     Libderiv->ABCD[155] = int_stack + 172348;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+175588,int_stack+180718,int_stack+3825,90);
     Libderiv->ABCD[143] = int_stack + 175588;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+178828,int_stack+184768,int_stack+7425,90);
     Libderiv->ABCD[142] = int_stack + 178828;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+182068,int_stack+187468,int_stack+5445,90);
     Libderiv->ABCD[131] = int_stack + 182068;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+185308,int_stack+190168,int_stack+11025,90);
     Libderiv->ABCD[130] = int_stack + 185308;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+188548,int_stack+192868,int_stack+9045,90);
     Libderiv->ABCD[129] = int_stack + 188548;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+191788,int_stack+195568,int_stack+14625,90);
     Libderiv->ABCD[119] = int_stack + 191788;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+195028,int_stack+16245,int_stack+12645,90);
     Libderiv->ABCD[118] = int_stack + 195028;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+1620,int_stack+198268,int_stack+18945,90);
     Libderiv->ABCD[117] = int_stack + 1620;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+4860,int_stack+200968,int_stack+20565,90);
     Libderiv->ABCD[116] = int_stack + 4860;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+198268,int_stack+203668,int_stack+23085,90);
     Libderiv->ABCD[107] = int_stack + 198268;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+201508,int_stack+206368,int_stack+24705,90);
     Libderiv->ABCD[106] = int_stack + 201508;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+204748,int_stack+209068,int_stack+26325,90);
     Libderiv->ABCD[105] = int_stack + 204748;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+207988,int_stack+211768,int_stack+27945,90);
     Libderiv->ABCD[104] = int_stack + 207988;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+211228,int_stack+31185,int_stack+29565,90);
     Libderiv->ABCD[103] = int_stack + 211228;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+8100,int_stack+33885,int_stack+214468,90);
     Libderiv->ABCD[95] = int_stack + 8100;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+11340,int_stack+217708,int_stack+216088,90);
     Libderiv->ABCD[94] = int_stack + 11340;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+214468,int_stack+38205,int_stack+36585,90);
     Libderiv->ABCD[93] = int_stack + 214468;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+14580,int_stack+220408,int_stack+40905,90);
     Libderiv->ABCD[92] = int_stack + 14580;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+217708,int_stack+223108,int_stack+42525,90);
     Libderiv->ABCD[91] = int_stack + 217708;
 /*--- compute (dd|gd) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+220948,int_stack+45765,int_stack+44145,90);
     Libderiv->ABCD[90] = int_stack + 220948;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+17820,int_stack+225808,int_stack+48465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[47] = int_stack + 17820;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+224188,int_stack+228508,int_stack+50085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+120553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[46] = int_stack + 224188;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+227428,int_stack+231208,int_stack+51705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+127843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[45] = int_stack + 227428;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+230668,int_stack+233908,int_stack+53325, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+134458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[44] = int_stack + 230668;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+21060,int_stack+56565,int_stack+54945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[43] = int_stack + 21060;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+24300,int_stack+238228,int_stack+236608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[42] = int_stack + 24300;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+233908,int_stack+59265,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+157498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[38] = int_stack + 233908;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+237148,int_stack+61965,int_stack+149983, 0.0, zero_stack, 1.0, int_stack+112588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[35] = int_stack + 237148;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+27540,int_stack+240928,int_stack+64665, 0.0, zero_stack, 1.0, int_stack+120553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[34] = int_stack + 27540;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+240388,int_stack+243628,int_stack+66285, 0.0, zero_stack, 1.0, int_stack+127843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[33] = int_stack + 240388;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+30780,int_stack+246328,int_stack+67905, 0.0, zero_stack, 1.0, int_stack+134458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[32] = int_stack + 30780;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+243628,int_stack+71145,int_stack+69525, 0.0, zero_stack, 1.0, int_stack+141748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[31] = int_stack + 243628;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+34020,int_stack+250648,int_stack+249028, 0.0, zero_stack, 1.0, int_stack+148363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[30] = int_stack + 34020;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+246868,int_stack+75465,int_stack+73845, 0.0, zero_stack, 1.0, int_stack+157498, 1.0, int_stack+164113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[26] = int_stack + 246868;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+250108,int_stack+254968,int_stack+253348, 0.0, zero_stack, 2.0, int_stack+164113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[25] = int_stack + 250108;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+253348,int_stack+79785,int_stack+78165, 1.0, int_stack+112588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[23] = int_stack + 253348;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+37260,int_stack+82485,int_stack+108700, 1.0, int_stack+120553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[22] = int_stack + 37260;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+40500,int_stack+85185,int_stack+114883, 1.0, int_stack+127843, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[21] = int_stack + 40500;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+43740,int_stack+87885,int_stack+122173, 1.0, int_stack+134458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[20] = int_stack + 43740;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+46980,int_stack+90585,int_stack+129463, 1.0, int_stack+141748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[19] = int_stack + 46980;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+127033,int_stack+93285,int_stack+136078, 1.0, int_stack+148363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[18] = int_stack + 127033;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+148228,int_stack+95985,int_stack+143368, 1.0, int_stack+157498, 0.0, zero_stack, 1.0, int_stack+170728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[14] = int_stack + 148228;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+140938,int_stack+98685,int_stack+110320, 1.0, int_stack+164113, 1.0, int_stack+170728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[13] = int_stack + 140938;
 /*--- compute (dd|gd) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+154843,int_stack+101385,int_stack+159118, 2.0, int_stack+170728, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,90);
     Libderiv->ABCD[12] = int_stack + 154843;

}
