/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_gdff(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gd|ff) integrals */

void d12hrr_order_gdff(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][6][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][10] = int_stack + 784;
 Libderiv->deriv_classes[6][6][9] = int_stack + 1568;
 Libderiv->deriv_classes[6][6][8] = int_stack + 2352;
 Libderiv->deriv_classes[6][6][7] = int_stack + 3136;
 Libderiv->dvrr_classes[6][5] = int_stack + 3920;
 Libderiv->deriv_classes[6][6][6] = int_stack + 4508;
 Libderiv->deriv_classes[6][6][2] = int_stack + 5292;
 Libderiv->deriv_classes[6][6][1] = int_stack + 6076;
 Libderiv->dvrr_classes[5][6] = int_stack + 6860;
 Libderiv->deriv_classes[6][6][0] = int_stack + 7448;
 Libderiv->deriv2_classes[4][3][143] = int_stack + 8232;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 8382;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 8607;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 8922;
 Libderiv->deriv2_classes[5][3][143] = int_stack + 9342;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 9552;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 9867;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 10308;
 Libderiv->deriv2_classes[6][3][143] = int_stack + 10896;
 Libderiv->deriv2_classes[6][4][143] = int_stack + 11176;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 11596;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 12184;
 Libderiv->deriv2_classes[4][3][131] = int_stack + 12968;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 13118;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 13343;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 13658;
 Libderiv->deriv2_classes[5][3][131] = int_stack + 14078;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 14288;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 14603;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 15044;
 Libderiv->deriv2_classes[6][3][131] = int_stack + 15632;
 Libderiv->deriv2_classes[6][4][131] = int_stack + 15912;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 16332;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 16920;
 Libderiv->deriv2_classes[4][3][130] = int_stack + 17704;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 17854;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 18079;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 18394;
 Libderiv->deriv2_classes[5][3][130] = int_stack + 18814;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 19024;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 19339;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 19780;
 Libderiv->deriv2_classes[6][3][130] = int_stack + 20368;
 Libderiv->deriv2_classes[6][4][130] = int_stack + 20648;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 21068;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 21656;
 Libderiv->deriv2_classes[4][3][119] = int_stack + 22440;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 22590;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 22815;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 23130;
 Libderiv->deriv2_classes[5][3][119] = int_stack + 23550;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 23760;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 24075;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 24516;
 Libderiv->deriv2_classes[6][3][119] = int_stack + 25104;
 Libderiv->deriv2_classes[6][4][119] = int_stack + 25384;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 25804;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 26392;
 Libderiv->deriv2_classes[4][3][118] = int_stack + 27176;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 27326;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 27551;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 27866;
 Libderiv->deriv2_classes[5][3][118] = int_stack + 28286;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 28496;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 28811;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 29252;
 Libderiv->deriv2_classes[6][3][118] = int_stack + 29840;
 Libderiv->deriv2_classes[6][4][118] = int_stack + 30120;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 30540;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 31128;
 Libderiv->deriv2_classes[4][3][117] = int_stack + 31912;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 32062;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 32287;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 32602;
 Libderiv->deriv2_classes[5][3][117] = int_stack + 33022;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 33232;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 33547;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 33988;
 Libderiv->deriv2_classes[6][3][117] = int_stack + 34576;
 Libderiv->deriv2_classes[6][4][117] = int_stack + 34856;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 35276;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 35864;
 Libderiv->deriv2_classes[4][3][107] = int_stack + 36648;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 36798;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 37023;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 37338;
 Libderiv->deriv2_classes[5][3][107] = int_stack + 37758;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 37968;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 38283;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 38724;
 Libderiv->deriv2_classes[6][3][107] = int_stack + 39312;
 Libderiv->deriv2_classes[6][4][107] = int_stack + 39592;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 40012;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 40600;
 Libderiv->deriv2_classes[4][3][106] = int_stack + 41384;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 41534;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 41759;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 42074;
 Libderiv->deriv2_classes[5][3][106] = int_stack + 42494;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 42704;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 43019;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 43460;
 Libderiv->deriv2_classes[6][3][106] = int_stack + 44048;
 Libderiv->deriv2_classes[6][4][106] = int_stack + 44328;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 44748;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 45336;
 Libderiv->deriv2_classes[4][3][105] = int_stack + 46120;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 46270;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 46495;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 46810;
 Libderiv->deriv2_classes[5][3][105] = int_stack + 47230;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 47440;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 47755;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 48196;
 Libderiv->deriv2_classes[6][3][105] = int_stack + 48784;
 Libderiv->deriv2_classes[6][4][105] = int_stack + 49064;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 49484;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 50072;
 Libderiv->deriv2_classes[4][3][104] = int_stack + 50856;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 51006;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 51231;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 51546;
 Libderiv->deriv2_classes[5][3][104] = int_stack + 51966;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 52176;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 52491;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 52932;
 Libderiv->deriv2_classes[6][3][104] = int_stack + 53520;
 Libderiv->deriv2_classes[6][4][104] = int_stack + 53800;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 54220;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 54808;
 Libderiv->deriv2_classes[4][3][95] = int_stack + 55592;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 55742;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 55967;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 56282;
 Libderiv->deriv2_classes[5][3][95] = int_stack + 56702;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 56912;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 57227;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 57668;
 Libderiv->deriv2_classes[6][3][95] = int_stack + 58256;
 Libderiv->deriv2_classes[6][4][95] = int_stack + 58536;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 58956;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 59544;
 Libderiv->deriv2_classes[4][3][94] = int_stack + 60328;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 60478;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 60703;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 61018;
 Libderiv->deriv2_classes[5][3][94] = int_stack + 61438;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 61648;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 61963;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 62404;
 Libderiv->deriv2_classes[6][3][94] = int_stack + 62992;
 Libderiv->deriv2_classes[6][4][94] = int_stack + 63272;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 63692;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 64280;
 Libderiv->deriv2_classes[4][3][93] = int_stack + 65064;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 65214;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 65439;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 65754;
 Libderiv->deriv2_classes[5][3][93] = int_stack + 66174;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 66384;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 66699;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 67140;
 Libderiv->deriv2_classes[6][3][93] = int_stack + 67728;
 Libderiv->deriv2_classes[6][4][93] = int_stack + 68008;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 68428;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 69016;
 Libderiv->deriv2_classes[4][3][92] = int_stack + 69800;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 69950;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 70175;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 70490;
 Libderiv->deriv2_classes[5][3][92] = int_stack + 70910;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 71120;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 71435;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 71876;
 Libderiv->deriv2_classes[6][3][92] = int_stack + 72464;
 Libderiv->deriv2_classes[6][4][92] = int_stack + 72744;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 73164;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 73752;
 Libderiv->deriv2_classes[4][3][91] = int_stack + 74536;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 74686;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 74911;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 75226;
 Libderiv->deriv2_classes[5][3][91] = int_stack + 75646;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 75856;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 76171;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 76612;
 Libderiv->deriv2_classes[6][3][91] = int_stack + 77200;
 Libderiv->deriv2_classes[6][4][91] = int_stack + 77480;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 77900;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 78488;
 Libderiv->deriv2_classes[4][3][83] = int_stack + 79272;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 79422;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 79647;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 79962;
 Libderiv->deriv2_classes[5][3][83] = int_stack + 80382;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 80592;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 80907;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 81348;
 Libderiv->deriv_classes[6][3][11] = int_stack + 81936;
 Libderiv->deriv2_classes[6][3][83] = int_stack + 82216;
 Libderiv->deriv_classes[6][4][11] = int_stack + 82496;
 Libderiv->deriv2_classes[6][4][83] = int_stack + 82916;
 Libderiv->deriv_classes[6][5][11] = int_stack + 83336;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 83924;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 84512;
 Libderiv->deriv2_classes[4][3][82] = int_stack + 85296;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 85446;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 85671;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 85986;
 Libderiv->deriv2_classes[5][3][82] = int_stack + 86406;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 86616;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 86931;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 87372;
 Libderiv->deriv_classes[6][3][10] = int_stack + 87960;
 Libderiv->deriv2_classes[6][3][82] = int_stack + 88240;
 Libderiv->deriv_classes[6][4][10] = int_stack + 88520;
 Libderiv->deriv2_classes[6][4][82] = int_stack + 88940;
 Libderiv->deriv_classes[6][5][10] = int_stack + 89360;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 89948;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 90536;
 Libderiv->deriv2_classes[4][3][81] = int_stack + 91320;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 91470;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 91695;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 92010;
 Libderiv->deriv2_classes[5][3][81] = int_stack + 92430;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 92640;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 92955;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 93396;
 Libderiv->deriv_classes[6][3][9] = int_stack + 93984;
 Libderiv->deriv2_classes[6][3][81] = int_stack + 94264;
 Libderiv->deriv_classes[6][4][9] = int_stack + 94544;
 Libderiv->deriv2_classes[6][4][81] = int_stack + 94964;
 Libderiv->deriv_classes[6][5][9] = int_stack + 95384;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 95972;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 96560;
 Libderiv->deriv2_classes[4][3][80] = int_stack + 97344;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 97494;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 97719;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 98034;
 Libderiv->deriv2_classes[5][3][80] = int_stack + 98454;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 98664;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 98979;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 99420;
 Libderiv->deriv_classes[6][3][8] = int_stack + 100008;
 Libderiv->deriv2_classes[6][3][80] = int_stack + 100288;
 Libderiv->deriv_classes[6][4][8] = int_stack + 100568;
 Libderiv->deriv2_classes[6][4][80] = int_stack + 100988;
 Libderiv->deriv_classes[6][5][8] = int_stack + 101408;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 101996;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 102584;
 Libderiv->deriv2_classes[4][3][79] = int_stack + 103368;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 103518;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 103743;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 104058;
 Libderiv->deriv2_classes[5][3][79] = int_stack + 104478;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 104688;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 105003;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 105444;
 Libderiv->deriv_classes[6][3][7] = int_stack + 106032;
 Libderiv->deriv2_classes[6][3][79] = int_stack + 106312;
 Libderiv->deriv_classes[6][4][7] = int_stack + 106592;
 Libderiv->deriv2_classes[6][4][79] = int_stack + 107012;
 Libderiv->deriv_classes[6][5][7] = int_stack + 107432;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 108020;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 108608;
 Libderiv->deriv2_classes[4][3][78] = int_stack + 109392;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 109542;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 109767;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 110082;
 Libderiv->deriv2_classes[5][3][78] = int_stack + 110502;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 110712;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 111027;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 111468;
 Libderiv->dvrr_classes[6][3] = int_stack + 112056;
 Libderiv->deriv_classes[6][3][6] = int_stack + 112336;
 Libderiv->deriv2_classes[6][3][78] = int_stack + 112616;
 Libderiv->dvrr_classes[6][4] = int_stack + 112896;
 Libderiv->deriv_classes[6][4][6] = int_stack + 113316;
 Libderiv->deriv2_classes[6][4][78] = int_stack + 113736;
 Libderiv->deriv_classes[6][5][6] = int_stack + 114156;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 114744;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 115332;
 Libderiv->deriv2_classes[4][3][35] = int_stack + 116116;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 116266;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 116491;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 116806;
 Libderiv->deriv2_classes[5][3][35] = int_stack + 117226;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 117436;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 117751;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 118192;
 Libderiv->deriv2_classes[6][3][35] = int_stack + 118780;
 Libderiv->deriv2_classes[6][4][35] = int_stack + 119060;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 119480;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 120068;
 Libderiv->deriv2_classes[4][3][34] = int_stack + 120852;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 121002;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 121227;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 121542;
 Libderiv->deriv2_classes[5][3][34] = int_stack + 121962;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 122172;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 122487;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 122928;
 Libderiv->deriv2_classes[6][3][34] = int_stack + 123516;
 Libderiv->deriv2_classes[6][4][34] = int_stack + 123796;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 124216;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 124804;
 Libderiv->deriv2_classes[4][3][33] = int_stack + 125588;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 125738;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 125963;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 126278;
 Libderiv->deriv2_classes[5][3][33] = int_stack + 126698;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 126908;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 127223;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 127664;
 Libderiv->deriv2_classes[6][3][33] = int_stack + 128252;
 Libderiv->deriv2_classes[6][4][33] = int_stack + 128532;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 128952;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 129540;
 Libderiv->deriv2_classes[4][3][32] = int_stack + 130324;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 130474;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 130699;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 131014;
 Libderiv->deriv2_classes[5][3][32] = int_stack + 131434;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 131644;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 131959;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 132400;
 Libderiv->deriv2_classes[6][3][32] = int_stack + 132988;
 Libderiv->deriv2_classes[6][4][32] = int_stack + 133268;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 133688;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 134276;
 Libderiv->deriv2_classes[4][3][31] = int_stack + 135060;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 135210;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 135435;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 135750;
 Libderiv->deriv2_classes[5][3][31] = int_stack + 136170;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 136380;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 136695;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 137136;
 Libderiv->deriv2_classes[6][3][31] = int_stack + 137724;
 Libderiv->deriv2_classes[6][4][31] = int_stack + 138004;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 138424;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 139012;
 Libderiv->deriv2_classes[4][3][30] = int_stack + 139796;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 139946;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 140171;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 140486;
 Libderiv->deriv2_classes[5][3][30] = int_stack + 140906;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 141116;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 141431;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 141872;
 Libderiv->deriv_classes[6][3][2] = int_stack + 142460;
 Libderiv->deriv2_classes[6][3][30] = int_stack + 142740;
 Libderiv->deriv_classes[6][4][2] = int_stack + 143020;
 Libderiv->deriv2_classes[6][4][30] = int_stack + 143440;
 Libderiv->deriv_classes[6][5][2] = int_stack + 143860;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 144448;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 145036;
 Libderiv->deriv2_classes[4][3][26] = int_stack + 145820;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 145970;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 146195;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 146510;
 Libderiv->deriv2_classes[5][3][26] = int_stack + 146930;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 147140;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 147455;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 147896;
 Libderiv->deriv2_classes[6][3][26] = int_stack + 148484;
 Libderiv->deriv2_classes[6][4][26] = int_stack + 148764;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 149184;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 149772;
 Libderiv->deriv2_classes[4][3][23] = int_stack + 150556;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 150706;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 150931;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 151246;
 Libderiv->deriv2_classes[5][3][23] = int_stack + 151666;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 151876;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 152191;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 152632;
 Libderiv->deriv2_classes[6][3][23] = int_stack + 153220;
 Libderiv->deriv2_classes[6][4][23] = int_stack + 153500;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 153920;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 154508;
 Libderiv->deriv2_classes[4][3][22] = int_stack + 155292;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 155442;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 155667;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 155982;
 Libderiv->deriv2_classes[5][3][22] = int_stack + 156402;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 156612;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 156927;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 157368;
 Libderiv->deriv2_classes[6][3][22] = int_stack + 157956;
 Libderiv->deriv2_classes[6][4][22] = int_stack + 158236;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 158656;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 159244;
 Libderiv->deriv2_classes[4][3][21] = int_stack + 160028;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 160178;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 160403;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 160718;
 Libderiv->deriv2_classes[5][3][21] = int_stack + 161138;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 161348;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 161663;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 162104;
 Libderiv->deriv2_classes[6][3][21] = int_stack + 162692;
 Libderiv->deriv2_classes[6][4][21] = int_stack + 162972;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 163392;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 163980;
 Libderiv->deriv2_classes[4][3][20] = int_stack + 164764;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 164914;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 165139;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 165454;
 Libderiv->deriv2_classes[5][3][20] = int_stack + 165874;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 166084;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 166399;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 166840;
 Libderiv->deriv2_classes[6][3][20] = int_stack + 167428;
 Libderiv->deriv2_classes[6][4][20] = int_stack + 167708;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 168128;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 168716;
 Libderiv->deriv2_classes[4][3][19] = int_stack + 169500;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 169650;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 169875;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 170190;
 Libderiv->deriv2_classes[5][3][19] = int_stack + 170610;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 170820;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 171135;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 171576;
 Libderiv->deriv2_classes[6][3][19] = int_stack + 172164;
 Libderiv->deriv2_classes[6][4][19] = int_stack + 172444;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 172864;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 173452;
 Libderiv->deriv2_classes[4][3][18] = int_stack + 174236;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 174386;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 174611;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 174926;
 Libderiv->deriv2_classes[5][3][18] = int_stack + 175346;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 175556;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 175871;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 176312;
 Libderiv->deriv_classes[6][3][1] = int_stack + 176900;
 Libderiv->deriv2_classes[6][3][18] = int_stack + 177180;
 Libderiv->deriv_classes[6][4][1] = int_stack + 177460;
 Libderiv->deriv2_classes[6][4][18] = int_stack + 177880;
 Libderiv->deriv_classes[6][5][1] = int_stack + 178300;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 178888;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 179476;
 Libderiv->deriv2_classes[4][3][14] = int_stack + 180260;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 180410;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 180635;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 180950;
 Libderiv->deriv2_classes[5][3][14] = int_stack + 181370;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 181580;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 181895;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 182336;
 Libderiv->deriv2_classes[6][3][14] = int_stack + 182924;
 Libderiv->deriv2_classes[6][4][14] = int_stack + 183204;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 183624;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 184212;
 Libderiv->deriv2_classes[4][3][13] = int_stack + 184996;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 185146;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 185371;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 185686;
 Libderiv->deriv2_classes[5][3][13] = int_stack + 186106;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 186316;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 186631;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 187072;
 Libderiv->deriv2_classes[6][3][13] = int_stack + 187660;
 Libderiv->deriv2_classes[6][4][13] = int_stack + 187940;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 188360;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 188948;
 Libderiv->deriv_classes[4][3][11] = int_stack + 189732;
 Libderiv->deriv_classes[4][4][11] = int_stack + 189882;
 Libderiv->deriv_classes[4][5][11] = int_stack + 190107;
 Libderiv->deriv_classes[4][6][11] = int_stack + 190422;
 Libderiv->deriv2_classes[4][3][11] = int_stack + 190842;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 190992;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 191217;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 191532;
 Libderiv->deriv_classes[5][3][11] = int_stack + 191952;
 Libderiv->deriv_classes[5][4][11] = int_stack + 192162;
 Libderiv->deriv_classes[5][5][11] = int_stack + 192477;
 Libderiv->deriv_classes[5][6][11] = int_stack + 192918;
 Libderiv->deriv2_classes[5][3][11] = int_stack + 193506;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 193716;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 194031;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 194472;
 Libderiv->deriv2_classes[6][3][11] = int_stack + 195060;
 Libderiv->deriv2_classes[6][4][11] = int_stack + 195340;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 195760;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 196348;
 Libderiv->deriv_classes[4][3][10] = int_stack + 197132;
 Libderiv->deriv_classes[4][4][10] = int_stack + 197282;
 Libderiv->deriv_classes[4][5][10] = int_stack + 197507;
 Libderiv->deriv_classes[4][6][10] = int_stack + 197822;
 Libderiv->deriv2_classes[4][3][10] = int_stack + 198242;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 198392;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 198617;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 198932;
 Libderiv->deriv_classes[5][3][10] = int_stack + 199352;
 Libderiv->deriv_classes[5][4][10] = int_stack + 199562;
 Libderiv->deriv_classes[5][5][10] = int_stack + 199877;
 Libderiv->deriv_classes[5][6][10] = int_stack + 200318;
 Libderiv->deriv2_classes[5][3][10] = int_stack + 200906;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 201116;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 201431;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 201872;
 Libderiv->deriv2_classes[6][3][10] = int_stack + 202460;
 Libderiv->deriv2_classes[6][4][10] = int_stack + 202740;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 203160;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 203748;
 Libderiv->deriv_classes[4][3][9] = int_stack + 204532;
 Libderiv->deriv_classes[4][4][9] = int_stack + 204682;
 Libderiv->deriv_classes[4][5][9] = int_stack + 204907;
 Libderiv->deriv_classes[4][6][9] = int_stack + 205222;
 Libderiv->deriv2_classes[4][3][9] = int_stack + 205642;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 205792;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 206017;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 206332;
 Libderiv->deriv_classes[5][3][9] = int_stack + 206752;
 Libderiv->deriv_classes[5][4][9] = int_stack + 206962;
 Libderiv->deriv_classes[5][5][9] = int_stack + 207277;
 Libderiv->deriv_classes[5][6][9] = int_stack + 207718;
 Libderiv->deriv2_classes[5][3][9] = int_stack + 208306;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 208516;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 208831;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 209272;
 Libderiv->deriv2_classes[6][3][9] = int_stack + 209860;
 Libderiv->deriv2_classes[6][4][9] = int_stack + 210140;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 210560;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 211148;
 Libderiv->deriv_classes[4][3][8] = int_stack + 211932;
 Libderiv->deriv_classes[4][4][8] = int_stack + 212082;
 Libderiv->deriv_classes[4][5][8] = int_stack + 212307;
 Libderiv->deriv_classes[4][6][8] = int_stack + 212622;
 Libderiv->deriv2_classes[4][3][8] = int_stack + 213042;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 213192;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 213417;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 213732;
 Libderiv->deriv_classes[5][3][8] = int_stack + 214152;
 Libderiv->deriv_classes[5][4][8] = int_stack + 214362;
 Libderiv->deriv_classes[5][5][8] = int_stack + 214677;
 Libderiv->deriv_classes[5][6][8] = int_stack + 215118;
 Libderiv->deriv2_classes[5][3][8] = int_stack + 215706;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 215916;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 216231;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 216672;
 Libderiv->deriv2_classes[6][3][8] = int_stack + 217260;
 Libderiv->deriv2_classes[6][4][8] = int_stack + 217540;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 217960;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 218548;
 Libderiv->deriv_classes[4][3][7] = int_stack + 219332;
 Libderiv->deriv_classes[4][4][7] = int_stack + 219482;
 Libderiv->deriv_classes[4][5][7] = int_stack + 219707;
 Libderiv->deriv_classes[4][6][7] = int_stack + 220022;
 Libderiv->deriv2_classes[4][3][7] = int_stack + 220442;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 220592;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 220817;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 221132;
 Libderiv->deriv_classes[5][3][7] = int_stack + 221552;
 Libderiv->deriv_classes[5][4][7] = int_stack + 221762;
 Libderiv->deriv_classes[5][5][7] = int_stack + 222077;
 Libderiv->deriv_classes[5][6][7] = int_stack + 222518;
 Libderiv->deriv2_classes[5][3][7] = int_stack + 223106;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 223316;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 223631;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 224072;
 Libderiv->deriv2_classes[6][3][7] = int_stack + 224660;
 Libderiv->deriv2_classes[6][4][7] = int_stack + 224940;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 225360;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 225948;
 Libderiv->deriv_classes[4][3][6] = int_stack + 226732;
 Libderiv->deriv_classes[4][4][6] = int_stack + 226882;
 Libderiv->deriv_classes[4][5][6] = int_stack + 227107;
 Libderiv->deriv_classes[4][6][6] = int_stack + 227422;
 Libderiv->deriv2_classes[4][3][6] = int_stack + 227842;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 227992;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 228217;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 228532;
 Libderiv->dvrr_classes[5][3] = int_stack + 228952;
 Libderiv->deriv_classes[5][3][6] = int_stack + 229162;
 Libderiv->dvrr_classes[5][4] = int_stack + 229372;
 Libderiv->deriv_classes[5][4][6] = int_stack + 229687;
 Libderiv->dvrr_classes[5][5] = int_stack + 230002;
 Libderiv->deriv_classes[5][5][6] = int_stack + 230443;
 Libderiv->deriv_classes[5][6][6] = int_stack + 230884;
 Libderiv->deriv2_classes[5][3][6] = int_stack + 231472;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 231682;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 231997;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 232438;
 Libderiv->deriv_classes[6][3][0] = int_stack + 233026;
 Libderiv->deriv2_classes[6][3][6] = int_stack + 233306;
 Libderiv->deriv_classes[6][4][0] = int_stack + 233586;
 Libderiv->deriv2_classes[6][4][6] = int_stack + 234006;
 Libderiv->deriv_classes[6][5][0] = int_stack + 234426;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 235014;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 235602;
 Libderiv->deriv_classes[4][3][2] = int_stack + 236386;
 Libderiv->deriv_classes[4][4][2] = int_stack + 236536;
 Libderiv->deriv_classes[4][5][2] = int_stack + 236761;
 Libderiv->deriv_classes[4][6][2] = int_stack + 237076;
 Libderiv->deriv2_classes[4][3][2] = int_stack + 237496;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 237646;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 237871;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 238186;
 Libderiv->deriv_classes[5][3][2] = int_stack + 238606;
 Libderiv->deriv_classes[5][4][2] = int_stack + 238816;
 Libderiv->deriv_classes[5][5][2] = int_stack + 239131;
 Libderiv->deriv_classes[5][6][2] = int_stack + 239572;
 Libderiv->deriv2_classes[5][3][2] = int_stack + 240160;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 240370;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 240685;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 241126;
 Libderiv->deriv2_classes[6][3][2] = int_stack + 241714;
 Libderiv->deriv2_classes[6][4][2] = int_stack + 241994;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 242414;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 243002;
 Libderiv->deriv_classes[4][3][1] = int_stack + 243786;
 Libderiv->deriv_classes[4][4][1] = int_stack + 243936;
 Libderiv->deriv_classes[4][5][1] = int_stack + 244161;
 Libderiv->deriv_classes[4][6][1] = int_stack + 244476;
 Libderiv->deriv2_classes[4][3][1] = int_stack + 244896;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 245046;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 245271;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 245586;
 Libderiv->deriv_classes[5][3][1] = int_stack + 246006;
 Libderiv->deriv_classes[5][4][1] = int_stack + 246216;
 Libderiv->deriv_classes[5][5][1] = int_stack + 246531;
 Libderiv->deriv_classes[5][6][1] = int_stack + 246972;
 Libderiv->deriv2_classes[5][3][1] = int_stack + 247560;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 247770;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 248085;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 248526;
 Libderiv->deriv2_classes[6][3][1] = int_stack + 249114;
 Libderiv->deriv2_classes[6][4][1] = int_stack + 249394;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 249814;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 250402;
 Libderiv->dvrr_classes[4][3] = int_stack + 251186;
 Libderiv->dvrr_classes[4][4] = int_stack + 251336;
 Libderiv->dvrr_classes[4][5] = int_stack + 251561;
 Libderiv->dvrr_classes[4][6] = int_stack + 251876;
 Libderiv->deriv_classes[4][3][0] = int_stack + 252296;
 Libderiv->deriv_classes[4][4][0] = int_stack + 252446;
 Libderiv->deriv_classes[4][5][0] = int_stack + 252671;
 Libderiv->deriv_classes[4][6][0] = int_stack + 252986;
 Libderiv->deriv2_classes[4][3][0] = int_stack + 253406;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 253556;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 253781;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 254096;
 Libderiv->deriv_classes[5][3][0] = int_stack + 254516;
 Libderiv->deriv_classes[5][4][0] = int_stack + 254726;
 Libderiv->deriv_classes[5][5][0] = int_stack + 255041;
 Libderiv->deriv_classes[5][6][0] = int_stack + 255482;
 Libderiv->deriv2_classes[5][3][0] = int_stack + 256070;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 256280;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 256595;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 257036;
 Libderiv->deriv2_classes[6][3][0] = int_stack + 257624;
 Libderiv->deriv2_classes[6][4][0] = int_stack + 257904;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 258324;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 258912;
 memset(int_stack,0,2077568);

 Libderiv->dvrr_stack = int_stack + 685421;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_gdff(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+259696,int_stack+251336,int_stack+251186,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+260146,int_stack+251561,int_stack+251336,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+260821,int_stack+260146,int_stack+259696,15);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+261721,int_stack+189882,int_stack+189732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251186,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+262171,int_stack+190107,int_stack+189882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251336,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+262846,int_stack+262171,int_stack+261721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+263746,int_stack+190422,int_stack+190107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251561,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+264691,int_stack+263746,int_stack+262171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260146,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+266041,int_stack+264691,int_stack+262846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260821,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+263746,int_stack+229372,int_stack+228952,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+264376,int_stack+230002,int_stack+229372,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+267541,int_stack+264376,int_stack+263746,21);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+265321,int_stack+192162,int_stack+191952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228952,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+268801,int_stack+192477,int_stack+192162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229372,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+269746,int_stack+268801,int_stack+265321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+192918,int_stack+192477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230002,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+272329,int_stack+271006,int_stack+268801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264376,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+274219,int_stack+272329,int_stack+269746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+276319,int_stack+274219,int_stack+266041,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+112896,int_stack+112056,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+271846,int_stack+3920,int_stack+112896,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+280819,int_stack+271846,int_stack+271006,28);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+273106,int_stack+82496,int_stack+81936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112056,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+282499,int_stack+83336,int_stack+82496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112896,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+283759,int_stack+282499,int_stack+273106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271006,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+285439,int_stack+0,int_stack+83336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+287203,int_stack+285439,int_stack+282499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271846,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+289723,int_stack+287203,int_stack+283759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+292523,int_stack+289723,int_stack+274219,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+285439,int_stack+197282,int_stack+197132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251186, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+285889,int_stack+197507,int_stack+197282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251336, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+286564,int_stack+285889,int_stack+285439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+287464,int_stack+197822,int_stack+197507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251561, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+288409,int_stack+287464,int_stack+285889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260146, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+289759,int_stack+288409,int_stack+286564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260821, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+287464,int_stack+199562,int_stack+199352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228952, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+288094,int_stack+199877,int_stack+199562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229372, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+291259,int_stack+288094,int_stack+287464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+298823,int_stack+200318,int_stack+199877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230002, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+300146,int_stack+298823,int_stack+288094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264376, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+302036,int_stack+300146,int_stack+291259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+304136,int_stack+302036,int_stack+289759,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+298823,int_stack+88520,int_stack+87960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112056, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+299663,int_stack+89360,int_stack+88520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112896, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+308636,int_stack+299663,int_stack+298823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271006, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+310316,int_stack+784,int_stack+89360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+312080,int_stack+310316,int_stack+299663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271846, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+314600,int_stack+312080,int_stack+308636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+317400,int_stack+314600,int_stack+302036,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+310316,int_stack+204682,int_stack+204532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251186, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+310766,int_stack+204907,int_stack+204682, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251336, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+311441,int_stack+310766,int_stack+310316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+312341,int_stack+205222,int_stack+204907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251561, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+313286,int_stack+312341,int_stack+310766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260146, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+314636,int_stack+313286,int_stack+311441, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260821, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+312341,int_stack+206962,int_stack+206752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228952, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+312971,int_stack+207277,int_stack+206962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229372, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+316136,int_stack+312971,int_stack+312341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+207718,int_stack+207277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230002, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+323700,int_stack+0,int_stack+312971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264376, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+325590,int_stack+323700,int_stack+316136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+327690,int_stack+325590,int_stack+314636,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+323700,int_stack+94544,int_stack+93984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112056, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+95384,int_stack+94544, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112896, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+332190,int_stack+0,int_stack+323700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+333870,int_stack+1568,int_stack+95384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+335634,int_stack+333870,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271846, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+338154,int_stack+335634,int_stack+332190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+340954,int_stack+338154,int_stack+325590,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+333870,int_stack+212082,int_stack+211932, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+334320,int_stack+212307,int_stack+212082, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+334995,int_stack+334320,int_stack+333870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+335895,int_stack+212622,int_stack+212307, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+336840,int_stack+335895,int_stack+334320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+338190,int_stack+336840,int_stack+334995, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+260821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+335895,int_stack+214362,int_stack+214152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+336525,int_stack+214677,int_stack+214362, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+339690,int_stack+336525,int_stack+335895, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+347254,int_stack+215118,int_stack+214677, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+348577,int_stack+347254,int_stack+336525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+350467,int_stack+348577,int_stack+339690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+352567,int_stack+350467,int_stack+338190,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+347254,int_stack+100568,int_stack+100008, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+348094,int_stack+101408,int_stack+100568, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+357067,int_stack+348094,int_stack+347254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+358747,int_stack+2352,int_stack+101408, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+360511,int_stack+358747,int_stack+348094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+363031,int_stack+360511,int_stack+357067, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+365831,int_stack+363031,int_stack+350467,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+358747,int_stack+219482,int_stack+219332, 0.0, zero_stack, 1.0, int_stack+251186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+359197,int_stack+219707,int_stack+219482, 0.0, zero_stack, 1.0, int_stack+251336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+359872,int_stack+359197,int_stack+358747, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+360772,int_stack+220022,int_stack+219707, 0.0, zero_stack, 1.0, int_stack+251561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+361717,int_stack+360772,int_stack+359197, 0.0, zero_stack, 1.0, int_stack+260146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+363067,int_stack+361717,int_stack+359872, 0.0, zero_stack, 1.0, int_stack+260821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+360772,int_stack+221762,int_stack+221552, 0.0, zero_stack, 1.0, int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+361402,int_stack+222077,int_stack+221762, 0.0, zero_stack, 1.0, int_stack+229372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+364567,int_stack+361402,int_stack+360772, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1260,int_stack+222518,int_stack+222077, 0.0, zero_stack, 1.0, int_stack+230002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+1260,int_stack+361402, 0.0, zero_stack, 1.0, int_stack+264376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+374021,int_stack+372131,int_stack+364567, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+376121,int_stack+374021,int_stack+363067,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+372131,int_stack+106592,int_stack+106032, 0.0, zero_stack, 1.0, int_stack+112056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1260,int_stack+107432,int_stack+106592, 0.0, zero_stack, 1.0, int_stack+112896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+380621,int_stack+1260,int_stack+372131, 0.0, zero_stack, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+382301,int_stack+3136,int_stack+107432, 0.0, zero_stack, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+384065,int_stack+382301,int_stack+1260, 0.0, zero_stack, 1.0, int_stack+271846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+386585,int_stack+384065,int_stack+380621, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+389385,int_stack+386585,int_stack+374021,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+382301,int_stack+226882,int_stack+226732, 1.0, int_stack+251186, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+382751,int_stack+227107,int_stack+226882, 1.0, int_stack+251336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+383426,int_stack+382751,int_stack+382301, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+384326,int_stack+227422,int_stack+227107, 1.0, int_stack+251561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+385271,int_stack+384326,int_stack+382751, 1.0, int_stack+260146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+386621,int_stack+385271,int_stack+383426, 1.0, int_stack+260821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+384326,int_stack+229687,int_stack+229162, 1.0, int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+384956,int_stack+230443,int_stack+229687, 1.0, int_stack+229372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+388121,int_stack+384956,int_stack+384326, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2520,int_stack+230884,int_stack+230443, 1.0, int_stack+230002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+395685,int_stack+2520,int_stack+384956, 1.0, int_stack+264376, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+397575,int_stack+395685,int_stack+388121, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+399675,int_stack+397575,int_stack+386621,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+395685,int_stack+113316,int_stack+112336, 1.0, int_stack+112056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2520,int_stack+114156,int_stack+113316, 1.0, int_stack+112896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+2520,int_stack+395685, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+405855,int_stack+4508,int_stack+114156, 1.0, int_stack+3920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+407619,int_stack+405855,int_stack+2520, 1.0, int_stack+271846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+410139,int_stack+407619,int_stack+404175, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+412939,int_stack+410139,int_stack+397575,100);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+280819,int_stack+251876,int_stack+251561,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+405855,int_stack+280819,int_stack+260146,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+280819,int_stack+405855,int_stack+260821,15);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+405855,int_stack+6860,int_stack+230002,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+407178,int_stack+405855,int_stack+264376,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+407178,int_stack+267541,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+405855,int_stack+271006,int_stack+280819,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+267541,int_stack+236536,int_stack+236386,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+267991,int_stack+236761,int_stack+236536,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+267991,int_stack+267541,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+411255,int_stack+237076,int_stack+236761,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+3780,int_stack+411255,int_stack+267991,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+411255,int_stack+3780,int_stack+410355,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+3780,int_stack+238816,int_stack+238606,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+396525,int_stack+239131,int_stack+238816,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+263746,int_stack+396525,int_stack+3780,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+259696,int_stack+239572,int_stack+239131,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+419239,int_stack+259696,int_stack+396525,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+421129,int_stack+419239,int_stack+263746,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+423229,int_stack+421129,int_stack+411255, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+419239,int_stack+143020,int_stack+142460,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+259696,int_stack+143860,int_stack+143020,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+259696,int_stack+419239,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+429409,int_stack+5292,int_stack+143860,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+431173,int_stack+429409,int_stack+259696,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+433693,int_stack+431173,int_stack+427729,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+436493,int_stack+433693,int_stack+421129, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+429409,int_stack+243936,int_stack+243786,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+429859,int_stack+244161,int_stack+243936,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+430534,int_stack+429859,int_stack+429409,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+431434,int_stack+244476,int_stack+244161,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+432379,int_stack+431434,int_stack+429859,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+433729,int_stack+432379,int_stack+430534,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+431434,int_stack+246216,int_stack+246006,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+432064,int_stack+246531,int_stack+246216,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+435229,int_stack+432064,int_stack+431434,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4410,int_stack+246972,int_stack+246531,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+4410,int_stack+432064,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+444683,int_stack+442793,int_stack+435229,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+446783,int_stack+444683,int_stack+433729, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+442793,int_stack+177460,int_stack+176900,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+4410,int_stack+178300,int_stack+177460,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+4410,int_stack+442793,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+452963,int_stack+6076,int_stack+178300,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+454727,int_stack+452963,int_stack+4410,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+457247,int_stack+454727,int_stack+451283,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+460047,int_stack+457247,int_stack+444683, 0.0, zero_stack, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+452963,int_stack+252446,int_stack+252296,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+453413,int_stack+252671,int_stack+252446,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+454088,int_stack+453413,int_stack+452963,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+454988,int_stack+252986,int_stack+252671,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+455933,int_stack+454988,int_stack+453413,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+457283,int_stack+455933,int_stack+454088,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+454988,int_stack+254726,int_stack+254516,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+455618,int_stack+255041,int_stack+254726,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+458783,int_stack+455618,int_stack+454988,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+5670,int_stack+255482,int_stack+255041,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+466347,int_stack+5670,int_stack+455618,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+468237,int_stack+466347,int_stack+458783,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+470337,int_stack+468237,int_stack+457283, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+280819,int_stack+233586,int_stack+233026,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+466347,int_stack+234426,int_stack+233586,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+5670,int_stack+466347,int_stack+280819,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+474837,int_stack+7448,int_stack+234426,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+476601,int_stack+474837,int_stack+466347,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+479121,int_stack+476601,int_stack+5670,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+481921,int_stack+479121,int_stack+468237, 1.0, int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+8382,int_stack+8232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+189732,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+8607,int_stack+8382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+189882,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+261721,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+474837,int_stack+8922,int_stack+8607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+190107,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+475782,int_stack+474837,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+262171,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+477132,int_stack+475782,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+262846,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+9552,int_stack+9342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+191952,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+474837,int_stack+9867,int_stack+9552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+192162,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+475782,int_stack+474837,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+265321,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+10308,int_stack+9867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+192477,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+478632,int_stack+271006,int_stack+474837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+268801,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+478632,int_stack+475782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+269746,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+488221,int_stack+271006,int_stack+477132,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+11176,int_stack+10896, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+81936,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+474837,int_stack+11596,int_stack+11176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+82496,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+476097,int_stack+474837,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+273106,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+477777,int_stack+12184,int_stack+11596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+83336,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+7350,int_stack+477777,int_stack+474837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+282499,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+477777,int_stack+7350,int_stack+476097, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+283759,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+492721,int_stack+477777,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+13118,int_stack+12968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189732, 1.0, int_stack+197132,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+13343,int_stack+13118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189882, 1.0, int_stack+197282,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261721, 1.0, int_stack+285439,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+7350,int_stack+13658,int_stack+13343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190107, 1.0, int_stack+197507,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+8295,int_stack+7350,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262171, 1.0, int_stack+285889,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+9645,int_stack+8295,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262846, 1.0, int_stack+286564,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+14288,int_stack+14078, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191952, 1.0, int_stack+199352,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7350,int_stack+14603,int_stack+14288, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192162, 1.0, int_stack+199562,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+8295,int_stack+7350,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265321, 1.0, int_stack+287464,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+15044,int_stack+14603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192477, 1.0, int_stack+199877,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+11145,int_stack+271006,int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268801, 1.0, int_stack+288094,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+11145,int_stack+8295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269746, 1.0, int_stack+291259,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+474837,int_stack+271006,int_stack+9645,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+15912,int_stack+15632, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81936, 1.0, int_stack+87960,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+7350,int_stack+16332,int_stack+15912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82496, 1.0, int_stack+88520,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+8610,int_stack+7350,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273106, 1.0, int_stack+298823,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+10290,int_stack+16920,int_stack+16332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83336, 1.0, int_stack+89360,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+12054,int_stack+10290,int_stack+7350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282499, 1.0, int_stack+299663,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+14574,int_stack+12054,int_stack+8610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283759, 1.0, int_stack+308636,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+7350,int_stack+14574,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+17854,int_stack+17704, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+197132, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+18079,int_stack+17854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+197282, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+285439, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+13650,int_stack+18394,int_stack+18079, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+197507, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+14595,int_stack+13650,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+285889, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+15945,int_stack+14595,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+286564, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+19024,int_stack+18814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+199352, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13650,int_stack+19339,int_stack+19024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+199562, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+14595,int_stack+13650,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+287464, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+19780,int_stack+19339, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+199877, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+17445,int_stack+271006,int_stack+13650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+288094, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+17445,int_stack+14595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+291259, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+499021,int_stack+271006,int_stack+15945,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+20648,int_stack+20368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+87960, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+13650,int_stack+21068,int_stack+20648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+88520, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+14910,int_stack+13650,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+298823, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+16590,int_stack+21656,int_stack+21068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+89360, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+18354,int_stack+16590,int_stack+13650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+299663, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+503521,int_stack+18354,int_stack+14910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+308636, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+13650,int_stack+503521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+22590,int_stack+22440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189732, 0.0, zero_stack, 1.0, int_stack+204532,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+22815,int_stack+22590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189882, 0.0, zero_stack, 1.0, int_stack+204682,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261721, 0.0, zero_stack, 1.0, int_stack+310316,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+503521,int_stack+23130,int_stack+22815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190107, 0.0, zero_stack, 1.0, int_stack+204907,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+504466,int_stack+503521,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262171, 0.0, zero_stack, 1.0, int_stack+310766,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+19950,int_stack+504466,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262846, 0.0, zero_stack, 1.0, int_stack+311441,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+23760,int_stack+23550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191952, 0.0, zero_stack, 1.0, int_stack+206752,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+503521,int_stack+24075,int_stack+23760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192162, 0.0, zero_stack, 1.0, int_stack+206962,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+504466,int_stack+503521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265321, 0.0, zero_stack, 1.0, int_stack+312341,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+24516,int_stack+24075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192477, 0.0, zero_stack, 1.0, int_stack+207277,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+21450,int_stack+271006,int_stack+503521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268801, 0.0, zero_stack, 1.0, int_stack+312971,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+21450,int_stack+504466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269746, 0.0, zero_stack, 1.0, int_stack+316136,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+503521,int_stack+271006,int_stack+19950,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+25384,int_stack+25104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81936, 0.0, zero_stack, 1.0, int_stack+93984,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+19950,int_stack+25804,int_stack+25384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82496, 0.0, zero_stack, 1.0, int_stack+94544,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+21210,int_stack+19950,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273106, 0.0, zero_stack, 1.0, int_stack+323700,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+22890,int_stack+26392,int_stack+25804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83336, 0.0, zero_stack, 1.0, int_stack+95384,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+24654,int_stack+22890,int_stack+19950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282499, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+508021,int_stack+24654,int_stack+21210, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283759, 0.0, zero_stack, 1.0, int_stack+332190,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+19950,int_stack+508021,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+27326,int_stack+27176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197132, 1.0, int_stack+204532, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+27551,int_stack+27326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197282, 1.0, int_stack+204682, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285439, 1.0, int_stack+310316, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+508021,int_stack+27866,int_stack+27551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197507, 1.0, int_stack+204907, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+508966,int_stack+508021,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285889, 1.0, int_stack+310766, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+508966,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+286564, 1.0, int_stack+311441, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+28496,int_stack+28286, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199352, 1.0, int_stack+206752, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+508021,int_stack+28811,int_stack+28496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199562, 1.0, int_stack+206962, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+508966,int_stack+508021,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287464, 1.0, int_stack+312341, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+29252,int_stack+28811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199877, 1.0, int_stack+207277, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27750,int_stack+271006,int_stack+508021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288094, 1.0, int_stack+312971, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+27750,int_stack+508966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291259, 1.0, int_stack+316136, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+508021,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+30120,int_stack+29840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87960, 1.0, int_stack+93984, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+30540,int_stack+30120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88520, 1.0, int_stack+94544, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+27510,int_stack+26250,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298823, 1.0, int_stack+323700, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+479337,int_stack+31128,int_stack+30540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89360, 1.0, int_stack+95384, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+29190,int_stack+479337,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299663, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+29190,int_stack+27510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308636, 1.0, int_stack+332190, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+515321,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+32062,int_stack+31912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+204532, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+32287,int_stack+32062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+204682, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+310316, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+32602,int_stack+32287, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+204907, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+310766, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+513466,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+311441, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+33232,int_stack+33022, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+206752, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+33547,int_stack+33232, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+206962, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+312341, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+33988,int_stack+33547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+207277, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+27750,int_stack+271006,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+312971, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+27750,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+316136, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+27750,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+34856,int_stack+34576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+93984, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+35276,int_stack+34856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+94544, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+32250,int_stack+26250,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+323700, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+35864,int_stack+35276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+95384, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+33930,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+33930,int_stack+32250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+332190, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+521621,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+36798,int_stack+36648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+211932,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+37023,int_stack+36798, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189882, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212082,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+261721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+333870,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+37338,int_stack+37023, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+190107, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+212307,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262171, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334320,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+513466,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334995,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+37968,int_stack+37758, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+191952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214152,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+38283,int_stack+37968, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192162, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214362,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+265321, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+335895,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+38724,int_stack+38283, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+192477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+214677,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+32250,int_stack+271006,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+268801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336525,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+32250,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+269746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339690,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+32250,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+39592,int_stack+39312, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+81936, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100008,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+40012,int_stack+39592, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+82496, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+100568,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+36750,int_stack+26250,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+273106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+347254,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+40600,int_stack+40012, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+83336, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+101408,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+38430,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282499, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348094,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+38430,int_stack+36750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+283759, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+357067,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+527921,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+41534,int_stack+41384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197132, 0.0, zero_stack, 1.0, int_stack+211932, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+41759,int_stack+41534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197282, 0.0, zero_stack, 1.0, int_stack+212082, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285439, 0.0, zero_stack, 1.0, int_stack+333870, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+42074,int_stack+41759, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+197507, 0.0, zero_stack, 1.0, int_stack+212307, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+285889, 0.0, zero_stack, 1.0, int_stack+334320, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+513466,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+286564, 0.0, zero_stack, 1.0, int_stack+334995, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+42704,int_stack+42494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199352, 0.0, zero_stack, 1.0, int_stack+214152, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+43019,int_stack+42704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199562, 0.0, zero_stack, 1.0, int_stack+214362, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+287464, 0.0, zero_stack, 1.0, int_stack+335895, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+43460,int_stack+43019, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+199877, 0.0, zero_stack, 1.0, int_stack+214677, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+36750,int_stack+271006,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+288094, 0.0, zero_stack, 1.0, int_stack+336525, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+36750,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+291259, 0.0, zero_stack, 1.0, int_stack+339690, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+36750,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+44328,int_stack+44048, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+87960, 0.0, zero_stack, 1.0, int_stack+100008, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+44748,int_stack+44328, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+88520, 0.0, zero_stack, 1.0, int_stack+100568, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+41250,int_stack+26250,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298823, 0.0, zero_stack, 1.0, int_stack+347254, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+42930,int_stack+45336,int_stack+44748, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+89360, 0.0, zero_stack, 1.0, int_stack+101408, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+42930,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299663, 0.0, zero_stack, 1.0, int_stack+348094, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+42930,int_stack+512521,int_stack+41250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308636, 0.0, zero_stack, 1.0, int_stack+357067, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+534221,int_stack+42930,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+46270,int_stack+46120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204532, 1.0, int_stack+211932, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+46495,int_stack+46270, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204682, 1.0, int_stack+212082, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310316, 1.0, int_stack+333870, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+41250,int_stack+46810,int_stack+46495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+204907, 1.0, int_stack+212307, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+42195,int_stack+41250,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+310766, 1.0, int_stack+334320, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+42195,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+311441, 1.0, int_stack+334995, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+47440,int_stack+47230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206752, 1.0, int_stack+214152, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+41250,int_stack+47755,int_stack+47440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+206962, 1.0, int_stack+214362, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+42195,int_stack+41250,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312341, 1.0, int_stack+335895, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+43455,int_stack+48196,int_stack+47755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+207277, 1.0, int_stack+214677, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+44778,int_stack+43455,int_stack+41250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+312971, 1.0, int_stack+336525, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+44778,int_stack+42195, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316136, 1.0, int_stack+339690, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+41250,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+49064,int_stack+48784, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+93984, 1.0, int_stack+100008, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+49484,int_stack+49064, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+94544, 1.0, int_stack+100568, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+45750,int_stack+26250,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+323700, 1.0, int_stack+347254, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+47430,int_stack+50072,int_stack+49484, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+95384, 1.0, int_stack+101408, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+47430,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+348094, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+47430,int_stack+512521,int_stack+45750, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332190, 1.0, int_stack+357067, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+540521,int_stack+47430,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+51006,int_stack+50856, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+211932, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+51231,int_stack+51006, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+212082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+333870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+45750,int_stack+51546,int_stack+51231, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+212307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+46695,int_stack+45750,int_stack+271456, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+334320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+46695,int_stack+272131, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+334995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+52176,int_stack+51966, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+214152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+45750,int_stack+52491,int_stack+52176, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+214362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+46695,int_stack+45750,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+335895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+47955,int_stack+52932,int_stack+52491, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+214677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+49278,int_stack+47955,int_stack+45750, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+336525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+49278,int_stack+46695, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+339690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+45750,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+53800,int_stack+53520, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+100008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+54220,int_stack+53800, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+100568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+50250,int_stack+26250,int_stack+281659, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+347254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+51930,int_stack+54808,int_stack+54220, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+101408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+51930,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+348094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+51930,int_stack+512521,int_stack+50250, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+357067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+546821,int_stack+51930,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+55742,int_stack+55592, 0.0, zero_stack, 1.0, int_stack+189732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219332,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+55967,int_stack+55742, 0.0, zero_stack, 1.0, int_stack+189882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219482,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 1.0, int_stack+261721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358747,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+50250,int_stack+56282,int_stack+55967, 0.0, zero_stack, 1.0, int_stack+190107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219707,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+51195,int_stack+50250,int_stack+271456, 0.0, zero_stack, 1.0, int_stack+262171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359197,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+51195,int_stack+272131, 0.0, zero_stack, 1.0, int_stack+262846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359872,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+56912,int_stack+56702, 0.0, zero_stack, 1.0, int_stack+191952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221552,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+50250,int_stack+57227,int_stack+56912, 0.0, zero_stack, 1.0, int_stack+192162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221762,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+51195,int_stack+50250,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+265321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360772,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+52455,int_stack+57668,int_stack+57227, 0.0, zero_stack, 1.0, int_stack+192477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222077,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+53778,int_stack+52455,int_stack+50250, 0.0, zero_stack, 1.0, int_stack+268801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361402,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+53778,int_stack+51195, 0.0, zero_stack, 1.0, int_stack+269746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364567,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+50250,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+58536,int_stack+58256, 0.0, zero_stack, 1.0, int_stack+81936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106032,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+58956,int_stack+58536, 0.0, zero_stack, 1.0, int_stack+82496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106592,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+54750,int_stack+26250,int_stack+281659, 0.0, zero_stack, 1.0, int_stack+273106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372131,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56430,int_stack+59544,int_stack+58956, 0.0, zero_stack, 1.0, int_stack+83336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107432,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+56430,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+282499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1260,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+56430,int_stack+512521,int_stack+54750, 0.0, zero_stack, 1.0, int_stack+283759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380621,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+553121,int_stack+56430,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+60478,int_stack+60328, 0.0, zero_stack, 1.0, int_stack+197132, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219332, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+60703,int_stack+60478, 0.0, zero_stack, 1.0, int_stack+197282, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219482, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 1.0, int_stack+285439, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+358747, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+54750,int_stack+61018,int_stack+60703, 0.0, zero_stack, 1.0, int_stack+197507, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219707, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+55695,int_stack+54750,int_stack+271456, 0.0, zero_stack, 1.0, int_stack+285889, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359197, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+55695,int_stack+272131, 0.0, zero_stack, 1.0, int_stack+286564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+359872, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+61648,int_stack+61438, 0.0, zero_stack, 1.0, int_stack+199352, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221552, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+54750,int_stack+61963,int_stack+61648, 0.0, zero_stack, 1.0, int_stack+199562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221762, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+55695,int_stack+54750,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+287464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360772, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+56955,int_stack+62404,int_stack+61963, 0.0, zero_stack, 1.0, int_stack+199877, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+222077, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+58278,int_stack+56955,int_stack+54750, 0.0, zero_stack, 1.0, int_stack+288094, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361402, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+58278,int_stack+55695, 0.0, zero_stack, 1.0, int_stack+291259, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364567, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+54750,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+63272,int_stack+62992, 0.0, zero_stack, 1.0, int_stack+87960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106032, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+63692,int_stack+63272, 0.0, zero_stack, 1.0, int_stack+88520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+106592, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+59250,int_stack+26250,int_stack+281659, 0.0, zero_stack, 1.0, int_stack+298823, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+372131, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+60930,int_stack+64280,int_stack+63692, 0.0, zero_stack, 1.0, int_stack+89360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+107432, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+60930,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+299663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1260, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+60930,int_stack+512521,int_stack+59250, 0.0, zero_stack, 1.0, int_stack+308636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+380621, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+559421,int_stack+60930,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+65214,int_stack+65064, 0.0, zero_stack, 1.0, int_stack+204532, 0.0, zero_stack, 1.0, int_stack+219332, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+65439,int_stack+65214, 0.0, zero_stack, 1.0, int_stack+204682, 0.0, zero_stack, 1.0, int_stack+219482, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 1.0, int_stack+310316, 0.0, zero_stack, 1.0, int_stack+358747, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+59250,int_stack+65754,int_stack+65439, 0.0, zero_stack, 1.0, int_stack+204907, 0.0, zero_stack, 1.0, int_stack+219707, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+60195,int_stack+59250,int_stack+271456, 0.0, zero_stack, 1.0, int_stack+310766, 0.0, zero_stack, 1.0, int_stack+359197, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+60195,int_stack+272131, 0.0, zero_stack, 1.0, int_stack+311441, 0.0, zero_stack, 1.0, int_stack+359872, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+66384,int_stack+66174, 0.0, zero_stack, 1.0, int_stack+206752, 0.0, zero_stack, 1.0, int_stack+221552, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+59250,int_stack+66699,int_stack+66384, 0.0, zero_stack, 1.0, int_stack+206962, 0.0, zero_stack, 1.0, int_stack+221762, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+60195,int_stack+59250,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+312341, 0.0, zero_stack, 1.0, int_stack+360772, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+61455,int_stack+67140,int_stack+66699, 0.0, zero_stack, 1.0, int_stack+207277, 0.0, zero_stack, 1.0, int_stack+222077, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+62778,int_stack+61455,int_stack+59250, 0.0, zero_stack, 1.0, int_stack+312971, 0.0, zero_stack, 1.0, int_stack+361402, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+62778,int_stack+60195, 0.0, zero_stack, 1.0, int_stack+316136, 0.0, zero_stack, 1.0, int_stack+364567, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+59250,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+68008,int_stack+67728, 0.0, zero_stack, 1.0, int_stack+93984, 0.0, zero_stack, 1.0, int_stack+106032, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+68428,int_stack+68008, 0.0, zero_stack, 1.0, int_stack+94544, 0.0, zero_stack, 1.0, int_stack+106592, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+63750,int_stack+26250,int_stack+281659, 0.0, zero_stack, 1.0, int_stack+323700, 0.0, zero_stack, 1.0, int_stack+372131, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+65430,int_stack+69016,int_stack+68428, 0.0, zero_stack, 1.0, int_stack+95384, 0.0, zero_stack, 1.0, int_stack+107432, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+67194,int_stack+65430,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+67194,int_stack+63750, 0.0, zero_stack, 1.0, int_stack+332190, 0.0, zero_stack, 1.0, int_stack+380621, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+565721,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+69950,int_stack+69800, 0.0, zero_stack, 1.0, int_stack+211932, 1.0, int_stack+219332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+70175,int_stack+69950, 0.0, zero_stack, 1.0, int_stack+212082, 1.0, int_stack+219482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 1.0, int_stack+333870, 1.0, int_stack+358747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+70490,int_stack+70175, 0.0, zero_stack, 1.0, int_stack+212307, 1.0, int_stack+219707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+271456, 0.0, zero_stack, 1.0, int_stack+334320, 1.0, int_stack+359197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+513466,int_stack+272131, 0.0, zero_stack, 1.0, int_stack+334995, 1.0, int_stack+359872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+71120,int_stack+70910, 0.0, zero_stack, 1.0, int_stack+214152, 1.0, int_stack+221552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+71435,int_stack+71120, 0.0, zero_stack, 1.0, int_stack+214362, 1.0, int_stack+221762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+335895, 1.0, int_stack+360772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+71876,int_stack+71435, 0.0, zero_stack, 1.0, int_stack+214677, 1.0, int_stack+222077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+63750,int_stack+271006,int_stack+512521, 0.0, zero_stack, 1.0, int_stack+336525, 1.0, int_stack+361402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+63750,int_stack+513466, 0.0, zero_stack, 1.0, int_stack+339690, 1.0, int_stack+364567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+63750,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+72744,int_stack+72464, 0.0, zero_stack, 1.0, int_stack+100008, 1.0, int_stack+106032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+73164,int_stack+72744, 0.0, zero_stack, 1.0, int_stack+100568, 1.0, int_stack+106592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+68250,int_stack+26250,int_stack+281659, 0.0, zero_stack, 1.0, int_stack+347254, 1.0, int_stack+372131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+69930,int_stack+73752,int_stack+73164, 0.0, zero_stack, 1.0, int_stack+101408, 1.0, int_stack+107432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+71694,int_stack+69930,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+348094, 1.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+71694,int_stack+68250, 0.0, zero_stack, 1.0, int_stack+357067, 1.0, int_stack+380621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+572021,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+74686,int_stack+74536, 0.0, zero_stack, 2.0, int_stack+219332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+74911,int_stack+74686, 0.0, zero_stack, 2.0, int_stack+219482, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 0.0, zero_stack, 2.0, int_stack+358747, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+75226,int_stack+74911, 0.0, zero_stack, 2.0, int_stack+219707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+271456, 0.0, zero_stack, 2.0, int_stack+359197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+513466,int_stack+272131, 0.0, zero_stack, 2.0, int_stack+359872, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+75856,int_stack+75646, 0.0, zero_stack, 2.0, int_stack+221552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+76171,int_stack+75856, 0.0, zero_stack, 2.0, int_stack+221762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 2.0, int_stack+360772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+76612,int_stack+76171, 0.0, zero_stack, 2.0, int_stack+222077, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+68250,int_stack+271006,int_stack+512521, 0.0, zero_stack, 2.0, int_stack+361402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+68250,int_stack+513466, 0.0, zero_stack, 2.0, int_stack+364567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+68250,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+77480,int_stack+77200, 0.0, zero_stack, 2.0, int_stack+106032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+77900,int_stack+77480, 0.0, zero_stack, 2.0, int_stack+106592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+72750,int_stack+26250,int_stack+281659, 0.0, zero_stack, 2.0, int_stack+372131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+74430,int_stack+78488,int_stack+77900, 0.0, zero_stack, 2.0, int_stack+107432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+76194,int_stack+74430,int_stack+26250, 0.0, zero_stack, 2.0, int_stack+1260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+76194,int_stack+72750, 0.0, zero_stack, 2.0, int_stack+380621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+72750,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+271006,int_stack+79422,int_stack+79272, 1.0, int_stack+189732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226732,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+271456,int_stack+79647,int_stack+79422, 1.0, int_stack+189882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226882,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+272131,int_stack+271456,int_stack+271006, 1.0, int_stack+261721, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382301,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+79962,int_stack+79647, 1.0, int_stack+190107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227107,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+271456, 1.0, int_stack+262171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382751,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+513466,int_stack+272131, 1.0, int_stack+262846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383426,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+80592,int_stack+80382, 1.0, int_stack+191952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229162,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+80907,int_stack+80592, 1.0, int_stack+192162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229687,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 1.0, int_stack+265321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384326,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+271006,int_stack+81348,int_stack+80907, 1.0, int_stack+192477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230443,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+79050,int_stack+271006,int_stack+512521, 1.0, int_stack+268801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384956,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+271006,int_stack+79050,int_stack+513466, 1.0, int_stack+269746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388121,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+578321,int_stack+271006,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+281659,int_stack+82916,int_stack+82216, 1.0, int_stack+81936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112336,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+83924,int_stack+82916, 1.0, int_stack+82496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113316,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+79050,int_stack+26250,int_stack+281659, 1.0, int_stack+273106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395685,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+80730,int_stack+84512,int_stack+83924, 1.0, int_stack+83336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114156,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+82494,int_stack+80730,int_stack+26250, 1.0, int_stack+282499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+82494,int_stack+79050, 1.0, int_stack+283759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404175,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+582821,int_stack+512521,int_stack+271006,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+85446,int_stack+85296, 1.0, int_stack+197132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226732, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+85671,int_stack+85446, 1.0, int_stack+197282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226882, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 1.0, int_stack+285439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382301, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+79050,int_stack+85986,int_stack+85671, 1.0, int_stack+197507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227107, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+79995,int_stack+79050,int_stack+512971, 1.0, int_stack+285889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382751, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+79995,int_stack+513646, 1.0, int_stack+286564, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383426, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+86616,int_stack+86406, 1.0, int_stack+199352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229162, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+79050,int_stack+86931,int_stack+86616, 1.0, int_stack+199562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229687, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+79995,int_stack+79050,int_stack+467607, 1.0, int_stack+287464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384326, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+81255,int_stack+87372,int_stack+86931, 1.0, int_stack+199877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230443, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+82578,int_stack+81255,int_stack+79050, 1.0, int_stack+288094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384956, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+84468,int_stack+82578,int_stack+79995, 1.0, int_stack+291259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388121, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+79050,int_stack+84468,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+88940,int_stack+88240, 1.0, int_stack+87960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112336, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+291259,int_stack+89948,int_stack+88940, 1.0, int_stack+88520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113316, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+86568,int_stack+291259,int_stack+26250, 1.0, int_stack+298823, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395685, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+90536,int_stack+89948, 1.0, int_stack+89360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114156, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+88248,int_stack+512521,int_stack+291259, 1.0, int_stack+299663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+88248,int_stack+86568, 1.0, int_stack+308636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404175, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+281659,int_stack+512521,int_stack+84468,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+91470,int_stack+91320, 1.0, int_stack+204532, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226732, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+91695,int_stack+91470, 1.0, int_stack+204682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226882, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 1.0, int_stack+310316, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382301, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+308636,int_stack+92010,int_stack+91695, 1.0, int_stack+204907, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+227107, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+298823,int_stack+308636,int_stack+512971, 1.0, int_stack+310766, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+382751, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+298823,int_stack+513646, 1.0, int_stack+311441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+383426, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+92640,int_stack+92430, 1.0, int_stack+206752, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229162, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+298823,int_stack+92955,int_stack+92640, 1.0, int_stack+206962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229687, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+299768,int_stack+298823,int_stack+467607, 1.0, int_stack+312341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384326, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+308636,int_stack+93396,int_stack+92955, 1.0, int_stack+207277, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+230443, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+309959,int_stack+308636,int_stack+298823, 1.0, int_stack+312971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+384956, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+311849,int_stack+309959,int_stack+299768, 1.0, int_stack+316136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+388121, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+83550,int_stack+311849,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+94964,int_stack+94264, 1.0, int_stack+93984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+112336, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+316136,int_stack+95972,int_stack+94964, 1.0, int_stack+94544, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+113316, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+298823,int_stack+316136,int_stack+26250, 1.0, int_stack+323700, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+395685, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+323700,int_stack+96560,int_stack+95972, 1.0, int_stack+95384, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+114156, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+308636,int_stack+323700,int_stack+316136, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+308636,int_stack+298823, 1.0, int_stack+332190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404175, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+88050,int_stack+512521,int_stack+311849,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+97494,int_stack+97344, 1.0, int_stack+211932, 0.0, zero_stack, 1.0, int_stack+226732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+97719,int_stack+97494, 1.0, int_stack+212082, 0.0, zero_stack, 1.0, int_stack+226882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 1.0, int_stack+333870, 0.0, zero_stack, 1.0, int_stack+382301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+332190,int_stack+98034,int_stack+97719, 1.0, int_stack+212307, 0.0, zero_stack, 1.0, int_stack+227107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+298823,int_stack+332190,int_stack+512971, 1.0, int_stack+334320, 0.0, zero_stack, 1.0, int_stack+382751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+298823,int_stack+513646, 1.0, int_stack+334995, 0.0, zero_stack, 1.0, int_stack+383426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+98664,int_stack+98454, 1.0, int_stack+214152, 0.0, zero_stack, 1.0, int_stack+229162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+298823,int_stack+98979,int_stack+98664, 1.0, int_stack+214362, 0.0, zero_stack, 1.0, int_stack+229687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+0,int_stack+298823,int_stack+467607, 1.0, int_stack+335895, 0.0, zero_stack, 1.0, int_stack+384326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+299768,int_stack+99420,int_stack+98979, 1.0, int_stack+214677, 0.0, zero_stack, 1.0, int_stack+230443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+323700,int_stack+299768,int_stack+298823, 1.0, int_stack+336525, 0.0, zero_stack, 1.0, int_stack+384956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+298823,int_stack+323700,int_stack+0, 1.0, int_stack+339690, 0.0, zero_stack, 1.0, int_stack+388121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+332190,int_stack+298823,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+100988,int_stack+100288, 1.0, int_stack+100008, 0.0, zero_stack, 1.0, int_stack+112336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+101996,int_stack+100988, 1.0, int_stack+100568, 0.0, zero_stack, 1.0, int_stack+113316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+323700,int_stack+0,int_stack+26250, 1.0, int_stack+347254, 0.0, zero_stack, 1.0, int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+102584,int_stack+101996, 1.0, int_stack+101408, 0.0, zero_stack, 1.0, int_stack+114156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+308636,int_stack+512521,int_stack+0, 1.0, int_stack+348094, 0.0, zero_stack, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+308636,int_stack+323700, 1.0, int_stack+357067, 0.0, zero_stack, 1.0, int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+94350,int_stack+512521,int_stack+298823,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+298823,int_stack+103518,int_stack+103368, 1.0, int_stack+219332, 1.0, int_stack+226732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+299273,int_stack+103743,int_stack+103518, 1.0, int_stack+219482, 1.0, int_stack+226882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+299948,int_stack+299273,int_stack+298823, 1.0, int_stack+358747, 1.0, int_stack+382301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+300848,int_stack+104058,int_stack+103743, 1.0, int_stack+219707, 1.0, int_stack+227107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+300848,int_stack+299273, 1.0, int_stack+359197, 1.0, int_stack+382751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+299948, 1.0, int_stack+359872, 1.0, int_stack+383426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+104688,int_stack+104478, 1.0, int_stack+221552, 1.0, int_stack+229162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+105003,int_stack+104688, 1.0, int_stack+221762, 1.0, int_stack+229687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+467607, 1.0, int_stack+360772, 1.0, int_stack+384326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+513466,int_stack+105444,int_stack+105003, 1.0, int_stack+222077, 1.0, int_stack+230443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+323700,int_stack+513466,int_stack+512521, 1.0, int_stack+361402, 1.0, int_stack+384956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+323700,int_stack+0, 1.0, int_stack+364567, 1.0, int_stack+388121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+357067,int_stack+512521,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+107012,int_stack+106312, 1.0, int_stack+106032, 1.0, int_stack+112336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+108020,int_stack+107012, 1.0, int_stack+106592, 1.0, int_stack+113316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+323700,int_stack+0,int_stack+26250, 1.0, int_stack+372131, 1.0, int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+108608,int_stack+108020, 1.0, int_stack+107432, 1.0, int_stack+114156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+298823,int_stack+372131,int_stack+0, 1.0, int_stack+1260, 1.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+308636,int_stack+298823,int_stack+323700, 1.0, int_stack+380621, 1.0, int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+100650,int_stack+308636,int_stack+512521,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+109542,int_stack+109392, 2.0, int_stack+226732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+109767,int_stack+109542, 2.0, int_stack+226882, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 2.0, int_stack+382301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+308636,int_stack+110082,int_stack+109767, 2.0, int_stack+227107, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+309581,int_stack+308636,int_stack+512971, 2.0, int_stack+382751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+309581,int_stack+513646, 2.0, int_stack+383426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+110712,int_stack+110502, 2.0, int_stack+229162, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+308636,int_stack+111027,int_stack+110712, 2.0, int_stack+229687, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+309581,int_stack+308636,int_stack+467607, 2.0, int_stack+384326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+310841,int_stack+111468,int_stack+111027, 2.0, int_stack+230443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+323700,int_stack+310841,int_stack+308636, 2.0, int_stack+384956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+310841,int_stack+323700,int_stack+309581, 2.0, int_stack+388121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+380621,int_stack+310841,int_stack+26250,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+113736,int_stack+112616, 2.0, int_stack+112336, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+388121,int_stack+114744,int_stack+113736, 2.0, int_stack+113316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+323700,int_stack+388121,int_stack+26250, 2.0, int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+308636,int_stack+115332,int_stack+114744, 2.0, int_stack+114156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+308636,int_stack+388121, 2.0, int_stack+2520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+323700, 2.0, int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+106950,int_stack+512521,int_stack+310841,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+116266,int_stack+116116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236386,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+116491,int_stack+116266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236536,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+404175,int_stack+116806,int_stack+116491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236761,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+323700,int_stack+404175,int_stack+512971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267991,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+323700,int_stack+513646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410355,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+117436,int_stack+117226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238606,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+323700,int_stack+117751,int_stack+117436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238816,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+323700,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+118192,int_stack+117751, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239131,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+512521,int_stack+323700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396525,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+372131,int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+308636,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+395685,int_stack+119060,int_stack+118780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142460,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+119480,int_stack+119060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143020,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419239,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+120068,int_stack+119480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143860,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+228952,int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427729,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+113250,int_stack+0,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+274219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+121002,int_stack+120852, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236386, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+121227,int_stack+121002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236536, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+121542,int_stack+121227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236761, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+512971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267991, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+945,int_stack+513646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410355, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+122172,int_stack+121962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238606, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+122487,int_stack+122172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238816, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+122928,int_stack+122487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239131, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+2205,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396525, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+372131,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+268666,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+289759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+395685,int_stack+123796,int_stack+123516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142460, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+124216,int_stack+123796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143020, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419239, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+124804,int_stack+124216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143860, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+228952,int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427729, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+589121,int_stack+0,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+125738,int_stack+125588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236386, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+125963,int_stack+125738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236536, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+126278,int_stack+125963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236761, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+512971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267991, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+945,int_stack+513646, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410355, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+126908,int_stack+126698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238606, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+127223,int_stack+126908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238816, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+127664,int_stack+127223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239131, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+2205,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396525, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+372131,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+119550,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+314636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+395685,int_stack+128532,int_stack+128252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142460, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+128952,int_stack+128532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143020, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419239, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+129540,int_stack+128952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+228952,int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427729, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+595421,int_stack+0,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+325590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+130474,int_stack+130324, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+130699,int_stack+130474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+131014,int_stack+130699, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+512971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+267991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+945,int_stack+513646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+131644,int_stack+131434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+131959,int_stack+131644, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+238816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+132400,int_stack+131959, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+239131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+2205,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+372131,int_stack+945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+124050,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+395685,int_stack+133268,int_stack+132988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+142460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+133688,int_stack+133268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+395685, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+419239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+134276,int_stack+133688, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+228952,int_stack+404175, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+128550,int_stack+0,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+350467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+135210,int_stack+135060, 0.0, zero_stack, 1.0, int_stack+236386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+135435,int_stack+135210, 0.0, zero_stack, 1.0, int_stack+236536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 0.0, zero_stack, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+135750,int_stack+135435, 0.0, zero_stack, 1.0, int_stack+236761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+512971, 0.0, zero_stack, 1.0, int_stack+267991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+945,int_stack+513646, 0.0, zero_stack, 1.0, int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+136380,int_stack+136170, 0.0, zero_stack, 1.0, int_stack+238606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+136695,int_stack+136380, 0.0, zero_stack, 1.0, int_stack+238816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+137136,int_stack+136695, 0.0, zero_stack, 1.0, int_stack+239131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+2205,int_stack+0, 0.0, zero_stack, 1.0, int_stack+396525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+372131,int_stack+945, 0.0, zero_stack, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+601721,int_stack+512521,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+395685,int_stack+138004,int_stack+137724, 0.0, zero_stack, 1.0, int_stack+142460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+138424,int_stack+138004, 0.0, zero_stack, 1.0, int_stack+143020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+395685, 0.0, zero_stack, 1.0, int_stack+419239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+139012,int_stack+138424, 0.0, zero_stack, 1.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+228952,int_stack+404175, 0.0, zero_stack, 1.0, int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+606221,int_stack+0,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+374021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+139946,int_stack+139796, 1.0, int_stack+236386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+140171,int_stack+139946, 1.0, int_stack+236536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521, 1.0, int_stack+267541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+140486,int_stack+140171, 1.0, int_stack+236761, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+512971, 1.0, int_stack+267991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+945,int_stack+513646, 1.0, int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+141116,int_stack+140906, 1.0, int_stack+238606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+141431,int_stack+141116, 1.0, int_stack+238816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+467607, 1.0, int_stack+3780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+141872,int_stack+141431, 1.0, int_stack+239131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+2205,int_stack+0, 1.0, int_stack+396525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+2205,int_stack+372131,int_stack+945, 1.0, int_stack+263746, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+134850,int_stack+2205,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+386621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+143440,int_stack+142740, 1.0, int_stack+142460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+372131,int_stack+144448,int_stack+143440, 1.0, int_stack+143020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+372131,int_stack+26250, 1.0, int_stack+419239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+419239,int_stack+145036,int_stack+144448, 1.0, int_stack+143860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+419239,int_stack+372131, 1.0, int_stack+259696, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+228952,int_stack+404175, 1.0, int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+259696,int_stack+512521,int_stack+2205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+397575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+145970,int_stack+145820,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+146195,int_stack+145970,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+512971,int_stack+512521,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+513646,int_stack+146510,int_stack+146195,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+427729,int_stack+513646,int_stack+512971,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+427729,int_stack+410355,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+147140,int_stack+146930,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+427729,int_stack+147455,int_stack+147140,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+512521,int_stack+427729,int_stack+467607,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+513781,int_stack+147896,int_stack+147455,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+513781,int_stack+427729,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+512521,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+139350,int_stack+228952,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+411255, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+148764,int_stack+148484,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+149184,int_stack+148764,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+512521,int_stack+26250,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+372131,int_stack+149772,int_stack+149184,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+372131,int_stack+512521,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+427729,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+143850,int_stack+512521,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+421129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+150706,int_stack+150556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243786,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+150931,int_stack+150706, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243936,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429409,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+151246,int_stack+150931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244161,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429859,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430534,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+151876,int_stack+151666, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246006,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+152191,int_stack+151876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246216,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431434,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+152632,int_stack+152191, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246531,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432064,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435229,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+612521,int_stack+228952,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+266041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+153500,int_stack+153220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+372131,int_stack+153920,int_stack+153500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177460,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442793,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+154508,int_stack+153920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178300,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+372131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451283,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+617021,int_stack+512521,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+274219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+155442,int_stack+155292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243786, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+155667,int_stack+155442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243936, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429409, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+155982,int_stack+155667, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244161, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429859, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430534, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+156612,int_stack+156402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246006, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+156927,int_stack+156612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246216, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431434, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+157368,int_stack+156927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246531, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432064, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435229, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+150150,int_stack+228952,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+289759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+158236,int_stack+157956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+372131,int_stack+158656,int_stack+158236, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177460, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442793, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+159244,int_stack+158656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178300, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+372131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451283, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+623321,int_stack+512521,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+302036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+160178,int_stack+160028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243786, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+160403,int_stack+160178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243936, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429409, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+160718,int_stack+160403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244161, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429859, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430534, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+161348,int_stack+161138, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246006, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+161663,int_stack+161348, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246216, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431434, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+162104,int_stack+161663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246531, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432064, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435229, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+154650,int_stack+228952,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+314636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+162972,int_stack+162692, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+372131,int_stack+163392,int_stack+162972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177460, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442793, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+163980,int_stack+163392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178300, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+372131, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451283, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+629621,int_stack+512521,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+325590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+164914,int_stack+164764, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+165139,int_stack+164914, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+165454,int_stack+165139, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+166084,int_stack+165874, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+166399,int_stack+166084, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+166840,int_stack+166399, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+435229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+159150,int_stack+228952,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+338190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+167708,int_stack+167428, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+372131,int_stack+168128,int_stack+167708, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+177460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+372131,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+168716,int_stack+168128, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+178300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+372131, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+427729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+635921,int_stack+512521,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+350467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+169650,int_stack+169500, 0.0, zero_stack, 1.0, int_stack+243786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+169875,int_stack+169650, 0.0, zero_stack, 1.0, int_stack+243936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+429409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+170190,int_stack+169875, 0.0, zero_stack, 1.0, int_stack+244161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 1.0, int_stack+429859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 1.0, int_stack+430534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+170820,int_stack+170610, 0.0, zero_stack, 1.0, int_stack+246006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+171135,int_stack+170820, 0.0, zero_stack, 1.0, int_stack+246216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+431434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+171576,int_stack+171135, 0.0, zero_stack, 1.0, int_stack+246531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+228952,int_stack+512521, 0.0, zero_stack, 1.0, int_stack+432064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+513466, 0.0, zero_stack, 1.0, int_stack+435229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+163650,int_stack+228952,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+363067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+172444,int_stack+172164, 0.0, zero_stack, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+372131,int_stack+172864,int_stack+172444, 0.0, zero_stack, 1.0, int_stack+177460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+427729,int_stack+372131,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+173452,int_stack+172864, 0.0, zero_stack, 1.0, int_stack+178300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+372131, 0.0, zero_stack, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+0,int_stack+427729, 0.0, zero_stack, 1.0, int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+642221,int_stack+512521,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+374021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+174386,int_stack+174236, 1.0, int_stack+243786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+174611,int_stack+174386, 1.0, int_stack+243936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 1.0, int_stack+429409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+174926,int_stack+174611, 1.0, int_stack+244161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 1.0, int_stack+429859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 1.0, int_stack+430534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+175556,int_stack+175346, 1.0, int_stack+246006, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+175871,int_stack+175556, 1.0, int_stack+246216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 1.0, int_stack+431434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+176312,int_stack+175871, 1.0, int_stack+246531, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+372131,int_stack+228952,int_stack+512521, 1.0, int_stack+432064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+372131,int_stack+513466, 1.0, int_stack+435229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+427729,int_stack+228952,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+386621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+177880,int_stack+177180, 1.0, int_stack+176900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+435229,int_stack+178888,int_stack+177880, 1.0, int_stack+177460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+435229,int_stack+26250, 1.0, int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+442793,int_stack+179476,int_stack+178888, 1.0, int_stack+178300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+442793,int_stack+435229, 1.0, int_stack+4410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+0,int_stack+512521,int_stack+404175, 1.0, int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+168150,int_stack+0,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+397575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+180410,int_stack+180260,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+180635,int_stack+180410,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+180950,int_stack+180635,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+230077,int_stack+229402,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+0,int_stack+410355,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+181580,int_stack+181370,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+181895,int_stack+181580,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+945,int_stack+0,int_stack+467607,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2205,int_stack+182336,int_stack+181895,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+2205,int_stack+0,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+2205,int_stack+442793,int_stack+945,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+174450,int_stack+2205,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+411255, 1.0, int_stack+433729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+183204,int_stack+182924,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+442793,int_stack+183624,int_stack+183204,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+26250,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+184212,int_stack+183624,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+228952,int_stack+0,int_stack+442793,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+228952,int_stack+451283,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+648521,int_stack+512521,int_stack+2205, 0.0, zero_stack, 1.0, int_stack+421129, 1.0, int_stack+444683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+185146,int_stack+184996,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+185371,int_stack+185146,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+512971,int_stack+512521,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+513646,int_stack+185686,int_stack+185371,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+451283,int_stack+513646,int_stack+512971,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+451283,int_stack+410355,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+186316,int_stack+186106,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+451283,int_stack+186631,int_stack+186316,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+512521,int_stack+451283,int_stack+467607,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+513781,int_stack+187072,int_stack+186631,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+513781,int_stack+451283,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+442793,int_stack+512521,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+0,int_stack+228952,int_stack+26250, 0.0, zero_stack, 2.0, int_stack+433729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+187940,int_stack+187660,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+188360,int_stack+187940,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+512521,int_stack+26250,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+442793,int_stack+188948,int_stack+188360,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+298823,int_stack+442793,int_stack+512521,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+298823,int_stack+451283,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+178950,int_stack+512521,int_stack+228952, 0.0, zero_stack, 2.0, int_stack+444683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+190992,int_stack+190842, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252296,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+191217,int_stack+190992, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252446,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452963,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+191532,int_stack+191217, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252671,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453413,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454088,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+193716,int_stack+193506, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254516,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+194031,int_stack+193716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254726,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454988,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+194472,int_stack+194031, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255041,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455618,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+442793,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458783,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+185250,int_stack+228952,int_stack+26250, 1.0, int_stack+266041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+195340,int_stack+195060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233026,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+442793,int_stack+195760,int_stack+195340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233586,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+196348,int_stack+195760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234426,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+298823,int_stack+512521,int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466347,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+298823,int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5670,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+189750,int_stack+512521,int_stack+228952, 1.0, int_stack+274219, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+198392,int_stack+198242, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252296, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+198617,int_stack+198392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252446, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452963, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+198932,int_stack+198617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252671, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453413, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454088, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+201116,int_stack+200906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254516, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+201431,int_stack+201116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254726, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454988, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+201872,int_stack+201431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255041, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455618, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+442793,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458783, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+196050,int_stack+228952,int_stack+26250, 1.0, int_stack+289759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+202740,int_stack+202460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233026, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+442793,int_stack+203160,int_stack+202740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233586, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+203748,int_stack+203160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234426, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+298823,int_stack+512521,int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466347, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+298823,int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5670, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+654821,int_stack+512521,int_stack+228952, 1.0, int_stack+302036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+205792,int_stack+205642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252296, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+206017,int_stack+205792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252446, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452963, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+206332,int_stack+206017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252671, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453413, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454088, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+208516,int_stack+208306, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254516, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+208831,int_stack+208516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254726, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454988, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+209272,int_stack+208831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255041, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455618, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+442793,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458783, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+298823,int_stack+228952,int_stack+26250, 1.0, int_stack+314636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+210140,int_stack+209860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233026, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+442793,int_stack+210560,int_stack+210140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233586, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+211148,int_stack+210560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234426, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+265996,int_stack+512521,int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466347, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+265996,int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5670, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+200550,int_stack+512521,int_stack+228952, 1.0, int_stack+325590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+213192,int_stack+213042, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+213417,int_stack+213192, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+213732,int_stack+213417, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+252671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+215916,int_stack+215706, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+216231,int_stack+215916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+254726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+454988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+216672,int_stack+216231, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+255041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+228952,int_stack+512521, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+455618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+442793,int_stack+513466, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+458783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+206850,int_stack+228952,int_stack+26250, 1.0, int_stack+338190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+217540,int_stack+217260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+442793,int_stack+217960,int_stack+217540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+233586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+26250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+218548,int_stack+217960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+234426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+265996,int_stack+512521,int_stack+442793, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+466347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+265996,int_stack+451283, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+5670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+211350,int_stack+512521,int_stack+228952, 1.0, int_stack+350467, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+220592,int_stack+220442, 0.0, zero_stack, 1.0, int_stack+252296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+220817,int_stack+220592, 0.0, zero_stack, 1.0, int_stack+252446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 0.0, zero_stack, 1.0, int_stack+452963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+221132,int_stack+220817, 0.0, zero_stack, 1.0, int_stack+252671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 0.0, zero_stack, 1.0, int_stack+453413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 0.0, zero_stack, 1.0, int_stack+454088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+223316,int_stack+223106, 0.0, zero_stack, 1.0, int_stack+254516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+223631,int_stack+223316, 0.0, zero_stack, 1.0, int_stack+254726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 0.0, zero_stack, 1.0, int_stack+454988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+228952,int_stack+224072,int_stack+223631, 0.0, zero_stack, 1.0, int_stack+255041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+228952,int_stack+512521, 0.0, zero_stack, 1.0, int_stack+455618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+228952,int_stack+442793,int_stack+513466, 0.0, zero_stack, 1.0, int_stack+458783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+347254,int_stack+228952,int_stack+26250, 1.0, int_stack+363067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+224940,int_stack+224660, 0.0, zero_stack, 1.0, int_stack+233026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+442793,int_stack+225360,int_stack+224940, 0.0, zero_stack, 1.0, int_stack+233586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+26250, 0.0, zero_stack, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+225948,int_stack+225360, 0.0, zero_stack, 1.0, int_stack+234426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+265996,int_stack+512521,int_stack+442793, 0.0, zero_stack, 1.0, int_stack+466347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+265996,int_stack+451283, 0.0, zero_stack, 1.0, int_stack+5670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+217650,int_stack+512521,int_stack+228952, 1.0, int_stack+374021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+228952,int_stack+227992,int_stack+227842, 1.0, int_stack+252296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+229402,int_stack+228217,int_stack+227992, 1.0, int_stack+252446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+229402,int_stack+228952, 1.0, int_stack+452963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+230077,int_stack+228532,int_stack+228217, 1.0, int_stack+252671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+230077,int_stack+229402, 1.0, int_stack+453413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+512521,int_stack+410355, 1.0, int_stack+454088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+467607,int_stack+231682,int_stack+231472, 1.0, int_stack+254516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+512521,int_stack+231997,int_stack+231682, 1.0, int_stack+254726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+513466,int_stack+512521,int_stack+467607, 1.0, int_stack+454988, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+451283,int_stack+232438,int_stack+231997, 1.0, int_stack+255041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+442793,int_stack+451283,int_stack+512521, 1.0, int_stack+455618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+451283,int_stack+442793,int_stack+513466, 1.0, int_stack+458783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+223950,int_stack+451283,int_stack+26250, 1.0, int_stack+386621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   d1hrr3_build_fp(Libderiv->CD,int_stack+26250,int_stack+234006,int_stack+233306, 1.0, int_stack+233026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+458783,int_stack+235014,int_stack+234006, 1.0, int_stack+233586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|fd) ---*/
   d1hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+458783,int_stack+26250, 1.0, int_stack+280819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+442793,int_stack+235602,int_stack+235014, 1.0, int_stack+234426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+512521,int_stack+442793,int_stack+458783, 1.0, int_stack+466347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ff) ---*/
   d1hrr3_build_ff(Libderiv->CD,int_stack+453383,int_stack+512521,int_stack+404175, 1.0, int_stack+5670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+228450,int_stack+453383,int_stack+451283, 1.0, int_stack+397575, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+451283,int_stack+237646,int_stack+237496,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+451733,int_stack+237871,int_stack+237646,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+410355,int_stack+451733,int_stack+451283,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+452408,int_stack+238186,int_stack+237871,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+453353,int_stack+452408,int_stack+451733,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+453353,int_stack+410355,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+410355,int_stack+240370,int_stack+240160,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+451283,int_stack+240685,int_stack+240370,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+452228,int_stack+451283,int_stack+410355,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+453488,int_stack+241126,int_stack+240685,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+466347,int_stack+453488,int_stack+451283,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+453488,int_stack+466347,int_stack+452228,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+234750,int_stack+453488,int_stack+26250, 1.0, int_stack+411255, 0.0, zero_stack, 1.0, int_stack+457283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+280819,int_stack+241994,int_stack+241714,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+242414,int_stack+241994,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+280819,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+466347,int_stack+243002,int_stack+242414,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+410355,int_stack+466347,int_stack+26250,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+410355,int_stack+404175,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+661121,int_stack+512521,int_stack+453488, 1.0, int_stack+421129, 0.0, zero_stack, 1.0, int_stack+468237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+245046,int_stack+244896,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+245271,int_stack+245046,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+404175,int_stack+245586,int_stack+245271,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+410355,int_stack+404175,int_stack+512971,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+410355,int_stack+513646,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+410355,int_stack+247770,int_stack+247560,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+410985,int_stack+248085,int_stack+247770,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+410985,int_stack+410355,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+248526,int_stack+248085,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+466347,int_stack+512521,int_stack+410985,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+466347,int_stack+404175,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+451283,int_stack+512521,int_stack+26250, 1.0, int_stack+433729, 1.0, int_stack+457283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+280819,int_stack+249394,int_stack+249114,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+249814,int_stack+249394,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+280819,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+466347,int_stack+250402,int_stack+249814,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+410355,int_stack+466347,int_stack+26250,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+4500,int_stack+410355,int_stack+404175,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+239250,int_stack+4500,int_stack+512521, 1.0, int_stack+444683, 1.0, int_stack+468237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (g0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+512521,int_stack+253556,int_stack+253406,15);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+512971,int_stack+253781,int_stack+253556,15);
 /*--- compute (g0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+513646,int_stack+512971,int_stack+512521,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+4500,int_stack+254096,int_stack+253781,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+5445,int_stack+4500,int_stack+512971,15);
 /*--- compute (g0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+26250,int_stack+5445,int_stack+513646,15);
 /*--- compute (h0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+4500,int_stack+256280,int_stack+256070,21);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+5130,int_stack+256595,int_stack+256280,21);
 /*--- compute (h0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+6075,int_stack+5130,int_stack+4500,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+512521,int_stack+257036,int_stack+256595,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+466347,int_stack+512521,int_stack+5130,21);
 /*--- compute (h0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+512521,int_stack+466347,int_stack+6075,21);
 /*--- compute (gp|ff) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+245550,int_stack+512521,int_stack+26250, 2.0, int_stack+457283, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (i0|fp) ---*/
   hrr3_build_fp(Libderiv->CD,int_stack+280819,int_stack+257904,int_stack+257624,28);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+26250,int_stack+258324,int_stack+257904,28);
 /*--- compute (i0|fd) ---*/
   hrr3_build_fd(Libderiv->CD,int_stack+404175,int_stack+26250,int_stack+280819,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+466347,int_stack+258912,int_stack+258324,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+4500,int_stack+466347,int_stack+26250,28);
 /*--- compute (i0|ff) ---*/
   hrr3_build_ff(Libderiv->CD,int_stack+455783,int_stack+4500,int_stack+404175,28);
 /*--- compute (hp|ff) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+250050,int_stack+455783,int_stack+512521, 2.0, int_stack+468237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+667421,int_stack+292523,int_stack+276319,100);
     Libderiv->ABCD[11] = int_stack + 667421;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+287959,int_stack+317400,int_stack+304136,100);
     Libderiv->ABCD[10] = int_stack + 287959;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+313136,int_stack+340954,int_stack+327690,100);
     Libderiv->ABCD[9] = int_stack + 313136;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+336690,int_stack+365831,int_stack+352567,100);
     Libderiv->ABCD[8] = int_stack + 336690;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+361567,int_stack+389385,int_stack+376121,100);
     Libderiv->ABCD[7] = int_stack + 361567;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+385121,int_stack+412939,int_stack+399675,100);
     Libderiv->ABCD[6] = int_stack + 385121;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+410355,int_stack+436493,int_stack+423229, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+405855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[2] = int_stack + 410355;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+432229,int_stack+460047,int_stack+446783, 0.0, zero_stack, 1.0, int_stack+405855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[1] = int_stack + 432229;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+455783,int_stack+481921,int_stack+470337, 1.0, int_stack+405855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[0] = int_stack + 455783;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+676421,int_stack+492721,int_stack+488221,100);
     Libderiv->ABCD[155] = int_stack + 676421;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+479337,int_stack+7350,int_stack+474837,100);
     Libderiv->ABCD[143] = int_stack + 479337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+4500,int_stack+13650,int_stack+499021,100);
     Libderiv->ABCD[142] = int_stack + 4500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+488337,int_stack+19950,int_stack+503521,100);
     Libderiv->ABCD[131] = int_stack + 488337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+13500,int_stack+515321,int_stack+508021,100);
     Libderiv->ABCD[130] = int_stack + 13500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+497337,int_stack+521621,int_stack+27750,100);
     Libderiv->ABCD[129] = int_stack + 497337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+22500,int_stack+527921,int_stack+32250,100);
     Libderiv->ABCD[119] = int_stack + 22500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+506337,int_stack+534221,int_stack+36750,100);
     Libderiv->ABCD[118] = int_stack + 506337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+31500,int_stack+540521,int_stack+41250,100);
     Libderiv->ABCD[117] = int_stack + 31500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+515337,int_stack+546821,int_stack+45750,100);
     Libderiv->ABCD[116] = int_stack + 515337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+40500,int_stack+553121,int_stack+50250,100);
     Libderiv->ABCD[107] = int_stack + 40500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+524337,int_stack+559421,int_stack+54750,100);
     Libderiv->ABCD[106] = int_stack + 524337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+49500,int_stack+565721,int_stack+59250,100);
     Libderiv->ABCD[105] = int_stack + 49500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+533337,int_stack+572021,int_stack+63750,100);
     Libderiv->ABCD[104] = int_stack + 533337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+58500,int_stack+72750,int_stack+68250,100);
     Libderiv->ABCD[103] = int_stack + 58500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+67500,int_stack+582821,int_stack+578321,100);
     Libderiv->ABCD[95] = int_stack + 67500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+542337,int_stack+281659,int_stack+79050,100);
     Libderiv->ABCD[94] = int_stack + 542337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+551337,int_stack+88050,int_stack+83550,100);
     Libderiv->ABCD[93] = int_stack + 551337;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+76500,int_stack+94350,int_stack+332190,100);
     Libderiv->ABCD[92] = int_stack + 76500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+85500,int_stack+100650,int_stack+357067,100);
     Libderiv->ABCD[91] = int_stack + 85500;
 /*--- compute (gd|ff) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+94500,int_stack+106950,int_stack+380621,100);
     Libderiv->ABCD[90] = int_stack + 94500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+103500,int_stack+113250,int_stack+308636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+276319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[47] = int_stack + 103500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+560337,int_stack+589121,int_stack+268666, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+304136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[46] = int_stack + 560337;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+265996,int_stack+595421,int_stack+119550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+327690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[45] = int_stack + 265996;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+112500,int_stack+128550,int_stack+124050, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+352567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[44] = int_stack + 112500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+121500,int_stack+606221,int_stack+601721, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+376121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[43] = int_stack + 121500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+569337,int_stack+259696,int_stack+134850, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+399675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[42] = int_stack + 569337;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+256350,int_stack+143850,int_stack+139350, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+423229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[38] = int_stack + 256350;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+130500,int_stack+617021,int_stack+612521, 0.0, zero_stack, 1.0, int_stack+276319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[35] = int_stack + 130500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+139500,int_stack+623321,int_stack+150150, 0.0, zero_stack, 1.0, int_stack+304136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[34] = int_stack + 139500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+578337,int_stack+629621,int_stack+154650, 0.0, zero_stack, 1.0, int_stack+327690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[33] = int_stack + 578337;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+148500,int_stack+635921,int_stack+159150, 0.0, zero_stack, 1.0, int_stack+352567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[32] = int_stack + 148500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+587337,int_stack+642221,int_stack+163650, 0.0, zero_stack, 1.0, int_stack+376121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[31] = int_stack + 587337;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+157500,int_stack+168150,int_stack+427729, 0.0, zero_stack, 1.0, int_stack+399675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[30] = int_stack + 157500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+596337,int_stack+648521,int_stack+174450, 0.0, zero_stack, 1.0, int_stack+423229, 1.0, int_stack+446783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[26] = int_stack + 596337;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+166500,int_stack+178950,int_stack+0, 0.0, zero_stack, 2.0, int_stack+446783, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[25] = int_stack + 166500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+175500,int_stack+189750,int_stack+185250, 1.0, int_stack+276319, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[23] = int_stack + 175500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+184500,int_stack+654821,int_stack+196050, 1.0, int_stack+304136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[22] = int_stack + 184500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+274996,int_stack+200550,int_stack+298823, 1.0, int_stack+327690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[21] = int_stack + 274996;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+193500,int_stack+211350,int_stack+206850, 1.0, int_stack+352567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[20] = int_stack + 193500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+202500,int_stack+217650,int_stack+347254, 1.0, int_stack+376121, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[19] = int_stack + 202500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+211500,int_stack+228450,int_stack+223950, 1.0, int_stack+399675, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[18] = int_stack + 211500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+220500,int_stack+661121,int_stack+234750, 1.0, int_stack+423229, 0.0, zero_stack, 1.0, int_stack+470337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[14] = int_stack + 220500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+229500,int_stack+239250,int_stack+451283, 1.0, int_stack+446783, 1.0, int_stack+470337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[13] = int_stack + 229500;
 /*--- compute (gd|ff) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+419355,int_stack+250050,int_stack+245550, 2.0, int_stack+470337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,100);
     Libderiv->ABCD[12] = int_stack + 419355;

}
