/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d12vrr_order_gfgg(Libderiv_t *, prim_data *);

  /* Computes derivatives of (gf|gg) integrals */

void d12hrr_order_gfgg(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[7][8][11] = int_stack + 0;
 Libderiv->deriv_classes[7][8][10] = int_stack + 1620;
 Libderiv->deriv_classes[7][8][9] = int_stack + 3240;
 Libderiv->deriv_classes[7][8][8] = int_stack + 4860;
 Libderiv->deriv_classes[7][8][7] = int_stack + 6480;
 Libderiv->dvrr_classes[7][7] = int_stack + 8100;
 Libderiv->deriv_classes[7][8][6] = int_stack + 9396;
 Libderiv->deriv_classes[7][8][2] = int_stack + 11016;
 Libderiv->deriv_classes[7][8][1] = int_stack + 12636;
 Libderiv->dvrr_classes[6][8] = int_stack + 14256;
 Libderiv->deriv_classes[7][8][0] = int_stack + 15516;
 Libderiv->deriv2_classes[4][4][143] = int_stack + 17136;
 Libderiv->deriv2_classes[4][5][143] = int_stack + 17361;
 Libderiv->deriv2_classes[4][6][143] = int_stack + 17676;
 Libderiv->deriv2_classes[4][7][143] = int_stack + 18096;
 Libderiv->deriv2_classes[4][8][143] = int_stack + 18636;
 Libderiv->deriv2_classes[5][4][143] = int_stack + 19311;
 Libderiv->deriv2_classes[5][5][143] = int_stack + 19626;
 Libderiv->deriv2_classes[5][6][143] = int_stack + 20067;
 Libderiv->deriv2_classes[5][7][143] = int_stack + 20655;
 Libderiv->deriv2_classes[5][8][143] = int_stack + 21411;
 Libderiv->deriv2_classes[6][4][143] = int_stack + 22356;
 Libderiv->deriv2_classes[6][5][143] = int_stack + 22776;
 Libderiv->deriv2_classes[6][6][143] = int_stack + 23364;
 Libderiv->deriv2_classes[6][7][143] = int_stack + 24148;
 Libderiv->deriv2_classes[6][8][143] = int_stack + 25156;
 Libderiv->deriv2_classes[7][4][143] = int_stack + 26416;
 Libderiv->deriv2_classes[7][5][143] = int_stack + 26956;
 Libderiv->deriv2_classes[7][6][143] = int_stack + 27712;
 Libderiv->deriv2_classes[7][7][143] = int_stack + 28720;
 Libderiv->deriv2_classes[7][8][143] = int_stack + 30016;
 Libderiv->deriv2_classes[4][4][131] = int_stack + 31636;
 Libderiv->deriv2_classes[4][5][131] = int_stack + 31861;
 Libderiv->deriv2_classes[4][6][131] = int_stack + 32176;
 Libderiv->deriv2_classes[4][7][131] = int_stack + 32596;
 Libderiv->deriv2_classes[4][8][131] = int_stack + 33136;
 Libderiv->deriv2_classes[5][4][131] = int_stack + 33811;
 Libderiv->deriv2_classes[5][5][131] = int_stack + 34126;
 Libderiv->deriv2_classes[5][6][131] = int_stack + 34567;
 Libderiv->deriv2_classes[5][7][131] = int_stack + 35155;
 Libderiv->deriv2_classes[5][8][131] = int_stack + 35911;
 Libderiv->deriv2_classes[6][4][131] = int_stack + 36856;
 Libderiv->deriv2_classes[6][5][131] = int_stack + 37276;
 Libderiv->deriv2_classes[6][6][131] = int_stack + 37864;
 Libderiv->deriv2_classes[6][7][131] = int_stack + 38648;
 Libderiv->deriv2_classes[6][8][131] = int_stack + 39656;
 Libderiv->deriv2_classes[7][4][131] = int_stack + 40916;
 Libderiv->deriv2_classes[7][5][131] = int_stack + 41456;
 Libderiv->deriv2_classes[7][6][131] = int_stack + 42212;
 Libderiv->deriv2_classes[7][7][131] = int_stack + 43220;
 Libderiv->deriv2_classes[7][8][131] = int_stack + 44516;
 Libderiv->deriv2_classes[4][4][130] = int_stack + 46136;
 Libderiv->deriv2_classes[4][5][130] = int_stack + 46361;
 Libderiv->deriv2_classes[4][6][130] = int_stack + 46676;
 Libderiv->deriv2_classes[4][7][130] = int_stack + 47096;
 Libderiv->deriv2_classes[4][8][130] = int_stack + 47636;
 Libderiv->deriv2_classes[5][4][130] = int_stack + 48311;
 Libderiv->deriv2_classes[5][5][130] = int_stack + 48626;
 Libderiv->deriv2_classes[5][6][130] = int_stack + 49067;
 Libderiv->deriv2_classes[5][7][130] = int_stack + 49655;
 Libderiv->deriv2_classes[5][8][130] = int_stack + 50411;
 Libderiv->deriv2_classes[6][4][130] = int_stack + 51356;
 Libderiv->deriv2_classes[6][5][130] = int_stack + 51776;
 Libderiv->deriv2_classes[6][6][130] = int_stack + 52364;
 Libderiv->deriv2_classes[6][7][130] = int_stack + 53148;
 Libderiv->deriv2_classes[6][8][130] = int_stack + 54156;
 Libderiv->deriv2_classes[7][4][130] = int_stack + 55416;
 Libderiv->deriv2_classes[7][5][130] = int_stack + 55956;
 Libderiv->deriv2_classes[7][6][130] = int_stack + 56712;
 Libderiv->deriv2_classes[7][7][130] = int_stack + 57720;
 Libderiv->deriv2_classes[7][8][130] = int_stack + 59016;
 Libderiv->deriv2_classes[4][4][119] = int_stack + 60636;
 Libderiv->deriv2_classes[4][5][119] = int_stack + 60861;
 Libderiv->deriv2_classes[4][6][119] = int_stack + 61176;
 Libderiv->deriv2_classes[4][7][119] = int_stack + 61596;
 Libderiv->deriv2_classes[4][8][119] = int_stack + 62136;
 Libderiv->deriv2_classes[5][4][119] = int_stack + 62811;
 Libderiv->deriv2_classes[5][5][119] = int_stack + 63126;
 Libderiv->deriv2_classes[5][6][119] = int_stack + 63567;
 Libderiv->deriv2_classes[5][7][119] = int_stack + 64155;
 Libderiv->deriv2_classes[5][8][119] = int_stack + 64911;
 Libderiv->deriv2_classes[6][4][119] = int_stack + 65856;
 Libderiv->deriv2_classes[6][5][119] = int_stack + 66276;
 Libderiv->deriv2_classes[6][6][119] = int_stack + 66864;
 Libderiv->deriv2_classes[6][7][119] = int_stack + 67648;
 Libderiv->deriv2_classes[6][8][119] = int_stack + 68656;
 Libderiv->deriv2_classes[7][4][119] = int_stack + 69916;
 Libderiv->deriv2_classes[7][5][119] = int_stack + 70456;
 Libderiv->deriv2_classes[7][6][119] = int_stack + 71212;
 Libderiv->deriv2_classes[7][7][119] = int_stack + 72220;
 Libderiv->deriv2_classes[7][8][119] = int_stack + 73516;
 Libderiv->deriv2_classes[4][4][118] = int_stack + 75136;
 Libderiv->deriv2_classes[4][5][118] = int_stack + 75361;
 Libderiv->deriv2_classes[4][6][118] = int_stack + 75676;
 Libderiv->deriv2_classes[4][7][118] = int_stack + 76096;
 Libderiv->deriv2_classes[4][8][118] = int_stack + 76636;
 Libderiv->deriv2_classes[5][4][118] = int_stack + 77311;
 Libderiv->deriv2_classes[5][5][118] = int_stack + 77626;
 Libderiv->deriv2_classes[5][6][118] = int_stack + 78067;
 Libderiv->deriv2_classes[5][7][118] = int_stack + 78655;
 Libderiv->deriv2_classes[5][8][118] = int_stack + 79411;
 Libderiv->deriv2_classes[6][4][118] = int_stack + 80356;
 Libderiv->deriv2_classes[6][5][118] = int_stack + 80776;
 Libderiv->deriv2_classes[6][6][118] = int_stack + 81364;
 Libderiv->deriv2_classes[6][7][118] = int_stack + 82148;
 Libderiv->deriv2_classes[6][8][118] = int_stack + 83156;
 Libderiv->deriv2_classes[7][4][118] = int_stack + 84416;
 Libderiv->deriv2_classes[7][5][118] = int_stack + 84956;
 Libderiv->deriv2_classes[7][6][118] = int_stack + 85712;
 Libderiv->deriv2_classes[7][7][118] = int_stack + 86720;
 Libderiv->deriv2_classes[7][8][118] = int_stack + 88016;
 Libderiv->deriv2_classes[4][4][117] = int_stack + 89636;
 Libderiv->deriv2_classes[4][5][117] = int_stack + 89861;
 Libderiv->deriv2_classes[4][6][117] = int_stack + 90176;
 Libderiv->deriv2_classes[4][7][117] = int_stack + 90596;
 Libderiv->deriv2_classes[4][8][117] = int_stack + 91136;
 Libderiv->deriv2_classes[5][4][117] = int_stack + 91811;
 Libderiv->deriv2_classes[5][5][117] = int_stack + 92126;
 Libderiv->deriv2_classes[5][6][117] = int_stack + 92567;
 Libderiv->deriv2_classes[5][7][117] = int_stack + 93155;
 Libderiv->deriv2_classes[5][8][117] = int_stack + 93911;
 Libderiv->deriv2_classes[6][4][117] = int_stack + 94856;
 Libderiv->deriv2_classes[6][5][117] = int_stack + 95276;
 Libderiv->deriv2_classes[6][6][117] = int_stack + 95864;
 Libderiv->deriv2_classes[6][7][117] = int_stack + 96648;
 Libderiv->deriv2_classes[6][8][117] = int_stack + 97656;
 Libderiv->deriv2_classes[7][4][117] = int_stack + 98916;
 Libderiv->deriv2_classes[7][5][117] = int_stack + 99456;
 Libderiv->deriv2_classes[7][6][117] = int_stack + 100212;
 Libderiv->deriv2_classes[7][7][117] = int_stack + 101220;
 Libderiv->deriv2_classes[7][8][117] = int_stack + 102516;
 Libderiv->deriv2_classes[4][4][107] = int_stack + 104136;
 Libderiv->deriv2_classes[4][5][107] = int_stack + 104361;
 Libderiv->deriv2_classes[4][6][107] = int_stack + 104676;
 Libderiv->deriv2_classes[4][7][107] = int_stack + 105096;
 Libderiv->deriv2_classes[4][8][107] = int_stack + 105636;
 Libderiv->deriv2_classes[5][4][107] = int_stack + 106311;
 Libderiv->deriv2_classes[5][5][107] = int_stack + 106626;
 Libderiv->deriv2_classes[5][6][107] = int_stack + 107067;
 Libderiv->deriv2_classes[5][7][107] = int_stack + 107655;
 Libderiv->deriv2_classes[5][8][107] = int_stack + 108411;
 Libderiv->deriv2_classes[6][4][107] = int_stack + 109356;
 Libderiv->deriv2_classes[6][5][107] = int_stack + 109776;
 Libderiv->deriv2_classes[6][6][107] = int_stack + 110364;
 Libderiv->deriv2_classes[6][7][107] = int_stack + 111148;
 Libderiv->deriv2_classes[6][8][107] = int_stack + 112156;
 Libderiv->deriv2_classes[7][4][107] = int_stack + 113416;
 Libderiv->deriv2_classes[7][5][107] = int_stack + 113956;
 Libderiv->deriv2_classes[7][6][107] = int_stack + 114712;
 Libderiv->deriv2_classes[7][7][107] = int_stack + 115720;
 Libderiv->deriv2_classes[7][8][107] = int_stack + 117016;
 Libderiv->deriv2_classes[4][4][106] = int_stack + 118636;
 Libderiv->deriv2_classes[4][5][106] = int_stack + 118861;
 Libderiv->deriv2_classes[4][6][106] = int_stack + 119176;
 Libderiv->deriv2_classes[4][7][106] = int_stack + 119596;
 Libderiv->deriv2_classes[4][8][106] = int_stack + 120136;
 Libderiv->deriv2_classes[5][4][106] = int_stack + 120811;
 Libderiv->deriv2_classes[5][5][106] = int_stack + 121126;
 Libderiv->deriv2_classes[5][6][106] = int_stack + 121567;
 Libderiv->deriv2_classes[5][7][106] = int_stack + 122155;
 Libderiv->deriv2_classes[5][8][106] = int_stack + 122911;
 Libderiv->deriv2_classes[6][4][106] = int_stack + 123856;
 Libderiv->deriv2_classes[6][5][106] = int_stack + 124276;
 Libderiv->deriv2_classes[6][6][106] = int_stack + 124864;
 Libderiv->deriv2_classes[6][7][106] = int_stack + 125648;
 Libderiv->deriv2_classes[6][8][106] = int_stack + 126656;
 Libderiv->deriv2_classes[7][4][106] = int_stack + 127916;
 Libderiv->deriv2_classes[7][5][106] = int_stack + 128456;
 Libderiv->deriv2_classes[7][6][106] = int_stack + 129212;
 Libderiv->deriv2_classes[7][7][106] = int_stack + 130220;
 Libderiv->deriv2_classes[7][8][106] = int_stack + 131516;
 Libderiv->deriv2_classes[4][4][105] = int_stack + 133136;
 Libderiv->deriv2_classes[4][5][105] = int_stack + 133361;
 Libderiv->deriv2_classes[4][6][105] = int_stack + 133676;
 Libderiv->deriv2_classes[4][7][105] = int_stack + 134096;
 Libderiv->deriv2_classes[4][8][105] = int_stack + 134636;
 Libderiv->deriv2_classes[5][4][105] = int_stack + 135311;
 Libderiv->deriv2_classes[5][5][105] = int_stack + 135626;
 Libderiv->deriv2_classes[5][6][105] = int_stack + 136067;
 Libderiv->deriv2_classes[5][7][105] = int_stack + 136655;
 Libderiv->deriv2_classes[5][8][105] = int_stack + 137411;
 Libderiv->deriv2_classes[6][4][105] = int_stack + 138356;
 Libderiv->deriv2_classes[6][5][105] = int_stack + 138776;
 Libderiv->deriv2_classes[6][6][105] = int_stack + 139364;
 Libderiv->deriv2_classes[6][7][105] = int_stack + 140148;
 Libderiv->deriv2_classes[6][8][105] = int_stack + 141156;
 Libderiv->deriv2_classes[7][4][105] = int_stack + 142416;
 Libderiv->deriv2_classes[7][5][105] = int_stack + 142956;
 Libderiv->deriv2_classes[7][6][105] = int_stack + 143712;
 Libderiv->deriv2_classes[7][7][105] = int_stack + 144720;
 Libderiv->deriv2_classes[7][8][105] = int_stack + 146016;
 Libderiv->deriv2_classes[4][4][104] = int_stack + 147636;
 Libderiv->deriv2_classes[4][5][104] = int_stack + 147861;
 Libderiv->deriv2_classes[4][6][104] = int_stack + 148176;
 Libderiv->deriv2_classes[4][7][104] = int_stack + 148596;
 Libderiv->deriv2_classes[4][8][104] = int_stack + 149136;
 Libderiv->deriv2_classes[5][4][104] = int_stack + 149811;
 Libderiv->deriv2_classes[5][5][104] = int_stack + 150126;
 Libderiv->deriv2_classes[5][6][104] = int_stack + 150567;
 Libderiv->deriv2_classes[5][7][104] = int_stack + 151155;
 Libderiv->deriv2_classes[5][8][104] = int_stack + 151911;
 Libderiv->deriv2_classes[6][4][104] = int_stack + 152856;
 Libderiv->deriv2_classes[6][5][104] = int_stack + 153276;
 Libderiv->deriv2_classes[6][6][104] = int_stack + 153864;
 Libderiv->deriv2_classes[6][7][104] = int_stack + 154648;
 Libderiv->deriv2_classes[6][8][104] = int_stack + 155656;
 Libderiv->deriv2_classes[7][4][104] = int_stack + 156916;
 Libderiv->deriv2_classes[7][5][104] = int_stack + 157456;
 Libderiv->deriv2_classes[7][6][104] = int_stack + 158212;
 Libderiv->deriv2_classes[7][7][104] = int_stack + 159220;
 Libderiv->deriv2_classes[7][8][104] = int_stack + 160516;
 Libderiv->deriv2_classes[4][4][95] = int_stack + 162136;
 Libderiv->deriv2_classes[4][5][95] = int_stack + 162361;
 Libderiv->deriv2_classes[4][6][95] = int_stack + 162676;
 Libderiv->deriv2_classes[4][7][95] = int_stack + 163096;
 Libderiv->deriv2_classes[4][8][95] = int_stack + 163636;
 Libderiv->deriv2_classes[5][4][95] = int_stack + 164311;
 Libderiv->deriv2_classes[5][5][95] = int_stack + 164626;
 Libderiv->deriv2_classes[5][6][95] = int_stack + 165067;
 Libderiv->deriv2_classes[5][7][95] = int_stack + 165655;
 Libderiv->deriv2_classes[5][8][95] = int_stack + 166411;
 Libderiv->deriv2_classes[6][4][95] = int_stack + 167356;
 Libderiv->deriv2_classes[6][5][95] = int_stack + 167776;
 Libderiv->deriv2_classes[6][6][95] = int_stack + 168364;
 Libderiv->deriv2_classes[6][7][95] = int_stack + 169148;
 Libderiv->deriv2_classes[6][8][95] = int_stack + 170156;
 Libderiv->deriv2_classes[7][4][95] = int_stack + 171416;
 Libderiv->deriv2_classes[7][5][95] = int_stack + 171956;
 Libderiv->deriv2_classes[7][6][95] = int_stack + 172712;
 Libderiv->deriv2_classes[7][7][95] = int_stack + 173720;
 Libderiv->deriv2_classes[7][8][95] = int_stack + 175016;
 Libderiv->deriv2_classes[4][4][94] = int_stack + 176636;
 Libderiv->deriv2_classes[4][5][94] = int_stack + 176861;
 Libderiv->deriv2_classes[4][6][94] = int_stack + 177176;
 Libderiv->deriv2_classes[4][7][94] = int_stack + 177596;
 Libderiv->deriv2_classes[4][8][94] = int_stack + 178136;
 Libderiv->deriv2_classes[5][4][94] = int_stack + 178811;
 Libderiv->deriv2_classes[5][5][94] = int_stack + 179126;
 Libderiv->deriv2_classes[5][6][94] = int_stack + 179567;
 Libderiv->deriv2_classes[5][7][94] = int_stack + 180155;
 Libderiv->deriv2_classes[5][8][94] = int_stack + 180911;
 Libderiv->deriv2_classes[6][4][94] = int_stack + 181856;
 Libderiv->deriv2_classes[6][5][94] = int_stack + 182276;
 Libderiv->deriv2_classes[6][6][94] = int_stack + 182864;
 Libderiv->deriv2_classes[6][7][94] = int_stack + 183648;
 Libderiv->deriv2_classes[6][8][94] = int_stack + 184656;
 Libderiv->deriv2_classes[7][4][94] = int_stack + 185916;
 Libderiv->deriv2_classes[7][5][94] = int_stack + 186456;
 Libderiv->deriv2_classes[7][6][94] = int_stack + 187212;
 Libderiv->deriv2_classes[7][7][94] = int_stack + 188220;
 Libderiv->deriv2_classes[7][8][94] = int_stack + 189516;
 Libderiv->deriv2_classes[4][4][93] = int_stack + 191136;
 Libderiv->deriv2_classes[4][5][93] = int_stack + 191361;
 Libderiv->deriv2_classes[4][6][93] = int_stack + 191676;
 Libderiv->deriv2_classes[4][7][93] = int_stack + 192096;
 Libderiv->deriv2_classes[4][8][93] = int_stack + 192636;
 Libderiv->deriv2_classes[5][4][93] = int_stack + 193311;
 Libderiv->deriv2_classes[5][5][93] = int_stack + 193626;
 Libderiv->deriv2_classes[5][6][93] = int_stack + 194067;
 Libderiv->deriv2_classes[5][7][93] = int_stack + 194655;
 Libderiv->deriv2_classes[5][8][93] = int_stack + 195411;
 Libderiv->deriv2_classes[6][4][93] = int_stack + 196356;
 Libderiv->deriv2_classes[6][5][93] = int_stack + 196776;
 Libderiv->deriv2_classes[6][6][93] = int_stack + 197364;
 Libderiv->deriv2_classes[6][7][93] = int_stack + 198148;
 Libderiv->deriv2_classes[6][8][93] = int_stack + 199156;
 Libderiv->deriv2_classes[7][4][93] = int_stack + 200416;
 Libderiv->deriv2_classes[7][5][93] = int_stack + 200956;
 Libderiv->deriv2_classes[7][6][93] = int_stack + 201712;
 Libderiv->deriv2_classes[7][7][93] = int_stack + 202720;
 Libderiv->deriv2_classes[7][8][93] = int_stack + 204016;
 Libderiv->deriv2_classes[4][4][92] = int_stack + 205636;
 Libderiv->deriv2_classes[4][5][92] = int_stack + 205861;
 Libderiv->deriv2_classes[4][6][92] = int_stack + 206176;
 Libderiv->deriv2_classes[4][7][92] = int_stack + 206596;
 Libderiv->deriv2_classes[4][8][92] = int_stack + 207136;
 Libderiv->deriv2_classes[5][4][92] = int_stack + 207811;
 Libderiv->deriv2_classes[5][5][92] = int_stack + 208126;
 Libderiv->deriv2_classes[5][6][92] = int_stack + 208567;
 Libderiv->deriv2_classes[5][7][92] = int_stack + 209155;
 Libderiv->deriv2_classes[5][8][92] = int_stack + 209911;
 Libderiv->deriv2_classes[6][4][92] = int_stack + 210856;
 Libderiv->deriv2_classes[6][5][92] = int_stack + 211276;
 Libderiv->deriv2_classes[6][6][92] = int_stack + 211864;
 Libderiv->deriv2_classes[6][7][92] = int_stack + 212648;
 Libderiv->deriv2_classes[6][8][92] = int_stack + 213656;
 Libderiv->deriv2_classes[7][4][92] = int_stack + 214916;
 Libderiv->deriv2_classes[7][5][92] = int_stack + 215456;
 Libderiv->deriv2_classes[7][6][92] = int_stack + 216212;
 Libderiv->deriv2_classes[7][7][92] = int_stack + 217220;
 Libderiv->deriv2_classes[7][8][92] = int_stack + 218516;
 Libderiv->deriv2_classes[4][4][91] = int_stack + 220136;
 Libderiv->deriv2_classes[4][5][91] = int_stack + 220361;
 Libderiv->deriv2_classes[4][6][91] = int_stack + 220676;
 Libderiv->deriv2_classes[4][7][91] = int_stack + 221096;
 Libderiv->deriv2_classes[4][8][91] = int_stack + 221636;
 Libderiv->deriv2_classes[5][4][91] = int_stack + 222311;
 Libderiv->deriv2_classes[5][5][91] = int_stack + 222626;
 Libderiv->deriv2_classes[5][6][91] = int_stack + 223067;
 Libderiv->deriv2_classes[5][7][91] = int_stack + 223655;
 Libderiv->deriv2_classes[5][8][91] = int_stack + 224411;
 Libderiv->deriv2_classes[6][4][91] = int_stack + 225356;
 Libderiv->deriv2_classes[6][5][91] = int_stack + 225776;
 Libderiv->deriv2_classes[6][6][91] = int_stack + 226364;
 Libderiv->deriv2_classes[6][7][91] = int_stack + 227148;
 Libderiv->deriv2_classes[6][8][91] = int_stack + 228156;
 Libderiv->deriv2_classes[7][4][91] = int_stack + 229416;
 Libderiv->deriv2_classes[7][5][91] = int_stack + 229956;
 Libderiv->deriv2_classes[7][6][91] = int_stack + 230712;
 Libderiv->deriv2_classes[7][7][91] = int_stack + 231720;
 Libderiv->deriv2_classes[7][8][91] = int_stack + 233016;
 Libderiv->deriv2_classes[4][4][83] = int_stack + 234636;
 Libderiv->deriv2_classes[4][5][83] = int_stack + 234861;
 Libderiv->deriv2_classes[4][6][83] = int_stack + 235176;
 Libderiv->deriv2_classes[4][7][83] = int_stack + 235596;
 Libderiv->deriv2_classes[4][8][83] = int_stack + 236136;
 Libderiv->deriv2_classes[5][4][83] = int_stack + 236811;
 Libderiv->deriv2_classes[5][5][83] = int_stack + 237126;
 Libderiv->deriv2_classes[5][6][83] = int_stack + 237567;
 Libderiv->deriv2_classes[5][7][83] = int_stack + 238155;
 Libderiv->deriv2_classes[5][8][83] = int_stack + 238911;
 Libderiv->deriv2_classes[6][4][83] = int_stack + 239856;
 Libderiv->deriv2_classes[6][5][83] = int_stack + 240276;
 Libderiv->deriv2_classes[6][6][83] = int_stack + 240864;
 Libderiv->deriv2_classes[6][7][83] = int_stack + 241648;
 Libderiv->deriv2_classes[6][8][83] = int_stack + 242656;
 Libderiv->deriv_classes[7][4][11] = int_stack + 243916;
 Libderiv->deriv2_classes[7][4][83] = int_stack + 244456;
 Libderiv->deriv_classes[7][5][11] = int_stack + 244996;
 Libderiv->deriv2_classes[7][5][83] = int_stack + 245752;
 Libderiv->deriv_classes[7][6][11] = int_stack + 246508;
 Libderiv->deriv2_classes[7][6][83] = int_stack + 247516;
 Libderiv->deriv_classes[7][7][11] = int_stack + 248524;
 Libderiv->deriv2_classes[7][7][83] = int_stack + 249820;
 Libderiv->deriv2_classes[7][8][83] = int_stack + 251116;
 Libderiv->deriv2_classes[4][4][82] = int_stack + 252736;
 Libderiv->deriv2_classes[4][5][82] = int_stack + 252961;
 Libderiv->deriv2_classes[4][6][82] = int_stack + 253276;
 Libderiv->deriv2_classes[4][7][82] = int_stack + 253696;
 Libderiv->deriv2_classes[4][8][82] = int_stack + 254236;
 Libderiv->deriv2_classes[5][4][82] = int_stack + 254911;
 Libderiv->deriv2_classes[5][5][82] = int_stack + 255226;
 Libderiv->deriv2_classes[5][6][82] = int_stack + 255667;
 Libderiv->deriv2_classes[5][7][82] = int_stack + 256255;
 Libderiv->deriv2_classes[5][8][82] = int_stack + 257011;
 Libderiv->deriv2_classes[6][4][82] = int_stack + 257956;
 Libderiv->deriv2_classes[6][5][82] = int_stack + 258376;
 Libderiv->deriv2_classes[6][6][82] = int_stack + 258964;
 Libderiv->deriv2_classes[6][7][82] = int_stack + 259748;
 Libderiv->deriv2_classes[6][8][82] = int_stack + 260756;
 Libderiv->deriv_classes[7][4][10] = int_stack + 262016;
 Libderiv->deriv2_classes[7][4][82] = int_stack + 262556;
 Libderiv->deriv_classes[7][5][10] = int_stack + 263096;
 Libderiv->deriv2_classes[7][5][82] = int_stack + 263852;
 Libderiv->deriv_classes[7][6][10] = int_stack + 264608;
 Libderiv->deriv2_classes[7][6][82] = int_stack + 265616;
 Libderiv->deriv_classes[7][7][10] = int_stack + 266624;
 Libderiv->deriv2_classes[7][7][82] = int_stack + 267920;
 Libderiv->deriv2_classes[7][8][82] = int_stack + 269216;
 Libderiv->deriv2_classes[4][4][81] = int_stack + 270836;
 Libderiv->deriv2_classes[4][5][81] = int_stack + 271061;
 Libderiv->deriv2_classes[4][6][81] = int_stack + 271376;
 Libderiv->deriv2_classes[4][7][81] = int_stack + 271796;
 Libderiv->deriv2_classes[4][8][81] = int_stack + 272336;
 Libderiv->deriv2_classes[5][4][81] = int_stack + 273011;
 Libderiv->deriv2_classes[5][5][81] = int_stack + 273326;
 Libderiv->deriv2_classes[5][6][81] = int_stack + 273767;
 Libderiv->deriv2_classes[5][7][81] = int_stack + 274355;
 Libderiv->deriv2_classes[5][8][81] = int_stack + 275111;
 Libderiv->deriv2_classes[6][4][81] = int_stack + 276056;
 Libderiv->deriv2_classes[6][5][81] = int_stack + 276476;
 Libderiv->deriv2_classes[6][6][81] = int_stack + 277064;
 Libderiv->deriv2_classes[6][7][81] = int_stack + 277848;
 Libderiv->deriv2_classes[6][8][81] = int_stack + 278856;
 Libderiv->deriv_classes[7][4][9] = int_stack + 280116;
 Libderiv->deriv2_classes[7][4][81] = int_stack + 280656;
 Libderiv->deriv_classes[7][5][9] = int_stack + 281196;
 Libderiv->deriv2_classes[7][5][81] = int_stack + 281952;
 Libderiv->deriv_classes[7][6][9] = int_stack + 282708;
 Libderiv->deriv2_classes[7][6][81] = int_stack + 283716;
 Libderiv->deriv_classes[7][7][9] = int_stack + 284724;
 Libderiv->deriv2_classes[7][7][81] = int_stack + 286020;
 Libderiv->deriv2_classes[7][8][81] = int_stack + 287316;
 Libderiv->deriv2_classes[4][4][80] = int_stack + 288936;
 Libderiv->deriv2_classes[4][5][80] = int_stack + 289161;
 Libderiv->deriv2_classes[4][6][80] = int_stack + 289476;
 Libderiv->deriv2_classes[4][7][80] = int_stack + 289896;
 Libderiv->deriv2_classes[4][8][80] = int_stack + 290436;
 Libderiv->deriv2_classes[5][4][80] = int_stack + 291111;
 Libderiv->deriv2_classes[5][5][80] = int_stack + 291426;
 Libderiv->deriv2_classes[5][6][80] = int_stack + 291867;
 Libderiv->deriv2_classes[5][7][80] = int_stack + 292455;
 Libderiv->deriv2_classes[5][8][80] = int_stack + 293211;
 Libderiv->deriv2_classes[6][4][80] = int_stack + 294156;
 Libderiv->deriv2_classes[6][5][80] = int_stack + 294576;
 Libderiv->deriv2_classes[6][6][80] = int_stack + 295164;
 Libderiv->deriv2_classes[6][7][80] = int_stack + 295948;
 Libderiv->deriv2_classes[6][8][80] = int_stack + 296956;
 Libderiv->deriv_classes[7][4][8] = int_stack + 298216;
 Libderiv->deriv2_classes[7][4][80] = int_stack + 298756;
 Libderiv->deriv_classes[7][5][8] = int_stack + 299296;
 Libderiv->deriv2_classes[7][5][80] = int_stack + 300052;
 Libderiv->deriv_classes[7][6][8] = int_stack + 300808;
 Libderiv->deriv2_classes[7][6][80] = int_stack + 301816;
 Libderiv->deriv_classes[7][7][8] = int_stack + 302824;
 Libderiv->deriv2_classes[7][7][80] = int_stack + 304120;
 Libderiv->deriv2_classes[7][8][80] = int_stack + 305416;
 Libderiv->deriv2_classes[4][4][79] = int_stack + 307036;
 Libderiv->deriv2_classes[4][5][79] = int_stack + 307261;
 Libderiv->deriv2_classes[4][6][79] = int_stack + 307576;
 Libderiv->deriv2_classes[4][7][79] = int_stack + 307996;
 Libderiv->deriv2_classes[4][8][79] = int_stack + 308536;
 Libderiv->deriv2_classes[5][4][79] = int_stack + 309211;
 Libderiv->deriv2_classes[5][5][79] = int_stack + 309526;
 Libderiv->deriv2_classes[5][6][79] = int_stack + 309967;
 Libderiv->deriv2_classes[5][7][79] = int_stack + 310555;
 Libderiv->deriv2_classes[5][8][79] = int_stack + 311311;
 Libderiv->deriv2_classes[6][4][79] = int_stack + 312256;
 Libderiv->deriv2_classes[6][5][79] = int_stack + 312676;
 Libderiv->deriv2_classes[6][6][79] = int_stack + 313264;
 Libderiv->deriv2_classes[6][7][79] = int_stack + 314048;
 Libderiv->deriv2_classes[6][8][79] = int_stack + 315056;
 Libderiv->deriv_classes[7][4][7] = int_stack + 316316;
 Libderiv->deriv2_classes[7][4][79] = int_stack + 316856;
 Libderiv->deriv_classes[7][5][7] = int_stack + 317396;
 Libderiv->deriv2_classes[7][5][79] = int_stack + 318152;
 Libderiv->deriv_classes[7][6][7] = int_stack + 318908;
 Libderiv->deriv2_classes[7][6][79] = int_stack + 319916;
 Libderiv->deriv_classes[7][7][7] = int_stack + 320924;
 Libderiv->deriv2_classes[7][7][79] = int_stack + 322220;
 Libderiv->deriv2_classes[7][8][79] = int_stack + 323516;
 Libderiv->deriv2_classes[4][4][78] = int_stack + 325136;
 Libderiv->deriv2_classes[4][5][78] = int_stack + 325361;
 Libderiv->deriv2_classes[4][6][78] = int_stack + 325676;
 Libderiv->deriv2_classes[4][7][78] = int_stack + 326096;
 Libderiv->deriv2_classes[4][8][78] = int_stack + 326636;
 Libderiv->deriv2_classes[5][4][78] = int_stack + 327311;
 Libderiv->deriv2_classes[5][5][78] = int_stack + 327626;
 Libderiv->deriv2_classes[5][6][78] = int_stack + 328067;
 Libderiv->deriv2_classes[5][7][78] = int_stack + 328655;
 Libderiv->deriv2_classes[5][8][78] = int_stack + 329411;
 Libderiv->deriv2_classes[6][4][78] = int_stack + 330356;
 Libderiv->deriv2_classes[6][5][78] = int_stack + 330776;
 Libderiv->deriv2_classes[6][6][78] = int_stack + 331364;
 Libderiv->deriv2_classes[6][7][78] = int_stack + 332148;
 Libderiv->deriv2_classes[6][8][78] = int_stack + 333156;
 Libderiv->dvrr_classes[7][4] = int_stack + 334416;
 Libderiv->deriv_classes[7][4][6] = int_stack + 334956;
 Libderiv->deriv2_classes[7][4][78] = int_stack + 335496;
 Libderiv->dvrr_classes[7][5] = int_stack + 336036;
 Libderiv->deriv_classes[7][5][6] = int_stack + 336792;
 Libderiv->deriv2_classes[7][5][78] = int_stack + 337548;
 Libderiv->dvrr_classes[7][6] = int_stack + 338304;
 Libderiv->deriv_classes[7][6][6] = int_stack + 339312;
 Libderiv->deriv2_classes[7][6][78] = int_stack + 340320;
 Libderiv->deriv_classes[7][7][6] = int_stack + 341328;
 Libderiv->deriv2_classes[7][7][78] = int_stack + 342624;
 Libderiv->deriv2_classes[7][8][78] = int_stack + 343920;
 Libderiv->deriv2_classes[4][4][35] = int_stack + 345540;
 Libderiv->deriv2_classes[4][5][35] = int_stack + 345765;
 Libderiv->deriv2_classes[4][6][35] = int_stack + 346080;
 Libderiv->deriv2_classes[4][7][35] = int_stack + 346500;
 Libderiv->deriv2_classes[4][8][35] = int_stack + 347040;
 Libderiv->deriv2_classes[5][4][35] = int_stack + 347715;
 Libderiv->deriv2_classes[5][5][35] = int_stack + 348030;
 Libderiv->deriv2_classes[5][6][35] = int_stack + 348471;
 Libderiv->deriv2_classes[5][7][35] = int_stack + 349059;
 Libderiv->deriv2_classes[5][8][35] = int_stack + 349815;
 Libderiv->deriv2_classes[6][4][35] = int_stack + 350760;
 Libderiv->deriv2_classes[6][5][35] = int_stack + 351180;
 Libderiv->deriv2_classes[6][6][35] = int_stack + 351768;
 Libderiv->deriv2_classes[6][7][35] = int_stack + 352552;
 Libderiv->deriv2_classes[6][8][35] = int_stack + 353560;
 Libderiv->deriv2_classes[7][4][35] = int_stack + 354820;
 Libderiv->deriv2_classes[7][5][35] = int_stack + 355360;
 Libderiv->deriv2_classes[7][6][35] = int_stack + 356116;
 Libderiv->deriv2_classes[7][7][35] = int_stack + 357124;
 Libderiv->deriv2_classes[7][8][35] = int_stack + 358420;
 Libderiv->deriv2_classes[4][4][34] = int_stack + 360040;
 Libderiv->deriv2_classes[4][5][34] = int_stack + 360265;
 Libderiv->deriv2_classes[4][6][34] = int_stack + 360580;
 Libderiv->deriv2_classes[4][7][34] = int_stack + 361000;
 Libderiv->deriv2_classes[4][8][34] = int_stack + 361540;
 Libderiv->deriv2_classes[5][4][34] = int_stack + 362215;
 Libderiv->deriv2_classes[5][5][34] = int_stack + 362530;
 Libderiv->deriv2_classes[5][6][34] = int_stack + 362971;
 Libderiv->deriv2_classes[5][7][34] = int_stack + 363559;
 Libderiv->deriv2_classes[5][8][34] = int_stack + 364315;
 Libderiv->deriv2_classes[6][4][34] = int_stack + 365260;
 Libderiv->deriv2_classes[6][5][34] = int_stack + 365680;
 Libderiv->deriv2_classes[6][6][34] = int_stack + 366268;
 Libderiv->deriv2_classes[6][7][34] = int_stack + 367052;
 Libderiv->deriv2_classes[6][8][34] = int_stack + 368060;
 Libderiv->deriv2_classes[7][4][34] = int_stack + 369320;
 Libderiv->deriv2_classes[7][5][34] = int_stack + 369860;
 Libderiv->deriv2_classes[7][6][34] = int_stack + 370616;
 Libderiv->deriv2_classes[7][7][34] = int_stack + 371624;
 Libderiv->deriv2_classes[7][8][34] = int_stack + 372920;
 Libderiv->deriv2_classes[4][4][33] = int_stack + 374540;
 Libderiv->deriv2_classes[4][5][33] = int_stack + 374765;
 Libderiv->deriv2_classes[4][6][33] = int_stack + 375080;
 Libderiv->deriv2_classes[4][7][33] = int_stack + 375500;
 Libderiv->deriv2_classes[4][8][33] = int_stack + 376040;
 Libderiv->deriv2_classes[5][4][33] = int_stack + 376715;
 Libderiv->deriv2_classes[5][5][33] = int_stack + 377030;
 Libderiv->deriv2_classes[5][6][33] = int_stack + 377471;
 Libderiv->deriv2_classes[5][7][33] = int_stack + 378059;
 Libderiv->deriv2_classes[5][8][33] = int_stack + 378815;
 Libderiv->deriv2_classes[6][4][33] = int_stack + 379760;
 Libderiv->deriv2_classes[6][5][33] = int_stack + 380180;
 Libderiv->deriv2_classes[6][6][33] = int_stack + 380768;
 Libderiv->deriv2_classes[6][7][33] = int_stack + 381552;
 Libderiv->deriv2_classes[6][8][33] = int_stack + 382560;
 Libderiv->deriv2_classes[7][4][33] = int_stack + 383820;
 Libderiv->deriv2_classes[7][5][33] = int_stack + 384360;
 Libderiv->deriv2_classes[7][6][33] = int_stack + 385116;
 Libderiv->deriv2_classes[7][7][33] = int_stack + 386124;
 Libderiv->deriv2_classes[7][8][33] = int_stack + 387420;
 Libderiv->deriv2_classes[4][4][32] = int_stack + 389040;
 Libderiv->deriv2_classes[4][5][32] = int_stack + 389265;
 Libderiv->deriv2_classes[4][6][32] = int_stack + 389580;
 Libderiv->deriv2_classes[4][7][32] = int_stack + 390000;
 Libderiv->deriv2_classes[4][8][32] = int_stack + 390540;
 Libderiv->deriv2_classes[5][4][32] = int_stack + 391215;
 Libderiv->deriv2_classes[5][5][32] = int_stack + 391530;
 Libderiv->deriv2_classes[5][6][32] = int_stack + 391971;
 Libderiv->deriv2_classes[5][7][32] = int_stack + 392559;
 Libderiv->deriv2_classes[5][8][32] = int_stack + 393315;
 Libderiv->deriv2_classes[6][4][32] = int_stack + 394260;
 Libderiv->deriv2_classes[6][5][32] = int_stack + 394680;
 Libderiv->deriv2_classes[6][6][32] = int_stack + 395268;
 Libderiv->deriv2_classes[6][7][32] = int_stack + 396052;
 Libderiv->deriv2_classes[6][8][32] = int_stack + 397060;
 Libderiv->deriv2_classes[7][4][32] = int_stack + 398320;
 Libderiv->deriv2_classes[7][5][32] = int_stack + 398860;
 Libderiv->deriv2_classes[7][6][32] = int_stack + 399616;
 Libderiv->deriv2_classes[7][7][32] = int_stack + 400624;
 Libderiv->deriv2_classes[7][8][32] = int_stack + 401920;
 Libderiv->deriv2_classes[4][4][31] = int_stack + 403540;
 Libderiv->deriv2_classes[4][5][31] = int_stack + 403765;
 Libderiv->deriv2_classes[4][6][31] = int_stack + 404080;
 Libderiv->deriv2_classes[4][7][31] = int_stack + 404500;
 Libderiv->deriv2_classes[4][8][31] = int_stack + 405040;
 Libderiv->deriv2_classes[5][4][31] = int_stack + 405715;
 Libderiv->deriv2_classes[5][5][31] = int_stack + 406030;
 Libderiv->deriv2_classes[5][6][31] = int_stack + 406471;
 Libderiv->deriv2_classes[5][7][31] = int_stack + 407059;
 Libderiv->deriv2_classes[5][8][31] = int_stack + 407815;
 Libderiv->deriv2_classes[6][4][31] = int_stack + 408760;
 Libderiv->deriv2_classes[6][5][31] = int_stack + 409180;
 Libderiv->deriv2_classes[6][6][31] = int_stack + 409768;
 Libderiv->deriv2_classes[6][7][31] = int_stack + 410552;
 Libderiv->deriv2_classes[6][8][31] = int_stack + 411560;
 Libderiv->deriv2_classes[7][4][31] = int_stack + 412820;
 Libderiv->deriv2_classes[7][5][31] = int_stack + 413360;
 Libderiv->deriv2_classes[7][6][31] = int_stack + 414116;
 Libderiv->deriv2_classes[7][7][31] = int_stack + 415124;
 Libderiv->deriv2_classes[7][8][31] = int_stack + 416420;
 Libderiv->deriv2_classes[4][4][30] = int_stack + 418040;
 Libderiv->deriv2_classes[4][5][30] = int_stack + 418265;
 Libderiv->deriv2_classes[4][6][30] = int_stack + 418580;
 Libderiv->deriv2_classes[4][7][30] = int_stack + 419000;
 Libderiv->deriv2_classes[4][8][30] = int_stack + 419540;
 Libderiv->deriv2_classes[5][4][30] = int_stack + 420215;
 Libderiv->deriv2_classes[5][5][30] = int_stack + 420530;
 Libderiv->deriv2_classes[5][6][30] = int_stack + 420971;
 Libderiv->deriv2_classes[5][7][30] = int_stack + 421559;
 Libderiv->deriv2_classes[5][8][30] = int_stack + 422315;
 Libderiv->deriv2_classes[6][4][30] = int_stack + 423260;
 Libderiv->deriv2_classes[6][5][30] = int_stack + 423680;
 Libderiv->deriv2_classes[6][6][30] = int_stack + 424268;
 Libderiv->deriv2_classes[6][7][30] = int_stack + 425052;
 Libderiv->deriv2_classes[6][8][30] = int_stack + 426060;
 Libderiv->deriv_classes[7][4][2] = int_stack + 427320;
 Libderiv->deriv2_classes[7][4][30] = int_stack + 427860;
 Libderiv->deriv_classes[7][5][2] = int_stack + 428400;
 Libderiv->deriv2_classes[7][5][30] = int_stack + 429156;
 Libderiv->deriv_classes[7][6][2] = int_stack + 429912;
 Libderiv->deriv2_classes[7][6][30] = int_stack + 430920;
 Libderiv->deriv_classes[7][7][2] = int_stack + 431928;
 Libderiv->deriv2_classes[7][7][30] = int_stack + 433224;
 Libderiv->deriv2_classes[7][8][30] = int_stack + 434520;
 Libderiv->deriv2_classes[4][4][26] = int_stack + 436140;
 Libderiv->deriv2_classes[4][5][26] = int_stack + 436365;
 Libderiv->deriv2_classes[4][6][26] = int_stack + 436680;
 Libderiv->deriv2_classes[4][7][26] = int_stack + 437100;
 Libderiv->deriv2_classes[4][8][26] = int_stack + 437640;
 Libderiv->deriv2_classes[5][4][26] = int_stack + 438315;
 Libderiv->deriv2_classes[5][5][26] = int_stack + 438630;
 Libderiv->deriv2_classes[5][6][26] = int_stack + 439071;
 Libderiv->deriv2_classes[5][7][26] = int_stack + 439659;
 Libderiv->deriv2_classes[5][8][26] = int_stack + 440415;
 Libderiv->deriv2_classes[6][4][26] = int_stack + 441360;
 Libderiv->deriv2_classes[6][5][26] = int_stack + 441780;
 Libderiv->deriv2_classes[6][6][26] = int_stack + 442368;
 Libderiv->deriv2_classes[6][7][26] = int_stack + 443152;
 Libderiv->deriv2_classes[6][8][26] = int_stack + 444160;
 Libderiv->deriv2_classes[7][4][26] = int_stack + 445420;
 Libderiv->deriv2_classes[7][5][26] = int_stack + 445960;
 Libderiv->deriv2_classes[7][6][26] = int_stack + 446716;
 Libderiv->deriv2_classes[7][7][26] = int_stack + 447724;
 Libderiv->deriv2_classes[7][8][26] = int_stack + 449020;
 Libderiv->deriv2_classes[4][4][23] = int_stack + 450640;
 Libderiv->deriv2_classes[4][5][23] = int_stack + 450865;
 Libderiv->deriv2_classes[4][6][23] = int_stack + 451180;
 Libderiv->deriv2_classes[4][7][23] = int_stack + 451600;
 Libderiv->deriv2_classes[4][8][23] = int_stack + 452140;
 Libderiv->deriv2_classes[5][4][23] = int_stack + 452815;
 Libderiv->deriv2_classes[5][5][23] = int_stack + 453130;
 Libderiv->deriv2_classes[5][6][23] = int_stack + 453571;
 Libderiv->deriv2_classes[5][7][23] = int_stack + 454159;
 Libderiv->deriv2_classes[5][8][23] = int_stack + 454915;
 Libderiv->deriv2_classes[6][4][23] = int_stack + 455860;
 Libderiv->deriv2_classes[6][5][23] = int_stack + 456280;
 Libderiv->deriv2_classes[6][6][23] = int_stack + 456868;
 Libderiv->deriv2_classes[6][7][23] = int_stack + 457652;
 Libderiv->deriv2_classes[6][8][23] = int_stack + 458660;
 Libderiv->deriv2_classes[7][4][23] = int_stack + 459920;
 Libderiv->deriv2_classes[7][5][23] = int_stack + 460460;
 Libderiv->deriv2_classes[7][6][23] = int_stack + 461216;
 Libderiv->deriv2_classes[7][7][23] = int_stack + 462224;
 Libderiv->deriv2_classes[7][8][23] = int_stack + 463520;
 Libderiv->deriv2_classes[4][4][22] = int_stack + 465140;
 Libderiv->deriv2_classes[4][5][22] = int_stack + 465365;
 Libderiv->deriv2_classes[4][6][22] = int_stack + 465680;
 Libderiv->deriv2_classes[4][7][22] = int_stack + 466100;
 Libderiv->deriv2_classes[4][8][22] = int_stack + 466640;
 Libderiv->deriv2_classes[5][4][22] = int_stack + 467315;
 Libderiv->deriv2_classes[5][5][22] = int_stack + 467630;
 Libderiv->deriv2_classes[5][6][22] = int_stack + 468071;
 Libderiv->deriv2_classes[5][7][22] = int_stack + 468659;
 Libderiv->deriv2_classes[5][8][22] = int_stack + 469415;
 Libderiv->deriv2_classes[6][4][22] = int_stack + 470360;
 Libderiv->deriv2_classes[6][5][22] = int_stack + 470780;
 Libderiv->deriv2_classes[6][6][22] = int_stack + 471368;
 Libderiv->deriv2_classes[6][7][22] = int_stack + 472152;
 Libderiv->deriv2_classes[6][8][22] = int_stack + 473160;
 Libderiv->deriv2_classes[7][4][22] = int_stack + 474420;
 Libderiv->deriv2_classes[7][5][22] = int_stack + 474960;
 Libderiv->deriv2_classes[7][6][22] = int_stack + 475716;
 Libderiv->deriv2_classes[7][7][22] = int_stack + 476724;
 Libderiv->deriv2_classes[7][8][22] = int_stack + 478020;
 Libderiv->deriv2_classes[4][4][21] = int_stack + 479640;
 Libderiv->deriv2_classes[4][5][21] = int_stack + 479865;
 Libderiv->deriv2_classes[4][6][21] = int_stack + 480180;
 Libderiv->deriv2_classes[4][7][21] = int_stack + 480600;
 Libderiv->deriv2_classes[4][8][21] = int_stack + 481140;
 Libderiv->deriv2_classes[5][4][21] = int_stack + 481815;
 Libderiv->deriv2_classes[5][5][21] = int_stack + 482130;
 Libderiv->deriv2_classes[5][6][21] = int_stack + 482571;
 Libderiv->deriv2_classes[5][7][21] = int_stack + 483159;
 Libderiv->deriv2_classes[5][8][21] = int_stack + 483915;
 Libderiv->deriv2_classes[6][4][21] = int_stack + 484860;
 Libderiv->deriv2_classes[6][5][21] = int_stack + 485280;
 Libderiv->deriv2_classes[6][6][21] = int_stack + 485868;
 Libderiv->deriv2_classes[6][7][21] = int_stack + 486652;
 Libderiv->deriv2_classes[6][8][21] = int_stack + 487660;
 Libderiv->deriv2_classes[7][4][21] = int_stack + 488920;
 Libderiv->deriv2_classes[7][5][21] = int_stack + 489460;
 Libderiv->deriv2_classes[7][6][21] = int_stack + 490216;
 Libderiv->deriv2_classes[7][7][21] = int_stack + 491224;
 Libderiv->deriv2_classes[7][8][21] = int_stack + 492520;
 Libderiv->deriv2_classes[4][4][20] = int_stack + 494140;
 Libderiv->deriv2_classes[4][5][20] = int_stack + 494365;
 Libderiv->deriv2_classes[4][6][20] = int_stack + 494680;
 Libderiv->deriv2_classes[4][7][20] = int_stack + 495100;
 Libderiv->deriv2_classes[4][8][20] = int_stack + 495640;
 Libderiv->deriv2_classes[5][4][20] = int_stack + 496315;
 Libderiv->deriv2_classes[5][5][20] = int_stack + 496630;
 Libderiv->deriv2_classes[5][6][20] = int_stack + 497071;
 Libderiv->deriv2_classes[5][7][20] = int_stack + 497659;
 Libderiv->deriv2_classes[5][8][20] = int_stack + 498415;
 Libderiv->deriv2_classes[6][4][20] = int_stack + 499360;
 Libderiv->deriv2_classes[6][5][20] = int_stack + 499780;
 Libderiv->deriv2_classes[6][6][20] = int_stack + 500368;
 Libderiv->deriv2_classes[6][7][20] = int_stack + 501152;
 Libderiv->deriv2_classes[6][8][20] = int_stack + 502160;
 Libderiv->deriv2_classes[7][4][20] = int_stack + 503420;
 Libderiv->deriv2_classes[7][5][20] = int_stack + 503960;
 Libderiv->deriv2_classes[7][6][20] = int_stack + 504716;
 Libderiv->deriv2_classes[7][7][20] = int_stack + 505724;
 Libderiv->deriv2_classes[7][8][20] = int_stack + 507020;
 Libderiv->deriv2_classes[4][4][19] = int_stack + 508640;
 Libderiv->deriv2_classes[4][5][19] = int_stack + 508865;
 Libderiv->deriv2_classes[4][6][19] = int_stack + 509180;
 Libderiv->deriv2_classes[4][7][19] = int_stack + 509600;
 Libderiv->deriv2_classes[4][8][19] = int_stack + 510140;
 Libderiv->deriv2_classes[5][4][19] = int_stack + 510815;
 Libderiv->deriv2_classes[5][5][19] = int_stack + 511130;
 Libderiv->deriv2_classes[5][6][19] = int_stack + 511571;
 Libderiv->deriv2_classes[5][7][19] = int_stack + 512159;
 Libderiv->deriv2_classes[5][8][19] = int_stack + 512915;
 Libderiv->deriv2_classes[6][4][19] = int_stack + 513860;
 Libderiv->deriv2_classes[6][5][19] = int_stack + 514280;
 Libderiv->deriv2_classes[6][6][19] = int_stack + 514868;
 Libderiv->deriv2_classes[6][7][19] = int_stack + 515652;
 Libderiv->deriv2_classes[6][8][19] = int_stack + 516660;
 Libderiv->deriv2_classes[7][4][19] = int_stack + 517920;
 Libderiv->deriv2_classes[7][5][19] = int_stack + 518460;
 Libderiv->deriv2_classes[7][6][19] = int_stack + 519216;
 Libderiv->deriv2_classes[7][7][19] = int_stack + 520224;
 Libderiv->deriv2_classes[7][8][19] = int_stack + 521520;
 Libderiv->deriv2_classes[4][4][18] = int_stack + 523140;
 Libderiv->deriv2_classes[4][5][18] = int_stack + 523365;
 Libderiv->deriv2_classes[4][6][18] = int_stack + 523680;
 Libderiv->deriv2_classes[4][7][18] = int_stack + 524100;
 Libderiv->deriv2_classes[4][8][18] = int_stack + 524640;
 Libderiv->deriv2_classes[5][4][18] = int_stack + 525315;
 Libderiv->deriv2_classes[5][5][18] = int_stack + 525630;
 Libderiv->deriv2_classes[5][6][18] = int_stack + 526071;
 Libderiv->deriv2_classes[5][7][18] = int_stack + 526659;
 Libderiv->deriv2_classes[5][8][18] = int_stack + 527415;
 Libderiv->deriv2_classes[6][4][18] = int_stack + 528360;
 Libderiv->deriv2_classes[6][5][18] = int_stack + 528780;
 Libderiv->deriv2_classes[6][6][18] = int_stack + 529368;
 Libderiv->deriv2_classes[6][7][18] = int_stack + 530152;
 Libderiv->deriv2_classes[6][8][18] = int_stack + 531160;
 Libderiv->deriv_classes[7][4][1] = int_stack + 532420;
 Libderiv->deriv2_classes[7][4][18] = int_stack + 532960;
 Libderiv->deriv_classes[7][5][1] = int_stack + 533500;
 Libderiv->deriv2_classes[7][5][18] = int_stack + 534256;
 Libderiv->deriv_classes[7][6][1] = int_stack + 535012;
 Libderiv->deriv2_classes[7][6][18] = int_stack + 536020;
 Libderiv->deriv_classes[7][7][1] = int_stack + 537028;
 Libderiv->deriv2_classes[7][7][18] = int_stack + 538324;
 Libderiv->deriv2_classes[7][8][18] = int_stack + 539620;
 Libderiv->deriv2_classes[4][4][14] = int_stack + 541240;
 Libderiv->deriv2_classes[4][5][14] = int_stack + 541465;
 Libderiv->deriv2_classes[4][6][14] = int_stack + 541780;
 Libderiv->deriv2_classes[4][7][14] = int_stack + 542200;
 Libderiv->deriv2_classes[4][8][14] = int_stack + 542740;
 Libderiv->deriv2_classes[5][4][14] = int_stack + 543415;
 Libderiv->deriv2_classes[5][5][14] = int_stack + 543730;
 Libderiv->deriv2_classes[5][6][14] = int_stack + 544171;
 Libderiv->deriv2_classes[5][7][14] = int_stack + 544759;
 Libderiv->deriv2_classes[5][8][14] = int_stack + 545515;
 Libderiv->deriv2_classes[6][4][14] = int_stack + 546460;
 Libderiv->deriv2_classes[6][5][14] = int_stack + 546880;
 Libderiv->deriv2_classes[6][6][14] = int_stack + 547468;
 Libderiv->deriv2_classes[6][7][14] = int_stack + 548252;
 Libderiv->deriv2_classes[6][8][14] = int_stack + 549260;
 Libderiv->deriv2_classes[7][4][14] = int_stack + 550520;
 Libderiv->deriv2_classes[7][5][14] = int_stack + 551060;
 Libderiv->deriv2_classes[7][6][14] = int_stack + 551816;
 Libderiv->deriv2_classes[7][7][14] = int_stack + 552824;
 Libderiv->deriv2_classes[7][8][14] = int_stack + 554120;
 Libderiv->deriv2_classes[4][4][13] = int_stack + 555740;
 Libderiv->deriv2_classes[4][5][13] = int_stack + 555965;
 Libderiv->deriv2_classes[4][6][13] = int_stack + 556280;
 Libderiv->deriv2_classes[4][7][13] = int_stack + 556700;
 Libderiv->deriv2_classes[4][8][13] = int_stack + 557240;
 Libderiv->deriv2_classes[5][4][13] = int_stack + 557915;
 Libderiv->deriv2_classes[5][5][13] = int_stack + 558230;
 Libderiv->deriv2_classes[5][6][13] = int_stack + 558671;
 Libderiv->deriv2_classes[5][7][13] = int_stack + 559259;
 Libderiv->deriv2_classes[5][8][13] = int_stack + 560015;
 Libderiv->deriv2_classes[6][4][13] = int_stack + 560960;
 Libderiv->deriv2_classes[6][5][13] = int_stack + 561380;
 Libderiv->deriv2_classes[6][6][13] = int_stack + 561968;
 Libderiv->deriv2_classes[6][7][13] = int_stack + 562752;
 Libderiv->deriv2_classes[6][8][13] = int_stack + 563760;
 Libderiv->deriv2_classes[7][4][13] = int_stack + 565020;
 Libderiv->deriv2_classes[7][5][13] = int_stack + 565560;
 Libderiv->deriv2_classes[7][6][13] = int_stack + 566316;
 Libderiv->deriv2_classes[7][7][13] = int_stack + 567324;
 Libderiv->deriv2_classes[7][8][13] = int_stack + 568620;
 Libderiv->deriv_classes[4][4][11] = int_stack + 570240;
 Libderiv->deriv_classes[4][5][11] = int_stack + 570465;
 Libderiv->deriv_classes[4][6][11] = int_stack + 570780;
 Libderiv->deriv_classes[4][7][11] = int_stack + 571200;
 Libderiv->deriv_classes[4][8][11] = int_stack + 571740;
 Libderiv->deriv2_classes[4][4][11] = int_stack + 572415;
 Libderiv->deriv2_classes[4][5][11] = int_stack + 572640;
 Libderiv->deriv2_classes[4][6][11] = int_stack + 572955;
 Libderiv->deriv2_classes[4][7][11] = int_stack + 573375;
 Libderiv->deriv2_classes[4][8][11] = int_stack + 573915;
 Libderiv->deriv_classes[5][4][11] = int_stack + 574590;
 Libderiv->deriv_classes[5][5][11] = int_stack + 574905;
 Libderiv->deriv_classes[5][6][11] = int_stack + 575346;
 Libderiv->deriv_classes[5][7][11] = int_stack + 575934;
 Libderiv->deriv_classes[5][8][11] = int_stack + 576690;
 Libderiv->deriv2_classes[5][4][11] = int_stack + 577635;
 Libderiv->deriv2_classes[5][5][11] = int_stack + 577950;
 Libderiv->deriv2_classes[5][6][11] = int_stack + 578391;
 Libderiv->deriv2_classes[5][7][11] = int_stack + 578979;
 Libderiv->deriv2_classes[5][8][11] = int_stack + 579735;
 Libderiv->deriv_classes[6][4][11] = int_stack + 580680;
 Libderiv->deriv_classes[6][5][11] = int_stack + 581100;
 Libderiv->deriv_classes[6][6][11] = int_stack + 581688;
 Libderiv->deriv_classes[6][7][11] = int_stack + 582472;
 Libderiv->deriv_classes[6][8][11] = int_stack + 583480;
 Libderiv->deriv2_classes[6][4][11] = int_stack + 584740;
 Libderiv->deriv2_classes[6][5][11] = int_stack + 585160;
 Libderiv->deriv2_classes[6][6][11] = int_stack + 585748;
 Libderiv->deriv2_classes[6][7][11] = int_stack + 586532;
 Libderiv->deriv2_classes[6][8][11] = int_stack + 587540;
 Libderiv->deriv2_classes[7][4][11] = int_stack + 588800;
 Libderiv->deriv2_classes[7][5][11] = int_stack + 589340;
 Libderiv->deriv2_classes[7][6][11] = int_stack + 590096;
 Libderiv->deriv2_classes[7][7][11] = int_stack + 591104;
 Libderiv->deriv2_classes[7][8][11] = int_stack + 592400;
 Libderiv->deriv_classes[4][4][10] = int_stack + 594020;
 Libderiv->deriv_classes[4][5][10] = int_stack + 594245;
 Libderiv->deriv_classes[4][6][10] = int_stack + 594560;
 Libderiv->deriv_classes[4][7][10] = int_stack + 594980;
 Libderiv->deriv_classes[4][8][10] = int_stack + 595520;
 Libderiv->deriv2_classes[4][4][10] = int_stack + 596195;
 Libderiv->deriv2_classes[4][5][10] = int_stack + 596420;
 Libderiv->deriv2_classes[4][6][10] = int_stack + 596735;
 Libderiv->deriv2_classes[4][7][10] = int_stack + 597155;
 Libderiv->deriv2_classes[4][8][10] = int_stack + 597695;
 Libderiv->deriv_classes[5][4][10] = int_stack + 598370;
 Libderiv->deriv_classes[5][5][10] = int_stack + 598685;
 Libderiv->deriv_classes[5][6][10] = int_stack + 599126;
 Libderiv->deriv_classes[5][7][10] = int_stack + 599714;
 Libderiv->deriv_classes[5][8][10] = int_stack + 600470;
 Libderiv->deriv2_classes[5][4][10] = int_stack + 601415;
 Libderiv->deriv2_classes[5][5][10] = int_stack + 601730;
 Libderiv->deriv2_classes[5][6][10] = int_stack + 602171;
 Libderiv->deriv2_classes[5][7][10] = int_stack + 602759;
 Libderiv->deriv2_classes[5][8][10] = int_stack + 603515;
 Libderiv->deriv_classes[6][4][10] = int_stack + 604460;
 Libderiv->deriv_classes[6][5][10] = int_stack + 604880;
 Libderiv->deriv_classes[6][6][10] = int_stack + 605468;
 Libderiv->deriv_classes[6][7][10] = int_stack + 606252;
 Libderiv->deriv_classes[6][8][10] = int_stack + 607260;
 Libderiv->deriv2_classes[6][4][10] = int_stack + 608520;
 Libderiv->deriv2_classes[6][5][10] = int_stack + 608940;
 Libderiv->deriv2_classes[6][6][10] = int_stack + 609528;
 Libderiv->deriv2_classes[6][7][10] = int_stack + 610312;
 Libderiv->deriv2_classes[6][8][10] = int_stack + 611320;
 Libderiv->deriv2_classes[7][4][10] = int_stack + 612580;
 Libderiv->deriv2_classes[7][5][10] = int_stack + 613120;
 Libderiv->deriv2_classes[7][6][10] = int_stack + 613876;
 Libderiv->deriv2_classes[7][7][10] = int_stack + 614884;
 Libderiv->deriv2_classes[7][8][10] = int_stack + 616180;
 Libderiv->deriv_classes[4][4][9] = int_stack + 617800;
 Libderiv->deriv_classes[4][5][9] = int_stack + 618025;
 Libderiv->deriv_classes[4][6][9] = int_stack + 618340;
 Libderiv->deriv_classes[4][7][9] = int_stack + 618760;
 Libderiv->deriv_classes[4][8][9] = int_stack + 619300;
 Libderiv->deriv2_classes[4][4][9] = int_stack + 619975;
 Libderiv->deriv2_classes[4][5][9] = int_stack + 620200;
 Libderiv->deriv2_classes[4][6][9] = int_stack + 620515;
 Libderiv->deriv2_classes[4][7][9] = int_stack + 620935;
 Libderiv->deriv2_classes[4][8][9] = int_stack + 621475;
 Libderiv->deriv_classes[5][4][9] = int_stack + 622150;
 Libderiv->deriv_classes[5][5][9] = int_stack + 622465;
 Libderiv->deriv_classes[5][6][9] = int_stack + 622906;
 Libderiv->deriv_classes[5][7][9] = int_stack + 623494;
 Libderiv->deriv_classes[5][8][9] = int_stack + 624250;
 Libderiv->deriv2_classes[5][4][9] = int_stack + 625195;
 Libderiv->deriv2_classes[5][5][9] = int_stack + 625510;
 Libderiv->deriv2_classes[5][6][9] = int_stack + 625951;
 Libderiv->deriv2_classes[5][7][9] = int_stack + 626539;
 Libderiv->deriv2_classes[5][8][9] = int_stack + 627295;
 Libderiv->deriv_classes[6][4][9] = int_stack + 628240;
 Libderiv->deriv_classes[6][5][9] = int_stack + 628660;
 Libderiv->deriv_classes[6][6][9] = int_stack + 629248;
 Libderiv->deriv_classes[6][7][9] = int_stack + 630032;
 Libderiv->deriv_classes[6][8][9] = int_stack + 631040;
 Libderiv->deriv2_classes[6][4][9] = int_stack + 632300;
 Libderiv->deriv2_classes[6][5][9] = int_stack + 632720;
 Libderiv->deriv2_classes[6][6][9] = int_stack + 633308;
 Libderiv->deriv2_classes[6][7][9] = int_stack + 634092;
 Libderiv->deriv2_classes[6][8][9] = int_stack + 635100;
 Libderiv->deriv2_classes[7][4][9] = int_stack + 636360;
 Libderiv->deriv2_classes[7][5][9] = int_stack + 636900;
 Libderiv->deriv2_classes[7][6][9] = int_stack + 637656;
 Libderiv->deriv2_classes[7][7][9] = int_stack + 638664;
 Libderiv->deriv2_classes[7][8][9] = int_stack + 639960;
 Libderiv->deriv_classes[4][4][8] = int_stack + 641580;
 Libderiv->deriv_classes[4][5][8] = int_stack + 641805;
 Libderiv->deriv_classes[4][6][8] = int_stack + 642120;
 Libderiv->deriv_classes[4][7][8] = int_stack + 642540;
 Libderiv->deriv_classes[4][8][8] = int_stack + 643080;
 Libderiv->deriv2_classes[4][4][8] = int_stack + 643755;
 Libderiv->deriv2_classes[4][5][8] = int_stack + 643980;
 Libderiv->deriv2_classes[4][6][8] = int_stack + 644295;
 Libderiv->deriv2_classes[4][7][8] = int_stack + 644715;
 Libderiv->deriv2_classes[4][8][8] = int_stack + 645255;
 Libderiv->deriv_classes[5][4][8] = int_stack + 645930;
 Libderiv->deriv_classes[5][5][8] = int_stack + 646245;
 Libderiv->deriv_classes[5][6][8] = int_stack + 646686;
 Libderiv->deriv_classes[5][7][8] = int_stack + 647274;
 Libderiv->deriv_classes[5][8][8] = int_stack + 648030;
 Libderiv->deriv2_classes[5][4][8] = int_stack + 648975;
 Libderiv->deriv2_classes[5][5][8] = int_stack + 649290;
 Libderiv->deriv2_classes[5][6][8] = int_stack + 649731;
 Libderiv->deriv2_classes[5][7][8] = int_stack + 650319;
 Libderiv->deriv2_classes[5][8][8] = int_stack + 651075;
 Libderiv->deriv_classes[6][4][8] = int_stack + 652020;
 Libderiv->deriv_classes[6][5][8] = int_stack + 652440;
 Libderiv->deriv_classes[6][6][8] = int_stack + 653028;
 Libderiv->deriv_classes[6][7][8] = int_stack + 653812;
 Libderiv->deriv_classes[6][8][8] = int_stack + 654820;
 Libderiv->deriv2_classes[6][4][8] = int_stack + 656080;
 Libderiv->deriv2_classes[6][5][8] = int_stack + 656500;
 Libderiv->deriv2_classes[6][6][8] = int_stack + 657088;
 Libderiv->deriv2_classes[6][7][8] = int_stack + 657872;
 Libderiv->deriv2_classes[6][8][8] = int_stack + 658880;
 Libderiv->deriv2_classes[7][4][8] = int_stack + 660140;
 Libderiv->deriv2_classes[7][5][8] = int_stack + 660680;
 Libderiv->deriv2_classes[7][6][8] = int_stack + 661436;
 Libderiv->deriv2_classes[7][7][8] = int_stack + 662444;
 Libderiv->deriv2_classes[7][8][8] = int_stack + 663740;
 Libderiv->deriv_classes[4][4][7] = int_stack + 665360;
 Libderiv->deriv_classes[4][5][7] = int_stack + 665585;
 Libderiv->deriv_classes[4][6][7] = int_stack + 665900;
 Libderiv->deriv_classes[4][7][7] = int_stack + 666320;
 Libderiv->deriv_classes[4][8][7] = int_stack + 666860;
 Libderiv->deriv2_classes[4][4][7] = int_stack + 667535;
 Libderiv->deriv2_classes[4][5][7] = int_stack + 667760;
 Libderiv->deriv2_classes[4][6][7] = int_stack + 668075;
 Libderiv->deriv2_classes[4][7][7] = int_stack + 668495;
 Libderiv->deriv2_classes[4][8][7] = int_stack + 669035;
 Libderiv->deriv_classes[5][4][7] = int_stack + 669710;
 Libderiv->deriv_classes[5][5][7] = int_stack + 670025;
 Libderiv->deriv_classes[5][6][7] = int_stack + 670466;
 Libderiv->deriv_classes[5][7][7] = int_stack + 671054;
 Libderiv->deriv_classes[5][8][7] = int_stack + 671810;
 Libderiv->deriv2_classes[5][4][7] = int_stack + 672755;
 Libderiv->deriv2_classes[5][5][7] = int_stack + 673070;
 Libderiv->deriv2_classes[5][6][7] = int_stack + 673511;
 Libderiv->deriv2_classes[5][7][7] = int_stack + 674099;
 Libderiv->deriv2_classes[5][8][7] = int_stack + 674855;
 Libderiv->deriv_classes[6][4][7] = int_stack + 675800;
 Libderiv->deriv_classes[6][5][7] = int_stack + 676220;
 Libderiv->deriv_classes[6][6][7] = int_stack + 676808;
 Libderiv->deriv_classes[6][7][7] = int_stack + 677592;
 Libderiv->deriv_classes[6][8][7] = int_stack + 678600;
 Libderiv->deriv2_classes[6][4][7] = int_stack + 679860;
 Libderiv->deriv2_classes[6][5][7] = int_stack + 680280;
 Libderiv->deriv2_classes[6][6][7] = int_stack + 680868;
 Libderiv->deriv2_classes[6][7][7] = int_stack + 681652;
 Libderiv->deriv2_classes[6][8][7] = int_stack + 682660;
 Libderiv->deriv2_classes[7][4][7] = int_stack + 683920;
 Libderiv->deriv2_classes[7][5][7] = int_stack + 684460;
 Libderiv->deriv2_classes[7][6][7] = int_stack + 685216;
 Libderiv->deriv2_classes[7][7][7] = int_stack + 686224;
 Libderiv->deriv2_classes[7][8][7] = int_stack + 687520;
 Libderiv->deriv_classes[4][4][6] = int_stack + 689140;
 Libderiv->deriv_classes[4][5][6] = int_stack + 689365;
 Libderiv->deriv_classes[4][6][6] = int_stack + 689680;
 Libderiv->deriv_classes[4][7][6] = int_stack + 690100;
 Libderiv->deriv_classes[4][8][6] = int_stack + 690640;
 Libderiv->deriv2_classes[4][4][6] = int_stack + 691315;
 Libderiv->deriv2_classes[4][5][6] = int_stack + 691540;
 Libderiv->deriv2_classes[4][6][6] = int_stack + 691855;
 Libderiv->deriv2_classes[4][7][6] = int_stack + 692275;
 Libderiv->deriv2_classes[4][8][6] = int_stack + 692815;
 Libderiv->deriv_classes[5][4][6] = int_stack + 693490;
 Libderiv->deriv_classes[5][5][6] = int_stack + 693805;
 Libderiv->deriv_classes[5][6][6] = int_stack + 694246;
 Libderiv->deriv_classes[5][7][6] = int_stack + 694834;
 Libderiv->deriv_classes[5][8][6] = int_stack + 695590;
 Libderiv->deriv2_classes[5][4][6] = int_stack + 696535;
 Libderiv->deriv2_classes[5][5][6] = int_stack + 696850;
 Libderiv->deriv2_classes[5][6][6] = int_stack + 697291;
 Libderiv->deriv2_classes[5][7][6] = int_stack + 697879;
 Libderiv->deriv2_classes[5][8][6] = int_stack + 698635;
 Libderiv->dvrr_classes[6][4] = int_stack + 699580;
 Libderiv->deriv_classes[6][4][6] = int_stack + 700000;
 Libderiv->dvrr_classes[6][5] = int_stack + 700420;
 Libderiv->deriv_classes[6][5][6] = int_stack + 701008;
 Libderiv->dvrr_classes[6][6] = int_stack + 701596;
 Libderiv->deriv_classes[6][6][6] = int_stack + 702380;
 Libderiv->dvrr_classes[6][7] = int_stack + 703164;
 Libderiv->deriv_classes[6][7][6] = int_stack + 704172;
 Libderiv->deriv_classes[6][8][6] = int_stack + 705180;
 Libderiv->deriv2_classes[6][4][6] = int_stack + 706440;
 Libderiv->deriv2_classes[6][5][6] = int_stack + 706860;
 Libderiv->deriv2_classes[6][6][6] = int_stack + 707448;
 Libderiv->deriv2_classes[6][7][6] = int_stack + 708232;
 Libderiv->deriv2_classes[6][8][6] = int_stack + 709240;
 Libderiv->deriv_classes[7][4][0] = int_stack + 710500;
 Libderiv->deriv2_classes[7][4][6] = int_stack + 711040;
 Libderiv->deriv_classes[7][5][0] = int_stack + 711580;
 Libderiv->deriv2_classes[7][5][6] = int_stack + 712336;
 Libderiv->deriv_classes[7][6][0] = int_stack + 713092;
 Libderiv->deriv2_classes[7][6][6] = int_stack + 714100;
 Libderiv->deriv_classes[7][7][0] = int_stack + 715108;
 Libderiv->deriv2_classes[7][7][6] = int_stack + 716404;
 Libderiv->deriv2_classes[7][8][6] = int_stack + 717700;
 Libderiv->deriv_classes[4][4][2] = int_stack + 719320;
 Libderiv->deriv_classes[4][5][2] = int_stack + 719545;
 Libderiv->deriv_classes[4][6][2] = int_stack + 719860;
 Libderiv->deriv_classes[4][7][2] = int_stack + 720280;
 Libderiv->deriv_classes[4][8][2] = int_stack + 720820;
 Libderiv->deriv2_classes[4][4][2] = int_stack + 721495;
 Libderiv->deriv2_classes[4][5][2] = int_stack + 721720;
 Libderiv->deriv2_classes[4][6][2] = int_stack + 722035;
 Libderiv->deriv2_classes[4][7][2] = int_stack + 722455;
 Libderiv->deriv2_classes[4][8][2] = int_stack + 722995;
 Libderiv->deriv_classes[5][4][2] = int_stack + 723670;
 Libderiv->deriv_classes[5][5][2] = int_stack + 723985;
 Libderiv->deriv_classes[5][6][2] = int_stack + 724426;
 Libderiv->deriv_classes[5][7][2] = int_stack + 725014;
 Libderiv->deriv_classes[5][8][2] = int_stack + 725770;
 Libderiv->deriv2_classes[5][4][2] = int_stack + 726715;
 Libderiv->deriv2_classes[5][5][2] = int_stack + 727030;
 Libderiv->deriv2_classes[5][6][2] = int_stack + 727471;
 Libderiv->deriv2_classes[5][7][2] = int_stack + 728059;
 Libderiv->deriv2_classes[5][8][2] = int_stack + 728815;
 Libderiv->deriv_classes[6][4][2] = int_stack + 729760;
 Libderiv->deriv_classes[6][5][2] = int_stack + 730180;
 Libderiv->deriv_classes[6][6][2] = int_stack + 730768;
 Libderiv->deriv_classes[6][7][2] = int_stack + 731552;
 Libderiv->deriv_classes[6][8][2] = int_stack + 732560;
 Libderiv->deriv2_classes[6][4][2] = int_stack + 733820;
 Libderiv->deriv2_classes[6][5][2] = int_stack + 734240;
 Libderiv->deriv2_classes[6][6][2] = int_stack + 734828;
 Libderiv->deriv2_classes[6][7][2] = int_stack + 735612;
 Libderiv->deriv2_classes[6][8][2] = int_stack + 736620;
 Libderiv->deriv2_classes[7][4][2] = int_stack + 737880;
 Libderiv->deriv2_classes[7][5][2] = int_stack + 738420;
 Libderiv->deriv2_classes[7][6][2] = int_stack + 739176;
 Libderiv->deriv2_classes[7][7][2] = int_stack + 740184;
 Libderiv->deriv2_classes[7][8][2] = int_stack + 741480;
 Libderiv->deriv_classes[4][4][1] = int_stack + 743100;
 Libderiv->deriv_classes[4][5][1] = int_stack + 743325;
 Libderiv->deriv_classes[4][6][1] = int_stack + 743640;
 Libderiv->deriv_classes[4][7][1] = int_stack + 744060;
 Libderiv->deriv_classes[4][8][1] = int_stack + 744600;
 Libderiv->deriv2_classes[4][4][1] = int_stack + 745275;
 Libderiv->deriv2_classes[4][5][1] = int_stack + 745500;
 Libderiv->deriv2_classes[4][6][1] = int_stack + 745815;
 Libderiv->deriv2_classes[4][7][1] = int_stack + 746235;
 Libderiv->deriv2_classes[4][8][1] = int_stack + 746775;
 Libderiv->deriv_classes[5][4][1] = int_stack + 747450;
 Libderiv->deriv_classes[5][5][1] = int_stack + 747765;
 Libderiv->deriv_classes[5][6][1] = int_stack + 748206;
 Libderiv->deriv_classes[5][7][1] = int_stack + 748794;
 Libderiv->deriv_classes[5][8][1] = int_stack + 749550;
 Libderiv->deriv2_classes[5][4][1] = int_stack + 750495;
 Libderiv->deriv2_classes[5][5][1] = int_stack + 750810;
 Libderiv->deriv2_classes[5][6][1] = int_stack + 751251;
 Libderiv->deriv2_classes[5][7][1] = int_stack + 751839;
 Libderiv->deriv2_classes[5][8][1] = int_stack + 752595;
 Libderiv->deriv_classes[6][4][1] = int_stack + 753540;
 Libderiv->deriv_classes[6][5][1] = int_stack + 753960;
 Libderiv->deriv_classes[6][6][1] = int_stack + 754548;
 Libderiv->deriv_classes[6][7][1] = int_stack + 755332;
 Libderiv->deriv_classes[6][8][1] = int_stack + 756340;
 Libderiv->deriv2_classes[6][4][1] = int_stack + 757600;
 Libderiv->deriv2_classes[6][5][1] = int_stack + 758020;
 Libderiv->deriv2_classes[6][6][1] = int_stack + 758608;
 Libderiv->deriv2_classes[6][7][1] = int_stack + 759392;
 Libderiv->deriv2_classes[6][8][1] = int_stack + 760400;
 Libderiv->deriv2_classes[7][4][1] = int_stack + 761660;
 Libderiv->deriv2_classes[7][5][1] = int_stack + 762200;
 Libderiv->deriv2_classes[7][6][1] = int_stack + 762956;
 Libderiv->deriv2_classes[7][7][1] = int_stack + 763964;
 Libderiv->deriv2_classes[7][8][1] = int_stack + 765260;
 Libderiv->dvrr_classes[4][4] = int_stack + 766880;
 Libderiv->dvrr_classes[4][5] = int_stack + 767105;
 Libderiv->dvrr_classes[4][6] = int_stack + 767420;
 Libderiv->dvrr_classes[4][7] = int_stack + 767840;
 Libderiv->dvrr_classes[4][8] = int_stack + 768380;
 Libderiv->deriv_classes[4][4][0] = int_stack + 769055;
 Libderiv->deriv_classes[4][5][0] = int_stack + 769280;
 Libderiv->deriv_classes[4][6][0] = int_stack + 769595;
 Libderiv->deriv_classes[4][7][0] = int_stack + 770015;
 Libderiv->deriv_classes[4][8][0] = int_stack + 770555;
 Libderiv->deriv2_classes[4][4][0] = int_stack + 771230;
 Libderiv->deriv2_classes[4][5][0] = int_stack + 771455;
 Libderiv->deriv2_classes[4][6][0] = int_stack + 771770;
 Libderiv->deriv2_classes[4][7][0] = int_stack + 772190;
 Libderiv->deriv2_classes[4][8][0] = int_stack + 772730;
 Libderiv->dvrr_classes[5][4] = int_stack + 773405;
 Libderiv->dvrr_classes[5][5] = int_stack + 773720;
 Libderiv->dvrr_classes[5][6] = int_stack + 774161;
 Libderiv->dvrr_classes[5][7] = int_stack + 774749;
 Libderiv->dvrr_classes[5][8] = int_stack + 775505;
 Libderiv->deriv_classes[5][4][0] = int_stack + 776450;
 Libderiv->deriv_classes[5][5][0] = int_stack + 776765;
 Libderiv->deriv_classes[5][6][0] = int_stack + 777206;
 Libderiv->deriv_classes[5][7][0] = int_stack + 777794;
 Libderiv->deriv_classes[5][8][0] = int_stack + 778550;
 Libderiv->deriv2_classes[5][4][0] = int_stack + 779495;
 Libderiv->deriv2_classes[5][5][0] = int_stack + 779810;
 Libderiv->deriv2_classes[5][6][0] = int_stack + 780251;
 Libderiv->deriv2_classes[5][7][0] = int_stack + 780839;
 Libderiv->deriv2_classes[5][8][0] = int_stack + 781595;
 Libderiv->deriv_classes[6][4][0] = int_stack + 782540;
 Libderiv->deriv_classes[6][5][0] = int_stack + 782960;
 Libderiv->deriv_classes[6][6][0] = int_stack + 783548;
 Libderiv->deriv_classes[6][7][0] = int_stack + 784332;
 Libderiv->deriv_classes[6][8][0] = int_stack + 785340;
 Libderiv->deriv2_classes[6][4][0] = int_stack + 786600;
 Libderiv->deriv2_classes[6][5][0] = int_stack + 787020;
 Libderiv->deriv2_classes[6][6][0] = int_stack + 787608;
 Libderiv->deriv2_classes[6][7][0] = int_stack + 788392;
 Libderiv->deriv2_classes[6][8][0] = int_stack + 789400;
 Libderiv->deriv2_classes[7][4][0] = int_stack + 790660;
 Libderiv->deriv2_classes[7][5][0] = int_stack + 791200;
 Libderiv->deriv2_classes[7][6][0] = int_stack + 791956;
 Libderiv->deriv2_classes[7][7][0] = int_stack + 792964;
 Libderiv->deriv2_classes[7][8][0] = int_stack + 794260;
 memset(int_stack,0,6367040);

 Libderiv->dvrr_stack = int_stack + 3249046;
 for(i=0;i<num_prim_comb;i++) {
   d12vrr_order_gfgg(Libderiv, Data);
   Data++;
 }

 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+795880,int_stack+767105,int_stack+766880,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+796555,int_stack+767420,int_stack+767105,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+797500,int_stack+796555,int_stack+795880,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+798850,int_stack+767840,int_stack+767420,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+800110,int_stack+798850,int_stack+796555,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+802000,int_stack+800110,int_stack+797500,15);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+804250,int_stack+570465,int_stack+570240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+766880,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+804925,int_stack+570780,int_stack+570465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767105,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+805870,int_stack+804925,int_stack+804250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+807220,int_stack+571200,int_stack+570780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767420,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+808480,int_stack+807220,int_stack+804925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796555,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+810370,int_stack+808480,int_stack+805870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797500,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+812620,int_stack+571740,int_stack+571200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767840,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+814240,int_stack+812620,int_stack+807220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798850,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+816760,int_stack+814240,int_stack+808480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800110,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+812620,int_stack+816760,int_stack+810370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802000,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+815995,int_stack+773720,int_stack+773405,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+816940,int_stack+774161,int_stack+773720,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+818263,int_stack+816940,int_stack+815995,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+820153,int_stack+774749,int_stack+774161,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+821917,int_stack+820153,int_stack+816940,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+824563,int_stack+821917,int_stack+818263,21);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+827713,int_stack+574905,int_stack+574590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+828658,int_stack+575346,int_stack+574905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773720,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+829981,int_stack+828658,int_stack+827713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+831871,int_stack+575934,int_stack+575346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774161,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+833635,int_stack+831871,int_stack+828658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816940,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+836281,int_stack+833635,int_stack+829981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818263,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+839431,int_stack+576690,int_stack+575934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774749,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+841699,int_stack+839431,int_stack+831871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820153,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+845227,int_stack+841699,int_stack+833635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821917,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+839431,int_stack+845227,int_stack+836281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824563,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+844156,int_stack+839431,int_stack+812620,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+854281,int_stack+700420,int_stack+699580,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+855541,int_stack+701596,int_stack+700420,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+857305,int_stack+855541,int_stack+854281,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+859825,int_stack+703164,int_stack+701596,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+862177,int_stack+859825,int_stack+855541,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+865705,int_stack+862177,int_stack+857305,28);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+869905,int_stack+581100,int_stack+580680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699580,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+871165,int_stack+581688,int_stack+581100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700420,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+872929,int_stack+871165,int_stack+869905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+875449,int_stack+582472,int_stack+581688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701596,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+877801,int_stack+875449,int_stack+871165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855541,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+881329,int_stack+877801,int_stack+872929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857305,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+885529,int_stack+583480,int_stack+582472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703164,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+888553,int_stack+885529,int_stack+875449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859825,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+893257,int_stack+888553,int_stack+877801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862177,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+885529,int_stack+893257,int_stack+881329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865705,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+891829,int_stack+885529,int_stack+839431,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+906004,int_stack+891829,int_stack+844156,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+926254,int_stack+336036,int_stack+334416,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+927874,int_stack+338304,int_stack+336036,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+930142,int_stack+927874,int_stack+926254,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+933382,int_stack+8100,int_stack+338304,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+936406,int_stack+933382,int_stack+927874,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+940942,int_stack+936406,int_stack+930142,36);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+946342,int_stack+244996,int_stack+243916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334416,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+947962,int_stack+246508,int_stack+244996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336036,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+950230,int_stack+947962,int_stack+946342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+953470,int_stack+248524,int_stack+246508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338304,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+956494,int_stack+953470,int_stack+947962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927874,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+961030,int_stack+956494,int_stack+950230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930142,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+966430,int_stack+0,int_stack+248524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+970318,int_stack+966430,int_stack+953470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+933382,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+976366,int_stack+970318,int_stack+956494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936406,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+966430,int_stack+976366,int_stack+961030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940942,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+974530,int_stack+966430,int_stack+885529,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+993430,int_stack+974530,int_stack+891829,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+571740,int_stack+594245,int_stack+594020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+766880, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+576690,int_stack+594560,int_stack+594245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767105, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+966430,int_stack+576690,int_stack+571740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+583480,int_stack+594980,int_stack+594560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767420, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+967780,int_stack+583480,int_stack+576690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796555, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+969670,int_stack+967780,int_stack+966430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797500, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+595520,int_stack+594980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767840, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+971920,int_stack+0,int_stack+583480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798850, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+974440,int_stack+971920,int_stack+967780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800110, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+977590,int_stack+974440,int_stack+969670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802000, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+971920,int_stack+598685,int_stack+598370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+972865,int_stack+599126,int_stack+598685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773720, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+974188,int_stack+972865,int_stack+971920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+980965,int_stack+599714,int_stack+599126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774161, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+982729,int_stack+980965,int_stack+972865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816940, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+985375,int_stack+982729,int_stack+974188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818263, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+988525,int_stack+600470,int_stack+599714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774749, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1021780,int_stack+988525,int_stack+980965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820153, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+988525,int_stack+1021780,int_stack+982729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821917, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1021780,int_stack+988525,int_stack+985375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824563, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1026505,int_stack+1021780,int_stack+977590,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+988525,int_stack+604880,int_stack+604460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699580, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+989785,int_stack+605468,int_stack+604880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700420, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1036630,int_stack+989785,int_stack+988525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1039150,int_stack+606252,int_stack+605468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701596, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1041502,int_stack+1039150,int_stack+989785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855541, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1045030,int_stack+1041502,int_stack+1036630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857305, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1049230,int_stack+607260,int_stack+606252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703164, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1052254,int_stack+1049230,int_stack+1039150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859825, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1056958,int_stack+1052254,int_stack+1041502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862177, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1049230,int_stack+1056958,int_stack+1045030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865705, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1055530,int_stack+1049230,int_stack+1021780,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1069705,int_stack+1055530,int_stack+1026505,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+263096,int_stack+262016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334416, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1089955,int_stack+264608,int_stack+263096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336036, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1092223,int_stack+1089955,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1095463,int_stack+266624,int_stack+264608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338304, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1098487,int_stack+1095463,int_stack+1089955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927874, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1103023,int_stack+1098487,int_stack+1092223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930142, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1108423,int_stack+1620,int_stack+266624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1112311,int_stack+1108423,int_stack+1095463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+933382, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1118359,int_stack+1112311,int_stack+1098487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936406, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1108423,int_stack+1118359,int_stack+1103023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940942, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1116523,int_stack+1108423,int_stack+1049230,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1135423,int_stack+1116523,int_stack+1055530,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+595520,int_stack+618025,int_stack+617800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+766880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+600470,int_stack+618340,int_stack+618025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767105, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1108423,int_stack+600470,int_stack+595520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+607260,int_stack+618760,int_stack+618340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767420, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1109773,int_stack+607260,int_stack+600470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796555, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1111663,int_stack+1109773,int_stack+1108423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797500, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1620,int_stack+619300,int_stack+618760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767840, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1113913,int_stack+1620,int_stack+607260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798850, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1116433,int_stack+1113913,int_stack+1109773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800110, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1119583,int_stack+1116433,int_stack+1111663, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802000, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1113913,int_stack+622465,int_stack+622150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1114858,int_stack+622906,int_stack+622465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773720, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1116181,int_stack+1114858,int_stack+1113913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1122958,int_stack+623494,int_stack+622906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774161, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1124722,int_stack+1122958,int_stack+1114858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816940, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1127368,int_stack+1124722,int_stack+1116181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818263, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1130518,int_stack+624250,int_stack+623494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774749, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1163773,int_stack+1130518,int_stack+1122958, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820153, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1130518,int_stack+1163773,int_stack+1124722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821917, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1163773,int_stack+1130518,int_stack+1127368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824563, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1168498,int_stack+1163773,int_stack+1119583,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1130518,int_stack+628660,int_stack+628240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699580, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1131778,int_stack+629248,int_stack+628660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700420, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1178623,int_stack+1131778,int_stack+1130518, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1181143,int_stack+630032,int_stack+629248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701596, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1183495,int_stack+1181143,int_stack+1131778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855541, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1187023,int_stack+1183495,int_stack+1178623, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857305, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1191223,int_stack+631040,int_stack+630032, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703164, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1194247,int_stack+1191223,int_stack+1181143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859825, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1198951,int_stack+1194247,int_stack+1183495, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862177, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1191223,int_stack+1198951,int_stack+1187023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865705, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1197523,int_stack+1191223,int_stack+1163773,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1211698,int_stack+1197523,int_stack+1168498,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1620,int_stack+281196,int_stack+280116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334416, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1231948,int_stack+282708,int_stack+281196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336036, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1234216,int_stack+1231948,int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1237456,int_stack+284724,int_stack+282708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338304, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1240480,int_stack+1237456,int_stack+1231948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927874, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1245016,int_stack+1240480,int_stack+1234216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930142, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1250416,int_stack+3240,int_stack+284724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1254304,int_stack+1250416,int_stack+1237456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+933382, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1260352,int_stack+1254304,int_stack+1240480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936406, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1250416,int_stack+1260352,int_stack+1245016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940942, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1258516,int_stack+1250416,int_stack+1191223,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1277416,int_stack+1258516,int_stack+1197523,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+619300,int_stack+641805,int_stack+641580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+766880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+624250,int_stack+642120,int_stack+641805, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1250416,int_stack+624250,int_stack+619300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+631040,int_stack+642540,int_stack+642120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1251766,int_stack+631040,int_stack+624250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+796555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1253656,int_stack+1251766,int_stack+1250416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+3240,int_stack+643080,int_stack+642540, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1255906,int_stack+3240,int_stack+631040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+798850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1258426,int_stack+1255906,int_stack+1251766, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+800110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1261576,int_stack+1258426,int_stack+1253656, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+802000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1255906,int_stack+646245,int_stack+645930, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1256851,int_stack+646686,int_stack+646245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1258174,int_stack+1256851,int_stack+1255906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1264951,int_stack+647274,int_stack+646686, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1266715,int_stack+1264951,int_stack+1256851, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+816940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1269361,int_stack+1266715,int_stack+1258174, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+818263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1272511,int_stack+648030,int_stack+647274, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+774749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1305766,int_stack+1272511,int_stack+1264951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1272511,int_stack+1305766,int_stack+1266715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1305766,int_stack+1272511,int_stack+1269361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+824563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1310491,int_stack+1305766,int_stack+1261576,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1272511,int_stack+652440,int_stack+652020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1273771,int_stack+653028,int_stack+652440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1320616,int_stack+1273771,int_stack+1272511, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1323136,int_stack+653812,int_stack+653028, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1325488,int_stack+1323136,int_stack+1273771, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+855541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1329016,int_stack+1325488,int_stack+1320616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+857305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1333216,int_stack+654820,int_stack+653812, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+703164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1336240,int_stack+1333216,int_stack+1323136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1340944,int_stack+1336240,int_stack+1325488, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1333216,int_stack+1340944,int_stack+1329016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1339516,int_stack+1333216,int_stack+1305766,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1353691,int_stack+1339516,int_stack+1310491,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+3240,int_stack+299296,int_stack+298216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1373941,int_stack+300808,int_stack+299296, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1376209,int_stack+1373941,int_stack+3240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1379449,int_stack+302824,int_stack+300808, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+338304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1382473,int_stack+1379449,int_stack+1373941, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1387009,int_stack+1382473,int_stack+1376209, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+930142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1392409,int_stack+4860,int_stack+302824, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1396297,int_stack+1392409,int_stack+1379449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+933382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1402345,int_stack+1396297,int_stack+1382473, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+936406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1392409,int_stack+1402345,int_stack+1387009, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+940942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1400509,int_stack+1392409,int_stack+1333216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1419409,int_stack+1400509,int_stack+1339516,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+643080,int_stack+665585,int_stack+665360, 0.0, zero_stack, 1.0, int_stack+766880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+648030,int_stack+665900,int_stack+665585, 0.0, zero_stack, 1.0, int_stack+767105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1392409,int_stack+648030,int_stack+643080, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+654820,int_stack+666320,int_stack+665900, 0.0, zero_stack, 1.0, int_stack+767420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1393759,int_stack+654820,int_stack+648030, 0.0, zero_stack, 1.0, int_stack+796555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1395649,int_stack+1393759,int_stack+1392409, 0.0, zero_stack, 1.0, int_stack+797500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+4860,int_stack+666860,int_stack+666320, 0.0, zero_stack, 1.0, int_stack+767840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1397899,int_stack+4860,int_stack+654820, 0.0, zero_stack, 1.0, int_stack+798850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1400419,int_stack+1397899,int_stack+1393759, 0.0, zero_stack, 1.0, int_stack+800110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1403569,int_stack+1400419,int_stack+1395649, 0.0, zero_stack, 1.0, int_stack+802000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1397899,int_stack+670025,int_stack+669710, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1398844,int_stack+670466,int_stack+670025, 0.0, zero_stack, 1.0, int_stack+773720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1400167,int_stack+1398844,int_stack+1397899, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1406944,int_stack+671054,int_stack+670466, 0.0, zero_stack, 1.0, int_stack+774161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1408708,int_stack+1406944,int_stack+1398844, 0.0, zero_stack, 1.0, int_stack+816940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1411354,int_stack+1408708,int_stack+1400167, 0.0, zero_stack, 1.0, int_stack+818263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1414504,int_stack+671810,int_stack+671054, 0.0, zero_stack, 1.0, int_stack+774749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1447759,int_stack+1414504,int_stack+1406944, 0.0, zero_stack, 1.0, int_stack+820153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1414504,int_stack+1447759,int_stack+1408708, 0.0, zero_stack, 1.0, int_stack+821917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1447759,int_stack+1414504,int_stack+1411354, 0.0, zero_stack, 1.0, int_stack+824563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1452484,int_stack+1447759,int_stack+1403569,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1414504,int_stack+676220,int_stack+675800, 0.0, zero_stack, 1.0, int_stack+699580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1415764,int_stack+676808,int_stack+676220, 0.0, zero_stack, 1.0, int_stack+700420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1462609,int_stack+1415764,int_stack+1414504, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1465129,int_stack+677592,int_stack+676808, 0.0, zero_stack, 1.0, int_stack+701596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1467481,int_stack+1465129,int_stack+1415764, 0.0, zero_stack, 1.0, int_stack+855541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1471009,int_stack+1467481,int_stack+1462609, 0.0, zero_stack, 1.0, int_stack+857305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1475209,int_stack+678600,int_stack+677592, 0.0, zero_stack, 1.0, int_stack+703164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1478233,int_stack+1475209,int_stack+1465129, 0.0, zero_stack, 1.0, int_stack+859825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1482937,int_stack+1478233,int_stack+1467481, 0.0, zero_stack, 1.0, int_stack+862177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1475209,int_stack+1482937,int_stack+1471009, 0.0, zero_stack, 1.0, int_stack+865705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1481509,int_stack+1475209,int_stack+1447759,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1495684,int_stack+1481509,int_stack+1452484,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+4860,int_stack+317396,int_stack+316316, 0.0, zero_stack, 1.0, int_stack+334416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1515934,int_stack+318908,int_stack+317396, 0.0, zero_stack, 1.0, int_stack+336036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1518202,int_stack+1515934,int_stack+4860, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1521442,int_stack+320924,int_stack+318908, 0.0, zero_stack, 1.0, int_stack+338304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1524466,int_stack+1521442,int_stack+1515934, 0.0, zero_stack, 1.0, int_stack+927874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1529002,int_stack+1524466,int_stack+1518202, 0.0, zero_stack, 1.0, int_stack+930142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1534402,int_stack+6480,int_stack+320924, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1538290,int_stack+1534402,int_stack+1521442, 0.0, zero_stack, 1.0, int_stack+933382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1544338,int_stack+1538290,int_stack+1524466, 0.0, zero_stack, 1.0, int_stack+936406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1534402,int_stack+1544338,int_stack+1529002, 0.0, zero_stack, 1.0, int_stack+940942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1542502,int_stack+1534402,int_stack+1475209,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1561402,int_stack+1542502,int_stack+1481509,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+666860,int_stack+689365,int_stack+689140, 1.0, int_stack+766880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+671810,int_stack+689680,int_stack+689365, 1.0, int_stack+767105, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1534402,int_stack+671810,int_stack+666860, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+678600,int_stack+690100,int_stack+689680, 1.0, int_stack+767420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1535752,int_stack+678600,int_stack+671810, 1.0, int_stack+796555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1537642,int_stack+1535752,int_stack+1534402, 1.0, int_stack+797500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+6480,int_stack+690640,int_stack+690100, 1.0, int_stack+767840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+795880,int_stack+6480,int_stack+678600, 1.0, int_stack+798850, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1539892,int_stack+795880,int_stack+1535752, 1.0, int_stack+800110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1543042,int_stack+1539892,int_stack+1537642, 1.0, int_stack+802000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1539892,int_stack+693805,int_stack+693490, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1540837,int_stack+694246,int_stack+693805, 1.0, int_stack+773720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+795880,int_stack+1540837,int_stack+1539892, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1546417,int_stack+694834,int_stack+694246, 1.0, int_stack+774161, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1548181,int_stack+1546417,int_stack+1540837, 1.0, int_stack+816940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1550827,int_stack+1548181,int_stack+795880, 1.0, int_stack+818263, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815995,int_stack+695590,int_stack+694834, 1.0, int_stack+774749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1553977,int_stack+815995,int_stack+1546417, 1.0, int_stack+820153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1589752,int_stack+1553977,int_stack+1548181, 1.0, int_stack+821917, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1553977,int_stack+1589752,int_stack+1550827, 1.0, int_stack+824563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+1589752,int_stack+1553977,int_stack+1543042,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1558702,int_stack+701008,int_stack+700000, 1.0, int_stack+699580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+815995,int_stack+702380,int_stack+701008, 1.0, int_stack+700420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1599877,int_stack+815995,int_stack+1558702, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+817759,int_stack+704172,int_stack+702380, 1.0, int_stack+701596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1602397,int_stack+817759,int_stack+815995, 1.0, int_stack+855541, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1605925,int_stack+1602397,int_stack+1599877, 1.0, int_stack+857305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+854281,int_stack+705180,int_stack+704172, 1.0, int_stack+703164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1610125,int_stack+854281,int_stack+817759, 1.0, int_stack+859825, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1614829,int_stack+1610125,int_stack+1602397, 1.0, int_stack+862177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1620709,int_stack+1614829,int_stack+1605925, 1.0, int_stack+865705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1627009,int_stack+1620709,int_stack+1553977,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1641184,int_stack+1627009,int_stack+1589752,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+6480,int_stack+336792,int_stack+334956, 1.0, int_stack+334416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1610125,int_stack+339312,int_stack+336792, 1.0, int_stack+336036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1612393,int_stack+1610125,int_stack+6480, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1615633,int_stack+341328,int_stack+339312, 1.0, int_stack+338304, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+854281,int_stack+1615633,int_stack+1610125, 1.0, int_stack+927874, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+854281,int_stack+1612393, 1.0, int_stack+930142, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+926254,int_stack+9396,int_stack+341328, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1666834,int_stack+926254,int_stack+1615633, 1.0, int_stack+933382, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+926254,int_stack+1666834,int_stack+854281, 1.0, int_stack+936406, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1666834,int_stack+926254,int_stack+1661434, 1.0, int_stack+940942, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+926254,int_stack+1666834,int_stack+1620709,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1666834,int_stack+926254,int_stack+1627009,225);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+926254,int_stack+768380,int_stack+767840,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+927874,int_stack+926254,int_stack+798850,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+930394,int_stack+927874,int_stack+800110,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+926254,int_stack+930394,int_stack+802000,15);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+929629,int_stack+775505,int_stack+774749,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+931897,int_stack+929629,int_stack+820153,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+935425,int_stack+931897,int_stack+821917,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+929629,int_stack+935425,int_stack+824563,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+934354,int_stack+929629,int_stack+926254,225);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+820111,int_stack+14256,int_stack+703164,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+797770,int_stack+820111,int_stack+859825,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+820111,int_stack+797770,int_stack+862177,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+797770,int_stack+820111,int_stack+865705,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+797770,int_stack+929629,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1709359,int_stack+1695184,int_stack+934354,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+690640,int_stack+719545,int_stack+719320,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+695590,int_stack+719860,int_stack+719545,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+820111,int_stack+695590,int_stack+690640,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+720280,int_stack+719860,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+821461,int_stack+14256,int_stack+695590,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+823351,int_stack+821461,int_stack+820111,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+825601,int_stack+720820,int_stack+720280,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+8100,int_stack+825601,int_stack+14256,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+858817,int_stack+8100,int_stack+821461,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+861967,int_stack+858817,int_stack+823351,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+858817,int_stack+723985,int_stack+723670,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+859762,int_stack+724426,int_stack+723985,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+8100,int_stack+859762,int_stack+858817,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+825601,int_stack+725014,int_stack+724426,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+865342,int_stack+825601,int_stack+859762,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1729609,int_stack+865342,int_stack+8100,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+773405,int_stack+725770,int_stack+725014,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1732759,int_stack+773405,int_stack+825601,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1736287,int_stack+1732759,int_stack+865342,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1740697,int_stack+1736287,int_stack+1729609,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1745422,int_stack+1740697,int_stack+861967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+705180,int_stack+730180,int_stack+729760,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1732759,int_stack+730768,int_stack+730180,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1734523,int_stack+1732759,int_stack+705180,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1737043,int_stack+731552,int_stack+730768,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1755547,int_stack+1737043,int_stack+1732759,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1759075,int_stack+1755547,int_stack+1734523,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+773405,int_stack+732560,int_stack+731552,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1763275,int_stack+773405,int_stack+1737043,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1767979,int_stack+1763275,int_stack+1755547,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1773859,int_stack+1767979,int_stack+1759075,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1780159,int_stack+1773859,int_stack+1740697, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+929629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1794334,int_stack+1780159,int_stack+1745422, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1763275,int_stack+428400,int_stack+427320,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1764895,int_stack+429912,int_stack+428400,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1767163,int_stack+1764895,int_stack+1763275,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1770403,int_stack+431928,int_stack+429912,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1814584,int_stack+1770403,int_stack+1764895,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1819120,int_stack+1814584,int_stack+1767163,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1824520,int_stack+11016,int_stack+431928,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1828408,int_stack+1824520,int_stack+1770403,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1834456,int_stack+1828408,int_stack+1814584,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1824520,int_stack+1834456,int_stack+1819120,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+1832620,int_stack+1824520,int_stack+1773859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+797770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1851520,int_stack+1832620,int_stack+1780159, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+720820,int_stack+743325,int_stack+743100,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+725770,int_stack+743640,int_stack+743325,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1824520,int_stack+725770,int_stack+720820,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+732560,int_stack+744060,int_stack+743640,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1825870,int_stack+732560,int_stack+725770,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1827760,int_stack+1825870,int_stack+1824520,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1830010,int_stack+744600,int_stack+744060,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1831630,int_stack+1830010,int_stack+732560,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1834150,int_stack+1831630,int_stack+1825870,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1830010,int_stack+1834150,int_stack+1827760,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1833385,int_stack+747765,int_stack+747450,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1834330,int_stack+748206,int_stack+747765,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1835653,int_stack+1834330,int_stack+1833385,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1837543,int_stack+748794,int_stack+748206,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+9990,int_stack+1837543,int_stack+1834330,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1839307,int_stack+9990,int_stack+1835653,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1842457,int_stack+749550,int_stack+748794,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1844725,int_stack+1842457,int_stack+1837543,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1879870,int_stack+1844725,int_stack+9990,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1842457,int_stack+1879870,int_stack+1839307,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+1879870,int_stack+1842457,int_stack+1830010, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1847182,int_stack+753960,int_stack+753540,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1848442,int_stack+754548,int_stack+753960,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+773405,int_stack+1848442,int_stack+1847182,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1889995,int_stack+755332,int_stack+754548,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1892347,int_stack+1889995,int_stack+1848442,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1895875,int_stack+1892347,int_stack+773405,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1900075,int_stack+756340,int_stack+755332,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1903099,int_stack+1900075,int_stack+1889995,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1907803,int_stack+1903099,int_stack+1892347,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1900075,int_stack+1907803,int_stack+1895875,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1906375,int_stack+1900075,int_stack+1842457, 0.0, zero_stack, 1.0, int_stack+929629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1920550,int_stack+1906375,int_stack+1879870, 0.0, zero_stack, 1.0, int_stack+934354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+944479,int_stack+533500,int_stack+532420,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1940800,int_stack+535012,int_stack+533500,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1943068,int_stack+1940800,int_stack+944479,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1946308,int_stack+537028,int_stack+535012,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1949332,int_stack+1946308,int_stack+1940800,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1953868,int_stack+1949332,int_stack+1943068,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1959268,int_stack+12636,int_stack+537028,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1963156,int_stack+1959268,int_stack+1946308,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1969204,int_stack+1963156,int_stack+1949332,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1959268,int_stack+1969204,int_stack+1953868,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+1967368,int_stack+1959268,int_stack+1900075, 0.0, zero_stack, 1.0, int_stack+797770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1986268,int_stack+1967368,int_stack+1906375, 0.0, zero_stack, 1.0, int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+744600,int_stack+769280,int_stack+769055,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+749550,int_stack+769595,int_stack+769280,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1959268,int_stack+749550,int_stack+744600,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+756340,int_stack+770015,int_stack+769595,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1960618,int_stack+756340,int_stack+749550,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1962508,int_stack+1960618,int_stack+1959268,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+12636,int_stack+770555,int_stack+770015,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1964758,int_stack+12636,int_stack+756340,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1967278,int_stack+1964758,int_stack+1960618,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1970428,int_stack+1967278,int_stack+1962508,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1964758,int_stack+776765,int_stack+776450,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1965703,int_stack+777206,int_stack+776765,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1967026,int_stack+1965703,int_stack+1964758,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1973803,int_stack+777794,int_stack+777206,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1975567,int_stack+1973803,int_stack+1965703,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1978213,int_stack+1975567,int_stack+1967026,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1981363,int_stack+778550,int_stack+777794,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2014618,int_stack+1981363,int_stack+1973803,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1981363,int_stack+2014618,int_stack+1975567,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2014618,int_stack+1981363,int_stack+1978213,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+2019343,int_stack+2014618,int_stack+1970428, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+926254,int_stack+782960,int_stack+782540,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+927514,int_stack+783548,int_stack+782960,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1981363,int_stack+927514,int_stack+926254,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1983883,int_stack+784332,int_stack+783548,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2029468,int_stack+1983883,int_stack+927514,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2032996,int_stack+2029468,int_stack+1981363,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2037196,int_stack+785340,int_stack+784332,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2040220,int_stack+2037196,int_stack+1983883,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2044924,int_stack+2040220,int_stack+2029468,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2037196,int_stack+2044924,int_stack+2032996,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2043496,int_stack+2037196,int_stack+2014618, 1.0, int_stack+929629, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+2057671,int_stack+2043496,int_stack+2019343, 1.0, int_stack+934354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+12636,int_stack+711580,int_stack+710500,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+929278,int_stack+713092,int_stack+711580,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+931546,int_stack+929278,int_stack+12636,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+934786,int_stack+715108,int_stack+713092,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+937810,int_stack+934786,int_stack+929278,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2077921,int_stack+937810,int_stack+931546,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2083321,int_stack+15516,int_stack+715108,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2087209,int_stack+2083321,int_stack+934786,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2093257,int_stack+2087209,int_stack+937810,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2083321,int_stack+2093257,int_stack+2077921,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2091421,int_stack+2083321,int_stack+2037196, 1.0, int_stack+797770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2110321,int_stack+2091421,int_stack+2043496, 1.0, int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+17361,int_stack+17136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+570240,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+17676,int_stack+17361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+570465,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+804250,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+18096,int_stack+17676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+570780,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+804925,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+805870,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+18636,int_stack+18096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+571200,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+807220,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+808480,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+810370,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+19626,int_stack+19311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+574590,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+20067,int_stack+19626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+574905,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+827713,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+20655,int_stack+20067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+575346,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+828658,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+797770,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+829981,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+21411,int_stack+20655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+575934,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2083321,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+831871,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2083321,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+833635,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+797770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+836281,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2083321,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+22776,int_stack+22356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+580680,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+797770,int_stack+23364,int_stack+22776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+581100,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+799534,int_stack+797770,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+869905,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1699909,int_stack+24148,int_stack+23364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+581688,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1702261,int_stack+1699909,int_stack+797770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+871165,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2093446,int_stack+1702261,int_stack+799534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+872929,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+797770,int_stack+25156,int_stack+24148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+582472,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2097646,int_stack+797770,int_stack+1699909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+875449,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+797770,int_stack+2097646,int_stack+1702261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+877801,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2097646,int_stack+797770,int_stack+2093446, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+881329,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+2097646,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2152846,int_stack+2138671,int_stack+2083321,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2083321,int_stack+26956,int_stack+26416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+243916,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2084941,int_stack+27712,int_stack+26956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+244996,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2087209,int_stack+2084941,int_stack+2083321, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+946342,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2090449,int_stack+28720,int_stack+27712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+246508,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+2090449,int_stack+2084941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+947962,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1699720,int_stack+1695184,int_stack+2087209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+950230,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2083321,int_stack+30016,int_stack+28720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+248524,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+797770,int_stack+2083321,int_stack+2090449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+953470,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2083321,int_stack+797770,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+956494,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15516,int_stack+2083321,int_stack+1699720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+961030,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+15516,int_stack+2097646,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2191996,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+31861,int_stack+31636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570240, 1.0, int_stack+594020,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+32176,int_stack+31861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570465, 1.0, int_stack+594245,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804250, 1.0, int_stack+571740,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+32596,int_stack+32176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570780, 1.0, int_stack+594560,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804925, 1.0, int_stack+576690,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+805870, 1.0, int_stack+966430,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+33136,int_stack+32596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571200, 1.0, int_stack+594980,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807220, 1.0, int_stack+583480,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808480, 1.0, int_stack+967780,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810370, 1.0, int_stack+969670,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+34126,int_stack+33811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574590, 1.0, int_stack+598370,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+34567,int_stack+34126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574905, 1.0, int_stack+598685,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827713, 1.0, int_stack+971920,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+35155,int_stack+34567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575346, 1.0, int_stack+599126,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828658, 1.0, int_stack+972865,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829981, 1.0, int_stack+974188,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+35911,int_stack+35155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575934, 1.0, int_stack+599714,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+831871, 1.0, int_stack+980965,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+833635, 1.0, int_stack+982729,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836281, 1.0, int_stack+985375,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+37276,int_stack+36856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580680, 1.0, int_stack+604460,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+37864,int_stack+37276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581100, 1.0, int_stack+604880,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+869905, 1.0, int_stack+988525,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+38648,int_stack+37864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581688, 1.0, int_stack+605468,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+871165, 1.0, int_stack+989785,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+872929, 1.0, int_stack+1036630,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+39656,int_stack+38648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582472, 1.0, int_stack+606252,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+15516,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+875449, 1.0, int_stack+1039150,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+15516,int_stack+2143396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877801, 1.0, int_stack+1041502,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+15516,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881329, 1.0, int_stack+1045030,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+15516,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2083321,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+41456,int_stack+40916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243916, 1.0, int_stack+262016,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+42212,int_stack+41456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244996, 1.0, int_stack+263096,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+946342, 1.0, int_stack+0,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+43220,int_stack+42212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246508, 1.0, int_stack+264608,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947962, 1.0, int_stack+1089955,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+950230, 1.0, int_stack+1092223,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+44516,int_stack+43220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248524, 1.0, int_stack+266624,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+953470, 1.0, int_stack+1095463,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+956494, 1.0, int_stack+1098487,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961030, 1.0, int_stack+1103023,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+15516,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+15516,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+46361,int_stack+46136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+594020, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+46676,int_stack+46361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+594245, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+571740, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+47096,int_stack+46676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+594560, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+576690, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+966430, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+47636,int_stack+47096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+594980, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+583480, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+967780, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+969670, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+48626,int_stack+48311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+598370, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+49067,int_stack+48626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+598685, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+971920, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+49655,int_stack+49067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+599126, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+972865, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+974188, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+50411,int_stack+49655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+599714, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+980965, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+982729, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+985375, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+51776,int_stack+51356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+604460, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+52364,int_stack+51776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+604880, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+988525, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+53148,int_stack+52364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+605468, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+989785, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1036630, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+54156,int_stack+53148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+606252, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43866,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1039150, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+43866,int_stack+1699909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1041502, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+43866,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1045030, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+43866,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2220346,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+55956,int_stack+55416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+262016, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+56712,int_stack+55956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+263096, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+57720,int_stack+56712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+264608, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1089955, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1092223, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+59016,int_stack+57720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+266624, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1095463, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1098487, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1103023, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+43866,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2240596,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+60861,int_stack+60636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570240, 0.0, zero_stack, 1.0, int_stack+617800,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+61176,int_stack+60861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570465, 0.0, zero_stack, 1.0, int_stack+618025,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804250, 0.0, zero_stack, 1.0, int_stack+595520,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+61596,int_stack+61176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570780, 0.0, zero_stack, 1.0, int_stack+618340,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804925, 0.0, zero_stack, 1.0, int_stack+600470,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+805870, 0.0, zero_stack, 1.0, int_stack+1108423,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+62136,int_stack+61596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571200, 0.0, zero_stack, 1.0, int_stack+618760,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807220, 0.0, zero_stack, 1.0, int_stack+607260,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808480, 0.0, zero_stack, 1.0, int_stack+1109773,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810370, 0.0, zero_stack, 1.0, int_stack+1111663,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+63126,int_stack+62811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574590, 0.0, zero_stack, 1.0, int_stack+622150,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+63567,int_stack+63126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574905, 0.0, zero_stack, 1.0, int_stack+622465,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827713, 0.0, zero_stack, 1.0, int_stack+1113913,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+64155,int_stack+63567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575346, 0.0, zero_stack, 1.0, int_stack+622906,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828658, 0.0, zero_stack, 1.0, int_stack+1114858,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829981, 0.0, zero_stack, 1.0, int_stack+1116181,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+64911,int_stack+64155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575934, 0.0, zero_stack, 1.0, int_stack+623494,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+831871, 0.0, zero_stack, 1.0, int_stack+1122958,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+833635, 0.0, zero_stack, 1.0, int_stack+1124722,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836281, 0.0, zero_stack, 1.0, int_stack+1127368,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+66276,int_stack+65856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580680, 0.0, zero_stack, 1.0, int_stack+628240,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+66864,int_stack+66276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581100, 0.0, zero_stack, 1.0, int_stack+628660,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+869905, 0.0, zero_stack, 1.0, int_stack+1130518,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+67648,int_stack+66864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581688, 0.0, zero_stack, 1.0, int_stack+629248,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+871165, 0.0, zero_stack, 1.0, int_stack+1131778,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+872929, 0.0, zero_stack, 1.0, int_stack+1178623,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+68656,int_stack+67648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582472, 0.0, zero_stack, 1.0, int_stack+630032,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+43866,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+875449, 0.0, zero_stack, 1.0, int_stack+1181143,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+43866,int_stack+2143396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877801, 0.0, zero_stack, 1.0, int_stack+1183495,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+43866,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881329, 0.0, zero_stack, 1.0, int_stack+1187023,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+43866,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2268946,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+70456,int_stack+69916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243916, 0.0, zero_stack, 1.0, int_stack+280116,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+71212,int_stack+70456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244996, 0.0, zero_stack, 1.0, int_stack+281196,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+946342, 0.0, zero_stack, 1.0, int_stack+1620,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+72220,int_stack+71212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246508, 0.0, zero_stack, 1.0, int_stack+282708,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947962, 0.0, zero_stack, 1.0, int_stack+1231948,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+950230, 0.0, zero_stack, 1.0, int_stack+1234216,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+73516,int_stack+72220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248524, 0.0, zero_stack, 1.0, int_stack+284724,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+953470, 0.0, zero_stack, 1.0, int_stack+1237456,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+956494, 0.0, zero_stack, 1.0, int_stack+1240480,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961030, 0.0, zero_stack, 1.0, int_stack+1245016,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+43866,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+43866,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+75361,int_stack+75136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594020, 1.0, int_stack+617800, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+75676,int_stack+75361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594245, 1.0, int_stack+618025, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571740, 1.0, int_stack+595520, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+76096,int_stack+75676, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594560, 1.0, int_stack+618340, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+576690, 1.0, int_stack+600470, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+966430, 1.0, int_stack+1108423, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+76636,int_stack+76096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594980, 1.0, int_stack+618760, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583480, 1.0, int_stack+607260, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967780, 1.0, int_stack+1109773, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969670, 1.0, int_stack+1111663, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+77626,int_stack+77311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598370, 1.0, int_stack+622150, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+78067,int_stack+77626, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598685, 1.0, int_stack+622465, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+971920, 1.0, int_stack+1113913, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+78655,int_stack+78067, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599126, 1.0, int_stack+622906, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+972865, 1.0, int_stack+1114858, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+974188, 1.0, int_stack+1116181, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+79411,int_stack+78655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599714, 1.0, int_stack+623494, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+980965, 1.0, int_stack+1122958, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+982729, 1.0, int_stack+1124722, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+985375, 1.0, int_stack+1127368, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+80776,int_stack+80356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604460, 1.0, int_stack+628240, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+81364,int_stack+80776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604880, 1.0, int_stack+628660, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+988525, 1.0, int_stack+1130518, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+82148,int_stack+81364, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605468, 1.0, int_stack+629248, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+989785, 1.0, int_stack+1131778, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1036630, 1.0, int_stack+1178623, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+83156,int_stack+82148, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606252, 1.0, int_stack+630032, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1039150, 1.0, int_stack+1181143, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+1699909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1041502, 1.0, int_stack+1183495, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1045030, 1.0, int_stack+1187023, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2289196,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+84956,int_stack+84416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262016, 1.0, int_stack+280116, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+85712,int_stack+84956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263096, 1.0, int_stack+281196, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 1.0, int_stack+1620, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+86720,int_stack+85712, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264608, 1.0, int_stack+282708, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1089955, 1.0, int_stack+1231948, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1092223, 1.0, int_stack+1234216, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+88016,int_stack+86720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266624, 1.0, int_stack+284724, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095463, 1.0, int_stack+1237456, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1098487, 1.0, int_stack+1240480, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1103023, 1.0, int_stack+1245016, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2309446,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+89861,int_stack+89636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+617800, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+90176,int_stack+89861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+618025, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+595520, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+90596,int_stack+90176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+618340, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+600470, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1108423, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+91136,int_stack+90596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+618760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+607260, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1109773, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1111663, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+92126,int_stack+91811, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+622150, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+92567,int_stack+92126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+622465, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1113913, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+93155,int_stack+92567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+622906, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1114858, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1116181, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+93911,int_stack+93155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+623494, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1122958, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1124722, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1127368, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+95276,int_stack+94856, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+628240, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+95864,int_stack+95276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+628660, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1130518, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+96648,int_stack+95864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+629248, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1131778, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1178623, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+97656,int_stack+96648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+630032, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1181143, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+2143396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1183495, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1187023, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+78516,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+99456,int_stack+98916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+280116, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+100212,int_stack+99456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+281196, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+101220,int_stack+100212, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+282708, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1231948, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1234216, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+102516,int_stack+101220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+284724, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1237456, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1240480, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1245016, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2337796,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+104361,int_stack+104136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641580,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+104676,int_stack+104361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641805,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804250, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+619300,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+105096,int_stack+104676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+570780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642120,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+804925, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+624250,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+805870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1250416,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+105636,int_stack+105096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571200, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642540,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+807220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+631040,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1251766,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1253656,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+106626,int_stack+106311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645930,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+107067,int_stack+106626, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+646245,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+827713, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1255906,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+107655,int_stack+107067, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+646686,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+828658, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1256851,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829981, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1258174,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+108411,int_stack+107655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+575934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+647274,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+831871, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1264951,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+833635, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1266715,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+836281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1269361,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+109776,int_stack+109356, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652020,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+110364,int_stack+109776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+652440,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+869905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1272511,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+111148,int_stack+110364, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581688, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653028,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+871165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1273771,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+872929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1320616,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+112156,int_stack+111148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+582472, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+653812,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+875449, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1323136,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+1699909, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1325488,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+881329, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1329016,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2366146,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+113956,int_stack+113416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+298216,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+114712,int_stack+113956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+244996, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299296,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+946342, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+3240,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+115720,int_stack+114712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246508, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+300808,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+947962, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1373941,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+950230, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1376209,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+117016,int_stack+115720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+248524, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+302824,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+953470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1379449,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+956494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1382473,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+961030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1387009,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2386396,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+118861,int_stack+118636, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594020, 0.0, zero_stack, 1.0, int_stack+641580, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+119176,int_stack+118861, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594245, 0.0, zero_stack, 1.0, int_stack+641805, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+571740, 0.0, zero_stack, 1.0, int_stack+619300, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+119596,int_stack+119176, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594560, 0.0, zero_stack, 1.0, int_stack+642120, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+576690, 0.0, zero_stack, 1.0, int_stack+624250, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+966430, 0.0, zero_stack, 1.0, int_stack+1250416, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+120136,int_stack+119596, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594980, 0.0, zero_stack, 1.0, int_stack+642540, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583480, 0.0, zero_stack, 1.0, int_stack+631040, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+967780, 0.0, zero_stack, 1.0, int_stack+1251766, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+969670, 0.0, zero_stack, 1.0, int_stack+1253656, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+121126,int_stack+120811, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598370, 0.0, zero_stack, 1.0, int_stack+645930, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+121567,int_stack+121126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+598685, 0.0, zero_stack, 1.0, int_stack+646245, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+971920, 0.0, zero_stack, 1.0, int_stack+1255906, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+122155,int_stack+121567, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599126, 0.0, zero_stack, 1.0, int_stack+646686, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+972865, 0.0, zero_stack, 1.0, int_stack+1256851, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+974188, 0.0, zero_stack, 1.0, int_stack+1258174, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+122911,int_stack+122155, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599714, 0.0, zero_stack, 1.0, int_stack+647274, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+980965, 0.0, zero_stack, 1.0, int_stack+1264951, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+982729, 0.0, zero_stack, 1.0, int_stack+1266715, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+985375, 0.0, zero_stack, 1.0, int_stack+1269361, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+124276,int_stack+123856, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604460, 0.0, zero_stack, 1.0, int_stack+652020, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+124864,int_stack+124276, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604880, 0.0, zero_stack, 1.0, int_stack+652440, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+988525, 0.0, zero_stack, 1.0, int_stack+1272511, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+125648,int_stack+124864, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605468, 0.0, zero_stack, 1.0, int_stack+653028, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+989785, 0.0, zero_stack, 1.0, int_stack+1273771, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1036630, 0.0, zero_stack, 1.0, int_stack+1320616, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+126656,int_stack+125648, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+606252, 0.0, zero_stack, 1.0, int_stack+653812, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1039150, 0.0, zero_stack, 1.0, int_stack+1323136, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+2143396, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1041502, 0.0, zero_stack, 1.0, int_stack+1325488, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1045030, 0.0, zero_stack, 1.0, int_stack+1329016, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+98766,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+128456,int_stack+127916, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+262016, 0.0, zero_stack, 1.0, int_stack+298216, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+129212,int_stack+128456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+263096, 0.0, zero_stack, 1.0, int_stack+299296, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 1.0, int_stack+3240, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+130220,int_stack+129212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+264608, 0.0, zero_stack, 1.0, int_stack+300808, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1089955, 0.0, zero_stack, 1.0, int_stack+1373941, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1092223, 0.0, zero_stack, 1.0, int_stack+1376209, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+131516,int_stack+130220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266624, 0.0, zero_stack, 1.0, int_stack+302824, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1095463, 0.0, zero_stack, 1.0, int_stack+1379449, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1098487, 0.0, zero_stack, 1.0, int_stack+1382473, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1103023, 0.0, zero_stack, 1.0, int_stack+1387009, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2414746,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+133361,int_stack+133136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+617800, 1.0, int_stack+641580, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+133676,int_stack+133361, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618025, 1.0, int_stack+641805, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+595520, 1.0, int_stack+619300, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+134096,int_stack+133676, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618340, 1.0, int_stack+642120, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+600470, 1.0, int_stack+624250, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1108423, 1.0, int_stack+1250416, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+134636,int_stack+134096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+618760, 1.0, int_stack+642540, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607260, 1.0, int_stack+631040, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1109773, 1.0, int_stack+1251766, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1111663, 1.0, int_stack+1253656, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+135626,int_stack+135311, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622150, 1.0, int_stack+645930, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+136067,int_stack+135626, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622465, 1.0, int_stack+646245, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1113913, 1.0, int_stack+1255906, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+136655,int_stack+136067, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622906, 1.0, int_stack+646686, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1114858, 1.0, int_stack+1256851, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1116181, 1.0, int_stack+1258174, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+137411,int_stack+136655, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+623494, 1.0, int_stack+647274, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1122958, 1.0, int_stack+1264951, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1124722, 1.0, int_stack+1266715, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1127368, 1.0, int_stack+1269361, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+138776,int_stack+138356, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628240, 1.0, int_stack+652020, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+139364,int_stack+138776, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+628660, 1.0, int_stack+652440, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1130518, 1.0, int_stack+1272511, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+140148,int_stack+139364, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+629248, 1.0, int_stack+653028, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1131778, 1.0, int_stack+1273771, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1178623, 1.0, int_stack+1320616, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+141156,int_stack+140148, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630032, 1.0, int_stack+653812, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1181143, 1.0, int_stack+1323136, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+1699909, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1183495, 1.0, int_stack+1325488, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1187023, 1.0, int_stack+1329016, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+119016,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+142956,int_stack+142416, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+280116, 1.0, int_stack+298216, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+143712,int_stack+142956, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+281196, 1.0, int_stack+299296, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620, 1.0, int_stack+3240, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+144720,int_stack+143712, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+282708, 1.0, int_stack+300808, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1231948, 1.0, int_stack+1373941, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1234216, 1.0, int_stack+1376209, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+146016,int_stack+144720, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+284724, 1.0, int_stack+302824, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1237456, 1.0, int_stack+1379449, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1240480, 1.0, int_stack+1382473, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1245016, 1.0, int_stack+1387009, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2443096,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+147861,int_stack+147636, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+641580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+148176,int_stack+147861, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+641805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+619300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+148596,int_stack+148176, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+642120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+624250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1250416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+149136,int_stack+148596, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+642540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+631040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1251766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1253656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+150126,int_stack+149811, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+645930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+150567,int_stack+150126, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+646245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1255906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+151155,int_stack+150567, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+646686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1256851, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1258174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+151911,int_stack+151155, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+647274, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1264951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1266715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1269361, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+153276,int_stack+152856, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+652020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+153864,int_stack+153276, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+652440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1272511, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+154648,int_stack+153864, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+653028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1273771, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1320616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+155656,int_stack+154648, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+653812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1323136, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+2143396, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1325488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1329016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2471446,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+157456,int_stack+156916, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+298216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+158212,int_stack+157456, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+299296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+3240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+159220,int_stack+158212, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+300808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1373941, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1376209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+160516,int_stack+159220, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+302824, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1379449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1382473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1387009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2491696,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+162361,int_stack+162136, 0.0, zero_stack, 1.0, int_stack+570240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665360,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+162676,int_stack+162361, 0.0, zero_stack, 1.0, int_stack+570465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665585,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+804250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643080,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+163096,int_stack+162676, 0.0, zero_stack, 1.0, int_stack+570780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665900,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+804925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648030,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+805870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392409,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+163636,int_stack+163096, 0.0, zero_stack, 1.0, int_stack+571200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666320,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+807220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654820,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 1.0, int_stack+808480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1393759,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 1.0, int_stack+810370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1395649,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+164626,int_stack+164311, 0.0, zero_stack, 1.0, int_stack+574590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669710,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+165067,int_stack+164626, 0.0, zero_stack, 1.0, int_stack+574905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+670025,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+827713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397899,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+165655,int_stack+165067, 0.0, zero_stack, 1.0, int_stack+575346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+670466,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 1.0, int_stack+828658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398844,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 1.0, int_stack+829981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1400167,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+166411,int_stack+165655, 0.0, zero_stack, 1.0, int_stack+575934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671054,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 1.0, int_stack+831871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406944,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+833635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408708,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+836281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411354,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+167776,int_stack+167356, 0.0, zero_stack, 1.0, int_stack+580680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675800,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+168364,int_stack+167776, 0.0, zero_stack, 1.0, int_stack+581100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676220,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+869905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1414504,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+169148,int_stack+168364, 0.0, zero_stack, 1.0, int_stack+581688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676808,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 1.0, int_stack+871165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415764,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 1.0, int_stack+872929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1462609,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+170156,int_stack+169148, 0.0, zero_stack, 1.0, int_stack+582472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677592,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 1.0, int_stack+875449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1465129,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+1699909, 0.0, zero_stack, 1.0, int_stack+877801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1467481,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 1.0, int_stack+881329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1471009,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+139266,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+171956,int_stack+171416, 0.0, zero_stack, 1.0, int_stack+243916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316316,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+172712,int_stack+171956, 0.0, zero_stack, 1.0, int_stack+244996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317396,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+946342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4860,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+173720,int_stack+172712, 0.0, zero_stack, 1.0, int_stack+246508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318908,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 1.0, int_stack+947962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515934,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 1.0, int_stack+950230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1518202,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+175016,int_stack+173720, 0.0, zero_stack, 1.0, int_stack+248524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320924,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 1.0, int_stack+953470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1521442,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 1.0, int_stack+956494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1524466,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+961030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1529002,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2520046,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+176861,int_stack+176636, 0.0, zero_stack, 1.0, int_stack+594020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665360, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+177176,int_stack+176861, 0.0, zero_stack, 1.0, int_stack+594245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665585, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+571740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+643080, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+177596,int_stack+177176, 0.0, zero_stack, 1.0, int_stack+594560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+665900, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+576690, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+648030, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+966430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1392409, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+178136,int_stack+177596, 0.0, zero_stack, 1.0, int_stack+594980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666320, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+583480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+654820, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 1.0, int_stack+967780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1393759, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 1.0, int_stack+969670, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1395649, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+179126,int_stack+178811, 0.0, zero_stack, 1.0, int_stack+598370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669710, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+179567,int_stack+179126, 0.0, zero_stack, 1.0, int_stack+598685, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+670025, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+971920, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1397899, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+180155,int_stack+179567, 0.0, zero_stack, 1.0, int_stack+599126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+670466, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 1.0, int_stack+972865, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1398844, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 1.0, int_stack+974188, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1400167, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+180911,int_stack+180155, 0.0, zero_stack, 1.0, int_stack+599714, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671054, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 1.0, int_stack+980965, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1406944, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+982729, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1408708, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+985375, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1411354, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+182276,int_stack+181856, 0.0, zero_stack, 1.0, int_stack+604460, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+675800, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+182864,int_stack+182276, 0.0, zero_stack, 1.0, int_stack+604880, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676220, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+988525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1414504, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+183648,int_stack+182864, 0.0, zero_stack, 1.0, int_stack+605468, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+676808, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 1.0, int_stack+989785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1415764, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 1.0, int_stack+1036630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1462609, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+184656,int_stack+183648, 0.0, zero_stack, 1.0, int_stack+606252, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677592, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 1.0, int_stack+1039150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1465129, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+2143396, 0.0, zero_stack, 1.0, int_stack+1041502, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1467481, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 1.0, int_stack+1045030, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1471009, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+159516,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+186456,int_stack+185916, 0.0, zero_stack, 1.0, int_stack+262016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+316316, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+187212,int_stack+186456, 0.0, zero_stack, 1.0, int_stack+263096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+317396, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4860, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+188220,int_stack+187212, 0.0, zero_stack, 1.0, int_stack+264608, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+318908, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 1.0, int_stack+1089955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1515934, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 1.0, int_stack+1092223, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1518202, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+189516,int_stack+188220, 0.0, zero_stack, 1.0, int_stack+266624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+320924, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 1.0, int_stack+1095463, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1521442, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 1.0, int_stack+1098487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1524466, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1103023, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1529002, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2548396,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+191361,int_stack+191136, 0.0, zero_stack, 1.0, int_stack+617800, 0.0, zero_stack, 1.0, int_stack+665360, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+191676,int_stack+191361, 0.0, zero_stack, 1.0, int_stack+618025, 0.0, zero_stack, 1.0, int_stack+665585, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+595520, 0.0, zero_stack, 1.0, int_stack+643080, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+192096,int_stack+191676, 0.0, zero_stack, 1.0, int_stack+618340, 0.0, zero_stack, 1.0, int_stack+665900, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+600470, 0.0, zero_stack, 1.0, int_stack+648030, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1108423, 0.0, zero_stack, 1.0, int_stack+1392409, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+192636,int_stack+192096, 0.0, zero_stack, 1.0, int_stack+618760, 0.0, zero_stack, 1.0, int_stack+666320, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+607260, 0.0, zero_stack, 1.0, int_stack+654820, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 1.0, int_stack+1109773, 0.0, zero_stack, 1.0, int_stack+1393759, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 1.0, int_stack+1111663, 0.0, zero_stack, 1.0, int_stack+1395649, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+193626,int_stack+193311, 0.0, zero_stack, 1.0, int_stack+622150, 0.0, zero_stack, 1.0, int_stack+669710, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+194067,int_stack+193626, 0.0, zero_stack, 1.0, int_stack+622465, 0.0, zero_stack, 1.0, int_stack+670025, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+1113913, 0.0, zero_stack, 1.0, int_stack+1397899, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+194655,int_stack+194067, 0.0, zero_stack, 1.0, int_stack+622906, 0.0, zero_stack, 1.0, int_stack+670466, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 1.0, int_stack+1114858, 0.0, zero_stack, 1.0, int_stack+1398844, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 1.0, int_stack+1116181, 0.0, zero_stack, 1.0, int_stack+1400167, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+195411,int_stack+194655, 0.0, zero_stack, 1.0, int_stack+623494, 0.0, zero_stack, 1.0, int_stack+671054, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 1.0, int_stack+1122958, 0.0, zero_stack, 1.0, int_stack+1406944, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1124722, 0.0, zero_stack, 1.0, int_stack+1408708, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1127368, 0.0, zero_stack, 1.0, int_stack+1411354, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+196776,int_stack+196356, 0.0, zero_stack, 1.0, int_stack+628240, 0.0, zero_stack, 1.0, int_stack+675800, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+197364,int_stack+196776, 0.0, zero_stack, 1.0, int_stack+628660, 0.0, zero_stack, 1.0, int_stack+676220, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+1130518, 0.0, zero_stack, 1.0, int_stack+1414504, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+198148,int_stack+197364, 0.0, zero_stack, 1.0, int_stack+629248, 0.0, zero_stack, 1.0, int_stack+676808, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 1.0, int_stack+1131778, 0.0, zero_stack, 1.0, int_stack+1415764, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 1.0, int_stack+1178623, 0.0, zero_stack, 1.0, int_stack+1462609, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+199156,int_stack+198148, 0.0, zero_stack, 1.0, int_stack+630032, 0.0, zero_stack, 1.0, int_stack+677592, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 1.0, int_stack+1181143, 0.0, zero_stack, 1.0, int_stack+1465129, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+1699909, 0.0, zero_stack, 1.0, int_stack+1183495, 0.0, zero_stack, 1.0, int_stack+1467481, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 1.0, int_stack+1187023, 0.0, zero_stack, 1.0, int_stack+1471009, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+179766,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+200956,int_stack+200416, 0.0, zero_stack, 1.0, int_stack+280116, 0.0, zero_stack, 1.0, int_stack+316316, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+201712,int_stack+200956, 0.0, zero_stack, 1.0, int_stack+281196, 0.0, zero_stack, 1.0, int_stack+317396, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1620, 0.0, zero_stack, 1.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+202720,int_stack+201712, 0.0, zero_stack, 1.0, int_stack+282708, 0.0, zero_stack, 1.0, int_stack+318908, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 1.0, int_stack+1231948, 0.0, zero_stack, 1.0, int_stack+1515934, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 1.0, int_stack+1234216, 0.0, zero_stack, 1.0, int_stack+1518202, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+204016,int_stack+202720, 0.0, zero_stack, 1.0, int_stack+284724, 0.0, zero_stack, 1.0, int_stack+320924, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 1.0, int_stack+1237456, 0.0, zero_stack, 1.0, int_stack+1521442, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 1.0, int_stack+1240480, 0.0, zero_stack, 1.0, int_stack+1524466, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1245016, 0.0, zero_stack, 1.0, int_stack+1529002, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2576746,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+205861,int_stack+205636, 0.0, zero_stack, 1.0, int_stack+641580, 1.0, int_stack+665360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+206176,int_stack+205861, 0.0, zero_stack, 1.0, int_stack+641805, 1.0, int_stack+665585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+619300, 1.0, int_stack+643080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+206596,int_stack+206176, 0.0, zero_stack, 1.0, int_stack+642120, 1.0, int_stack+665900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+624250, 1.0, int_stack+648030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1250416, 1.0, int_stack+1392409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+207136,int_stack+206596, 0.0, zero_stack, 1.0, int_stack+642540, 1.0, int_stack+666320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+631040, 1.0, int_stack+654820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 1.0, int_stack+1251766, 1.0, int_stack+1393759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 1.0, int_stack+1253656, 1.0, int_stack+1395649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+208126,int_stack+207811, 0.0, zero_stack, 1.0, int_stack+645930, 1.0, int_stack+669710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+208567,int_stack+208126, 0.0, zero_stack, 1.0, int_stack+646245, 1.0, int_stack+670025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+1255906, 1.0, int_stack+1397899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+209155,int_stack+208567, 0.0, zero_stack, 1.0, int_stack+646686, 1.0, int_stack+670466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 1.0, int_stack+1256851, 1.0, int_stack+1398844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 1.0, int_stack+1258174, 1.0, int_stack+1400167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+209911,int_stack+209155, 0.0, zero_stack, 1.0, int_stack+647274, 1.0, int_stack+671054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 1.0, int_stack+1264951, 1.0, int_stack+1406944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1266715, 1.0, int_stack+1408708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1269361, 1.0, int_stack+1411354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+211276,int_stack+210856, 0.0, zero_stack, 1.0, int_stack+652020, 1.0, int_stack+675800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+211864,int_stack+211276, 0.0, zero_stack, 1.0, int_stack+652440, 1.0, int_stack+676220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+1272511, 1.0, int_stack+1414504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+212648,int_stack+211864, 0.0, zero_stack, 1.0, int_stack+653028, 1.0, int_stack+676808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 1.0, int_stack+1273771, 1.0, int_stack+1415764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 0.0, zero_stack, 1.0, int_stack+1320616, 1.0, int_stack+1462609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+213656,int_stack+212648, 0.0, zero_stack, 1.0, int_stack+653812, 1.0, int_stack+677592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 1.0, int_stack+1323136, 1.0, int_stack+1465129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+2143396, 0.0, zero_stack, 1.0, int_stack+1325488, 1.0, int_stack+1467481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 0.0, zero_stack, 1.0, int_stack+1329016, 1.0, int_stack+1471009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+2605096,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+215456,int_stack+214916, 0.0, zero_stack, 1.0, int_stack+298216, 1.0, int_stack+316316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+216212,int_stack+215456, 0.0, zero_stack, 1.0, int_stack+299296, 1.0, int_stack+317396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+3240, 1.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+217220,int_stack+216212, 0.0, zero_stack, 1.0, int_stack+300808, 1.0, int_stack+318908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 1.0, int_stack+1373941, 1.0, int_stack+1515934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 1.0, int_stack+1376209, 1.0, int_stack+1518202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+218516,int_stack+217220, 0.0, zero_stack, 1.0, int_stack+302824, 1.0, int_stack+320924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 1.0, int_stack+1379449, 1.0, int_stack+1521442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 0.0, zero_stack, 1.0, int_stack+1382473, 1.0, int_stack+1524466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1387009, 1.0, int_stack+1529002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2625346,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+220361,int_stack+220136, 0.0, zero_stack, 2.0, int_stack+665360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+220676,int_stack+220361, 0.0, zero_stack, 2.0, int_stack+665585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 2.0, int_stack+643080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+221096,int_stack+220676, 0.0, zero_stack, 2.0, int_stack+665900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 2.0, int_stack+648030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 2.0, int_stack+1392409, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+221636,int_stack+221096, 0.0, zero_stack, 2.0, int_stack+666320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 2.0, int_stack+654820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 2.0, int_stack+1393759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 2.0, int_stack+1395649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+222626,int_stack+222311, 0.0, zero_stack, 2.0, int_stack+669710, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+223067,int_stack+222626, 0.0, zero_stack, 2.0, int_stack+670025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 2.0, int_stack+1397899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+223655,int_stack+223067, 0.0, zero_stack, 2.0, int_stack+670466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 2.0, int_stack+1398844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 2.0, int_stack+1400167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+224411,int_stack+223655, 0.0, zero_stack, 2.0, int_stack+671054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 2.0, int_stack+1406944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 2.0, int_stack+1408708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 2.0, int_stack+1411354, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+225776,int_stack+225356, 0.0, zero_stack, 2.0, int_stack+675800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+226364,int_stack+225776, 0.0, zero_stack, 2.0, int_stack+676220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 0.0, zero_stack, 2.0, int_stack+1414504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+227148,int_stack+226364, 0.0, zero_stack, 2.0, int_stack+676808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 0.0, zero_stack, 2.0, int_stack+1415764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 0.0, zero_stack, 2.0, int_stack+1462609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+228156,int_stack+227148, 0.0, zero_stack, 2.0, int_stack+677592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 0.0, zero_stack, 2.0, int_stack+1465129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+1699909, 0.0, zero_stack, 2.0, int_stack+1467481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 0.0, zero_stack, 2.0, int_stack+1471009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+200016,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+229956,int_stack+229416, 0.0, zero_stack, 2.0, int_stack+316316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+230712,int_stack+229956, 0.0, zero_stack, 2.0, int_stack+317396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 0.0, zero_stack, 2.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+231720,int_stack+230712, 0.0, zero_stack, 2.0, int_stack+318908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 0.0, zero_stack, 2.0, int_stack+1515934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 0.0, zero_stack, 2.0, int_stack+1518202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+233016,int_stack+231720, 0.0, zero_stack, 2.0, int_stack+320924, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+2180224, 0.0, zero_stack, 2.0, int_stack+1521442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1700584,int_stack+2183248, 0.0, zero_stack, 2.0, int_stack+1524466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700584,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 2.0, int_stack+1529002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1700584,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2653696,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+234861,int_stack+234636, 1.0, int_stack+570240, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689140,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+235176,int_stack+234861, 1.0, int_stack+570465, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689365,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 1.0, int_stack+804250, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666860,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+235596,int_stack+235176, 1.0, int_stack+570780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689680,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 1.0, int_stack+804925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671810,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 1.0, int_stack+805870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534402,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+236136,int_stack+235596, 1.0, int_stack+571200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690100,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 1.0, int_stack+807220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678600,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 1.0, int_stack+808480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1535752,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 1.0, int_stack+810370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537642,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+237126,int_stack+236811, 1.0, int_stack+574590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693490,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+237567,int_stack+237126, 1.0, int_stack+574905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693805,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 1.0, int_stack+827713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1539892,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+238155,int_stack+237567, 1.0, int_stack+575346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694246,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 1.0, int_stack+828658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540837,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 1.0, int_stack+829981, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+238911,int_stack+238155, 1.0, int_stack+575934, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694834,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 1.0, int_stack+831871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1546417,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 1.0, int_stack+833635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548181,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 1.0, int_stack+836281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550827,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+240276,int_stack+239856, 1.0, int_stack+580680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700000,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+240864,int_stack+240276, 1.0, int_stack+581100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701008,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 1.0, int_stack+869905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558702,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+241648,int_stack+240864, 1.0, int_stack+581688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702380,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 1.0, int_stack+871165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 1.0, int_stack+872929, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599877,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+242656,int_stack+241648, 1.0, int_stack+582472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704172,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2187505, 1.0, int_stack+875449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+817759,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+72216,int_stack+2143396, 1.0, int_stack+877801, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602397,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 1.0, int_stack+881329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605925,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+220266,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+245752,int_stack+244456, 1.0, int_stack+243916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334956,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+247516,int_stack+245752, 1.0, int_stack+244996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336792,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 1.0, int_stack+946342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+249820,int_stack+247516, 1.0, int_stack+246508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339312,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 1.0, int_stack+947962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1610125,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2138671,int_stack+2183248,int_stack+2176984, 1.0, int_stack+950230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612393,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+251116,int_stack+249820, 1.0, int_stack+248524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341328,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2180224, 1.0, int_stack+953470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1615633,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2144071,int_stack+2183248, 1.0, int_stack+956494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144071,int_stack+2173096,int_stack+2138671, 1.0, int_stack+961030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1661434,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2144071,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2682046,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+252961,int_stack+252736, 1.0, int_stack+594020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689140, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+253276,int_stack+252961, 1.0, int_stack+594245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689365, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 1.0, int_stack+571740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666860, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+253696,int_stack+253276, 1.0, int_stack+594560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689680, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 1.0, int_stack+576690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671810, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 1.0, int_stack+966430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534402, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+254236,int_stack+253696, 1.0, int_stack+594980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690100, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 1.0, int_stack+583480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678600, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 1.0, int_stack+967780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1535752, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 1.0, int_stack+969670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537642, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+255226,int_stack+254911, 1.0, int_stack+598370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693490, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+255667,int_stack+255226, 1.0, int_stack+598685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693805, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 1.0, int_stack+971920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1539892, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+256255,int_stack+255667, 1.0, int_stack+599126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694246, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 1.0, int_stack+972865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540837, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 1.0, int_stack+974188, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+257011,int_stack+256255, 1.0, int_stack+599714, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694834, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 1.0, int_stack+980965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1546417, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 1.0, int_stack+982729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548181, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 1.0, int_stack+985375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550827, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+258376,int_stack+257956, 1.0, int_stack+604460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700000, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+258964,int_stack+258376, 1.0, int_stack+604880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701008, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 1.0, int_stack+988525, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558702, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+259748,int_stack+258964, 1.0, int_stack+605468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702380, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 1.0, int_stack+989785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 1.0, int_stack+1036630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599877, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+260756,int_stack+259748, 1.0, int_stack+606252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704172, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+980965,int_stack+2183221,int_stack+2187505, 1.0, int_stack+1039150, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+817759, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+980965,int_stack+1699909, 1.0, int_stack+1041502, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602397, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 1.0, int_stack+1045030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605925, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+240516,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+263852,int_stack+262556, 1.0, int_stack+262016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334956, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+265616,int_stack+263852, 1.0, int_stack+263096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336792, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+267920,int_stack+265616, 1.0, int_stack+264608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339312, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 1.0, int_stack+1089955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1610125, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 1.0, int_stack+1092223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612393, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1089955,int_stack+269216,int_stack+267920, 1.0, int_stack+266624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341328, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2173096,int_stack+1089955,int_stack+2180224, 1.0, int_stack+1095463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1615633, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1089955,int_stack+2173096,int_stack+2183248, 1.0, int_stack+1098487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2173096,int_stack+1089955,int_stack+1695184, 1.0, int_stack+1103023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1661434, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+946099,int_stack+2173096,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2710396,int_stack+946099,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+271061,int_stack+270836, 1.0, int_stack+617800, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689140, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+271376,int_stack+271061, 1.0, int_stack+618025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689365, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 1.0, int_stack+595520, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+666860, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+271796,int_stack+271376, 1.0, int_stack+618340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+689680, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 1.0, int_stack+600470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+671810, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 1.0, int_stack+1108423, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1534402, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+272336,int_stack+271796, 1.0, int_stack+618760, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690100, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2144161,int_stack+0,int_stack+785340, 1.0, int_stack+607260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+678600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2146681,int_stack+2144161,int_stack+2140021, 1.0, int_stack+1109773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1535752, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+946099,int_stack+2146681,int_stack+2141911, 1.0, int_stack+1111663, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1537642, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+273326,int_stack+273011, 1.0, int_stack+622150, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693490, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+273767,int_stack+273326, 1.0, int_stack+622465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+693805, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+0,int_stack+778550, 1.0, int_stack+1113913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1539892, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2140561,int_stack+274355,int_stack+273767, 1.0, int_stack+622906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694246, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2142325,int_stack+2140561,int_stack+0, 1.0, int_stack+1114858, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1540837, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2144971,int_stack+2142325,int_stack+2138671, 1.0, int_stack+1116181, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2148121,int_stack+275111,int_stack+274355, 1.0, int_stack+623494, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694834, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+949474,int_stack+2148121,int_stack+2140561, 1.0, int_stack+1122958, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1546417, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148121,int_stack+949474,int_stack+2142325, 1.0, int_stack+1124722, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1548181, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+949474,int_stack+2148121,int_stack+2144971, 1.0, int_stack+1127368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1550827, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+954199,int_stack+949474,int_stack+946099,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+276476,int_stack+276056, 1.0, int_stack+628240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+700000, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+946099,int_stack+277064,int_stack+276476, 1.0, int_stack+628660, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+701008, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+964324,int_stack+946099,int_stack+785340, 1.0, int_stack+1130518, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1558702, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+966844,int_stack+277848,int_stack+277064, 1.0, int_stack+629248, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702380, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+969196,int_stack+966844,int_stack+946099, 1.0, int_stack+1131778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+972724,int_stack+969196,int_stack+964324, 1.0, int_stack+1178623, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1599877, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+946099,int_stack+278856,int_stack+277848, 1.0, int_stack+630032, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+704172, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1122958,int_stack+946099,int_stack+966844, 1.0, int_stack+1181143, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+817759, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1127662,int_stack+1122958,int_stack+969196, 1.0, int_stack+1183495, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1602397, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+1127662,int_stack+972724, 1.0, int_stack+1187023, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1605925, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+949474,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1089955,int_stack+2138671,int_stack+954199,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+0,int_stack+281952,int_stack+280656, 1.0, int_stack+280116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334956, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1122958,int_stack+283716,int_stack+281952, 1.0, int_stack+281196, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336792, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1125226,int_stack+1122958,int_stack+0, 1.0, int_stack+1620, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+286020,int_stack+283716, 1.0, int_stack+282708, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+339312, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1128466,int_stack+0,int_stack+1122958, 1.0, int_stack+1231948, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1610125, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+946099,int_stack+1128466,int_stack+1125226, 1.0, int_stack+1234216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1612393, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1231948,int_stack+287316,int_stack+286020, 1.0, int_stack+284724, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341328, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+951499,int_stack+1231948,int_stack+0, 1.0, int_stack+1237456, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1615633, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1231948,int_stack+951499,int_stack+1128466, 1.0, int_stack+1240480, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+951499,int_stack+1231948,int_stack+946099, 1.0, int_stack+1245016, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+951499,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+946099,int_stack+2173096,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+289161,int_stack+288936, 1.0, int_stack+641580, 0.0, zero_stack, 1.0, int_stack+689140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+289476,int_stack+289161, 1.0, int_stack+641805, 0.0, zero_stack, 1.0, int_stack+689365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 1.0, int_stack+619300, 0.0, zero_stack, 1.0, int_stack+666860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+289896,int_stack+289476, 1.0, int_stack+642120, 0.0, zero_stack, 1.0, int_stack+689680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 1.0, int_stack+624250, 0.0, zero_stack, 1.0, int_stack+671810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 1.0, int_stack+1250416, 0.0, zero_stack, 1.0, int_stack+1534402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+290436,int_stack+289896, 1.0, int_stack+642540, 0.0, zero_stack, 1.0, int_stack+690100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 1.0, int_stack+631040, 0.0, zero_stack, 1.0, int_stack+678600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 1.0, int_stack+1251766, 0.0, zero_stack, 1.0, int_stack+1535752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 1.0, int_stack+1253656, 0.0, zero_stack, 1.0, int_stack+1537642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+291426,int_stack+291111, 1.0, int_stack+645930, 0.0, zero_stack, 1.0, int_stack+693490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+291867,int_stack+291426, 1.0, int_stack+646245, 0.0, zero_stack, 1.0, int_stack+693805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 1.0, int_stack+1255906, 0.0, zero_stack, 1.0, int_stack+1539892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+292455,int_stack+291867, 1.0, int_stack+646686, 0.0, zero_stack, 1.0, int_stack+694246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 1.0, int_stack+1256851, 0.0, zero_stack, 1.0, int_stack+1540837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 1.0, int_stack+1258174, 0.0, zero_stack, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+293211,int_stack+292455, 1.0, int_stack+647274, 0.0, zero_stack, 1.0, int_stack+694834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 1.0, int_stack+1264951, 0.0, zero_stack, 1.0, int_stack+1546417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 1.0, int_stack+1266715, 0.0, zero_stack, 1.0, int_stack+1548181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 1.0, int_stack+1269361, 0.0, zero_stack, 1.0, int_stack+1550827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+294576,int_stack+294156, 1.0, int_stack+652020, 0.0, zero_stack, 1.0, int_stack+700000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+295164,int_stack+294576, 1.0, int_stack+652440, 0.0, zero_stack, 1.0, int_stack+701008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 1.0, int_stack+1272511, 0.0, zero_stack, 1.0, int_stack+1558702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+295948,int_stack+295164, 1.0, int_stack+653028, 0.0, zero_stack, 1.0, int_stack+702380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2143396,int_stack+2187505,int_stack+2183221, 1.0, int_stack+1273771, 0.0, zero_stack, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146924,int_stack+2143396,int_stack+2184985, 1.0, int_stack+1320616, 0.0, zero_stack, 1.0, int_stack+1599877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+296956,int_stack+295948, 1.0, int_stack+653812, 0.0, zero_stack, 1.0, int_stack+704172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1264951,int_stack+2183221,int_stack+2187505, 1.0, int_stack+1323136, 0.0, zero_stack, 1.0, int_stack+817759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+1264951,int_stack+2143396, 1.0, int_stack+1325488, 0.0, zero_stack, 1.0, int_stack+1602397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+2146924, 1.0, int_stack+1329016, 0.0, zero_stack, 1.0, int_stack+1605925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1231948,int_stack+1695184,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+300052,int_stack+298756, 1.0, int_stack+298216, 0.0, zero_stack, 1.0, int_stack+334956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+301816,int_stack+300052, 1.0, int_stack+299296, 0.0, zero_stack, 1.0, int_stack+336792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+0,int_stack+2174716,int_stack+2173096, 1.0, int_stack+3240, 0.0, zero_stack, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2176984,int_stack+304120,int_stack+301816, 1.0, int_stack+300808, 0.0, zero_stack, 1.0, int_stack+339312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2180008,int_stack+2176984,int_stack+2174716, 1.0, int_stack+1373941, 0.0, zero_stack, 1.0, int_stack+1610125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2184544,int_stack+2180008,int_stack+0, 1.0, int_stack+1376209, 0.0, zero_stack, 1.0, int_stack+1612393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+305416,int_stack+304120, 1.0, int_stack+302824, 0.0, zero_stack, 1.0, int_stack+341328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2138671,int_stack+2173096,int_stack+2176984, 1.0, int_stack+1379449, 0.0, zero_stack, 1.0, int_stack+1615633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1373941,int_stack+2138671,int_stack+2180008, 1.0, int_stack+1382473, 0.0, zero_stack, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+1373941,int_stack+2184544, 1.0, int_stack+1387009, 0.0, zero_stack, 1.0, int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+260766,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+307261,int_stack+307036, 1.0, int_stack+665360, 1.0, int_stack+689140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+307576,int_stack+307261, 1.0, int_stack+665585, 1.0, int_stack+689365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 1.0, int_stack+643080, 1.0, int_stack+666860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+307996,int_stack+307576, 1.0, int_stack+665900, 1.0, int_stack+689680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 1.0, int_stack+648030, 1.0, int_stack+671810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 1.0, int_stack+1392409, 1.0, int_stack+1534402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+308536,int_stack+307996, 1.0, int_stack+666320, 1.0, int_stack+690100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 1.0, int_stack+654820, 1.0, int_stack+678600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 1.0, int_stack+1393759, 1.0, int_stack+1535752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 1.0, int_stack+1395649, 1.0, int_stack+1537642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+309526,int_stack+309211, 1.0, int_stack+669710, 1.0, int_stack+693490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+309967,int_stack+309526, 1.0, int_stack+670025, 1.0, int_stack+693805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 1.0, int_stack+1397899, 1.0, int_stack+1539892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+310555,int_stack+309967, 1.0, int_stack+670466, 1.0, int_stack+694246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 1.0, int_stack+1398844, 1.0, int_stack+1540837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 1.0, int_stack+1400167, 1.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+311311,int_stack+310555, 1.0, int_stack+671054, 1.0, int_stack+694834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 1.0, int_stack+1406944, 1.0, int_stack+1546417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 1.0, int_stack+1408708, 1.0, int_stack+1548181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 1.0, int_stack+1411354, 1.0, int_stack+1550827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+1700674,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+312676,int_stack+312256, 1.0, int_stack+675800, 1.0, int_stack+700000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2183221,int_stack+313264,int_stack+312676, 1.0, int_stack+676220, 1.0, int_stack+701008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2184985,int_stack+2183221,int_stack+785340, 1.0, int_stack+1414504, 1.0, int_stack+1558702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2187505,int_stack+314048,int_stack+313264, 1.0, int_stack+676808, 1.0, int_stack+702380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1699909,int_stack+2187505,int_stack+2183221, 1.0, int_stack+1415764, 1.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1703437,int_stack+1699909,int_stack+2184985, 1.0, int_stack+1462609, 1.0, int_stack+1599877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2183221,int_stack+315056,int_stack+314048, 1.0, int_stack+677592, 1.0, int_stack+704172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1406944,int_stack+2183221,int_stack+2187505, 1.0, int_stack+1465129, 1.0, int_stack+817759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2183221,int_stack+1406944,int_stack+1699909, 1.0, int_stack+1467481, 1.0, int_stack+1602397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2183221,int_stack+1703437, 1.0, int_stack+1471009, 1.0, int_stack+1605925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+1373941,int_stack+2138671,int_stack+2173096,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+2173096,int_stack+318152,int_stack+316856, 1.0, int_stack+316316, 1.0, int_stack+334956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2174716,int_stack+319916,int_stack+318152, 1.0, int_stack+317396, 1.0, int_stack+336792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2176984,int_stack+2174716,int_stack+2173096, 1.0, int_stack+4860, 1.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2180224,int_stack+322220,int_stack+319916, 1.0, int_stack+318908, 1.0, int_stack+339312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2183248,int_stack+2180224,int_stack+2174716, 1.0, int_stack+1515934, 1.0, int_stack+1610125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1695184,int_stack+2183248,int_stack+2176984, 1.0, int_stack+1518202, 1.0, int_stack+1612393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1515934,int_stack+323516,int_stack+322220, 1.0, int_stack+320924, 1.0, int_stack+341328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2173096,int_stack+1515934,int_stack+2180224, 1.0, int_stack+1521442, 1.0, int_stack+1615633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1515934,int_stack+2173096,int_stack+2183248, 1.0, int_stack+1524466, 1.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2173096,int_stack+1515934,int_stack+1695184, 1.0, int_stack+1529002, 1.0, int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+289116,int_stack+2173096,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2738746,int_stack+289116,int_stack+2138671,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+325361,int_stack+325136, 2.0, int_stack+689140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+325676,int_stack+325361, 2.0, int_stack+689365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 2.0, int_stack+666860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+326096,int_stack+325676, 2.0, int_stack+689680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 2.0, int_stack+671810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 2.0, int_stack+1534402, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+326636,int_stack+326096, 2.0, int_stack+690100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 2.0, int_stack+678600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 2.0, int_stack+1535752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 2.0, int_stack+1537642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+327626,int_stack+327311, 2.0, int_stack+693490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+328067,int_stack+327626, 2.0, int_stack+693805, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 2.0, int_stack+1539892, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+328655,int_stack+328067, 2.0, int_stack+694246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 2.0, int_stack+1540837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+289116,int_stack+2138671,int_stack+2148859, 2.0, int_stack+795880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+795880,int_stack+329411,int_stack+328655, 2.0, int_stack+694834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+798148,int_stack+795880,int_stack+2150749, 2.0, int_stack+1546417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+801676,int_stack+798148,int_stack+2138671, 2.0, int_stack+1548181, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+801676,int_stack+289116, 2.0, int_stack+1550827, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+330776,int_stack+330356, 2.0, int_stack+700000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+299241,int_stack+331364,int_stack+330776, 2.0, int_stack+701008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+301005,int_stack+299241,int_stack+785340, 2.0, int_stack+1558702, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1558702,int_stack+332148,int_stack+331364, 2.0, int_stack+702380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+303525,int_stack+1558702,int_stack+299241, 2.0, int_stack+815995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+307053,int_stack+303525,int_stack+301005, 2.0, int_stack+1599877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+299241,int_stack+333156,int_stack+332148, 2.0, int_stack+704172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+311253,int_stack+299241,int_stack+1558702, 2.0, int_stack+817759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+315957,int_stack+311253,int_stack+303525, 2.0, int_stack+1602397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+315957,int_stack+307053, 2.0, int_stack+1605925, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671,225);
 /*--- compute (gd|gg) ---*/
   hrr1_build_gd(Libderiv->AB,int_stack+299241,int_stack+1695184,int_stack+289116,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+337548,int_stack+335496, 2.0, int_stack+334956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+340320,int_stack+337548, 2.0, int_stack+336792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 2.0, int_stack+6480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+342624,int_stack+340320, 2.0, int_stack+339312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2141695,int_stack+2138671,int_stack+290736, 2.0, int_stack+1610125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2146231,int_stack+2141695,int_stack+293004, 2.0, int_stack+1612393, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+343920,int_stack+342624, 2.0, int_stack+341328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671, 2.0, int_stack+1615633, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+2141695, 2.0, int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1546417,int_stack+2146231, 2.0, int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+0,int_stack+72216,225);
 /*--- compute (hd|gg) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2767096,int_stack+2173096,int_stack+1695184,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+345765,int_stack+345540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719320,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+346080,int_stack+345765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719545,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690640,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+346500,int_stack+346080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719860,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695590,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820111,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+347040,int_stack+346500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720280,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14256,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821461,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823351,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+348030,int_stack+347715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723670,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+348471,int_stack+348030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723985,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858817,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+349059,int_stack+348471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724426,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859762,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+349815,int_stack+349059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725014,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825601,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865342,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1729609,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+812620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+351180,int_stack+350760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729760,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+351768,int_stack+351180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730180,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+352552,int_stack+351768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730768,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732759,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1734523,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+353560,int_stack+352552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731552,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1737043,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1755547,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1759075,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+839431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+319491,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+844156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+355360,int_stack+354820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427320,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+356116,int_stack+355360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428400,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763275,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+357124,int_stack+356116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429912,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+854281,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764895,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+854281,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1767163,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+358420,int_stack+357124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431928,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1770403,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814584,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819120,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+0,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+885529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2795446,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+891829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+360265,int_stack+360040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719320, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+360580,int_stack+360265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719545, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690640, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+361000,int_stack+360580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719860, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695590, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820111, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+361540,int_stack+361000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720280, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14256, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821461, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823351, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+362530,int_stack+362215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723670, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+362971,int_stack+362530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723985, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858817, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+363559,int_stack+362971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724426, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859762, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+364315,int_stack+363559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725014, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825601, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865342, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1729609, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+365680,int_stack+365260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729760, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+366268,int_stack+365680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730180, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+367052,int_stack+366268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730768, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732759, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1734523, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+368060,int_stack+367052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731552, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1737043, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1755547, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1759075, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1021780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+339741,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1026505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+369860,int_stack+369320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427320, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+370616,int_stack+369860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428400, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763275, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+371624,int_stack+370616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429912, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+854281,int_stack+2138671,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764895, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+854281,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1767163, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+372920,int_stack+371624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431928, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1770403, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814584, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819120, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+0,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1049230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2823796,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1055530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+374765,int_stack+374540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719320, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+375080,int_stack+374765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719545, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+375500,int_stack+375080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719860, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695590, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820111, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+376040,int_stack+375500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720280, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14256, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821461, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823351, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+377030,int_stack+376715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723670, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+377471,int_stack+377030, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723985, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858817, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+378059,int_stack+377471, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724426, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859762, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+378815,int_stack+378059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725014, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825601, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865342, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1729609, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1119583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+380180,int_stack+379760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729760, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+380768,int_stack+380180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730180, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+381552,int_stack+380768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730768, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732759, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1734523, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+382560,int_stack+381552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731552, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1737043, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1755547, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1759075, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1163773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+359991,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1168498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+384360,int_stack+383820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427320, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+385116,int_stack+384360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428400, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763275, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+386124,int_stack+385116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429912, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+854281,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764895, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+854281,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1767163, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+387420,int_stack+386124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431928, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1770403, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814584, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819120, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+0,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1191223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2852146,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1197523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+389265,int_stack+389040, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+389580,int_stack+389265, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+690640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+390000,int_stack+389580, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+695590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+820111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+390540,int_stack+390000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+823351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+391530,int_stack+391215, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+391971,int_stack+391530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+723985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+858817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+392559,int_stack+391971, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+724426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+859762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+393315,int_stack+392559, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+825601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+865342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1729609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1261576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+394680,int_stack+394260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+395268,int_stack+394680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+785340, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+396052,int_stack+395268, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+730768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1732759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1734523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+397060,int_stack+396052, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+731552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1737043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1755547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1759075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1305766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1599877,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1310491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+398860,int_stack+398320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+427320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+399616,int_stack+398860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1763275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+400624,int_stack+399616, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+854281,int_stack+2138671,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1764895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+854281,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1767163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+401920,int_stack+400624, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1770403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+854281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1814584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1819120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+0,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1333216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2880496,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1339516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+403765,int_stack+403540, 0.0, zero_stack, 1.0, int_stack+719320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+404080,int_stack+403765, 0.0, zero_stack, 1.0, int_stack+719545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+690640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+404500,int_stack+404080, 0.0, zero_stack, 1.0, int_stack+719860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+785340,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+695590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+820111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+405040,int_stack+404500, 0.0, zero_stack, 1.0, int_stack+720280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 1.0, int_stack+821461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 1.0, int_stack+823351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+406030,int_stack+405715, 0.0, zero_stack, 1.0, int_stack+723670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+406471,int_stack+406030, 0.0, zero_stack, 1.0, int_stack+723985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+858817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+407059,int_stack+406471, 0.0, zero_stack, 1.0, int_stack+724426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 1.0, int_stack+859762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+407815,int_stack+407059, 0.0, zero_stack, 1.0, int_stack+725014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 1.0, int_stack+825601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+865342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1729609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1403569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+785340,int_stack+409180,int_stack+408760, 0.0, zero_stack, 1.0, int_stack+729760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+409768,int_stack+409180, 0.0, zero_stack, 1.0, int_stack+730180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+785340, 0.0, zero_stack, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+410552,int_stack+409768, 0.0, zero_stack, 1.0, int_stack+730768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1732759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 1.0, int_stack+1734523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+411560,int_stack+410552, 0.0, zero_stack, 1.0, int_stack+731552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 1.0, int_stack+1737043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 1.0, int_stack+1755547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 1.0, int_stack+1759075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1447759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+380241,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1452484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+413360,int_stack+412820, 0.0, zero_stack, 1.0, int_stack+427320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+414116,int_stack+413360, 0.0, zero_stack, 1.0, int_stack+428400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1763275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+415124,int_stack+414116, 0.0, zero_stack, 1.0, int_stack+429912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+854281,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 1.0, int_stack+1764895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+854281,int_stack+293004, 0.0, zero_stack, 1.0, int_stack+1767163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+416420,int_stack+415124, 0.0, zero_stack, 1.0, int_stack+431928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1770403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+854281, 0.0, zero_stack, 1.0, int_stack+1814584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+0,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 1.0, int_stack+1819120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+0,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1475209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2908846,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1481509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+418265,int_stack+418040, 1.0, int_stack+719320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+418580,int_stack+418265, 1.0, int_stack+719545, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 1.0, int_stack+690640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+785340,int_stack+419000,int_stack+418580, 1.0, int_stack+719860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+785340,int_stack+778550, 1.0, int_stack+695590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 1.0, int_stack+820111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+419540,int_stack+419000, 1.0, int_stack+720280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+785340, 1.0, int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 1.0, int_stack+821461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 1.0, int_stack+823351, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+420530,int_stack+420215, 1.0, int_stack+723670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+420971,int_stack+420530, 1.0, int_stack+723985, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 1.0, int_stack+858817, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+421559,int_stack+420971, 1.0, int_stack+724426, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 1.0, int_stack+859762, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 1.0, int_stack+8100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+422315,int_stack+421559, 1.0, int_stack+725014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 1.0, int_stack+825601, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 1.0, int_stack+865342, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+865342,int_stack+2147536,int_stack+2173096, 1.0, int_stack+1729609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+865342,int_stack+2144161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1543042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+423680,int_stack+423260, 1.0, int_stack+729760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1729609,int_stack+424268,int_stack+423680, 1.0, int_stack+730180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2173096,int_stack+1729609,int_stack+14256, 1.0, int_stack+705180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2175616,int_stack+425052,int_stack+424268, 1.0, int_stack+730768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2177968,int_stack+2175616,int_stack+1729609, 1.0, int_stack+1732759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1729609,int_stack+2177968,int_stack+2173096, 1.0, int_stack+1734523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1733809,int_stack+426060,int_stack+425052, 1.0, int_stack+731552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2181496,int_stack+1733809,int_stack+2175616, 1.0, int_stack+1737043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1733809,int_stack+2181496,int_stack+2177968, 1.0, int_stack+1755547, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+1733809,int_stack+1729609, 1.0, int_stack+1759075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+865342, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1553977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+400491,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1589752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+429156,int_stack+427860, 1.0, int_stack+427320, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+430920,int_stack+429156, 1.0, int_stack+428400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 1.0, int_stack+1763275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+865342,int_stack+433224,int_stack+430920, 1.0, int_stack+429912, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+868366,int_stack+865342,int_stack+290736, 1.0, int_stack+1764895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+868366,int_stack+293004, 1.0, int_stack+1767163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+434520,int_stack+433224, 1.0, int_stack+431928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+865342, 1.0, int_stack+1770403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+868366, 1.0, int_stack+1814584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+865342,int_stack+1546417,int_stack+1661434, 1.0, int_stack+1819120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+865342,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1620709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2937196,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1627009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+436365,int_stack+436140,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+436680,int_stack+436365,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+437100,int_stack+436680,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+437640,int_stack+437100,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+438630,int_stack+438315,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+439071,int_stack+438630,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+439659,int_stack+439071,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+440415,int_stack+439659,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+861967, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+441780,int_stack+441360,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+442368,int_stack+441780,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+443152,int_stack+442368,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+444160,int_stack+443152,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1740697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+420741,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1745422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+445960,int_stack+445420,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+446716,int_stack+445960,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+447724,int_stack+446716,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2141695,int_stack+2138671,int_stack+290736,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+2141695,int_stack+293004,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+449020,int_stack+447724,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+2141695,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+1546417,int_stack+1661434,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+72216, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1773859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2965546,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1780159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+450865,int_stack+450640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743100,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+451180,int_stack+450865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743325,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720820,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+451600,int_stack+451180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743640,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725770,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1824520,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+452140,int_stack+451600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744060,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732560,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1825870,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827760,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+453130,int_stack+452815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747450,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+453571,int_stack+453130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747765,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833385,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+454159,int_stack+453571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748206,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1834330,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835653,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+454915,int_stack+454159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748794,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837543,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839307,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 1.0, int_stack+812620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+456280,int_stack+455860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753540,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+456868,int_stack+456280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753960,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1847182,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+457652,int_stack+456868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754548,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1848442,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+458660,int_stack+457652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755332,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889995,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1892347,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1895875,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+839431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+815995,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+844156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+460460,int_stack+459920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+532420,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+461216,int_stack+460460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533500,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+944479,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+462224,int_stack+461216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535012,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1698208,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1940800,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1698208,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943068,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+463520,int_stack+462224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537028,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946308,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1698208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949332,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1953868,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+885529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2993896,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+891829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+465365,int_stack+465140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743100, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+465680,int_stack+465365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743325, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720820, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+466100,int_stack+465680, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743640, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725770, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1824520, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+466640,int_stack+466100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744060, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732560, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1825870, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827760, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+467630,int_stack+467315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747450, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+468071,int_stack+467630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747765, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833385, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+468659,int_stack+468071, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748206, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1834330, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835653, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+469415,int_stack+468659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748794, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837543, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839307, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 1.0, int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+470780,int_stack+470360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753540, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+471368,int_stack+470780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753960, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1847182, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+472152,int_stack+471368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754548, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1848442, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+473160,int_stack+472152, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755332, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889995, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1892347, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1895875, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1021780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+440991,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1026505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+474960,int_stack+474420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+532420, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+475716,int_stack+474960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533500, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+944479, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+476724,int_stack+475716, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535012, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2141695,int_stack+2138671,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1940800, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+2141695,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943068, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+478020,int_stack+476724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537028, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946308, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+2141695, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949332, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1953868, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+1049230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3022246,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1055530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+479865,int_stack+479640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743100, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+480180,int_stack+479865, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743325, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720820, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+480600,int_stack+480180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743640, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725770, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1824520, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+481140,int_stack+480600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744060, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732560, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1825870, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827760, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+482130,int_stack+481815, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747450, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+482571,int_stack+482130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747765, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833385, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+483159,int_stack+482571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748206, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1834330, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835653, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+483915,int_stack+483159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748794, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837543, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839307, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 1.0, int_stack+1119583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+485280,int_stack+484860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753540, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+485868,int_stack+485280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753960, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1847182, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+486652,int_stack+485868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754548, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1848442, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+487660,int_stack+486652, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755332, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889995, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1892347, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1895875, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1163773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+461241,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1168498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+489460,int_stack+488920, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+532420, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+490216,int_stack+489460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533500, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+944479, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+491224,int_stack+490216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535012, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1698208,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1940800, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1698208,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943068, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+492520,int_stack+491224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537028, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946308, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1698208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949332, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1953868, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+1191223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3050596,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1197523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+494365,int_stack+494140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+494680,int_stack+494365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+720820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+495100,int_stack+494680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+743640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+725770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1824520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+495640,int_stack+495100, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+732560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1825870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1827760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+496630,int_stack+496315, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+497071,int_stack+496630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1833385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+497659,int_stack+497071, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1834330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1835653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+498415,int_stack+497659, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+748794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1837543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1839307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 1.0, int_stack+1261576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+499780,int_stack+499360, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+500368,int_stack+499780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+753960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1847182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+501152,int_stack+500368, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1848442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+502160,int_stack+501152, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+755332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1889995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1892347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1895875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1305766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+481491,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1310491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+503960,int_stack+503420, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+532420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+504716,int_stack+503960, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+944479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+505724,int_stack+504716, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2141695,int_stack+2138671,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1940800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+2141695,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1943068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+507020,int_stack+505724, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+537028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1946308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+2141695, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1949332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1953868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+1333216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3078946,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1339516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+508865,int_stack+508640, 0.0, zero_stack, 1.0, int_stack+743100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+509180,int_stack+508865, 0.0, zero_stack, 1.0, int_stack+743325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+720820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+509600,int_stack+509180, 0.0, zero_stack, 1.0, int_stack+743640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+725770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1824520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+510140,int_stack+509600, 0.0, zero_stack, 1.0, int_stack+744060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256, 0.0, zero_stack, 1.0, int_stack+732560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 1.0, int_stack+1825870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 1.0, int_stack+1827760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+511130,int_stack+510815, 0.0, zero_stack, 1.0, int_stack+747450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+511571,int_stack+511130, 0.0, zero_stack, 1.0, int_stack+747765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+1833385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+512159,int_stack+511571, 0.0, zero_stack, 1.0, int_stack+748206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 1.0, int_stack+1834330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 1.0, int_stack+1835653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+512915,int_stack+512159, 0.0, zero_stack, 1.0, int_stack+748794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 1.0, int_stack+1837543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1839307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 1.0, int_stack+1403569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+514280,int_stack+513860, 0.0, zero_stack, 1.0, int_stack+753540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+514868,int_stack+514280, 0.0, zero_stack, 1.0, int_stack+753960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 1.0, int_stack+1847182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+515652,int_stack+514868, 0.0, zero_stack, 1.0, int_stack+754548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1848442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+516660,int_stack+515652, 0.0, zero_stack, 1.0, int_stack+755332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 1.0, int_stack+1889995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 1.0, int_stack+1892347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 1.0, int_stack+1895875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1447759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1515934,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1452484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+518460,int_stack+517920, 0.0, zero_stack, 1.0, int_stack+532420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+519216,int_stack+518460, 0.0, zero_stack, 1.0, int_stack+533500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+944479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+520224,int_stack+519216, 0.0, zero_stack, 1.0, int_stack+535012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1698208,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 1.0, int_stack+1940800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1698208,int_stack+293004, 0.0, zero_stack, 1.0, int_stack+1943068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+521520,int_stack+520224, 0.0, zero_stack, 1.0, int_stack+537028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1946308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1698208, 0.0, zero_stack, 1.0, int_stack+1949332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 1.0, int_stack+1953868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+1475209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3107296,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1481509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+523365,int_stack+523140, 1.0, int_stack+743100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+523680,int_stack+523365, 1.0, int_stack+743325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 1.0, int_stack+720820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+524100,int_stack+523680, 1.0, int_stack+743640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550, 1.0, int_stack+725770, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 1.0, int_stack+1824520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+524640,int_stack+524100, 1.0, int_stack+744060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256, 1.0, int_stack+732560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 1.0, int_stack+1825870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 1.0, int_stack+1827760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+525630,int_stack+525315, 1.0, int_stack+747450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+526071,int_stack+525630, 1.0, int_stack+747765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 1.0, int_stack+1833385, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+526659,int_stack+526071, 1.0, int_stack+748206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 1.0, int_stack+1834330, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 1.0, int_stack+1835653, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+527415,int_stack+526659, 1.0, int_stack+748794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1833385,int_stack+2147536,int_stack+2150749, 1.0, int_stack+1837543, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+1833385,int_stack+2138671, 1.0, int_stack+9990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 1.0, int_stack+1839307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 1.0, int_stack+1543042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+528780,int_stack+528360, 1.0, int_stack+753540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+529368,int_stack+528780, 1.0, int_stack+753960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 1.0, int_stack+1847182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+530152,int_stack+529368, 1.0, int_stack+754548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 1.0, int_stack+1848442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1847182,int_stack+2179732,int_stack+2174860, 1.0, int_stack+773405, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+773405,int_stack+531160,int_stack+530152, 1.0, int_stack+755332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2183260,int_stack+773405,int_stack+2177380, 1.0, int_stack+1889995, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2183260,int_stack+2179732, 1.0, int_stack+1892347, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+1847182, 1.0, int_stack+1895875, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1553977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+501741,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1589752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+534256,int_stack+532960, 1.0, int_stack+532420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+536020,int_stack+534256, 1.0, int_stack+533500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 1.0, int_stack+944479, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+538324,int_stack+536020, 1.0, int_stack+535012, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2141695,int_stack+2138671,int_stack+290736, 1.0, int_stack+1940800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+2141695,int_stack+293004, 1.0, int_stack+1943068, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1940800,int_stack+539620,int_stack+538324, 1.0, int_stack+537028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+289116,int_stack+1940800,int_stack+2138671, 1.0, int_stack+1946308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+289116,int_stack+2141695, 1.0, int_stack+1949332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+289116,int_stack+1546417,int_stack+1661434, 1.0, int_stack+1953868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+289116,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+1620709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3135646,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1627009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+541465,int_stack+541240,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+541780,int_stack+541465,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+542200,int_stack+541780,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+542740,int_stack+542200,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+543730,int_stack+543415,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+544171,int_stack+543730,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+544759,int_stack+544171,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+545515,int_stack+544759,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 0.0, zero_stack, 1.0, int_stack+861967, 1.0, int_stack+1830010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+546880,int_stack+546460,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+547468,int_stack+546880,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+548252,int_stack+547468,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+549260,int_stack+548252,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1740697, 1.0, int_stack+1842457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+521991,int_stack+2138671,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+1745422, 1.0, int_stack+1879870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+551060,int_stack+550520,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+551816,int_stack+551060,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+552824,int_stack+551816,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1698208,int_stack+1695184,int_stack+290736,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1698208,int_stack+293004,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+554120,int_stack+552824,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1698208,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1546417,int_stack+1661434,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+72216, 0.0, zero_stack, 1.0, int_stack+1773859, 1.0, int_stack+1900075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3163996,int_stack+2173096,int_stack+2138671, 0.0, zero_stack, 1.0, int_stack+1780159, 1.0, int_stack+1906375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+555965,int_stack+555740,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+556280,int_stack+555965,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+556700,int_stack+556280,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+557240,int_stack+556700,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+558230,int_stack+557915,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+558671,int_stack+558230,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+559259,int_stack+558671,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+560015,int_stack+559259,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 0.0, zero_stack, 2.0, int_stack+1830010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+561380,int_stack+560960,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+561968,int_stack+561380,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+562752,int_stack+561968,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+563760,int_stack+562752,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 0.0, zero_stack, 2.0, int_stack+1842457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+542241,int_stack+1695184,int_stack+289116, 0.0, zero_stack, 2.0, int_stack+1879870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+565560,int_stack+565020,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+566316,int_stack+565560,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2138671,int_stack+567324,int_stack+566316,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2141695,int_stack+2138671,int_stack+290736,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+2141695,int_stack+293004,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+568620,int_stack+567324,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2138671,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+2141695,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+1546417,int_stack+1661434,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+2138671,int_stack+72216, 0.0, zero_stack, 2.0, int_stack+1900075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3192346,int_stack+2173096,int_stack+1695184, 0.0, zero_stack, 2.0, int_stack+1906375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+572640,int_stack+572415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769055,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+572955,int_stack+572640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769280,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744600,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+573375,int_stack+572955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769595,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749550,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1959268,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+573915,int_stack+573375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770015,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756340,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960618,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1962508,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+577950,int_stack+577635, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776450,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+578391,int_stack+577950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776765,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1964758,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+578979,int_stack+578391, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777206,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1965703,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1967026,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+579735,int_stack+578979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777794,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1973803,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1975567,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978213,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 1.0, int_stack+812620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+585160,int_stack+584740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782540,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+585748,int_stack+585160, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782960,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+586532,int_stack+585748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783548,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927514,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1981363,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+587540,int_stack+586532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784332,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1983883,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029468,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2032996,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 1.0, int_stack+839431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+562491,int_stack+2138671,int_stack+289116, 1.0, int_stack+844156, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+589340,int_stack+588800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710500,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+590096,int_stack+589340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711580,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1695184,int_stack+591104,int_stack+590096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713092,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1698208,int_stack+1695184,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+929278,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1698208,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+931546,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+592400,int_stack+591104, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+715108,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934786,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1698208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937810,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077921,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1695184,int_stack+72216, 1.0, int_stack+885529, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+3220696,int_stack+2173096,int_stack+2138671, 1.0, int_stack+891829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+596420,int_stack+596195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769055, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+596735,int_stack+596420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769280, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744600, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+597155,int_stack+596735, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769595, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749550, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1959268, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+597695,int_stack+597155, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770015, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756340, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960618, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1962508, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+601730,int_stack+601415, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776450, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+602171,int_stack+601730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776765, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1964758, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+602759,int_stack+602171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777206, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1965703, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1967026, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+603515,int_stack+602759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777794, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1973803, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1975567, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978213, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 1.0, int_stack+977590, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+608940,int_stack+608520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782540, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+609528,int_stack+608940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782960, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+610312,int_stack+609528, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783548, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927514, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1981363, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+611320,int_stack+610312, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784332, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1983883, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029468, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2032996, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 1.0, int_stack+1021780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+865342,int_stack+1695184,int_stack+289116, 1.0, int_stack+1026505, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+613120,int_stack+612580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710500, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+613876,int_stack+613120, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711580, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1021780,int_stack+614884,int_stack+613876, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713092, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1024804,int_stack+1021780,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+929278, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1024804,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+931546, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+616180,int_stack+614884, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+715108, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1021780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934786, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1024804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937810, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1021780,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077921, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1021780,int_stack+72216, 1.0, int_stack+1049230, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1021780,int_stack+2173096,int_stack+1695184, 1.0, int_stack+1055530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+620200,int_stack+619975, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769055, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+620515,int_stack+620200, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769280, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744600, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+620935,int_stack+620515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769595, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749550, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1959268, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+621475,int_stack+620935, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770015, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756340, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960618, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1962508, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+625510,int_stack+625195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776450, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+625951,int_stack+625510, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776765, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1964758, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+626539,int_stack+625951, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777206, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1965703, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1967026, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+627295,int_stack+626539, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777794, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1973803, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1975567, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978213, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 1.0, int_stack+1119583, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+632720,int_stack+632300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782540, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+633308,int_stack+632720, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782960, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+634092,int_stack+633308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783548, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927514, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1981363, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+635100,int_stack+634092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784332, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1983883, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029468, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2032996, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 1.0, int_stack+1163773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+885592,int_stack+2138671,int_stack+289116, 1.0, int_stack+1168498, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+636900,int_stack+636360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710500, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+637656,int_stack+636900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711580, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1163773,int_stack+638664,int_stack+637656, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713092, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1166797,int_stack+1163773,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+929278, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1166797,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+931546, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+639960,int_stack+638664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+715108, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1163773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934786, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1166797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937810, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1163773,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077921, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1163773,int_stack+72216, 1.0, int_stack+1191223, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1163773,int_stack+2173096,int_stack+2138671, 1.0, int_stack+1197523, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+643980,int_stack+643755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+644295,int_stack+643980, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+744600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+644715,int_stack+644295, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+769595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+749550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1959268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+645255,int_stack+644715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+756340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1960618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1962508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+649290,int_stack+648975, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+649731,int_stack+649290, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+776765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1964758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+650319,int_stack+649731, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1965703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1967026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+651075,int_stack+650319, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1973803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1975567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1978213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 1.0, int_stack+1261576, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+656500,int_stack+656080, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+657088,int_stack+656500, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+782960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+657872,int_stack+657088, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+927514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1981363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+658880,int_stack+657872, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+784332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1983883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2029468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2032996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 1.0, int_stack+1305766, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+582741,int_stack+1695184,int_stack+289116, 1.0, int_stack+1310491, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+660680,int_stack+660140, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+710500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+661436,int_stack+660680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+711580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1305766,int_stack+662444,int_stack+661436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+713092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1308790,int_stack+1305766,int_stack+290736, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+929278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1308790,int_stack+293004, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+931546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+663740,int_stack+662444, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+715108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1305766, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+934786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1308790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+937810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1305766,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2077921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1305766,int_stack+72216, 1.0, int_stack+1333216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1305766,int_stack+2173096,int_stack+1695184, 1.0, int_stack+1339516, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+667760,int_stack+667535, 0.0, zero_stack, 1.0, int_stack+769055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+668075,int_stack+667760, 0.0, zero_stack, 1.0, int_stack+769280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1695184,int_stack+778550,int_stack+770555, 0.0, zero_stack, 1.0, int_stack+744600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+668495,int_stack+668075, 0.0, zero_stack, 1.0, int_stack+769595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1696534,int_stack+14256,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+749550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1698424,int_stack+1696534,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1959268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1700674,int_stack+669035,int_stack+668495, 0.0, zero_stack, 1.0, int_stack+770015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1702294,int_stack+1700674,int_stack+14256, 0.0, zero_stack, 1.0, int_stack+756340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704814,int_stack+1702294,int_stack+1696534, 0.0, zero_stack, 1.0, int_stack+1960618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1700674,int_stack+1704814,int_stack+1698424, 0.0, zero_stack, 1.0, int_stack+1962508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+673070,int_stack+672755, 0.0, zero_stack, 1.0, int_stack+776450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1704049,int_stack+673511,int_stack+673070, 0.0, zero_stack, 1.0, int_stack+776765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1705372,int_stack+1704049,int_stack+778550, 0.0, zero_stack, 1.0, int_stack+1964758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1707262,int_stack+674099,int_stack+673511, 0.0, zero_stack, 1.0, int_stack+777206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1695184,int_stack+1707262,int_stack+1704049, 0.0, zero_stack, 1.0, int_stack+1965703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1695184,int_stack+1705372, 0.0, zero_stack, 1.0, int_stack+1967026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1704049,int_stack+674855,int_stack+674099, 0.0, zero_stack, 1.0, int_stack+777794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+1704049,int_stack+1707262, 0.0, zero_stack, 1.0, int_stack+1973803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1704049,int_stack+2176246,int_stack+1695184, 0.0, zero_stack, 1.0, int_stack+1975567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1695184,int_stack+1704049,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+1978213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+1695184,int_stack+1700674, 1.0, int_stack+1403569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+680280,int_stack+679860, 0.0, zero_stack, 1.0, int_stack+782540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+680868,int_stack+680280, 0.0, zero_stack, 1.0, int_stack+782960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 0.0, zero_stack, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+681652,int_stack+680868, 0.0, zero_stack, 1.0, int_stack+783548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 0.0, zero_stack, 1.0, int_stack+927514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 0.0, zero_stack, 1.0, int_stack+1981363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2173096,int_stack+682660,int_stack+681652, 0.0, zero_stack, 1.0, int_stack+784332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1699909,int_stack+2173096,int_stack+2177380, 0.0, zero_stack, 1.0, int_stack+1983883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+1699909,int_stack+2179732, 0.0, zero_stack, 1.0, int_stack+2029468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 0.0, zero_stack, 1.0, int_stack+2032996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+2138671,int_stack+72216,int_stack+1695184, 1.0, int_stack+1447759, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+602991,int_stack+2138671,int_stack+289116, 1.0, int_stack+1452484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+684460,int_stack+683920, 0.0, zero_stack, 1.0, int_stack+710500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+685216,int_stack+684460, 0.0, zero_stack, 1.0, int_stack+711580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1447759,int_stack+686224,int_stack+685216, 0.0, zero_stack, 1.0, int_stack+713092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1450783,int_stack+1447759,int_stack+290736, 0.0, zero_stack, 1.0, int_stack+929278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+1450783,int_stack+293004, 0.0, zero_stack, 1.0, int_stack+931546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+687520,int_stack+686224, 0.0, zero_stack, 1.0, int_stack+715108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+1447759, 0.0, zero_stack, 1.0, int_stack+934786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1546417,int_stack+293004,int_stack+1450783, 0.0, zero_stack, 1.0, int_stack+937810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+1447759,int_stack+1546417,int_stack+1661434, 0.0, zero_stack, 1.0, int_stack+2077921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+1447759,int_stack+72216, 1.0, int_stack+1475209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1447759,int_stack+2173096,int_stack+2138671, 1.0, int_stack+1481509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+770555,int_stack+691540,int_stack+691315, 1.0, int_stack+769055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+778550,int_stack+691855,int_stack+691540, 1.0, int_stack+769280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2138671,int_stack+778550,int_stack+770555, 1.0, int_stack+744600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+14256,int_stack+692275,int_stack+691855, 1.0, int_stack+769595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2140021,int_stack+14256,int_stack+778550, 1.0, int_stack+749550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2141911,int_stack+2140021,int_stack+2138671, 1.0, int_stack+1959268, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2144161,int_stack+692815,int_stack+692275, 1.0, int_stack+770015, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2145781,int_stack+2144161,int_stack+14256, 1.0, int_stack+756340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2148301,int_stack+2145781,int_stack+2140021, 1.0, int_stack+1960618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2144161,int_stack+2148301,int_stack+2141911, 1.0, int_stack+1962508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (h0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+778550,int_stack+696850,int_stack+696535, 1.0, int_stack+776450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2147536,int_stack+697291,int_stack+696850, 1.0, int_stack+776765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2148859,int_stack+2147536,int_stack+778550, 1.0, int_stack+1964758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2150749,int_stack+697879,int_stack+697291, 1.0, int_stack+777206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2138671,int_stack+2150749,int_stack+2147536, 1.0, int_stack+1965703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+2138671,int_stack+2148859, 1.0, int_stack+1967026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2147536,int_stack+698635,int_stack+697879, 1.0, int_stack+777794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2176246,int_stack+2147536,int_stack+2150749, 1.0, int_stack+1973803, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2147536,int_stack+2176246,int_stack+2138671, 1.0, int_stack+1975567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+2138671,int_stack+2147536,int_stack+2173096, 1.0, int_stack+1978213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2138671,int_stack+2144161, 1.0, int_stack+1543042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+14256,int_stack+706860,int_stack+706440, 1.0, int_stack+782540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2173096,int_stack+707448,int_stack+706860, 1.0, int_stack+782960, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+2174860,int_stack+2173096,int_stack+14256, 1.0, int_stack+926254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2177380,int_stack+708232,int_stack+707448, 1.0, int_stack+783548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2179732,int_stack+2177380,int_stack+2173096, 1.0, int_stack+927514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+2183260,int_stack+2179732,int_stack+2174860, 1.0, int_stack+1981363, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+926254,int_stack+709240,int_stack+708232, 1.0, int_stack+784332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2143396,int_stack+926254,int_stack+2177380, 1.0, int_stack+1983883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2173096,int_stack+2143396,int_stack+2179732, 1.0, int_stack+2029468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+2173096,int_stack+2183260, 1.0, int_stack+2032996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2138671, 1.0, int_stack+1553977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1940800,int_stack+1695184,int_stack+289116, 1.0, int_stack+1589752, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   d1hrr3_build_gp(Libderiv->CD,int_stack+1589752,int_stack+712336,int_stack+711040, 1.0, int_stack+710500, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1591372,int_stack+714100,int_stack+712336, 1.0, int_stack+711580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gd) ---*/
   d1hrr3_build_gd(Libderiv->CD,int_stack+1593640,int_stack+1591372,int_stack+1589752, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+926254,int_stack+716404,int_stack+714100, 1.0, int_stack+713092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+289116,int_stack+926254,int_stack+1591372, 1.0, int_stack+929278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gf) ---*/
   d1hrr3_build_gf(Libderiv->CD,int_stack+1661434,int_stack+289116,int_stack+1593640, 1.0, int_stack+931546, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+929278,int_stack+717700,int_stack+716404, 1.0, int_stack+715108, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1589752,int_stack+929278,int_stack+926254, 1.0, int_stack+934786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+926254,int_stack+1589752,int_stack+289116, 1.0, int_stack+937810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|gg) ---*/
   d1hrr3_build_gg(Libderiv->CD,int_stack+289116,int_stack+926254,int_stack+1661434, 1.0, int_stack+2077921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+289116,int_stack+72216, 1.0, int_stack+1620709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+623241,int_stack+2173096,int_stack+1695184, 1.0, int_stack+1627009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+721720,int_stack+721495,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1695859,int_stack+722035,int_stack+721720,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1696804,int_stack+1695859,int_stack+1695184,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1698154,int_stack+722455,int_stack+722035,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1699414,int_stack+1698154,int_stack+1695859,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1701304,int_stack+1699414,int_stack+1696804,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+722995,int_stack+722455,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1703554,int_stack+1695184,int_stack+1698154,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+1703554,int_stack+1699414,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1703554,int_stack+1695184,int_stack+1701304,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+727030,int_stack+726715,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1696129,int_stack+727471,int_stack+727030,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1697452,int_stack+1696129,int_stack+1695184,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1699342,int_stack+728059,int_stack+727471,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2173096,int_stack+1699342,int_stack+1696129,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2175742,int_stack+2173096,int_stack+1697452,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+728815,int_stack+728059,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2178892,int_stack+1695184,int_stack+1699342,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+2178892,int_stack+2173096,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2178892,int_stack+1695184,int_stack+2175742,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2178892,int_stack+1703554, 1.0, int_stack+861967, 0.0, zero_stack, 1.0, int_stack+1970428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+734240,int_stack+733820,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1696444,int_stack+734828,int_stack+734240,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1698208,int_stack+1696444,int_stack+1695184,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1700728,int_stack+735612,int_stack+734828,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1703080,int_stack+1700728,int_stack+1696444,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1703080,int_stack+1698208,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+736620,int_stack+735612,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2183617,int_stack+1695184,int_stack+1700728,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+2183617,int_stack+1703080,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+1695184,int_stack+2173096,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2178892, 1.0, int_stack+1740697, 0.0, zero_stack, 1.0, int_stack+2014618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+651591,int_stack+1695184,int_stack+289116, 1.0, int_stack+1745422, 0.0, zero_stack, 1.0, int_stack+2019343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+738420,int_stack+737880,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+739176,int_stack+738420,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2173096,int_stack+740184,int_stack+739176,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2176120,int_stack+2173096,int_stack+290736,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2077921,int_stack+2176120,int_stack+293004,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+741480,int_stack+740184,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2173096,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2180656,int_stack+293004,int_stack+2176120,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+289116,int_stack+2180656,int_stack+2077921,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+289116,int_stack+72216, 1.0, int_stack+1773859, 0.0, zero_stack, 1.0, int_stack+2037196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1729609,int_stack+2173096,int_stack+1695184, 1.0, int_stack+1780159, 0.0, zero_stack, 1.0, int_stack+2043496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+745500,int_stack+745275,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1695859,int_stack+745815,int_stack+745500,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1696804,int_stack+1695859,int_stack+1695184,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1698154,int_stack+746235,int_stack+745815,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1699414,int_stack+1698154,int_stack+1695859,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1701304,int_stack+1699414,int_stack+1696804,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+746775,int_stack+746235,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1703554,int_stack+1695184,int_stack+1698154,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+1703554,int_stack+1699414,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1703554,int_stack+1695184,int_stack+1701304,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+750810,int_stack+750495,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1696129,int_stack+751251,int_stack+750810,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1697452,int_stack+1696129,int_stack+1695184,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1699342,int_stack+751839,int_stack+751251,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2173096,int_stack+1699342,int_stack+1696129,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2175742,int_stack+2173096,int_stack+1697452,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+752595,int_stack+751839,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2178892,int_stack+1695184,int_stack+1699342,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+2178892,int_stack+2173096,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2178892,int_stack+1695184,int_stack+2175742,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2178892,int_stack+1703554, 1.0, int_stack+1830010, 1.0, int_stack+1970428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+758020,int_stack+757600,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1696444,int_stack+758608,int_stack+758020,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1698208,int_stack+1696444,int_stack+1695184,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1700728,int_stack+759392,int_stack+758608,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1703080,int_stack+1700728,int_stack+1696444,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1703080,int_stack+1698208,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+760400,int_stack+759392,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2183617,int_stack+1695184,int_stack+1700728,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+2183617,int_stack+1703080,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+1695184,int_stack+2173096,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2178892, 1.0, int_stack+1842457, 1.0, int_stack+2014618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1814584,int_stack+1695184,int_stack+289116, 1.0, int_stack+1879870, 1.0, int_stack+2019343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1879870,int_stack+762200,int_stack+761660,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1881490,int_stack+762956,int_stack+762200,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1883758,int_stack+1881490,int_stack+1879870,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1886998,int_stack+763964,int_stack+762956,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1890022,int_stack+1886998,int_stack+1881490,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2077921,int_stack+1890022,int_stack+1883758,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1879870,int_stack+765260,int_stack+763964,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+289116,int_stack+1879870,int_stack+1886998,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1879870,int_stack+289116,int_stack+1890022,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+289116,int_stack+1879870,int_stack+2077921,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+289116,int_stack+72216, 1.0, int_stack+1900075, 1.0, int_stack+2037196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1757959,int_stack+2173096,int_stack+1695184, 1.0, int_stack+1906375, 1.0, int_stack+2043496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (g0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+771455,int_stack+771230,15);
 /*--- compute (g0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1695859,int_stack+771770,int_stack+771455,15);
 /*--- compute (g0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1696804,int_stack+1695859,int_stack+1695184,15);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1698154,int_stack+772190,int_stack+771770,15);
 /*--- compute (g0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1699414,int_stack+1698154,int_stack+1695859,15);
 /*--- compute (g0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+1701304,int_stack+1699414,int_stack+1696804,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+772730,int_stack+772190,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1703554,int_stack+1695184,int_stack+1698154,15);
 /*--- compute (g0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+1703554,int_stack+1699414,15);
 /*--- compute (g0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+1703554,int_stack+1695184,int_stack+1701304,15);
 /*--- compute (h0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+779810,int_stack+779495,21);
 /*--- compute (h0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1696129,int_stack+780251,int_stack+779810,21);
 /*--- compute (h0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1697452,int_stack+1696129,int_stack+1695184,21);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1699342,int_stack+780839,int_stack+780251,21);
 /*--- compute (h0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2173096,int_stack+1699342,int_stack+1696129,21);
 /*--- compute (h0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2175742,int_stack+2173096,int_stack+1697452,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+781595,int_stack+780839,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2178892,int_stack+1695184,int_stack+1699342,21);
 /*--- compute (h0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+2178892,int_stack+2173096,21);
 /*--- compute (h0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+2178892,int_stack+1695184,int_stack+2175742,21);
 /*--- compute (gp|gg) ---*/
   d1hrr1_build_gp(Libderiv->AB,int_stack+289116,int_stack+2178892,int_stack+1703554, 2.0, int_stack+1970428, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (i0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+1695184,int_stack+787020,int_stack+786600,28);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1696444,int_stack+787608,int_stack+787020,28);
 /*--- compute (i0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+1698208,int_stack+1696444,int_stack+1695184,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1700728,int_stack+788392,int_stack+787608,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1703080,int_stack+1700728,int_stack+1696444,28);
 /*--- compute (i0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2173096,int_stack+1703080,int_stack+1698208,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1695184,int_stack+789400,int_stack+788392,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2183617,int_stack+1695184,int_stack+1700728,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+1695184,int_stack+2183617,int_stack+1703080,28);
 /*--- compute (i0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+72216,int_stack+1695184,int_stack+2173096,28);
 /*--- compute (hp|gg) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+1695184,int_stack+72216,int_stack+2178892, 2.0, int_stack+2014618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gd|gg) ---*/
   d1hrr1_build_gd(Libderiv->AB,int_stack+1879870,int_stack+1695184,int_stack+289116, 2.0, int_stack+2019343, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (k0|gp) ---*/
   hrr3_build_gp(Libderiv->CD,int_stack+289116,int_stack+791200,int_stack+790660,36);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+290736,int_stack+791956,int_stack+791200,36);
 /*--- compute (k0|gd) ---*/
   hrr3_build_gd(Libderiv->CD,int_stack+293004,int_stack+290736,int_stack+289116,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2014618,int_stack+792964,int_stack+791956,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2017642,int_stack+2014618,int_stack+290736,36);
 /*--- compute (k0|gf) ---*/
   hrr3_build_gf(Libderiv->CD,int_stack+2077921,int_stack+2017642,int_stack+293004,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+289116,int_stack+794260,int_stack+792964,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+293004,int_stack+289116,int_stack+2014618,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2022178,int_stack+293004,int_stack+2017642,36);
 /*--- compute (k0|gg) ---*/
   hrr3_build_gg(Libderiv->CD,int_stack+289116,int_stack+2022178,int_stack+2077921,36);
 /*--- compute (ip|gg) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+2173096,int_stack+289116,int_stack+72216, 2.0, int_stack+2037196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (hd|gg) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+2014618,int_stack+2173096,int_stack+1695184, 2.0, int_stack+2043496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+671841,int_stack+993430,int_stack+906004,225);
     Libderiv->ABCD[11] = int_stack + 671841;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+705591,int_stack+1135423,int_stack+1069705,225);
     Libderiv->ABCD[10] = int_stack + 705591;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+739341,int_stack+1277416,int_stack+1211698,225);
     Libderiv->ABCD[9] = int_stack + 739341;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+773091,int_stack+1419409,int_stack+1353691,225);
     Libderiv->ABCD[8] = int_stack + 773091;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+1394191,int_stack+1561402,int_stack+1495684,225);
     Libderiv->ABCD[7] = int_stack + 1394191;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+1536184,int_stack+1666834,int_stack+1641184,225);
     Libderiv->ABCD[6] = int_stack + 1536184;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1661434,int_stack+1851520,int_stack+1794334, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1709359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[2] = int_stack + 1661434;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1834834,int_stack+1986268,int_stack+1920550, 0.0, zero_stack, 1.0, int_stack+1709359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[1] = int_stack + 1834834;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1961050,int_stack+2110321,int_stack+2057671, 1.0, int_stack+1709359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[0] = int_stack + 1961050;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+1695184,int_stack+2191996,int_stack+2152846,225);
     Libderiv->ABCD[155] = int_stack + 1695184;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+974449,int_stack+15516,int_stack+2083321,225);
     Libderiv->ABCD[143] = int_stack + 974449;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2077921,int_stack+2240596,int_stack+2220346,225);
     Libderiv->ABCD[142] = int_stack + 2077921;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2111671,int_stack+43866,int_stack+2268946,225);
     Libderiv->ABCD[131] = int_stack + 2111671;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2145421,int_stack+2309446,int_stack+2289196,225);
     Libderiv->ABCD[130] = int_stack + 2145421;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2179171,int_stack+2337796,int_stack+78516,225);
     Libderiv->ABCD[129] = int_stack + 2179171;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2212921,int_stack+2386396,int_stack+2366146,225);
     Libderiv->ABCD[119] = int_stack + 2212921;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2246671,int_stack+2414746,int_stack+98766,225);
     Libderiv->ABCD[118] = int_stack + 2246671;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2280421,int_stack+2443096,int_stack+119016,225);
     Libderiv->ABCD[117] = int_stack + 2280421;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2314171,int_stack+2491696,int_stack+2471446,225);
     Libderiv->ABCD[116] = int_stack + 2314171;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2347921,int_stack+2520046,int_stack+139266,225);
     Libderiv->ABCD[107] = int_stack + 2347921;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2381671,int_stack+2548396,int_stack+159516,225);
     Libderiv->ABCD[106] = int_stack + 2381671;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2415421,int_stack+2576746,int_stack+179766,225);
     Libderiv->ABCD[105] = int_stack + 2415421;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2449171,int_stack+2625346,int_stack+2605096,225);
     Libderiv->ABCD[104] = int_stack + 2449171;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2482921,int_stack+2653696,int_stack+200016,225);
     Libderiv->ABCD[103] = int_stack + 2482921;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2516671,int_stack+2682046,int_stack+220266,225);
     Libderiv->ABCD[95] = int_stack + 2516671;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2550421,int_stack+2710396,int_stack+240516,225);
     Libderiv->ABCD[94] = int_stack + 2550421;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+2584171,int_stack+946099,int_stack+1089955,225);
     Libderiv->ABCD[93] = int_stack + 2584171;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+1089955,int_stack+260766,int_stack+1231948,225);
     Libderiv->ABCD[92] = int_stack + 1089955;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+1231948,int_stack+2738746,int_stack+1373941,225);
     Libderiv->ABCD[91] = int_stack + 1231948;
 /*--- compute (gf|gg) ---*/
   hrr1_build_gf(Libderiv->AB,int_stack+1265698,int_stack+2767096,int_stack+299241,225);
     Libderiv->ABCD[90] = int_stack + 1265698;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1123705,int_stack+2795446,int_stack+319491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+906004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[47] = int_stack + 1123705;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2617921,int_stack+2823796,int_stack+339741, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1069705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[46] = int_stack + 2617921;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2651671,int_stack+2852146,int_stack+359991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1211698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[45] = int_stack + 2651671;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2685421,int_stack+2880496,int_stack+1599877, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1353691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[44] = int_stack + 2685421;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2719171,int_stack+2908846,int_stack+380241, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1495684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[43] = int_stack + 2719171;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2752921,int_stack+2937196,int_stack+400491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1641184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[42] = int_stack + 2752921;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2786671,int_stack+2965546,int_stack+420741, 0.0, zero_stack, 0.0, zero_stack, 2.0, int_stack+1794334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[38] = int_stack + 2786671;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2820421,int_stack+2993896,int_stack+815995, 0.0, zero_stack, 1.0, int_stack+906004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[35] = int_stack + 2820421;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2854171,int_stack+3022246,int_stack+440991, 0.0, zero_stack, 1.0, int_stack+1069705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[34] = int_stack + 2854171;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2887921,int_stack+3050596,int_stack+461241, 0.0, zero_stack, 1.0, int_stack+1211698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[33] = int_stack + 2887921;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2921671,int_stack+3078946,int_stack+481491, 0.0, zero_stack, 1.0, int_stack+1353691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[32] = int_stack + 2921671;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2955421,int_stack+3107296,int_stack+1515934, 0.0, zero_stack, 1.0, int_stack+1495684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[31] = int_stack + 2955421;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+2989171,int_stack+3135646,int_stack+501741, 0.0, zero_stack, 1.0, int_stack+1641184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[30] = int_stack + 2989171;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+3022921,int_stack+3163996,int_stack+521991, 0.0, zero_stack, 1.0, int_stack+1794334, 1.0, int_stack+1920550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[26] = int_stack + 3022921;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+3056671,int_stack+3192346,int_stack+542241, 0.0, zero_stack, 2.0, int_stack+1920550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[25] = int_stack + 3056671;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+3090421,int_stack+3220696,int_stack+562491, 1.0, int_stack+906004, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[23] = int_stack + 3090421;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+3124171,int_stack+1021780,int_stack+865342, 1.0, int_stack+1069705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[22] = int_stack + 3124171;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+3157921,int_stack+1163773,int_stack+885592, 1.0, int_stack+1211698, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[21] = int_stack + 3157921;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1157455,int_stack+1305766,int_stack+582741, 1.0, int_stack+1353691, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[20] = int_stack + 1157455;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1299448,int_stack+1447759,int_stack+602991, 1.0, int_stack+1495684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[19] = int_stack + 1299448;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1333198,int_stack+623241,int_stack+1940800, 1.0, int_stack+1641184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[18] = int_stack + 1333198;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1191205,int_stack+1729609,int_stack+651591, 1.0, int_stack+1794334, 0.0, zero_stack, 1.0, int_stack+2057671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[14] = int_stack + 1191205;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+3191671,int_stack+1757959,int_stack+1814584, 1.0, int_stack+1920550, 1.0, int_stack+2057671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[13] = int_stack + 3191671;
 /*--- compute (gf|gg) ---*/
   d1hrr1_build_gf(Libderiv->AB,int_stack+1900120,int_stack+2014618,int_stack+1879870, 2.0, int_stack+2057671, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,225);
     Libderiv->ABCD[12] = int_stack + 1900120;

}
