/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ddii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (dd|ii) integrals */

void d1hrr_order_ddii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[2][6][11] = int_stack + 0;
 Libderiv->deriv_classes[2][7][11] = int_stack + 168;
 Libderiv->deriv_classes[2][8][11] = int_stack + 384;
 Libderiv->deriv_classes[2][9][11] = int_stack + 654;
 Libderiv->deriv_classes[2][10][11] = int_stack + 984;
 Libderiv->deriv_classes[2][11][11] = int_stack + 1380;
 Libderiv->deriv_classes[2][12][11] = int_stack + 1848;
 Libderiv->deriv_classes[3][6][11] = int_stack + 2394;
 Libderiv->deriv_classes[3][7][11] = int_stack + 2674;
 Libderiv->deriv_classes[3][8][11] = int_stack + 3034;
 Libderiv->deriv_classes[3][9][11] = int_stack + 3484;
 Libderiv->deriv_classes[3][10][11] = int_stack + 4034;
 Libderiv->deriv_classes[3][11][11] = int_stack + 4694;
 Libderiv->deriv_classes[3][12][11] = int_stack + 5474;
 Libderiv->deriv_classes[4][6][11] = int_stack + 6384;
 Libderiv->deriv_classes[4][7][11] = int_stack + 6804;
 Libderiv->deriv_classes[4][8][11] = int_stack + 7344;
 Libderiv->deriv_classes[4][9][11] = int_stack + 8019;
 Libderiv->deriv_classes[4][10][11] = int_stack + 8844;
 Libderiv->deriv_classes[4][11][11] = int_stack + 9834;
 Libderiv->deriv_classes[4][12][11] = int_stack + 11004;
 Libderiv->deriv_classes[2][6][10] = int_stack + 12369;
 Libderiv->deriv_classes[2][7][10] = int_stack + 12537;
 Libderiv->deriv_classes[2][8][10] = int_stack + 12753;
 Libderiv->deriv_classes[2][9][10] = int_stack + 13023;
 Libderiv->deriv_classes[2][10][10] = int_stack + 13353;
 Libderiv->deriv_classes[2][11][10] = int_stack + 13749;
 Libderiv->deriv_classes[2][12][10] = int_stack + 14217;
 Libderiv->deriv_classes[3][6][10] = int_stack + 14763;
 Libderiv->deriv_classes[3][7][10] = int_stack + 15043;
 Libderiv->deriv_classes[3][8][10] = int_stack + 15403;
 Libderiv->deriv_classes[3][9][10] = int_stack + 15853;
 Libderiv->deriv_classes[3][10][10] = int_stack + 16403;
 Libderiv->deriv_classes[3][11][10] = int_stack + 17063;
 Libderiv->deriv_classes[3][12][10] = int_stack + 17843;
 Libderiv->deriv_classes[4][6][10] = int_stack + 18753;
 Libderiv->deriv_classes[4][7][10] = int_stack + 19173;
 Libderiv->deriv_classes[4][8][10] = int_stack + 19713;
 Libderiv->deriv_classes[4][9][10] = int_stack + 20388;
 Libderiv->deriv_classes[4][10][10] = int_stack + 21213;
 Libderiv->deriv_classes[4][11][10] = int_stack + 22203;
 Libderiv->deriv_classes[4][12][10] = int_stack + 23373;
 Libderiv->deriv_classes[2][6][9] = int_stack + 24738;
 Libderiv->deriv_classes[2][7][9] = int_stack + 24906;
 Libderiv->deriv_classes[2][8][9] = int_stack + 25122;
 Libderiv->deriv_classes[2][9][9] = int_stack + 25392;
 Libderiv->deriv_classes[2][10][9] = int_stack + 25722;
 Libderiv->deriv_classes[2][11][9] = int_stack + 26118;
 Libderiv->deriv_classes[2][12][9] = int_stack + 26586;
 Libderiv->deriv_classes[3][6][9] = int_stack + 27132;
 Libderiv->deriv_classes[3][7][9] = int_stack + 27412;
 Libderiv->deriv_classes[3][8][9] = int_stack + 27772;
 Libderiv->deriv_classes[3][9][9] = int_stack + 28222;
 Libderiv->deriv_classes[3][10][9] = int_stack + 28772;
 Libderiv->deriv_classes[3][11][9] = int_stack + 29432;
 Libderiv->deriv_classes[3][12][9] = int_stack + 30212;
 Libderiv->deriv_classes[4][6][9] = int_stack + 31122;
 Libderiv->deriv_classes[4][7][9] = int_stack + 31542;
 Libderiv->deriv_classes[4][8][9] = int_stack + 32082;
 Libderiv->deriv_classes[4][9][9] = int_stack + 32757;
 Libderiv->deriv_classes[4][10][9] = int_stack + 33582;
 Libderiv->deriv_classes[4][11][9] = int_stack + 34572;
 Libderiv->deriv_classes[4][12][9] = int_stack + 35742;
 Libderiv->deriv_classes[2][6][8] = int_stack + 37107;
 Libderiv->deriv_classes[2][7][8] = int_stack + 37275;
 Libderiv->deriv_classes[2][8][8] = int_stack + 37491;
 Libderiv->deriv_classes[2][9][8] = int_stack + 37761;
 Libderiv->deriv_classes[2][10][8] = int_stack + 38091;
 Libderiv->deriv_classes[2][11][8] = int_stack + 38487;
 Libderiv->deriv_classes[2][12][8] = int_stack + 38955;
 Libderiv->deriv_classes[3][6][8] = int_stack + 39501;
 Libderiv->deriv_classes[3][7][8] = int_stack + 39781;
 Libderiv->deriv_classes[3][8][8] = int_stack + 40141;
 Libderiv->deriv_classes[3][9][8] = int_stack + 40591;
 Libderiv->deriv_classes[3][10][8] = int_stack + 41141;
 Libderiv->deriv_classes[3][11][8] = int_stack + 41801;
 Libderiv->deriv_classes[3][12][8] = int_stack + 42581;
 Libderiv->deriv_classes[4][6][8] = int_stack + 43491;
 Libderiv->deriv_classes[4][7][8] = int_stack + 43911;
 Libderiv->deriv_classes[4][8][8] = int_stack + 44451;
 Libderiv->deriv_classes[4][9][8] = int_stack + 45126;
 Libderiv->deriv_classes[4][10][8] = int_stack + 45951;
 Libderiv->deriv_classes[4][11][8] = int_stack + 46941;
 Libderiv->deriv_classes[4][12][8] = int_stack + 48111;
 Libderiv->deriv_classes[2][6][7] = int_stack + 49476;
 Libderiv->deriv_classes[2][7][7] = int_stack + 49644;
 Libderiv->deriv_classes[2][8][7] = int_stack + 49860;
 Libderiv->deriv_classes[2][9][7] = int_stack + 50130;
 Libderiv->deriv_classes[2][10][7] = int_stack + 50460;
 Libderiv->deriv_classes[2][11][7] = int_stack + 50856;
 Libderiv->deriv_classes[2][12][7] = int_stack + 51324;
 Libderiv->deriv_classes[3][6][7] = int_stack + 51870;
 Libderiv->deriv_classes[3][7][7] = int_stack + 52150;
 Libderiv->deriv_classes[3][8][7] = int_stack + 52510;
 Libderiv->deriv_classes[3][9][7] = int_stack + 52960;
 Libderiv->deriv_classes[3][10][7] = int_stack + 53510;
 Libderiv->deriv_classes[3][11][7] = int_stack + 54170;
 Libderiv->deriv_classes[3][12][7] = int_stack + 54950;
 Libderiv->deriv_classes[4][6][7] = int_stack + 55860;
 Libderiv->deriv_classes[4][7][7] = int_stack + 56280;
 Libderiv->deriv_classes[4][8][7] = int_stack + 56820;
 Libderiv->deriv_classes[4][9][7] = int_stack + 57495;
 Libderiv->deriv_classes[4][10][7] = int_stack + 58320;
 Libderiv->deriv_classes[4][11][7] = int_stack + 59310;
 Libderiv->deriv_classes[4][12][7] = int_stack + 60480;
 Libderiv->deriv_classes[2][6][6] = int_stack + 61845;
 Libderiv->deriv_classes[2][7][6] = int_stack + 62013;
 Libderiv->deriv_classes[2][8][6] = int_stack + 62229;
 Libderiv->deriv_classes[2][9][6] = int_stack + 62499;
 Libderiv->deriv_classes[2][10][6] = int_stack + 62829;
 Libderiv->deriv_classes[2][11][6] = int_stack + 63225;
 Libderiv->deriv_classes[2][12][6] = int_stack + 63693;
 Libderiv->deriv_classes[3][6][6] = int_stack + 64239;
 Libderiv->deriv_classes[3][7][6] = int_stack + 64519;
 Libderiv->deriv_classes[3][8][6] = int_stack + 64879;
 Libderiv->deriv_classes[3][9][6] = int_stack + 65329;
 Libderiv->deriv_classes[3][10][6] = int_stack + 65879;
 Libderiv->deriv_classes[3][11][6] = int_stack + 66539;
 Libderiv->deriv_classes[3][12][6] = int_stack + 67319;
 Libderiv->dvrr_classes[4][6] = int_stack + 68229;
 Libderiv->deriv_classes[4][6][6] = int_stack + 68649;
 Libderiv->dvrr_classes[4][7] = int_stack + 69069;
 Libderiv->deriv_classes[4][7][6] = int_stack + 69609;
 Libderiv->dvrr_classes[4][8] = int_stack + 70149;
 Libderiv->deriv_classes[4][8][6] = int_stack + 70824;
 Libderiv->dvrr_classes[4][9] = int_stack + 71499;
 Libderiv->deriv_classes[4][9][6] = int_stack + 72324;
 Libderiv->dvrr_classes[4][10] = int_stack + 73149;
 Libderiv->deriv_classes[4][10][6] = int_stack + 74139;
 Libderiv->dvrr_classes[4][11] = int_stack + 75129;
 Libderiv->deriv_classes[4][11][6] = int_stack + 76299;
 Libderiv->deriv_classes[4][12][6] = int_stack + 77469;
 Libderiv->deriv_classes[2][6][2] = int_stack + 78834;
 Libderiv->deriv_classes[2][7][2] = int_stack + 79002;
 Libderiv->deriv_classes[2][8][2] = int_stack + 79218;
 Libderiv->deriv_classes[2][9][2] = int_stack + 79488;
 Libderiv->deriv_classes[2][10][2] = int_stack + 79818;
 Libderiv->deriv_classes[2][11][2] = int_stack + 80214;
 Libderiv->deriv_classes[2][12][2] = int_stack + 80682;
 Libderiv->deriv_classes[3][6][2] = int_stack + 81228;
 Libderiv->deriv_classes[3][7][2] = int_stack + 81508;
 Libderiv->deriv_classes[3][8][2] = int_stack + 81868;
 Libderiv->deriv_classes[3][9][2] = int_stack + 82318;
 Libderiv->deriv_classes[3][10][2] = int_stack + 82868;
 Libderiv->deriv_classes[3][11][2] = int_stack + 83528;
 Libderiv->deriv_classes[3][12][2] = int_stack + 84308;
 Libderiv->deriv_classes[4][6][2] = int_stack + 85218;
 Libderiv->deriv_classes[4][7][2] = int_stack + 85638;
 Libderiv->deriv_classes[4][8][2] = int_stack + 86178;
 Libderiv->deriv_classes[4][9][2] = int_stack + 86853;
 Libderiv->deriv_classes[4][10][2] = int_stack + 87678;
 Libderiv->deriv_classes[4][11][2] = int_stack + 88668;
 Libderiv->deriv_classes[4][12][2] = int_stack + 89838;
 Libderiv->deriv_classes[2][6][1] = int_stack + 91203;
 Libderiv->deriv_classes[2][7][1] = int_stack + 91371;
 Libderiv->deriv_classes[2][8][1] = int_stack + 91587;
 Libderiv->deriv_classes[2][9][1] = int_stack + 91857;
 Libderiv->deriv_classes[2][10][1] = int_stack + 92187;
 Libderiv->deriv_classes[2][11][1] = int_stack + 92583;
 Libderiv->deriv_classes[2][12][1] = int_stack + 93051;
 Libderiv->deriv_classes[3][6][1] = int_stack + 93597;
 Libderiv->deriv_classes[3][7][1] = int_stack + 93877;
 Libderiv->deriv_classes[3][8][1] = int_stack + 94237;
 Libderiv->deriv_classes[3][9][1] = int_stack + 94687;
 Libderiv->deriv_classes[3][10][1] = int_stack + 95237;
 Libderiv->deriv_classes[3][11][1] = int_stack + 95897;
 Libderiv->deriv_classes[3][12][1] = int_stack + 96677;
 Libderiv->deriv_classes[4][6][1] = int_stack + 97587;
 Libderiv->deriv_classes[4][7][1] = int_stack + 98007;
 Libderiv->deriv_classes[4][8][1] = int_stack + 98547;
 Libderiv->deriv_classes[4][9][1] = int_stack + 99222;
 Libderiv->deriv_classes[4][10][1] = int_stack + 100047;
 Libderiv->deriv_classes[4][11][1] = int_stack + 101037;
 Libderiv->deriv_classes[4][12][1] = int_stack + 102207;
 Libderiv->dvrr_classes[2][6] = int_stack + 103572;
 Libderiv->dvrr_classes[2][7] = int_stack + 103740;
 Libderiv->dvrr_classes[2][8] = int_stack + 103956;
 Libderiv->dvrr_classes[2][9] = int_stack + 104226;
 Libderiv->dvrr_classes[2][10] = int_stack + 104556;
 Libderiv->dvrr_classes[2][11] = int_stack + 104952;
 Libderiv->dvrr_classes[2][12] = int_stack + 105420;
 Libderiv->deriv_classes[2][6][0] = int_stack + 105966;
 Libderiv->deriv_classes[2][7][0] = int_stack + 106134;
 Libderiv->deriv_classes[2][8][0] = int_stack + 106350;
 Libderiv->deriv_classes[2][9][0] = int_stack + 106620;
 Libderiv->deriv_classes[2][10][0] = int_stack + 106950;
 Libderiv->deriv_classes[2][11][0] = int_stack + 107346;
 Libderiv->deriv_classes[2][12][0] = int_stack + 107814;
 Libderiv->dvrr_classes[3][6] = int_stack + 108360;
 Libderiv->dvrr_classes[3][7] = int_stack + 108640;
 Libderiv->dvrr_classes[3][8] = int_stack + 109000;
 Libderiv->dvrr_classes[3][9] = int_stack + 109450;
 Libderiv->dvrr_classes[3][10] = int_stack + 110000;
 Libderiv->dvrr_classes[3][11] = int_stack + 110660;
 Libderiv->dvrr_classes[3][12] = int_stack + 111440;
 Libderiv->deriv_classes[3][6][0] = int_stack + 112350;
 Libderiv->deriv_classes[3][7][0] = int_stack + 112630;
 Libderiv->deriv_classes[3][8][0] = int_stack + 112990;
 Libderiv->deriv_classes[3][9][0] = int_stack + 113440;
 Libderiv->deriv_classes[3][10][0] = int_stack + 113990;
 Libderiv->deriv_classes[3][11][0] = int_stack + 114650;
 Libderiv->deriv_classes[3][12][0] = int_stack + 115430;
 Libderiv->deriv_classes[4][6][0] = int_stack + 116340;
 Libderiv->deriv_classes[4][7][0] = int_stack + 116760;
 Libderiv->deriv_classes[4][8][0] = int_stack + 117300;
 Libderiv->deriv_classes[4][9][0] = int_stack + 117975;
 Libderiv->deriv_classes[4][10][0] = int_stack + 118800;
 Libderiv->deriv_classes[4][11][0] = int_stack + 119790;
 Libderiv->deriv_classes[4][12][0] = int_stack + 120960;
 memset(int_stack,0,978600);

 Libderiv->dvrr_stack = int_stack + 454238;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ddii(Libderiv, Data);
   Data++;
 }

 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+122325,int_stack+103740,int_stack+103572,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+122829,int_stack+103956,int_stack+103740,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+123477,int_stack+122829,int_stack+122325,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+124485,int_stack+104226,int_stack+103956,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+125295,int_stack+124485,int_stack+122829,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+126591,int_stack+125295,int_stack+123477,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+128271,int_stack+104556,int_stack+104226,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+129261,int_stack+128271,int_stack+124485,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+130881,int_stack+129261,int_stack+125295,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+133041,int_stack+130881,int_stack+126591,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+135561,int_stack+104952,int_stack+104556,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+136749,int_stack+135561,int_stack+128271,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+138729,int_stack+136749,int_stack+129261,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+141429,int_stack+138729,int_stack+130881,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+144669,int_stack+141429,int_stack+133041,6);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+148197,int_stack+168,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103572,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+148701,int_stack+384,int_stack+168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103740,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+149349,int_stack+148701,int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122325,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+150357,int_stack+654,int_stack+384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103956,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+151167,int_stack+150357,int_stack+148701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122829,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+152463,int_stack+151167,int_stack+149349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123477,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+148197,int_stack+984,int_stack+654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104226,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+154143,int_stack+148197,int_stack+150357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124485,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+155763,int_stack+154143,int_stack+151167, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125295,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+149187,int_stack+155763,int_stack+152463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126591,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+151707,int_stack+1380,int_stack+984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104556,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+157923,int_stack+151707,int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128271,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+159903,int_stack+157923,int_stack+154143, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129261,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+162603,int_stack+159903,int_stack+155763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130881,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+152895,int_stack+162603,int_stack+149187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133041,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+148197,int_stack+1848,int_stack+1380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104952,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+148197,int_stack+151707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135561,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+148197,int_stack+0,int_stack+157923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136749,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+165843,int_stack+148197,int_stack+159903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138729,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+148197,int_stack+165843,int_stack+162603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141429,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+156423,int_stack+148197,int_stack+152895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144669,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+148197,int_stack+108640,int_stack+108360,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+149037,int_stack+109000,int_stack+108640,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+150117,int_stack+149037,int_stack+148197,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+151797,int_stack+109450,int_stack+109000,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+153147,int_stack+151797,int_stack+149037,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+161127,int_stack+153147,int_stack+150117,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+110000,int_stack+109450,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+163927,int_stack+0,int_stack+151797,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+166627,int_stack+163927,int_stack+153147,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+170227,int_stack+166627,int_stack+161127,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+174427,int_stack+110660,int_stack+110000,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+176407,int_stack+174427,int_stack+0,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+179707,int_stack+176407,int_stack+163927,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+184207,int_stack+179707,int_stack+166627,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+189607,int_stack+184207,int_stack+170227,10);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+155307,int_stack+2674,int_stack+2394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108360,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195487,int_stack+3034,int_stack+2674, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108640,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+196567,int_stack+195487,int_stack+155307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148197,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1650,int_stack+3484,int_stack+3034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109000,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+198247,int_stack+1650,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149037,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+200407,int_stack+198247,int_stack+196567, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150117,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+4034,int_stack+3484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109450,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+203207,int_stack+195487,int_stack+1650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151797,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+205907,int_stack+203207,int_stack+198247, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153147,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+209507,int_stack+205907,int_stack+200407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161127,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1650,int_stack+4694,int_stack+4034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110000,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+197137,int_stack+1650,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+213707,int_stack+197137,int_stack+203207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163927,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+200437,int_stack+213707,int_stack+205907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166627,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+218207,int_stack+200437,int_stack+209507, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170227,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+205837,int_stack+5474,int_stack+4694, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110660,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+208177,int_stack+205837,int_stack+1650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174427,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+224087,int_stack+208177,int_stack+197137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176407,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+205837,int_stack+224087,int_stack+213707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179707,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+224087,int_stack+205837,int_stack+200437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184207,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+224087,int_stack+218207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189607,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+203327,int_stack+195487,int_stack+156423,784);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1650,int_stack+69069,int_stack+68229,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2910,int_stack+70149,int_stack+69069,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+217439,int_stack+2910,int_stack+1650,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+219959,int_stack+71499,int_stack+70149,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+221984,int_stack+219959,int_stack+2910,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+225224,int_stack+221984,int_stack+217439,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+229424,int_stack+73149,int_stack+71499,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+155307,int_stack+229424,int_stack+219959,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+231899,int_stack+155307,int_stack+221984,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+237299,int_stack+231899,int_stack+225224,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+243599,int_stack+75129,int_stack+73149,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+246569,int_stack+243599,int_stack+229424,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+251519,int_stack+246569,int_stack+155307,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+258269,int_stack+251519,int_stack+231899,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+266369,int_stack+258269,int_stack+237299,15);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4530,int_stack+6804,int_stack+6384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68229,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+159357,int_stack+7344,int_stack+6804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69069,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+275189,int_stack+159357,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1650,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4530,int_stack+8019,int_stack+7344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70149,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+277709,int_stack+4530,int_stack+159357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2910,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+280949,int_stack+277709,int_stack+275189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217439,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+275189,int_stack+8844,int_stack+8019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71499,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+285149,int_stack+275189,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219959,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+289199,int_stack+285149,int_stack+277709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221984,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+294599,int_stack+289199,int_stack+280949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225224,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4530,int_stack+9834,int_stack+8844, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73149,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+277664,int_stack+4530,int_stack+275189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229424,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+300899,int_stack+277664,int_stack+285149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155307,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+307649,int_stack+300899,int_stack+289199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231899,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+282614,int_stack+307649,int_stack+294599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237299,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+291434,int_stack+11004,int_stack+9834, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75129,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+294944,int_stack+291434,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243599,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+315749,int_stack+294944,int_stack+277664, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246569,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+323999,int_stack+315749,int_stack+300899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251519,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+291434,int_stack+323999,int_stack+307649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258269,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+302774,int_stack+291434,int_stack+282614, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266369,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+275189,int_stack+302774,int_stack+195487,784);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+12537,int_stack+12369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103572, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195991,int_stack+12753,int_stack+12537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103740, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+196639,int_stack+195991,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122325, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+197647,int_stack+13023,int_stack+12753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103956, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+198457,int_stack+197647,int_stack+195991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122829, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+199753,int_stack+198457,int_stack+196639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123477, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+13353,int_stack+13023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104226, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+201433,int_stack+195487,int_stack+197647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124485, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4530,int_stack+201433,int_stack+198457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125295, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196477,int_stack+4530,int_stack+199753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126591, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+198997,int_stack+13749,int_stack+13353, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104556, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+6690,int_stack+198997,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128271, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8670,int_stack+6690,int_stack+201433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129261, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+298709,int_stack+8670,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130881, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+301949,int_stack+298709,int_stack+196477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133041, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4530,int_stack+14217,int_stack+13749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104952, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+195487,int_stack+4530,int_stack+198997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135561, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+197863,int_stack+195487,int_stack+6690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136749, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+4530,int_stack+197863,int_stack+8670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138729, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+195487,int_stack+4530,int_stack+298709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141429, 0.0, zero_stack,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4530,int_stack+195487,int_stack+301949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144669, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+15043,int_stack+14763, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108360, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+196327,int_stack+15403,int_stack+15043, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108640, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+197407,int_stack+196327,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148197, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+199087,int_stack+15853,int_stack+15403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109000, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+200437,int_stack+199087,int_stack+196327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149037, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+298709,int_stack+200437,int_stack+197407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150117, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+16403,int_stack+15853, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109450, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+301509,int_stack+195487,int_stack+199087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151797, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+304209,int_stack+301509,int_stack+200437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153147, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+197137,int_stack+304209,int_stack+298709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161127, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+298709,int_stack+17063,int_stack+16403, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110000, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+307809,int_stack+298709,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+311109,int_stack+307809,int_stack+301509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163927, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+315609,int_stack+311109,int_stack+304209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166627, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+300689,int_stack+315609,int_stack+197137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170227, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+195487,int_stack+17843,int_stack+17063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110660, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+197827,int_stack+195487,int_stack+298709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174427, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+321009,int_stack+197827,int_stack+307809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176407, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+195487,int_stack+321009,int_stack+311109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179707, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+321009,int_stack+195487,int_stack+315609, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184207, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+321009,int_stack+300689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189607, 0.0, zero_stack,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+298709,int_stack+195487,int_stack+4530,784);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4530,int_stack+19173,int_stack+18753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68229, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5790,int_stack+19713,int_stack+19173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69069, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+7410,int_stack+5790,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1650, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+9930,int_stack+20388,int_stack+19713, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70149, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+11955,int_stack+9930,int_stack+5790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2910, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+15195,int_stack+11955,int_stack+7410, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217439, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+4530,int_stack+21213,int_stack+20388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71499, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+312821,int_stack+4530,int_stack+9930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219959, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+316871,int_stack+312821,int_stack+11955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221984, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+7005,int_stack+316871,int_stack+15195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225224, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+13305,int_stack+22203,int_stack+21213, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73149, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+16275,int_stack+13305,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229424, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+322271,int_stack+16275,int_stack+312821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155307, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+329021,int_stack+322271,int_stack+316871, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231899, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+312821,int_stack+329021,int_stack+7005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237299, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4530,int_stack+23373,int_stack+22203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75129, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+337121,int_stack+4530,int_stack+13305, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243599, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+4530,int_stack+337121,int_stack+16275, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246569, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+12780,int_stack+4530,int_stack+322271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251519, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+337121,int_stack+12780,int_stack+329021, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258269, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4530,int_stack+337121,int_stack+312821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266369, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+312821,int_stack+4530,int_stack+195487,784);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+24906,int_stack+24738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103572, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195991,int_stack+25122,int_stack+24906, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103740, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+196639,int_stack+195991,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122325, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+197647,int_stack+25392,int_stack+25122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103956, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+198457,int_stack+197647,int_stack+195991, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122829, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+199753,int_stack+198457,int_stack+196639, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123477, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+25722,int_stack+25392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104226, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+201433,int_stack+195487,int_stack+197647, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124485, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+4530,int_stack+201433,int_stack+198457, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125295, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196477,int_stack+4530,int_stack+199753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126591, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+198997,int_stack+26118,int_stack+25722, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104556, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+6690,int_stack+198997,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128271, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+8670,int_stack+6690,int_stack+201433, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129261, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+11370,int_stack+8670,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130881, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+14610,int_stack+11370,int_stack+196477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133041, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+4530,int_stack+26586,int_stack+26118, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104952, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+195487,int_stack+4530,int_stack+198997, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135561, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+197863,int_stack+195487,int_stack+6690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136749, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+4530,int_stack+197863,int_stack+8670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138729, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+195487,int_stack+4530,int_stack+11370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141429, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4530,int_stack+195487,int_stack+14610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144669, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+27412,int_stack+27132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108360, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+196327,int_stack+27772,int_stack+27412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108640, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+197407,int_stack+196327,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+199087,int_stack+28222,int_stack+27772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109000, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+200437,int_stack+199087,int_stack+196327, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149037, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+9234,int_stack+200437,int_stack+197407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150117, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+28772,int_stack+28222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109450, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+12034,int_stack+195487,int_stack+199087, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151797, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+14734,int_stack+12034,int_stack+200437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153147, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+197137,int_stack+14734,int_stack+9234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161127, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+9234,int_stack+29432,int_stack+28772, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110000, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+18334,int_stack+9234,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+21634,int_stack+18334,int_stack+12034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163927, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+336341,int_stack+21634,int_stack+14734, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166627, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+11214,int_stack+336341,int_stack+197137, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170227, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+195487,int_stack+30212,int_stack+29432, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110660, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+197827,int_stack+195487,int_stack+9234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174427, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+341741,int_stack+197827,int_stack+18334, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176407, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+195487,int_stack+341741,int_stack+21634, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179707, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+17094,int_stack+195487,int_stack+336341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184207, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+17094,int_stack+11214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189607, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+9234,int_stack+195487,int_stack+4530,784);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4530,int_stack+31542,int_stack+31122, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68229, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5790,int_stack+32082,int_stack+31542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69069, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+336341,int_stack+5790,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1650, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+338861,int_stack+32757,int_stack+32082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70149, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+340886,int_stack+338861,int_stack+5790, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2910, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4530,int_stack+340886,int_stack+336341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217439, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+336341,int_stack+33582,int_stack+32757, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71499, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+344126,int_stack+336341,int_stack+338861, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219959, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+23346,int_stack+344126,int_stack+340886, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221984, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+348176,int_stack+23346,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225224, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4530,int_stack+34572,int_stack+33582, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73149, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+338816,int_stack+4530,int_stack+336341, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229424, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+354476,int_stack+338816,int_stack+344126, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155307, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+361226,int_stack+354476,int_stack+23346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231899, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+23346,int_stack+361226,int_stack+348176, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237299, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+343766,int_stack+35742,int_stack+34572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75129, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+347276,int_stack+343766,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243599, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+369326,int_stack+347276,int_stack+338816, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246569, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+336341,int_stack+369326,int_stack+354476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251519, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+346466,int_stack+336341,int_stack+361226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258269, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+357806,int_stack+346466,int_stack+23346, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266369, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+369566,int_stack+357806,int_stack+195487,784);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+37275,int_stack+37107, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195991,int_stack+37491,int_stack+37275, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+196639,int_stack+195991,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+197647,int_stack+37761,int_stack+37491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+103956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+198457,int_stack+197647,int_stack+195991, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+122829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+199753,int_stack+198457,int_stack+196639, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+123477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+38091,int_stack+37761, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+201433,int_stack+195487,int_stack+197647, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+124485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+23346,int_stack+201433,int_stack+198457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+125295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196477,int_stack+23346,int_stack+199753, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+126591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+198997,int_stack+38487,int_stack+38091, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+25506,int_stack+198997,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+128271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+27486,int_stack+25506,int_stack+201433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+129261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+30186,int_stack+27486,int_stack+23346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+130881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+33426,int_stack+30186,int_stack+196477, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+133041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+23346,int_stack+38955,int_stack+38487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+104952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+195487,int_stack+23346,int_stack+198997, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+135561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+197863,int_stack+195487,int_stack+25506, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+136749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+23346,int_stack+197863,int_stack+27486, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+138729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+195487,int_stack+23346,int_stack+30186, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+141429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4530,int_stack+195487,int_stack+33426, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+144669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+39781,int_stack+39501, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+196327,int_stack+40141,int_stack+39781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+108640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+197407,int_stack+196327,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+199087,int_stack+40591,int_stack+40141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+200437,int_stack+199087,int_stack+196327, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+149037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+23346,int_stack+200437,int_stack+197407, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+150117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+41141,int_stack+40591, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+109450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+26146,int_stack+195487,int_stack+199087, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+151797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+28846,int_stack+26146,int_stack+200437, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+153147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+197137,int_stack+28846,int_stack+23346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+161127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+23346,int_stack+41801,int_stack+41141, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+32446,int_stack+23346,int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+35746,int_stack+32446,int_stack+26146, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+163927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+336341,int_stack+35746,int_stack+28846, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+166627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+25326,int_stack+336341,int_stack+197137, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+170227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+195487,int_stack+42581,int_stack+41801, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+110660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+197827,int_stack+195487,int_stack+23346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+174427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+341741,int_stack+197827,int_stack+32446, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+176407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+195487,int_stack+341741,int_stack+35746, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+179707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+341741,int_stack+195487,int_stack+336341, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+184207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+341741,int_stack+25326, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+189607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+336341,int_stack+195487,int_stack+4530,784);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4530,int_stack+43911,int_stack+43491, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+68229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5790,int_stack+44451,int_stack+43911, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+69069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+350453,int_stack+5790,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+352973,int_stack+45126,int_stack+44451, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+70149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+354998,int_stack+352973,int_stack+5790, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4530,int_stack+354998,int_stack+350453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+217439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+350453,int_stack+45951,int_stack+45126, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+71499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+358238,int_stack+350453,int_stack+352973, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+219959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+362288,int_stack+358238,int_stack+354998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+221984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+23346,int_stack+362288,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+225224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4530,int_stack+46941,int_stack+45951, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+73149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+352928,int_stack+4530,int_stack+350453, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+229424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+29646,int_stack+352928,int_stack+358238, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+155307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+36396,int_stack+29646,int_stack+362288, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+231899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+357878,int_stack+36396,int_stack+23346, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+237299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+23346,int_stack+48111,int_stack+46941, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+75129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+393086,int_stack+23346,int_stack+4530, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+243599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+399026,int_stack+393086,int_stack+352928, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+246569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+407276,int_stack+399026,int_stack+29646, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+251519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+393086,int_stack+407276,int_stack+36396, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+258269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+404426,int_stack+393086,int_stack+357878, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+266369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+23346,int_stack+404426,int_stack+195487,784);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+49644,int_stack+49476, 0.0, zero_stack, 1.0, int_stack+103572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195991,int_stack+49860,int_stack+49644, 0.0, zero_stack, 1.0, int_stack+103740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+196639,int_stack+195991,int_stack+195487, 0.0, zero_stack, 1.0, int_stack+122325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+197647,int_stack+50130,int_stack+49860, 0.0, zero_stack, 1.0, int_stack+103956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+198457,int_stack+197647,int_stack+195991, 0.0, zero_stack, 1.0, int_stack+122829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+199753,int_stack+198457,int_stack+196639, 0.0, zero_stack, 1.0, int_stack+123477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+50460,int_stack+50130, 0.0, zero_stack, 1.0, int_stack+104226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+201433,int_stack+195487,int_stack+197647, 0.0, zero_stack, 1.0, int_stack+124485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+393086,int_stack+201433,int_stack+198457, 0.0, zero_stack, 1.0, int_stack+125295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+196477,int_stack+393086,int_stack+199753, 0.0, zero_stack, 1.0, int_stack+126591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+198997,int_stack+50856,int_stack+50460, 0.0, zero_stack, 1.0, int_stack+104556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+395246,int_stack+198997,int_stack+195487, 0.0, zero_stack, 1.0, int_stack+128271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+397226,int_stack+395246,int_stack+201433, 0.0, zero_stack, 1.0, int_stack+129261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+399926,int_stack+397226,int_stack+393086, 0.0, zero_stack, 1.0, int_stack+130881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+403166,int_stack+399926,int_stack+196477, 0.0, zero_stack, 1.0, int_stack+133041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+393086,int_stack+51324,int_stack+50856, 0.0, zero_stack, 1.0, int_stack+104952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+195487,int_stack+393086,int_stack+198997, 0.0, zero_stack, 1.0, int_stack+135561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+197863,int_stack+195487,int_stack+395246, 0.0, zero_stack, 1.0, int_stack+136749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+393086,int_stack+197863,int_stack+397226, 0.0, zero_stack, 1.0, int_stack+138729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+195487,int_stack+393086,int_stack+399926, 0.0, zero_stack, 1.0, int_stack+141429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4530,int_stack+195487,int_stack+403166, 0.0, zero_stack, 1.0, int_stack+144669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+52150,int_stack+51870, 0.0, zero_stack, 1.0, int_stack+108360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+196327,int_stack+52510,int_stack+52150, 0.0, zero_stack, 1.0, int_stack+108640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+197407,int_stack+196327,int_stack+195487, 0.0, zero_stack, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+199087,int_stack+52960,int_stack+52510, 0.0, zero_stack, 1.0, int_stack+109000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+200437,int_stack+199087,int_stack+196327, 0.0, zero_stack, 1.0, int_stack+149037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+393086,int_stack+200437,int_stack+197407, 0.0, zero_stack, 1.0, int_stack+150117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+195487,int_stack+53510,int_stack+52960, 0.0, zero_stack, 1.0, int_stack+109450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+395886,int_stack+195487,int_stack+199087, 0.0, zero_stack, 1.0, int_stack+151797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+398586,int_stack+395886,int_stack+200437, 0.0, zero_stack, 1.0, int_stack+153147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+197137,int_stack+398586,int_stack+393086, 0.0, zero_stack, 1.0, int_stack+161127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+393086,int_stack+54170,int_stack+53510, 0.0, zero_stack, 1.0, int_stack+110000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+402186,int_stack+393086,int_stack+195487, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+405486,int_stack+402186,int_stack+395886, 0.0, zero_stack, 1.0, int_stack+163927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+409986,int_stack+405486,int_stack+398586, 0.0, zero_stack, 1.0, int_stack+166627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+395066,int_stack+409986,int_stack+197137, 0.0, zero_stack, 1.0, int_stack+170227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+195487,int_stack+54950,int_stack+54170, 0.0, zero_stack, 1.0, int_stack+110660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+197827,int_stack+195487,int_stack+393086, 0.0, zero_stack, 1.0, int_stack+174427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+46866,int_stack+197827,int_stack+402186, 0.0, zero_stack, 1.0, int_stack+176407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+195487,int_stack+46866,int_stack+405486, 0.0, zero_stack, 1.0, int_stack+179707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+46866,int_stack+195487,int_stack+409986, 0.0, zero_stack, 1.0, int_stack+184207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+46866,int_stack+395066, 0.0, zero_stack, 1.0, int_stack+189607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+393086,int_stack+195487,int_stack+4530,784);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4530,int_stack+56280,int_stack+55860, 0.0, zero_stack, 1.0, int_stack+68229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5790,int_stack+56820,int_stack+56280, 0.0, zero_stack, 1.0, int_stack+69069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+46866,int_stack+5790,int_stack+4530, 0.0, zero_stack, 1.0, int_stack+1650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+49386,int_stack+57495,int_stack+56820, 0.0, zero_stack, 1.0, int_stack+70149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+51411,int_stack+49386,int_stack+5790, 0.0, zero_stack, 1.0, int_stack+2910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+4530,int_stack+51411,int_stack+46866, 0.0, zero_stack, 1.0, int_stack+217439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+46866,int_stack+58320,int_stack+57495, 0.0, zero_stack, 1.0, int_stack+71499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+407198,int_stack+46866,int_stack+49386, 0.0, zero_stack, 1.0, int_stack+219959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+411248,int_stack+407198,int_stack+51411, 0.0, zero_stack, 1.0, int_stack+221984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+49341,int_stack+411248,int_stack+4530, 0.0, zero_stack, 1.0, int_stack+225224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4530,int_stack+59310,int_stack+58320, 0.0, zero_stack, 1.0, int_stack+73149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+350453,int_stack+4530,int_stack+46866, 0.0, zero_stack, 1.0, int_stack+229424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+355403,int_stack+350453,int_stack+407198, 0.0, zero_stack, 1.0, int_stack+155307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+416648,int_stack+355403,int_stack+411248, 0.0, zero_stack, 1.0, int_stack+231899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+407198,int_stack+416648,int_stack+49341, 0.0, zero_stack, 1.0, int_stack+237299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+46866,int_stack+60480,int_stack+59310, 0.0, zero_stack, 1.0, int_stack+75129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+50376,int_stack+46866,int_stack+4530, 0.0, zero_stack, 1.0, int_stack+243599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+424748,int_stack+50376,int_stack+350453, 0.0, zero_stack, 1.0, int_stack+246569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+46866,int_stack+424748,int_stack+355403, 0.0, zero_stack, 1.0, int_stack+251519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+350453,int_stack+46866,int_stack+416648, 0.0, zero_stack, 1.0, int_stack+258269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+46866,int_stack+350453,int_stack+407198, 0.0, zero_stack, 1.0, int_stack+266369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+407198,int_stack+46866,int_stack+195487,784);
 /*--- compute (d0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+195487,int_stack+62013,int_stack+61845, 1.0, int_stack+103572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+195991,int_stack+62229,int_stack+62013, 1.0, int_stack+103740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+196639,int_stack+195991,int_stack+195487, 1.0, int_stack+122325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+197647,int_stack+62499,int_stack+62229, 1.0, int_stack+103956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+198457,int_stack+197647,int_stack+195991, 1.0, int_stack+122829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+199753,int_stack+198457,int_stack+196639, 1.0, int_stack+123477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+122325,int_stack+62829,int_stack+62499, 1.0, int_stack+104226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+195487,int_stack+122325,int_stack+197647, 1.0, int_stack+124485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+46866,int_stack+195487,int_stack+198457, 1.0, int_stack+125295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+123315,int_stack+46866,int_stack+199753, 1.0, int_stack+126591, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+125835,int_stack+63225,int_stack+62829, 1.0, int_stack+104556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+197107,int_stack+125835,int_stack+122325, 1.0, int_stack+128271, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+199087,int_stack+197107,int_stack+195487, 1.0, int_stack+129261, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+127023,int_stack+199087,int_stack+46866, 1.0, int_stack+130881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+46866,int_stack+127023,int_stack+123315, 1.0, int_stack+133041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+50394,int_stack+63693,int_stack+63225, 1.0, int_stack+104952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+51798,int_stack+50394,int_stack+125835, 1.0, int_stack+135561, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+54174,int_stack+51798,int_stack+197107, 1.0, int_stack+136749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+57474,int_stack+54174,int_stack+199087, 1.0, int_stack+138729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+50394,int_stack+57474,int_stack+127023, 1.0, int_stack+141429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (d0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+4530,int_stack+50394,int_stack+46866, 1.0, int_stack+144669, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,6);
 /*--- compute (f0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+46866,int_stack+64519,int_stack+64239, 1.0, int_stack+108360, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+47706,int_stack+64879,int_stack+64519, 1.0, int_stack+108640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+48786,int_stack+47706,int_stack+46866, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+50466,int_stack+65329,int_stack+64879, 1.0, int_stack+109000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+51816,int_stack+50466,int_stack+47706, 1.0, int_stack+149037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+53976,int_stack+51816,int_stack+48786, 1.0, int_stack+150117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+148197,int_stack+65879,int_stack+65329, 1.0, int_stack+109450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+46866,int_stack+148197,int_stack+50466, 1.0, int_stack+151797, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+56776,int_stack+46866,int_stack+51816, 1.0, int_stack+153147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+149847,int_stack+56776,int_stack+53976, 1.0, int_stack+161127, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+49566,int_stack+66539,int_stack+65879, 1.0, int_stack+110000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+51546,int_stack+49566,int_stack+148197, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+60376,int_stack+51546,int_stack+46866, 1.0, int_stack+163927, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+195487,int_stack+60376,int_stack+56776, 1.0, int_stack+166627, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+122325,int_stack+195487,int_stack+149847, 1.0, int_stack+170227, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+46866,int_stack+67319,int_stack+66539, 1.0, int_stack+110660, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+148197,int_stack+46866,int_stack+49566, 1.0, int_stack+174427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+54846,int_stack+148197,int_stack+51546, 1.0, int_stack+176407, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+148197,int_stack+54846,int_stack+60376, 1.0, int_stack+179707, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+46866,int_stack+148197,int_stack+195487, 1.0, int_stack+184207, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (f0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+46866,int_stack+122325, 1.0, int_stack+189607, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+46866,int_stack+195487,int_stack+4530,784);
 /*--- compute (g0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4530,int_stack+69609,int_stack+68649, 1.0, int_stack+68229, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+5790,int_stack+70824,int_stack+69609, 1.0, int_stack+69069, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+122325,int_stack+5790,int_stack+4530, 1.0, int_stack+1650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+124845,int_stack+72324,int_stack+70824, 1.0, int_stack+70149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+126870,int_stack+124845,int_stack+5790, 1.0, int_stack+2910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+130110,int_stack+126870,int_stack+122325, 1.0, int_stack+217439, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+217439,int_stack+74139,int_stack+72324, 1.0, int_stack+71499, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+60978,int_stack+217439,int_stack+124845, 1.0, int_stack+219959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+65028,int_stack+60978,int_stack+126870, 1.0, int_stack+221984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+122325,int_stack+65028,int_stack+130110, 1.0, int_stack+225224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+219914,int_stack+76299,int_stack+74139, 1.0, int_stack+73149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+222884,int_stack+219914,int_stack+217439, 1.0, int_stack+229424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+128625,int_stack+222884,int_stack+60978, 1.0, int_stack+155307, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+148197,int_stack+128625,int_stack+65028, 1.0, int_stack+231899, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+60978,int_stack+148197,int_stack+122325, 1.0, int_stack+237299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+122325,int_stack+77469,int_stack+76299, 1.0, int_stack+75129, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+69798,int_stack+122325,int_stack+219914, 1.0, int_stack+243599, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+227834,int_stack+69798,int_stack+222884, 1.0, int_stack+246569, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+217439,int_stack+227834,int_stack+128625, 1.0, int_stack+251519, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+122325,int_stack+217439,int_stack+148197, 1.0, int_stack+258269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (g0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+148197,int_stack+122325,int_stack+60978, 1.0, int_stack+266369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,15);
 /*--- compute (fp|ii) ---*/
   hrr1_build_fp(Libderiv->AB,int_stack+217439,int_stack+148197,int_stack+195487,784);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+195487,int_stack+105420,int_stack+104952,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+196891,int_stack+195487,int_stack+135561,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+199267,int_stack+196891,int_stack+136749,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+148197,int_stack+199267,int_stack+138729,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+195487,int_stack+148197,int_stack+141429,6);
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+148197,int_stack+195487,int_stack+144669,6);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+195487,int_stack+111440,int_stack+110660,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+197827,int_stack+195487,int_stack+174427,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+152901,int_stack+197827,int_stack+176407,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+195487,int_stack+152901,int_stack+179707,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+152901,int_stack+195487,int_stack+184207,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+195487,int_stack+152901,int_stack+189607,10);
 /*--- compute (dp|ii) ---*/
   hrr1_build_dp(Libderiv->AB,int_stack+152901,int_stack+195487,int_stack+148197,784);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+167013,int_stack+79002,int_stack+78834,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167517,int_stack+79218,int_stack+79002,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+168165,int_stack+167517,int_stack+167013,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+169173,int_stack+79488,int_stack+79218,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+169983,int_stack+169173,int_stack+167517,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+171279,int_stack+169983,int_stack+168165,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+167013,int_stack+79818,int_stack+79488,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+172959,int_stack+167013,int_stack+169173,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+174579,int_stack+172959,int_stack+169983,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+168003,int_stack+174579,int_stack+171279,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+170523,int_stack+80214,int_stack+79818,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+176739,int_stack+170523,int_stack+167013,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+178719,int_stack+176739,int_stack+172959,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+181419,int_stack+178719,int_stack+174579,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+171711,int_stack+181419,int_stack+168003,6);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+167013,int_stack+80682,int_stack+80214,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+184659,int_stack+167013,int_stack+170523,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+167013,int_stack+184659,int_stack+176739,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+184659,int_stack+167013,int_stack+178719,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+167013,int_stack+184659,int_stack+181419,6);
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+175239,int_stack+167013,int_stack+171711,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+167013,int_stack+81508,int_stack+81228,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167853,int_stack+81868,int_stack+81508,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+168933,int_stack+167853,int_stack+167013,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+170613,int_stack+82318,int_stack+81868,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+171963,int_stack+170613,int_stack+167853,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+179943,int_stack+171963,int_stack+168933,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+167013,int_stack+82868,int_stack+82318,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+182743,int_stack+167013,int_stack+170613,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+185443,int_stack+182743,int_stack+171963,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+168663,int_stack+185443,int_stack+179943,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+179943,int_stack+83528,int_stack+82868,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+189043,int_stack+179943,int_stack+167013,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+60978,int_stack+189043,int_stack+182743,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+65478,int_stack+60978,int_stack+185443,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+181923,int_stack+65478,int_stack+168663,10);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+167013,int_stack+84308,int_stack+83528,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+169353,int_stack+167013,int_stack+179943,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+70878,int_stack+169353,int_stack+189043,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+167013,int_stack+70878,int_stack+60978,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+70878,int_stack+167013,int_stack+65478,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+167013,int_stack+70878,int_stack+181923,10);
 /*--- compute (dp|ii) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+60978,int_stack+167013,int_stack+175239, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+174853,int_stack+85638,int_stack+85218,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+176113,int_stack+86178,int_stack+85638,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+177733,int_stack+176113,int_stack+174853,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+180253,int_stack+86853,int_stack+86178,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+182278,int_stack+180253,int_stack+176113,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+185518,int_stack+182278,int_stack+177733,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+174853,int_stack+87678,int_stack+86853,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+189718,int_stack+174853,int_stack+180253,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+75090,int_stack+189718,int_stack+182278,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+177328,int_stack+75090,int_stack+185518,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+183628,int_stack+88668,int_stack+87678,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+80490,int_stack+183628,int_stack+174853,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+122325,int_stack+80490,int_stack+189718,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+186598,int_stack+122325,int_stack+75090,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+129075,int_stack+186598,int_stack+177328,15);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+75090,int_stack+89838,int_stack+88668,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+174853,int_stack+75090,int_stack+183628,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+137895,int_stack+174853,int_stack+80490,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+174853,int_stack+137895,int_stack+122325,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+75090,int_stack+174853,int_stack+186598,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+174853,int_stack+75090,int_stack+129075,15);
 /*--- compute (fp|ii) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+122325,int_stack+174853,int_stack+167013, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+167013,int_stack+91371,int_stack+91203,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167517,int_stack+91587,int_stack+91371,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+168165,int_stack+167517,int_stack+167013,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+169173,int_stack+91857,int_stack+91587,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+169983,int_stack+169173,int_stack+167517,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+171279,int_stack+169983,int_stack+168165,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+167013,int_stack+92187,int_stack+91857,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+172959,int_stack+167013,int_stack+169173,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+174579,int_stack+172959,int_stack+169983,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+168003,int_stack+174579,int_stack+171279,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+170523,int_stack+92583,int_stack+92187,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+176739,int_stack+170523,int_stack+167013,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+178719,int_stack+176739,int_stack+172959,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+181419,int_stack+178719,int_stack+174579,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+171711,int_stack+181419,int_stack+168003,6);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+167013,int_stack+93051,int_stack+92583,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+184659,int_stack+167013,int_stack+170523,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+167013,int_stack+184659,int_stack+176739,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+184659,int_stack+167013,int_stack+178719,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+167013,int_stack+184659,int_stack+181419,6);
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+175239,int_stack+167013,int_stack+171711,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+167013,int_stack+93877,int_stack+93597,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167853,int_stack+94237,int_stack+93877,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+168933,int_stack+167853,int_stack+167013,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+170613,int_stack+94687,int_stack+94237,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+171963,int_stack+170613,int_stack+167853,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+179943,int_stack+171963,int_stack+168933,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+167013,int_stack+95237,int_stack+94687,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+182743,int_stack+167013,int_stack+170613,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+185443,int_stack+182743,int_stack+171963,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+168663,int_stack+185443,int_stack+179943,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+179943,int_stack+95897,int_stack+95237,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+189043,int_stack+179943,int_stack+167013,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+75090,int_stack+189043,int_stack+182743,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+79590,int_stack+75090,int_stack+185443,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+181923,int_stack+79590,int_stack+168663,10);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+167013,int_stack+96677,int_stack+95897,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+169353,int_stack+167013,int_stack+179943,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+84990,int_stack+169353,int_stack+189043,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+167013,int_stack+84990,int_stack+75090,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+84990,int_stack+167013,int_stack+79590,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+167013,int_stack+84990,int_stack+181923,10);
 /*--- compute (dp|ii) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+75090,int_stack+167013,int_stack+175239, 0.0, zero_stack, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+174853,int_stack+98007,int_stack+97587,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+176113,int_stack+98547,int_stack+98007,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+177733,int_stack+176113,int_stack+174853,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+180253,int_stack+99222,int_stack+98547,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+182278,int_stack+180253,int_stack+176113,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+185518,int_stack+182278,int_stack+177733,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+174853,int_stack+100047,int_stack+99222,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+189718,int_stack+174853,int_stack+180253,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+89202,int_stack+189718,int_stack+182278,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+177328,int_stack+89202,int_stack+185518,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+183628,int_stack+101037,int_stack+100047,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+94602,int_stack+183628,int_stack+174853,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+240959,int_stack+94602,int_stack+189718,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+186598,int_stack+240959,int_stack+89202,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+247709,int_stack+186598,int_stack+177328,15);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+89202,int_stack+102207,int_stack+101037,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+174853,int_stack+89202,int_stack+183628,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+256529,int_stack+174853,int_stack+94602,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+174853,int_stack+256529,int_stack+240959,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+256529,int_stack+174853,int_stack+186598,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+174853,int_stack+256529,int_stack+247709,15);
 /*--- compute (fp|ii) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+240959,int_stack+174853,int_stack+167013, 0.0, zero_stack, 1.0, int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (d0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+167013,int_stack+106134,int_stack+105966,6);
 /*--- compute (d0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167517,int_stack+106350,int_stack+106134,6);
 /*--- compute (d0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+168165,int_stack+167517,int_stack+167013,6);
 /*--- compute (d0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+169173,int_stack+106620,int_stack+106350,6);
 /*--- compute (d0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+169983,int_stack+169173,int_stack+167517,6);
 /*--- compute (d0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+171279,int_stack+169983,int_stack+168165,6);
 /*--- compute (d0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+167013,int_stack+106950,int_stack+106620,6);
 /*--- compute (d0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+172959,int_stack+167013,int_stack+169173,6);
 /*--- compute (d0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+174579,int_stack+172959,int_stack+169983,6);
 /*--- compute (d0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+168003,int_stack+174579,int_stack+171279,6);
 /*--- compute (d0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+170523,int_stack+107346,int_stack+106950,6);
 /*--- compute (d0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+176739,int_stack+170523,int_stack+167013,6);
 /*--- compute (d0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+178719,int_stack+176739,int_stack+172959,6);
 /*--- compute (d0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+181419,int_stack+178719,int_stack+174579,6);
 /*--- compute (d0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+171711,int_stack+181419,int_stack+168003,6);
 /*--- compute (d0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+167013,int_stack+107814,int_stack+107346,6);
 /*--- compute (d0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+184659,int_stack+167013,int_stack+170523,6);
 /*--- compute (d0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+167013,int_stack+184659,int_stack+176739,6);
 /*--- compute (d0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+184659,int_stack+167013,int_stack+178719,6);
 /*--- compute (d0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+167013,int_stack+184659,int_stack+181419,6);
 /*--- compute (d0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+175239,int_stack+167013,int_stack+171711,6);
 /*--- compute (f0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+167013,int_stack+112630,int_stack+112350,10);
 /*--- compute (f0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+167853,int_stack+112990,int_stack+112630,10);
 /*--- compute (f0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+168933,int_stack+167853,int_stack+167013,10);
 /*--- compute (f0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+170613,int_stack+113440,int_stack+112990,10);
 /*--- compute (f0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+171963,int_stack+170613,int_stack+167853,10);
 /*--- compute (f0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+179943,int_stack+171963,int_stack+168933,10);
 /*--- compute (f0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+167013,int_stack+113990,int_stack+113440,10);
 /*--- compute (f0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+182743,int_stack+167013,int_stack+170613,10);
 /*--- compute (f0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+185443,int_stack+182743,int_stack+171963,10);
 /*--- compute (f0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+168663,int_stack+185443,int_stack+179943,10);
 /*--- compute (f0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+179943,int_stack+114650,int_stack+113990,10);
 /*--- compute (f0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+189043,int_stack+179943,int_stack+167013,10);
 /*--- compute (f0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+264479,int_stack+189043,int_stack+182743,10);
 /*--- compute (f0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+268979,int_stack+264479,int_stack+185443,10);
 /*--- compute (f0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+181923,int_stack+268979,int_stack+168663,10);
 /*--- compute (f0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+167013,int_stack+115430,int_stack+114650,10);
 /*--- compute (f0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+169353,int_stack+167013,int_stack+179943,10);
 /*--- compute (f0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+89202,int_stack+169353,int_stack+189043,10);
 /*--- compute (f0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+167013,int_stack+89202,int_stack+264479,10);
 /*--- compute (f0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+89202,int_stack+167013,int_stack+268979,10);
 /*--- compute (f0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+167013,int_stack+89202,int_stack+181923,10);
 /*--- compute (dp|ii) ---*/
   d1hrr1_build_dp(Libderiv->AB,int_stack+89202,int_stack+167013,int_stack+175239, 1.0, int_stack+148197, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (g0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+103314,int_stack+116760,int_stack+116340,15);
 /*--- compute (g0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+104574,int_stack+117300,int_stack+116760,15);
 /*--- compute (g0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+106194,int_stack+104574,int_stack+103314,15);
 /*--- compute (g0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+108714,int_stack+117975,int_stack+117300,15);
 /*--- compute (g0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+110739,int_stack+108714,int_stack+104574,15);
 /*--- compute (g0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+174853,int_stack+110739,int_stack+106194,15);
 /*--- compute (g0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+103314,int_stack+118800,int_stack+117975,15);
 /*--- compute (g0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+113979,int_stack+103314,int_stack+108714,15);
 /*--- compute (g0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+179053,int_stack+113979,int_stack+110739,15);
 /*--- compute (g0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+105789,int_stack+179053,int_stack+174853,15);
 /*--- compute (g0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+174853,int_stack+119790,int_stack+118800,15);
 /*--- compute (g0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+184453,int_stack+174853,int_stack+103314,15);
 /*--- compute (g0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+264479,int_stack+184453,int_stack+113979,15);
 /*--- compute (g0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+0,int_stack+264479,int_stack+179053,15);
 /*--- compute (g0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+350453,int_stack+0,int_stack+105789,15);
 /*--- compute (g0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+103314,int_stack+120960,int_stack+119790,15);
 /*--- compute (g0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+106824,int_stack+103314,int_stack+174853,15);
 /*--- compute (g0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+174853,int_stack+106824,int_stack+184453,15);
 /*--- compute (g0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+183103,int_stack+174853,int_stack+264479,15);
 /*--- compute (g0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+103314,int_stack+183103,int_stack+0,15);
 /*--- compute (g0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+174853,int_stack+103314,int_stack+350453,15);
 /*--- compute (fp|ii) ---*/
   d1hrr1_build_fp(Libderiv->AB,int_stack+430718,int_stack+174853,int_stack+167013, 1.0, int_stack+195487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (dd|ii) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+167013,int_stack+275189,int_stack+203327,784);
     Libderiv->ABCD[11] = int_stack + 167013;
 /*--- compute (dd|ii) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+264479,int_stack+312821,int_stack+298709,784);
     Libderiv->ABCD[10] = int_stack + 264479;
 /*--- compute (dd|ii) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+292703,int_stack+369566,int_stack+9234,784);
     Libderiv->ABCD[9] = int_stack + 292703;
 /*--- compute (dd|ii) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+350453,int_stack+23346,int_stack+336341,784);
     Libderiv->ABCD[8] = int_stack + 350453;
 /*--- compute (dd|ii) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+0,int_stack+407198,int_stack+393086,784);
     Libderiv->ABCD[7] = int_stack + 0;
 /*--- compute (dd|ii) ---*/
   hrr1_build_dd(Libderiv->AB,int_stack+378677,int_stack+217439,int_stack+46866,784);
     Libderiv->ABCD[6] = int_stack + 378677;
 /*--- compute (dd|ii) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+195237,int_stack+122325,int_stack+60978, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+152901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[2] = int_stack + 195237;
 /*--- compute (dd|ii) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+103314,int_stack+240959,int_stack+75090, 0.0, zero_stack, 1.0, int_stack+152901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[1] = int_stack + 103314;
 /*--- compute (dd|ii) ---*/
   d1hrr1_build_dd(Libderiv->AB,int_stack+223461,int_stack+430718,int_stack+89202, 1.0, int_stack+152901, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[0] = int_stack + 223461;

}
