/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hfih(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hf|ih) integrals */

void d1hrr_order_hfih(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3444;
 Libderiv->deriv_classes[5][11][11] = int_stack + 4830;
 Libderiv->deriv_classes[6][6][11] = int_stack + 6468;
 Libderiv->deriv_classes[6][7][11] = int_stack + 7252;
 Libderiv->deriv_classes[6][8][11] = int_stack + 8260;
 Libderiv->deriv_classes[6][9][11] = int_stack + 9520;
 Libderiv->deriv_classes[6][10][11] = int_stack + 11060;
 Libderiv->deriv_classes[6][11][11] = int_stack + 12908;
 Libderiv->deriv_classes[7][6][11] = int_stack + 15092;
 Libderiv->deriv_classes[7][7][11] = int_stack + 16100;
 Libderiv->deriv_classes[7][8][11] = int_stack + 17396;
 Libderiv->deriv_classes[7][9][11] = int_stack + 19016;
 Libderiv->deriv_classes[7][10][11] = int_stack + 20996;
 Libderiv->deriv_classes[7][11][11] = int_stack + 23372;
 Libderiv->deriv_classes[8][6][11] = int_stack + 26180;
 Libderiv->deriv_classes[8][7][11] = int_stack + 27440;
 Libderiv->deriv_classes[8][8][11] = int_stack + 29060;
 Libderiv->deriv_classes[8][9][11] = int_stack + 31085;
 Libderiv->deriv_classes[8][10][11] = int_stack + 33560;
 Libderiv->deriv_classes[8][11][11] = int_stack + 36530;
 Libderiv->deriv_classes[5][6][10] = int_stack + 40040;
 Libderiv->deriv_classes[5][7][10] = int_stack + 40628;
 Libderiv->deriv_classes[5][8][10] = int_stack + 41384;
 Libderiv->deriv_classes[5][9][10] = int_stack + 42329;
 Libderiv->deriv_classes[5][10][10] = int_stack + 43484;
 Libderiv->deriv_classes[5][11][10] = int_stack + 44870;
 Libderiv->deriv_classes[6][6][10] = int_stack + 46508;
 Libderiv->deriv_classes[6][7][10] = int_stack + 47292;
 Libderiv->deriv_classes[6][8][10] = int_stack + 48300;
 Libderiv->deriv_classes[6][9][10] = int_stack + 49560;
 Libderiv->deriv_classes[6][10][10] = int_stack + 51100;
 Libderiv->deriv_classes[6][11][10] = int_stack + 52948;
 Libderiv->deriv_classes[7][6][10] = int_stack + 55132;
 Libderiv->deriv_classes[7][7][10] = int_stack + 56140;
 Libderiv->deriv_classes[7][8][10] = int_stack + 57436;
 Libderiv->deriv_classes[7][9][10] = int_stack + 59056;
 Libderiv->deriv_classes[7][10][10] = int_stack + 61036;
 Libderiv->deriv_classes[7][11][10] = int_stack + 63412;
 Libderiv->deriv_classes[8][6][10] = int_stack + 66220;
 Libderiv->deriv_classes[8][7][10] = int_stack + 67480;
 Libderiv->deriv_classes[8][8][10] = int_stack + 69100;
 Libderiv->deriv_classes[8][9][10] = int_stack + 71125;
 Libderiv->deriv_classes[8][10][10] = int_stack + 73600;
 Libderiv->deriv_classes[8][11][10] = int_stack + 76570;
 Libderiv->deriv_classes[5][6][9] = int_stack + 80080;
 Libderiv->deriv_classes[5][7][9] = int_stack + 80668;
 Libderiv->deriv_classes[5][8][9] = int_stack + 81424;
 Libderiv->deriv_classes[5][9][9] = int_stack + 82369;
 Libderiv->deriv_classes[5][10][9] = int_stack + 83524;
 Libderiv->deriv_classes[5][11][9] = int_stack + 84910;
 Libderiv->deriv_classes[6][6][9] = int_stack + 86548;
 Libderiv->deriv_classes[6][7][9] = int_stack + 87332;
 Libderiv->deriv_classes[6][8][9] = int_stack + 88340;
 Libderiv->deriv_classes[6][9][9] = int_stack + 89600;
 Libderiv->deriv_classes[6][10][9] = int_stack + 91140;
 Libderiv->deriv_classes[6][11][9] = int_stack + 92988;
 Libderiv->deriv_classes[7][6][9] = int_stack + 95172;
 Libderiv->deriv_classes[7][7][9] = int_stack + 96180;
 Libderiv->deriv_classes[7][8][9] = int_stack + 97476;
 Libderiv->deriv_classes[7][9][9] = int_stack + 99096;
 Libderiv->deriv_classes[7][10][9] = int_stack + 101076;
 Libderiv->deriv_classes[7][11][9] = int_stack + 103452;
 Libderiv->deriv_classes[8][6][9] = int_stack + 106260;
 Libderiv->deriv_classes[8][7][9] = int_stack + 107520;
 Libderiv->deriv_classes[8][8][9] = int_stack + 109140;
 Libderiv->deriv_classes[8][9][9] = int_stack + 111165;
 Libderiv->deriv_classes[8][10][9] = int_stack + 113640;
 Libderiv->deriv_classes[8][11][9] = int_stack + 116610;
 Libderiv->deriv_classes[5][6][8] = int_stack + 120120;
 Libderiv->deriv_classes[5][7][8] = int_stack + 120708;
 Libderiv->deriv_classes[5][8][8] = int_stack + 121464;
 Libderiv->deriv_classes[5][9][8] = int_stack + 122409;
 Libderiv->deriv_classes[5][10][8] = int_stack + 123564;
 Libderiv->deriv_classes[5][11][8] = int_stack + 124950;
 Libderiv->deriv_classes[6][6][8] = int_stack + 126588;
 Libderiv->deriv_classes[6][7][8] = int_stack + 127372;
 Libderiv->deriv_classes[6][8][8] = int_stack + 128380;
 Libderiv->deriv_classes[6][9][8] = int_stack + 129640;
 Libderiv->deriv_classes[6][10][8] = int_stack + 131180;
 Libderiv->deriv_classes[6][11][8] = int_stack + 133028;
 Libderiv->deriv_classes[7][6][8] = int_stack + 135212;
 Libderiv->deriv_classes[7][7][8] = int_stack + 136220;
 Libderiv->deriv_classes[7][8][8] = int_stack + 137516;
 Libderiv->deriv_classes[7][9][8] = int_stack + 139136;
 Libderiv->deriv_classes[7][10][8] = int_stack + 141116;
 Libderiv->deriv_classes[7][11][8] = int_stack + 143492;
 Libderiv->deriv_classes[8][6][8] = int_stack + 146300;
 Libderiv->deriv_classes[8][7][8] = int_stack + 147560;
 Libderiv->deriv_classes[8][8][8] = int_stack + 149180;
 Libderiv->deriv_classes[8][9][8] = int_stack + 151205;
 Libderiv->deriv_classes[8][10][8] = int_stack + 153680;
 Libderiv->deriv_classes[8][11][8] = int_stack + 156650;
 Libderiv->deriv_classes[5][6][7] = int_stack + 160160;
 Libderiv->deriv_classes[5][7][7] = int_stack + 160748;
 Libderiv->deriv_classes[5][8][7] = int_stack + 161504;
 Libderiv->deriv_classes[5][9][7] = int_stack + 162449;
 Libderiv->deriv_classes[5][10][7] = int_stack + 163604;
 Libderiv->deriv_classes[5][11][7] = int_stack + 164990;
 Libderiv->deriv_classes[6][6][7] = int_stack + 166628;
 Libderiv->deriv_classes[6][7][7] = int_stack + 167412;
 Libderiv->deriv_classes[6][8][7] = int_stack + 168420;
 Libderiv->deriv_classes[6][9][7] = int_stack + 169680;
 Libderiv->deriv_classes[6][10][7] = int_stack + 171220;
 Libderiv->deriv_classes[6][11][7] = int_stack + 173068;
 Libderiv->deriv_classes[7][6][7] = int_stack + 175252;
 Libderiv->deriv_classes[7][7][7] = int_stack + 176260;
 Libderiv->deriv_classes[7][8][7] = int_stack + 177556;
 Libderiv->deriv_classes[7][9][7] = int_stack + 179176;
 Libderiv->deriv_classes[7][10][7] = int_stack + 181156;
 Libderiv->deriv_classes[7][11][7] = int_stack + 183532;
 Libderiv->deriv_classes[8][6][7] = int_stack + 186340;
 Libderiv->deriv_classes[8][7][7] = int_stack + 187600;
 Libderiv->deriv_classes[8][8][7] = int_stack + 189220;
 Libderiv->deriv_classes[8][9][7] = int_stack + 191245;
 Libderiv->deriv_classes[8][10][7] = int_stack + 193720;
 Libderiv->deriv_classes[8][11][7] = int_stack + 196690;
 Libderiv->deriv_classes[5][6][6] = int_stack + 200200;
 Libderiv->deriv_classes[5][7][6] = int_stack + 200788;
 Libderiv->deriv_classes[5][8][6] = int_stack + 201544;
 Libderiv->deriv_classes[5][9][6] = int_stack + 202489;
 Libderiv->deriv_classes[5][10][6] = int_stack + 203644;
 Libderiv->deriv_classes[5][11][6] = int_stack + 205030;
 Libderiv->deriv_classes[6][6][6] = int_stack + 206668;
 Libderiv->deriv_classes[6][7][6] = int_stack + 207452;
 Libderiv->deriv_classes[6][8][6] = int_stack + 208460;
 Libderiv->deriv_classes[6][9][6] = int_stack + 209720;
 Libderiv->deriv_classes[6][10][6] = int_stack + 211260;
 Libderiv->deriv_classes[6][11][6] = int_stack + 213108;
 Libderiv->deriv_classes[7][6][6] = int_stack + 215292;
 Libderiv->deriv_classes[7][7][6] = int_stack + 216300;
 Libderiv->deriv_classes[7][8][6] = int_stack + 217596;
 Libderiv->deriv_classes[7][9][6] = int_stack + 219216;
 Libderiv->deriv_classes[7][10][6] = int_stack + 221196;
 Libderiv->deriv_classes[7][11][6] = int_stack + 223572;
 Libderiv->dvrr_classes[8][6] = int_stack + 226380;
 Libderiv->deriv_classes[8][6][6] = int_stack + 227640;
 Libderiv->dvrr_classes[8][7] = int_stack + 228900;
 Libderiv->deriv_classes[8][7][6] = int_stack + 230520;
 Libderiv->dvrr_classes[8][8] = int_stack + 232140;
 Libderiv->deriv_classes[8][8][6] = int_stack + 234165;
 Libderiv->dvrr_classes[8][9] = int_stack + 236190;
 Libderiv->deriv_classes[8][9][6] = int_stack + 238665;
 Libderiv->dvrr_classes[8][10] = int_stack + 241140;
 Libderiv->deriv_classes[8][10][6] = int_stack + 244110;
 Libderiv->deriv_classes[8][11][6] = int_stack + 247080;
 Libderiv->deriv_classes[5][6][2] = int_stack + 250590;
 Libderiv->deriv_classes[5][7][2] = int_stack + 251178;
 Libderiv->deriv_classes[5][8][2] = int_stack + 251934;
 Libderiv->deriv_classes[5][9][2] = int_stack + 252879;
 Libderiv->deriv_classes[5][10][2] = int_stack + 254034;
 Libderiv->deriv_classes[5][11][2] = int_stack + 255420;
 Libderiv->deriv_classes[6][6][2] = int_stack + 257058;
 Libderiv->deriv_classes[6][7][2] = int_stack + 257842;
 Libderiv->deriv_classes[6][8][2] = int_stack + 258850;
 Libderiv->deriv_classes[6][9][2] = int_stack + 260110;
 Libderiv->deriv_classes[6][10][2] = int_stack + 261650;
 Libderiv->deriv_classes[6][11][2] = int_stack + 263498;
 Libderiv->deriv_classes[7][6][2] = int_stack + 265682;
 Libderiv->deriv_classes[7][7][2] = int_stack + 266690;
 Libderiv->deriv_classes[7][8][2] = int_stack + 267986;
 Libderiv->deriv_classes[7][9][2] = int_stack + 269606;
 Libderiv->deriv_classes[7][10][2] = int_stack + 271586;
 Libderiv->deriv_classes[7][11][2] = int_stack + 273962;
 Libderiv->deriv_classes[8][6][2] = int_stack + 276770;
 Libderiv->deriv_classes[8][7][2] = int_stack + 278030;
 Libderiv->deriv_classes[8][8][2] = int_stack + 279650;
 Libderiv->deriv_classes[8][9][2] = int_stack + 281675;
 Libderiv->deriv_classes[8][10][2] = int_stack + 284150;
 Libderiv->deriv_classes[8][11][2] = int_stack + 287120;
 Libderiv->deriv_classes[5][6][1] = int_stack + 290630;
 Libderiv->deriv_classes[5][7][1] = int_stack + 291218;
 Libderiv->deriv_classes[5][8][1] = int_stack + 291974;
 Libderiv->deriv_classes[5][9][1] = int_stack + 292919;
 Libderiv->deriv_classes[5][10][1] = int_stack + 294074;
 Libderiv->deriv_classes[5][11][1] = int_stack + 295460;
 Libderiv->deriv_classes[6][6][1] = int_stack + 297098;
 Libderiv->deriv_classes[6][7][1] = int_stack + 297882;
 Libderiv->deriv_classes[6][8][1] = int_stack + 298890;
 Libderiv->deriv_classes[6][9][1] = int_stack + 300150;
 Libderiv->deriv_classes[6][10][1] = int_stack + 301690;
 Libderiv->deriv_classes[6][11][1] = int_stack + 303538;
 Libderiv->deriv_classes[7][6][1] = int_stack + 305722;
 Libderiv->deriv_classes[7][7][1] = int_stack + 306730;
 Libderiv->deriv_classes[7][8][1] = int_stack + 308026;
 Libderiv->deriv_classes[7][9][1] = int_stack + 309646;
 Libderiv->deriv_classes[7][10][1] = int_stack + 311626;
 Libderiv->deriv_classes[7][11][1] = int_stack + 314002;
 Libderiv->deriv_classes[8][6][1] = int_stack + 316810;
 Libderiv->deriv_classes[8][7][1] = int_stack + 318070;
 Libderiv->deriv_classes[8][8][1] = int_stack + 319690;
 Libderiv->deriv_classes[8][9][1] = int_stack + 321715;
 Libderiv->deriv_classes[8][10][1] = int_stack + 324190;
 Libderiv->deriv_classes[8][11][1] = int_stack + 327160;
 Libderiv->dvrr_classes[5][6] = int_stack + 330670;
 Libderiv->dvrr_classes[5][7] = int_stack + 331258;
 Libderiv->dvrr_classes[5][8] = int_stack + 332014;
 Libderiv->dvrr_classes[5][9] = int_stack + 332959;
 Libderiv->dvrr_classes[5][10] = int_stack + 334114;
 Libderiv->dvrr_classes[5][11] = int_stack + 335500;
 Libderiv->deriv_classes[5][6][0] = int_stack + 337138;
 Libderiv->deriv_classes[5][7][0] = int_stack + 337726;
 Libderiv->deriv_classes[5][8][0] = int_stack + 338482;
 Libderiv->deriv_classes[5][9][0] = int_stack + 339427;
 Libderiv->deriv_classes[5][10][0] = int_stack + 340582;
 Libderiv->deriv_classes[5][11][0] = int_stack + 341968;
 Libderiv->dvrr_classes[6][6] = int_stack + 343606;
 Libderiv->dvrr_classes[6][7] = int_stack + 344390;
 Libderiv->dvrr_classes[6][8] = int_stack + 345398;
 Libderiv->dvrr_classes[6][9] = int_stack + 346658;
 Libderiv->dvrr_classes[6][10] = int_stack + 348198;
 Libderiv->dvrr_classes[6][11] = int_stack + 350046;
 Libderiv->deriv_classes[6][6][0] = int_stack + 352230;
 Libderiv->deriv_classes[6][7][0] = int_stack + 353014;
 Libderiv->deriv_classes[6][8][0] = int_stack + 354022;
 Libderiv->deriv_classes[6][9][0] = int_stack + 355282;
 Libderiv->deriv_classes[6][10][0] = int_stack + 356822;
 Libderiv->deriv_classes[6][11][0] = int_stack + 358670;
 Libderiv->dvrr_classes[7][6] = int_stack + 360854;
 Libderiv->dvrr_classes[7][7] = int_stack + 361862;
 Libderiv->dvrr_classes[7][8] = int_stack + 363158;
 Libderiv->dvrr_classes[7][9] = int_stack + 364778;
 Libderiv->dvrr_classes[7][10] = int_stack + 366758;
 Libderiv->dvrr_classes[7][11] = int_stack + 369134;
 Libderiv->deriv_classes[7][6][0] = int_stack + 371942;
 Libderiv->deriv_classes[7][7][0] = int_stack + 372950;
 Libderiv->deriv_classes[7][8][0] = int_stack + 374246;
 Libderiv->deriv_classes[7][9][0] = int_stack + 375866;
 Libderiv->deriv_classes[7][10][0] = int_stack + 377846;
 Libderiv->deriv_classes[7][11][0] = int_stack + 380222;
 Libderiv->deriv_classes[8][6][0] = int_stack + 383030;
 Libderiv->deriv_classes[8][7][0] = int_stack + 384290;
 Libderiv->deriv_classes[8][8][0] = int_stack + 385910;
 Libderiv->deriv_classes[8][9][0] = int_stack + 387935;
 Libderiv->deriv_classes[8][10][0] = int_stack + 390410;
 Libderiv->deriv_classes[8][11][0] = int_stack + 393380;
 memset(int_stack,0,3175120);

 Libderiv->dvrr_stack = int_stack + 2154633;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hfih(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+396890,int_stack+331258,int_stack+330670,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+398654,int_stack+332014,int_stack+331258,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+400922,int_stack+398654,int_stack+396890,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+404450,int_stack+332959,int_stack+332014,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+407285,int_stack+404450,int_stack+398654,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+411821,int_stack+407285,int_stack+400922,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+417701,int_stack+334114,int_stack+332959,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+421166,int_stack+417701,int_stack+404450,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+426836,int_stack+421166,int_stack+407285,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+434396,int_stack+426836,int_stack+411821,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+443216,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330670,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+444980,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331258,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+447248,int_stack+444980,int_stack+443216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396890,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+450776,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332014,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+453611,int_stack+450776,int_stack+444980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398654,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+458147,int_stack+453611,int_stack+447248, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400922,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+443216,int_stack+3444,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332959,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+464027,int_stack+443216,int_stack+450776, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404450,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+469697,int_stack+464027,int_stack+453611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407285,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+446681,int_stack+469697,int_stack+458147, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411821,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+455501,int_stack+4830,int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334114,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+477257,int_stack+455501,int_stack+443216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417701,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+484187,int_stack+477257,int_stack+464027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421166,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+455501,int_stack+484187,int_stack+469697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426836,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+466841,int_stack+455501,int_stack+446681, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434396,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+443216,int_stack+344390,int_stack+343606,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+445568,int_stack+345398,int_stack+344390,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+448592,int_stack+445568,int_stack+443216,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+453296,int_stack+346658,int_stack+345398,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+457076,int_stack+453296,int_stack+445568,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+479189,int_stack+457076,int_stack+448592,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+487029,int_stack+348198,int_stack+346658,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+491649,int_stack+487029,int_stack+453296,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+499209,int_stack+491649,int_stack+457076,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+509289,int_stack+499209,int_stack+479189,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+463124,int_stack+7252,int_stack+6468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343606,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+0,int_stack+8260,int_stack+7252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344390,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+3024,int_stack+0,int_stack+463124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443216,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+521049,int_stack+9520,int_stack+8260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345398,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+524829,int_stack+521049,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445568,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+530877,int_stack+524829,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448592,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+11060,int_stack+9520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346658,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+538717,int_stack+0,int_stack+521049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453296,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+546277,int_stack+538717,int_stack+524829, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457076,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+556357,int_stack+546277,int_stack+530877, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479189,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+521049,int_stack+12908,int_stack+11060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348198,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+526593,int_stack+521049,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487029,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+0,int_stack+526593,int_stack+538717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491649,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+521049,int_stack+0,int_stack+546277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499209,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+536169,int_stack+521049,int_stack+556357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509289,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+552633,int_stack+536169,int_stack+466841,588);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+521049,int_stack+361862,int_stack+360854,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+524073,int_stack+363158,int_stack+361862,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+527961,int_stack+524073,int_stack+521049,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+364778,int_stack+363158,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+4860,int_stack+0,int_stack+524073,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+463124,int_stack+4860,int_stack+527961,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+473204,int_stack+366758,int_stack+364778,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+589677,int_stack+473204,int_stack+0,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+599397,int_stack+589677,int_stack+4860,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+612357,int_stack+599397,int_stack+463124,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+627477,int_stack+16100,int_stack+15092, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360854,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+630501,int_stack+17396,int_stack+16100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361862,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+634389,int_stack+630501,int_stack+627477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521049,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+640437,int_stack+19016,int_stack+17396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363158,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+645297,int_stack+640437,int_stack+630501, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524073,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+653073,int_stack+645297,int_stack+634389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527961,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+627477,int_stack+20996,int_stack+19016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364778,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+663153,int_stack+627477,int_stack+640437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+672873,int_stack+663153,int_stack+645297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4860,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+633417,int_stack+672873,int_stack+653073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+463124,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+648537,int_stack+23372,int_stack+20996, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366758,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+12636,int_stack+648537,int_stack+627477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473204,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+685833,int_stack+12636,int_stack+663153, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589677,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+648537,int_stack+685833,int_stack+672873, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599397,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+667977,int_stack+648537,int_stack+633417, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612357,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+689145,int_stack+667977,int_stack+536169,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+738537,int_stack+689145,int_stack+552633,588);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+12636,int_stack+228900,int_stack+226380,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+16416,int_stack+232140,int_stack+228900,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+627477,int_stack+16416,int_stack+12636,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+635037,int_stack+236190,int_stack+232140,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+641112,int_stack+635037,int_stack+16416,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+650832,int_stack+641112,int_stack+627477,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+534009,int_stack+241140,int_stack+236190,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+541434,int_stack+534009,int_stack+635037,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+553584,int_stack+541434,int_stack+641112,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+569784,int_stack+553584,int_stack+650832,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+21276,int_stack+27440,int_stack+26180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226380,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+812625,int_stack+29060,int_stack+27440, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228900,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+817485,int_stack+812625,int_stack+21276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+21276,int_stack+31085,int_stack+29060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232140,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+825045,int_stack+21276,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16416,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+834765,int_stack+825045,int_stack+817485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+627477,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+33560,int_stack+31085, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236190,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+847365,int_stack+812625,int_stack+21276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635037,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+859515,int_stack+847365,int_stack+825045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641112,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+875715,int_stack+859515,int_stack+834765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650832,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+21276,int_stack+36530,int_stack+33560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241140,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+820050,int_stack+21276,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534009,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+894615,int_stack+820050,int_stack+847365, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541434,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+812625,int_stack+894615,int_stack+859515, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553584,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+836925,int_stack+812625,int_stack+875715, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569784,45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+863385,int_stack+836925,int_stack+667977,588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+926889,int_stack+863385,int_stack+689145,588);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+40628,int_stack+40040, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330670, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814389,int_stack+41384,int_stack+40628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331258, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+816657,int_stack+814389,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396890, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+820185,int_stack+42329,int_stack+41384, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332014, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+823020,int_stack+820185,int_stack+814389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398654, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+827556,int_stack+823020,int_stack+816657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400922, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+43484,int_stack+42329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332959, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+833436,int_stack+812625,int_stack+820185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404450, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+839106,int_stack+833436,int_stack+823020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407285, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+816090,int_stack+839106,int_stack+827556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411821, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+824910,int_stack+44870,int_stack+43484, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334114, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+846666,int_stack+824910,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417701, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+853596,int_stack+846666,int_stack+833436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421166, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+824910,int_stack+853596,int_stack+839106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426836, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+836250,int_stack+824910,int_stack+816090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434396, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+47292,int_stack+46508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343606, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814977,int_stack+48300,int_stack+47292, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344390, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+818001,int_stack+814977,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443216, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+822705,int_stack+49560,int_stack+48300, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345398, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+826485,int_stack+822705,int_stack+814977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445568, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+848598,int_stack+826485,int_stack+818001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448592, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+51100,int_stack+49560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346658, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+856438,int_stack+812625,int_stack+822705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453296, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+863998,int_stack+856438,int_stack+826485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457076, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+817245,int_stack+863998,int_stack+848598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479189, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+848598,int_stack+52948,int_stack+51100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348198, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+874078,int_stack+848598,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487029, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+883318,int_stack+874078,int_stack+856438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491649, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+848598,int_stack+883318,int_stack+863998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499209, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+863718,int_stack+848598,int_stack+817245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509289, 0.0, zero_stack,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+880182,int_stack+863718,int_stack+836250,588);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+56140,int_stack+55132, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360854, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815649,int_stack+57436,int_stack+56140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361862, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+819537,int_stack+815649,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521049, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825585,int_stack+59056,int_stack+57436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363158, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+830445,int_stack+825585,int_stack+815649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524073, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+838221,int_stack+830445,int_stack+819537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527961, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+61036,int_stack+59056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364778, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+848301,int_stack+812625,int_stack+825585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+21276,int_stack+848301,int_stack+830445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4860, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+818565,int_stack+21276,int_stack+838221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+463124, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+833685,int_stack+63412,int_stack+61036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366758, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+34236,int_stack+833685,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473204, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+46116,int_stack+34236,int_stack+848301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589677, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+833685,int_stack+46116,int_stack+21276, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599397, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+21276,int_stack+833685,int_stack+818565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612357, 0.0, zero_stack,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+812625,int_stack+21276,int_stack+863718,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+663432,int_stack+812625,int_stack+880182,588);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+42444,int_stack+67480,int_stack+66220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226380, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+46224,int_stack+69100,int_stack+67480, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228900, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+51084,int_stack+46224,int_stack+42444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+58644,int_stack+71125,int_stack+69100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232140, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+862017,int_stack+58644,int_stack+46224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16416, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+871737,int_stack+862017,int_stack+51084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+627477, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+42444,int_stack+73600,int_stack+71125, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236190, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+884337,int_stack+42444,int_stack+58644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635037, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+49869,int_stack+884337,int_stack+862017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641112, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+896487,int_stack+49869,int_stack+871737, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650832, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+862017,int_stack+76570,int_stack+73600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241140, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1025673,int_stack+862017,int_stack+42444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534009, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+862017,int_stack+1025673,int_stack+884337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541434, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1025673,int_stack+862017,int_stack+49869, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553584, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+862017,int_stack+1025673,int_stack+896487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569784, 0.0, zero_stack,45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1025673,int_stack+862017,int_stack+21276,588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1089177,int_stack+1025673,int_stack+812625,588);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+80668,int_stack+80080, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330670, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814389,int_stack+81424,int_stack+80668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331258, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+816657,int_stack+814389,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+820185,int_stack+82369,int_stack+81424, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332014, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+823020,int_stack+820185,int_stack+814389, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398654, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+827556,int_stack+823020,int_stack+816657, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400922, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+83524,int_stack+82369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332959, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+833436,int_stack+812625,int_stack+820185, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404450, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+839106,int_stack+833436,int_stack+823020, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407285, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+816090,int_stack+839106,int_stack+827556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411821, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+824910,int_stack+84910,int_stack+83524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334114, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+846666,int_stack+824910,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417701, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+853596,int_stack+846666,int_stack+833436, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421166, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+824910,int_stack+853596,int_stack+839106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426836, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+836250,int_stack+824910,int_stack+816090, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434396, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+87332,int_stack+86548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343606, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814977,int_stack+88340,int_stack+87332, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344390, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+818001,int_stack+814977,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443216, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+822705,int_stack+89600,int_stack+88340, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345398, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+826485,int_stack+822705,int_stack+814977, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445568, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+848598,int_stack+826485,int_stack+818001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448592, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+91140,int_stack+89600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346658, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+856438,int_stack+812625,int_stack+822705, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453296, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+863998,int_stack+856438,int_stack+826485, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457076, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+817245,int_stack+863998,int_stack+848598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479189, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+848598,int_stack+92988,int_stack+91140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348198, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+874078,int_stack+848598,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487029, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+883318,int_stack+874078,int_stack+856438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491649, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+848598,int_stack+883318,int_stack+863998, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499209, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+863718,int_stack+848598,int_stack+817245, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509289, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+880182,int_stack+863718,int_stack+836250,588);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+96180,int_stack+95172, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360854, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815649,int_stack+97476,int_stack+96180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361862, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+819537,int_stack+815649,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521049, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825585,int_stack+99096,int_stack+97476, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363158, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+830445,int_stack+825585,int_stack+815649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524073, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+838221,int_stack+830445,int_stack+819537, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527961, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+101076,int_stack+99096, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364778, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+848301,int_stack+812625,int_stack+825585, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1025673,int_stack+848301,int_stack+830445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+818565,int_stack+1025673,int_stack+838221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+463124, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+833685,int_stack+103452,int_stack+101076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366758, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1038633,int_stack+833685,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473204, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1050513,int_stack+1038633,int_stack+848301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589677, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+833685,int_stack+1050513,int_stack+1025673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599397, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1025673,int_stack+833685,int_stack+818565, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612357, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+812625,int_stack+1025673,int_stack+863718,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+21276,int_stack+812625,int_stack+880182,588);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1046841,int_stack+107520,int_stack+106260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226380, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1050621,int_stack+109140,int_stack+107520, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228900, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1055481,int_stack+1050621,int_stack+1046841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1063041,int_stack+111165,int_stack+109140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232140, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069116,int_stack+1063041,int_stack+1050621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16416, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+862017,int_stack+1069116,int_stack+1055481, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+627477, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1046841,int_stack+113640,int_stack+111165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236190, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+874617,int_stack+1046841,int_stack+1063041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635037, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+886767,int_stack+874617,int_stack+1069116, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641112, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1054266,int_stack+886767,int_stack+862017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650832, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+862017,int_stack+116610,int_stack+113640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241140, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1073166,int_stack+862017,int_stack+1046841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534009, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+902967,int_stack+1073166,int_stack+874617, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541434, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+862017,int_stack+902967,int_stack+886767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553584, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+886317,int_stack+862017,int_stack+1054266, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569784, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1187961,int_stack+886317,int_stack+1025673,588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1251465,int_stack+1187961,int_stack+812625,588);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+120708,int_stack+120120, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+330670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814389,int_stack+121464,int_stack+120708, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+331258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+816657,int_stack+814389,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+820185,int_stack+122409,int_stack+121464, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+823020,int_stack+820185,int_stack+814389, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+398654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+827556,int_stack+823020,int_stack+816657, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+400922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+123564,int_stack+122409, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+833436,int_stack+812625,int_stack+820185, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+404450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+839106,int_stack+833436,int_stack+823020, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+407285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+816090,int_stack+839106,int_stack+827556, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+411821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+824910,int_stack+124950,int_stack+123564, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+334114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+846666,int_stack+824910,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+417701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+853596,int_stack+846666,int_stack+833436, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+421166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+824910,int_stack+853596,int_stack+839106, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+426836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+836250,int_stack+824910,int_stack+816090, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+434396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+127372,int_stack+126588, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+343606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814977,int_stack+128380,int_stack+127372, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+344390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+818001,int_stack+814977,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+443216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+822705,int_stack+129640,int_stack+128380, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+345398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+826485,int_stack+822705,int_stack+814977, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+848598,int_stack+826485,int_stack+818001, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+131180,int_stack+129640, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+856438,int_stack+812625,int_stack+822705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+453296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+863998,int_stack+856438,int_stack+826485, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+457076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+817245,int_stack+863998,int_stack+848598, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+479189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+848598,int_stack+133028,int_stack+131180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+348198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+874078,int_stack+848598,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+487029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+883318,int_stack+874078,int_stack+856438, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+848598,int_stack+883318,int_stack+863998, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+499209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+863718,int_stack+848598,int_stack+817245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+509289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+880182,int_stack+863718,int_stack+836250,588);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+136220,int_stack+135212, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+360854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815649,int_stack+137516,int_stack+136220, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+361862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+819537,int_stack+815649,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+521049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825585,int_stack+139136,int_stack+137516, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+363158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+830445,int_stack+825585,int_stack+815649, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+524073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+838221,int_stack+830445,int_stack+819537, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+527961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+141116,int_stack+139136, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+364778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+848301,int_stack+812625,int_stack+825585, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1187961,int_stack+848301,int_stack+830445, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+818565,int_stack+1187961,int_stack+838221, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+463124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+833685,int_stack+143492,int_stack+141116, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+366758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1200921,int_stack+833685,int_stack+812625, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1212801,int_stack+1200921,int_stack+848301, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+589677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+833685,int_stack+1212801,int_stack+1187961, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+599397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1187961,int_stack+833685,int_stack+818565, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+612357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+812625,int_stack+1187961,int_stack+863718,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1350249,int_stack+812625,int_stack+880182,588);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1209129,int_stack+147560,int_stack+146300, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+226380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1212909,int_stack+149180,int_stack+147560, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+228900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1217769,int_stack+1212909,int_stack+1209129, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1225329,int_stack+151205,int_stack+149180, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+232140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1231404,int_stack+1225329,int_stack+1212909, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+16416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+862017,int_stack+1231404,int_stack+1217769, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+627477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1209129,int_stack+153680,int_stack+151205, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+236190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+874617,int_stack+1209129,int_stack+1225329, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+635037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+886767,int_stack+874617,int_stack+1231404, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+641112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1216554,int_stack+886767,int_stack+862017, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+862017,int_stack+156650,int_stack+153680, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+241140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1235454,int_stack+862017,int_stack+1209129, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+534009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+902967,int_stack+1235454,int_stack+874617, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+541434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+862017,int_stack+902967,int_stack+886767, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+553584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+886317,int_stack+862017,int_stack+1216554, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+569784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1025673,int_stack+886317,int_stack+1187961,588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1424337,int_stack+1025673,int_stack+812625,588);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+160748,int_stack+160160, 0.0, zero_stack, 1.0, int_stack+330670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814389,int_stack+161504,int_stack+160748, 0.0, zero_stack, 1.0, int_stack+331258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+816657,int_stack+814389,int_stack+812625, 0.0, zero_stack, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+820185,int_stack+162449,int_stack+161504, 0.0, zero_stack, 1.0, int_stack+332014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+823020,int_stack+820185,int_stack+814389, 0.0, zero_stack, 1.0, int_stack+398654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+827556,int_stack+823020,int_stack+816657, 0.0, zero_stack, 1.0, int_stack+400922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+163604,int_stack+162449, 0.0, zero_stack, 1.0, int_stack+332959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+833436,int_stack+812625,int_stack+820185, 0.0, zero_stack, 1.0, int_stack+404450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+839106,int_stack+833436,int_stack+823020, 0.0, zero_stack, 1.0, int_stack+407285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+816090,int_stack+839106,int_stack+827556, 0.0, zero_stack, 1.0, int_stack+411821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+824910,int_stack+164990,int_stack+163604, 0.0, zero_stack, 1.0, int_stack+334114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+846666,int_stack+824910,int_stack+812625, 0.0, zero_stack, 1.0, int_stack+417701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+853596,int_stack+846666,int_stack+833436, 0.0, zero_stack, 1.0, int_stack+421166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+824910,int_stack+853596,int_stack+839106, 0.0, zero_stack, 1.0, int_stack+426836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+836250,int_stack+824910,int_stack+816090, 0.0, zero_stack, 1.0, int_stack+434396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+167412,int_stack+166628, 0.0, zero_stack, 1.0, int_stack+343606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814977,int_stack+168420,int_stack+167412, 0.0, zero_stack, 1.0, int_stack+344390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+818001,int_stack+814977,int_stack+812625, 0.0, zero_stack, 1.0, int_stack+443216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+822705,int_stack+169680,int_stack+168420, 0.0, zero_stack, 1.0, int_stack+345398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+826485,int_stack+822705,int_stack+814977, 0.0, zero_stack, 1.0, int_stack+445568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+848598,int_stack+826485,int_stack+818001, 0.0, zero_stack, 1.0, int_stack+448592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+171220,int_stack+169680, 0.0, zero_stack, 1.0, int_stack+346658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+856438,int_stack+812625,int_stack+822705, 0.0, zero_stack, 1.0, int_stack+453296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+863998,int_stack+856438,int_stack+826485, 0.0, zero_stack, 1.0, int_stack+457076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+817245,int_stack+863998,int_stack+848598, 0.0, zero_stack, 1.0, int_stack+479189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+848598,int_stack+173068,int_stack+171220, 0.0, zero_stack, 1.0, int_stack+348198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+874078,int_stack+848598,int_stack+812625, 0.0, zero_stack, 1.0, int_stack+487029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+883318,int_stack+874078,int_stack+856438, 0.0, zero_stack, 1.0, int_stack+491649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+848598,int_stack+883318,int_stack+863998, 0.0, zero_stack, 1.0, int_stack+499209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+863718,int_stack+848598,int_stack+817245, 0.0, zero_stack, 1.0, int_stack+509289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+880182,int_stack+863718,int_stack+836250,588);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+176260,int_stack+175252, 0.0, zero_stack, 1.0, int_stack+360854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815649,int_stack+177556,int_stack+176260, 0.0, zero_stack, 1.0, int_stack+361862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+819537,int_stack+815649,int_stack+812625, 0.0, zero_stack, 1.0, int_stack+521049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825585,int_stack+179176,int_stack+177556, 0.0, zero_stack, 1.0, int_stack+363158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+830445,int_stack+825585,int_stack+815649, 0.0, zero_stack, 1.0, int_stack+524073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+838221,int_stack+830445,int_stack+819537, 0.0, zero_stack, 1.0, int_stack+527961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+812625,int_stack+181156,int_stack+179176, 0.0, zero_stack, 1.0, int_stack+364778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+848301,int_stack+812625,int_stack+825585, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1025673,int_stack+848301,int_stack+830445, 0.0, zero_stack, 1.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+818565,int_stack+1025673,int_stack+838221, 0.0, zero_stack, 1.0, int_stack+463124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+833685,int_stack+183532,int_stack+181156, 0.0, zero_stack, 1.0, int_stack+366758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1038633,int_stack+833685,int_stack+812625, 0.0, zero_stack, 1.0, int_stack+473204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1050513,int_stack+1038633,int_stack+848301, 0.0, zero_stack, 1.0, int_stack+589677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+833685,int_stack+1050513,int_stack+1025673, 0.0, zero_stack, 1.0, int_stack+599397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1025673,int_stack+833685,int_stack+818565, 0.0, zero_stack, 1.0, int_stack+612357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+812625,int_stack+1025673,int_stack+863718,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+95364,int_stack+812625,int_stack+880182,588);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1046841,int_stack+187600,int_stack+186340, 0.0, zero_stack, 1.0, int_stack+226380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1050621,int_stack+189220,int_stack+187600, 0.0, zero_stack, 1.0, int_stack+228900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1055481,int_stack+1050621,int_stack+1046841, 0.0, zero_stack, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1063041,int_stack+191245,int_stack+189220, 0.0, zero_stack, 1.0, int_stack+232140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1069116,int_stack+1063041,int_stack+1050621, 0.0, zero_stack, 1.0, int_stack+16416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+862017,int_stack+1069116,int_stack+1055481, 0.0, zero_stack, 1.0, int_stack+627477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1046841,int_stack+193720,int_stack+191245, 0.0, zero_stack, 1.0, int_stack+236190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+874617,int_stack+1046841,int_stack+1063041, 0.0, zero_stack, 1.0, int_stack+635037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+886767,int_stack+874617,int_stack+1069116, 0.0, zero_stack, 1.0, int_stack+641112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1054266,int_stack+886767,int_stack+862017, 0.0, zero_stack, 1.0, int_stack+650832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+862017,int_stack+196690,int_stack+193720, 0.0, zero_stack, 1.0, int_stack+241140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1073166,int_stack+862017,int_stack+1046841, 0.0, zero_stack, 1.0, int_stack+534009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+902967,int_stack+1073166,int_stack+874617, 0.0, zero_stack, 1.0, int_stack+541434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+862017,int_stack+902967,int_stack+886767, 0.0, zero_stack, 1.0, int_stack+553584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+886317,int_stack+862017,int_stack+1054266, 0.0, zero_stack, 1.0, int_stack+569784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1187961,int_stack+886317,int_stack+1025673,588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1523121,int_stack+1187961,int_stack+812625,588);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+200788,int_stack+200200, 1.0, int_stack+330670, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814389,int_stack+201544,int_stack+200788, 1.0, int_stack+331258, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+816657,int_stack+814389,int_stack+812625, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+820185,int_stack+202489,int_stack+201544, 1.0, int_stack+332014, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+823020,int_stack+820185,int_stack+814389, 1.0, int_stack+398654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+827556,int_stack+823020,int_stack+816657, 1.0, int_stack+400922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+396890,int_stack+203644,int_stack+202489, 1.0, int_stack+332959, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+812625,int_stack+396890,int_stack+820185, 1.0, int_stack+404450, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+833436,int_stack+812625,int_stack+823020, 1.0, int_stack+407285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+400355,int_stack+833436,int_stack+827556, 1.0, int_stack+411821, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+409175,int_stack+205030,int_stack+203644, 1.0, int_stack+334114, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+818295,int_stack+409175,int_stack+396890, 1.0, int_stack+417701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+840996,int_stack+818295,int_stack+812625, 1.0, int_stack+421166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+812625,int_stack+840996,int_stack+833436, 1.0, int_stack+426836, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+823965,int_stack+812625,int_stack+400355, 1.0, int_stack+434396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+207452,int_stack+206668, 1.0, int_stack+343606, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+814977,int_stack+208460,int_stack+207452, 1.0, int_stack+344390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+818001,int_stack+814977,int_stack+812625, 1.0, int_stack+443216, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+836313,int_stack+209720,int_stack+208460, 1.0, int_stack+345398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+840093,int_stack+836313,int_stack+814977, 1.0, int_stack+445568, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+846141,int_stack+840093,int_stack+818001, 1.0, int_stack+448592, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+443216,int_stack+211260,int_stack+209720, 1.0, int_stack+346658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+812625,int_stack+443216,int_stack+836313, 1.0, int_stack+453296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+853981,int_stack+812625,int_stack+840093, 1.0, int_stack+457076, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+447836,int_stack+853981,int_stack+846141, 1.0, int_stack+479189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+836313,int_stack+213108,int_stack+211260, 1.0, int_stack+348198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+841857,int_stack+836313,int_stack+443216, 1.0, int_stack+487029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+864061,int_stack+841857,int_stack+812625, 1.0, int_stack+491649, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+836313,int_stack+864061,int_stack+853981, 1.0, int_stack+499209, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+851433,int_stack+836313,int_stack+447836, 1.0, int_stack+509289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+867897,int_stack+851433,int_stack+823965,588);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+812625,int_stack+216300,int_stack+215292, 1.0, int_stack+360854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+815649,int_stack+217596,int_stack+216300, 1.0, int_stack+361862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+819537,int_stack+815649,int_stack+812625, 1.0, int_stack+521049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+825585,int_stack+219216,int_stack+217596, 1.0, int_stack+363158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+830445,int_stack+825585,int_stack+815649, 1.0, int_stack+524073, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+838221,int_stack+830445,int_stack+819537, 1.0, int_stack+527961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+521049,int_stack+221196,int_stack+219216, 1.0, int_stack+364778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+812625,int_stack+521049,int_stack+825585, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+443216,int_stack+812625,int_stack+830445, 1.0, int_stack+4860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+822345,int_stack+443216,int_stack+838221, 1.0, int_stack+463124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+0,int_stack+223572,int_stack+221196, 1.0, int_stack+366758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+837465,int_stack+0,int_stack+521049, 1.0, int_stack+473204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+456176,int_stack+837465,int_stack+812625, 1.0, int_stack+589677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+904941,int_stack+456176,int_stack+443216, 1.0, int_stack+599397, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+443216,int_stack+904941,int_stack+822345, 1.0, int_stack+612357, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1187961,int_stack+443216,int_stack+851433,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1621905,int_stack+1187961,int_stack+867897,588);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+464384,int_stack+230520,int_stack+227640, 1.0, int_stack+226380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+468164,int_stack+234165,int_stack+230520, 1.0, int_stack+228900, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+812625,int_stack+468164,int_stack+464384, 1.0, int_stack+12636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+820185,int_stack+238665,int_stack+234165, 1.0, int_stack+232140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+826260,int_stack+820185,int_stack+468164, 1.0, int_stack+16416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+835980,int_stack+826260,int_stack+812625, 1.0, int_stack+627477, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+627477,int_stack+244110,int_stack+238665, 1.0, int_stack+236190, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+848580,int_stack+627477,int_stack+820185, 1.0, int_stack+635037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+860730,int_stack+848580,int_stack+826260, 1.0, int_stack+641112, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+812625,int_stack+860730,int_stack+835980, 1.0, int_stack+650832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+634902,int_stack+247080,int_stack+244110, 1.0, int_stack+241140, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+643812,int_stack+634902,int_stack+627477, 1.0, int_stack+534009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+876930,int_stack+643812,int_stack+848580, 1.0, int_stack+541434, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+627477,int_stack+876930,int_stack+860730, 1.0, int_stack+553584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+831525,int_stack+627477,int_stack+812625, 1.0, int_stack+569784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ih) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1025673,int_stack+831525,int_stack+443216,588);
 /*--- compute (id|ih) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+812625,int_stack+1025673,int_stack+1187961,588);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1187961,int_stack+335500,int_stack+334114,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1192119,int_stack+1187961,int_stack+417701,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1199049,int_stack+1192119,int_stack+421166,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1208499,int_stack+1199049,int_stack+426836,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1187961,int_stack+1208499,int_stack+434396,21);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1200309,int_stack+350046,int_stack+348198,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1205853,int_stack+1200309,int_stack+487029,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1215093,int_stack+1205853,int_stack+491649,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1227693,int_stack+1215093,int_stack+499209,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1200309,int_stack+1227693,int_stack+509289,28);
 /*--- compute (hp|ih) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1025673,int_stack+1200309,int_stack+1187961,588);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1216773,int_stack+369134,int_stack+366758,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1223901,int_stack+1216773,int_stack+473204,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1062717,int_stack+1223901,int_stack+589677,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1216773,int_stack+1062717,int_stack+599397,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1062717,int_stack+1216773,int_stack+612357,36);
 /*--- compute (ip|ih) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+396890,int_stack+1062717,int_stack+1200309,588);
 /*--- compute (hd|ih) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+446282,int_stack+396890,int_stack+1025673,588);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1216773,int_stack+251178,int_stack+250590,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1218537,int_stack+251934,int_stack+251178,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1220805,int_stack+1218537,int_stack+1216773,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1224333,int_stack+252879,int_stack+251934,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1227168,int_stack+1224333,int_stack+1218537,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1231704,int_stack+1227168,int_stack+1220805,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1216773,int_stack+254034,int_stack+252879,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1237584,int_stack+1216773,int_stack+1224333,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1243254,int_stack+1237584,int_stack+1227168,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1220238,int_stack+1243254,int_stack+1231704,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1229058,int_stack+255420,int_stack+254034,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+911409,int_stack+1229058,int_stack+1216773,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+0,int_stack+911409,int_stack+1237584,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+911409,int_stack+0,int_stack+1243254,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+0,int_stack+911409,int_stack+1220238,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+911409,int_stack+257842,int_stack+257058,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+913761,int_stack+258850,int_stack+257842,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+916785,int_stack+913761,int_stack+911409,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+921489,int_stack+260110,int_stack+258850,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12348,int_stack+921489,int_stack+913761,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1216773,int_stack+12348,int_stack+916785,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+911409,int_stack+261650,int_stack+260110,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1224613,int_stack+911409,int_stack+921489,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+916029,int_stack+1224613,int_stack+12348,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1232173,int_stack+916029,int_stack+1216773,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1216773,int_stack+263498,int_stack+261650,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+360854,int_stack+1216773,int_stack+911409,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+520370,int_stack+360854,int_stack+1224613,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1216773,int_stack+520370,int_stack+916029,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+520370,int_stack+1216773,int_stack+1232173,28);
 /*--- compute (hp|ih) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+536834,int_stack+520370,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1187961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+266690,int_stack+265682,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3024,int_stack+267986,int_stack+266690,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+6912,int_stack+3024,int_stack+0,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+12960,int_stack+269606,int_stack+267986,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1216773,int_stack+12960,int_stack+3024,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1224549,int_stack+1216773,int_stack+6912,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+271586,int_stack+269606,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1234629,int_stack+0,int_stack+12960,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+5940,int_stack+1234629,int_stack+1216773,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+573878,int_stack+5940,int_stack+1224549,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1216773,int_stack+273962,int_stack+271586,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+588998,int_stack+1216773,int_stack+0,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1216773,int_stack+588998,int_stack+1234629,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+588998,int_stack+1216773,int_stack+5940,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1216773,int_stack+588998,int_stack+573878,36);
 /*--- compute (ip|ih) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+573878,int_stack+1216773,int_stack+520370, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1200309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (hd|ih) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+169452,int_stack+573878,int_stack+536834, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1025673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+520370,int_stack+278030,int_stack+276770,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+524150,int_stack+279650,int_stack+278030,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+529010,int_stack+524150,int_stack+520370,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+536570,int_stack+281675,int_stack+279650,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+542645,int_stack+536570,int_stack+524150,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+552365,int_stack+542645,int_stack+529010,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+520370,int_stack+284150,int_stack+281675,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+623270,int_stack+520370,int_stack+536570,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+635420,int_stack+623270,int_stack+542645,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+527795,int_stack+635420,int_stack+552365,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+546695,int_stack+287120,int_stack+284150,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+555605,int_stack+546695,int_stack+520370,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+0,int_stack+555605,int_stack+623270,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+546695,int_stack+0,int_stack+635420,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+623270,int_stack+546695,int_stack+527795,45);
 /*--- compute (kp|ih) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+1695993,int_stack+623270,int_stack+1216773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1062717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (id|ih) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1759497,int_stack+1695993,int_stack+573878, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1695993,int_stack+291218,int_stack+290630,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1697757,int_stack+291974,int_stack+291218,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1700025,int_stack+1697757,int_stack+1695993,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1703553,int_stack+292919,int_stack+291974,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1706388,int_stack+1703553,int_stack+1697757,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1710924,int_stack+1706388,int_stack+1700025,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1695993,int_stack+294074,int_stack+292919,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1716804,int_stack+1695993,int_stack+1703553,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1722474,int_stack+1716804,int_stack+1706388,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1699458,int_stack+1722474,int_stack+1710924,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1708278,int_stack+295460,int_stack+294074,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1730034,int_stack+1708278,int_stack+1695993,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1736964,int_stack+1730034,int_stack+1716804,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1708278,int_stack+1736964,int_stack+1722474,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1719618,int_stack+1708278,int_stack+1699458,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1695993,int_stack+297882,int_stack+297098,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1698345,int_stack+298890,int_stack+297882,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1701369,int_stack+1698345,int_stack+1695993,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1706073,int_stack+300150,int_stack+298890,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1709853,int_stack+1706073,int_stack+1698345,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1731966,int_stack+1709853,int_stack+1701369,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1695993,int_stack+301690,int_stack+300150,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1739806,int_stack+1695993,int_stack+1706073,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1747366,int_stack+1739806,int_stack+1709853,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1700613,int_stack+1747366,int_stack+1731966,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1731966,int_stack+303538,int_stack+301690,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1216773,int_stack+1731966,int_stack+1695993,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1226013,int_stack+1216773,int_stack+1739806,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1731966,int_stack+1226013,int_stack+1747366,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1216773,int_stack+1731966,int_stack+1700613,28);
 /*--- compute (hp|ih) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+520370,int_stack+1216773,int_stack+1719618, 0.0, zero_stack, 1.0, int_stack+1187961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1233237,int_stack+306730,int_stack+305722,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1236261,int_stack+308026,int_stack+306730,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1240149,int_stack+1236261,int_stack+1233237,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1246197,int_stack+309646,int_stack+308026,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1695993,int_stack+1246197,int_stack+1236261,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1703769,int_stack+1695993,int_stack+1240149,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1233237,int_stack+311626,int_stack+309646,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1713849,int_stack+1233237,int_stack+1246197,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1723569,int_stack+1713849,int_stack+1695993,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1736529,int_stack+1723569,int_stack+1703769,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1695993,int_stack+314002,int_stack+311626,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1239177,int_stack+1695993,int_stack+1233237,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1695993,int_stack+1239177,int_stack+1713849,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+0,int_stack+1695993,int_stack+1723569,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1695993,int_stack+0,int_stack+1736529,36);
 /*--- compute (ip|ih) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+557414,int_stack+1695993,int_stack+1216773, 0.0, zero_stack, 1.0, int_stack+1200309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (hd|ih) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+1858281,int_stack+557414,int_stack+520370, 0.0, zero_stack, 1.0, int_stack+1025673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+520370,int_stack+318070,int_stack+316810,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+524150,int_stack+319690,int_stack+318070,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+529010,int_stack+524150,int_stack+520370,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+536570,int_stack+321715,int_stack+319690,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+542645,int_stack+536570,int_stack+524150,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1216773,int_stack+542645,int_stack+529010,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+520370,int_stack+324190,int_stack+321715,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1229373,int_stack+520370,int_stack+536570,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+0,int_stack+1229373,int_stack+542645,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+527795,int_stack+0,int_stack+1216773,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1216773,int_stack+327160,int_stack+324190,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1717161,int_stack+1216773,int_stack+520370,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1732011,int_stack+1717161,int_stack+1229373,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1216773,int_stack+1732011,int_stack+0,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1717161,int_stack+1216773,int_stack+527795,45);
 /*--- compute (kp|ih) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+243540,int_stack+1717161,int_stack+1695993, 0.0, zero_stack, 1.0, int_stack+1062717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (id|ih) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1932369,int_stack+243540,int_stack+557414, 0.0, zero_stack, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+243540,int_stack+337726,int_stack+337138,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+245304,int_stack+338482,int_stack+337726,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+247572,int_stack+245304,int_stack+243540,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+251100,int_stack+339427,int_stack+338482,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+253935,int_stack+251100,int_stack+245304,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+258471,int_stack+253935,int_stack+247572,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+243540,int_stack+340582,int_stack+339427,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+264351,int_stack+243540,int_stack+251100,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+270021,int_stack+264351,int_stack+253935,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+247005,int_stack+270021,int_stack+258471,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+255825,int_stack+341968,int_stack+340582,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+277581,int_stack+255825,int_stack+243540,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+284511,int_stack+277581,int_stack+264351,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+255825,int_stack+284511,int_stack+270021,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+267165,int_stack+255825,int_stack+247005,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+243540,int_stack+353014,int_stack+352230,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+245892,int_stack+354022,int_stack+353014,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+248916,int_stack+245892,int_stack+243540,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+253620,int_stack+355282,int_stack+354022,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+257400,int_stack+253620,int_stack+245892,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+279513,int_stack+257400,int_stack+248916,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+243540,int_stack+356822,int_stack+355282,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+287353,int_stack+243540,int_stack+253620,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+294913,int_stack+287353,int_stack+257400,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+248160,int_stack+294913,int_stack+279513,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+279513,int_stack+358670,int_stack+356822,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+304993,int_stack+279513,int_stack+243540,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+314233,int_stack+304993,int_stack+287353,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+279513,int_stack+314233,int_stack+294913,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+294633,int_stack+279513,int_stack+248160,28);
 /*--- compute (hp|ih) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+311097,int_stack+294633,int_stack+267165, 1.0, int_stack+1187961, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1187961,int_stack+372950,int_stack+371942,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1190985,int_stack+374246,int_stack+372950,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+243540,int_stack+1190985,int_stack+1187961,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1194873,int_stack+375866,int_stack+374246,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+249588,int_stack+1194873,int_stack+1190985,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+257364,int_stack+249588,int_stack+243540,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+243540,int_stack+377846,int_stack+375866,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+267444,int_stack+243540,int_stack+1194873,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+277164,int_stack+267444,int_stack+249588,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+348141,int_stack+277164,int_stack+257364,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+249480,int_stack+380222,int_stack+377846,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1187961,int_stack+249480,int_stack+243540,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+243540,int_stack+1187961,int_stack+267444,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+363261,int_stack+243540,int_stack+277164,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+243540,int_stack+363261,int_stack+348141,36);
 /*--- compute (ip|ih) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+1695993,int_stack+243540,int_stack+294633, 1.0, int_stack+1200309, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (hd|ih) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+520370,int_stack+1695993,int_stack+311097, 1.0, int_stack+1025673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1025673,int_stack+384290,int_stack+383030,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1029453,int_stack+385910,int_stack+384290,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1034313,int_stack+1029453,int_stack+1025673,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1041873,int_stack+387935,int_stack+385910,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1047948,int_stack+1041873,int_stack+1029453,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+264708,int_stack+1047948,int_stack+1034313,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1025673,int_stack+390410,int_stack+387935,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+277308,int_stack+1025673,int_stack+1041873,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+289458,int_stack+277308,int_stack+1047948,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1033098,int_stack+289458,int_stack+264708,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+264708,int_stack+393380,int_stack+390410,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+305658,int_stack+264708,int_stack+1025673,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+320508,int_stack+305658,int_stack+277308,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+264708,int_stack+320508,int_stack+289458,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+289008,int_stack+264708,int_stack+1033098,45);
 /*--- compute (kp|ih) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+1187961,int_stack+289008,int_stack+243540, 1.0, int_stack+1062717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (id|ih) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+243540,int_stack+1187961,int_stack+1695993, 1.0, int_stack+396890, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+2031153,int_stack+926889,int_stack+738537,588);
     Libderiv->ABCD[11] = int_stack + 2031153;
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+911409,int_stack+1089177,int_stack+663432,588);
     Libderiv->ABCD[10] = int_stack + 911409;
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+594458,int_stack+1251465,int_stack+21276,588);
     Libderiv->ABCD[9] = int_stack + 594458;
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1034889,int_stack+1424337,int_stack+1350249,588);
     Libderiv->ABCD[8] = int_stack + 1034889;
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1158369,int_stack+1523121,int_stack+95364,588);
     Libderiv->ABCD[7] = int_stack + 1158369;
 /*--- compute (hf|ih) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+0,int_stack+812625,int_stack+1621905,588);
     Libderiv->ABCD[6] = int_stack + 0;
 /*--- compute (hf|ih) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+717938,int_stack+1759497,int_stack+169452, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
     Libderiv->ABCD[2] = int_stack + 717938;
 /*--- compute (hf|ih) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+1281849,int_stack+1932369,int_stack+1858281, 0.0, zero_stack, 1.0, int_stack+446282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
     Libderiv->ABCD[1] = int_stack + 1281849;
 /*--- compute (hf|ih) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+1405329,int_stack+243540,int_stack+520370, 1.0, int_stack+446282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,588);
     Libderiv->ABCD[0] = int_stack + 1405329;

}
