/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_hfii(Libderiv_t *, prim_data *);

  /* Computes derivatives of (hf|ii) integrals */

void d1hrr_order_hfii(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[5][6][11] = int_stack + 0;
 Libderiv->deriv_classes[5][7][11] = int_stack + 588;
 Libderiv->deriv_classes[5][8][11] = int_stack + 1344;
 Libderiv->deriv_classes[5][9][11] = int_stack + 2289;
 Libderiv->deriv_classes[5][10][11] = int_stack + 3444;
 Libderiv->deriv_classes[5][11][11] = int_stack + 4830;
 Libderiv->deriv_classes[5][12][11] = int_stack + 6468;
 Libderiv->deriv_classes[6][6][11] = int_stack + 8379;
 Libderiv->deriv_classes[6][7][11] = int_stack + 9163;
 Libderiv->deriv_classes[6][8][11] = int_stack + 10171;
 Libderiv->deriv_classes[6][9][11] = int_stack + 11431;
 Libderiv->deriv_classes[6][10][11] = int_stack + 12971;
 Libderiv->deriv_classes[6][11][11] = int_stack + 14819;
 Libderiv->deriv_classes[6][12][11] = int_stack + 17003;
 Libderiv->deriv_classes[7][6][11] = int_stack + 19551;
 Libderiv->deriv_classes[7][7][11] = int_stack + 20559;
 Libderiv->deriv_classes[7][8][11] = int_stack + 21855;
 Libderiv->deriv_classes[7][9][11] = int_stack + 23475;
 Libderiv->deriv_classes[7][10][11] = int_stack + 25455;
 Libderiv->deriv_classes[7][11][11] = int_stack + 27831;
 Libderiv->deriv_classes[7][12][11] = int_stack + 30639;
 Libderiv->deriv_classes[8][6][11] = int_stack + 33915;
 Libderiv->deriv_classes[8][7][11] = int_stack + 35175;
 Libderiv->deriv_classes[8][8][11] = int_stack + 36795;
 Libderiv->deriv_classes[8][9][11] = int_stack + 38820;
 Libderiv->deriv_classes[8][10][11] = int_stack + 41295;
 Libderiv->deriv_classes[8][11][11] = int_stack + 44265;
 Libderiv->deriv_classes[8][12][11] = int_stack + 47775;
 Libderiv->deriv_classes[5][6][10] = int_stack + 51870;
 Libderiv->deriv_classes[5][7][10] = int_stack + 52458;
 Libderiv->deriv_classes[5][8][10] = int_stack + 53214;
 Libderiv->deriv_classes[5][9][10] = int_stack + 54159;
 Libderiv->deriv_classes[5][10][10] = int_stack + 55314;
 Libderiv->deriv_classes[5][11][10] = int_stack + 56700;
 Libderiv->deriv_classes[5][12][10] = int_stack + 58338;
 Libderiv->deriv_classes[6][6][10] = int_stack + 60249;
 Libderiv->deriv_classes[6][7][10] = int_stack + 61033;
 Libderiv->deriv_classes[6][8][10] = int_stack + 62041;
 Libderiv->deriv_classes[6][9][10] = int_stack + 63301;
 Libderiv->deriv_classes[6][10][10] = int_stack + 64841;
 Libderiv->deriv_classes[6][11][10] = int_stack + 66689;
 Libderiv->deriv_classes[6][12][10] = int_stack + 68873;
 Libderiv->deriv_classes[7][6][10] = int_stack + 71421;
 Libderiv->deriv_classes[7][7][10] = int_stack + 72429;
 Libderiv->deriv_classes[7][8][10] = int_stack + 73725;
 Libderiv->deriv_classes[7][9][10] = int_stack + 75345;
 Libderiv->deriv_classes[7][10][10] = int_stack + 77325;
 Libderiv->deriv_classes[7][11][10] = int_stack + 79701;
 Libderiv->deriv_classes[7][12][10] = int_stack + 82509;
 Libderiv->deriv_classes[8][6][10] = int_stack + 85785;
 Libderiv->deriv_classes[8][7][10] = int_stack + 87045;
 Libderiv->deriv_classes[8][8][10] = int_stack + 88665;
 Libderiv->deriv_classes[8][9][10] = int_stack + 90690;
 Libderiv->deriv_classes[8][10][10] = int_stack + 93165;
 Libderiv->deriv_classes[8][11][10] = int_stack + 96135;
 Libderiv->deriv_classes[8][12][10] = int_stack + 99645;
 Libderiv->deriv_classes[5][6][9] = int_stack + 103740;
 Libderiv->deriv_classes[5][7][9] = int_stack + 104328;
 Libderiv->deriv_classes[5][8][9] = int_stack + 105084;
 Libderiv->deriv_classes[5][9][9] = int_stack + 106029;
 Libderiv->deriv_classes[5][10][9] = int_stack + 107184;
 Libderiv->deriv_classes[5][11][9] = int_stack + 108570;
 Libderiv->deriv_classes[5][12][9] = int_stack + 110208;
 Libderiv->deriv_classes[6][6][9] = int_stack + 112119;
 Libderiv->deriv_classes[6][7][9] = int_stack + 112903;
 Libderiv->deriv_classes[6][8][9] = int_stack + 113911;
 Libderiv->deriv_classes[6][9][9] = int_stack + 115171;
 Libderiv->deriv_classes[6][10][9] = int_stack + 116711;
 Libderiv->deriv_classes[6][11][9] = int_stack + 118559;
 Libderiv->deriv_classes[6][12][9] = int_stack + 120743;
 Libderiv->deriv_classes[7][6][9] = int_stack + 123291;
 Libderiv->deriv_classes[7][7][9] = int_stack + 124299;
 Libderiv->deriv_classes[7][8][9] = int_stack + 125595;
 Libderiv->deriv_classes[7][9][9] = int_stack + 127215;
 Libderiv->deriv_classes[7][10][9] = int_stack + 129195;
 Libderiv->deriv_classes[7][11][9] = int_stack + 131571;
 Libderiv->deriv_classes[7][12][9] = int_stack + 134379;
 Libderiv->deriv_classes[8][6][9] = int_stack + 137655;
 Libderiv->deriv_classes[8][7][9] = int_stack + 138915;
 Libderiv->deriv_classes[8][8][9] = int_stack + 140535;
 Libderiv->deriv_classes[8][9][9] = int_stack + 142560;
 Libderiv->deriv_classes[8][10][9] = int_stack + 145035;
 Libderiv->deriv_classes[8][11][9] = int_stack + 148005;
 Libderiv->deriv_classes[8][12][9] = int_stack + 151515;
 Libderiv->deriv_classes[5][6][8] = int_stack + 155610;
 Libderiv->deriv_classes[5][7][8] = int_stack + 156198;
 Libderiv->deriv_classes[5][8][8] = int_stack + 156954;
 Libderiv->deriv_classes[5][9][8] = int_stack + 157899;
 Libderiv->deriv_classes[5][10][8] = int_stack + 159054;
 Libderiv->deriv_classes[5][11][8] = int_stack + 160440;
 Libderiv->deriv_classes[5][12][8] = int_stack + 162078;
 Libderiv->deriv_classes[6][6][8] = int_stack + 163989;
 Libderiv->deriv_classes[6][7][8] = int_stack + 164773;
 Libderiv->deriv_classes[6][8][8] = int_stack + 165781;
 Libderiv->deriv_classes[6][9][8] = int_stack + 167041;
 Libderiv->deriv_classes[6][10][8] = int_stack + 168581;
 Libderiv->deriv_classes[6][11][8] = int_stack + 170429;
 Libderiv->deriv_classes[6][12][8] = int_stack + 172613;
 Libderiv->deriv_classes[7][6][8] = int_stack + 175161;
 Libderiv->deriv_classes[7][7][8] = int_stack + 176169;
 Libderiv->deriv_classes[7][8][8] = int_stack + 177465;
 Libderiv->deriv_classes[7][9][8] = int_stack + 179085;
 Libderiv->deriv_classes[7][10][8] = int_stack + 181065;
 Libderiv->deriv_classes[7][11][8] = int_stack + 183441;
 Libderiv->deriv_classes[7][12][8] = int_stack + 186249;
 Libderiv->deriv_classes[8][6][8] = int_stack + 189525;
 Libderiv->deriv_classes[8][7][8] = int_stack + 190785;
 Libderiv->deriv_classes[8][8][8] = int_stack + 192405;
 Libderiv->deriv_classes[8][9][8] = int_stack + 194430;
 Libderiv->deriv_classes[8][10][8] = int_stack + 196905;
 Libderiv->deriv_classes[8][11][8] = int_stack + 199875;
 Libderiv->deriv_classes[8][12][8] = int_stack + 203385;
 Libderiv->deriv_classes[5][6][7] = int_stack + 207480;
 Libderiv->deriv_classes[5][7][7] = int_stack + 208068;
 Libderiv->deriv_classes[5][8][7] = int_stack + 208824;
 Libderiv->deriv_classes[5][9][7] = int_stack + 209769;
 Libderiv->deriv_classes[5][10][7] = int_stack + 210924;
 Libderiv->deriv_classes[5][11][7] = int_stack + 212310;
 Libderiv->deriv_classes[5][12][7] = int_stack + 213948;
 Libderiv->deriv_classes[6][6][7] = int_stack + 215859;
 Libderiv->deriv_classes[6][7][7] = int_stack + 216643;
 Libderiv->deriv_classes[6][8][7] = int_stack + 217651;
 Libderiv->deriv_classes[6][9][7] = int_stack + 218911;
 Libderiv->deriv_classes[6][10][7] = int_stack + 220451;
 Libderiv->deriv_classes[6][11][7] = int_stack + 222299;
 Libderiv->deriv_classes[6][12][7] = int_stack + 224483;
 Libderiv->deriv_classes[7][6][7] = int_stack + 227031;
 Libderiv->deriv_classes[7][7][7] = int_stack + 228039;
 Libderiv->deriv_classes[7][8][7] = int_stack + 229335;
 Libderiv->deriv_classes[7][9][7] = int_stack + 230955;
 Libderiv->deriv_classes[7][10][7] = int_stack + 232935;
 Libderiv->deriv_classes[7][11][7] = int_stack + 235311;
 Libderiv->deriv_classes[7][12][7] = int_stack + 238119;
 Libderiv->deriv_classes[8][6][7] = int_stack + 241395;
 Libderiv->deriv_classes[8][7][7] = int_stack + 242655;
 Libderiv->deriv_classes[8][8][7] = int_stack + 244275;
 Libderiv->deriv_classes[8][9][7] = int_stack + 246300;
 Libderiv->deriv_classes[8][10][7] = int_stack + 248775;
 Libderiv->deriv_classes[8][11][7] = int_stack + 251745;
 Libderiv->deriv_classes[8][12][7] = int_stack + 255255;
 Libderiv->deriv_classes[5][6][6] = int_stack + 259350;
 Libderiv->deriv_classes[5][7][6] = int_stack + 259938;
 Libderiv->deriv_classes[5][8][6] = int_stack + 260694;
 Libderiv->deriv_classes[5][9][6] = int_stack + 261639;
 Libderiv->deriv_classes[5][10][6] = int_stack + 262794;
 Libderiv->deriv_classes[5][11][6] = int_stack + 264180;
 Libderiv->deriv_classes[5][12][6] = int_stack + 265818;
 Libderiv->deriv_classes[6][6][6] = int_stack + 267729;
 Libderiv->deriv_classes[6][7][6] = int_stack + 268513;
 Libderiv->deriv_classes[6][8][6] = int_stack + 269521;
 Libderiv->deriv_classes[6][9][6] = int_stack + 270781;
 Libderiv->deriv_classes[6][10][6] = int_stack + 272321;
 Libderiv->deriv_classes[6][11][6] = int_stack + 274169;
 Libderiv->deriv_classes[6][12][6] = int_stack + 276353;
 Libderiv->deriv_classes[7][6][6] = int_stack + 278901;
 Libderiv->deriv_classes[7][7][6] = int_stack + 279909;
 Libderiv->deriv_classes[7][8][6] = int_stack + 281205;
 Libderiv->deriv_classes[7][9][6] = int_stack + 282825;
 Libderiv->deriv_classes[7][10][6] = int_stack + 284805;
 Libderiv->deriv_classes[7][11][6] = int_stack + 287181;
 Libderiv->deriv_classes[7][12][6] = int_stack + 289989;
 Libderiv->dvrr_classes[8][6] = int_stack + 293265;
 Libderiv->deriv_classes[8][6][6] = int_stack + 294525;
 Libderiv->dvrr_classes[8][7] = int_stack + 295785;
 Libderiv->deriv_classes[8][7][6] = int_stack + 297405;
 Libderiv->dvrr_classes[8][8] = int_stack + 299025;
 Libderiv->deriv_classes[8][8][6] = int_stack + 301050;
 Libderiv->dvrr_classes[8][9] = int_stack + 303075;
 Libderiv->deriv_classes[8][9][6] = int_stack + 305550;
 Libderiv->dvrr_classes[8][10] = int_stack + 308025;
 Libderiv->deriv_classes[8][10][6] = int_stack + 310995;
 Libderiv->dvrr_classes[8][11] = int_stack + 313965;
 Libderiv->deriv_classes[8][11][6] = int_stack + 317475;
 Libderiv->deriv_classes[8][12][6] = int_stack + 320985;
 Libderiv->deriv_classes[5][6][2] = int_stack + 325080;
 Libderiv->deriv_classes[5][7][2] = int_stack + 325668;
 Libderiv->deriv_classes[5][8][2] = int_stack + 326424;
 Libderiv->deriv_classes[5][9][2] = int_stack + 327369;
 Libderiv->deriv_classes[5][10][2] = int_stack + 328524;
 Libderiv->deriv_classes[5][11][2] = int_stack + 329910;
 Libderiv->deriv_classes[5][12][2] = int_stack + 331548;
 Libderiv->deriv_classes[6][6][2] = int_stack + 333459;
 Libderiv->deriv_classes[6][7][2] = int_stack + 334243;
 Libderiv->deriv_classes[6][8][2] = int_stack + 335251;
 Libderiv->deriv_classes[6][9][2] = int_stack + 336511;
 Libderiv->deriv_classes[6][10][2] = int_stack + 338051;
 Libderiv->deriv_classes[6][11][2] = int_stack + 339899;
 Libderiv->deriv_classes[6][12][2] = int_stack + 342083;
 Libderiv->deriv_classes[7][6][2] = int_stack + 344631;
 Libderiv->deriv_classes[7][7][2] = int_stack + 345639;
 Libderiv->deriv_classes[7][8][2] = int_stack + 346935;
 Libderiv->deriv_classes[7][9][2] = int_stack + 348555;
 Libderiv->deriv_classes[7][10][2] = int_stack + 350535;
 Libderiv->deriv_classes[7][11][2] = int_stack + 352911;
 Libderiv->deriv_classes[7][12][2] = int_stack + 355719;
 Libderiv->deriv_classes[8][6][2] = int_stack + 358995;
 Libderiv->deriv_classes[8][7][2] = int_stack + 360255;
 Libderiv->deriv_classes[8][8][2] = int_stack + 361875;
 Libderiv->deriv_classes[8][9][2] = int_stack + 363900;
 Libderiv->deriv_classes[8][10][2] = int_stack + 366375;
 Libderiv->deriv_classes[8][11][2] = int_stack + 369345;
 Libderiv->deriv_classes[8][12][2] = int_stack + 372855;
 Libderiv->deriv_classes[5][6][1] = int_stack + 376950;
 Libderiv->deriv_classes[5][7][1] = int_stack + 377538;
 Libderiv->deriv_classes[5][8][1] = int_stack + 378294;
 Libderiv->deriv_classes[5][9][1] = int_stack + 379239;
 Libderiv->deriv_classes[5][10][1] = int_stack + 380394;
 Libderiv->deriv_classes[5][11][1] = int_stack + 381780;
 Libderiv->deriv_classes[5][12][1] = int_stack + 383418;
 Libderiv->deriv_classes[6][6][1] = int_stack + 385329;
 Libderiv->deriv_classes[6][7][1] = int_stack + 386113;
 Libderiv->deriv_classes[6][8][1] = int_stack + 387121;
 Libderiv->deriv_classes[6][9][1] = int_stack + 388381;
 Libderiv->deriv_classes[6][10][1] = int_stack + 389921;
 Libderiv->deriv_classes[6][11][1] = int_stack + 391769;
 Libderiv->deriv_classes[6][12][1] = int_stack + 393953;
 Libderiv->deriv_classes[7][6][1] = int_stack + 396501;
 Libderiv->deriv_classes[7][7][1] = int_stack + 397509;
 Libderiv->deriv_classes[7][8][1] = int_stack + 398805;
 Libderiv->deriv_classes[7][9][1] = int_stack + 400425;
 Libderiv->deriv_classes[7][10][1] = int_stack + 402405;
 Libderiv->deriv_classes[7][11][1] = int_stack + 404781;
 Libderiv->deriv_classes[7][12][1] = int_stack + 407589;
 Libderiv->deriv_classes[8][6][1] = int_stack + 410865;
 Libderiv->deriv_classes[8][7][1] = int_stack + 412125;
 Libderiv->deriv_classes[8][8][1] = int_stack + 413745;
 Libderiv->deriv_classes[8][9][1] = int_stack + 415770;
 Libderiv->deriv_classes[8][10][1] = int_stack + 418245;
 Libderiv->deriv_classes[8][11][1] = int_stack + 421215;
 Libderiv->deriv_classes[8][12][1] = int_stack + 424725;
 Libderiv->dvrr_classes[5][6] = int_stack + 428820;
 Libderiv->dvrr_classes[5][7] = int_stack + 429408;
 Libderiv->dvrr_classes[5][8] = int_stack + 430164;
 Libderiv->dvrr_classes[5][9] = int_stack + 431109;
 Libderiv->dvrr_classes[5][10] = int_stack + 432264;
 Libderiv->dvrr_classes[5][11] = int_stack + 433650;
 Libderiv->dvrr_classes[5][12] = int_stack + 435288;
 Libderiv->deriv_classes[5][6][0] = int_stack + 437199;
 Libderiv->deriv_classes[5][7][0] = int_stack + 437787;
 Libderiv->deriv_classes[5][8][0] = int_stack + 438543;
 Libderiv->deriv_classes[5][9][0] = int_stack + 439488;
 Libderiv->deriv_classes[5][10][0] = int_stack + 440643;
 Libderiv->deriv_classes[5][11][0] = int_stack + 442029;
 Libderiv->deriv_classes[5][12][0] = int_stack + 443667;
 Libderiv->dvrr_classes[6][6] = int_stack + 445578;
 Libderiv->dvrr_classes[6][7] = int_stack + 446362;
 Libderiv->dvrr_classes[6][8] = int_stack + 447370;
 Libderiv->dvrr_classes[6][9] = int_stack + 448630;
 Libderiv->dvrr_classes[6][10] = int_stack + 450170;
 Libderiv->dvrr_classes[6][11] = int_stack + 452018;
 Libderiv->dvrr_classes[6][12] = int_stack + 454202;
 Libderiv->deriv_classes[6][6][0] = int_stack + 456750;
 Libderiv->deriv_classes[6][7][0] = int_stack + 457534;
 Libderiv->deriv_classes[6][8][0] = int_stack + 458542;
 Libderiv->deriv_classes[6][9][0] = int_stack + 459802;
 Libderiv->deriv_classes[6][10][0] = int_stack + 461342;
 Libderiv->deriv_classes[6][11][0] = int_stack + 463190;
 Libderiv->deriv_classes[6][12][0] = int_stack + 465374;
 Libderiv->dvrr_classes[7][6] = int_stack + 467922;
 Libderiv->dvrr_classes[7][7] = int_stack + 468930;
 Libderiv->dvrr_classes[7][8] = int_stack + 470226;
 Libderiv->dvrr_classes[7][9] = int_stack + 471846;
 Libderiv->dvrr_classes[7][10] = int_stack + 473826;
 Libderiv->dvrr_classes[7][11] = int_stack + 476202;
 Libderiv->dvrr_classes[7][12] = int_stack + 479010;
 Libderiv->deriv_classes[7][6][0] = int_stack + 482286;
 Libderiv->deriv_classes[7][7][0] = int_stack + 483294;
 Libderiv->deriv_classes[7][8][0] = int_stack + 484590;
 Libderiv->deriv_classes[7][9][0] = int_stack + 486210;
 Libderiv->deriv_classes[7][10][0] = int_stack + 488190;
 Libderiv->deriv_classes[7][11][0] = int_stack + 490566;
 Libderiv->deriv_classes[7][12][0] = int_stack + 493374;
 Libderiv->deriv_classes[8][6][0] = int_stack + 496650;
 Libderiv->deriv_classes[8][7][0] = int_stack + 497910;
 Libderiv->deriv_classes[8][8][0] = int_stack + 499530;
 Libderiv->deriv_classes[8][9][0] = int_stack + 501555;
 Libderiv->deriv_classes[8][10][0] = int_stack + 504030;
 Libderiv->deriv_classes[8][11][0] = int_stack + 507000;
 Libderiv->deriv_classes[8][12][0] = int_stack + 510510;
 memset(int_stack,0,4116840);

 Libderiv->dvrr_stack = int_stack + 2778922;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_hfii(Libderiv, Data);
   Data++;
 }

 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+514605,int_stack+429408,int_stack+428820,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+516369,int_stack+430164,int_stack+429408,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+518637,int_stack+516369,int_stack+514605,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+522165,int_stack+431109,int_stack+430164,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+525000,int_stack+522165,int_stack+516369,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+529536,int_stack+525000,int_stack+518637,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+535416,int_stack+432264,int_stack+431109,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+538881,int_stack+535416,int_stack+522165,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+544551,int_stack+538881,int_stack+525000,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+552111,int_stack+544551,int_stack+529536,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+560931,int_stack+433650,int_stack+432264,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+565089,int_stack+560931,int_stack+535416,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+572019,int_stack+565089,int_stack+538881,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+581469,int_stack+572019,int_stack+544551,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+592809,int_stack+581469,int_stack+552111,21);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+605157,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428820,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+606921,int_stack+1344,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429408,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+609189,int_stack+606921,int_stack+605157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514605,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+612717,int_stack+2289,int_stack+1344, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430164,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+615552,int_stack+612717,int_stack+606921, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516369,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+620088,int_stack+615552,int_stack+609189, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518637,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+605157,int_stack+3444,int_stack+2289, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431109,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+625968,int_stack+605157,int_stack+612717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522165,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+631638,int_stack+625968,int_stack+615552, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525000,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+608622,int_stack+631638,int_stack+620088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529536,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+617442,int_stack+4830,int_stack+3444, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432264,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+639198,int_stack+617442,int_stack+605157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535416,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+646128,int_stack+639198,int_stack+625968, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538881,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+655578,int_stack+646128,int_stack+631638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544551,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+621600,int_stack+655578,int_stack+608622, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+552111,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+605157,int_stack+6468,int_stack+4830, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433650,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+0,int_stack+605157,int_stack+617442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560931,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+605157,int_stack+0,int_stack+639198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565089,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+666918,int_stack+605157,int_stack+646128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572019,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+605157,int_stack+666918,int_stack+655578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581469,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+633948,int_stack+605157,int_stack+621600, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592809,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+605157,int_stack+446362,int_stack+445578,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+607509,int_stack+447370,int_stack+446362,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+610533,int_stack+607509,int_stack+605157,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+615237,int_stack+448630,int_stack+447370,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+619017,int_stack+615237,int_stack+607509,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+625065,int_stack+619017,int_stack+610533,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+450170,int_stack+448630,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+650412,int_stack+0,int_stack+615237,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+657972,int_stack+650412,int_stack+619017,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+668052,int_stack+657972,int_stack+625065,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+679812,int_stack+452018,int_stack+450170,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+685356,int_stack+679812,int_stack+0,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+694596,int_stack+685356,int_stack+650412,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+707196,int_stack+694596,int_stack+657972,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+722316,int_stack+707196,int_stack+668052,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+9163,int_stack+8379, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445578,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+738780,int_stack+10171,int_stack+9163, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446362,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+741804,int_stack+738780,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605157,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+4620,int_stack+11431,int_stack+10171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+447370,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+746508,int_stack+4620,int_stack+738780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607509,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+752556,int_stack+746508,int_stack+741804, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610533,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+738780,int_stack+12971,int_stack+11431, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448630,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+760396,int_stack+738780,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615237,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+767956,int_stack+760396,int_stack+746508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+619017,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+778036,int_stack+767956,int_stack+752556, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625065,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+4620,int_stack+14819,int_stack+12971, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450170,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+743400,int_stack+4620,int_stack+738780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+789796,int_stack+743400,int_stack+760396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650412,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+752640,int_stack+789796,int_stack+767956, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657972,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+802396,int_stack+752640,int_stack+778036, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668052,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+767760,int_stack+17003,int_stack+14819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452018,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+774312,int_stack+767760,int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679812,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+818860,int_stack+774312,int_stack+743400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685356,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+767760,int_stack+818860,int_stack+789796, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694596,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+818860,int_stack+767760,int_stack+752640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707196,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+738780,int_stack+818860,int_stack+802396, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722316,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+760732,int_stack+738780,int_stack+633948,784);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4620,int_stack+468930,int_stack+467922,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+7644,int_stack+470226,int_stack+468930,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+11532,int_stack+7644,int_stack+4620,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+810124,int_stack+471846,int_stack+470226,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+814984,int_stack+810124,int_stack+7644,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+822760,int_stack+814984,int_stack+11532,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+832840,int_stack+473826,int_stack+471846,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+632905,int_stack+832840,int_stack+810124,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+838780,int_stack+632905,int_stack+814984,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+851740,int_stack+838780,int_stack+822760,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+642625,int_stack+476202,int_stack+473826,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+866860,int_stack+642625,int_stack+832840,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+878740,int_stack+866860,int_stack+632905,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+894940,int_stack+878740,int_stack+838780,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+914380,int_stack+894940,int_stack+851740,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+935548,int_stack+20559,int_stack+19551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467922,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+938572,int_stack+21855,int_stack+20559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468930,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+942460,int_stack+938572,int_stack+935548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4620,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+948508,int_stack+23475,int_stack+21855, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470226,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+953368,int_stack+948508,int_stack+938572, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7644,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+961144,int_stack+953368,int_stack+942460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11532,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+935548,int_stack+25455,int_stack+23475, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471846,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+971224,int_stack+935548,int_stack+948508, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810124,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+980944,int_stack+971224,int_stack+953368, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814984,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+941488,int_stack+980944,int_stack+961144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822760,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+956608,int_stack+27831,int_stack+25455, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473826,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+993904,int_stack+956608,int_stack+935548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+832840,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1005784,int_stack+993904,int_stack+971224, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632905,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1021984,int_stack+1005784,int_stack+980944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+838780,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+963736,int_stack+1021984,int_stack+941488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+851740,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+935548,int_stack+30639,int_stack+27831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476202,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+17580,int_stack+935548,int_stack+956608, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642625,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+935548,int_stack+17580,int_stack+993904, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866860,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1041424,int_stack+935548,int_stack+1005784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+878740,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+935548,int_stack+1041424,int_stack+1021984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+894940,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+984904,int_stack+935548,int_stack+963736, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+914380,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1013128,int_stack+984904,int_stack+738780,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1078984,int_stack+1013128,int_stack+760732,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+738780,int_stack+295785,int_stack+293265,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+742560,int_stack+299025,int_stack+295785,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+747420,int_stack+742560,int_stack+738780,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+754980,int_stack+303075,int_stack+299025,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+761055,int_stack+754980,int_stack+742560,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+770775,int_stack+761055,int_stack+747420,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+783375,int_stack+308025,int_stack+303075,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+790800,int_stack+783375,int_stack+754980,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+935548,int_stack+790800,int_stack+761055,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+951748,int_stack+935548,int_stack+770775,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+970648,int_stack+313965,int_stack+308025,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+17580,int_stack+970648,int_stack+783375,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1177768,int_stack+17580,int_stack+790800,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1198018,int_stack+1177768,int_stack+935548,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1222318,int_stack+1198018,int_stack+951748,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+802950,int_stack+35175,int_stack+33915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+979558,int_stack+36795,int_stack+35175, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295785,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1248778,int_stack+979558,int_stack+802950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738780,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+802950,int_stack+38820,int_stack+36795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299025,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1256338,int_stack+802950,int_stack+979558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742560,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1266058,int_stack+1256338,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747420,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1248778,int_stack+41295,int_stack+38820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303075,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1278658,int_stack+1248778,int_stack+802950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754980,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1290808,int_stack+1278658,int_stack+1256338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761055,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1307008,int_stack+1290808,int_stack+1266058, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770775,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1256203,int_stack+44265,int_stack+41295, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308025,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1325908,int_stack+1256203,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783375,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1340758,int_stack+1325908,int_stack+1278658, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790800,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1265113,int_stack+1340758,int_stack+1290808, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935548,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1361008,int_stack+1265113,int_stack+1307008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951748,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1289413,int_stack+47775,int_stack+44265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313965,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1299943,int_stack+1289413,int_stack+1256203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+970648,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1387468,int_stack+1299943,int_stack+1325908, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17580,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1289413,int_stack+1387468,int_stack+1340758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1177768,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1319788,int_stack+1289413,int_stack+1265113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198018,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1248778,int_stack+1319788,int_stack+1361008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222318,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1284058,int_stack+1248778,int_stack+984904,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1368730,int_stack+1284058,int_stack+1013128,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1248778,int_stack+52458,int_stack+51870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428820, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1250542,int_stack+53214,int_stack+52458, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429408, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1252810,int_stack+1250542,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514605, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1256338,int_stack+54159,int_stack+53214, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430164, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1259173,int_stack+1256338,int_stack+1250542, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516369, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1263709,int_stack+1259173,int_stack+1252810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518637, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1248778,int_stack+55314,int_stack+54159, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431109, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1269589,int_stack+1248778,int_stack+1256338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522165, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1275259,int_stack+1269589,int_stack+1259173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525000, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1252243,int_stack+1275259,int_stack+1263709, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529536, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1261063,int_stack+56700,int_stack+55314, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432264, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1282819,int_stack+1261063,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535416, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1289749,int_stack+1282819,int_stack+1269589, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538881, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1299199,int_stack+1289749,int_stack+1275259, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544551, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1265221,int_stack+1299199,int_stack+1252243, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+552111, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1248778,int_stack+58338,int_stack+56700, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433650, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1310539,int_stack+1248778,int_stack+1261063, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560931, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1248778,int_stack+1310539,int_stack+1282819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565089, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1310539,int_stack+1248778,int_stack+1289749, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572019, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1248778,int_stack+1310539,int_stack+1299199, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581469, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1277569,int_stack+1248778,int_stack+1265221, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592809, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1248778,int_stack+61033,int_stack+60249, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445578, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1251130,int_stack+62041,int_stack+61033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446362, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1254154,int_stack+1251130,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605157, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1258858,int_stack+63301,int_stack+62041, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+447370, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1262638,int_stack+1258858,int_stack+1251130, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607509, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1268686,int_stack+1262638,int_stack+1254154, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610533, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1248778,int_stack+64841,int_stack+63301, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448630, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1294033,int_stack+1248778,int_stack+1258858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615237, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1301593,int_stack+1294033,int_stack+1262638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+619017, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1253398,int_stack+1301593,int_stack+1268686, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625065, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1265158,int_stack+66689,int_stack+64841, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450170, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1311673,int_stack+1265158,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1320913,int_stack+1311673,int_stack+1294033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650412, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1333513,int_stack+1320913,int_stack+1301593, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657972, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1294033,int_stack+1333513,int_stack+1253398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668052, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1248778,int_stack+68873,int_stack+66689, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452018, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1348633,int_stack+1248778,int_stack+1265158, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679812, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1248778,int_stack+1348633,int_stack+1311673, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685356, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1348633,int_stack+1248778,int_stack+1320913, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694596, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1248778,int_stack+1348633,int_stack+1333513, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707196, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1310497,int_stack+1248778,int_stack+1294033, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722316, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+979558,int_stack+1310497,int_stack+1277569,784);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1248778,int_stack+72429,int_stack+71421, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467922, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1251802,int_stack+73725,int_stack+72429, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468930, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1255690,int_stack+1251802,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4620, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1261738,int_stack+75345,int_stack+73725, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470226, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1266598,int_stack+1261738,int_stack+1251802, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7644, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1274374,int_stack+1266598,int_stack+1255690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11532, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1248778,int_stack+77325,int_stack+75345, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471846, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1284454,int_stack+1248778,int_stack+1261738, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810124, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1294174,int_stack+1284454,int_stack+1266598, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814984, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1254718,int_stack+1294174,int_stack+1274374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822760, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1269838,int_stack+79701,int_stack+77325, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473826, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1332449,int_stack+1269838,int_stack+1248778, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+832840, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1344329,int_stack+1332449,int_stack+1284454, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632905, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1028950,int_stack+1344329,int_stack+1294174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+838780, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1276966,int_stack+1028950,int_stack+1254718, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+851740, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1248778,int_stack+82509,int_stack+79701, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476202, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1048390,int_stack+1248778,int_stack+1269838, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642625, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1248778,int_stack+1048390,int_stack+1332449, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866860, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1048390,int_stack+1248778,int_stack+1344329, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+878740, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1248778,int_stack+1048390,int_stack+1028950, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+894940, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1028950,int_stack+1248778,int_stack+1276966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+914380, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1500442,int_stack+1028950,int_stack+1310497,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1248778,int_stack+1500442,int_stack+979558,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+979558,int_stack+87045,int_stack+85785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+983338,int_stack+88665,int_stack+87045, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295785, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+988198,int_stack+983338,int_stack+979558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738780, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+995758,int_stack+90690,int_stack+88665, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299025, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1001833,int_stack+995758,int_stack+983338, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742560, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1011553,int_stack+1001833,int_stack+988198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747420, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+979558,int_stack+93165,int_stack+90690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303075, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1347562,int_stack+979558,int_stack+995758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754980, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1057174,int_stack+1347562,int_stack+1001833, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761055, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+986983,int_stack+1057174,int_stack+1011553, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770775, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1005883,int_stack+96135,int_stack+93165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308025, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+32430,int_stack+1005883,int_stack+979558, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783375, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+47280,int_stack+32430,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790800, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+67530,int_stack+47280,int_stack+1057174, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935548, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1566298,int_stack+67530,int_stack+986983, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951748, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1057174,int_stack+99645,int_stack+96135, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313965, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1347562,int_stack+1057174,int_stack+1005883, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+970648, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+979558,int_stack+1347562,int_stack+32430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17580, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1592758,int_stack+979558,int_stack+47280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1177768, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+979558,int_stack+1592758,int_stack+67530, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198018, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+32430,int_stack+979558,int_stack+1566298, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222318, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1566298,int_stack+32430,int_stack+1028950,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1650970,int_stack+1566298,int_stack+1500442,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1500442,int_stack+104328,int_stack+103740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428820, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1502206,int_stack+105084,int_stack+104328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429408, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1504474,int_stack+1502206,int_stack+1500442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1508002,int_stack+106029,int_stack+105084, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430164, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1510837,int_stack+1508002,int_stack+1502206, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516369, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1515373,int_stack+1510837,int_stack+1504474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518637, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1500442,int_stack+107184,int_stack+106029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431109, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1521253,int_stack+1500442,int_stack+1508002, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522165, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1526923,int_stack+1521253,int_stack+1510837, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525000, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1503907,int_stack+1526923,int_stack+1515373, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529536, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1512727,int_stack+108570,int_stack+107184, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432264, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1534483,int_stack+1512727,int_stack+1500442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535416, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1541413,int_stack+1534483,int_stack+1521253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538881, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1550863,int_stack+1541413,int_stack+1526923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544551, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1516885,int_stack+1550863,int_stack+1503907, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+552111, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1500442,int_stack+110208,int_stack+108570, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433650, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1562203,int_stack+1500442,int_stack+1512727, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560931, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1500442,int_stack+1562203,int_stack+1534483, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565089, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1562203,int_stack+1500442,int_stack+1541413, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572019, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1500442,int_stack+1562203,int_stack+1550863, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581469, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1529233,int_stack+1500442,int_stack+1516885, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592809, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1500442,int_stack+112903,int_stack+112119, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445578, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1502794,int_stack+113911,int_stack+112903, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446362, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1505818,int_stack+1502794,int_stack+1500442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605157, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1510522,int_stack+115171,int_stack+113911, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+447370, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1514302,int_stack+1510522,int_stack+1502794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607509, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1520350,int_stack+1514302,int_stack+1505818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610533, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1500442,int_stack+116711,int_stack+115171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448630, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1545697,int_stack+1500442,int_stack+1510522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615237, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1553257,int_stack+1545697,int_stack+1514302, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+619017, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1505062,int_stack+1553257,int_stack+1520350, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625065, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1516822,int_stack+118559,int_stack+116711, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450170, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1563337,int_stack+1516822,int_stack+1500442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1572577,int_stack+1563337,int_stack+1545697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650412, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1585177,int_stack+1572577,int_stack+1553257, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657972, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1545697,int_stack+1585177,int_stack+1505062, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668052, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1500442,int_stack+120743,int_stack+118559, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452018, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1600297,int_stack+1500442,int_stack+1516822, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679812, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1500442,int_stack+1600297,int_stack+1563337, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685356, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1600297,int_stack+1500442,int_stack+1572577, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694596, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+1600297,int_stack+1585177, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707196, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1500442,int_stack+1347562,int_stack+1545697, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722316, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1545697,int_stack+1500442,int_stack+1529233,784);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1595089,int_stack+124299,int_stack+123291, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467922, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1598113,int_stack+125595,int_stack+124299, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468930, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1602001,int_stack+1598113,int_stack+1595089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4620, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1608049,int_stack+127215,int_stack+125595, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470226, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1612909,int_stack+1608049,int_stack+1598113, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7644, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1620685,int_stack+1612909,int_stack+1602001, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11532, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1595089,int_stack+129195,int_stack+127215, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471846, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1630765,int_stack+1595089,int_stack+1608049, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810124, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1347562,int_stack+1630765,int_stack+1612909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814984, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1601029,int_stack+1347562,int_stack+1620685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822760, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1616149,int_stack+131571,int_stack+129195, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473826, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1522394,int_stack+1616149,int_stack+1595089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+832840, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+32430,int_stack+1522394,int_stack+1630765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632905, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1623277,int_stack+32430,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+838780, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1347562,int_stack+1623277,int_stack+1601029, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+851740, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1595089,int_stack+134379,int_stack+131571, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476202, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+48630,int_stack+1595089,int_stack+1616149, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642625, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1595089,int_stack+48630,int_stack+1522394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866860, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+48630,int_stack+1595089,int_stack+32430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+878740, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1595089,int_stack+48630,int_stack+1623277, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+894940, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+32430,int_stack+1595089,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+914380, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+60654,int_stack+32430,int_stack+1500442,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+979558,int_stack+60654,int_stack+1545697,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1500442,int_stack+138915,int_stack+137655, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1504222,int_stack+140535,int_stack+138915, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295785, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1509082,int_stack+1504222,int_stack+1500442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738780, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1516642,int_stack+142560,int_stack+140535, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299025, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1522717,int_stack+1516642,int_stack+1504222, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742560, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1532437,int_stack+1522717,int_stack+1509082, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747420, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1500442,int_stack+145035,int_stack+142560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303075, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1545037,int_stack+1500442,int_stack+1516642, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754980, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1557187,int_stack+1545037,int_stack+1522717, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761055, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1507867,int_stack+1557187,int_stack+1532437, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770775, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1526767,int_stack+148005,int_stack+145035, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308025, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1573387,int_stack+1526767,int_stack+1500442, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783375, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1588237,int_stack+1573387,int_stack+1545037, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790800, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1608487,int_stack+1588237,int_stack+1557187, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935548, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1535677,int_stack+1608487,int_stack+1507867, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951748, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1500442,int_stack+151515,int_stack+148005, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313965, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1632787,int_stack+1500442,int_stack+1526767, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+970648, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1500442,int_stack+1632787,int_stack+1573387, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17580, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1782682,int_stack+1500442,int_stack+1588237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1500442,int_stack+1782682,int_stack+1608487, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198018, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1562137,int_stack+1500442,int_stack+1535677, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222318, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1782682,int_stack+1562137,int_stack+32430,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1500442,int_stack+1782682,int_stack+60654,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1782682,int_stack+156198,int_stack+155610, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+428820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1784446,int_stack+156954,int_stack+156198, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+429408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1786714,int_stack+1784446,int_stack+1782682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1790242,int_stack+157899,int_stack+156954, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+430164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1793077,int_stack+1790242,int_stack+1784446, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+516369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1797613,int_stack+1793077,int_stack+1786714, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+518637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1782682,int_stack+159054,int_stack+157899, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+431109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1803493,int_stack+1782682,int_stack+1790242, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+522165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1809163,int_stack+1803493,int_stack+1793077, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+525000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1786147,int_stack+1809163,int_stack+1797613, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1794967,int_stack+160440,int_stack+159054, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+432264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1816723,int_stack+1794967,int_stack+1782682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1823653,int_stack+1816723,int_stack+1803493, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+538881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1833103,int_stack+1823653,int_stack+1809163, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+544551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1799125,int_stack+1833103,int_stack+1786147, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+552111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1782682,int_stack+162078,int_stack+160440, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+433650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1844443,int_stack+1782682,int_stack+1794967, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+560931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1782682,int_stack+1844443,int_stack+1816723, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+565089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1844443,int_stack+1782682,int_stack+1823653, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1782682,int_stack+1844443,int_stack+1833103, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+581469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1811473,int_stack+1782682,int_stack+1799125, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+592809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1782682,int_stack+164773,int_stack+163989, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+445578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1785034,int_stack+165781,int_stack+164773, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+446362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1788058,int_stack+1785034,int_stack+1782682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+605157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1792762,int_stack+167041,int_stack+165781, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+447370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1796542,int_stack+1792762,int_stack+1785034, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+607509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1802590,int_stack+1796542,int_stack+1788058, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+610533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1782682,int_stack+168581,int_stack+167041, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+448630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1827937,int_stack+1782682,int_stack+1792762, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+615237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1835497,int_stack+1827937,int_stack+1796542, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+619017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1787302,int_stack+1835497,int_stack+1802590, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1799062,int_stack+170429,int_stack+168581, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+450170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1845577,int_stack+1799062,int_stack+1782682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1854817,int_stack+1845577,int_stack+1827937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+650412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+32430,int_stack+1854817,int_stack+1835497, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1827937,int_stack+32430,int_stack+1787302, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+668052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1782682,int_stack+172613,int_stack+170429, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+452018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+47550,int_stack+1782682,int_stack+1799062, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+679812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1782682,int_stack+47550,int_stack+1845577, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+685356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+47550,int_stack+1782682,int_stack+1854817, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+694596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+47550,int_stack+32430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+32430,int_stack+1347562,int_stack+1827937, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+722316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+54382,int_stack+32430,int_stack+1811473,784);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1347562,int_stack+176169,int_stack+175161, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+467922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1350586,int_stack+177465,int_stack+176169, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+468930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1354474,int_stack+1350586,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1360522,int_stack+179085,int_stack+177465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+470226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+103774,int_stack+1360522,int_stack+1350586, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+7644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+111550,int_stack+103774,int_stack+1354474, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+11532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+181065,int_stack+179085, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+471846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+121630,int_stack+1347562,int_stack+1360522, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+810124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1353502,int_stack+121630,int_stack+103774, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+814984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+131350,int_stack+1353502,int_stack+111550, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+822760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+103774,int_stack+183441,int_stack+181065, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+473826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+146470,int_stack+103774,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+832840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+158350,int_stack+146470,int_stack+121630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+632905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+110902,int_stack+158350,int_stack+1353502, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+838780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1347562,int_stack+110902,int_stack+131350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+851740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+130342,int_stack+186249,int_stack+183441, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+174550,int_stack+130342,int_stack+103774, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+642625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1782682,int_stack+174550,int_stack+146470, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+866860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+130342,int_stack+1782682,int_stack+158350, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+878740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1782682,int_stack+130342,int_stack+110902, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+894940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1809898,int_stack+1782682,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+914380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+103774,int_stack+1809898,int_stack+32430,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+1838122,int_stack+103774,int_stack+54382,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32430,int_stack+190785,int_stack+189525, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36210,int_stack+192405,int_stack+190785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+295785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41070,int_stack+36210,int_stack+32430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+738780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48630,int_stack+194430,int_stack+192405, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+299025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+54705,int_stack+48630,int_stack+36210, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+742560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+64425,int_stack+54705,int_stack+41070, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+747420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+32430,int_stack+196905,int_stack+194430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+303075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+77025,int_stack+32430,int_stack+48630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+754980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1347562,int_stack+77025,int_stack+54705, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+39855,int_stack+1347562,int_stack+64425, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+770775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+58755,int_stack+199875,int_stack+196905, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+308025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1782682,int_stack+58755,int_stack+32430, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+783375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+169630,int_stack+1782682,int_stack+77025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+790800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+67665,int_stack+169630,int_stack+1347562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+935548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1936906,int_stack+67665,int_stack+39855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+951748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1347562,int_stack+203385,int_stack+199875, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+313965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+32430,int_stack+1347562,int_stack+58755, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+970648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1963366,int_stack+32430,int_stack+1782682, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+17580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+32430,int_stack+1963366,int_stack+169630, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+169630,int_stack+32430,int_stack+67665, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1198018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+32430,int_stack+169630,int_stack+1936906, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1222318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1936906,int_stack+32430,int_stack+1809898,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2021578,int_stack+1936906,int_stack+103774,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1936906,int_stack+208068,int_stack+207480, 0.0, zero_stack, 1.0, int_stack+428820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1938670,int_stack+208824,int_stack+208068, 0.0, zero_stack, 1.0, int_stack+429408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1940938,int_stack+1938670,int_stack+1936906, 0.0, zero_stack, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1944466,int_stack+209769,int_stack+208824, 0.0, zero_stack, 1.0, int_stack+430164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1947301,int_stack+1944466,int_stack+1938670, 0.0, zero_stack, 1.0, int_stack+516369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1951837,int_stack+1947301,int_stack+1940938, 0.0, zero_stack, 1.0, int_stack+518637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1936906,int_stack+210924,int_stack+209769, 0.0, zero_stack, 1.0, int_stack+431109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1957717,int_stack+1936906,int_stack+1944466, 0.0, zero_stack, 1.0, int_stack+522165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1963387,int_stack+1957717,int_stack+1947301, 0.0, zero_stack, 1.0, int_stack+525000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1940371,int_stack+1963387,int_stack+1951837, 0.0, zero_stack, 1.0, int_stack+529536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1949191,int_stack+212310,int_stack+210924, 0.0, zero_stack, 1.0, int_stack+432264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1970947,int_stack+1949191,int_stack+1936906, 0.0, zero_stack, 1.0, int_stack+535416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1977877,int_stack+1970947,int_stack+1957717, 0.0, zero_stack, 1.0, int_stack+538881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1987327,int_stack+1977877,int_stack+1963387, 0.0, zero_stack, 1.0, int_stack+544551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1953349,int_stack+1987327,int_stack+1940371, 0.0, zero_stack, 1.0, int_stack+552111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+213948,int_stack+212310, 0.0, zero_stack, 1.0, int_stack+433650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1998667,int_stack+1936906,int_stack+1949191, 0.0, zero_stack, 1.0, int_stack+560931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1936906,int_stack+1998667,int_stack+1970947, 0.0, zero_stack, 1.0, int_stack+565089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1998667,int_stack+1936906,int_stack+1977877, 0.0, zero_stack, 1.0, int_stack+572019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1936906,int_stack+1998667,int_stack+1987327, 0.0, zero_stack, 1.0, int_stack+581469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1965697,int_stack+1936906,int_stack+1953349, 0.0, zero_stack, 1.0, int_stack+592809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1936906,int_stack+216643,int_stack+215859, 0.0, zero_stack, 1.0, int_stack+445578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1939258,int_stack+217651,int_stack+216643, 0.0, zero_stack, 1.0, int_stack+446362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1942282,int_stack+1939258,int_stack+1936906, 0.0, zero_stack, 1.0, int_stack+605157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1946986,int_stack+218911,int_stack+217651, 0.0, zero_stack, 1.0, int_stack+447370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1950766,int_stack+1946986,int_stack+1939258, 0.0, zero_stack, 1.0, int_stack+607509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1956814,int_stack+1950766,int_stack+1942282, 0.0, zero_stack, 1.0, int_stack+610533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1936906,int_stack+220451,int_stack+218911, 0.0, zero_stack, 1.0, int_stack+448630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1982161,int_stack+1936906,int_stack+1946986, 0.0, zero_stack, 1.0, int_stack+615237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1989721,int_stack+1982161,int_stack+1950766, 0.0, zero_stack, 1.0, int_stack+619017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1941526,int_stack+1989721,int_stack+1956814, 0.0, zero_stack, 1.0, int_stack+625065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+1953286,int_stack+222299,int_stack+220451, 0.0, zero_stack, 1.0, int_stack+450170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1999801,int_stack+1953286,int_stack+1936906, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+32430,int_stack+1999801,int_stack+1982161, 0.0, zero_stack, 1.0, int_stack+650412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+45030,int_stack+32430,int_stack+1989721, 0.0, zero_stack, 1.0, int_stack+657972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1982161,int_stack+45030,int_stack+1941526, 0.0, zero_stack, 1.0, int_stack+668052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+224483,int_stack+222299, 0.0, zero_stack, 1.0, int_stack+452018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+2009041,int_stack+1936906,int_stack+1953286, 0.0, zero_stack, 1.0, int_stack+679812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+1936906,int_stack+2009041,int_stack+1999801, 0.0, zero_stack, 1.0, int_stack+685356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1998625,int_stack+1936906,int_stack+32430, 0.0, zero_stack, 1.0, int_stack+694596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+1998625,int_stack+45030, 0.0, zero_stack, 1.0, int_stack+707196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1998625,int_stack+1347562,int_stack+1982161, 0.0, zero_stack, 1.0, int_stack+722316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+32430,int_stack+1998625,int_stack+1965697,784);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1347562,int_stack+228039,int_stack+227031, 0.0, zero_stack, 1.0, int_stack+467922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1350586,int_stack+229335,int_stack+228039, 0.0, zero_stack, 1.0, int_stack+468930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1354474,int_stack+1350586,int_stack+1347562, 0.0, zero_stack, 1.0, int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1360522,int_stack+230955,int_stack+229335, 0.0, zero_stack, 1.0, int_stack+470226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+81822,int_stack+1360522,int_stack+1350586, 0.0, zero_stack, 1.0, int_stack+7644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+89598,int_stack+81822,int_stack+1354474, 0.0, zero_stack, 1.0, int_stack+11532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+232935,int_stack+230955, 0.0, zero_stack, 1.0, int_stack+471846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+99678,int_stack+1347562,int_stack+1360522, 0.0, zero_stack, 1.0, int_stack+810124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1353502,int_stack+99678,int_stack+81822, 0.0, zero_stack, 1.0, int_stack+814984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+109398,int_stack+1353502,int_stack+89598, 0.0, zero_stack, 1.0, int_stack+822760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+81822,int_stack+235311,int_stack+232935, 0.0, zero_stack, 1.0, int_stack+473826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+124518,int_stack+81822,int_stack+1347562, 0.0, zero_stack, 1.0, int_stack+832840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+136398,int_stack+124518,int_stack+99678, 0.0, zero_stack, 1.0, int_stack+632905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+88950,int_stack+136398,int_stack+1353502, 0.0, zero_stack, 1.0, int_stack+838780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1347562,int_stack+88950,int_stack+109398, 0.0, zero_stack, 1.0, int_stack+851740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+108390,int_stack+238119,int_stack+235311, 0.0, zero_stack, 1.0, int_stack+476202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+152598,int_stack+108390,int_stack+81822, 0.0, zero_stack, 1.0, int_stack+642625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+166854,int_stack+152598,int_stack+124518, 0.0, zero_stack, 1.0, int_stack+866860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+108390,int_stack+166854,int_stack+136398, 0.0, zero_stack, 1.0, int_stack+878740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+132690,int_stack+108390,int_stack+88950, 0.0, zero_stack, 1.0, int_stack+894940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+81822,int_stack+132690,int_stack+1347562, 0.0, zero_stack, 1.0, int_stack+914380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+110046,int_stack+81822,int_stack+1998625,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+2153290,int_stack+110046,int_stack+32430,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32430,int_stack+242655,int_stack+241395, 0.0, zero_stack, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36210,int_stack+244275,int_stack+242655, 0.0, zero_stack, 1.0, int_stack+295785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41070,int_stack+36210,int_stack+32430, 0.0, zero_stack, 1.0, int_stack+738780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48630,int_stack+246300,int_stack+244275, 0.0, zero_stack, 1.0, int_stack+299025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+54705,int_stack+48630,int_stack+36210, 0.0, zero_stack, 1.0, int_stack+742560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+64425,int_stack+54705,int_stack+41070, 0.0, zero_stack, 1.0, int_stack+747420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+32430,int_stack+248775,int_stack+246300, 0.0, zero_stack, 1.0, int_stack+303075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1347562,int_stack+32430,int_stack+48630, 0.0, zero_stack, 1.0, int_stack+754980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+175902,int_stack+1347562,int_stack+54705, 0.0, zero_stack, 1.0, int_stack+761055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+39855,int_stack+175902,int_stack+64425, 0.0, zero_stack, 1.0, int_stack+770775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+58755,int_stack+251745,int_stack+248775, 0.0, zero_stack, 1.0, int_stack+308025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+192102,int_stack+58755,int_stack+32430, 0.0, zero_stack, 1.0, int_stack+783375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+206952,int_stack+192102,int_stack+1347562, 0.0, zero_stack, 1.0, int_stack+790800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+227202,int_stack+206952,int_stack+175902, 0.0, zero_stack, 1.0, int_stack+935548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1936906,int_stack+227202,int_stack+39855, 0.0, zero_stack, 1.0, int_stack+951748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+175902,int_stack+255255,int_stack+251745, 0.0, zero_stack, 1.0, int_stack+313965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+1347562,int_stack+175902,int_stack+58755, 0.0, zero_stack, 1.0, int_stack+970648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+32430,int_stack+1347562,int_stack+192102, 0.0, zero_stack, 1.0, int_stack+17580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+175902,int_stack+32430,int_stack+206952, 0.0, zero_stack, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+32430,int_stack+175902,int_stack+227202, 0.0, zero_stack, 1.0, int_stack+1198018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+175902,int_stack+32430,int_stack+1936906, 0.0, zero_stack, 1.0, int_stack+1222318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1936906,int_stack+175902,int_stack+81822,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2252074,int_stack+1936906,int_stack+110046,784);
 /*--- compute (h0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1936906,int_stack+259938,int_stack+259350, 1.0, int_stack+428820, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1938670,int_stack+260694,int_stack+259938, 1.0, int_stack+429408, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1940938,int_stack+1938670,int_stack+1936906, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1944466,int_stack+261639,int_stack+260694, 1.0, int_stack+430164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1947301,int_stack+1944466,int_stack+1938670, 1.0, int_stack+516369, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1951837,int_stack+1947301,int_stack+1940938, 1.0, int_stack+518637, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+514605,int_stack+262794,int_stack+261639, 1.0, int_stack+431109, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1936906,int_stack+514605,int_stack+1944466, 1.0, int_stack+522165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1957717,int_stack+1936906,int_stack+1947301, 1.0, int_stack+525000, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+518070,int_stack+1957717,int_stack+1951837, 1.0, int_stack+529536, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+526890,int_stack+264180,int_stack+262794, 1.0, int_stack+432264, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+1942576,int_stack+526890,int_stack+514605, 1.0, int_stack+535416, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+1965277,int_stack+1942576,int_stack+1936906, 1.0, int_stack+538881, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+531048,int_stack+1965277,int_stack+1957717, 1.0, int_stack+544551, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1949506,int_stack+531048,int_stack+518070, 1.0, int_stack+552111, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+265818,int_stack+264180, 1.0, int_stack+433650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+514605,int_stack+1936906,int_stack+526890, 1.0, int_stack+560931, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+542388,int_stack+514605,int_stack+1942576, 1.0, int_stack+565089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+514605,int_stack+542388,int_stack+1965277, 1.0, int_stack+572019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+542388,int_stack+514605,int_stack+531048, 1.0, int_stack+581469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (h0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+514605,int_stack+542388,int_stack+1949506, 1.0, int_stack+592809, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,21);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+531069,int_stack+268513,int_stack+267729, 1.0, int_stack+445578, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+533421,int_stack+269521,int_stack+268513, 1.0, int_stack+446362, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+536445,int_stack+533421,int_stack+531069, 1.0, int_stack+605157, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+541149,int_stack+270781,int_stack+269521, 1.0, int_stack+447370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+544929,int_stack+541149,int_stack+533421, 1.0, int_stack+607509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+550977,int_stack+544929,int_stack+536445, 1.0, int_stack+610533, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+605157,int_stack+272321,int_stack+270781, 1.0, int_stack+448630, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+531069,int_stack+605157,int_stack+541149, 1.0, int_stack+615237, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1936906,int_stack+531069,int_stack+544929, 1.0, int_stack+619017, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+609777,int_stack+1936906,int_stack+550977, 1.0, int_stack+625065, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+621537,int_stack+274169,int_stack+272321, 1.0, int_stack+450170, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+538629,int_stack+621537,int_stack+605157, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+547869,int_stack+538629,int_stack+531069, 1.0, int_stack+650412, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+1946986,int_stack+547869,int_stack+1936906, 1.0, int_stack+657972, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1962106,int_stack+1946986,int_stack+609777, 1.0, int_stack+668052, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+276353,int_stack+274169, 1.0, int_stack+452018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+605157,int_stack+1936906,int_stack+621537, 1.0, int_stack+679812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+616245,int_stack+605157,int_stack+538629, 1.0, int_stack+685356, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+1978570,int_stack+616245,int_stack+547869, 1.0, int_stack+694596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+1978570,int_stack+1946986, 1.0, int_stack+707196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+1978570,int_stack+1347562,int_stack+1962106, 1.0, int_stack+722316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+32430,int_stack+1978570,int_stack+514605,784);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+514605,int_stack+279909,int_stack+278901, 1.0, int_stack+467922, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+517629,int_stack+281205,int_stack+279909, 1.0, int_stack+468930, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+521517,int_stack+517629,int_stack+514605, 1.0, int_stack+4620, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+527565,int_stack+282825,int_stack+281205, 1.0, int_stack+470226, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+532425,int_stack+527565,int_stack+517629, 1.0, int_stack+7644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+540201,int_stack+532425,int_stack+521517, 1.0, int_stack+11532, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+514605,int_stack+284805,int_stack+282825, 1.0, int_stack+471846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+550281,int_stack+514605,int_stack+527565, 1.0, int_stack+810124, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1347562,int_stack+550281,int_stack+532425, 1.0, int_stack+814984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+520545,int_stack+1347562,int_stack+540201, 1.0, int_stack+822760, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+535665,int_stack+287181,int_stack+284805, 1.0, int_stack+473826, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+2000522,int_stack+535665,int_stack+514605, 1.0, int_stack+832840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+605157,int_stack+2000522,int_stack+550281, 1.0, int_stack+632905, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+621357,int_stack+605157,int_stack+1347562, 1.0, int_stack+838780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+1347562,int_stack+621357,int_stack+520545, 1.0, int_stack+851740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+514605,int_stack+289989,int_stack+287181, 1.0, int_stack+476202, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+542793,int_stack+514605,int_stack+535665, 1.0, int_stack+642625, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+514605,int_stack+542793,int_stack+2000522, 1.0, int_stack+866860, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+534405,int_stack+514605,int_stack+605157, 1.0, int_stack+878740, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+1936906,int_stack+534405,int_stack+621357, 1.0, int_stack+894940, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+605157,int_stack+1936906,int_stack+1347562, 1.0, int_stack+914380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+81822,int_stack+605157,int_stack+1978570,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+147678,int_stack+81822,int_stack+32430,784);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+32430,int_stack+297405,int_stack+294525, 1.0, int_stack+293265, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36210,int_stack+301050,int_stack+297405, 1.0, int_stack+295785, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41070,int_stack+36210,int_stack+32430, 1.0, int_stack+738780, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+48630,int_stack+305550,int_stack+301050, 1.0, int_stack+299025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+54705,int_stack+48630,int_stack+36210, 1.0, int_stack+742560, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+64425,int_stack+54705,int_stack+41070, 1.0, int_stack+747420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+738780,int_stack+310995,int_stack+305550, 1.0, int_stack+303075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+32430,int_stack+738780,int_stack+48630, 1.0, int_stack+754980, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1347562,int_stack+32430,int_stack+54705, 1.0, int_stack+761055, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+746205,int_stack+1347562,int_stack+64425, 1.0, int_stack+770775, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|np) ---*/
   d1hrr3_build_np(Libderiv->CD,int_stack+765105,int_stack+317475,int_stack+310995, 1.0, int_stack+308025, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|md) ---*/
   d1hrr3_build_md(Libderiv->CD,int_stack+44580,int_stack+765105,int_stack+738780, 1.0, int_stack+783375, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lf) ---*/
   d1hrr3_build_lf(Libderiv->CD,int_stack+59430,int_stack+44580,int_stack+32430, 1.0, int_stack+790800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kg) ---*/
   d1hrr3_build_kg(Libderiv->CD,int_stack+774015,int_stack+59430,int_stack+1347562, 1.0, int_stack+935548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ih) ---*/
   d1hrr3_build_ih(Libderiv->CD,int_stack+798315,int_stack+774015,int_stack+746205, 1.0, int_stack+951748, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|op) ---*/
   d1hrr3_build_op(Libderiv->CD,int_stack+935548,int_stack+320985,int_stack+317475, 1.0, int_stack+313965, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|nd) ---*/
   d1hrr3_build_nd(Libderiv->CD,int_stack+946078,int_stack+935548,int_stack+765105, 1.0, int_stack+970648, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mf) ---*/
   d1hrr3_build_mf(Libderiv->CD,int_stack+738780,int_stack+946078,int_stack+44580, 1.0, int_stack+17580, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lg) ---*/
   d1hrr3_build_lg(Libderiv->CD,int_stack+935548,int_stack+738780,int_stack+59430, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kh) ---*/
   d1hrr3_build_kh(Libderiv->CD,int_stack+738780,int_stack+935548,int_stack+774015, 1.0, int_stack+1198018, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ii) ---*/
   d1hrr3_build_ii(Libderiv->CD,int_stack+935548,int_stack+738780,int_stack+798315, 1.0, int_stack+1222318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|ii) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1936906,int_stack+935548,int_stack+605157,784);
 /*--- compute (id|ii) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2383786,int_stack+1936906,int_stack+81822,784);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+435288,int_stack+433650,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1941820,int_stack+1936906,int_stack+560931,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+1950136,int_stack+1941820,int_stack+565089,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1961686,int_stack+1950136,int_stack+572019,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1936906,int_stack+1961686,int_stack+581469,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+1952782,int_stack+1936906,int_stack+592809,21);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+454202,int_stack+452018,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1969246,int_stack+1936906,int_stack+679812,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+1936906,int_stack+1969246,int_stack+685356,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1969246,int_stack+1936906,int_stack+694596,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+1969246,int_stack+707196,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+1969246,int_stack+1347562,int_stack+722316,28);
 /*--- compute (hp|ii) ---*/
   hrr1_build_hp(Libderiv->AB,int_stack+1177768,int_stack+1969246,int_stack+1952782,784);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1347562,int_stack+479010,int_stack+476202,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1991198,int_stack+1347562,int_stack+642625,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+1347562,int_stack+1991198,int_stack+866860,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1991198,int_stack+1347562,int_stack+878740,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+935548,int_stack+1991198,int_stack+894940,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+1991198,int_stack+935548,int_stack+914380,36);
 /*--- compute (ip|ii) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+514605,int_stack+1991198,int_stack+1969246,784);
 /*--- compute (hd|ii) ---*/
   hrr1_build_hd(Libderiv->AB,int_stack+580461,int_stack+514605,int_stack+1177768,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2019422,int_stack+325668,int_stack+325080,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1347562,int_stack+326424,int_stack+325668,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1349830,int_stack+1347562,int_stack+2019422,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1353358,int_stack+327369,int_stack+326424,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1356193,int_stack+1353358,int_stack+1347562,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1360729,int_stack+1356193,int_stack+1349830,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+328524,int_stack+327369,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1936906,int_stack+1347562,int_stack+1353358,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1942576,int_stack+1936906,int_stack+1356193,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1351027,int_stack+1942576,int_stack+1360729,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1359847,int_stack+329910,int_stack+328524,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1227160,int_stack+1359847,int_stack+1347562,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+1234090,int_stack+1227160,int_stack+1936906,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+679245,int_stack+1234090,int_stack+1942576,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1936906,int_stack+679245,int_stack+1351027,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1347562,int_stack+331548,int_stack+329910,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+690585,int_stack+1347562,int_stack+1359847,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+1347562,int_stack+690585,int_stack+1227160,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+690585,int_stack+1347562,int_stack+1234090,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+690585,int_stack+679245,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+679245,int_stack+1347562,int_stack+1936906,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1936906,int_stack+334243,int_stack+333459,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1939258,int_stack+335251,int_stack+334243,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1942282,int_stack+1939258,int_stack+1936906,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1946986,int_stack+336511,int_stack+335251,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1347562,int_stack+1946986,int_stack+1939258,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1353610,int_stack+1347562,int_stack+1942282,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1936906,int_stack+338051,int_stack+336511,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+695709,int_stack+1936906,int_stack+1946986,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1941526,int_stack+695709,int_stack+1347562,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+703269,int_stack+1941526,int_stack+1353610,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1347562,int_stack+339899,int_stack+338051,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+1353106,int_stack+1347562,int_stack+1936906,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+715029,int_stack+1353106,int_stack+695709,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+727629,int_stack+715029,int_stack+1941526,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+742749,int_stack+727629,int_stack+703269,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+695709,int_stack+342083,int_stack+339899,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+702261,int_stack+695709,int_stack+1347562,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+1936906,int_stack+702261,int_stack+1353106,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1347562,int_stack+1936906,int_stack+715029,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+695709,int_stack+1347562,int_stack+727629,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+716877,int_stack+695709,int_stack+742749,28);
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+738829,int_stack+716877,int_stack+679245, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1952782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+679245,int_stack+345639,int_stack+344631,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+682269,int_stack+346935,int_stack+345639,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+686157,int_stack+682269,int_stack+679245,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+692205,int_stack+348555,int_stack+346935,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+697065,int_stack+692205,int_stack+682269,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+704841,int_stack+697065,int_stack+686157,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+679245,int_stack+350535,int_stack+348555,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1347562,int_stack+679245,int_stack+692205,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1936906,int_stack+1347562,int_stack+697065,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+685185,int_stack+1936906,int_stack+704841,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+700305,int_stack+352911,int_stack+350535,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+788221,int_stack+700305,int_stack+679245,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+800101,int_stack+788221,int_stack+1347562,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1347562,int_stack+800101,int_stack+1936906,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+816301,int_stack+1347562,int_stack+685185,36);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1936906,int_stack+355719,int_stack+352911,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+679245,int_stack+1936906,int_stack+700305,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+693501,int_stack+679245,int_stack+788221,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+837469,int_stack+693501,int_stack+800101,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+788221,int_stack+837469,int_stack+1347562,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+837469,int_stack+788221,int_stack+816301,36);
 /*--- compute (ip|ii) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+865693,int_stack+837469,int_stack+716877, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1969246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (hd|ii) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+0,int_stack+865693,int_stack+738829, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347562,int_stack+360255,int_stack+358995,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1351342,int_stack+361875,int_stack+360255,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1356202,int_stack+1351342,int_stack+1347562,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+931549,int_stack+363900,int_stack+361875,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+937624,int_stack+931549,int_stack+1351342,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+947344,int_stack+937624,int_stack+1356202,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+366375,int_stack+363900,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1354987,int_stack+1347562,int_stack+931549,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+959944,int_stack+1354987,int_stack+937624,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+679245,int_stack+959944,int_stack+947344,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+931549,int_stack+369345,int_stack+366375,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+940459,int_stack+931549,int_stack+1347562,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+698145,int_stack+940459,int_stack+1354987,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+718395,int_stack+698145,int_stack+959944,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+742695,int_stack+718395,int_stack+679245,45);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+679245,int_stack+372855,int_stack+369345,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1347562,int_stack+679245,int_stack+931549,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+769155,int_stack+1347562,int_stack+940459,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+931549,int_stack+769155,int_stack+698145,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+769155,int_stack+931549,int_stack+718395,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+931549,int_stack+769155,int_stack+742695,45);
 /*--- compute (kp|ii) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+679245,int_stack+931549,int_stack+837469, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1991198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (id|ii) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+2515498,int_stack+679245,int_stack+865693, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+679245,int_stack+377538,int_stack+376950,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+681009,int_stack+378294,int_stack+377538,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+683277,int_stack+681009,int_stack+679245,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+686805,int_stack+379239,int_stack+378294,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+689640,int_stack+686805,int_stack+681009,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+694176,int_stack+689640,int_stack+683277,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+679245,int_stack+380394,int_stack+379239,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+700056,int_stack+679245,int_stack+686805,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+705726,int_stack+700056,int_stack+689640,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+682710,int_stack+705726,int_stack+694176,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+691530,int_stack+381780,int_stack+380394,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+713286,int_stack+691530,int_stack+679245,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+720216,int_stack+713286,int_stack+700056,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+729666,int_stack+720216,int_stack+705726,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+695688,int_stack+729666,int_stack+682710,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+679245,int_stack+383418,int_stack+381780,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+741006,int_stack+679245,int_stack+691530,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+679245,int_stack+741006,int_stack+713286,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+741006,int_stack+679245,int_stack+720216,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1936906,int_stack+741006,int_stack+729666,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+708036,int_stack+1936906,int_stack+695688,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1936906,int_stack+386113,int_stack+385329,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1939258,int_stack+387121,int_stack+386113,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1942282,int_stack+1939258,int_stack+1936906,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1946986,int_stack+388381,int_stack+387121,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+679245,int_stack+1946986,int_stack+1939258,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+685293,int_stack+679245,int_stack+1942282,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1936906,int_stack+389921,int_stack+388381,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+693133,int_stack+1936906,int_stack+1946986,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1941526,int_stack+693133,int_stack+679245,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+724500,int_stack+1941526,int_stack+685293,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+679245,int_stack+391769,int_stack+389921,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+736260,int_stack+679245,int_stack+1936906,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+745500,int_stack+736260,int_stack+693133,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+684789,int_stack+745500,int_stack+1941526,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+758100,int_stack+684789,int_stack+724500,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+724500,int_stack+393953,int_stack+391769,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1936906,int_stack+724500,int_stack+679245,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+774564,int_stack+1936906,int_stack+736260,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+724500,int_stack+774564,int_stack+745500,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+724500,int_stack+684789,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+724500,int_stack+1347562,int_stack+758100,28);
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+746452,int_stack+724500,int_stack+708036, 0.0, zero_stack, 1.0, int_stack+1952782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347562,int_stack+397509,int_stack+396501,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1350586,int_stack+398805,int_stack+397509,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1354474,int_stack+1350586,int_stack+1347562,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1360522,int_stack+400425,int_stack+398805,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+795844,int_stack+1360522,int_stack+1350586,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+803620,int_stack+795844,int_stack+1354474,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+402405,int_stack+400425,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+813700,int_stack+1347562,int_stack+1360522,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1353502,int_stack+813700,int_stack+795844,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+823420,int_stack+1353502,int_stack+803620,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+795844,int_stack+404781,int_stack+402405,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+838540,int_stack+795844,int_stack+1347562,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+850420,int_stack+838540,int_stack+813700,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+802972,int_stack+850420,int_stack+1353502,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1347562,int_stack+802972,int_stack+823420,36);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+822412,int_stack+407589,int_stack+404781,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+866620,int_stack+822412,int_stack+795844,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+880876,int_stack+866620,int_stack+838540,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+822412,int_stack+880876,int_stack+850420,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+846712,int_stack+822412,int_stack+802972,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+795844,int_stack+846712,int_stack+1347562,36);
 /*--- compute (ip|ii) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+824068,int_stack+795844,int_stack+724500, 0.0, zero_stack, 1.0, int_stack+1969246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (hd|ii) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+246462,int_stack+824068,int_stack+746452, 0.0, zero_stack, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347562,int_stack+412125,int_stack+410865,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1351342,int_stack+413745,int_stack+412125,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1356202,int_stack+1351342,int_stack+1347562,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+889924,int_stack+415770,int_stack+413745,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+895999,int_stack+889924,int_stack+1351342,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+905719,int_stack+895999,int_stack+1356202,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+418245,int_stack+415770,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1354987,int_stack+1347562,int_stack+889924,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+918319,int_stack+1354987,int_stack+895999,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+934519,int_stack+918319,int_stack+905719,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+889924,int_stack+421215,int_stack+418245,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+898834,int_stack+889924,int_stack+1347562,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+953419,int_stack+898834,int_stack+1354987,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+679245,int_stack+953419,int_stack+918319,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+703545,int_stack+679245,int_stack+934519,45);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1347562,int_stack+424725,int_stack+421215,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+913684,int_stack+1347562,int_stack+889924,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+730005,int_stack+913684,int_stack+898834,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+889924,int_stack+730005,int_stack+953419,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+730005,int_stack+889924,int_stack+679245,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+889924,int_stack+730005,int_stack+703545,45);
 /*--- compute (kp|ii) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+679245,int_stack+889924,int_stack+795844, 0.0, zero_stack, 1.0, int_stack+1991198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (id|ii) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+2647210,int_stack+679245,int_stack+824068, 0.0, zero_stack, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (h0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+679245,int_stack+437787,int_stack+437199,21);
 /*--- compute (h0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+681009,int_stack+438543,int_stack+437787,21);
 /*--- compute (h0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+683277,int_stack+681009,int_stack+679245,21);
 /*--- compute (h0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+686805,int_stack+439488,int_stack+438543,21);
 /*--- compute (h0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+689640,int_stack+686805,int_stack+681009,21);
 /*--- compute (h0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+694176,int_stack+689640,int_stack+683277,21);
 /*--- compute (h0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+679245,int_stack+440643,int_stack+439488,21);
 /*--- compute (h0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+700056,int_stack+679245,int_stack+686805,21);
 /*--- compute (h0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+705726,int_stack+700056,int_stack+689640,21);
 /*--- compute (h0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+682710,int_stack+705726,int_stack+694176,21);
 /*--- compute (h0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+691530,int_stack+442029,int_stack+440643,21);
 /*--- compute (h0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+713286,int_stack+691530,int_stack+679245,21);
 /*--- compute (h0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+720216,int_stack+713286,int_stack+700056,21);
 /*--- compute (h0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+729666,int_stack+720216,int_stack+705726,21);
 /*--- compute (h0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+695688,int_stack+729666,int_stack+682710,21);
 /*--- compute (h0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+679245,int_stack+443667,int_stack+442029,21);
 /*--- compute (h0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+741006,int_stack+679245,int_stack+691530,21);
 /*--- compute (h0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+679245,int_stack+741006,int_stack+713286,21);
 /*--- compute (h0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+741006,int_stack+679245,int_stack+720216,21);
 /*--- compute (h0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1936906,int_stack+741006,int_stack+729666,21);
 /*--- compute (h0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+708036,int_stack+1936906,int_stack+695688,21);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1936906,int_stack+457534,int_stack+456750,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1939258,int_stack+458542,int_stack+457534,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1942282,int_stack+1939258,int_stack+1936906,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1946986,int_stack+459802,int_stack+458542,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+679245,int_stack+1946986,int_stack+1939258,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+685293,int_stack+679245,int_stack+1942282,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1936906,int_stack+461342,int_stack+459802,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+693133,int_stack+1936906,int_stack+1946986,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1941526,int_stack+693133,int_stack+679245,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+724500,int_stack+1941526,int_stack+685293,28);
 /*--- compute (i0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+679245,int_stack+463190,int_stack+461342,28);
 /*--- compute (i0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+736260,int_stack+679245,int_stack+1936906,28);
 /*--- compute (i0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+745500,int_stack+736260,int_stack+693133,28);
 /*--- compute (i0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+684789,int_stack+745500,int_stack+1941526,28);
 /*--- compute (i0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+758100,int_stack+684789,int_stack+724500,28);
 /*--- compute (i0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+724500,int_stack+465374,int_stack+463190,28);
 /*--- compute (i0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1936906,int_stack+724500,int_stack+679245,28);
 /*--- compute (i0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+774564,int_stack+1936906,int_stack+736260,28);
 /*--- compute (i0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+724500,int_stack+774564,int_stack+745500,28);
 /*--- compute (i0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+1347562,int_stack+724500,int_stack+684789,28);
 /*--- compute (i0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+724500,int_stack+1347562,int_stack+758100,28);
 /*--- compute (hp|ii) ---*/
   d1hrr1_build_hp(Libderiv->AB,int_stack+746452,int_stack+724500,int_stack+708036, 1.0, int_stack+1952782, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1347562,int_stack+483294,int_stack+482286,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1350586,int_stack+484590,int_stack+483294,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1354474,int_stack+1350586,int_stack+1347562,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1360522,int_stack+486210,int_stack+484590,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+795844,int_stack+1360522,int_stack+1350586,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+803620,int_stack+795844,int_stack+1354474,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1347562,int_stack+488190,int_stack+486210,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+813700,int_stack+1347562,int_stack+1360522,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1353502,int_stack+813700,int_stack+795844,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+823420,int_stack+1353502,int_stack+803620,36);
 /*--- compute (k0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+795844,int_stack+490566,int_stack+488190,36);
 /*--- compute (k0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+838540,int_stack+795844,int_stack+1347562,36);
 /*--- compute (k0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+850420,int_stack+838540,int_stack+813700,36);
 /*--- compute (k0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+802972,int_stack+850420,int_stack+1353502,36);
 /*--- compute (k0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+1347562,int_stack+802972,int_stack+823420,36);
 /*--- compute (k0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+822412,int_stack+493374,int_stack+490566,36);
 /*--- compute (k0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+866620,int_stack+822412,int_stack+795844,36);
 /*--- compute (k0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+880876,int_stack+866620,int_stack+838540,36);
 /*--- compute (k0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+822412,int_stack+880876,int_stack+850420,36);
 /*--- compute (k0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+846712,int_stack+822412,int_stack+802972,36);
 /*--- compute (k0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+795844,int_stack+846712,int_stack+1347562,36);
 /*--- compute (ip|ii) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+824068,int_stack+795844,int_stack+724500, 1.0, int_stack+1969246, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (hd|ii) ---*/
   d1hrr1_build_hd(Libderiv->AB,int_stack+345246,int_stack+824068,int_stack+746452, 1.0, int_stack+1177768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1177768,int_stack+497910,int_stack+496650,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1181548,int_stack+499530,int_stack+497910,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+1186408,int_stack+1181548,int_stack+1177768,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1193968,int_stack+501555,int_stack+499530,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1200043,int_stack+1193968,int_stack+1181548,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1209763,int_stack+1200043,int_stack+1186408,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+1177768,int_stack+504030,int_stack+501555,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1222363,int_stack+1177768,int_stack+1193968,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1347562,int_stack+1222363,int_stack+1200043,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1185193,int_stack+1347562,int_stack+1209763,45);
 /*--- compute (l0|np) ---*/
   hrr3_build_np(Libderiv->CD,int_stack+1204093,int_stack+507000,int_stack+504030,45);
 /*--- compute (l0|md) ---*/
   hrr3_build_md(Libderiv->CD,int_stack+889924,int_stack+1204093,int_stack+1177768,45);
 /*--- compute (l0|lf) ---*/
   hrr3_build_lf(Libderiv->CD,int_stack+904774,int_stack+889924,int_stack+1222363,45);
 /*--- compute (l0|kg) ---*/
   hrr3_build_kg(Libderiv->CD,int_stack+1213003,int_stack+904774,int_stack+1347562,45);
 /*--- compute (l0|ih) ---*/
   hrr3_build_ih(Libderiv->CD,int_stack+925024,int_stack+1213003,int_stack+1185193,45);
 /*--- compute (l0|op) ---*/
   hrr3_build_op(Libderiv->CD,int_stack+1347562,int_stack+510510,int_stack+507000,45);
 /*--- compute (l0|nd) ---*/
   hrr3_build_nd(Libderiv->CD,int_stack+1177768,int_stack+1347562,int_stack+1204093,45);
 /*--- compute (l0|mf) ---*/
   hrr3_build_mf(Libderiv->CD,int_stack+951484,int_stack+1177768,int_stack+889924,45);
 /*--- compute (l0|lg) ---*/
   hrr3_build_lg(Libderiv->CD,int_stack+1177768,int_stack+951484,int_stack+904774,45);
 /*--- compute (l0|kh) ---*/
   hrr3_build_kh(Libderiv->CD,int_stack+889924,int_stack+1177768,int_stack+1213003,45);
 /*--- compute (l0|ii) ---*/
   hrr3_build_ii(Libderiv->CD,int_stack+1177768,int_stack+889924,int_stack+925024,45);
 /*--- compute (kp|ii) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+889924,int_stack+1177768,int_stack+795844, 1.0, int_stack+1991198, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (id|ii) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+679245,int_stack+889924,int_stack+824068, 1.0, int_stack+514605, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
 /*--- compute (hf|ii) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+810957,int_stack+1368730,int_stack+1078984,784);
     Libderiv->ABCD[11] = int_stack + 810957;
 /*--- compute (hf|ii) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1078342,int_stack+1650970,int_stack+1248778,784);
     Libderiv->ABCD[10] = int_stack + 1078342;
 /*--- compute (hf|ii) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1632154,int_stack+1500442,int_stack+979558,784);
     Libderiv->ABCD[9] = int_stack + 1632154;
 /*--- compute (hf|ii) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1242982,int_stack+2021578,int_stack+1838122,784);
     Libderiv->ABCD[8] = int_stack + 1242982;
 /*--- compute (hf|ii) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1796794,int_stack+2252074,int_stack+2153290,784);
     Libderiv->ABCD[7] = int_stack + 1796794;
 /*--- compute (hf|ii) ---*/
   hrr1_build_hf(Libderiv->AB,int_stack+1961434,int_stack+2383786,int_stack+147678,784);
     Libderiv->ABCD[6] = int_stack + 1961434;
 /*--- compute (hf|ii) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+2126074,int_stack+2515498,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[2] = int_stack + 2126074;
 /*--- compute (hf|ii) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+0,int_stack+2647210,int_stack+246462, 0.0, zero_stack, 1.0, int_stack+580461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[1] = int_stack + 0;
 /*--- compute (hf|ii) ---*/
   d1hrr1_build_hf(Libderiv->AB,int_stack+164640,int_stack+679245,int_stack+345246, 1.0, int_stack+580461, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,784);
     Libderiv->ABCD[0] = int_stack + 164640;

}
