/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include <string.h>
#include <libint/libint.h>
#include "libderiv.h"
#include <libint/hrr_header.h>

#include "d1hrr_header.h"

extern void d1vrr_order_ighh(Libderiv_t *, prim_data *);

  /* Computes derivatives of (ig|hh) integrals */

void d1hrr_order_ighh(Libderiv_t *Libderiv, int num_prim_comb)
{
 prim_data *Data = Libderiv->PrimQuartet;
 double *int_stack = Libderiv->int_stack;
 double *zero_stack = Libderiv->zero_stack;
 int i,j;
 double tmp, *target;

 Libderiv->deriv_classes[6][5][11] = int_stack + 0;
 Libderiv->deriv_classes[6][6][11] = int_stack + 588;
 Libderiv->deriv_classes[6][7][11] = int_stack + 1372;
 Libderiv->deriv_classes[6][8][11] = int_stack + 2380;
 Libderiv->deriv_classes[6][9][11] = int_stack + 3640;
 Libderiv->deriv_classes[6][10][11] = int_stack + 5180;
 Libderiv->deriv_classes[7][5][11] = int_stack + 7028;
 Libderiv->deriv_classes[7][6][11] = int_stack + 7784;
 Libderiv->deriv_classes[7][7][11] = int_stack + 8792;
 Libderiv->deriv_classes[7][8][11] = int_stack + 10088;
 Libderiv->deriv_classes[7][9][11] = int_stack + 11708;
 Libderiv->deriv_classes[7][10][11] = int_stack + 13688;
 Libderiv->deriv_classes[8][5][11] = int_stack + 16064;
 Libderiv->deriv_classes[8][6][11] = int_stack + 17009;
 Libderiv->deriv_classes[8][7][11] = int_stack + 18269;
 Libderiv->deriv_classes[8][8][11] = int_stack + 19889;
 Libderiv->deriv_classes[8][9][11] = int_stack + 21914;
 Libderiv->deriv_classes[8][10][11] = int_stack + 24389;
 Libderiv->deriv_classes[9][5][11] = int_stack + 27359;
 Libderiv->deriv_classes[9][6][11] = int_stack + 28514;
 Libderiv->deriv_classes[9][7][11] = int_stack + 30054;
 Libderiv->deriv_classes[9][8][11] = int_stack + 32034;
 Libderiv->deriv_classes[9][9][11] = int_stack + 34509;
 Libderiv->deriv_classes[9][10][11] = int_stack + 37534;
 Libderiv->deriv_classes[10][5][11] = int_stack + 41164;
 Libderiv->deriv_classes[10][6][11] = int_stack + 42550;
 Libderiv->deriv_classes[10][7][11] = int_stack + 44398;
 Libderiv->deriv_classes[10][8][11] = int_stack + 46774;
 Libderiv->deriv_classes[10][9][11] = int_stack + 49744;
 Libderiv->deriv_classes[10][10][11] = int_stack + 53374;
 Libderiv->deriv_classes[6][5][10] = int_stack + 57730;
 Libderiv->deriv_classes[6][6][10] = int_stack + 58318;
 Libderiv->deriv_classes[6][7][10] = int_stack + 59102;
 Libderiv->deriv_classes[6][8][10] = int_stack + 60110;
 Libderiv->deriv_classes[6][9][10] = int_stack + 61370;
 Libderiv->deriv_classes[6][10][10] = int_stack + 62910;
 Libderiv->deriv_classes[7][5][10] = int_stack + 64758;
 Libderiv->deriv_classes[7][6][10] = int_stack + 65514;
 Libderiv->deriv_classes[7][7][10] = int_stack + 66522;
 Libderiv->deriv_classes[7][8][10] = int_stack + 67818;
 Libderiv->deriv_classes[7][9][10] = int_stack + 69438;
 Libderiv->deriv_classes[7][10][10] = int_stack + 71418;
 Libderiv->deriv_classes[8][5][10] = int_stack + 73794;
 Libderiv->deriv_classes[8][6][10] = int_stack + 74739;
 Libderiv->deriv_classes[8][7][10] = int_stack + 75999;
 Libderiv->deriv_classes[8][8][10] = int_stack + 77619;
 Libderiv->deriv_classes[8][9][10] = int_stack + 79644;
 Libderiv->deriv_classes[8][10][10] = int_stack + 82119;
 Libderiv->deriv_classes[9][5][10] = int_stack + 85089;
 Libderiv->deriv_classes[9][6][10] = int_stack + 86244;
 Libderiv->deriv_classes[9][7][10] = int_stack + 87784;
 Libderiv->deriv_classes[9][8][10] = int_stack + 89764;
 Libderiv->deriv_classes[9][9][10] = int_stack + 92239;
 Libderiv->deriv_classes[9][10][10] = int_stack + 95264;
 Libderiv->deriv_classes[10][5][10] = int_stack + 98894;
 Libderiv->deriv_classes[10][6][10] = int_stack + 100280;
 Libderiv->deriv_classes[10][7][10] = int_stack + 102128;
 Libderiv->deriv_classes[10][8][10] = int_stack + 104504;
 Libderiv->deriv_classes[10][9][10] = int_stack + 107474;
 Libderiv->deriv_classes[10][10][10] = int_stack + 111104;
 Libderiv->deriv_classes[6][5][9] = int_stack + 115460;
 Libderiv->deriv_classes[6][6][9] = int_stack + 116048;
 Libderiv->deriv_classes[6][7][9] = int_stack + 116832;
 Libderiv->deriv_classes[6][8][9] = int_stack + 117840;
 Libderiv->deriv_classes[6][9][9] = int_stack + 119100;
 Libderiv->deriv_classes[6][10][9] = int_stack + 120640;
 Libderiv->deriv_classes[7][5][9] = int_stack + 122488;
 Libderiv->deriv_classes[7][6][9] = int_stack + 123244;
 Libderiv->deriv_classes[7][7][9] = int_stack + 124252;
 Libderiv->deriv_classes[7][8][9] = int_stack + 125548;
 Libderiv->deriv_classes[7][9][9] = int_stack + 127168;
 Libderiv->deriv_classes[7][10][9] = int_stack + 129148;
 Libderiv->deriv_classes[8][5][9] = int_stack + 131524;
 Libderiv->deriv_classes[8][6][9] = int_stack + 132469;
 Libderiv->deriv_classes[8][7][9] = int_stack + 133729;
 Libderiv->deriv_classes[8][8][9] = int_stack + 135349;
 Libderiv->deriv_classes[8][9][9] = int_stack + 137374;
 Libderiv->deriv_classes[8][10][9] = int_stack + 139849;
 Libderiv->deriv_classes[9][5][9] = int_stack + 142819;
 Libderiv->deriv_classes[9][6][9] = int_stack + 143974;
 Libderiv->deriv_classes[9][7][9] = int_stack + 145514;
 Libderiv->deriv_classes[9][8][9] = int_stack + 147494;
 Libderiv->deriv_classes[9][9][9] = int_stack + 149969;
 Libderiv->deriv_classes[9][10][9] = int_stack + 152994;
 Libderiv->deriv_classes[10][5][9] = int_stack + 156624;
 Libderiv->deriv_classes[10][6][9] = int_stack + 158010;
 Libderiv->deriv_classes[10][7][9] = int_stack + 159858;
 Libderiv->deriv_classes[10][8][9] = int_stack + 162234;
 Libderiv->deriv_classes[10][9][9] = int_stack + 165204;
 Libderiv->deriv_classes[10][10][9] = int_stack + 168834;
 Libderiv->deriv_classes[6][5][8] = int_stack + 173190;
 Libderiv->deriv_classes[6][6][8] = int_stack + 173778;
 Libderiv->deriv_classes[6][7][8] = int_stack + 174562;
 Libderiv->deriv_classes[6][8][8] = int_stack + 175570;
 Libderiv->deriv_classes[6][9][8] = int_stack + 176830;
 Libderiv->deriv_classes[6][10][8] = int_stack + 178370;
 Libderiv->deriv_classes[7][5][8] = int_stack + 180218;
 Libderiv->deriv_classes[7][6][8] = int_stack + 180974;
 Libderiv->deriv_classes[7][7][8] = int_stack + 181982;
 Libderiv->deriv_classes[7][8][8] = int_stack + 183278;
 Libderiv->deriv_classes[7][9][8] = int_stack + 184898;
 Libderiv->deriv_classes[7][10][8] = int_stack + 186878;
 Libderiv->deriv_classes[8][5][8] = int_stack + 189254;
 Libderiv->deriv_classes[8][6][8] = int_stack + 190199;
 Libderiv->deriv_classes[8][7][8] = int_stack + 191459;
 Libderiv->deriv_classes[8][8][8] = int_stack + 193079;
 Libderiv->deriv_classes[8][9][8] = int_stack + 195104;
 Libderiv->deriv_classes[8][10][8] = int_stack + 197579;
 Libderiv->deriv_classes[9][5][8] = int_stack + 200549;
 Libderiv->deriv_classes[9][6][8] = int_stack + 201704;
 Libderiv->deriv_classes[9][7][8] = int_stack + 203244;
 Libderiv->deriv_classes[9][8][8] = int_stack + 205224;
 Libderiv->deriv_classes[9][9][8] = int_stack + 207699;
 Libderiv->deriv_classes[9][10][8] = int_stack + 210724;
 Libderiv->deriv_classes[10][5][8] = int_stack + 214354;
 Libderiv->deriv_classes[10][6][8] = int_stack + 215740;
 Libderiv->deriv_classes[10][7][8] = int_stack + 217588;
 Libderiv->deriv_classes[10][8][8] = int_stack + 219964;
 Libderiv->deriv_classes[10][9][8] = int_stack + 222934;
 Libderiv->deriv_classes[10][10][8] = int_stack + 226564;
 Libderiv->deriv_classes[6][5][7] = int_stack + 230920;
 Libderiv->deriv_classes[6][6][7] = int_stack + 231508;
 Libderiv->deriv_classes[6][7][7] = int_stack + 232292;
 Libderiv->deriv_classes[6][8][7] = int_stack + 233300;
 Libderiv->deriv_classes[6][9][7] = int_stack + 234560;
 Libderiv->deriv_classes[6][10][7] = int_stack + 236100;
 Libderiv->deriv_classes[7][5][7] = int_stack + 237948;
 Libderiv->deriv_classes[7][6][7] = int_stack + 238704;
 Libderiv->deriv_classes[7][7][7] = int_stack + 239712;
 Libderiv->deriv_classes[7][8][7] = int_stack + 241008;
 Libderiv->deriv_classes[7][9][7] = int_stack + 242628;
 Libderiv->deriv_classes[7][10][7] = int_stack + 244608;
 Libderiv->deriv_classes[8][5][7] = int_stack + 246984;
 Libderiv->deriv_classes[8][6][7] = int_stack + 247929;
 Libderiv->deriv_classes[8][7][7] = int_stack + 249189;
 Libderiv->deriv_classes[8][8][7] = int_stack + 250809;
 Libderiv->deriv_classes[8][9][7] = int_stack + 252834;
 Libderiv->deriv_classes[8][10][7] = int_stack + 255309;
 Libderiv->deriv_classes[9][5][7] = int_stack + 258279;
 Libderiv->deriv_classes[9][6][7] = int_stack + 259434;
 Libderiv->deriv_classes[9][7][7] = int_stack + 260974;
 Libderiv->deriv_classes[9][8][7] = int_stack + 262954;
 Libderiv->deriv_classes[9][9][7] = int_stack + 265429;
 Libderiv->deriv_classes[9][10][7] = int_stack + 268454;
 Libderiv->deriv_classes[10][5][7] = int_stack + 272084;
 Libderiv->deriv_classes[10][6][7] = int_stack + 273470;
 Libderiv->deriv_classes[10][7][7] = int_stack + 275318;
 Libderiv->deriv_classes[10][8][7] = int_stack + 277694;
 Libderiv->deriv_classes[10][9][7] = int_stack + 280664;
 Libderiv->deriv_classes[10][10][7] = int_stack + 284294;
 Libderiv->deriv_classes[6][5][6] = int_stack + 288650;
 Libderiv->deriv_classes[6][6][6] = int_stack + 289238;
 Libderiv->deriv_classes[6][7][6] = int_stack + 290022;
 Libderiv->deriv_classes[6][8][6] = int_stack + 291030;
 Libderiv->deriv_classes[6][9][6] = int_stack + 292290;
 Libderiv->deriv_classes[6][10][6] = int_stack + 293830;
 Libderiv->deriv_classes[7][5][6] = int_stack + 295678;
 Libderiv->deriv_classes[7][6][6] = int_stack + 296434;
 Libderiv->deriv_classes[7][7][6] = int_stack + 297442;
 Libderiv->deriv_classes[7][8][6] = int_stack + 298738;
 Libderiv->deriv_classes[7][9][6] = int_stack + 300358;
 Libderiv->deriv_classes[7][10][6] = int_stack + 302338;
 Libderiv->deriv_classes[8][5][6] = int_stack + 304714;
 Libderiv->deriv_classes[8][6][6] = int_stack + 305659;
 Libderiv->deriv_classes[8][7][6] = int_stack + 306919;
 Libderiv->deriv_classes[8][8][6] = int_stack + 308539;
 Libderiv->deriv_classes[8][9][6] = int_stack + 310564;
 Libderiv->deriv_classes[8][10][6] = int_stack + 313039;
 Libderiv->deriv_classes[9][5][6] = int_stack + 316009;
 Libderiv->deriv_classes[9][6][6] = int_stack + 317164;
 Libderiv->deriv_classes[9][7][6] = int_stack + 318704;
 Libderiv->deriv_classes[9][8][6] = int_stack + 320684;
 Libderiv->deriv_classes[9][9][6] = int_stack + 323159;
 Libderiv->deriv_classes[9][10][6] = int_stack + 326184;
 Libderiv->dvrr_classes[10][5] = int_stack + 329814;
 Libderiv->deriv_classes[10][5][6] = int_stack + 331200;
 Libderiv->dvrr_classes[10][6] = int_stack + 332586;
 Libderiv->deriv_classes[10][6][6] = int_stack + 334434;
 Libderiv->dvrr_classes[10][7] = int_stack + 336282;
 Libderiv->deriv_classes[10][7][6] = int_stack + 338658;
 Libderiv->dvrr_classes[10][8] = int_stack + 341034;
 Libderiv->deriv_classes[10][8][6] = int_stack + 344004;
 Libderiv->dvrr_classes[10][9] = int_stack + 346974;
 Libderiv->deriv_classes[10][9][6] = int_stack + 350604;
 Libderiv->deriv_classes[10][10][6] = int_stack + 354234;
 Libderiv->deriv_classes[6][5][2] = int_stack + 358590;
 Libderiv->deriv_classes[6][6][2] = int_stack + 359178;
 Libderiv->deriv_classes[6][7][2] = int_stack + 359962;
 Libderiv->deriv_classes[6][8][2] = int_stack + 360970;
 Libderiv->deriv_classes[6][9][2] = int_stack + 362230;
 Libderiv->deriv_classes[6][10][2] = int_stack + 363770;
 Libderiv->deriv_classes[7][5][2] = int_stack + 365618;
 Libderiv->deriv_classes[7][6][2] = int_stack + 366374;
 Libderiv->deriv_classes[7][7][2] = int_stack + 367382;
 Libderiv->deriv_classes[7][8][2] = int_stack + 368678;
 Libderiv->deriv_classes[7][9][2] = int_stack + 370298;
 Libderiv->deriv_classes[7][10][2] = int_stack + 372278;
 Libderiv->deriv_classes[8][5][2] = int_stack + 374654;
 Libderiv->deriv_classes[8][6][2] = int_stack + 375599;
 Libderiv->deriv_classes[8][7][2] = int_stack + 376859;
 Libderiv->deriv_classes[8][8][2] = int_stack + 378479;
 Libderiv->deriv_classes[8][9][2] = int_stack + 380504;
 Libderiv->deriv_classes[8][10][2] = int_stack + 382979;
 Libderiv->deriv_classes[9][5][2] = int_stack + 385949;
 Libderiv->deriv_classes[9][6][2] = int_stack + 387104;
 Libderiv->deriv_classes[9][7][2] = int_stack + 388644;
 Libderiv->deriv_classes[9][8][2] = int_stack + 390624;
 Libderiv->deriv_classes[9][9][2] = int_stack + 393099;
 Libderiv->deriv_classes[9][10][2] = int_stack + 396124;
 Libderiv->deriv_classes[10][5][2] = int_stack + 399754;
 Libderiv->deriv_classes[10][6][2] = int_stack + 401140;
 Libderiv->deriv_classes[10][7][2] = int_stack + 402988;
 Libderiv->deriv_classes[10][8][2] = int_stack + 405364;
 Libderiv->deriv_classes[10][9][2] = int_stack + 408334;
 Libderiv->deriv_classes[10][10][2] = int_stack + 411964;
 Libderiv->deriv_classes[6][5][1] = int_stack + 416320;
 Libderiv->deriv_classes[6][6][1] = int_stack + 416908;
 Libderiv->deriv_classes[6][7][1] = int_stack + 417692;
 Libderiv->deriv_classes[6][8][1] = int_stack + 418700;
 Libderiv->deriv_classes[6][9][1] = int_stack + 419960;
 Libderiv->deriv_classes[6][10][1] = int_stack + 421500;
 Libderiv->deriv_classes[7][5][1] = int_stack + 423348;
 Libderiv->deriv_classes[7][6][1] = int_stack + 424104;
 Libderiv->deriv_classes[7][7][1] = int_stack + 425112;
 Libderiv->deriv_classes[7][8][1] = int_stack + 426408;
 Libderiv->deriv_classes[7][9][1] = int_stack + 428028;
 Libderiv->deriv_classes[7][10][1] = int_stack + 430008;
 Libderiv->deriv_classes[8][5][1] = int_stack + 432384;
 Libderiv->deriv_classes[8][6][1] = int_stack + 433329;
 Libderiv->deriv_classes[8][7][1] = int_stack + 434589;
 Libderiv->deriv_classes[8][8][1] = int_stack + 436209;
 Libderiv->deriv_classes[8][9][1] = int_stack + 438234;
 Libderiv->deriv_classes[8][10][1] = int_stack + 440709;
 Libderiv->deriv_classes[9][5][1] = int_stack + 443679;
 Libderiv->deriv_classes[9][6][1] = int_stack + 444834;
 Libderiv->deriv_classes[9][7][1] = int_stack + 446374;
 Libderiv->deriv_classes[9][8][1] = int_stack + 448354;
 Libderiv->deriv_classes[9][9][1] = int_stack + 450829;
 Libderiv->deriv_classes[9][10][1] = int_stack + 453854;
 Libderiv->deriv_classes[10][5][1] = int_stack + 457484;
 Libderiv->deriv_classes[10][6][1] = int_stack + 458870;
 Libderiv->deriv_classes[10][7][1] = int_stack + 460718;
 Libderiv->deriv_classes[10][8][1] = int_stack + 463094;
 Libderiv->deriv_classes[10][9][1] = int_stack + 466064;
 Libderiv->deriv_classes[10][10][1] = int_stack + 469694;
 Libderiv->dvrr_classes[6][5] = int_stack + 474050;
 Libderiv->dvrr_classes[6][6] = int_stack + 474638;
 Libderiv->dvrr_classes[6][7] = int_stack + 475422;
 Libderiv->dvrr_classes[6][8] = int_stack + 476430;
 Libderiv->dvrr_classes[6][9] = int_stack + 477690;
 Libderiv->dvrr_classes[6][10] = int_stack + 479230;
 Libderiv->deriv_classes[6][5][0] = int_stack + 481078;
 Libderiv->deriv_classes[6][6][0] = int_stack + 481666;
 Libderiv->deriv_classes[6][7][0] = int_stack + 482450;
 Libderiv->deriv_classes[6][8][0] = int_stack + 483458;
 Libderiv->deriv_classes[6][9][0] = int_stack + 484718;
 Libderiv->deriv_classes[6][10][0] = int_stack + 486258;
 Libderiv->dvrr_classes[7][5] = int_stack + 488106;
 Libderiv->dvrr_classes[7][6] = int_stack + 488862;
 Libderiv->dvrr_classes[7][7] = int_stack + 489870;
 Libderiv->dvrr_classes[7][8] = int_stack + 491166;
 Libderiv->dvrr_classes[7][9] = int_stack + 492786;
 Libderiv->dvrr_classes[7][10] = int_stack + 494766;
 Libderiv->deriv_classes[7][5][0] = int_stack + 497142;
 Libderiv->deriv_classes[7][6][0] = int_stack + 497898;
 Libderiv->deriv_classes[7][7][0] = int_stack + 498906;
 Libderiv->deriv_classes[7][8][0] = int_stack + 500202;
 Libderiv->deriv_classes[7][9][0] = int_stack + 501822;
 Libderiv->deriv_classes[7][10][0] = int_stack + 503802;
 Libderiv->dvrr_classes[8][5] = int_stack + 506178;
 Libderiv->dvrr_classes[8][6] = int_stack + 507123;
 Libderiv->dvrr_classes[8][7] = int_stack + 508383;
 Libderiv->dvrr_classes[8][8] = int_stack + 510003;
 Libderiv->dvrr_classes[8][9] = int_stack + 512028;
 Libderiv->dvrr_classes[8][10] = int_stack + 514503;
 Libderiv->deriv_classes[8][5][0] = int_stack + 517473;
 Libderiv->deriv_classes[8][6][0] = int_stack + 518418;
 Libderiv->deriv_classes[8][7][0] = int_stack + 519678;
 Libderiv->deriv_classes[8][8][0] = int_stack + 521298;
 Libderiv->deriv_classes[8][9][0] = int_stack + 523323;
 Libderiv->deriv_classes[8][10][0] = int_stack + 525798;
 Libderiv->dvrr_classes[9][5] = int_stack + 528768;
 Libderiv->dvrr_classes[9][6] = int_stack + 529923;
 Libderiv->dvrr_classes[9][7] = int_stack + 531463;
 Libderiv->dvrr_classes[9][8] = int_stack + 533443;
 Libderiv->dvrr_classes[9][9] = int_stack + 535918;
 Libderiv->dvrr_classes[9][10] = int_stack + 538943;
 Libderiv->deriv_classes[9][5][0] = int_stack + 542573;
 Libderiv->deriv_classes[9][6][0] = int_stack + 543728;
 Libderiv->deriv_classes[9][7][0] = int_stack + 545268;
 Libderiv->deriv_classes[9][8][0] = int_stack + 547248;
 Libderiv->deriv_classes[9][9][0] = int_stack + 549723;
 Libderiv->deriv_classes[9][10][0] = int_stack + 552748;
 Libderiv->deriv_classes[10][5][0] = int_stack + 556378;
 Libderiv->deriv_classes[10][6][0] = int_stack + 557764;
 Libderiv->deriv_classes[10][7][0] = int_stack + 559612;
 Libderiv->deriv_classes[10][8][0] = int_stack + 561988;
 Libderiv->deriv_classes[10][9][0] = int_stack + 564958;
 Libderiv->deriv_classes[10][10][0] = int_stack + 568588;
 memset(int_stack,0,4583552);

 Libderiv->dvrr_stack = int_stack + 3592704;
 for(i=0;i<num_prim_comb;i++) {
   d1vrr_order_ighh(Libderiv, Data);
   Data++;
 }

 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+572944,int_stack+474638,int_stack+474050,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+574708,int_stack+475422,int_stack+474638,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+577060,int_stack+574708,int_stack+572944,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+580588,int_stack+476430,int_stack+475422,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+583612,int_stack+580588,int_stack+574708,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+588316,int_stack+583612,int_stack+577060,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+594196,int_stack+477690,int_stack+476430,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+597976,int_stack+594196,int_stack+580588,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+604024,int_stack+597976,int_stack+583612,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+611864,int_stack+604024,int_stack+588316,28);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+620684,int_stack+588,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474050,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+622448,int_stack+1372,int_stack+588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474638,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+624800,int_stack+622448,int_stack+620684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572944,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+628328,int_stack+2380,int_stack+1372, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475422,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+631352,int_stack+628328,int_stack+622448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574708,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+636056,int_stack+631352,int_stack+624800, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577060,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+620684,int_stack+3640,int_stack+2380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476430,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+641936,int_stack+620684,int_stack+628328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580588,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+647984,int_stack+641936,int_stack+631352, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583612,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+624464,int_stack+647984,int_stack+636056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588316,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+633284,int_stack+5180,int_stack+3640, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477690,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+655824,int_stack+633284,int_stack+620684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594196,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+663384,int_stack+655824,int_stack+641936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597976,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+633284,int_stack+663384,int_stack+647984, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604024,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+645044,int_stack+633284,int_stack+624464, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611864,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+620684,int_stack+488862,int_stack+488106,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+622952,int_stack+489870,int_stack+488862,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+625976,int_stack+622952,int_stack+620684,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+630512,int_stack+491166,int_stack+489870,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+634400,int_stack+630512,int_stack+622952,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+657392,int_stack+634400,int_stack+625976,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+664952,int_stack+492786,int_stack+491166,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+669812,int_stack+664952,int_stack+630512,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+677588,int_stack+669812,int_stack+634400,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+687668,int_stack+677588,int_stack+657392,36);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+640448,int_stack+7784,int_stack+7028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488106,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+0,int_stack+8792,int_stack+7784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488862,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+3024,int_stack+0,int_stack+640448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620684,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+640448,int_stack+10088,int_stack+8792, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489870,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+699008,int_stack+640448,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622952,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+705056,int_stack+699008,int_stack+3024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625976,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+11708,int_stack+10088, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491166,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+712616,int_stack+0,int_stack+640448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630512,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+720392,int_stack+712616,int_stack+699008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634400,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+730472,int_stack+720392,int_stack+705056, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657392,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+699008,int_stack+13688,int_stack+11708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492786,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+4860,int_stack+699008,int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664952,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+699008,int_stack+4860,int_stack+712616, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669812,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+699008,int_stack+720392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677588,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+699008,int_stack+0,int_stack+730472, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687668,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+714884,int_stack+699008,int_stack+645044,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+507123,int_stack+506178,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2835,int_stack+508383,int_stack+507123,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+6615,int_stack+2835,int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+640448,int_stack+510003,int_stack+508383,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+645308,int_stack+640448,int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+751928,int_stack+645308,int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+761378,int_stack+512028,int_stack+510003,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+767453,int_stack+761378,int_stack+640448,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+777173,int_stack+767453,int_stack+645308,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+789773,int_stack+777173,int_stack+751928,45);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+12285,int_stack+17009,int_stack+16064, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506178,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+652868,int_stack+18269,int_stack+17009, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507123,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+803948,int_stack+652868,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+12285,int_stack+19889,int_stack+18269, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508383,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+809618,int_stack+12285,int_stack+652868, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+817178,int_stack+809618,int_stack+803948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+826628,int_stack+21914,int_stack+19889, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510003,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+832703,int_stack+826628,int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640448,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+842423,int_stack+832703,int_stack+809618, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645308,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+855023,int_stack+842423,int_stack+817178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751928,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+12285,int_stack+24389,int_stack+21914, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512028,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+803948,int_stack+12285,int_stack+826628, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761378,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+816098,int_stack+803948,int_stack+832703, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767453,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+869198,int_stack+816098,int_stack+842423, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777173,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+803948,int_stack+869198,int_stack+855023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+789773,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+823793,int_stack+803948,int_stack+699008,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+871421,int_stack+823793,int_stack+714884,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+699008,int_stack+529923,int_stack+528768,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+702473,int_stack+531463,int_stack+529923,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+707093,int_stack+702473,int_stack+699008,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+714023,int_stack+533443,int_stack+531463,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+719963,int_stack+714023,int_stack+702473,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+729203,int_stack+719963,int_stack+707093,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+740753,int_stack+535918,int_stack+533443,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+12285,int_stack+740753,int_stack+714023,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+945509,int_stack+12285,int_stack+719963,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+960909,int_stack+945509,int_stack+729203,55);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+748178,int_stack+28514,int_stack+27359, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528768,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+978234,int_stack+30054,int_stack+28514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529923,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+982854,int_stack+978234,int_stack+748178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699008,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+989784,int_stack+32034,int_stack+30054, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+531463,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+995724,int_stack+989784,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702473,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1004964,int_stack+995724,int_stack+982854, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707093,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+978234,int_stack+34509,int_stack+32034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533443,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1016514,int_stack+978234,int_stack+989784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714023,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1028394,int_stack+1016514,int_stack+995724, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719963,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+985659,int_stack+1028394,int_stack+1004964, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729203,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1002984,int_stack+37534,int_stack+34509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535918,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+24165,int_stack+1002984,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+740753,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1043794,int_stack+24165,int_stack+1016514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1002984,int_stack+1043794,int_stack+1028394, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945509,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1026084,int_stack+1002984,int_stack+985659, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960909,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1050339,int_stack+1026084,int_stack+803948,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1109874,int_stack+1050339,int_stack+823793,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1205130,int_stack+1109874,int_stack+871421,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+803948,int_stack+332586,int_stack+329814,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+808106,int_stack+336282,int_stack+332586,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+813650,int_stack+808106,int_stack+803948,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+821966,int_stack+341034,int_stack+336282,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+829094,int_stack+821966,int_stack+808106,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+840182,int_stack+829094,int_stack+813650,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+854042,int_stack+346974,int_stack+341034,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+862952,int_stack+854042,int_stack+821966,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+877208,int_stack+862952,int_stack+829094,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+895688,int_stack+877208,int_stack+840182,66);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+916478,int_stack+42550,int_stack+41164, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329814,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+920636,int_stack+44398,int_stack+42550, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332586,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+926180,int_stack+920636,int_stack+916478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803948,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+934496,int_stack+46774,int_stack+44398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336282,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+24165,int_stack+934496,int_stack+920636, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808106,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+978234,int_stack+24165,int_stack+926180, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813650,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+916478,int_stack+49744,int_stack+46774, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341034,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+35253,int_stack+916478,int_stack+934496, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821966,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+925388,int_stack+35253,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829094,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+992094,int_stack+925388,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840182,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+978234,int_stack+53374,int_stack+49744, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346974,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1328610,int_stack+978234,int_stack+916478, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854042,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1346430,int_stack+1328610,int_stack+35253, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862952,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+24165,int_stack+1346430,int_stack+925388, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877208,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1328610,int_stack+24165,int_stack+992094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895688,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1357716,int_stack+1328610,int_stack+1026084,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+1430481,int_stack+1357716,int_stack+1050339,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+1549551,int_stack+1430481,int_stack+1109874,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328610,int_stack+58318,int_stack+57730, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474050, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1330374,int_stack+59102,int_stack+58318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474638, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1332726,int_stack+1330374,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572944, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1336254,int_stack+60110,int_stack+59102, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475422, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1339278,int_stack+1336254,int_stack+1330374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574708, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1343982,int_stack+1339278,int_stack+1332726, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577060, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328610,int_stack+61370,int_stack+60110, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476430, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1349862,int_stack+1328610,int_stack+1336254, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580588, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1355910,int_stack+1349862,int_stack+1339278, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583612, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1332390,int_stack+1355910,int_stack+1343982, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588316, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1341210,int_stack+62910,int_stack+61370, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477690, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1363750,int_stack+1341210,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594196, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1371310,int_stack+1363750,int_stack+1349862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597976, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1341210,int_stack+1371310,int_stack+1355910, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604024, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1352970,int_stack+1341210,int_stack+1332390, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611864, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328610,int_stack+65514,int_stack+64758, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488106, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1330878,int_stack+66522,int_stack+65514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488862, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1333902,int_stack+1330878,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620684, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1338438,int_stack+67818,int_stack+66522, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489870, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1342326,int_stack+1338438,int_stack+1330878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622952, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1365318,int_stack+1342326,int_stack+1333902, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625976, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328610,int_stack+69438,int_stack+67818, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491166, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1372878,int_stack+1328610,int_stack+1338438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630512, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1380654,int_stack+1372878,int_stack+1342326, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634400, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1333470,int_stack+1380654,int_stack+1365318, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657392, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1365318,int_stack+71418,int_stack+69438, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492786, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1390734,int_stack+1365318,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664952, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1400454,int_stack+1390734,int_stack+1372878, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669812, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1365318,int_stack+1400454,int_stack+1380654, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677588, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1380438,int_stack+1365318,int_stack+1333470, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687668, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1396314,int_stack+1380438,int_stack+1352970,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1328610,int_stack+74739,int_stack+73794, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506178, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1331445,int_stack+75999,int_stack+74739, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507123, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1335225,int_stack+1331445,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1340895,int_stack+77619,int_stack+75999, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508383, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1345755,int_stack+1340895,int_stack+1331445, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1353315,int_stack+1345755,int_stack+1335225, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1328610,int_stack+79644,int_stack+77619, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510003, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1362765,int_stack+1328610,int_stack+1340895, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640448, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1433358,int_stack+1362765,int_stack+1345755, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645308, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1334685,int_stack+1433358,int_stack+1353315, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751928, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1348860,int_stack+82119,int_stack+79644, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512028, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1445958,int_stack+1348860,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761378, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1458108,int_stack+1445958,int_stack+1362765, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767453, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1348860,int_stack+1458108,int_stack+1433358, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777173, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1433358,int_stack+1348860,int_stack+1334685, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+789773, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1453203,int_stack+1433358,int_stack+1380438,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+978234,int_stack+1453203,int_stack+1396314,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1500831,int_stack+86244,int_stack+85089, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528768, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1504296,int_stack+87784,int_stack+86244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529923, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1508916,int_stack+1504296,int_stack+1500831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699008, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1515846,int_stack+89764,int_stack+87784, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+531463, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1521786,int_stack+1515846,int_stack+1504296, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702473, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1531026,int_stack+1521786,int_stack+1508916, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707093, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1500831,int_stack+92239,int_stack+89764, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533443, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1328610,int_stack+1500831,int_stack+1515846, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714023, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1340490,int_stack+1328610,int_stack+1521786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719963, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1508256,int_stack+1340490,int_stack+1531026, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729203, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1525581,int_stack+95264,int_stack+92239, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535918, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1534656,int_stack+1525581,int_stack+1500831, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+740753, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1355890,int_stack+1534656,int_stack+1328610, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1525581,int_stack+1355890,int_stack+1340490, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945509, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1328610,int_stack+1525581,int_stack+1508256, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960909, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1352865,int_stack+1328610,int_stack+1433358,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1052322,int_stack+1352865,int_stack+1453203,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1412400,int_stack+1052322,int_stack+978234,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+978234,int_stack+100280,int_stack+98894, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329814, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982392,int_stack+102128,int_stack+100280, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332586, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+987936,int_stack+982392,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803948, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+996252,int_stack+104504,int_stack+102128, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336282, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1003380,int_stack+996252,int_stack+982392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808106, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1014468,int_stack+1003380,int_stack+987936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813650, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+978234,int_stack+107474,int_stack+104504, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341034, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1028328,int_stack+978234,int_stack+996252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821966, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+24165,int_stack+1028328,int_stack+1003380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829094, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+987144,int_stack+24165,int_stack+1014468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840182, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1007934,int_stack+111104,int_stack+107474, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346974, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+42645,int_stack+1007934,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854042, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+60465,int_stack+42645,int_stack+1028328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862952, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1007934,int_stack+60465,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877208, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+24165,int_stack+1007934,int_stack+987144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895688, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+978234,int_stack+24165,int_stack+1328610,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+1708311,int_stack+978234,int_stack+1352865,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+1827381,int_stack+1708311,int_stack+1052322,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+116048,int_stack+115460, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474050, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1710075,int_stack+116832,int_stack+116048, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474638, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1712427,int_stack+1710075,int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1715955,int_stack+117840,int_stack+116832, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475422, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1718979,int_stack+1715955,int_stack+1710075, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574708, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1723683,int_stack+1718979,int_stack+1712427, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577060, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708311,int_stack+119100,int_stack+117840, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476430, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1729563,int_stack+1708311,int_stack+1715955, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580588, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1735611,int_stack+1729563,int_stack+1718979, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583612, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1712091,int_stack+1735611,int_stack+1723683, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588316, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1720911,int_stack+120640,int_stack+119100, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477690, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1743451,int_stack+1720911,int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594196, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1751011,int_stack+1743451,int_stack+1729563, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597976, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1720911,int_stack+1751011,int_stack+1735611, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604024, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1732671,int_stack+1720911,int_stack+1712091, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611864, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+123244,int_stack+122488, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488106, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1710579,int_stack+124252,int_stack+123244, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488862, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1713603,int_stack+1710579,int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620684, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1718139,int_stack+125548,int_stack+124252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489870, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1722027,int_stack+1718139,int_stack+1710579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622952, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1745019,int_stack+1722027,int_stack+1713603, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625976, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708311,int_stack+127168,int_stack+125548, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491166, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1752579,int_stack+1708311,int_stack+1718139, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630512, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1760355,int_stack+1752579,int_stack+1722027, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634400, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1713171,int_stack+1760355,int_stack+1745019, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657392, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1745019,int_stack+129148,int_stack+127168, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492786, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1770435,int_stack+1745019,int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664952, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1780155,int_stack+1770435,int_stack+1752579, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669812, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1745019,int_stack+1780155,int_stack+1760355, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677588, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1760139,int_stack+1745019,int_stack+1713171, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687668, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1776015,int_stack+1760139,int_stack+1732671,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+132469,int_stack+131524, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506178, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1711146,int_stack+133729,int_stack+132469, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507123, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1714926,int_stack+1711146,int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1720596,int_stack+135349,int_stack+133729, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508383, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1725456,int_stack+1720596,int_stack+1711146, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1733016,int_stack+1725456,int_stack+1714926, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708311,int_stack+137374,int_stack+135349, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510003, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1742466,int_stack+1708311,int_stack+1720596, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640448, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1813059,int_stack+1742466,int_stack+1725456, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645308, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1714386,int_stack+1813059,int_stack+1733016, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751928, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1728561,int_stack+139849,int_stack+137374, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512028, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+978234,int_stack+1728561,int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761378, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+990384,int_stack+978234,int_stack+1742466, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767453, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1728561,int_stack+990384,int_stack+1813059, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777173, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+978234,int_stack+1728561,int_stack+1714386, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+789773, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+998079,int_stack+978234,int_stack+1760139,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1045707,int_stack+998079,int_stack+1776015,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1119795,int_stack+143974,int_stack+142819, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528768, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1123260,int_stack+145514,int_stack+143974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529923, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1127880,int_stack+1123260,int_stack+1119795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699008, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1134810,int_stack+147494,int_stack+145514, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+531463, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1140750,int_stack+1134810,int_stack+1123260, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702473, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1149990,int_stack+1140750,int_stack+1127880, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707093, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1119795,int_stack+149969,int_stack+147494, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533443, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1161540,int_stack+1119795,int_stack+1134810, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714023, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1173420,int_stack+1161540,int_stack+1140750, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719963, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1127220,int_stack+1173420,int_stack+1149990, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729203, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1144545,int_stack+152994,int_stack+149969, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535918, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1188820,int_stack+1144545,int_stack+1119795, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+740753, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1708311,int_stack+1188820,int_stack+1161540, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1144545,int_stack+1708311,int_stack+1173420, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945509, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1708311,int_stack+1144545,int_stack+1127220, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960909, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1732566,int_stack+1708311,int_stack+978234,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+24165,int_stack+1732566,int_stack+998079,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+1986141,int_stack+24165,int_stack+1045707,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+978234,int_stack+158010,int_stack+156624, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329814, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+982392,int_stack+159858,int_stack+158010, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332586, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+987936,int_stack+982392,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803948, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+996252,int_stack+162234,int_stack+159858, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336282, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1003380,int_stack+996252,int_stack+982392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808106, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1014468,int_stack+1003380,int_stack+987936, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813650, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+978234,int_stack+165204,int_stack+162234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341034, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1028328,int_stack+978234,int_stack+996252, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821966, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1042584,int_stack+1028328,int_stack+1003380, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829094, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+987144,int_stack+1042584,int_stack+1014468, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840182, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1007934,int_stack+168834,int_stack+165204, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346974, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1061064,int_stack+1007934,int_stack+978234, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854042, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1078884,int_stack+1061064,int_stack+1028328, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862952, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1007934,int_stack+1078884,int_stack+1042584, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877208, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1035654,int_stack+1007934,int_stack+987144, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895688, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1064760,int_stack+1035654,int_stack+1708311,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+2109621,int_stack+1064760,int_stack+1732566,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+978234,int_stack+2109621,int_stack+24165,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24165,int_stack+173778,int_stack+173190, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+25929,int_stack+174562,int_stack+173778, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+474638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28281,int_stack+25929,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+31809,int_stack+175570,int_stack+174562, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+475422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+34833,int_stack+31809,int_stack+25929, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+574708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+39537,int_stack+34833,int_stack+28281, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+577060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+24165,int_stack+176830,int_stack+175570, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+476430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+45417,int_stack+24165,int_stack+31809, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+580588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+51465,int_stack+45417,int_stack+34833, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+583612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+27945,int_stack+51465,int_stack+39537, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+588316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+36765,int_stack+178370,int_stack+176830, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+477690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+59305,int_stack+36765,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+594196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+66865,int_stack+59305,int_stack+45417, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+597976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+36765,int_stack+66865,int_stack+51465, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+604024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+48525,int_stack+36765,int_stack+27945, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+611864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24165,int_stack+180974,int_stack+180218, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+26433,int_stack+181982,int_stack+180974, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+488862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+29457,int_stack+26433,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+620684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+33993,int_stack+183278,int_stack+181982, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+489870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+37881,int_stack+33993,int_stack+26433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+622952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+60873,int_stack+37881,int_stack+29457, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+625976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+24165,int_stack+184898,int_stack+183278, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+491166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+68433,int_stack+24165,int_stack+33993, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+630512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+76209,int_stack+68433,int_stack+37881, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+634400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+29025,int_stack+76209,int_stack+60873, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+657392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+60873,int_stack+186878,int_stack+184898, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+492786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+86289,int_stack+60873,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+664952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+96009,int_stack+86289,int_stack+68433, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+669812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+60873,int_stack+96009,int_stack+76209, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+677588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+75993,int_stack+60873,int_stack+29025, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+687668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+91869,int_stack+75993,int_stack+48525,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+24165,int_stack+190199,int_stack+189254, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+506178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+27000,int_stack+191459,int_stack+190199, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+507123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+30780,int_stack+27000,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+36450,int_stack+193079,int_stack+191459, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+508383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+41310,int_stack+36450,int_stack+27000, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+48870,int_stack+41310,int_stack+30780, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+24165,int_stack+195104,int_stack+193079, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+510003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+58320,int_stack+24165,int_stack+36450, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+640448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+128913,int_stack+58320,int_stack+41310, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+645308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+30240,int_stack+128913,int_stack+48870, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+751928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+44415,int_stack+197579,int_stack+195104, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+512028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+141513,int_stack+44415,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+761378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+153663,int_stack+141513,int_stack+58320, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+767453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+44415,int_stack+153663,int_stack+128913, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+777173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+128913,int_stack+44415,int_stack+30240, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+789773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+148758,int_stack+128913,int_stack+75993,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2109621,int_stack+148758,int_stack+91869,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+196386,int_stack+201704,int_stack+200549, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+528768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+24165,int_stack+203244,int_stack+201704, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+529923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+28785,int_stack+24165,int_stack+196386, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+699008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+196386,int_stack+205224,int_stack+203244, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+531463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+35715,int_stack+196386,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+702473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+44955,int_stack+35715,int_stack+28785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+707093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+24165,int_stack+207699,int_stack+205224, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+533443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+56505,int_stack+24165,int_stack+196386, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+714023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+68385,int_stack+56505,int_stack+35715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+719963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+83785,int_stack+68385,int_stack+44955, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+729203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+196386,int_stack+210724,int_stack+207699, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+535918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+31590,int_stack+196386,int_stack+24165, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+740753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+101110,int_stack+31590,int_stack+56505, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+24165,int_stack+101110,int_stack+68385, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+945509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+101110,int_stack+24165,int_stack+83785, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+960909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+24165,int_stack+101110,int_stack+128913,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+1708311,int_stack+24165,int_stack+148758,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2183709,int_stack+1708311,int_stack+2109621,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2109621,int_stack+215740,int_stack+214354, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+329814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2113779,int_stack+217588,int_stack+215740, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+332586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2119323,int_stack+2113779,int_stack+2109621, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+803948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2127639,int_stack+219964,int_stack+217588, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+336282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2134767,int_stack+2127639,int_stack+2113779, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+808106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2145855,int_stack+2134767,int_stack+2119323, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+813650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2109621,int_stack+222934,int_stack+219964, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+341034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2159715,int_stack+2109621,int_stack+2127639, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+821966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+125365,int_stack+2159715,int_stack+2134767, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+829094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2118531,int_stack+125365,int_stack+2145855, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+840182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2139321,int_stack+226564,int_stack+222934, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+346974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+143845,int_stack+2139321,int_stack+2109621, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+854042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+161665,int_stack+143845,int_stack+2159715, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+862952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2139321,int_stack+161665,int_stack+125365, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+877208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+125365,int_stack+2139321,int_stack+2118531, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+895688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+154471,int_stack+125365,int_stack+101110,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+2307189,int_stack+154471,int_stack+24165,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+24165,int_stack+2307189,int_stack+1708311,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+231508,int_stack+230920, 0.0, zero_stack, 1.0, int_stack+474050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1710075,int_stack+232292,int_stack+231508, 0.0, zero_stack, 1.0, int_stack+474638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1712427,int_stack+1710075,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1715955,int_stack+233300,int_stack+232292, 0.0, zero_stack, 1.0, int_stack+475422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1718979,int_stack+1715955,int_stack+1710075, 0.0, zero_stack, 1.0, int_stack+574708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1723683,int_stack+1718979,int_stack+1712427, 0.0, zero_stack, 1.0, int_stack+577060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708311,int_stack+234560,int_stack+233300, 0.0, zero_stack, 1.0, int_stack+476430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1729563,int_stack+1708311,int_stack+1715955, 0.0, zero_stack, 1.0, int_stack+580588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1735611,int_stack+1729563,int_stack+1718979, 0.0, zero_stack, 1.0, int_stack+583612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1712091,int_stack+1735611,int_stack+1723683, 0.0, zero_stack, 1.0, int_stack+588316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1720911,int_stack+236100,int_stack+234560, 0.0, zero_stack, 1.0, int_stack+477690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1743451,int_stack+1720911,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+594196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1751011,int_stack+1743451,int_stack+1729563, 0.0, zero_stack, 1.0, int_stack+597976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1720911,int_stack+1751011,int_stack+1735611, 0.0, zero_stack, 1.0, int_stack+604024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1732671,int_stack+1720911,int_stack+1712091, 0.0, zero_stack, 1.0, int_stack+611864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+238704,int_stack+237948, 0.0, zero_stack, 1.0, int_stack+488106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1710579,int_stack+239712,int_stack+238704, 0.0, zero_stack, 1.0, int_stack+488862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1713603,int_stack+1710579,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+620684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1718139,int_stack+241008,int_stack+239712, 0.0, zero_stack, 1.0, int_stack+489870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1722027,int_stack+1718139,int_stack+1710579, 0.0, zero_stack, 1.0, int_stack+622952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1745019,int_stack+1722027,int_stack+1713603, 0.0, zero_stack, 1.0, int_stack+625976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708311,int_stack+242628,int_stack+241008, 0.0, zero_stack, 1.0, int_stack+491166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1752579,int_stack+1708311,int_stack+1718139, 0.0, zero_stack, 1.0, int_stack+630512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1760355,int_stack+1752579,int_stack+1722027, 0.0, zero_stack, 1.0, int_stack+634400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1713171,int_stack+1760355,int_stack+1745019, 0.0, zero_stack, 1.0, int_stack+657392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1745019,int_stack+244608,int_stack+242628, 0.0, zero_stack, 1.0, int_stack+492786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1770435,int_stack+1745019,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+664952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1780155,int_stack+1770435,int_stack+1752579, 0.0, zero_stack, 1.0, int_stack+669812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1745019,int_stack+1780155,int_stack+1760355, 0.0, zero_stack, 1.0, int_stack+677588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1760139,int_stack+1745019,int_stack+1713171, 0.0, zero_stack, 1.0, int_stack+687668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+1776015,int_stack+1760139,int_stack+1732671,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+247929,int_stack+246984, 0.0, zero_stack, 1.0, int_stack+506178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1711146,int_stack+249189,int_stack+247929, 0.0, zero_stack, 1.0, int_stack+507123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1714926,int_stack+1711146,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1720596,int_stack+250809,int_stack+249189, 0.0, zero_stack, 1.0, int_stack+508383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1725456,int_stack+1720596,int_stack+1711146, 0.0, zero_stack, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1733016,int_stack+1725456,int_stack+1714926, 0.0, zero_stack, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+1708311,int_stack+252834,int_stack+250809, 0.0, zero_stack, 1.0, int_stack+510003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1742466,int_stack+1708311,int_stack+1720596, 0.0, zero_stack, 1.0, int_stack+640448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1813059,int_stack+1742466,int_stack+1725456, 0.0, zero_stack, 1.0, int_stack+645308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+1714386,int_stack+1813059,int_stack+1733016, 0.0, zero_stack, 1.0, int_stack+751928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+1728561,int_stack+255309,int_stack+252834, 0.0, zero_stack, 1.0, int_stack+512028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2307189,int_stack+1728561,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+761378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2319339,int_stack+2307189,int_stack+1742466, 0.0, zero_stack, 1.0, int_stack+767453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1728561,int_stack+2319339,int_stack+1813059, 0.0, zero_stack, 1.0, int_stack+777173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2307189,int_stack+1728561,int_stack+1714386, 0.0, zero_stack, 1.0, int_stack+789773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+2327034,int_stack+2307189,int_stack+1760139,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2109621,int_stack+2327034,int_stack+1776015,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2374662,int_stack+259434,int_stack+258279, 0.0, zero_stack, 1.0, int_stack+528768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2378127,int_stack+260974,int_stack+259434, 0.0, zero_stack, 1.0, int_stack+529923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2382747,int_stack+2378127,int_stack+2374662, 0.0, zero_stack, 1.0, int_stack+699008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2389677,int_stack+262954,int_stack+260974, 0.0, zero_stack, 1.0, int_stack+531463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2395617,int_stack+2389677,int_stack+2378127, 0.0, zero_stack, 1.0, int_stack+702473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2404857,int_stack+2395617,int_stack+2382747, 0.0, zero_stack, 1.0, int_stack+707093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2374662,int_stack+265429,int_stack+262954, 0.0, zero_stack, 1.0, int_stack+533443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1708311,int_stack+2374662,int_stack+2389677, 0.0, zero_stack, 1.0, int_stack+714023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1720191,int_stack+1708311,int_stack+2395617, 0.0, zero_stack, 1.0, int_stack+719963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2382087,int_stack+1720191,int_stack+2404857, 0.0, zero_stack, 1.0, int_stack+729203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2399412,int_stack+268454,int_stack+265429, 0.0, zero_stack, 1.0, int_stack+535918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2408487,int_stack+2399412,int_stack+2374662, 0.0, zero_stack, 1.0, int_stack+740753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+1735591,int_stack+2408487,int_stack+1708311, 0.0, zero_stack, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2399412,int_stack+1735591,int_stack+1720191, 0.0, zero_stack, 1.0, int_stack+945509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+1708311,int_stack+2399412,int_stack+2382087, 0.0, zero_stack, 1.0, int_stack+960909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1732566,int_stack+1708311,int_stack+2307189,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+2374662,int_stack+1732566,int_stack+2327034,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+2469918,int_stack+2374662,int_stack+2109621,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2109621,int_stack+273470,int_stack+272084, 0.0, zero_stack, 1.0, int_stack+329814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2113779,int_stack+275318,int_stack+273470, 0.0, zero_stack, 1.0, int_stack+332586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2119323,int_stack+2113779,int_stack+2109621, 0.0, zero_stack, 1.0, int_stack+803948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2127639,int_stack+277694,int_stack+275318, 0.0, zero_stack, 1.0, int_stack+336282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2134767,int_stack+2127639,int_stack+2113779, 0.0, zero_stack, 1.0, int_stack+808106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2145855,int_stack+2134767,int_stack+2119323, 0.0, zero_stack, 1.0, int_stack+813650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+2109621,int_stack+280664,int_stack+277694, 0.0, zero_stack, 1.0, int_stack+341034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2159715,int_stack+2109621,int_stack+2127639, 0.0, zero_stack, 1.0, int_stack+821966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2307189,int_stack+2159715,int_stack+2134767, 0.0, zero_stack, 1.0, int_stack+829094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2118531,int_stack+2307189,int_stack+2145855, 0.0, zero_stack, 1.0, int_stack+840182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2139321,int_stack+284294,int_stack+280664, 0.0, zero_stack, 1.0, int_stack+346974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2325669,int_stack+2139321,int_stack+2109621, 0.0, zero_stack, 1.0, int_stack+854042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2343489,int_stack+2325669,int_stack+2159715, 0.0, zero_stack, 1.0, int_stack+862952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2139321,int_stack+2343489,int_stack+2307189, 0.0, zero_stack, 1.0, int_stack+877208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2307189,int_stack+2139321,int_stack+2118531, 0.0, zero_stack, 1.0, int_stack+895688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+2109621,int_stack+2307189,int_stack+1708311,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+2593398,int_stack+2109621,int_stack+1732566,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+2712468,int_stack+2593398,int_stack+2374662,441);
 /*--- compute (i0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2593398,int_stack+289238,int_stack+288650, 1.0, int_stack+474050, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2595162,int_stack+290022,int_stack+289238, 1.0, int_stack+474638, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2597514,int_stack+2595162,int_stack+2593398, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2601042,int_stack+291030,int_stack+290022, 1.0, int_stack+475422, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2604066,int_stack+2601042,int_stack+2595162, 1.0, int_stack+574708, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2608770,int_stack+2604066,int_stack+2597514, 1.0, int_stack+577060, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+572944,int_stack+292290,int_stack+291030, 1.0, int_stack+476430, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2593398,int_stack+572944,int_stack+2601042, 1.0, int_stack+580588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2614650,int_stack+2593398,int_stack+2604066, 1.0, int_stack+583612, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+576724,int_stack+2614650,int_stack+2608770, 1.0, int_stack+588316, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+585544,int_stack+293830,int_stack+292290, 1.0, int_stack+477690, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2599446,int_stack+585544,int_stack+572944, 1.0, int_stack+594196, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2622490,int_stack+2599446,int_stack+2593398, 1.0, int_stack+597976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2593398,int_stack+2622490,int_stack+2614650, 1.0, int_stack+604024, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (i0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2605158,int_stack+2593398,int_stack+576724, 1.0, int_stack+611864, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,28);
 /*--- compute (k0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2593398,int_stack+296434,int_stack+295678, 1.0, int_stack+488106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2595666,int_stack+297442,int_stack+296434, 1.0, int_stack+488862, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2598690,int_stack+2595666,int_stack+2593398, 1.0, int_stack+620684, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2617506,int_stack+298738,int_stack+297442, 1.0, int_stack+489870, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2621394,int_stack+2617506,int_stack+2595666, 1.0, int_stack+622952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2627442,int_stack+2621394,int_stack+2598690, 1.0, int_stack+625976, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+620684,int_stack+300358,int_stack+298738, 1.0, int_stack+491166, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2593398,int_stack+620684,int_stack+2617506, 1.0, int_stack+630512, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2635002,int_stack+2593398,int_stack+2621394, 1.0, int_stack+634400, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+625544,int_stack+2635002,int_stack+2627442, 1.0, int_stack+657392, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2617506,int_stack+302338,int_stack+300358, 1.0, int_stack+492786, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+2623446,int_stack+2617506,int_stack+620684, 1.0, int_stack+664952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2645082,int_stack+2623446,int_stack+2593398, 1.0, int_stack+669812, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2617506,int_stack+2645082,int_stack+2635002, 1.0, int_stack+677588, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (k0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2632626,int_stack+2617506,int_stack+625544, 1.0, int_stack+687668, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2648502,int_stack+2632626,int_stack+2605158,441);
 /*--- compute (l0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+2593398,int_stack+305659,int_stack+304714, 1.0, int_stack+506178, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+2596233,int_stack+306919,int_stack+305659, 1.0, int_stack+507123, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+2600013,int_stack+2596233,int_stack+2593398, 1.0, int_stack+0, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+2605683,int_stack+308539,int_stack+306919, 1.0, int_stack+508383, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2610543,int_stack+2605683,int_stack+2596233, 1.0, int_stack+2835, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2618103,int_stack+2610543,int_stack+2600013, 1.0, int_stack+6615, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+310564,int_stack+308539, 1.0, int_stack+510003, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+2593398,int_stack+0,int_stack+2605683, 1.0, int_stack+640448, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+620684,int_stack+2593398,int_stack+2610543, 1.0, int_stack+645308, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+2603118,int_stack+620684,int_stack+2618103, 1.0, int_stack+751928, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2617293,int_stack+313039,int_stack+310564, 1.0, int_stack+512028, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+633284,int_stack+2617293,int_stack+0, 1.0, int_stack+761378, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+645434,int_stack+633284,int_stack+2593398, 1.0, int_stack+767453, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+2685546,int_stack+645434,int_stack+620684, 1.0, int_stack+777173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (l0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+620684,int_stack+2685546,int_stack+2603118, 1.0, int_stack+789773, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+2109621,int_stack+620684,int_stack+2632626,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+1708311,int_stack+2109621,int_stack+2648502,441);
 /*--- compute (m0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+640529,int_stack+317164,int_stack+316009, 1.0, int_stack+528768, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+643994,int_stack+318704,int_stack+317164, 1.0, int_stack+529923, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+648614,int_stack+643994,int_stack+640529, 1.0, int_stack+699008, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+655544,int_stack+320684,int_stack+318704, 1.0, int_stack+531463, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+2593398,int_stack+655544,int_stack+643994, 1.0, int_stack+702473, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+2602638,int_stack+2593398,int_stack+648614, 1.0, int_stack+707093, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+699008,int_stack+323159,int_stack+320684, 1.0, int_stack+533443, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+640529,int_stack+699008,int_stack+655544, 1.0, int_stack+714023, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+2614188,int_stack+640529,int_stack+2593398, 1.0, int_stack+719963, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+706433,int_stack+2614188,int_stack+2602638, 1.0, int_stack+729203, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+2593398,int_stack+326184,int_stack+323159, 1.0, int_stack+535918, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+723758,int_stack+2593398,int_stack+699008, 1.0, int_stack+740753, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+2593398,int_stack+723758,int_stack+640529, 1.0, int_stack+12285, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+640529,int_stack+2593398,int_stack+2614188, 1.0, int_stack+945509, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (m0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+2593398,int_stack+640529,int_stack+706433, 1.0, int_stack+960909, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+2617653,int_stack+2593398,int_stack+620684,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+2307189,int_stack+2617653,int_stack+2109621,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+182925,int_stack+2307189,int_stack+1708311,441);
 /*--- compute (n0|hp) ---*/
   d1hrr3_build_hp(Libderiv->CD,int_stack+1708311,int_stack+334434,int_stack+331200, 1.0, int_stack+329814, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ip) ---*/
   d1hrr3_build_ip(Libderiv->CD,int_stack+1712469,int_stack+338658,int_stack+334434, 1.0, int_stack+332586, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hd) ---*/
   d1hrr3_build_hd(Libderiv->CD,int_stack+1718013,int_stack+1712469,int_stack+1708311, 1.0, int_stack+803948, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kp) ---*/
   d1hrr3_build_kp(Libderiv->CD,int_stack+1726329,int_stack+344004,int_stack+338658, 1.0, int_stack+336282, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|id) ---*/
   d1hrr3_build_id(Libderiv->CD,int_stack+1733457,int_stack+1726329,int_stack+1712469, 1.0, int_stack+808106, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hf) ---*/
   d1hrr3_build_hf(Libderiv->CD,int_stack+1744545,int_stack+1733457,int_stack+1718013, 1.0, int_stack+813650, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|lp) ---*/
   d1hrr3_build_lp(Libderiv->CD,int_stack+803948,int_stack+350604,int_stack+344004, 1.0, int_stack+341034, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kd) ---*/
   d1hrr3_build_kd(Libderiv->CD,int_stack+1708311,int_stack+803948,int_stack+1726329, 1.0, int_stack+821966, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|if) ---*/
   d1hrr3_build_if(Libderiv->CD,int_stack+1758405,int_stack+1708311,int_stack+1733457, 1.0, int_stack+829094, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hg) ---*/
   d1hrr3_build_hg(Libderiv->CD,int_stack+812858,int_stack+1758405,int_stack+1744545, 1.0, int_stack+840182, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|mp) ---*/
   d1hrr3_build_mp(Libderiv->CD,int_stack+833648,int_stack+354234,int_stack+350604, 1.0, int_stack+346974, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ld) ---*/
   d1hrr3_build_ld(Libderiv->CD,int_stack+1722567,int_stack+833648,int_stack+803948, 1.0, int_stack+854042, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|kf) ---*/
   d1hrr3_build_kf(Libderiv->CD,int_stack+833648,int_stack+1722567,int_stack+1708311, 1.0, int_stack+862952, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|ig) ---*/
   d1hrr3_build_ig(Libderiv->CD,int_stack+1708311,int_stack+833648,int_stack+1758405, 1.0, int_stack+877208, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (n0|hh) ---*/
   d1hrr3_build_hh(Libderiv->CD,int_stack+833648,int_stack+1708311,int_stack+812858, 1.0, int_stack+895688, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,66);
 /*--- compute (mp|hh) ---*/
   hrr1_build_mp(Libderiv->AB,int_stack+1708311,int_stack+833648,int_stack+2593398,441);
 /*--- compute (ld|hh) ---*/
   hrr1_build_ld(Libderiv->AB,int_stack+803948,int_stack+1708311,int_stack+2617653,441);
 /*--- compute (kf|hh) ---*/
   hrr1_build_kf(Libderiv->AB,int_stack+2871228,int_stack+803948,int_stack+2307189,441);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2307189,int_stack+479230,int_stack+477690,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2311809,int_stack+2307189,int_stack+594196,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2319369,int_stack+2311809,int_stack+597976,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2307189,int_stack+2319369,int_stack+604024,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2318949,int_stack+2307189,int_stack+611864,28);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2307189,int_stack+494766,int_stack+492786,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2331297,int_stack+2307189,int_stack+664952,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2341017,int_stack+2331297,int_stack+669812,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2353977,int_stack+2341017,int_stack+677588,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2331297,int_stack+2353977,int_stack+687668,36);
 /*--- compute (ip|hh) ---*/
   hrr1_build_ip(Libderiv->AB,int_stack+2347173,int_stack+2331297,int_stack+2318949,441);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2384217,int_stack+514503,int_stack+512028,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2391642,int_stack+2384217,int_stack+761378,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2403792,int_stack+2391642,int_stack+767453,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2384217,int_stack+2403792,int_stack+777173,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2403117,int_stack+2384217,int_stack+789773,45);
 /*--- compute (kp|hh) ---*/
   hrr1_build_kp(Libderiv->AB,int_stack+1708311,int_stack+2403117,int_stack+2331297,441);
 /*--- compute (id|hh) ---*/
   hrr1_build_id(Libderiv->AB,int_stack+2109621,int_stack+1708311,int_stack+2347173,441);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2384217,int_stack+538943,int_stack+535918,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2422962,int_stack+2384217,int_stack+740753,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2437812,int_stack+2422962,int_stack+12285,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+1755939,int_stack+2437812,int_stack+945509,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2422962,int_stack+1755939,int_stack+960909,55);
 /*--- compute (lp|hh) ---*/
   hrr1_build_lp(Libderiv->AB,int_stack+1755939,int_stack+2422962,int_stack+2403117,441);
 /*--- compute (kd|hh) ---*/
   hrr1_build_kd(Libderiv->AB,int_stack+2593398,int_stack+1755939,int_stack+1708311,441);
 /*--- compute (if|hh) ---*/
   hrr1_build_if(Libderiv->AB,int_stack+572944,int_stack+2593398,int_stack+2109621,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+1815474,int_stack+359178,int_stack+358590,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+1817238,int_stack+359962,int_stack+359178,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+1819590,int_stack+1817238,int_stack+1815474,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+1823118,int_stack+360970,int_stack+359962,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2447217,int_stack+1823118,int_stack+1817238,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2451921,int_stack+2447217,int_stack+1819590,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+1815474,int_stack+362230,int_stack+360970,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2457801,int_stack+1815474,int_stack+1823118,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1819254,int_stack+2457801,int_stack+2447217,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2384217,int_stack+1819254,int_stack+2451921,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2447217,int_stack+363770,int_stack+362230,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2393037,int_stack+2447217,int_stack+1815474,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2447217,int_stack+2393037,int_stack+2457801,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2307189,int_stack+2447217,int_stack+1819254,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2447217,int_stack+2307189,int_stack+2384217,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2384217,int_stack+366374,int_stack+365618,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2386485,int_stack+367382,int_stack+366374,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2389509,int_stack+2386485,int_stack+2384217,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2394045,int_stack+368678,int_stack+367382,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2307189,int_stack+2394045,int_stack+2386485,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2459565,int_stack+2307189,int_stack+2389509,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2384217,int_stack+370298,int_stack+368678,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+1815474,int_stack+2384217,int_stack+2394045,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2389077,int_stack+1815474,int_stack+2307189,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2307189,int_stack+2389077,int_stack+2459565,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2459565,int_stack+372278,int_stack+370298,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2688654,int_stack+2459565,int_stack+2384217,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2698374,int_stack+2688654,int_stack+1815474,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+2698374,int_stack+2389077,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2688654,int_stack+0,int_stack+2307189,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+696424,int_stack+2688654,int_stack+2447217, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2318949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2447217,int_stack+375599,int_stack+374654,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2450052,int_stack+376859,int_stack+375599,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2453832,int_stack+2450052,int_stack+2447217,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2459502,int_stack+378479,int_stack+376859,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2307189,int_stack+2459502,int_stack+2450052,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+0,int_stack+2307189,int_stack+2453832,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2447217,int_stack+380504,int_stack+378479,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+9450,int_stack+2447217,int_stack+2459502,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2453292,int_stack+9450,int_stack+2307189,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2384217,int_stack+2453292,int_stack+0,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+0,int_stack+382979,int_stack+380504,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+528768,int_stack+0,int_stack+2447217,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+733468,int_stack+528768,int_stack+9450,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+733468,int_stack+2453292,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+733468,int_stack+0,int_stack+2384217,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+753313,int_stack+733468,int_stack+2688654, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2331297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+800941,int_stack+753313,int_stack+696424, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2347173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+696424,int_stack+387104,int_stack+385949,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+699889,int_stack+388644,int_stack+387104,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+704509,int_stack+699889,int_stack+696424,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+711439,int_stack+390624,int_stack+388644,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+717379,int_stack+711439,int_stack+699889,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2688654,int_stack+717379,int_stack+704509,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+696424,int_stack+393099,int_stack+390624,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2700204,int_stack+696424,int_stack+711439,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2384217,int_stack+2700204,int_stack+717379,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+703849,int_stack+2384217,int_stack+2688654,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2688654,int_stack+396124,int_stack+393099,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+0,int_stack+2688654,int_stack+696424,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+875029,int_stack+0,int_stack+2700204,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+0,int_stack+875029,int_stack+2384217,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+875029,int_stack+0,int_stack+703849,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+899284,int_stack+875029,int_stack+733468, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2403117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+3029988,int_stack+899284,int_stack+753313, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+3125244,int_stack+3029988,int_stack+800941, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2109621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+0,int_stack+401140,int_stack+399754,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+4158,int_stack+402988,int_stack+401140,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+9702,int_stack+4158,int_stack+0,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2384217,int_stack+405364,int_stack+402988,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2391345,int_stack+2384217,int_stack+4158,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+958819,int_stack+2391345,int_stack+9702,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+0,int_stack+408334,int_stack+405364,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+8910,int_stack+0,int_stack+2384217,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+696424,int_stack+8910,int_stack+2391345,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+714904,int_stack+696424,int_stack+958819,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+958819,int_stack+411964,int_stack+408334,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+2384217,int_stack+958819,int_stack+0,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+735694,int_stack+2384217,int_stack+8910,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+759454,int_stack+735694,int_stack+696424,66);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+787174,int_stack+759454,int_stack+714904,66);
 /*--- compute (mp|hh) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+696424,int_stack+787174,int_stack+875029, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2422962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ld|hh) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+769189,int_stack+696424,int_stack+899284, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+1755939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kf|hh) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+3248724,int_stack+769189,int_stack+3029988, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+2593398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3029988,int_stack+416908,int_stack+416320,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3031752,int_stack+417692,int_stack+416908,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3034104,int_stack+3031752,int_stack+3029988,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3037632,int_stack+418700,int_stack+417692,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3040656,int_stack+3037632,int_stack+3031752,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3045360,int_stack+3040656,int_stack+3034104,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3029988,int_stack+419960,int_stack+418700,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3051240,int_stack+3029988,int_stack+3037632,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3057288,int_stack+3051240,int_stack+3040656,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3033768,int_stack+3057288,int_stack+3045360,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3042588,int_stack+421500,int_stack+419960,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3065128,int_stack+3042588,int_stack+3029988,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3072688,int_stack+3065128,int_stack+3051240,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2307189,int_stack+3072688,int_stack+3057288,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3042588,int_stack+2307189,int_stack+3033768,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2307189,int_stack+424104,int_stack+423348,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2309457,int_stack+425112,int_stack+424104,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2312481,int_stack+2309457,int_stack+2307189,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3029988,int_stack+426408,int_stack+425112,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3033876,int_stack+3029988,int_stack+2309457,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3054936,int_stack+3033876,int_stack+2312481,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2307189,int_stack+428028,int_stack+426408,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3062496,int_stack+2307189,int_stack+3029988,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3070272,int_stack+3062496,int_stack+3033876,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3029988,int_stack+3070272,int_stack+3054936,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3054936,int_stack+430008,int_stack+428028,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3080352,int_stack+3054936,int_stack+2307189,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3090072,int_stack+3080352,int_stack+3062496,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3054936,int_stack+3090072,int_stack+3070272,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3070056,int_stack+3054936,int_stack+3029988,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+3085932,int_stack+3070056,int_stack+3042588, 0.0, zero_stack, 1.0, int_stack+2318949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3029988,int_stack+433329,int_stack+432384,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3032823,int_stack+434589,int_stack+433329,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3036603,int_stack+3032823,int_stack+3029988,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3042273,int_stack+436209,int_stack+434589,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3047133,int_stack+3042273,int_stack+3032823,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3054693,int_stack+3047133,int_stack+3036603,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3029988,int_stack+438234,int_stack+436209,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2307189,int_stack+3029988,int_stack+3042273,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+696424,int_stack+2307189,int_stack+3047133,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3036063,int_stack+696424,int_stack+3054693,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3050238,int_stack+440709,int_stack+438234,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3057663,int_stack+3050238,int_stack+3029988,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+709024,int_stack+3057663,int_stack+2307189,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2384217,int_stack+709024,int_stack+696424,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+696424,int_stack+2384217,int_stack+3036063,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+716269,int_stack+696424,int_stack+3070056, 0.0, zero_stack, 1.0, int_stack+2331297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+763897,int_stack+716269,int_stack+3085932, 0.0, zero_stack, 1.0, int_stack+2347173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2384217,int_stack+444834,int_stack+443679,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2387682,int_stack+446374,int_stack+444834,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2392302,int_stack+2387682,int_stack+2384217,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+837985,int_stack+448354,int_stack+446374,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+843925,int_stack+837985,int_stack+2387682,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+853165,int_stack+843925,int_stack+2392302,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2384217,int_stack+450829,int_stack+448354,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+864715,int_stack+2384217,int_stack+837985,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+876595,int_stack+864715,int_stack+843925,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+891995,int_stack+876595,int_stack+853165,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+837985,int_stack+453854,int_stack+450829,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+847060,int_stack+837985,int_stack+2384217,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+909320,int_stack+847060,int_stack+864715,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+837985,int_stack+909320,int_stack+876595,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+909320,int_stack+837985,int_stack+891995,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+837985,int_stack+909320,int_stack+696424, 0.0, zero_stack, 1.0, int_stack+2403117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+3029988,int_stack+837985,int_stack+716269, 0.0, zero_stack, 1.0, int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+306405,int_stack+3029988,int_stack+763897, 0.0, zero_stack, 1.0, int_stack+2109621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+696424,int_stack+458870,int_stack+457484,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+700582,int_stack+460718,int_stack+458870,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+706126,int_stack+700582,int_stack+696424,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+714442,int_stack+463094,int_stack+460718,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+721570,int_stack+714442,int_stack+700582,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+732658,int_stack+721570,int_stack+706126,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+696424,int_stack+466064,int_stack+463094,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+746518,int_stack+696424,int_stack+714442,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+760774,int_stack+746518,int_stack+721570,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+705334,int_stack+760774,int_stack+732658,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+726124,int_stack+469694,int_stack+466064,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+779254,int_stack+726124,int_stack+696424,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+797074,int_stack+779254,int_stack+746518,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+726124,int_stack+797074,int_stack+760774,66);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+753844,int_stack+726124,int_stack+705334,66);
 /*--- compute (mp|hh) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+1328610,int_stack+753844,int_stack+909320, 0.0, zero_stack, 1.0, int_stack+2422962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ld|hh) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+696424,int_stack+1328610,int_stack+837985, 0.0, zero_stack, 1.0, int_stack+1755939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kf|hh) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+815494,int_stack+696424,int_stack+3029988, 0.0, zero_stack, 1.0, int_stack+2593398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (i0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3029988,int_stack+481666,int_stack+481078,28);
 /*--- compute (i0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3031752,int_stack+482450,int_stack+481666,28);
 /*--- compute (i0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3034104,int_stack+3031752,int_stack+3029988,28);
 /*--- compute (i0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3037632,int_stack+483458,int_stack+482450,28);
 /*--- compute (i0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3040656,int_stack+3037632,int_stack+3031752,28);
 /*--- compute (i0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3045360,int_stack+3040656,int_stack+3034104,28);
 /*--- compute (i0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3029988,int_stack+484718,int_stack+483458,28);
 /*--- compute (i0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3051240,int_stack+3029988,int_stack+3037632,28);
 /*--- compute (i0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3057288,int_stack+3051240,int_stack+3040656,28);
 /*--- compute (i0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3033768,int_stack+3057288,int_stack+3045360,28);
 /*--- compute (i0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3042588,int_stack+486258,int_stack+484718,28);
 /*--- compute (i0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3065128,int_stack+3042588,int_stack+3029988,28);
 /*--- compute (i0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3072688,int_stack+3065128,int_stack+3051240,28);
 /*--- compute (i0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2307189,int_stack+3072688,int_stack+3057288,28);
 /*--- compute (i0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3042588,int_stack+2307189,int_stack+3033768,28);
 /*--- compute (k0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2307189,int_stack+497898,int_stack+497142,36);
 /*--- compute (k0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2309457,int_stack+498906,int_stack+497898,36);
 /*--- compute (k0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2312481,int_stack+2309457,int_stack+2307189,36);
 /*--- compute (k0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3029988,int_stack+500202,int_stack+498906,36);
 /*--- compute (k0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3033876,int_stack+3029988,int_stack+2309457,36);
 /*--- compute (k0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3054936,int_stack+3033876,int_stack+2312481,36);
 /*--- compute (k0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2307189,int_stack+501822,int_stack+500202,36);
 /*--- compute (k0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+3062496,int_stack+2307189,int_stack+3029988,36);
 /*--- compute (k0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+3070272,int_stack+3062496,int_stack+3033876,36);
 /*--- compute (k0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3029988,int_stack+3070272,int_stack+3054936,36);
 /*--- compute (k0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3054936,int_stack+503802,int_stack+501822,36);
 /*--- compute (k0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3080352,int_stack+3054936,int_stack+2307189,36);
 /*--- compute (k0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+3090072,int_stack+3080352,int_stack+3062496,36);
 /*--- compute (k0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+3054936,int_stack+3090072,int_stack+3070272,36);
 /*--- compute (k0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+3070056,int_stack+3054936,int_stack+3029988,36);
 /*--- compute (ip|hh) ---*/
   d1hrr1_build_ip(Libderiv->AB,int_stack+3085932,int_stack+3070056,int_stack+3042588, 1.0, int_stack+2318949, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (l0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+3029988,int_stack+518418,int_stack+517473,45);
 /*--- compute (l0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+3032823,int_stack+519678,int_stack+518418,45);
 /*--- compute (l0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+3036603,int_stack+3032823,int_stack+3029988,45);
 /*--- compute (l0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+3042273,int_stack+521298,int_stack+519678,45);
 /*--- compute (l0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+3047133,int_stack+3042273,int_stack+3032823,45);
 /*--- compute (l0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+3054693,int_stack+3047133,int_stack+3036603,45);
 /*--- compute (l0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+3029988,int_stack+523323,int_stack+521298,45);
 /*--- compute (l0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2307189,int_stack+3029988,int_stack+3042273,45);
 /*--- compute (l0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2316909,int_stack+2307189,int_stack+3047133,45);
 /*--- compute (l0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+3036063,int_stack+2316909,int_stack+3054693,45);
 /*--- compute (l0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+3050238,int_stack+525798,int_stack+523323,45);
 /*--- compute (l0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+3057663,int_stack+3050238,int_stack+3029988,45);
 /*--- compute (l0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+696424,int_stack+3057663,int_stack+2307189,45);
 /*--- compute (l0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2384217,int_stack+696424,int_stack+2316909,45);
 /*--- compute (l0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+696424,int_stack+2384217,int_stack+3036063,45);
 /*--- compute (kp|hh) ---*/
   d1hrr1_build_kp(Libderiv->AB,int_stack+716269,int_stack+696424,int_stack+3070056, 1.0, int_stack+2331297, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (id|hh) ---*/
   d1hrr1_build_id(Libderiv->AB,int_stack+1328610,int_stack+716269,int_stack+3085932, 1.0, int_stack+2347173, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (m0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+763897,int_stack+543728,int_stack+542573,55);
 /*--- compute (m0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+767362,int_stack+545268,int_stack+543728,55);
 /*--- compute (m0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+771982,int_stack+767362,int_stack+763897,55);
 /*--- compute (m0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+778912,int_stack+547248,int_stack+545268,55);
 /*--- compute (m0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+784852,int_stack+778912,int_stack+767362,55);
 /*--- compute (m0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+794092,int_stack+784852,int_stack+771982,55);
 /*--- compute (m0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+763897,int_stack+549723,int_stack+547248,55);
 /*--- compute (m0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2307189,int_stack+763897,int_stack+778912,55);
 /*--- compute (m0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+2319069,int_stack+2307189,int_stack+784852,55);
 /*--- compute (m0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+771322,int_stack+2319069,int_stack+794092,55);
 /*--- compute (m0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+788647,int_stack+552748,int_stack+549723,55);
 /*--- compute (m0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+797722,int_stack+788647,int_stack+763897,55);
 /*--- compute (m0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+2334469,int_stack+797722,int_stack+2307189,55);
 /*--- compute (m0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+788647,int_stack+2334469,int_stack+2319069,55);
 /*--- compute (m0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+2307189,int_stack+788647,int_stack+771322,55);
 /*--- compute (lp|hh) ---*/
   d1hrr1_build_lp(Libderiv->AB,int_stack+2331444,int_stack+2307189,int_stack+696424, 1.0, int_stack+2403117, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kd|hh) ---*/
   d1hrr1_build_kd(Libderiv->AB,int_stack+3029988,int_stack+2331444,int_stack+716269, 1.0, int_stack+1708311, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (if|hh) ---*/
   d1hrr1_build_if(Libderiv->AB,int_stack+429885,int_stack+3029988,int_stack+1328610, 1.0, int_stack+2109621, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (n0|hp) ---*/
   hrr3_build_hp(Libderiv->CD,int_stack+2109621,int_stack+557764,int_stack+556378,66);
 /*--- compute (n0|ip) ---*/
   hrr3_build_ip(Libderiv->CD,int_stack+2113779,int_stack+559612,int_stack+557764,66);
 /*--- compute (n0|hd) ---*/
   hrr3_build_hd(Libderiv->CD,int_stack+2119323,int_stack+2113779,int_stack+2109621,66);
 /*--- compute (n0|kp) ---*/
   hrr3_build_kp(Libderiv->CD,int_stack+2127639,int_stack+561988,int_stack+559612,66);
 /*--- compute (n0|id) ---*/
   hrr3_build_id(Libderiv->CD,int_stack+2134767,int_stack+2127639,int_stack+2113779,66);
 /*--- compute (n0|hf) ---*/
   hrr3_build_hf(Libderiv->CD,int_stack+2145855,int_stack+2134767,int_stack+2119323,66);
 /*--- compute (n0|lp) ---*/
   hrr3_build_lp(Libderiv->CD,int_stack+2109621,int_stack+564958,int_stack+561988,66);
 /*--- compute (n0|kd) ---*/
   hrr3_build_kd(Libderiv->CD,int_stack+2159715,int_stack+2109621,int_stack+2127639,66);
 /*--- compute (n0|if) ---*/
   hrr3_build_if(Libderiv->CD,int_stack+1328610,int_stack+2159715,int_stack+2134767,66);
 /*--- compute (n0|hg) ---*/
   hrr3_build_hg(Libderiv->CD,int_stack+2118531,int_stack+1328610,int_stack+2145855,66);
 /*--- compute (n0|mp) ---*/
   hrr3_build_mp(Libderiv->CD,int_stack+2139321,int_stack+568588,int_stack+564958,66);
 /*--- compute (n0|ld) ---*/
   hrr3_build_ld(Libderiv->CD,int_stack+1347090,int_stack+2139321,int_stack+2109621,66);
 /*--- compute (n0|kf) ---*/
   hrr3_build_kf(Libderiv->CD,int_stack+1364910,int_stack+1347090,int_stack+2159715,66);
 /*--- compute (n0|ig) ---*/
   hrr3_build_ig(Libderiv->CD,int_stack+2139321,int_stack+1364910,int_stack+1328610,66);
 /*--- compute (n0|hh) ---*/
   hrr3_build_hh(Libderiv->CD,int_stack+1328610,int_stack+2139321,int_stack+2118531,66);
 /*--- compute (mp|hh) ---*/
   d1hrr1_build_mp(Libderiv->AB,int_stack+2109621,int_stack+1328610,int_stack+2307189, 1.0, int_stack+2422962, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ld|hh) ---*/
   d1hrr1_build_ld(Libderiv->AB,int_stack+696424,int_stack+2109621,int_stack+2331444, 1.0, int_stack+1755939, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (kf|hh) ---*/
   d1hrr1_build_kf(Libderiv->AB,int_stack+2307189,int_stack+696424,int_stack+3029988, 1.0, int_stack+2593398, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+3407484,int_stack+1549551,int_stack+1205130,441);
     Libderiv->ABCD[11] = int_stack + 3407484;
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+1136994,int_stack+1827381,int_stack+1412400,441);
     Libderiv->ABCD[10] = int_stack + 1136994;
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+1322214,int_stack+978234,int_stack+1986141,441);
     Libderiv->ABCD[9] = int_stack + 1322214;
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+1507434,int_stack+24165,int_stack+2183709,441);
     Libderiv->ABCD[8] = int_stack + 1507434;
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+1692654,int_stack+2712468,int_stack+2469918,441);
     Libderiv->ABCD[7] = int_stack + 1692654;
 /*--- compute (ig|hh) ---*/
   hrr1_build_ig(Libderiv->AB,int_stack+2465949,int_stack+2871228,int_stack+182925,441);
     Libderiv->ABCD[6] = int_stack + 2465949;
 /*--- compute (ig|hh) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+2651169,int_stack+3248724,int_stack+3125244, 0.0, zero_stack, 0.0, zero_stack, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[2] = int_stack + 2651169;
 /*--- compute (ig|hh) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+2836389,int_stack+815494,int_stack+306405, 0.0, zero_stack, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[1] = int_stack + 2836389;
 /*--- compute (ig|hh) ---*/
   d1hrr1_build_ig(Libderiv->AB,int_stack+696424,int_stack+2307189,int_stack+429885, 1.0, int_stack+572944, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack, 0.0, zero_stack,441);
     Libderiv->ABCD[0] = int_stack + 696424;

}
