/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ns|ks) integrals */

#include "libint.h"

REALTYPE *_build_n0k0_0(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[0] + U40*I1[0]
           + (nineo2z)*(I2[0] - (lpoz)*I3[0])
           + (seveno2zn)*I4[0];
*(vp++) = U00*I0[1] + U40*I1[1]
           + (nineo2z)*(I2[1] - (lpoz)*I3[1])
           + (sixo2zn)*I4[1];
*(vp++) = U00*I0[2] + U40*I1[2]
           + (nineo2z)*(I2[2] - (lpoz)*I3[2])
           + (sixo2zn)*I4[2];
*(vp++) = U00*I0[3] + U40*I1[3]
           + (nineo2z)*(I2[3] - (lpoz)*I3[3])
           + (fiveo2zn)*I4[3];
*(vp++) = U00*I0[4] + U40*I1[4]
           + (nineo2z)*(I2[4] - (lpoz)*I3[4])
           + (fiveo2zn)*I4[4];
*(vp++) = U00*I0[5] + U40*I1[5]
           + (nineo2z)*(I2[5] - (lpoz)*I3[5])
           + (fiveo2zn)*I4[5];
*(vp++) = U00*I0[6] + U40*I1[6]
           + (nineo2z)*(I2[6] - (lpoz)*I3[6])
           + (fouro2zn)*I4[6];
*(vp++) = U00*I0[7] + U40*I1[7]
           + (nineo2z)*(I2[7] - (lpoz)*I3[7])
           + (fouro2zn)*I4[7];
*(vp++) = U00*I0[8] + U40*I1[8]
           + (nineo2z)*(I2[8] - (lpoz)*I3[8])
           + (fouro2zn)*I4[8];
*(vp++) = U00*I0[9] + U40*I1[9]
           + (nineo2z)*(I2[9] - (lpoz)*I3[9])
           + (fouro2zn)*I4[9];
*(vp++) = U00*I0[10] + U40*I1[10]
           + (nineo2z)*(I2[10] - (lpoz)*I3[10])
           + (threeo2zn)*I4[10];
*(vp++) = U00*I0[11] + U40*I1[11]
           + (nineo2z)*(I2[11] - (lpoz)*I3[11])
           + (threeo2zn)*I4[11];
*(vp++) = U00*I0[12] + U40*I1[12]
           + (nineo2z)*(I2[12] - (lpoz)*I3[12])
           + (threeo2zn)*I4[12];
*(vp++) = U00*I0[13] + U40*I1[13]
           + (nineo2z)*(I2[13] - (lpoz)*I3[13])
           + (threeo2zn)*I4[13];
*(vp++) = U00*I0[14] + U40*I1[14]
           + (nineo2z)*(I2[14] - (lpoz)*I3[14])
           + (threeo2zn)*I4[14];
*(vp++) = U00*I0[15] + U40*I1[15]
           + (nineo2z)*(I2[15] - (lpoz)*I3[15])
           + (twoo2zn)*I4[15];
*(vp++) = U00*I0[16] + U40*I1[16]
           + (nineo2z)*(I2[16] - (lpoz)*I3[16])
           + (twoo2zn)*I4[16];
*(vp++) = U00*I0[17] + U40*I1[17]
           + (nineo2z)*(I2[17] - (lpoz)*I3[17])
           + (twoo2zn)*I4[17];
*(vp++) = U00*I0[18] + U40*I1[18]
           + (nineo2z)*(I2[18] - (lpoz)*I3[18])
           + (twoo2zn)*I4[18];
*(vp++) = U00*I0[19] + U40*I1[19]
           + (nineo2z)*(I2[19] - (lpoz)*I3[19])
           + (twoo2zn)*I4[19];
*(vp++) = U00*I0[20] + U40*I1[20]
           + (nineo2z)*(I2[20] - (lpoz)*I3[20])
           + (twoo2zn)*I4[20];
*(vp++) = U00*I0[21] + U40*I1[21]
           + (nineo2z)*(I2[21] - (lpoz)*I3[21])
           + (oneo2zn)*I4[21];
*(vp++) = U00*I0[22] + U40*I1[22]
           + (nineo2z)*(I2[22] - (lpoz)*I3[22])
           + (oneo2zn)*I4[22];
*(vp++) = U00*I0[23] + U40*I1[23]
           + (nineo2z)*(I2[23] - (lpoz)*I3[23])
           + (oneo2zn)*I4[23];
*(vp++) = U00*I0[24] + U40*I1[24]
           + (nineo2z)*(I2[24] - (lpoz)*I3[24])
           + (oneo2zn)*I4[24];
*(vp++) = U00*I0[25] + U40*I1[25]
           + (nineo2z)*(I2[25] - (lpoz)*I3[25])
           + (oneo2zn)*I4[25];
*(vp++) = U00*I0[26] + U40*I1[26]
           + (nineo2z)*(I2[26] - (lpoz)*I3[26])
           + (oneo2zn)*I4[26];
*(vp++) = U00*I0[27] + U40*I1[27]
           + (nineo2z)*(I2[27] - (lpoz)*I3[27])
           + (oneo2zn)*I4[27];
*(vp++) = U00*I0[28] + U40*I1[28]
           + (nineo2z)*(I2[28] - (lpoz)*I3[28]);
*(vp++) = U00*I0[29] + U40*I1[29]
           + (nineo2z)*(I2[29] - (lpoz)*I3[29]);
*(vp++) = U00*I0[30] + U40*I1[30]
           + (nineo2z)*(I2[30] - (lpoz)*I3[30]);
*(vp++) = U00*I0[31] + U40*I1[31]
           + (nineo2z)*(I2[31] - (lpoz)*I3[31]);
*(vp++) = U00*I0[32] + U40*I1[32]
           + (nineo2z)*(I2[32] - (lpoz)*I3[32]);
*(vp++) = U00*I0[33] + U40*I1[33]
           + (nineo2z)*(I2[33] - (lpoz)*I3[33]);
*(vp++) = U00*I0[34] + U40*I1[34]
           + (nineo2z)*(I2[34] - (lpoz)*I3[34]);
*(vp++) = U00*I0[35] + U40*I1[35]
           + (nineo2z)*(I2[35] - (lpoz)*I3[35]);
*(vp++) = U00*I0[36] + U40*I1[36]
           + (eighto2z)*(I2[36] - (lpoz)*I3[36])
           + (seveno2zn)*I4[28];
*(vp++) = U00*I0[37] + U40*I1[37]
           + (eighto2z)*(I2[37] - (lpoz)*I3[37])
           + (sixo2zn)*I4[29];
*(vp++) = U00*I0[38] + U40*I1[38]
           + (eighto2z)*(I2[38] - (lpoz)*I3[38])
           + (sixo2zn)*I4[30];
*(vp++) = U00*I0[39] + U40*I1[39]
           + (eighto2z)*(I2[39] - (lpoz)*I3[39])
           + (fiveo2zn)*I4[31];
*(vp++) = U00*I0[40] + U40*I1[40]
           + (eighto2z)*(I2[40] - (lpoz)*I3[40])
           + (fiveo2zn)*I4[32];
*(vp++) = U00*I0[41] + U40*I1[41]
           + (eighto2z)*(I2[41] - (lpoz)*I3[41])
           + (fiveo2zn)*I4[33];
*(vp++) = U00*I0[42] + U40*I1[42]
           + (eighto2z)*(I2[42] - (lpoz)*I3[42])
           + (fouro2zn)*I4[34];
*(vp++) = U00*I0[43] + U40*I1[43]
           + (eighto2z)*(I2[43] - (lpoz)*I3[43])
           + (fouro2zn)*I4[35];
*(vp++) = U00*I0[44] + U40*I1[44]
           + (eighto2z)*(I2[44] - (lpoz)*I3[44])
           + (fouro2zn)*I4[36];
*(vp++) = U00*I0[45] + U40*I1[45]
           + (eighto2z)*(I2[45] - (lpoz)*I3[45])
           + (fouro2zn)*I4[37];
*(vp++) = U00*I0[46] + U40*I1[46]
           + (eighto2z)*(I2[46] - (lpoz)*I3[46])
           + (threeo2zn)*I4[38];
*(vp++) = U00*I0[47] + U40*I1[47]
           + (eighto2z)*(I2[47] - (lpoz)*I3[47])
           + (threeo2zn)*I4[39];
*(vp++) = U00*I0[48] + U40*I1[48]
           + (eighto2z)*(I2[48] - (lpoz)*I3[48])
           + (threeo2zn)*I4[40];
*(vp++) = U00*I0[49] + U40*I1[49]
           + (eighto2z)*(I2[49] - (lpoz)*I3[49])
           + (threeo2zn)*I4[41];
*(vp++) = U00*I0[50] + U40*I1[50]
           + (eighto2z)*(I2[50] - (lpoz)*I3[50])
           + (threeo2zn)*I4[42];
*(vp++) = U00*I0[51] + U40*I1[51]
           + (eighto2z)*(I2[51] - (lpoz)*I3[51])
           + (twoo2zn)*I4[43];
*(vp++) = U00*I0[52] + U40*I1[52]
           + (eighto2z)*(I2[52] - (lpoz)*I3[52])
           + (twoo2zn)*I4[44];
*(vp++) = U00*I0[53] + U40*I1[53]
           + (eighto2z)*(I2[53] - (lpoz)*I3[53])
           + (twoo2zn)*I4[45];
*(vp++) = U00*I0[54] + U40*I1[54]
           + (eighto2z)*(I2[54] - (lpoz)*I3[54])
           + (twoo2zn)*I4[46];
*(vp++) = U00*I0[55] + U40*I1[55]
           + (eighto2z)*(I2[55] - (lpoz)*I3[55])
           + (twoo2zn)*I4[47];
*(vp++) = U00*I0[56] + U40*I1[56]
           + (eighto2z)*(I2[56] - (lpoz)*I3[56])
           + (twoo2zn)*I4[48];
*(vp++) = U00*I0[57] + U40*I1[57]
           + (eighto2z)*(I2[57] - (lpoz)*I3[57])
           + (oneo2zn)*I4[49];
*(vp++) = U00*I0[58] + U40*I1[58]
           + (eighto2z)*(I2[58] - (lpoz)*I3[58])
           + (oneo2zn)*I4[50];
*(vp++) = U00*I0[59] + U40*I1[59]
           + (eighto2z)*(I2[59] - (lpoz)*I3[59])
           + (oneo2zn)*I4[51];
*(vp++) = U00*I0[60] + U40*I1[60]
           + (eighto2z)*(I2[60] - (lpoz)*I3[60])
           + (oneo2zn)*I4[52];
*(vp++) = U00*I0[61] + U40*I1[61]
           + (eighto2z)*(I2[61] - (lpoz)*I3[61])
           + (oneo2zn)*I4[53];
*(vp++) = U00*I0[62] + U40*I1[62]
           + (eighto2z)*(I2[62] - (lpoz)*I3[62])
           + (oneo2zn)*I4[54];
*(vp++) = U00*I0[63] + U40*I1[63]
           + (eighto2z)*(I2[63] - (lpoz)*I3[63])
           + (oneo2zn)*I4[55];
*(vp++) = U00*I0[64] + U40*I1[64]
           + (eighto2z)*(I2[64] - (lpoz)*I3[64]);
*(vp++) = U00*I0[65] + U40*I1[65]
           + (eighto2z)*(I2[65] - (lpoz)*I3[65]);
*(vp++) = U00*I0[66] + U40*I1[66]
           + (eighto2z)*(I2[66] - (lpoz)*I3[66]);
*(vp++) = U00*I0[67] + U40*I1[67]
           + (eighto2z)*(I2[67] - (lpoz)*I3[67]);
*(vp++) = U00*I0[68] + U40*I1[68]
           + (eighto2z)*(I2[68] - (lpoz)*I3[68]);
*(vp++) = U00*I0[69] + U40*I1[69]
           + (eighto2z)*(I2[69] - (lpoz)*I3[69]);
*(vp++) = U00*I0[70] + U40*I1[70]
           + (eighto2z)*(I2[70] - (lpoz)*I3[70]);
*(vp++) = U00*I0[71] + U40*I1[71]
           + (eighto2z)*(I2[71] - (lpoz)*I3[71]);
*(vp++) = U00*I0[72] + U40*I1[72]
           + (eighto2z)*(I2[72] - (lpoz)*I3[72])
           + (seveno2zn)*I4[56];
*(vp++) = U00*I0[73] + U40*I1[73]
           + (eighto2z)*(I2[73] - (lpoz)*I3[73])
           + (sixo2zn)*I4[57];
*(vp++) = U00*I0[74] + U40*I1[74]
           + (eighto2z)*(I2[74] - (lpoz)*I3[74])
           + (sixo2zn)*I4[58];
*(vp++) = U00*I0[75] + U40*I1[75]
           + (eighto2z)*(I2[75] - (lpoz)*I3[75])
           + (fiveo2zn)*I4[59];
*(vp++) = U00*I0[76] + U40*I1[76]
           + (eighto2z)*(I2[76] - (lpoz)*I3[76])
           + (fiveo2zn)*I4[60];
*(vp++) = U00*I0[77] + U40*I1[77]
           + (eighto2z)*(I2[77] - (lpoz)*I3[77])
           + (fiveo2zn)*I4[61];
*(vp++) = U00*I0[78] + U40*I1[78]
           + (eighto2z)*(I2[78] - (lpoz)*I3[78])
           + (fouro2zn)*I4[62];
*(vp++) = U00*I0[79] + U40*I1[79]
           + (eighto2z)*(I2[79] - (lpoz)*I3[79])
           + (fouro2zn)*I4[63];
*(vp++) = U00*I0[80] + U40*I1[80]
           + (eighto2z)*(I2[80] - (lpoz)*I3[80])
           + (fouro2zn)*I4[64];
*(vp++) = U00*I0[81] + U40*I1[81]
           + (eighto2z)*(I2[81] - (lpoz)*I3[81])
           + (fouro2zn)*I4[65];
*(vp++) = U00*I0[82] + U40*I1[82]
           + (eighto2z)*(I2[82] - (lpoz)*I3[82])
           + (threeo2zn)*I4[66];
*(vp++) = U00*I0[83] + U40*I1[83]
           + (eighto2z)*(I2[83] - (lpoz)*I3[83])
           + (threeo2zn)*I4[67];
*(vp++) = U00*I0[84] + U40*I1[84]
           + (eighto2z)*(I2[84] - (lpoz)*I3[84])
           + (threeo2zn)*I4[68];
*(vp++) = U00*I0[85] + U40*I1[85]
           + (eighto2z)*(I2[85] - (lpoz)*I3[85])
           + (threeo2zn)*I4[69];
*(vp++) = U00*I0[86] + U40*I1[86]
           + (eighto2z)*(I2[86] - (lpoz)*I3[86])
           + (threeo2zn)*I4[70];
*(vp++) = U00*I0[87] + U40*I1[87]
           + (eighto2z)*(I2[87] - (lpoz)*I3[87])
           + (twoo2zn)*I4[71];
*(vp++) = U00*I0[88] + U40*I1[88]
           + (eighto2z)*(I2[88] - (lpoz)*I3[88])
           + (twoo2zn)*I4[72];
*(vp++) = U00*I0[89] + U40*I1[89]
           + (eighto2z)*(I2[89] - (lpoz)*I3[89])
           + (twoo2zn)*I4[73];
*(vp++) = U00*I0[90] + U40*I1[90]
           + (eighto2z)*(I2[90] - (lpoz)*I3[90])
           + (twoo2zn)*I4[74];
*(vp++) = U00*I0[91] + U40*I1[91]
           + (eighto2z)*(I2[91] - (lpoz)*I3[91])
           + (twoo2zn)*I4[75];
*(vp++) = U00*I0[92] + U40*I1[92]
           + (eighto2z)*(I2[92] - (lpoz)*I3[92])
           + (twoo2zn)*I4[76];
*(vp++) = U00*I0[93] + U40*I1[93]
           + (eighto2z)*(I2[93] - (lpoz)*I3[93])
           + (oneo2zn)*I4[77];
*(vp++) = U00*I0[94] + U40*I1[94]
           + (eighto2z)*(I2[94] - (lpoz)*I3[94])
           + (oneo2zn)*I4[78];
*(vp++) = U00*I0[95] + U40*I1[95]
           + (eighto2z)*(I2[95] - (lpoz)*I3[95])
           + (oneo2zn)*I4[79];
*(vp++) = U00*I0[96] + U40*I1[96]
           + (eighto2z)*(I2[96] - (lpoz)*I3[96])
           + (oneo2zn)*I4[80];
*(vp++) = U00*I0[97] + U40*I1[97]
           + (eighto2z)*(I2[97] - (lpoz)*I3[97])
           + (oneo2zn)*I4[81];
*(vp++) = U00*I0[98] + U40*I1[98]
           + (eighto2z)*(I2[98] - (lpoz)*I3[98])
           + (oneo2zn)*I4[82];
*(vp++) = U00*I0[99] + U40*I1[99]
           + (eighto2z)*(I2[99] - (lpoz)*I3[99])
           + (oneo2zn)*I4[83];
*(vp++) = U00*I0[100] + U40*I1[100]
           + (eighto2z)*(I2[100] - (lpoz)*I3[100]);
*(vp++) = U00*I0[101] + U40*I1[101]
           + (eighto2z)*(I2[101] - (lpoz)*I3[101]);
*(vp++) = U00*I0[102] + U40*I1[102]
           + (eighto2z)*(I2[102] - (lpoz)*I3[102]);
*(vp++) = U00*I0[103] + U40*I1[103]
           + (eighto2z)*(I2[103] - (lpoz)*I3[103]);
*(vp++) = U00*I0[104] + U40*I1[104]
           + (eighto2z)*(I2[104] - (lpoz)*I3[104]);
*(vp++) = U00*I0[105] + U40*I1[105]
           + (eighto2z)*(I2[105] - (lpoz)*I3[105]);
*(vp++) = U00*I0[106] + U40*I1[106]
           + (eighto2z)*(I2[106] - (lpoz)*I3[106]);
*(vp++) = U00*I0[107] + U40*I1[107]
           + (eighto2z)*(I2[107] - (lpoz)*I3[107]);
*(vp++) = U00*I0[108] + U40*I1[108]
           + (seveno2z)*(I2[108] - (lpoz)*I3[108])
           + (seveno2zn)*I4[84];
*(vp++) = U00*I0[109] + U40*I1[109]
           + (seveno2z)*(I2[109] - (lpoz)*I3[109])
           + (sixo2zn)*I4[85];
*(vp++) = U00*I0[110] + U40*I1[110]
           + (seveno2z)*(I2[110] - (lpoz)*I3[110])
           + (sixo2zn)*I4[86];
*(vp++) = U00*I0[111] + U40*I1[111]
           + (seveno2z)*(I2[111] - (lpoz)*I3[111])
           + (fiveo2zn)*I4[87];
*(vp++) = U00*I0[112] + U40*I1[112]
           + (seveno2z)*(I2[112] - (lpoz)*I3[112])
           + (fiveo2zn)*I4[88];
*(vp++) = U00*I0[113] + U40*I1[113]
           + (seveno2z)*(I2[113] - (lpoz)*I3[113])
           + (fiveo2zn)*I4[89];
*(vp++) = U00*I0[114] + U40*I1[114]
           + (seveno2z)*(I2[114] - (lpoz)*I3[114])
           + (fouro2zn)*I4[90];
*(vp++) = U00*I0[115] + U40*I1[115]
           + (seveno2z)*(I2[115] - (lpoz)*I3[115])
           + (fouro2zn)*I4[91];
*(vp++) = U00*I0[116] + U40*I1[116]
           + (seveno2z)*(I2[116] - (lpoz)*I3[116])
           + (fouro2zn)*I4[92];
*(vp++) = U00*I0[117] + U40*I1[117]
           + (seveno2z)*(I2[117] - (lpoz)*I3[117])
           + (fouro2zn)*I4[93];
*(vp++) = U00*I0[118] + U40*I1[118]
           + (seveno2z)*(I2[118] - (lpoz)*I3[118])
           + (threeo2zn)*I4[94];
*(vp++) = U00*I0[119] + U40*I1[119]
           + (seveno2z)*(I2[119] - (lpoz)*I3[119])
           + (threeo2zn)*I4[95];
*(vp++) = U00*I0[120] + U40*I1[120]
           + (seveno2z)*(I2[120] - (lpoz)*I3[120])
           + (threeo2zn)*I4[96];
*(vp++) = U00*I0[121] + U40*I1[121]
           + (seveno2z)*(I2[121] - (lpoz)*I3[121])
           + (threeo2zn)*I4[97];
*(vp++) = U00*I0[122] + U40*I1[122]
           + (seveno2z)*(I2[122] - (lpoz)*I3[122])
           + (threeo2zn)*I4[98];
*(vp++) = U00*I0[123] + U40*I1[123]
           + (seveno2z)*(I2[123] - (lpoz)*I3[123])
           + (twoo2zn)*I4[99];
*(vp++) = U00*I0[124] + U40*I1[124]
           + (seveno2z)*(I2[124] - (lpoz)*I3[124])
           + (twoo2zn)*I4[100];
*(vp++) = U00*I0[125] + U40*I1[125]
           + (seveno2z)*(I2[125] - (lpoz)*I3[125])
           + (twoo2zn)*I4[101];
*(vp++) = U00*I0[126] + U40*I1[126]
           + (seveno2z)*(I2[126] - (lpoz)*I3[126])
           + (twoo2zn)*I4[102];
*(vp++) = U00*I0[127] + U40*I1[127]
           + (seveno2z)*(I2[127] - (lpoz)*I3[127])
           + (twoo2zn)*I4[103];
*(vp++) = U00*I0[128] + U40*I1[128]
           + (seveno2z)*(I2[128] - (lpoz)*I3[128])
           + (twoo2zn)*I4[104];
*(vp++) = U00*I0[129] + U40*I1[129]
           + (seveno2z)*(I2[129] - (lpoz)*I3[129])
           + (oneo2zn)*I4[105];
*(vp++) = U00*I0[130] + U40*I1[130]
           + (seveno2z)*(I2[130] - (lpoz)*I3[130])
           + (oneo2zn)*I4[106];
*(vp++) = U00*I0[131] + U40*I1[131]
           + (seveno2z)*(I2[131] - (lpoz)*I3[131])
           + (oneo2zn)*I4[107];
*(vp++) = U00*I0[132] + U40*I1[132]
           + (seveno2z)*(I2[132] - (lpoz)*I3[132])
           + (oneo2zn)*I4[108];
*(vp++) = U00*I0[133] + U40*I1[133]
           + (seveno2z)*(I2[133] - (lpoz)*I3[133])
           + (oneo2zn)*I4[109];
*(vp++) = U00*I0[134] + U40*I1[134]
           + (seveno2z)*(I2[134] - (lpoz)*I3[134])
           + (oneo2zn)*I4[110];
*(vp++) = U00*I0[135] + U40*I1[135]
           + (seveno2z)*(I2[135] - (lpoz)*I3[135])
           + (oneo2zn)*I4[111];
*(vp++) = U00*I0[136] + U40*I1[136]
           + (seveno2z)*(I2[136] - (lpoz)*I3[136]);
*(vp++) = U00*I0[137] + U40*I1[137]
           + (seveno2z)*(I2[137] - (lpoz)*I3[137]);
*(vp++) = U00*I0[138] + U40*I1[138]
           + (seveno2z)*(I2[138] - (lpoz)*I3[138]);
*(vp++) = U00*I0[139] + U40*I1[139]
           + (seveno2z)*(I2[139] - (lpoz)*I3[139]);
*(vp++) = U00*I0[140] + U40*I1[140]
           + (seveno2z)*(I2[140] - (lpoz)*I3[140]);
*(vp++) = U00*I0[141] + U40*I1[141]
           + (seveno2z)*(I2[141] - (lpoz)*I3[141]);
*(vp++) = U00*I0[142] + U40*I1[142]
           + (seveno2z)*(I2[142] - (lpoz)*I3[142]);
*(vp++) = U00*I0[143] + U40*I1[143]
           + (seveno2z)*(I2[143] - (lpoz)*I3[143]);
*(vp++) = U00*I0[144] + U40*I1[144]
           + (seveno2z)*(I2[144] - (lpoz)*I3[144])
           + (seveno2zn)*I4[112];
*(vp++) = U00*I0[145] + U40*I1[145]
           + (seveno2z)*(I2[145] - (lpoz)*I3[145])
           + (sixo2zn)*I4[113];
*(vp++) = U00*I0[146] + U40*I1[146]
           + (seveno2z)*(I2[146] - (lpoz)*I3[146])
           + (sixo2zn)*I4[114];
*(vp++) = U00*I0[147] + U40*I1[147]
           + (seveno2z)*(I2[147] - (lpoz)*I3[147])
           + (fiveo2zn)*I4[115];
*(vp++) = U00*I0[148] + U40*I1[148]
           + (seveno2z)*(I2[148] - (lpoz)*I3[148])
           + (fiveo2zn)*I4[116];
*(vp++) = U00*I0[149] + U40*I1[149]
           + (seveno2z)*(I2[149] - (lpoz)*I3[149])
           + (fiveo2zn)*I4[117];
*(vp++) = U00*I0[150] + U40*I1[150]
           + (seveno2z)*(I2[150] - (lpoz)*I3[150])
           + (fouro2zn)*I4[118];
*(vp++) = U00*I0[151] + U40*I1[151]
           + (seveno2z)*(I2[151] - (lpoz)*I3[151])
           + (fouro2zn)*I4[119];
*(vp++) = U00*I0[152] + U40*I1[152]
           + (seveno2z)*(I2[152] - (lpoz)*I3[152])
           + (fouro2zn)*I4[120];
*(vp++) = U00*I0[153] + U40*I1[153]
           + (seveno2z)*(I2[153] - (lpoz)*I3[153])
           + (fouro2zn)*I4[121];
*(vp++) = U00*I0[154] + U40*I1[154]
           + (seveno2z)*(I2[154] - (lpoz)*I3[154])
           + (threeo2zn)*I4[122];
*(vp++) = U00*I0[155] + U40*I1[155]
           + (seveno2z)*(I2[155] - (lpoz)*I3[155])
           + (threeo2zn)*I4[123];
*(vp++) = U00*I0[156] + U40*I1[156]
           + (seveno2z)*(I2[156] - (lpoz)*I3[156])
           + (threeo2zn)*I4[124];
*(vp++) = U00*I0[157] + U40*I1[157]
           + (seveno2z)*(I2[157] - (lpoz)*I3[157])
           + (threeo2zn)*I4[125];
*(vp++) = U00*I0[158] + U40*I1[158]
           + (seveno2z)*(I2[158] - (lpoz)*I3[158])
           + (threeo2zn)*I4[126];
*(vp++) = U00*I0[159] + U40*I1[159]
           + (seveno2z)*(I2[159] - (lpoz)*I3[159])
           + (twoo2zn)*I4[127];
*(vp++) = U00*I0[160] + U40*I1[160]
           + (seveno2z)*(I2[160] - (lpoz)*I3[160])
           + (twoo2zn)*I4[128];
*(vp++) = U00*I0[161] + U40*I1[161]
           + (seveno2z)*(I2[161] - (lpoz)*I3[161])
           + (twoo2zn)*I4[129];
*(vp++) = U00*I0[162] + U40*I1[162]
           + (seveno2z)*(I2[162] - (lpoz)*I3[162])
           + (twoo2zn)*I4[130];
*(vp++) = U00*I0[163] + U40*I1[163]
           + (seveno2z)*(I2[163] - (lpoz)*I3[163])
           + (twoo2zn)*I4[131];
*(vp++) = U00*I0[164] + U40*I1[164]
           + (seveno2z)*(I2[164] - (lpoz)*I3[164])
           + (twoo2zn)*I4[132];
*(vp++) = U00*I0[165] + U40*I1[165]
           + (seveno2z)*(I2[165] - (lpoz)*I3[165])
           + (oneo2zn)*I4[133];
*(vp++) = U00*I0[166] + U40*I1[166]
           + (seveno2z)*(I2[166] - (lpoz)*I3[166])
           + (oneo2zn)*I4[134];
*(vp++) = U00*I0[167] + U40*I1[167]
           + (seveno2z)*(I2[167] - (lpoz)*I3[167])
           + (oneo2zn)*I4[135];
*(vp++) = U00*I0[168] + U40*I1[168]
           + (seveno2z)*(I2[168] - (lpoz)*I3[168])
           + (oneo2zn)*I4[136];
*(vp++) = U00*I0[169] + U40*I1[169]
           + (seveno2z)*(I2[169] - (lpoz)*I3[169])
           + (oneo2zn)*I4[137];
*(vp++) = U00*I0[170] + U40*I1[170]
           + (seveno2z)*(I2[170] - (lpoz)*I3[170])
           + (oneo2zn)*I4[138];
*(vp++) = U00*I0[171] + U40*I1[171]
           + (seveno2z)*(I2[171] - (lpoz)*I3[171])
           + (oneo2zn)*I4[139];
*(vp++) = U00*I0[172] + U40*I1[172]
           + (seveno2z)*(I2[172] - (lpoz)*I3[172]);
*(vp++) = U00*I0[173] + U40*I1[173]
           + (seveno2z)*(I2[173] - (lpoz)*I3[173]);
*(vp++) = U00*I0[174] + U40*I1[174]
           + (seveno2z)*(I2[174] - (lpoz)*I3[174]);
*(vp++) = U00*I0[175] + U40*I1[175]
           + (seveno2z)*(I2[175] - (lpoz)*I3[175]);
*(vp++) = U00*I0[176] + U40*I1[176]
           + (seveno2z)*(I2[176] - (lpoz)*I3[176]);
*(vp++) = U00*I0[177] + U40*I1[177]
           + (seveno2z)*(I2[177] - (lpoz)*I3[177]);
*(vp++) = U00*I0[178] + U40*I1[178]
           + (seveno2z)*(I2[178] - (lpoz)*I3[178]);
*(vp++) = U00*I0[179] + U40*I1[179]
           + (seveno2z)*(I2[179] - (lpoz)*I3[179]);
*(vp++) = U00*I0[180] + U40*I1[180]
           + (seveno2z)*(I2[180] - (lpoz)*I3[180])
           + (seveno2zn)*I4[140];
*(vp++) = U00*I0[181] + U40*I1[181]
           + (seveno2z)*(I2[181] - (lpoz)*I3[181])
           + (sixo2zn)*I4[141];
*(vp++) = U00*I0[182] + U40*I1[182]
           + (seveno2z)*(I2[182] - (lpoz)*I3[182])
           + (sixo2zn)*I4[142];
*(vp++) = U00*I0[183] + U40*I1[183]
           + (seveno2z)*(I2[183] - (lpoz)*I3[183])
           + (fiveo2zn)*I4[143];
*(vp++) = U00*I0[184] + U40*I1[184]
           + (seveno2z)*(I2[184] - (lpoz)*I3[184])
           + (fiveo2zn)*I4[144];
*(vp++) = U00*I0[185] + U40*I1[185]
           + (seveno2z)*(I2[185] - (lpoz)*I3[185])
           + (fiveo2zn)*I4[145];
*(vp++) = U00*I0[186] + U40*I1[186]
           + (seveno2z)*(I2[186] - (lpoz)*I3[186])
           + (fouro2zn)*I4[146];
*(vp++) = U00*I0[187] + U40*I1[187]
           + (seveno2z)*(I2[187] - (lpoz)*I3[187])
           + (fouro2zn)*I4[147];
*(vp++) = U00*I0[188] + U40*I1[188]
           + (seveno2z)*(I2[188] - (lpoz)*I3[188])
           + (fouro2zn)*I4[148];
*(vp++) = U00*I0[189] + U40*I1[189]
           + (seveno2z)*(I2[189] - (lpoz)*I3[189])
           + (fouro2zn)*I4[149];
*(vp++) = U00*I0[190] + U40*I1[190]
           + (seveno2z)*(I2[190] - (lpoz)*I3[190])
           + (threeo2zn)*I4[150];
*(vp++) = U00*I0[191] + U40*I1[191]
           + (seveno2z)*(I2[191] - (lpoz)*I3[191])
           + (threeo2zn)*I4[151];
*(vp++) = U00*I0[192] + U40*I1[192]
           + (seveno2z)*(I2[192] - (lpoz)*I3[192])
           + (threeo2zn)*I4[152];
*(vp++) = U00*I0[193] + U40*I1[193]
           + (seveno2z)*(I2[193] - (lpoz)*I3[193])
           + (threeo2zn)*I4[153];
*(vp++) = U00*I0[194] + U40*I1[194]
           + (seveno2z)*(I2[194] - (lpoz)*I3[194])
           + (threeo2zn)*I4[154];
*(vp++) = U00*I0[195] + U40*I1[195]
           + (seveno2z)*(I2[195] - (lpoz)*I3[195])
           + (twoo2zn)*I4[155];
*(vp++) = U00*I0[196] + U40*I1[196]
           + (seveno2z)*(I2[196] - (lpoz)*I3[196])
           + (twoo2zn)*I4[156];
*(vp++) = U00*I0[197] + U40*I1[197]
           + (seveno2z)*(I2[197] - (lpoz)*I3[197])
           + (twoo2zn)*I4[157];
*(vp++) = U00*I0[198] + U40*I1[198]
           + (seveno2z)*(I2[198] - (lpoz)*I3[198])
           + (twoo2zn)*I4[158];
*(vp++) = U00*I0[199] + U40*I1[199]
           + (seveno2z)*(I2[199] - (lpoz)*I3[199])
           + (twoo2zn)*I4[159];
*(vp++) = U00*I0[200] + U40*I1[200]
           + (seveno2z)*(I2[200] - (lpoz)*I3[200])
           + (twoo2zn)*I4[160];
*(vp++) = U00*I0[201] + U40*I1[201]
           + (seveno2z)*(I2[201] - (lpoz)*I3[201])
           + (oneo2zn)*I4[161];
*(vp++) = U00*I0[202] + U40*I1[202]
           + (seveno2z)*(I2[202] - (lpoz)*I3[202])
           + (oneo2zn)*I4[162];
*(vp++) = U00*I0[203] + U40*I1[203]
           + (seveno2z)*(I2[203] - (lpoz)*I3[203])
           + (oneo2zn)*I4[163];
*(vp++) = U00*I0[204] + U40*I1[204]
           + (seveno2z)*(I2[204] - (lpoz)*I3[204])
           + (oneo2zn)*I4[164];
*(vp++) = U00*I0[205] + U40*I1[205]
           + (seveno2z)*(I2[205] - (lpoz)*I3[205])
           + (oneo2zn)*I4[165];
*(vp++) = U00*I0[206] + U40*I1[206]
           + (seveno2z)*(I2[206] - (lpoz)*I3[206])
           + (oneo2zn)*I4[166];
*(vp++) = U00*I0[207] + U40*I1[207]
           + (seveno2z)*(I2[207] - (lpoz)*I3[207])
           + (oneo2zn)*I4[167];
*(vp++) = U00*I0[208] + U40*I1[208]
           + (seveno2z)*(I2[208] - (lpoz)*I3[208]);
*(vp++) = U00*I0[209] + U40*I1[209]
           + (seveno2z)*(I2[209] - (lpoz)*I3[209]);
*(vp++) = U00*I0[210] + U40*I1[210]
           + (seveno2z)*(I2[210] - (lpoz)*I3[210]);
*(vp++) = U00*I0[211] + U40*I1[211]
           + (seveno2z)*(I2[211] - (lpoz)*I3[211]);
*(vp++) = U00*I0[212] + U40*I1[212]
           + (seveno2z)*(I2[212] - (lpoz)*I3[212]);
*(vp++) = U00*I0[213] + U40*I1[213]
           + (seveno2z)*(I2[213] - (lpoz)*I3[213]);
*(vp++) = U00*I0[214] + U40*I1[214]
           + (seveno2z)*(I2[214] - (lpoz)*I3[214]);
*(vp++) = U00*I0[215] + U40*I1[215]
           + (seveno2z)*(I2[215] - (lpoz)*I3[215]);
*(vp++) = U00*I0[216] + U40*I1[216]
           + (sixo2z)*(I2[216] - (lpoz)*I3[216])
           + (seveno2zn)*I4[168];
*(vp++) = U00*I0[217] + U40*I1[217]
           + (sixo2z)*(I2[217] - (lpoz)*I3[217])
           + (sixo2zn)*I4[169];
*(vp++) = U00*I0[218] + U40*I1[218]
           + (sixo2z)*(I2[218] - (lpoz)*I3[218])
           + (sixo2zn)*I4[170];
*(vp++) = U00*I0[219] + U40*I1[219]
           + (sixo2z)*(I2[219] - (lpoz)*I3[219])
           + (fiveo2zn)*I4[171];
*(vp++) = U00*I0[220] + U40*I1[220]
           + (sixo2z)*(I2[220] - (lpoz)*I3[220])
           + (fiveo2zn)*I4[172];
*(vp++) = U00*I0[221] + U40*I1[221]
           + (sixo2z)*(I2[221] - (lpoz)*I3[221])
           + (fiveo2zn)*I4[173];
*(vp++) = U00*I0[222] + U40*I1[222]
           + (sixo2z)*(I2[222] - (lpoz)*I3[222])
           + (fouro2zn)*I4[174];
*(vp++) = U00*I0[223] + U40*I1[223]
           + (sixo2z)*(I2[223] - (lpoz)*I3[223])
           + (fouro2zn)*I4[175];
*(vp++) = U00*I0[224] + U40*I1[224]
           + (sixo2z)*(I2[224] - (lpoz)*I3[224])
           + (fouro2zn)*I4[176];
*(vp++) = U00*I0[225] + U40*I1[225]
           + (sixo2z)*(I2[225] - (lpoz)*I3[225])
           + (fouro2zn)*I4[177];
*(vp++) = U00*I0[226] + U40*I1[226]
           + (sixo2z)*(I2[226] - (lpoz)*I3[226])
           + (threeo2zn)*I4[178];
*(vp++) = U00*I0[227] + U40*I1[227]
           + (sixo2z)*(I2[227] - (lpoz)*I3[227])
           + (threeo2zn)*I4[179];
*(vp++) = U00*I0[228] + U40*I1[228]
           + (sixo2z)*(I2[228] - (lpoz)*I3[228])
           + (threeo2zn)*I4[180];
*(vp++) = U00*I0[229] + U40*I1[229]
           + (sixo2z)*(I2[229] - (lpoz)*I3[229])
           + (threeo2zn)*I4[181];
*(vp++) = U00*I0[230] + U40*I1[230]
           + (sixo2z)*(I2[230] - (lpoz)*I3[230])
           + (threeo2zn)*I4[182];
*(vp++) = U00*I0[231] + U40*I1[231]
           + (sixo2z)*(I2[231] - (lpoz)*I3[231])
           + (twoo2zn)*I4[183];
*(vp++) = U00*I0[232] + U40*I1[232]
           + (sixo2z)*(I2[232] - (lpoz)*I3[232])
           + (twoo2zn)*I4[184];
*(vp++) = U00*I0[233] + U40*I1[233]
           + (sixo2z)*(I2[233] - (lpoz)*I3[233])
           + (twoo2zn)*I4[185];
*(vp++) = U00*I0[234] + U40*I1[234]
           + (sixo2z)*(I2[234] - (lpoz)*I3[234])
           + (twoo2zn)*I4[186];
*(vp++) = U00*I0[235] + U40*I1[235]
           + (sixo2z)*(I2[235] - (lpoz)*I3[235])
           + (twoo2zn)*I4[187];
*(vp++) = U00*I0[236] + U40*I1[236]
           + (sixo2z)*(I2[236] - (lpoz)*I3[236])
           + (twoo2zn)*I4[188];
*(vp++) = U00*I0[237] + U40*I1[237]
           + (sixo2z)*(I2[237] - (lpoz)*I3[237])
           + (oneo2zn)*I4[189];
*(vp++) = U00*I0[238] + U40*I1[238]
           + (sixo2z)*(I2[238] - (lpoz)*I3[238])
           + (oneo2zn)*I4[190];
*(vp++) = U00*I0[239] + U40*I1[239]
           + (sixo2z)*(I2[239] - (lpoz)*I3[239])
           + (oneo2zn)*I4[191];
*(vp++) = U00*I0[240] + U40*I1[240]
           + (sixo2z)*(I2[240] - (lpoz)*I3[240])
           + (oneo2zn)*I4[192];
*(vp++) = U00*I0[241] + U40*I1[241]
           + (sixo2z)*(I2[241] - (lpoz)*I3[241])
           + (oneo2zn)*I4[193];
*(vp++) = U00*I0[242] + U40*I1[242]
           + (sixo2z)*(I2[242] - (lpoz)*I3[242])
           + (oneo2zn)*I4[194];
*(vp++) = U00*I0[243] + U40*I1[243]
           + (sixo2z)*(I2[243] - (lpoz)*I3[243])
           + (oneo2zn)*I4[195];
*(vp++) = U00*I0[244] + U40*I1[244]
           + (sixo2z)*(I2[244] - (lpoz)*I3[244]);
*(vp++) = U00*I0[245] + U40*I1[245]
           + (sixo2z)*(I2[245] - (lpoz)*I3[245]);
*(vp++) = U00*I0[246] + U40*I1[246]
           + (sixo2z)*(I2[246] - (lpoz)*I3[246]);
*(vp++) = U00*I0[247] + U40*I1[247]
           + (sixo2z)*(I2[247] - (lpoz)*I3[247]);
*(vp++) = U00*I0[248] + U40*I1[248]
           + (sixo2z)*(I2[248] - (lpoz)*I3[248]);
*(vp++) = U00*I0[249] + U40*I1[249]
           + (sixo2z)*(I2[249] - (lpoz)*I3[249]);
*(vp++) = U00*I0[250] + U40*I1[250]
           + (sixo2z)*(I2[250] - (lpoz)*I3[250]);
*(vp++) = U00*I0[251] + U40*I1[251]
           + (sixo2z)*(I2[251] - (lpoz)*I3[251]);
*(vp++) = U00*I0[252] + U40*I1[252]
           + (sixo2z)*(I2[252] - (lpoz)*I3[252])
           + (seveno2zn)*I4[196];
*(vp++) = U00*I0[253] + U40*I1[253]
           + (sixo2z)*(I2[253] - (lpoz)*I3[253])
           + (sixo2zn)*I4[197];
*(vp++) = U00*I0[254] + U40*I1[254]
           + (sixo2z)*(I2[254] - (lpoz)*I3[254])
           + (sixo2zn)*I4[198];
*(vp++) = U00*I0[255] + U40*I1[255]
           + (sixo2z)*(I2[255] - (lpoz)*I3[255])
           + (fiveo2zn)*I4[199];
*(vp++) = U00*I0[256] + U40*I1[256]
           + (sixo2z)*(I2[256] - (lpoz)*I3[256])
           + (fiveo2zn)*I4[200];
*(vp++) = U00*I0[257] + U40*I1[257]
           + (sixo2z)*(I2[257] - (lpoz)*I3[257])
           + (fiveo2zn)*I4[201];
*(vp++) = U00*I0[258] + U40*I1[258]
           + (sixo2z)*(I2[258] - (lpoz)*I3[258])
           + (fouro2zn)*I4[202];
*(vp++) = U00*I0[259] + U40*I1[259]
           + (sixo2z)*(I2[259] - (lpoz)*I3[259])
           + (fouro2zn)*I4[203];
*(vp++) = U00*I0[260] + U40*I1[260]
           + (sixo2z)*(I2[260] - (lpoz)*I3[260])
           + (fouro2zn)*I4[204];
*(vp++) = U00*I0[261] + U40*I1[261]
           + (sixo2z)*(I2[261] - (lpoz)*I3[261])
           + (fouro2zn)*I4[205];
*(vp++) = U00*I0[262] + U40*I1[262]
           + (sixo2z)*(I2[262] - (lpoz)*I3[262])
           + (threeo2zn)*I4[206];
*(vp++) = U00*I0[263] + U40*I1[263]
           + (sixo2z)*(I2[263] - (lpoz)*I3[263])
           + (threeo2zn)*I4[207];
*(vp++) = U00*I0[264] + U40*I1[264]
           + (sixo2z)*(I2[264] - (lpoz)*I3[264])
           + (threeo2zn)*I4[208];
*(vp++) = U00*I0[265] + U40*I1[265]
           + (sixo2z)*(I2[265] - (lpoz)*I3[265])
           + (threeo2zn)*I4[209];
*(vp++) = U00*I0[266] + U40*I1[266]
           + (sixo2z)*(I2[266] - (lpoz)*I3[266])
           + (threeo2zn)*I4[210];
*(vp++) = U00*I0[267] + U40*I1[267]
           + (sixo2z)*(I2[267] - (lpoz)*I3[267])
           + (twoo2zn)*I4[211];
*(vp++) = U00*I0[268] + U40*I1[268]
           + (sixo2z)*(I2[268] - (lpoz)*I3[268])
           + (twoo2zn)*I4[212];
*(vp++) = U00*I0[269] + U40*I1[269]
           + (sixo2z)*(I2[269] - (lpoz)*I3[269])
           + (twoo2zn)*I4[213];
*(vp++) = U00*I0[270] + U40*I1[270]
           + (sixo2z)*(I2[270] - (lpoz)*I3[270])
           + (twoo2zn)*I4[214];
*(vp++) = U00*I0[271] + U40*I1[271]
           + (sixo2z)*(I2[271] - (lpoz)*I3[271])
           + (twoo2zn)*I4[215];
*(vp++) = U00*I0[272] + U40*I1[272]
           + (sixo2z)*(I2[272] - (lpoz)*I3[272])
           + (twoo2zn)*I4[216];
*(vp++) = U00*I0[273] + U40*I1[273]
           + (sixo2z)*(I2[273] - (lpoz)*I3[273])
           + (oneo2zn)*I4[217];
*(vp++) = U00*I0[274] + U40*I1[274]
           + (sixo2z)*(I2[274] - (lpoz)*I3[274])
           + (oneo2zn)*I4[218];
*(vp++) = U00*I0[275] + U40*I1[275]
           + (sixo2z)*(I2[275] - (lpoz)*I3[275])
           + (oneo2zn)*I4[219];
*(vp++) = U00*I0[276] + U40*I1[276]
           + (sixo2z)*(I2[276] - (lpoz)*I3[276])
           + (oneo2zn)*I4[220];
*(vp++) = U00*I0[277] + U40*I1[277]
           + (sixo2z)*(I2[277] - (lpoz)*I3[277])
           + (oneo2zn)*I4[221];
*(vp++) = U00*I0[278] + U40*I1[278]
           + (sixo2z)*(I2[278] - (lpoz)*I3[278])
           + (oneo2zn)*I4[222];
*(vp++) = U00*I0[279] + U40*I1[279]
           + (sixo2z)*(I2[279] - (lpoz)*I3[279])
           + (oneo2zn)*I4[223];
*(vp++) = U00*I0[280] + U40*I1[280]
           + (sixo2z)*(I2[280] - (lpoz)*I3[280]);
*(vp++) = U00*I0[281] + U40*I1[281]
           + (sixo2z)*(I2[281] - (lpoz)*I3[281]);
*(vp++) = U00*I0[282] + U40*I1[282]
           + (sixo2z)*(I2[282] - (lpoz)*I3[282]);
*(vp++) = U00*I0[283] + U40*I1[283]
           + (sixo2z)*(I2[283] - (lpoz)*I3[283]);
*(vp++) = U00*I0[284] + U40*I1[284]
           + (sixo2z)*(I2[284] - (lpoz)*I3[284]);
*(vp++) = U00*I0[285] + U40*I1[285]
           + (sixo2z)*(I2[285] - (lpoz)*I3[285]);
*(vp++) = U00*I0[286] + U40*I1[286]
           + (sixo2z)*(I2[286] - (lpoz)*I3[286]);
*(vp++) = U00*I0[287] + U40*I1[287]
           + (sixo2z)*(I2[287] - (lpoz)*I3[287]);
*(vp++) = U00*I0[288] + U40*I1[288]
           + (sixo2z)*(I2[288] - (lpoz)*I3[288])
           + (seveno2zn)*I4[224];
*(vp++) = U00*I0[289] + U40*I1[289]
           + (sixo2z)*(I2[289] - (lpoz)*I3[289])
           + (sixo2zn)*I4[225];
*(vp++) = U00*I0[290] + U40*I1[290]
           + (sixo2z)*(I2[290] - (lpoz)*I3[290])
           + (sixo2zn)*I4[226];
*(vp++) = U00*I0[291] + U40*I1[291]
           + (sixo2z)*(I2[291] - (lpoz)*I3[291])
           + (fiveo2zn)*I4[227];
*(vp++) = U00*I0[292] + U40*I1[292]
           + (sixo2z)*(I2[292] - (lpoz)*I3[292])
           + (fiveo2zn)*I4[228];
*(vp++) = U00*I0[293] + U40*I1[293]
           + (sixo2z)*(I2[293] - (lpoz)*I3[293])
           + (fiveo2zn)*I4[229];
*(vp++) = U00*I0[294] + U40*I1[294]
           + (sixo2z)*(I2[294] - (lpoz)*I3[294])
           + (fouro2zn)*I4[230];
*(vp++) = U00*I0[295] + U40*I1[295]
           + (sixo2z)*(I2[295] - (lpoz)*I3[295])
           + (fouro2zn)*I4[231];
*(vp++) = U00*I0[296] + U40*I1[296]
           + (sixo2z)*(I2[296] - (lpoz)*I3[296])
           + (fouro2zn)*I4[232];
*(vp++) = U00*I0[297] + U40*I1[297]
           + (sixo2z)*(I2[297] - (lpoz)*I3[297])
           + (fouro2zn)*I4[233];
return vp;
}

REALTYPE *_build_n0k0_1(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[298] + U40*I1[298]
           + (sixo2z)*(I2[298] - (lpoz)*I3[298])
           + (threeo2zn)*I4[234];
*(vp++) = U00*I0[299] + U40*I1[299]
           + (sixo2z)*(I2[299] - (lpoz)*I3[299])
           + (threeo2zn)*I4[235];
*(vp++) = U00*I0[300] + U40*I1[300]
           + (sixo2z)*(I2[300] - (lpoz)*I3[300])
           + (threeo2zn)*I4[236];
*(vp++) = U00*I0[301] + U40*I1[301]
           + (sixo2z)*(I2[301] - (lpoz)*I3[301])
           + (threeo2zn)*I4[237];
*(vp++) = U00*I0[302] + U40*I1[302]
           + (sixo2z)*(I2[302] - (lpoz)*I3[302])
           + (threeo2zn)*I4[238];
*(vp++) = U00*I0[303] + U40*I1[303]
           + (sixo2z)*(I2[303] - (lpoz)*I3[303])
           + (twoo2zn)*I4[239];
*(vp++) = U00*I0[304] + U40*I1[304]
           + (sixo2z)*(I2[304] - (lpoz)*I3[304])
           + (twoo2zn)*I4[240];
*(vp++) = U00*I0[305] + U40*I1[305]
           + (sixo2z)*(I2[305] - (lpoz)*I3[305])
           + (twoo2zn)*I4[241];
*(vp++) = U00*I0[306] + U40*I1[306]
           + (sixo2z)*(I2[306] - (lpoz)*I3[306])
           + (twoo2zn)*I4[242];
*(vp++) = U00*I0[307] + U40*I1[307]
           + (sixo2z)*(I2[307] - (lpoz)*I3[307])
           + (twoo2zn)*I4[243];
*(vp++) = U00*I0[308] + U40*I1[308]
           + (sixo2z)*(I2[308] - (lpoz)*I3[308])
           + (twoo2zn)*I4[244];
*(vp++) = U00*I0[309] + U40*I1[309]
           + (sixo2z)*(I2[309] - (lpoz)*I3[309])
           + (oneo2zn)*I4[245];
*(vp++) = U00*I0[310] + U40*I1[310]
           + (sixo2z)*(I2[310] - (lpoz)*I3[310])
           + (oneo2zn)*I4[246];
*(vp++) = U00*I0[311] + U40*I1[311]
           + (sixo2z)*(I2[311] - (lpoz)*I3[311])
           + (oneo2zn)*I4[247];
*(vp++) = U00*I0[312] + U40*I1[312]
           + (sixo2z)*(I2[312] - (lpoz)*I3[312])
           + (oneo2zn)*I4[248];
*(vp++) = U00*I0[313] + U40*I1[313]
           + (sixo2z)*(I2[313] - (lpoz)*I3[313])
           + (oneo2zn)*I4[249];
*(vp++) = U00*I0[314] + U40*I1[314]
           + (sixo2z)*(I2[314] - (lpoz)*I3[314])
           + (oneo2zn)*I4[250];
*(vp++) = U00*I0[315] + U40*I1[315]
           + (sixo2z)*(I2[315] - (lpoz)*I3[315])
           + (oneo2zn)*I4[251];
*(vp++) = U00*I0[316] + U40*I1[316]
           + (sixo2z)*(I2[316] - (lpoz)*I3[316]);
*(vp++) = U00*I0[317] + U40*I1[317]
           + (sixo2z)*(I2[317] - (lpoz)*I3[317]);
*(vp++) = U00*I0[318] + U40*I1[318]
           + (sixo2z)*(I2[318] - (lpoz)*I3[318]);
*(vp++) = U00*I0[319] + U40*I1[319]
           + (sixo2z)*(I2[319] - (lpoz)*I3[319]);
*(vp++) = U00*I0[320] + U40*I1[320]
           + (sixo2z)*(I2[320] - (lpoz)*I3[320]);
*(vp++) = U00*I0[321] + U40*I1[321]
           + (sixo2z)*(I2[321] - (lpoz)*I3[321]);
*(vp++) = U00*I0[322] + U40*I1[322]
           + (sixo2z)*(I2[322] - (lpoz)*I3[322]);
*(vp++) = U00*I0[323] + U40*I1[323]
           + (sixo2z)*(I2[323] - (lpoz)*I3[323]);
*(vp++) = U00*I0[324] + U40*I1[324]
           + (sixo2z)*(I2[324] - (lpoz)*I3[324])
           + (seveno2zn)*I4[252];
*(vp++) = U00*I0[325] + U40*I1[325]
           + (sixo2z)*(I2[325] - (lpoz)*I3[325])
           + (sixo2zn)*I4[253];
*(vp++) = U00*I0[326] + U40*I1[326]
           + (sixo2z)*(I2[326] - (lpoz)*I3[326])
           + (sixo2zn)*I4[254];
*(vp++) = U00*I0[327] + U40*I1[327]
           + (sixo2z)*(I2[327] - (lpoz)*I3[327])
           + (fiveo2zn)*I4[255];
*(vp++) = U00*I0[328] + U40*I1[328]
           + (sixo2z)*(I2[328] - (lpoz)*I3[328])
           + (fiveo2zn)*I4[256];
*(vp++) = U00*I0[329] + U40*I1[329]
           + (sixo2z)*(I2[329] - (lpoz)*I3[329])
           + (fiveo2zn)*I4[257];
*(vp++) = U00*I0[330] + U40*I1[330]
           + (sixo2z)*(I2[330] - (lpoz)*I3[330])
           + (fouro2zn)*I4[258];
*(vp++) = U00*I0[331] + U40*I1[331]
           + (sixo2z)*(I2[331] - (lpoz)*I3[331])
           + (fouro2zn)*I4[259];
*(vp++) = U00*I0[332] + U40*I1[332]
           + (sixo2z)*(I2[332] - (lpoz)*I3[332])
           + (fouro2zn)*I4[260];
*(vp++) = U00*I0[333] + U40*I1[333]
           + (sixo2z)*(I2[333] - (lpoz)*I3[333])
           + (fouro2zn)*I4[261];
*(vp++) = U00*I0[334] + U40*I1[334]
           + (sixo2z)*(I2[334] - (lpoz)*I3[334])
           + (threeo2zn)*I4[262];
*(vp++) = U00*I0[335] + U40*I1[335]
           + (sixo2z)*(I2[335] - (lpoz)*I3[335])
           + (threeo2zn)*I4[263];
*(vp++) = U00*I0[336] + U40*I1[336]
           + (sixo2z)*(I2[336] - (lpoz)*I3[336])
           + (threeo2zn)*I4[264];
*(vp++) = U00*I0[337] + U40*I1[337]
           + (sixo2z)*(I2[337] - (lpoz)*I3[337])
           + (threeo2zn)*I4[265];
*(vp++) = U00*I0[338] + U40*I1[338]
           + (sixo2z)*(I2[338] - (lpoz)*I3[338])
           + (threeo2zn)*I4[266];
*(vp++) = U00*I0[339] + U40*I1[339]
           + (sixo2z)*(I2[339] - (lpoz)*I3[339])
           + (twoo2zn)*I4[267];
*(vp++) = U00*I0[340] + U40*I1[340]
           + (sixo2z)*(I2[340] - (lpoz)*I3[340])
           + (twoo2zn)*I4[268];
*(vp++) = U00*I0[341] + U40*I1[341]
           + (sixo2z)*(I2[341] - (lpoz)*I3[341])
           + (twoo2zn)*I4[269];
*(vp++) = U00*I0[342] + U40*I1[342]
           + (sixo2z)*(I2[342] - (lpoz)*I3[342])
           + (twoo2zn)*I4[270];
*(vp++) = U00*I0[343] + U40*I1[343]
           + (sixo2z)*(I2[343] - (lpoz)*I3[343])
           + (twoo2zn)*I4[271];
*(vp++) = U00*I0[344] + U40*I1[344]
           + (sixo2z)*(I2[344] - (lpoz)*I3[344])
           + (twoo2zn)*I4[272];
*(vp++) = U00*I0[345] + U40*I1[345]
           + (sixo2z)*(I2[345] - (lpoz)*I3[345])
           + (oneo2zn)*I4[273];
*(vp++) = U00*I0[346] + U40*I1[346]
           + (sixo2z)*(I2[346] - (lpoz)*I3[346])
           + (oneo2zn)*I4[274];
*(vp++) = U00*I0[347] + U40*I1[347]
           + (sixo2z)*(I2[347] - (lpoz)*I3[347])
           + (oneo2zn)*I4[275];
*(vp++) = U00*I0[348] + U40*I1[348]
           + (sixo2z)*(I2[348] - (lpoz)*I3[348])
           + (oneo2zn)*I4[276];
*(vp++) = U00*I0[349] + U40*I1[349]
           + (sixo2z)*(I2[349] - (lpoz)*I3[349])
           + (oneo2zn)*I4[277];
*(vp++) = U00*I0[350] + U40*I1[350]
           + (sixo2z)*(I2[350] - (lpoz)*I3[350])
           + (oneo2zn)*I4[278];
*(vp++) = U00*I0[351] + U40*I1[351]
           + (sixo2z)*(I2[351] - (lpoz)*I3[351])
           + (oneo2zn)*I4[279];
*(vp++) = U00*I0[352] + U40*I1[352]
           + (sixo2z)*(I2[352] - (lpoz)*I3[352]);
*(vp++) = U00*I0[353] + U40*I1[353]
           + (sixo2z)*(I2[353] - (lpoz)*I3[353]);
*(vp++) = U00*I0[354] + U40*I1[354]
           + (sixo2z)*(I2[354] - (lpoz)*I3[354]);
*(vp++) = U00*I0[355] + U40*I1[355]
           + (sixo2z)*(I2[355] - (lpoz)*I3[355]);
*(vp++) = U00*I0[356] + U40*I1[356]
           + (sixo2z)*(I2[356] - (lpoz)*I3[356]);
*(vp++) = U00*I0[357] + U40*I1[357]
           + (sixo2z)*(I2[357] - (lpoz)*I3[357]);
*(vp++) = U00*I0[358] + U40*I1[358]
           + (sixo2z)*(I2[358] - (lpoz)*I3[358]);
*(vp++) = U00*I0[359] + U40*I1[359]
           + (sixo2z)*(I2[359] - (lpoz)*I3[359]);
*(vp++) = U00*I0[360] + U40*I1[360]
           + (fiveo2z)*(I2[360] - (lpoz)*I3[360])
           + (seveno2zn)*I4[280];
*(vp++) = U00*I0[361] + U40*I1[361]
           + (fiveo2z)*(I2[361] - (lpoz)*I3[361])
           + (sixo2zn)*I4[281];
*(vp++) = U00*I0[362] + U40*I1[362]
           + (fiveo2z)*(I2[362] - (lpoz)*I3[362])
           + (sixo2zn)*I4[282];
*(vp++) = U00*I0[363] + U40*I1[363]
           + (fiveo2z)*(I2[363] - (lpoz)*I3[363])
           + (fiveo2zn)*I4[283];
*(vp++) = U00*I0[364] + U40*I1[364]
           + (fiveo2z)*(I2[364] - (lpoz)*I3[364])
           + (fiveo2zn)*I4[284];
*(vp++) = U00*I0[365] + U40*I1[365]
           + (fiveo2z)*(I2[365] - (lpoz)*I3[365])
           + (fiveo2zn)*I4[285];
*(vp++) = U00*I0[366] + U40*I1[366]
           + (fiveo2z)*(I2[366] - (lpoz)*I3[366])
           + (fouro2zn)*I4[286];
*(vp++) = U00*I0[367] + U40*I1[367]
           + (fiveo2z)*(I2[367] - (lpoz)*I3[367])
           + (fouro2zn)*I4[287];
*(vp++) = U00*I0[368] + U40*I1[368]
           + (fiveo2z)*(I2[368] - (lpoz)*I3[368])
           + (fouro2zn)*I4[288];
*(vp++) = U00*I0[369] + U40*I1[369]
           + (fiveo2z)*(I2[369] - (lpoz)*I3[369])
           + (fouro2zn)*I4[289];
*(vp++) = U00*I0[370] + U40*I1[370]
           + (fiveo2z)*(I2[370] - (lpoz)*I3[370])
           + (threeo2zn)*I4[290];
*(vp++) = U00*I0[371] + U40*I1[371]
           + (fiveo2z)*(I2[371] - (lpoz)*I3[371])
           + (threeo2zn)*I4[291];
*(vp++) = U00*I0[372] + U40*I1[372]
           + (fiveo2z)*(I2[372] - (lpoz)*I3[372])
           + (threeo2zn)*I4[292];
*(vp++) = U00*I0[373] + U40*I1[373]
           + (fiveo2z)*(I2[373] - (lpoz)*I3[373])
           + (threeo2zn)*I4[293];
*(vp++) = U00*I0[374] + U40*I1[374]
           + (fiveo2z)*(I2[374] - (lpoz)*I3[374])
           + (threeo2zn)*I4[294];
*(vp++) = U00*I0[375] + U40*I1[375]
           + (fiveo2z)*(I2[375] - (lpoz)*I3[375])
           + (twoo2zn)*I4[295];
*(vp++) = U00*I0[376] + U40*I1[376]
           + (fiveo2z)*(I2[376] - (lpoz)*I3[376])
           + (twoo2zn)*I4[296];
*(vp++) = U00*I0[377] + U40*I1[377]
           + (fiveo2z)*(I2[377] - (lpoz)*I3[377])
           + (twoo2zn)*I4[297];
*(vp++) = U00*I0[378] + U40*I1[378]
           + (fiveo2z)*(I2[378] - (lpoz)*I3[378])
           + (twoo2zn)*I4[298];
*(vp++) = U00*I0[379] + U40*I1[379]
           + (fiveo2z)*(I2[379] - (lpoz)*I3[379])
           + (twoo2zn)*I4[299];
*(vp++) = U00*I0[380] + U40*I1[380]
           + (fiveo2z)*(I2[380] - (lpoz)*I3[380])
           + (twoo2zn)*I4[300];
*(vp++) = U00*I0[381] + U40*I1[381]
           + (fiveo2z)*(I2[381] - (lpoz)*I3[381])
           + (oneo2zn)*I4[301];
*(vp++) = U00*I0[382] + U40*I1[382]
           + (fiveo2z)*(I2[382] - (lpoz)*I3[382])
           + (oneo2zn)*I4[302];
*(vp++) = U00*I0[383] + U40*I1[383]
           + (fiveo2z)*(I2[383] - (lpoz)*I3[383])
           + (oneo2zn)*I4[303];
*(vp++) = U00*I0[384] + U40*I1[384]
           + (fiveo2z)*(I2[384] - (lpoz)*I3[384])
           + (oneo2zn)*I4[304];
*(vp++) = U00*I0[385] + U40*I1[385]
           + (fiveo2z)*(I2[385] - (lpoz)*I3[385])
           + (oneo2zn)*I4[305];
*(vp++) = U00*I0[386] + U40*I1[386]
           + (fiveo2z)*(I2[386] - (lpoz)*I3[386])
           + (oneo2zn)*I4[306];
*(vp++) = U00*I0[387] + U40*I1[387]
           + (fiveo2z)*(I2[387] - (lpoz)*I3[387])
           + (oneo2zn)*I4[307];
*(vp++) = U00*I0[388] + U40*I1[388]
           + (fiveo2z)*(I2[388] - (lpoz)*I3[388]);
*(vp++) = U00*I0[389] + U40*I1[389]
           + (fiveo2z)*(I2[389] - (lpoz)*I3[389]);
*(vp++) = U00*I0[390] + U40*I1[390]
           + (fiveo2z)*(I2[390] - (lpoz)*I3[390]);
*(vp++) = U00*I0[391] + U40*I1[391]
           + (fiveo2z)*(I2[391] - (lpoz)*I3[391]);
*(vp++) = U00*I0[392] + U40*I1[392]
           + (fiveo2z)*(I2[392] - (lpoz)*I3[392]);
*(vp++) = U00*I0[393] + U40*I1[393]
           + (fiveo2z)*(I2[393] - (lpoz)*I3[393]);
*(vp++) = U00*I0[394] + U40*I1[394]
           + (fiveo2z)*(I2[394] - (lpoz)*I3[394]);
*(vp++) = U00*I0[395] + U40*I1[395]
           + (fiveo2z)*(I2[395] - (lpoz)*I3[395]);
*(vp++) = U00*I0[396] + U40*I1[396]
           + (fiveo2z)*(I2[396] - (lpoz)*I3[396])
           + (seveno2zn)*I4[308];
*(vp++) = U00*I0[397] + U40*I1[397]
           + (fiveo2z)*(I2[397] - (lpoz)*I3[397])
           + (sixo2zn)*I4[309];
*(vp++) = U00*I0[398] + U40*I1[398]
           + (fiveo2z)*(I2[398] - (lpoz)*I3[398])
           + (sixo2zn)*I4[310];
*(vp++) = U00*I0[399] + U40*I1[399]
           + (fiveo2z)*(I2[399] - (lpoz)*I3[399])
           + (fiveo2zn)*I4[311];
*(vp++) = U00*I0[400] + U40*I1[400]
           + (fiveo2z)*(I2[400] - (lpoz)*I3[400])
           + (fiveo2zn)*I4[312];
*(vp++) = U00*I0[401] + U40*I1[401]
           + (fiveo2z)*(I2[401] - (lpoz)*I3[401])
           + (fiveo2zn)*I4[313];
*(vp++) = U00*I0[402] + U40*I1[402]
           + (fiveo2z)*(I2[402] - (lpoz)*I3[402])
           + (fouro2zn)*I4[314];
*(vp++) = U00*I0[403] + U40*I1[403]
           + (fiveo2z)*(I2[403] - (lpoz)*I3[403])
           + (fouro2zn)*I4[315];
*(vp++) = U00*I0[404] + U40*I1[404]
           + (fiveo2z)*(I2[404] - (lpoz)*I3[404])
           + (fouro2zn)*I4[316];
*(vp++) = U00*I0[405] + U40*I1[405]
           + (fiveo2z)*(I2[405] - (lpoz)*I3[405])
           + (fouro2zn)*I4[317];
*(vp++) = U00*I0[406] + U40*I1[406]
           + (fiveo2z)*(I2[406] - (lpoz)*I3[406])
           + (threeo2zn)*I4[318];
*(vp++) = U00*I0[407] + U40*I1[407]
           + (fiveo2z)*(I2[407] - (lpoz)*I3[407])
           + (threeo2zn)*I4[319];
*(vp++) = U00*I0[408] + U40*I1[408]
           + (fiveo2z)*(I2[408] - (lpoz)*I3[408])
           + (threeo2zn)*I4[320];
*(vp++) = U00*I0[409] + U40*I1[409]
           + (fiveo2z)*(I2[409] - (lpoz)*I3[409])
           + (threeo2zn)*I4[321];
*(vp++) = U00*I0[410] + U40*I1[410]
           + (fiveo2z)*(I2[410] - (lpoz)*I3[410])
           + (threeo2zn)*I4[322];
*(vp++) = U00*I0[411] + U40*I1[411]
           + (fiveo2z)*(I2[411] - (lpoz)*I3[411])
           + (twoo2zn)*I4[323];
*(vp++) = U00*I0[412] + U40*I1[412]
           + (fiveo2z)*(I2[412] - (lpoz)*I3[412])
           + (twoo2zn)*I4[324];
*(vp++) = U00*I0[413] + U40*I1[413]
           + (fiveo2z)*(I2[413] - (lpoz)*I3[413])
           + (twoo2zn)*I4[325];
*(vp++) = U00*I0[414] + U40*I1[414]
           + (fiveo2z)*(I2[414] - (lpoz)*I3[414])
           + (twoo2zn)*I4[326];
*(vp++) = U00*I0[415] + U40*I1[415]
           + (fiveo2z)*(I2[415] - (lpoz)*I3[415])
           + (twoo2zn)*I4[327];
*(vp++) = U00*I0[416] + U40*I1[416]
           + (fiveo2z)*(I2[416] - (lpoz)*I3[416])
           + (twoo2zn)*I4[328];
*(vp++) = U00*I0[417] + U40*I1[417]
           + (fiveo2z)*(I2[417] - (lpoz)*I3[417])
           + (oneo2zn)*I4[329];
*(vp++) = U00*I0[418] + U40*I1[418]
           + (fiveo2z)*(I2[418] - (lpoz)*I3[418])
           + (oneo2zn)*I4[330];
*(vp++) = U00*I0[419] + U40*I1[419]
           + (fiveo2z)*(I2[419] - (lpoz)*I3[419])
           + (oneo2zn)*I4[331];
*(vp++) = U00*I0[420] + U40*I1[420]
           + (fiveo2z)*(I2[420] - (lpoz)*I3[420])
           + (oneo2zn)*I4[332];
*(vp++) = U00*I0[421] + U40*I1[421]
           + (fiveo2z)*(I2[421] - (lpoz)*I3[421])
           + (oneo2zn)*I4[333];
*(vp++) = U00*I0[422] + U40*I1[422]
           + (fiveo2z)*(I2[422] - (lpoz)*I3[422])
           + (oneo2zn)*I4[334];
*(vp++) = U00*I0[423] + U40*I1[423]
           + (fiveo2z)*(I2[423] - (lpoz)*I3[423])
           + (oneo2zn)*I4[335];
*(vp++) = U00*I0[424] + U40*I1[424]
           + (fiveo2z)*(I2[424] - (lpoz)*I3[424]);
*(vp++) = U00*I0[425] + U40*I1[425]
           + (fiveo2z)*(I2[425] - (lpoz)*I3[425]);
*(vp++) = U00*I0[426] + U40*I1[426]
           + (fiveo2z)*(I2[426] - (lpoz)*I3[426]);
*(vp++) = U00*I0[427] + U40*I1[427]
           + (fiveo2z)*(I2[427] - (lpoz)*I3[427]);
*(vp++) = U00*I0[428] + U40*I1[428]
           + (fiveo2z)*(I2[428] - (lpoz)*I3[428]);
*(vp++) = U00*I0[429] + U40*I1[429]
           + (fiveo2z)*(I2[429] - (lpoz)*I3[429]);
*(vp++) = U00*I0[430] + U40*I1[430]
           + (fiveo2z)*(I2[430] - (lpoz)*I3[430]);
*(vp++) = U00*I0[431] + U40*I1[431]
           + (fiveo2z)*(I2[431] - (lpoz)*I3[431]);
*(vp++) = U00*I0[432] + U40*I1[432]
           + (fiveo2z)*(I2[432] - (lpoz)*I3[432])
           + (seveno2zn)*I4[336];
*(vp++) = U00*I0[433] + U40*I1[433]
           + (fiveo2z)*(I2[433] - (lpoz)*I3[433])
           + (sixo2zn)*I4[337];
*(vp++) = U00*I0[434] + U40*I1[434]
           + (fiveo2z)*(I2[434] - (lpoz)*I3[434])
           + (sixo2zn)*I4[338];
*(vp++) = U00*I0[435] + U40*I1[435]
           + (fiveo2z)*(I2[435] - (lpoz)*I3[435])
           + (fiveo2zn)*I4[339];
*(vp++) = U00*I0[436] + U40*I1[436]
           + (fiveo2z)*(I2[436] - (lpoz)*I3[436])
           + (fiveo2zn)*I4[340];
*(vp++) = U00*I0[437] + U40*I1[437]
           + (fiveo2z)*(I2[437] - (lpoz)*I3[437])
           + (fiveo2zn)*I4[341];
*(vp++) = U00*I0[438] + U40*I1[438]
           + (fiveo2z)*(I2[438] - (lpoz)*I3[438])
           + (fouro2zn)*I4[342];
*(vp++) = U00*I0[439] + U40*I1[439]
           + (fiveo2z)*(I2[439] - (lpoz)*I3[439])
           + (fouro2zn)*I4[343];
*(vp++) = U00*I0[440] + U40*I1[440]
           + (fiveo2z)*(I2[440] - (lpoz)*I3[440])
           + (fouro2zn)*I4[344];
*(vp++) = U00*I0[441] + U40*I1[441]
           + (fiveo2z)*(I2[441] - (lpoz)*I3[441])
           + (fouro2zn)*I4[345];
*(vp++) = U00*I0[442] + U40*I1[442]
           + (fiveo2z)*(I2[442] - (lpoz)*I3[442])
           + (threeo2zn)*I4[346];
*(vp++) = U00*I0[443] + U40*I1[443]
           + (fiveo2z)*(I2[443] - (lpoz)*I3[443])
           + (threeo2zn)*I4[347];
*(vp++) = U00*I0[444] + U40*I1[444]
           + (fiveo2z)*(I2[444] - (lpoz)*I3[444])
           + (threeo2zn)*I4[348];
*(vp++) = U00*I0[445] + U40*I1[445]
           + (fiveo2z)*(I2[445] - (lpoz)*I3[445])
           + (threeo2zn)*I4[349];
*(vp++) = U00*I0[446] + U40*I1[446]
           + (fiveo2z)*(I2[446] - (lpoz)*I3[446])
           + (threeo2zn)*I4[350];
*(vp++) = U00*I0[447] + U40*I1[447]
           + (fiveo2z)*(I2[447] - (lpoz)*I3[447])
           + (twoo2zn)*I4[351];
*(vp++) = U00*I0[448] + U40*I1[448]
           + (fiveo2z)*(I2[448] - (lpoz)*I3[448])
           + (twoo2zn)*I4[352];
*(vp++) = U00*I0[449] + U40*I1[449]
           + (fiveo2z)*(I2[449] - (lpoz)*I3[449])
           + (twoo2zn)*I4[353];
*(vp++) = U00*I0[450] + U40*I1[450]
           + (fiveo2z)*(I2[450] - (lpoz)*I3[450])
           + (twoo2zn)*I4[354];
*(vp++) = U00*I0[451] + U40*I1[451]
           + (fiveo2z)*(I2[451] - (lpoz)*I3[451])
           + (twoo2zn)*I4[355];
*(vp++) = U00*I0[452] + U40*I1[452]
           + (fiveo2z)*(I2[452] - (lpoz)*I3[452])
           + (twoo2zn)*I4[356];
*(vp++) = U00*I0[453] + U40*I1[453]
           + (fiveo2z)*(I2[453] - (lpoz)*I3[453])
           + (oneo2zn)*I4[357];
*(vp++) = U00*I0[454] + U40*I1[454]
           + (fiveo2z)*(I2[454] - (lpoz)*I3[454])
           + (oneo2zn)*I4[358];
*(vp++) = U00*I0[455] + U40*I1[455]
           + (fiveo2z)*(I2[455] - (lpoz)*I3[455])
           + (oneo2zn)*I4[359];
*(vp++) = U00*I0[456] + U40*I1[456]
           + (fiveo2z)*(I2[456] - (lpoz)*I3[456])
           + (oneo2zn)*I4[360];
*(vp++) = U00*I0[457] + U40*I1[457]
           + (fiveo2z)*(I2[457] - (lpoz)*I3[457])
           + (oneo2zn)*I4[361];
*(vp++) = U00*I0[458] + U40*I1[458]
           + (fiveo2z)*(I2[458] - (lpoz)*I3[458])
           + (oneo2zn)*I4[362];
*(vp++) = U00*I0[459] + U40*I1[459]
           + (fiveo2z)*(I2[459] - (lpoz)*I3[459])
           + (oneo2zn)*I4[363];
*(vp++) = U00*I0[460] + U40*I1[460]
           + (fiveo2z)*(I2[460] - (lpoz)*I3[460]);
*(vp++) = U00*I0[461] + U40*I1[461]
           + (fiveo2z)*(I2[461] - (lpoz)*I3[461]);
*(vp++) = U00*I0[462] + U40*I1[462]
           + (fiveo2z)*(I2[462] - (lpoz)*I3[462]);
*(vp++) = U00*I0[463] + U40*I1[463]
           + (fiveo2z)*(I2[463] - (lpoz)*I3[463]);
*(vp++) = U00*I0[464] + U40*I1[464]
           + (fiveo2z)*(I2[464] - (lpoz)*I3[464]);
*(vp++) = U00*I0[465] + U40*I1[465]
           + (fiveo2z)*(I2[465] - (lpoz)*I3[465]);
*(vp++) = U00*I0[466] + U40*I1[466]
           + (fiveo2z)*(I2[466] - (lpoz)*I3[466]);
*(vp++) = U00*I0[467] + U40*I1[467]
           + (fiveo2z)*(I2[467] - (lpoz)*I3[467]);
*(vp++) = U00*I0[468] + U40*I1[468]
           + (fiveo2z)*(I2[468] - (lpoz)*I3[468])
           + (seveno2zn)*I4[364];
*(vp++) = U00*I0[469] + U40*I1[469]
           + (fiveo2z)*(I2[469] - (lpoz)*I3[469])
           + (sixo2zn)*I4[365];
*(vp++) = U00*I0[470] + U40*I1[470]
           + (fiveo2z)*(I2[470] - (lpoz)*I3[470])
           + (sixo2zn)*I4[366];
*(vp++) = U00*I0[471] + U40*I1[471]
           + (fiveo2z)*(I2[471] - (lpoz)*I3[471])
           + (fiveo2zn)*I4[367];
*(vp++) = U00*I0[472] + U40*I1[472]
           + (fiveo2z)*(I2[472] - (lpoz)*I3[472])
           + (fiveo2zn)*I4[368];
*(vp++) = U00*I0[473] + U40*I1[473]
           + (fiveo2z)*(I2[473] - (lpoz)*I3[473])
           + (fiveo2zn)*I4[369];
*(vp++) = U00*I0[474] + U40*I1[474]
           + (fiveo2z)*(I2[474] - (lpoz)*I3[474])
           + (fouro2zn)*I4[370];
*(vp++) = U00*I0[475] + U40*I1[475]
           + (fiveo2z)*(I2[475] - (lpoz)*I3[475])
           + (fouro2zn)*I4[371];
*(vp++) = U00*I0[476] + U40*I1[476]
           + (fiveo2z)*(I2[476] - (lpoz)*I3[476])
           + (fouro2zn)*I4[372];
*(vp++) = U00*I0[477] + U40*I1[477]
           + (fiveo2z)*(I2[477] - (lpoz)*I3[477])
           + (fouro2zn)*I4[373];
*(vp++) = U00*I0[478] + U40*I1[478]
           + (fiveo2z)*(I2[478] - (lpoz)*I3[478])
           + (threeo2zn)*I4[374];
*(vp++) = U00*I0[479] + U40*I1[479]
           + (fiveo2z)*(I2[479] - (lpoz)*I3[479])
           + (threeo2zn)*I4[375];
*(vp++) = U00*I0[480] + U40*I1[480]
           + (fiveo2z)*(I2[480] - (lpoz)*I3[480])
           + (threeo2zn)*I4[376];
*(vp++) = U00*I0[481] + U40*I1[481]
           + (fiveo2z)*(I2[481] - (lpoz)*I3[481])
           + (threeo2zn)*I4[377];
*(vp++) = U00*I0[482] + U40*I1[482]
           + (fiveo2z)*(I2[482] - (lpoz)*I3[482])
           + (threeo2zn)*I4[378];
*(vp++) = U00*I0[483] + U40*I1[483]
           + (fiveo2z)*(I2[483] - (lpoz)*I3[483])
           + (twoo2zn)*I4[379];
*(vp++) = U00*I0[484] + U40*I1[484]
           + (fiveo2z)*(I2[484] - (lpoz)*I3[484])
           + (twoo2zn)*I4[380];
*(vp++) = U00*I0[485] + U40*I1[485]
           + (fiveo2z)*(I2[485] - (lpoz)*I3[485])
           + (twoo2zn)*I4[381];
*(vp++) = U00*I0[486] + U40*I1[486]
           + (fiveo2z)*(I2[486] - (lpoz)*I3[486])
           + (twoo2zn)*I4[382];
*(vp++) = U00*I0[487] + U40*I1[487]
           + (fiveo2z)*(I2[487] - (lpoz)*I3[487])
           + (twoo2zn)*I4[383];
*(vp++) = U00*I0[488] + U40*I1[488]
           + (fiveo2z)*(I2[488] - (lpoz)*I3[488])
           + (twoo2zn)*I4[384];
*(vp++) = U00*I0[489] + U40*I1[489]
           + (fiveo2z)*(I2[489] - (lpoz)*I3[489])
           + (oneo2zn)*I4[385];
*(vp++) = U00*I0[490] + U40*I1[490]
           + (fiveo2z)*(I2[490] - (lpoz)*I3[490])
           + (oneo2zn)*I4[386];
*(vp++) = U00*I0[491] + U40*I1[491]
           + (fiveo2z)*(I2[491] - (lpoz)*I3[491])
           + (oneo2zn)*I4[387];
*(vp++) = U00*I0[492] + U40*I1[492]
           + (fiveo2z)*(I2[492] - (lpoz)*I3[492])
           + (oneo2zn)*I4[388];
*(vp++) = U00*I0[493] + U40*I1[493]
           + (fiveo2z)*(I2[493] - (lpoz)*I3[493])
           + (oneo2zn)*I4[389];
*(vp++) = U00*I0[494] + U40*I1[494]
           + (fiveo2z)*(I2[494] - (lpoz)*I3[494])
           + (oneo2zn)*I4[390];
*(vp++) = U00*I0[495] + U40*I1[495]
           + (fiveo2z)*(I2[495] - (lpoz)*I3[495])
           + (oneo2zn)*I4[391];
*(vp++) = U00*I0[496] + U40*I1[496]
           + (fiveo2z)*(I2[496] - (lpoz)*I3[496]);
*(vp++) = U00*I0[497] + U40*I1[497]
           + (fiveo2z)*(I2[497] - (lpoz)*I3[497]);
*(vp++) = U00*I0[498] + U40*I1[498]
           + (fiveo2z)*(I2[498] - (lpoz)*I3[498]);
*(vp++) = U00*I0[499] + U40*I1[499]
           + (fiveo2z)*(I2[499] - (lpoz)*I3[499]);
*(vp++) = U00*I0[500] + U40*I1[500]
           + (fiveo2z)*(I2[500] - (lpoz)*I3[500]);
*(vp++) = U00*I0[501] + U40*I1[501]
           + (fiveo2z)*(I2[501] - (lpoz)*I3[501]);
*(vp++) = U00*I0[502] + U40*I1[502]
           + (fiveo2z)*(I2[502] - (lpoz)*I3[502]);
*(vp++) = U00*I0[503] + U40*I1[503]
           + (fiveo2z)*(I2[503] - (lpoz)*I3[503]);
*(vp++) = U00*I0[504] + U40*I1[504]
           + (fiveo2z)*(I2[504] - (lpoz)*I3[504])
           + (seveno2zn)*I4[392];
*(vp++) = U00*I0[505] + U40*I1[505]
           + (fiveo2z)*(I2[505] - (lpoz)*I3[505])
           + (sixo2zn)*I4[393];
*(vp++) = U00*I0[506] + U40*I1[506]
           + (fiveo2z)*(I2[506] - (lpoz)*I3[506])
           + (sixo2zn)*I4[394];
*(vp++) = U00*I0[507] + U40*I1[507]
           + (fiveo2z)*(I2[507] - (lpoz)*I3[507])
           + (fiveo2zn)*I4[395];
*(vp++) = U00*I0[508] + U40*I1[508]
           + (fiveo2z)*(I2[508] - (lpoz)*I3[508])
           + (fiveo2zn)*I4[396];
*(vp++) = U00*I0[509] + U40*I1[509]
           + (fiveo2z)*(I2[509] - (lpoz)*I3[509])
           + (fiveo2zn)*I4[397];
*(vp++) = U00*I0[510] + U40*I1[510]
           + (fiveo2z)*(I2[510] - (lpoz)*I3[510])
           + (fouro2zn)*I4[398];
*(vp++) = U00*I0[511] + U40*I1[511]
           + (fiveo2z)*(I2[511] - (lpoz)*I3[511])
           + (fouro2zn)*I4[399];
*(vp++) = U00*I0[512] + U40*I1[512]
           + (fiveo2z)*(I2[512] - (lpoz)*I3[512])
           + (fouro2zn)*I4[400];
*(vp++) = U00*I0[513] + U40*I1[513]
           + (fiveo2z)*(I2[513] - (lpoz)*I3[513])
           + (fouro2zn)*I4[401];
*(vp++) = U00*I0[514] + U40*I1[514]
           + (fiveo2z)*(I2[514] - (lpoz)*I3[514])
           + (threeo2zn)*I4[402];
*(vp++) = U00*I0[515] + U40*I1[515]
           + (fiveo2z)*(I2[515] - (lpoz)*I3[515])
           + (threeo2zn)*I4[403];
*(vp++) = U00*I0[516] + U40*I1[516]
           + (fiveo2z)*(I2[516] - (lpoz)*I3[516])
           + (threeo2zn)*I4[404];
*(vp++) = U00*I0[517] + U40*I1[517]
           + (fiveo2z)*(I2[517] - (lpoz)*I3[517])
           + (threeo2zn)*I4[405];
*(vp++) = U00*I0[518] + U40*I1[518]
           + (fiveo2z)*(I2[518] - (lpoz)*I3[518])
           + (threeo2zn)*I4[406];
*(vp++) = U00*I0[519] + U40*I1[519]
           + (fiveo2z)*(I2[519] - (lpoz)*I3[519])
           + (twoo2zn)*I4[407];
*(vp++) = U00*I0[520] + U40*I1[520]
           + (fiveo2z)*(I2[520] - (lpoz)*I3[520])
           + (twoo2zn)*I4[408];
*(vp++) = U00*I0[521] + U40*I1[521]
           + (fiveo2z)*(I2[521] - (lpoz)*I3[521])
           + (twoo2zn)*I4[409];
*(vp++) = U00*I0[522] + U40*I1[522]
           + (fiveo2z)*(I2[522] - (lpoz)*I3[522])
           + (twoo2zn)*I4[410];
*(vp++) = U00*I0[523] + U40*I1[523]
           + (fiveo2z)*(I2[523] - (lpoz)*I3[523])
           + (twoo2zn)*I4[411];
*(vp++) = U00*I0[524] + U40*I1[524]
           + (fiveo2z)*(I2[524] - (lpoz)*I3[524])
           + (twoo2zn)*I4[412];
*(vp++) = U00*I0[525] + U40*I1[525]
           + (fiveo2z)*(I2[525] - (lpoz)*I3[525])
           + (oneo2zn)*I4[413];
*(vp++) = U00*I0[526] + U40*I1[526]
           + (fiveo2z)*(I2[526] - (lpoz)*I3[526])
           + (oneo2zn)*I4[414];
*(vp++) = U00*I0[527] + U40*I1[527]
           + (fiveo2z)*(I2[527] - (lpoz)*I3[527])
           + (oneo2zn)*I4[415];
*(vp++) = U00*I0[528] + U40*I1[528]
           + (fiveo2z)*(I2[528] - (lpoz)*I3[528])
           + (oneo2zn)*I4[416];
*(vp++) = U00*I0[529] + U40*I1[529]
           + (fiveo2z)*(I2[529] - (lpoz)*I3[529])
           + (oneo2zn)*I4[417];
*(vp++) = U00*I0[530] + U40*I1[530]
           + (fiveo2z)*(I2[530] - (lpoz)*I3[530])
           + (oneo2zn)*I4[418];
*(vp++) = U00*I0[531] + U40*I1[531]
           + (fiveo2z)*(I2[531] - (lpoz)*I3[531])
           + (oneo2zn)*I4[419];
*(vp++) = U00*I0[532] + U40*I1[532]
           + (fiveo2z)*(I2[532] - (lpoz)*I3[532]);
*(vp++) = U00*I0[533] + U40*I1[533]
           + (fiveo2z)*(I2[533] - (lpoz)*I3[533]);
*(vp++) = U00*I0[534] + U40*I1[534]
           + (fiveo2z)*(I2[534] - (lpoz)*I3[534]);
*(vp++) = U00*I0[535] + U40*I1[535]
           + (fiveo2z)*(I2[535] - (lpoz)*I3[535]);
*(vp++) = U00*I0[536] + U40*I1[536]
           + (fiveo2z)*(I2[536] - (lpoz)*I3[536]);
*(vp++) = U00*I0[537] + U40*I1[537]
           + (fiveo2z)*(I2[537] - (lpoz)*I3[537]);
*(vp++) = U00*I0[538] + U40*I1[538]
           + (fiveo2z)*(I2[538] - (lpoz)*I3[538]);
*(vp++) = U00*I0[539] + U40*I1[539]
           + (fiveo2z)*(I2[539] - (lpoz)*I3[539]);
*(vp++) = U00*I0[540] + U40*I1[540]
           + (fouro2z)*(I2[540] - (lpoz)*I3[540])
           + (seveno2zn)*I4[420];
*(vp++) = U00*I0[541] + U40*I1[541]
           + (fouro2z)*(I2[541] - (lpoz)*I3[541])
           + (sixo2zn)*I4[421];
*(vp++) = U00*I0[542] + U40*I1[542]
           + (fouro2z)*(I2[542] - (lpoz)*I3[542])
           + (sixo2zn)*I4[422];
*(vp++) = U00*I0[543] + U40*I1[543]
           + (fouro2z)*(I2[543] - (lpoz)*I3[543])
           + (fiveo2zn)*I4[423];
*(vp++) = U00*I0[544] + U40*I1[544]
           + (fouro2z)*(I2[544] - (lpoz)*I3[544])
           + (fiveo2zn)*I4[424];
*(vp++) = U00*I0[545] + U40*I1[545]
           + (fouro2z)*(I2[545] - (lpoz)*I3[545])
           + (fiveo2zn)*I4[425];
*(vp++) = U00*I0[546] + U40*I1[546]
           + (fouro2z)*(I2[546] - (lpoz)*I3[546])
           + (fouro2zn)*I4[426];
*(vp++) = U00*I0[547] + U40*I1[547]
           + (fouro2z)*(I2[547] - (lpoz)*I3[547])
           + (fouro2zn)*I4[427];
*(vp++) = U00*I0[548] + U40*I1[548]
           + (fouro2z)*(I2[548] - (lpoz)*I3[548])
           + (fouro2zn)*I4[428];
*(vp++) = U00*I0[549] + U40*I1[549]
           + (fouro2z)*(I2[549] - (lpoz)*I3[549])
           + (fouro2zn)*I4[429];
*(vp++) = U00*I0[550] + U40*I1[550]
           + (fouro2z)*(I2[550] - (lpoz)*I3[550])
           + (threeo2zn)*I4[430];
*(vp++) = U00*I0[551] + U40*I1[551]
           + (fouro2z)*(I2[551] - (lpoz)*I3[551])
           + (threeo2zn)*I4[431];
*(vp++) = U00*I0[552] + U40*I1[552]
           + (fouro2z)*(I2[552] - (lpoz)*I3[552])
           + (threeo2zn)*I4[432];
*(vp++) = U00*I0[553] + U40*I1[553]
           + (fouro2z)*(I2[553] - (lpoz)*I3[553])
           + (threeo2zn)*I4[433];
*(vp++) = U00*I0[554] + U40*I1[554]
           + (fouro2z)*(I2[554] - (lpoz)*I3[554])
           + (threeo2zn)*I4[434];
*(vp++) = U00*I0[555] + U40*I1[555]
           + (fouro2z)*(I2[555] - (lpoz)*I3[555])
           + (twoo2zn)*I4[435];
*(vp++) = U00*I0[556] + U40*I1[556]
           + (fouro2z)*(I2[556] - (lpoz)*I3[556])
           + (twoo2zn)*I4[436];
*(vp++) = U00*I0[557] + U40*I1[557]
           + (fouro2z)*(I2[557] - (lpoz)*I3[557])
           + (twoo2zn)*I4[437];
*(vp++) = U00*I0[558] + U40*I1[558]
           + (fouro2z)*(I2[558] - (lpoz)*I3[558])
           + (twoo2zn)*I4[438];
*(vp++) = U00*I0[559] + U40*I1[559]
           + (fouro2z)*(I2[559] - (lpoz)*I3[559])
           + (twoo2zn)*I4[439];
*(vp++) = U00*I0[560] + U40*I1[560]
           + (fouro2z)*(I2[560] - (lpoz)*I3[560])
           + (twoo2zn)*I4[440];
*(vp++) = U00*I0[561] + U40*I1[561]
           + (fouro2z)*(I2[561] - (lpoz)*I3[561])
           + (oneo2zn)*I4[441];
*(vp++) = U00*I0[562] + U40*I1[562]
           + (fouro2z)*(I2[562] - (lpoz)*I3[562])
           + (oneo2zn)*I4[442];
*(vp++) = U00*I0[563] + U40*I1[563]
           + (fouro2z)*(I2[563] - (lpoz)*I3[563])
           + (oneo2zn)*I4[443];
*(vp++) = U00*I0[564] + U40*I1[564]
           + (fouro2z)*(I2[564] - (lpoz)*I3[564])
           + (oneo2zn)*I4[444];
*(vp++) = U00*I0[565] + U40*I1[565]
           + (fouro2z)*(I2[565] - (lpoz)*I3[565])
           + (oneo2zn)*I4[445];
*(vp++) = U00*I0[566] + U40*I1[566]
           + (fouro2z)*(I2[566] - (lpoz)*I3[566])
           + (oneo2zn)*I4[446];
*(vp++) = U00*I0[567] + U40*I1[567]
           + (fouro2z)*(I2[567] - (lpoz)*I3[567])
           + (oneo2zn)*I4[447];
*(vp++) = U00*I0[568] + U40*I1[568]
           + (fouro2z)*(I2[568] - (lpoz)*I3[568]);
*(vp++) = U00*I0[569] + U40*I1[569]
           + (fouro2z)*(I2[569] - (lpoz)*I3[569]);
*(vp++) = U00*I0[570] + U40*I1[570]
           + (fouro2z)*(I2[570] - (lpoz)*I3[570]);
*(vp++) = U00*I0[571] + U40*I1[571]
           + (fouro2z)*(I2[571] - (lpoz)*I3[571]);
*(vp++) = U00*I0[572] + U40*I1[572]
           + (fouro2z)*(I2[572] - (lpoz)*I3[572]);
*(vp++) = U00*I0[573] + U40*I1[573]
           + (fouro2z)*(I2[573] - (lpoz)*I3[573]);
*(vp++) = U00*I0[574] + U40*I1[574]
           + (fouro2z)*(I2[574] - (lpoz)*I3[574]);
*(vp++) = U00*I0[575] + U40*I1[575]
           + (fouro2z)*(I2[575] - (lpoz)*I3[575]);
*(vp++) = U00*I0[576] + U40*I1[576]
           + (fouro2z)*(I2[576] - (lpoz)*I3[576])
           + (seveno2zn)*I4[448];
*(vp++) = U00*I0[577] + U40*I1[577]
           + (fouro2z)*(I2[577] - (lpoz)*I3[577])
           + (sixo2zn)*I4[449];
*(vp++) = U00*I0[578] + U40*I1[578]
           + (fouro2z)*(I2[578] - (lpoz)*I3[578])
           + (sixo2zn)*I4[450];
*(vp++) = U00*I0[579] + U40*I1[579]
           + (fouro2z)*(I2[579] - (lpoz)*I3[579])
           + (fiveo2zn)*I4[451];
*(vp++) = U00*I0[580] + U40*I1[580]
           + (fouro2z)*(I2[580] - (lpoz)*I3[580])
           + (fiveo2zn)*I4[452];
*(vp++) = U00*I0[581] + U40*I1[581]
           + (fouro2z)*(I2[581] - (lpoz)*I3[581])
           + (fiveo2zn)*I4[453];
*(vp++) = U00*I0[582] + U40*I1[582]
           + (fouro2z)*(I2[582] - (lpoz)*I3[582])
           + (fouro2zn)*I4[454];
*(vp++) = U00*I0[583] + U40*I1[583]
           + (fouro2z)*(I2[583] - (lpoz)*I3[583])
           + (fouro2zn)*I4[455];
*(vp++) = U00*I0[584] + U40*I1[584]
           + (fouro2z)*(I2[584] - (lpoz)*I3[584])
           + (fouro2zn)*I4[456];
*(vp++) = U00*I0[585] + U40*I1[585]
           + (fouro2z)*(I2[585] - (lpoz)*I3[585])
           + (fouro2zn)*I4[457];
*(vp++) = U00*I0[586] + U40*I1[586]
           + (fouro2z)*(I2[586] - (lpoz)*I3[586])
           + (threeo2zn)*I4[458];
*(vp++) = U00*I0[587] + U40*I1[587]
           + (fouro2z)*(I2[587] - (lpoz)*I3[587])
           + (threeo2zn)*I4[459];
*(vp++) = U00*I0[588] + U40*I1[588]
           + (fouro2z)*(I2[588] - (lpoz)*I3[588])
           + (threeo2zn)*I4[460];
*(vp++) = U00*I0[589] + U40*I1[589]
           + (fouro2z)*(I2[589] - (lpoz)*I3[589])
           + (threeo2zn)*I4[461];
*(vp++) = U00*I0[590] + U40*I1[590]
           + (fouro2z)*(I2[590] - (lpoz)*I3[590])
           + (threeo2zn)*I4[462];
*(vp++) = U00*I0[591] + U40*I1[591]
           + (fouro2z)*(I2[591] - (lpoz)*I3[591])
           + (twoo2zn)*I4[463];
*(vp++) = U00*I0[592] + U40*I1[592]
           + (fouro2z)*(I2[592] - (lpoz)*I3[592])
           + (twoo2zn)*I4[464];
*(vp++) = U00*I0[593] + U40*I1[593]
           + (fouro2z)*(I2[593] - (lpoz)*I3[593])
           + (twoo2zn)*I4[465];
*(vp++) = U00*I0[594] + U40*I1[594]
           + (fouro2z)*(I2[594] - (lpoz)*I3[594])
           + (twoo2zn)*I4[466];
*(vp++) = U00*I0[595] + U40*I1[595]
           + (fouro2z)*(I2[595] - (lpoz)*I3[595])
           + (twoo2zn)*I4[467];
return vp;
}

REALTYPE *_build_n0k0_2(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[596] + U40*I1[596]
           + (fouro2z)*(I2[596] - (lpoz)*I3[596])
           + (twoo2zn)*I4[468];
*(vp++) = U00*I0[597] + U40*I1[597]
           + (fouro2z)*(I2[597] - (lpoz)*I3[597])
           + (oneo2zn)*I4[469];
*(vp++) = U00*I0[598] + U40*I1[598]
           + (fouro2z)*(I2[598] - (lpoz)*I3[598])
           + (oneo2zn)*I4[470];
*(vp++) = U00*I0[599] + U40*I1[599]
           + (fouro2z)*(I2[599] - (lpoz)*I3[599])
           + (oneo2zn)*I4[471];
*(vp++) = U00*I0[600] + U40*I1[600]
           + (fouro2z)*(I2[600] - (lpoz)*I3[600])
           + (oneo2zn)*I4[472];
*(vp++) = U00*I0[601] + U40*I1[601]
           + (fouro2z)*(I2[601] - (lpoz)*I3[601])
           + (oneo2zn)*I4[473];
*(vp++) = U00*I0[602] + U40*I1[602]
           + (fouro2z)*(I2[602] - (lpoz)*I3[602])
           + (oneo2zn)*I4[474];
*(vp++) = U00*I0[603] + U40*I1[603]
           + (fouro2z)*(I2[603] - (lpoz)*I3[603])
           + (oneo2zn)*I4[475];
*(vp++) = U00*I0[604] + U40*I1[604]
           + (fouro2z)*(I2[604] - (lpoz)*I3[604]);
*(vp++) = U00*I0[605] + U40*I1[605]
           + (fouro2z)*(I2[605] - (lpoz)*I3[605]);
*(vp++) = U00*I0[606] + U40*I1[606]
           + (fouro2z)*(I2[606] - (lpoz)*I3[606]);
*(vp++) = U00*I0[607] + U40*I1[607]
           + (fouro2z)*(I2[607] - (lpoz)*I3[607]);
*(vp++) = U00*I0[608] + U40*I1[608]
           + (fouro2z)*(I2[608] - (lpoz)*I3[608]);
*(vp++) = U00*I0[609] + U40*I1[609]
           + (fouro2z)*(I2[609] - (lpoz)*I3[609]);
*(vp++) = U00*I0[610] + U40*I1[610]
           + (fouro2z)*(I2[610] - (lpoz)*I3[610]);
*(vp++) = U00*I0[611] + U40*I1[611]
           + (fouro2z)*(I2[611] - (lpoz)*I3[611]);
*(vp++) = U00*I0[612] + U40*I1[612]
           + (fouro2z)*(I2[612] - (lpoz)*I3[612])
           + (seveno2zn)*I4[476];
*(vp++) = U00*I0[613] + U40*I1[613]
           + (fouro2z)*(I2[613] - (lpoz)*I3[613])
           + (sixo2zn)*I4[477];
*(vp++) = U00*I0[614] + U40*I1[614]
           + (fouro2z)*(I2[614] - (lpoz)*I3[614])
           + (sixo2zn)*I4[478];
*(vp++) = U00*I0[615] + U40*I1[615]
           + (fouro2z)*(I2[615] - (lpoz)*I3[615])
           + (fiveo2zn)*I4[479];
*(vp++) = U00*I0[616] + U40*I1[616]
           + (fouro2z)*(I2[616] - (lpoz)*I3[616])
           + (fiveo2zn)*I4[480];
*(vp++) = U00*I0[617] + U40*I1[617]
           + (fouro2z)*(I2[617] - (lpoz)*I3[617])
           + (fiveo2zn)*I4[481];
*(vp++) = U00*I0[618] + U40*I1[618]
           + (fouro2z)*(I2[618] - (lpoz)*I3[618])
           + (fouro2zn)*I4[482];
*(vp++) = U00*I0[619] + U40*I1[619]
           + (fouro2z)*(I2[619] - (lpoz)*I3[619])
           + (fouro2zn)*I4[483];
*(vp++) = U00*I0[620] + U40*I1[620]
           + (fouro2z)*(I2[620] - (lpoz)*I3[620])
           + (fouro2zn)*I4[484];
*(vp++) = U00*I0[621] + U40*I1[621]
           + (fouro2z)*(I2[621] - (lpoz)*I3[621])
           + (fouro2zn)*I4[485];
*(vp++) = U00*I0[622] + U40*I1[622]
           + (fouro2z)*(I2[622] - (lpoz)*I3[622])
           + (threeo2zn)*I4[486];
*(vp++) = U00*I0[623] + U40*I1[623]
           + (fouro2z)*(I2[623] - (lpoz)*I3[623])
           + (threeo2zn)*I4[487];
*(vp++) = U00*I0[624] + U40*I1[624]
           + (fouro2z)*(I2[624] - (lpoz)*I3[624])
           + (threeo2zn)*I4[488];
*(vp++) = U00*I0[625] + U40*I1[625]
           + (fouro2z)*(I2[625] - (lpoz)*I3[625])
           + (threeo2zn)*I4[489];
*(vp++) = U00*I0[626] + U40*I1[626]
           + (fouro2z)*(I2[626] - (lpoz)*I3[626])
           + (threeo2zn)*I4[490];
*(vp++) = U00*I0[627] + U40*I1[627]
           + (fouro2z)*(I2[627] - (lpoz)*I3[627])
           + (twoo2zn)*I4[491];
*(vp++) = U00*I0[628] + U40*I1[628]
           + (fouro2z)*(I2[628] - (lpoz)*I3[628])
           + (twoo2zn)*I4[492];
*(vp++) = U00*I0[629] + U40*I1[629]
           + (fouro2z)*(I2[629] - (lpoz)*I3[629])
           + (twoo2zn)*I4[493];
*(vp++) = U00*I0[630] + U40*I1[630]
           + (fouro2z)*(I2[630] - (lpoz)*I3[630])
           + (twoo2zn)*I4[494];
*(vp++) = U00*I0[631] + U40*I1[631]
           + (fouro2z)*(I2[631] - (lpoz)*I3[631])
           + (twoo2zn)*I4[495];
*(vp++) = U00*I0[632] + U40*I1[632]
           + (fouro2z)*(I2[632] - (lpoz)*I3[632])
           + (twoo2zn)*I4[496];
*(vp++) = U00*I0[633] + U40*I1[633]
           + (fouro2z)*(I2[633] - (lpoz)*I3[633])
           + (oneo2zn)*I4[497];
*(vp++) = U00*I0[634] + U40*I1[634]
           + (fouro2z)*(I2[634] - (lpoz)*I3[634])
           + (oneo2zn)*I4[498];
*(vp++) = U00*I0[635] + U40*I1[635]
           + (fouro2z)*(I2[635] - (lpoz)*I3[635])
           + (oneo2zn)*I4[499];
*(vp++) = U00*I0[636] + U40*I1[636]
           + (fouro2z)*(I2[636] - (lpoz)*I3[636])
           + (oneo2zn)*I4[500];
*(vp++) = U00*I0[637] + U40*I1[637]
           + (fouro2z)*(I2[637] - (lpoz)*I3[637])
           + (oneo2zn)*I4[501];
*(vp++) = U00*I0[638] + U40*I1[638]
           + (fouro2z)*(I2[638] - (lpoz)*I3[638])
           + (oneo2zn)*I4[502];
*(vp++) = U00*I0[639] + U40*I1[639]
           + (fouro2z)*(I2[639] - (lpoz)*I3[639])
           + (oneo2zn)*I4[503];
*(vp++) = U00*I0[640] + U40*I1[640]
           + (fouro2z)*(I2[640] - (lpoz)*I3[640]);
*(vp++) = U00*I0[641] + U40*I1[641]
           + (fouro2z)*(I2[641] - (lpoz)*I3[641]);
*(vp++) = U00*I0[642] + U40*I1[642]
           + (fouro2z)*(I2[642] - (lpoz)*I3[642]);
*(vp++) = U00*I0[643] + U40*I1[643]
           + (fouro2z)*(I2[643] - (lpoz)*I3[643]);
*(vp++) = U00*I0[644] + U40*I1[644]
           + (fouro2z)*(I2[644] - (lpoz)*I3[644]);
*(vp++) = U00*I0[645] + U40*I1[645]
           + (fouro2z)*(I2[645] - (lpoz)*I3[645]);
*(vp++) = U00*I0[646] + U40*I1[646]
           + (fouro2z)*(I2[646] - (lpoz)*I3[646]);
*(vp++) = U00*I0[647] + U40*I1[647]
           + (fouro2z)*(I2[647] - (lpoz)*I3[647]);
*(vp++) = U00*I0[648] + U40*I1[648]
           + (fouro2z)*(I2[648] - (lpoz)*I3[648])
           + (seveno2zn)*I4[504];
*(vp++) = U00*I0[649] + U40*I1[649]
           + (fouro2z)*(I2[649] - (lpoz)*I3[649])
           + (sixo2zn)*I4[505];
*(vp++) = U00*I0[650] + U40*I1[650]
           + (fouro2z)*(I2[650] - (lpoz)*I3[650])
           + (sixo2zn)*I4[506];
*(vp++) = U00*I0[651] + U40*I1[651]
           + (fouro2z)*(I2[651] - (lpoz)*I3[651])
           + (fiveo2zn)*I4[507];
*(vp++) = U00*I0[652] + U40*I1[652]
           + (fouro2z)*(I2[652] - (lpoz)*I3[652])
           + (fiveo2zn)*I4[508];
*(vp++) = U00*I0[653] + U40*I1[653]
           + (fouro2z)*(I2[653] - (lpoz)*I3[653])
           + (fiveo2zn)*I4[509];
*(vp++) = U00*I0[654] + U40*I1[654]
           + (fouro2z)*(I2[654] - (lpoz)*I3[654])
           + (fouro2zn)*I4[510];
*(vp++) = U00*I0[655] + U40*I1[655]
           + (fouro2z)*(I2[655] - (lpoz)*I3[655])
           + (fouro2zn)*I4[511];
*(vp++) = U00*I0[656] + U40*I1[656]
           + (fouro2z)*(I2[656] - (lpoz)*I3[656])
           + (fouro2zn)*I4[512];
*(vp++) = U00*I0[657] + U40*I1[657]
           + (fouro2z)*(I2[657] - (lpoz)*I3[657])
           + (fouro2zn)*I4[513];
*(vp++) = U00*I0[658] + U40*I1[658]
           + (fouro2z)*(I2[658] - (lpoz)*I3[658])
           + (threeo2zn)*I4[514];
*(vp++) = U00*I0[659] + U40*I1[659]
           + (fouro2z)*(I2[659] - (lpoz)*I3[659])
           + (threeo2zn)*I4[515];
*(vp++) = U00*I0[660] + U40*I1[660]
           + (fouro2z)*(I2[660] - (lpoz)*I3[660])
           + (threeo2zn)*I4[516];
*(vp++) = U00*I0[661] + U40*I1[661]
           + (fouro2z)*(I2[661] - (lpoz)*I3[661])
           + (threeo2zn)*I4[517];
*(vp++) = U00*I0[662] + U40*I1[662]
           + (fouro2z)*(I2[662] - (lpoz)*I3[662])
           + (threeo2zn)*I4[518];
*(vp++) = U00*I0[663] + U40*I1[663]
           + (fouro2z)*(I2[663] - (lpoz)*I3[663])
           + (twoo2zn)*I4[519];
*(vp++) = U00*I0[664] + U40*I1[664]
           + (fouro2z)*(I2[664] - (lpoz)*I3[664])
           + (twoo2zn)*I4[520];
*(vp++) = U00*I0[665] + U40*I1[665]
           + (fouro2z)*(I2[665] - (lpoz)*I3[665])
           + (twoo2zn)*I4[521];
*(vp++) = U00*I0[666] + U40*I1[666]
           + (fouro2z)*(I2[666] - (lpoz)*I3[666])
           + (twoo2zn)*I4[522];
*(vp++) = U00*I0[667] + U40*I1[667]
           + (fouro2z)*(I2[667] - (lpoz)*I3[667])
           + (twoo2zn)*I4[523];
*(vp++) = U00*I0[668] + U40*I1[668]
           + (fouro2z)*(I2[668] - (lpoz)*I3[668])
           + (twoo2zn)*I4[524];
*(vp++) = U00*I0[669] + U40*I1[669]
           + (fouro2z)*(I2[669] - (lpoz)*I3[669])
           + (oneo2zn)*I4[525];
*(vp++) = U00*I0[670] + U40*I1[670]
           + (fouro2z)*(I2[670] - (lpoz)*I3[670])
           + (oneo2zn)*I4[526];
*(vp++) = U00*I0[671] + U40*I1[671]
           + (fouro2z)*(I2[671] - (lpoz)*I3[671])
           + (oneo2zn)*I4[527];
*(vp++) = U00*I0[672] + U40*I1[672]
           + (fouro2z)*(I2[672] - (lpoz)*I3[672])
           + (oneo2zn)*I4[528];
*(vp++) = U00*I0[673] + U40*I1[673]
           + (fouro2z)*(I2[673] - (lpoz)*I3[673])
           + (oneo2zn)*I4[529];
*(vp++) = U00*I0[674] + U40*I1[674]
           + (fouro2z)*(I2[674] - (lpoz)*I3[674])
           + (oneo2zn)*I4[530];
*(vp++) = U00*I0[675] + U40*I1[675]
           + (fouro2z)*(I2[675] - (lpoz)*I3[675])
           + (oneo2zn)*I4[531];
*(vp++) = U00*I0[676] + U40*I1[676]
           + (fouro2z)*(I2[676] - (lpoz)*I3[676]);
*(vp++) = U00*I0[677] + U40*I1[677]
           + (fouro2z)*(I2[677] - (lpoz)*I3[677]);
*(vp++) = U00*I0[678] + U40*I1[678]
           + (fouro2z)*(I2[678] - (lpoz)*I3[678]);
*(vp++) = U00*I0[679] + U40*I1[679]
           + (fouro2z)*(I2[679] - (lpoz)*I3[679]);
*(vp++) = U00*I0[680] + U40*I1[680]
           + (fouro2z)*(I2[680] - (lpoz)*I3[680]);
*(vp++) = U00*I0[681] + U40*I1[681]
           + (fouro2z)*(I2[681] - (lpoz)*I3[681]);
*(vp++) = U00*I0[682] + U40*I1[682]
           + (fouro2z)*(I2[682] - (lpoz)*I3[682]);
*(vp++) = U00*I0[683] + U40*I1[683]
           + (fouro2z)*(I2[683] - (lpoz)*I3[683]);
*(vp++) = U00*I0[684] + U40*I1[684]
           + (fouro2z)*(I2[684] - (lpoz)*I3[684])
           + (seveno2zn)*I4[532];
*(vp++) = U00*I0[685] + U40*I1[685]
           + (fouro2z)*(I2[685] - (lpoz)*I3[685])
           + (sixo2zn)*I4[533];
*(vp++) = U00*I0[686] + U40*I1[686]
           + (fouro2z)*(I2[686] - (lpoz)*I3[686])
           + (sixo2zn)*I4[534];
*(vp++) = U00*I0[687] + U40*I1[687]
           + (fouro2z)*(I2[687] - (lpoz)*I3[687])
           + (fiveo2zn)*I4[535];
*(vp++) = U00*I0[688] + U40*I1[688]
           + (fouro2z)*(I2[688] - (lpoz)*I3[688])
           + (fiveo2zn)*I4[536];
*(vp++) = U00*I0[689] + U40*I1[689]
           + (fouro2z)*(I2[689] - (lpoz)*I3[689])
           + (fiveo2zn)*I4[537];
*(vp++) = U00*I0[690] + U40*I1[690]
           + (fouro2z)*(I2[690] - (lpoz)*I3[690])
           + (fouro2zn)*I4[538];
*(vp++) = U00*I0[691] + U40*I1[691]
           + (fouro2z)*(I2[691] - (lpoz)*I3[691])
           + (fouro2zn)*I4[539];
*(vp++) = U00*I0[692] + U40*I1[692]
           + (fouro2z)*(I2[692] - (lpoz)*I3[692])
           + (fouro2zn)*I4[540];
*(vp++) = U00*I0[693] + U40*I1[693]
           + (fouro2z)*(I2[693] - (lpoz)*I3[693])
           + (fouro2zn)*I4[541];
*(vp++) = U00*I0[694] + U40*I1[694]
           + (fouro2z)*(I2[694] - (lpoz)*I3[694])
           + (threeo2zn)*I4[542];
*(vp++) = U00*I0[695] + U40*I1[695]
           + (fouro2z)*(I2[695] - (lpoz)*I3[695])
           + (threeo2zn)*I4[543];
*(vp++) = U00*I0[696] + U40*I1[696]
           + (fouro2z)*(I2[696] - (lpoz)*I3[696])
           + (threeo2zn)*I4[544];
*(vp++) = U00*I0[697] + U40*I1[697]
           + (fouro2z)*(I2[697] - (lpoz)*I3[697])
           + (threeo2zn)*I4[545];
*(vp++) = U00*I0[698] + U40*I1[698]
           + (fouro2z)*(I2[698] - (lpoz)*I3[698])
           + (threeo2zn)*I4[546];
*(vp++) = U00*I0[699] + U40*I1[699]
           + (fouro2z)*(I2[699] - (lpoz)*I3[699])
           + (twoo2zn)*I4[547];
*(vp++) = U00*I0[700] + U40*I1[700]
           + (fouro2z)*(I2[700] - (lpoz)*I3[700])
           + (twoo2zn)*I4[548];
*(vp++) = U00*I0[701] + U40*I1[701]
           + (fouro2z)*(I2[701] - (lpoz)*I3[701])
           + (twoo2zn)*I4[549];
*(vp++) = U00*I0[702] + U40*I1[702]
           + (fouro2z)*(I2[702] - (lpoz)*I3[702])
           + (twoo2zn)*I4[550];
*(vp++) = U00*I0[703] + U40*I1[703]
           + (fouro2z)*(I2[703] - (lpoz)*I3[703])
           + (twoo2zn)*I4[551];
*(vp++) = U00*I0[704] + U40*I1[704]
           + (fouro2z)*(I2[704] - (lpoz)*I3[704])
           + (twoo2zn)*I4[552];
*(vp++) = U00*I0[705] + U40*I1[705]
           + (fouro2z)*(I2[705] - (lpoz)*I3[705])
           + (oneo2zn)*I4[553];
*(vp++) = U00*I0[706] + U40*I1[706]
           + (fouro2z)*(I2[706] - (lpoz)*I3[706])
           + (oneo2zn)*I4[554];
*(vp++) = U00*I0[707] + U40*I1[707]
           + (fouro2z)*(I2[707] - (lpoz)*I3[707])
           + (oneo2zn)*I4[555];
*(vp++) = U00*I0[708] + U40*I1[708]
           + (fouro2z)*(I2[708] - (lpoz)*I3[708])
           + (oneo2zn)*I4[556];
*(vp++) = U00*I0[709] + U40*I1[709]
           + (fouro2z)*(I2[709] - (lpoz)*I3[709])
           + (oneo2zn)*I4[557];
*(vp++) = U00*I0[710] + U40*I1[710]
           + (fouro2z)*(I2[710] - (lpoz)*I3[710])
           + (oneo2zn)*I4[558];
*(vp++) = U00*I0[711] + U40*I1[711]
           + (fouro2z)*(I2[711] - (lpoz)*I3[711])
           + (oneo2zn)*I4[559];
*(vp++) = U00*I0[712] + U40*I1[712]
           + (fouro2z)*(I2[712] - (lpoz)*I3[712]);
*(vp++) = U00*I0[713] + U40*I1[713]
           + (fouro2z)*(I2[713] - (lpoz)*I3[713]);
*(vp++) = U00*I0[714] + U40*I1[714]
           + (fouro2z)*(I2[714] - (lpoz)*I3[714]);
*(vp++) = U00*I0[715] + U40*I1[715]
           + (fouro2z)*(I2[715] - (lpoz)*I3[715]);
*(vp++) = U00*I0[716] + U40*I1[716]
           + (fouro2z)*(I2[716] - (lpoz)*I3[716]);
*(vp++) = U00*I0[717] + U40*I1[717]
           + (fouro2z)*(I2[717] - (lpoz)*I3[717]);
*(vp++) = U00*I0[718] + U40*I1[718]
           + (fouro2z)*(I2[718] - (lpoz)*I3[718]);
*(vp++) = U00*I0[719] + U40*I1[719]
           + (fouro2z)*(I2[719] - (lpoz)*I3[719]);
*(vp++) = U00*I0[720] + U40*I1[720]
           + (fouro2z)*(I2[720] - (lpoz)*I3[720])
           + (seveno2zn)*I4[560];
*(vp++) = U00*I0[721] + U40*I1[721]
           + (fouro2z)*(I2[721] - (lpoz)*I3[721])
           + (sixo2zn)*I4[561];
*(vp++) = U00*I0[722] + U40*I1[722]
           + (fouro2z)*(I2[722] - (lpoz)*I3[722])
           + (sixo2zn)*I4[562];
*(vp++) = U00*I0[723] + U40*I1[723]
           + (fouro2z)*(I2[723] - (lpoz)*I3[723])
           + (fiveo2zn)*I4[563];
*(vp++) = U00*I0[724] + U40*I1[724]
           + (fouro2z)*(I2[724] - (lpoz)*I3[724])
           + (fiveo2zn)*I4[564];
*(vp++) = U00*I0[725] + U40*I1[725]
           + (fouro2z)*(I2[725] - (lpoz)*I3[725])
           + (fiveo2zn)*I4[565];
*(vp++) = U00*I0[726] + U40*I1[726]
           + (fouro2z)*(I2[726] - (lpoz)*I3[726])
           + (fouro2zn)*I4[566];
*(vp++) = U00*I0[727] + U40*I1[727]
           + (fouro2z)*(I2[727] - (lpoz)*I3[727])
           + (fouro2zn)*I4[567];
*(vp++) = U00*I0[728] + U40*I1[728]
           + (fouro2z)*(I2[728] - (lpoz)*I3[728])
           + (fouro2zn)*I4[568];
*(vp++) = U00*I0[729] + U40*I1[729]
           + (fouro2z)*(I2[729] - (lpoz)*I3[729])
           + (fouro2zn)*I4[569];
*(vp++) = U00*I0[730] + U40*I1[730]
           + (fouro2z)*(I2[730] - (lpoz)*I3[730])
           + (threeo2zn)*I4[570];
*(vp++) = U00*I0[731] + U40*I1[731]
           + (fouro2z)*(I2[731] - (lpoz)*I3[731])
           + (threeo2zn)*I4[571];
*(vp++) = U00*I0[732] + U40*I1[732]
           + (fouro2z)*(I2[732] - (lpoz)*I3[732])
           + (threeo2zn)*I4[572];
*(vp++) = U00*I0[733] + U40*I1[733]
           + (fouro2z)*(I2[733] - (lpoz)*I3[733])
           + (threeo2zn)*I4[573];
*(vp++) = U00*I0[734] + U40*I1[734]
           + (fouro2z)*(I2[734] - (lpoz)*I3[734])
           + (threeo2zn)*I4[574];
*(vp++) = U00*I0[735] + U40*I1[735]
           + (fouro2z)*(I2[735] - (lpoz)*I3[735])
           + (twoo2zn)*I4[575];
*(vp++) = U00*I0[736] + U40*I1[736]
           + (fouro2z)*(I2[736] - (lpoz)*I3[736])
           + (twoo2zn)*I4[576];
*(vp++) = U00*I0[737] + U40*I1[737]
           + (fouro2z)*(I2[737] - (lpoz)*I3[737])
           + (twoo2zn)*I4[577];
*(vp++) = U00*I0[738] + U40*I1[738]
           + (fouro2z)*(I2[738] - (lpoz)*I3[738])
           + (twoo2zn)*I4[578];
*(vp++) = U00*I0[739] + U40*I1[739]
           + (fouro2z)*(I2[739] - (lpoz)*I3[739])
           + (twoo2zn)*I4[579];
*(vp++) = U00*I0[740] + U40*I1[740]
           + (fouro2z)*(I2[740] - (lpoz)*I3[740])
           + (twoo2zn)*I4[580];
*(vp++) = U00*I0[741] + U40*I1[741]
           + (fouro2z)*(I2[741] - (lpoz)*I3[741])
           + (oneo2zn)*I4[581];
*(vp++) = U00*I0[742] + U40*I1[742]
           + (fouro2z)*(I2[742] - (lpoz)*I3[742])
           + (oneo2zn)*I4[582];
*(vp++) = U00*I0[743] + U40*I1[743]
           + (fouro2z)*(I2[743] - (lpoz)*I3[743])
           + (oneo2zn)*I4[583];
*(vp++) = U00*I0[744] + U40*I1[744]
           + (fouro2z)*(I2[744] - (lpoz)*I3[744])
           + (oneo2zn)*I4[584];
*(vp++) = U00*I0[745] + U40*I1[745]
           + (fouro2z)*(I2[745] - (lpoz)*I3[745])
           + (oneo2zn)*I4[585];
*(vp++) = U00*I0[746] + U40*I1[746]
           + (fouro2z)*(I2[746] - (lpoz)*I3[746])
           + (oneo2zn)*I4[586];
*(vp++) = U00*I0[747] + U40*I1[747]
           + (fouro2z)*(I2[747] - (lpoz)*I3[747])
           + (oneo2zn)*I4[587];
*(vp++) = U00*I0[748] + U40*I1[748]
           + (fouro2z)*(I2[748] - (lpoz)*I3[748]);
*(vp++) = U00*I0[749] + U40*I1[749]
           + (fouro2z)*(I2[749] - (lpoz)*I3[749]);
*(vp++) = U00*I0[750] + U40*I1[750]
           + (fouro2z)*(I2[750] - (lpoz)*I3[750]);
*(vp++) = U00*I0[751] + U40*I1[751]
           + (fouro2z)*(I2[751] - (lpoz)*I3[751]);
*(vp++) = U00*I0[752] + U40*I1[752]
           + (fouro2z)*(I2[752] - (lpoz)*I3[752]);
*(vp++) = U00*I0[753] + U40*I1[753]
           + (fouro2z)*(I2[753] - (lpoz)*I3[753]);
*(vp++) = U00*I0[754] + U40*I1[754]
           + (fouro2z)*(I2[754] - (lpoz)*I3[754]);
*(vp++) = U00*I0[755] + U40*I1[755]
           + (fouro2z)*(I2[755] - (lpoz)*I3[755]);
*(vp++) = U00*I0[756] + U40*I1[756]
           + (threeo2z)*(I2[756] - (lpoz)*I3[756])
           + (seveno2zn)*I4[588];
*(vp++) = U00*I0[757] + U40*I1[757]
           + (threeo2z)*(I2[757] - (lpoz)*I3[757])
           + (sixo2zn)*I4[589];
*(vp++) = U00*I0[758] + U40*I1[758]
           + (threeo2z)*(I2[758] - (lpoz)*I3[758])
           + (sixo2zn)*I4[590];
*(vp++) = U00*I0[759] + U40*I1[759]
           + (threeo2z)*(I2[759] - (lpoz)*I3[759])
           + (fiveo2zn)*I4[591];
*(vp++) = U00*I0[760] + U40*I1[760]
           + (threeo2z)*(I2[760] - (lpoz)*I3[760])
           + (fiveo2zn)*I4[592];
*(vp++) = U00*I0[761] + U40*I1[761]
           + (threeo2z)*(I2[761] - (lpoz)*I3[761])
           + (fiveo2zn)*I4[593];
*(vp++) = U00*I0[762] + U40*I1[762]
           + (threeo2z)*(I2[762] - (lpoz)*I3[762])
           + (fouro2zn)*I4[594];
*(vp++) = U00*I0[763] + U40*I1[763]
           + (threeo2z)*(I2[763] - (lpoz)*I3[763])
           + (fouro2zn)*I4[595];
*(vp++) = U00*I0[764] + U40*I1[764]
           + (threeo2z)*(I2[764] - (lpoz)*I3[764])
           + (fouro2zn)*I4[596];
*(vp++) = U00*I0[765] + U40*I1[765]
           + (threeo2z)*(I2[765] - (lpoz)*I3[765])
           + (fouro2zn)*I4[597];
*(vp++) = U00*I0[766] + U40*I1[766]
           + (threeo2z)*(I2[766] - (lpoz)*I3[766])
           + (threeo2zn)*I4[598];
*(vp++) = U00*I0[767] + U40*I1[767]
           + (threeo2z)*(I2[767] - (lpoz)*I3[767])
           + (threeo2zn)*I4[599];
*(vp++) = U00*I0[768] + U40*I1[768]
           + (threeo2z)*(I2[768] - (lpoz)*I3[768])
           + (threeo2zn)*I4[600];
*(vp++) = U00*I0[769] + U40*I1[769]
           + (threeo2z)*(I2[769] - (lpoz)*I3[769])
           + (threeo2zn)*I4[601];
*(vp++) = U00*I0[770] + U40*I1[770]
           + (threeo2z)*(I2[770] - (lpoz)*I3[770])
           + (threeo2zn)*I4[602];
*(vp++) = U00*I0[771] + U40*I1[771]
           + (threeo2z)*(I2[771] - (lpoz)*I3[771])
           + (twoo2zn)*I4[603];
*(vp++) = U00*I0[772] + U40*I1[772]
           + (threeo2z)*(I2[772] - (lpoz)*I3[772])
           + (twoo2zn)*I4[604];
*(vp++) = U00*I0[773] + U40*I1[773]
           + (threeo2z)*(I2[773] - (lpoz)*I3[773])
           + (twoo2zn)*I4[605];
*(vp++) = U00*I0[774] + U40*I1[774]
           + (threeo2z)*(I2[774] - (lpoz)*I3[774])
           + (twoo2zn)*I4[606];
*(vp++) = U00*I0[775] + U40*I1[775]
           + (threeo2z)*(I2[775] - (lpoz)*I3[775])
           + (twoo2zn)*I4[607];
*(vp++) = U00*I0[776] + U40*I1[776]
           + (threeo2z)*(I2[776] - (lpoz)*I3[776])
           + (twoo2zn)*I4[608];
*(vp++) = U00*I0[777] + U40*I1[777]
           + (threeo2z)*(I2[777] - (lpoz)*I3[777])
           + (oneo2zn)*I4[609];
*(vp++) = U00*I0[778] + U40*I1[778]
           + (threeo2z)*(I2[778] - (lpoz)*I3[778])
           + (oneo2zn)*I4[610];
*(vp++) = U00*I0[779] + U40*I1[779]
           + (threeo2z)*(I2[779] - (lpoz)*I3[779])
           + (oneo2zn)*I4[611];
*(vp++) = U00*I0[780] + U40*I1[780]
           + (threeo2z)*(I2[780] - (lpoz)*I3[780])
           + (oneo2zn)*I4[612];
*(vp++) = U00*I0[781] + U40*I1[781]
           + (threeo2z)*(I2[781] - (lpoz)*I3[781])
           + (oneo2zn)*I4[613];
*(vp++) = U00*I0[782] + U40*I1[782]
           + (threeo2z)*(I2[782] - (lpoz)*I3[782])
           + (oneo2zn)*I4[614];
*(vp++) = U00*I0[783] + U40*I1[783]
           + (threeo2z)*(I2[783] - (lpoz)*I3[783])
           + (oneo2zn)*I4[615];
*(vp++) = U00*I0[784] + U40*I1[784]
           + (threeo2z)*(I2[784] - (lpoz)*I3[784]);
*(vp++) = U00*I0[785] + U40*I1[785]
           + (threeo2z)*(I2[785] - (lpoz)*I3[785]);
*(vp++) = U00*I0[786] + U40*I1[786]
           + (threeo2z)*(I2[786] - (lpoz)*I3[786]);
*(vp++) = U00*I0[787] + U40*I1[787]
           + (threeo2z)*(I2[787] - (lpoz)*I3[787]);
*(vp++) = U00*I0[788] + U40*I1[788]
           + (threeo2z)*(I2[788] - (lpoz)*I3[788]);
*(vp++) = U00*I0[789] + U40*I1[789]
           + (threeo2z)*(I2[789] - (lpoz)*I3[789]);
*(vp++) = U00*I0[790] + U40*I1[790]
           + (threeo2z)*(I2[790] - (lpoz)*I3[790]);
*(vp++) = U00*I0[791] + U40*I1[791]
           + (threeo2z)*(I2[791] - (lpoz)*I3[791]);
*(vp++) = U00*I0[792] + U40*I1[792]
           + (threeo2z)*(I2[792] - (lpoz)*I3[792])
           + (seveno2zn)*I4[616];
*(vp++) = U00*I0[793] + U40*I1[793]
           + (threeo2z)*(I2[793] - (lpoz)*I3[793])
           + (sixo2zn)*I4[617];
*(vp++) = U00*I0[794] + U40*I1[794]
           + (threeo2z)*(I2[794] - (lpoz)*I3[794])
           + (sixo2zn)*I4[618];
*(vp++) = U00*I0[795] + U40*I1[795]
           + (threeo2z)*(I2[795] - (lpoz)*I3[795])
           + (fiveo2zn)*I4[619];
*(vp++) = U00*I0[796] + U40*I1[796]
           + (threeo2z)*(I2[796] - (lpoz)*I3[796])
           + (fiveo2zn)*I4[620];
*(vp++) = U00*I0[797] + U40*I1[797]
           + (threeo2z)*(I2[797] - (lpoz)*I3[797])
           + (fiveo2zn)*I4[621];
*(vp++) = U00*I0[798] + U40*I1[798]
           + (threeo2z)*(I2[798] - (lpoz)*I3[798])
           + (fouro2zn)*I4[622];
*(vp++) = U00*I0[799] + U40*I1[799]
           + (threeo2z)*(I2[799] - (lpoz)*I3[799])
           + (fouro2zn)*I4[623];
*(vp++) = U00*I0[800] + U40*I1[800]
           + (threeo2z)*(I2[800] - (lpoz)*I3[800])
           + (fouro2zn)*I4[624];
*(vp++) = U00*I0[801] + U40*I1[801]
           + (threeo2z)*(I2[801] - (lpoz)*I3[801])
           + (fouro2zn)*I4[625];
*(vp++) = U00*I0[802] + U40*I1[802]
           + (threeo2z)*(I2[802] - (lpoz)*I3[802])
           + (threeo2zn)*I4[626];
*(vp++) = U00*I0[803] + U40*I1[803]
           + (threeo2z)*(I2[803] - (lpoz)*I3[803])
           + (threeo2zn)*I4[627];
*(vp++) = U00*I0[804] + U40*I1[804]
           + (threeo2z)*(I2[804] - (lpoz)*I3[804])
           + (threeo2zn)*I4[628];
*(vp++) = U00*I0[805] + U40*I1[805]
           + (threeo2z)*(I2[805] - (lpoz)*I3[805])
           + (threeo2zn)*I4[629];
*(vp++) = U00*I0[806] + U40*I1[806]
           + (threeo2z)*(I2[806] - (lpoz)*I3[806])
           + (threeo2zn)*I4[630];
*(vp++) = U00*I0[807] + U40*I1[807]
           + (threeo2z)*(I2[807] - (lpoz)*I3[807])
           + (twoo2zn)*I4[631];
*(vp++) = U00*I0[808] + U40*I1[808]
           + (threeo2z)*(I2[808] - (lpoz)*I3[808])
           + (twoo2zn)*I4[632];
*(vp++) = U00*I0[809] + U40*I1[809]
           + (threeo2z)*(I2[809] - (lpoz)*I3[809])
           + (twoo2zn)*I4[633];
*(vp++) = U00*I0[810] + U40*I1[810]
           + (threeo2z)*(I2[810] - (lpoz)*I3[810])
           + (twoo2zn)*I4[634];
*(vp++) = U00*I0[811] + U40*I1[811]
           + (threeo2z)*(I2[811] - (lpoz)*I3[811])
           + (twoo2zn)*I4[635];
*(vp++) = U00*I0[812] + U40*I1[812]
           + (threeo2z)*(I2[812] - (lpoz)*I3[812])
           + (twoo2zn)*I4[636];
*(vp++) = U00*I0[813] + U40*I1[813]
           + (threeo2z)*(I2[813] - (lpoz)*I3[813])
           + (oneo2zn)*I4[637];
*(vp++) = U00*I0[814] + U40*I1[814]
           + (threeo2z)*(I2[814] - (lpoz)*I3[814])
           + (oneo2zn)*I4[638];
*(vp++) = U00*I0[815] + U40*I1[815]
           + (threeo2z)*(I2[815] - (lpoz)*I3[815])
           + (oneo2zn)*I4[639];
*(vp++) = U00*I0[816] + U40*I1[816]
           + (threeo2z)*(I2[816] - (lpoz)*I3[816])
           + (oneo2zn)*I4[640];
*(vp++) = U00*I0[817] + U40*I1[817]
           + (threeo2z)*(I2[817] - (lpoz)*I3[817])
           + (oneo2zn)*I4[641];
*(vp++) = U00*I0[818] + U40*I1[818]
           + (threeo2z)*(I2[818] - (lpoz)*I3[818])
           + (oneo2zn)*I4[642];
*(vp++) = U00*I0[819] + U40*I1[819]
           + (threeo2z)*(I2[819] - (lpoz)*I3[819])
           + (oneo2zn)*I4[643];
*(vp++) = U00*I0[820] + U40*I1[820]
           + (threeo2z)*(I2[820] - (lpoz)*I3[820]);
*(vp++) = U00*I0[821] + U40*I1[821]
           + (threeo2z)*(I2[821] - (lpoz)*I3[821]);
*(vp++) = U00*I0[822] + U40*I1[822]
           + (threeo2z)*(I2[822] - (lpoz)*I3[822]);
*(vp++) = U00*I0[823] + U40*I1[823]
           + (threeo2z)*(I2[823] - (lpoz)*I3[823]);
*(vp++) = U00*I0[824] + U40*I1[824]
           + (threeo2z)*(I2[824] - (lpoz)*I3[824]);
*(vp++) = U00*I0[825] + U40*I1[825]
           + (threeo2z)*(I2[825] - (lpoz)*I3[825]);
*(vp++) = U00*I0[826] + U40*I1[826]
           + (threeo2z)*(I2[826] - (lpoz)*I3[826]);
*(vp++) = U00*I0[827] + U40*I1[827]
           + (threeo2z)*(I2[827] - (lpoz)*I3[827]);
*(vp++) = U00*I0[828] + U40*I1[828]
           + (threeo2z)*(I2[828] - (lpoz)*I3[828])
           + (seveno2zn)*I4[644];
*(vp++) = U00*I0[829] + U40*I1[829]
           + (threeo2z)*(I2[829] - (lpoz)*I3[829])
           + (sixo2zn)*I4[645];
*(vp++) = U00*I0[830] + U40*I1[830]
           + (threeo2z)*(I2[830] - (lpoz)*I3[830])
           + (sixo2zn)*I4[646];
*(vp++) = U00*I0[831] + U40*I1[831]
           + (threeo2z)*(I2[831] - (lpoz)*I3[831])
           + (fiveo2zn)*I4[647];
*(vp++) = U00*I0[832] + U40*I1[832]
           + (threeo2z)*(I2[832] - (lpoz)*I3[832])
           + (fiveo2zn)*I4[648];
*(vp++) = U00*I0[833] + U40*I1[833]
           + (threeo2z)*(I2[833] - (lpoz)*I3[833])
           + (fiveo2zn)*I4[649];
*(vp++) = U00*I0[834] + U40*I1[834]
           + (threeo2z)*(I2[834] - (lpoz)*I3[834])
           + (fouro2zn)*I4[650];
*(vp++) = U00*I0[835] + U40*I1[835]
           + (threeo2z)*(I2[835] - (lpoz)*I3[835])
           + (fouro2zn)*I4[651];
*(vp++) = U00*I0[836] + U40*I1[836]
           + (threeo2z)*(I2[836] - (lpoz)*I3[836])
           + (fouro2zn)*I4[652];
*(vp++) = U00*I0[837] + U40*I1[837]
           + (threeo2z)*(I2[837] - (lpoz)*I3[837])
           + (fouro2zn)*I4[653];
*(vp++) = U00*I0[838] + U40*I1[838]
           + (threeo2z)*(I2[838] - (lpoz)*I3[838])
           + (threeo2zn)*I4[654];
*(vp++) = U00*I0[839] + U40*I1[839]
           + (threeo2z)*(I2[839] - (lpoz)*I3[839])
           + (threeo2zn)*I4[655];
*(vp++) = U00*I0[840] + U40*I1[840]
           + (threeo2z)*(I2[840] - (lpoz)*I3[840])
           + (threeo2zn)*I4[656];
*(vp++) = U00*I0[841] + U40*I1[841]
           + (threeo2z)*(I2[841] - (lpoz)*I3[841])
           + (threeo2zn)*I4[657];
*(vp++) = U00*I0[842] + U40*I1[842]
           + (threeo2z)*(I2[842] - (lpoz)*I3[842])
           + (threeo2zn)*I4[658];
*(vp++) = U00*I0[843] + U40*I1[843]
           + (threeo2z)*(I2[843] - (lpoz)*I3[843])
           + (twoo2zn)*I4[659];
*(vp++) = U00*I0[844] + U40*I1[844]
           + (threeo2z)*(I2[844] - (lpoz)*I3[844])
           + (twoo2zn)*I4[660];
*(vp++) = U00*I0[845] + U40*I1[845]
           + (threeo2z)*(I2[845] - (lpoz)*I3[845])
           + (twoo2zn)*I4[661];
*(vp++) = U00*I0[846] + U40*I1[846]
           + (threeo2z)*(I2[846] - (lpoz)*I3[846])
           + (twoo2zn)*I4[662];
*(vp++) = U00*I0[847] + U40*I1[847]
           + (threeo2z)*(I2[847] - (lpoz)*I3[847])
           + (twoo2zn)*I4[663];
*(vp++) = U00*I0[848] + U40*I1[848]
           + (threeo2z)*(I2[848] - (lpoz)*I3[848])
           + (twoo2zn)*I4[664];
*(vp++) = U00*I0[849] + U40*I1[849]
           + (threeo2z)*(I2[849] - (lpoz)*I3[849])
           + (oneo2zn)*I4[665];
*(vp++) = U00*I0[850] + U40*I1[850]
           + (threeo2z)*(I2[850] - (lpoz)*I3[850])
           + (oneo2zn)*I4[666];
*(vp++) = U00*I0[851] + U40*I1[851]
           + (threeo2z)*(I2[851] - (lpoz)*I3[851])
           + (oneo2zn)*I4[667];
*(vp++) = U00*I0[852] + U40*I1[852]
           + (threeo2z)*(I2[852] - (lpoz)*I3[852])
           + (oneo2zn)*I4[668];
*(vp++) = U00*I0[853] + U40*I1[853]
           + (threeo2z)*(I2[853] - (lpoz)*I3[853])
           + (oneo2zn)*I4[669];
*(vp++) = U00*I0[854] + U40*I1[854]
           + (threeo2z)*(I2[854] - (lpoz)*I3[854])
           + (oneo2zn)*I4[670];
*(vp++) = U00*I0[855] + U40*I1[855]
           + (threeo2z)*(I2[855] - (lpoz)*I3[855])
           + (oneo2zn)*I4[671];
*(vp++) = U00*I0[856] + U40*I1[856]
           + (threeo2z)*(I2[856] - (lpoz)*I3[856]);
*(vp++) = U00*I0[857] + U40*I1[857]
           + (threeo2z)*(I2[857] - (lpoz)*I3[857]);
*(vp++) = U00*I0[858] + U40*I1[858]
           + (threeo2z)*(I2[858] - (lpoz)*I3[858]);
*(vp++) = U00*I0[859] + U40*I1[859]
           + (threeo2z)*(I2[859] - (lpoz)*I3[859]);
*(vp++) = U00*I0[860] + U40*I1[860]
           + (threeo2z)*(I2[860] - (lpoz)*I3[860]);
*(vp++) = U00*I0[861] + U40*I1[861]
           + (threeo2z)*(I2[861] - (lpoz)*I3[861]);
*(vp++) = U00*I0[862] + U40*I1[862]
           + (threeo2z)*(I2[862] - (lpoz)*I3[862]);
*(vp++) = U00*I0[863] + U40*I1[863]
           + (threeo2z)*(I2[863] - (lpoz)*I3[863]);
*(vp++) = U00*I0[864] + U40*I1[864]
           + (threeo2z)*(I2[864] - (lpoz)*I3[864])
           + (seveno2zn)*I4[672];
*(vp++) = U00*I0[865] + U40*I1[865]
           + (threeo2z)*(I2[865] - (lpoz)*I3[865])
           + (sixo2zn)*I4[673];
*(vp++) = U00*I0[866] + U40*I1[866]
           + (threeo2z)*(I2[866] - (lpoz)*I3[866])
           + (sixo2zn)*I4[674];
*(vp++) = U00*I0[867] + U40*I1[867]
           + (threeo2z)*(I2[867] - (lpoz)*I3[867])
           + (fiveo2zn)*I4[675];
*(vp++) = U00*I0[868] + U40*I1[868]
           + (threeo2z)*(I2[868] - (lpoz)*I3[868])
           + (fiveo2zn)*I4[676];
*(vp++) = U00*I0[869] + U40*I1[869]
           + (threeo2z)*(I2[869] - (lpoz)*I3[869])
           + (fiveo2zn)*I4[677];
*(vp++) = U00*I0[870] + U40*I1[870]
           + (threeo2z)*(I2[870] - (lpoz)*I3[870])
           + (fouro2zn)*I4[678];
*(vp++) = U00*I0[871] + U40*I1[871]
           + (threeo2z)*(I2[871] - (lpoz)*I3[871])
           + (fouro2zn)*I4[679];
*(vp++) = U00*I0[872] + U40*I1[872]
           + (threeo2z)*(I2[872] - (lpoz)*I3[872])
           + (fouro2zn)*I4[680];
*(vp++) = U00*I0[873] + U40*I1[873]
           + (threeo2z)*(I2[873] - (lpoz)*I3[873])
           + (fouro2zn)*I4[681];
*(vp++) = U00*I0[874] + U40*I1[874]
           + (threeo2z)*(I2[874] - (lpoz)*I3[874])
           + (threeo2zn)*I4[682];
*(vp++) = U00*I0[875] + U40*I1[875]
           + (threeo2z)*(I2[875] - (lpoz)*I3[875])
           + (threeo2zn)*I4[683];
*(vp++) = U00*I0[876] + U40*I1[876]
           + (threeo2z)*(I2[876] - (lpoz)*I3[876])
           + (threeo2zn)*I4[684];
*(vp++) = U00*I0[877] + U40*I1[877]
           + (threeo2z)*(I2[877] - (lpoz)*I3[877])
           + (threeo2zn)*I4[685];
*(vp++) = U00*I0[878] + U40*I1[878]
           + (threeo2z)*(I2[878] - (lpoz)*I3[878])
           + (threeo2zn)*I4[686];
*(vp++) = U00*I0[879] + U40*I1[879]
           + (threeo2z)*(I2[879] - (lpoz)*I3[879])
           + (twoo2zn)*I4[687];
*(vp++) = U00*I0[880] + U40*I1[880]
           + (threeo2z)*(I2[880] - (lpoz)*I3[880])
           + (twoo2zn)*I4[688];
*(vp++) = U00*I0[881] + U40*I1[881]
           + (threeo2z)*(I2[881] - (lpoz)*I3[881])
           + (twoo2zn)*I4[689];
*(vp++) = U00*I0[882] + U40*I1[882]
           + (threeo2z)*(I2[882] - (lpoz)*I3[882])
           + (twoo2zn)*I4[690];
*(vp++) = U00*I0[883] + U40*I1[883]
           + (threeo2z)*(I2[883] - (lpoz)*I3[883])
           + (twoo2zn)*I4[691];
*(vp++) = U00*I0[884] + U40*I1[884]
           + (threeo2z)*(I2[884] - (lpoz)*I3[884])
           + (twoo2zn)*I4[692];
*(vp++) = U00*I0[885] + U40*I1[885]
           + (threeo2z)*(I2[885] - (lpoz)*I3[885])
           + (oneo2zn)*I4[693];
*(vp++) = U00*I0[886] + U40*I1[886]
           + (threeo2z)*(I2[886] - (lpoz)*I3[886])
           + (oneo2zn)*I4[694];
*(vp++) = U00*I0[887] + U40*I1[887]
           + (threeo2z)*(I2[887] - (lpoz)*I3[887])
           + (oneo2zn)*I4[695];
*(vp++) = U00*I0[888] + U40*I1[888]
           + (threeo2z)*(I2[888] - (lpoz)*I3[888])
           + (oneo2zn)*I4[696];
*(vp++) = U00*I0[889] + U40*I1[889]
           + (threeo2z)*(I2[889] - (lpoz)*I3[889])
           + (oneo2zn)*I4[697];
*(vp++) = U00*I0[890] + U40*I1[890]
           + (threeo2z)*(I2[890] - (lpoz)*I3[890])
           + (oneo2zn)*I4[698];
*(vp++) = U00*I0[891] + U40*I1[891]
           + (threeo2z)*(I2[891] - (lpoz)*I3[891])
           + (oneo2zn)*I4[699];
*(vp++) = U00*I0[892] + U40*I1[892]
           + (threeo2z)*(I2[892] - (lpoz)*I3[892]);
*(vp++) = U00*I0[893] + U40*I1[893]
           + (threeo2z)*(I2[893] - (lpoz)*I3[893]);
return vp;
}

REALTYPE *_build_n0k0_3(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[894] + U40*I1[894]
           + (threeo2z)*(I2[894] - (lpoz)*I3[894]);
*(vp++) = U00*I0[895] + U40*I1[895]
           + (threeo2z)*(I2[895] - (lpoz)*I3[895]);
*(vp++) = U00*I0[896] + U40*I1[896]
           + (threeo2z)*(I2[896] - (lpoz)*I3[896]);
*(vp++) = U00*I0[897] + U40*I1[897]
           + (threeo2z)*(I2[897] - (lpoz)*I3[897]);
*(vp++) = U00*I0[898] + U40*I1[898]
           + (threeo2z)*(I2[898] - (lpoz)*I3[898]);
*(vp++) = U00*I0[899] + U40*I1[899]
           + (threeo2z)*(I2[899] - (lpoz)*I3[899]);
*(vp++) = U00*I0[900] + U40*I1[900]
           + (threeo2z)*(I2[900] - (lpoz)*I3[900])
           + (seveno2zn)*I4[700];
*(vp++) = U00*I0[901] + U40*I1[901]
           + (threeo2z)*(I2[901] - (lpoz)*I3[901])
           + (sixo2zn)*I4[701];
*(vp++) = U00*I0[902] + U40*I1[902]
           + (threeo2z)*(I2[902] - (lpoz)*I3[902])
           + (sixo2zn)*I4[702];
*(vp++) = U00*I0[903] + U40*I1[903]
           + (threeo2z)*(I2[903] - (lpoz)*I3[903])
           + (fiveo2zn)*I4[703];
*(vp++) = U00*I0[904] + U40*I1[904]
           + (threeo2z)*(I2[904] - (lpoz)*I3[904])
           + (fiveo2zn)*I4[704];
*(vp++) = U00*I0[905] + U40*I1[905]
           + (threeo2z)*(I2[905] - (lpoz)*I3[905])
           + (fiveo2zn)*I4[705];
*(vp++) = U00*I0[906] + U40*I1[906]
           + (threeo2z)*(I2[906] - (lpoz)*I3[906])
           + (fouro2zn)*I4[706];
*(vp++) = U00*I0[907] + U40*I1[907]
           + (threeo2z)*(I2[907] - (lpoz)*I3[907])
           + (fouro2zn)*I4[707];
*(vp++) = U00*I0[908] + U40*I1[908]
           + (threeo2z)*(I2[908] - (lpoz)*I3[908])
           + (fouro2zn)*I4[708];
*(vp++) = U00*I0[909] + U40*I1[909]
           + (threeo2z)*(I2[909] - (lpoz)*I3[909])
           + (fouro2zn)*I4[709];
*(vp++) = U00*I0[910] + U40*I1[910]
           + (threeo2z)*(I2[910] - (lpoz)*I3[910])
           + (threeo2zn)*I4[710];
*(vp++) = U00*I0[911] + U40*I1[911]
           + (threeo2z)*(I2[911] - (lpoz)*I3[911])
           + (threeo2zn)*I4[711];
*(vp++) = U00*I0[912] + U40*I1[912]
           + (threeo2z)*(I2[912] - (lpoz)*I3[912])
           + (threeo2zn)*I4[712];
*(vp++) = U00*I0[913] + U40*I1[913]
           + (threeo2z)*(I2[913] - (lpoz)*I3[913])
           + (threeo2zn)*I4[713];
*(vp++) = U00*I0[914] + U40*I1[914]
           + (threeo2z)*(I2[914] - (lpoz)*I3[914])
           + (threeo2zn)*I4[714];
*(vp++) = U00*I0[915] + U40*I1[915]
           + (threeo2z)*(I2[915] - (lpoz)*I3[915])
           + (twoo2zn)*I4[715];
*(vp++) = U00*I0[916] + U40*I1[916]
           + (threeo2z)*(I2[916] - (lpoz)*I3[916])
           + (twoo2zn)*I4[716];
*(vp++) = U00*I0[917] + U40*I1[917]
           + (threeo2z)*(I2[917] - (lpoz)*I3[917])
           + (twoo2zn)*I4[717];
*(vp++) = U00*I0[918] + U40*I1[918]
           + (threeo2z)*(I2[918] - (lpoz)*I3[918])
           + (twoo2zn)*I4[718];
*(vp++) = U00*I0[919] + U40*I1[919]
           + (threeo2z)*(I2[919] - (lpoz)*I3[919])
           + (twoo2zn)*I4[719];
*(vp++) = U00*I0[920] + U40*I1[920]
           + (threeo2z)*(I2[920] - (lpoz)*I3[920])
           + (twoo2zn)*I4[720];
*(vp++) = U00*I0[921] + U40*I1[921]
           + (threeo2z)*(I2[921] - (lpoz)*I3[921])
           + (oneo2zn)*I4[721];
*(vp++) = U00*I0[922] + U40*I1[922]
           + (threeo2z)*(I2[922] - (lpoz)*I3[922])
           + (oneo2zn)*I4[722];
*(vp++) = U00*I0[923] + U40*I1[923]
           + (threeo2z)*(I2[923] - (lpoz)*I3[923])
           + (oneo2zn)*I4[723];
*(vp++) = U00*I0[924] + U40*I1[924]
           + (threeo2z)*(I2[924] - (lpoz)*I3[924])
           + (oneo2zn)*I4[724];
*(vp++) = U00*I0[925] + U40*I1[925]
           + (threeo2z)*(I2[925] - (lpoz)*I3[925])
           + (oneo2zn)*I4[725];
*(vp++) = U00*I0[926] + U40*I1[926]
           + (threeo2z)*(I2[926] - (lpoz)*I3[926])
           + (oneo2zn)*I4[726];
*(vp++) = U00*I0[927] + U40*I1[927]
           + (threeo2z)*(I2[927] - (lpoz)*I3[927])
           + (oneo2zn)*I4[727];
*(vp++) = U00*I0[928] + U40*I1[928]
           + (threeo2z)*(I2[928] - (lpoz)*I3[928]);
*(vp++) = U00*I0[929] + U40*I1[929]
           + (threeo2z)*(I2[929] - (lpoz)*I3[929]);
*(vp++) = U00*I0[930] + U40*I1[930]
           + (threeo2z)*(I2[930] - (lpoz)*I3[930]);
*(vp++) = U00*I0[931] + U40*I1[931]
           + (threeo2z)*(I2[931] - (lpoz)*I3[931]);
*(vp++) = U00*I0[932] + U40*I1[932]
           + (threeo2z)*(I2[932] - (lpoz)*I3[932]);
*(vp++) = U00*I0[933] + U40*I1[933]
           + (threeo2z)*(I2[933] - (lpoz)*I3[933]);
*(vp++) = U00*I0[934] + U40*I1[934]
           + (threeo2z)*(I2[934] - (lpoz)*I3[934]);
*(vp++) = U00*I0[935] + U40*I1[935]
           + (threeo2z)*(I2[935] - (lpoz)*I3[935]);
*(vp++) = U00*I0[936] + U40*I1[936]
           + (threeo2z)*(I2[936] - (lpoz)*I3[936])
           + (seveno2zn)*I4[728];
*(vp++) = U00*I0[937] + U40*I1[937]
           + (threeo2z)*(I2[937] - (lpoz)*I3[937])
           + (sixo2zn)*I4[729];
*(vp++) = U00*I0[938] + U40*I1[938]
           + (threeo2z)*(I2[938] - (lpoz)*I3[938])
           + (sixo2zn)*I4[730];
*(vp++) = U00*I0[939] + U40*I1[939]
           + (threeo2z)*(I2[939] - (lpoz)*I3[939])
           + (fiveo2zn)*I4[731];
*(vp++) = U00*I0[940] + U40*I1[940]
           + (threeo2z)*(I2[940] - (lpoz)*I3[940])
           + (fiveo2zn)*I4[732];
*(vp++) = U00*I0[941] + U40*I1[941]
           + (threeo2z)*(I2[941] - (lpoz)*I3[941])
           + (fiveo2zn)*I4[733];
*(vp++) = U00*I0[942] + U40*I1[942]
           + (threeo2z)*(I2[942] - (lpoz)*I3[942])
           + (fouro2zn)*I4[734];
*(vp++) = U00*I0[943] + U40*I1[943]
           + (threeo2z)*(I2[943] - (lpoz)*I3[943])
           + (fouro2zn)*I4[735];
*(vp++) = U00*I0[944] + U40*I1[944]
           + (threeo2z)*(I2[944] - (lpoz)*I3[944])
           + (fouro2zn)*I4[736];
*(vp++) = U00*I0[945] + U40*I1[945]
           + (threeo2z)*(I2[945] - (lpoz)*I3[945])
           + (fouro2zn)*I4[737];
*(vp++) = U00*I0[946] + U40*I1[946]
           + (threeo2z)*(I2[946] - (lpoz)*I3[946])
           + (threeo2zn)*I4[738];
*(vp++) = U00*I0[947] + U40*I1[947]
           + (threeo2z)*(I2[947] - (lpoz)*I3[947])
           + (threeo2zn)*I4[739];
*(vp++) = U00*I0[948] + U40*I1[948]
           + (threeo2z)*(I2[948] - (lpoz)*I3[948])
           + (threeo2zn)*I4[740];
*(vp++) = U00*I0[949] + U40*I1[949]
           + (threeo2z)*(I2[949] - (lpoz)*I3[949])
           + (threeo2zn)*I4[741];
*(vp++) = U00*I0[950] + U40*I1[950]
           + (threeo2z)*(I2[950] - (lpoz)*I3[950])
           + (threeo2zn)*I4[742];
*(vp++) = U00*I0[951] + U40*I1[951]
           + (threeo2z)*(I2[951] - (lpoz)*I3[951])
           + (twoo2zn)*I4[743];
*(vp++) = U00*I0[952] + U40*I1[952]
           + (threeo2z)*(I2[952] - (lpoz)*I3[952])
           + (twoo2zn)*I4[744];
*(vp++) = U00*I0[953] + U40*I1[953]
           + (threeo2z)*(I2[953] - (lpoz)*I3[953])
           + (twoo2zn)*I4[745];
*(vp++) = U00*I0[954] + U40*I1[954]
           + (threeo2z)*(I2[954] - (lpoz)*I3[954])
           + (twoo2zn)*I4[746];
*(vp++) = U00*I0[955] + U40*I1[955]
           + (threeo2z)*(I2[955] - (lpoz)*I3[955])
           + (twoo2zn)*I4[747];
*(vp++) = U00*I0[956] + U40*I1[956]
           + (threeo2z)*(I2[956] - (lpoz)*I3[956])
           + (twoo2zn)*I4[748];
*(vp++) = U00*I0[957] + U40*I1[957]
           + (threeo2z)*(I2[957] - (lpoz)*I3[957])
           + (oneo2zn)*I4[749];
*(vp++) = U00*I0[958] + U40*I1[958]
           + (threeo2z)*(I2[958] - (lpoz)*I3[958])
           + (oneo2zn)*I4[750];
*(vp++) = U00*I0[959] + U40*I1[959]
           + (threeo2z)*(I2[959] - (lpoz)*I3[959])
           + (oneo2zn)*I4[751];
*(vp++) = U00*I0[960] + U40*I1[960]
           + (threeo2z)*(I2[960] - (lpoz)*I3[960])
           + (oneo2zn)*I4[752];
*(vp++) = U00*I0[961] + U40*I1[961]
           + (threeo2z)*(I2[961] - (lpoz)*I3[961])
           + (oneo2zn)*I4[753];
*(vp++) = U00*I0[962] + U40*I1[962]
           + (threeo2z)*(I2[962] - (lpoz)*I3[962])
           + (oneo2zn)*I4[754];
*(vp++) = U00*I0[963] + U40*I1[963]
           + (threeo2z)*(I2[963] - (lpoz)*I3[963])
           + (oneo2zn)*I4[755];
*(vp++) = U00*I0[964] + U40*I1[964]
           + (threeo2z)*(I2[964] - (lpoz)*I3[964]);
*(vp++) = U00*I0[965] + U40*I1[965]
           + (threeo2z)*(I2[965] - (lpoz)*I3[965]);
*(vp++) = U00*I0[966] + U40*I1[966]
           + (threeo2z)*(I2[966] - (lpoz)*I3[966]);
*(vp++) = U00*I0[967] + U40*I1[967]
           + (threeo2z)*(I2[967] - (lpoz)*I3[967]);
*(vp++) = U00*I0[968] + U40*I1[968]
           + (threeo2z)*(I2[968] - (lpoz)*I3[968]);
*(vp++) = U00*I0[969] + U40*I1[969]
           + (threeo2z)*(I2[969] - (lpoz)*I3[969]);
*(vp++) = U00*I0[970] + U40*I1[970]
           + (threeo2z)*(I2[970] - (lpoz)*I3[970]);
*(vp++) = U00*I0[971] + U40*I1[971]
           + (threeo2z)*(I2[971] - (lpoz)*I3[971]);
*(vp++) = U00*I0[972] + U40*I1[972]
           + (threeo2z)*(I2[972] - (lpoz)*I3[972])
           + (seveno2zn)*I4[756];
*(vp++) = U00*I0[973] + U40*I1[973]
           + (threeo2z)*(I2[973] - (lpoz)*I3[973])
           + (sixo2zn)*I4[757];
*(vp++) = U00*I0[974] + U40*I1[974]
           + (threeo2z)*(I2[974] - (lpoz)*I3[974])
           + (sixo2zn)*I4[758];
*(vp++) = U00*I0[975] + U40*I1[975]
           + (threeo2z)*(I2[975] - (lpoz)*I3[975])
           + (fiveo2zn)*I4[759];
*(vp++) = U00*I0[976] + U40*I1[976]
           + (threeo2z)*(I2[976] - (lpoz)*I3[976])
           + (fiveo2zn)*I4[760];
*(vp++) = U00*I0[977] + U40*I1[977]
           + (threeo2z)*(I2[977] - (lpoz)*I3[977])
           + (fiveo2zn)*I4[761];
*(vp++) = U00*I0[978] + U40*I1[978]
           + (threeo2z)*(I2[978] - (lpoz)*I3[978])
           + (fouro2zn)*I4[762];
*(vp++) = U00*I0[979] + U40*I1[979]
           + (threeo2z)*(I2[979] - (lpoz)*I3[979])
           + (fouro2zn)*I4[763];
*(vp++) = U00*I0[980] + U40*I1[980]
           + (threeo2z)*(I2[980] - (lpoz)*I3[980])
           + (fouro2zn)*I4[764];
*(vp++) = U00*I0[981] + U40*I1[981]
           + (threeo2z)*(I2[981] - (lpoz)*I3[981])
           + (fouro2zn)*I4[765];
*(vp++) = U00*I0[982] + U40*I1[982]
           + (threeo2z)*(I2[982] - (lpoz)*I3[982])
           + (threeo2zn)*I4[766];
*(vp++) = U00*I0[983] + U40*I1[983]
           + (threeo2z)*(I2[983] - (lpoz)*I3[983])
           + (threeo2zn)*I4[767];
*(vp++) = U00*I0[984] + U40*I1[984]
           + (threeo2z)*(I2[984] - (lpoz)*I3[984])
           + (threeo2zn)*I4[768];
*(vp++) = U00*I0[985] + U40*I1[985]
           + (threeo2z)*(I2[985] - (lpoz)*I3[985])
           + (threeo2zn)*I4[769];
*(vp++) = U00*I0[986] + U40*I1[986]
           + (threeo2z)*(I2[986] - (lpoz)*I3[986])
           + (threeo2zn)*I4[770];
*(vp++) = U00*I0[987] + U40*I1[987]
           + (threeo2z)*(I2[987] - (lpoz)*I3[987])
           + (twoo2zn)*I4[771];
*(vp++) = U00*I0[988] + U40*I1[988]
           + (threeo2z)*(I2[988] - (lpoz)*I3[988])
           + (twoo2zn)*I4[772];
*(vp++) = U00*I0[989] + U40*I1[989]
           + (threeo2z)*(I2[989] - (lpoz)*I3[989])
           + (twoo2zn)*I4[773];
*(vp++) = U00*I0[990] + U40*I1[990]
           + (threeo2z)*(I2[990] - (lpoz)*I3[990])
           + (twoo2zn)*I4[774];
*(vp++) = U00*I0[991] + U40*I1[991]
           + (threeo2z)*(I2[991] - (lpoz)*I3[991])
           + (twoo2zn)*I4[775];
*(vp++) = U00*I0[992] + U40*I1[992]
           + (threeo2z)*(I2[992] - (lpoz)*I3[992])
           + (twoo2zn)*I4[776];
*(vp++) = U00*I0[993] + U40*I1[993]
           + (threeo2z)*(I2[993] - (lpoz)*I3[993])
           + (oneo2zn)*I4[777];
*(vp++) = U00*I0[994] + U40*I1[994]
           + (threeo2z)*(I2[994] - (lpoz)*I3[994])
           + (oneo2zn)*I4[778];
*(vp++) = U00*I0[995] + U40*I1[995]
           + (threeo2z)*(I2[995] - (lpoz)*I3[995])
           + (oneo2zn)*I4[779];
*(vp++) = U00*I0[996] + U40*I1[996]
           + (threeo2z)*(I2[996] - (lpoz)*I3[996])
           + (oneo2zn)*I4[780];
*(vp++) = U00*I0[997] + U40*I1[997]
           + (threeo2z)*(I2[997] - (lpoz)*I3[997])
           + (oneo2zn)*I4[781];
*(vp++) = U00*I0[998] + U40*I1[998]
           + (threeo2z)*(I2[998] - (lpoz)*I3[998])
           + (oneo2zn)*I4[782];
*(vp++) = U00*I0[999] + U40*I1[999]
           + (threeo2z)*(I2[999] - (lpoz)*I3[999])
           + (oneo2zn)*I4[783];
*(vp++) = U00*I0[1000] + U40*I1[1000]
           + (threeo2z)*(I2[1000] - (lpoz)*I3[1000]);
*(vp++) = U00*I0[1001] + U40*I1[1001]
           + (threeo2z)*(I2[1001] - (lpoz)*I3[1001]);
*(vp++) = U00*I0[1002] + U40*I1[1002]
           + (threeo2z)*(I2[1002] - (lpoz)*I3[1002]);
*(vp++) = U00*I0[1003] + U40*I1[1003]
           + (threeo2z)*(I2[1003] - (lpoz)*I3[1003]);
*(vp++) = U00*I0[1004] + U40*I1[1004]
           + (threeo2z)*(I2[1004] - (lpoz)*I3[1004]);
*(vp++) = U00*I0[1005] + U40*I1[1005]
           + (threeo2z)*(I2[1005] - (lpoz)*I3[1005]);
*(vp++) = U00*I0[1006] + U40*I1[1006]
           + (threeo2z)*(I2[1006] - (lpoz)*I3[1006]);
*(vp++) = U00*I0[1007] + U40*I1[1007]
           + (threeo2z)*(I2[1007] - (lpoz)*I3[1007]);
*(vp++) = U00*I0[1008] + U40*I1[1008]
           + (twoo2z)*(I2[1008] - (lpoz)*I3[1008])
           + (seveno2zn)*I4[784];
*(vp++) = U00*I0[1009] + U40*I1[1009]
           + (twoo2z)*(I2[1009] - (lpoz)*I3[1009])
           + (sixo2zn)*I4[785];
*(vp++) = U00*I0[1010] + U40*I1[1010]
           + (twoo2z)*(I2[1010] - (lpoz)*I3[1010])
           + (sixo2zn)*I4[786];
*(vp++) = U00*I0[1011] + U40*I1[1011]
           + (twoo2z)*(I2[1011] - (lpoz)*I3[1011])
           + (fiveo2zn)*I4[787];
*(vp++) = U00*I0[1012] + U40*I1[1012]
           + (twoo2z)*(I2[1012] - (lpoz)*I3[1012])
           + (fiveo2zn)*I4[788];
*(vp++) = U00*I0[1013] + U40*I1[1013]
           + (twoo2z)*(I2[1013] - (lpoz)*I3[1013])
           + (fiveo2zn)*I4[789];
*(vp++) = U00*I0[1014] + U40*I1[1014]
           + (twoo2z)*(I2[1014] - (lpoz)*I3[1014])
           + (fouro2zn)*I4[790];
*(vp++) = U00*I0[1015] + U40*I1[1015]
           + (twoo2z)*(I2[1015] - (lpoz)*I3[1015])
           + (fouro2zn)*I4[791];
*(vp++) = U00*I0[1016] + U40*I1[1016]
           + (twoo2z)*(I2[1016] - (lpoz)*I3[1016])
           + (fouro2zn)*I4[792];
*(vp++) = U00*I0[1017] + U40*I1[1017]
           + (twoo2z)*(I2[1017] - (lpoz)*I3[1017])
           + (fouro2zn)*I4[793];
*(vp++) = U00*I0[1018] + U40*I1[1018]
           + (twoo2z)*(I2[1018] - (lpoz)*I3[1018])
           + (threeo2zn)*I4[794];
*(vp++) = U00*I0[1019] + U40*I1[1019]
           + (twoo2z)*(I2[1019] - (lpoz)*I3[1019])
           + (threeo2zn)*I4[795];
*(vp++) = U00*I0[1020] + U40*I1[1020]
           + (twoo2z)*(I2[1020] - (lpoz)*I3[1020])
           + (threeo2zn)*I4[796];
*(vp++) = U00*I0[1021] + U40*I1[1021]
           + (twoo2z)*(I2[1021] - (lpoz)*I3[1021])
           + (threeo2zn)*I4[797];
*(vp++) = U00*I0[1022] + U40*I1[1022]
           + (twoo2z)*(I2[1022] - (lpoz)*I3[1022])
           + (threeo2zn)*I4[798];
*(vp++) = U00*I0[1023] + U40*I1[1023]
           + (twoo2z)*(I2[1023] - (lpoz)*I3[1023])
           + (twoo2zn)*I4[799];
*(vp++) = U00*I0[1024] + U40*I1[1024]
           + (twoo2z)*(I2[1024] - (lpoz)*I3[1024])
           + (twoo2zn)*I4[800];
*(vp++) = U00*I0[1025] + U40*I1[1025]
           + (twoo2z)*(I2[1025] - (lpoz)*I3[1025])
           + (twoo2zn)*I4[801];
*(vp++) = U00*I0[1026] + U40*I1[1026]
           + (twoo2z)*(I2[1026] - (lpoz)*I3[1026])
           + (twoo2zn)*I4[802];
*(vp++) = U00*I0[1027] + U40*I1[1027]
           + (twoo2z)*(I2[1027] - (lpoz)*I3[1027])
           + (twoo2zn)*I4[803];
*(vp++) = U00*I0[1028] + U40*I1[1028]
           + (twoo2z)*(I2[1028] - (lpoz)*I3[1028])
           + (twoo2zn)*I4[804];
*(vp++) = U00*I0[1029] + U40*I1[1029]
           + (twoo2z)*(I2[1029] - (lpoz)*I3[1029])
           + (oneo2zn)*I4[805];
*(vp++) = U00*I0[1030] + U40*I1[1030]
           + (twoo2z)*(I2[1030] - (lpoz)*I3[1030])
           + (oneo2zn)*I4[806];
*(vp++) = U00*I0[1031] + U40*I1[1031]
           + (twoo2z)*(I2[1031] - (lpoz)*I3[1031])
           + (oneo2zn)*I4[807];
*(vp++) = U00*I0[1032] + U40*I1[1032]
           + (twoo2z)*(I2[1032] - (lpoz)*I3[1032])
           + (oneo2zn)*I4[808];
*(vp++) = U00*I0[1033] + U40*I1[1033]
           + (twoo2z)*(I2[1033] - (lpoz)*I3[1033])
           + (oneo2zn)*I4[809];
*(vp++) = U00*I0[1034] + U40*I1[1034]
           + (twoo2z)*(I2[1034] - (lpoz)*I3[1034])
           + (oneo2zn)*I4[810];
*(vp++) = U00*I0[1035] + U40*I1[1035]
           + (twoo2z)*(I2[1035] - (lpoz)*I3[1035])
           + (oneo2zn)*I4[811];
*(vp++) = U00*I0[1036] + U40*I1[1036]
           + (twoo2z)*(I2[1036] - (lpoz)*I3[1036]);
*(vp++) = U00*I0[1037] + U40*I1[1037]
           + (twoo2z)*(I2[1037] - (lpoz)*I3[1037]);
*(vp++) = U00*I0[1038] + U40*I1[1038]
           + (twoo2z)*(I2[1038] - (lpoz)*I3[1038]);
*(vp++) = U00*I0[1039] + U40*I1[1039]
           + (twoo2z)*(I2[1039] - (lpoz)*I3[1039]);
*(vp++) = U00*I0[1040] + U40*I1[1040]
           + (twoo2z)*(I2[1040] - (lpoz)*I3[1040]);
*(vp++) = U00*I0[1041] + U40*I1[1041]
           + (twoo2z)*(I2[1041] - (lpoz)*I3[1041]);
*(vp++) = U00*I0[1042] + U40*I1[1042]
           + (twoo2z)*(I2[1042] - (lpoz)*I3[1042]);
*(vp++) = U00*I0[1043] + U40*I1[1043]
           + (twoo2z)*(I2[1043] - (lpoz)*I3[1043]);
*(vp++) = U00*I0[1044] + U40*I1[1044]
           + (twoo2z)*(I2[1044] - (lpoz)*I3[1044])
           + (seveno2zn)*I4[812];
*(vp++) = U00*I0[1045] + U40*I1[1045]
           + (twoo2z)*(I2[1045] - (lpoz)*I3[1045])
           + (sixo2zn)*I4[813];
*(vp++) = U00*I0[1046] + U40*I1[1046]
           + (twoo2z)*(I2[1046] - (lpoz)*I3[1046])
           + (sixo2zn)*I4[814];
*(vp++) = U00*I0[1047] + U40*I1[1047]
           + (twoo2z)*(I2[1047] - (lpoz)*I3[1047])
           + (fiveo2zn)*I4[815];
*(vp++) = U00*I0[1048] + U40*I1[1048]
           + (twoo2z)*(I2[1048] - (lpoz)*I3[1048])
           + (fiveo2zn)*I4[816];
*(vp++) = U00*I0[1049] + U40*I1[1049]
           + (twoo2z)*(I2[1049] - (lpoz)*I3[1049])
           + (fiveo2zn)*I4[817];
*(vp++) = U00*I0[1050] + U40*I1[1050]
           + (twoo2z)*(I2[1050] - (lpoz)*I3[1050])
           + (fouro2zn)*I4[818];
*(vp++) = U00*I0[1051] + U40*I1[1051]
           + (twoo2z)*(I2[1051] - (lpoz)*I3[1051])
           + (fouro2zn)*I4[819];
*(vp++) = U00*I0[1052] + U40*I1[1052]
           + (twoo2z)*(I2[1052] - (lpoz)*I3[1052])
           + (fouro2zn)*I4[820];
*(vp++) = U00*I0[1053] + U40*I1[1053]
           + (twoo2z)*(I2[1053] - (lpoz)*I3[1053])
           + (fouro2zn)*I4[821];
*(vp++) = U00*I0[1054] + U40*I1[1054]
           + (twoo2z)*(I2[1054] - (lpoz)*I3[1054])
           + (threeo2zn)*I4[822];
*(vp++) = U00*I0[1055] + U40*I1[1055]
           + (twoo2z)*(I2[1055] - (lpoz)*I3[1055])
           + (threeo2zn)*I4[823];
*(vp++) = U00*I0[1056] + U40*I1[1056]
           + (twoo2z)*(I2[1056] - (lpoz)*I3[1056])
           + (threeo2zn)*I4[824];
*(vp++) = U00*I0[1057] + U40*I1[1057]
           + (twoo2z)*(I2[1057] - (lpoz)*I3[1057])
           + (threeo2zn)*I4[825];
*(vp++) = U00*I0[1058] + U40*I1[1058]
           + (twoo2z)*(I2[1058] - (lpoz)*I3[1058])
           + (threeo2zn)*I4[826];
*(vp++) = U00*I0[1059] + U40*I1[1059]
           + (twoo2z)*(I2[1059] - (lpoz)*I3[1059])
           + (twoo2zn)*I4[827];
*(vp++) = U00*I0[1060] + U40*I1[1060]
           + (twoo2z)*(I2[1060] - (lpoz)*I3[1060])
           + (twoo2zn)*I4[828];
*(vp++) = U00*I0[1061] + U40*I1[1061]
           + (twoo2z)*(I2[1061] - (lpoz)*I3[1061])
           + (twoo2zn)*I4[829];
*(vp++) = U00*I0[1062] + U40*I1[1062]
           + (twoo2z)*(I2[1062] - (lpoz)*I3[1062])
           + (twoo2zn)*I4[830];
*(vp++) = U00*I0[1063] + U40*I1[1063]
           + (twoo2z)*(I2[1063] - (lpoz)*I3[1063])
           + (twoo2zn)*I4[831];
*(vp++) = U00*I0[1064] + U40*I1[1064]
           + (twoo2z)*(I2[1064] - (lpoz)*I3[1064])
           + (twoo2zn)*I4[832];
*(vp++) = U00*I0[1065] + U40*I1[1065]
           + (twoo2z)*(I2[1065] - (lpoz)*I3[1065])
           + (oneo2zn)*I4[833];
*(vp++) = U00*I0[1066] + U40*I1[1066]
           + (twoo2z)*(I2[1066] - (lpoz)*I3[1066])
           + (oneo2zn)*I4[834];
*(vp++) = U00*I0[1067] + U40*I1[1067]
           + (twoo2z)*(I2[1067] - (lpoz)*I3[1067])
           + (oneo2zn)*I4[835];
*(vp++) = U00*I0[1068] + U40*I1[1068]
           + (twoo2z)*(I2[1068] - (lpoz)*I3[1068])
           + (oneo2zn)*I4[836];
*(vp++) = U00*I0[1069] + U40*I1[1069]
           + (twoo2z)*(I2[1069] - (lpoz)*I3[1069])
           + (oneo2zn)*I4[837];
*(vp++) = U00*I0[1070] + U40*I1[1070]
           + (twoo2z)*(I2[1070] - (lpoz)*I3[1070])
           + (oneo2zn)*I4[838];
*(vp++) = U00*I0[1071] + U40*I1[1071]
           + (twoo2z)*(I2[1071] - (lpoz)*I3[1071])
           + (oneo2zn)*I4[839];
*(vp++) = U00*I0[1072] + U40*I1[1072]
           + (twoo2z)*(I2[1072] - (lpoz)*I3[1072]);
*(vp++) = U00*I0[1073] + U40*I1[1073]
           + (twoo2z)*(I2[1073] - (lpoz)*I3[1073]);
*(vp++) = U00*I0[1074] + U40*I1[1074]
           + (twoo2z)*(I2[1074] - (lpoz)*I3[1074]);
*(vp++) = U00*I0[1075] + U40*I1[1075]
           + (twoo2z)*(I2[1075] - (lpoz)*I3[1075]);
*(vp++) = U00*I0[1076] + U40*I1[1076]
           + (twoo2z)*(I2[1076] - (lpoz)*I3[1076]);
*(vp++) = U00*I0[1077] + U40*I1[1077]
           + (twoo2z)*(I2[1077] - (lpoz)*I3[1077]);
*(vp++) = U00*I0[1078] + U40*I1[1078]
           + (twoo2z)*(I2[1078] - (lpoz)*I3[1078]);
*(vp++) = U00*I0[1079] + U40*I1[1079]
           + (twoo2z)*(I2[1079] - (lpoz)*I3[1079]);
*(vp++) = U00*I0[1080] + U40*I1[1080]
           + (twoo2z)*(I2[1080] - (lpoz)*I3[1080])
           + (seveno2zn)*I4[840];
*(vp++) = U00*I0[1081] + U40*I1[1081]
           + (twoo2z)*(I2[1081] - (lpoz)*I3[1081])
           + (sixo2zn)*I4[841];
*(vp++) = U00*I0[1082] + U40*I1[1082]
           + (twoo2z)*(I2[1082] - (lpoz)*I3[1082])
           + (sixo2zn)*I4[842];
*(vp++) = U00*I0[1083] + U40*I1[1083]
           + (twoo2z)*(I2[1083] - (lpoz)*I3[1083])
           + (fiveo2zn)*I4[843];
*(vp++) = U00*I0[1084] + U40*I1[1084]
           + (twoo2z)*(I2[1084] - (lpoz)*I3[1084])
           + (fiveo2zn)*I4[844];
*(vp++) = U00*I0[1085] + U40*I1[1085]
           + (twoo2z)*(I2[1085] - (lpoz)*I3[1085])
           + (fiveo2zn)*I4[845];
*(vp++) = U00*I0[1086] + U40*I1[1086]
           + (twoo2z)*(I2[1086] - (lpoz)*I3[1086])
           + (fouro2zn)*I4[846];
*(vp++) = U00*I0[1087] + U40*I1[1087]
           + (twoo2z)*(I2[1087] - (lpoz)*I3[1087])
           + (fouro2zn)*I4[847];
*(vp++) = U00*I0[1088] + U40*I1[1088]
           + (twoo2z)*(I2[1088] - (lpoz)*I3[1088])
           + (fouro2zn)*I4[848];
*(vp++) = U00*I0[1089] + U40*I1[1089]
           + (twoo2z)*(I2[1089] - (lpoz)*I3[1089])
           + (fouro2zn)*I4[849];
*(vp++) = U00*I0[1090] + U40*I1[1090]
           + (twoo2z)*(I2[1090] - (lpoz)*I3[1090])
           + (threeo2zn)*I4[850];
*(vp++) = U00*I0[1091] + U40*I1[1091]
           + (twoo2z)*(I2[1091] - (lpoz)*I3[1091])
           + (threeo2zn)*I4[851];
*(vp++) = U00*I0[1092] + U40*I1[1092]
           + (twoo2z)*(I2[1092] - (lpoz)*I3[1092])
           + (threeo2zn)*I4[852];
*(vp++) = U00*I0[1093] + U40*I1[1093]
           + (twoo2z)*(I2[1093] - (lpoz)*I3[1093])
           + (threeo2zn)*I4[853];
*(vp++) = U00*I0[1094] + U40*I1[1094]
           + (twoo2z)*(I2[1094] - (lpoz)*I3[1094])
           + (threeo2zn)*I4[854];
*(vp++) = U00*I0[1095] + U40*I1[1095]
           + (twoo2z)*(I2[1095] - (lpoz)*I3[1095])
           + (twoo2zn)*I4[855];
*(vp++) = U00*I0[1096] + U40*I1[1096]
           + (twoo2z)*(I2[1096] - (lpoz)*I3[1096])
           + (twoo2zn)*I4[856];
*(vp++) = U00*I0[1097] + U40*I1[1097]
           + (twoo2z)*(I2[1097] - (lpoz)*I3[1097])
           + (twoo2zn)*I4[857];
*(vp++) = U00*I0[1098] + U40*I1[1098]
           + (twoo2z)*(I2[1098] - (lpoz)*I3[1098])
           + (twoo2zn)*I4[858];
*(vp++) = U00*I0[1099] + U40*I1[1099]
           + (twoo2z)*(I2[1099] - (lpoz)*I3[1099])
           + (twoo2zn)*I4[859];
*(vp++) = U00*I0[1100] + U40*I1[1100]
           + (twoo2z)*(I2[1100] - (lpoz)*I3[1100])
           + (twoo2zn)*I4[860];
*(vp++) = U00*I0[1101] + U40*I1[1101]
           + (twoo2z)*(I2[1101] - (lpoz)*I3[1101])
           + (oneo2zn)*I4[861];
*(vp++) = U00*I0[1102] + U40*I1[1102]
           + (twoo2z)*(I2[1102] - (lpoz)*I3[1102])
           + (oneo2zn)*I4[862];
*(vp++) = U00*I0[1103] + U40*I1[1103]
           + (twoo2z)*(I2[1103] - (lpoz)*I3[1103])
           + (oneo2zn)*I4[863];
*(vp++) = U00*I0[1104] + U40*I1[1104]
           + (twoo2z)*(I2[1104] - (lpoz)*I3[1104])
           + (oneo2zn)*I4[864];
*(vp++) = U00*I0[1105] + U40*I1[1105]
           + (twoo2z)*(I2[1105] - (lpoz)*I3[1105])
           + (oneo2zn)*I4[865];
*(vp++) = U00*I0[1106] + U40*I1[1106]
           + (twoo2z)*(I2[1106] - (lpoz)*I3[1106])
           + (oneo2zn)*I4[866];
*(vp++) = U00*I0[1107] + U40*I1[1107]
           + (twoo2z)*(I2[1107] - (lpoz)*I3[1107])
           + (oneo2zn)*I4[867];
*(vp++) = U00*I0[1108] + U40*I1[1108]
           + (twoo2z)*(I2[1108] - (lpoz)*I3[1108]);
*(vp++) = U00*I0[1109] + U40*I1[1109]
           + (twoo2z)*(I2[1109] - (lpoz)*I3[1109]);
*(vp++) = U00*I0[1110] + U40*I1[1110]
           + (twoo2z)*(I2[1110] - (lpoz)*I3[1110]);
*(vp++) = U00*I0[1111] + U40*I1[1111]
           + (twoo2z)*(I2[1111] - (lpoz)*I3[1111]);
*(vp++) = U00*I0[1112] + U40*I1[1112]
           + (twoo2z)*(I2[1112] - (lpoz)*I3[1112]);
*(vp++) = U00*I0[1113] + U40*I1[1113]
           + (twoo2z)*(I2[1113] - (lpoz)*I3[1113]);
*(vp++) = U00*I0[1114] + U40*I1[1114]
           + (twoo2z)*(I2[1114] - (lpoz)*I3[1114]);
*(vp++) = U00*I0[1115] + U40*I1[1115]
           + (twoo2z)*(I2[1115] - (lpoz)*I3[1115]);
*(vp++) = U00*I0[1116] + U40*I1[1116]
           + (twoo2z)*(I2[1116] - (lpoz)*I3[1116])
           + (seveno2zn)*I4[868];
*(vp++) = U00*I0[1117] + U40*I1[1117]
           + (twoo2z)*(I2[1117] - (lpoz)*I3[1117])
           + (sixo2zn)*I4[869];
*(vp++) = U00*I0[1118] + U40*I1[1118]
           + (twoo2z)*(I2[1118] - (lpoz)*I3[1118])
           + (sixo2zn)*I4[870];
*(vp++) = U00*I0[1119] + U40*I1[1119]
           + (twoo2z)*(I2[1119] - (lpoz)*I3[1119])
           + (fiveo2zn)*I4[871];
*(vp++) = U00*I0[1120] + U40*I1[1120]
           + (twoo2z)*(I2[1120] - (lpoz)*I3[1120])
           + (fiveo2zn)*I4[872];
*(vp++) = U00*I0[1121] + U40*I1[1121]
           + (twoo2z)*(I2[1121] - (lpoz)*I3[1121])
           + (fiveo2zn)*I4[873];
*(vp++) = U00*I0[1122] + U40*I1[1122]
           + (twoo2z)*(I2[1122] - (lpoz)*I3[1122])
           + (fouro2zn)*I4[874];
*(vp++) = U00*I0[1123] + U40*I1[1123]
           + (twoo2z)*(I2[1123] - (lpoz)*I3[1123])
           + (fouro2zn)*I4[875];
*(vp++) = U00*I0[1124] + U40*I1[1124]
           + (twoo2z)*(I2[1124] - (lpoz)*I3[1124])
           + (fouro2zn)*I4[876];
*(vp++) = U00*I0[1125] + U40*I1[1125]
           + (twoo2z)*(I2[1125] - (lpoz)*I3[1125])
           + (fouro2zn)*I4[877];
*(vp++) = U00*I0[1126] + U40*I1[1126]
           + (twoo2z)*(I2[1126] - (lpoz)*I3[1126])
           + (threeo2zn)*I4[878];
*(vp++) = U00*I0[1127] + U40*I1[1127]
           + (twoo2z)*(I2[1127] - (lpoz)*I3[1127])
           + (threeo2zn)*I4[879];
*(vp++) = U00*I0[1128] + U40*I1[1128]
           + (twoo2z)*(I2[1128] - (lpoz)*I3[1128])
           + (threeo2zn)*I4[880];
*(vp++) = U00*I0[1129] + U40*I1[1129]
           + (twoo2z)*(I2[1129] - (lpoz)*I3[1129])
           + (threeo2zn)*I4[881];
*(vp++) = U00*I0[1130] + U40*I1[1130]
           + (twoo2z)*(I2[1130] - (lpoz)*I3[1130])
           + (threeo2zn)*I4[882];
*(vp++) = U00*I0[1131] + U40*I1[1131]
           + (twoo2z)*(I2[1131] - (lpoz)*I3[1131])
           + (twoo2zn)*I4[883];
*(vp++) = U00*I0[1132] + U40*I1[1132]
           + (twoo2z)*(I2[1132] - (lpoz)*I3[1132])
           + (twoo2zn)*I4[884];
*(vp++) = U00*I0[1133] + U40*I1[1133]
           + (twoo2z)*(I2[1133] - (lpoz)*I3[1133])
           + (twoo2zn)*I4[885];
*(vp++) = U00*I0[1134] + U40*I1[1134]
           + (twoo2z)*(I2[1134] - (lpoz)*I3[1134])
           + (twoo2zn)*I4[886];
*(vp++) = U00*I0[1135] + U40*I1[1135]
           + (twoo2z)*(I2[1135] - (lpoz)*I3[1135])
           + (twoo2zn)*I4[887];
*(vp++) = U00*I0[1136] + U40*I1[1136]
           + (twoo2z)*(I2[1136] - (lpoz)*I3[1136])
           + (twoo2zn)*I4[888];
*(vp++) = U00*I0[1137] + U40*I1[1137]
           + (twoo2z)*(I2[1137] - (lpoz)*I3[1137])
           + (oneo2zn)*I4[889];
*(vp++) = U00*I0[1138] + U40*I1[1138]
           + (twoo2z)*(I2[1138] - (lpoz)*I3[1138])
           + (oneo2zn)*I4[890];
*(vp++) = U00*I0[1139] + U40*I1[1139]
           + (twoo2z)*(I2[1139] - (lpoz)*I3[1139])
           + (oneo2zn)*I4[891];
*(vp++) = U00*I0[1140] + U40*I1[1140]
           + (twoo2z)*(I2[1140] - (lpoz)*I3[1140])
           + (oneo2zn)*I4[892];
*(vp++) = U00*I0[1141] + U40*I1[1141]
           + (twoo2z)*(I2[1141] - (lpoz)*I3[1141])
           + (oneo2zn)*I4[893];
*(vp++) = U00*I0[1142] + U40*I1[1142]
           + (twoo2z)*(I2[1142] - (lpoz)*I3[1142])
           + (oneo2zn)*I4[894];
*(vp++) = U00*I0[1143] + U40*I1[1143]
           + (twoo2z)*(I2[1143] - (lpoz)*I3[1143])
           + (oneo2zn)*I4[895];
*(vp++) = U00*I0[1144] + U40*I1[1144]
           + (twoo2z)*(I2[1144] - (lpoz)*I3[1144]);
*(vp++) = U00*I0[1145] + U40*I1[1145]
           + (twoo2z)*(I2[1145] - (lpoz)*I3[1145]);
*(vp++) = U00*I0[1146] + U40*I1[1146]
           + (twoo2z)*(I2[1146] - (lpoz)*I3[1146]);
*(vp++) = U00*I0[1147] + U40*I1[1147]
           + (twoo2z)*(I2[1147] - (lpoz)*I3[1147]);
*(vp++) = U00*I0[1148] + U40*I1[1148]
           + (twoo2z)*(I2[1148] - (lpoz)*I3[1148]);
*(vp++) = U00*I0[1149] + U40*I1[1149]
           + (twoo2z)*(I2[1149] - (lpoz)*I3[1149]);
*(vp++) = U00*I0[1150] + U40*I1[1150]
           + (twoo2z)*(I2[1150] - (lpoz)*I3[1150]);
*(vp++) = U00*I0[1151] + U40*I1[1151]
           + (twoo2z)*(I2[1151] - (lpoz)*I3[1151]);
*(vp++) = U00*I0[1152] + U40*I1[1152]
           + (twoo2z)*(I2[1152] - (lpoz)*I3[1152])
           + (seveno2zn)*I4[896];
*(vp++) = U00*I0[1153] + U40*I1[1153]
           + (twoo2z)*(I2[1153] - (lpoz)*I3[1153])
           + (sixo2zn)*I4[897];
*(vp++) = U00*I0[1154] + U40*I1[1154]
           + (twoo2z)*(I2[1154] - (lpoz)*I3[1154])
           + (sixo2zn)*I4[898];
*(vp++) = U00*I0[1155] + U40*I1[1155]
           + (twoo2z)*(I2[1155] - (lpoz)*I3[1155])
           + (fiveo2zn)*I4[899];
*(vp++) = U00*I0[1156] + U40*I1[1156]
           + (twoo2z)*(I2[1156] - (lpoz)*I3[1156])
           + (fiveo2zn)*I4[900];
*(vp++) = U00*I0[1157] + U40*I1[1157]
           + (twoo2z)*(I2[1157] - (lpoz)*I3[1157])
           + (fiveo2zn)*I4[901];
*(vp++) = U00*I0[1158] + U40*I1[1158]
           + (twoo2z)*(I2[1158] - (lpoz)*I3[1158])
           + (fouro2zn)*I4[902];
*(vp++) = U00*I0[1159] + U40*I1[1159]
           + (twoo2z)*(I2[1159] - (lpoz)*I3[1159])
           + (fouro2zn)*I4[903];
*(vp++) = U00*I0[1160] + U40*I1[1160]
           + (twoo2z)*(I2[1160] - (lpoz)*I3[1160])
           + (fouro2zn)*I4[904];
*(vp++) = U00*I0[1161] + U40*I1[1161]
           + (twoo2z)*(I2[1161] - (lpoz)*I3[1161])
           + (fouro2zn)*I4[905];
*(vp++) = U00*I0[1162] + U40*I1[1162]
           + (twoo2z)*(I2[1162] - (lpoz)*I3[1162])
           + (threeo2zn)*I4[906];
*(vp++) = U00*I0[1163] + U40*I1[1163]
           + (twoo2z)*(I2[1163] - (lpoz)*I3[1163])
           + (threeo2zn)*I4[907];
*(vp++) = U00*I0[1164] + U40*I1[1164]
           + (twoo2z)*(I2[1164] - (lpoz)*I3[1164])
           + (threeo2zn)*I4[908];
*(vp++) = U00*I0[1165] + U40*I1[1165]
           + (twoo2z)*(I2[1165] - (lpoz)*I3[1165])
           + (threeo2zn)*I4[909];
*(vp++) = U00*I0[1166] + U40*I1[1166]
           + (twoo2z)*(I2[1166] - (lpoz)*I3[1166])
           + (threeo2zn)*I4[910];
*(vp++) = U00*I0[1167] + U40*I1[1167]
           + (twoo2z)*(I2[1167] - (lpoz)*I3[1167])
           + (twoo2zn)*I4[911];
*(vp++) = U00*I0[1168] + U40*I1[1168]
           + (twoo2z)*(I2[1168] - (lpoz)*I3[1168])
           + (twoo2zn)*I4[912];
*(vp++) = U00*I0[1169] + U40*I1[1169]
           + (twoo2z)*(I2[1169] - (lpoz)*I3[1169])
           + (twoo2zn)*I4[913];
*(vp++) = U00*I0[1170] + U40*I1[1170]
           + (twoo2z)*(I2[1170] - (lpoz)*I3[1170])
           + (twoo2zn)*I4[914];
*(vp++) = U00*I0[1171] + U40*I1[1171]
           + (twoo2z)*(I2[1171] - (lpoz)*I3[1171])
           + (twoo2zn)*I4[915];
*(vp++) = U00*I0[1172] + U40*I1[1172]
           + (twoo2z)*(I2[1172] - (lpoz)*I3[1172])
           + (twoo2zn)*I4[916];
*(vp++) = U00*I0[1173] + U40*I1[1173]
           + (twoo2z)*(I2[1173] - (lpoz)*I3[1173])
           + (oneo2zn)*I4[917];
*(vp++) = U00*I0[1174] + U40*I1[1174]
           + (twoo2z)*(I2[1174] - (lpoz)*I3[1174])
           + (oneo2zn)*I4[918];
*(vp++) = U00*I0[1175] + U40*I1[1175]
           + (twoo2z)*(I2[1175] - (lpoz)*I3[1175])
           + (oneo2zn)*I4[919];
*(vp++) = U00*I0[1176] + U40*I1[1176]
           + (twoo2z)*(I2[1176] - (lpoz)*I3[1176])
           + (oneo2zn)*I4[920];
*(vp++) = U00*I0[1177] + U40*I1[1177]
           + (twoo2z)*(I2[1177] - (lpoz)*I3[1177])
           + (oneo2zn)*I4[921];
*(vp++) = U00*I0[1178] + U40*I1[1178]
           + (twoo2z)*(I2[1178] - (lpoz)*I3[1178])
           + (oneo2zn)*I4[922];
*(vp++) = U00*I0[1179] + U40*I1[1179]
           + (twoo2z)*(I2[1179] - (lpoz)*I3[1179])
           + (oneo2zn)*I4[923];
*(vp++) = U00*I0[1180] + U40*I1[1180]
           + (twoo2z)*(I2[1180] - (lpoz)*I3[1180]);
*(vp++) = U00*I0[1181] + U40*I1[1181]
           + (twoo2z)*(I2[1181] - (lpoz)*I3[1181]);
*(vp++) = U00*I0[1182] + U40*I1[1182]
           + (twoo2z)*(I2[1182] - (lpoz)*I3[1182]);
*(vp++) = U00*I0[1183] + U40*I1[1183]
           + (twoo2z)*(I2[1183] - (lpoz)*I3[1183]);
*(vp++) = U00*I0[1184] + U40*I1[1184]
           + (twoo2z)*(I2[1184] - (lpoz)*I3[1184]);
*(vp++) = U00*I0[1185] + U40*I1[1185]
           + (twoo2z)*(I2[1185] - (lpoz)*I3[1185]);
*(vp++) = U00*I0[1186] + U40*I1[1186]
           + (twoo2z)*(I2[1186] - (lpoz)*I3[1186]);
*(vp++) = U00*I0[1187] + U40*I1[1187]
           + (twoo2z)*(I2[1187] - (lpoz)*I3[1187]);
*(vp++) = U00*I0[1188] + U40*I1[1188]
           + (twoo2z)*(I2[1188] - (lpoz)*I3[1188])
           + (seveno2zn)*I4[924];
*(vp++) = U00*I0[1189] + U40*I1[1189]
           + (twoo2z)*(I2[1189] - (lpoz)*I3[1189])
           + (sixo2zn)*I4[925];
*(vp++) = U00*I0[1190] + U40*I1[1190]
           + (twoo2z)*(I2[1190] - (lpoz)*I3[1190])
           + (sixo2zn)*I4[926];
*(vp++) = U00*I0[1191] + U40*I1[1191]
           + (twoo2z)*(I2[1191] - (lpoz)*I3[1191])
           + (fiveo2zn)*I4[927];
return vp;
}

REALTYPE *_build_n0k0_4(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[1192] + U40*I1[1192]
           + (twoo2z)*(I2[1192] - (lpoz)*I3[1192])
           + (fiveo2zn)*I4[928];
*(vp++) = U00*I0[1193] + U40*I1[1193]
           + (twoo2z)*(I2[1193] - (lpoz)*I3[1193])
           + (fiveo2zn)*I4[929];
*(vp++) = U00*I0[1194] + U40*I1[1194]
           + (twoo2z)*(I2[1194] - (lpoz)*I3[1194])
           + (fouro2zn)*I4[930];
*(vp++) = U00*I0[1195] + U40*I1[1195]
           + (twoo2z)*(I2[1195] - (lpoz)*I3[1195])
           + (fouro2zn)*I4[931];
*(vp++) = U00*I0[1196] + U40*I1[1196]
           + (twoo2z)*(I2[1196] - (lpoz)*I3[1196])
           + (fouro2zn)*I4[932];
*(vp++) = U00*I0[1197] + U40*I1[1197]
           + (twoo2z)*(I2[1197] - (lpoz)*I3[1197])
           + (fouro2zn)*I4[933];
*(vp++) = U00*I0[1198] + U40*I1[1198]
           + (twoo2z)*(I2[1198] - (lpoz)*I3[1198])
           + (threeo2zn)*I4[934];
*(vp++) = U00*I0[1199] + U40*I1[1199]
           + (twoo2z)*(I2[1199] - (lpoz)*I3[1199])
           + (threeo2zn)*I4[935];
*(vp++) = U00*I0[1200] + U40*I1[1200]
           + (twoo2z)*(I2[1200] - (lpoz)*I3[1200])
           + (threeo2zn)*I4[936];
*(vp++) = U00*I0[1201] + U40*I1[1201]
           + (twoo2z)*(I2[1201] - (lpoz)*I3[1201])
           + (threeo2zn)*I4[937];
*(vp++) = U00*I0[1202] + U40*I1[1202]
           + (twoo2z)*(I2[1202] - (lpoz)*I3[1202])
           + (threeo2zn)*I4[938];
*(vp++) = U00*I0[1203] + U40*I1[1203]
           + (twoo2z)*(I2[1203] - (lpoz)*I3[1203])
           + (twoo2zn)*I4[939];
*(vp++) = U00*I0[1204] + U40*I1[1204]
           + (twoo2z)*(I2[1204] - (lpoz)*I3[1204])
           + (twoo2zn)*I4[940];
*(vp++) = U00*I0[1205] + U40*I1[1205]
           + (twoo2z)*(I2[1205] - (lpoz)*I3[1205])
           + (twoo2zn)*I4[941];
*(vp++) = U00*I0[1206] + U40*I1[1206]
           + (twoo2z)*(I2[1206] - (lpoz)*I3[1206])
           + (twoo2zn)*I4[942];
*(vp++) = U00*I0[1207] + U40*I1[1207]
           + (twoo2z)*(I2[1207] - (lpoz)*I3[1207])
           + (twoo2zn)*I4[943];
*(vp++) = U00*I0[1208] + U40*I1[1208]
           + (twoo2z)*(I2[1208] - (lpoz)*I3[1208])
           + (twoo2zn)*I4[944];
*(vp++) = U00*I0[1209] + U40*I1[1209]
           + (twoo2z)*(I2[1209] - (lpoz)*I3[1209])
           + (oneo2zn)*I4[945];
*(vp++) = U00*I0[1210] + U40*I1[1210]
           + (twoo2z)*(I2[1210] - (lpoz)*I3[1210])
           + (oneo2zn)*I4[946];
*(vp++) = U00*I0[1211] + U40*I1[1211]
           + (twoo2z)*(I2[1211] - (lpoz)*I3[1211])
           + (oneo2zn)*I4[947];
*(vp++) = U00*I0[1212] + U40*I1[1212]
           + (twoo2z)*(I2[1212] - (lpoz)*I3[1212])
           + (oneo2zn)*I4[948];
*(vp++) = U00*I0[1213] + U40*I1[1213]
           + (twoo2z)*(I2[1213] - (lpoz)*I3[1213])
           + (oneo2zn)*I4[949];
*(vp++) = U00*I0[1214] + U40*I1[1214]
           + (twoo2z)*(I2[1214] - (lpoz)*I3[1214])
           + (oneo2zn)*I4[950];
*(vp++) = U00*I0[1215] + U40*I1[1215]
           + (twoo2z)*(I2[1215] - (lpoz)*I3[1215])
           + (oneo2zn)*I4[951];
*(vp++) = U00*I0[1216] + U40*I1[1216]
           + (twoo2z)*(I2[1216] - (lpoz)*I3[1216]);
*(vp++) = U00*I0[1217] + U40*I1[1217]
           + (twoo2z)*(I2[1217] - (lpoz)*I3[1217]);
*(vp++) = U00*I0[1218] + U40*I1[1218]
           + (twoo2z)*(I2[1218] - (lpoz)*I3[1218]);
*(vp++) = U00*I0[1219] + U40*I1[1219]
           + (twoo2z)*(I2[1219] - (lpoz)*I3[1219]);
*(vp++) = U00*I0[1220] + U40*I1[1220]
           + (twoo2z)*(I2[1220] - (lpoz)*I3[1220]);
*(vp++) = U00*I0[1221] + U40*I1[1221]
           + (twoo2z)*(I2[1221] - (lpoz)*I3[1221]);
*(vp++) = U00*I0[1222] + U40*I1[1222]
           + (twoo2z)*(I2[1222] - (lpoz)*I3[1222]);
*(vp++) = U00*I0[1223] + U40*I1[1223]
           + (twoo2z)*(I2[1223] - (lpoz)*I3[1223]);
*(vp++) = U00*I0[1224] + U40*I1[1224]
           + (twoo2z)*(I2[1224] - (lpoz)*I3[1224])
           + (seveno2zn)*I4[952];
*(vp++) = U00*I0[1225] + U40*I1[1225]
           + (twoo2z)*(I2[1225] - (lpoz)*I3[1225])
           + (sixo2zn)*I4[953];
*(vp++) = U00*I0[1226] + U40*I1[1226]
           + (twoo2z)*(I2[1226] - (lpoz)*I3[1226])
           + (sixo2zn)*I4[954];
*(vp++) = U00*I0[1227] + U40*I1[1227]
           + (twoo2z)*(I2[1227] - (lpoz)*I3[1227])
           + (fiveo2zn)*I4[955];
*(vp++) = U00*I0[1228] + U40*I1[1228]
           + (twoo2z)*(I2[1228] - (lpoz)*I3[1228])
           + (fiveo2zn)*I4[956];
*(vp++) = U00*I0[1229] + U40*I1[1229]
           + (twoo2z)*(I2[1229] - (lpoz)*I3[1229])
           + (fiveo2zn)*I4[957];
*(vp++) = U00*I0[1230] + U40*I1[1230]
           + (twoo2z)*(I2[1230] - (lpoz)*I3[1230])
           + (fouro2zn)*I4[958];
*(vp++) = U00*I0[1231] + U40*I1[1231]
           + (twoo2z)*(I2[1231] - (lpoz)*I3[1231])
           + (fouro2zn)*I4[959];
*(vp++) = U00*I0[1232] + U40*I1[1232]
           + (twoo2z)*(I2[1232] - (lpoz)*I3[1232])
           + (fouro2zn)*I4[960];
*(vp++) = U00*I0[1233] + U40*I1[1233]
           + (twoo2z)*(I2[1233] - (lpoz)*I3[1233])
           + (fouro2zn)*I4[961];
*(vp++) = U00*I0[1234] + U40*I1[1234]
           + (twoo2z)*(I2[1234] - (lpoz)*I3[1234])
           + (threeo2zn)*I4[962];
*(vp++) = U00*I0[1235] + U40*I1[1235]
           + (twoo2z)*(I2[1235] - (lpoz)*I3[1235])
           + (threeo2zn)*I4[963];
*(vp++) = U00*I0[1236] + U40*I1[1236]
           + (twoo2z)*(I2[1236] - (lpoz)*I3[1236])
           + (threeo2zn)*I4[964];
*(vp++) = U00*I0[1237] + U40*I1[1237]
           + (twoo2z)*(I2[1237] - (lpoz)*I3[1237])
           + (threeo2zn)*I4[965];
*(vp++) = U00*I0[1238] + U40*I1[1238]
           + (twoo2z)*(I2[1238] - (lpoz)*I3[1238])
           + (threeo2zn)*I4[966];
*(vp++) = U00*I0[1239] + U40*I1[1239]
           + (twoo2z)*(I2[1239] - (lpoz)*I3[1239])
           + (twoo2zn)*I4[967];
*(vp++) = U00*I0[1240] + U40*I1[1240]
           + (twoo2z)*(I2[1240] - (lpoz)*I3[1240])
           + (twoo2zn)*I4[968];
*(vp++) = U00*I0[1241] + U40*I1[1241]
           + (twoo2z)*(I2[1241] - (lpoz)*I3[1241])
           + (twoo2zn)*I4[969];
*(vp++) = U00*I0[1242] + U40*I1[1242]
           + (twoo2z)*(I2[1242] - (lpoz)*I3[1242])
           + (twoo2zn)*I4[970];
*(vp++) = U00*I0[1243] + U40*I1[1243]
           + (twoo2z)*(I2[1243] - (lpoz)*I3[1243])
           + (twoo2zn)*I4[971];
*(vp++) = U00*I0[1244] + U40*I1[1244]
           + (twoo2z)*(I2[1244] - (lpoz)*I3[1244])
           + (twoo2zn)*I4[972];
*(vp++) = U00*I0[1245] + U40*I1[1245]
           + (twoo2z)*(I2[1245] - (lpoz)*I3[1245])
           + (oneo2zn)*I4[973];
*(vp++) = U00*I0[1246] + U40*I1[1246]
           + (twoo2z)*(I2[1246] - (lpoz)*I3[1246])
           + (oneo2zn)*I4[974];
*(vp++) = U00*I0[1247] + U40*I1[1247]
           + (twoo2z)*(I2[1247] - (lpoz)*I3[1247])
           + (oneo2zn)*I4[975];
*(vp++) = U00*I0[1248] + U40*I1[1248]
           + (twoo2z)*(I2[1248] - (lpoz)*I3[1248])
           + (oneo2zn)*I4[976];
*(vp++) = U00*I0[1249] + U40*I1[1249]
           + (twoo2z)*(I2[1249] - (lpoz)*I3[1249])
           + (oneo2zn)*I4[977];
*(vp++) = U00*I0[1250] + U40*I1[1250]
           + (twoo2z)*(I2[1250] - (lpoz)*I3[1250])
           + (oneo2zn)*I4[978];
*(vp++) = U00*I0[1251] + U40*I1[1251]
           + (twoo2z)*(I2[1251] - (lpoz)*I3[1251])
           + (oneo2zn)*I4[979];
*(vp++) = U00*I0[1252] + U40*I1[1252]
           + (twoo2z)*(I2[1252] - (lpoz)*I3[1252]);
*(vp++) = U00*I0[1253] + U40*I1[1253]
           + (twoo2z)*(I2[1253] - (lpoz)*I3[1253]);
*(vp++) = U00*I0[1254] + U40*I1[1254]
           + (twoo2z)*(I2[1254] - (lpoz)*I3[1254]);
*(vp++) = U00*I0[1255] + U40*I1[1255]
           + (twoo2z)*(I2[1255] - (lpoz)*I3[1255]);
*(vp++) = U00*I0[1256] + U40*I1[1256]
           + (twoo2z)*(I2[1256] - (lpoz)*I3[1256]);
*(vp++) = U00*I0[1257] + U40*I1[1257]
           + (twoo2z)*(I2[1257] - (lpoz)*I3[1257]);
*(vp++) = U00*I0[1258] + U40*I1[1258]
           + (twoo2z)*(I2[1258] - (lpoz)*I3[1258]);
*(vp++) = U00*I0[1259] + U40*I1[1259]
           + (twoo2z)*(I2[1259] - (lpoz)*I3[1259]);
*(vp++) = U00*I0[1260] + U40*I1[1260]
           + (twoo2z)*(I2[1260] - (lpoz)*I3[1260])
           + (seveno2zn)*I4[980];
*(vp++) = U00*I0[1261] + U40*I1[1261]
           + (twoo2z)*(I2[1261] - (lpoz)*I3[1261])
           + (sixo2zn)*I4[981];
*(vp++) = U00*I0[1262] + U40*I1[1262]
           + (twoo2z)*(I2[1262] - (lpoz)*I3[1262])
           + (sixo2zn)*I4[982];
*(vp++) = U00*I0[1263] + U40*I1[1263]
           + (twoo2z)*(I2[1263] - (lpoz)*I3[1263])
           + (fiveo2zn)*I4[983];
*(vp++) = U00*I0[1264] + U40*I1[1264]
           + (twoo2z)*(I2[1264] - (lpoz)*I3[1264])
           + (fiveo2zn)*I4[984];
*(vp++) = U00*I0[1265] + U40*I1[1265]
           + (twoo2z)*(I2[1265] - (lpoz)*I3[1265])
           + (fiveo2zn)*I4[985];
*(vp++) = U00*I0[1266] + U40*I1[1266]
           + (twoo2z)*(I2[1266] - (lpoz)*I3[1266])
           + (fouro2zn)*I4[986];
*(vp++) = U00*I0[1267] + U40*I1[1267]
           + (twoo2z)*(I2[1267] - (lpoz)*I3[1267])
           + (fouro2zn)*I4[987];
*(vp++) = U00*I0[1268] + U40*I1[1268]
           + (twoo2z)*(I2[1268] - (lpoz)*I3[1268])
           + (fouro2zn)*I4[988];
*(vp++) = U00*I0[1269] + U40*I1[1269]
           + (twoo2z)*(I2[1269] - (lpoz)*I3[1269])
           + (fouro2zn)*I4[989];
*(vp++) = U00*I0[1270] + U40*I1[1270]
           + (twoo2z)*(I2[1270] - (lpoz)*I3[1270])
           + (threeo2zn)*I4[990];
*(vp++) = U00*I0[1271] + U40*I1[1271]
           + (twoo2z)*(I2[1271] - (lpoz)*I3[1271])
           + (threeo2zn)*I4[991];
*(vp++) = U00*I0[1272] + U40*I1[1272]
           + (twoo2z)*(I2[1272] - (lpoz)*I3[1272])
           + (threeo2zn)*I4[992];
*(vp++) = U00*I0[1273] + U40*I1[1273]
           + (twoo2z)*(I2[1273] - (lpoz)*I3[1273])
           + (threeo2zn)*I4[993];
*(vp++) = U00*I0[1274] + U40*I1[1274]
           + (twoo2z)*(I2[1274] - (lpoz)*I3[1274])
           + (threeo2zn)*I4[994];
*(vp++) = U00*I0[1275] + U40*I1[1275]
           + (twoo2z)*(I2[1275] - (lpoz)*I3[1275])
           + (twoo2zn)*I4[995];
*(vp++) = U00*I0[1276] + U40*I1[1276]
           + (twoo2z)*(I2[1276] - (lpoz)*I3[1276])
           + (twoo2zn)*I4[996];
*(vp++) = U00*I0[1277] + U40*I1[1277]
           + (twoo2z)*(I2[1277] - (lpoz)*I3[1277])
           + (twoo2zn)*I4[997];
*(vp++) = U00*I0[1278] + U40*I1[1278]
           + (twoo2z)*(I2[1278] - (lpoz)*I3[1278])
           + (twoo2zn)*I4[998];
*(vp++) = U00*I0[1279] + U40*I1[1279]
           + (twoo2z)*(I2[1279] - (lpoz)*I3[1279])
           + (twoo2zn)*I4[999];
*(vp++) = U00*I0[1280] + U40*I1[1280]
           + (twoo2z)*(I2[1280] - (lpoz)*I3[1280])
           + (twoo2zn)*I4[1000];
*(vp++) = U00*I0[1281] + U40*I1[1281]
           + (twoo2z)*(I2[1281] - (lpoz)*I3[1281])
           + (oneo2zn)*I4[1001];
*(vp++) = U00*I0[1282] + U40*I1[1282]
           + (twoo2z)*(I2[1282] - (lpoz)*I3[1282])
           + (oneo2zn)*I4[1002];
*(vp++) = U00*I0[1283] + U40*I1[1283]
           + (twoo2z)*(I2[1283] - (lpoz)*I3[1283])
           + (oneo2zn)*I4[1003];
*(vp++) = U00*I0[1284] + U40*I1[1284]
           + (twoo2z)*(I2[1284] - (lpoz)*I3[1284])
           + (oneo2zn)*I4[1004];
*(vp++) = U00*I0[1285] + U40*I1[1285]
           + (twoo2z)*(I2[1285] - (lpoz)*I3[1285])
           + (oneo2zn)*I4[1005];
*(vp++) = U00*I0[1286] + U40*I1[1286]
           + (twoo2z)*(I2[1286] - (lpoz)*I3[1286])
           + (oneo2zn)*I4[1006];
*(vp++) = U00*I0[1287] + U40*I1[1287]
           + (twoo2z)*(I2[1287] - (lpoz)*I3[1287])
           + (oneo2zn)*I4[1007];
*(vp++) = U00*I0[1288] + U40*I1[1288]
           + (twoo2z)*(I2[1288] - (lpoz)*I3[1288]);
*(vp++) = U00*I0[1289] + U40*I1[1289]
           + (twoo2z)*(I2[1289] - (lpoz)*I3[1289]);
*(vp++) = U00*I0[1290] + U40*I1[1290]
           + (twoo2z)*(I2[1290] - (lpoz)*I3[1290]);
*(vp++) = U00*I0[1291] + U40*I1[1291]
           + (twoo2z)*(I2[1291] - (lpoz)*I3[1291]);
*(vp++) = U00*I0[1292] + U40*I1[1292]
           + (twoo2z)*(I2[1292] - (lpoz)*I3[1292]);
*(vp++) = U00*I0[1293] + U40*I1[1293]
           + (twoo2z)*(I2[1293] - (lpoz)*I3[1293]);
*(vp++) = U00*I0[1294] + U40*I1[1294]
           + (twoo2z)*(I2[1294] - (lpoz)*I3[1294]);
*(vp++) = U00*I0[1295] + U40*I1[1295]
           + (twoo2z)*(I2[1295] - (lpoz)*I3[1295]);
*(vp++) = U00*I0[1296] + U40*I1[1296]
           + (oneo2z)*(I2[1296] - (lpoz)*I3[1296])
           + (seveno2zn)*I4[1008];
*(vp++) = U00*I0[1297] + U40*I1[1297]
           + (oneo2z)*(I2[1297] - (lpoz)*I3[1297])
           + (sixo2zn)*I4[1009];
*(vp++) = U00*I0[1298] + U40*I1[1298]
           + (oneo2z)*(I2[1298] - (lpoz)*I3[1298])
           + (sixo2zn)*I4[1010];
*(vp++) = U00*I0[1299] + U40*I1[1299]
           + (oneo2z)*(I2[1299] - (lpoz)*I3[1299])
           + (fiveo2zn)*I4[1011];
*(vp++) = U00*I0[1300] + U40*I1[1300]
           + (oneo2z)*(I2[1300] - (lpoz)*I3[1300])
           + (fiveo2zn)*I4[1012];
*(vp++) = U00*I0[1301] + U40*I1[1301]
           + (oneo2z)*(I2[1301] - (lpoz)*I3[1301])
           + (fiveo2zn)*I4[1013];
*(vp++) = U00*I0[1302] + U40*I1[1302]
           + (oneo2z)*(I2[1302] - (lpoz)*I3[1302])
           + (fouro2zn)*I4[1014];
*(vp++) = U00*I0[1303] + U40*I1[1303]
           + (oneo2z)*(I2[1303] - (lpoz)*I3[1303])
           + (fouro2zn)*I4[1015];
*(vp++) = U00*I0[1304] + U40*I1[1304]
           + (oneo2z)*(I2[1304] - (lpoz)*I3[1304])
           + (fouro2zn)*I4[1016];
*(vp++) = U00*I0[1305] + U40*I1[1305]
           + (oneo2z)*(I2[1305] - (lpoz)*I3[1305])
           + (fouro2zn)*I4[1017];
*(vp++) = U00*I0[1306] + U40*I1[1306]
           + (oneo2z)*(I2[1306] - (lpoz)*I3[1306])
           + (threeo2zn)*I4[1018];
*(vp++) = U00*I0[1307] + U40*I1[1307]
           + (oneo2z)*(I2[1307] - (lpoz)*I3[1307])
           + (threeo2zn)*I4[1019];
*(vp++) = U00*I0[1308] + U40*I1[1308]
           + (oneo2z)*(I2[1308] - (lpoz)*I3[1308])
           + (threeo2zn)*I4[1020];
*(vp++) = U00*I0[1309] + U40*I1[1309]
           + (oneo2z)*(I2[1309] - (lpoz)*I3[1309])
           + (threeo2zn)*I4[1021];
*(vp++) = U00*I0[1310] + U40*I1[1310]
           + (oneo2z)*(I2[1310] - (lpoz)*I3[1310])
           + (threeo2zn)*I4[1022];
*(vp++) = U00*I0[1311] + U40*I1[1311]
           + (oneo2z)*(I2[1311] - (lpoz)*I3[1311])
           + (twoo2zn)*I4[1023];
*(vp++) = U00*I0[1312] + U40*I1[1312]
           + (oneo2z)*(I2[1312] - (lpoz)*I3[1312])
           + (twoo2zn)*I4[1024];
*(vp++) = U00*I0[1313] + U40*I1[1313]
           + (oneo2z)*(I2[1313] - (lpoz)*I3[1313])
           + (twoo2zn)*I4[1025];
*(vp++) = U00*I0[1314] + U40*I1[1314]
           + (oneo2z)*(I2[1314] - (lpoz)*I3[1314])
           + (twoo2zn)*I4[1026];
*(vp++) = U00*I0[1315] + U40*I1[1315]
           + (oneo2z)*(I2[1315] - (lpoz)*I3[1315])
           + (twoo2zn)*I4[1027];
*(vp++) = U00*I0[1316] + U40*I1[1316]
           + (oneo2z)*(I2[1316] - (lpoz)*I3[1316])
           + (twoo2zn)*I4[1028];
*(vp++) = U00*I0[1317] + U40*I1[1317]
           + (oneo2z)*(I2[1317] - (lpoz)*I3[1317])
           + (oneo2zn)*I4[1029];
*(vp++) = U00*I0[1318] + U40*I1[1318]
           + (oneo2z)*(I2[1318] - (lpoz)*I3[1318])
           + (oneo2zn)*I4[1030];
*(vp++) = U00*I0[1319] + U40*I1[1319]
           + (oneo2z)*(I2[1319] - (lpoz)*I3[1319])
           + (oneo2zn)*I4[1031];
*(vp++) = U00*I0[1320] + U40*I1[1320]
           + (oneo2z)*(I2[1320] - (lpoz)*I3[1320])
           + (oneo2zn)*I4[1032];
*(vp++) = U00*I0[1321] + U40*I1[1321]
           + (oneo2z)*(I2[1321] - (lpoz)*I3[1321])
           + (oneo2zn)*I4[1033];
*(vp++) = U00*I0[1322] + U40*I1[1322]
           + (oneo2z)*(I2[1322] - (lpoz)*I3[1322])
           + (oneo2zn)*I4[1034];
*(vp++) = U00*I0[1323] + U40*I1[1323]
           + (oneo2z)*(I2[1323] - (lpoz)*I3[1323])
           + (oneo2zn)*I4[1035];
*(vp++) = U00*I0[1324] + U40*I1[1324]
           + (oneo2z)*(I2[1324] - (lpoz)*I3[1324]);
*(vp++) = U00*I0[1325] + U40*I1[1325]
           + (oneo2z)*(I2[1325] - (lpoz)*I3[1325]);
*(vp++) = U00*I0[1326] + U40*I1[1326]
           + (oneo2z)*(I2[1326] - (lpoz)*I3[1326]);
*(vp++) = U00*I0[1327] + U40*I1[1327]
           + (oneo2z)*(I2[1327] - (lpoz)*I3[1327]);
*(vp++) = U00*I0[1328] + U40*I1[1328]
           + (oneo2z)*(I2[1328] - (lpoz)*I3[1328]);
*(vp++) = U00*I0[1329] + U40*I1[1329]
           + (oneo2z)*(I2[1329] - (lpoz)*I3[1329]);
*(vp++) = U00*I0[1330] + U40*I1[1330]
           + (oneo2z)*(I2[1330] - (lpoz)*I3[1330]);
*(vp++) = U00*I0[1331] + U40*I1[1331]
           + (oneo2z)*(I2[1331] - (lpoz)*I3[1331]);
*(vp++) = U00*I0[1332] + U40*I1[1332]
           + (oneo2z)*(I2[1332] - (lpoz)*I3[1332])
           + (seveno2zn)*I4[1036];
*(vp++) = U00*I0[1333] + U40*I1[1333]
           + (oneo2z)*(I2[1333] - (lpoz)*I3[1333])
           + (sixo2zn)*I4[1037];
*(vp++) = U00*I0[1334] + U40*I1[1334]
           + (oneo2z)*(I2[1334] - (lpoz)*I3[1334])
           + (sixo2zn)*I4[1038];
*(vp++) = U00*I0[1335] + U40*I1[1335]
           + (oneo2z)*(I2[1335] - (lpoz)*I3[1335])
           + (fiveo2zn)*I4[1039];
*(vp++) = U00*I0[1336] + U40*I1[1336]
           + (oneo2z)*(I2[1336] - (lpoz)*I3[1336])
           + (fiveo2zn)*I4[1040];
*(vp++) = U00*I0[1337] + U40*I1[1337]
           + (oneo2z)*(I2[1337] - (lpoz)*I3[1337])
           + (fiveo2zn)*I4[1041];
*(vp++) = U00*I0[1338] + U40*I1[1338]
           + (oneo2z)*(I2[1338] - (lpoz)*I3[1338])
           + (fouro2zn)*I4[1042];
*(vp++) = U00*I0[1339] + U40*I1[1339]
           + (oneo2z)*(I2[1339] - (lpoz)*I3[1339])
           + (fouro2zn)*I4[1043];
*(vp++) = U00*I0[1340] + U40*I1[1340]
           + (oneo2z)*(I2[1340] - (lpoz)*I3[1340])
           + (fouro2zn)*I4[1044];
*(vp++) = U00*I0[1341] + U40*I1[1341]
           + (oneo2z)*(I2[1341] - (lpoz)*I3[1341])
           + (fouro2zn)*I4[1045];
*(vp++) = U00*I0[1342] + U40*I1[1342]
           + (oneo2z)*(I2[1342] - (lpoz)*I3[1342])
           + (threeo2zn)*I4[1046];
*(vp++) = U00*I0[1343] + U40*I1[1343]
           + (oneo2z)*(I2[1343] - (lpoz)*I3[1343])
           + (threeo2zn)*I4[1047];
*(vp++) = U00*I0[1344] + U40*I1[1344]
           + (oneo2z)*(I2[1344] - (lpoz)*I3[1344])
           + (threeo2zn)*I4[1048];
*(vp++) = U00*I0[1345] + U40*I1[1345]
           + (oneo2z)*(I2[1345] - (lpoz)*I3[1345])
           + (threeo2zn)*I4[1049];
*(vp++) = U00*I0[1346] + U40*I1[1346]
           + (oneo2z)*(I2[1346] - (lpoz)*I3[1346])
           + (threeo2zn)*I4[1050];
*(vp++) = U00*I0[1347] + U40*I1[1347]
           + (oneo2z)*(I2[1347] - (lpoz)*I3[1347])
           + (twoo2zn)*I4[1051];
*(vp++) = U00*I0[1348] + U40*I1[1348]
           + (oneo2z)*(I2[1348] - (lpoz)*I3[1348])
           + (twoo2zn)*I4[1052];
*(vp++) = U00*I0[1349] + U40*I1[1349]
           + (oneo2z)*(I2[1349] - (lpoz)*I3[1349])
           + (twoo2zn)*I4[1053];
*(vp++) = U00*I0[1350] + U40*I1[1350]
           + (oneo2z)*(I2[1350] - (lpoz)*I3[1350])
           + (twoo2zn)*I4[1054];
*(vp++) = U00*I0[1351] + U40*I1[1351]
           + (oneo2z)*(I2[1351] - (lpoz)*I3[1351])
           + (twoo2zn)*I4[1055];
*(vp++) = U00*I0[1352] + U40*I1[1352]
           + (oneo2z)*(I2[1352] - (lpoz)*I3[1352])
           + (twoo2zn)*I4[1056];
*(vp++) = U00*I0[1353] + U40*I1[1353]
           + (oneo2z)*(I2[1353] - (lpoz)*I3[1353])
           + (oneo2zn)*I4[1057];
*(vp++) = U00*I0[1354] + U40*I1[1354]
           + (oneo2z)*(I2[1354] - (lpoz)*I3[1354])
           + (oneo2zn)*I4[1058];
*(vp++) = U00*I0[1355] + U40*I1[1355]
           + (oneo2z)*(I2[1355] - (lpoz)*I3[1355])
           + (oneo2zn)*I4[1059];
*(vp++) = U00*I0[1356] + U40*I1[1356]
           + (oneo2z)*(I2[1356] - (lpoz)*I3[1356])
           + (oneo2zn)*I4[1060];
*(vp++) = U00*I0[1357] + U40*I1[1357]
           + (oneo2z)*(I2[1357] - (lpoz)*I3[1357])
           + (oneo2zn)*I4[1061];
*(vp++) = U00*I0[1358] + U40*I1[1358]
           + (oneo2z)*(I2[1358] - (lpoz)*I3[1358])
           + (oneo2zn)*I4[1062];
*(vp++) = U00*I0[1359] + U40*I1[1359]
           + (oneo2z)*(I2[1359] - (lpoz)*I3[1359])
           + (oneo2zn)*I4[1063];
*(vp++) = U00*I0[1360] + U40*I1[1360]
           + (oneo2z)*(I2[1360] - (lpoz)*I3[1360]);
*(vp++) = U00*I0[1361] + U40*I1[1361]
           + (oneo2z)*(I2[1361] - (lpoz)*I3[1361]);
*(vp++) = U00*I0[1362] + U40*I1[1362]
           + (oneo2z)*(I2[1362] - (lpoz)*I3[1362]);
*(vp++) = U00*I0[1363] + U40*I1[1363]
           + (oneo2z)*(I2[1363] - (lpoz)*I3[1363]);
*(vp++) = U00*I0[1364] + U40*I1[1364]
           + (oneo2z)*(I2[1364] - (lpoz)*I3[1364]);
*(vp++) = U00*I0[1365] + U40*I1[1365]
           + (oneo2z)*(I2[1365] - (lpoz)*I3[1365]);
*(vp++) = U00*I0[1366] + U40*I1[1366]
           + (oneo2z)*(I2[1366] - (lpoz)*I3[1366]);
*(vp++) = U00*I0[1367] + U40*I1[1367]
           + (oneo2z)*(I2[1367] - (lpoz)*I3[1367]);
*(vp++) = U00*I0[1368] + U40*I1[1368]
           + (oneo2z)*(I2[1368] - (lpoz)*I3[1368])
           + (seveno2zn)*I4[1064];
*(vp++) = U00*I0[1369] + U40*I1[1369]
           + (oneo2z)*(I2[1369] - (lpoz)*I3[1369])
           + (sixo2zn)*I4[1065];
*(vp++) = U00*I0[1370] + U40*I1[1370]
           + (oneo2z)*(I2[1370] - (lpoz)*I3[1370])
           + (sixo2zn)*I4[1066];
*(vp++) = U00*I0[1371] + U40*I1[1371]
           + (oneo2z)*(I2[1371] - (lpoz)*I3[1371])
           + (fiveo2zn)*I4[1067];
*(vp++) = U00*I0[1372] + U40*I1[1372]
           + (oneo2z)*(I2[1372] - (lpoz)*I3[1372])
           + (fiveo2zn)*I4[1068];
*(vp++) = U00*I0[1373] + U40*I1[1373]
           + (oneo2z)*(I2[1373] - (lpoz)*I3[1373])
           + (fiveo2zn)*I4[1069];
*(vp++) = U00*I0[1374] + U40*I1[1374]
           + (oneo2z)*(I2[1374] - (lpoz)*I3[1374])
           + (fouro2zn)*I4[1070];
*(vp++) = U00*I0[1375] + U40*I1[1375]
           + (oneo2z)*(I2[1375] - (lpoz)*I3[1375])
           + (fouro2zn)*I4[1071];
*(vp++) = U00*I0[1376] + U40*I1[1376]
           + (oneo2z)*(I2[1376] - (lpoz)*I3[1376])
           + (fouro2zn)*I4[1072];
*(vp++) = U00*I0[1377] + U40*I1[1377]
           + (oneo2z)*(I2[1377] - (lpoz)*I3[1377])
           + (fouro2zn)*I4[1073];
*(vp++) = U00*I0[1378] + U40*I1[1378]
           + (oneo2z)*(I2[1378] - (lpoz)*I3[1378])
           + (threeo2zn)*I4[1074];
*(vp++) = U00*I0[1379] + U40*I1[1379]
           + (oneo2z)*(I2[1379] - (lpoz)*I3[1379])
           + (threeo2zn)*I4[1075];
*(vp++) = U00*I0[1380] + U40*I1[1380]
           + (oneo2z)*(I2[1380] - (lpoz)*I3[1380])
           + (threeo2zn)*I4[1076];
*(vp++) = U00*I0[1381] + U40*I1[1381]
           + (oneo2z)*(I2[1381] - (lpoz)*I3[1381])
           + (threeo2zn)*I4[1077];
*(vp++) = U00*I0[1382] + U40*I1[1382]
           + (oneo2z)*(I2[1382] - (lpoz)*I3[1382])
           + (threeo2zn)*I4[1078];
*(vp++) = U00*I0[1383] + U40*I1[1383]
           + (oneo2z)*(I2[1383] - (lpoz)*I3[1383])
           + (twoo2zn)*I4[1079];
*(vp++) = U00*I0[1384] + U40*I1[1384]
           + (oneo2z)*(I2[1384] - (lpoz)*I3[1384])
           + (twoo2zn)*I4[1080];
*(vp++) = U00*I0[1385] + U40*I1[1385]
           + (oneo2z)*(I2[1385] - (lpoz)*I3[1385])
           + (twoo2zn)*I4[1081];
*(vp++) = U00*I0[1386] + U40*I1[1386]
           + (oneo2z)*(I2[1386] - (lpoz)*I3[1386])
           + (twoo2zn)*I4[1082];
*(vp++) = U00*I0[1387] + U40*I1[1387]
           + (oneo2z)*(I2[1387] - (lpoz)*I3[1387])
           + (twoo2zn)*I4[1083];
*(vp++) = U00*I0[1388] + U40*I1[1388]
           + (oneo2z)*(I2[1388] - (lpoz)*I3[1388])
           + (twoo2zn)*I4[1084];
*(vp++) = U00*I0[1389] + U40*I1[1389]
           + (oneo2z)*(I2[1389] - (lpoz)*I3[1389])
           + (oneo2zn)*I4[1085];
*(vp++) = U00*I0[1390] + U40*I1[1390]
           + (oneo2z)*(I2[1390] - (lpoz)*I3[1390])
           + (oneo2zn)*I4[1086];
*(vp++) = U00*I0[1391] + U40*I1[1391]
           + (oneo2z)*(I2[1391] - (lpoz)*I3[1391])
           + (oneo2zn)*I4[1087];
*(vp++) = U00*I0[1392] + U40*I1[1392]
           + (oneo2z)*(I2[1392] - (lpoz)*I3[1392])
           + (oneo2zn)*I4[1088];
*(vp++) = U00*I0[1393] + U40*I1[1393]
           + (oneo2z)*(I2[1393] - (lpoz)*I3[1393])
           + (oneo2zn)*I4[1089];
*(vp++) = U00*I0[1394] + U40*I1[1394]
           + (oneo2z)*(I2[1394] - (lpoz)*I3[1394])
           + (oneo2zn)*I4[1090];
*(vp++) = U00*I0[1395] + U40*I1[1395]
           + (oneo2z)*(I2[1395] - (lpoz)*I3[1395])
           + (oneo2zn)*I4[1091];
*(vp++) = U00*I0[1396] + U40*I1[1396]
           + (oneo2z)*(I2[1396] - (lpoz)*I3[1396]);
*(vp++) = U00*I0[1397] + U40*I1[1397]
           + (oneo2z)*(I2[1397] - (lpoz)*I3[1397]);
*(vp++) = U00*I0[1398] + U40*I1[1398]
           + (oneo2z)*(I2[1398] - (lpoz)*I3[1398]);
*(vp++) = U00*I0[1399] + U40*I1[1399]
           + (oneo2z)*(I2[1399] - (lpoz)*I3[1399]);
*(vp++) = U00*I0[1400] + U40*I1[1400]
           + (oneo2z)*(I2[1400] - (lpoz)*I3[1400]);
*(vp++) = U00*I0[1401] + U40*I1[1401]
           + (oneo2z)*(I2[1401] - (lpoz)*I3[1401]);
*(vp++) = U00*I0[1402] + U40*I1[1402]
           + (oneo2z)*(I2[1402] - (lpoz)*I3[1402]);
*(vp++) = U00*I0[1403] + U40*I1[1403]
           + (oneo2z)*(I2[1403] - (lpoz)*I3[1403]);
*(vp++) = U00*I0[1404] + U40*I1[1404]
           + (oneo2z)*(I2[1404] - (lpoz)*I3[1404])
           + (seveno2zn)*I4[1092];
*(vp++) = U00*I0[1405] + U40*I1[1405]
           + (oneo2z)*(I2[1405] - (lpoz)*I3[1405])
           + (sixo2zn)*I4[1093];
*(vp++) = U00*I0[1406] + U40*I1[1406]
           + (oneo2z)*(I2[1406] - (lpoz)*I3[1406])
           + (sixo2zn)*I4[1094];
*(vp++) = U00*I0[1407] + U40*I1[1407]
           + (oneo2z)*(I2[1407] - (lpoz)*I3[1407])
           + (fiveo2zn)*I4[1095];
*(vp++) = U00*I0[1408] + U40*I1[1408]
           + (oneo2z)*(I2[1408] - (lpoz)*I3[1408])
           + (fiveo2zn)*I4[1096];
*(vp++) = U00*I0[1409] + U40*I1[1409]
           + (oneo2z)*(I2[1409] - (lpoz)*I3[1409])
           + (fiveo2zn)*I4[1097];
*(vp++) = U00*I0[1410] + U40*I1[1410]
           + (oneo2z)*(I2[1410] - (lpoz)*I3[1410])
           + (fouro2zn)*I4[1098];
*(vp++) = U00*I0[1411] + U40*I1[1411]
           + (oneo2z)*(I2[1411] - (lpoz)*I3[1411])
           + (fouro2zn)*I4[1099];
*(vp++) = U00*I0[1412] + U40*I1[1412]
           + (oneo2z)*(I2[1412] - (lpoz)*I3[1412])
           + (fouro2zn)*I4[1100];
*(vp++) = U00*I0[1413] + U40*I1[1413]
           + (oneo2z)*(I2[1413] - (lpoz)*I3[1413])
           + (fouro2zn)*I4[1101];
*(vp++) = U00*I0[1414] + U40*I1[1414]
           + (oneo2z)*(I2[1414] - (lpoz)*I3[1414])
           + (threeo2zn)*I4[1102];
*(vp++) = U00*I0[1415] + U40*I1[1415]
           + (oneo2z)*(I2[1415] - (lpoz)*I3[1415])
           + (threeo2zn)*I4[1103];
*(vp++) = U00*I0[1416] + U40*I1[1416]
           + (oneo2z)*(I2[1416] - (lpoz)*I3[1416])
           + (threeo2zn)*I4[1104];
*(vp++) = U00*I0[1417] + U40*I1[1417]
           + (oneo2z)*(I2[1417] - (lpoz)*I3[1417])
           + (threeo2zn)*I4[1105];
*(vp++) = U00*I0[1418] + U40*I1[1418]
           + (oneo2z)*(I2[1418] - (lpoz)*I3[1418])
           + (threeo2zn)*I4[1106];
*(vp++) = U00*I0[1419] + U40*I1[1419]
           + (oneo2z)*(I2[1419] - (lpoz)*I3[1419])
           + (twoo2zn)*I4[1107];
*(vp++) = U00*I0[1420] + U40*I1[1420]
           + (oneo2z)*(I2[1420] - (lpoz)*I3[1420])
           + (twoo2zn)*I4[1108];
*(vp++) = U00*I0[1421] + U40*I1[1421]
           + (oneo2z)*(I2[1421] - (lpoz)*I3[1421])
           + (twoo2zn)*I4[1109];
*(vp++) = U00*I0[1422] + U40*I1[1422]
           + (oneo2z)*(I2[1422] - (lpoz)*I3[1422])
           + (twoo2zn)*I4[1110];
*(vp++) = U00*I0[1423] + U40*I1[1423]
           + (oneo2z)*(I2[1423] - (lpoz)*I3[1423])
           + (twoo2zn)*I4[1111];
*(vp++) = U00*I0[1424] + U40*I1[1424]
           + (oneo2z)*(I2[1424] - (lpoz)*I3[1424])
           + (twoo2zn)*I4[1112];
*(vp++) = U00*I0[1425] + U40*I1[1425]
           + (oneo2z)*(I2[1425] - (lpoz)*I3[1425])
           + (oneo2zn)*I4[1113];
*(vp++) = U00*I0[1426] + U40*I1[1426]
           + (oneo2z)*(I2[1426] - (lpoz)*I3[1426])
           + (oneo2zn)*I4[1114];
*(vp++) = U00*I0[1427] + U40*I1[1427]
           + (oneo2z)*(I2[1427] - (lpoz)*I3[1427])
           + (oneo2zn)*I4[1115];
*(vp++) = U00*I0[1428] + U40*I1[1428]
           + (oneo2z)*(I2[1428] - (lpoz)*I3[1428])
           + (oneo2zn)*I4[1116];
*(vp++) = U00*I0[1429] + U40*I1[1429]
           + (oneo2z)*(I2[1429] - (lpoz)*I3[1429])
           + (oneo2zn)*I4[1117];
*(vp++) = U00*I0[1430] + U40*I1[1430]
           + (oneo2z)*(I2[1430] - (lpoz)*I3[1430])
           + (oneo2zn)*I4[1118];
*(vp++) = U00*I0[1431] + U40*I1[1431]
           + (oneo2z)*(I2[1431] - (lpoz)*I3[1431])
           + (oneo2zn)*I4[1119];
*(vp++) = U00*I0[1432] + U40*I1[1432]
           + (oneo2z)*(I2[1432] - (lpoz)*I3[1432]);
*(vp++) = U00*I0[1433] + U40*I1[1433]
           + (oneo2z)*(I2[1433] - (lpoz)*I3[1433]);
*(vp++) = U00*I0[1434] + U40*I1[1434]
           + (oneo2z)*(I2[1434] - (lpoz)*I3[1434]);
*(vp++) = U00*I0[1435] + U40*I1[1435]
           + (oneo2z)*(I2[1435] - (lpoz)*I3[1435]);
*(vp++) = U00*I0[1436] + U40*I1[1436]
           + (oneo2z)*(I2[1436] - (lpoz)*I3[1436]);
*(vp++) = U00*I0[1437] + U40*I1[1437]
           + (oneo2z)*(I2[1437] - (lpoz)*I3[1437]);
*(vp++) = U00*I0[1438] + U40*I1[1438]
           + (oneo2z)*(I2[1438] - (lpoz)*I3[1438]);
*(vp++) = U00*I0[1439] + U40*I1[1439]
           + (oneo2z)*(I2[1439] - (lpoz)*I3[1439]);
*(vp++) = U00*I0[1440] + U40*I1[1440]
           + (oneo2z)*(I2[1440] - (lpoz)*I3[1440])
           + (seveno2zn)*I4[1120];
*(vp++) = U00*I0[1441] + U40*I1[1441]
           + (oneo2z)*(I2[1441] - (lpoz)*I3[1441])
           + (sixo2zn)*I4[1121];
*(vp++) = U00*I0[1442] + U40*I1[1442]
           + (oneo2z)*(I2[1442] - (lpoz)*I3[1442])
           + (sixo2zn)*I4[1122];
*(vp++) = U00*I0[1443] + U40*I1[1443]
           + (oneo2z)*(I2[1443] - (lpoz)*I3[1443])
           + (fiveo2zn)*I4[1123];
*(vp++) = U00*I0[1444] + U40*I1[1444]
           + (oneo2z)*(I2[1444] - (lpoz)*I3[1444])
           + (fiveo2zn)*I4[1124];
*(vp++) = U00*I0[1445] + U40*I1[1445]
           + (oneo2z)*(I2[1445] - (lpoz)*I3[1445])
           + (fiveo2zn)*I4[1125];
*(vp++) = U00*I0[1446] + U40*I1[1446]
           + (oneo2z)*(I2[1446] - (lpoz)*I3[1446])
           + (fouro2zn)*I4[1126];
*(vp++) = U00*I0[1447] + U40*I1[1447]
           + (oneo2z)*(I2[1447] - (lpoz)*I3[1447])
           + (fouro2zn)*I4[1127];
*(vp++) = U00*I0[1448] + U40*I1[1448]
           + (oneo2z)*(I2[1448] - (lpoz)*I3[1448])
           + (fouro2zn)*I4[1128];
*(vp++) = U00*I0[1449] + U40*I1[1449]
           + (oneo2z)*(I2[1449] - (lpoz)*I3[1449])
           + (fouro2zn)*I4[1129];
*(vp++) = U00*I0[1450] + U40*I1[1450]
           + (oneo2z)*(I2[1450] - (lpoz)*I3[1450])
           + (threeo2zn)*I4[1130];
*(vp++) = U00*I0[1451] + U40*I1[1451]
           + (oneo2z)*(I2[1451] - (lpoz)*I3[1451])
           + (threeo2zn)*I4[1131];
*(vp++) = U00*I0[1452] + U40*I1[1452]
           + (oneo2z)*(I2[1452] - (lpoz)*I3[1452])
           + (threeo2zn)*I4[1132];
*(vp++) = U00*I0[1453] + U40*I1[1453]
           + (oneo2z)*(I2[1453] - (lpoz)*I3[1453])
           + (threeo2zn)*I4[1133];
*(vp++) = U00*I0[1454] + U40*I1[1454]
           + (oneo2z)*(I2[1454] - (lpoz)*I3[1454])
           + (threeo2zn)*I4[1134];
*(vp++) = U00*I0[1455] + U40*I1[1455]
           + (oneo2z)*(I2[1455] - (lpoz)*I3[1455])
           + (twoo2zn)*I4[1135];
*(vp++) = U00*I0[1456] + U40*I1[1456]
           + (oneo2z)*(I2[1456] - (lpoz)*I3[1456])
           + (twoo2zn)*I4[1136];
*(vp++) = U00*I0[1457] + U40*I1[1457]
           + (oneo2z)*(I2[1457] - (lpoz)*I3[1457])
           + (twoo2zn)*I4[1137];
*(vp++) = U00*I0[1458] + U40*I1[1458]
           + (oneo2z)*(I2[1458] - (lpoz)*I3[1458])
           + (twoo2zn)*I4[1138];
*(vp++) = U00*I0[1459] + U40*I1[1459]
           + (oneo2z)*(I2[1459] - (lpoz)*I3[1459])
           + (twoo2zn)*I4[1139];
*(vp++) = U00*I0[1460] + U40*I1[1460]
           + (oneo2z)*(I2[1460] - (lpoz)*I3[1460])
           + (twoo2zn)*I4[1140];
*(vp++) = U00*I0[1461] + U40*I1[1461]
           + (oneo2z)*(I2[1461] - (lpoz)*I3[1461])
           + (oneo2zn)*I4[1141];
*(vp++) = U00*I0[1462] + U40*I1[1462]
           + (oneo2z)*(I2[1462] - (lpoz)*I3[1462])
           + (oneo2zn)*I4[1142];
*(vp++) = U00*I0[1463] + U40*I1[1463]
           + (oneo2z)*(I2[1463] - (lpoz)*I3[1463])
           + (oneo2zn)*I4[1143];
*(vp++) = U00*I0[1464] + U40*I1[1464]
           + (oneo2z)*(I2[1464] - (lpoz)*I3[1464])
           + (oneo2zn)*I4[1144];
*(vp++) = U00*I0[1465] + U40*I1[1465]
           + (oneo2z)*(I2[1465] - (lpoz)*I3[1465])
           + (oneo2zn)*I4[1145];
*(vp++) = U00*I0[1466] + U40*I1[1466]
           + (oneo2z)*(I2[1466] - (lpoz)*I3[1466])
           + (oneo2zn)*I4[1146];
*(vp++) = U00*I0[1467] + U40*I1[1467]
           + (oneo2z)*(I2[1467] - (lpoz)*I3[1467])
           + (oneo2zn)*I4[1147];
*(vp++) = U00*I0[1468] + U40*I1[1468]
           + (oneo2z)*(I2[1468] - (lpoz)*I3[1468]);
*(vp++) = U00*I0[1469] + U40*I1[1469]
           + (oneo2z)*(I2[1469] - (lpoz)*I3[1469]);
*(vp++) = U00*I0[1470] + U40*I1[1470]
           + (oneo2z)*(I2[1470] - (lpoz)*I3[1470]);
*(vp++) = U00*I0[1471] + U40*I1[1471]
           + (oneo2z)*(I2[1471] - (lpoz)*I3[1471]);
*(vp++) = U00*I0[1472] + U40*I1[1472]
           + (oneo2z)*(I2[1472] - (lpoz)*I3[1472]);
*(vp++) = U00*I0[1473] + U40*I1[1473]
           + (oneo2z)*(I2[1473] - (lpoz)*I3[1473]);
*(vp++) = U00*I0[1474] + U40*I1[1474]
           + (oneo2z)*(I2[1474] - (lpoz)*I3[1474]);
*(vp++) = U00*I0[1475] + U40*I1[1475]
           + (oneo2z)*(I2[1475] - (lpoz)*I3[1475]);
*(vp++) = U00*I0[1476] + U40*I1[1476]
           + (oneo2z)*(I2[1476] - (lpoz)*I3[1476])
           + (seveno2zn)*I4[1148];
*(vp++) = U00*I0[1477] + U40*I1[1477]
           + (oneo2z)*(I2[1477] - (lpoz)*I3[1477])
           + (sixo2zn)*I4[1149];
*(vp++) = U00*I0[1478] + U40*I1[1478]
           + (oneo2z)*(I2[1478] - (lpoz)*I3[1478])
           + (sixo2zn)*I4[1150];
*(vp++) = U00*I0[1479] + U40*I1[1479]
           + (oneo2z)*(I2[1479] - (lpoz)*I3[1479])
           + (fiveo2zn)*I4[1151];
*(vp++) = U00*I0[1480] + U40*I1[1480]
           + (oneo2z)*(I2[1480] - (lpoz)*I3[1480])
           + (fiveo2zn)*I4[1152];
*(vp++) = U00*I0[1481] + U40*I1[1481]
           + (oneo2z)*(I2[1481] - (lpoz)*I3[1481])
           + (fiveo2zn)*I4[1153];
*(vp++) = U00*I0[1482] + U40*I1[1482]
           + (oneo2z)*(I2[1482] - (lpoz)*I3[1482])
           + (fouro2zn)*I4[1154];
*(vp++) = U00*I0[1483] + U40*I1[1483]
           + (oneo2z)*(I2[1483] - (lpoz)*I3[1483])
           + (fouro2zn)*I4[1155];
*(vp++) = U00*I0[1484] + U40*I1[1484]
           + (oneo2z)*(I2[1484] - (lpoz)*I3[1484])
           + (fouro2zn)*I4[1156];
*(vp++) = U00*I0[1485] + U40*I1[1485]
           + (oneo2z)*(I2[1485] - (lpoz)*I3[1485])
           + (fouro2zn)*I4[1157];
*(vp++) = U00*I0[1486] + U40*I1[1486]
           + (oneo2z)*(I2[1486] - (lpoz)*I3[1486])
           + (threeo2zn)*I4[1158];
*(vp++) = U00*I0[1487] + U40*I1[1487]
           + (oneo2z)*(I2[1487] - (lpoz)*I3[1487])
           + (threeo2zn)*I4[1159];
*(vp++) = U00*I0[1488] + U40*I1[1488]
           + (oneo2z)*(I2[1488] - (lpoz)*I3[1488])
           + (threeo2zn)*I4[1160];
*(vp++) = U00*I0[1489] + U40*I1[1489]
           + (oneo2z)*(I2[1489] - (lpoz)*I3[1489])
           + (threeo2zn)*I4[1161];
return vp;
}

REALTYPE *_build_n0k0_5(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[1490] + U40*I1[1490]
           + (oneo2z)*(I2[1490] - (lpoz)*I3[1490])
           + (threeo2zn)*I4[1162];
*(vp++) = U00*I0[1491] + U40*I1[1491]
           + (oneo2z)*(I2[1491] - (lpoz)*I3[1491])
           + (twoo2zn)*I4[1163];
*(vp++) = U00*I0[1492] + U40*I1[1492]
           + (oneo2z)*(I2[1492] - (lpoz)*I3[1492])
           + (twoo2zn)*I4[1164];
*(vp++) = U00*I0[1493] + U40*I1[1493]
           + (oneo2z)*(I2[1493] - (lpoz)*I3[1493])
           + (twoo2zn)*I4[1165];
*(vp++) = U00*I0[1494] + U40*I1[1494]
           + (oneo2z)*(I2[1494] - (lpoz)*I3[1494])
           + (twoo2zn)*I4[1166];
*(vp++) = U00*I0[1495] + U40*I1[1495]
           + (oneo2z)*(I2[1495] - (lpoz)*I3[1495])
           + (twoo2zn)*I4[1167];
*(vp++) = U00*I0[1496] + U40*I1[1496]
           + (oneo2z)*(I2[1496] - (lpoz)*I3[1496])
           + (twoo2zn)*I4[1168];
*(vp++) = U00*I0[1497] + U40*I1[1497]
           + (oneo2z)*(I2[1497] - (lpoz)*I3[1497])
           + (oneo2zn)*I4[1169];
*(vp++) = U00*I0[1498] + U40*I1[1498]
           + (oneo2z)*(I2[1498] - (lpoz)*I3[1498])
           + (oneo2zn)*I4[1170];
*(vp++) = U00*I0[1499] + U40*I1[1499]
           + (oneo2z)*(I2[1499] - (lpoz)*I3[1499])
           + (oneo2zn)*I4[1171];
*(vp++) = U00*I0[1500] + U40*I1[1500]
           + (oneo2z)*(I2[1500] - (lpoz)*I3[1500])
           + (oneo2zn)*I4[1172];
*(vp++) = U00*I0[1501] + U40*I1[1501]
           + (oneo2z)*(I2[1501] - (lpoz)*I3[1501])
           + (oneo2zn)*I4[1173];
*(vp++) = U00*I0[1502] + U40*I1[1502]
           + (oneo2z)*(I2[1502] - (lpoz)*I3[1502])
           + (oneo2zn)*I4[1174];
*(vp++) = U00*I0[1503] + U40*I1[1503]
           + (oneo2z)*(I2[1503] - (lpoz)*I3[1503])
           + (oneo2zn)*I4[1175];
*(vp++) = U00*I0[1504] + U40*I1[1504]
           + (oneo2z)*(I2[1504] - (lpoz)*I3[1504]);
*(vp++) = U00*I0[1505] + U40*I1[1505]
           + (oneo2z)*(I2[1505] - (lpoz)*I3[1505]);
*(vp++) = U00*I0[1506] + U40*I1[1506]
           + (oneo2z)*(I2[1506] - (lpoz)*I3[1506]);
*(vp++) = U00*I0[1507] + U40*I1[1507]
           + (oneo2z)*(I2[1507] - (lpoz)*I3[1507]);
*(vp++) = U00*I0[1508] + U40*I1[1508]
           + (oneo2z)*(I2[1508] - (lpoz)*I3[1508]);
*(vp++) = U00*I0[1509] + U40*I1[1509]
           + (oneo2z)*(I2[1509] - (lpoz)*I3[1509]);
*(vp++) = U00*I0[1510] + U40*I1[1510]
           + (oneo2z)*(I2[1510] - (lpoz)*I3[1510]);
*(vp++) = U00*I0[1511] + U40*I1[1511]
           + (oneo2z)*(I2[1511] - (lpoz)*I3[1511]);
*(vp++) = U00*I0[1512] + U40*I1[1512]
           + (oneo2z)*(I2[1512] - (lpoz)*I3[1512])
           + (seveno2zn)*I4[1176];
*(vp++) = U00*I0[1513] + U40*I1[1513]
           + (oneo2z)*(I2[1513] - (lpoz)*I3[1513])
           + (sixo2zn)*I4[1177];
*(vp++) = U00*I0[1514] + U40*I1[1514]
           + (oneo2z)*(I2[1514] - (lpoz)*I3[1514])
           + (sixo2zn)*I4[1178];
*(vp++) = U00*I0[1515] + U40*I1[1515]
           + (oneo2z)*(I2[1515] - (lpoz)*I3[1515])
           + (fiveo2zn)*I4[1179];
*(vp++) = U00*I0[1516] + U40*I1[1516]
           + (oneo2z)*(I2[1516] - (lpoz)*I3[1516])
           + (fiveo2zn)*I4[1180];
*(vp++) = U00*I0[1517] + U40*I1[1517]
           + (oneo2z)*(I2[1517] - (lpoz)*I3[1517])
           + (fiveo2zn)*I4[1181];
*(vp++) = U00*I0[1518] + U40*I1[1518]
           + (oneo2z)*(I2[1518] - (lpoz)*I3[1518])
           + (fouro2zn)*I4[1182];
*(vp++) = U00*I0[1519] + U40*I1[1519]
           + (oneo2z)*(I2[1519] - (lpoz)*I3[1519])
           + (fouro2zn)*I4[1183];
*(vp++) = U00*I0[1520] + U40*I1[1520]
           + (oneo2z)*(I2[1520] - (lpoz)*I3[1520])
           + (fouro2zn)*I4[1184];
*(vp++) = U00*I0[1521] + U40*I1[1521]
           + (oneo2z)*(I2[1521] - (lpoz)*I3[1521])
           + (fouro2zn)*I4[1185];
*(vp++) = U00*I0[1522] + U40*I1[1522]
           + (oneo2z)*(I2[1522] - (lpoz)*I3[1522])
           + (threeo2zn)*I4[1186];
*(vp++) = U00*I0[1523] + U40*I1[1523]
           + (oneo2z)*(I2[1523] - (lpoz)*I3[1523])
           + (threeo2zn)*I4[1187];
*(vp++) = U00*I0[1524] + U40*I1[1524]
           + (oneo2z)*(I2[1524] - (lpoz)*I3[1524])
           + (threeo2zn)*I4[1188];
*(vp++) = U00*I0[1525] + U40*I1[1525]
           + (oneo2z)*(I2[1525] - (lpoz)*I3[1525])
           + (threeo2zn)*I4[1189];
*(vp++) = U00*I0[1526] + U40*I1[1526]
           + (oneo2z)*(I2[1526] - (lpoz)*I3[1526])
           + (threeo2zn)*I4[1190];
*(vp++) = U00*I0[1527] + U40*I1[1527]
           + (oneo2z)*(I2[1527] - (lpoz)*I3[1527])
           + (twoo2zn)*I4[1191];
*(vp++) = U00*I0[1528] + U40*I1[1528]
           + (oneo2z)*(I2[1528] - (lpoz)*I3[1528])
           + (twoo2zn)*I4[1192];
*(vp++) = U00*I0[1529] + U40*I1[1529]
           + (oneo2z)*(I2[1529] - (lpoz)*I3[1529])
           + (twoo2zn)*I4[1193];
*(vp++) = U00*I0[1530] + U40*I1[1530]
           + (oneo2z)*(I2[1530] - (lpoz)*I3[1530])
           + (twoo2zn)*I4[1194];
*(vp++) = U00*I0[1531] + U40*I1[1531]
           + (oneo2z)*(I2[1531] - (lpoz)*I3[1531])
           + (twoo2zn)*I4[1195];
*(vp++) = U00*I0[1532] + U40*I1[1532]
           + (oneo2z)*(I2[1532] - (lpoz)*I3[1532])
           + (twoo2zn)*I4[1196];
*(vp++) = U00*I0[1533] + U40*I1[1533]
           + (oneo2z)*(I2[1533] - (lpoz)*I3[1533])
           + (oneo2zn)*I4[1197];
*(vp++) = U00*I0[1534] + U40*I1[1534]
           + (oneo2z)*(I2[1534] - (lpoz)*I3[1534])
           + (oneo2zn)*I4[1198];
*(vp++) = U00*I0[1535] + U40*I1[1535]
           + (oneo2z)*(I2[1535] - (lpoz)*I3[1535])
           + (oneo2zn)*I4[1199];
*(vp++) = U00*I0[1536] + U40*I1[1536]
           + (oneo2z)*(I2[1536] - (lpoz)*I3[1536])
           + (oneo2zn)*I4[1200];
*(vp++) = U00*I0[1537] + U40*I1[1537]
           + (oneo2z)*(I2[1537] - (lpoz)*I3[1537])
           + (oneo2zn)*I4[1201];
*(vp++) = U00*I0[1538] + U40*I1[1538]
           + (oneo2z)*(I2[1538] - (lpoz)*I3[1538])
           + (oneo2zn)*I4[1202];
*(vp++) = U00*I0[1539] + U40*I1[1539]
           + (oneo2z)*(I2[1539] - (lpoz)*I3[1539])
           + (oneo2zn)*I4[1203];
*(vp++) = U00*I0[1540] + U40*I1[1540]
           + (oneo2z)*(I2[1540] - (lpoz)*I3[1540]);
*(vp++) = U00*I0[1541] + U40*I1[1541]
           + (oneo2z)*(I2[1541] - (lpoz)*I3[1541]);
*(vp++) = U00*I0[1542] + U40*I1[1542]
           + (oneo2z)*(I2[1542] - (lpoz)*I3[1542]);
*(vp++) = U00*I0[1543] + U40*I1[1543]
           + (oneo2z)*(I2[1543] - (lpoz)*I3[1543]);
*(vp++) = U00*I0[1544] + U40*I1[1544]
           + (oneo2z)*(I2[1544] - (lpoz)*I3[1544]);
*(vp++) = U00*I0[1545] + U40*I1[1545]
           + (oneo2z)*(I2[1545] - (lpoz)*I3[1545]);
*(vp++) = U00*I0[1546] + U40*I1[1546]
           + (oneo2z)*(I2[1546] - (lpoz)*I3[1546]);
*(vp++) = U00*I0[1547] + U40*I1[1547]
           + (oneo2z)*(I2[1547] - (lpoz)*I3[1547]);
*(vp++) = U00*I0[1548] + U40*I1[1548]
           + (oneo2z)*(I2[1548] - (lpoz)*I3[1548])
           + (seveno2zn)*I4[1204];
*(vp++) = U00*I0[1549] + U40*I1[1549]
           + (oneo2z)*(I2[1549] - (lpoz)*I3[1549])
           + (sixo2zn)*I4[1205];
*(vp++) = U00*I0[1550] + U40*I1[1550]
           + (oneo2z)*(I2[1550] - (lpoz)*I3[1550])
           + (sixo2zn)*I4[1206];
*(vp++) = U00*I0[1551] + U40*I1[1551]
           + (oneo2z)*(I2[1551] - (lpoz)*I3[1551])
           + (fiveo2zn)*I4[1207];
*(vp++) = U00*I0[1552] + U40*I1[1552]
           + (oneo2z)*(I2[1552] - (lpoz)*I3[1552])
           + (fiveo2zn)*I4[1208];
*(vp++) = U00*I0[1553] + U40*I1[1553]
           + (oneo2z)*(I2[1553] - (lpoz)*I3[1553])
           + (fiveo2zn)*I4[1209];
*(vp++) = U00*I0[1554] + U40*I1[1554]
           + (oneo2z)*(I2[1554] - (lpoz)*I3[1554])
           + (fouro2zn)*I4[1210];
*(vp++) = U00*I0[1555] + U40*I1[1555]
           + (oneo2z)*(I2[1555] - (lpoz)*I3[1555])
           + (fouro2zn)*I4[1211];
*(vp++) = U00*I0[1556] + U40*I1[1556]
           + (oneo2z)*(I2[1556] - (lpoz)*I3[1556])
           + (fouro2zn)*I4[1212];
*(vp++) = U00*I0[1557] + U40*I1[1557]
           + (oneo2z)*(I2[1557] - (lpoz)*I3[1557])
           + (fouro2zn)*I4[1213];
*(vp++) = U00*I0[1558] + U40*I1[1558]
           + (oneo2z)*(I2[1558] - (lpoz)*I3[1558])
           + (threeo2zn)*I4[1214];
*(vp++) = U00*I0[1559] + U40*I1[1559]
           + (oneo2z)*(I2[1559] - (lpoz)*I3[1559])
           + (threeo2zn)*I4[1215];
*(vp++) = U00*I0[1560] + U40*I1[1560]
           + (oneo2z)*(I2[1560] - (lpoz)*I3[1560])
           + (threeo2zn)*I4[1216];
*(vp++) = U00*I0[1561] + U40*I1[1561]
           + (oneo2z)*(I2[1561] - (lpoz)*I3[1561])
           + (threeo2zn)*I4[1217];
*(vp++) = U00*I0[1562] + U40*I1[1562]
           + (oneo2z)*(I2[1562] - (lpoz)*I3[1562])
           + (threeo2zn)*I4[1218];
*(vp++) = U00*I0[1563] + U40*I1[1563]
           + (oneo2z)*(I2[1563] - (lpoz)*I3[1563])
           + (twoo2zn)*I4[1219];
*(vp++) = U00*I0[1564] + U40*I1[1564]
           + (oneo2z)*(I2[1564] - (lpoz)*I3[1564])
           + (twoo2zn)*I4[1220];
*(vp++) = U00*I0[1565] + U40*I1[1565]
           + (oneo2z)*(I2[1565] - (lpoz)*I3[1565])
           + (twoo2zn)*I4[1221];
*(vp++) = U00*I0[1566] + U40*I1[1566]
           + (oneo2z)*(I2[1566] - (lpoz)*I3[1566])
           + (twoo2zn)*I4[1222];
*(vp++) = U00*I0[1567] + U40*I1[1567]
           + (oneo2z)*(I2[1567] - (lpoz)*I3[1567])
           + (twoo2zn)*I4[1223];
*(vp++) = U00*I0[1568] + U40*I1[1568]
           + (oneo2z)*(I2[1568] - (lpoz)*I3[1568])
           + (twoo2zn)*I4[1224];
*(vp++) = U00*I0[1569] + U40*I1[1569]
           + (oneo2z)*(I2[1569] - (lpoz)*I3[1569])
           + (oneo2zn)*I4[1225];
*(vp++) = U00*I0[1570] + U40*I1[1570]
           + (oneo2z)*(I2[1570] - (lpoz)*I3[1570])
           + (oneo2zn)*I4[1226];
*(vp++) = U00*I0[1571] + U40*I1[1571]
           + (oneo2z)*(I2[1571] - (lpoz)*I3[1571])
           + (oneo2zn)*I4[1227];
*(vp++) = U00*I0[1572] + U40*I1[1572]
           + (oneo2z)*(I2[1572] - (lpoz)*I3[1572])
           + (oneo2zn)*I4[1228];
*(vp++) = U00*I0[1573] + U40*I1[1573]
           + (oneo2z)*(I2[1573] - (lpoz)*I3[1573])
           + (oneo2zn)*I4[1229];
*(vp++) = U00*I0[1574] + U40*I1[1574]
           + (oneo2z)*(I2[1574] - (lpoz)*I3[1574])
           + (oneo2zn)*I4[1230];
*(vp++) = U00*I0[1575] + U40*I1[1575]
           + (oneo2z)*(I2[1575] - (lpoz)*I3[1575])
           + (oneo2zn)*I4[1231];
*(vp++) = U00*I0[1576] + U40*I1[1576]
           + (oneo2z)*(I2[1576] - (lpoz)*I3[1576]);
*(vp++) = U00*I0[1577] + U40*I1[1577]
           + (oneo2z)*(I2[1577] - (lpoz)*I3[1577]);
*(vp++) = U00*I0[1578] + U40*I1[1578]
           + (oneo2z)*(I2[1578] - (lpoz)*I3[1578]);
*(vp++) = U00*I0[1579] + U40*I1[1579]
           + (oneo2z)*(I2[1579] - (lpoz)*I3[1579]);
*(vp++) = U00*I0[1580] + U40*I1[1580]
           + (oneo2z)*(I2[1580] - (lpoz)*I3[1580]);
*(vp++) = U00*I0[1581] + U40*I1[1581]
           + (oneo2z)*(I2[1581] - (lpoz)*I3[1581]);
*(vp++) = U00*I0[1582] + U40*I1[1582]
           + (oneo2z)*(I2[1582] - (lpoz)*I3[1582]);
*(vp++) = U00*I0[1583] + U40*I1[1583]
           + (oneo2z)*(I2[1583] - (lpoz)*I3[1583]);
*(vp++) = U00*I0[1584] + U40*I1[1584]
           + (oneo2z)*(I2[1584] - (lpoz)*I3[1584])
           + (seveno2zn)*I4[1232];
*(vp++) = U00*I0[1585] + U40*I1[1585]
           + (oneo2z)*(I2[1585] - (lpoz)*I3[1585])
           + (sixo2zn)*I4[1233];
*(vp++) = U00*I0[1586] + U40*I1[1586]
           + (oneo2z)*(I2[1586] - (lpoz)*I3[1586])
           + (sixo2zn)*I4[1234];
*(vp++) = U00*I0[1587] + U40*I1[1587]
           + (oneo2z)*(I2[1587] - (lpoz)*I3[1587])
           + (fiveo2zn)*I4[1235];
*(vp++) = U00*I0[1588] + U40*I1[1588]
           + (oneo2z)*(I2[1588] - (lpoz)*I3[1588])
           + (fiveo2zn)*I4[1236];
*(vp++) = U00*I0[1589] + U40*I1[1589]
           + (oneo2z)*(I2[1589] - (lpoz)*I3[1589])
           + (fiveo2zn)*I4[1237];
*(vp++) = U00*I0[1590] + U40*I1[1590]
           + (oneo2z)*(I2[1590] - (lpoz)*I3[1590])
           + (fouro2zn)*I4[1238];
*(vp++) = U00*I0[1591] + U40*I1[1591]
           + (oneo2z)*(I2[1591] - (lpoz)*I3[1591])
           + (fouro2zn)*I4[1239];
*(vp++) = U00*I0[1592] + U40*I1[1592]
           + (oneo2z)*(I2[1592] - (lpoz)*I3[1592])
           + (fouro2zn)*I4[1240];
*(vp++) = U00*I0[1593] + U40*I1[1593]
           + (oneo2z)*(I2[1593] - (lpoz)*I3[1593])
           + (fouro2zn)*I4[1241];
*(vp++) = U00*I0[1594] + U40*I1[1594]
           + (oneo2z)*(I2[1594] - (lpoz)*I3[1594])
           + (threeo2zn)*I4[1242];
*(vp++) = U00*I0[1595] + U40*I1[1595]
           + (oneo2z)*(I2[1595] - (lpoz)*I3[1595])
           + (threeo2zn)*I4[1243];
*(vp++) = U00*I0[1596] + U40*I1[1596]
           + (oneo2z)*(I2[1596] - (lpoz)*I3[1596])
           + (threeo2zn)*I4[1244];
*(vp++) = U00*I0[1597] + U40*I1[1597]
           + (oneo2z)*(I2[1597] - (lpoz)*I3[1597])
           + (threeo2zn)*I4[1245];
*(vp++) = U00*I0[1598] + U40*I1[1598]
           + (oneo2z)*(I2[1598] - (lpoz)*I3[1598])
           + (threeo2zn)*I4[1246];
*(vp++) = U00*I0[1599] + U40*I1[1599]
           + (oneo2z)*(I2[1599] - (lpoz)*I3[1599])
           + (twoo2zn)*I4[1247];
*(vp++) = U00*I0[1600] + U40*I1[1600]
           + (oneo2z)*(I2[1600] - (lpoz)*I3[1600])
           + (twoo2zn)*I4[1248];
*(vp++) = U00*I0[1601] + U40*I1[1601]
           + (oneo2z)*(I2[1601] - (lpoz)*I3[1601])
           + (twoo2zn)*I4[1249];
*(vp++) = U00*I0[1602] + U40*I1[1602]
           + (oneo2z)*(I2[1602] - (lpoz)*I3[1602])
           + (twoo2zn)*I4[1250];
*(vp++) = U00*I0[1603] + U40*I1[1603]
           + (oneo2z)*(I2[1603] - (lpoz)*I3[1603])
           + (twoo2zn)*I4[1251];
*(vp++) = U00*I0[1604] + U40*I1[1604]
           + (oneo2z)*(I2[1604] - (lpoz)*I3[1604])
           + (twoo2zn)*I4[1252];
*(vp++) = U00*I0[1605] + U40*I1[1605]
           + (oneo2z)*(I2[1605] - (lpoz)*I3[1605])
           + (oneo2zn)*I4[1253];
*(vp++) = U00*I0[1606] + U40*I1[1606]
           + (oneo2z)*(I2[1606] - (lpoz)*I3[1606])
           + (oneo2zn)*I4[1254];
*(vp++) = U00*I0[1607] + U40*I1[1607]
           + (oneo2z)*(I2[1607] - (lpoz)*I3[1607])
           + (oneo2zn)*I4[1255];
*(vp++) = U00*I0[1608] + U40*I1[1608]
           + (oneo2z)*(I2[1608] - (lpoz)*I3[1608])
           + (oneo2zn)*I4[1256];
*(vp++) = U00*I0[1609] + U40*I1[1609]
           + (oneo2z)*(I2[1609] - (lpoz)*I3[1609])
           + (oneo2zn)*I4[1257];
*(vp++) = U00*I0[1610] + U40*I1[1610]
           + (oneo2z)*(I2[1610] - (lpoz)*I3[1610])
           + (oneo2zn)*I4[1258];
*(vp++) = U00*I0[1611] + U40*I1[1611]
           + (oneo2z)*(I2[1611] - (lpoz)*I3[1611])
           + (oneo2zn)*I4[1259];
*(vp++) = U00*I0[1612] + U40*I1[1612]
           + (oneo2z)*(I2[1612] - (lpoz)*I3[1612]);
*(vp++) = U00*I0[1613] + U40*I1[1613]
           + (oneo2z)*(I2[1613] - (lpoz)*I3[1613]);
*(vp++) = U00*I0[1614] + U40*I1[1614]
           + (oneo2z)*(I2[1614] - (lpoz)*I3[1614]);
*(vp++) = U00*I0[1615] + U40*I1[1615]
           + (oneo2z)*(I2[1615] - (lpoz)*I3[1615]);
*(vp++) = U00*I0[1616] + U40*I1[1616]
           + (oneo2z)*(I2[1616] - (lpoz)*I3[1616]);
*(vp++) = U00*I0[1617] + U40*I1[1617]
           + (oneo2z)*(I2[1617] - (lpoz)*I3[1617]);
*(vp++) = U00*I0[1618] + U40*I1[1618]
           + (oneo2z)*(I2[1618] - (lpoz)*I3[1618]);
*(vp++) = U00*I0[1619] + U40*I1[1619]
           + (oneo2z)*(I2[1619] - (lpoz)*I3[1619]);
*(vp++) = U00*I0[1620] + U40*I1[1620]
           + (seveno2zn)*I4[1260];
*(vp++) = U00*I0[1621] + U40*I1[1621]
           + (sixo2zn)*I4[1261];
*(vp++) = U00*I0[1622] + U40*I1[1622]
           + (sixo2zn)*I4[1262];
*(vp++) = U00*I0[1623] + U40*I1[1623]
           + (fiveo2zn)*I4[1263];
*(vp++) = U00*I0[1624] + U40*I1[1624]
           + (fiveo2zn)*I4[1264];
*(vp++) = U00*I0[1625] + U40*I1[1625]
           + (fiveo2zn)*I4[1265];
*(vp++) = U00*I0[1626] + U40*I1[1626]
           + (fouro2zn)*I4[1266];
*(vp++) = U00*I0[1627] + U40*I1[1627]
           + (fouro2zn)*I4[1267];
*(vp++) = U00*I0[1628] + U40*I1[1628]
           + (fouro2zn)*I4[1268];
*(vp++) = U00*I0[1629] + U40*I1[1629]
           + (fouro2zn)*I4[1269];
*(vp++) = U00*I0[1630] + U40*I1[1630]
           + (threeo2zn)*I4[1270];
*(vp++) = U00*I0[1631] + U40*I1[1631]
           + (threeo2zn)*I4[1271];
*(vp++) = U00*I0[1632] + U40*I1[1632]
           + (threeo2zn)*I4[1272];
*(vp++) = U00*I0[1633] + U40*I1[1633]
           + (threeo2zn)*I4[1273];
*(vp++) = U00*I0[1634] + U40*I1[1634]
           + (threeo2zn)*I4[1274];
*(vp++) = U00*I0[1635] + U40*I1[1635]
           + (twoo2zn)*I4[1275];
*(vp++) = U00*I0[1636] + U40*I1[1636]
           + (twoo2zn)*I4[1276];
*(vp++) = U00*I0[1637] + U40*I1[1637]
           + (twoo2zn)*I4[1277];
*(vp++) = U00*I0[1638] + U40*I1[1638]
           + (twoo2zn)*I4[1278];
*(vp++) = U00*I0[1639] + U40*I1[1639]
           + (twoo2zn)*I4[1279];
*(vp++) = U00*I0[1640] + U40*I1[1640]
           + (twoo2zn)*I4[1280];
*(vp++) = U00*I0[1641] + U40*I1[1641]
           + (oneo2zn)*I4[1281];
*(vp++) = U00*I0[1642] + U40*I1[1642]
           + (oneo2zn)*I4[1282];
*(vp++) = U00*I0[1643] + U40*I1[1643]
           + (oneo2zn)*I4[1283];
*(vp++) = U00*I0[1644] + U40*I1[1644]
           + (oneo2zn)*I4[1284];
*(vp++) = U00*I0[1645] + U40*I1[1645]
           + (oneo2zn)*I4[1285];
*(vp++) = U00*I0[1646] + U40*I1[1646]
           + (oneo2zn)*I4[1286];
*(vp++) = U00*I0[1647] + U40*I1[1647]
           + (oneo2zn)*I4[1287];
*(vp++) = U00*I0[1648] + U40*I1[1648];
*(vp++) = U00*I0[1649] + U40*I1[1649];
*(vp++) = U00*I0[1650] + U40*I1[1650];
*(vp++) = U00*I0[1651] + U40*I1[1651];
*(vp++) = U00*I0[1652] + U40*I1[1652];
*(vp++) = U00*I0[1653] + U40*I1[1653];
*(vp++) = U00*I0[1654] + U40*I1[1654];
*(vp++) = U00*I0[1655] + U40*I1[1655];
*(vp++) = U00*I0[1656] + U40*I1[1656]
           + (seveno2zn)*I4[1288];
*(vp++) = U00*I0[1657] + U40*I1[1657]
           + (sixo2zn)*I4[1289];
*(vp++) = U00*I0[1658] + U40*I1[1658]
           + (sixo2zn)*I4[1290];
*(vp++) = U00*I0[1659] + U40*I1[1659]
           + (fiveo2zn)*I4[1291];
*(vp++) = U00*I0[1660] + U40*I1[1660]
           + (fiveo2zn)*I4[1292];
*(vp++) = U00*I0[1661] + U40*I1[1661]
           + (fiveo2zn)*I4[1293];
*(vp++) = U00*I0[1662] + U40*I1[1662]
           + (fouro2zn)*I4[1294];
*(vp++) = U00*I0[1663] + U40*I1[1663]
           + (fouro2zn)*I4[1295];
*(vp++) = U00*I0[1664] + U40*I1[1664]
           + (fouro2zn)*I4[1296];
*(vp++) = U00*I0[1665] + U40*I1[1665]
           + (fouro2zn)*I4[1297];
*(vp++) = U00*I0[1666] + U40*I1[1666]
           + (threeo2zn)*I4[1298];
*(vp++) = U00*I0[1667] + U40*I1[1667]
           + (threeo2zn)*I4[1299];
*(vp++) = U00*I0[1668] + U40*I1[1668]
           + (threeo2zn)*I4[1300];
*(vp++) = U00*I0[1669] + U40*I1[1669]
           + (threeo2zn)*I4[1301];
*(vp++) = U00*I0[1670] + U40*I1[1670]
           + (threeo2zn)*I4[1302];
*(vp++) = U00*I0[1671] + U40*I1[1671]
           + (twoo2zn)*I4[1303];
*(vp++) = U00*I0[1672] + U40*I1[1672]
           + (twoo2zn)*I4[1304];
*(vp++) = U00*I0[1673] + U40*I1[1673]
           + (twoo2zn)*I4[1305];
*(vp++) = U00*I0[1674] + U40*I1[1674]
           + (twoo2zn)*I4[1306];
*(vp++) = U00*I0[1675] + U40*I1[1675]
           + (twoo2zn)*I4[1307];
*(vp++) = U00*I0[1676] + U40*I1[1676]
           + (twoo2zn)*I4[1308];
*(vp++) = U00*I0[1677] + U40*I1[1677]
           + (oneo2zn)*I4[1309];
*(vp++) = U00*I0[1678] + U40*I1[1678]
           + (oneo2zn)*I4[1310];
*(vp++) = U00*I0[1679] + U40*I1[1679]
           + (oneo2zn)*I4[1311];
*(vp++) = U00*I0[1680] + U40*I1[1680]
           + (oneo2zn)*I4[1312];
*(vp++) = U00*I0[1681] + U40*I1[1681]
           + (oneo2zn)*I4[1313];
*(vp++) = U00*I0[1682] + U40*I1[1682]
           + (oneo2zn)*I4[1314];
*(vp++) = U00*I0[1683] + U40*I1[1683]
           + (oneo2zn)*I4[1315];
*(vp++) = U00*I0[1684] + U40*I1[1684];
*(vp++) = U00*I0[1685] + U40*I1[1685];
*(vp++) = U00*I0[1686] + U40*I1[1686];
*(vp++) = U00*I0[1687] + U40*I1[1687];
*(vp++) = U00*I0[1688] + U40*I1[1688];
*(vp++) = U00*I0[1689] + U40*I1[1689];
*(vp++) = U00*I0[1690] + U40*I1[1690];
*(vp++) = U00*I0[1691] + U40*I1[1691];
*(vp++) = U00*I0[1692] + U40*I1[1692]
           + (seveno2zn)*I4[1316];
*(vp++) = U00*I0[1693] + U40*I1[1693]
           + (sixo2zn)*I4[1317];
*(vp++) = U00*I0[1694] + U40*I1[1694]
           + (sixo2zn)*I4[1318];
*(vp++) = U00*I0[1695] + U40*I1[1695]
           + (fiveo2zn)*I4[1319];
*(vp++) = U00*I0[1696] + U40*I1[1696]
           + (fiveo2zn)*I4[1320];
*(vp++) = U00*I0[1697] + U40*I1[1697]
           + (fiveo2zn)*I4[1321];
*(vp++) = U00*I0[1698] + U40*I1[1698]
           + (fouro2zn)*I4[1322];
*(vp++) = U00*I0[1699] + U40*I1[1699]
           + (fouro2zn)*I4[1323];
*(vp++) = U00*I0[1700] + U40*I1[1700]
           + (fouro2zn)*I4[1324];
*(vp++) = U00*I0[1701] + U40*I1[1701]
           + (fouro2zn)*I4[1325];
*(vp++) = U00*I0[1702] + U40*I1[1702]
           + (threeo2zn)*I4[1326];
*(vp++) = U00*I0[1703] + U40*I1[1703]
           + (threeo2zn)*I4[1327];
*(vp++) = U00*I0[1704] + U40*I1[1704]
           + (threeo2zn)*I4[1328];
*(vp++) = U00*I0[1705] + U40*I1[1705]
           + (threeo2zn)*I4[1329];
*(vp++) = U00*I0[1706] + U40*I1[1706]
           + (threeo2zn)*I4[1330];
*(vp++) = U00*I0[1707] + U40*I1[1707]
           + (twoo2zn)*I4[1331];
*(vp++) = U00*I0[1708] + U40*I1[1708]
           + (twoo2zn)*I4[1332];
*(vp++) = U00*I0[1709] + U40*I1[1709]
           + (twoo2zn)*I4[1333];
*(vp++) = U00*I0[1710] + U40*I1[1710]
           + (twoo2zn)*I4[1334];
*(vp++) = U00*I0[1711] + U40*I1[1711]
           + (twoo2zn)*I4[1335];
*(vp++) = U00*I0[1712] + U40*I1[1712]
           + (twoo2zn)*I4[1336];
*(vp++) = U00*I0[1713] + U40*I1[1713]
           + (oneo2zn)*I4[1337];
*(vp++) = U00*I0[1714] + U40*I1[1714]
           + (oneo2zn)*I4[1338];
*(vp++) = U00*I0[1715] + U40*I1[1715]
           + (oneo2zn)*I4[1339];
*(vp++) = U00*I0[1716] + U40*I1[1716]
           + (oneo2zn)*I4[1340];
*(vp++) = U00*I0[1717] + U40*I1[1717]
           + (oneo2zn)*I4[1341];
*(vp++) = U00*I0[1718] + U40*I1[1718]
           + (oneo2zn)*I4[1342];
*(vp++) = U00*I0[1719] + U40*I1[1719]
           + (oneo2zn)*I4[1343];
*(vp++) = U00*I0[1720] + U40*I1[1720];
*(vp++) = U00*I0[1721] + U40*I1[1721];
*(vp++) = U00*I0[1722] + U40*I1[1722];
*(vp++) = U00*I0[1723] + U40*I1[1723];
*(vp++) = U00*I0[1724] + U40*I1[1724];
*(vp++) = U00*I0[1725] + U40*I1[1725];
*(vp++) = U00*I0[1726] + U40*I1[1726];
*(vp++) = U00*I0[1727] + U40*I1[1727];
*(vp++) = U00*I0[1728] + U40*I1[1728]
           + (seveno2zn)*I4[1344];
*(vp++) = U00*I0[1729] + U40*I1[1729]
           + (sixo2zn)*I4[1345];
*(vp++) = U00*I0[1730] + U40*I1[1730]
           + (sixo2zn)*I4[1346];
*(vp++) = U00*I0[1731] + U40*I1[1731]
           + (fiveo2zn)*I4[1347];
*(vp++) = U00*I0[1732] + U40*I1[1732]
           + (fiveo2zn)*I4[1348];
*(vp++) = U00*I0[1733] + U40*I1[1733]
           + (fiveo2zn)*I4[1349];
*(vp++) = U00*I0[1734] + U40*I1[1734]
           + (fouro2zn)*I4[1350];
*(vp++) = U00*I0[1735] + U40*I1[1735]
           + (fouro2zn)*I4[1351];
*(vp++) = U00*I0[1736] + U40*I1[1736]
           + (fouro2zn)*I4[1352];
*(vp++) = U00*I0[1737] + U40*I1[1737]
           + (fouro2zn)*I4[1353];
*(vp++) = U00*I0[1738] + U40*I1[1738]
           + (threeo2zn)*I4[1354];
*(vp++) = U00*I0[1739] + U40*I1[1739]
           + (threeo2zn)*I4[1355];
*(vp++) = U00*I0[1740] + U40*I1[1740]
           + (threeo2zn)*I4[1356];
*(vp++) = U00*I0[1741] + U40*I1[1741]
           + (threeo2zn)*I4[1357];
*(vp++) = U00*I0[1742] + U40*I1[1742]
           + (threeo2zn)*I4[1358];
*(vp++) = U00*I0[1743] + U40*I1[1743]
           + (twoo2zn)*I4[1359];
*(vp++) = U00*I0[1744] + U40*I1[1744]
           + (twoo2zn)*I4[1360];
*(vp++) = U00*I0[1745] + U40*I1[1745]
           + (twoo2zn)*I4[1361];
*(vp++) = U00*I0[1746] + U40*I1[1746]
           + (twoo2zn)*I4[1362];
*(vp++) = U00*I0[1747] + U40*I1[1747]
           + (twoo2zn)*I4[1363];
*(vp++) = U00*I0[1748] + U40*I1[1748]
           + (twoo2zn)*I4[1364];
*(vp++) = U00*I0[1749] + U40*I1[1749]
           + (oneo2zn)*I4[1365];
*(vp++) = U00*I0[1750] + U40*I1[1750]
           + (oneo2zn)*I4[1366];
*(vp++) = U00*I0[1751] + U40*I1[1751]
           + (oneo2zn)*I4[1367];
*(vp++) = U00*I0[1752] + U40*I1[1752]
           + (oneo2zn)*I4[1368];
*(vp++) = U00*I0[1753] + U40*I1[1753]
           + (oneo2zn)*I4[1369];
*(vp++) = U00*I0[1754] + U40*I1[1754]
           + (oneo2zn)*I4[1370];
*(vp++) = U00*I0[1755] + U40*I1[1755]
           + (oneo2zn)*I4[1371];
*(vp++) = U00*I0[1756] + U40*I1[1756];
*(vp++) = U00*I0[1757] + U40*I1[1757];
*(vp++) = U00*I0[1758] + U40*I1[1758];
*(vp++) = U00*I0[1759] + U40*I1[1759];
*(vp++) = U00*I0[1760] + U40*I1[1760];
*(vp++) = U00*I0[1761] + U40*I1[1761];
*(vp++) = U00*I0[1762] + U40*I1[1762];
*(vp++) = U00*I0[1763] + U40*I1[1763];
*(vp++) = U00*I0[1764] + U40*I1[1764]
           + (seveno2zn)*I4[1372];
*(vp++) = U00*I0[1765] + U40*I1[1765]
           + (sixo2zn)*I4[1373];
*(vp++) = U00*I0[1766] + U40*I1[1766]
           + (sixo2zn)*I4[1374];
*(vp++) = U00*I0[1767] + U40*I1[1767]
           + (fiveo2zn)*I4[1375];
*(vp++) = U00*I0[1768] + U40*I1[1768]
           + (fiveo2zn)*I4[1376];
*(vp++) = U00*I0[1769] + U40*I1[1769]
           + (fiveo2zn)*I4[1377];
*(vp++) = U00*I0[1770] + U40*I1[1770]
           + (fouro2zn)*I4[1378];
*(vp++) = U00*I0[1771] + U40*I1[1771]
           + (fouro2zn)*I4[1379];
*(vp++) = U00*I0[1772] + U40*I1[1772]
           + (fouro2zn)*I4[1380];
*(vp++) = U00*I0[1773] + U40*I1[1773]
           + (fouro2zn)*I4[1381];
*(vp++) = U00*I0[1774] + U40*I1[1774]
           + (threeo2zn)*I4[1382];
*(vp++) = U00*I0[1775] + U40*I1[1775]
           + (threeo2zn)*I4[1383];
*(vp++) = U00*I0[1776] + U40*I1[1776]
           + (threeo2zn)*I4[1384];
*(vp++) = U00*I0[1777] + U40*I1[1777]
           + (threeo2zn)*I4[1385];
*(vp++) = U00*I0[1778] + U40*I1[1778]
           + (threeo2zn)*I4[1386];
*(vp++) = U00*I0[1779] + U40*I1[1779]
           + (twoo2zn)*I4[1387];
*(vp++) = U00*I0[1780] + U40*I1[1780]
           + (twoo2zn)*I4[1388];
*(vp++) = U00*I0[1781] + U40*I1[1781]
           + (twoo2zn)*I4[1389];
*(vp++) = U00*I0[1782] + U40*I1[1782]
           + (twoo2zn)*I4[1390];
*(vp++) = U00*I0[1783] + U40*I1[1783]
           + (twoo2zn)*I4[1391];
*(vp++) = U00*I0[1784] + U40*I1[1784]
           + (twoo2zn)*I4[1392];
*(vp++) = U00*I0[1785] + U40*I1[1785]
           + (oneo2zn)*I4[1393];
*(vp++) = U00*I0[1786] + U40*I1[1786]
           + (oneo2zn)*I4[1394];
*(vp++) = U00*I0[1787] + U40*I1[1787]
           + (oneo2zn)*I4[1395];
return vp;
}

REALTYPE *_build_n0k0_6(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U00*I0[1788] + U40*I1[1788]
           + (oneo2zn)*I4[1396];
*(vp++) = U00*I0[1789] + U40*I1[1789]
           + (oneo2zn)*I4[1397];
*(vp++) = U00*I0[1790] + U40*I1[1790]
           + (oneo2zn)*I4[1398];
*(vp++) = U00*I0[1791] + U40*I1[1791]
           + (oneo2zn)*I4[1399];
*(vp++) = U00*I0[1792] + U40*I1[1792];
*(vp++) = U00*I0[1793] + U40*I1[1793];
*(vp++) = U00*I0[1794] + U40*I1[1794];
*(vp++) = U00*I0[1795] + U40*I1[1795];
*(vp++) = U00*I0[1796] + U40*I1[1796];
*(vp++) = U00*I0[1797] + U40*I1[1797];
*(vp++) = U00*I0[1798] + U40*I1[1798];
*(vp++) = U00*I0[1799] + U40*I1[1799];
*(vp++) = U00*I0[1800] + U40*I1[1800]
           + (seveno2zn)*I4[1400];
*(vp++) = U00*I0[1801] + U40*I1[1801]
           + (sixo2zn)*I4[1401];
*(vp++) = U00*I0[1802] + U40*I1[1802]
           + (sixo2zn)*I4[1402];
*(vp++) = U00*I0[1803] + U40*I1[1803]
           + (fiveo2zn)*I4[1403];
*(vp++) = U00*I0[1804] + U40*I1[1804]
           + (fiveo2zn)*I4[1404];
*(vp++) = U00*I0[1805] + U40*I1[1805]
           + (fiveo2zn)*I4[1405];
*(vp++) = U00*I0[1806] + U40*I1[1806]
           + (fouro2zn)*I4[1406];
*(vp++) = U00*I0[1807] + U40*I1[1807]
           + (fouro2zn)*I4[1407];
*(vp++) = U00*I0[1808] + U40*I1[1808]
           + (fouro2zn)*I4[1408];
*(vp++) = U00*I0[1809] + U40*I1[1809]
           + (fouro2zn)*I4[1409];
*(vp++) = U00*I0[1810] + U40*I1[1810]
           + (threeo2zn)*I4[1410];
*(vp++) = U00*I0[1811] + U40*I1[1811]
           + (threeo2zn)*I4[1411];
*(vp++) = U00*I0[1812] + U40*I1[1812]
           + (threeo2zn)*I4[1412];
*(vp++) = U00*I0[1813] + U40*I1[1813]
           + (threeo2zn)*I4[1413];
*(vp++) = U00*I0[1814] + U40*I1[1814]
           + (threeo2zn)*I4[1414];
*(vp++) = U00*I0[1815] + U40*I1[1815]
           + (twoo2zn)*I4[1415];
*(vp++) = U00*I0[1816] + U40*I1[1816]
           + (twoo2zn)*I4[1416];
*(vp++) = U00*I0[1817] + U40*I1[1817]
           + (twoo2zn)*I4[1417];
*(vp++) = U00*I0[1818] + U40*I1[1818]
           + (twoo2zn)*I4[1418];
*(vp++) = U00*I0[1819] + U40*I1[1819]
           + (twoo2zn)*I4[1419];
*(vp++) = U00*I0[1820] + U40*I1[1820]
           + (twoo2zn)*I4[1420];
*(vp++) = U00*I0[1821] + U40*I1[1821]
           + (oneo2zn)*I4[1421];
*(vp++) = U00*I0[1822] + U40*I1[1822]
           + (oneo2zn)*I4[1422];
*(vp++) = U00*I0[1823] + U40*I1[1823]
           + (oneo2zn)*I4[1423];
*(vp++) = U00*I0[1824] + U40*I1[1824]
           + (oneo2zn)*I4[1424];
*(vp++) = U00*I0[1825] + U40*I1[1825]
           + (oneo2zn)*I4[1425];
*(vp++) = U00*I0[1826] + U40*I1[1826]
           + (oneo2zn)*I4[1426];
*(vp++) = U00*I0[1827] + U40*I1[1827]
           + (oneo2zn)*I4[1427];
*(vp++) = U00*I0[1828] + U40*I1[1828];
*(vp++) = U00*I0[1829] + U40*I1[1829];
*(vp++) = U00*I0[1830] + U40*I1[1830];
*(vp++) = U00*I0[1831] + U40*I1[1831];
*(vp++) = U00*I0[1832] + U40*I1[1832];
*(vp++) = U00*I0[1833] + U40*I1[1833];
*(vp++) = U00*I0[1834] + U40*I1[1834];
*(vp++) = U00*I0[1835] + U40*I1[1835];
*(vp++) = U00*I0[1836] + U40*I1[1836]
           + (seveno2zn)*I4[1428];
*(vp++) = U00*I0[1837] + U40*I1[1837]
           + (sixo2zn)*I4[1429];
*(vp++) = U00*I0[1838] + U40*I1[1838]
           + (sixo2zn)*I4[1430];
*(vp++) = U00*I0[1839] + U40*I1[1839]
           + (fiveo2zn)*I4[1431];
*(vp++) = U00*I0[1840] + U40*I1[1840]
           + (fiveo2zn)*I4[1432];
*(vp++) = U00*I0[1841] + U40*I1[1841]
           + (fiveo2zn)*I4[1433];
*(vp++) = U00*I0[1842] + U40*I1[1842]
           + (fouro2zn)*I4[1434];
*(vp++) = U00*I0[1843] + U40*I1[1843]
           + (fouro2zn)*I4[1435];
*(vp++) = U00*I0[1844] + U40*I1[1844]
           + (fouro2zn)*I4[1436];
*(vp++) = U00*I0[1845] + U40*I1[1845]
           + (fouro2zn)*I4[1437];
*(vp++) = U00*I0[1846] + U40*I1[1846]
           + (threeo2zn)*I4[1438];
*(vp++) = U00*I0[1847] + U40*I1[1847]
           + (threeo2zn)*I4[1439];
*(vp++) = U00*I0[1848] + U40*I1[1848]
           + (threeo2zn)*I4[1440];
*(vp++) = U00*I0[1849] + U40*I1[1849]
           + (threeo2zn)*I4[1441];
*(vp++) = U00*I0[1850] + U40*I1[1850]
           + (threeo2zn)*I4[1442];
*(vp++) = U00*I0[1851] + U40*I1[1851]
           + (twoo2zn)*I4[1443];
*(vp++) = U00*I0[1852] + U40*I1[1852]
           + (twoo2zn)*I4[1444];
*(vp++) = U00*I0[1853] + U40*I1[1853]
           + (twoo2zn)*I4[1445];
*(vp++) = U00*I0[1854] + U40*I1[1854]
           + (twoo2zn)*I4[1446];
*(vp++) = U00*I0[1855] + U40*I1[1855]
           + (twoo2zn)*I4[1447];
*(vp++) = U00*I0[1856] + U40*I1[1856]
           + (twoo2zn)*I4[1448];
*(vp++) = U00*I0[1857] + U40*I1[1857]
           + (oneo2zn)*I4[1449];
*(vp++) = U00*I0[1858] + U40*I1[1858]
           + (oneo2zn)*I4[1450];
*(vp++) = U00*I0[1859] + U40*I1[1859]
           + (oneo2zn)*I4[1451];
*(vp++) = U00*I0[1860] + U40*I1[1860]
           + (oneo2zn)*I4[1452];
*(vp++) = U00*I0[1861] + U40*I1[1861]
           + (oneo2zn)*I4[1453];
*(vp++) = U00*I0[1862] + U40*I1[1862]
           + (oneo2zn)*I4[1454];
*(vp++) = U00*I0[1863] + U40*I1[1863]
           + (oneo2zn)*I4[1455];
*(vp++) = U00*I0[1864] + U40*I1[1864];
*(vp++) = U00*I0[1865] + U40*I1[1865];
*(vp++) = U00*I0[1866] + U40*I1[1866];
*(vp++) = U00*I0[1867] + U40*I1[1867];
*(vp++) = U00*I0[1868] + U40*I1[1868];
*(vp++) = U00*I0[1869] + U40*I1[1869];
*(vp++) = U00*I0[1870] + U40*I1[1870];
*(vp++) = U00*I0[1871] + U40*I1[1871];
*(vp++) = U00*I0[1872] + U40*I1[1872]
           + (seveno2zn)*I4[1456];
*(vp++) = U00*I0[1873] + U40*I1[1873]
           + (sixo2zn)*I4[1457];
*(vp++) = U00*I0[1874] + U40*I1[1874]
           + (sixo2zn)*I4[1458];
*(vp++) = U00*I0[1875] + U40*I1[1875]
           + (fiveo2zn)*I4[1459];
*(vp++) = U00*I0[1876] + U40*I1[1876]
           + (fiveo2zn)*I4[1460];
*(vp++) = U00*I0[1877] + U40*I1[1877]
           + (fiveo2zn)*I4[1461];
*(vp++) = U00*I0[1878] + U40*I1[1878]
           + (fouro2zn)*I4[1462];
*(vp++) = U00*I0[1879] + U40*I1[1879]
           + (fouro2zn)*I4[1463];
*(vp++) = U00*I0[1880] + U40*I1[1880]
           + (fouro2zn)*I4[1464];
*(vp++) = U00*I0[1881] + U40*I1[1881]
           + (fouro2zn)*I4[1465];
*(vp++) = U00*I0[1882] + U40*I1[1882]
           + (threeo2zn)*I4[1466];
*(vp++) = U00*I0[1883] + U40*I1[1883]
           + (threeo2zn)*I4[1467];
*(vp++) = U00*I0[1884] + U40*I1[1884]
           + (threeo2zn)*I4[1468];
*(vp++) = U00*I0[1885] + U40*I1[1885]
           + (threeo2zn)*I4[1469];
*(vp++) = U00*I0[1886] + U40*I1[1886]
           + (threeo2zn)*I4[1470];
*(vp++) = U00*I0[1887] + U40*I1[1887]
           + (twoo2zn)*I4[1471];
*(vp++) = U00*I0[1888] + U40*I1[1888]
           + (twoo2zn)*I4[1472];
*(vp++) = U00*I0[1889] + U40*I1[1889]
           + (twoo2zn)*I4[1473];
*(vp++) = U00*I0[1890] + U40*I1[1890]
           + (twoo2zn)*I4[1474];
*(vp++) = U00*I0[1891] + U40*I1[1891]
           + (twoo2zn)*I4[1475];
*(vp++) = U00*I0[1892] + U40*I1[1892]
           + (twoo2zn)*I4[1476];
*(vp++) = U00*I0[1893] + U40*I1[1893]
           + (oneo2zn)*I4[1477];
*(vp++) = U00*I0[1894] + U40*I1[1894]
           + (oneo2zn)*I4[1478];
*(vp++) = U00*I0[1895] + U40*I1[1895]
           + (oneo2zn)*I4[1479];
*(vp++) = U00*I0[1896] + U40*I1[1896]
           + (oneo2zn)*I4[1480];
*(vp++) = U00*I0[1897] + U40*I1[1897]
           + (oneo2zn)*I4[1481];
*(vp++) = U00*I0[1898] + U40*I1[1898]
           + (oneo2zn)*I4[1482];
*(vp++) = U00*I0[1899] + U40*I1[1899]
           + (oneo2zn)*I4[1483];
*(vp++) = U00*I0[1900] + U40*I1[1900];
*(vp++) = U00*I0[1901] + U40*I1[1901];
*(vp++) = U00*I0[1902] + U40*I1[1902];
*(vp++) = U00*I0[1903] + U40*I1[1903];
*(vp++) = U00*I0[1904] + U40*I1[1904];
*(vp++) = U00*I0[1905] + U40*I1[1905];
*(vp++) = U00*I0[1906] + U40*I1[1906];
*(vp++) = U00*I0[1907] + U40*I1[1907];
*(vp++) = U00*I0[1908] + U40*I1[1908]
           + (seveno2zn)*I4[1484];
*(vp++) = U00*I0[1909] + U40*I1[1909]
           + (sixo2zn)*I4[1485];
*(vp++) = U00*I0[1910] + U40*I1[1910]
           + (sixo2zn)*I4[1486];
*(vp++) = U00*I0[1911] + U40*I1[1911]
           + (fiveo2zn)*I4[1487];
*(vp++) = U00*I0[1912] + U40*I1[1912]
           + (fiveo2zn)*I4[1488];
*(vp++) = U00*I0[1913] + U40*I1[1913]
           + (fiveo2zn)*I4[1489];
*(vp++) = U00*I0[1914] + U40*I1[1914]
           + (fouro2zn)*I4[1490];
*(vp++) = U00*I0[1915] + U40*I1[1915]
           + (fouro2zn)*I4[1491];
*(vp++) = U00*I0[1916] + U40*I1[1916]
           + (fouro2zn)*I4[1492];
*(vp++) = U00*I0[1917] + U40*I1[1917]
           + (fouro2zn)*I4[1493];
*(vp++) = U00*I0[1918] + U40*I1[1918]
           + (threeo2zn)*I4[1494];
*(vp++) = U00*I0[1919] + U40*I1[1919]
           + (threeo2zn)*I4[1495];
*(vp++) = U00*I0[1920] + U40*I1[1920]
           + (threeo2zn)*I4[1496];
*(vp++) = U00*I0[1921] + U40*I1[1921]
           + (threeo2zn)*I4[1497];
*(vp++) = U00*I0[1922] + U40*I1[1922]
           + (threeo2zn)*I4[1498];
*(vp++) = U00*I0[1923] + U40*I1[1923]
           + (twoo2zn)*I4[1499];
*(vp++) = U00*I0[1924] + U40*I1[1924]
           + (twoo2zn)*I4[1500];
*(vp++) = U00*I0[1925] + U40*I1[1925]
           + (twoo2zn)*I4[1501];
*(vp++) = U00*I0[1926] + U40*I1[1926]
           + (twoo2zn)*I4[1502];
*(vp++) = U00*I0[1927] + U40*I1[1927]
           + (twoo2zn)*I4[1503];
*(vp++) = U00*I0[1928] + U40*I1[1928]
           + (twoo2zn)*I4[1504];
*(vp++) = U00*I0[1929] + U40*I1[1929]
           + (oneo2zn)*I4[1505];
*(vp++) = U00*I0[1930] + U40*I1[1930]
           + (oneo2zn)*I4[1506];
*(vp++) = U00*I0[1931] + U40*I1[1931]
           + (oneo2zn)*I4[1507];
*(vp++) = U00*I0[1932] + U40*I1[1932]
           + (oneo2zn)*I4[1508];
*(vp++) = U00*I0[1933] + U40*I1[1933]
           + (oneo2zn)*I4[1509];
*(vp++) = U00*I0[1934] + U40*I1[1934]
           + (oneo2zn)*I4[1510];
*(vp++) = U00*I0[1935] + U40*I1[1935]
           + (oneo2zn)*I4[1511];
*(vp++) = U00*I0[1936] + U40*I1[1936];
*(vp++) = U00*I0[1937] + U40*I1[1937];
*(vp++) = U00*I0[1938] + U40*I1[1938];
*(vp++) = U00*I0[1939] + U40*I1[1939];
*(vp++) = U00*I0[1940] + U40*I1[1940];
*(vp++) = U00*I0[1941] + U40*I1[1941];
*(vp++) = U00*I0[1942] + U40*I1[1942];
*(vp++) = U00*I0[1943] + U40*I1[1943];
*(vp++) = U00*I0[1944] + U40*I1[1944]
           + (seveno2zn)*I4[1512];
*(vp++) = U00*I0[1945] + U40*I1[1945]
           + (sixo2zn)*I4[1513];
*(vp++) = U00*I0[1946] + U40*I1[1946]
           + (sixo2zn)*I4[1514];
*(vp++) = U00*I0[1947] + U40*I1[1947]
           + (fiveo2zn)*I4[1515];
*(vp++) = U00*I0[1948] + U40*I1[1948]
           + (fiveo2zn)*I4[1516];
*(vp++) = U00*I0[1949] + U40*I1[1949]
           + (fiveo2zn)*I4[1517];
*(vp++) = U00*I0[1950] + U40*I1[1950]
           + (fouro2zn)*I4[1518];
*(vp++) = U00*I0[1951] + U40*I1[1951]
           + (fouro2zn)*I4[1519];
*(vp++) = U00*I0[1952] + U40*I1[1952]
           + (fouro2zn)*I4[1520];
*(vp++) = U00*I0[1953] + U40*I1[1953]
           + (fouro2zn)*I4[1521];
*(vp++) = U00*I0[1954] + U40*I1[1954]
           + (threeo2zn)*I4[1522];
*(vp++) = U00*I0[1955] + U40*I1[1955]
           + (threeo2zn)*I4[1523];
*(vp++) = U00*I0[1956] + U40*I1[1956]
           + (threeo2zn)*I4[1524];
*(vp++) = U00*I0[1957] + U40*I1[1957]
           + (threeo2zn)*I4[1525];
*(vp++) = U00*I0[1958] + U40*I1[1958]
           + (threeo2zn)*I4[1526];
*(vp++) = U00*I0[1959] + U40*I1[1959]
           + (twoo2zn)*I4[1527];
*(vp++) = U00*I0[1960] + U40*I1[1960]
           + (twoo2zn)*I4[1528];
*(vp++) = U00*I0[1961] + U40*I1[1961]
           + (twoo2zn)*I4[1529];
*(vp++) = U00*I0[1962] + U40*I1[1962]
           + (twoo2zn)*I4[1530];
*(vp++) = U00*I0[1963] + U40*I1[1963]
           + (twoo2zn)*I4[1531];
*(vp++) = U00*I0[1964] + U40*I1[1964]
           + (twoo2zn)*I4[1532];
*(vp++) = U00*I0[1965] + U40*I1[1965]
           + (oneo2zn)*I4[1533];
*(vp++) = U00*I0[1966] + U40*I1[1966]
           + (oneo2zn)*I4[1534];
*(vp++) = U00*I0[1967] + U40*I1[1967]
           + (oneo2zn)*I4[1535];
*(vp++) = U00*I0[1968] + U40*I1[1968]
           + (oneo2zn)*I4[1536];
*(vp++) = U00*I0[1969] + U40*I1[1969]
           + (oneo2zn)*I4[1537];
*(vp++) = U00*I0[1970] + U40*I1[1970]
           + (oneo2zn)*I4[1538];
*(vp++) = U00*I0[1971] + U40*I1[1971]
           + (oneo2zn)*I4[1539];
*(vp++) = U00*I0[1972] + U40*I1[1972];
*(vp++) = U00*I0[1973] + U40*I1[1973];
*(vp++) = U00*I0[1974] + U40*I1[1974];
*(vp++) = U00*I0[1975] + U40*I1[1975];
*(vp++) = U00*I0[1976] + U40*I1[1976];
*(vp++) = U00*I0[1977] + U40*I1[1977];
*(vp++) = U00*I0[1978] + U40*I1[1978];
*(vp++) = U00*I0[1979] + U40*I1[1979];
*(vp++) = U01*I0[1620] + U41*I1[1620]
           + (nineo2z)*(I2[1296] - (lpoz)*I3[1296]);
*(vp++) = U01*I0[1621] + U41*I1[1621]
           + (nineo2z)*(I2[1297] - (lpoz)*I3[1297])
           + (oneo2zn)*I4[1260];
*(vp++) = U01*I0[1622] + U41*I1[1622]
           + (nineo2z)*(I2[1298] - (lpoz)*I3[1298]);
*(vp++) = U01*I0[1623] + U41*I1[1623]
           + (nineo2z)*(I2[1299] - (lpoz)*I3[1299])
           + (twoo2zn)*I4[1261];
*(vp++) = U01*I0[1624] + U41*I1[1624]
           + (nineo2z)*(I2[1300] - (lpoz)*I3[1300])
           + (oneo2zn)*I4[1262];
*(vp++) = U01*I0[1625] + U41*I1[1625]
           + (nineo2z)*(I2[1301] - (lpoz)*I3[1301]);
*(vp++) = U01*I0[1626] + U41*I1[1626]
           + (nineo2z)*(I2[1302] - (lpoz)*I3[1302])
           + (threeo2zn)*I4[1263];
*(vp++) = U01*I0[1627] + U41*I1[1627]
           + (nineo2z)*(I2[1303] - (lpoz)*I3[1303])
           + (twoo2zn)*I4[1264];
*(vp++) = U01*I0[1628] + U41*I1[1628]
           + (nineo2z)*(I2[1304] - (lpoz)*I3[1304])
           + (oneo2zn)*I4[1265];
*(vp++) = U01*I0[1629] + U41*I1[1629]
           + (nineo2z)*(I2[1305] - (lpoz)*I3[1305]);
*(vp++) = U01*I0[1630] + U41*I1[1630]
           + (nineo2z)*(I2[1306] - (lpoz)*I3[1306])
           + (fouro2zn)*I4[1266];
*(vp++) = U01*I0[1631] + U41*I1[1631]
           + (nineo2z)*(I2[1307] - (lpoz)*I3[1307])
           + (threeo2zn)*I4[1267];
*(vp++) = U01*I0[1632] + U41*I1[1632]
           + (nineo2z)*(I2[1308] - (lpoz)*I3[1308])
           + (twoo2zn)*I4[1268];
*(vp++) = U01*I0[1633] + U41*I1[1633]
           + (nineo2z)*(I2[1309] - (lpoz)*I3[1309])
           + (oneo2zn)*I4[1269];
*(vp++) = U01*I0[1634] + U41*I1[1634]
           + (nineo2z)*(I2[1310] - (lpoz)*I3[1310]);
*(vp++) = U01*I0[1635] + U41*I1[1635]
           + (nineo2z)*(I2[1311] - (lpoz)*I3[1311])
           + (fiveo2zn)*I4[1270];
*(vp++) = U01*I0[1636] + U41*I1[1636]
           + (nineo2z)*(I2[1312] - (lpoz)*I3[1312])
           + (fouro2zn)*I4[1271];
*(vp++) = U01*I0[1637] + U41*I1[1637]
           + (nineo2z)*(I2[1313] - (lpoz)*I3[1313])
           + (threeo2zn)*I4[1272];
*(vp++) = U01*I0[1638] + U41*I1[1638]
           + (nineo2z)*(I2[1314] - (lpoz)*I3[1314])
           + (twoo2zn)*I4[1273];
*(vp++) = U01*I0[1639] + U41*I1[1639]
           + (nineo2z)*(I2[1315] - (lpoz)*I3[1315])
           + (oneo2zn)*I4[1274];
*(vp++) = U01*I0[1640] + U41*I1[1640]
           + (nineo2z)*(I2[1316] - (lpoz)*I3[1316]);
*(vp++) = U01*I0[1641] + U41*I1[1641]
           + (nineo2z)*(I2[1317] - (lpoz)*I3[1317])
           + (sixo2zn)*I4[1275];
*(vp++) = U01*I0[1642] + U41*I1[1642]
           + (nineo2z)*(I2[1318] - (lpoz)*I3[1318])
           + (fiveo2zn)*I4[1276];
*(vp++) = U01*I0[1643] + U41*I1[1643]
           + (nineo2z)*(I2[1319] - (lpoz)*I3[1319])
           + (fouro2zn)*I4[1277];
*(vp++) = U01*I0[1644] + U41*I1[1644]
           + (nineo2z)*(I2[1320] - (lpoz)*I3[1320])
           + (threeo2zn)*I4[1278];
*(vp++) = U01*I0[1645] + U41*I1[1645]
           + (nineo2z)*(I2[1321] - (lpoz)*I3[1321])
           + (twoo2zn)*I4[1279];
*(vp++) = U01*I0[1646] + U41*I1[1646]
           + (nineo2z)*(I2[1322] - (lpoz)*I3[1322])
           + (oneo2zn)*I4[1280];
*(vp++) = U01*I0[1647] + U41*I1[1647]
           + (nineo2z)*(I2[1323] - (lpoz)*I3[1323]);
*(vp++) = U01*I0[1648] + U41*I1[1648]
           + (nineo2z)*(I2[1324] - (lpoz)*I3[1324])
           + (seveno2zn)*I4[1281];
*(vp++) = U01*I0[1649] + U41*I1[1649]
           + (nineo2z)*(I2[1325] - (lpoz)*I3[1325])
           + (sixo2zn)*I4[1282];
*(vp++) = U01*I0[1650] + U41*I1[1650]
           + (nineo2z)*(I2[1326] - (lpoz)*I3[1326])
           + (fiveo2zn)*I4[1283];
*(vp++) = U01*I0[1651] + U41*I1[1651]
           + (nineo2z)*(I2[1327] - (lpoz)*I3[1327])
           + (fouro2zn)*I4[1284];
*(vp++) = U01*I0[1652] + U41*I1[1652]
           + (nineo2z)*(I2[1328] - (lpoz)*I3[1328])
           + (threeo2zn)*I4[1285];
*(vp++) = U01*I0[1653] + U41*I1[1653]
           + (nineo2z)*(I2[1329] - (lpoz)*I3[1329])
           + (twoo2zn)*I4[1286];
*(vp++) = U01*I0[1654] + U41*I1[1654]
           + (nineo2z)*(I2[1330] - (lpoz)*I3[1330])
           + (oneo2zn)*I4[1287];
*(vp++) = U01*I0[1655] + U41*I1[1655]
           + (nineo2z)*(I2[1331] - (lpoz)*I3[1331]);
*(vp++) = U01*I0[1656] + U41*I1[1656]
           + (eighto2z)*(I2[1332] - (lpoz)*I3[1332]);
*(vp++) = U01*I0[1657] + U41*I1[1657]
           + (eighto2z)*(I2[1333] - (lpoz)*I3[1333])
           + (oneo2zn)*I4[1288];
*(vp++) = U01*I0[1658] + U41*I1[1658]
           + (eighto2z)*(I2[1334] - (lpoz)*I3[1334]);
*(vp++) = U01*I0[1659] + U41*I1[1659]
           + (eighto2z)*(I2[1335] - (lpoz)*I3[1335])
           + (twoo2zn)*I4[1289];
*(vp++) = U01*I0[1660] + U41*I1[1660]
           + (eighto2z)*(I2[1336] - (lpoz)*I3[1336])
           + (oneo2zn)*I4[1290];
*(vp++) = U01*I0[1661] + U41*I1[1661]
           + (eighto2z)*(I2[1337] - (lpoz)*I3[1337]);
*(vp++) = U01*I0[1662] + U41*I1[1662]
           + (eighto2z)*(I2[1338] - (lpoz)*I3[1338])
           + (threeo2zn)*I4[1291];
*(vp++) = U01*I0[1663] + U41*I1[1663]
           + (eighto2z)*(I2[1339] - (lpoz)*I3[1339])
           + (twoo2zn)*I4[1292];
*(vp++) = U01*I0[1664] + U41*I1[1664]
           + (eighto2z)*(I2[1340] - (lpoz)*I3[1340])
           + (oneo2zn)*I4[1293];
*(vp++) = U01*I0[1665] + U41*I1[1665]
           + (eighto2z)*(I2[1341] - (lpoz)*I3[1341]);
*(vp++) = U01*I0[1666] + U41*I1[1666]
           + (eighto2z)*(I2[1342] - (lpoz)*I3[1342])
           + (fouro2zn)*I4[1294];
*(vp++) = U01*I0[1667] + U41*I1[1667]
           + (eighto2z)*(I2[1343] - (lpoz)*I3[1343])
           + (threeo2zn)*I4[1295];
*(vp++) = U01*I0[1668] + U41*I1[1668]
           + (eighto2z)*(I2[1344] - (lpoz)*I3[1344])
           + (twoo2zn)*I4[1296];
*(vp++) = U01*I0[1669] + U41*I1[1669]
           + (eighto2z)*(I2[1345] - (lpoz)*I3[1345])
           + (oneo2zn)*I4[1297];
*(vp++) = U01*I0[1670] + U41*I1[1670]
           + (eighto2z)*(I2[1346] - (lpoz)*I3[1346]);
*(vp++) = U01*I0[1671] + U41*I1[1671]
           + (eighto2z)*(I2[1347] - (lpoz)*I3[1347])
           + (fiveo2zn)*I4[1298];
*(vp++) = U01*I0[1672] + U41*I1[1672]
           + (eighto2z)*(I2[1348] - (lpoz)*I3[1348])
           + (fouro2zn)*I4[1299];
*(vp++) = U01*I0[1673] + U41*I1[1673]
           + (eighto2z)*(I2[1349] - (lpoz)*I3[1349])
           + (threeo2zn)*I4[1300];
*(vp++) = U01*I0[1674] + U41*I1[1674]
           + (eighto2z)*(I2[1350] - (lpoz)*I3[1350])
           + (twoo2zn)*I4[1301];
*(vp++) = U01*I0[1675] + U41*I1[1675]
           + (eighto2z)*(I2[1351] - (lpoz)*I3[1351])
           + (oneo2zn)*I4[1302];
*(vp++) = U01*I0[1676] + U41*I1[1676]
           + (eighto2z)*(I2[1352] - (lpoz)*I3[1352]);
*(vp++) = U01*I0[1677] + U41*I1[1677]
           + (eighto2z)*(I2[1353] - (lpoz)*I3[1353])
           + (sixo2zn)*I4[1303];
*(vp++) = U01*I0[1678] + U41*I1[1678]
           + (eighto2z)*(I2[1354] - (lpoz)*I3[1354])
           + (fiveo2zn)*I4[1304];
*(vp++) = U01*I0[1679] + U41*I1[1679]
           + (eighto2z)*(I2[1355] - (lpoz)*I3[1355])
           + (fouro2zn)*I4[1305];
*(vp++) = U01*I0[1680] + U41*I1[1680]
           + (eighto2z)*(I2[1356] - (lpoz)*I3[1356])
           + (threeo2zn)*I4[1306];
*(vp++) = U01*I0[1681] + U41*I1[1681]
           + (eighto2z)*(I2[1357] - (lpoz)*I3[1357])
           + (twoo2zn)*I4[1307];
*(vp++) = U01*I0[1682] + U41*I1[1682]
           + (eighto2z)*(I2[1358] - (lpoz)*I3[1358])
           + (oneo2zn)*I4[1308];
*(vp++) = U01*I0[1683] + U41*I1[1683]
           + (eighto2z)*(I2[1359] - (lpoz)*I3[1359]);
*(vp++) = U01*I0[1684] + U41*I1[1684]
           + (eighto2z)*(I2[1360] - (lpoz)*I3[1360])
           + (seveno2zn)*I4[1309];
*(vp++) = U01*I0[1685] + U41*I1[1685]
           + (eighto2z)*(I2[1361] - (lpoz)*I3[1361])
           + (sixo2zn)*I4[1310];
*(vp++) = U01*I0[1686] + U41*I1[1686]
           + (eighto2z)*(I2[1362] - (lpoz)*I3[1362])
           + (fiveo2zn)*I4[1311];
*(vp++) = U01*I0[1687] + U41*I1[1687]
           + (eighto2z)*(I2[1363] - (lpoz)*I3[1363])
           + (fouro2zn)*I4[1312];
*(vp++) = U01*I0[1688] + U41*I1[1688]
           + (eighto2z)*(I2[1364] - (lpoz)*I3[1364])
           + (threeo2zn)*I4[1313];
*(vp++) = U01*I0[1689] + U41*I1[1689]
           + (eighto2z)*(I2[1365] - (lpoz)*I3[1365])
           + (twoo2zn)*I4[1314];
*(vp++) = U01*I0[1690] + U41*I1[1690]
           + (eighto2z)*(I2[1366] - (lpoz)*I3[1366])
           + (oneo2zn)*I4[1315];
*(vp++) = U01*I0[1691] + U41*I1[1691]
           + (eighto2z)*(I2[1367] - (lpoz)*I3[1367]);
*(vp++) = U01*I0[1692] + U41*I1[1692]
           + (seveno2z)*(I2[1368] - (lpoz)*I3[1368]);
*(vp++) = U01*I0[1693] + U41*I1[1693]
           + (seveno2z)*(I2[1369] - (lpoz)*I3[1369])
           + (oneo2zn)*I4[1316];
*(vp++) = U01*I0[1694] + U41*I1[1694]
           + (seveno2z)*(I2[1370] - (lpoz)*I3[1370]);
*(vp++) = U01*I0[1695] + U41*I1[1695]
           + (seveno2z)*(I2[1371] - (lpoz)*I3[1371])
           + (twoo2zn)*I4[1317];
*(vp++) = U01*I0[1696] + U41*I1[1696]
           + (seveno2z)*(I2[1372] - (lpoz)*I3[1372])
           + (oneo2zn)*I4[1318];
*(vp++) = U01*I0[1697] + U41*I1[1697]
           + (seveno2z)*(I2[1373] - (lpoz)*I3[1373]);
*(vp++) = U01*I0[1698] + U41*I1[1698]
           + (seveno2z)*(I2[1374] - (lpoz)*I3[1374])
           + (threeo2zn)*I4[1319];
*(vp++) = U01*I0[1699] + U41*I1[1699]
           + (seveno2z)*(I2[1375] - (lpoz)*I3[1375])
           + (twoo2zn)*I4[1320];
*(vp++) = U01*I0[1700] + U41*I1[1700]
           + (seveno2z)*(I2[1376] - (lpoz)*I3[1376])
           + (oneo2zn)*I4[1321];
*(vp++) = U01*I0[1701] + U41*I1[1701]
           + (seveno2z)*(I2[1377] - (lpoz)*I3[1377]);
*(vp++) = U01*I0[1702] + U41*I1[1702]
           + (seveno2z)*(I2[1378] - (lpoz)*I3[1378])
           + (fouro2zn)*I4[1322];
*(vp++) = U01*I0[1703] + U41*I1[1703]
           + (seveno2z)*(I2[1379] - (lpoz)*I3[1379])
           + (threeo2zn)*I4[1323];
*(vp++) = U01*I0[1704] + U41*I1[1704]
           + (seveno2z)*(I2[1380] - (lpoz)*I3[1380])
           + (twoo2zn)*I4[1324];
*(vp++) = U01*I0[1705] + U41*I1[1705]
           + (seveno2z)*(I2[1381] - (lpoz)*I3[1381])
           + (oneo2zn)*I4[1325];
*(vp++) = U01*I0[1706] + U41*I1[1706]
           + (seveno2z)*(I2[1382] - (lpoz)*I3[1382]);
*(vp++) = U01*I0[1707] + U41*I1[1707]
           + (seveno2z)*(I2[1383] - (lpoz)*I3[1383])
           + (fiveo2zn)*I4[1326];
*(vp++) = U01*I0[1708] + U41*I1[1708]
           + (seveno2z)*(I2[1384] - (lpoz)*I3[1384])
           + (fouro2zn)*I4[1327];
*(vp++) = U01*I0[1709] + U41*I1[1709]
           + (seveno2z)*(I2[1385] - (lpoz)*I3[1385])
           + (threeo2zn)*I4[1328];
*(vp++) = U01*I0[1710] + U41*I1[1710]
           + (seveno2z)*(I2[1386] - (lpoz)*I3[1386])
           + (twoo2zn)*I4[1329];
*(vp++) = U01*I0[1711] + U41*I1[1711]
           + (seveno2z)*(I2[1387] - (lpoz)*I3[1387])
           + (oneo2zn)*I4[1330];
*(vp++) = U01*I0[1712] + U41*I1[1712]
           + (seveno2z)*(I2[1388] - (lpoz)*I3[1388]);
*(vp++) = U01*I0[1713] + U41*I1[1713]
           + (seveno2z)*(I2[1389] - (lpoz)*I3[1389])
           + (sixo2zn)*I4[1331];
*(vp++) = U01*I0[1714] + U41*I1[1714]
           + (seveno2z)*(I2[1390] - (lpoz)*I3[1390])
           + (fiveo2zn)*I4[1332];
*(vp++) = U01*I0[1715] + U41*I1[1715]
           + (seveno2z)*(I2[1391] - (lpoz)*I3[1391])
           + (fouro2zn)*I4[1333];
*(vp++) = U01*I0[1716] + U41*I1[1716]
           + (seveno2z)*(I2[1392] - (lpoz)*I3[1392])
           + (threeo2zn)*I4[1334];
*(vp++) = U01*I0[1717] + U41*I1[1717]
           + (seveno2z)*(I2[1393] - (lpoz)*I3[1393])
           + (twoo2zn)*I4[1335];
*(vp++) = U01*I0[1718] + U41*I1[1718]
           + (seveno2z)*(I2[1394] - (lpoz)*I3[1394])
           + (oneo2zn)*I4[1336];
*(vp++) = U01*I0[1719] + U41*I1[1719]
           + (seveno2z)*(I2[1395] - (lpoz)*I3[1395]);
*(vp++) = U01*I0[1720] + U41*I1[1720]
           + (seveno2z)*(I2[1396] - (lpoz)*I3[1396])
           + (seveno2zn)*I4[1337];
*(vp++) = U01*I0[1721] + U41*I1[1721]
           + (seveno2z)*(I2[1397] - (lpoz)*I3[1397])
           + (sixo2zn)*I4[1338];
*(vp++) = U01*I0[1722] + U41*I1[1722]
           + (seveno2z)*(I2[1398] - (lpoz)*I3[1398])
           + (fiveo2zn)*I4[1339];
*(vp++) = U01*I0[1723] + U41*I1[1723]
           + (seveno2z)*(I2[1399] - (lpoz)*I3[1399])
           + (fouro2zn)*I4[1340];
*(vp++) = U01*I0[1724] + U41*I1[1724]
           + (seveno2z)*(I2[1400] - (lpoz)*I3[1400])
           + (threeo2zn)*I4[1341];
*(vp++) = U01*I0[1725] + U41*I1[1725]
           + (seveno2z)*(I2[1401] - (lpoz)*I3[1401])
           + (twoo2zn)*I4[1342];
return vp;
}

REALTYPE *_build_n0k0_7(prim_data *Data, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U00, U01, U02, U10, U11, U12, U20, U21, U22;
  REALTYPE U30, U31, U32, U40, U41, U42, U50, U51, U52;
  REALTYPE lpoz = Data->poz;
  REALTYPE lpon = Data->pon;
  REALTYPE oneo2zn;
  REALTYPE twoo2zn;
  REALTYPE threeo2zn;
  REALTYPE fouro2zn;
  REALTYPE fiveo2zn;
  REALTYPE sixo2zn;
  REALTYPE seveno2zn;
  REALTYPE oneo2z;
  REALTYPE twoo2z;
  REALTYPE threeo2z;
  REALTYPE fouro2z;
  REALTYPE fiveo2z;
  REALTYPE sixo2z;
  REALTYPE seveno2z;
  REALTYPE eighto2z;
  REALTYPE nineo2z;
  oneo2zn = 1.0*Data->oo2zn;
  twoo2zn = 2.0*Data->oo2zn;
  threeo2zn = 3.0*Data->oo2zn;
  fouro2zn = 4.0*Data->oo2zn;
  fiveo2zn = 5.0*Data->oo2zn;
  sixo2zn = 6.0*Data->oo2zn;
  seveno2zn = 7.0*Data->oo2zn;
  oneo2z = 1.0*Data->oo2z;
  twoo2z = 2.0*Data->oo2z;
  threeo2z = 3.0*Data->oo2z;
  fouro2z = 4.0*Data->oo2z;
  fiveo2z = 5.0*Data->oo2z;
  sixo2z = 6.0*Data->oo2z;
  seveno2z = 7.0*Data->oo2z;
  eighto2z = 8.0*Data->oo2z;
  nineo2z = 9.0*Data->oo2z;
  U00 = Data->U[0][0];
  U01 = Data->U[0][1];
  U02 = Data->U[0][2];
  U40 = Data->U[4][0];
  U41 = Data->U[4][1];
  U42 = Data->U[4][2];


*(vp++) = U01*I0[1726] + U41*I1[1726]
           + (seveno2z)*(I2[1402] - (lpoz)*I3[1402])
           + (oneo2zn)*I4[1343];
*(vp++) = U01*I0[1727] + U41*I1[1727]
           + (seveno2z)*(I2[1403] - (lpoz)*I3[1403]);
*(vp++) = U01*I0[1728] + U41*I1[1728]
           + (sixo2z)*(I2[1404] - (lpoz)*I3[1404]);
*(vp++) = U01*I0[1729] + U41*I1[1729]
           + (sixo2z)*(I2[1405] - (lpoz)*I3[1405])
           + (oneo2zn)*I4[1344];
*(vp++) = U01*I0[1730] + U41*I1[1730]
           + (sixo2z)*(I2[1406] - (lpoz)*I3[1406]);
*(vp++) = U01*I0[1731] + U41*I1[1731]
           + (sixo2z)*(I2[1407] - (lpoz)*I3[1407])
           + (twoo2zn)*I4[1345];
*(vp++) = U01*I0[1732] + U41*I1[1732]
           + (sixo2z)*(I2[1408] - (lpoz)*I3[1408])
           + (oneo2zn)*I4[1346];
*(vp++) = U01*I0[1733] + U41*I1[1733]
           + (sixo2z)*(I2[1409] - (lpoz)*I3[1409]);
*(vp++) = U01*I0[1734] + U41*I1[1734]
           + (sixo2z)*(I2[1410] - (lpoz)*I3[1410])
           + (threeo2zn)*I4[1347];
*(vp++) = U01*I0[1735] + U41*I1[1735]
           + (sixo2z)*(I2[1411] - (lpoz)*I3[1411])
           + (twoo2zn)*I4[1348];
*(vp++) = U01*I0[1736] + U41*I1[1736]
           + (sixo2z)*(I2[1412] - (lpoz)*I3[1412])
           + (oneo2zn)*I4[1349];
*(vp++) = U01*I0[1737] + U41*I1[1737]
           + (sixo2z)*(I2[1413] - (lpoz)*I3[1413]);
*(vp++) = U01*I0[1738] + U41*I1[1738]
           + (sixo2z)*(I2[1414] - (lpoz)*I3[1414])
           + (fouro2zn)*I4[1350];
*(vp++) = U01*I0[1739] + U41*I1[1739]
           + (sixo2z)*(I2[1415] - (lpoz)*I3[1415])
           + (threeo2zn)*I4[1351];
*(vp++) = U01*I0[1740] + U41*I1[1740]
           + (sixo2z)*(I2[1416] - (lpoz)*I3[1416])
           + (twoo2zn)*I4[1352];
*(vp++) = U01*I0[1741] + U41*I1[1741]
           + (sixo2z)*(I2[1417] - (lpoz)*I3[1417])
           + (oneo2zn)*I4[1353];
*(vp++) = U01*I0[1742] + U41*I1[1742]
           + (sixo2z)*(I2[1418] - (lpoz)*I3[1418]);
*(vp++) = U01*I0[1743] + U41*I1[1743]
           + (sixo2z)*(I2[1419] - (lpoz)*I3[1419])
           + (fiveo2zn)*I4[1354];
*(vp++) = U01*I0[1744] + U41*I1[1744]
           + (sixo2z)*(I2[1420] - (lpoz)*I3[1420])
           + (fouro2zn)*I4[1355];
*(vp++) = U01*I0[1745] + U41*I1[1745]
           + (sixo2z)*(I2[1421] - (lpoz)*I3[1421])
           + (threeo2zn)*I4[1356];
*(vp++) = U01*I0[1746] + U41*I1[1746]
           + (sixo2z)*(I2[1422] - (lpoz)*I3[1422])
           + (twoo2zn)*I4[1357];
*(vp++) = U01*I0[1747] + U41*I1[1747]
           + (sixo2z)*(I2[1423] - (lpoz)*I3[1423])
           + (oneo2zn)*I4[1358];
*(vp++) = U01*I0[1748] + U41*I1[1748]
           + (sixo2z)*(I2[1424] - (lpoz)*I3[1424]);
*(vp++) = U01*I0[1749] + U41*I1[1749]
           + (sixo2z)*(I2[1425] - (lpoz)*I3[1425])
           + (sixo2zn)*I4[1359];
*(vp++) = U01*I0[1750] + U41*I1[1750]
           + (sixo2z)*(I2[1426] - (lpoz)*I3[1426])
           + (fiveo2zn)*I4[1360];
*(vp++) = U01*I0[1751] + U41*I1[1751]
           + (sixo2z)*(I2[1427] - (lpoz)*I3[1427])
           + (fouro2zn)*I4[1361];
*(vp++) = U01*I0[1752] + U41*I1[1752]
           + (sixo2z)*(I2[1428] - (lpoz)*I3[1428])
           + (threeo2zn)*I4[1362];
*(vp++) = U01*I0[1753] + U41*I1[1753]
           + (sixo2z)*(I2[1429] - (lpoz)*I3[1429])
           + (twoo2zn)*I4[1363];
*(vp++) = U01*I0[1754] + U41*I1[1754]
           + (sixo2z)*(I2[1430] - (lpoz)*I3[1430])
           + (oneo2zn)*I4[1364];
*(vp++) = U01*I0[1755] + U41*I1[1755]
           + (sixo2z)*(I2[1431] - (lpoz)*I3[1431]);
*(vp++) = U01*I0[1756] + U41*I1[1756]
           + (sixo2z)*(I2[1432] - (lpoz)*I3[1432])
           + (seveno2zn)*I4[1365];
*(vp++) = U01*I0[1757] + U41*I1[1757]
           + (sixo2z)*(I2[1433] - (lpoz)*I3[1433])
           + (sixo2zn)*I4[1366];
*(vp++) = U01*I0[1758] + U41*I1[1758]
           + (sixo2z)*(I2[1434] - (lpoz)*I3[1434])
           + (fiveo2zn)*I4[1367];
*(vp++) = U01*I0[1759] + U41*I1[1759]
           + (sixo2z)*(I2[1435] - (lpoz)*I3[1435])
           + (fouro2zn)*I4[1368];
*(vp++) = U01*I0[1760] + U41*I1[1760]
           + (sixo2z)*(I2[1436] - (lpoz)*I3[1436])
           + (threeo2zn)*I4[1369];
*(vp++) = U01*I0[1761] + U41*I1[1761]
           + (sixo2z)*(I2[1437] - (lpoz)*I3[1437])
           + (twoo2zn)*I4[1370];
*(vp++) = U01*I0[1762] + U41*I1[1762]
           + (sixo2z)*(I2[1438] - (lpoz)*I3[1438])
           + (oneo2zn)*I4[1371];
*(vp++) = U01*I0[1763] + U41*I1[1763]
           + (sixo2z)*(I2[1439] - (lpoz)*I3[1439]);
*(vp++) = U01*I0[1764] + U41*I1[1764]
           + (fiveo2z)*(I2[1440] - (lpoz)*I3[1440]);
*(vp++) = U01*I0[1765] + U41*I1[1765]
           + (fiveo2z)*(I2[1441] - (lpoz)*I3[1441])
           + (oneo2zn)*I4[1372];
*(vp++) = U01*I0[1766] + U41*I1[1766]
           + (fiveo2z)*(I2[1442] - (lpoz)*I3[1442]);
*(vp++) = U01*I0[1767] + U41*I1[1767]
           + (fiveo2z)*(I2[1443] - (lpoz)*I3[1443])
           + (twoo2zn)*I4[1373];
*(vp++) = U01*I0[1768] + U41*I1[1768]
           + (fiveo2z)*(I2[1444] - (lpoz)*I3[1444])
           + (oneo2zn)*I4[1374];
*(vp++) = U01*I0[1769] + U41*I1[1769]
           + (fiveo2z)*(I2[1445] - (lpoz)*I3[1445]);
*(vp++) = U01*I0[1770] + U41*I1[1770]
           + (fiveo2z)*(I2[1446] - (lpoz)*I3[1446])
           + (threeo2zn)*I4[1375];
*(vp++) = U01*I0[1771] + U41*I1[1771]
           + (fiveo2z)*(I2[1447] - (lpoz)*I3[1447])
           + (twoo2zn)*I4[1376];
*(vp++) = U01*I0[1772] + U41*I1[1772]
           + (fiveo2z)*(I2[1448] - (lpoz)*I3[1448])
           + (oneo2zn)*I4[1377];
*(vp++) = U01*I0[1773] + U41*I1[1773]
           + (fiveo2z)*(I2[1449] - (lpoz)*I3[1449]);
*(vp++) = U01*I0[1774] + U41*I1[1774]
           + (fiveo2z)*(I2[1450] - (lpoz)*I3[1450])
           + (fouro2zn)*I4[1378];
*(vp++) = U01*I0[1775] + U41*I1[1775]
           + (fiveo2z)*(I2[1451] - (lpoz)*I3[1451])
           + (threeo2zn)*I4[1379];
*(vp++) = U01*I0[1776] + U41*I1[1776]
           + (fiveo2z)*(I2[1452] - (lpoz)*I3[1452])
           + (twoo2zn)*I4[1380];
*(vp++) = U01*I0[1777] + U41*I1[1777]
           + (fiveo2z)*(I2[1453] - (lpoz)*I3[1453])
           + (oneo2zn)*I4[1381];
*(vp++) = U01*I0[1778] + U41*I1[1778]
           + (fiveo2z)*(I2[1454] - (lpoz)*I3[1454]);
*(vp++) = U01*I0[1779] + U41*I1[1779]
           + (fiveo2z)*(I2[1455] - (lpoz)*I3[1455])
           + (fiveo2zn)*I4[1382];
*(vp++) = U01*I0[1780] + U41*I1[1780]
           + (fiveo2z)*(I2[1456] - (lpoz)*I3[1456])
           + (fouro2zn)*I4[1383];
*(vp++) = U01*I0[1781] + U41*I1[1781]
           + (fiveo2z)*(I2[1457] - (lpoz)*I3[1457])
           + (threeo2zn)*I4[1384];
*(vp++) = U01*I0[1782] + U41*I1[1782]
           + (fiveo2z)*(I2[1458] - (lpoz)*I3[1458])
           + (twoo2zn)*I4[1385];
*(vp++) = U01*I0[1783] + U41*I1[1783]
           + (fiveo2z)*(I2[1459] - (lpoz)*I3[1459])
           + (oneo2zn)*I4[1386];
*(vp++) = U01*I0[1784] + U41*I1[1784]
           + (fiveo2z)*(I2[1460] - (lpoz)*I3[1460]);
*(vp++) = U01*I0[1785] + U41*I1[1785]
           + (fiveo2z)*(I2[1461] - (lpoz)*I3[1461])
           + (sixo2zn)*I4[1387];
*(vp++) = U01*I0[1786] + U41*I1[1786]
           + (fiveo2z)*(I2[1462] - (lpoz)*I3[1462])
           + (fiveo2zn)*I4[1388];
*(vp++) = U01*I0[1787] + U41*I1[1787]
           + (fiveo2z)*(I2[1463] - (lpoz)*I3[1463])
           + (fouro2zn)*I4[1389];
*(vp++) = U01*I0[1788] + U41*I1[1788]
           + (fiveo2z)*(I2[1464] - (lpoz)*I3[1464])
           + (threeo2zn)*I4[1390];
*(vp++) = U01*I0[1789] + U41*I1[1789]
           + (fiveo2z)*(I2[1465] - (lpoz)*I3[1465])
           + (twoo2zn)*I4[1391];
*(vp++) = U01*I0[1790] + U41*I1[1790]
           + (fiveo2z)*(I2[1466] - (lpoz)*I3[1466])
           + (oneo2zn)*I4[1392];
*(vp++) = U01*I0[1791] + U41*I1[1791]
           + (fiveo2z)*(I2[1467] - (lpoz)*I3[1467]);
*(vp++) = U01*I0[1792] + U41*I1[1792]
           + (fiveo2z)*(I2[1468] - (lpoz)*I3[1468])
           + (seveno2zn)*I4[1393];
*(vp++) = U01*I0[1793] + U41*I1[1793]
           + (fiveo2z)*(I2[1469] - (lpoz)*I3[1469])
           + (sixo2zn)*I4[1394];
*(vp++) = U01*I0[1794] + U41*I1[1794]
           + (fiveo2z)*(I2[1470] - (lpoz)*I3[1470])
           + (fiveo2zn)*I4[1395];
*(vp++) = U01*I0[1795] + U41*I1[1795]
           + (fiveo2z)*(I2[1471] - (lpoz)*I3[1471])
           + (fouro2zn)*I4[1396];
*(vp++) = U01*I0[1796] + U41*I1[1796]
           + (fiveo2z)*(I2[1472] - (lpoz)*I3[1472])
           + (threeo2zn)*I4[1397];
*(vp++) = U01*I0[1797] + U41*I1[1797]
           + (fiveo2z)*(I2[1473] - (lpoz)*I3[1473])
           + (twoo2zn)*I4[1398];
*(vp++) = U01*I0[1798] + U41*I1[1798]
           + (fiveo2z)*(I2[1474] - (lpoz)*I3[1474])
           + (oneo2zn)*I4[1399];
*(vp++) = U01*I0[1799] + U41*I1[1799]
           + (fiveo2z)*(I2[1475] - (lpoz)*I3[1475]);
*(vp++) = U01*I0[1800] + U41*I1[1800]
           + (fouro2z)*(I2[1476] - (lpoz)*I3[1476]);
*(vp++) = U01*I0[1801] + U41*I1[1801]
           + (fouro2z)*(I2[1477] - (lpoz)*I3[1477])
           + (oneo2zn)*I4[1400];
*(vp++) = U01*I0[1802] + U41*I1[1802]
           + (fouro2z)*(I2[1478] - (lpoz)*I3[1478]);
*(vp++) = U01*I0[1803] + U41*I1[1803]
           + (fouro2z)*(I2[1479] - (lpoz)*I3[1479])
           + (twoo2zn)*I4[1401];
*(vp++) = U01*I0[1804] + U41*I1[1804]
           + (fouro2z)*(I2[1480] - (lpoz)*I3[1480])
           + (oneo2zn)*I4[1402];
*(vp++) = U01*I0[1805] + U41*I1[1805]
           + (fouro2z)*(I2[1481] - (lpoz)*I3[1481]);
*(vp++) = U01*I0[1806] + U41*I1[1806]
           + (fouro2z)*(I2[1482] - (lpoz)*I3[1482])
           + (threeo2zn)*I4[1403];
*(vp++) = U01*I0[1807] + U41*I1[1807]
           + (fouro2z)*(I2[1483] - (lpoz)*I3[1483])
           + (twoo2zn)*I4[1404];
*(vp++) = U01*I0[1808] + U41*I1[1808]
           + (fouro2z)*(I2[1484] - (lpoz)*I3[1484])
           + (oneo2zn)*I4[1405];
*(vp++) = U01*I0[1809] + U41*I1[1809]
           + (fouro2z)*(I2[1485] - (lpoz)*I3[1485]);
*(vp++) = U01*I0[1810] + U41*I1[1810]
           + (fouro2z)*(I2[1486] - (lpoz)*I3[1486])
           + (fouro2zn)*I4[1406];
*(vp++) = U01*I0[1811] + U41*I1[1811]
           + (fouro2z)*(I2[1487] - (lpoz)*I3[1487])
           + (threeo2zn)*I4[1407];
*(vp++) = U01*I0[1812] + U41*I1[1812]
           + (fouro2z)*(I2[1488] - (lpoz)*I3[1488])
           + (twoo2zn)*I4[1408];
*(vp++) = U01*I0[1813] + U41*I1[1813]
           + (fouro2z)*(I2[1489] - (lpoz)*I3[1489])
           + (oneo2zn)*I4[1409];
*(vp++) = U01*I0[1814] + U41*I1[1814]
           + (fouro2z)*(I2[1490] - (lpoz)*I3[1490]);
*(vp++) = U01*I0[1815] + U41*I1[1815]
           + (fouro2z)*(I2[1491] - (lpoz)*I3[1491])
           + (fiveo2zn)*I4[1410];
*(vp++) = U01*I0[1816] + U41*I1[1816]
           + (fouro2z)*(I2[1492] - (lpoz)*I3[1492])
           + (fouro2zn)*I4[1411];
*(vp++) = U01*I0[1817] + U41*I1[1817]
           + (fouro2z)*(I2[1493] - (lpoz)*I3[1493])
           + (threeo2zn)*I4[1412];
*(vp++) = U01*I0[1818] + U41*I1[1818]
           + (fouro2z)*(I2[1494] - (lpoz)*I3[1494])
           + (twoo2zn)*I4[1413];
*(vp++) = U01*I0[1819] + U41*I1[1819]
           + (fouro2z)*(I2[1495] - (lpoz)*I3[1495])
           + (oneo2zn)*I4[1414];
*(vp++) = U01*I0[1820] + U41*I1[1820]
           + (fouro2z)*(I2[1496] - (lpoz)*I3[1496]);
*(vp++) = U01*I0[1821] + U41*I1[1821]
           + (fouro2z)*(I2[1497] - (lpoz)*I3[1497])
           + (sixo2zn)*I4[1415];
*(vp++) = U01*I0[1822] + U41*I1[1822]
           + (fouro2z)*(I2[1498] - (lpoz)*I3[1498])
           + (fiveo2zn)*I4[1416];
*(vp++) = U01*I0[1823] + U41*I1[1823]
           + (fouro2z)*(I2[1499] - (lpoz)*I3[1499])
           + (fouro2zn)*I4[1417];
*(vp++) = U01*I0[1824] + U41*I1[1824]
           + (fouro2z)*(I2[1500] - (lpoz)*I3[1500])
           + (threeo2zn)*I4[1418];
*(vp++) = U01*I0[1825] + U41*I1[1825]
           + (fouro2z)*(I2[1501] - (lpoz)*I3[1501])
           + (twoo2zn)*I4[1419];
*(vp++) = U01*I0[1826] + U41*I1[1826]
           + (fouro2z)*(I2[1502] - (lpoz)*I3[1502])
           + (oneo2zn)*I4[1420];
*(vp++) = U01*I0[1827] + U41*I1[1827]
           + (fouro2z)*(I2[1503] - (lpoz)*I3[1503]);
*(vp++) = U01*I0[1828] + U41*I1[1828]
           + (fouro2z)*(I2[1504] - (lpoz)*I3[1504])
           + (seveno2zn)*I4[1421];
*(vp++) = U01*I0[1829] + U41*I1[1829]
           + (fouro2z)*(I2[1505] - (lpoz)*I3[1505])
           + (sixo2zn)*I4[1422];
*(vp++) = U01*I0[1830] + U41*I1[1830]
           + (fouro2z)*(I2[1506] - (lpoz)*I3[1506])
           + (fiveo2zn)*I4[1423];
*(vp++) = U01*I0[1831] + U41*I1[1831]
           + (fouro2z)*(I2[1507] - (lpoz)*I3[1507])
           + (fouro2zn)*I4[1424];
*(vp++) = U01*I0[1832] + U41*I1[1832]
           + (fouro2z)*(I2[1508] - (lpoz)*I3[1508])
           + (threeo2zn)*I4[1425];
*(vp++) = U01*I0[1833] + U41*I1[1833]
           + (fouro2z)*(I2[1509] - (lpoz)*I3[1509])
           + (twoo2zn)*I4[1426];
*(vp++) = U01*I0[1834] + U41*I1[1834]
           + (fouro2z)*(I2[1510] - (lpoz)*I3[1510])
           + (oneo2zn)*I4[1427];
*(vp++) = U01*I0[1835] + U41*I1[1835]
           + (fouro2z)*(I2[1511] - (lpoz)*I3[1511]);
*(vp++) = U01*I0[1836] + U41*I1[1836]
           + (threeo2z)*(I2[1512] - (lpoz)*I3[1512]);
*(vp++) = U01*I0[1837] + U41*I1[1837]
           + (threeo2z)*(I2[1513] - (lpoz)*I3[1513])
           + (oneo2zn)*I4[1428];
*(vp++) = U01*I0[1838] + U41*I1[1838]
           + (threeo2z)*(I2[1514] - (lpoz)*I3[1514]);
*(vp++) = U01*I0[1839] + U41*I1[1839]
           + (threeo2z)*(I2[1515] - (lpoz)*I3[1515])
           + (twoo2zn)*I4[1429];
*(vp++) = U01*I0[1840] + U41*I1[1840]
           + (threeo2z)*(I2[1516] - (lpoz)*I3[1516])
           + (oneo2zn)*I4[1430];
*(vp++) = U01*I0[1841] + U41*I1[1841]
           + (threeo2z)*(I2[1517] - (lpoz)*I3[1517]);
*(vp++) = U01*I0[1842] + U41*I1[1842]
           + (threeo2z)*(I2[1518] - (lpoz)*I3[1518])
           + (threeo2zn)*I4[1431];
*(vp++) = U01*I0[1843] + U41*I1[1843]
           + (threeo2z)*(I2[1519] - (lpoz)*I3[1519])
           + (twoo2zn)*I4[1432];
*(vp++) = U01*I0[1844] + U41*I1[1844]
           + (threeo2z)*(I2[1520] - (lpoz)*I3[1520])
           + (oneo2zn)*I4[1433];
*(vp++) = U01*I0[1845] + U41*I1[1845]
           + (threeo2z)*(I2[1521] - (lpoz)*I3[1521]);
*(vp++) = U01*I0[1846] + U41*I1[1846]
           + (threeo2z)*(I2[1522] - (lpoz)*I3[1522])
           + (fouro2zn)*I4[1434];
*(vp++) = U01*I0[1847] + U41*I1[1847]
           + (threeo2z)*(I2[1523] - (lpoz)*I3[1523])
           + (threeo2zn)*I4[1435];
*(vp++) = U01*I0[1848] + U41*I1[1848]
           + (threeo2z)*(I2[1524] - (lpoz)*I3[1524])
           + (twoo2zn)*I4[1436];
*(vp++) = U01*I0[1849] + U41*I1[1849]
           + (threeo2z)*(I2[1525] - (lpoz)*I3[1525])
           + (oneo2zn)*I4[1437];
*(vp++) = U01*I0[1850] + U41*I1[1850]
           + (threeo2z)*(I2[1526] - (lpoz)*I3[1526]);
*(vp++) = U01*I0[1851] + U41*I1[1851]
           + (threeo2z)*(I2[1527] - (lpoz)*I3[1527])
           + (fiveo2zn)*I4[1438];
*(vp++) = U01*I0[1852] + U41*I1[1852]
           + (threeo2z)*(I2[1528] - (lpoz)*I3[1528])
           + (fouro2zn)*I4[1439];
*(vp++) = U01*I0[1853] + U41*I1[1853]
           + (threeo2z)*(I2[1529] - (lpoz)*I3[1529])
           + (threeo2zn)*I4[1440];
*(vp++) = U01*I0[1854] + U41*I1[1854]
           + (threeo2z)*(I2[1530] - (lpoz)*I3[1530])
           + (twoo2zn)*I4[1441];
*(vp++) = U01*I0[1855] + U41*I1[1855]
           + (threeo2z)*(I2[1531] - (lpoz)*I3[1531])
           + (oneo2zn)*I4[1442];
*(vp++) = U01*I0[1856] + U41*I1[1856]
           + (threeo2z)*(I2[1532] - (lpoz)*I3[1532]);
*(vp++) = U01*I0[1857] + U41*I1[1857]
           + (threeo2z)*(I2[1533] - (lpoz)*I3[1533])
           + (sixo2zn)*I4[1443];
*(vp++) = U01*I0[1858] + U41*I1[1858]
           + (threeo2z)*(I2[1534] - (lpoz)*I3[1534])
           + (fiveo2zn)*I4[1444];
*(vp++) = U01*I0[1859] + U41*I1[1859]
           + (threeo2z)*(I2[1535] - (lpoz)*I3[1535])
           + (fouro2zn)*I4[1445];
*(vp++) = U01*I0[1860] + U41*I1[1860]
           + (threeo2z)*(I2[1536] - (lpoz)*I3[1536])
           + (threeo2zn)*I4[1446];
*(vp++) = U01*I0[1861] + U41*I1[1861]
           + (threeo2z)*(I2[1537] - (lpoz)*I3[1537])
           + (twoo2zn)*I4[1447];
*(vp++) = U01*I0[1862] + U41*I1[1862]
           + (threeo2z)*(I2[1538] - (lpoz)*I3[1538])
           + (oneo2zn)*I4[1448];
*(vp++) = U01*I0[1863] + U41*I1[1863]
           + (threeo2z)*(I2[1539] - (lpoz)*I3[1539]);
*(vp++) = U01*I0[1864] + U41*I1[1864]
           + (threeo2z)*(I2[1540] - (lpoz)*I3[1540])
           + (seveno2zn)*I4[1449];
*(vp++) = U01*I0[1865] + U41*I1[1865]
           + (threeo2z)*(I2[1541] - (lpoz)*I3[1541])
           + (sixo2zn)*I4[1450];
*(vp++) = U01*I0[1866] + U41*I1[1866]
           + (threeo2z)*(I2[1542] - (lpoz)*I3[1542])
           + (fiveo2zn)*I4[1451];
*(vp++) = U01*I0[1867] + U41*I1[1867]
           + (threeo2z)*(I2[1543] - (lpoz)*I3[1543])
           + (fouro2zn)*I4[1452];
*(vp++) = U01*I0[1868] + U41*I1[1868]
           + (threeo2z)*(I2[1544] - (lpoz)*I3[1544])
           + (threeo2zn)*I4[1453];
*(vp++) = U01*I0[1869] + U41*I1[1869]
           + (threeo2z)*(I2[1545] - (lpoz)*I3[1545])
           + (twoo2zn)*I4[1454];
*(vp++) = U01*I0[1870] + U41*I1[1870]
           + (threeo2z)*(I2[1546] - (lpoz)*I3[1546])
           + (oneo2zn)*I4[1455];
*(vp++) = U01*I0[1871] + U41*I1[1871]
           + (threeo2z)*(I2[1547] - (lpoz)*I3[1547]);
*(vp++) = U01*I0[1872] + U41*I1[1872]
           + (twoo2z)*(I2[1548] - (lpoz)*I3[1548]);
*(vp++) = U01*I0[1873] + U41*I1[1873]
           + (twoo2z)*(I2[1549] - (lpoz)*I3[1549])
           + (oneo2zn)*I4[1456];
*(vp++) = U01*I0[1874] + U41*I1[1874]
           + (twoo2z)*(I2[1550] - (lpoz)*I3[1550]);
*(vp++) = U01*I0[1875] + U41*I1[1875]
           + (twoo2z)*(I2[1551] - (lpoz)*I3[1551])
           + (twoo2zn)*I4[1457];
*(vp++) = U01*I0[1876] + U41*I1[1876]
           + (twoo2z)*(I2[1552] - (lpoz)*I3[1552])
           + (oneo2zn)*I4[1458];
*(vp++) = U01*I0[1877] + U41*I1[1877]
           + (twoo2z)*(I2[1553] - (lpoz)*I3[1553]);
*(vp++) = U01*I0[1878] + U41*I1[1878]
           + (twoo2z)*(I2[1554] - (lpoz)*I3[1554])
           + (threeo2zn)*I4[1459];
*(vp++) = U01*I0[1879] + U41*I1[1879]
           + (twoo2z)*(I2[1555] - (lpoz)*I3[1555])
           + (twoo2zn)*I4[1460];
*(vp++) = U01*I0[1880] + U41*I1[1880]
           + (twoo2z)*(I2[1556] - (lpoz)*I3[1556])
           + (oneo2zn)*I4[1461];
*(vp++) = U01*I0[1881] + U41*I1[1881]
           + (twoo2z)*(I2[1557] - (lpoz)*I3[1557]);
*(vp++) = U01*I0[1882] + U41*I1[1882]
           + (twoo2z)*(I2[1558] - (lpoz)*I3[1558])
           + (fouro2zn)*I4[1462];
*(vp++) = U01*I0[1883] + U41*I1[1883]
           + (twoo2z)*(I2[1559] - (lpoz)*I3[1559])
           + (threeo2zn)*I4[1463];
*(vp++) = U01*I0[1884] + U41*I1[1884]
           + (twoo2z)*(I2[1560] - (lpoz)*I3[1560])
           + (twoo2zn)*I4[1464];
*(vp++) = U01*I0[1885] + U41*I1[1885]
           + (twoo2z)*(I2[1561] - (lpoz)*I3[1561])
           + (oneo2zn)*I4[1465];
*(vp++) = U01*I0[1886] + U41*I1[1886]
           + (twoo2z)*(I2[1562] - (lpoz)*I3[1562]);
*(vp++) = U01*I0[1887] + U41*I1[1887]
           + (twoo2z)*(I2[1563] - (lpoz)*I3[1563])
           + (fiveo2zn)*I4[1466];
*(vp++) = U01*I0[1888] + U41*I1[1888]
           + (twoo2z)*(I2[1564] - (lpoz)*I3[1564])
           + (fouro2zn)*I4[1467];
*(vp++) = U01*I0[1889] + U41*I1[1889]
           + (twoo2z)*(I2[1565] - (lpoz)*I3[1565])
           + (threeo2zn)*I4[1468];
*(vp++) = U01*I0[1890] + U41*I1[1890]
           + (twoo2z)*(I2[1566] - (lpoz)*I3[1566])
           + (twoo2zn)*I4[1469];
*(vp++) = U01*I0[1891] + U41*I1[1891]
           + (twoo2z)*(I2[1567] - (lpoz)*I3[1567])
           + (oneo2zn)*I4[1470];
*(vp++) = U01*I0[1892] + U41*I1[1892]
           + (twoo2z)*(I2[1568] - (lpoz)*I3[1568]);
*(vp++) = U01*I0[1893] + U41*I1[1893]
           + (twoo2z)*(I2[1569] - (lpoz)*I3[1569])
           + (sixo2zn)*I4[1471];
*(vp++) = U01*I0[1894] + U41*I1[1894]
           + (twoo2z)*(I2[1570] - (lpoz)*I3[1570])
           + (fiveo2zn)*I4[1472];
*(vp++) = U01*I0[1895] + U41*I1[1895]
           + (twoo2z)*(I2[1571] - (lpoz)*I3[1571])
           + (fouro2zn)*I4[1473];
*(vp++) = U01*I0[1896] + U41*I1[1896]
           + (twoo2z)*(I2[1572] - (lpoz)*I3[1572])
           + (threeo2zn)*I4[1474];
*(vp++) = U01*I0[1897] + U41*I1[1897]
           + (twoo2z)*(I2[1573] - (lpoz)*I3[1573])
           + (twoo2zn)*I4[1475];
*(vp++) = U01*I0[1898] + U41*I1[1898]
           + (twoo2z)*(I2[1574] - (lpoz)*I3[1574])
           + (oneo2zn)*I4[1476];
*(vp++) = U01*I0[1899] + U41*I1[1899]
           + (twoo2z)*(I2[1575] - (lpoz)*I3[1575]);
*(vp++) = U01*I0[1900] + U41*I1[1900]
           + (twoo2z)*(I2[1576] - (lpoz)*I3[1576])
           + (seveno2zn)*I4[1477];
*(vp++) = U01*I0[1901] + U41*I1[1901]
           + (twoo2z)*(I2[1577] - (lpoz)*I3[1577])
           + (sixo2zn)*I4[1478];
*(vp++) = U01*I0[1902] + U41*I1[1902]
           + (twoo2z)*(I2[1578] - (lpoz)*I3[1578])
           + (fiveo2zn)*I4[1479];
*(vp++) = U01*I0[1903] + U41*I1[1903]
           + (twoo2z)*(I2[1579] - (lpoz)*I3[1579])
           + (fouro2zn)*I4[1480];
*(vp++) = U01*I0[1904] + U41*I1[1904]
           + (twoo2z)*(I2[1580] - (lpoz)*I3[1580])
           + (threeo2zn)*I4[1481];
*(vp++) = U01*I0[1905] + U41*I1[1905]
           + (twoo2z)*(I2[1581] - (lpoz)*I3[1581])
           + (twoo2zn)*I4[1482];
*(vp++) = U01*I0[1906] + U41*I1[1906]
           + (twoo2z)*(I2[1582] - (lpoz)*I3[1582])
           + (oneo2zn)*I4[1483];
*(vp++) = U01*I0[1907] + U41*I1[1907]
           + (twoo2z)*(I2[1583] - (lpoz)*I3[1583]);
*(vp++) = U01*I0[1908] + U41*I1[1908]
           + (oneo2z)*(I2[1584] - (lpoz)*I3[1584]);
*(vp++) = U01*I0[1909] + U41*I1[1909]
           + (oneo2z)*(I2[1585] - (lpoz)*I3[1585])
           + (oneo2zn)*I4[1484];
*(vp++) = U01*I0[1910] + U41*I1[1910]
           + (oneo2z)*(I2[1586] - (lpoz)*I3[1586]);
*(vp++) = U01*I0[1911] + U41*I1[1911]
           + (oneo2z)*(I2[1587] - (lpoz)*I3[1587])
           + (twoo2zn)*I4[1485];
*(vp++) = U01*I0[1912] + U41*I1[1912]
           + (oneo2z)*(I2[1588] - (lpoz)*I3[1588])
           + (oneo2zn)*I4[1486];
*(vp++) = U01*I0[1913] + U41*I1[1913]
           + (oneo2z)*(I2[1589] - (lpoz)*I3[1589]);
*(vp++) = U01*I0[1914] + U41*I1[1914]
           + (oneo2z)*(I2[1590] - (lpoz)*I3[1590])
           + (threeo2zn)*I4[1487];
*(vp++) = U01*I0[1915] + U41*I1[1915]
           + (oneo2z)*(I2[1591] - (lpoz)*I3[1591])
           + (twoo2zn)*I4[1488];
*(vp++) = U01*I0[1916] + U41*I1[1916]
           + (oneo2z)*(I2[1592] - (lpoz)*I3[1592])
           + (oneo2zn)*I4[1489];
*(vp++) = U01*I0[1917] + U41*I1[1917]
           + (oneo2z)*(I2[1593] - (lpoz)*I3[1593]);
*(vp++) = U01*I0[1918] + U41*I1[1918]
           + (oneo2z)*(I2[1594] - (lpoz)*I3[1594])
           + (fouro2zn)*I4[1490];
*(vp++) = U01*I0[1919] + U41*I1[1919]
           + (oneo2z)*(I2[1595] - (lpoz)*I3[1595])
           + (threeo2zn)*I4[1491];
*(vp++) = U01*I0[1920] + U41*I1[1920]
           + (oneo2z)*(I2[1596] - (lpoz)*I3[1596])
           + (twoo2zn)*I4[1492];
*(vp++) = U01*I0[1921] + U41*I1[1921]
           + (oneo2z)*(I2[1597] - (lpoz)*I3[1597])
           + (oneo2zn)*I4[1493];
*(vp++) = U01*I0[1922] + U41*I1[1922]
           + (oneo2z)*(I2[1598] - (lpoz)*I3[1598]);
*(vp++) = U01*I0[1923] + U41*I1[1923]
           + (oneo2z)*(I2[1599] - (lpoz)*I3[1599])
           + (fiveo2zn)*I4[1494];
*(vp++) = U01*I0[1924] + U41*I1[1924]
           + (oneo2z)*(I2[1600] - (lpoz)*I3[1600])
           + (fouro2zn)*I4[1495];
*(vp++) = U01*I0[1925] + U41*I1[1925]
           + (oneo2z)*(I2[1601] - (lpoz)*I3[1601])
           + (threeo2zn)*I4[1496];
*(vp++) = U01*I0[1926] + U41*I1[1926]
           + (oneo2z)*(I2[1602] - (lpoz)*I3[1602])
           + (twoo2zn)*I4[1497];
*(vp++) = U01*I0[1927] + U41*I1[1927]
           + (oneo2z)*(I2[1603] - (lpoz)*I3[1603])
           + (oneo2zn)*I4[1498];
*(vp++) = U01*I0[1928] + U41*I1[1928]
           + (oneo2z)*(I2[1604] - (lpoz)*I3[1604]);
*(vp++) = U01*I0[1929] + U41*I1[1929]
           + (oneo2z)*(I2[1605] - (lpoz)*I3[1605])
           + (sixo2zn)*I4[1499];
*(vp++) = U01*I0[1930] + U41*I1[1930]
           + (oneo2z)*(I2[1606] - (lpoz)*I3[1606])
           + (fiveo2zn)*I4[1500];
*(vp++) = U01*I0[1931] + U41*I1[1931]
           + (oneo2z)*(I2[1607] - (lpoz)*I3[1607])
           + (fouro2zn)*I4[1501];
*(vp++) = U01*I0[1932] + U41*I1[1932]
           + (oneo2z)*(I2[1608] - (lpoz)*I3[1608])
           + (threeo2zn)*I4[1502];
*(vp++) = U01*I0[1933] + U41*I1[1933]
           + (oneo2z)*(I2[1609] - (lpoz)*I3[1609])
           + (twoo2zn)*I4[1503];
*(vp++) = U01*I0[1934] + U41*I1[1934]
           + (oneo2z)*(I2[1610] - (lpoz)*I3[1610])
           + (oneo2zn)*I4[1504];
*(vp++) = U01*I0[1935] + U41*I1[1935]
           + (oneo2z)*(I2[1611] - (lpoz)*I3[1611]);
*(vp++) = U01*I0[1936] + U41*I1[1936]
           + (oneo2z)*(I2[1612] - (lpoz)*I3[1612])
           + (seveno2zn)*I4[1505];
*(vp++) = U01*I0[1937] + U41*I1[1937]
           + (oneo2z)*(I2[1613] - (lpoz)*I3[1613])
           + (sixo2zn)*I4[1506];
*(vp++) = U01*I0[1938] + U41*I1[1938]
           + (oneo2z)*(I2[1614] - (lpoz)*I3[1614])
           + (fiveo2zn)*I4[1507];
*(vp++) = U01*I0[1939] + U41*I1[1939]
           + (oneo2z)*(I2[1615] - (lpoz)*I3[1615])
           + (fouro2zn)*I4[1508];
*(vp++) = U01*I0[1940] + U41*I1[1940]
           + (oneo2z)*(I2[1616] - (lpoz)*I3[1616])
           + (threeo2zn)*I4[1509];
*(vp++) = U01*I0[1941] + U41*I1[1941]
           + (oneo2z)*(I2[1617] - (lpoz)*I3[1617])
           + (twoo2zn)*I4[1510];
*(vp++) = U01*I0[1942] + U41*I1[1942]
           + (oneo2z)*(I2[1618] - (lpoz)*I3[1618])
           + (oneo2zn)*I4[1511];
*(vp++) = U01*I0[1943] + U41*I1[1943]
           + (oneo2z)*(I2[1619] - (lpoz)*I3[1619]);
*(vp++) = U01*I0[1944] + U41*I1[1944];
*(vp++) = U01*I0[1945] + U41*I1[1945]
           + (oneo2zn)*I4[1512];
*(vp++) = U01*I0[1946] + U41*I1[1946];
*(vp++) = U01*I0[1947] + U41*I1[1947]
           + (twoo2zn)*I4[1513];
*(vp++) = U01*I0[1948] + U41*I1[1948]
           + (oneo2zn)*I4[1514];
*(vp++) = U01*I0[1949] + U41*I1[1949];
*(vp++) = U01*I0[1950] + U41*I1[1950]
           + (threeo2zn)*I4[1515];
*(vp++) = U01*I0[1951] + U41*I1[1951]
           + (twoo2zn)*I4[1516];
*(vp++) = U01*I0[1952] + U41*I1[1952]
           + (oneo2zn)*I4[1517];
*(vp++) = U01*I0[1953] + U41*I1[1953];
*(vp++) = U01*I0[1954] + U41*I1[1954]
           + (fouro2zn)*I4[1518];
*(vp++) = U01*I0[1955] + U41*I1[1955]
           + (threeo2zn)*I4[1519];
*(vp++) = U01*I0[1956] + U41*I1[1956]
           + (twoo2zn)*I4[1520];
*(vp++) = U01*I0[1957] + U41*I1[1957]
           + (oneo2zn)*I4[1521];
*(vp++) = U01*I0[1958] + U41*I1[1958];
*(vp++) = U01*I0[1959] + U41*I1[1959]
           + (fiveo2zn)*I4[1522];
*(vp++) = U01*I0[1960] + U41*I1[1960]
           + (fouro2zn)*I4[1523];
*(vp++) = U01*I0[1961] + U41*I1[1961]
           + (threeo2zn)*I4[1524];
*(vp++) = U01*I0[1962] + U41*I1[1962]
           + (twoo2zn)*I4[1525];
*(vp++) = U01*I0[1963] + U41*I1[1963]
           + (oneo2zn)*I4[1526];
*(vp++) = U01*I0[1964] + U41*I1[1964];
*(vp++) = U01*I0[1965] + U41*I1[1965]
           + (sixo2zn)*I4[1527];
*(vp++) = U01*I0[1966] + U41*I1[1966]
           + (fiveo2zn)*I4[1528];
*(vp++) = U01*I0[1967] + U41*I1[1967]
           + (fouro2zn)*I4[1529];
*(vp++) = U01*I0[1968] + U41*I1[1968]
           + (threeo2zn)*I4[1530];
*(vp++) = U01*I0[1969] + U41*I1[1969]
           + (twoo2zn)*I4[1531];
*(vp++) = U01*I0[1970] + U41*I1[1970]
           + (oneo2zn)*I4[1532];
*(vp++) = U01*I0[1971] + U41*I1[1971];
*(vp++) = U01*I0[1972] + U41*I1[1972]
           + (seveno2zn)*I4[1533];
*(vp++) = U01*I0[1973] + U41*I1[1973]
           + (sixo2zn)*I4[1534];
*(vp++) = U01*I0[1974] + U41*I1[1974]
           + (fiveo2zn)*I4[1535];
*(vp++) = U01*I0[1975] + U41*I1[1975]
           + (fouro2zn)*I4[1536];
*(vp++) = U01*I0[1976] + U41*I1[1976]
           + (threeo2zn)*I4[1537];
*(vp++) = U01*I0[1977] + U41*I1[1977]
           + (twoo2zn)*I4[1538];
*(vp++) = U01*I0[1978] + U41*I1[1978]
           + (oneo2zn)*I4[1539];
*(vp++) = U01*I0[1979] + U41*I1[1979];
*(vp++) = U02*I0[1944] + U42*I1[1944]
           + (nineo2z)*(I2[1584] - (lpoz)*I3[1584]);
*(vp++) = U02*I0[1945] + U42*I1[1945]
           + (nineo2z)*(I2[1585] - (lpoz)*I3[1585]);
*(vp++) = U02*I0[1946] + U42*I1[1946]
           + (nineo2z)*(I2[1586] - (lpoz)*I3[1586])
           + (oneo2zn)*I4[1512];
*(vp++) = U02*I0[1947] + U42*I1[1947]
           + (nineo2z)*(I2[1587] - (lpoz)*I3[1587]);
*(vp++) = U02*I0[1948] + U42*I1[1948]
           + (nineo2z)*(I2[1588] - (lpoz)*I3[1588])
           + (oneo2zn)*I4[1513];
*(vp++) = U02*I0[1949] + U42*I1[1949]
           + (nineo2z)*(I2[1589] - (lpoz)*I3[1589])
           + (twoo2zn)*I4[1514];
*(vp++) = U02*I0[1950] + U42*I1[1950]
           + (nineo2z)*(I2[1590] - (lpoz)*I3[1590]);
*(vp++) = U02*I0[1951] + U42*I1[1951]
           + (nineo2z)*(I2[1591] - (lpoz)*I3[1591])
           + (oneo2zn)*I4[1515];
*(vp++) = U02*I0[1952] + U42*I1[1952]
           + (nineo2z)*(I2[1592] - (lpoz)*I3[1592])
           + (twoo2zn)*I4[1516];
*(vp++) = U02*I0[1953] + U42*I1[1953]
           + (nineo2z)*(I2[1593] - (lpoz)*I3[1593])
           + (threeo2zn)*I4[1517];
*(vp++) = U02*I0[1954] + U42*I1[1954]
           + (nineo2z)*(I2[1594] - (lpoz)*I3[1594]);
*(vp++) = U02*I0[1955] + U42*I1[1955]
           + (nineo2z)*(I2[1595] - (lpoz)*I3[1595])
           + (oneo2zn)*I4[1518];
*(vp++) = U02*I0[1956] + U42*I1[1956]
           + (nineo2z)*(I2[1596] - (lpoz)*I3[1596])
           + (twoo2zn)*I4[1519];
*(vp++) = U02*I0[1957] + U42*I1[1957]
           + (nineo2z)*(I2[1597] - (lpoz)*I3[1597])
           + (threeo2zn)*I4[1520];
*(vp++) = U02*I0[1958] + U42*I1[1958]
           + (nineo2z)*(I2[1598] - (lpoz)*I3[1598])
           + (fouro2zn)*I4[1521];
*(vp++) = U02*I0[1959] + U42*I1[1959]
           + (nineo2z)*(I2[1599] - (lpoz)*I3[1599]);
*(vp++) = U02*I0[1960] + U42*I1[1960]
           + (nineo2z)*(I2[1600] - (lpoz)*I3[1600])
           + (oneo2zn)*I4[1522];
*(vp++) = U02*I0[1961] + U42*I1[1961]
           + (nineo2z)*(I2[1601] - (lpoz)*I3[1601])
           + (twoo2zn)*I4[1523];
*(vp++) = U02*I0[1962] + U42*I1[1962]
           + (nineo2z)*(I2[1602] - (lpoz)*I3[1602])
           + (threeo2zn)*I4[1524];
*(vp++) = U02*I0[1963] + U42*I1[1963]
           + (nineo2z)*(I2[1603] - (lpoz)*I3[1603])
           + (fouro2zn)*I4[1525];
*(vp++) = U02*I0[1964] + U42*I1[1964]
           + (nineo2z)*(I2[1604] - (lpoz)*I3[1604])
           + (fiveo2zn)*I4[1526];
*(vp++) = U02*I0[1965] + U42*I1[1965]
           + (nineo2z)*(I2[1605] - (lpoz)*I3[1605]);
*(vp++) = U02*I0[1966] + U42*I1[1966]
           + (nineo2z)*(I2[1606] - (lpoz)*I3[1606])
           + (oneo2zn)*I4[1527];
*(vp++) = U02*I0[1967] + U42*I1[1967]
           + (nineo2z)*(I2[1607] - (lpoz)*I3[1607])
           + (twoo2zn)*I4[1528];
*(vp++) = U02*I0[1968] + U42*I1[1968]
           + (nineo2z)*(I2[1608] - (lpoz)*I3[1608])
           + (threeo2zn)*I4[1529];
*(vp++) = U02*I0[1969] + U42*I1[1969]
           + (nineo2z)*(I2[1609] - (lpoz)*I3[1609])
           + (fouro2zn)*I4[1530];
*(vp++) = U02*I0[1970] + U42*I1[1970]
           + (nineo2z)*(I2[1610] - (lpoz)*I3[1610])
           + (fiveo2zn)*I4[1531];
*(vp++) = U02*I0[1971] + U42*I1[1971]
           + (nineo2z)*(I2[1611] - (lpoz)*I3[1611])
           + (sixo2zn)*I4[1532];
*(vp++) = U02*I0[1972] + U42*I1[1972]
           + (nineo2z)*(I2[1612] - (lpoz)*I3[1612]);
*(vp++) = U02*I0[1973] + U42*I1[1973]
           + (nineo2z)*(I2[1613] - (lpoz)*I3[1613])
           + (oneo2zn)*I4[1533];
*(vp++) = U02*I0[1974] + U42*I1[1974]
           + (nineo2z)*(I2[1614] - (lpoz)*I3[1614])
           + (twoo2zn)*I4[1534];
*(vp++) = U02*I0[1975] + U42*I1[1975]
           + (nineo2z)*(I2[1615] - (lpoz)*I3[1615])
           + (threeo2zn)*I4[1535];
*(vp++) = U02*I0[1976] + U42*I1[1976]
           + (nineo2z)*(I2[1616] - (lpoz)*I3[1616])
           + (fouro2zn)*I4[1536];
*(vp++) = U02*I0[1977] + U42*I1[1977]
           + (nineo2z)*(I2[1617] - (lpoz)*I3[1617])
           + (fiveo2zn)*I4[1537];
*(vp++) = U02*I0[1978] + U42*I1[1978]
           + (nineo2z)*(I2[1618] - (lpoz)*I3[1618])
           + (sixo2zn)*I4[1538];
*(vp++) = U02*I0[1979] + U42*I1[1979]
           + (nineo2z)*(I2[1619] - (lpoz)*I3[1619])
           + (seveno2zn)*I4[1539];
return vp;
}
/* Total number of FLOPs = 18744 */
