/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdio.h>
#include "libint.h"
#include "vrr_header.h"

  /* Computes quartets necessary to compute (np|nn) integrals */

void vrr_order_npnn(Libint_t * Libint, prim_data *Data)
{
 REALTYPE *vrr_stack = Libint->vrr_stack;
 REALTYPE *tmp, *target_ptr;
 int i, am[2];
 _BUILD_p000(Data,vrr_stack+0, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+10, Data->F+11, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+9, Data->F+10, NULL, NULL, NULL);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+11, Data->F+12, NULL, NULL, NULL);
 _BUILD_p0p0(Data,vrr_stack+12, vrr_stack+3, vrr_stack+9, NULL, NULL, Data->F+11);
 _BUILD_p0p0(Data,vrr_stack+21, vrr_stack+6, vrr_stack+3, NULL, NULL, Data->F+10);
 _BUILD_d0p0(Data,vrr_stack+30, vrr_stack+21, vrr_stack+12, vrr_stack+6, vrr_stack+3, vrr_stack+0);
 _BUILD_00d0(Data,vrr_stack+48, vrr_stack+3, vrr_stack+9, Data->F+10, Data->F+11, NULL);
 _BUILD_00d0(Data,vrr_stack+54, vrr_stack+6, vrr_stack+3, Data->F+9, Data->F+10, NULL);
 _BUILD_p0d0(Data,vrr_stack+60, vrr_stack+54, vrr_stack+48, NULL, NULL, vrr_stack+3);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+8, Data->F+9, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+78, vrr_stack+0, vrr_stack+6, Data->F+8, Data->F+9, NULL);
 _BUILD_p0d0(Data,vrr_stack+84, vrr_stack+78, vrr_stack+54, NULL, NULL, vrr_stack+6);
 _BUILD_00p0(Data,vrr_stack+102, Data->F+12, Data->F+13, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+105, vrr_stack+9, vrr_stack+102, Data->F+11, Data->F+12, NULL);
 _BUILD_p0d0(Data,vrr_stack+111, vrr_stack+48, vrr_stack+105, NULL, NULL, vrr_stack+9);
 _BUILD_d0d0(Data,vrr_stack+129, vrr_stack+60, vrr_stack+111, vrr_stack+54, vrr_stack+48, vrr_stack+12);
 _BUILD_d0d0(Data,vrr_stack+165, vrr_stack+84, vrr_stack+60, vrr_stack+78, vrr_stack+54, vrr_stack+21);
 _BUILD_f0d0(Data,vrr_stack+201, vrr_stack+165, vrr_stack+129, vrr_stack+84, vrr_stack+60, vrr_stack+30);
 _BUILD_00f0(Data,vrr_stack+12, vrr_stack+54, vrr_stack+48, vrr_stack+6, vrr_stack+3, NULL);
 _BUILD_00f0(Data,vrr_stack+22, vrr_stack+78, vrr_stack+54, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00f0(Data,vrr_stack+32, vrr_stack+48, vrr_stack+105, vrr_stack+3, vrr_stack+9, NULL);
 _BUILD_p0f0(Data,vrr_stack+261, vrr_stack+12, vrr_stack+32, NULL, NULL, vrr_stack+48);
 _BUILD_p0f0(Data,vrr_stack+291, vrr_stack+22, vrr_stack+12, NULL, NULL, vrr_stack+54);
 _BUILD_d0f0(Data,vrr_stack+321, vrr_stack+291, vrr_stack+261, vrr_stack+22, vrr_stack+12, vrr_stack+60);
 _BUILD_00p0(Data,vrr_stack+60, Data->F+7, Data->F+8, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+60, vrr_stack+0, Data->F+7, Data->F+8, NULL);
 _BUILD_00f0(Data,vrr_stack+63, vrr_stack+3, vrr_stack+78, vrr_stack+60, vrr_stack+0, NULL);
 _BUILD_p0f0(Data,vrr_stack+381, vrr_stack+63, vrr_stack+22, NULL, NULL, vrr_stack+78);
 _BUILD_d0f0(Data,vrr_stack+411, vrr_stack+381, vrr_stack+291, vrr_stack+63, vrr_stack+22, vrr_stack+84);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+13, Data->F+14, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+42, vrr_stack+102, vrr_stack+0, Data->F+12, Data->F+13, NULL);
 _BUILD_00f0(Data,vrr_stack+84, vrr_stack+105, vrr_stack+42, vrr_stack+9, vrr_stack+102, NULL);
 _BUILD_p0f0(Data,vrr_stack+471, vrr_stack+32, vrr_stack+84, NULL, NULL, vrr_stack+105);
 _BUILD_d0f0(Data,vrr_stack+501, vrr_stack+261, vrr_stack+471, vrr_stack+12, vrr_stack+32, vrr_stack+111);
 _BUILD_f0f0(Data,vrr_stack+561, vrr_stack+321, vrr_stack+501, vrr_stack+291, vrr_stack+261, vrr_stack+129);
 _BUILD_f0f0(Data,vrr_stack+661, vrr_stack+411, vrr_stack+321, vrr_stack+381, vrr_stack+291, vrr_stack+165);
 _BUILD_g0f0(Data,vrr_stack+761, vrr_stack+661, vrr_stack+561, vrr_stack+411, vrr_stack+321, vrr_stack+201);
 _BUILD_00g0(Data,vrr_stack+111, vrr_stack+12, vrr_stack+32, vrr_stack+54, vrr_stack+48, NULL);
 _BUILD_00g0(Data,vrr_stack+126, vrr_stack+22, vrr_stack+12, vrr_stack+78, vrr_stack+54, NULL);
 _BUILD_p0g0(Data,vrr_stack+141, vrr_stack+126, vrr_stack+111, NULL, NULL, vrr_stack+12);
 _BUILD_00g0(Data,vrr_stack+186, vrr_stack+63, vrr_stack+22, vrr_stack+3, vrr_stack+78, NULL);
 _BUILD_p0g0(Data,vrr_stack+201, vrr_stack+186, vrr_stack+126, NULL, NULL, vrr_stack+22);
 _BUILD_00g0(Data,vrr_stack+246, vrr_stack+32, vrr_stack+84, vrr_stack+48, vrr_stack+105, NULL);
 _BUILD_p0g0(Data,vrr_stack+911, vrr_stack+111, vrr_stack+246, NULL, NULL, vrr_stack+32);
 _BUILD_d0g0(Data,vrr_stack+956, vrr_stack+141, vrr_stack+911, vrr_stack+126, vrr_stack+111, vrr_stack+261);
 _BUILD_d0g0(Data,vrr_stack+1046, vrr_stack+201, vrr_stack+141, vrr_stack+186, vrr_stack+126, vrr_stack+291);
 _BUILD_f0g0(Data,vrr_stack+1136, vrr_stack+1046, vrr_stack+956, vrr_stack+201, vrr_stack+141, vrr_stack+321);
 _BUILD_00p0(Data,vrr_stack+9, Data->F+6, Data->F+7, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+261, vrr_stack+9, vrr_stack+60, Data->F+6, Data->F+7, NULL);
 _BUILD_00f0(Data,vrr_stack+267, vrr_stack+261, vrr_stack+3, vrr_stack+9, vrr_stack+60, NULL);
 _BUILD_00g0(Data,vrr_stack+48, vrr_stack+267, vrr_stack+63, vrr_stack+261, vrr_stack+3, NULL);
 _BUILD_p0g0(Data,vrr_stack+277, vrr_stack+48, vrr_stack+186, NULL, NULL, vrr_stack+63);
 _BUILD_d0g0(Data,vrr_stack+1286, vrr_stack+277, vrr_stack+201, vrr_stack+48, vrr_stack+186, vrr_stack+381);
 _BUILD_f0g0(Data,vrr_stack+1376, vrr_stack+1286, vrr_stack+1046, vrr_stack+277, vrr_stack+201, vrr_stack+411);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+14, Data->F+15, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+322, vrr_stack+0, vrr_stack+3, Data->F+13, Data->F+14, NULL);
 _BUILD_00f0(Data,vrr_stack+328, vrr_stack+42, vrr_stack+322, vrr_stack+102, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+338, vrr_stack+84, vrr_stack+328, vrr_stack+105, vrr_stack+42, NULL);
 _BUILD_p0g0(Data,vrr_stack+353, vrr_stack+246, vrr_stack+338, NULL, NULL, vrr_stack+84);
 _BUILD_d0g0(Data,vrr_stack+1526, vrr_stack+911, vrr_stack+353, vrr_stack+111, vrr_stack+246, vrr_stack+471);
 _BUILD_f0g0(Data,vrr_stack+1616, vrr_stack+956, vrr_stack+1526, vrr_stack+141, vrr_stack+911, vrr_stack+501);
 _BUILD_g0g0(Data,vrr_stack+1766, vrr_stack+1136, vrr_stack+1616, vrr_stack+1046, vrr_stack+956, vrr_stack+561);
 _BUILD_g0g0(Data,vrr_stack+398, vrr_stack+1376, vrr_stack+1136, vrr_stack+1286, vrr_stack+1046, vrr_stack+661);
 _BUILD_h0g0(Data,vrr_stack+1991, vrr_stack+398, vrr_stack+1766, vrr_stack+1376, vrr_stack+1136, vrr_stack+761);
 _BUILD_00h0(Data,vrr_stack+623, vrr_stack+126, vrr_stack+111, vrr_stack+22, vrr_stack+12, NULL);
 _BUILD_00h0(Data,vrr_stack+644, vrr_stack+186, vrr_stack+126, vrr_stack+63, vrr_stack+22, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+111, vrr_stack+246, vrr_stack+12, vrr_stack+32, NULL);
 _BUILD_p0h0(Data,vrr_stack+686, vrr_stack+623, vrr_stack+665, NULL, NULL, vrr_stack+111);
 _BUILD_p0h0(Data,vrr_stack+749, vrr_stack+644, vrr_stack+623, NULL, NULL, vrr_stack+126);
 _BUILD_d0h0(Data,vrr_stack+2306, vrr_stack+749, vrr_stack+686, vrr_stack+644, vrr_stack+623, vrr_stack+141);
 _BUILD_00h0(Data,vrr_stack+141, vrr_stack+48, vrr_stack+186, vrr_stack+267, vrr_stack+63, NULL);
 _BUILD_p0h0(Data,vrr_stack+812, vrr_stack+141, vrr_stack+644, NULL, NULL, vrr_stack+186);
 _BUILD_d0h0(Data,vrr_stack+2432, vrr_stack+812, vrr_stack+749, vrr_stack+141, vrr_stack+644, vrr_stack+201);
 _BUILD_00h0(Data,vrr_stack+63, vrr_stack+246, vrr_stack+338, vrr_stack+32, vrr_stack+84, NULL);
 _BUILD_p0h0(Data,vrr_stack+2558, vrr_stack+665, vrr_stack+63, NULL, NULL, vrr_stack+246);
 _BUILD_d0h0(Data,vrr_stack+2621, vrr_stack+686, vrr_stack+2558, vrr_stack+623, vrr_stack+665, vrr_stack+911);
 _BUILD_f0h0(Data,vrr_stack+2747, vrr_stack+2306, vrr_stack+2621, vrr_stack+749, vrr_stack+686, vrr_stack+956);
 _BUILD_f0h0(Data,vrr_stack+2957, vrr_stack+2432, vrr_stack+2306, vrr_stack+812, vrr_stack+749, vrr_stack+1046);
 _BUILD_g0h0(Data,vrr_stack+3167, vrr_stack+2957, vrr_stack+2747, vrr_stack+2432, vrr_stack+2306, vrr_stack+1136);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+5, Data->F+6, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+201, vrr_stack+6, vrr_stack+9, Data->F+5, Data->F+6, NULL);
 _BUILD_00f0(Data,vrr_stack+207, vrr_stack+201, vrr_stack+261, vrr_stack+6, vrr_stack+9, NULL);
 _BUILD_00g0(Data,vrr_stack+9, vrr_stack+207, vrr_stack+267, vrr_stack+201, vrr_stack+261, NULL);
 _BUILD_00h0(Data,vrr_stack+217, vrr_stack+9, vrr_stack+48, vrr_stack+207, vrr_stack+267, NULL);
 _BUILD_p0h0(Data,vrr_stack+875, vrr_stack+217, vrr_stack+141, NULL, NULL, vrr_stack+48);
 _BUILD_d0h0(Data,vrr_stack+938, vrr_stack+875, vrr_stack+812, vrr_stack+217, vrr_stack+141, vrr_stack+277);
 _BUILD_f0h0(Data,vrr_stack+1064, vrr_stack+938, vrr_stack+2432, vrr_stack+875, vrr_stack+812, vrr_stack+1286);
 _BUILD_g0h0(Data,vrr_stack+3482, vrr_stack+1064, vrr_stack+2957, vrr_stack+938, vrr_stack+2432, vrr_stack+1376);
 _BUILD_00p0(Data,vrr_stack+261, Data->F+15, Data->F+16, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+264, vrr_stack+3, vrr_stack+261, Data->F+14, Data->F+15, NULL);
 _BUILD_00f0(Data,vrr_stack+270, vrr_stack+322, vrr_stack+264, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+280, vrr_stack+328, vrr_stack+270, vrr_stack+42, vrr_stack+322, NULL);
 _BUILD_00h0(Data,vrr_stack+295, vrr_stack+338, vrr_stack+280, vrr_stack+84, vrr_stack+328, NULL);
 _BUILD_p0h0(Data,vrr_stack+1274, vrr_stack+63, vrr_stack+295, NULL, NULL, vrr_stack+338);
 _BUILD_d0h0(Data,vrr_stack+1337, vrr_stack+2558, vrr_stack+1274, vrr_stack+665, vrr_stack+63, vrr_stack+353);
 _BUILD_f0h0(Data,vrr_stack+3797, vrr_stack+2621, vrr_stack+1337, vrr_stack+686, vrr_stack+2558, vrr_stack+1526);
 _BUILD_g0h0(Data,vrr_stack+4007, vrr_stack+2747, vrr_stack+3797, vrr_stack+2306, vrr_stack+2621, vrr_stack+1616);
 _BUILD_h0h0(Data,vrr_stack+4322, vrr_stack+3167, vrr_stack+4007, vrr_stack+2957, vrr_stack+2747, vrr_stack+1766);
 _BUILD_h0h0(Data,vrr_stack+1463, vrr_stack+3482, vrr_stack+3167, vrr_stack+1064, vrr_stack+2957, vrr_stack+398);
 _BUILD_i0h0(Data,vrr_stack+4763, vrr_stack+1463, vrr_stack+4322, vrr_stack+3482, vrr_stack+3167, vrr_stack+1991);
 _BUILD_00i0(Data,vrr_stack+353, vrr_stack+623, vrr_stack+665, vrr_stack+126, vrr_stack+111, NULL);
 _BUILD_00i0(Data,vrr_stack+381, vrr_stack+644, vrr_stack+623, vrr_stack+186, vrr_stack+126, NULL);
 _BUILD_p0i0(Data,vrr_stack+409, vrr_stack+381, vrr_stack+353, NULL, NULL, vrr_stack+623);
 _BUILD_00i0(Data,vrr_stack+493, vrr_stack+141, vrr_stack+644, vrr_stack+48, vrr_stack+186, NULL);
 _BUILD_p0i0(Data,vrr_stack+521, vrr_stack+493, vrr_stack+381, NULL, NULL, vrr_stack+644);
 _BUILD_00i0(Data,vrr_stack+162, vrr_stack+665, vrr_stack+63, vrr_stack+111, vrr_stack+246, NULL);
 _BUILD_p0i0(Data,vrr_stack+1904, vrr_stack+353, vrr_stack+162, NULL, NULL, vrr_stack+665);
 _BUILD_d0i0(Data,vrr_stack+1988, vrr_stack+409, vrr_stack+1904, vrr_stack+381, vrr_stack+353, vrr_stack+686);
 _BUILD_d0i0(Data,vrr_stack+5351, vrr_stack+521, vrr_stack+409, vrr_stack+493, vrr_stack+381, vrr_stack+749);
 _BUILD_f0i0(Data,vrr_stack+5519, vrr_stack+5351, vrr_stack+1988, vrr_stack+521, vrr_stack+409, vrr_stack+2306);
 _BUILD_00i0(Data,vrr_stack+686, vrr_stack+217, vrr_stack+141, vrr_stack+9, vrr_stack+48, NULL);
 _BUILD_p0i0(Data,vrr_stack+714, vrr_stack+686, vrr_stack+493, NULL, NULL, vrr_stack+141);
 _BUILD_d0i0(Data,vrr_stack+2156, vrr_stack+714, vrr_stack+521, vrr_stack+686, vrr_stack+493, vrr_stack+812);
 _BUILD_f0i0(Data,vrr_stack+5799, vrr_stack+2156, vrr_stack+5351, vrr_stack+714, vrr_stack+521, vrr_stack+2432);
 _BUILD_00i0(Data,vrr_stack+798, vrr_stack+63, vrr_stack+295, vrr_stack+246, vrr_stack+338, NULL);
 _BUILD_p0i0(Data,vrr_stack+2324, vrr_stack+162, vrr_stack+798, NULL, NULL, vrr_stack+63);
 _BUILD_d0i0(Data,vrr_stack+6079, vrr_stack+1904, vrr_stack+2324, vrr_stack+353, vrr_stack+162, vrr_stack+2558);
 _BUILD_f0i0(Data,vrr_stack+6247, vrr_stack+1988, vrr_stack+6079, vrr_stack+409, vrr_stack+1904, vrr_stack+2621);
 _BUILD_g0i0(Data,vrr_stack+6527, vrr_stack+5519, vrr_stack+6247, vrr_stack+5351, vrr_stack+1988, vrr_stack+2747);
 _BUILD_g0i0(Data,vrr_stack+2408, vrr_stack+5799, vrr_stack+5519, vrr_stack+2156, vrr_stack+5351, vrr_stack+2957);
 _BUILD_h0i0(Data,vrr_stack+6947, vrr_stack+2408, vrr_stack+6527, vrr_stack+5799, vrr_stack+5519, vrr_stack+3167);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+4, Data->F+5, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+316, vrr_stack+0, vrr_stack+6, Data->F+4, Data->F+5, NULL);
 _BUILD_00f0(Data,vrr_stack+826, vrr_stack+316, vrr_stack+201, vrr_stack+0, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+836, vrr_stack+826, vrr_stack+207, vrr_stack+316, vrr_stack+201, NULL);
 _BUILD_00h0(Data,vrr_stack+851, vrr_stack+836, vrr_stack+9, vrr_stack+826, vrr_stack+207, NULL);
 _BUILD_00i0(Data,vrr_stack+84, vrr_stack+851, vrr_stack+217, vrr_stack+836, vrr_stack+9, NULL);
 _BUILD_p0i0(Data,vrr_stack+2828, vrr_stack+84, vrr_stack+686, NULL, NULL, vrr_stack+217);
 _BUILD_d0i0(Data,vrr_stack+2912, vrr_stack+2828, vrr_stack+714, vrr_stack+84, vrr_stack+686, vrr_stack+875);
 _BUILD_f0i0(Data,vrr_stack+3080, vrr_stack+2912, vrr_stack+2156, vrr_stack+2828, vrr_stack+714, vrr_stack+938);
 _BUILD_g0i0(Data,vrr_stack+7535, vrr_stack+3080, vrr_stack+5799, vrr_stack+2912, vrr_stack+2156, vrr_stack+1064);
 _BUILD_h0i0(Data,vrr_stack+7955, vrr_stack+7535, vrr_stack+2408, vrr_stack+3080, vrr_stack+5799, vrr_stack+3482);
 _BUILD_00p0(Data,vrr_stack+6, Data->F+16, Data->F+17, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+9, vrr_stack+261, vrr_stack+6, Data->F+15, Data->F+16, NULL);
 _BUILD_00f0(Data,vrr_stack+15, vrr_stack+264, vrr_stack+9, vrr_stack+3, vrr_stack+261, NULL);
 _BUILD_00g0(Data,vrr_stack+25, vrr_stack+270, vrr_stack+15, vrr_stack+322, vrr_stack+264, NULL);
 _BUILD_00h0(Data,vrr_stack+40, vrr_stack+280, vrr_stack+25, vrr_stack+328, vrr_stack+270, NULL);
 _BUILD_00i0(Data,vrr_stack+872, vrr_stack+295, vrr_stack+40, vrr_stack+338, vrr_stack+280, NULL);
 _BUILD_p0i0(Data,vrr_stack+900, vrr_stack+798, vrr_stack+872, NULL, NULL, vrr_stack+295);
 _BUILD_d0i0(Data,vrr_stack+984, vrr_stack+2324, vrr_stack+900, vrr_stack+162, vrr_stack+798, vrr_stack+1274);
 _BUILD_f0i0(Data,vrr_stack+3360, vrr_stack+6079, vrr_stack+984, vrr_stack+1904, vrr_stack+2324, vrr_stack+1337);
 _BUILD_g0i0(Data,vrr_stack+8543, vrr_stack+6247, vrr_stack+3360, vrr_stack+1988, vrr_stack+6079, vrr_stack+3797);
 _BUILD_h0i0(Data,vrr_stack+8963, vrr_stack+6527, vrr_stack+8543, vrr_stack+5519, vrr_stack+6247, vrr_stack+4007);
 _BUILD_i0i0(Data,vrr_stack+9551, vrr_stack+6947, vrr_stack+8963, vrr_stack+2408, vrr_stack+6527, vrr_stack+4322);
 _BUILD_i0i0(Data,vrr_stack+3640, vrr_stack+7955, vrr_stack+6947, vrr_stack+7535, vrr_stack+2408, vrr_stack+1463);
 _BUILD_k0i0(Data,vrr_stack+10335, vrr_stack+3640, vrr_stack+9551, vrr_stack+7955, vrr_stack+6947, vrr_stack+4763);
 _BUILD_00k0(Data,vrr_stack+1152, vrr_stack+381, vrr_stack+353, vrr_stack+644, vrr_stack+623, NULL);
 _BUILD_00k0(Data,vrr_stack+1188, vrr_stack+493, vrr_stack+381, vrr_stack+141, vrr_stack+644, NULL);
 _BUILD_00k0(Data,vrr_stack+1224, vrr_stack+353, vrr_stack+162, vrr_stack+623, vrr_stack+665, NULL);
 _BUILD_p0k0(Data,vrr_stack+1260, vrr_stack+1152, vrr_stack+1224, NULL, NULL, vrr_stack+353);
 _BUILD_p0k0(Data,vrr_stack+1368, vrr_stack+1188, vrr_stack+1152, NULL, NULL, vrr_stack+381);
 _BUILD_d0k0(Data,vrr_stack+1476, vrr_stack+1368, vrr_stack+1260, vrr_stack+1188, vrr_stack+1152, vrr_stack+409);
 _BUILD_00k0(Data,vrr_stack+409, vrr_stack+686, vrr_stack+493, vrr_stack+217, vrr_stack+141, NULL);
 _BUILD_p0k0(Data,vrr_stack+1692, vrr_stack+409, vrr_stack+1188, NULL, NULL, vrr_stack+493);
 _BUILD_d0k0(Data,vrr_stack+4424, vrr_stack+1692, vrr_stack+1368, vrr_stack+409, vrr_stack+1188, vrr_stack+521);
 _BUILD_00k0(Data,vrr_stack+521, vrr_stack+162, vrr_stack+798, vrr_stack+665, vrr_stack+63, NULL);
 _BUILD_p0k0(Data,vrr_stack+557, vrr_stack+1224, vrr_stack+521, NULL, NULL, vrr_stack+162);
 _BUILD_d0k0(Data,vrr_stack+4640, vrr_stack+1260, vrr_stack+557, vrr_stack+1152, vrr_stack+1224, vrr_stack+1904);
 _BUILD_f0k0(Data,vrr_stack+4856, vrr_stack+1476, vrr_stack+4640, vrr_stack+1368, vrr_stack+1260, vrr_stack+1988);
 _BUILD_f0k0(Data,vrr_stack+11343, vrr_stack+4424, vrr_stack+1476, vrr_stack+1692, vrr_stack+1368, vrr_stack+5351);
 _BUILD_g0k0(Data,vrr_stack+11703, vrr_stack+11343, vrr_stack+4856, vrr_stack+4424, vrr_stack+1476, vrr_stack+5519);
 _BUILD_00k0(Data,vrr_stack+445, vrr_stack+84, vrr_stack+686, vrr_stack+851, vrr_stack+217, NULL);
 _BUILD_p0k0(Data,vrr_stack+1800, vrr_stack+445, vrr_stack+409, NULL, NULL, vrr_stack+686);
 _BUILD_d0k0(Data,vrr_stack+1908, vrr_stack+1800, vrr_stack+1692, vrr_stack+445, vrr_stack+409, vrr_stack+714);
 _BUILD_f0k0(Data,vrr_stack+5216, vrr_stack+1908, vrr_stack+4424, vrr_stack+1800, vrr_stack+1692, vrr_stack+2156);
 _BUILD_g0k0(Data,vrr_stack+12243, vrr_stack+5216, vrr_stack+11343, vrr_stack+1908, vrr_stack+4424, vrr_stack+5799);
 _BUILD_00k0(Data,vrr_stack+714, vrr_stack+798, vrr_stack+872, vrr_stack+63, vrr_stack+295, NULL);
 _BUILD_p0k0(Data,vrr_stack+2124, vrr_stack+521, vrr_stack+714, NULL, NULL, vrr_stack+798);
 _BUILD_d0k0(Data,vrr_stack+5576, vrr_stack+557, vrr_stack+2124, vrr_stack+1224, vrr_stack+521, vrr_stack+2324);
 _BUILD_f0k0(Data,vrr_stack+12783, vrr_stack+4640, vrr_stack+5576, vrr_stack+1260, vrr_stack+557, vrr_stack+6079);
 _BUILD_g0k0(Data,vrr_stack+13143, vrr_stack+4856, vrr_stack+12783, vrr_stack+1476, vrr_stack+4640, vrr_stack+6247);
 _BUILD_h0k0(Data,vrr_stack+13683, vrr_stack+11703, vrr_stack+13143, vrr_stack+11343, vrr_stack+4856, vrr_stack+6527);
 _BUILD_h0k0(Data,vrr_stack+5792, vrr_stack+12243, vrr_stack+11703, vrr_stack+5216, vrr_stack+11343, vrr_stack+2408);
 _BUILD_i0k0(Data,vrr_stack+14439, vrr_stack+5792, vrr_stack+13683, vrr_stack+12243, vrr_stack+11703, vrr_stack+6947);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+3, Data->F+4, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+750, vrr_stack+3, vrr_stack+0, Data->F+3, Data->F+4, NULL);
 _BUILD_00f0(Data,vrr_stack+756, vrr_stack+750, vrr_stack+316, vrr_stack+3, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+766, vrr_stack+756, vrr_stack+826, vrr_stack+750, vrr_stack+316, NULL);
 _BUILD_00h0(Data,vrr_stack+665, vrr_stack+766, vrr_stack+836, vrr_stack+756, vrr_stack+826, NULL);
 _BUILD_00i0(Data,vrr_stack+316, vrr_stack+665, vrr_stack+851, vrr_stack+766, vrr_stack+836, NULL);
 _BUILD_00k0(Data,vrr_stack+2232, vrr_stack+316, vrr_stack+84, vrr_stack+665, vrr_stack+851, NULL);
 _BUILD_p0k0(Data,vrr_stack+2268, vrr_stack+2232, vrr_stack+445, NULL, NULL, vrr_stack+84);
 _BUILD_d0k0(Data,vrr_stack+2376, vrr_stack+2268, vrr_stack+1800, vrr_stack+2232, vrr_stack+445, vrr_stack+2828);
 _BUILD_f0k0(Data,vrr_stack+6548, vrr_stack+2376, vrr_stack+1908, vrr_stack+2268, vrr_stack+1800, vrr_stack+2912);
 _BUILD_g0k0(Data,vrr_stack+6908, vrr_stack+6548, vrr_stack+5216, vrr_stack+2376, vrr_stack+1908, vrr_stack+3080);
 _BUILD_h0k0(Data,vrr_stack+2592, vrr_stack+6908, vrr_stack+12243, vrr_stack+6548, vrr_stack+5216, vrr_stack+7535);
 _BUILD_i0k0(Data,vrr_stack+15447, vrr_stack+2592, vrr_stack+5792, vrr_stack+6908, vrr_stack+12243, vrr_stack+7955);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+17, Data->F+18, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+826, vrr_stack+6, vrr_stack+0, Data->F+16, Data->F+17, NULL);
 _BUILD_00f0(Data,vrr_stack+832, vrr_stack+9, vrr_stack+826, vrr_stack+261, vrr_stack+6, NULL);
 _BUILD_00g0(Data,vrr_stack+842, vrr_stack+15, vrr_stack+832, vrr_stack+264, vrr_stack+9, NULL);
 _BUILD_00h0(Data,vrr_stack+61, vrr_stack+25, vrr_stack+842, vrr_stack+270, vrr_stack+15, NULL);
 _BUILD_00i0(Data,vrr_stack+112, vrr_stack+40, vrr_stack+61, vrr_stack+280, vrr_stack+25, NULL);
 _BUILD_00k0(Data,vrr_stack+190, vrr_stack+872, vrr_stack+112, vrr_stack+295, vrr_stack+40, NULL);
 _BUILD_p0k0(Data,vrr_stack+7448, vrr_stack+714, vrr_stack+190, NULL, NULL, vrr_stack+872);
 _BUILD_d0k0(Data,vrr_stack+7556, vrr_stack+2124, vrr_stack+7448, vrr_stack+521, vrr_stack+714, vrr_stack+900);
 _BUILD_f0k0(Data,vrr_stack+7772, vrr_stack+5576, vrr_stack+7556, vrr_stack+557, vrr_stack+2124, vrr_stack+984);
 _BUILD_g0k0(Data,vrr_stack+16455, vrr_stack+12783, vrr_stack+7772, vrr_stack+4640, vrr_stack+5576, vrr_stack+3360);
 _BUILD_h0k0(Data,vrr_stack+16995, vrr_stack+13143, vrr_stack+16455, vrr_stack+4856, vrr_stack+12783, vrr_stack+8543);
 _BUILD_i0k0(Data,vrr_stack+17751, vrr_stack+13683, vrr_stack+16995, vrr_stack+11703, vrr_stack+13143, vrr_stack+8963);
 _BUILD_k0k0(Data,vrr_stack+8132, vrr_stack+14439, vrr_stack+17751, vrr_stack+5792, vrr_stack+13683, vrr_stack+9551);
 _BUILD_k0k0(Data,vrr_stack+18759, vrr_stack+15447, vrr_stack+14439, vrr_stack+2592, vrr_stack+5792, vrr_stack+3640);
 _BUILD_l0k0(Data,vrr_stack+20055, vrr_stack+18759, vrr_stack+8132, vrr_stack+15447, vrr_stack+14439, vrr_stack+10335);
 _BUILD_00l0(Data,vrr_stack+900, vrr_stack+1152, vrr_stack+1224, vrr_stack+381, vrr_stack+353, NULL);
 _BUILD_00l0(Data,vrr_stack+945, vrr_stack+1188, vrr_stack+1152, vrr_stack+493, vrr_stack+381, NULL);
 _BUILD_p0l0(Data,vrr_stack+990, vrr_stack+945, vrr_stack+900, NULL, NULL, vrr_stack+1152);
 _BUILD_00l0(Data,vrr_stack+3348, vrr_stack+409, vrr_stack+1188, vrr_stack+686, vrr_stack+493, NULL);
 _BUILD_p0l0(Data,vrr_stack+3393, vrr_stack+3348, vrr_stack+945, NULL, NULL, vrr_stack+1188);
 _BUILD_00l0(Data,vrr_stack+3528, vrr_stack+1224, vrr_stack+521, vrr_stack+353, vrr_stack+162, NULL);
 _BUILD_p0l0(Data,vrr_stack+3573, vrr_stack+900, vrr_stack+3528, NULL, NULL, vrr_stack+1224);
 _BUILD_d0l0(Data,vrr_stack+3708, vrr_stack+990, vrr_stack+3573, vrr_stack+945, vrr_stack+900, vrr_stack+1260);
 _BUILD_d0l0(Data,vrr_stack+3978, vrr_stack+3393, vrr_stack+990, vrr_stack+3348, vrr_stack+945, vrr_stack+1368);
 _BUILD_f0l0(Data,vrr_stack+9428, vrr_stack+3978, vrr_stack+3708, vrr_stack+3393, vrr_stack+990, vrr_stack+1476);
 _BUILD_00l0(Data,vrr_stack+1260, vrr_stack+445, vrr_stack+409, vrr_stack+84, vrr_stack+686, NULL);
 _BUILD_p0l0(Data,vrr_stack+1305, vrr_stack+1260, vrr_stack+3348, NULL, NULL, vrr_stack+409);
 _BUILD_d0l0(Data,vrr_stack+9878, vrr_stack+1305, vrr_stack+3393, vrr_stack+1260, vrr_stack+3348, vrr_stack+1692);
 _BUILD_f0l0(Data,vrr_stack+10148, vrr_stack+9878, vrr_stack+3978, vrr_stack+1305, vrr_stack+3393, vrr_stack+4424);
 _BUILD_00l0(Data,vrr_stack+1440, vrr_stack+521, vrr_stack+714, vrr_stack+162, vrr_stack+798, NULL);
 _BUILD_p0l0(Data,vrr_stack+1485, vrr_stack+3528, vrr_stack+1440, NULL, NULL, vrr_stack+521);
 _BUILD_d0l0(Data,vrr_stack+4248, vrr_stack+3573, vrr_stack+1485, vrr_stack+900, vrr_stack+3528, vrr_stack+557);
 _BUILD_f0l0(Data,vrr_stack+10598, vrr_stack+3708, vrr_stack+4248, vrr_stack+990, vrr_stack+3573, vrr_stack+4640);
 _BUILD_g0l0(Data,vrr_stack+21675, vrr_stack+9428, vrr_stack+10598, vrr_stack+3978, vrr_stack+3708, vrr_stack+4856);
 _BUILD_g0l0(Data,vrr_stack+4518, vrr_stack+10148, vrr_stack+9428, vrr_stack+9878, vrr_stack+3978, vrr_stack+11343);
 _BUILD_h0l0(Data,vrr_stack+22350, vrr_stack+4518, vrr_stack+21675, vrr_stack+10148, vrr_stack+9428, vrr_stack+11703);
 _BUILD_00l0(Data,vrr_stack+557, vrr_stack+2232, vrr_stack+445, vrr_stack+316, vrr_stack+84, NULL);
 _BUILD_p0l0(Data,vrr_stack+1620, vrr_stack+557, vrr_stack+1260, NULL, NULL, vrr_stack+445);
 _BUILD_d0l0(Data,vrr_stack+11048, vrr_stack+1620, vrr_stack+1305, vrr_stack+557, vrr_stack+1260, vrr_stack+1800);
 _BUILD_f0l0(Data,vrr_stack+11318, vrr_stack+11048, vrr_stack+9878, vrr_stack+1620, vrr_stack+1305, vrr_stack+1908);
 _BUILD_g0l0(Data,vrr_stack+23295, vrr_stack+11318, vrr_stack+10148, vrr_stack+11048, vrr_stack+9878, vrr_stack+5216);
 _BUILD_h0l0(Data,vrr_stack+23970, vrr_stack+23295, vrr_stack+4518, vrr_stack+11318, vrr_stack+10148, vrr_stack+12243);
 _BUILD_00l0(Data,vrr_stack+602, vrr_stack+714, vrr_stack+190, vrr_stack+798, vrr_stack+872, NULL);
 _BUILD_p0l0(Data,vrr_stack+1755, vrr_stack+1440, vrr_stack+602, NULL, NULL, vrr_stack+714);
 _BUILD_d0l0(Data,vrr_stack+5193, vrr_stack+1485, vrr_stack+1755, vrr_stack+3528, vrr_stack+1440, vrr_stack+2124);
 _BUILD_f0l0(Data,vrr_stack+11768, vrr_stack+4248, vrr_stack+5193, vrr_stack+3573, vrr_stack+1485, vrr_stack+5576);
 _BUILD_g0l0(Data,vrr_stack+24915, vrr_stack+10598, vrr_stack+11768, vrr_stack+3708, vrr_stack+4248, vrr_stack+12783);
 _BUILD_h0l0(Data,vrr_stack+25590, vrr_stack+21675, vrr_stack+24915, vrr_stack+9428, vrr_stack+10598, vrr_stack+13143);
 _BUILD_i0l0(Data,vrr_stack+12218, vrr_stack+22350, vrr_stack+25590, vrr_stack+4518, vrr_stack+21675, vrr_stack+13683);
 _BUILD_i0l0(Data,vrr_stack+26535, vrr_stack+23970, vrr_stack+22350, vrr_stack+23295, vrr_stack+4518, vrr_stack+5792);
 _BUILD_k0l0(Data,vrr_stack+27795, vrr_stack+26535, vrr_stack+12218, vrr_stack+23970, vrr_stack+22350, vrr_stack+14439);
 _BUILD_00p0(Data,vrr_stack+647, Data->F+2, Data->F+3, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+650, vrr_stack+647, vrr_stack+3, Data->F+2, Data->F+3, NULL);
 _BUILD_00f0(Data,vrr_stack+686, vrr_stack+650, vrr_stack+750, vrr_stack+647, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+857, vrr_stack+686, vrr_stack+756, vrr_stack+650, vrr_stack+750, NULL);
 _BUILD_00h0(Data,vrr_stack+1890, vrr_stack+857, vrr_stack+766, vrr_stack+686, vrr_stack+756, NULL);
 _BUILD_00i0(Data,vrr_stack+1911, vrr_stack+1890, vrr_stack+665, vrr_stack+857, vrr_stack+766, NULL);
 _BUILD_00k0(Data,vrr_stack+750, vrr_stack+1911, vrr_stack+316, vrr_stack+1890, vrr_stack+665, NULL);
 _BUILD_00l0(Data,vrr_stack+1939, vrr_stack+750, vrr_stack+2232, vrr_stack+1911, vrr_stack+316, NULL);
 _BUILD_p0l0(Data,vrr_stack+1984, vrr_stack+1939, vrr_stack+557, NULL, NULL, vrr_stack+2232);
 _BUILD_d0l0(Data,vrr_stack+5463, vrr_stack+1984, vrr_stack+1620, vrr_stack+1939, vrr_stack+557, vrr_stack+2268);
 _BUILD_f0l0(Data,vrr_stack+5733, vrr_stack+5463, vrr_stack+11048, vrr_stack+1984, vrr_stack+1620, vrr_stack+2376);
 _BUILD_g0l0(Data,vrr_stack+13478, vrr_stack+5733, vrr_stack+11318, vrr_stack+5463, vrr_stack+11048, vrr_stack+6548);
 _BUILD_h0l0(Data,vrr_stack+14153, vrr_stack+13478, vrr_stack+23295, vrr_stack+5733, vrr_stack+11318, vrr_stack+6908);
 _BUILD_i0l0(Data,vrr_stack+6183, vrr_stack+14153, vrr_stack+23970, vrr_stack+13478, vrr_stack+23295, vrr_stack+2592);
 _BUILD_k0l0(Data,vrr_stack+29415, vrr_stack+6183, vrr_stack+26535, vrr_stack+14153, vrr_stack+23970, vrr_stack+15447);
 _BUILD_00p0(Data,vrr_stack+3, Data->F+18, Data->F+19, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+2268, vrr_stack+0, vrr_stack+3, Data->F+17, Data->F+18, NULL);
 _BUILD_00f0(Data,vrr_stack+2274, vrr_stack+826, vrr_stack+2268, vrr_stack+6, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+2284, vrr_stack+832, vrr_stack+2274, vrr_stack+9, vrr_stack+826, NULL);
 _BUILD_00h0(Data,vrr_stack+2299, vrr_stack+842, vrr_stack+2284, vrr_stack+15, vrr_stack+832, NULL);
 _BUILD_00i0(Data,vrr_stack+2320, vrr_stack+61, vrr_stack+2299, vrr_stack+25, vrr_stack+842, NULL);
 _BUILD_00k0(Data,vrr_stack+2348, vrr_stack+112, vrr_stack+2320, vrr_stack+40, vrr_stack+61, NULL);
 _BUILD_00l0(Data,vrr_stack+6, vrr_stack+190, vrr_stack+2348, vrr_stack+872, vrr_stack+112, NULL);
 _BUILD_p0l0(Data,vrr_stack+2384, vrr_stack+602, vrr_stack+6, NULL, NULL, vrr_stack+190);
 _BUILD_d0l0(Data,vrr_stack+2519, vrr_stack+1755, vrr_stack+2384, vrr_stack+1440, vrr_stack+602, vrr_stack+7448);
 _BUILD_f0l0(Data,vrr_stack+2789, vrr_stack+5193, vrr_stack+2519, vrr_stack+1485, vrr_stack+1755, vrr_stack+7556);
 _BUILD_g0l0(Data,vrr_stack+15098, vrr_stack+11768, vrr_stack+2789, vrr_stack+4248, vrr_stack+5193, vrr_stack+7772);
 _BUILD_h0l0(Data,vrr_stack+31035, vrr_stack+24915, vrr_stack+15098, vrr_stack+10598, vrr_stack+11768, vrr_stack+16455);
 _BUILD_i0l0(Data,vrr_stack+31980, vrr_stack+25590, vrr_stack+31035, vrr_stack+21675, vrr_stack+24915, vrr_stack+16995);
 _BUILD_k0l0(Data,vrr_stack+15773, vrr_stack+12218, vrr_stack+31980, vrr_stack+22350, vrr_stack+25590, vrr_stack+17751);
 _BUILD_l0l0(Data,vrr_stack+33240, vrr_stack+27795, vrr_stack+15773, vrr_stack+26535, vrr_stack+12218, vrr_stack+8132);
 _BUILD_l0l0(Data,vrr_stack+35265, vrr_stack+29415, vrr_stack+27795, vrr_stack+6183, vrr_stack+26535, vrr_stack+18759);
 _BUILD_m0l0(Data,vrr_stack+17393, vrr_stack+35265, vrr_stack+33240, vrr_stack+29415, vrr_stack+27795, vrr_stack+20055);
 _BUILD_00m0(Data,vrr_stack+3239, vrr_stack+945, vrr_stack+900, vrr_stack+1188, vrr_stack+1152, NULL);
 _BUILD_00m0(Data,vrr_stack+2119, vrr_stack+3348, vrr_stack+945, vrr_stack+409, vrr_stack+1188, NULL);
 _BUILD_00m0(Data,vrr_stack+2174, vrr_stack+900, vrr_stack+3528, vrr_stack+1152, vrr_stack+1224, NULL);
 _BUILD_p0m0(Data,vrr_stack+7443, vrr_stack+3239, vrr_stack+2174, NULL, NULL, vrr_stack+900);
 _BUILD_p0m0(Data,vrr_stack+7608, vrr_stack+2119, vrr_stack+3239, NULL, NULL, vrr_stack+945);
 _BUILD_d0m0(Data,vrr_stack+7773, vrr_stack+7608, vrr_stack+7443, vrr_stack+2119, vrr_stack+3239, vrr_stack+990);
 _BUILD_00m0(Data,vrr_stack+990, vrr_stack+1260, vrr_stack+3348, vrr_stack+445, vrr_stack+409, NULL);
 _BUILD_p0m0(Data,vrr_stack+1045, vrr_stack+990, vrr_stack+2119, NULL, NULL, vrr_stack+3348);
 _BUILD_d0m0(Data,vrr_stack+8103, vrr_stack+1045, vrr_stack+7608, vrr_stack+990, vrr_stack+2119, vrr_stack+3393);
 _BUILD_00m0(Data,vrr_stack+3393, vrr_stack+3528, vrr_stack+1440, vrr_stack+1224, vrr_stack+521, NULL);
 _BUILD_p0m0(Data,vrr_stack+8433, vrr_stack+2174, vrr_stack+3393, NULL, NULL, vrr_stack+3528);
 _BUILD_d0m0(Data,vrr_stack+8598, vrr_stack+7443, vrr_stack+8433, vrr_stack+3239, vrr_stack+2174, vrr_stack+3573);
 _BUILD_f0m0(Data,vrr_stack+19868, vrr_stack+7773, vrr_stack+8598, vrr_stack+7608, vrr_stack+7443, vrr_stack+3708);
 _BUILD_f0m0(Data,vrr_stack+20418, vrr_stack+8103, vrr_stack+7773, vrr_stack+1045, vrr_stack+7608, vrr_stack+3978);
 _BUILD_g0m0(Data,vrr_stack+37290, vrr_stack+20418, vrr_stack+19868, vrr_stack+8103, vrr_stack+7773, vrr_stack+9428);
 _BUILD_00m0(Data,vrr_stack+3573, vrr_stack+557, vrr_stack+1260, vrr_stack+2232, vrr_stack+445, NULL);
 _BUILD_p0m0(Data,vrr_stack+3628, vrr_stack+3573, vrr_stack+990, NULL, NULL, vrr_stack+1260);
 _BUILD_d0m0(Data,vrr_stack+3793, vrr_stack+3628, vrr_stack+1045, vrr_stack+3573, vrr_stack+990, vrr_stack+1305);
 _BUILD_f0m0(Data,vrr_stack+8928, vrr_stack+3793, vrr_stack+8103, vrr_stack+3628, vrr_stack+1045, vrr_stack+9878);
 _BUILD_g0m0(Data,vrr_stack+38115, vrr_stack+8928, vrr_stack+20418, vrr_stack+3793, vrr_stack+8103, vrr_stack+10148);
 _BUILD_00m0(Data,vrr_stack+1305, vrr_stack+1440, vrr_stack+602, vrr_stack+521, vrr_stack+714, NULL);
 _BUILD_p0m0(Data,vrr_stack+9478, vrr_stack+3393, vrr_stack+1305, NULL, NULL, vrr_stack+1440);
 _BUILD_d0m0(Data,vrr_stack+9643, vrr_stack+8433, vrr_stack+9478, vrr_stack+2174, vrr_stack+3393, vrr_stack+1485);
 _BUILD_f0m0(Data,vrr_stack+9973, vrr_stack+8598, vrr_stack+9643, vrr_stack+7443, vrr_stack+8433, vrr_stack+4248);
 _BUILD_g0m0(Data,vrr_stack+38940, vrr_stack+19868, vrr_stack+9973, vrr_stack+7773, vrr_stack+8598, vrr_stack+10598);
 _BUILD_h0m0(Data,vrr_stack+39765, vrr_stack+37290, vrr_stack+38940, vrr_stack+20418, vrr_stack+19868, vrr_stack+21675);
 _BUILD_h0m0(Data,vrr_stack+20968, vrr_stack+38115, vrr_stack+37290, vrr_stack+8928, vrr_stack+20418, vrr_stack+4518);
 _BUILD_i0m0(Data,vrr_stack+40920, vrr_stack+20968, vrr_stack+39765, vrr_stack+38115, vrr_stack+37290, vrr_stack+22350);
 _BUILD_00m0(Data,vrr_stack+1485, vrr_stack+1939, vrr_stack+557, vrr_stack+750, vrr_stack+2232, NULL);
 _BUILD_p0m0(Data,vrr_stack+4123, vrr_stack+1485, vrr_stack+3573, NULL, NULL, vrr_stack+557);
 _BUILD_d0m0(Data,vrr_stack+4288, vrr_stack+4123, vrr_stack+3628, vrr_stack+1485, vrr_stack+3573, vrr_stack+1620);
 _BUILD_f0m0(Data,vrr_stack+4618, vrr_stack+4288, vrr_stack+3793, vrr_stack+4123, vrr_stack+3628, vrr_stack+11048);
 _BUILD_g0m0(Data,vrr_stack+22123, vrr_stack+4618, vrr_stack+8928, vrr_stack+4288, vrr_stack+3793, vrr_stack+11318);
 _BUILD_h0m0(Data,vrr_stack+10523, vrr_stack+22123, vrr_stack+38115, vrr_stack+4618, vrr_stack+8928, vrr_stack+23295);
 _BUILD_i0m0(Data,vrr_stack+42460, vrr_stack+10523, vrr_stack+20968, vrr_stack+22123, vrr_stack+38115, vrr_stack+23970);
 _BUILD_00m0(Data,vrr_stack+1540, vrr_stack+602, vrr_stack+6, vrr_stack+714, vrr_stack+190, NULL);
 _BUILD_p0m0(Data,vrr_stack+226, vrr_stack+1305, vrr_stack+1540, NULL, NULL, vrr_stack+602);
 _BUILD_d0m0(Data,vrr_stack+22948, vrr_stack+9478, vrr_stack+226, vrr_stack+3393, vrr_stack+1305, vrr_stack+1755);
 _BUILD_f0m0(Data,vrr_stack+23278, vrr_stack+9643, vrr_stack+22948, vrr_stack+8433, vrr_stack+9478, vrr_stack+5193);
 _BUILD_g0m0(Data,vrr_stack+23828, vrr_stack+9973, vrr_stack+23278, vrr_stack+8598, vrr_stack+9643, vrr_stack+11768);
 _BUILD_h0m0(Data,vrr_stack+44000, vrr_stack+38940, vrr_stack+23828, vrr_stack+19868, vrr_stack+9973, vrr_stack+24915);
 _BUILD_i0m0(Data,vrr_stack+45155, vrr_stack+39765, vrr_stack+44000, vrr_stack+37290, vrr_stack+38940, vrr_stack+25590);
 _BUILD_k0m0(Data,vrr_stack+46695, vrr_stack+40920, vrr_stack+45155, vrr_stack+20968, vrr_stack+39765, vrr_stack+12218);
 _BUILD_k0m0(Data,vrr_stack+48675, vrr_stack+42460, vrr_stack+40920, vrr_stack+10523, vrr_stack+20968, vrr_stack+26535);
 _BUILD_l0m0(Data,vrr_stack+24653, vrr_stack+48675, vrr_stack+46695, vrr_stack+42460, vrr_stack+40920, vrr_stack+27795);
 _BUILD_00p0(Data,vrr_stack+1595, Data->F+1, Data->F+2, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1598, vrr_stack+1595, vrr_stack+647, Data->F+1, Data->F+2, NULL);
 _BUILD_00f0(Data,vrr_stack+51, vrr_stack+1598, vrr_stack+650, vrr_stack+1595, vrr_stack+647, NULL);
 _BUILD_00g0(Data,vrr_stack+1604, vrr_stack+51, vrr_stack+686, vrr_stack+1598, vrr_stack+650, NULL);
 _BUILD_00h0(Data,vrr_stack+647, vrr_stack+1604, vrr_stack+857, vrr_stack+51, vrr_stack+686, NULL);
 _BUILD_00i0(Data,vrr_stack+872, vrr_stack+647, vrr_stack+1890, vrr_stack+1604, vrr_stack+857, NULL);
 _BUILD_00k0(Data,vrr_stack+668, vrr_stack+872, vrr_stack+1911, vrr_stack+647, vrr_stack+1890, NULL);
 _BUILD_00l0(Data,vrr_stack+704, vrr_stack+668, vrr_stack+750, vrr_stack+872, vrr_stack+1911, NULL);
 _BUILD_00m0(Data,vrr_stack+1619, vrr_stack+704, vrr_stack+1939, vrr_stack+668, vrr_stack+750, NULL);
 _BUILD_p0m0(Data,vrr_stack+1674, vrr_stack+1619, vrr_stack+1485, NULL, NULL, vrr_stack+1939);
 _BUILD_d0m0(Data,vrr_stack+11678, vrr_stack+1674, vrr_stack+4123, vrr_stack+1619, vrr_stack+1485, vrr_stack+1984);
 _BUILD_f0m0(Data,vrr_stack+12008, vrr_stack+11678, vrr_stack+4288, vrr_stack+1674, vrr_stack+4123, vrr_stack+5463);
 _BUILD_g0m0(Data,vrr_stack+12558, vrr_stack+12008, vrr_stack+4618, vrr_stack+11678, vrr_stack+4288, vrr_stack+5733);
 _BUILD_h0m0(Data,vrr_stack+27128, vrr_stack+12558, vrr_stack+22123, vrr_stack+12008, vrr_stack+4618, vrr_stack+13478);
 _BUILD_i0m0(Data,vrr_stack+50655, vrr_stack+27128, vrr_stack+10523, vrr_stack+12558, vrr_stack+22123, vrr_stack+14153);
 _BUILD_k0m0(Data,vrr_stack+52195, vrr_stack+50655, vrr_stack+42460, vrr_stack+27128, vrr_stack+10523, vrr_stack+6183);
 _BUILD_l0m0(Data,vrr_stack+54175, vrr_stack+52195, vrr_stack+48675, vrr_stack+50655, vrr_stack+42460, vrr_stack+29415);
 _BUILD_00p0(Data,vrr_stack+1984, Data->F+19, Data->F+20, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+1987, vrr_stack+3, vrr_stack+1984, Data->F+18, Data->F+19, NULL);
 _BUILD_00f0(Data,vrr_stack+1993, vrr_stack+2268, vrr_stack+1987, vrr_stack+0, vrr_stack+3, NULL);
 _BUILD_00g0(Data,vrr_stack+857, vrr_stack+2274, vrr_stack+1993, vrr_stack+826, vrr_stack+2268, NULL);
 _BUILD_00h0(Data,vrr_stack+2003, vrr_stack+2284, vrr_stack+857, vrr_stack+832, vrr_stack+2274, NULL);
 _BUILD_00i0(Data,vrr_stack+2024, vrr_stack+2299, vrr_stack+2003, vrr_stack+842, vrr_stack+2284, NULL);
 _BUILD_00k0(Data,vrr_stack+2052, vrr_stack+2320, vrr_stack+2024, vrr_stack+61, vrr_stack+2299, NULL);
 _BUILD_00l0(Data,vrr_stack+61, vrr_stack+2348, vrr_stack+2052, vrr_stack+112, vrr_stack+2320, NULL);
 _BUILD_00m0(Data,vrr_stack+106, vrr_stack+6, vrr_stack+61, vrr_stack+190, vrr_stack+2348, NULL);
 _BUILD_p0m0(Data,vrr_stack+5168, vrr_stack+1540, vrr_stack+106, NULL, NULL, vrr_stack+6);
 _BUILD_d0m0(Data,vrr_stack+5333, vrr_stack+226, vrr_stack+5168, vrr_stack+1305, vrr_stack+1540, vrr_stack+2384);
 _BUILD_f0m0(Data,vrr_stack+5663, vrr_stack+22948, vrr_stack+5333, vrr_stack+9478, vrr_stack+226, vrr_stack+2519);
 _BUILD_g0m0(Data,vrr_stack+6213, vrr_stack+23278, vrr_stack+5663, vrr_stack+9643, vrr_stack+22948, vrr_stack+2789);
 _BUILD_h0m0(Data,vrr_stack+13383, vrr_stack+23828, vrr_stack+6213, vrr_stack+9973, vrr_stack+23278, vrr_stack+15098);
 _BUILD_i0m0(Data,vrr_stack+28283, vrr_stack+44000, vrr_stack+13383, vrr_stack+38940, vrr_stack+23828, vrr_stack+31035);
 _BUILD_k0m0(Data,vrr_stack+29823, vrr_stack+45155, vrr_stack+28283, vrr_stack+39765, vrr_stack+44000, vrr_stack+31980);
 _BUILD_l0m0(Data,vrr_stack+56650, vrr_stack+46695, vrr_stack+29823, vrr_stack+40920, vrr_stack+45155, vrr_stack+15773);
 _BUILD_m0m0(Data,vrr_stack+59125, vrr_stack+24653, vrr_stack+56650, vrr_stack+48675, vrr_stack+46695, vrr_stack+33240);
 _BUILD_m0m0(Data,vrr_stack+31803, vrr_stack+54175, vrr_stack+24653, vrr_stack+52195, vrr_stack+48675, vrr_stack+35265);
 _BUILD_n0m0(Data,vrr_stack+62150, vrr_stack+31803, vrr_stack+59125, vrr_stack+54175, vrr_stack+24653, vrr_stack+17393);
 _BUILD_00n0(Data,vrr_stack+2384, vrr_stack+3239, vrr_stack+2174, vrr_stack+945, vrr_stack+900, NULL);
 _BUILD_00n0(Data,vrr_stack+2450, vrr_stack+2119, vrr_stack+3239, vrr_stack+3348, vrr_stack+945, NULL);
 _BUILD_p0n0(Data,vrr_stack+2516, vrr_stack+2450, vrr_stack+2384, NULL, NULL, vrr_stack+3239);
 _BUILD_00n0(Data,vrr_stack+2714, vrr_stack+990, vrr_stack+2119, vrr_stack+1260, vrr_stack+3348, NULL);
 _BUILD_p0n0(Data,vrr_stack+2780, vrr_stack+2714, vrr_stack+2450, NULL, NULL, vrr_stack+2119);
 _BUILD_00n0(Data,vrr_stack+2978, vrr_stack+2174, vrr_stack+3393, vrr_stack+900, vrr_stack+3528, NULL);
 _BUILD_p0n0(Data,vrr_stack+7038, vrr_stack+2384, vrr_stack+2978, NULL, NULL, vrr_stack+2174);
 _BUILD_d0n0(Data,vrr_stack+14538, vrr_stack+2516, vrr_stack+7038, vrr_stack+2450, vrr_stack+2384, vrr_stack+7443);
 _BUILD_d0n0(Data,vrr_stack+14934, vrr_stack+2780, vrr_stack+2516, vrr_stack+2714, vrr_stack+2450, vrr_stack+7608);
 _BUILD_f0n0(Data,vrr_stack+15330, vrr_stack+14934, vrr_stack+14538, vrr_stack+2780, vrr_stack+2516, vrr_stack+7773);
 _BUILD_00n0(Data,vrr_stack+900, vrr_stack+3573, vrr_stack+990, vrr_stack+557, vrr_stack+1260, NULL);
 _BUILD_p0n0(Data,vrr_stack+7236, vrr_stack+900, vrr_stack+2714, NULL, NULL, vrr_stack+990);
 _BUILD_d0n0(Data,vrr_stack+7434, vrr_stack+7236, vrr_stack+2780, vrr_stack+900, vrr_stack+2714, vrr_stack+1045);
 _BUILD_f0n0(Data,vrr_stack+15990, vrr_stack+7434, vrr_stack+14934, vrr_stack+7236, vrr_stack+2780, vrr_stack+8103);
 _BUILD_00n0(Data,vrr_stack+1045, vrr_stack+3393, vrr_stack+1305, vrr_stack+3528, vrr_stack+1440, NULL);
 _BUILD_p0n0(Data,vrr_stack+7830, vrr_stack+2978, vrr_stack+1045, NULL, NULL, vrr_stack+3393);
 _BUILD_d0n0(Data,vrr_stack+8028, vrr_stack+7038, vrr_stack+7830, vrr_stack+2384, vrr_stack+2978, vrr_stack+8433);
 _BUILD_f0n0(Data,vrr_stack+16650, vrr_stack+14538, vrr_stack+8028, vrr_stack+2516, vrr_stack+7038, vrr_stack+8598);
 _BUILD_g0n0(Data,vrr_stack+17310, vrr_stack+15330, vrr_stack+16650, vrr_stack+14934, vrr_stack+14538, vrr_stack+19868);
 _BUILD_g0n0(Data,vrr_stack+18300, vrr_stack+15990, vrr_stack+15330, vrr_stack+7434, vrr_stack+14934, vrr_stack+20418);
 _BUILD_h0n0(Data,vrr_stack+19290, vrr_stack+18300, vrr_stack+17310, vrr_stack+15990, vrr_stack+15330, vrr_stack+37290);
 _BUILD_00n0(Data,vrr_stack+1111, vrr_stack+1485, vrr_stack+3573, vrr_stack+1939, vrr_stack+557, NULL);
 _BUILD_p0n0(Data,vrr_stack+8424, vrr_stack+1111, vrr_stack+900, NULL, NULL, vrr_stack+3573);
 _BUILD_d0n0(Data,vrr_stack+34828, vrr_stack+8424, vrr_stack+7236, vrr_stack+1111, vrr_stack+900, vrr_stack+3628);
 _BUILD_f0n0(Data,vrr_stack+35224, vrr_stack+34828, vrr_stack+7434, vrr_stack+8424, vrr_stack+7236, vrr_stack+3793);
 _BUILD_g0n0(Data,vrr_stack+35884, vrr_stack+35224, vrr_stack+15990, vrr_stack+34828, vrr_stack+7434, vrr_stack+8928);
 _BUILD_h0n0(Data,vrr_stack+65780, vrr_stack+35884, vrr_stack+18300, vrr_stack+35224, vrr_stack+15990, vrr_stack+38115);
 _BUILD_00n0(Data,vrr_stack+3628, vrr_stack+1305, vrr_stack+1540, vrr_stack+1440, vrr_stack+602, NULL);
 _BUILD_p0n0(Data,vrr_stack+3694, vrr_stack+1045, vrr_stack+3628, NULL, NULL, vrr_stack+1305);
 _BUILD_d0n0(Data,vrr_stack+8622, vrr_stack+7830, vrr_stack+3694, vrr_stack+2978, vrr_stack+1045, vrr_stack+9478);
 _BUILD_f0n0(Data,vrr_stack+36874, vrr_stack+8028, vrr_stack+8622, vrr_stack+7038, vrr_stack+7830, vrr_stack+9643);
 _BUILD_g0n0(Data,vrr_stack+37534, vrr_stack+16650, vrr_stack+36874, vrr_stack+14538, vrr_stack+8028, vrr_stack+9973);
 _BUILD_h0n0(Data,vrr_stack+9018, vrr_stack+17310, vrr_stack+37534, vrr_stack+15330, vrr_stack+16650, vrr_stack+38940);
 _BUILD_i0n0(Data,vrr_stack+67166, vrr_stack+19290, vrr_stack+9018, vrr_stack+18300, vrr_stack+17310, vrr_stack+39765);
 _BUILD_i0n0(Data,vrr_stack+38524, vrr_stack+65780, vrr_stack+19290, vrr_stack+35884, vrr_stack+18300, vrr_stack+20968);
 _BUILD_k0n0(Data,vrr_stack+69014, vrr_stack+38524, vrr_stack+67166, vrr_stack+65780, vrr_stack+19290, vrr_stack+40920);
 _BUILD_00n0(Data,vrr_stack+3892, vrr_stack+1619, vrr_stack+1485, vrr_stack+704, vrr_stack+1939, NULL);
 _BUILD_p0n0(Data,vrr_stack+20676, vrr_stack+3892, vrr_stack+1111, NULL, NULL, vrr_stack+1485);
 _BUILD_d0n0(Data,vrr_stack+20874, vrr_stack+20676, vrr_stack+8424, vrr_stack+3892, vrr_stack+1111, vrr_stack+4123);
 _BUILD_f0n0(Data,vrr_stack+21270, vrr_stack+20874, vrr_stack+34828, vrr_stack+20676, vrr_stack+8424, vrr_stack+4288);
 _BUILD_g0n0(Data,vrr_stack+40372, vrr_stack+21270, vrr_stack+35224, vrr_stack+20874, vrr_stack+34828, vrr_stack+4618);
 _BUILD_h0n0(Data,vrr_stack+71390, vrr_stack+40372, vrr_stack+35884, vrr_stack+21270, vrr_stack+35224, vrr_stack+22123);
 _BUILD_i0n0(Data,vrr_stack+72776, vrr_stack+71390, vrr_stack+65780, vrr_stack+40372, vrr_stack+35884, vrr_stack+10523);
 _BUILD_k0n0(Data,vrr_stack+74624, vrr_stack+72776, vrr_stack+38524, vrr_stack+71390, vrr_stack+65780, vrr_stack+42460);
 _BUILD_00n0(Data,vrr_stack+3958, vrr_stack+1540, vrr_stack+106, vrr_stack+602, vrr_stack+6, NULL);
 _BUILD_p0n0(Data,vrr_stack+4024, vrr_stack+3628, vrr_stack+3958, NULL, NULL, vrr_stack+1540);
 _BUILD_d0n0(Data,vrr_stack+4222, vrr_stack+3694, vrr_stack+4024, vrr_stack+1045, vrr_stack+3628, vrr_stack+226);
 _BUILD_f0n0(Data,vrr_stack+10404, vrr_stack+8622, vrr_stack+4222, vrr_stack+7830, vrr_stack+3694, vrr_stack+22948);
 _BUILD_g0n0(Data,vrr_stack+21930, vrr_stack+36874, vrr_stack+10404, vrr_stack+8028, vrr_stack+8622, vrr_stack+23278);
 _BUILD_h0n0(Data,vrr_stack+41362, vrr_stack+37534, vrr_stack+21930, vrr_stack+16650, vrr_stack+36874, vrr_stack+23828);
 _BUILD_i0n0(Data,vrr_stack+77000, vrr_stack+9018, vrr_stack+41362, vrr_stack+17310, vrr_stack+37534, vrr_stack+44000);
 _BUILD_k0n0(Data,vrr_stack+42748, vrr_stack+67166, vrr_stack+77000, vrr_stack+19290, vrr_stack+9018, vrr_stack+45155);
 _BUILD_l0n0(Data,vrr_stack+78848, vrr_stack+69014, vrr_stack+42748, vrr_stack+38524, vrr_stack+67166, vrr_stack+46695);
 _BUILD_l0n0(Data,vrr_stack+45124, vrr_stack+74624, vrr_stack+69014, vrr_stack+72776, vrr_stack+38524, vrr_stack+48675);
 _BUILD_m0n0(Data,vrr_stack+81818, vrr_stack+45124, vrr_stack+78848, vrr_stack+74624, vrr_stack+69014, vrr_stack+24653);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+0, Data->F+1, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+4618, vrr_stack+0, vrr_stack+1595, Data->F+0, Data->F+1, NULL);
 _BUILD_00f0(Data,vrr_stack+4624, vrr_stack+4618, vrr_stack+1598, vrr_stack+0, vrr_stack+1595, NULL);
 _BUILD_00g0(Data,vrr_stack+4634, vrr_stack+4624, vrr_stack+51, vrr_stack+4618, vrr_stack+1598, NULL);
 _BUILD_00h0(Data,vrr_stack+4649, vrr_stack+4634, vrr_stack+1604, vrr_stack+4624, vrr_stack+51, NULL);
 _BUILD_00i0(Data,vrr_stack+4670, vrr_stack+4649, vrr_stack+647, vrr_stack+4634, vrr_stack+1604, NULL);
 _BUILD_00k0(Data,vrr_stack+4698, vrr_stack+4670, vrr_stack+872, vrr_stack+4649, vrr_stack+647, NULL);
 _BUILD_00l0(Data,vrr_stack+4618, vrr_stack+4698, vrr_stack+668, vrr_stack+4670, vrr_stack+872, NULL);
 _BUILD_00m0(Data,vrr_stack+4734, vrr_stack+4618, vrr_stack+704, vrr_stack+4698, vrr_stack+668, NULL);
 _BUILD_00n0(Data,vrr_stack+4663, vrr_stack+4734, vrr_stack+1619, vrr_stack+4618, vrr_stack+704, NULL);
 _BUILD_p0n0(Data,vrr_stack+4789, vrr_stack+4663, vrr_stack+3892, NULL, NULL, vrr_stack+1619);
 _BUILD_d0n0(Data,vrr_stack+161, vrr_stack+4789, vrr_stack+20676, vrr_stack+4663, vrr_stack+3892, vrr_stack+1674);
 _BUILD_f0n0(Data,vrr_stack+22920, vrr_stack+161, vrr_stack+20874, vrr_stack+4789, vrr_stack+20676, vrr_stack+11678);
 _BUILD_g0n0(Data,vrr_stack+23580, vrr_stack+22920, vrr_stack+21270, vrr_stack+161, vrr_stack+20874, vrr_stack+12008);
 _BUILD_h0n0(Data,vrr_stack+11064, vrr_stack+23580, vrr_stack+40372, vrr_stack+22920, vrr_stack+21270, vrr_stack+12558);
 _BUILD_i0n0(Data,vrr_stack+24570, vrr_stack+11064, vrr_stack+71390, vrr_stack+23580, vrr_stack+40372, vrr_stack+27128);
 _BUILD_k0n0(Data,vrr_stack+48094, vrr_stack+24570, vrr_stack+72776, vrr_stack+11064, vrr_stack+71390, vrr_stack+50655);
 _BUILD_l0n0(Data,vrr_stack+85448, vrr_stack+48094, vrr_stack+74624, vrr_stack+24570, vrr_stack+72776, vrr_stack+52195);
 _BUILD_m0n0(Data,vrr_stack+22920, vrr_stack+85448, vrr_stack+45124, vrr_stack+48094, vrr_stack+74624, vrr_stack+54175);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+20, Data->F+21, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+48094, vrr_stack+1984, vrr_stack+0, Data->F+19, Data->F+20, NULL);
 _BUILD_00f0(Data,vrr_stack+51, vrr_stack+1987, vrr_stack+48094, vrr_stack+3, vrr_stack+1984, NULL);
 _BUILD_00g0(Data,vrr_stack+48100, vrr_stack+1993, vrr_stack+51, vrr_stack+2268, vrr_stack+1987, NULL);
 _BUILD_00h0(Data,vrr_stack+48115, vrr_stack+857, vrr_stack+48100, vrr_stack+2274, vrr_stack+1993, NULL);
 _BUILD_00i0(Data,vrr_stack+872, vrr_stack+2003, vrr_stack+48115, vrr_stack+2284, vrr_stack+857, NULL);
 _BUILD_00k0(Data,vrr_stack+48136, vrr_stack+2024, vrr_stack+872, vrr_stack+2299, vrr_stack+2003, NULL);
 _BUILD_00l0(Data,vrr_stack+4618, vrr_stack+2052, vrr_stack+48136, vrr_stack+2320, vrr_stack+2024, NULL);
 _BUILD_00m0(Data,vrr_stack+48172, vrr_stack+61, vrr_stack+4618, vrr_stack+2348, vrr_stack+2052, NULL);
 _BUILD_00n0(Data,vrr_stack+48227, vrr_stack+106, vrr_stack+48172, vrr_stack+6, vrr_stack+61, NULL);
 _BUILD_p0n0(Data,vrr_stack+48293, vrr_stack+3958, vrr_stack+48227, NULL, NULL, vrr_stack+106);
 _BUILD_d0n0(Data,vrr_stack+48491, vrr_stack+4024, vrr_stack+48293, vrr_stack+3628, vrr_stack+3958, vrr_stack+5168);
 _BUILD_f0n0(Data,vrr_stack+48887, vrr_stack+4222, vrr_stack+48491, vrr_stack+3694, vrr_stack+4024, vrr_stack+5333);
 _BUILD_g0n0(Data,vrr_stack+49547, vrr_stack+10404, vrr_stack+48887, vrr_stack+8622, vrr_stack+4222, vrr_stack+5663);
 _BUILD_h0n0(Data,vrr_stack+50537, vrr_stack+21930, vrr_stack+49547, vrr_stack+36874, vrr_stack+10404, vrr_stack+6213);
 _BUILD_i0n0(Data,vrr_stack+51923, vrr_stack+41362, vrr_stack+50537, vrr_stack+37534, vrr_stack+21930, vrr_stack+13383);
 _BUILD_k0n0(Data,vrr_stack+53771, vrr_stack+77000, vrr_stack+51923, vrr_stack+9018, vrr_stack+41362, vrr_stack+28283);
 _BUILD_l0n0(Data,vrr_stack+11064, vrr_stack+42748, vrr_stack+53771, vrr_stack+67166, vrr_stack+77000, vrr_stack+29823);
 _BUILD_m0n0(Data,vrr_stack+26550, vrr_stack+78848, vrr_stack+11064, vrr_stack+69014, vrr_stack+42748, vrr_stack+56650);
 _BUILD_n0n0(Data,vrr_stack+88418, vrr_stack+81818, vrr_stack+26550, vrr_stack+45124, vrr_stack+78848, vrr_stack+59125);
 _BUILD_n0n0(Data,vrr_stack+56147, vrr_stack+22920, vrr_stack+81818, vrr_stack+85448, vrr_stack+45124, vrr_stack+31803);
   tmp = vrr_stack + 56147;
   target_ptr = Libint->vrr_classes[10][10];
   for(i=0;i<4356;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00o0(Data,vrr_stack+85448, vrr_stack+2384, vrr_stack+2978, vrr_stack+3239, vrr_stack+2174, NULL);
 _BUILD_00o0(Data,vrr_stack+85526, vrr_stack+2450, vrr_stack+2384, vrr_stack+2119, vrr_stack+3239, NULL);
 _BUILD_p0o0(Data,vrr_stack+85604, vrr_stack+85526, vrr_stack+85448, NULL, NULL, vrr_stack+2384);
 _BUILD_00o0(Data,vrr_stack+85838, vrr_stack+2714, vrr_stack+2450, vrr_stack+990, vrr_stack+2119, NULL);
 _BUILD_p0o0(Data,vrr_stack+85916, vrr_stack+85838, vrr_stack+85526, NULL, NULL, vrr_stack+2450);
 _BUILD_00o0(Data,vrr_stack+86150, vrr_stack+2978, vrr_stack+1045, vrr_stack+2174, vrr_stack+3393, NULL);
 _BUILD_p0o0(Data,vrr_stack+86228, vrr_stack+85448, vrr_stack+86150, NULL, NULL, vrr_stack+2978);
 _BUILD_d0o0(Data,vrr_stack+86462, vrr_stack+85604, vrr_stack+86228, vrr_stack+85526, vrr_stack+85448, vrr_stack+7038);
 _BUILD_d0o0(Data,vrr_stack+86930, vrr_stack+85916, vrr_stack+85604, vrr_stack+85838, vrr_stack+85526, vrr_stack+2516);
 _BUILD_f0o0(Data,vrr_stack+87398, vrr_stack+86930, vrr_stack+86462, vrr_stack+85916, vrr_stack+85604, vrr_stack+14538);
 _BUILD_00o0(Data,vrr_stack+2516, vrr_stack+900, vrr_stack+2714, vrr_stack+3573, vrr_stack+990, NULL);
 _BUILD_p0o0(Data,vrr_stack+88178, vrr_stack+2516, vrr_stack+85838, NULL, NULL, vrr_stack+2714);
 _BUILD_d0o0(Data,vrr_stack+60503, vrr_stack+88178, vrr_stack+85916, vrr_stack+2516, vrr_stack+85838, vrr_stack+2780);
 _BUILD_f0o0(Data,vrr_stack+60971, vrr_stack+60503, vrr_stack+86930, vrr_stack+88178, vrr_stack+85916, vrr_stack+14934);
 _BUILD_00o0(Data,vrr_stack+2780, vrr_stack+1045, vrr_stack+3628, vrr_stack+3393, vrr_stack+1305, NULL);
 _BUILD_p0o0(Data,vrr_stack+61751, vrr_stack+86150, vrr_stack+2780, NULL, NULL, vrr_stack+1045);
 _BUILD_d0o0(Data,vrr_stack+14034, vrr_stack+86228, vrr_stack+61751, vrr_stack+85448, vrr_stack+86150, vrr_stack+7830);
 _BUILD_f0o0(Data,vrr_stack+14502, vrr_stack+86462, vrr_stack+14034, vrr_stack+85604, vrr_stack+86228, vrr_stack+8028);
 _BUILD_g0o0(Data,vrr_stack+30180, vrr_stack+87398, vrr_stack+14502, vrr_stack+86930, vrr_stack+86462, vrr_stack+16650);
 _BUILD_g0o0(Data,vrr_stack+31350, vrr_stack+60971, vrr_stack+87398, vrr_stack+60503, vrr_stack+86930, vrr_stack+15330);
 _BUILD_h0o0(Data,vrr_stack+32520, vrr_stack+31350, vrr_stack+30180, vrr_stack+60971, vrr_stack+87398, vrr_stack+17310);
 _BUILD_00o0(Data,vrr_stack+16650, vrr_stack+1111, vrr_stack+900, vrr_stack+1485, vrr_stack+3573, NULL);
 _BUILD_p0o0(Data,vrr_stack+16728, vrr_stack+16650, vrr_stack+2516, NULL, NULL, vrr_stack+900);
 _BUILD_d0o0(Data,vrr_stack+16962, vrr_stack+16728, vrr_stack+88178, vrr_stack+16650, vrr_stack+2516, vrr_stack+7236);
 _BUILD_f0o0(Data,vrr_stack+17430, vrr_stack+16962, vrr_stack+60503, vrr_stack+16728, vrr_stack+88178, vrr_stack+7434);
 _BUILD_g0o0(Data,vrr_stack+4789, vrr_stack+17430, vrr_stack+60971, vrr_stack+16962, vrr_stack+60503, vrr_stack+15990);
 _BUILD_h0o0(Data,vrr_stack+5959, vrr_stack+4789, vrr_stack+31350, vrr_stack+17430, vrr_stack+60971, vrr_stack+18300);
 _BUILD_00o0(Data,vrr_stack+18210, vrr_stack+3628, vrr_stack+3958, vrr_stack+1305, vrr_stack+1540, NULL);
 _BUILD_p0o0(Data,vrr_stack+18288, vrr_stack+2780, vrr_stack+18210, NULL, NULL, vrr_stack+3628);
 _BUILD_d0o0(Data,vrr_stack+18522, vrr_stack+61751, vrr_stack+18288, vrr_stack+86150, vrr_stack+2780, vrr_stack+3694);
 _BUILD_f0o0(Data,vrr_stack+15282, vrr_stack+14034, vrr_stack+18522, vrr_stack+86228, vrr_stack+61751, vrr_stack+8622);
 _BUILD_g0o0(Data,vrr_stack+92774, vrr_stack+14502, vrr_stack+15282, vrr_stack+86462, vrr_stack+14034, vrr_stack+36874);
 _BUILD_h0o0(Data,vrr_stack+93944, vrr_stack+30180, vrr_stack+92774, vrr_stack+87398, vrr_stack+14502, vrr_stack+37534);
 _BUILD_i0o0(Data,vrr_stack+95582, vrr_stack+32520, vrr_stack+93944, vrr_stack+31350, vrr_stack+30180, vrr_stack+9018);
 _BUILD_i0o0(Data,vrr_stack+97766, vrr_stack+5959, vrr_stack+32520, vrr_stack+4789, vrr_stack+31350, vrr_stack+19290);
 _BUILD_k0o0(Data,vrr_stack+99950, vrr_stack+97766, vrr_stack+95582, vrr_stack+5959, vrr_stack+32520, vrr_stack+67166);
 _BUILD_00o0(Data,vrr_stack+67166, vrr_stack+3892, vrr_stack+1111, vrr_stack+1619, vrr_stack+1485, NULL);
 _BUILD_p0o0(Data,vrr_stack+67244, vrr_stack+67166, vrr_stack+16650, NULL, NULL, vrr_stack+1111);
 _BUILD_d0o0(Data,vrr_stack+67478, vrr_stack+67244, vrr_stack+16728, vrr_stack+67166, vrr_stack+16650, vrr_stack+8424);
 _BUILD_f0o0(Data,vrr_stack+67946, vrr_stack+67478, vrr_stack+16962, vrr_stack+67244, vrr_stack+16728, vrr_stack+34828);
 _BUILD_g0o0(Data,vrr_stack+36874, vrr_stack+67946, vrr_stack+17430, vrr_stack+67478, vrr_stack+16962, vrr_stack+35224);
 _BUILD_h0o0(Data,vrr_stack+18990, vrr_stack+36874, vrr_stack+4789, vrr_stack+67946, vrr_stack+17430, vrr_stack+35884);
 _BUILD_i0o0(Data,vrr_stack+34158, vrr_stack+18990, vrr_stack+5959, vrr_stack+36874, vrr_stack+4789, vrr_stack+65780);
 _BUILD_k0o0(Data,vrr_stack+102758, vrr_stack+34158, vrr_stack+97766, vrr_stack+18990, vrr_stack+5959, vrr_stack+38524);
 _BUILD_00o0(Data,vrr_stack+65780, vrr_stack+3958, vrr_stack+48227, vrr_stack+1540, vrr_stack+106, NULL);
 _BUILD_p0o0(Data,vrr_stack+65858, vrr_stack+18210, vrr_stack+65780, NULL, NULL, vrr_stack+3958);
 _BUILD_d0o0(Data,vrr_stack+66092, vrr_stack+18288, vrr_stack+65858, vrr_stack+2780, vrr_stack+18210, vrr_stack+4024);
 _BUILD_f0o0(Data,vrr_stack+38044, vrr_stack+18522, vrr_stack+66092, vrr_stack+61751, vrr_stack+18288, vrr_stack+4222);
 _BUILD_g0o0(Data,vrr_stack+38824, vrr_stack+15282, vrr_stack+38044, vrr_stack+14034, vrr_stack+18522, vrr_stack+10404);
 _BUILD_h0o0(Data,vrr_stack+7597, vrr_stack+92774, vrr_stack+38824, vrr_stack+14502, vrr_stack+15282, vrr_stack+21930);
 _BUILD_i0o0(Data,vrr_stack+105566, vrr_stack+93944, vrr_stack+7597, vrr_stack+30180, vrr_stack+92774, vrr_stack+41362);
 _BUILD_k0o0(Data,vrr_stack+107750, vrr_stack+95582, vrr_stack+105566, vrr_stack+32520, vrr_stack+93944, vrr_stack+77000);
 _BUILD_l0o0(Data,vrr_stack+110558, vrr_stack+99950, vrr_stack+107750, vrr_stack+97766, vrr_stack+95582, vrr_stack+42748);
 _BUILD_l0o0(Data,vrr_stack+41362, vrr_stack+102758, vrr_stack+99950, vrr_stack+34158, vrr_stack+97766, vrr_stack+69014);
 _BUILD_m0o0(Data,vrr_stack+114068, vrr_stack+41362, vrr_stack+110558, vrr_stack+102758, vrr_stack+99950, vrr_stack+78848);
 _BUILD_00o0(Data,vrr_stack+77000, vrr_stack+4663, vrr_stack+3892, vrr_stack+4734, vrr_stack+1619, NULL);
 _BUILD_p0o0(Data,vrr_stack+77078, vrr_stack+77000, vrr_stack+67166, NULL, NULL, vrr_stack+3892);
 _BUILD_d0o0(Data,vrr_stack+77312, vrr_stack+77078, vrr_stack+67244, vrr_stack+77000, vrr_stack+67166, vrr_stack+20676);
 _BUILD_f0o0(Data,vrr_stack+77780, vrr_stack+77312, vrr_stack+67478, vrr_stack+77078, vrr_stack+67244, vrr_stack+20874);
 _BUILD_g0o0(Data,vrr_stack+78560, vrr_stack+77780, vrr_stack+67946, vrr_stack+77312, vrr_stack+67478, vrr_stack+21270);
 _BUILD_h0o0(Data,vrr_stack+79730, vrr_stack+78560, vrr_stack+36874, vrr_stack+77780, vrr_stack+67946, vrr_stack+40372);
 _BUILD_i0o0(Data,vrr_stack+68726, vrr_stack+79730, vrr_stack+18990, vrr_stack+78560, vrr_stack+36874, vrr_stack+71390);
 _BUILD_k0o0(Data,vrr_stack+118358, vrr_stack+68726, vrr_stack+34158, vrr_stack+79730, vrr_stack+18990, vrr_stack+72776);
 _BUILD_l0o0(Data,vrr_stack+77078, vrr_stack+118358, vrr_stack+102758, vrr_stack+68726, vrr_stack+34158, vrr_stack+74624);
 _BUILD_m0o0(Data,vrr_stack+68726, vrr_stack+77078, vrr_stack+41362, vrr_stack+118358, vrr_stack+102758, vrr_stack+45124);
 _BUILD_00p0(Data,vrr_stack+118358, Data->F+21, Data->F+22, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+88412, vrr_stack+0, vrr_stack+118358, Data->F+20, Data->F+21, NULL);
 _BUILD_00f0(Data,vrr_stack+118361, vrr_stack+48094, vrr_stack+88412, vrr_stack+1984, vrr_stack+0, NULL);
 _BUILD_00g0(Data,vrr_stack+118371, vrr_stack+51, vrr_stack+118361, vrr_stack+1987, vrr_stack+48094, NULL);
 _BUILD_00h0(Data,vrr_stack+118386, vrr_stack+48100, vrr_stack+118371, vrr_stack+1993, vrr_stack+51, NULL);
 _BUILD_00i0(Data,vrr_stack+118407, vrr_stack+48115, vrr_stack+118386, vrr_stack+857, vrr_stack+48100, NULL);
 _BUILD_00k0(Data,vrr_stack+118435, vrr_stack+872, vrr_stack+118407, vrr_stack+2003, vrr_stack+48115, NULL);
 _BUILD_00l0(Data,vrr_stack+118471, vrr_stack+48136, vrr_stack+118435, vrr_stack+2024, vrr_stack+872, NULL);
 _BUILD_00m0(Data,vrr_stack+118516, vrr_stack+4618, vrr_stack+118471, vrr_stack+2052, vrr_stack+48136, NULL);
 _BUILD_00n0(Data,vrr_stack+118571, vrr_stack+48172, vrr_stack+118516, vrr_stack+61, vrr_stack+4618, NULL);
 _BUILD_00o0(Data,vrr_stack+118637, vrr_stack+48227, vrr_stack+118571, vrr_stack+106, vrr_stack+48172, NULL);
 _BUILD_p0o0(Data,vrr_stack+61, vrr_stack+65780, vrr_stack+118637, NULL, NULL, vrr_stack+48227);
 _BUILD_d0o0(Data,vrr_stack+295, vrr_stack+65858, vrr_stack+61, vrr_stack+18210, vrr_stack+65780, vrr_stack+48293);
 _BUILD_f0o0(Data,vrr_stack+118715, vrr_stack+66092, vrr_stack+295, vrr_stack+18288, vrr_stack+65858, vrr_stack+48491);
 _BUILD_g0o0(Data,vrr_stack+119495, vrr_stack+38044, vrr_stack+118715, vrr_stack+18522, vrr_stack+66092, vrr_stack+48887);
 _BUILD_h0o0(Data,vrr_stack+73016, vrr_stack+38824, vrr_stack+119495, vrr_stack+15282, vrr_stack+38044, vrr_stack+49547);
 _BUILD_i0o0(Data,vrr_stack+48293, vrr_stack+7597, vrr_stack+73016, vrr_stack+92774, vrr_stack+38824, vrr_stack+50537);
 _BUILD_k0o0(Data,vrr_stack+44872, vrr_stack+105566, vrr_stack+48293, vrr_stack+93944, vrr_stack+7597, vrr_stack+51923);
 _BUILD_l0o0(Data,vrr_stack+120665, vrr_stack+107750, vrr_stack+44872, vrr_stack+95582, vrr_stack+105566, vrr_stack+53771);
 _BUILD_m0o0(Data,vrr_stack+50477, vrr_stack+110558, vrr_stack+120665, vrr_stack+99950, vrr_stack+107750, vrr_stack+11064);
 _BUILD_n0o0(Data,vrr_stack+124175, vrr_stack+114068, vrr_stack+50477, vrr_stack+41362, vrr_stack+110558, vrr_stack+26550);
 _BUILD_n0o0(Data,vrr_stack+129323, vrr_stack+68726, vrr_stack+114068, vrr_stack+77078, vrr_stack+41362, vrr_stack+81818);
   tmp = vrr_stack + 129323;
   target_ptr = Libint->vrr_classes[10][11];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_00q0(Data,vrr_stack+77078, vrr_stack+85448, vrr_stack+86150, vrr_stack+2384, vrr_stack+2978, NULL);
 _BUILD_00q0(Data,vrr_stack+77169, vrr_stack+85526, vrr_stack+85448, vrr_stack+2450, vrr_stack+2384, NULL);
 _BUILD_p0q0(Data,vrr_stack+77260, vrr_stack+77169, vrr_stack+77078, NULL, NULL, vrr_stack+85448);
 _BUILD_00q0(Data,vrr_stack+77533, vrr_stack+85838, vrr_stack+85526, vrr_stack+2714, vrr_stack+2450, NULL);
 _BUILD_p0q0(Data,vrr_stack+77624, vrr_stack+77533, vrr_stack+77169, NULL, NULL, vrr_stack+85526);
 _BUILD_00q0(Data,vrr_stack+77897, vrr_stack+86150, vrr_stack+2780, vrr_stack+2978, vrr_stack+1045, NULL);
 _BUILD_p0q0(Data,vrr_stack+77988, vrr_stack+77078, vrr_stack+77897, NULL, NULL, vrr_stack+86150);
 _BUILD_d0q0(Data,vrr_stack+78261, vrr_stack+77260, vrr_stack+77988, vrr_stack+77169, vrr_stack+77078, vrr_stack+86228);
 _BUILD_d0q0(Data,vrr_stack+78807, vrr_stack+77624, vrr_stack+77260, vrr_stack+77533, vrr_stack+77169, vrr_stack+85604);
 _BUILD_f0q0(Data,vrr_stack+79353, vrr_stack+78807, vrr_stack+78261, vrr_stack+77624, vrr_stack+77260, vrr_stack+86462);
 _BUILD_00q0(Data,vrr_stack+85604, vrr_stack+2516, vrr_stack+85838, vrr_stack+900, vrr_stack+2714, NULL);
 _BUILD_p0q0(Data,vrr_stack+86228, vrr_stack+85604, vrr_stack+77533, NULL, NULL, vrr_stack+85838);
 _BUILD_d0q0(Data,vrr_stack+80263, vrr_stack+86228, vrr_stack+77624, vrr_stack+85604, vrr_stack+77533, vrr_stack+85916);
 _BUILD_f0q0(Data,vrr_stack+80809, vrr_stack+80263, vrr_stack+78807, vrr_stack+86228, vrr_stack+77624, vrr_stack+86930);
 _BUILD_00q0(Data,vrr_stack+85916, vrr_stack+2780, vrr_stack+18210, vrr_stack+1045, vrr_stack+3628, NULL);
 _BUILD_p0q0(Data,vrr_stack+86501, vrr_stack+77897, vrr_stack+85916, NULL, NULL, vrr_stack+2780);
 _BUILD_d0q0(Data,vrr_stack+86774, vrr_stack+77988, vrr_stack+86501, vrr_stack+77078, vrr_stack+77897, vrr_stack+61751);
 _BUILD_f0q0(Data,vrr_stack+26550, vrr_stack+78261, vrr_stack+86774, vrr_stack+77260, vrr_stack+77988, vrr_stack+14034);
 _BUILD_g0q0(Data,vrr_stack+27460, vrr_stack+79353, vrr_stack+26550, vrr_stack+78807, vrr_stack+78261, vrr_stack+14502);
 _BUILD_g0q0(Data,vrr_stack+54767, vrr_stack+80809, vrr_stack+79353, vrr_stack+80263, vrr_stack+78807, vrr_stack+87398);
 _BUILD_h0q0(Data,vrr_stack+74654, vrr_stack+54767, vrr_stack+27460, vrr_stack+80809, vrr_stack+79353, vrr_stack+30180);
 _BUILD_00q0(Data,vrr_stack+61751, vrr_stack+16650, vrr_stack+2516, vrr_stack+1111, vrr_stack+900, NULL);
 _BUILD_p0q0(Data,vrr_stack+61842, vrr_stack+61751, vrr_stack+85604, NULL, NULL, vrr_stack+2516);
 _BUILD_d0q0(Data,vrr_stack+87320, vrr_stack+61842, vrr_stack+86228, vrr_stack+61751, vrr_stack+85604, vrr_stack+88178);
 _BUILD_f0q0(Data,vrr_stack+28825, vrr_stack+87320, vrr_stack+80263, vrr_stack+61842, vrr_stack+86228, vrr_stack+60503);
 _BUILD_g0q0(Data,vrr_stack+29735, vrr_stack+28825, vrr_stack+80809, vrr_stack+87320, vrr_stack+80263, vrr_stack+60971);
 _BUILD_h0q0(Data,vrr_stack+20628, vrr_stack+29735, vrr_stack+54767, vrr_stack+28825, vrr_stack+80809, vrr_stack+31350);
 _BUILD_00q0(Data,vrr_stack+60503, vrr_stack+18210, vrr_stack+65780, vrr_stack+3628, vrr_stack+3958, NULL);
 _BUILD_p0q0(Data,vrr_stack+60594, vrr_stack+85916, vrr_stack+60503, NULL, NULL, vrr_stack+18210);
 _BUILD_d0q0(Data,vrr_stack+87866, vrr_stack+86501, vrr_stack+60594, vrr_stack+77897, vrr_stack+85916, vrr_stack+18288);
 _BUILD_f0q0(Data,vrr_stack+31100, vrr_stack+86774, vrr_stack+87866, vrr_stack+77988, vrr_stack+86501, vrr_stack+18522);
 _BUILD_g0q0(Data,vrr_stack+39994, vrr_stack+26550, vrr_stack+31100, vrr_stack+78261, vrr_stack+86774, vrr_stack+15282);
 _BUILD_h0q0(Data,vrr_stack+9235, vrr_stack+27460, vrr_stack+39994, vrr_stack+79353, vrr_stack+26550, vrr_stack+92774);
 _BUILD_i0q0(Data,vrr_stack+11146, vrr_stack+74654, vrr_stack+9235, vrr_stack+54767, vrr_stack+27460, vrr_stack+93944);
 _BUILD_i0q0(Data,vrr_stack+92774, vrr_stack+20628, vrr_stack+74654, vrr_stack+29735, vrr_stack+54767, vrr_stack+32520);
 _BUILD_k0q0(Data,vrr_stack+134471, vrr_stack+92774, vrr_stack+11146, vrr_stack+20628, vrr_stack+74654, vrr_stack+95582);
 _BUILD_00q0(Data,vrr_stack+95322, vrr_stack+67166, vrr_stack+16650, vrr_stack+3892, vrr_stack+1111, NULL);
 _BUILD_p0q0(Data,vrr_stack+95413, vrr_stack+95322, vrr_stack+61751, NULL, NULL, vrr_stack+16650);
 _BUILD_d0q0(Data,vrr_stack+95686, vrr_stack+95413, vrr_stack+61842, vrr_stack+95322, vrr_stack+61751, vrr_stack+16728);
 _BUILD_f0q0(Data,vrr_stack+96232, vrr_stack+95686, vrr_stack+87320, vrr_stack+95413, vrr_stack+61842, vrr_stack+16962);
 _BUILD_g0q0(Data,vrr_stack+900, vrr_stack+96232, vrr_stack+28825, vrr_stack+95686, vrr_stack+87320, vrr_stack+17430);
 _BUILD_h0q0(Data,vrr_stack+32010, vrr_stack+900, vrr_stack+29735, vrr_stack+96232, vrr_stack+28825, vrr_stack+4789);
 _BUILD_i0q0(Data,vrr_stack+13694, vrr_stack+32010, vrr_stack+20628, vrr_stack+900, vrr_stack+29735, vrr_stack+5959);
 _BUILD_k0q0(Data,vrr_stack+137747, vrr_stack+13694, vrr_stack+92774, vrr_stack+32010, vrr_stack+20628, vrr_stack+97766);
 _BUILD_00q0(Data,vrr_stack+16728, vrr_stack+65780, vrr_stack+118637, vrr_stack+3958, vrr_stack+48227, NULL);
 _BUILD_p0q0(Data,vrr_stack+3958, vrr_stack+60503, vrr_stack+16728, NULL, NULL, vrr_stack+65780);
 _BUILD_d0q0(Data,vrr_stack+16819, vrr_stack+60594, vrr_stack+3958, vrr_stack+85916, vrr_stack+60503, vrr_stack+65858);
 _BUILD_f0q0(Data,vrr_stack+97142, vrr_stack+87866, vrr_stack+16819, vrr_stack+86501, vrr_stack+60594, vrr_stack+66092);
 _BUILD_g0q0(Data,vrr_stack+98052, vrr_stack+31100, vrr_stack+97142, vrr_stack+86774, vrr_stack+87866, vrr_stack+38044);
 _BUILD_h0q0(Data,vrr_stack+4729, vrr_stack+39994, vrr_stack+98052, vrr_stack+26550, vrr_stack+31100, vrr_stack+38824);
 _BUILD_i0q0(Data,vrr_stack+141023, vrr_stack+9235, vrr_stack+4729, vrr_stack+27460, vrr_stack+39994, vrr_stack+7597);
 _BUILD_k0q0(Data,vrr_stack+143571, vrr_stack+11146, vrr_stack+141023, vrr_stack+74654, vrr_stack+9235, vrr_stack+105566);
 _BUILD_l0q0(Data,vrr_stack+146847, vrr_stack+134471, vrr_stack+143571, vrr_stack+92774, vrr_stack+11146, vrr_stack+107750);
 _BUILD_l0q0(Data,vrr_stack+105566, vrr_stack+137747, vrr_stack+134471, vrr_stack+13694, vrr_stack+92774, vrr_stack+99950);
 _BUILD_m0q0(Data,vrr_stack+150942, vrr_stack+105566, vrr_stack+146847, vrr_stack+137747, vrr_stack+134471, vrr_stack+110558);
 _BUILD_00q0(Data,vrr_stack+109661, vrr_stack+77000, vrr_stack+67166, vrr_stack+4663, vrr_stack+3892, NULL);
 _BUILD_p0q0(Data,vrr_stack+109752, vrr_stack+109661, vrr_stack+95322, NULL, NULL, vrr_stack+67166);
 _BUILD_d0q0(Data,vrr_stack+110025, vrr_stack+109752, vrr_stack+95413, vrr_stack+109661, vrr_stack+95322, vrr_stack+67244);
 _BUILD_f0q0(Data,vrr_stack+110571, vrr_stack+110025, vrr_stack+95686, vrr_stack+109752, vrr_stack+95413, vrr_stack+67478);
 _BUILD_g0q0(Data,vrr_stack+111481, vrr_stack+110571, vrr_stack+96232, vrr_stack+110025, vrr_stack+95686, vrr_stack+67946);
 _BUILD_h0q0(Data,vrr_stack+38044, vrr_stack+111481, vrr_stack+900, vrr_stack+110571, vrr_stack+96232, vrr_stack+36874);
 _BUILD_i0q0(Data,vrr_stack+99417, vrr_stack+38044, vrr_stack+32010, vrr_stack+111481, vrr_stack+900, vrr_stack+18990);
 _BUILD_k0q0(Data,vrr_stack+109752, vrr_stack+99417, vrr_stack+13694, vrr_stack+38044, vrr_stack+32010, vrr_stack+34158);
 _BUILD_l0q0(Data,vrr_stack+33921, vrr_stack+109752, vrr_stack+137747, vrr_stack+99417, vrr_stack+13694, vrr_stack+102758);
 _BUILD_m0q0(Data,vrr_stack+99417, vrr_stack+33921, vrr_stack+105566, vrr_stack+109752, vrr_stack+137747, vrr_stack+41362);
 _BUILD_00p0(Data,vrr_stack+109752, Data->F+22, Data->F+23, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+109755, vrr_stack+118358, vrr_stack+109752, Data->F+21, Data->F+22, NULL);
 _BUILD_00f0(Data,vrr_stack+109761, vrr_stack+88412, vrr_stack+109755, vrr_stack+0, vrr_stack+118358, NULL);
 _BUILD_00g0(Data,vrr_stack+56132, vrr_stack+118361, vrr_stack+109761, vrr_stack+48094, vrr_stack+88412, NULL);
 _BUILD_00h0(Data,vrr_stack+0, vrr_stack+118371, vrr_stack+56132, vrr_stack+51, vrr_stack+118361, NULL);
 _BUILD_00i0(Data,vrr_stack+21, vrr_stack+118386, vrr_stack+0, vrr_stack+48100, vrr_stack+118371, NULL);
 _BUILD_00k0(Data,vrr_stack+109771, vrr_stack+118407, vrr_stack+21, vrr_stack+48115, vrr_stack+118386, NULL);
 _BUILD_00l0(Data,vrr_stack+109807, vrr_stack+118435, vrr_stack+109771, vrr_stack+872, vrr_stack+118407, NULL);
 _BUILD_00m0(Data,vrr_stack+109852, vrr_stack+118471, vrr_stack+109807, vrr_stack+48136, vrr_stack+118435, NULL);
 _BUILD_00n0(Data,vrr_stack+4663, vrr_stack+118516, vrr_stack+109852, vrr_stack+4618, vrr_stack+118471, NULL);
 _BUILD_00o0(Data,vrr_stack+109907, vrr_stack+118571, vrr_stack+4663, vrr_stack+48172, vrr_stack+118516, NULL);
 _BUILD_00q0(Data,vrr_stack+109985, vrr_stack+118637, vrr_stack+109907, vrr_stack+48227, vrr_stack+118571, NULL);
 _BUILD_p0q0(Data,vrr_stack+110076, vrr_stack+16728, vrr_stack+109985, NULL, NULL, vrr_stack+118637);
 _BUILD_d0q0(Data,vrr_stack+110349, vrr_stack+3958, vrr_stack+110076, vrr_stack+60503, vrr_stack+16728, vrr_stack+61);
 _BUILD_f0q0(Data,vrr_stack+110895, vrr_stack+16819, vrr_stack+110349, vrr_stack+60594, vrr_stack+3958, vrr_stack+295);
 _BUILD_g0q0(Data,vrr_stack+111805, vrr_stack+97142, vrr_stack+110895, vrr_stack+87866, vrr_stack+16819, vrr_stack+118715);
 _BUILD_h0q0(Data,vrr_stack+18288, vrr_stack+98052, vrr_stack+111805, vrr_stack+31100, vrr_stack+97142, vrr_stack+119495);
 _BUILD_i0q0(Data,vrr_stack+41359, vrr_stack+4729, vrr_stack+18288, vrr_stack+39994, vrr_stack+98052, vrr_stack+73016);
 _BUILD_k0q0(Data,vrr_stack+155947, vrr_stack+141023, vrr_stack+41359, vrr_stack+9235, vrr_stack+4729, vrr_stack+48293);
 _BUILD_l0q0(Data,vrr_stack+159223, vrr_stack+143571, vrr_stack+155947, vrr_stack+11146, vrr_stack+141023, vrr_stack+44872);
 _BUILD_m0q0(Data,vrr_stack+43907, vrr_stack+146847, vrr_stack+159223, vrr_stack+134471, vrr_stack+143571, vrr_stack+120665);
 _BUILD_n0q0(Data,vrr_stack+163318, vrr_stack+150942, vrr_stack+43907, vrr_stack+105566, vrr_stack+146847, vrr_stack+50477);
 _BUILD_n0q0(Data,vrr_stack+169324, vrr_stack+99417, vrr_stack+150942, vrr_stack+33921, vrr_stack+105566, vrr_stack+114068);
   tmp = vrr_stack + 169324;
   target_ptr = Libint->vrr_classes[10][12];
   for(i=0;i<6006;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+33921, vrr_stack+77078, vrr_stack+77897, vrr_stack+85448, vrr_stack+86150, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+34026, vrr_stack+77169, vrr_stack+77078, vrr_stack+85526, vrr_stack+85448, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+34131, vrr_stack+34026, vrr_stack+33921, NULL, NULL, vrr_stack+77078);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+34446, vrr_stack+77533, vrr_stack+77169, vrr_stack+85838, vrr_stack+85526, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+34551, vrr_stack+34446, vrr_stack+34026, NULL, NULL, vrr_stack+77169);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+85448, vrr_stack+77897, vrr_stack+85916, vrr_stack+86150, vrr_stack+2780, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+34866, vrr_stack+33921, vrr_stack+85448, NULL, NULL, vrr_stack+77897);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+35181, vrr_stack+34131, vrr_stack+34866, vrr_stack+34026, vrr_stack+33921, vrr_stack+77988);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+35811, vrr_stack+34551, vrr_stack+34131, vrr_stack+34446, vrr_stack+34026, vrr_stack+77260);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+36441, vrr_stack+35811, vrr_stack+35181, vrr_stack+34551, vrr_stack+34131, vrr_stack+78261);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+77260, vrr_stack+85604, vrr_stack+77533, vrr_stack+2516, vrr_stack+85838, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+77988, vrr_stack+77260, vrr_stack+34446, NULL, NULL, vrr_stack+77533);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+37491, vrr_stack+77988, vrr_stack+34551, vrr_stack+77260, vrr_stack+34446, vrr_stack+77624);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+38121, vrr_stack+37491, vrr_stack+35811, vrr_stack+77988, vrr_stack+34551, vrr_stack+78807);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+77624, vrr_stack+85916, vrr_stack+60503, vrr_stack+2780, vrr_stack+18210, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78303, vrr_stack+85448, vrr_stack+77624, NULL, NULL, vrr_stack+85916);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+78618, vrr_stack+34866, vrr_stack+78303, vrr_stack+33921, vrr_stack+85448, vrr_stack+86501);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+35181, vrr_stack+78618, vrr_stack+34131, vrr_stack+34866, vrr_stack+86774);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+118715, vrr_stack+36441, vrr_stack+73016, vrr_stack+35811, vrr_stack+35181, vrr_stack+26550);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+120290, vrr_stack+38121, vrr_stack+36441, vrr_stack+37491, vrr_stack+35811, vrr_stack+79353);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+121865, vrr_stack+120290, vrr_stack+118715, vrr_stack+38121, vrr_stack+36441, vrr_stack+27460);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+124070, vrr_stack+61751, vrr_stack+85604, vrr_stack+16650, vrr_stack+2516, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26550, vrr_stack+124070, vrr_stack+77260, NULL, NULL, vrr_stack+85604);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+26865, vrr_stack+26550, vrr_stack+77988, vrr_stack+124070, vrr_stack+77260, vrr_stack+86228);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+27495, vrr_stack+26865, vrr_stack+37491, vrr_stack+26550, vrr_stack+77988, vrr_stack+80263);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+2265, vrr_stack+27495, vrr_stack+38121, vrr_stack+26865, vrr_stack+37491, vrr_stack+80809);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+79248, vrr_stack+2265, vrr_stack+120290, vrr_stack+27495, vrr_stack+38121, vrr_stack+54767);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+28545, vrr_stack+60503, vrr_stack+16728, vrr_stack+18210, vrr_stack+65780, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+81453, vrr_stack+77624, vrr_stack+28545, NULL, NULL, vrr_stack+60503);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+39171, vrr_stack+78303, vrr_stack+81453, vrr_stack+85448, vrr_stack+77624, vrr_stack+60594);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+60594, vrr_stack+78618, vrr_stack+39171, vrr_stack+34866, vrr_stack+78303, vrr_stack+87866);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+48912, vrr_stack+73016, vrr_stack+60594, vrr_stack+35181, vrr_stack+78618, vrr_stack+31100);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+50487, vrr_stack+118715, vrr_stack+48912, vrr_stack+36441, vrr_stack+73016, vrr_stack+39994);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+52692, vrr_stack+121865, vrr_stack+50487, vrr_stack+120290, vrr_stack+118715, vrr_stack+9235);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+6640, vrr_stack+79248, vrr_stack+121865, vrr_stack+2265, vrr_stack+120290, vrr_stack+74654);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+175330, vrr_stack+6640, vrr_stack+52692, vrr_stack+79248, vrr_stack+121865, vrr_stack+11146);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+31100, vrr_stack+95322, vrr_stack+61751, vrr_stack+67166, vrr_stack+16650, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+31205, vrr_stack+31100, vrr_stack+124070, NULL, NULL, vrr_stack+61751);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+39801, vrr_stack+31205, vrr_stack+26550, vrr_stack+31100, vrr_stack+124070, vrr_stack+61842);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+74066, vrr_stack+39801, vrr_stack+26865, vrr_stack+31205, vrr_stack+26550, vrr_stack+87320);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+75116, vrr_stack+74066, vrr_stack+27495, vrr_stack+39801, vrr_stack+26865, vrr_stack+28825);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+86007, vrr_stack+75116, vrr_stack+2265, vrr_stack+74066, vrr_stack+27495, vrr_stack+29735);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+9580, vrr_stack+86007, vrr_stack+79248, vrr_stack+75116, vrr_stack+2265, vrr_stack+20628);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+179110, vrr_stack+9580, vrr_stack+6640, vrr_stack+86007, vrr_stack+79248, vrr_stack+92774);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+92774, vrr_stack+16728, vrr_stack+109985, vrr_stack+65780, vrr_stack+118637, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+65780, vrr_stack+28545, vrr_stack+92774, NULL, NULL, vrr_stack+16728);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+66095, vrr_stack+81453, vrr_stack+65780, vrr_stack+77624, vrr_stack+28545, vrr_stack+3958);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+92879, vrr_stack+39171, vrr_stack+66095, vrr_stack+78303, vrr_stack+81453, vrr_stack+16819);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+28650, vrr_stack+60594, vrr_stack+92879, vrr_stack+78618, vrr_stack+39171, vrr_stack+97142);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+20199, vrr_stack+48912, vrr_stack+28650, vrr_stack+73016, vrr_stack+60594, vrr_stack+98052);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+182890, vrr_stack+50487, vrr_stack+20199, vrr_stack+118715, vrr_stack+48912, vrr_stack+4729);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+185830, vrr_stack+52692, vrr_stack+182890, vrr_stack+121865, vrr_stack+50487, vrr_stack+141023);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+189610, vrr_stack+175330, vrr_stack+185830, vrr_stack+6640, vrr_stack+52692, vrr_stack+143571);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+141023, vrr_stack+179110, vrr_stack+175330, vrr_stack+9580, vrr_stack+6640, vrr_stack+134471);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+194335, vrr_stack+141023, vrr_stack+189610, vrr_stack+179110, vrr_stack+175330, vrr_stack+146847);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134471, vrr_stack+109661, vrr_stack+95322, vrr_stack+77000, vrr_stack+67166, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134576, vrr_stack+134471, vrr_stack+31100, NULL, NULL, vrr_stack+95322);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134891, vrr_stack+134576, vrr_stack+31205, vrr_stack+134471, vrr_stack+31100, vrr_stack+95413);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+135521, vrr_stack+134891, vrr_stack+39801, vrr_stack+134576, vrr_stack+31205, vrr_stack+95686);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+145748, vrr_stack+135521, vrr_stack+74066, vrr_stack+134891, vrr_stack+39801, vrr_stack+96232);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+95413, vrr_stack+145748, vrr_stack+75116, vrr_stack+135521, vrr_stack+74066, vrr_stack+900);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134576, vrr_stack+95413, vrr_stack+86007, vrr_stack+145748, vrr_stack+75116, vrr_stack+32010);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+145748, vrr_stack+134576, vrr_stack+9580, vrr_stack+95413, vrr_stack+86007, vrr_stack+13694);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+200110, vrr_stack+145748, vrr_stack+179110, vrr_stack+134576, vrr_stack+9580, vrr_stack+137747);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134576, vrr_stack+200110, vrr_stack+141023, vrr_stack+145748, vrr_stack+179110, vrr_stack+105566);
 _BUILD_00p0(Data,vrr_stack+145748, Data->F+23, Data->F+24, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+145751, vrr_stack+109752, vrr_stack+145748, Data->F+22, Data->F+23, NULL);
 _BUILD_00f0(Data,vrr_stack+145757, vrr_stack+109755, vrr_stack+145751, vrr_stack+118358, vrr_stack+109752, NULL);
 _BUILD_00g0(Data,vrr_stack+145767, vrr_stack+109761, vrr_stack+145757, vrr_stack+88412, vrr_stack+109755, NULL);
 _BUILD_00h0(Data,vrr_stack+145782, vrr_stack+56132, vrr_stack+145767, vrr_stack+118361, vrr_stack+109761, NULL);
 _BUILD_00i0(Data,vrr_stack+145803, vrr_stack+0, vrr_stack+145782, vrr_stack+118371, vrr_stack+56132, NULL);
 _BUILD_00k0(Data,vrr_stack+145831, vrr_stack+21, vrr_stack+145803, vrr_stack+118386, vrr_stack+0, NULL);
 _BUILD_00l0(Data,vrr_stack+118358, vrr_stack+109771, vrr_stack+145831, vrr_stack+118407, vrr_stack+21, NULL);
 _BUILD_00m0(Data,vrr_stack+145867, vrr_stack+109807, vrr_stack+118358, vrr_stack+118435, vrr_stack+109771, NULL);
 _BUILD_00n0(Data,vrr_stack+118403, vrr_stack+109852, vrr_stack+145867, vrr_stack+118471, vrr_stack+109807, NULL);
 _BUILD_00o0(Data,vrr_stack+145922, vrr_stack+4663, vrr_stack+118403, vrr_stack+118516, vrr_stack+109852, NULL);
 _BUILD_00q0(Data,vrr_stack+118469, vrr_stack+109907, vrr_stack+145922, vrr_stack+118571, vrr_stack+4663, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+146000, vrr_stack+109985, vrr_stack+118469, vrr_stack+118637, vrr_stack+109907, NULL);
 am[0] = 1;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+146105, vrr_stack+92774, vrr_stack+146000, NULL, NULL, vrr_stack+109985);
 am[0] = 2;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+146420, vrr_stack+65780, vrr_stack+146105, vrr_stack+28545, vrr_stack+92774, vrr_stack+110076);
 am[0] = 3;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+147050, vrr_stack+66095, vrr_stack+146420, vrr_stack+81453, vrr_stack+65780, vrr_stack+110349);
 am[0] = 4;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+148100, vrr_stack+92879, vrr_stack+147050, vrr_stack+39171, vrr_stack+66095, vrr_stack+110895);
 am[0] = 5;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+95413, vrr_stack+28650, vrr_stack+148100, vrr_stack+60594, vrr_stack+92879, vrr_stack+111805);
 am[0] = 6;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+110076, vrr_stack+20199, vrr_stack+95413, vrr_stack+48912, vrr_stack+28650, vrr_stack+18288);
 am[0] = 7;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+104422, vrr_stack+182890, vrr_stack+110076, vrr_stack+50487, vrr_stack+20199, vrr_stack+41359);
 am[0] = 8;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+204835, vrr_stack+185830, vrr_stack+104422, vrr_stack+52692, vrr_stack+182890, vrr_stack+155947);
 am[0] = 9;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+209560, vrr_stack+189610, vrr_stack+204835, vrr_stack+175330, vrr_stack+185830, vrr_stack+159223);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+155947, vrr_stack+194335, vrr_stack+209560, vrr_stack+141023, vrr_stack+189610, vrr_stack+43907);
 am[0] = 10;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+40431, vrr_stack+134576, vrr_stack+194335, vrr_stack+200110, vrr_stack+141023, vrr_stack+150942);
   tmp = vrr_stack + 40431;
   target_ptr = Libint->vrr_classes[10][13];
   for(i=0;i<6930;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+200110, vrr_stack+33921, vrr_stack+85448, vrr_stack+77078, vrr_stack+77897, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+200230, vrr_stack+34026, vrr_stack+33921, vrr_stack+77169, vrr_stack+77078, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+200350, vrr_stack+200230, vrr_stack+200110, NULL, NULL, vrr_stack+33921);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+200710, vrr_stack+34446, vrr_stack+34026, vrr_stack+77533, vrr_stack+77169, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+200830, vrr_stack+200710, vrr_stack+200230, NULL, NULL, vrr_stack+34026);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+201190, vrr_stack+85448, vrr_stack+77624, vrr_stack+77897, vrr_stack+85916, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+201310, vrr_stack+200110, vrr_stack+201190, NULL, NULL, vrr_stack+85448);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+201670, vrr_stack+200350, vrr_stack+201310, vrr_stack+200230, vrr_stack+200110, vrr_stack+34866);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+202390, vrr_stack+200830, vrr_stack+200350, vrr_stack+200710, vrr_stack+200230, vrr_stack+34131);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+203110, vrr_stack+202390, vrr_stack+201670, vrr_stack+200830, vrr_stack+200350, vrr_stack+35181);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+34131, vrr_stack+77260, vrr_stack+34446, vrr_stack+85604, vrr_stack+77533, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+34866, vrr_stack+34131, vrr_stack+200710, NULL, NULL, vrr_stack+34446);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+113016, vrr_stack+34866, vrr_stack+200830, vrr_stack+34131, vrr_stack+200710, vrr_stack+34551);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+149675, vrr_stack+113016, vrr_stack+202390, vrr_stack+34866, vrr_stack+200830, vrr_stack+35811);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+34551, vrr_stack+77624, vrr_stack+28545, vrr_stack+85916, vrr_stack+60503, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+35226, vrr_stack+201190, vrr_stack+34551, NULL, NULL, vrr_stack+77624);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+35586, vrr_stack+201310, vrr_stack+35226, vrr_stack+200110, vrr_stack+201190, vrr_stack+78303);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+97618, vrr_stack+201670, vrr_stack+35586, vrr_stack+200350, vrr_stack+201310, vrr_stack+78618);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+4729, vrr_stack+203110, vrr_stack+97618, vrr_stack+202390, vrr_stack+201670, vrr_stack+73016);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+16819, vrr_stack+149675, vrr_stack+203110, vrr_stack+113016, vrr_stack+202390, vrr_stack+36441);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+12520, vrr_stack+16819, vrr_stack+4729, vrr_stack+149675, vrr_stack+203110, vrr_stack+118715);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+124070, vrr_stack+77260, vrr_stack+61751, vrr_stack+85604, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+73136, vrr_stack+73016, vrr_stack+34131, NULL, NULL, vrr_stack+77260);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+78303, vrr_stack+73136, vrr_stack+34866, vrr_stack+73016, vrr_stack+34131, vrr_stack+77988);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+118560, vrr_stack+78303, vrr_stack+113016, vrr_stack+73136, vrr_stack+34866, vrr_stack+37491);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+36306, vrr_stack+118560, vrr_stack+149675, vrr_stack+78303, vrr_stack+113016, vrr_stack+38121);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+215335, vrr_stack+36306, vrr_stack+16819, vrr_stack+118560, vrr_stack+149675, vrr_stack+120290);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+73496, vrr_stack+28545, vrr_stack+92774, vrr_stack+60503, vrr_stack+16728, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+73616, vrr_stack+34551, vrr_stack+73496, NULL, NULL, vrr_stack+28545);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+38106, vrr_stack+35226, vrr_stack+73616, vrr_stack+201190, vrr_stack+34551, vrr_stack+81453);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+119760, vrr_stack+35586, vrr_stack+38106, vrr_stack+201310, vrr_stack+35226, vrr_stack+39171);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+66725, vrr_stack+97618, vrr_stack+119760, vrr_stack+201670, vrr_stack+35586, vrr_stack+60594);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+217855, vrr_stack+4729, vrr_stack+66725, vrr_stack+203110, vrr_stack+97618, vrr_stack+48912);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+220375, vrr_stack+12520, vrr_stack+217855, vrr_stack+16819, vrr_stack+4729, vrr_stack+50487);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+47361, vrr_stack+215335, vrr_stack+12520, vrr_stack+36306, vrr_stack+16819, vrr_stack+121865);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+223735, vrr_stack+47361, vrr_stack+220375, vrr_stack+215335, vrr_stack+12520, vrr_stack+52692);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+81453, vrr_stack+31100, vrr_stack+124070, vrr_stack+95322, vrr_stack+61751, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+60503, vrr_stack+81453, vrr_stack+73016, NULL, NULL, vrr_stack+124070);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+60863, vrr_stack+60503, vrr_stack+73136, vrr_stack+81453, vrr_stack+73016, vrr_stack+26550);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+120960, vrr_stack+60863, vrr_stack+78303, vrr_stack+60503, vrr_stack+73136, vrr_stack+26865);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+122160, vrr_stack+120960, vrr_stack+118560, vrr_stack+60863, vrr_stack+78303, vrr_stack+27495);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+50721, vrr_stack+122160, vrr_stack+36306, vrr_stack+120960, vrr_stack+118560, vrr_stack+2265);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+49, vrr_stack+50721, vrr_stack+215335, vrr_stack+122160, vrr_stack+36306, vrr_stack+79248);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+228055, vrr_stack+49, vrr_stack+47361, vrr_stack+50721, vrr_stack+215335, vrr_stack+6640);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+26550, vrr_stack+92774, vrr_stack+146000, vrr_stack+16728, vrr_stack+109985, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+26670, vrr_stack+73496, vrr_stack+26550, NULL, NULL, vrr_stack+92774);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+27030, vrr_stack+73616, vrr_stack+26670, vrr_stack+34551, vrr_stack+73496, vrr_stack+65780);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+79023, vrr_stack+38106, vrr_stack+27030, vrr_stack+35226, vrr_stack+73616, vrr_stack+66095);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+6529, vrr_stack+119760, vrr_stack+79023, vrr_stack+35586, vrr_stack+38106, vrr_stack+92879);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+53241, vrr_stack+66725, vrr_stack+6529, vrr_stack+97618, vrr_stack+119760, vrr_stack+28650);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+232375, vrr_stack+217855, vrr_stack+53241, vrr_stack+4729, vrr_stack+66725, vrr_stack+20199);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+235735, vrr_stack+220375, vrr_stack+232375, vrr_stack+12520, vrr_stack+217855, vrr_stack+182890);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+240055, vrr_stack+223735, vrr_stack+235735, vrr_stack+47361, vrr_stack+220375, vrr_stack+185830);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+182890, vrr_stack+228055, vrr_stack+223735, vrr_stack+49, vrr_stack+47361, vrr_stack+175330);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+245455, vrr_stack+182890, vrr_stack+240055, vrr_stack+228055, vrr_stack+223735, vrr_stack+189610);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175330, vrr_stack+134471, vrr_stack+31100, vrr_stack+109661, vrr_stack+95322, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175450, vrr_stack+175330, vrr_stack+81453, NULL, NULL, vrr_stack+31100);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175810, vrr_stack+175450, vrr_stack+60503, vrr_stack+175330, vrr_stack+81453, vrr_stack+31205);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+31205, vrr_stack+175810, vrr_stack+60863, vrr_stack+175450, vrr_stack+60503, vrr_stack+39801);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+176530, vrr_stack+31205, vrr_stack+120960, vrr_stack+175810, vrr_stack+60863, vrr_stack+74066);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+188290, vrr_stack+176530, vrr_stack+122160, vrr_stack+31205, vrr_stack+120960, vrr_stack+75116);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+190810, vrr_stack+188290, vrr_stack+50721, vrr_stack+176530, vrr_stack+122160, vrr_stack+86007);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+252055, vrr_stack+190810, vrr_stack+49, vrr_stack+188290, vrr_stack+50721, vrr_stack+9580);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+256375, vrr_stack+252055, vrr_stack+228055, vrr_stack+190810, vrr_stack+49, vrr_stack+179110);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175450, vrr_stack+256375, vrr_stack+182890, vrr_stack+252055, vrr_stack+228055, vrr_stack+141023);
 _BUILD_00p0(Data,vrr_stack+252055, Data->F+24, Data->F+25, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+252058, vrr_stack+145748, vrr_stack+252055, Data->F+23, Data->F+24, NULL);
 _BUILD_00f0(Data,vrr_stack+252064, vrr_stack+145751, vrr_stack+252058, vrr_stack+109752, vrr_stack+145748, NULL);
 _BUILD_00g0(Data,vrr_stack+252074, vrr_stack+145757, vrr_stack+252064, vrr_stack+109755, vrr_stack+145751, NULL);
 _BUILD_00h0(Data,vrr_stack+252089, vrr_stack+145767, vrr_stack+252074, vrr_stack+109761, vrr_stack+145757, NULL);
 _BUILD_00i0(Data,vrr_stack+252110, vrr_stack+145782, vrr_stack+252089, vrr_stack+56132, vrr_stack+145767, NULL);
 _BUILD_00k0(Data,vrr_stack+252138, vrr_stack+145803, vrr_stack+252110, vrr_stack+0, vrr_stack+145782, NULL);
 _BUILD_00l0(Data,vrr_stack+252174, vrr_stack+145831, vrr_stack+252138, vrr_stack+21, vrr_stack+145803, NULL);
 _BUILD_00m0(Data,vrr_stack+252219, vrr_stack+118358, vrr_stack+252174, vrr_stack+109771, vrr_stack+145831, NULL);
 _BUILD_00n0(Data,vrr_stack+252274, vrr_stack+145867, vrr_stack+252219, vrr_stack+109807, vrr_stack+118358, NULL);
 _BUILD_00o0(Data,vrr_stack+252340, vrr_stack+118403, vrr_stack+252274, vrr_stack+109852, vrr_stack+145867, NULL);
 _BUILD_00q0(Data,vrr_stack+252418, vrr_stack+145922, vrr_stack+252340, vrr_stack+4663, vrr_stack+118403, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+252509, vrr_stack+118469, vrr_stack+252418, vrr_stack+109907, vrr_stack+145922, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+252614, vrr_stack+146000, vrr_stack+252509, vrr_stack+109985, vrr_stack+118469, NULL);
 am[0] = 1;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+252734, vrr_stack+26550, vrr_stack+252614, NULL, NULL, vrr_stack+146000);
 am[0] = 2;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+253094, vrr_stack+26670, vrr_stack+252734, vrr_stack+73496, vrr_stack+26550, vrr_stack+146105);
 am[0] = 3;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+253814, vrr_stack+27030, vrr_stack+253094, vrr_stack+73616, vrr_stack+26670, vrr_stack+146420);
 am[0] = 4;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+188290, vrr_stack+79023, vrr_stack+253814, vrr_stack+38106, vrr_stack+27030, vrr_stack+147050);
 am[0] = 5;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+190090, vrr_stack+6529, vrr_stack+188290, vrr_stack+119760, vrr_stack+79023, vrr_stack+148100);
 am[0] = 6;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+146105, vrr_stack+53241, vrr_stack+190090, vrr_stack+66725, vrr_stack+6529, vrr_stack+95413);
 am[0] = 7;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+92879, vrr_stack+232375, vrr_stack+146105, vrr_stack+217855, vrr_stack+53241, vrr_stack+110076);
 am[0] = 8;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+261775, vrr_stack+235735, vrr_stack+92879, vrr_stack+220375, vrr_stack+232375, vrr_stack+104422);
 am[0] = 9;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+104422, vrr_stack+240055, vrr_stack+261775, vrr_stack+223735, vrr_stack+235735, vrr_stack+204835);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+267175, vrr_stack+245455, vrr_stack+104422, vrr_stack+182890, vrr_stack+240055, vrr_stack+209560);
 am[0] = 10;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+204310, vrr_stack+175450, vrr_stack+245455, vrr_stack+256375, vrr_stack+182890, vrr_stack+194335);
   tmp = vrr_stack + 204310;
   target_ptr = Libint->vrr_classes[10][14];
   for(i=0;i<7920;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+111022, vrr_stack+200110, vrr_stack+201190, vrr_stack+33921, vrr_stack+85448, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+111158, vrr_stack+200230, vrr_stack+200110, vrr_stack+34026, vrr_stack+33921, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+111294, vrr_stack+111158, vrr_stack+111022, NULL, NULL, vrr_stack+200110);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+111702, vrr_stack+200710, vrr_stack+200230, vrr_stack+34446, vrr_stack+34026, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+111838, vrr_stack+111702, vrr_stack+111158, NULL, NULL, vrr_stack+200230);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+112246, vrr_stack+201190, vrr_stack+34551, vrr_stack+85448, vrr_stack+77624, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+85448, vrr_stack+111022, vrr_stack+112246, NULL, NULL, vrr_stack+201190);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+85856, vrr_stack+111294, vrr_stack+85448, vrr_stack+111158, vrr_stack+111022, vrr_stack+201310);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+86672, vrr_stack+111838, vrr_stack+111294, vrr_stack+111702, vrr_stack+111158, vrr_stack+200350);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+255014, vrr_stack+86672, vrr_stack+85856, vrr_stack+111838, vrr_stack+111294, vrr_stack+201670);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+200350, vrr_stack+34131, vrr_stack+200710, vrr_stack+77260, vrr_stack+34446, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+201310, vrr_stack+200350, vrr_stack+111702, NULL, NULL, vrr_stack+200710);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+87488, vrr_stack+201310, vrr_stack+111838, vrr_stack+200350, vrr_stack+111702, vrr_stack+200830);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+256374, vrr_stack+87488, vrr_stack+86672, vrr_stack+201310, vrr_stack+111838, vrr_stack+202390);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+200830, vrr_stack+34551, vrr_stack+73496, vrr_stack+77624, vrr_stack+28545, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+201718, vrr_stack+112246, vrr_stack+200830, NULL, NULL, vrr_stack+34551);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+202126, vrr_stack+85448, vrr_stack+201718, vrr_stack+111022, vrr_stack+112246, vrr_stack+35226);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+257734, vrr_stack+85856, vrr_stack+202126, vrr_stack+111294, vrr_stack+85448, vrr_stack+35586);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+259094, vrr_stack+255014, vrr_stack+257734, vrr_stack+86672, vrr_stack+85856, vrr_stack+97618);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+31205, vrr_stack+256374, vrr_stack+255014, vrr_stack+87488, vrr_stack+86672, vrr_stack+203110);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+73976, vrr_stack+31205, vrr_stack+259094, vrr_stack+256374, vrr_stack+255014, vrr_stack+4729);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+35226, vrr_stack+73016, vrr_stack+34131, vrr_stack+124070, vrr_stack+77260, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+35362, vrr_stack+35226, vrr_stack+200350, NULL, NULL, vrr_stack+34131);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+202942, vrr_stack+35362, vrr_stack+201310, vrr_stack+35226, vrr_stack+200350, vrr_stack+34866);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+192610, vrr_stack+202942, vrr_stack+87488, vrr_stack+35362, vrr_stack+201310, vrr_stack+113016);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+28650, vrr_stack+192610, vrr_stack+256374, vrr_stack+202942, vrr_stack+87488, vrr_stack+149675);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+28650, vrr_stack+31205, vrr_stack+192610, vrr_stack+256374, vrr_stack+16819);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+35770, vrr_stack+73496, vrr_stack+26550, vrr_stack+28545, vrr_stack+92774, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+203758, vrr_stack+200830, vrr_stack+35770, NULL, NULL, vrr_stack+73496);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+112382, vrr_stack+201718, vrr_stack+203758, vrr_stack+112246, vrr_stack+200830, vrr_stack+73616);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+149465, vrr_stack+202126, vrr_stack+112382, vrr_stack+85448, vrr_stack+201718, vrr_stack+38106);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+38106, vrr_stack+257734, vrr_stack+149465, vrr_stack+85856, vrr_stack+202126, vrr_stack+119760);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+140351, vrr_stack+259094, vrr_stack+38106, vrr_stack+255014, vrr_stack+257734, vrr_stack+66725);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+8329, vrr_stack+73976, vrr_stack+140351, vrr_stack+31205, vrr_stack+259094, vrr_stack+217855);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+15040, vrr_stack+212230, vrr_stack+73976, vrr_stack+28650, vrr_stack+31205, vrr_stack+12520);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+275095, vrr_stack+15040, vrr_stack+8329, vrr_stack+212230, vrr_stack+73976, vrr_stack+220375);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+217855, vrr_stack+81453, vrr_stack+73016, vrr_stack+31100, vrr_stack+124070, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+217991, vrr_stack+217855, vrr_stack+35226, NULL, NULL, vrr_stack+73016);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+218399, vrr_stack+217991, vrr_stack+35362, vrr_stack+217855, vrr_stack+35226, vrr_stack+73136);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+219215, vrr_stack+218399, vrr_stack+202942, vrr_stack+217991, vrr_stack+35362, vrr_stack+78303);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+220575, vrr_stack+219215, vrr_stack+192610, vrr_stack+218399, vrr_stack+202942, vrr_stack+118560);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+65780, vrr_stack+220575, vrr_stack+28650, vrr_stack+219215, vrr_stack+192610, vrr_stack+36306);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+18848, vrr_stack+65780, vrr_stack+212230, vrr_stack+220575, vrr_stack+28650, vrr_stack+215335);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+279991, vrr_stack+18848, vrr_stack+15040, vrr_stack+65780, vrr_stack+212230, vrr_stack+47361);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47361, vrr_stack+26550, vrr_stack+252614, vrr_stack+92774, vrr_stack+146000, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47497, vrr_stack+35770, vrr_stack+47361, NULL, NULL, vrr_stack+26550);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47905, vrr_stack+203758, vrr_stack+47497, vrr_stack+200830, vrr_stack+35770, vrr_stack+26670);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+48721, vrr_stack+112382, vrr_stack+47905, vrr_stack+201718, vrr_stack+203758, vrr_stack+27030);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+118560, vrr_stack+149465, vrr_stack+48721, vrr_stack+202126, vrr_stack+112382, vrr_stack+79023);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+76832, vrr_stack+38106, vrr_stack+118560, vrr_stack+257734, vrr_stack+149465, vrr_stack+6529);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+3409, vrr_stack+140351, vrr_stack+76832, vrr_stack+259094, vrr_stack+38106, vrr_stack+53241);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+284887, vrr_stack+8329, vrr_stack+3409, vrr_stack+73976, vrr_stack+140351, vrr_stack+232375);
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+289783, vrr_stack+275095, vrr_stack+284887, vrr_stack+15040, vrr_stack+8329, vrr_stack+235735);
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+232375, vrr_stack+279991, vrr_stack+275095, vrr_stack+18848, vrr_stack+15040, vrr_stack+223735);
 am[0] = 9;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+295903, vrr_stack+232375, vrr_stack+289783, vrr_stack+279991, vrr_stack+275095, vrr_stack+240055);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+238495, vrr_stack+175330, vrr_stack+81453, vrr_stack+134471, vrr_stack+31100, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+238631, vrr_stack+238495, vrr_stack+217855, NULL, NULL, vrr_stack+81453);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+239039, vrr_stack+238631, vrr_stack+217991, vrr_stack+238495, vrr_stack+217855, vrr_stack+60503);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+239855, vrr_stack+239039, vrr_stack+218399, vrr_stack+238631, vrr_stack+217991, vrr_stack+60863);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+241215, vrr_stack+239855, vrr_stack+219215, vrr_stack+239039, vrr_stack+218399, vrr_stack+120960);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+53241, vrr_stack+241215, vrr_stack+220575, vrr_stack+239855, vrr_stack+219215, vrr_stack+122160);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+222615, vrr_stack+53241, vrr_stack+65780, vrr_stack+241215, vrr_stack+220575, vrr_stack+50721);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+238631, vrr_stack+222615, vrr_stack+18848, vrr_stack+53241, vrr_stack+65780, vrr_stack+49);
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+303383, vrr_stack+238631, vrr_stack+279991, vrr_stack+222615, vrr_stack+18848, vrr_stack+228055);
 am[0] = 9;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+222615, vrr_stack+303383, vrr_stack+232375, vrr_stack+238631, vrr_stack+279991, vrr_stack+182890);
 _BUILD_00p0(Data,vrr_stack+238631, Data->F+25, Data->F+26, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+238634, vrr_stack+252055, vrr_stack+238631, Data->F+24, Data->F+25, NULL);
 _BUILD_00f0(Data,vrr_stack+238640, vrr_stack+252058, vrr_stack+238634, vrr_stack+145748, vrr_stack+252055, NULL);
 _BUILD_00g0(Data,vrr_stack+238650, vrr_stack+252064, vrr_stack+238640, vrr_stack+145751, vrr_stack+252058, NULL);
 _BUILD_00h0(Data,vrr_stack+238665, vrr_stack+252074, vrr_stack+238650, vrr_stack+145757, vrr_stack+252064, NULL);
 _BUILD_00i0(Data,vrr_stack+238686, vrr_stack+252089, vrr_stack+238665, vrr_stack+145767, vrr_stack+252074, NULL);
 _BUILD_00k0(Data,vrr_stack+238714, vrr_stack+252110, vrr_stack+238686, vrr_stack+145782, vrr_stack+252089, NULL);
 _BUILD_00l0(Data,vrr_stack+238750, vrr_stack+252138, vrr_stack+238714, vrr_stack+145803, vrr_stack+252110, NULL);
 _BUILD_00m0(Data,vrr_stack+238795, vrr_stack+252174, vrr_stack+238750, vrr_stack+145831, vrr_stack+252138, NULL);
 _BUILD_00n0(Data,vrr_stack+238850, vrr_stack+252219, vrr_stack+238795, vrr_stack+118358, vrr_stack+252174, NULL);
 _BUILD_00o0(Data,vrr_stack+238916, vrr_stack+252274, vrr_stack+238850, vrr_stack+145867, vrr_stack+252219, NULL);
 _BUILD_00q0(Data,vrr_stack+238994, vrr_stack+252340, vrr_stack+238916, vrr_stack+118403, vrr_stack+252274, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134471, vrr_stack+252418, vrr_stack+238994, vrr_stack+145922, vrr_stack+252340, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+239085, vrr_stack+252509, vrr_stack+134471, vrr_stack+118469, vrr_stack+252418, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+118358, vrr_stack+252614, vrr_stack+239085, vrr_stack+146000, vrr_stack+252509, NULL);
 am[0] = 1;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+239205, vrr_stack+47361, vrr_stack+118358, NULL, NULL, vrr_stack+252614);
 am[0] = 2;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+239613, vrr_stack+47497, vrr_stack+239205, vrr_stack+35770, vrr_stack+47361, vrr_stack+252734);
 am[0] = 3;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+240429, vrr_stack+47905, vrr_stack+239613, vrr_stack+203758, vrr_stack+47497, vrr_stack+253094);
 am[0] = 4;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+241789, vrr_stack+48721, vrr_stack+240429, vrr_stack+112382, vrr_stack+47905, vrr_stack+253814);
 am[0] = 5;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+50081, vrr_stack+118560, vrr_stack+241789, vrr_stack+149465, vrr_stack+48721, vrr_stack+188290);
 am[0] = 6;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+76832, vrr_stack+50081, vrr_stack+38106, vrr_stack+118560, vrr_stack+190090);
 am[0] = 7;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+185858, vrr_stack+3409, vrr_stack+182050, vrr_stack+140351, vrr_stack+76832, vrr_stack+146105);
 am[0] = 8;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+143207, vrr_stack+284887, vrr_stack+185858, vrr_stack+8329, vrr_stack+3409, vrr_stack+92879);
 am[0] = 9;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+309503, vrr_stack+289783, vrr_stack+143207, vrr_stack+275095, vrr_stack+284887, vrr_stack+261775);
 am[0] = 10;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+316983, vrr_stack+295903, vrr_stack+309503, vrr_stack+232375, vrr_stack+289783, vrr_stack+104422);
 am[0] = 10;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+325959, vrr_stack+222615, vrr_stack+295903, vrr_stack+303383, vrr_stack+232375, vrr_stack+245455);
   tmp = vrr_stack + 325959;
   target_ptr = Libint->vrr_classes[10][15];
   for(i=0;i<8976;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+303383, vrr_stack+111022, vrr_stack+112246, vrr_stack+200110, vrr_stack+201190, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+303536, vrr_stack+111158, vrr_stack+111022, vrr_stack+200230, vrr_stack+200110, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+303689, vrr_stack+303536, vrr_stack+303383, NULL, NULL, vrr_stack+111022);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+304148, vrr_stack+111702, vrr_stack+111158, vrr_stack+200710, vrr_stack+200230, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+304301, vrr_stack+304148, vrr_stack+303536, NULL, NULL, vrr_stack+111158);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+200110, vrr_stack+112246, vrr_stack+200830, vrr_stack+201190, vrr_stack+34551, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+304760, vrr_stack+303383, vrr_stack+200110, NULL, NULL, vrr_stack+112246);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+305219, vrr_stack+303689, vrr_stack+304760, vrr_stack+303536, vrr_stack+303383, vrr_stack+85448);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+306137, vrr_stack+304301, vrr_stack+303689, vrr_stack+304148, vrr_stack+303536, vrr_stack+111294);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+307055, vrr_stack+306137, vrr_stack+305219, vrr_stack+304301, vrr_stack+303689, vrr_stack+85856);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+111294, vrr_stack+200350, vrr_stack+111702, vrr_stack+34131, vrr_stack+200710, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+85448, vrr_stack+111294, vrr_stack+304148, NULL, NULL, vrr_stack+111702);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+308585, vrr_stack+85448, vrr_stack+304301, vrr_stack+111294, vrr_stack+304148, vrr_stack+111838);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+104422, vrr_stack+308585, vrr_stack+306137, vrr_stack+85448, vrr_stack+304301, vrr_stack+86672);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+111838, vrr_stack+200830, vrr_stack+35770, vrr_stack+34551, vrr_stack+73496, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+85907, vrr_stack+200110, vrr_stack+111838, NULL, NULL, vrr_stack+200830);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+86366, vrr_stack+304760, vrr_stack+85907, vrr_stack+303383, vrr_stack+200110, vrr_stack+201718);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+105952, vrr_stack+305219, vrr_stack+86366, vrr_stack+303689, vrr_stack+304760, vrr_stack+202126);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+107482, vrr_stack+307055, vrr_stack+105952, vrr_stack+306137, vrr_stack+305219, vrr_stack+257734);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+92774, vrr_stack+104422, vrr_stack+307055, vrr_stack+308585, vrr_stack+306137, vrr_stack+255014);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+252734, vrr_stack+92774, vrr_stack+107482, vrr_stack+104422, vrr_stack+307055, vrr_stack+259094);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+257734, vrr_stack+35226, vrr_stack+200350, vrr_stack+73016, vrr_stack+34131, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+257887, vrr_stack+257734, vrr_stack+111294, NULL, NULL, vrr_stack+200350);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+258346, vrr_stack+257887, vrr_stack+85448, vrr_stack+257734, vrr_stack+111294, vrr_stack+201310);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+259264, vrr_stack+258346, vrr_stack+308585, vrr_stack+257887, vrr_stack+85448, vrr_stack+87488);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+260794, vrr_stack+259264, vrr_stack+104422, vrr_stack+258346, vrr_stack+308585, vrr_stack+256374);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+263089, vrr_stack+260794, vrr_stack+92774, vrr_stack+259264, vrr_stack+104422, vrr_stack+31205);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+266302, vrr_stack+35770, vrr_stack+47361, vrr_stack+73496, vrr_stack+26550, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+266455, vrr_stack+111838, vrr_stack+266302, NULL, NULL, vrr_stack+35770);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+87284, vrr_stack+85907, vrr_stack+266455, vrr_stack+200110, vrr_stack+111838, vrr_stack+203758);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+255947, vrr_stack+86366, vrr_stack+87284, vrr_stack+304760, vrr_stack+85907, vrr_stack+112382);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+95069, vrr_stack+105952, vrr_stack+255947, vrr_stack+305219, vrr_stack+86366, vrr_stack+149465);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+120600, vrr_stack+107482, vrr_stack+95069, vrr_stack+307055, vrr_stack+105952, vrr_stack+38106);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+35906, vrr_stack+252734, vrr_stack+120600, vrr_stack+92774, vrr_stack+107482, vrr_stack+140351);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+30690, vrr_stack+263089, vrr_stack+252734, vrr_stack+260794, vrr_stack+92774, vrr_stack+73976);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+334935, vrr_stack+30690, vrr_stack+35906, vrr_stack+263089, vrr_stack+252734, vrr_stack+8329);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+140351, vrr_stack+217855, vrr_stack+35226, vrr_stack+81453, vrr_stack+73016, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+140351, vrr_stack+257734, NULL, NULL, vrr_stack+35226);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+73475, vrr_stack+73016, vrr_stack+257887, vrr_stack+140351, vrr_stack+257734, vrr_stack+35362);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+74393, vrr_stack+73475, vrr_stack+258346, vrr_stack+73016, vrr_stack+257887, vrr_stack+202942);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+140504, vrr_stack+74393, vrr_stack+259264, vrr_stack+73475, vrr_stack+258346, vrr_stack+192610);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+200966, vrr_stack+140504, vrr_stack+260794, vrr_stack+74393, vrr_stack+259264, vrr_stack+28650);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+7217, vrr_stack+200966, vrr_stack+263089, vrr_stack+140504, vrr_stack+260794, vrr_stack+212230);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+7217, vrr_stack+30690, vrr_stack+200966, vrr_stack+263089, vrr_stack+15040);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+35362, vrr_stack+47361, vrr_stack+118358, vrr_stack+26550, vrr_stack+252614, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+26550, vrr_stack+266302, vrr_stack+35362, NULL, NULL, vrr_stack+47361);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+27009, vrr_stack+266455, vrr_stack+26550, vrr_stack+111838, vrr_stack+266302, vrr_stack+47497);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+27927, vrr_stack+87284, vrr_stack+27009, vrr_stack+85907, vrr_stack+266455, vrr_stack+47905);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+52937, vrr_stack+255947, vrr_stack+27927, vrr_stack+86366, vrr_stack+87284, vrr_stack+48721);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+95069, vrr_stack+52937, vrr_stack+105952, vrr_stack+255947, vrr_stack+118560);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+11501, vrr_stack+120600, vrr_stack+0, vrr_stack+107482, vrr_stack+95069, vrr_stack+76832);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+75923, vrr_stack+35906, vrr_stack+11501, vrr_stack+252734, vrr_stack+120600, vrr_stack+3409);
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+340443, vrr_stack+334935, vrr_stack+75923, vrr_stack+30690, vrr_stack+35906, vrr_stack+284887);
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+347328, vrr_stack+212230, vrr_stack+334935, vrr_stack+7217, vrr_stack+30690, vrr_stack+275095);
 am[0] = 9;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+354213, vrr_stack+347328, vrr_stack+340443, vrr_stack+212230, vrr_stack+334935, vrr_stack+289783);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+275095, vrr_stack+238495, vrr_stack+217855, vrr_stack+175330, vrr_stack+81453, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+275248, vrr_stack+275095, vrr_stack+140351, NULL, NULL, vrr_stack+217855);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+275707, vrr_stack+275248, vrr_stack+73016, vrr_stack+275095, vrr_stack+140351, vrr_stack+217991);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+276625, vrr_stack+275707, vrr_stack+73475, vrr_stack+275248, vrr_stack+73016, vrr_stack+218399);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+284887, vrr_stack+276625, vrr_stack+74393, vrr_stack+275707, vrr_stack+73475, vrr_stack+219215);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+287182, vrr_stack+284887, vrr_stack+140504, vrr_stack+276625, vrr_stack+74393, vrr_stack+220575);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+275248, vrr_stack+287182, vrr_stack+200966, vrr_stack+284887, vrr_stack+140504, vrr_stack+65780);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+290395, vrr_stack+275248, vrr_stack+7217, vrr_stack+287182, vrr_stack+200966, vrr_stack+18848);
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+15785, vrr_stack+290395, vrr_stack+212230, vrr_stack+275248, vrr_stack+7217, vrr_stack+279991);
 am[0] = 9;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+275248, vrr_stack+15785, vrr_stack+347328, vrr_stack+290395, vrr_stack+212230, vrr_stack+232375);
 _BUILD_00p0(Data,vrr_stack+283663, Data->F+26, Data->F+27, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+283666, vrr_stack+238631, vrr_stack+283663, Data->F+25, Data->F+26, NULL);
 _BUILD_00f0(Data,vrr_stack+283672, vrr_stack+238634, vrr_stack+283666, vrr_stack+252055, vrr_stack+238631, NULL);
 _BUILD_00g0(Data,vrr_stack+283682, vrr_stack+238640, vrr_stack+283672, vrr_stack+252058, vrr_stack+238634, NULL);
 _BUILD_00h0(Data,vrr_stack+283697, vrr_stack+238650, vrr_stack+283682, vrr_stack+252064, vrr_stack+238640, NULL);
 _BUILD_00i0(Data,vrr_stack+283718, vrr_stack+238665, vrr_stack+283697, vrr_stack+252074, vrr_stack+238650, NULL);
 _BUILD_00k0(Data,vrr_stack+283746, vrr_stack+238686, vrr_stack+283718, vrr_stack+252089, vrr_stack+238665, NULL);
 _BUILD_00l0(Data,vrr_stack+252055, vrr_stack+238714, vrr_stack+283746, vrr_stack+252110, vrr_stack+238686, NULL);
 _BUILD_00m0(Data,vrr_stack+283782, vrr_stack+238750, vrr_stack+252055, vrr_stack+252138, vrr_stack+238714, NULL);
 _BUILD_00n0(Data,vrr_stack+252100, vrr_stack+238795, vrr_stack+283782, vrr_stack+252174, vrr_stack+238750, NULL);
 _BUILD_00o0(Data,vrr_stack+283837, vrr_stack+238850, vrr_stack+252100, vrr_stack+252219, vrr_stack+238795, NULL);
 _BUILD_00q0(Data,vrr_stack+252166, vrr_stack+238916, vrr_stack+283837, vrr_stack+252274, vrr_stack+238850, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+283915, vrr_stack+238994, vrr_stack+252166, vrr_stack+252340, vrr_stack+238916, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175330, vrr_stack+134471, vrr_stack+283915, vrr_stack+252418, vrr_stack+238994, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+252257, vrr_stack+239085, vrr_stack+175330, vrr_stack+252509, vrr_stack+134471, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+252393, vrr_stack+118358, vrr_stack+252257, vrr_stack+252614, vrr_stack+239085, NULL);
 am[0] = 1;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+284020, vrr_stack+35362, vrr_stack+252393, NULL, NULL, vrr_stack+118358);
 am[0] = 2;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+284479, vrr_stack+26550, vrr_stack+284020, vrr_stack+266302, vrr_stack+35362, vrr_stack+239205);
 am[0] = 3;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+285397, vrr_stack+27009, vrr_stack+284479, vrr_stack+266455, vrr_stack+26550, vrr_stack+239613);
 am[0] = 4;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+286927, vrr_stack+27927, vrr_stack+285397, vrr_stack+87284, vrr_stack+27009, vrr_stack+240429);
 am[0] = 5;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+289222, vrr_stack+52937, vrr_stack+286927, vrr_stack+255947, vrr_stack+27927, vrr_stack+241789);
 am[0] = 6;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+239205, vrr_stack+0, vrr_stack+289222, vrr_stack+95069, vrr_stack+52937, vrr_stack+50081);
 am[0] = 7;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+230095, vrr_stack+11501, vrr_stack+239205, vrr_stack+120600, vrr_stack+0, vrr_stack+182050);
 am[0] = 8;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+362628, vrr_stack+75923, vrr_stack+230095, vrr_stack+35906, vrr_stack+11501, vrr_stack+185858);
 am[0] = 9;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+340443, vrr_stack+362628, vrr_stack+334935, vrr_stack+75923, vrr_stack+143207);
 am[0] = 10;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+369513, vrr_stack+354213, vrr_stack+182050, vrr_stack+347328, vrr_stack+340443, vrr_stack+309503);
 am[0] = 10;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+379611, vrr_stack+275248, vrr_stack+354213, vrr_stack+15785, vrr_stack+347328, vrr_stack+295903);
   tmp = vrr_stack + 379611;
   target_ptr = Libint->vrr_classes[10][16];
   for(i=0;i<10098;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+15785, vrr_stack+303383, vrr_stack+200110, vrr_stack+111022, vrr_stack+112246, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+15956, vrr_stack+303536, vrr_stack+303383, vrr_stack+111158, vrr_stack+111022, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+16127, vrr_stack+15956, vrr_stack+15785, NULL, NULL, vrr_stack+303383);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+16640, vrr_stack+304148, vrr_stack+303536, vrr_stack+111702, vrr_stack+111158, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+16811, vrr_stack+16640, vrr_stack+15956, NULL, NULL, vrr_stack+303536);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+17324, vrr_stack+200110, vrr_stack+111838, vrr_stack+112246, vrr_stack+200830, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+17495, vrr_stack+15785, vrr_stack+17324, NULL, NULL, vrr_stack+200110);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+18008, vrr_stack+16127, vrr_stack+17495, vrr_stack+15956, vrr_stack+15785, vrr_stack+304760);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+19034, vrr_stack+16811, vrr_stack+16127, vrr_stack+16640, vrr_stack+15956, vrr_stack+303689);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+20060, vrr_stack+19034, vrr_stack+18008, vrr_stack+16811, vrr_stack+16127, vrr_stack+305219);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+303689, vrr_stack+111294, vrr_stack+304148, vrr_stack+200350, vrr_stack+111702, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+304760, vrr_stack+303689, vrr_stack+16640, NULL, NULL, vrr_stack+304148);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+21770, vrr_stack+304760, vrr_stack+16811, vrr_stack+303689, vrr_stack+16640, vrr_stack+304301);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+309503, vrr_stack+21770, vrr_stack+19034, vrr_stack+304760, vrr_stack+16811, vrr_stack+306137);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+304301, vrr_stack+111838, vrr_stack+266302, vrr_stack+200830, vrr_stack+35770, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+305273, vrr_stack+17324, vrr_stack+304301, NULL, NULL, vrr_stack+111838);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+305786, vrr_stack+17495, vrr_stack+305273, vrr_stack+15785, vrr_stack+17324, vrr_stack+85907);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+311213, vrr_stack+18008, vrr_stack+305786, vrr_stack+16127, vrr_stack+17495, vrr_stack+86366);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+312923, vrr_stack+20060, vrr_stack+311213, vrr_stack+19034, vrr_stack+18008, vrr_stack+105952);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+190465, vrr_stack+309503, vrr_stack+20060, vrr_stack+21770, vrr_stack+19034, vrr_stack+307055);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+217991, vrr_stack+190465, vrr_stack+312923, vrr_stack+309503, vrr_stack+20060, vrr_stack+107482);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+105952, vrr_stack+257734, vrr_stack+111294, vrr_stack+35226, vrr_stack+200350, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+106123, vrr_stack+105952, vrr_stack+303689, NULL, NULL, vrr_stack+111294);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+106636, vrr_stack+106123, vrr_stack+304760, vrr_stack+105952, vrr_stack+303689, vrr_stack+85448);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+85448, vrr_stack+106636, vrr_stack+21770, vrr_stack+106123, vrr_stack+304760, vrr_stack+308585);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+107662, vrr_stack+85448, vrr_stack+309503, vrr_stack+106636, vrr_stack+21770, vrr_stack+104422);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+47497, vrr_stack+107662, vrr_stack+190465, vrr_stack+85448, vrr_stack+309503, vrr_stack+92774);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+92774, vrr_stack+266302, vrr_stack+35362, vrr_stack+35770, vrr_stack+47361, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+92945, vrr_stack+304301, vrr_stack+92774, NULL, NULL, vrr_stack+266302);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+93458, vrr_stack+305273, vrr_stack+92945, vrr_stack+17324, vrr_stack+304301, vrr_stack+266455);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+306812, vrr_stack+305786, vrr_stack+93458, vrr_stack+17495, vrr_stack+305273, vrr_stack+87284);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+292435, vrr_stack+311213, vrr_stack+306812, vrr_stack+18008, vrr_stack+305786, vrr_stack+255947);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+142799, vrr_stack+312923, vrr_stack+292435, vrr_stack+20060, vrr_stack+311213, vrr_stack+95069);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+94484, vrr_stack+217991, vrr_stack+142799, vrr_stack+190465, vrr_stack+312923, vrr_stack+120600);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+118494, vrr_stack+47497, vrr_stack+217991, vrr_stack+107662, vrr_stack+190465, vrr_stack+252734);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+389709, vrr_stack+118494, vrr_stack+94484, vrr_stack+47497, vrr_stack+217991, vrr_stack+35906);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+266455, vrr_stack+140351, vrr_stack+257734, vrr_stack+217855, vrr_stack+35226, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+266626, vrr_stack+266455, vrr_stack+105952, NULL, NULL, vrr_stack+257734);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+104422, vrr_stack+266626, vrr_stack+106123, vrr_stack+266455, vrr_stack+105952, vrr_stack+257887);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+243489, vrr_stack+104422, vrr_stack+106636, vrr_stack+266626, vrr_stack+106123, vrr_stack+258346);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+252546, vrr_stack+243489, vrr_stack+85448, vrr_stack+104422, vrr_stack+106636, vrr_stack+259264);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+35515, vrr_stack+252546, vrr_stack+107662, vrr_stack+243489, vrr_stack+85448, vrr_stack+260794);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+257887, vrr_stack+35515, vrr_stack+47497, vrr_stack+252546, vrr_stack+107662, vrr_stack+263089);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+395865, vrr_stack+257887, vrr_stack+118494, vrr_stack+35515, vrr_stack+47497, vrr_stack+30690);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+262675, vrr_stack+35362, vrr_stack+252393, vrr_stack+47361, vrr_stack+118358, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+262846, vrr_stack+92774, vrr_stack+262675, NULL, NULL, vrr_stack+35362);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+263359, vrr_stack+92945, vrr_stack+262846, vrr_stack+304301, vrr_stack+92774, vrr_stack+26550);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+264385, vrr_stack+93458, vrr_stack+263359, vrr_stack+305273, vrr_stack+92945, vrr_stack+27009);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+255111, vrr_stack+306812, vrr_stack+264385, vrr_stack+305786, vrr_stack+93458, vrr_stack+27927);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+26550, vrr_stack+292435, vrr_stack+255111, vrr_stack+311213, vrr_stack+306812, vrr_stack+52937);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+30141, vrr_stack+142799, vrr_stack+26550, vrr_stack+312923, vrr_stack+292435, vrr_stack+0);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+94484, vrr_stack+30141, vrr_stack+217991, vrr_stack+142799, vrr_stack+11501);
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+402021, vrr_stack+389709, vrr_stack+0, vrr_stack+118494, vrr_stack+94484, vrr_stack+75923);
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+409716, vrr_stack+395865, vrr_stack+389709, vrr_stack+257887, vrr_stack+118494, vrr_stack+334935);
 am[0] = 9;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+417411, vrr_stack+409716, vrr_stack+402021, vrr_stack+395865, vrr_stack+389709, vrr_stack+340443);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+334935, vrr_stack+275095, vrr_stack+140351, vrr_stack+238495, vrr_stack+217855, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+335106, vrr_stack+334935, vrr_stack+266455, NULL, NULL, vrr_stack+140351);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+335619, vrr_stack+335106, vrr_stack+266626, vrr_stack+334935, vrr_stack+266455, vrr_stack+73016);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+336645, vrr_stack+335619, vrr_stack+104422, vrr_stack+335106, vrr_stack+266626, vrr_stack+73475);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+338355, vrr_stack+336645, vrr_stack+243489, vrr_stack+335619, vrr_stack+104422, vrr_stack+74393);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+338355, vrr_stack+252546, vrr_stack+336645, vrr_stack+243489, vrr_stack+140504);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+76607, vrr_stack+73016, vrr_stack+35515, vrr_stack+338355, vrr_stack+252546, vrr_stack+200966);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+335106, vrr_stack+76607, vrr_stack+257887, vrr_stack+73016, vrr_stack+35515, vrr_stack+7217);
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+6156, vrr_stack+335106, vrr_stack+395865, vrr_stack+76607, vrr_stack+257887, vrr_stack+212230);
 am[0] = 9;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+426816, vrr_stack+6156, vrr_stack+409716, vrr_stack+335106, vrr_stack+395865, vrr_stack+347328);
 _BUILD_00p0(Data,vrr_stack+335106, Data->F+27, Data->F+28, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+335109, vrr_stack+283663, vrr_stack+335106, Data->F+26, Data->F+27, NULL);
 _BUILD_00f0(Data,vrr_stack+335115, vrr_stack+283666, vrr_stack+335109, vrr_stack+238631, vrr_stack+283663, NULL);
 _BUILD_00g0(Data,vrr_stack+335125, vrr_stack+283672, vrr_stack+335115, vrr_stack+238634, vrr_stack+283666, NULL);
 _BUILD_00h0(Data,vrr_stack+335140, vrr_stack+283682, vrr_stack+335125, vrr_stack+238640, vrr_stack+283672, NULL);
 _BUILD_00i0(Data,vrr_stack+335161, vrr_stack+283697, vrr_stack+335140, vrr_stack+238650, vrr_stack+283682, NULL);
 _BUILD_00k0(Data,vrr_stack+267139, vrr_stack+283718, vrr_stack+335161, vrr_stack+238665, vrr_stack+283697, NULL);
 _BUILD_00l0(Data,vrr_stack+335189, vrr_stack+283746, vrr_stack+267139, vrr_stack+238686, vrr_stack+283718, NULL);
 _BUILD_00m0(Data,vrr_stack+335234, vrr_stack+252055, vrr_stack+335189, vrr_stack+238714, vrr_stack+283746, NULL);
 _BUILD_00n0(Data,vrr_stack+335289, vrr_stack+283782, vrr_stack+335234, vrr_stack+238750, vrr_stack+252055, NULL);
 _BUILD_00o0(Data,vrr_stack+335355, vrr_stack+252100, vrr_stack+335289, vrr_stack+238795, vrr_stack+283782, NULL);
 _BUILD_00q0(Data,vrr_stack+335433, vrr_stack+283837, vrr_stack+335355, vrr_stack+238850, vrr_stack+252100, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+335524, vrr_stack+252166, vrr_stack+335433, vrr_stack+238916, vrr_stack+283837, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+335629, vrr_stack+283915, vrr_stack+335524, vrr_stack+238994, vrr_stack+252166, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+47361, vrr_stack+175330, vrr_stack+335629, vrr_stack+134471, vrr_stack+283915, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+335749, vrr_stack+252257, vrr_stack+47361, vrr_stack+239085, vrr_stack+175330, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+335902, vrr_stack+252393, vrr_stack+335749, vrr_stack+118358, vrr_stack+252257, NULL);
 am[0] = 1;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+336073, vrr_stack+262675, vrr_stack+335902, NULL, NULL, vrr_stack+252393);
 am[0] = 2;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+336586, vrr_stack+262846, vrr_stack+336073, vrr_stack+92774, vrr_stack+262675, vrr_stack+284020);
 am[0] = 3;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+337612, vrr_stack+263359, vrr_stack+336586, vrr_stack+92945, vrr_stack+262846, vrr_stack+284479);
 am[0] = 4;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+339322, vrr_stack+264385, vrr_stack+337612, vrr_stack+93458, vrr_stack+263359, vrr_stack+285397);
 am[0] = 5;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+341887, vrr_stack+255111, vrr_stack+339322, vrr_stack+306812, vrr_stack+264385, vrr_stack+286927);
 am[0] = 6;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+284020, vrr_stack+26550, vrr_stack+341887, vrr_stack+292435, vrr_stack+255111, vrr_stack+289222);
 am[0] = 7;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+345478, vrr_stack+30141, vrr_stack+284020, vrr_stack+142799, vrr_stack+26550, vrr_stack+239205);
 am[0] = 8;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+0, vrr_stack+345478, vrr_stack+94484, vrr_stack+30141, vrr_stack+230095);
 am[0] = 9;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+230095, vrr_stack+402021, vrr_stack+73016, vrr_stack+389709, vrr_stack+0, vrr_stack+362628);
 am[0] = 10;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+436221, vrr_stack+417411, vrr_stack+230095, vrr_stack+409716, vrr_stack+402021, vrr_stack+182050);
 am[0] = 10;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+447507, vrr_stack+426816, vrr_stack+417411, vrr_stack+6156, vrr_stack+409716, vrr_stack+354213);
   tmp = vrr_stack + 447507;
   target_ptr = Libint->vrr_classes[10][17];
   for(i=0;i<11286;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+6156, vrr_stack+15785, vrr_stack+17324, vrr_stack+303383, vrr_stack+200110, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+6346, vrr_stack+15956, vrr_stack+15785, vrr_stack+303536, vrr_stack+303383, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+6536, vrr_stack+6346, vrr_stack+6156, NULL, NULL, vrr_stack+15785);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+7106, vrr_stack+16640, vrr_stack+15956, vrr_stack+304148, vrr_stack+303536, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+7296, vrr_stack+7106, vrr_stack+6346, NULL, NULL, vrr_stack+15956);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+303383, vrr_stack+17324, vrr_stack+304301, vrr_stack+200110, vrr_stack+111838, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+200110, vrr_stack+6156, vrr_stack+303383, NULL, NULL, vrr_stack+17324);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+200680, vrr_stack+6536, vrr_stack+200110, vrr_stack+6346, vrr_stack+6156, vrr_stack+17495);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+201820, vrr_stack+7296, vrr_stack+6536, vrr_stack+7106, vrr_stack+6346, vrr_stack+16127);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+7866, vrr_stack+201820, vrr_stack+200680, vrr_stack+7296, vrr_stack+6536, vrr_stack+18008);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+16127, vrr_stack+303689, vrr_stack+16640, vrr_stack+111294, vrr_stack+304148, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+17495, vrr_stack+16127, vrr_stack+7106, NULL, NULL, vrr_stack+16640);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+202960, vrr_stack+17495, vrr_stack+7296, vrr_stack+16127, vrr_stack+7106, vrr_stack+16811);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+9766, vrr_stack+202960, vrr_stack+201820, vrr_stack+17495, vrr_stack+7296, vrr_stack+19034);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+16811, vrr_stack+304301, vrr_stack+92774, vrr_stack+111838, vrr_stack+266302, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+18065, vrr_stack+303383, vrr_stack+16811, NULL, NULL, vrr_stack+304301);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+18635, vrr_stack+200110, vrr_stack+18065, vrr_stack+6156, vrr_stack+303383, vrr_stack+305273);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+11666, vrr_stack+200680, vrr_stack+18635, vrr_stack+6536, vrr_stack+200110, vrr_stack+305786);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+7866, vrr_stack+11666, vrr_stack+201820, vrr_stack+200680, vrr_stack+311213);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+184900, vrr_stack+9766, vrr_stack+7866, vrr_stack+202960, vrr_stack+201820, vrr_stack+20060);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+362628, vrr_stack+184900, vrr_stack+182050, vrr_stack+9766, vrr_stack+7866, vrr_stack+312923);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+311213, vrr_stack+105952, vrr_stack+303689, vrr_stack+257734, vrr_stack+111294, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+311403, vrr_stack+311213, vrr_stack+16127, NULL, NULL, vrr_stack+303689);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+311973, vrr_stack+311403, vrr_stack+17495, vrr_stack+311213, vrr_stack+16127, vrr_stack+304760);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+313113, vrr_stack+311973, vrr_stack+202960, vrr_stack+311403, vrr_stack+17495, vrr_stack+21770);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+19775, vrr_stack+313113, vrr_stack+9766, vrr_stack+311973, vrr_stack+202960, vrr_stack+309503);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+19775, vrr_stack+184900, vrr_stack+313113, vrr_stack+9766, vrr_stack+190465);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+315013, vrr_stack+92774, vrr_stack+262675, vrr_stack+266302, vrr_stack+35362, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+315203, vrr_stack+16811, vrr_stack+315013, NULL, NULL, vrr_stack+92774);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+315773, vrr_stack+18065, vrr_stack+315203, vrr_stack+303383, vrr_stack+16811, vrr_stack+92945);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+13566, vrr_stack+18635, vrr_stack+315773, vrr_stack+200110, vrr_stack+18065, vrr_stack+93458);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+187750, vrr_stack+11666, vrr_stack+13566, vrr_stack+200680, vrr_stack+18635, vrr_stack+306812);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+304472, vrr_stack+182050, vrr_stack+187750, vrr_stack+7866, vrr_stack+11666, vrr_stack+292435);
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+288808, vrr_stack+362628, vrr_stack+304472, vrr_stack+184900, vrr_stack+182050, vrr_stack+142799);
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+140504, vrr_stack+212230, vrr_stack+362628, vrr_stack+19775, vrr_stack+184900, vrr_stack+217991);
 am[0] = 7;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+458793, vrr_stack+140504, vrr_stack+288808, vrr_stack+212230, vrr_stack+362628, vrr_stack+94484);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+92945, vrr_stack+266455, vrr_stack+105952, vrr_stack+140351, vrr_stack+257734, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+93135, vrr_stack+92945, vrr_stack+311213, NULL, NULL, vrr_stack+105952);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+93705, vrr_stack+93135, vrr_stack+311403, vrr_stack+92945, vrr_stack+311213, vrr_stack+106123);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+94845, vrr_stack+93705, vrr_stack+311973, vrr_stack+93135, vrr_stack+311403, vrr_stack+106636);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+190600, vrr_stack+94845, vrr_stack+313113, vrr_stack+93705, vrr_stack+311973, vrr_stack+85448);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+216220, vrr_stack+190600, vrr_stack+19775, vrr_stack+94845, vrr_stack+313113, vrr_stack+107662);
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+106123, vrr_stack+216220, vrr_stack+212230, vrr_stack+190600, vrr_stack+19775, vrr_stack+47497);
 am[0] = 7;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+47497, vrr_stack+106123, vrr_stack+140504, vrr_stack+216220, vrr_stack+212230, vrr_stack+118494);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+54337, vrr_stack+262675, vrr_stack+335902, vrr_stack+35362, vrr_stack+252393, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+54527, vrr_stack+315013, vrr_stack+54337, NULL, NULL, vrr_stack+262675);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+85448, vrr_stack+315203, vrr_stack+54527, vrr_stack+16811, vrr_stack+315013, vrr_stack+262846);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+111443, vrr_stack+315773, vrr_stack+85448, vrr_stack+18065, vrr_stack+315203, vrr_stack+263359);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+366618, vrr_stack+13566, vrr_stack+111443, vrr_stack+18635, vrr_stack+315773, vrr_stack+264385);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+118358, vrr_stack+187750, vrr_stack+366618, vrr_stack+11666, vrr_stack+13566, vrr_stack+255111);
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+465633, vrr_stack+304472, vrr_stack+118358, vrr_stack+182050, vrr_stack+187750, vrr_stack+26550);
 am[0] = 7;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+470953, vrr_stack+288808, vrr_stack+465633, vrr_stack+362628, vrr_stack+304472, vrr_stack+30141);
 am[0] = 8;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+26550, vrr_stack+458793, vrr_stack+470953, vrr_stack+140504, vrr_stack+288808, vrr_stack+0);
 am[0] = 8;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+477793, vrr_stack+47497, vrr_stack+458793, vrr_stack+106123, vrr_stack+140504, vrr_stack+389709);
 am[0] = 9;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+486343, vrr_stack+477793, vrr_stack+26550, vrr_stack+47497, vrr_stack+458793, vrr_stack+402021);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+402021, vrr_stack+334935, vrr_stack+266455, vrr_stack+275095, vrr_stack+140351, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+402211, vrr_stack+402021, vrr_stack+92945, NULL, NULL, vrr_stack+266455);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+402781, vrr_stack+402211, vrr_stack+93135, vrr_stack+402021, vrr_stack+92945, vrr_stack+266626);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+403921, vrr_stack+402781, vrr_stack+93705, vrr_stack+402211, vrr_stack+93135, vrr_stack+104422);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+405821, vrr_stack+403921, vrr_stack+94845, vrr_stack+402781, vrr_stack+93705, vrr_stack+243489);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+389709, vrr_stack+405821, vrr_stack+190600, vrr_stack+403921, vrr_stack+94845, vrr_stack+252546);
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+252546, vrr_stack+389709, vrr_stack+216220, vrr_stack+405821, vrr_stack+190600, vrr_stack+35515);
 am[0] = 7;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+402211, vrr_stack+252546, vrr_stack+106123, vrr_stack+389709, vrr_stack+216220, vrr_stack+257887);
 am[0] = 8;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+496793, vrr_stack+402211, vrr_stack+47497, vrr_stack+252546, vrr_stack+106123, vrr_stack+395865);
 am[0] = 9;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+389709, vrr_stack+496793, vrr_stack+477793, vrr_stack+402211, vrr_stack+47497, vrr_stack+409716);
 _BUILD_00p0(Data,vrr_stack+402211, Data->F+28, Data->F+29, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+402214, vrr_stack+335106, vrr_stack+402211, Data->F+27, Data->F+28, NULL);
 _BUILD_00f0(Data,vrr_stack+402220, vrr_stack+335109, vrr_stack+402214, vrr_stack+283663, vrr_stack+335106, NULL);
 _BUILD_00g0(Data,vrr_stack+402230, vrr_stack+335115, vrr_stack+402220, vrr_stack+283666, vrr_stack+335109, NULL);
 _BUILD_00h0(Data,vrr_stack+402245, vrr_stack+335125, vrr_stack+402230, vrr_stack+283672, vrr_stack+335115, NULL);
 _BUILD_00i0(Data,vrr_stack+402266, vrr_stack+335140, vrr_stack+402245, vrr_stack+283682, vrr_stack+335125, NULL);
 _BUILD_00k0(Data,vrr_stack+402294, vrr_stack+335161, vrr_stack+402266, vrr_stack+283697, vrr_stack+335140, NULL);
 _BUILD_00l0(Data,vrr_stack+369468, vrr_stack+267139, vrr_stack+402294, vrr_stack+283718, vrr_stack+335161, NULL);
 _BUILD_00m0(Data,vrr_stack+283663, vrr_stack+335189, vrr_stack+369468, vrr_stack+283746, vrr_stack+267139, NULL);
 _BUILD_00n0(Data,vrr_stack+402330, vrr_stack+335234, vrr_stack+283663, vrr_stack+252055, vrr_stack+335189, NULL);
 _BUILD_00o0(Data,vrr_stack+402396, vrr_stack+335289, vrr_stack+402330, vrr_stack+283782, vrr_stack+335234, NULL);
 _BUILD_00q0(Data,vrr_stack+283718, vrr_stack+335355, vrr_stack+402396, vrr_stack+252100, vrr_stack+335289, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+134471, vrr_stack+335433, vrr_stack+283718, vrr_stack+283837, vrr_stack+335355, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+402474, vrr_stack+335524, vrr_stack+134471, vrr_stack+252166, vrr_stack+335433, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+252055, vrr_stack+335629, vrr_stack+402474, vrr_stack+283915, vrr_stack+335524, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+140351, vrr_stack+47361, vrr_stack+252055, vrr_stack+175330, vrr_stack+335629, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+283809, vrr_stack+335749, vrr_stack+140351, vrr_stack+252257, vrr_stack+47361, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+252191, vrr_stack+335902, vrr_stack+283809, vrr_stack+252393, vrr_stack+335749, NULL);
 am[0] = 1;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+252381, vrr_stack+54337, vrr_stack+252191, NULL, NULL, vrr_stack+335902);
 am[0] = 2;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+252951, vrr_stack+54527, vrr_stack+252381, vrr_stack+315013, vrr_stack+54337, vrr_stack+336073);
 am[0] = 3;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+254091, vrr_stack+85448, vrr_stack+252951, vrr_stack+315203, vrr_stack+54527, vrr_stack+336586);
 am[0] = 4;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+255991, vrr_stack+111443, vrr_stack+254091, vrr_stack+315773, vrr_stack+85448, vrr_stack+337612);
 am[0] = 5;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+402594, vrr_stack+366618, vrr_stack+255991, vrr_stack+13566, vrr_stack+111443, vrr_stack+339322);
 am[0] = 6;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+336073, vrr_stack+118358, vrr_stack+402594, vrr_stack+187750, vrr_stack+366618, vrr_stack+341887);
 am[0] = 7;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+406584, vrr_stack+465633, vrr_stack+336073, vrr_stack+304472, vrr_stack+118358, vrr_stack+284020);
 am[0] = 8;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+505343, vrr_stack+470953, vrr_stack+406584, vrr_stack+288808, vrr_stack+465633, vrr_stack+345478);
 am[0] = 9;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+341393, vrr_stack+26550, vrr_stack+505343, vrr_stack+458793, vrr_stack+470953, vrr_stack+73016);
 am[0] = 10;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+513893, vrr_stack+486343, vrr_stack+341393, vrr_stack+477793, vrr_stack+26550, vrr_stack+230095);
 am[0] = 10;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+230095, vrr_stack+389709, vrr_stack+486343, vrr_stack+496793, vrr_stack+477793, vrr_stack+417411);
   tmp = vrr_stack + 230095;
   target_ptr = Libint->vrr_classes[10][18];
   for(i=0;i<12540;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+204100, vrr_stack+6156, vrr_stack+303383, vrr_stack+15785, vrr_stack+17324, NULL);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+496793, vrr_stack+6346, vrr_stack+6156, vrr_stack+15956, vrr_stack+15785, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+497003, vrr_stack+496793, vrr_stack+204100, NULL, NULL, vrr_stack+6156);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+497633, vrr_stack+7106, vrr_stack+6346, vrr_stack+16640, vrr_stack+15956, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+497843, vrr_stack+497633, vrr_stack+496793, NULL, NULL, vrr_stack+6346);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+498473, vrr_stack+303383, vrr_stack+16811, vrr_stack+17324, vrr_stack+304301, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+498683, vrr_stack+204100, vrr_stack+498473, NULL, NULL, vrr_stack+303383);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+499313, vrr_stack+497003, vrr_stack+498683, vrr_stack+496793, vrr_stack+204100, vrr_stack+200110);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+500573, vrr_stack+497843, vrr_stack+497003, vrr_stack+497633, vrr_stack+496793, vrr_stack+6536);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+501833, vrr_stack+500573, vrr_stack+499313, vrr_stack+497843, vrr_stack+497003, vrr_stack+200680);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+6536, vrr_stack+16127, vrr_stack+7106, vrr_stack+303689, vrr_stack+16640, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+200110, vrr_stack+6536, vrr_stack+497633, NULL, NULL, vrr_stack+7106);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+503933, vrr_stack+200110, vrr_stack+497843, vrr_stack+6536, vrr_stack+497633, vrr_stack+7296);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+242635, vrr_stack+503933, vrr_stack+500573, vrr_stack+200110, vrr_stack+497843, vrr_stack+201820);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+7296, vrr_stack+16811, vrr_stack+315013, vrr_stack+304301, vrr_stack+92774, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+200740, vrr_stack+498473, vrr_stack+7296, NULL, NULL, vrr_stack+16811);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+201370, vrr_stack+498683, vrr_stack+200740, vrr_stack+204100, vrr_stack+498473, vrr_stack+18065);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+499313, vrr_stack+201370, vrr_stack+497003, vrr_stack+498683, vrr_stack+18635);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+75116, vrr_stack+501833, vrr_stack+73016, vrr_stack+500573, vrr_stack+499313, vrr_stack+11666);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+78266, vrr_stack+242635, vrr_stack+501833, vrr_stack+503933, vrr_stack+500573, vrr_stack+7866);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+283980, vrr_stack+78266, vrr_stack+75116, vrr_stack+242635, vrr_stack+501833, vrr_stack+182050);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+311213, vrr_stack+16127, vrr_stack+105952, vrr_stack+303689, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+182260, vrr_stack+182050, vrr_stack+6536, NULL, NULL, vrr_stack+16127);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+182890, vrr_stack+182260, vrr_stack+200110, vrr_stack+182050, vrr_stack+6536, vrr_stack+17495);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+7506, vrr_stack+182890, vrr_stack+503933, vrr_stack+182260, vrr_stack+200110, vrr_stack+202960);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+258841, vrr_stack+7506, vrr_stack+242635, vrr_stack+182890, vrr_stack+503933, vrr_stack+9766);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+258841, vrr_stack+78266, vrr_stack+7506, vrr_stack+242635, vrr_stack+184900);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+184150, vrr_stack+315013, vrr_stack+54337, vrr_stack+92774, vrr_stack+262675, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+184360, vrr_stack+7296, vrr_stack+184150, NULL, NULL, vrr_stack+315013);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+184990, vrr_stack+200740, vrr_stack+184360, vrr_stack+498473, vrr_stack+7296, vrr_stack+315203);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+9606, vrr_stack+201370, vrr_stack+184990, vrr_stack+498683, vrr_stack+200740, vrr_stack+315773);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+413424, vrr_stack+73016, vrr_stack+9606, vrr_stack+499313, vrr_stack+201370, vrr_stack+13566);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+11706, vrr_stack+75116, vrr_stack+413424, vrr_stack+501833, vrr_stack+73016, vrr_stack+187750);
 am[0] = 6;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+526433, vrr_stack+283980, vrr_stack+11706, vrr_stack+78266, vrr_stack+75116, vrr_stack+304472);
 am[0] = 6;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+303573, vrr_stack+0, vrr_stack+283980, vrr_stack+258841, vrr_stack+78266, vrr_stack+362628);
 am[0] = 7;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+532313, vrr_stack+303573, vrr_stack+526433, vrr_stack+0, vrr_stack+283980, vrr_stack+288808);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+362628, vrr_stack+92945, vrr_stack+311213, vrr_stack+266455, vrr_stack+105952, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+362838, vrr_stack+362628, vrr_stack+182050, NULL, NULL, vrr_stack+311213);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+363468, vrr_stack+362838, vrr_stack+182260, vrr_stack+362628, vrr_stack+182050, vrr_stack+311403);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+186250, vrr_stack+363468, vrr_stack+182890, vrr_stack+362838, vrr_stack+182260, vrr_stack+311973);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+288390, vrr_stack+186250, vrr_stack+7506, vrr_stack+363468, vrr_stack+182890, vrr_stack+313113);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+35100, vrr_stack+288390, vrr_stack+258841, vrr_stack+186250, vrr_stack+7506, vrr_stack+19775);
 am[0] = 6;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+17001, vrr_stack+35100, vrr_stack+0, vrr_stack+288390, vrr_stack+258841, vrr_stack+212230);
 am[0] = 7;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+539873, vrr_stack+17001, vrr_stack+303573, vrr_stack+35100, vrr_stack+0, vrr_stack+140504);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+140504, vrr_stack+54337, vrr_stack+252191, vrr_stack+262675, vrr_stack+335902, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+140714, vrr_stack+184150, vrr_stack+140504, NULL, NULL, vrr_stack+54337);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+141344, vrr_stack+184360, vrr_stack+140714, vrr_stack+7296, vrr_stack+184150, vrr_stack+54527);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+142604, vrr_stack+184990, vrr_stack+141344, vrr_stack+200740, vrr_stack+184360, vrr_stack+85448);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+144704, vrr_stack+9606, vrr_stack+142604, vrr_stack+201370, vrr_stack+184990, vrr_stack+111443);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+261991, vrr_stack+413424, vrr_stack+144704, vrr_stack+73016, vrr_stack+9606, vrr_stack+366618);
 am[0] = 6;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+547433, vrr_stack+11706, vrr_stack+261991, vrr_stack+75116, vrr_stack+413424, vrr_stack+118358);
 am[0] = 7;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+553313, vrr_stack+526433, vrr_stack+547433, vrr_stack+283980, vrr_stack+11706, vrr_stack+465633);
 am[0] = 8;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+560873, vrr_stack+532313, vrr_stack+553313, vrr_stack+303573, vrr_stack+526433, vrr_stack+470953);
 am[0] = 8;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+465633, vrr_stack+539873, vrr_stack+532313, vrr_stack+17001, vrr_stack+303573, vrr_stack+458793);
 am[0] = 9;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+570323, vrr_stack+465633, vrr_stack+560873, vrr_stack+539873, vrr_stack+532313, vrr_stack+26550);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+26550, vrr_stack+402021, vrr_stack+92945, vrr_stack+334935, vrr_stack+266455, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+26760, vrr_stack+26550, vrr_stack+362628, NULL, NULL, vrr_stack+92945);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+27390, vrr_stack+26760, vrr_stack+362838, vrr_stack+26550, vrr_stack+362628, vrr_stack+93135);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+28650, vrr_stack+27390, vrr_stack+363468, vrr_stack+26760, vrr_stack+362838, vrr_stack+93705);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+30750, vrr_stack+28650, vrr_stack+186250, vrr_stack+27390, vrr_stack+363468, vrr_stack+94845);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+93135, vrr_stack+30750, vrr_stack+288390, vrr_stack+28650, vrr_stack+186250, vrr_stack+190600);
 am[0] = 6;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+458793, vrr_stack+93135, vrr_stack+35100, vrr_stack+30750, vrr_stack+288390, vrr_stack+216220);
 am[0] = 7;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+26760, vrr_stack+458793, vrr_stack+17001, vrr_stack+93135, vrr_stack+35100, vrr_stack+106123);
 am[0] = 8;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+26760, vrr_stack+539873, vrr_stack+458793, vrr_stack+17001, vrr_stack+47497);
 am[0] = 9;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+581873, vrr_stack+212230, vrr_stack+465633, vrr_stack+26760, vrr_stack+539873, vrr_stack+477793);
 _BUILD_00p0(Data,vrr_stack+26760, Data->F+29, Data->F+30, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+26763, vrr_stack+402211, vrr_stack+26760, Data->F+28, Data->F+29, NULL);
 _BUILD_00f0(Data,vrr_stack+26769, vrr_stack+402214, vrr_stack+26763, vrr_stack+335106, vrr_stack+402211, NULL);
 _BUILD_00g0(Data,vrr_stack+26779, vrr_stack+402220, vrr_stack+26769, vrr_stack+335109, vrr_stack+402214, NULL);
 _BUILD_00h0(Data,vrr_stack+26794, vrr_stack+402230, vrr_stack+26779, vrr_stack+335115, vrr_stack+402220, NULL);
 _BUILD_00i0(Data,vrr_stack+26815, vrr_stack+402245, vrr_stack+26794, vrr_stack+335125, vrr_stack+402230, NULL);
 _BUILD_00k0(Data,vrr_stack+26843, vrr_stack+402266, vrr_stack+26815, vrr_stack+335140, vrr_stack+402245, NULL);
 _BUILD_00l0(Data,vrr_stack+26879, vrr_stack+402294, vrr_stack+26843, vrr_stack+335161, vrr_stack+402266, NULL);
 _BUILD_00m0(Data,vrr_stack+26924, vrr_stack+369468, vrr_stack+26879, vrr_stack+267139, vrr_stack+402294, NULL);
 _BUILD_00n0(Data,vrr_stack+26979, vrr_stack+283663, vrr_stack+26924, vrr_stack+335189, vrr_stack+369468, NULL);
 _BUILD_00o0(Data,vrr_stack+27045, vrr_stack+402330, vrr_stack+26979, vrr_stack+335234, vrr_stack+283663, NULL);
 _BUILD_00q0(Data,vrr_stack+27123, vrr_stack+402396, vrr_stack+27045, vrr_stack+335289, vrr_stack+402330, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+27214, vrr_stack+283718, vrr_stack+27123, vrr_stack+335355, vrr_stack+402396, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+175330, vrr_stack+134471, vrr_stack+27214, vrr_stack+335433, vrr_stack+283718, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+27319, vrr_stack+402474, vrr_stack+175330, vrr_stack+335524, vrr_stack+134471, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+275095, vrr_stack+252055, vrr_stack+27319, vrr_stack+335629, vrr_stack+402474, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+92774, vrr_stack+140351, vrr_stack+275095, vrr_stack+47361, vrr_stack+252055, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+47361, vrr_stack+283809, vrr_stack+92774, vrr_stack+335749, vrr_stack+140351, NULL);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+47551, vrr_stack+252191, vrr_stack+47361, vrr_stack+335902, vrr_stack+283809, NULL);
 am[0] = 1;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+47761, vrr_stack+140504, vrr_stack+47551, NULL, NULL, vrr_stack+252191);
 am[0] = 2;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+48391, vrr_stack+140714, vrr_stack+47761, vrr_stack+184150, vrr_stack+140504, vrr_stack+252381);
 am[0] = 3;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+49651, vrr_stack+141344, vrr_stack+48391, vrr_stack+184360, vrr_stack+140714, vrr_stack+252951);
 am[0] = 4;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+27455, vrr_stack+142604, vrr_stack+49651, vrr_stack+184990, vrr_stack+141344, vrr_stack+254091);
 am[0] = 5;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+30605, vrr_stack+144704, vrr_stack+27455, vrr_stack+9606, vrr_stack+142604, vrr_stack+255991);
 am[0] = 6;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+252381, vrr_stack+261991, vrr_stack+30605, vrr_stack+413424, vrr_stack+144704, vrr_stack+402594);
 am[0] = 7;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+475083, vrr_stack+547433, vrr_stack+252381, vrr_stack+11706, vrr_stack+261991, vrr_stack+336073);
 am[0] = 8;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+104422, vrr_stack+553313, vrr_stack+475083, vrr_stack+526433, vrr_stack+547433, vrr_stack+406584);
 am[0] = 9;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+593423, vrr_stack+560873, vrr_stack+104422, vrr_stack+532313, vrr_stack+553313, vrr_stack+505343);
 am[0] = 10;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+604973, vrr_stack+570323, vrr_stack+593423, vrr_stack+465633, vrr_stack+560873, vrr_stack+341393);
 am[0] = 10;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+334935, vrr_stack+581873, vrr_stack+570323, vrr_stack+212230, vrr_stack+465633, vrr_stack+486343);
   tmp = vrr_stack + 334935;
   target_ptr = Libint->vrr_classes[10][19];
   for(i=0;i<13860;i++)
     target_ptr[i] += tmp[i];
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+204100, vrr_stack+498473, vrr_stack+6156, vrr_stack+303383, NULL);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212461, vrr_stack+496793, vrr_stack+204100, vrr_stack+6346, vrr_stack+6156, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212692, vrr_stack+212461, vrr_stack+212230, NULL, NULL, vrr_stack+204100);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+213385, vrr_stack+497633, vrr_stack+496793, vrr_stack+7106, vrr_stack+6346, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+213616, vrr_stack+213385, vrr_stack+212461, NULL, NULL, vrr_stack+496793);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+214309, vrr_stack+498473, vrr_stack+7296, vrr_stack+303383, vrr_stack+16811, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+214540, vrr_stack+212230, vrr_stack+214309, NULL, NULL, vrr_stack+498473);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+215233, vrr_stack+212692, vrr_stack+214540, vrr_stack+212461, vrr_stack+212230, vrr_stack+498683);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+216619, vrr_stack+213616, vrr_stack+212692, vrr_stack+213385, vrr_stack+212461, vrr_stack+497003);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+218005, vrr_stack+216619, vrr_stack+215233, vrr_stack+213616, vrr_stack+212692, vrr_stack+499313);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212461, vrr_stack+6536, vrr_stack+497633, vrr_stack+16127, vrr_stack+7106, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+498473, vrr_stack+212461, vrr_stack+213385, NULL, NULL, vrr_stack+497633);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+499166, vrr_stack+498473, vrr_stack+213616, vrr_stack+212461, vrr_stack+213385, vrr_stack+497843);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+402594, vrr_stack+499166, vrr_stack+216619, vrr_stack+498473, vrr_stack+213616, vrr_stack+500573);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+213385, vrr_stack+7296, vrr_stack+184150, vrr_stack+16811, vrr_stack+315013, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+213616, vrr_stack+214309, vrr_stack+213385, NULL, NULL, vrr_stack+7296);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+496793, vrr_stack+214540, vrr_stack+213616, vrr_stack+212230, vrr_stack+214309, vrr_stack+200740);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+404904, vrr_stack+215233, vrr_stack+496793, vrr_stack+212692, vrr_stack+214540, vrr_stack+201370);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+200740, vrr_stack+218005, vrr_stack+404904, vrr_stack+216619, vrr_stack+215233, vrr_stack+73016);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+407214, vrr_stack+402594, vrr_stack+218005, vrr_stack+499166, vrr_stack+216619, vrr_stack+501833);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+458793, vrr_stack+407214, vrr_stack+200740, vrr_stack+402594, vrr_stack+218005, vrr_stack+75116);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+182050, vrr_stack+6536, vrr_stack+311213, vrr_stack+16127, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212692, vrr_stack+212230, vrr_stack+212461, NULL, NULL, vrr_stack+6536);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+216619, vrr_stack+212692, vrr_stack+498473, vrr_stack+212230, vrr_stack+212461, vrr_stack+200110);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+216619, vrr_stack+499166, vrr_stack+212692, vrr_stack+498473, vrr_stack+503933);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+500552, vrr_stack+73016, vrr_stack+402594, vrr_stack+216619, vrr_stack+499166, vrr_stack+242635);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+504017, vrr_stack+500552, vrr_stack+407214, vrr_stack+73016, vrr_stack+402594, vrr_stack+78266);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212461, vrr_stack+184150, vrr_stack+140504, vrr_stack+315013, vrr_stack+54337, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+402594, vrr_stack+213385, vrr_stack+212461, NULL, NULL, vrr_stack+184150);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+403287, vrr_stack+213616, vrr_stack+402594, vrr_stack+214309, vrr_stack+213385, vrr_stack+184360);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+242635, vrr_stack+496793, vrr_stack+403287, vrr_stack+214540, vrr_stack+213616, vrr_stack+184990);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+75326, vrr_stack+404904, vrr_stack+242635, vrr_stack+215233, vrr_stack+496793, vrr_stack+9606);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+508868, vrr_stack+200740, vrr_stack+75326, vrr_stack+218005, vrr_stack+404904, vrr_stack+413424);
 am[0] = 6;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+410679, vrr_stack+458793, vrr_stack+508868, vrr_stack+407214, vrr_stack+200740, vrr_stack+11706);
 am[0] = 6;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+9606, vrr_stack+504017, vrr_stack+458793, vrr_stack+500552, vrr_stack+407214, vrr_stack+283980);
 am[0] = 7;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+618833, vrr_stack+9606, vrr_stack+410679, vrr_stack+504017, vrr_stack+458793, vrr_stack+526433);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+404673, vrr_stack+362628, vrr_stack+182050, vrr_stack+92945, vrr_stack+311213, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+526433, vrr_stack+404673, vrr_stack+212230, NULL, NULL, vrr_stack+182050);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+527126, vrr_stack+526433, vrr_stack+212692, vrr_stack+404673, vrr_stack+212230, vrr_stack+182260);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+214309, vrr_stack+527126, vrr_stack+216619, vrr_stack+526433, vrr_stack+212692, vrr_stack+182890);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+407214, vrr_stack+214309, vrr_stack+73016, vrr_stack+527126, vrr_stack+216619, vrr_stack+7506);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+216619, vrr_stack+407214, vrr_stack+500552, vrr_stack+214309, vrr_stack+73016, vrr_stack+258841);
 am[0] = 6;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+309453, vrr_stack+216619, vrr_stack+504017, vrr_stack+407214, vrr_stack+500552, vrr_stack+0);
 am[0] = 7;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+309453, vrr_stack+9606, vrr_stack+216619, vrr_stack+504017, vrr_stack+303573);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+140504, vrr_stack+47551, vrr_stack+54337, vrr_stack+252191, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212692, vrr_stack+212461, vrr_stack+212230, NULL, NULL, vrr_stack+140504);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+73016, vrr_stack+402594, vrr_stack+212692, vrr_stack+213385, vrr_stack+212461, vrr_stack+140714);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+403287, vrr_stack+73016, vrr_stack+213616, vrr_stack+402594, vrr_stack+141344);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+528512, vrr_stack+242635, vrr_stack+182050, vrr_stack+496793, vrr_stack+403287, vrr_stack+142604);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+496793, vrr_stack+75326, vrr_stack+528512, vrr_stack+404904, vrr_stack+242635, vrr_stack+144704);
 am[0] = 6;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+501644, vrr_stack+508868, vrr_stack+496793, vrr_stack+200740, vrr_stack+75326, vrr_stack+261991);
 am[0] = 7;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+140504, vrr_stack+410679, vrr_stack+501644, vrr_stack+458793, vrr_stack+508868, vrr_stack+547433);
 am[0] = 8;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+627149, vrr_stack+618833, vrr_stack+140504, vrr_stack+9606, vrr_stack+410679, vrr_stack+553313);
 am[0] = 8;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+547433, vrr_stack+0, vrr_stack+618833, vrr_stack+309453, vrr_stack+9606, vrr_stack+532313);
 am[0] = 9;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+637544, vrr_stack+547433, vrr_stack+627149, vrr_stack+0, vrr_stack+618833, vrr_stack+560873);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+557828, vrr_stack+26550, vrr_stack+362628, vrr_stack+402021, vrr_stack+92945, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+92945, vrr_stack+557828, vrr_stack+404673, NULL, NULL, vrr_stack+362628);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+93638, vrr_stack+92945, vrr_stack+526433, vrr_stack+557828, vrr_stack+404673, vrr_stack+362838);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+404673, vrr_stack+93638, vrr_stack+527126, vrr_stack+92945, vrr_stack+526433, vrr_stack+363468);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+557828, vrr_stack+404673, vrr_stack+214309, vrr_stack+93638, vrr_stack+527126, vrr_stack+186250);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+92945, vrr_stack+557828, vrr_stack+407214, vrr_stack+404673, vrr_stack+214309, vrr_stack+288390);
 am[0] = 6;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+561293, vrr_stack+92945, vrr_stack+216619, vrr_stack+557828, vrr_stack+407214, vrr_stack+35100);
 am[0] = 7;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+8316, vrr_stack+561293, vrr_stack+309453, vrr_stack+92945, vrr_stack+216619, vrr_stack+17001);
 am[0] = 8;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+283980, vrr_stack+8316, vrr_stack+0, vrr_stack+561293, vrr_stack+309453, vrr_stack+539873);
 am[0] = 9;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+531977, vrr_stack+283980, vrr_stack+547433, vrr_stack+8316, vrr_stack+0, vrr_stack+465633);
 _BUILD_00p0(Data,vrr_stack+0, Data->F+30, Data->F+31, NULL, NULL, NULL);
 _BUILD_00d0(Data,vrr_stack+3, vrr_stack+26760, vrr_stack+0, Data->F+29, Data->F+30, NULL);
 _BUILD_00f0(Data,vrr_stack+9, vrr_stack+26763, vrr_stack+3, vrr_stack+402211, vrr_stack+26760, NULL);
 _BUILD_00g0(Data,vrr_stack+19, vrr_stack+26769, vrr_stack+9, vrr_stack+402214, vrr_stack+26763, NULL);
 _BUILD_00h0(Data,vrr_stack+34, vrr_stack+26779, vrr_stack+19, vrr_stack+402220, vrr_stack+26769, NULL);
 _BUILD_00i0(Data,vrr_stack+0, vrr_stack+26794, vrr_stack+34, vrr_stack+402230, vrr_stack+26779, NULL);
 _BUILD_00k0(Data,vrr_stack+28, vrr_stack+26815, vrr_stack+0, vrr_stack+402245, vrr_stack+26794, NULL);
 _BUILD_00l0(Data,vrr_stack+64, vrr_stack+26843, vrr_stack+28, vrr_stack+402266, vrr_stack+26815, NULL);
 _BUILD_00m0(Data,vrr_stack+0, vrr_stack+26879, vrr_stack+64, vrr_stack+402294, vrr_stack+26843, NULL);
 _BUILD_00n0(Data,vrr_stack+55, vrr_stack+26924, vrr_stack+0, vrr_stack+369468, vrr_stack+26879, NULL);
 _BUILD_00o0(Data,vrr_stack+121, vrr_stack+26979, vrr_stack+55, vrr_stack+283663, vrr_stack+26924, NULL);
 _BUILD_00q0(Data,vrr_stack+0, vrr_stack+27045, vrr_stack+121, vrr_stack+402330, vrr_stack+26979, NULL);
 am[0] = 0;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+91, vrr_stack+27123, vrr_stack+0, vrr_stack+402396, vrr_stack+27045, NULL);
 am[0] = 0;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+196, vrr_stack+27214, vrr_stack+91, vrr_stack+283718, vrr_stack+27123, NULL);
 am[0] = 0;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+175330, vrr_stack+196, vrr_stack+134471, vrr_stack+27214, NULL);
 am[0] = 0;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+136, vrr_stack+27319, vrr_stack+0, vrr_stack+402474, vrr_stack+175330, NULL);
 am[0] = 0;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+289, vrr_stack+275095, vrr_stack+136, vrr_stack+252055, vrr_stack+27319, NULL);
 am[0] = 0;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+92774, vrr_stack+289, vrr_stack+140351, vrr_stack+275095, NULL);
 am[0] = 0;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+190, vrr_stack+47361, vrr_stack+0, vrr_stack+283809, vrr_stack+92774, NULL);
 am[0] = 0;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+92774, vrr_stack+47551, vrr_stack+190, vrr_stack+252191, vrr_stack+47361, NULL);
 am[0] = 1;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+93005, vrr_stack+212230, vrr_stack+92774, NULL, NULL, vrr_stack+47551);
 am[0] = 2;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+93698, vrr_stack+212692, vrr_stack+93005, vrr_stack+212461, vrr_stack+212230, vrr_stack+47761);
 am[0] = 3;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+95084, vrr_stack+73016, vrr_stack+93698, vrr_stack+402594, vrr_stack+212692, vrr_stack+48391);
 am[0] = 4;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+182050, vrr_stack+95084, vrr_stack+403287, vrr_stack+73016, vrr_stack+49651);
 am[0] = 5;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+215695, vrr_stack+528512, vrr_stack+212230, vrr_stack+242635, vrr_stack+182050, vrr_stack+27455);
 am[0] = 6;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+496793, vrr_stack+215695, vrr_stack+75326, vrr_stack+528512, vrr_stack+30605);
 am[0] = 7;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+212230, vrr_stack+501644, vrr_stack+182050, vrr_stack+508868, vrr_stack+496793, vrr_stack+252381);
 am[0] = 8;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+182050, vrr_stack+140504, vrr_stack+212230, vrr_stack+410679, vrr_stack+501644, vrr_stack+475083);
 am[0] = 9;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+496793, vrr_stack+627149, vrr_stack+182050, vrr_stack+618833, vrr_stack+140504, vrr_stack+104422);
 am[0] = 10;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+0, vrr_stack+637544, vrr_stack+496793, vrr_stack+547433, vrr_stack+627149, vrr_stack+593423);
 am[0] = 10;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+496793, vrr_stack+531977, vrr_stack+637544, vrr_stack+283980, vrr_stack+547433, vrr_stack+570323);
   tmp = vrr_stack + 496793;
   target_ptr = Libint->vrr_classes[10][20];
   for(i=0;i<15246;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0n0(Data,vrr_stack+593423, vrr_stack+56147, vrr_stack+88418, vrr_stack+22920, vrr_stack+81818, vrr_stack+62150);
   tmp = vrr_stack + 593423;
   target_ptr = Libint->vrr_classes[11][10];
   for(i=0;i<5148;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0o0(Data,vrr_stack+598571, vrr_stack+129323, vrr_stack+124175, vrr_stack+68726, vrr_stack+114068, vrr_stack+88418);
   tmp = vrr_stack + 598571;
   target_ptr = Libint->vrr_classes[11][11];
   for(i=0;i<6084;i++)
     target_ptr[i] += tmp[i];
 _BUILD_o0q0(Data,vrr_stack+104422, vrr_stack+169324, vrr_stack+163318, vrr_stack+99417, vrr_stack+150942, vrr_stack+124175);
   tmp = vrr_stack + 104422;
   target_ptr = Libint->vrr_classes[11][12];
   for(i=0;i<7098;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 13;
 vrr_build_xxxx(am,Data,vrr_stack+111520, vrr_stack+40431, vrr_stack+155947, vrr_stack+134576, vrr_stack+194335, vrr_stack+163318);
   tmp = vrr_stack + 111520;
   target_ptr = Libint->vrr_classes[11][13];
   for(i=0;i<8190;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 14;
 vrr_build_xxxx(am,Data,vrr_stack+119710, vrr_stack+204310, vrr_stack+267175, vrr_stack+175450, vrr_stack+245455, vrr_stack+155947);
   tmp = vrr_stack + 119710;
   target_ptr = Libint->vrr_classes[11][14];
   for(i=0;i<9360;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 15;
 vrr_build_xxxx(am,Data,vrr_stack+129070, vrr_stack+325959, vrr_stack+316983, vrr_stack+222615, vrr_stack+295903, vrr_stack+267175);
   tmp = vrr_stack + 129070;
   target_ptr = Libint->vrr_classes[11][15];
   for(i=0;i<10608;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 16;
 vrr_build_xxxx(am,Data,vrr_stack+139678, vrr_stack+379611, vrr_stack+369513, vrr_stack+275248, vrr_stack+354213, vrr_stack+316983);
   tmp = vrr_stack + 139678;
   target_ptr = Libint->vrr_classes[11][16];
   for(i=0;i<11934;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 17;
 vrr_build_xxxx(am,Data,vrr_stack+151612, vrr_stack+447507, vrr_stack+436221, vrr_stack+426816, vrr_stack+417411, vrr_stack+369513);
   tmp = vrr_stack + 151612;
   target_ptr = Libint->vrr_classes[11][17];
   for(i=0;i<13338;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 18;
 vrr_build_xxxx(am,Data,vrr_stack+447507, vrr_stack+230095, vrr_stack+513893, vrr_stack+389709, vrr_stack+486343, vrr_stack+436221);
   tmp = vrr_stack + 447507;
   target_ptr = Libint->vrr_classes[11][18];
   for(i=0;i<14820;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 19;
 vrr_build_xxxx(am,Data,vrr_stack+462327, vrr_stack+334935, vrr_stack+604973, vrr_stack+581873, vrr_stack+570323, vrr_stack+513893);
   tmp = vrr_stack + 462327;
   target_ptr = Libint->vrr_classes[11][19];
   for(i=0;i<16380;i++)
     target_ptr[i] += tmp[i];
 am[0] = 11;  am[1] = 20;
 vrr_build_xxxx(am,Data,vrr_stack+478707, vrr_stack+496793, vrr_stack+0, vrr_stack+531977, vrr_stack+637544, vrr_stack+604973);
   tmp = vrr_stack + 478707;
   target_ptr = Libint->vrr_classes[11][20];
   for(i=0;i<18018;i++)
     target_ptr[i] += tmp[i];

}

