/*
 *  Copyright (C) 1996-2017 Edward F. Valeev and Justin T. Fermann
 *
 *  This file is part of Libint.
 *
 *  Libint is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Libint is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Libint.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

  /* These machine-generated functions compute a quartet of (ks|[r12,T1]|hs) integrals */

#include <libint/libint.h>
#include "libr12.h"

REALTYPE *_t1_build_k0h0_0(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  REALTYPE fivezboz;
  REALTYPE sixzboz;
  REALTYPE sevenzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  fivezboz = 5.0*(Data->twozeta_b*Data->oo2z);
  sixzboz = 6.0*(Data->twozeta_b*Data->oo2z);
  sevenzboz = 7.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 8.000000))*Data->oo2z;

*(vp++) = U0*I0[0]
          - U10*(I1[0] - I2[0])
          - U11*(I1[21] - I2[1])
          - U12*(I1[42] - I2[2])
          + (sevenzboz)*(I3[0] - AC0*I4[0]);
*(vp++) = U0*I0[1]
          - U10*(I1[1] - I2[1])
          - U11*(I1[22] - I2[3])
          - U12*(I1[43] - I2[4])
          + (sevenzboz)*(I3[1] - AC0*I4[1]);
*(vp++) = U0*I0[2]
          - U10*(I1[2] - I2[2])
          - U11*(I1[23] - I2[4])
          - U12*(I1[44] - I2[5])
          + (sevenzboz)*(I3[2] - AC0*I4[2]);
*(vp++) = U0*I0[3]
          - U10*(I1[3] - I2[3])
          - U11*(I1[24] - I2[6])
          - U12*(I1[45] - I2[7])
          + (sevenzboz)*(I3[3] - AC0*I4[3]);
*(vp++) = U0*I0[4]
          - U10*(I1[4] - I2[4])
          - U11*(I1[25] - I2[7])
          - U12*(I1[46] - I2[8])
          + (sevenzboz)*(I3[4] - AC0*I4[4]);
*(vp++) = U0*I0[5]
          - U10*(I1[5] - I2[5])
          - U11*(I1[26] - I2[8])
          - U12*(I1[47] - I2[9])
          + (sevenzboz)*(I3[5] - AC0*I4[5]);
*(vp++) = U0*I0[6]
          - U10*(I1[6] - I2[6])
          - U11*(I1[27] - I2[10])
          - U12*(I1[48] - I2[11])
          + (sevenzboz)*(I3[6] - AC0*I4[6]);
*(vp++) = U0*I0[7]
          - U10*(I1[7] - I2[7])
          - U11*(I1[28] - I2[11])
          - U12*(I1[49] - I2[12])
          + (sevenzboz)*(I3[7] - AC0*I4[7]);
*(vp++) = U0*I0[8]
          - U10*(I1[8] - I2[8])
          - U11*(I1[29] - I2[12])
          - U12*(I1[50] - I2[13])
          + (sevenzboz)*(I3[8] - AC0*I4[8]);
*(vp++) = U0*I0[9]
          - U10*(I1[9] - I2[9])
          - U11*(I1[30] - I2[13])
          - U12*(I1[51] - I2[14])
          + (sevenzboz)*(I3[9] - AC0*I4[9]);
*(vp++) = U0*I0[10]
          - U10*(I1[10] - I2[10])
          - U11*(I1[31] - I2[15])
          - U12*(I1[52] - I2[16])
          + (sevenzboz)*(I3[10] - AC0*I4[10]);
*(vp++) = U0*I0[11]
          - U10*(I1[11] - I2[11])
          - U11*(I1[32] - I2[16])
          - U12*(I1[53] - I2[17])
          + (sevenzboz)*(I3[11] - AC0*I4[11]);
*(vp++) = U0*I0[12]
          - U10*(I1[12] - I2[12])
          - U11*(I1[33] - I2[17])
          - U12*(I1[54] - I2[18])
          + (sevenzboz)*(I3[12] - AC0*I4[12]);
*(vp++) = U0*I0[13]
          - U10*(I1[13] - I2[13])
          - U11*(I1[34] - I2[18])
          - U12*(I1[55] - I2[19])
          + (sevenzboz)*(I3[13] - AC0*I4[13]);
*(vp++) = U0*I0[14]
          - U10*(I1[14] - I2[14])
          - U11*(I1[35] - I2[19])
          - U12*(I1[56] - I2[20])
          + (sevenzboz)*(I3[14] - AC0*I4[14]);
*(vp++) = U0*I0[15]
          - U10*(I1[15] - I2[15])
          - U11*(I1[36] - I2[21])
          - U12*(I1[57] - I2[22])
          + (sevenzboz)*(I3[15] - AC0*I4[15]);
*(vp++) = U0*I0[16]
          - U10*(I1[16] - I2[16])
          - U11*(I1[37] - I2[22])
          - U12*(I1[58] - I2[23])
          + (sevenzboz)*(I3[16] - AC0*I4[16]);
*(vp++) = U0*I0[17]
          - U10*(I1[17] - I2[17])
          - U11*(I1[38] - I2[23])
          - U12*(I1[59] - I2[24])
          + (sevenzboz)*(I3[17] - AC0*I4[17]);
*(vp++) = U0*I0[18]
          - U10*(I1[18] - I2[18])
          - U11*(I1[39] - I2[24])
          - U12*(I1[60] - I2[25])
          + (sevenzboz)*(I3[18] - AC0*I4[18]);
*(vp++) = U0*I0[19]
          - U10*(I1[19] - I2[19])
          - U11*(I1[40] - I2[25])
          - U12*(I1[61] - I2[26])
          + (sevenzboz)*(I3[19] - AC0*I4[19]);
*(vp++) = U0*I0[20]
          - U10*(I1[20] - I2[20])
          - U11*(I1[41] - I2[26])
          - U12*(I1[62] - I2[27])
          + (sevenzboz)*(I3[20] - AC0*I4[20]);
*(vp++) = U0*I0[21]
          - U10*(I1[21] - I2[28])
          - U11*(I1[63] - I2[29])
          - U12*(I1[84] - I2[30])
          + (sixzboz)*(I3[28] - AC0*I4[21])
          + (onezboz)*(I3[1] - AC1*I4[0]);
*(vp++) = U0*I0[22]
          - U10*(I1[22] - I2[29])
          - U11*(I1[64] - I2[31])
          - U12*(I1[85] - I2[32])
          + (sixzboz)*(I3[29] - AC0*I4[22])
          + (onezboz)*(I3[3] - AC1*I4[1]);
*(vp++) = U0*I0[23]
          - U10*(I1[23] - I2[30])
          - U11*(I1[65] - I2[32])
          - U12*(I1[86] - I2[33])
          + (sixzboz)*(I3[30] - AC0*I4[23])
          + (onezboz)*(I3[4] - AC1*I4[2]);
*(vp++) = U0*I0[24]
          - U10*(I1[24] - I2[31])
          - U11*(I1[66] - I2[34])
          - U12*(I1[87] - I2[35])
          + (sixzboz)*(I3[31] - AC0*I4[24])
          + (onezboz)*(I3[6] - AC1*I4[3]);
*(vp++) = U0*I0[25]
          - U10*(I1[25] - I2[32])
          - U11*(I1[67] - I2[35])
          - U12*(I1[88] - I2[36])
          + (sixzboz)*(I3[32] - AC0*I4[25])
          + (onezboz)*(I3[7] - AC1*I4[4]);
*(vp++) = U0*I0[26]
          - U10*(I1[26] - I2[33])
          - U11*(I1[68] - I2[36])
          - U12*(I1[89] - I2[37])
          + (sixzboz)*(I3[33] - AC0*I4[26])
          + (onezboz)*(I3[8] - AC1*I4[5]);
*(vp++) = U0*I0[27]
          - U10*(I1[27] - I2[34])
          - U11*(I1[69] - I2[38])
          - U12*(I1[90] - I2[39])
          + (sixzboz)*(I3[34] - AC0*I4[27])
          + (onezboz)*(I3[10] - AC1*I4[6]);
*(vp++) = U0*I0[28]
          - U10*(I1[28] - I2[35])
          - U11*(I1[70] - I2[39])
          - U12*(I1[91] - I2[40])
          + (sixzboz)*(I3[35] - AC0*I4[28])
          + (onezboz)*(I3[11] - AC1*I4[7]);
*(vp++) = U0*I0[29]
          - U10*(I1[29] - I2[36])
          - U11*(I1[71] - I2[40])
          - U12*(I1[92] - I2[41])
          + (sixzboz)*(I3[36] - AC0*I4[29])
          + (onezboz)*(I3[12] - AC1*I4[8]);
*(vp++) = U0*I0[30]
          - U10*(I1[30] - I2[37])
          - U11*(I1[72] - I2[41])
          - U12*(I1[93] - I2[42])
          + (sixzboz)*(I3[37] - AC0*I4[30])
          + (onezboz)*(I3[13] - AC1*I4[9]);
*(vp++) = U0*I0[31]
          - U10*(I1[31] - I2[38])
          - U11*(I1[73] - I2[43])
          - U12*(I1[94] - I2[44])
          + (sixzboz)*(I3[38] - AC0*I4[31])
          + (onezboz)*(I3[15] - AC1*I4[10]);
*(vp++) = U0*I0[32]
          - U10*(I1[32] - I2[39])
          - U11*(I1[74] - I2[44])
          - U12*(I1[95] - I2[45])
          + (sixzboz)*(I3[39] - AC0*I4[32])
          + (onezboz)*(I3[16] - AC1*I4[11]);
*(vp++) = U0*I0[33]
          - U10*(I1[33] - I2[40])
          - U11*(I1[75] - I2[45])
          - U12*(I1[96] - I2[46])
          + (sixzboz)*(I3[40] - AC0*I4[33])
          + (onezboz)*(I3[17] - AC1*I4[12]);
*(vp++) = U0*I0[34]
          - U10*(I1[34] - I2[41])
          - U11*(I1[76] - I2[46])
          - U12*(I1[97] - I2[47])
          + (sixzboz)*(I3[41] - AC0*I4[34])
          + (onezboz)*(I3[18] - AC1*I4[13]);
*(vp++) = U0*I0[35]
          - U10*(I1[35] - I2[42])
          - U11*(I1[77] - I2[47])
          - U12*(I1[98] - I2[48])
          + (sixzboz)*(I3[42] - AC0*I4[35])
          + (onezboz)*(I3[19] - AC1*I4[14]);
*(vp++) = U0*I0[36]
          - U10*(I1[36] - I2[43])
          - U11*(I1[78] - I2[49])
          - U12*(I1[99] - I2[50])
          + (sixzboz)*(I3[43] - AC0*I4[36])
          + (onezboz)*(I3[21] - AC1*I4[15]);
*(vp++) = U0*I0[37]
          - U10*(I1[37] - I2[44])
          - U11*(I1[79] - I2[50])
          - U12*(I1[100] - I2[51])
          + (sixzboz)*(I3[44] - AC0*I4[37])
          + (onezboz)*(I3[22] - AC1*I4[16]);
*(vp++) = U0*I0[38]
          - U10*(I1[38] - I2[45])
          - U11*(I1[80] - I2[51])
          - U12*(I1[101] - I2[52])
          + (sixzboz)*(I3[45] - AC0*I4[38])
          + (onezboz)*(I3[23] - AC1*I4[17]);
*(vp++) = U0*I0[39]
          - U10*(I1[39] - I2[46])
          - U11*(I1[81] - I2[52])
          - U12*(I1[102] - I2[53])
          + (sixzboz)*(I3[46] - AC0*I4[39])
          + (onezboz)*(I3[24] - AC1*I4[18]);
*(vp++) = U0*I0[40]
          - U10*(I1[40] - I2[47])
          - U11*(I1[82] - I2[53])
          - U12*(I1[103] - I2[54])
          + (sixzboz)*(I3[47] - AC0*I4[40])
          + (onezboz)*(I3[25] - AC1*I4[19]);
*(vp++) = U0*I0[41]
          - U10*(I1[41] - I2[48])
          - U11*(I1[83] - I2[54])
          - U12*(I1[104] - I2[55])
          + (sixzboz)*(I3[48] - AC0*I4[41])
          + (onezboz)*(I3[26] - AC1*I4[20]);
*(vp++) = U0*I0[42]
          - U10*(I1[42] - I2[56])
          - U11*(I1[84] - I2[57])
          - U12*(I1[105] - I2[58])
          + (sixzboz)*(I3[56] - AC0*I4[42])
          + (onezboz)*(I3[2] - AC2*I4[0]);
*(vp++) = U0*I0[43]
          - U10*(I1[43] - I2[57])
          - U11*(I1[85] - I2[59])
          - U12*(I1[106] - I2[60])
          + (sixzboz)*(I3[57] - AC0*I4[43])
          + (onezboz)*(I3[4] - AC2*I4[1]);
*(vp++) = U0*I0[44]
          - U10*(I1[44] - I2[58])
          - U11*(I1[86] - I2[60])
          - U12*(I1[107] - I2[61])
          + (sixzboz)*(I3[58] - AC0*I4[44])
          + (onezboz)*(I3[5] - AC2*I4[2]);
*(vp++) = U0*I0[45]
          - U10*(I1[45] - I2[59])
          - U11*(I1[87] - I2[62])
          - U12*(I1[108] - I2[63])
          + (sixzboz)*(I3[59] - AC0*I4[45])
          + (onezboz)*(I3[7] - AC2*I4[3]);
*(vp++) = U0*I0[46]
          - U10*(I1[46] - I2[60])
          - U11*(I1[88] - I2[63])
          - U12*(I1[109] - I2[64])
          + (sixzboz)*(I3[60] - AC0*I4[46])
          + (onezboz)*(I3[8] - AC2*I4[4]);
*(vp++) = U0*I0[47]
          - U10*(I1[47] - I2[61])
          - U11*(I1[89] - I2[64])
          - U12*(I1[110] - I2[65])
          + (sixzboz)*(I3[61] - AC0*I4[47])
          + (onezboz)*(I3[9] - AC2*I4[5]);
*(vp++) = U0*I0[48]
          - U10*(I1[48] - I2[62])
          - U11*(I1[90] - I2[66])
          - U12*(I1[111] - I2[67])
          + (sixzboz)*(I3[62] - AC0*I4[48])
          + (onezboz)*(I3[11] - AC2*I4[6]);
*(vp++) = U0*I0[49]
          - U10*(I1[49] - I2[63])
          - U11*(I1[91] - I2[67])
          - U12*(I1[112] - I2[68])
          + (sixzboz)*(I3[63] - AC0*I4[49])
          + (onezboz)*(I3[12] - AC2*I4[7]);
*(vp++) = U0*I0[50]
          - U10*(I1[50] - I2[64])
          - U11*(I1[92] - I2[68])
          - U12*(I1[113] - I2[69])
          + (sixzboz)*(I3[64] - AC0*I4[50])
          + (onezboz)*(I3[13] - AC2*I4[8]);
*(vp++) = U0*I0[51]
          - U10*(I1[51] - I2[65])
          - U11*(I1[93] - I2[69])
          - U12*(I1[114] - I2[70])
          + (sixzboz)*(I3[65] - AC0*I4[51])
          + (onezboz)*(I3[14] - AC2*I4[9]);
*(vp++) = U0*I0[52]
          - U10*(I1[52] - I2[66])
          - U11*(I1[94] - I2[71])
          - U12*(I1[115] - I2[72])
          + (sixzboz)*(I3[66] - AC0*I4[52])
          + (onezboz)*(I3[16] - AC2*I4[10]);
*(vp++) = U0*I0[53]
          - U10*(I1[53] - I2[67])
          - U11*(I1[95] - I2[72])
          - U12*(I1[116] - I2[73])
          + (sixzboz)*(I3[67] - AC0*I4[53])
          + (onezboz)*(I3[17] - AC2*I4[11]);
*(vp++) = U0*I0[54]
          - U10*(I1[54] - I2[68])
          - U11*(I1[96] - I2[73])
          - U12*(I1[117] - I2[74])
          + (sixzboz)*(I3[68] - AC0*I4[54])
          + (onezboz)*(I3[18] - AC2*I4[12]);
*(vp++) = U0*I0[55]
          - U10*(I1[55] - I2[69])
          - U11*(I1[97] - I2[74])
          - U12*(I1[118] - I2[75])
          + (sixzboz)*(I3[69] - AC0*I4[55])
          + (onezboz)*(I3[19] - AC2*I4[13]);
*(vp++) = U0*I0[56]
          - U10*(I1[56] - I2[70])
          - U11*(I1[98] - I2[75])
          - U12*(I1[119] - I2[76])
          + (sixzboz)*(I3[70] - AC0*I4[56])
          + (onezboz)*(I3[20] - AC2*I4[14]);
*(vp++) = U0*I0[57]
          - U10*(I1[57] - I2[71])
          - U11*(I1[99] - I2[77])
          - U12*(I1[120] - I2[78])
          + (sixzboz)*(I3[71] - AC0*I4[57])
          + (onezboz)*(I3[22] - AC2*I4[15]);
*(vp++) = U0*I0[58]
          - U10*(I1[58] - I2[72])
          - U11*(I1[100] - I2[78])
          - U12*(I1[121] - I2[79])
          + (sixzboz)*(I3[72] - AC0*I4[58])
          + (onezboz)*(I3[23] - AC2*I4[16]);
*(vp++) = U0*I0[59]
          - U10*(I1[59] - I2[73])
          - U11*(I1[101] - I2[79])
          - U12*(I1[122] - I2[80])
          + (sixzboz)*(I3[73] - AC0*I4[59])
          + (onezboz)*(I3[24] - AC2*I4[17]);
*(vp++) = U0*I0[60]
          - U10*(I1[60] - I2[74])
          - U11*(I1[102] - I2[80])
          - U12*(I1[123] - I2[81])
          + (sixzboz)*(I3[74] - AC0*I4[60])
          + (onezboz)*(I3[25] - AC2*I4[18]);
*(vp++) = U0*I0[61]
          - U10*(I1[61] - I2[75])
          - U11*(I1[103] - I2[81])
          - U12*(I1[124] - I2[82])
          + (sixzboz)*(I3[75] - AC0*I4[61])
          + (onezboz)*(I3[26] - AC2*I4[19]);
*(vp++) = U0*I0[62]
          - U10*(I1[62] - I2[76])
          - U11*(I1[104] - I2[82])
          - U12*(I1[125] - I2[83])
          + (sixzboz)*(I3[76] - AC0*I4[62])
          + (onezboz)*(I3[27] - AC2*I4[20]);
*(vp++) = U0*I0[63]
          - U10*(I1[63] - I2[84])
          - U11*(I1[126] - I2[85])
          - U12*(I1[147] - I2[86])
          + (fivezboz)*(I3[84] - AC0*I4[63])
          + (twozboz)*(I3[29] - AC1*I4[21]);
*(vp++) = U0*I0[64]
          - U10*(I1[64] - I2[85])
          - U11*(I1[127] - I2[87])
          - U12*(I1[148] - I2[88])
          + (fivezboz)*(I3[85] - AC0*I4[64])
          + (twozboz)*(I3[31] - AC1*I4[22]);
*(vp++) = U0*I0[65]
          - U10*(I1[65] - I2[86])
          - U11*(I1[128] - I2[88])
          - U12*(I1[149] - I2[89])
          + (fivezboz)*(I3[86] - AC0*I4[65])
          + (twozboz)*(I3[32] - AC1*I4[23]);
*(vp++) = U0*I0[66]
          - U10*(I1[66] - I2[87])
          - U11*(I1[129] - I2[90])
          - U12*(I1[150] - I2[91])
          + (fivezboz)*(I3[87] - AC0*I4[66])
          + (twozboz)*(I3[34] - AC1*I4[24]);
*(vp++) = U0*I0[67]
          - U10*(I1[67] - I2[88])
          - U11*(I1[130] - I2[91])
          - U12*(I1[151] - I2[92])
          + (fivezboz)*(I3[88] - AC0*I4[67])
          + (twozboz)*(I3[35] - AC1*I4[25]);
*(vp++) = U0*I0[68]
          - U10*(I1[68] - I2[89])
          - U11*(I1[131] - I2[92])
          - U12*(I1[152] - I2[93])
          + (fivezboz)*(I3[89] - AC0*I4[68])
          + (twozboz)*(I3[36] - AC1*I4[26]);
*(vp++) = U0*I0[69]
          - U10*(I1[69] - I2[90])
          - U11*(I1[132] - I2[94])
          - U12*(I1[153] - I2[95])
          + (fivezboz)*(I3[90] - AC0*I4[69])
          + (twozboz)*(I3[38] - AC1*I4[27]);
*(vp++) = U0*I0[70]
          - U10*(I1[70] - I2[91])
          - U11*(I1[133] - I2[95])
          - U12*(I1[154] - I2[96])
          + (fivezboz)*(I3[91] - AC0*I4[70])
          + (twozboz)*(I3[39] - AC1*I4[28]);
*(vp++) = U0*I0[71]
          - U10*(I1[71] - I2[92])
          - U11*(I1[134] - I2[96])
          - U12*(I1[155] - I2[97])
          + (fivezboz)*(I3[92] - AC0*I4[71])
          + (twozboz)*(I3[40] - AC1*I4[29]);
*(vp++) = U0*I0[72]
          - U10*(I1[72] - I2[93])
          - U11*(I1[135] - I2[97])
          - U12*(I1[156] - I2[98])
          + (fivezboz)*(I3[93] - AC0*I4[72])
          + (twozboz)*(I3[41] - AC1*I4[30]);
*(vp++) = U0*I0[73]
          - U10*(I1[73] - I2[94])
          - U11*(I1[136] - I2[99])
          - U12*(I1[157] - I2[100])
          + (fivezboz)*(I3[94] - AC0*I4[73])
          + (twozboz)*(I3[43] - AC1*I4[31]);
*(vp++) = U0*I0[74]
          - U10*(I1[74] - I2[95])
          - U11*(I1[137] - I2[100])
          - U12*(I1[158] - I2[101])
          + (fivezboz)*(I3[95] - AC0*I4[74])
          + (twozboz)*(I3[44] - AC1*I4[32]);
*(vp++) = U0*I0[75]
          - U10*(I1[75] - I2[96])
          - U11*(I1[138] - I2[101])
          - U12*(I1[159] - I2[102])
          + (fivezboz)*(I3[96] - AC0*I4[75])
          + (twozboz)*(I3[45] - AC1*I4[33]);
*(vp++) = U0*I0[76]
          - U10*(I1[76] - I2[97])
          - U11*(I1[139] - I2[102])
          - U12*(I1[160] - I2[103])
          + (fivezboz)*(I3[97] - AC0*I4[76])
          + (twozboz)*(I3[46] - AC1*I4[34]);
*(vp++) = U0*I0[77]
          - U10*(I1[77] - I2[98])
          - U11*(I1[140] - I2[103])
          - U12*(I1[161] - I2[104])
          + (fivezboz)*(I3[98] - AC0*I4[77])
          + (twozboz)*(I3[47] - AC1*I4[35]);
*(vp++) = U0*I0[78]
          - U10*(I1[78] - I2[99])
          - U11*(I1[141] - I2[105])
          - U12*(I1[162] - I2[106])
          + (fivezboz)*(I3[99] - AC0*I4[78])
          + (twozboz)*(I3[49] - AC1*I4[36]);
*(vp++) = U0*I0[79]
          - U10*(I1[79] - I2[100])
          - U11*(I1[142] - I2[106])
          - U12*(I1[163] - I2[107])
          + (fivezboz)*(I3[100] - AC0*I4[79])
          + (twozboz)*(I3[50] - AC1*I4[37]);
*(vp++) = U0*I0[80]
          - U10*(I1[80] - I2[101])
          - U11*(I1[143] - I2[107])
          - U12*(I1[164] - I2[108])
          + (fivezboz)*(I3[101] - AC0*I4[80])
          + (twozboz)*(I3[51] - AC1*I4[38]);
*(vp++) = U0*I0[81]
          - U10*(I1[81] - I2[102])
          - U11*(I1[144] - I2[108])
          - U12*(I1[165] - I2[109])
          + (fivezboz)*(I3[102] - AC0*I4[81])
          + (twozboz)*(I3[52] - AC1*I4[39]);
*(vp++) = U0*I0[82]
          - U10*(I1[82] - I2[103])
          - U11*(I1[145] - I2[109])
          - U12*(I1[166] - I2[110])
          + (fivezboz)*(I3[103] - AC0*I4[82])
          + (twozboz)*(I3[53] - AC1*I4[40]);
*(vp++) = U0*I0[83]
          - U10*(I1[83] - I2[104])
          - U11*(I1[146] - I2[110])
          - U12*(I1[167] - I2[111])
          + (fivezboz)*(I3[104] - AC0*I4[83])
          + (twozboz)*(I3[54] - AC1*I4[41]);
*(vp++) = U0*I0[84]
          - U10*(I1[84] - I2[112])
          - U11*(I1[147] - I2[113])
          - U12*(I1[168] - I2[114])
          + (fivezboz)*(I3[112] - AC0*I4[84])
          + (onezboz)*(I3[57] - AC1*I4[42])
          + (onezboz)*(I3[30] - AC2*I4[21]);
*(vp++) = U0*I0[85]
          - U10*(I1[85] - I2[113])
          - U11*(I1[148] - I2[115])
          - U12*(I1[169] - I2[116])
          + (fivezboz)*(I3[113] - AC0*I4[85])
          + (onezboz)*(I3[59] - AC1*I4[43])
          + (onezboz)*(I3[32] - AC2*I4[22]);
*(vp++) = U0*I0[86]
          - U10*(I1[86] - I2[114])
          - U11*(I1[149] - I2[116])
          - U12*(I1[170] - I2[117])
          + (fivezboz)*(I3[114] - AC0*I4[86])
          + (onezboz)*(I3[60] - AC1*I4[44])
          + (onezboz)*(I3[33] - AC2*I4[23]);
*(vp++) = U0*I0[87]
          - U10*(I1[87] - I2[115])
          - U11*(I1[150] - I2[118])
          - U12*(I1[171] - I2[119])
          + (fivezboz)*(I3[115] - AC0*I4[87])
          + (onezboz)*(I3[62] - AC1*I4[45])
          + (onezboz)*(I3[35] - AC2*I4[24]);
*(vp++) = U0*I0[88]
          - U10*(I1[88] - I2[116])
          - U11*(I1[151] - I2[119])
          - U12*(I1[172] - I2[120])
          + (fivezboz)*(I3[116] - AC0*I4[88])
          + (onezboz)*(I3[63] - AC1*I4[46])
          + (onezboz)*(I3[36] - AC2*I4[25]);
*(vp++) = U0*I0[89]
          - U10*(I1[89] - I2[117])
          - U11*(I1[152] - I2[120])
          - U12*(I1[173] - I2[121])
          + (fivezboz)*(I3[117] - AC0*I4[89])
          + (onezboz)*(I3[64] - AC1*I4[47])
          + (onezboz)*(I3[37] - AC2*I4[26]);
*(vp++) = U0*I0[90]
          - U10*(I1[90] - I2[118])
          - U11*(I1[153] - I2[122])
          - U12*(I1[174] - I2[123])
          + (fivezboz)*(I3[118] - AC0*I4[90])
          + (onezboz)*(I3[66] - AC1*I4[48])
          + (onezboz)*(I3[39] - AC2*I4[27]);
*(vp++) = U0*I0[91]
          - U10*(I1[91] - I2[119])
          - U11*(I1[154] - I2[123])
          - U12*(I1[175] - I2[124])
          + (fivezboz)*(I3[119] - AC0*I4[91])
          + (onezboz)*(I3[67] - AC1*I4[49])
          + (onezboz)*(I3[40] - AC2*I4[28]);
*(vp++) = U0*I0[92]
          - U10*(I1[92] - I2[120])
          - U11*(I1[155] - I2[124])
          - U12*(I1[176] - I2[125])
          + (fivezboz)*(I3[120] - AC0*I4[92])
          + (onezboz)*(I3[68] - AC1*I4[50])
          + (onezboz)*(I3[41] - AC2*I4[29]);
*(vp++) = U0*I0[93]
          - U10*(I1[93] - I2[121])
          - U11*(I1[156] - I2[125])
          - U12*(I1[177] - I2[126])
          + (fivezboz)*(I3[121] - AC0*I4[93])
          + (onezboz)*(I3[69] - AC1*I4[51])
          + (onezboz)*(I3[42] - AC2*I4[30]);
*(vp++) = U0*I0[94]
          - U10*(I1[94] - I2[122])
          - U11*(I1[157] - I2[127])
          - U12*(I1[178] - I2[128])
          + (fivezboz)*(I3[122] - AC0*I4[94])
          + (onezboz)*(I3[71] - AC1*I4[52])
          + (onezboz)*(I3[44] - AC2*I4[31]);
*(vp++) = U0*I0[95]
          - U10*(I1[95] - I2[123])
          - U11*(I1[158] - I2[128])
          - U12*(I1[179] - I2[129])
          + (fivezboz)*(I3[123] - AC0*I4[95])
          + (onezboz)*(I3[72] - AC1*I4[53])
          + (onezboz)*(I3[45] - AC2*I4[32]);
*(vp++) = U0*I0[96]
          - U10*(I1[96] - I2[124])
          - U11*(I1[159] - I2[129])
          - U12*(I1[180] - I2[130])
          + (fivezboz)*(I3[124] - AC0*I4[96])
          + (onezboz)*(I3[73] - AC1*I4[54])
          + (onezboz)*(I3[46] - AC2*I4[33]);
*(vp++) = U0*I0[97]
          - U10*(I1[97] - I2[125])
          - U11*(I1[160] - I2[130])
          - U12*(I1[181] - I2[131])
          + (fivezboz)*(I3[125] - AC0*I4[97])
          + (onezboz)*(I3[74] - AC1*I4[55])
          + (onezboz)*(I3[47] - AC2*I4[34]);
*(vp++) = U0*I0[98]
          - U10*(I1[98] - I2[126])
          - U11*(I1[161] - I2[131])
          - U12*(I1[182] - I2[132])
          + (fivezboz)*(I3[126] - AC0*I4[98])
          + (onezboz)*(I3[75] - AC1*I4[56])
          + (onezboz)*(I3[48] - AC2*I4[35]);
*(vp++) = U0*I0[99]
          - U10*(I1[99] - I2[127])
          - U11*(I1[162] - I2[133])
          - U12*(I1[183] - I2[134])
          + (fivezboz)*(I3[127] - AC0*I4[99])
          + (onezboz)*(I3[77] - AC1*I4[57])
          + (onezboz)*(I3[50] - AC2*I4[36]);
*(vp++) = U0*I0[100]
          - U10*(I1[100] - I2[128])
          - U11*(I1[163] - I2[134])
          - U12*(I1[184] - I2[135])
          + (fivezboz)*(I3[128] - AC0*I4[100])
          + (onezboz)*(I3[78] - AC1*I4[58])
          + (onezboz)*(I3[51] - AC2*I4[37]);
*(vp++) = U0*I0[101]
          - U10*(I1[101] - I2[129])
          - U11*(I1[164] - I2[135])
          - U12*(I1[185] - I2[136])
          + (fivezboz)*(I3[129] - AC0*I4[101])
          + (onezboz)*(I3[79] - AC1*I4[59])
          + (onezboz)*(I3[52] - AC2*I4[38]);
*(vp++) = U0*I0[102]
          - U10*(I1[102] - I2[130])
          - U11*(I1[165] - I2[136])
          - U12*(I1[186] - I2[137])
          + (fivezboz)*(I3[130] - AC0*I4[102])
          + (onezboz)*(I3[80] - AC1*I4[60])
          + (onezboz)*(I3[53] - AC2*I4[39]);
*(vp++) = U0*I0[103]
          - U10*(I1[103] - I2[131])
          - U11*(I1[166] - I2[137])
          - U12*(I1[187] - I2[138])
          + (fivezboz)*(I3[131] - AC0*I4[103])
          + (onezboz)*(I3[81] - AC1*I4[61])
          + (onezboz)*(I3[54] - AC2*I4[40]);
*(vp++) = U0*I0[104]
          - U10*(I1[104] - I2[132])
          - U11*(I1[167] - I2[138])
          - U12*(I1[188] - I2[139])
          + (fivezboz)*(I3[132] - AC0*I4[104])
          + (onezboz)*(I3[82] - AC1*I4[62])
          + (onezboz)*(I3[55] - AC2*I4[41]);
*(vp++) = U0*I0[105]
          - U10*(I1[105] - I2[140])
          - U11*(I1[168] - I2[141])
          - U12*(I1[189] - I2[142])
          + (fivezboz)*(I3[140] - AC0*I4[105])
          + (twozboz)*(I3[58] - AC2*I4[42]);
*(vp++) = U0*I0[106]
          - U10*(I1[106] - I2[141])
          - U11*(I1[169] - I2[143])
          - U12*(I1[190] - I2[144])
          + (fivezboz)*(I3[141] - AC0*I4[106])
          + (twozboz)*(I3[60] - AC2*I4[43]);
*(vp++) = U0*I0[107]
          - U10*(I1[107] - I2[142])
          - U11*(I1[170] - I2[144])
          - U12*(I1[191] - I2[145])
          + (fivezboz)*(I3[142] - AC0*I4[107])
          + (twozboz)*(I3[61] - AC2*I4[44]);
*(vp++) = U0*I0[108]
          - U10*(I1[108] - I2[143])
          - U11*(I1[171] - I2[146])
          - U12*(I1[192] - I2[147])
          + (fivezboz)*(I3[143] - AC0*I4[108])
          + (twozboz)*(I3[63] - AC2*I4[45]);
*(vp++) = U0*I0[109]
          - U10*(I1[109] - I2[144])
          - U11*(I1[172] - I2[147])
          - U12*(I1[193] - I2[148])
          + (fivezboz)*(I3[144] - AC0*I4[109])
          + (twozboz)*(I3[64] - AC2*I4[46]);
*(vp++) = U0*I0[110]
          - U10*(I1[110] - I2[145])
          - U11*(I1[173] - I2[148])
          - U12*(I1[194] - I2[149])
          + (fivezboz)*(I3[145] - AC0*I4[110])
          + (twozboz)*(I3[65] - AC2*I4[47]);
*(vp++) = U0*I0[111]
          - U10*(I1[111] - I2[146])
          - U11*(I1[174] - I2[150])
          - U12*(I1[195] - I2[151])
          + (fivezboz)*(I3[146] - AC0*I4[111])
          + (twozboz)*(I3[67] - AC2*I4[48]);
*(vp++) = U0*I0[112]
          - U10*(I1[112] - I2[147])
          - U11*(I1[175] - I2[151])
          - U12*(I1[196] - I2[152])
          + (fivezboz)*(I3[147] - AC0*I4[112])
          + (twozboz)*(I3[68] - AC2*I4[49]);
*(vp++) = U0*I0[113]
          - U10*(I1[113] - I2[148])
          - U11*(I1[176] - I2[152])
          - U12*(I1[197] - I2[153])
          + (fivezboz)*(I3[148] - AC0*I4[113])
          + (twozboz)*(I3[69] - AC2*I4[50]);
*(vp++) = U0*I0[114]
          - U10*(I1[114] - I2[149])
          - U11*(I1[177] - I2[153])
          - U12*(I1[198] - I2[154])
          + (fivezboz)*(I3[149] - AC0*I4[114])
          + (twozboz)*(I3[70] - AC2*I4[51]);
*(vp++) = U0*I0[115]
          - U10*(I1[115] - I2[150])
          - U11*(I1[178] - I2[155])
          - U12*(I1[199] - I2[156])
          + (fivezboz)*(I3[150] - AC0*I4[115])
          + (twozboz)*(I3[72] - AC2*I4[52]);
*(vp++) = U0*I0[116]
          - U10*(I1[116] - I2[151])
          - U11*(I1[179] - I2[156])
          - U12*(I1[200] - I2[157])
          + (fivezboz)*(I3[151] - AC0*I4[116])
          + (twozboz)*(I3[73] - AC2*I4[53]);
*(vp++) = U0*I0[117]
          - U10*(I1[117] - I2[152])
          - U11*(I1[180] - I2[157])
          - U12*(I1[201] - I2[158])
          + (fivezboz)*(I3[152] - AC0*I4[117])
          + (twozboz)*(I3[74] - AC2*I4[54]);
*(vp++) = U0*I0[118]
          - U10*(I1[118] - I2[153])
          - U11*(I1[181] - I2[158])
          - U12*(I1[202] - I2[159])
          + (fivezboz)*(I3[153] - AC0*I4[118])
          + (twozboz)*(I3[75] - AC2*I4[55]);
*(vp++) = U0*I0[119]
          - U10*(I1[119] - I2[154])
          - U11*(I1[182] - I2[159])
          - U12*(I1[203] - I2[160])
          + (fivezboz)*(I3[154] - AC0*I4[119])
          + (twozboz)*(I3[76] - AC2*I4[56]);
*(vp++) = U0*I0[120]
          - U10*(I1[120] - I2[155])
          - U11*(I1[183] - I2[161])
          - U12*(I1[204] - I2[162])
          + (fivezboz)*(I3[155] - AC0*I4[120])
          + (twozboz)*(I3[78] - AC2*I4[57]);
*(vp++) = U0*I0[121]
          - U10*(I1[121] - I2[156])
          - U11*(I1[184] - I2[162])
          - U12*(I1[205] - I2[163])
          + (fivezboz)*(I3[156] - AC0*I4[121])
          + (twozboz)*(I3[79] - AC2*I4[58]);
*(vp++) = U0*I0[122]
          - U10*(I1[122] - I2[157])
          - U11*(I1[185] - I2[163])
          - U12*(I1[206] - I2[164])
          + (fivezboz)*(I3[157] - AC0*I4[122])
          + (twozboz)*(I3[80] - AC2*I4[59]);
*(vp++) = U0*I0[123]
          - U10*(I1[123] - I2[158])
          - U11*(I1[186] - I2[164])
          - U12*(I1[207] - I2[165])
          + (fivezboz)*(I3[158] - AC0*I4[123])
          + (twozboz)*(I3[81] - AC2*I4[60]);
*(vp++) = U0*I0[124]
          - U10*(I1[124] - I2[159])
          - U11*(I1[187] - I2[165])
          - U12*(I1[208] - I2[166])
          + (fivezboz)*(I3[159] - AC0*I4[124])
          + (twozboz)*(I3[82] - AC2*I4[61]);
*(vp++) = U0*I0[125]
          - U10*(I1[125] - I2[160])
          - U11*(I1[188] - I2[166])
          - U12*(I1[209] - I2[167])
          + (fivezboz)*(I3[160] - AC0*I4[125])
          + (twozboz)*(I3[83] - AC2*I4[62]);
*(vp++) = U0*I0[126]
          - U10*(I1[126] - I2[168])
          - U11*(I1[210] - I2[169])
          - U12*(I1[231] - I2[170])
          + (fourzboz)*(I3[168] - AC0*I4[126])
          + (threezboz)*(I3[85] - AC1*I4[63]);
*(vp++) = U0*I0[127]
          - U10*(I1[127] - I2[169])
          - U11*(I1[211] - I2[171])
          - U12*(I1[232] - I2[172])
          + (fourzboz)*(I3[169] - AC0*I4[127])
          + (threezboz)*(I3[87] - AC1*I4[64]);
*(vp++) = U0*I0[128]
          - U10*(I1[128] - I2[170])
          - U11*(I1[212] - I2[172])
          - U12*(I1[233] - I2[173])
          + (fourzboz)*(I3[170] - AC0*I4[128])
          + (threezboz)*(I3[88] - AC1*I4[65]);
*(vp++) = U0*I0[129]
          - U10*(I1[129] - I2[171])
          - U11*(I1[213] - I2[174])
          - U12*(I1[234] - I2[175])
          + (fourzboz)*(I3[171] - AC0*I4[129])
          + (threezboz)*(I3[90] - AC1*I4[66]);
*(vp++) = U0*I0[130]
          - U10*(I1[130] - I2[172])
          - U11*(I1[214] - I2[175])
          - U12*(I1[235] - I2[176])
          + (fourzboz)*(I3[172] - AC0*I4[130])
          + (threezboz)*(I3[91] - AC1*I4[67]);
*(vp++) = U0*I0[131]
          - U10*(I1[131] - I2[173])
          - U11*(I1[215] - I2[176])
          - U12*(I1[236] - I2[177])
          + (fourzboz)*(I3[173] - AC0*I4[131])
          + (threezboz)*(I3[92] - AC1*I4[68]);
*(vp++) = U0*I0[132]
          - U10*(I1[132] - I2[174])
          - U11*(I1[216] - I2[178])
          - U12*(I1[237] - I2[179])
          + (fourzboz)*(I3[174] - AC0*I4[132])
          + (threezboz)*(I3[94] - AC1*I4[69]);
*(vp++) = U0*I0[133]
          - U10*(I1[133] - I2[175])
          - U11*(I1[217] - I2[179])
          - U12*(I1[238] - I2[180])
          + (fourzboz)*(I3[175] - AC0*I4[133])
          + (threezboz)*(I3[95] - AC1*I4[70]);
*(vp++) = U0*I0[134]
          - U10*(I1[134] - I2[176])
          - U11*(I1[218] - I2[180])
          - U12*(I1[239] - I2[181])
          + (fourzboz)*(I3[176] - AC0*I4[134])
          + (threezboz)*(I3[96] - AC1*I4[71]);
*(vp++) = U0*I0[135]
          - U10*(I1[135] - I2[177])
          - U11*(I1[219] - I2[181])
          - U12*(I1[240] - I2[182])
          + (fourzboz)*(I3[177] - AC0*I4[135])
          + (threezboz)*(I3[97] - AC1*I4[72]);
*(vp++) = U0*I0[136]
          - U10*(I1[136] - I2[178])
          - U11*(I1[220] - I2[183])
          - U12*(I1[241] - I2[184])
          + (fourzboz)*(I3[178] - AC0*I4[136])
          + (threezboz)*(I3[99] - AC1*I4[73]);
*(vp++) = U0*I0[137]
          - U10*(I1[137] - I2[179])
          - U11*(I1[221] - I2[184])
          - U12*(I1[242] - I2[185])
          + (fourzboz)*(I3[179] - AC0*I4[137])
          + (threezboz)*(I3[100] - AC1*I4[74]);
*(vp++) = U0*I0[138]
          - U10*(I1[138] - I2[180])
          - U11*(I1[222] - I2[185])
          - U12*(I1[243] - I2[186])
          + (fourzboz)*(I3[180] - AC0*I4[138])
          + (threezboz)*(I3[101] - AC1*I4[75]);
*(vp++) = U0*I0[139]
          - U10*(I1[139] - I2[181])
          - U11*(I1[223] - I2[186])
          - U12*(I1[244] - I2[187])
          + (fourzboz)*(I3[181] - AC0*I4[139])
          + (threezboz)*(I3[102] - AC1*I4[76]);
*(vp++) = U0*I0[140]
          - U10*(I1[140] - I2[182])
          - U11*(I1[224] - I2[187])
          - U12*(I1[245] - I2[188])
          + (fourzboz)*(I3[182] - AC0*I4[140])
          + (threezboz)*(I3[103] - AC1*I4[77]);
*(vp++) = U0*I0[141]
          - U10*(I1[141] - I2[183])
          - U11*(I1[225] - I2[189])
          - U12*(I1[246] - I2[190])
          + (fourzboz)*(I3[183] - AC0*I4[141])
          + (threezboz)*(I3[105] - AC1*I4[78]);
*(vp++) = U0*I0[142]
          - U10*(I1[142] - I2[184])
          - U11*(I1[226] - I2[190])
          - U12*(I1[247] - I2[191])
          + (fourzboz)*(I3[184] - AC0*I4[142])
          + (threezboz)*(I3[106] - AC1*I4[79]);
*(vp++) = U0*I0[143]
          - U10*(I1[143] - I2[185])
          - U11*(I1[227] - I2[191])
          - U12*(I1[248] - I2[192])
          + (fourzboz)*(I3[185] - AC0*I4[143])
          + (threezboz)*(I3[107] - AC1*I4[80]);
*(vp++) = U0*I0[144]
          - U10*(I1[144] - I2[186])
          - U11*(I1[228] - I2[192])
          - U12*(I1[249] - I2[193])
          + (fourzboz)*(I3[186] - AC0*I4[144])
          + (threezboz)*(I3[108] - AC1*I4[81]);
*(vp++) = U0*I0[145]
          - U10*(I1[145] - I2[187])
          - U11*(I1[229] - I2[193])
          - U12*(I1[250] - I2[194])
          + (fourzboz)*(I3[187] - AC0*I4[145])
          + (threezboz)*(I3[109] - AC1*I4[82]);
*(vp++) = U0*I0[146]
          - U10*(I1[146] - I2[188])
          - U11*(I1[230] - I2[194])
          - U12*(I1[251] - I2[195])
          + (fourzboz)*(I3[188] - AC0*I4[146])
          + (threezboz)*(I3[110] - AC1*I4[83]);
*(vp++) = U0*I0[147]
          - U10*(I1[147] - I2[196])
          - U11*(I1[231] - I2[197])
          - U12*(I1[252] - I2[198])
          + (fourzboz)*(I3[196] - AC0*I4[147])
          + (twozboz)*(I3[113] - AC1*I4[84])
          + (onezboz)*(I3[86] - AC2*I4[63]);
*(vp++) = U0*I0[148]
          - U10*(I1[148] - I2[197])
          - U11*(I1[232] - I2[199])
          - U12*(I1[253] - I2[200])
          + (fourzboz)*(I3[197] - AC0*I4[148])
          + (twozboz)*(I3[115] - AC1*I4[85])
          + (onezboz)*(I3[88] - AC2*I4[64]);
*(vp++) = U0*I0[149]
          - U10*(I1[149] - I2[198])
          - U11*(I1[233] - I2[200])
          - U12*(I1[254] - I2[201])
          + (fourzboz)*(I3[198] - AC0*I4[149])
          + (twozboz)*(I3[116] - AC1*I4[86])
          + (onezboz)*(I3[89] - AC2*I4[65]);
*(vp++) = U0*I0[150]
          - U10*(I1[150] - I2[199])
          - U11*(I1[234] - I2[202])
          - U12*(I1[255] - I2[203])
          + (fourzboz)*(I3[199] - AC0*I4[150])
          + (twozboz)*(I3[118] - AC1*I4[87])
          + (onezboz)*(I3[91] - AC2*I4[66]);
*(vp++) = U0*I0[151]
          - U10*(I1[151] - I2[200])
          - U11*(I1[235] - I2[203])
          - U12*(I1[256] - I2[204])
          + (fourzboz)*(I3[200] - AC0*I4[151])
          + (twozboz)*(I3[119] - AC1*I4[88])
          + (onezboz)*(I3[92] - AC2*I4[67]);
*(vp++) = U0*I0[152]
          - U10*(I1[152] - I2[201])
          - U11*(I1[236] - I2[204])
          - U12*(I1[257] - I2[205])
          + (fourzboz)*(I3[201] - AC0*I4[152])
          + (twozboz)*(I3[120] - AC1*I4[89])
          + (onezboz)*(I3[93] - AC2*I4[68]);
*(vp++) = U0*I0[153]
          - U10*(I1[153] - I2[202])
          - U11*(I1[237] - I2[206])
          - U12*(I1[258] - I2[207])
          + (fourzboz)*(I3[202] - AC0*I4[153])
          + (twozboz)*(I3[122] - AC1*I4[90])
          + (onezboz)*(I3[95] - AC2*I4[69]);
*(vp++) = U0*I0[154]
          - U10*(I1[154] - I2[203])
          - U11*(I1[238] - I2[207])
          - U12*(I1[259] - I2[208])
          + (fourzboz)*(I3[203] - AC0*I4[154])
          + (twozboz)*(I3[123] - AC1*I4[91])
          + (onezboz)*(I3[96] - AC2*I4[70]);
*(vp++) = U0*I0[155]
          - U10*(I1[155] - I2[204])
          - U11*(I1[239] - I2[208])
          - U12*(I1[260] - I2[209])
          + (fourzboz)*(I3[204] - AC0*I4[155])
          + (twozboz)*(I3[124] - AC1*I4[92])
          + (onezboz)*(I3[97] - AC2*I4[71]);
*(vp++) = U0*I0[156]
          - U10*(I1[156] - I2[205])
          - U11*(I1[240] - I2[209])
          - U12*(I1[261] - I2[210])
          + (fourzboz)*(I3[205] - AC0*I4[156])
          + (twozboz)*(I3[125] - AC1*I4[93])
          + (onezboz)*(I3[98] - AC2*I4[72]);
*(vp++) = U0*I0[157]
          - U10*(I1[157] - I2[206])
          - U11*(I1[241] - I2[211])
          - U12*(I1[262] - I2[212])
          + (fourzboz)*(I3[206] - AC0*I4[157])
          + (twozboz)*(I3[127] - AC1*I4[94])
          + (onezboz)*(I3[100] - AC2*I4[73]);
*(vp++) = U0*I0[158]
          - U10*(I1[158] - I2[207])
          - U11*(I1[242] - I2[212])
          - U12*(I1[263] - I2[213])
          + (fourzboz)*(I3[207] - AC0*I4[158])
          + (twozboz)*(I3[128] - AC1*I4[95])
          + (onezboz)*(I3[101] - AC2*I4[74]);
*(vp++) = U0*I0[159]
          - U10*(I1[159] - I2[208])
          - U11*(I1[243] - I2[213])
          - U12*(I1[264] - I2[214])
          + (fourzboz)*(I3[208] - AC0*I4[159])
          + (twozboz)*(I3[129] - AC1*I4[96])
          + (onezboz)*(I3[102] - AC2*I4[75]);
*(vp++) = U0*I0[160]
          - U10*(I1[160] - I2[209])
          - U11*(I1[244] - I2[214])
          - U12*(I1[265] - I2[215])
          + (fourzboz)*(I3[209] - AC0*I4[160])
          + (twozboz)*(I3[130] - AC1*I4[97])
          + (onezboz)*(I3[103] - AC2*I4[76]);
*(vp++) = U0*I0[161]
          - U10*(I1[161] - I2[210])
          - U11*(I1[245] - I2[215])
          - U12*(I1[266] - I2[216])
          + (fourzboz)*(I3[210] - AC0*I4[161])
          + (twozboz)*(I3[131] - AC1*I4[98])
          + (onezboz)*(I3[104] - AC2*I4[77]);
*(vp++) = U0*I0[162]
          - U10*(I1[162] - I2[211])
          - U11*(I1[246] - I2[217])
          - U12*(I1[267] - I2[218])
          + (fourzboz)*(I3[211] - AC0*I4[162])
          + (twozboz)*(I3[133] - AC1*I4[99])
          + (onezboz)*(I3[106] - AC2*I4[78]);
*(vp++) = U0*I0[163]
          - U10*(I1[163] - I2[212])
          - U11*(I1[247] - I2[218])
          - U12*(I1[268] - I2[219])
          + (fourzboz)*(I3[212] - AC0*I4[163])
          + (twozboz)*(I3[134] - AC1*I4[100])
          + (onezboz)*(I3[107] - AC2*I4[79]);
*(vp++) = U0*I0[164]
          - U10*(I1[164] - I2[213])
          - U11*(I1[248] - I2[219])
          - U12*(I1[269] - I2[220])
          + (fourzboz)*(I3[213] - AC0*I4[164])
          + (twozboz)*(I3[135] - AC1*I4[101])
          + (onezboz)*(I3[108] - AC2*I4[80]);
*(vp++) = U0*I0[165]
          - U10*(I1[165] - I2[214])
          - U11*(I1[249] - I2[220])
          - U12*(I1[270] - I2[221])
          + (fourzboz)*(I3[214] - AC0*I4[165])
          + (twozboz)*(I3[136] - AC1*I4[102])
          + (onezboz)*(I3[109] - AC2*I4[81]);
*(vp++) = U0*I0[166]
          - U10*(I1[166] - I2[215])
          - U11*(I1[250] - I2[221])
          - U12*(I1[271] - I2[222])
          + (fourzboz)*(I3[215] - AC0*I4[166])
          + (twozboz)*(I3[137] - AC1*I4[103])
          + (onezboz)*(I3[110] - AC2*I4[82]);
*(vp++) = U0*I0[167]
          - U10*(I1[167] - I2[216])
          - U11*(I1[251] - I2[222])
          - U12*(I1[272] - I2[223])
          + (fourzboz)*(I3[216] - AC0*I4[167])
          + (twozboz)*(I3[138] - AC1*I4[104])
          + (onezboz)*(I3[111] - AC2*I4[83]);
*(vp++) = U0*I0[168]
          - U10*(I1[168] - I2[224])
          - U11*(I1[252] - I2[225])
          - U12*(I1[273] - I2[226])
          + (fourzboz)*(I3[224] - AC0*I4[168])
          + (onezboz)*(I3[141] - AC1*I4[105])
          + (twozboz)*(I3[114] - AC2*I4[84]);
*(vp++) = U0*I0[169]
          - U10*(I1[169] - I2[225])
          - U11*(I1[253] - I2[227])
          - U12*(I1[274] - I2[228])
          + (fourzboz)*(I3[225] - AC0*I4[169])
          + (onezboz)*(I3[143] - AC1*I4[106])
          + (twozboz)*(I3[116] - AC2*I4[85]);
*(vp++) = U0*I0[170]
          - U10*(I1[170] - I2[226])
          - U11*(I1[254] - I2[228])
          - U12*(I1[275] - I2[229])
          + (fourzboz)*(I3[226] - AC0*I4[170])
          + (onezboz)*(I3[144] - AC1*I4[107])
          + (twozboz)*(I3[117] - AC2*I4[86]);
*(vp++) = U0*I0[171]
          - U10*(I1[171] - I2[227])
          - U11*(I1[255] - I2[230])
          - U12*(I1[276] - I2[231])
          + (fourzboz)*(I3[227] - AC0*I4[171])
          + (onezboz)*(I3[146] - AC1*I4[108])
          + (twozboz)*(I3[119] - AC2*I4[87]);
*(vp++) = U0*I0[172]
          - U10*(I1[172] - I2[228])
          - U11*(I1[256] - I2[231])
          - U12*(I1[277] - I2[232])
          + (fourzboz)*(I3[228] - AC0*I4[172])
          + (onezboz)*(I3[147] - AC1*I4[109])
          + (twozboz)*(I3[120] - AC2*I4[88]);
*(vp++) = U0*I0[173]
          - U10*(I1[173] - I2[229])
          - U11*(I1[257] - I2[232])
          - U12*(I1[278] - I2[233])
          + (fourzboz)*(I3[229] - AC0*I4[173])
          + (onezboz)*(I3[148] - AC1*I4[110])
          + (twozboz)*(I3[121] - AC2*I4[89]);
*(vp++) = U0*I0[174]
          - U10*(I1[174] - I2[230])
          - U11*(I1[258] - I2[234])
          - U12*(I1[279] - I2[235])
          + (fourzboz)*(I3[230] - AC0*I4[174])
          + (onezboz)*(I3[150] - AC1*I4[111])
          + (twozboz)*(I3[123] - AC2*I4[90]);
*(vp++) = U0*I0[175]
          - U10*(I1[175] - I2[231])
          - U11*(I1[259] - I2[235])
          - U12*(I1[280] - I2[236])
          + (fourzboz)*(I3[231] - AC0*I4[175])
          + (onezboz)*(I3[151] - AC1*I4[112])
          + (twozboz)*(I3[124] - AC2*I4[91]);
*(vp++) = U0*I0[176]
          - U10*(I1[176] - I2[232])
          - U11*(I1[260] - I2[236])
          - U12*(I1[281] - I2[237])
          + (fourzboz)*(I3[232] - AC0*I4[176])
          + (onezboz)*(I3[152] - AC1*I4[113])
          + (twozboz)*(I3[125] - AC2*I4[92]);
*(vp++) = U0*I0[177]
          - U10*(I1[177] - I2[233])
          - U11*(I1[261] - I2[237])
          - U12*(I1[282] - I2[238])
          + (fourzboz)*(I3[233] - AC0*I4[177])
          + (onezboz)*(I3[153] - AC1*I4[114])
          + (twozboz)*(I3[126] - AC2*I4[93]);
*(vp++) = U0*I0[178]
          - U10*(I1[178] - I2[234])
          - U11*(I1[262] - I2[239])
          - U12*(I1[283] - I2[240])
          + (fourzboz)*(I3[234] - AC0*I4[178])
          + (onezboz)*(I3[155] - AC1*I4[115])
          + (twozboz)*(I3[128] - AC2*I4[94]);
*(vp++) = U0*I0[179]
          - U10*(I1[179] - I2[235])
          - U11*(I1[263] - I2[240])
          - U12*(I1[284] - I2[241])
          + (fourzboz)*(I3[235] - AC0*I4[179])
          + (onezboz)*(I3[156] - AC1*I4[116])
          + (twozboz)*(I3[129] - AC2*I4[95]);
*(vp++) = U0*I0[180]
          - U10*(I1[180] - I2[236])
          - U11*(I1[264] - I2[241])
          - U12*(I1[285] - I2[242])
          + (fourzboz)*(I3[236] - AC0*I4[180])
          + (onezboz)*(I3[157] - AC1*I4[117])
          + (twozboz)*(I3[130] - AC2*I4[96]);
*(vp++) = U0*I0[181]
          - U10*(I1[181] - I2[237])
          - U11*(I1[265] - I2[242])
          - U12*(I1[286] - I2[243])
          + (fourzboz)*(I3[237] - AC0*I4[181])
          + (onezboz)*(I3[158] - AC1*I4[118])
          + (twozboz)*(I3[131] - AC2*I4[97]);
*(vp++) = U0*I0[182]
          - U10*(I1[182] - I2[238])
          - U11*(I1[266] - I2[243])
          - U12*(I1[287] - I2[244])
          + (fourzboz)*(I3[238] - AC0*I4[182])
          + (onezboz)*(I3[159] - AC1*I4[119])
          + (twozboz)*(I3[132] - AC2*I4[98]);
*(vp++) = U0*I0[183]
          - U10*(I1[183] - I2[239])
          - U11*(I1[267] - I2[245])
          - U12*(I1[288] - I2[246])
          + (fourzboz)*(I3[239] - AC0*I4[183])
          + (onezboz)*(I3[161] - AC1*I4[120])
          + (twozboz)*(I3[134] - AC2*I4[99]);
*(vp++) = U0*I0[184]
          - U10*(I1[184] - I2[240])
          - U11*(I1[268] - I2[246])
          - U12*(I1[289] - I2[247])
          + (fourzboz)*(I3[240] - AC0*I4[184])
          + (onezboz)*(I3[162] - AC1*I4[121])
          + (twozboz)*(I3[135] - AC2*I4[100]);
*(vp++) = U0*I0[185]
          - U10*(I1[185] - I2[241])
          - U11*(I1[269] - I2[247])
          - U12*(I1[290] - I2[248])
          + (fourzboz)*(I3[241] - AC0*I4[185])
          + (onezboz)*(I3[163] - AC1*I4[122])
          + (twozboz)*(I3[136] - AC2*I4[101]);
*(vp++) = U0*I0[186]
          - U10*(I1[186] - I2[242])
          - U11*(I1[270] - I2[248])
          - U12*(I1[291] - I2[249])
          + (fourzboz)*(I3[242] - AC0*I4[186])
          + (onezboz)*(I3[164] - AC1*I4[123])
          + (twozboz)*(I3[137] - AC2*I4[102]);
*(vp++) = U0*I0[187]
          - U10*(I1[187] - I2[243])
          - U11*(I1[271] - I2[249])
          - U12*(I1[292] - I2[250])
          + (fourzboz)*(I3[243] - AC0*I4[187])
          + (onezboz)*(I3[165] - AC1*I4[124])
          + (twozboz)*(I3[138] - AC2*I4[103]);
*(vp++) = U0*I0[188]
          - U10*(I1[188] - I2[244])
          - U11*(I1[272] - I2[250])
          - U12*(I1[293] - I2[251])
          + (fourzboz)*(I3[244] - AC0*I4[188])
          + (onezboz)*(I3[166] - AC1*I4[125])
          + (twozboz)*(I3[139] - AC2*I4[104]);
*(vp++) = U0*I0[189]
          - U10*(I1[189] - I2[252])
          - U11*(I1[273] - I2[253])
          - U12*(I1[294] - I2[254])
          + (fourzboz)*(I3[252] - AC0*I4[189])
          + (threezboz)*(I3[142] - AC2*I4[105]);
*(vp++) = U0*I0[190]
          - U10*(I1[190] - I2[253])
          - U11*(I1[274] - I2[255])
          - U12*(I1[295] - I2[256])
          + (fourzboz)*(I3[253] - AC0*I4[190])
          + (threezboz)*(I3[144] - AC2*I4[106]);
*(vp++) = U0*I0[191]
          - U10*(I1[191] - I2[254])
          - U11*(I1[275] - I2[256])
          - U12*(I1[296] - I2[257])
          + (fourzboz)*(I3[254] - AC0*I4[191])
          + (threezboz)*(I3[145] - AC2*I4[107]);
*(vp++) = U0*I0[192]
          - U10*(I1[192] - I2[255])
          - U11*(I1[276] - I2[258])
          - U12*(I1[297] - I2[259])
          + (fourzboz)*(I3[255] - AC0*I4[192])
          + (threezboz)*(I3[147] - AC2*I4[108]);
*(vp++) = U0*I0[193]
          - U10*(I1[193] - I2[256])
          - U11*(I1[277] - I2[259])
          - U12*(I1[298] - I2[260])
          + (fourzboz)*(I3[256] - AC0*I4[193])
          + (threezboz)*(I3[148] - AC2*I4[109]);
*(vp++) = U0*I0[194]
          - U10*(I1[194] - I2[257])
          - U11*(I1[278] - I2[260])
          - U12*(I1[299] - I2[261])
          + (fourzboz)*(I3[257] - AC0*I4[194])
          + (threezboz)*(I3[149] - AC2*I4[110]);
*(vp++) = U0*I0[195]
          - U10*(I1[195] - I2[258])
          - U11*(I1[279] - I2[262])
          - U12*(I1[300] - I2[263])
          + (fourzboz)*(I3[258] - AC0*I4[195])
          + (threezboz)*(I3[151] - AC2*I4[111]);
*(vp++) = U0*I0[196]
          - U10*(I1[196] - I2[259])
          - U11*(I1[280] - I2[263])
          - U12*(I1[301] - I2[264])
          + (fourzboz)*(I3[259] - AC0*I4[196])
          + (threezboz)*(I3[152] - AC2*I4[112]);
*(vp++) = U0*I0[197]
          - U10*(I1[197] - I2[260])
          - U11*(I1[281] - I2[264])
          - U12*(I1[302] - I2[265])
          + (fourzboz)*(I3[260] - AC0*I4[197])
          + (threezboz)*(I3[153] - AC2*I4[113]);
*(vp++) = U0*I0[198]
          - U10*(I1[198] - I2[261])
          - U11*(I1[282] - I2[265])
          - U12*(I1[303] - I2[266])
          + (fourzboz)*(I3[261] - AC0*I4[198])
          + (threezboz)*(I3[154] - AC2*I4[114]);
*(vp++) = U0*I0[199]
          - U10*(I1[199] - I2[262])
          - U11*(I1[283] - I2[267])
          - U12*(I1[304] - I2[268])
          + (fourzboz)*(I3[262] - AC0*I4[199])
          + (threezboz)*(I3[156] - AC2*I4[115]);
*(vp++) = U0*I0[200]
          - U10*(I1[200] - I2[263])
          - U11*(I1[284] - I2[268])
          - U12*(I1[305] - I2[269])
          + (fourzboz)*(I3[263] - AC0*I4[200])
          + (threezboz)*(I3[157] - AC2*I4[116]);
*(vp++) = U0*I0[201]
          - U10*(I1[201] - I2[264])
          - U11*(I1[285] - I2[269])
          - U12*(I1[306] - I2[270])
          + (fourzboz)*(I3[264] - AC0*I4[201])
          + (threezboz)*(I3[158] - AC2*I4[117]);
*(vp++) = U0*I0[202]
          - U10*(I1[202] - I2[265])
          - U11*(I1[286] - I2[270])
          - U12*(I1[307] - I2[271])
          + (fourzboz)*(I3[265] - AC0*I4[202])
          + (threezboz)*(I3[159] - AC2*I4[118]);
*(vp++) = U0*I0[203]
          - U10*(I1[203] - I2[266])
          - U11*(I1[287] - I2[271])
          - U12*(I1[308] - I2[272])
          + (fourzboz)*(I3[266] - AC0*I4[203])
          + (threezboz)*(I3[160] - AC2*I4[119]);
*(vp++) = U0*I0[204]
          - U10*(I1[204] - I2[267])
          - U11*(I1[288] - I2[273])
          - U12*(I1[309] - I2[274])
          + (fourzboz)*(I3[267] - AC0*I4[204])
          + (threezboz)*(I3[162] - AC2*I4[120]);
*(vp++) = U0*I0[205]
          - U10*(I1[205] - I2[268])
          - U11*(I1[289] - I2[274])
          - U12*(I1[310] - I2[275])
          + (fourzboz)*(I3[268] - AC0*I4[205])
          + (threezboz)*(I3[163] - AC2*I4[121]);
*(vp++) = U0*I0[206]
          - U10*(I1[206] - I2[269])
          - U11*(I1[290] - I2[275])
          - U12*(I1[311] - I2[276])
          + (fourzboz)*(I3[269] - AC0*I4[206])
          + (threezboz)*(I3[164] - AC2*I4[122]);
*(vp++) = U0*I0[207]
          - U10*(I1[207] - I2[270])
          - U11*(I1[291] - I2[276])
          - U12*(I1[312] - I2[277])
          + (fourzboz)*(I3[270] - AC0*I4[207])
          + (threezboz)*(I3[165] - AC2*I4[123]);
*(vp++) = U0*I0[208]
          - U10*(I1[208] - I2[271])
          - U11*(I1[292] - I2[277])
          - U12*(I1[313] - I2[278])
          + (fourzboz)*(I3[271] - AC0*I4[208])
          + (threezboz)*(I3[166] - AC2*I4[124]);
*(vp++) = U0*I0[209]
          - U10*(I1[209] - I2[272])
          - U11*(I1[293] - I2[278])
          - U12*(I1[314] - I2[279])
          + (fourzboz)*(I3[272] - AC0*I4[209])
          + (threezboz)*(I3[167] - AC2*I4[125]);
*(vp++) = U0*I0[210]
          - U10*(I1[210] - I2[280])
          - U11*(I1[315] - I2[281])
          - U12*(I1[336] - I2[282])
          + (threezboz)*(I3[280] - AC0*I4[210])
          + (fourzboz)*(I3[169] - AC1*I4[126]);
*(vp++) = U0*I0[211]
          - U10*(I1[211] - I2[281])
          - U11*(I1[316] - I2[283])
          - U12*(I1[337] - I2[284])
          + (threezboz)*(I3[281] - AC0*I4[211])
          + (fourzboz)*(I3[171] - AC1*I4[127]);
*(vp++) = U0*I0[212]
          - U10*(I1[212] - I2[282])
          - U11*(I1[317] - I2[284])
          - U12*(I1[338] - I2[285])
          + (threezboz)*(I3[282] - AC0*I4[212])
          + (fourzboz)*(I3[172] - AC1*I4[128]);
*(vp++) = U0*I0[213]
          - U10*(I1[213] - I2[283])
          - U11*(I1[318] - I2[286])
          - U12*(I1[339] - I2[287])
          + (threezboz)*(I3[283] - AC0*I4[213])
          + (fourzboz)*(I3[174] - AC1*I4[129]);
*(vp++) = U0*I0[214]
          - U10*(I1[214] - I2[284])
          - U11*(I1[319] - I2[287])
          - U12*(I1[340] - I2[288])
          + (threezboz)*(I3[284] - AC0*I4[214])
          + (fourzboz)*(I3[175] - AC1*I4[130]);
*(vp++) = U0*I0[215]
          - U10*(I1[215] - I2[285])
          - U11*(I1[320] - I2[288])
          - U12*(I1[341] - I2[289])
          + (threezboz)*(I3[285] - AC0*I4[215])
          + (fourzboz)*(I3[176] - AC1*I4[131]);
*(vp++) = U0*I0[216]
          - U10*(I1[216] - I2[286])
          - U11*(I1[321] - I2[290])
          - U12*(I1[342] - I2[291])
          + (threezboz)*(I3[286] - AC0*I4[216])
          + (fourzboz)*(I3[178] - AC1*I4[132]);
*(vp++) = U0*I0[217]
          - U10*(I1[217] - I2[287])
          - U11*(I1[322] - I2[291])
          - U12*(I1[343] - I2[292])
          + (threezboz)*(I3[287] - AC0*I4[217])
          + (fourzboz)*(I3[179] - AC1*I4[133]);
*(vp++) = U0*I0[218]
          - U10*(I1[218] - I2[288])
          - U11*(I1[323] - I2[292])
          - U12*(I1[344] - I2[293])
          + (threezboz)*(I3[288] - AC0*I4[218])
          + (fourzboz)*(I3[180] - AC1*I4[134]);
*(vp++) = U0*I0[219]
          - U10*(I1[219] - I2[289])
          - U11*(I1[324] - I2[293])
          - U12*(I1[345] - I2[294])
          + (threezboz)*(I3[289] - AC0*I4[219])
          + (fourzboz)*(I3[181] - AC1*I4[135]);
*(vp++) = U0*I0[220]
          - U10*(I1[220] - I2[290])
          - U11*(I1[325] - I2[295])
          - U12*(I1[346] - I2[296])
          + (threezboz)*(I3[290] - AC0*I4[220])
          + (fourzboz)*(I3[183] - AC1*I4[136]);
*(vp++) = U0*I0[221]
          - U10*(I1[221] - I2[291])
          - U11*(I1[326] - I2[296])
          - U12*(I1[347] - I2[297])
          + (threezboz)*(I3[291] - AC0*I4[221])
          + (fourzboz)*(I3[184] - AC1*I4[137]);
*(vp++) = U0*I0[222]
          - U10*(I1[222] - I2[292])
          - U11*(I1[327] - I2[297])
          - U12*(I1[348] - I2[298])
          + (threezboz)*(I3[292] - AC0*I4[222])
          + (fourzboz)*(I3[185] - AC1*I4[138]);
*(vp++) = U0*I0[223]
          - U10*(I1[223] - I2[293])
          - U11*(I1[328] - I2[298])
          - U12*(I1[349] - I2[299])
          + (threezboz)*(I3[293] - AC0*I4[223])
          + (fourzboz)*(I3[186] - AC1*I4[139]);
*(vp++) = U0*I0[224]
          - U10*(I1[224] - I2[294])
          - U11*(I1[329] - I2[299])
          - U12*(I1[350] - I2[300])
          + (threezboz)*(I3[294] - AC0*I4[224])
          + (fourzboz)*(I3[187] - AC1*I4[140]);
*(vp++) = U0*I0[225]
          - U10*(I1[225] - I2[295])
          - U11*(I1[330] - I2[301])
          - U12*(I1[351] - I2[302])
          + (threezboz)*(I3[295] - AC0*I4[225])
          + (fourzboz)*(I3[189] - AC1*I4[141]);
*(vp++) = U0*I0[226]
          - U10*(I1[226] - I2[296])
          - U11*(I1[331] - I2[302])
          - U12*(I1[352] - I2[303])
          + (threezboz)*(I3[296] - AC0*I4[226])
          + (fourzboz)*(I3[190] - AC1*I4[142]);
*(vp++) = U0*I0[227]
          - U10*(I1[227] - I2[297])
          - U11*(I1[332] - I2[303])
          - U12*(I1[353] - I2[304])
          + (threezboz)*(I3[297] - AC0*I4[227])
          + (fourzboz)*(I3[191] - AC1*I4[143]);
*(vp++) = U0*I0[228]
          - U10*(I1[228] - I2[298])
          - U11*(I1[333] - I2[304])
          - U12*(I1[354] - I2[305])
          + (threezboz)*(I3[298] - AC0*I4[228])
          + (fourzboz)*(I3[192] - AC1*I4[144]);
*(vp++) = U0*I0[229]
          - U10*(I1[229] - I2[299])
          - U11*(I1[334] - I2[305])
          - U12*(I1[355] - I2[306])
          + (threezboz)*(I3[299] - AC0*I4[229])
          + (fourzboz)*(I3[193] - AC1*I4[145]);
*(vp++) = U0*I0[230]
          - U10*(I1[230] - I2[300])
          - U11*(I1[335] - I2[306])
          - U12*(I1[356] - I2[307])
          + (threezboz)*(I3[300] - AC0*I4[230])
          + (fourzboz)*(I3[194] - AC1*I4[146]);
*(vp++) = U0*I0[231]
          - U10*(I1[231] - I2[308])
          - U11*(I1[336] - I2[309])
          - U12*(I1[357] - I2[310])
          + (threezboz)*(I3[308] - AC0*I4[231])
          + (threezboz)*(I3[197] - AC1*I4[147])
          + (onezboz)*(I3[170] - AC2*I4[126]);
*(vp++) = U0*I0[232]
          - U10*(I1[232] - I2[309])
          - U11*(I1[337] - I2[311])
          - U12*(I1[358] - I2[312])
          + (threezboz)*(I3[309] - AC0*I4[232])
          + (threezboz)*(I3[199] - AC1*I4[148])
          + (onezboz)*(I3[172] - AC2*I4[127]);
*(vp++) = U0*I0[233]
          - U10*(I1[233] - I2[310])
          - U11*(I1[338] - I2[312])
          - U12*(I1[359] - I2[313])
          + (threezboz)*(I3[310] - AC0*I4[233])
          + (threezboz)*(I3[200] - AC1*I4[149])
          + (onezboz)*(I3[173] - AC2*I4[128]);
*(vp++) = U0*I0[234]
          - U10*(I1[234] - I2[311])
          - U11*(I1[339] - I2[314])
          - U12*(I1[360] - I2[315])
          + (threezboz)*(I3[311] - AC0*I4[234])
          + (threezboz)*(I3[202] - AC1*I4[150])
          + (onezboz)*(I3[175] - AC2*I4[129]);
*(vp++) = U0*I0[235]
          - U10*(I1[235] - I2[312])
          - U11*(I1[340] - I2[315])
          - U12*(I1[361] - I2[316])
          + (threezboz)*(I3[312] - AC0*I4[235])
          + (threezboz)*(I3[203] - AC1*I4[151])
          + (onezboz)*(I3[176] - AC2*I4[130]);
*(vp++) = U0*I0[236]
          - U10*(I1[236] - I2[313])
          - U11*(I1[341] - I2[316])
          - U12*(I1[362] - I2[317])
          + (threezboz)*(I3[313] - AC0*I4[236])
          + (threezboz)*(I3[204] - AC1*I4[152])
          + (onezboz)*(I3[177] - AC2*I4[131]);
*(vp++) = U0*I0[237]
          - U10*(I1[237] - I2[314])
          - U11*(I1[342] - I2[318])
          - U12*(I1[363] - I2[319])
          + (threezboz)*(I3[314] - AC0*I4[237])
          + (threezboz)*(I3[206] - AC1*I4[153])
          + (onezboz)*(I3[179] - AC2*I4[132]);
*(vp++) = U0*I0[238]
          - U10*(I1[238] - I2[315])
          - U11*(I1[343] - I2[319])
          - U12*(I1[364] - I2[320])
          + (threezboz)*(I3[315] - AC0*I4[238])
          + (threezboz)*(I3[207] - AC1*I4[154])
          + (onezboz)*(I3[180] - AC2*I4[133]);
*(vp++) = U0*I0[239]
          - U10*(I1[239] - I2[316])
          - U11*(I1[344] - I2[320])
          - U12*(I1[365] - I2[321])
          + (threezboz)*(I3[316] - AC0*I4[239])
          + (threezboz)*(I3[208] - AC1*I4[155])
          + (onezboz)*(I3[181] - AC2*I4[134]);
*(vp++) = U0*I0[240]
          - U10*(I1[240] - I2[317])
          - U11*(I1[345] - I2[321])
          - U12*(I1[366] - I2[322])
          + (threezboz)*(I3[317] - AC0*I4[240])
          + (threezboz)*(I3[209] - AC1*I4[156])
          + (onezboz)*(I3[182] - AC2*I4[135]);
*(vp++) = U0*I0[241]
          - U10*(I1[241] - I2[318])
          - U11*(I1[346] - I2[323])
          - U12*(I1[367] - I2[324])
          + (threezboz)*(I3[318] - AC0*I4[241])
          + (threezboz)*(I3[211] - AC1*I4[157])
          + (onezboz)*(I3[184] - AC2*I4[136]);
*(vp++) = U0*I0[242]
          - U10*(I1[242] - I2[319])
          - U11*(I1[347] - I2[324])
          - U12*(I1[368] - I2[325])
          + (threezboz)*(I3[319] - AC0*I4[242])
          + (threezboz)*(I3[212] - AC1*I4[158])
          + (onezboz)*(I3[185] - AC2*I4[137]);
*(vp++) = U0*I0[243]
          - U10*(I1[243] - I2[320])
          - U11*(I1[348] - I2[325])
          - U12*(I1[369] - I2[326])
          + (threezboz)*(I3[320] - AC0*I4[243])
          + (threezboz)*(I3[213] - AC1*I4[159])
          + (onezboz)*(I3[186] - AC2*I4[138]);
*(vp++) = U0*I0[244]
          - U10*(I1[244] - I2[321])
          - U11*(I1[349] - I2[326])
          - U12*(I1[370] - I2[327])
          + (threezboz)*(I3[321] - AC0*I4[244])
          + (threezboz)*(I3[214] - AC1*I4[160])
          + (onezboz)*(I3[187] - AC2*I4[139]);
*(vp++) = U0*I0[245]
          - U10*(I1[245] - I2[322])
          - U11*(I1[350] - I2[327])
          - U12*(I1[371] - I2[328])
          + (threezboz)*(I3[322] - AC0*I4[245])
          + (threezboz)*(I3[215] - AC1*I4[161])
          + (onezboz)*(I3[188] - AC2*I4[140]);
*(vp++) = U0*I0[246]
          - U10*(I1[246] - I2[323])
          - U11*(I1[351] - I2[329])
          - U12*(I1[372] - I2[330])
          + (threezboz)*(I3[323] - AC0*I4[246])
          + (threezboz)*(I3[217] - AC1*I4[162])
          + (onezboz)*(I3[190] - AC2*I4[141]);
*(vp++) = U0*I0[247]
          - U10*(I1[247] - I2[324])
          - U11*(I1[352] - I2[330])
          - U12*(I1[373] - I2[331])
          + (threezboz)*(I3[324] - AC0*I4[247])
          + (threezboz)*(I3[218] - AC1*I4[163])
          + (onezboz)*(I3[191] - AC2*I4[142]);
*(vp++) = U0*I0[248]
          - U10*(I1[248] - I2[325])
          - U11*(I1[353] - I2[331])
          - U12*(I1[374] - I2[332])
          + (threezboz)*(I3[325] - AC0*I4[248])
          + (threezboz)*(I3[219] - AC1*I4[164])
          + (onezboz)*(I3[192] - AC2*I4[143]);
*(vp++) = U0*I0[249]
          - U10*(I1[249] - I2[326])
          - U11*(I1[354] - I2[332])
          - U12*(I1[375] - I2[333])
          + (threezboz)*(I3[326] - AC0*I4[249])
          + (threezboz)*(I3[220] - AC1*I4[165])
          + (onezboz)*(I3[193] - AC2*I4[144]);
*(vp++) = U0*I0[250]
          - U10*(I1[250] - I2[327])
          - U11*(I1[355] - I2[333])
          - U12*(I1[376] - I2[334])
          + (threezboz)*(I3[327] - AC0*I4[250])
          + (threezboz)*(I3[221] - AC1*I4[166])
          + (onezboz)*(I3[194] - AC2*I4[145]);
*(vp++) = U0*I0[251]
          - U10*(I1[251] - I2[328])
          - U11*(I1[356] - I2[334])
          - U12*(I1[377] - I2[335])
          + (threezboz)*(I3[328] - AC0*I4[251])
          + (threezboz)*(I3[222] - AC1*I4[167])
          + (onezboz)*(I3[195] - AC2*I4[146]);
*(vp++) = U0*I0[252]
          - U10*(I1[252] - I2[336])
          - U11*(I1[357] - I2[337])
          - U12*(I1[378] - I2[338])
          + (threezboz)*(I3[336] - AC0*I4[252])
          + (twozboz)*(I3[225] - AC1*I4[168])
          + (twozboz)*(I3[198] - AC2*I4[147]);
return vp;
}

REALTYPE *_t1_build_k0h0_1(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  REALTYPE fivezboz;
  REALTYPE sixzboz;
  REALTYPE sevenzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  fivezboz = 5.0*(Data->twozeta_b*Data->oo2z);
  sixzboz = 6.0*(Data->twozeta_b*Data->oo2z);
  sevenzboz = 7.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 8.000000))*Data->oo2z;

*(vp++) = U0*I0[253]
          - U10*(I1[253] - I2[337])
          - U11*(I1[358] - I2[339])
          - U12*(I1[379] - I2[340])
          + (threezboz)*(I3[337] - AC0*I4[253])
          + (twozboz)*(I3[227] - AC1*I4[169])
          + (twozboz)*(I3[200] - AC2*I4[148]);
*(vp++) = U0*I0[254]
          - U10*(I1[254] - I2[338])
          - U11*(I1[359] - I2[340])
          - U12*(I1[380] - I2[341])
          + (threezboz)*(I3[338] - AC0*I4[254])
          + (twozboz)*(I3[228] - AC1*I4[170])
          + (twozboz)*(I3[201] - AC2*I4[149]);
*(vp++) = U0*I0[255]
          - U10*(I1[255] - I2[339])
          - U11*(I1[360] - I2[342])
          - U12*(I1[381] - I2[343])
          + (threezboz)*(I3[339] - AC0*I4[255])
          + (twozboz)*(I3[230] - AC1*I4[171])
          + (twozboz)*(I3[203] - AC2*I4[150]);
*(vp++) = U0*I0[256]
          - U10*(I1[256] - I2[340])
          - U11*(I1[361] - I2[343])
          - U12*(I1[382] - I2[344])
          + (threezboz)*(I3[340] - AC0*I4[256])
          + (twozboz)*(I3[231] - AC1*I4[172])
          + (twozboz)*(I3[204] - AC2*I4[151]);
*(vp++) = U0*I0[257]
          - U10*(I1[257] - I2[341])
          - U11*(I1[362] - I2[344])
          - U12*(I1[383] - I2[345])
          + (threezboz)*(I3[341] - AC0*I4[257])
          + (twozboz)*(I3[232] - AC1*I4[173])
          + (twozboz)*(I3[205] - AC2*I4[152]);
*(vp++) = U0*I0[258]
          - U10*(I1[258] - I2[342])
          - U11*(I1[363] - I2[346])
          - U12*(I1[384] - I2[347])
          + (threezboz)*(I3[342] - AC0*I4[258])
          + (twozboz)*(I3[234] - AC1*I4[174])
          + (twozboz)*(I3[207] - AC2*I4[153]);
*(vp++) = U0*I0[259]
          - U10*(I1[259] - I2[343])
          - U11*(I1[364] - I2[347])
          - U12*(I1[385] - I2[348])
          + (threezboz)*(I3[343] - AC0*I4[259])
          + (twozboz)*(I3[235] - AC1*I4[175])
          + (twozboz)*(I3[208] - AC2*I4[154]);
*(vp++) = U0*I0[260]
          - U10*(I1[260] - I2[344])
          - U11*(I1[365] - I2[348])
          - U12*(I1[386] - I2[349])
          + (threezboz)*(I3[344] - AC0*I4[260])
          + (twozboz)*(I3[236] - AC1*I4[176])
          + (twozboz)*(I3[209] - AC2*I4[155]);
*(vp++) = U0*I0[261]
          - U10*(I1[261] - I2[345])
          - U11*(I1[366] - I2[349])
          - U12*(I1[387] - I2[350])
          + (threezboz)*(I3[345] - AC0*I4[261])
          + (twozboz)*(I3[237] - AC1*I4[177])
          + (twozboz)*(I3[210] - AC2*I4[156]);
*(vp++) = U0*I0[262]
          - U10*(I1[262] - I2[346])
          - U11*(I1[367] - I2[351])
          - U12*(I1[388] - I2[352])
          + (threezboz)*(I3[346] - AC0*I4[262])
          + (twozboz)*(I3[239] - AC1*I4[178])
          + (twozboz)*(I3[212] - AC2*I4[157]);
*(vp++) = U0*I0[263]
          - U10*(I1[263] - I2[347])
          - U11*(I1[368] - I2[352])
          - U12*(I1[389] - I2[353])
          + (threezboz)*(I3[347] - AC0*I4[263])
          + (twozboz)*(I3[240] - AC1*I4[179])
          + (twozboz)*(I3[213] - AC2*I4[158]);
*(vp++) = U0*I0[264]
          - U10*(I1[264] - I2[348])
          - U11*(I1[369] - I2[353])
          - U12*(I1[390] - I2[354])
          + (threezboz)*(I3[348] - AC0*I4[264])
          + (twozboz)*(I3[241] - AC1*I4[180])
          + (twozboz)*(I3[214] - AC2*I4[159]);
*(vp++) = U0*I0[265]
          - U10*(I1[265] - I2[349])
          - U11*(I1[370] - I2[354])
          - U12*(I1[391] - I2[355])
          + (threezboz)*(I3[349] - AC0*I4[265])
          + (twozboz)*(I3[242] - AC1*I4[181])
          + (twozboz)*(I3[215] - AC2*I4[160]);
*(vp++) = U0*I0[266]
          - U10*(I1[266] - I2[350])
          - U11*(I1[371] - I2[355])
          - U12*(I1[392] - I2[356])
          + (threezboz)*(I3[350] - AC0*I4[266])
          + (twozboz)*(I3[243] - AC1*I4[182])
          + (twozboz)*(I3[216] - AC2*I4[161]);
*(vp++) = U0*I0[267]
          - U10*(I1[267] - I2[351])
          - U11*(I1[372] - I2[357])
          - U12*(I1[393] - I2[358])
          + (threezboz)*(I3[351] - AC0*I4[267])
          + (twozboz)*(I3[245] - AC1*I4[183])
          + (twozboz)*(I3[218] - AC2*I4[162]);
*(vp++) = U0*I0[268]
          - U10*(I1[268] - I2[352])
          - U11*(I1[373] - I2[358])
          - U12*(I1[394] - I2[359])
          + (threezboz)*(I3[352] - AC0*I4[268])
          + (twozboz)*(I3[246] - AC1*I4[184])
          + (twozboz)*(I3[219] - AC2*I4[163]);
*(vp++) = U0*I0[269]
          - U10*(I1[269] - I2[353])
          - U11*(I1[374] - I2[359])
          - U12*(I1[395] - I2[360])
          + (threezboz)*(I3[353] - AC0*I4[269])
          + (twozboz)*(I3[247] - AC1*I4[185])
          + (twozboz)*(I3[220] - AC2*I4[164]);
*(vp++) = U0*I0[270]
          - U10*(I1[270] - I2[354])
          - U11*(I1[375] - I2[360])
          - U12*(I1[396] - I2[361])
          + (threezboz)*(I3[354] - AC0*I4[270])
          + (twozboz)*(I3[248] - AC1*I4[186])
          + (twozboz)*(I3[221] - AC2*I4[165]);
*(vp++) = U0*I0[271]
          - U10*(I1[271] - I2[355])
          - U11*(I1[376] - I2[361])
          - U12*(I1[397] - I2[362])
          + (threezboz)*(I3[355] - AC0*I4[271])
          + (twozboz)*(I3[249] - AC1*I4[187])
          + (twozboz)*(I3[222] - AC2*I4[166]);
*(vp++) = U0*I0[272]
          - U10*(I1[272] - I2[356])
          - U11*(I1[377] - I2[362])
          - U12*(I1[398] - I2[363])
          + (threezboz)*(I3[356] - AC0*I4[272])
          + (twozboz)*(I3[250] - AC1*I4[188])
          + (twozboz)*(I3[223] - AC2*I4[167]);
*(vp++) = U0*I0[273]
          - U10*(I1[273] - I2[364])
          - U11*(I1[378] - I2[365])
          - U12*(I1[399] - I2[366])
          + (threezboz)*(I3[364] - AC0*I4[273])
          + (onezboz)*(I3[253] - AC1*I4[189])
          + (threezboz)*(I3[226] - AC2*I4[168]);
*(vp++) = U0*I0[274]
          - U10*(I1[274] - I2[365])
          - U11*(I1[379] - I2[367])
          - U12*(I1[400] - I2[368])
          + (threezboz)*(I3[365] - AC0*I4[274])
          + (onezboz)*(I3[255] - AC1*I4[190])
          + (threezboz)*(I3[228] - AC2*I4[169]);
*(vp++) = U0*I0[275]
          - U10*(I1[275] - I2[366])
          - U11*(I1[380] - I2[368])
          - U12*(I1[401] - I2[369])
          + (threezboz)*(I3[366] - AC0*I4[275])
          + (onezboz)*(I3[256] - AC1*I4[191])
          + (threezboz)*(I3[229] - AC2*I4[170]);
*(vp++) = U0*I0[276]
          - U10*(I1[276] - I2[367])
          - U11*(I1[381] - I2[370])
          - U12*(I1[402] - I2[371])
          + (threezboz)*(I3[367] - AC0*I4[276])
          + (onezboz)*(I3[258] - AC1*I4[192])
          + (threezboz)*(I3[231] - AC2*I4[171]);
*(vp++) = U0*I0[277]
          - U10*(I1[277] - I2[368])
          - U11*(I1[382] - I2[371])
          - U12*(I1[403] - I2[372])
          + (threezboz)*(I3[368] - AC0*I4[277])
          + (onezboz)*(I3[259] - AC1*I4[193])
          + (threezboz)*(I3[232] - AC2*I4[172]);
*(vp++) = U0*I0[278]
          - U10*(I1[278] - I2[369])
          - U11*(I1[383] - I2[372])
          - U12*(I1[404] - I2[373])
          + (threezboz)*(I3[369] - AC0*I4[278])
          + (onezboz)*(I3[260] - AC1*I4[194])
          + (threezboz)*(I3[233] - AC2*I4[173]);
*(vp++) = U0*I0[279]
          - U10*(I1[279] - I2[370])
          - U11*(I1[384] - I2[374])
          - U12*(I1[405] - I2[375])
          + (threezboz)*(I3[370] - AC0*I4[279])
          + (onezboz)*(I3[262] - AC1*I4[195])
          + (threezboz)*(I3[235] - AC2*I4[174]);
*(vp++) = U0*I0[280]
          - U10*(I1[280] - I2[371])
          - U11*(I1[385] - I2[375])
          - U12*(I1[406] - I2[376])
          + (threezboz)*(I3[371] - AC0*I4[280])
          + (onezboz)*(I3[263] - AC1*I4[196])
          + (threezboz)*(I3[236] - AC2*I4[175]);
*(vp++) = U0*I0[281]
          - U10*(I1[281] - I2[372])
          - U11*(I1[386] - I2[376])
          - U12*(I1[407] - I2[377])
          + (threezboz)*(I3[372] - AC0*I4[281])
          + (onezboz)*(I3[264] - AC1*I4[197])
          + (threezboz)*(I3[237] - AC2*I4[176]);
*(vp++) = U0*I0[282]
          - U10*(I1[282] - I2[373])
          - U11*(I1[387] - I2[377])
          - U12*(I1[408] - I2[378])
          + (threezboz)*(I3[373] - AC0*I4[282])
          + (onezboz)*(I3[265] - AC1*I4[198])
          + (threezboz)*(I3[238] - AC2*I4[177]);
*(vp++) = U0*I0[283]
          - U10*(I1[283] - I2[374])
          - U11*(I1[388] - I2[379])
          - U12*(I1[409] - I2[380])
          + (threezboz)*(I3[374] - AC0*I4[283])
          + (onezboz)*(I3[267] - AC1*I4[199])
          + (threezboz)*(I3[240] - AC2*I4[178]);
*(vp++) = U0*I0[284]
          - U10*(I1[284] - I2[375])
          - U11*(I1[389] - I2[380])
          - U12*(I1[410] - I2[381])
          + (threezboz)*(I3[375] - AC0*I4[284])
          + (onezboz)*(I3[268] - AC1*I4[200])
          + (threezboz)*(I3[241] - AC2*I4[179]);
*(vp++) = U0*I0[285]
          - U10*(I1[285] - I2[376])
          - U11*(I1[390] - I2[381])
          - U12*(I1[411] - I2[382])
          + (threezboz)*(I3[376] - AC0*I4[285])
          + (onezboz)*(I3[269] - AC1*I4[201])
          + (threezboz)*(I3[242] - AC2*I4[180]);
*(vp++) = U0*I0[286]
          - U10*(I1[286] - I2[377])
          - U11*(I1[391] - I2[382])
          - U12*(I1[412] - I2[383])
          + (threezboz)*(I3[377] - AC0*I4[286])
          + (onezboz)*(I3[270] - AC1*I4[202])
          + (threezboz)*(I3[243] - AC2*I4[181]);
*(vp++) = U0*I0[287]
          - U10*(I1[287] - I2[378])
          - U11*(I1[392] - I2[383])
          - U12*(I1[413] - I2[384])
          + (threezboz)*(I3[378] - AC0*I4[287])
          + (onezboz)*(I3[271] - AC1*I4[203])
          + (threezboz)*(I3[244] - AC2*I4[182]);
*(vp++) = U0*I0[288]
          - U10*(I1[288] - I2[379])
          - U11*(I1[393] - I2[385])
          - U12*(I1[414] - I2[386])
          + (threezboz)*(I3[379] - AC0*I4[288])
          + (onezboz)*(I3[273] - AC1*I4[204])
          + (threezboz)*(I3[246] - AC2*I4[183]);
*(vp++) = U0*I0[289]
          - U10*(I1[289] - I2[380])
          - U11*(I1[394] - I2[386])
          - U12*(I1[415] - I2[387])
          + (threezboz)*(I3[380] - AC0*I4[289])
          + (onezboz)*(I3[274] - AC1*I4[205])
          + (threezboz)*(I3[247] - AC2*I4[184]);
*(vp++) = U0*I0[290]
          - U10*(I1[290] - I2[381])
          - U11*(I1[395] - I2[387])
          - U12*(I1[416] - I2[388])
          + (threezboz)*(I3[381] - AC0*I4[290])
          + (onezboz)*(I3[275] - AC1*I4[206])
          + (threezboz)*(I3[248] - AC2*I4[185]);
*(vp++) = U0*I0[291]
          - U10*(I1[291] - I2[382])
          - U11*(I1[396] - I2[388])
          - U12*(I1[417] - I2[389])
          + (threezboz)*(I3[382] - AC0*I4[291])
          + (onezboz)*(I3[276] - AC1*I4[207])
          + (threezboz)*(I3[249] - AC2*I4[186]);
*(vp++) = U0*I0[292]
          - U10*(I1[292] - I2[383])
          - U11*(I1[397] - I2[389])
          - U12*(I1[418] - I2[390])
          + (threezboz)*(I3[383] - AC0*I4[292])
          + (onezboz)*(I3[277] - AC1*I4[208])
          + (threezboz)*(I3[250] - AC2*I4[187]);
*(vp++) = U0*I0[293]
          - U10*(I1[293] - I2[384])
          - U11*(I1[398] - I2[390])
          - U12*(I1[419] - I2[391])
          + (threezboz)*(I3[384] - AC0*I4[293])
          + (onezboz)*(I3[278] - AC1*I4[209])
          + (threezboz)*(I3[251] - AC2*I4[188]);
*(vp++) = U0*I0[294]
          - U10*(I1[294] - I2[392])
          - U11*(I1[399] - I2[393])
          - U12*(I1[420] - I2[394])
          + (threezboz)*(I3[392] - AC0*I4[294])
          + (fourzboz)*(I3[254] - AC2*I4[189]);
*(vp++) = U0*I0[295]
          - U10*(I1[295] - I2[393])
          - U11*(I1[400] - I2[395])
          - U12*(I1[421] - I2[396])
          + (threezboz)*(I3[393] - AC0*I4[295])
          + (fourzboz)*(I3[256] - AC2*I4[190]);
*(vp++) = U0*I0[296]
          - U10*(I1[296] - I2[394])
          - U11*(I1[401] - I2[396])
          - U12*(I1[422] - I2[397])
          + (threezboz)*(I3[394] - AC0*I4[296])
          + (fourzboz)*(I3[257] - AC2*I4[191]);
*(vp++) = U0*I0[297]
          - U10*(I1[297] - I2[395])
          - U11*(I1[402] - I2[398])
          - U12*(I1[423] - I2[399])
          + (threezboz)*(I3[395] - AC0*I4[297])
          + (fourzboz)*(I3[259] - AC2*I4[192]);
*(vp++) = U0*I0[298]
          - U10*(I1[298] - I2[396])
          - U11*(I1[403] - I2[399])
          - U12*(I1[424] - I2[400])
          + (threezboz)*(I3[396] - AC0*I4[298])
          + (fourzboz)*(I3[260] - AC2*I4[193]);
*(vp++) = U0*I0[299]
          - U10*(I1[299] - I2[397])
          - U11*(I1[404] - I2[400])
          - U12*(I1[425] - I2[401])
          + (threezboz)*(I3[397] - AC0*I4[299])
          + (fourzboz)*(I3[261] - AC2*I4[194]);
*(vp++) = U0*I0[300]
          - U10*(I1[300] - I2[398])
          - U11*(I1[405] - I2[402])
          - U12*(I1[426] - I2[403])
          + (threezboz)*(I3[398] - AC0*I4[300])
          + (fourzboz)*(I3[263] - AC2*I4[195]);
*(vp++) = U0*I0[301]
          - U10*(I1[301] - I2[399])
          - U11*(I1[406] - I2[403])
          - U12*(I1[427] - I2[404])
          + (threezboz)*(I3[399] - AC0*I4[301])
          + (fourzboz)*(I3[264] - AC2*I4[196]);
*(vp++) = U0*I0[302]
          - U10*(I1[302] - I2[400])
          - U11*(I1[407] - I2[404])
          - U12*(I1[428] - I2[405])
          + (threezboz)*(I3[400] - AC0*I4[302])
          + (fourzboz)*(I3[265] - AC2*I4[197]);
*(vp++) = U0*I0[303]
          - U10*(I1[303] - I2[401])
          - U11*(I1[408] - I2[405])
          - U12*(I1[429] - I2[406])
          + (threezboz)*(I3[401] - AC0*I4[303])
          + (fourzboz)*(I3[266] - AC2*I4[198]);
*(vp++) = U0*I0[304]
          - U10*(I1[304] - I2[402])
          - U11*(I1[409] - I2[407])
          - U12*(I1[430] - I2[408])
          + (threezboz)*(I3[402] - AC0*I4[304])
          + (fourzboz)*(I3[268] - AC2*I4[199]);
*(vp++) = U0*I0[305]
          - U10*(I1[305] - I2[403])
          - U11*(I1[410] - I2[408])
          - U12*(I1[431] - I2[409])
          + (threezboz)*(I3[403] - AC0*I4[305])
          + (fourzboz)*(I3[269] - AC2*I4[200]);
*(vp++) = U0*I0[306]
          - U10*(I1[306] - I2[404])
          - U11*(I1[411] - I2[409])
          - U12*(I1[432] - I2[410])
          + (threezboz)*(I3[404] - AC0*I4[306])
          + (fourzboz)*(I3[270] - AC2*I4[201]);
*(vp++) = U0*I0[307]
          - U10*(I1[307] - I2[405])
          - U11*(I1[412] - I2[410])
          - U12*(I1[433] - I2[411])
          + (threezboz)*(I3[405] - AC0*I4[307])
          + (fourzboz)*(I3[271] - AC2*I4[202]);
*(vp++) = U0*I0[308]
          - U10*(I1[308] - I2[406])
          - U11*(I1[413] - I2[411])
          - U12*(I1[434] - I2[412])
          + (threezboz)*(I3[406] - AC0*I4[308])
          + (fourzboz)*(I3[272] - AC2*I4[203]);
*(vp++) = U0*I0[309]
          - U10*(I1[309] - I2[407])
          - U11*(I1[414] - I2[413])
          - U12*(I1[435] - I2[414])
          + (threezboz)*(I3[407] - AC0*I4[309])
          + (fourzboz)*(I3[274] - AC2*I4[204]);
*(vp++) = U0*I0[310]
          - U10*(I1[310] - I2[408])
          - U11*(I1[415] - I2[414])
          - U12*(I1[436] - I2[415])
          + (threezboz)*(I3[408] - AC0*I4[310])
          + (fourzboz)*(I3[275] - AC2*I4[205]);
*(vp++) = U0*I0[311]
          - U10*(I1[311] - I2[409])
          - U11*(I1[416] - I2[415])
          - U12*(I1[437] - I2[416])
          + (threezboz)*(I3[409] - AC0*I4[311])
          + (fourzboz)*(I3[276] - AC2*I4[206]);
*(vp++) = U0*I0[312]
          - U10*(I1[312] - I2[410])
          - U11*(I1[417] - I2[416])
          - U12*(I1[438] - I2[417])
          + (threezboz)*(I3[410] - AC0*I4[312])
          + (fourzboz)*(I3[277] - AC2*I4[207]);
*(vp++) = U0*I0[313]
          - U10*(I1[313] - I2[411])
          - U11*(I1[418] - I2[417])
          - U12*(I1[439] - I2[418])
          + (threezboz)*(I3[411] - AC0*I4[313])
          + (fourzboz)*(I3[278] - AC2*I4[208]);
*(vp++) = U0*I0[314]
          - U10*(I1[314] - I2[412])
          - U11*(I1[419] - I2[418])
          - U12*(I1[440] - I2[419])
          + (threezboz)*(I3[412] - AC0*I4[314])
          + (fourzboz)*(I3[279] - AC2*I4[209]);
*(vp++) = U0*I0[315]
          - U10*(I1[315] - I2[420])
          - U11*(I1[441] - I2[421])
          - U12*(I1[462] - I2[422])
          + (twozboz)*(I3[420] - AC0*I4[315])
          + (fivezboz)*(I3[281] - AC1*I4[210]);
*(vp++) = U0*I0[316]
          - U10*(I1[316] - I2[421])
          - U11*(I1[442] - I2[423])
          - U12*(I1[463] - I2[424])
          + (twozboz)*(I3[421] - AC0*I4[316])
          + (fivezboz)*(I3[283] - AC1*I4[211]);
*(vp++) = U0*I0[317]
          - U10*(I1[317] - I2[422])
          - U11*(I1[443] - I2[424])
          - U12*(I1[464] - I2[425])
          + (twozboz)*(I3[422] - AC0*I4[317])
          + (fivezboz)*(I3[284] - AC1*I4[212]);
*(vp++) = U0*I0[318]
          - U10*(I1[318] - I2[423])
          - U11*(I1[444] - I2[426])
          - U12*(I1[465] - I2[427])
          + (twozboz)*(I3[423] - AC0*I4[318])
          + (fivezboz)*(I3[286] - AC1*I4[213]);
*(vp++) = U0*I0[319]
          - U10*(I1[319] - I2[424])
          - U11*(I1[445] - I2[427])
          - U12*(I1[466] - I2[428])
          + (twozboz)*(I3[424] - AC0*I4[319])
          + (fivezboz)*(I3[287] - AC1*I4[214]);
*(vp++) = U0*I0[320]
          - U10*(I1[320] - I2[425])
          - U11*(I1[446] - I2[428])
          - U12*(I1[467] - I2[429])
          + (twozboz)*(I3[425] - AC0*I4[320])
          + (fivezboz)*(I3[288] - AC1*I4[215]);
*(vp++) = U0*I0[321]
          - U10*(I1[321] - I2[426])
          - U11*(I1[447] - I2[430])
          - U12*(I1[468] - I2[431])
          + (twozboz)*(I3[426] - AC0*I4[321])
          + (fivezboz)*(I3[290] - AC1*I4[216]);
*(vp++) = U0*I0[322]
          - U10*(I1[322] - I2[427])
          - U11*(I1[448] - I2[431])
          - U12*(I1[469] - I2[432])
          + (twozboz)*(I3[427] - AC0*I4[322])
          + (fivezboz)*(I3[291] - AC1*I4[217]);
*(vp++) = U0*I0[323]
          - U10*(I1[323] - I2[428])
          - U11*(I1[449] - I2[432])
          - U12*(I1[470] - I2[433])
          + (twozboz)*(I3[428] - AC0*I4[323])
          + (fivezboz)*(I3[292] - AC1*I4[218]);
*(vp++) = U0*I0[324]
          - U10*(I1[324] - I2[429])
          - U11*(I1[450] - I2[433])
          - U12*(I1[471] - I2[434])
          + (twozboz)*(I3[429] - AC0*I4[324])
          + (fivezboz)*(I3[293] - AC1*I4[219]);
*(vp++) = U0*I0[325]
          - U10*(I1[325] - I2[430])
          - U11*(I1[451] - I2[435])
          - U12*(I1[472] - I2[436])
          + (twozboz)*(I3[430] - AC0*I4[325])
          + (fivezboz)*(I3[295] - AC1*I4[220]);
*(vp++) = U0*I0[326]
          - U10*(I1[326] - I2[431])
          - U11*(I1[452] - I2[436])
          - U12*(I1[473] - I2[437])
          + (twozboz)*(I3[431] - AC0*I4[326])
          + (fivezboz)*(I3[296] - AC1*I4[221]);
*(vp++) = U0*I0[327]
          - U10*(I1[327] - I2[432])
          - U11*(I1[453] - I2[437])
          - U12*(I1[474] - I2[438])
          + (twozboz)*(I3[432] - AC0*I4[327])
          + (fivezboz)*(I3[297] - AC1*I4[222]);
*(vp++) = U0*I0[328]
          - U10*(I1[328] - I2[433])
          - U11*(I1[454] - I2[438])
          - U12*(I1[475] - I2[439])
          + (twozboz)*(I3[433] - AC0*I4[328])
          + (fivezboz)*(I3[298] - AC1*I4[223]);
*(vp++) = U0*I0[329]
          - U10*(I1[329] - I2[434])
          - U11*(I1[455] - I2[439])
          - U12*(I1[476] - I2[440])
          + (twozboz)*(I3[434] - AC0*I4[329])
          + (fivezboz)*(I3[299] - AC1*I4[224]);
*(vp++) = U0*I0[330]
          - U10*(I1[330] - I2[435])
          - U11*(I1[456] - I2[441])
          - U12*(I1[477] - I2[442])
          + (twozboz)*(I3[435] - AC0*I4[330])
          + (fivezboz)*(I3[301] - AC1*I4[225]);
*(vp++) = U0*I0[331]
          - U10*(I1[331] - I2[436])
          - U11*(I1[457] - I2[442])
          - U12*(I1[478] - I2[443])
          + (twozboz)*(I3[436] - AC0*I4[331])
          + (fivezboz)*(I3[302] - AC1*I4[226]);
*(vp++) = U0*I0[332]
          - U10*(I1[332] - I2[437])
          - U11*(I1[458] - I2[443])
          - U12*(I1[479] - I2[444])
          + (twozboz)*(I3[437] - AC0*I4[332])
          + (fivezboz)*(I3[303] - AC1*I4[227]);
*(vp++) = U0*I0[333]
          - U10*(I1[333] - I2[438])
          - U11*(I1[459] - I2[444])
          - U12*(I1[480] - I2[445])
          + (twozboz)*(I3[438] - AC0*I4[333])
          + (fivezboz)*(I3[304] - AC1*I4[228]);
*(vp++) = U0*I0[334]
          - U10*(I1[334] - I2[439])
          - U11*(I1[460] - I2[445])
          - U12*(I1[481] - I2[446])
          + (twozboz)*(I3[439] - AC0*I4[334])
          + (fivezboz)*(I3[305] - AC1*I4[229]);
*(vp++) = U0*I0[335]
          - U10*(I1[335] - I2[440])
          - U11*(I1[461] - I2[446])
          - U12*(I1[482] - I2[447])
          + (twozboz)*(I3[440] - AC0*I4[335])
          + (fivezboz)*(I3[306] - AC1*I4[230]);
*(vp++) = U0*I0[336]
          - U10*(I1[336] - I2[448])
          - U11*(I1[462] - I2[449])
          - U12*(I1[483] - I2[450])
          + (twozboz)*(I3[448] - AC0*I4[336])
          + (fourzboz)*(I3[309] - AC1*I4[231])
          + (onezboz)*(I3[282] - AC2*I4[210]);
*(vp++) = U0*I0[337]
          - U10*(I1[337] - I2[449])
          - U11*(I1[463] - I2[451])
          - U12*(I1[484] - I2[452])
          + (twozboz)*(I3[449] - AC0*I4[337])
          + (fourzboz)*(I3[311] - AC1*I4[232])
          + (onezboz)*(I3[284] - AC2*I4[211]);
*(vp++) = U0*I0[338]
          - U10*(I1[338] - I2[450])
          - U11*(I1[464] - I2[452])
          - U12*(I1[485] - I2[453])
          + (twozboz)*(I3[450] - AC0*I4[338])
          + (fourzboz)*(I3[312] - AC1*I4[233])
          + (onezboz)*(I3[285] - AC2*I4[212]);
*(vp++) = U0*I0[339]
          - U10*(I1[339] - I2[451])
          - U11*(I1[465] - I2[454])
          - U12*(I1[486] - I2[455])
          + (twozboz)*(I3[451] - AC0*I4[339])
          + (fourzboz)*(I3[314] - AC1*I4[234])
          + (onezboz)*(I3[287] - AC2*I4[213]);
*(vp++) = U0*I0[340]
          - U10*(I1[340] - I2[452])
          - U11*(I1[466] - I2[455])
          - U12*(I1[487] - I2[456])
          + (twozboz)*(I3[452] - AC0*I4[340])
          + (fourzboz)*(I3[315] - AC1*I4[235])
          + (onezboz)*(I3[288] - AC2*I4[214]);
*(vp++) = U0*I0[341]
          - U10*(I1[341] - I2[453])
          - U11*(I1[467] - I2[456])
          - U12*(I1[488] - I2[457])
          + (twozboz)*(I3[453] - AC0*I4[341])
          + (fourzboz)*(I3[316] - AC1*I4[236])
          + (onezboz)*(I3[289] - AC2*I4[215]);
*(vp++) = U0*I0[342]
          - U10*(I1[342] - I2[454])
          - U11*(I1[468] - I2[458])
          - U12*(I1[489] - I2[459])
          + (twozboz)*(I3[454] - AC0*I4[342])
          + (fourzboz)*(I3[318] - AC1*I4[237])
          + (onezboz)*(I3[291] - AC2*I4[216]);
*(vp++) = U0*I0[343]
          - U10*(I1[343] - I2[455])
          - U11*(I1[469] - I2[459])
          - U12*(I1[490] - I2[460])
          + (twozboz)*(I3[455] - AC0*I4[343])
          + (fourzboz)*(I3[319] - AC1*I4[238])
          + (onezboz)*(I3[292] - AC2*I4[217]);
*(vp++) = U0*I0[344]
          - U10*(I1[344] - I2[456])
          - U11*(I1[470] - I2[460])
          - U12*(I1[491] - I2[461])
          + (twozboz)*(I3[456] - AC0*I4[344])
          + (fourzboz)*(I3[320] - AC1*I4[239])
          + (onezboz)*(I3[293] - AC2*I4[218]);
*(vp++) = U0*I0[345]
          - U10*(I1[345] - I2[457])
          - U11*(I1[471] - I2[461])
          - U12*(I1[492] - I2[462])
          + (twozboz)*(I3[457] - AC0*I4[345])
          + (fourzboz)*(I3[321] - AC1*I4[240])
          + (onezboz)*(I3[294] - AC2*I4[219]);
*(vp++) = U0*I0[346]
          - U10*(I1[346] - I2[458])
          - U11*(I1[472] - I2[463])
          - U12*(I1[493] - I2[464])
          + (twozboz)*(I3[458] - AC0*I4[346])
          + (fourzboz)*(I3[323] - AC1*I4[241])
          + (onezboz)*(I3[296] - AC2*I4[220]);
*(vp++) = U0*I0[347]
          - U10*(I1[347] - I2[459])
          - U11*(I1[473] - I2[464])
          - U12*(I1[494] - I2[465])
          + (twozboz)*(I3[459] - AC0*I4[347])
          + (fourzboz)*(I3[324] - AC1*I4[242])
          + (onezboz)*(I3[297] - AC2*I4[221]);
*(vp++) = U0*I0[348]
          - U10*(I1[348] - I2[460])
          - U11*(I1[474] - I2[465])
          - U12*(I1[495] - I2[466])
          + (twozboz)*(I3[460] - AC0*I4[348])
          + (fourzboz)*(I3[325] - AC1*I4[243])
          + (onezboz)*(I3[298] - AC2*I4[222]);
*(vp++) = U0*I0[349]
          - U10*(I1[349] - I2[461])
          - U11*(I1[475] - I2[466])
          - U12*(I1[496] - I2[467])
          + (twozboz)*(I3[461] - AC0*I4[349])
          + (fourzboz)*(I3[326] - AC1*I4[244])
          + (onezboz)*(I3[299] - AC2*I4[223]);
*(vp++) = U0*I0[350]
          - U10*(I1[350] - I2[462])
          - U11*(I1[476] - I2[467])
          - U12*(I1[497] - I2[468])
          + (twozboz)*(I3[462] - AC0*I4[350])
          + (fourzboz)*(I3[327] - AC1*I4[245])
          + (onezboz)*(I3[300] - AC2*I4[224]);
*(vp++) = U0*I0[351]
          - U10*(I1[351] - I2[463])
          - U11*(I1[477] - I2[469])
          - U12*(I1[498] - I2[470])
          + (twozboz)*(I3[463] - AC0*I4[351])
          + (fourzboz)*(I3[329] - AC1*I4[246])
          + (onezboz)*(I3[302] - AC2*I4[225]);
*(vp++) = U0*I0[352]
          - U10*(I1[352] - I2[464])
          - U11*(I1[478] - I2[470])
          - U12*(I1[499] - I2[471])
          + (twozboz)*(I3[464] - AC0*I4[352])
          + (fourzboz)*(I3[330] - AC1*I4[247])
          + (onezboz)*(I3[303] - AC2*I4[226]);
*(vp++) = U0*I0[353]
          - U10*(I1[353] - I2[465])
          - U11*(I1[479] - I2[471])
          - U12*(I1[500] - I2[472])
          + (twozboz)*(I3[465] - AC0*I4[353])
          + (fourzboz)*(I3[331] - AC1*I4[248])
          + (onezboz)*(I3[304] - AC2*I4[227]);
*(vp++) = U0*I0[354]
          - U10*(I1[354] - I2[466])
          - U11*(I1[480] - I2[472])
          - U12*(I1[501] - I2[473])
          + (twozboz)*(I3[466] - AC0*I4[354])
          + (fourzboz)*(I3[332] - AC1*I4[249])
          + (onezboz)*(I3[305] - AC2*I4[228]);
*(vp++) = U0*I0[355]
          - U10*(I1[355] - I2[467])
          - U11*(I1[481] - I2[473])
          - U12*(I1[502] - I2[474])
          + (twozboz)*(I3[467] - AC0*I4[355])
          + (fourzboz)*(I3[333] - AC1*I4[250])
          + (onezboz)*(I3[306] - AC2*I4[229]);
*(vp++) = U0*I0[356]
          - U10*(I1[356] - I2[468])
          - U11*(I1[482] - I2[474])
          - U12*(I1[503] - I2[475])
          + (twozboz)*(I3[468] - AC0*I4[356])
          + (fourzboz)*(I3[334] - AC1*I4[251])
          + (onezboz)*(I3[307] - AC2*I4[230]);
*(vp++) = U0*I0[357]
          - U10*(I1[357] - I2[476])
          - U11*(I1[483] - I2[477])
          - U12*(I1[504] - I2[478])
          + (twozboz)*(I3[476] - AC0*I4[357])
          + (threezboz)*(I3[337] - AC1*I4[252])
          + (twozboz)*(I3[310] - AC2*I4[231]);
*(vp++) = U0*I0[358]
          - U10*(I1[358] - I2[477])
          - U11*(I1[484] - I2[479])
          - U12*(I1[505] - I2[480])
          + (twozboz)*(I3[477] - AC0*I4[358])
          + (threezboz)*(I3[339] - AC1*I4[253])
          + (twozboz)*(I3[312] - AC2*I4[232]);
*(vp++) = U0*I0[359]
          - U10*(I1[359] - I2[478])
          - U11*(I1[485] - I2[480])
          - U12*(I1[506] - I2[481])
          + (twozboz)*(I3[478] - AC0*I4[359])
          + (threezboz)*(I3[340] - AC1*I4[254])
          + (twozboz)*(I3[313] - AC2*I4[233]);
*(vp++) = U0*I0[360]
          - U10*(I1[360] - I2[479])
          - U11*(I1[486] - I2[482])
          - U12*(I1[507] - I2[483])
          + (twozboz)*(I3[479] - AC0*I4[360])
          + (threezboz)*(I3[342] - AC1*I4[255])
          + (twozboz)*(I3[315] - AC2*I4[234]);
*(vp++) = U0*I0[361]
          - U10*(I1[361] - I2[480])
          - U11*(I1[487] - I2[483])
          - U12*(I1[508] - I2[484])
          + (twozboz)*(I3[480] - AC0*I4[361])
          + (threezboz)*(I3[343] - AC1*I4[256])
          + (twozboz)*(I3[316] - AC2*I4[235]);
*(vp++) = U0*I0[362]
          - U10*(I1[362] - I2[481])
          - U11*(I1[488] - I2[484])
          - U12*(I1[509] - I2[485])
          + (twozboz)*(I3[481] - AC0*I4[362])
          + (threezboz)*(I3[344] - AC1*I4[257])
          + (twozboz)*(I3[317] - AC2*I4[236]);
*(vp++) = U0*I0[363]
          - U10*(I1[363] - I2[482])
          - U11*(I1[489] - I2[486])
          - U12*(I1[510] - I2[487])
          + (twozboz)*(I3[482] - AC0*I4[363])
          + (threezboz)*(I3[346] - AC1*I4[258])
          + (twozboz)*(I3[319] - AC2*I4[237]);
*(vp++) = U0*I0[364]
          - U10*(I1[364] - I2[483])
          - U11*(I1[490] - I2[487])
          - U12*(I1[511] - I2[488])
          + (twozboz)*(I3[483] - AC0*I4[364])
          + (threezboz)*(I3[347] - AC1*I4[259])
          + (twozboz)*(I3[320] - AC2*I4[238]);
*(vp++) = U0*I0[365]
          - U10*(I1[365] - I2[484])
          - U11*(I1[491] - I2[488])
          - U12*(I1[512] - I2[489])
          + (twozboz)*(I3[484] - AC0*I4[365])
          + (threezboz)*(I3[348] - AC1*I4[260])
          + (twozboz)*(I3[321] - AC2*I4[239]);
*(vp++) = U0*I0[366]
          - U10*(I1[366] - I2[485])
          - U11*(I1[492] - I2[489])
          - U12*(I1[513] - I2[490])
          + (twozboz)*(I3[485] - AC0*I4[366])
          + (threezboz)*(I3[349] - AC1*I4[261])
          + (twozboz)*(I3[322] - AC2*I4[240]);
*(vp++) = U0*I0[367]
          - U10*(I1[367] - I2[486])
          - U11*(I1[493] - I2[491])
          - U12*(I1[514] - I2[492])
          + (twozboz)*(I3[486] - AC0*I4[367])
          + (threezboz)*(I3[351] - AC1*I4[262])
          + (twozboz)*(I3[324] - AC2*I4[241]);
*(vp++) = U0*I0[368]
          - U10*(I1[368] - I2[487])
          - U11*(I1[494] - I2[492])
          - U12*(I1[515] - I2[493])
          + (twozboz)*(I3[487] - AC0*I4[368])
          + (threezboz)*(I3[352] - AC1*I4[263])
          + (twozboz)*(I3[325] - AC2*I4[242]);
*(vp++) = U0*I0[369]
          - U10*(I1[369] - I2[488])
          - U11*(I1[495] - I2[493])
          - U12*(I1[516] - I2[494])
          + (twozboz)*(I3[488] - AC0*I4[369])
          + (threezboz)*(I3[353] - AC1*I4[264])
          + (twozboz)*(I3[326] - AC2*I4[243]);
*(vp++) = U0*I0[370]
          - U10*(I1[370] - I2[489])
          - U11*(I1[496] - I2[494])
          - U12*(I1[517] - I2[495])
          + (twozboz)*(I3[489] - AC0*I4[370])
          + (threezboz)*(I3[354] - AC1*I4[265])
          + (twozboz)*(I3[327] - AC2*I4[244]);
*(vp++) = U0*I0[371]
          - U10*(I1[371] - I2[490])
          - U11*(I1[497] - I2[495])
          - U12*(I1[518] - I2[496])
          + (twozboz)*(I3[490] - AC0*I4[371])
          + (threezboz)*(I3[355] - AC1*I4[266])
          + (twozboz)*(I3[328] - AC2*I4[245]);
*(vp++) = U0*I0[372]
          - U10*(I1[372] - I2[491])
          - U11*(I1[498] - I2[497])
          - U12*(I1[519] - I2[498])
          + (twozboz)*(I3[491] - AC0*I4[372])
          + (threezboz)*(I3[357] - AC1*I4[267])
          + (twozboz)*(I3[330] - AC2*I4[246]);
*(vp++) = U0*I0[373]
          - U10*(I1[373] - I2[492])
          - U11*(I1[499] - I2[498])
          - U12*(I1[520] - I2[499])
          + (twozboz)*(I3[492] - AC0*I4[373])
          + (threezboz)*(I3[358] - AC1*I4[268])
          + (twozboz)*(I3[331] - AC2*I4[247]);
*(vp++) = U0*I0[374]
          - U10*(I1[374] - I2[493])
          - U11*(I1[500] - I2[499])
          - U12*(I1[521] - I2[500])
          + (twozboz)*(I3[493] - AC0*I4[374])
          + (threezboz)*(I3[359] - AC1*I4[269])
          + (twozboz)*(I3[332] - AC2*I4[248]);
*(vp++) = U0*I0[375]
          - U10*(I1[375] - I2[494])
          - U11*(I1[501] - I2[500])
          - U12*(I1[522] - I2[501])
          + (twozboz)*(I3[494] - AC0*I4[375])
          + (threezboz)*(I3[360] - AC1*I4[270])
          + (twozboz)*(I3[333] - AC2*I4[249]);
*(vp++) = U0*I0[376]
          - U10*(I1[376] - I2[495])
          - U11*(I1[502] - I2[501])
          - U12*(I1[523] - I2[502])
          + (twozboz)*(I3[495] - AC0*I4[376])
          + (threezboz)*(I3[361] - AC1*I4[271])
          + (twozboz)*(I3[334] - AC2*I4[250]);
*(vp++) = U0*I0[377]
          - U10*(I1[377] - I2[496])
          - U11*(I1[503] - I2[502])
          - U12*(I1[524] - I2[503])
          + (twozboz)*(I3[496] - AC0*I4[377])
          + (threezboz)*(I3[362] - AC1*I4[272])
          + (twozboz)*(I3[335] - AC2*I4[251]);
*(vp++) = U0*I0[378]
          - U10*(I1[378] - I2[504])
          - U11*(I1[504] - I2[505])
          - U12*(I1[525] - I2[506])
          + (twozboz)*(I3[504] - AC0*I4[378])
          + (twozboz)*(I3[365] - AC1*I4[273])
          + (threezboz)*(I3[338] - AC2*I4[252]);
*(vp++) = U0*I0[379]
          - U10*(I1[379] - I2[505])
          - U11*(I1[505] - I2[507])
          - U12*(I1[526] - I2[508])
          + (twozboz)*(I3[505] - AC0*I4[379])
          + (twozboz)*(I3[367] - AC1*I4[274])
          + (threezboz)*(I3[340] - AC2*I4[253]);
*(vp++) = U0*I0[380]
          - U10*(I1[380] - I2[506])
          - U11*(I1[506] - I2[508])
          - U12*(I1[527] - I2[509])
          + (twozboz)*(I3[506] - AC0*I4[380])
          + (twozboz)*(I3[368] - AC1*I4[275])
          + (threezboz)*(I3[341] - AC2*I4[254]);
*(vp++) = U0*I0[381]
          - U10*(I1[381] - I2[507])
          - U11*(I1[507] - I2[510])
          - U12*(I1[528] - I2[511])
          + (twozboz)*(I3[507] - AC0*I4[381])
          + (twozboz)*(I3[370] - AC1*I4[276])
          + (threezboz)*(I3[343] - AC2*I4[255]);
*(vp++) = U0*I0[382]
          - U10*(I1[382] - I2[508])
          - U11*(I1[508] - I2[511])
          - U12*(I1[529] - I2[512])
          + (twozboz)*(I3[508] - AC0*I4[382])
          + (twozboz)*(I3[371] - AC1*I4[277])
          + (threezboz)*(I3[344] - AC2*I4[256]);
*(vp++) = U0*I0[383]
          - U10*(I1[383] - I2[509])
          - U11*(I1[509] - I2[512])
          - U12*(I1[530] - I2[513])
          + (twozboz)*(I3[509] - AC0*I4[383])
          + (twozboz)*(I3[372] - AC1*I4[278])
          + (threezboz)*(I3[345] - AC2*I4[257]);
*(vp++) = U0*I0[384]
          - U10*(I1[384] - I2[510])
          - U11*(I1[510] - I2[514])
          - U12*(I1[531] - I2[515])
          + (twozboz)*(I3[510] - AC0*I4[384])
          + (twozboz)*(I3[374] - AC1*I4[279])
          + (threezboz)*(I3[347] - AC2*I4[258]);
*(vp++) = U0*I0[385]
          - U10*(I1[385] - I2[511])
          - U11*(I1[511] - I2[515])
          - U12*(I1[532] - I2[516])
          + (twozboz)*(I3[511] - AC0*I4[385])
          + (twozboz)*(I3[375] - AC1*I4[280])
          + (threezboz)*(I3[348] - AC2*I4[259]);
*(vp++) = U0*I0[386]
          - U10*(I1[386] - I2[512])
          - U11*(I1[512] - I2[516])
          - U12*(I1[533] - I2[517])
          + (twozboz)*(I3[512] - AC0*I4[386])
          + (twozboz)*(I3[376] - AC1*I4[281])
          + (threezboz)*(I3[349] - AC2*I4[260]);
*(vp++) = U0*I0[387]
          - U10*(I1[387] - I2[513])
          - U11*(I1[513] - I2[517])
          - U12*(I1[534] - I2[518])
          + (twozboz)*(I3[513] - AC0*I4[387])
          + (twozboz)*(I3[377] - AC1*I4[282])
          + (threezboz)*(I3[350] - AC2*I4[261]);
*(vp++) = U0*I0[388]
          - U10*(I1[388] - I2[514])
          - U11*(I1[514] - I2[519])
          - U12*(I1[535] - I2[520])
          + (twozboz)*(I3[514] - AC0*I4[388])
          + (twozboz)*(I3[379] - AC1*I4[283])
          + (threezboz)*(I3[352] - AC2*I4[262]);
*(vp++) = U0*I0[389]
          - U10*(I1[389] - I2[515])
          - U11*(I1[515] - I2[520])
          - U12*(I1[536] - I2[521])
          + (twozboz)*(I3[515] - AC0*I4[389])
          + (twozboz)*(I3[380] - AC1*I4[284])
          + (threezboz)*(I3[353] - AC2*I4[263]);
*(vp++) = U0*I0[390]
          - U10*(I1[390] - I2[516])
          - U11*(I1[516] - I2[521])
          - U12*(I1[537] - I2[522])
          + (twozboz)*(I3[516] - AC0*I4[390])
          + (twozboz)*(I3[381] - AC1*I4[285])
          + (threezboz)*(I3[354] - AC2*I4[264]);
*(vp++) = U0*I0[391]
          - U10*(I1[391] - I2[517])
          - U11*(I1[517] - I2[522])
          - U12*(I1[538] - I2[523])
          + (twozboz)*(I3[517] - AC0*I4[391])
          + (twozboz)*(I3[382] - AC1*I4[286])
          + (threezboz)*(I3[355] - AC2*I4[265]);
*(vp++) = U0*I0[392]
          - U10*(I1[392] - I2[518])
          - U11*(I1[518] - I2[523])
          - U12*(I1[539] - I2[524])
          + (twozboz)*(I3[518] - AC0*I4[392])
          + (twozboz)*(I3[383] - AC1*I4[287])
          + (threezboz)*(I3[356] - AC2*I4[266]);
*(vp++) = U0*I0[393]
          - U10*(I1[393] - I2[519])
          - U11*(I1[519] - I2[525])
          - U12*(I1[540] - I2[526])
          + (twozboz)*(I3[519] - AC0*I4[393])
          + (twozboz)*(I3[385] - AC1*I4[288])
          + (threezboz)*(I3[358] - AC2*I4[267]);
*(vp++) = U0*I0[394]
          - U10*(I1[394] - I2[520])
          - U11*(I1[520] - I2[526])
          - U12*(I1[541] - I2[527])
          + (twozboz)*(I3[520] - AC0*I4[394])
          + (twozboz)*(I3[386] - AC1*I4[289])
          + (threezboz)*(I3[359] - AC2*I4[268]);
*(vp++) = U0*I0[395]
          - U10*(I1[395] - I2[521])
          - U11*(I1[521] - I2[527])
          - U12*(I1[542] - I2[528])
          + (twozboz)*(I3[521] - AC0*I4[395])
          + (twozboz)*(I3[387] - AC1*I4[290])
          + (threezboz)*(I3[360] - AC2*I4[269]);
*(vp++) = U0*I0[396]
          - U10*(I1[396] - I2[522])
          - U11*(I1[522] - I2[528])
          - U12*(I1[543] - I2[529])
          + (twozboz)*(I3[522] - AC0*I4[396])
          + (twozboz)*(I3[388] - AC1*I4[291])
          + (threezboz)*(I3[361] - AC2*I4[270]);
*(vp++) = U0*I0[397]
          - U10*(I1[397] - I2[523])
          - U11*(I1[523] - I2[529])
          - U12*(I1[544] - I2[530])
          + (twozboz)*(I3[523] - AC0*I4[397])
          + (twozboz)*(I3[389] - AC1*I4[292])
          + (threezboz)*(I3[362] - AC2*I4[271]);
*(vp++) = U0*I0[398]
          - U10*(I1[398] - I2[524])
          - U11*(I1[524] - I2[530])
          - U12*(I1[545] - I2[531])
          + (twozboz)*(I3[524] - AC0*I4[398])
          + (twozboz)*(I3[390] - AC1*I4[293])
          + (threezboz)*(I3[363] - AC2*I4[272]);
*(vp++) = U0*I0[399]
          - U10*(I1[399] - I2[532])
          - U11*(I1[525] - I2[533])
          - U12*(I1[546] - I2[534])
          + (twozboz)*(I3[532] - AC0*I4[399])
          + (onezboz)*(I3[393] - AC1*I4[294])
          + (fourzboz)*(I3[366] - AC2*I4[273]);
*(vp++) = U0*I0[400]
          - U10*(I1[400] - I2[533])
          - U11*(I1[526] - I2[535])
          - U12*(I1[547] - I2[536])
          + (twozboz)*(I3[533] - AC0*I4[400])
          + (onezboz)*(I3[395] - AC1*I4[295])
          + (fourzboz)*(I3[368] - AC2*I4[274]);
*(vp++) = U0*I0[401]
          - U10*(I1[401] - I2[534])
          - U11*(I1[527] - I2[536])
          - U12*(I1[548] - I2[537])
          + (twozboz)*(I3[534] - AC0*I4[401])
          + (onezboz)*(I3[396] - AC1*I4[296])
          + (fourzboz)*(I3[369] - AC2*I4[275]);
*(vp++) = U0*I0[402]
          - U10*(I1[402] - I2[535])
          - U11*(I1[528] - I2[538])
          - U12*(I1[549] - I2[539])
          + (twozboz)*(I3[535] - AC0*I4[402])
          + (onezboz)*(I3[398] - AC1*I4[297])
          + (fourzboz)*(I3[371] - AC2*I4[276]);
*(vp++) = U0*I0[403]
          - U10*(I1[403] - I2[536])
          - U11*(I1[529] - I2[539])
          - U12*(I1[550] - I2[540])
          + (twozboz)*(I3[536] - AC0*I4[403])
          + (onezboz)*(I3[399] - AC1*I4[298])
          + (fourzboz)*(I3[372] - AC2*I4[277]);
*(vp++) = U0*I0[404]
          - U10*(I1[404] - I2[537])
          - U11*(I1[530] - I2[540])
          - U12*(I1[551] - I2[541])
          + (twozboz)*(I3[537] - AC0*I4[404])
          + (onezboz)*(I3[400] - AC1*I4[299])
          + (fourzboz)*(I3[373] - AC2*I4[278]);
*(vp++) = U0*I0[405]
          - U10*(I1[405] - I2[538])
          - U11*(I1[531] - I2[542])
          - U12*(I1[552] - I2[543])
          + (twozboz)*(I3[538] - AC0*I4[405])
          + (onezboz)*(I3[402] - AC1*I4[300])
          + (fourzboz)*(I3[375] - AC2*I4[279]);
*(vp++) = U0*I0[406]
          - U10*(I1[406] - I2[539])
          - U11*(I1[532] - I2[543])
          - U12*(I1[553] - I2[544])
          + (twozboz)*(I3[539] - AC0*I4[406])
          + (onezboz)*(I3[403] - AC1*I4[301])
          + (fourzboz)*(I3[376] - AC2*I4[280]);
*(vp++) = U0*I0[407]
          - U10*(I1[407] - I2[540])
          - U11*(I1[533] - I2[544])
          - U12*(I1[554] - I2[545])
          + (twozboz)*(I3[540] - AC0*I4[407])
          + (onezboz)*(I3[404] - AC1*I4[302])
          + (fourzboz)*(I3[377] - AC2*I4[281]);
*(vp++) = U0*I0[408]
          - U10*(I1[408] - I2[541])
          - U11*(I1[534] - I2[545])
          - U12*(I1[555] - I2[546])
          + (twozboz)*(I3[541] - AC0*I4[408])
          + (onezboz)*(I3[405] - AC1*I4[303])
          + (fourzboz)*(I3[378] - AC2*I4[282]);
*(vp++) = U0*I0[409]
          - U10*(I1[409] - I2[542])
          - U11*(I1[535] - I2[547])
          - U12*(I1[556] - I2[548])
          + (twozboz)*(I3[542] - AC0*I4[409])
          + (onezboz)*(I3[407] - AC1*I4[304])
          + (fourzboz)*(I3[380] - AC2*I4[283]);
*(vp++) = U0*I0[410]
          - U10*(I1[410] - I2[543])
          - U11*(I1[536] - I2[548])
          - U12*(I1[557] - I2[549])
          + (twozboz)*(I3[543] - AC0*I4[410])
          + (onezboz)*(I3[408] - AC1*I4[305])
          + (fourzboz)*(I3[381] - AC2*I4[284]);
*(vp++) = U0*I0[411]
          - U10*(I1[411] - I2[544])
          - U11*(I1[537] - I2[549])
          - U12*(I1[558] - I2[550])
          + (twozboz)*(I3[544] - AC0*I4[411])
          + (onezboz)*(I3[409] - AC1*I4[306])
          + (fourzboz)*(I3[382] - AC2*I4[285]);
*(vp++) = U0*I0[412]
          - U10*(I1[412] - I2[545])
          - U11*(I1[538] - I2[550])
          - U12*(I1[559] - I2[551])
          + (twozboz)*(I3[545] - AC0*I4[412])
          + (onezboz)*(I3[410] - AC1*I4[307])
          + (fourzboz)*(I3[383] - AC2*I4[286]);
*(vp++) = U0*I0[413]
          - U10*(I1[413] - I2[546])
          - U11*(I1[539] - I2[551])
          - U12*(I1[560] - I2[552])
          + (twozboz)*(I3[546] - AC0*I4[413])
          + (onezboz)*(I3[411] - AC1*I4[308])
          + (fourzboz)*(I3[384] - AC2*I4[287]);
*(vp++) = U0*I0[414]
          - U10*(I1[414] - I2[547])
          - U11*(I1[540] - I2[553])
          - U12*(I1[561] - I2[554])
          + (twozboz)*(I3[547] - AC0*I4[414])
          + (onezboz)*(I3[413] - AC1*I4[309])
          + (fourzboz)*(I3[386] - AC2*I4[288]);
*(vp++) = U0*I0[415]
          - U10*(I1[415] - I2[548])
          - U11*(I1[541] - I2[554])
          - U12*(I1[562] - I2[555])
          + (twozboz)*(I3[548] - AC0*I4[415])
          + (onezboz)*(I3[414] - AC1*I4[310])
          + (fourzboz)*(I3[387] - AC2*I4[289]);
*(vp++) = U0*I0[416]
          - U10*(I1[416] - I2[549])
          - U11*(I1[542] - I2[555])
          - U12*(I1[563] - I2[556])
          + (twozboz)*(I3[549] - AC0*I4[416])
          + (onezboz)*(I3[415] - AC1*I4[311])
          + (fourzboz)*(I3[388] - AC2*I4[290]);
*(vp++) = U0*I0[417]
          - U10*(I1[417] - I2[550])
          - U11*(I1[543] - I2[556])
          - U12*(I1[564] - I2[557])
          + (twozboz)*(I3[550] - AC0*I4[417])
          + (onezboz)*(I3[416] - AC1*I4[312])
          + (fourzboz)*(I3[389] - AC2*I4[291]);
*(vp++) = U0*I0[418]
          - U10*(I1[418] - I2[551])
          - U11*(I1[544] - I2[557])
          - U12*(I1[565] - I2[558])
          + (twozboz)*(I3[551] - AC0*I4[418])
          + (onezboz)*(I3[417] - AC1*I4[313])
          + (fourzboz)*(I3[390] - AC2*I4[292]);
*(vp++) = U0*I0[419]
          - U10*(I1[419] - I2[552])
          - U11*(I1[545] - I2[558])
          - U12*(I1[566] - I2[559])
          + (twozboz)*(I3[552] - AC0*I4[419])
          + (onezboz)*(I3[418] - AC1*I4[314])
          + (fourzboz)*(I3[391] - AC2*I4[293]);
*(vp++) = U0*I0[420]
          - U10*(I1[420] - I2[560])
          - U11*(I1[546] - I2[561])
          - U12*(I1[567] - I2[562])
          + (twozboz)*(I3[560] - AC0*I4[420])
          + (fivezboz)*(I3[394] - AC2*I4[294]);
*(vp++) = U0*I0[421]
          - U10*(I1[421] - I2[561])
          - U11*(I1[547] - I2[563])
          - U12*(I1[568] - I2[564])
          + (twozboz)*(I3[561] - AC0*I4[421])
          + (fivezboz)*(I3[396] - AC2*I4[295]);
*(vp++) = U0*I0[422]
          - U10*(I1[422] - I2[562])
          - U11*(I1[548] - I2[564])
          - U12*(I1[569] - I2[565])
          + (twozboz)*(I3[562] - AC0*I4[422])
          + (fivezboz)*(I3[397] - AC2*I4[296]);
*(vp++) = U0*I0[423]
          - U10*(I1[423] - I2[563])
          - U11*(I1[549] - I2[566])
          - U12*(I1[570] - I2[567])
          + (twozboz)*(I3[563] - AC0*I4[423])
          + (fivezboz)*(I3[399] - AC2*I4[297]);
*(vp++) = U0*I0[424]
          - U10*(I1[424] - I2[564])
          - U11*(I1[550] - I2[567])
          - U12*(I1[571] - I2[568])
          + (twozboz)*(I3[564] - AC0*I4[424])
          + (fivezboz)*(I3[400] - AC2*I4[298]);
*(vp++) = U0*I0[425]
          - U10*(I1[425] - I2[565])
          - U11*(I1[551] - I2[568])
          - U12*(I1[572] - I2[569])
          + (twozboz)*(I3[565] - AC0*I4[425])
          + (fivezboz)*(I3[401] - AC2*I4[299]);
*(vp++) = U0*I0[426]
          - U10*(I1[426] - I2[566])
          - U11*(I1[552] - I2[570])
          - U12*(I1[573] - I2[571])
          + (twozboz)*(I3[566] - AC0*I4[426])
          + (fivezboz)*(I3[403] - AC2*I4[300]);
*(vp++) = U0*I0[427]
          - U10*(I1[427] - I2[567])
          - U11*(I1[553] - I2[571])
          - U12*(I1[574] - I2[572])
          + (twozboz)*(I3[567] - AC0*I4[427])
          + (fivezboz)*(I3[404] - AC2*I4[301]);
*(vp++) = U0*I0[428]
          - U10*(I1[428] - I2[568])
          - U11*(I1[554] - I2[572])
          - U12*(I1[575] - I2[573])
          + (twozboz)*(I3[568] - AC0*I4[428])
          + (fivezboz)*(I3[405] - AC2*I4[302]);
*(vp++) = U0*I0[429]
          - U10*(I1[429] - I2[569])
          - U11*(I1[555] - I2[573])
          - U12*(I1[576] - I2[574])
          + (twozboz)*(I3[569] - AC0*I4[429])
          + (fivezboz)*(I3[406] - AC2*I4[303]);
*(vp++) = U0*I0[430]
          - U10*(I1[430] - I2[570])
          - U11*(I1[556] - I2[575])
          - U12*(I1[577] - I2[576])
          + (twozboz)*(I3[570] - AC0*I4[430])
          + (fivezboz)*(I3[408] - AC2*I4[304]);
*(vp++) = U0*I0[431]
          - U10*(I1[431] - I2[571])
          - U11*(I1[557] - I2[576])
          - U12*(I1[578] - I2[577])
          + (twozboz)*(I3[571] - AC0*I4[431])
          + (fivezboz)*(I3[409] - AC2*I4[305]);
*(vp++) = U0*I0[432]
          - U10*(I1[432] - I2[572])
          - U11*(I1[558] - I2[577])
          - U12*(I1[579] - I2[578])
          + (twozboz)*(I3[572] - AC0*I4[432])
          + (fivezboz)*(I3[410] - AC2*I4[306]);
*(vp++) = U0*I0[433]
          - U10*(I1[433] - I2[573])
          - U11*(I1[559] - I2[578])
          - U12*(I1[580] - I2[579])
          + (twozboz)*(I3[573] - AC0*I4[433])
          + (fivezboz)*(I3[411] - AC2*I4[307]);
*(vp++) = U0*I0[434]
          - U10*(I1[434] - I2[574])
          - U11*(I1[560] - I2[579])
          - U12*(I1[581] - I2[580])
          + (twozboz)*(I3[574] - AC0*I4[434])
          + (fivezboz)*(I3[412] - AC2*I4[308]);
*(vp++) = U0*I0[435]
          - U10*(I1[435] - I2[575])
          - U11*(I1[561] - I2[581])
          - U12*(I1[582] - I2[582])
          + (twozboz)*(I3[575] - AC0*I4[435])
          + (fivezboz)*(I3[414] - AC2*I4[309]);
*(vp++) = U0*I0[436]
          - U10*(I1[436] - I2[576])
          - U11*(I1[562] - I2[582])
          - U12*(I1[583] - I2[583])
          + (twozboz)*(I3[576] - AC0*I4[436])
          + (fivezboz)*(I3[415] - AC2*I4[310]);
*(vp++) = U0*I0[437]
          - U10*(I1[437] - I2[577])
          - U11*(I1[563] - I2[583])
          - U12*(I1[584] - I2[584])
          + (twozboz)*(I3[577] - AC0*I4[437])
          + (fivezboz)*(I3[416] - AC2*I4[311]);
*(vp++) = U0*I0[438]
          - U10*(I1[438] - I2[578])
          - U11*(I1[564] - I2[584])
          - U12*(I1[585] - I2[585])
          + (twozboz)*(I3[578] - AC0*I4[438])
          + (fivezboz)*(I3[417] - AC2*I4[312]);
*(vp++) = U0*I0[439]
          - U10*(I1[439] - I2[579])
          - U11*(I1[565] - I2[585])
          - U12*(I1[586] - I2[586])
          + (twozboz)*(I3[579] - AC0*I4[439])
          + (fivezboz)*(I3[418] - AC2*I4[313]);
*(vp++) = U0*I0[440]
          - U10*(I1[440] - I2[580])
          - U11*(I1[566] - I2[586])
          - U12*(I1[587] - I2[587])
          + (twozboz)*(I3[580] - AC0*I4[440])
          + (fivezboz)*(I3[419] - AC2*I4[314]);
*(vp++) = U0*I0[441]
          - U10*(I1[441] - I2[588])
          - U11*(I1[588] - I2[589])
          - U12*(I1[609] - I2[590])
          + (onezboz)*(I3[588] - AC0*I4[441])
          + (sixzboz)*(I3[421] - AC1*I4[315]);
*(vp++) = U0*I0[442]
          - U10*(I1[442] - I2[589])
          - U11*(I1[589] - I2[591])
          - U12*(I1[610] - I2[592])
          + (onezboz)*(I3[589] - AC0*I4[442])
          + (sixzboz)*(I3[423] - AC1*I4[316]);
*(vp++) = U0*I0[443]
          - U10*(I1[443] - I2[590])
          - U11*(I1[590] - I2[592])
          - U12*(I1[611] - I2[593])
          + (onezboz)*(I3[590] - AC0*I4[443])
          + (sixzboz)*(I3[424] - AC1*I4[317]);
*(vp++) = U0*I0[444]
          - U10*(I1[444] - I2[591])
          - U11*(I1[591] - I2[594])
          - U12*(I1[612] - I2[595])
          + (onezboz)*(I3[591] - AC0*I4[444])
          + (sixzboz)*(I3[426] - AC1*I4[318]);
*(vp++) = U0*I0[445]
          - U10*(I1[445] - I2[592])
          - U11*(I1[592] - I2[595])
          - U12*(I1[613] - I2[596])
          + (onezboz)*(I3[592] - AC0*I4[445])
          + (sixzboz)*(I3[427] - AC1*I4[319]);
*(vp++) = U0*I0[446]
          - U10*(I1[446] - I2[593])
          - U11*(I1[593] - I2[596])
          - U12*(I1[614] - I2[597])
          + (onezboz)*(I3[593] - AC0*I4[446])
          + (sixzboz)*(I3[428] - AC1*I4[320]);
*(vp++) = U0*I0[447]
          - U10*(I1[447] - I2[594])
          - U11*(I1[594] - I2[598])
          - U12*(I1[615] - I2[599])
          + (onezboz)*(I3[594] - AC0*I4[447])
          + (sixzboz)*(I3[430] - AC1*I4[321]);
*(vp++) = U0*I0[448]
          - U10*(I1[448] - I2[595])
          - U11*(I1[595] - I2[599])
          - U12*(I1[616] - I2[600])
          + (onezboz)*(I3[595] - AC0*I4[448])
          + (sixzboz)*(I3[431] - AC1*I4[322]);
*(vp++) = U0*I0[449]
          - U10*(I1[449] - I2[596])
          - U11*(I1[596] - I2[600])
          - U12*(I1[617] - I2[601])
          + (onezboz)*(I3[596] - AC0*I4[449])
          + (sixzboz)*(I3[432] - AC1*I4[323]);
*(vp++) = U0*I0[450]
          - U10*(I1[450] - I2[597])
          - U11*(I1[597] - I2[601])
          - U12*(I1[618] - I2[602])
          + (onezboz)*(I3[597] - AC0*I4[450])
          + (sixzboz)*(I3[433] - AC1*I4[324]);
*(vp++) = U0*I0[451]
          - U10*(I1[451] - I2[598])
          - U11*(I1[598] - I2[603])
          - U12*(I1[619] - I2[604])
          + (onezboz)*(I3[598] - AC0*I4[451])
          + (sixzboz)*(I3[435] - AC1*I4[325]);
*(vp++) = U0*I0[452]
          - U10*(I1[452] - I2[599])
          - U11*(I1[599] - I2[604])
          - U12*(I1[620] - I2[605])
          + (onezboz)*(I3[599] - AC0*I4[452])
          + (sixzboz)*(I3[436] - AC1*I4[326]);
*(vp++) = U0*I0[453]
          - U10*(I1[453] - I2[600])
          - U11*(I1[600] - I2[605])
          - U12*(I1[621] - I2[606])
          + (onezboz)*(I3[600] - AC0*I4[453])
          + (sixzboz)*(I3[437] - AC1*I4[327]);
*(vp++) = U0*I0[454]
          - U10*(I1[454] - I2[601])
          - U11*(I1[601] - I2[606])
          - U12*(I1[622] - I2[607])
          + (onezboz)*(I3[601] - AC0*I4[454])
          + (sixzboz)*(I3[438] - AC1*I4[328]);
*(vp++) = U0*I0[455]
          - U10*(I1[455] - I2[602])
          - U11*(I1[602] - I2[607])
          - U12*(I1[623] - I2[608])
          + (onezboz)*(I3[602] - AC0*I4[455])
          + (sixzboz)*(I3[439] - AC1*I4[329]);
*(vp++) = U0*I0[456]
          - U10*(I1[456] - I2[603])
          - U11*(I1[603] - I2[609])
          - U12*(I1[624] - I2[610])
          + (onezboz)*(I3[603] - AC0*I4[456])
          + (sixzboz)*(I3[441] - AC1*I4[330]);
*(vp++) = U0*I0[457]
          - U10*(I1[457] - I2[604])
          - U11*(I1[604] - I2[610])
          - U12*(I1[625] - I2[611])
          + (onezboz)*(I3[604] - AC0*I4[457])
          + (sixzboz)*(I3[442] - AC1*I4[331]);
*(vp++) = U0*I0[458]
          - U10*(I1[458] - I2[605])
          - U11*(I1[605] - I2[611])
          - U12*(I1[626] - I2[612])
          + (onezboz)*(I3[605] - AC0*I4[458])
          + (sixzboz)*(I3[443] - AC1*I4[332]);
*(vp++) = U0*I0[459]
          - U10*(I1[459] - I2[606])
          - U11*(I1[606] - I2[612])
          - U12*(I1[627] - I2[613])
          + (onezboz)*(I3[606] - AC0*I4[459])
          + (sixzboz)*(I3[444] - AC1*I4[333]);
*(vp++) = U0*I0[460]
          - U10*(I1[460] - I2[607])
          - U11*(I1[607] - I2[613])
          - U12*(I1[628] - I2[614])
          + (onezboz)*(I3[607] - AC0*I4[460])
          + (sixzboz)*(I3[445] - AC1*I4[334]);
*(vp++) = U0*I0[461]
          - U10*(I1[461] - I2[608])
          - U11*(I1[608] - I2[614])
          - U12*(I1[629] - I2[615])
          + (onezboz)*(I3[608] - AC0*I4[461])
          + (sixzboz)*(I3[446] - AC1*I4[335]);
*(vp++) = U0*I0[462]
          - U10*(I1[462] - I2[616])
          - U11*(I1[609] - I2[617])
          - U12*(I1[630] - I2[618])
          + (onezboz)*(I3[616] - AC0*I4[462])
          + (fivezboz)*(I3[449] - AC1*I4[336])
          + (onezboz)*(I3[422] - AC2*I4[315]);
*(vp++) = U0*I0[463]
          - U10*(I1[463] - I2[617])
          - U11*(I1[610] - I2[619])
          - U12*(I1[631] - I2[620])
          + (onezboz)*(I3[617] - AC0*I4[463])
          + (fivezboz)*(I3[451] - AC1*I4[337])
          + (onezboz)*(I3[424] - AC2*I4[316]);
*(vp++) = U0*I0[464]
          - U10*(I1[464] - I2[618])
          - U11*(I1[611] - I2[620])
          - U12*(I1[632] - I2[621])
          + (onezboz)*(I3[618] - AC0*I4[464])
          + (fivezboz)*(I3[452] - AC1*I4[338])
          + (onezboz)*(I3[425] - AC2*I4[317]);
*(vp++) = U0*I0[465]
          - U10*(I1[465] - I2[619])
          - U11*(I1[612] - I2[622])
          - U12*(I1[633] - I2[623])
          + (onezboz)*(I3[619] - AC0*I4[465])
          + (fivezboz)*(I3[454] - AC1*I4[339])
          + (onezboz)*(I3[427] - AC2*I4[318]);
*(vp++) = U0*I0[466]
          - U10*(I1[466] - I2[620])
          - U11*(I1[613] - I2[623])
          - U12*(I1[634] - I2[624])
          + (onezboz)*(I3[620] - AC0*I4[466])
          + (fivezboz)*(I3[455] - AC1*I4[340])
          + (onezboz)*(I3[428] - AC2*I4[319]);
*(vp++) = U0*I0[467]
          - U10*(I1[467] - I2[621])
          - U11*(I1[614] - I2[624])
          - U12*(I1[635] - I2[625])
          + (onezboz)*(I3[621] - AC0*I4[467])
          + (fivezboz)*(I3[456] - AC1*I4[341])
          + (onezboz)*(I3[429] - AC2*I4[320]);
*(vp++) = U0*I0[468]
          - U10*(I1[468] - I2[622])
          - U11*(I1[615] - I2[626])
          - U12*(I1[636] - I2[627])
          + (onezboz)*(I3[622] - AC0*I4[468])
          + (fivezboz)*(I3[458] - AC1*I4[342])
          + (onezboz)*(I3[431] - AC2*I4[321]);
*(vp++) = U0*I0[469]
          - U10*(I1[469] - I2[623])
          - U11*(I1[616] - I2[627])
          - U12*(I1[637] - I2[628])
          + (onezboz)*(I3[623] - AC0*I4[469])
          + (fivezboz)*(I3[459] - AC1*I4[343])
          + (onezboz)*(I3[432] - AC2*I4[322]);
*(vp++) = U0*I0[470]
          - U10*(I1[470] - I2[624])
          - U11*(I1[617] - I2[628])
          - U12*(I1[638] - I2[629])
          + (onezboz)*(I3[624] - AC0*I4[470])
          + (fivezboz)*(I3[460] - AC1*I4[344])
          + (onezboz)*(I3[433] - AC2*I4[323]);
*(vp++) = U0*I0[471]
          - U10*(I1[471] - I2[625])
          - U11*(I1[618] - I2[629])
          - U12*(I1[639] - I2[630])
          + (onezboz)*(I3[625] - AC0*I4[471])
          + (fivezboz)*(I3[461] - AC1*I4[345])
          + (onezboz)*(I3[434] - AC2*I4[324]);
*(vp++) = U0*I0[472]
          - U10*(I1[472] - I2[626])
          - U11*(I1[619] - I2[631])
          - U12*(I1[640] - I2[632])
          + (onezboz)*(I3[626] - AC0*I4[472])
          + (fivezboz)*(I3[463] - AC1*I4[346])
          + (onezboz)*(I3[436] - AC2*I4[325]);
*(vp++) = U0*I0[473]
          - U10*(I1[473] - I2[627])
          - U11*(I1[620] - I2[632])
          - U12*(I1[641] - I2[633])
          + (onezboz)*(I3[627] - AC0*I4[473])
          + (fivezboz)*(I3[464] - AC1*I4[347])
          + (onezboz)*(I3[437] - AC2*I4[326]);
*(vp++) = U0*I0[474]
          - U10*(I1[474] - I2[628])
          - U11*(I1[621] - I2[633])
          - U12*(I1[642] - I2[634])
          + (onezboz)*(I3[628] - AC0*I4[474])
          + (fivezboz)*(I3[465] - AC1*I4[348])
          + (onezboz)*(I3[438] - AC2*I4[327]);
*(vp++) = U0*I0[475]
          - U10*(I1[475] - I2[629])
          - U11*(I1[622] - I2[634])
          - U12*(I1[643] - I2[635])
          + (onezboz)*(I3[629] - AC0*I4[475])
          + (fivezboz)*(I3[466] - AC1*I4[349])
          + (onezboz)*(I3[439] - AC2*I4[328]);
*(vp++) = U0*I0[476]
          - U10*(I1[476] - I2[630])
          - U11*(I1[623] - I2[635])
          - U12*(I1[644] - I2[636])
          + (onezboz)*(I3[630] - AC0*I4[476])
          + (fivezboz)*(I3[467] - AC1*I4[350])
          + (onezboz)*(I3[440] - AC2*I4[329]);
*(vp++) = U0*I0[477]
          - U10*(I1[477] - I2[631])
          - U11*(I1[624] - I2[637])
          - U12*(I1[645] - I2[638])
          + (onezboz)*(I3[631] - AC0*I4[477])
          + (fivezboz)*(I3[469] - AC1*I4[351])
          + (onezboz)*(I3[442] - AC2*I4[330]);
*(vp++) = U0*I0[478]
          - U10*(I1[478] - I2[632])
          - U11*(I1[625] - I2[638])
          - U12*(I1[646] - I2[639])
          + (onezboz)*(I3[632] - AC0*I4[478])
          + (fivezboz)*(I3[470] - AC1*I4[352])
          + (onezboz)*(I3[443] - AC2*I4[331]);
*(vp++) = U0*I0[479]
          - U10*(I1[479] - I2[633])
          - U11*(I1[626] - I2[639])
          - U12*(I1[647] - I2[640])
          + (onezboz)*(I3[633] - AC0*I4[479])
          + (fivezboz)*(I3[471] - AC1*I4[353])
          + (onezboz)*(I3[444] - AC2*I4[332]);
*(vp++) = U0*I0[480]
          - U10*(I1[480] - I2[634])
          - U11*(I1[627] - I2[640])
          - U12*(I1[648] - I2[641])
          + (onezboz)*(I3[634] - AC0*I4[480])
          + (fivezboz)*(I3[472] - AC1*I4[354])
          + (onezboz)*(I3[445] - AC2*I4[333]);
*(vp++) = U0*I0[481]
          - U10*(I1[481] - I2[635])
          - U11*(I1[628] - I2[641])
          - U12*(I1[649] - I2[642])
          + (onezboz)*(I3[635] - AC0*I4[481])
          + (fivezboz)*(I3[473] - AC1*I4[355])
          + (onezboz)*(I3[446] - AC2*I4[334]);
*(vp++) = U0*I0[482]
          - U10*(I1[482] - I2[636])
          - U11*(I1[629] - I2[642])
          - U12*(I1[650] - I2[643])
          + (onezboz)*(I3[636] - AC0*I4[482])
          + (fivezboz)*(I3[474] - AC1*I4[356])
          + (onezboz)*(I3[447] - AC2*I4[335]);
*(vp++) = U0*I0[483]
          - U10*(I1[483] - I2[644])
          - U11*(I1[630] - I2[645])
          - U12*(I1[651] - I2[646])
          + (onezboz)*(I3[644] - AC0*I4[483])
          + (fourzboz)*(I3[477] - AC1*I4[357])
          + (twozboz)*(I3[450] - AC2*I4[336]);
*(vp++) = U0*I0[484]
          - U10*(I1[484] - I2[645])
          - U11*(I1[631] - I2[647])
          - U12*(I1[652] - I2[648])
          + (onezboz)*(I3[645] - AC0*I4[484])
          + (fourzboz)*(I3[479] - AC1*I4[358])
          + (twozboz)*(I3[452] - AC2*I4[337]);
*(vp++) = U0*I0[485]
          - U10*(I1[485] - I2[646])
          - U11*(I1[632] - I2[648])
          - U12*(I1[653] - I2[649])
          + (onezboz)*(I3[646] - AC0*I4[485])
          + (fourzboz)*(I3[480] - AC1*I4[359])
          + (twozboz)*(I3[453] - AC2*I4[338]);
*(vp++) = U0*I0[486]
          - U10*(I1[486] - I2[647])
          - U11*(I1[633] - I2[650])
          - U12*(I1[654] - I2[651])
          + (onezboz)*(I3[647] - AC0*I4[486])
          + (fourzboz)*(I3[482] - AC1*I4[360])
          + (twozboz)*(I3[455] - AC2*I4[339]);
*(vp++) = U0*I0[487]
          - U10*(I1[487] - I2[648])
          - U11*(I1[634] - I2[651])
          - U12*(I1[655] - I2[652])
          + (onezboz)*(I3[648] - AC0*I4[487])
          + (fourzboz)*(I3[483] - AC1*I4[361])
          + (twozboz)*(I3[456] - AC2*I4[340]);
*(vp++) = U0*I0[488]
          - U10*(I1[488] - I2[649])
          - U11*(I1[635] - I2[652])
          - U12*(I1[656] - I2[653])
          + (onezboz)*(I3[649] - AC0*I4[488])
          + (fourzboz)*(I3[484] - AC1*I4[362])
          + (twozboz)*(I3[457] - AC2*I4[341]);
*(vp++) = U0*I0[489]
          - U10*(I1[489] - I2[650])
          - U11*(I1[636] - I2[654])
          - U12*(I1[657] - I2[655])
          + (onezboz)*(I3[650] - AC0*I4[489])
          + (fourzboz)*(I3[486] - AC1*I4[363])
          + (twozboz)*(I3[459] - AC2*I4[342]);
*(vp++) = U0*I0[490]
          - U10*(I1[490] - I2[651])
          - U11*(I1[637] - I2[655])
          - U12*(I1[658] - I2[656])
          + (onezboz)*(I3[651] - AC0*I4[490])
          + (fourzboz)*(I3[487] - AC1*I4[364])
          + (twozboz)*(I3[460] - AC2*I4[343]);
*(vp++) = U0*I0[491]
          - U10*(I1[491] - I2[652])
          - U11*(I1[638] - I2[656])
          - U12*(I1[659] - I2[657])
          + (onezboz)*(I3[652] - AC0*I4[491])
          + (fourzboz)*(I3[488] - AC1*I4[365])
          + (twozboz)*(I3[461] - AC2*I4[344]);
*(vp++) = U0*I0[492]
          - U10*(I1[492] - I2[653])
          - U11*(I1[639] - I2[657])
          - U12*(I1[660] - I2[658])
          + (onezboz)*(I3[653] - AC0*I4[492])
          + (fourzboz)*(I3[489] - AC1*I4[366])
          + (twozboz)*(I3[462] - AC2*I4[345]);
*(vp++) = U0*I0[493]
          - U10*(I1[493] - I2[654])
          - U11*(I1[640] - I2[659])
          - U12*(I1[661] - I2[660])
          + (onezboz)*(I3[654] - AC0*I4[493])
          + (fourzboz)*(I3[491] - AC1*I4[367])
          + (twozboz)*(I3[464] - AC2*I4[346]);
*(vp++) = U0*I0[494]
          - U10*(I1[494] - I2[655])
          - U11*(I1[641] - I2[660])
          - U12*(I1[662] - I2[661])
          + (onezboz)*(I3[655] - AC0*I4[494])
          + (fourzboz)*(I3[492] - AC1*I4[368])
          + (twozboz)*(I3[465] - AC2*I4[347]);
*(vp++) = U0*I0[495]
          - U10*(I1[495] - I2[656])
          - U11*(I1[642] - I2[661])
          - U12*(I1[663] - I2[662])
          + (onezboz)*(I3[656] - AC0*I4[495])
          + (fourzboz)*(I3[493] - AC1*I4[369])
          + (twozboz)*(I3[466] - AC2*I4[348]);
*(vp++) = U0*I0[496]
          - U10*(I1[496] - I2[657])
          - U11*(I1[643] - I2[662])
          - U12*(I1[664] - I2[663])
          + (onezboz)*(I3[657] - AC0*I4[496])
          + (fourzboz)*(I3[494] - AC1*I4[370])
          + (twozboz)*(I3[467] - AC2*I4[349]);
*(vp++) = U0*I0[497]
          - U10*(I1[497] - I2[658])
          - U11*(I1[644] - I2[663])
          - U12*(I1[665] - I2[664])
          + (onezboz)*(I3[658] - AC0*I4[497])
          + (fourzboz)*(I3[495] - AC1*I4[371])
          + (twozboz)*(I3[468] - AC2*I4[350]);
*(vp++) = U0*I0[498]
          - U10*(I1[498] - I2[659])
          - U11*(I1[645] - I2[665])
          - U12*(I1[666] - I2[666])
          + (onezboz)*(I3[659] - AC0*I4[498])
          + (fourzboz)*(I3[497] - AC1*I4[372])
          + (twozboz)*(I3[470] - AC2*I4[351]);
*(vp++) = U0*I0[499]
          - U10*(I1[499] - I2[660])
          - U11*(I1[646] - I2[666])
          - U12*(I1[667] - I2[667])
          + (onezboz)*(I3[660] - AC0*I4[499])
          + (fourzboz)*(I3[498] - AC1*I4[373])
          + (twozboz)*(I3[471] - AC2*I4[352]);
*(vp++) = U0*I0[500]
          - U10*(I1[500] - I2[661])
          - U11*(I1[647] - I2[667])
          - U12*(I1[668] - I2[668])
          + (onezboz)*(I3[661] - AC0*I4[500])
          + (fourzboz)*(I3[499] - AC1*I4[374])
          + (twozboz)*(I3[472] - AC2*I4[353]);
*(vp++) = U0*I0[501]
          - U10*(I1[501] - I2[662])
          - U11*(I1[648] - I2[668])
          - U12*(I1[669] - I2[669])
          + (onezboz)*(I3[662] - AC0*I4[501])
          + (fourzboz)*(I3[500] - AC1*I4[375])
          + (twozboz)*(I3[473] - AC2*I4[354]);
*(vp++) = U0*I0[502]
          - U10*(I1[502] - I2[663])
          - U11*(I1[649] - I2[669])
          - U12*(I1[670] - I2[670])
          + (onezboz)*(I3[663] - AC0*I4[502])
          + (fourzboz)*(I3[501] - AC1*I4[376])
          + (twozboz)*(I3[474] - AC2*I4[355]);
*(vp++) = U0*I0[503]
          - U10*(I1[503] - I2[664])
          - U11*(I1[650] - I2[670])
          - U12*(I1[671] - I2[671])
          + (onezboz)*(I3[664] - AC0*I4[503])
          + (fourzboz)*(I3[502] - AC1*I4[377])
          + (twozboz)*(I3[475] - AC2*I4[356]);
*(vp++) = U0*I0[504]
          - U10*(I1[504] - I2[672])
          - U11*(I1[651] - I2[673])
          - U12*(I1[672] - I2[674])
          + (onezboz)*(I3[672] - AC0*I4[504])
          + (threezboz)*(I3[505] - AC1*I4[378])
          + (threezboz)*(I3[478] - AC2*I4[357]);
*(vp++) = U0*I0[505]
          - U10*(I1[505] - I2[673])
          - U11*(I1[652] - I2[675])
          - U12*(I1[673] - I2[676])
          + (onezboz)*(I3[673] - AC0*I4[505])
          + (threezboz)*(I3[507] - AC1*I4[379])
          + (threezboz)*(I3[480] - AC2*I4[358]);
return vp;
}

REALTYPE *_t1_build_k0h0_2(prim_data *Data, contr_data *ShellData, REALTYPE *vp, const REALTYPE *I0, const REALTYPE *I1, const REALTYPE *I2, const REALTYPE *I3, const REALTYPE *I4)
{
  REALTYPE U0, U10, U11, U12;
  REALTYPE AC0, AC1, AC2;
  REALTYPE onezboz;
  REALTYPE twozboz;
  REALTYPE threezboz;
  REALTYPE fourzboz;
  REALTYPE fivezboz;
  REALTYPE sixzboz;
  REALTYPE sevenzboz;
  AC0 = ShellData->AC[0];
  AC1 = ShellData->AC[1];
  AC2 = ShellData->AC[2];
  onezboz = 1.0*(Data->twozeta_b*Data->oo2z);
  twozboz = 2.0*(Data->twozeta_b*Data->oo2z);
  threezboz = 3.0*(Data->twozeta_b*Data->oo2z);
  fourzboz = 4.0*(Data->twozeta_b*Data->oo2z);
  fivezboz = 5.0*(Data->twozeta_b*Data->oo2z);
  sixzboz = 6.0*(Data->twozeta_b*Data->oo2z);
  sevenzboz = 7.0*(Data->twozeta_b*Data->oo2z);
  U10 = ShellData->AB[0]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U11 = ShellData->AB[1]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U12 = ShellData->AB[2]*(Data->twozeta_a*Data->twozeta_b*Data->oo2z);
  U0  = (Data->twozeta_a - Data->twozeta_b*(Data->twozeta_a*ShellData->ABdotAC + 8.000000))*Data->oo2z;

*(vp++) = U0*I0[506]
          - U10*(I1[506] - I2[674])
          - U11*(I1[653] - I2[676])
          - U12*(I1[674] - I2[677])
          + (onezboz)*(I3[674] - AC0*I4[506])
          + (threezboz)*(I3[508] - AC1*I4[380])
          + (threezboz)*(I3[481] - AC2*I4[359]);
*(vp++) = U0*I0[507]
          - U10*(I1[507] - I2[675])
          - U11*(I1[654] - I2[678])
          - U12*(I1[675] - I2[679])
          + (onezboz)*(I3[675] - AC0*I4[507])
          + (threezboz)*(I3[510] - AC1*I4[381])
          + (threezboz)*(I3[483] - AC2*I4[360]);
*(vp++) = U0*I0[508]
          - U10*(I1[508] - I2[676])
          - U11*(I1[655] - I2[679])
          - U12*(I1[676] - I2[680])
          + (onezboz)*(I3[676] - AC0*I4[508])
          + (threezboz)*(I3[511] - AC1*I4[382])
          + (threezboz)*(I3[484] - AC2*I4[361]);
*(vp++) = U0*I0[509]
          - U10*(I1[509] - I2[677])
          - U11*(I1[656] - I2[680])
          - U12*(I1[677] - I2[681])
          + (onezboz)*(I3[677] - AC0*I4[509])
          + (threezboz)*(I3[512] - AC1*I4[383])
          + (threezboz)*(I3[485] - AC2*I4[362]);
*(vp++) = U0*I0[510]
          - U10*(I1[510] - I2[678])
          - U11*(I1[657] - I2[682])
          - U12*(I1[678] - I2[683])
          + (onezboz)*(I3[678] - AC0*I4[510])
          + (threezboz)*(I3[514] - AC1*I4[384])
          + (threezboz)*(I3[487] - AC2*I4[363]);
*(vp++) = U0*I0[511]
          - U10*(I1[511] - I2[679])
          - U11*(I1[658] - I2[683])
          - U12*(I1[679] - I2[684])
          + (onezboz)*(I3[679] - AC0*I4[511])
          + (threezboz)*(I3[515] - AC1*I4[385])
          + (threezboz)*(I3[488] - AC2*I4[364]);
*(vp++) = U0*I0[512]
          - U10*(I1[512] - I2[680])
          - U11*(I1[659] - I2[684])
          - U12*(I1[680] - I2[685])
          + (onezboz)*(I3[680] - AC0*I4[512])
          + (threezboz)*(I3[516] - AC1*I4[386])
          + (threezboz)*(I3[489] - AC2*I4[365]);
*(vp++) = U0*I0[513]
          - U10*(I1[513] - I2[681])
          - U11*(I1[660] - I2[685])
          - U12*(I1[681] - I2[686])
          + (onezboz)*(I3[681] - AC0*I4[513])
          + (threezboz)*(I3[517] - AC1*I4[387])
          + (threezboz)*(I3[490] - AC2*I4[366]);
*(vp++) = U0*I0[514]
          - U10*(I1[514] - I2[682])
          - U11*(I1[661] - I2[687])
          - U12*(I1[682] - I2[688])
          + (onezboz)*(I3[682] - AC0*I4[514])
          + (threezboz)*(I3[519] - AC1*I4[388])
          + (threezboz)*(I3[492] - AC2*I4[367]);
*(vp++) = U0*I0[515]
          - U10*(I1[515] - I2[683])
          - U11*(I1[662] - I2[688])
          - U12*(I1[683] - I2[689])
          + (onezboz)*(I3[683] - AC0*I4[515])
          + (threezboz)*(I3[520] - AC1*I4[389])
          + (threezboz)*(I3[493] - AC2*I4[368]);
*(vp++) = U0*I0[516]
          - U10*(I1[516] - I2[684])
          - U11*(I1[663] - I2[689])
          - U12*(I1[684] - I2[690])
          + (onezboz)*(I3[684] - AC0*I4[516])
          + (threezboz)*(I3[521] - AC1*I4[390])
          + (threezboz)*(I3[494] - AC2*I4[369]);
*(vp++) = U0*I0[517]
          - U10*(I1[517] - I2[685])
          - U11*(I1[664] - I2[690])
          - U12*(I1[685] - I2[691])
          + (onezboz)*(I3[685] - AC0*I4[517])
          + (threezboz)*(I3[522] - AC1*I4[391])
          + (threezboz)*(I3[495] - AC2*I4[370]);
*(vp++) = U0*I0[518]
          - U10*(I1[518] - I2[686])
          - U11*(I1[665] - I2[691])
          - U12*(I1[686] - I2[692])
          + (onezboz)*(I3[686] - AC0*I4[518])
          + (threezboz)*(I3[523] - AC1*I4[392])
          + (threezboz)*(I3[496] - AC2*I4[371]);
*(vp++) = U0*I0[519]
          - U10*(I1[519] - I2[687])
          - U11*(I1[666] - I2[693])
          - U12*(I1[687] - I2[694])
          + (onezboz)*(I3[687] - AC0*I4[519])
          + (threezboz)*(I3[525] - AC1*I4[393])
          + (threezboz)*(I3[498] - AC2*I4[372]);
*(vp++) = U0*I0[520]
          - U10*(I1[520] - I2[688])
          - U11*(I1[667] - I2[694])
          - U12*(I1[688] - I2[695])
          + (onezboz)*(I3[688] - AC0*I4[520])
          + (threezboz)*(I3[526] - AC1*I4[394])
          + (threezboz)*(I3[499] - AC2*I4[373]);
*(vp++) = U0*I0[521]
          - U10*(I1[521] - I2[689])
          - U11*(I1[668] - I2[695])
          - U12*(I1[689] - I2[696])
          + (onezboz)*(I3[689] - AC0*I4[521])
          + (threezboz)*(I3[527] - AC1*I4[395])
          + (threezboz)*(I3[500] - AC2*I4[374]);
*(vp++) = U0*I0[522]
          - U10*(I1[522] - I2[690])
          - U11*(I1[669] - I2[696])
          - U12*(I1[690] - I2[697])
          + (onezboz)*(I3[690] - AC0*I4[522])
          + (threezboz)*(I3[528] - AC1*I4[396])
          + (threezboz)*(I3[501] - AC2*I4[375]);
*(vp++) = U0*I0[523]
          - U10*(I1[523] - I2[691])
          - U11*(I1[670] - I2[697])
          - U12*(I1[691] - I2[698])
          + (onezboz)*(I3[691] - AC0*I4[523])
          + (threezboz)*(I3[529] - AC1*I4[397])
          + (threezboz)*(I3[502] - AC2*I4[376]);
*(vp++) = U0*I0[524]
          - U10*(I1[524] - I2[692])
          - U11*(I1[671] - I2[698])
          - U12*(I1[692] - I2[699])
          + (onezboz)*(I3[692] - AC0*I4[524])
          + (threezboz)*(I3[530] - AC1*I4[398])
          + (threezboz)*(I3[503] - AC2*I4[377]);
*(vp++) = U0*I0[525]
          - U10*(I1[525] - I2[700])
          - U11*(I1[672] - I2[701])
          - U12*(I1[693] - I2[702])
          + (onezboz)*(I3[700] - AC0*I4[525])
          + (twozboz)*(I3[533] - AC1*I4[399])
          + (fourzboz)*(I3[506] - AC2*I4[378]);
*(vp++) = U0*I0[526]
          - U10*(I1[526] - I2[701])
          - U11*(I1[673] - I2[703])
          - U12*(I1[694] - I2[704])
          + (onezboz)*(I3[701] - AC0*I4[526])
          + (twozboz)*(I3[535] - AC1*I4[400])
          + (fourzboz)*(I3[508] - AC2*I4[379]);
*(vp++) = U0*I0[527]
          - U10*(I1[527] - I2[702])
          - U11*(I1[674] - I2[704])
          - U12*(I1[695] - I2[705])
          + (onezboz)*(I3[702] - AC0*I4[527])
          + (twozboz)*(I3[536] - AC1*I4[401])
          + (fourzboz)*(I3[509] - AC2*I4[380]);
*(vp++) = U0*I0[528]
          - U10*(I1[528] - I2[703])
          - U11*(I1[675] - I2[706])
          - U12*(I1[696] - I2[707])
          + (onezboz)*(I3[703] - AC0*I4[528])
          + (twozboz)*(I3[538] - AC1*I4[402])
          + (fourzboz)*(I3[511] - AC2*I4[381]);
*(vp++) = U0*I0[529]
          - U10*(I1[529] - I2[704])
          - U11*(I1[676] - I2[707])
          - U12*(I1[697] - I2[708])
          + (onezboz)*(I3[704] - AC0*I4[529])
          + (twozboz)*(I3[539] - AC1*I4[403])
          + (fourzboz)*(I3[512] - AC2*I4[382]);
*(vp++) = U0*I0[530]
          - U10*(I1[530] - I2[705])
          - U11*(I1[677] - I2[708])
          - U12*(I1[698] - I2[709])
          + (onezboz)*(I3[705] - AC0*I4[530])
          + (twozboz)*(I3[540] - AC1*I4[404])
          + (fourzboz)*(I3[513] - AC2*I4[383]);
*(vp++) = U0*I0[531]
          - U10*(I1[531] - I2[706])
          - U11*(I1[678] - I2[710])
          - U12*(I1[699] - I2[711])
          + (onezboz)*(I3[706] - AC0*I4[531])
          + (twozboz)*(I3[542] - AC1*I4[405])
          + (fourzboz)*(I3[515] - AC2*I4[384]);
*(vp++) = U0*I0[532]
          - U10*(I1[532] - I2[707])
          - U11*(I1[679] - I2[711])
          - U12*(I1[700] - I2[712])
          + (onezboz)*(I3[707] - AC0*I4[532])
          + (twozboz)*(I3[543] - AC1*I4[406])
          + (fourzboz)*(I3[516] - AC2*I4[385]);
*(vp++) = U0*I0[533]
          - U10*(I1[533] - I2[708])
          - U11*(I1[680] - I2[712])
          - U12*(I1[701] - I2[713])
          + (onezboz)*(I3[708] - AC0*I4[533])
          + (twozboz)*(I3[544] - AC1*I4[407])
          + (fourzboz)*(I3[517] - AC2*I4[386]);
*(vp++) = U0*I0[534]
          - U10*(I1[534] - I2[709])
          - U11*(I1[681] - I2[713])
          - U12*(I1[702] - I2[714])
          + (onezboz)*(I3[709] - AC0*I4[534])
          + (twozboz)*(I3[545] - AC1*I4[408])
          + (fourzboz)*(I3[518] - AC2*I4[387]);
*(vp++) = U0*I0[535]
          - U10*(I1[535] - I2[710])
          - U11*(I1[682] - I2[715])
          - U12*(I1[703] - I2[716])
          + (onezboz)*(I3[710] - AC0*I4[535])
          + (twozboz)*(I3[547] - AC1*I4[409])
          + (fourzboz)*(I3[520] - AC2*I4[388]);
*(vp++) = U0*I0[536]
          - U10*(I1[536] - I2[711])
          - U11*(I1[683] - I2[716])
          - U12*(I1[704] - I2[717])
          + (onezboz)*(I3[711] - AC0*I4[536])
          + (twozboz)*(I3[548] - AC1*I4[410])
          + (fourzboz)*(I3[521] - AC2*I4[389]);
*(vp++) = U0*I0[537]
          - U10*(I1[537] - I2[712])
          - U11*(I1[684] - I2[717])
          - U12*(I1[705] - I2[718])
          + (onezboz)*(I3[712] - AC0*I4[537])
          + (twozboz)*(I3[549] - AC1*I4[411])
          + (fourzboz)*(I3[522] - AC2*I4[390]);
*(vp++) = U0*I0[538]
          - U10*(I1[538] - I2[713])
          - U11*(I1[685] - I2[718])
          - U12*(I1[706] - I2[719])
          + (onezboz)*(I3[713] - AC0*I4[538])
          + (twozboz)*(I3[550] - AC1*I4[412])
          + (fourzboz)*(I3[523] - AC2*I4[391]);
*(vp++) = U0*I0[539]
          - U10*(I1[539] - I2[714])
          - U11*(I1[686] - I2[719])
          - U12*(I1[707] - I2[720])
          + (onezboz)*(I3[714] - AC0*I4[539])
          + (twozboz)*(I3[551] - AC1*I4[413])
          + (fourzboz)*(I3[524] - AC2*I4[392]);
*(vp++) = U0*I0[540]
          - U10*(I1[540] - I2[715])
          - U11*(I1[687] - I2[721])
          - U12*(I1[708] - I2[722])
          + (onezboz)*(I3[715] - AC0*I4[540])
          + (twozboz)*(I3[553] - AC1*I4[414])
          + (fourzboz)*(I3[526] - AC2*I4[393]);
*(vp++) = U0*I0[541]
          - U10*(I1[541] - I2[716])
          - U11*(I1[688] - I2[722])
          - U12*(I1[709] - I2[723])
          + (onezboz)*(I3[716] - AC0*I4[541])
          + (twozboz)*(I3[554] - AC1*I4[415])
          + (fourzboz)*(I3[527] - AC2*I4[394]);
*(vp++) = U0*I0[542]
          - U10*(I1[542] - I2[717])
          - U11*(I1[689] - I2[723])
          - U12*(I1[710] - I2[724])
          + (onezboz)*(I3[717] - AC0*I4[542])
          + (twozboz)*(I3[555] - AC1*I4[416])
          + (fourzboz)*(I3[528] - AC2*I4[395]);
*(vp++) = U0*I0[543]
          - U10*(I1[543] - I2[718])
          - U11*(I1[690] - I2[724])
          - U12*(I1[711] - I2[725])
          + (onezboz)*(I3[718] - AC0*I4[543])
          + (twozboz)*(I3[556] - AC1*I4[417])
          + (fourzboz)*(I3[529] - AC2*I4[396]);
*(vp++) = U0*I0[544]
          - U10*(I1[544] - I2[719])
          - U11*(I1[691] - I2[725])
          - U12*(I1[712] - I2[726])
          + (onezboz)*(I3[719] - AC0*I4[544])
          + (twozboz)*(I3[557] - AC1*I4[418])
          + (fourzboz)*(I3[530] - AC2*I4[397]);
*(vp++) = U0*I0[545]
          - U10*(I1[545] - I2[720])
          - U11*(I1[692] - I2[726])
          - U12*(I1[713] - I2[727])
          + (onezboz)*(I3[720] - AC0*I4[545])
          + (twozboz)*(I3[558] - AC1*I4[419])
          + (fourzboz)*(I3[531] - AC2*I4[398]);
*(vp++) = U0*I0[546]
          - U10*(I1[546] - I2[728])
          - U11*(I1[693] - I2[729])
          - U12*(I1[714] - I2[730])
          + (onezboz)*(I3[728] - AC0*I4[546])
          + (onezboz)*(I3[561] - AC1*I4[420])
          + (fivezboz)*(I3[534] - AC2*I4[399]);
*(vp++) = U0*I0[547]
          - U10*(I1[547] - I2[729])
          - U11*(I1[694] - I2[731])
          - U12*(I1[715] - I2[732])
          + (onezboz)*(I3[729] - AC0*I4[547])
          + (onezboz)*(I3[563] - AC1*I4[421])
          + (fivezboz)*(I3[536] - AC2*I4[400]);
*(vp++) = U0*I0[548]
          - U10*(I1[548] - I2[730])
          - U11*(I1[695] - I2[732])
          - U12*(I1[716] - I2[733])
          + (onezboz)*(I3[730] - AC0*I4[548])
          + (onezboz)*(I3[564] - AC1*I4[422])
          + (fivezboz)*(I3[537] - AC2*I4[401]);
*(vp++) = U0*I0[549]
          - U10*(I1[549] - I2[731])
          - U11*(I1[696] - I2[734])
          - U12*(I1[717] - I2[735])
          + (onezboz)*(I3[731] - AC0*I4[549])
          + (onezboz)*(I3[566] - AC1*I4[423])
          + (fivezboz)*(I3[539] - AC2*I4[402]);
*(vp++) = U0*I0[550]
          - U10*(I1[550] - I2[732])
          - U11*(I1[697] - I2[735])
          - U12*(I1[718] - I2[736])
          + (onezboz)*(I3[732] - AC0*I4[550])
          + (onezboz)*(I3[567] - AC1*I4[424])
          + (fivezboz)*(I3[540] - AC2*I4[403]);
*(vp++) = U0*I0[551]
          - U10*(I1[551] - I2[733])
          - U11*(I1[698] - I2[736])
          - U12*(I1[719] - I2[737])
          + (onezboz)*(I3[733] - AC0*I4[551])
          + (onezboz)*(I3[568] - AC1*I4[425])
          + (fivezboz)*(I3[541] - AC2*I4[404]);
*(vp++) = U0*I0[552]
          - U10*(I1[552] - I2[734])
          - U11*(I1[699] - I2[738])
          - U12*(I1[720] - I2[739])
          + (onezboz)*(I3[734] - AC0*I4[552])
          + (onezboz)*(I3[570] - AC1*I4[426])
          + (fivezboz)*(I3[543] - AC2*I4[405]);
*(vp++) = U0*I0[553]
          - U10*(I1[553] - I2[735])
          - U11*(I1[700] - I2[739])
          - U12*(I1[721] - I2[740])
          + (onezboz)*(I3[735] - AC0*I4[553])
          + (onezboz)*(I3[571] - AC1*I4[427])
          + (fivezboz)*(I3[544] - AC2*I4[406]);
*(vp++) = U0*I0[554]
          - U10*(I1[554] - I2[736])
          - U11*(I1[701] - I2[740])
          - U12*(I1[722] - I2[741])
          + (onezboz)*(I3[736] - AC0*I4[554])
          + (onezboz)*(I3[572] - AC1*I4[428])
          + (fivezboz)*(I3[545] - AC2*I4[407]);
*(vp++) = U0*I0[555]
          - U10*(I1[555] - I2[737])
          - U11*(I1[702] - I2[741])
          - U12*(I1[723] - I2[742])
          + (onezboz)*(I3[737] - AC0*I4[555])
          + (onezboz)*(I3[573] - AC1*I4[429])
          + (fivezboz)*(I3[546] - AC2*I4[408]);
*(vp++) = U0*I0[556]
          - U10*(I1[556] - I2[738])
          - U11*(I1[703] - I2[743])
          - U12*(I1[724] - I2[744])
          + (onezboz)*(I3[738] - AC0*I4[556])
          + (onezboz)*(I3[575] - AC1*I4[430])
          + (fivezboz)*(I3[548] - AC2*I4[409]);
*(vp++) = U0*I0[557]
          - U10*(I1[557] - I2[739])
          - U11*(I1[704] - I2[744])
          - U12*(I1[725] - I2[745])
          + (onezboz)*(I3[739] - AC0*I4[557])
          + (onezboz)*(I3[576] - AC1*I4[431])
          + (fivezboz)*(I3[549] - AC2*I4[410]);
*(vp++) = U0*I0[558]
          - U10*(I1[558] - I2[740])
          - U11*(I1[705] - I2[745])
          - U12*(I1[726] - I2[746])
          + (onezboz)*(I3[740] - AC0*I4[558])
          + (onezboz)*(I3[577] - AC1*I4[432])
          + (fivezboz)*(I3[550] - AC2*I4[411]);
*(vp++) = U0*I0[559]
          - U10*(I1[559] - I2[741])
          - U11*(I1[706] - I2[746])
          - U12*(I1[727] - I2[747])
          + (onezboz)*(I3[741] - AC0*I4[559])
          + (onezboz)*(I3[578] - AC1*I4[433])
          + (fivezboz)*(I3[551] - AC2*I4[412]);
*(vp++) = U0*I0[560]
          - U10*(I1[560] - I2[742])
          - U11*(I1[707] - I2[747])
          - U12*(I1[728] - I2[748])
          + (onezboz)*(I3[742] - AC0*I4[560])
          + (onezboz)*(I3[579] - AC1*I4[434])
          + (fivezboz)*(I3[552] - AC2*I4[413]);
*(vp++) = U0*I0[561]
          - U10*(I1[561] - I2[743])
          - U11*(I1[708] - I2[749])
          - U12*(I1[729] - I2[750])
          + (onezboz)*(I3[743] - AC0*I4[561])
          + (onezboz)*(I3[581] - AC1*I4[435])
          + (fivezboz)*(I3[554] - AC2*I4[414]);
*(vp++) = U0*I0[562]
          - U10*(I1[562] - I2[744])
          - U11*(I1[709] - I2[750])
          - U12*(I1[730] - I2[751])
          + (onezboz)*(I3[744] - AC0*I4[562])
          + (onezboz)*(I3[582] - AC1*I4[436])
          + (fivezboz)*(I3[555] - AC2*I4[415]);
*(vp++) = U0*I0[563]
          - U10*(I1[563] - I2[745])
          - U11*(I1[710] - I2[751])
          - U12*(I1[731] - I2[752])
          + (onezboz)*(I3[745] - AC0*I4[563])
          + (onezboz)*(I3[583] - AC1*I4[437])
          + (fivezboz)*(I3[556] - AC2*I4[416]);
*(vp++) = U0*I0[564]
          - U10*(I1[564] - I2[746])
          - U11*(I1[711] - I2[752])
          - U12*(I1[732] - I2[753])
          + (onezboz)*(I3[746] - AC0*I4[564])
          + (onezboz)*(I3[584] - AC1*I4[438])
          + (fivezboz)*(I3[557] - AC2*I4[417]);
*(vp++) = U0*I0[565]
          - U10*(I1[565] - I2[747])
          - U11*(I1[712] - I2[753])
          - U12*(I1[733] - I2[754])
          + (onezboz)*(I3[747] - AC0*I4[565])
          + (onezboz)*(I3[585] - AC1*I4[439])
          + (fivezboz)*(I3[558] - AC2*I4[418]);
*(vp++) = U0*I0[566]
          - U10*(I1[566] - I2[748])
          - U11*(I1[713] - I2[754])
          - U12*(I1[734] - I2[755])
          + (onezboz)*(I3[748] - AC0*I4[566])
          + (onezboz)*(I3[586] - AC1*I4[440])
          + (fivezboz)*(I3[559] - AC2*I4[419]);
*(vp++) = U0*I0[567]
          - U10*(I1[567] - I2[756])
          - U11*(I1[714] - I2[757])
          - U12*(I1[735] - I2[758])
          + (onezboz)*(I3[756] - AC0*I4[567])
          + (sixzboz)*(I3[562] - AC2*I4[420]);
*(vp++) = U0*I0[568]
          - U10*(I1[568] - I2[757])
          - U11*(I1[715] - I2[759])
          - U12*(I1[736] - I2[760])
          + (onezboz)*(I3[757] - AC0*I4[568])
          + (sixzboz)*(I3[564] - AC2*I4[421]);
*(vp++) = U0*I0[569]
          - U10*(I1[569] - I2[758])
          - U11*(I1[716] - I2[760])
          - U12*(I1[737] - I2[761])
          + (onezboz)*(I3[758] - AC0*I4[569])
          + (sixzboz)*(I3[565] - AC2*I4[422]);
*(vp++) = U0*I0[570]
          - U10*(I1[570] - I2[759])
          - U11*(I1[717] - I2[762])
          - U12*(I1[738] - I2[763])
          + (onezboz)*(I3[759] - AC0*I4[570])
          + (sixzboz)*(I3[567] - AC2*I4[423]);
*(vp++) = U0*I0[571]
          - U10*(I1[571] - I2[760])
          - U11*(I1[718] - I2[763])
          - U12*(I1[739] - I2[764])
          + (onezboz)*(I3[760] - AC0*I4[571])
          + (sixzboz)*(I3[568] - AC2*I4[424]);
*(vp++) = U0*I0[572]
          - U10*(I1[572] - I2[761])
          - U11*(I1[719] - I2[764])
          - U12*(I1[740] - I2[765])
          + (onezboz)*(I3[761] - AC0*I4[572])
          + (sixzboz)*(I3[569] - AC2*I4[425]);
*(vp++) = U0*I0[573]
          - U10*(I1[573] - I2[762])
          - U11*(I1[720] - I2[766])
          - U12*(I1[741] - I2[767])
          + (onezboz)*(I3[762] - AC0*I4[573])
          + (sixzboz)*(I3[571] - AC2*I4[426]);
*(vp++) = U0*I0[574]
          - U10*(I1[574] - I2[763])
          - U11*(I1[721] - I2[767])
          - U12*(I1[742] - I2[768])
          + (onezboz)*(I3[763] - AC0*I4[574])
          + (sixzboz)*(I3[572] - AC2*I4[427]);
*(vp++) = U0*I0[575]
          - U10*(I1[575] - I2[764])
          - U11*(I1[722] - I2[768])
          - U12*(I1[743] - I2[769])
          + (onezboz)*(I3[764] - AC0*I4[575])
          + (sixzboz)*(I3[573] - AC2*I4[428]);
*(vp++) = U0*I0[576]
          - U10*(I1[576] - I2[765])
          - U11*(I1[723] - I2[769])
          - U12*(I1[744] - I2[770])
          + (onezboz)*(I3[765] - AC0*I4[576])
          + (sixzboz)*(I3[574] - AC2*I4[429]);
*(vp++) = U0*I0[577]
          - U10*(I1[577] - I2[766])
          - U11*(I1[724] - I2[771])
          - U12*(I1[745] - I2[772])
          + (onezboz)*(I3[766] - AC0*I4[577])
          + (sixzboz)*(I3[576] - AC2*I4[430]);
*(vp++) = U0*I0[578]
          - U10*(I1[578] - I2[767])
          - U11*(I1[725] - I2[772])
          - U12*(I1[746] - I2[773])
          + (onezboz)*(I3[767] - AC0*I4[578])
          + (sixzboz)*(I3[577] - AC2*I4[431]);
*(vp++) = U0*I0[579]
          - U10*(I1[579] - I2[768])
          - U11*(I1[726] - I2[773])
          - U12*(I1[747] - I2[774])
          + (onezboz)*(I3[768] - AC0*I4[579])
          + (sixzboz)*(I3[578] - AC2*I4[432]);
*(vp++) = U0*I0[580]
          - U10*(I1[580] - I2[769])
          - U11*(I1[727] - I2[774])
          - U12*(I1[748] - I2[775])
          + (onezboz)*(I3[769] - AC0*I4[580])
          + (sixzboz)*(I3[579] - AC2*I4[433]);
*(vp++) = U0*I0[581]
          - U10*(I1[581] - I2[770])
          - U11*(I1[728] - I2[775])
          - U12*(I1[749] - I2[776])
          + (onezboz)*(I3[770] - AC0*I4[581])
          + (sixzboz)*(I3[580] - AC2*I4[434]);
*(vp++) = U0*I0[582]
          - U10*(I1[582] - I2[771])
          - U11*(I1[729] - I2[777])
          - U12*(I1[750] - I2[778])
          + (onezboz)*(I3[771] - AC0*I4[582])
          + (sixzboz)*(I3[582] - AC2*I4[435]);
*(vp++) = U0*I0[583]
          - U10*(I1[583] - I2[772])
          - U11*(I1[730] - I2[778])
          - U12*(I1[751] - I2[779])
          + (onezboz)*(I3[772] - AC0*I4[583])
          + (sixzboz)*(I3[583] - AC2*I4[436]);
*(vp++) = U0*I0[584]
          - U10*(I1[584] - I2[773])
          - U11*(I1[731] - I2[779])
          - U12*(I1[752] - I2[780])
          + (onezboz)*(I3[773] - AC0*I4[584])
          + (sixzboz)*(I3[584] - AC2*I4[437]);
*(vp++) = U0*I0[585]
          - U10*(I1[585] - I2[774])
          - U11*(I1[732] - I2[780])
          - U12*(I1[753] - I2[781])
          + (onezboz)*(I3[774] - AC0*I4[585])
          + (sixzboz)*(I3[585] - AC2*I4[438]);
*(vp++) = U0*I0[586]
          - U10*(I1[586] - I2[775])
          - U11*(I1[733] - I2[781])
          - U12*(I1[754] - I2[782])
          + (onezboz)*(I3[775] - AC0*I4[586])
          + (sixzboz)*(I3[586] - AC2*I4[439]);
*(vp++) = U0*I0[587]
          - U10*(I1[587] - I2[776])
          - U11*(I1[734] - I2[782])
          - U12*(I1[755] - I2[783])
          + (onezboz)*(I3[776] - AC0*I4[587])
          + (sixzboz)*(I3[587] - AC2*I4[440]);
*(vp++) = U0*I0[588]
          - U10*(I1[588] - I2[784])
          - U11*(I1[756] - I2[785])
          - U12*(I1[777] - I2[786])
          + (sevenzboz)*(I3[589] - AC1*I4[441]);
*(vp++) = U0*I0[589]
          - U10*(I1[589] - I2[785])
          - U11*(I1[757] - I2[787])
          - U12*(I1[778] - I2[788])
          + (sevenzboz)*(I3[591] - AC1*I4[442]);
*(vp++) = U0*I0[590]
          - U10*(I1[590] - I2[786])
          - U11*(I1[758] - I2[788])
          - U12*(I1[779] - I2[789])
          + (sevenzboz)*(I3[592] - AC1*I4[443]);
*(vp++) = U0*I0[591]
          - U10*(I1[591] - I2[787])
          - U11*(I1[759] - I2[790])
          - U12*(I1[780] - I2[791])
          + (sevenzboz)*(I3[594] - AC1*I4[444]);
*(vp++) = U0*I0[592]
          - U10*(I1[592] - I2[788])
          - U11*(I1[760] - I2[791])
          - U12*(I1[781] - I2[792])
          + (sevenzboz)*(I3[595] - AC1*I4[445]);
*(vp++) = U0*I0[593]
          - U10*(I1[593] - I2[789])
          - U11*(I1[761] - I2[792])
          - U12*(I1[782] - I2[793])
          + (sevenzboz)*(I3[596] - AC1*I4[446]);
*(vp++) = U0*I0[594]
          - U10*(I1[594] - I2[790])
          - U11*(I1[762] - I2[794])
          - U12*(I1[783] - I2[795])
          + (sevenzboz)*(I3[598] - AC1*I4[447]);
*(vp++) = U0*I0[595]
          - U10*(I1[595] - I2[791])
          - U11*(I1[763] - I2[795])
          - U12*(I1[784] - I2[796])
          + (sevenzboz)*(I3[599] - AC1*I4[448]);
*(vp++) = U0*I0[596]
          - U10*(I1[596] - I2[792])
          - U11*(I1[764] - I2[796])
          - U12*(I1[785] - I2[797])
          + (sevenzboz)*(I3[600] - AC1*I4[449]);
*(vp++) = U0*I0[597]
          - U10*(I1[597] - I2[793])
          - U11*(I1[765] - I2[797])
          - U12*(I1[786] - I2[798])
          + (sevenzboz)*(I3[601] - AC1*I4[450]);
*(vp++) = U0*I0[598]
          - U10*(I1[598] - I2[794])
          - U11*(I1[766] - I2[799])
          - U12*(I1[787] - I2[800])
          + (sevenzboz)*(I3[603] - AC1*I4[451]);
*(vp++) = U0*I0[599]
          - U10*(I1[599] - I2[795])
          - U11*(I1[767] - I2[800])
          - U12*(I1[788] - I2[801])
          + (sevenzboz)*(I3[604] - AC1*I4[452]);
*(vp++) = U0*I0[600]
          - U10*(I1[600] - I2[796])
          - U11*(I1[768] - I2[801])
          - U12*(I1[789] - I2[802])
          + (sevenzboz)*(I3[605] - AC1*I4[453]);
*(vp++) = U0*I0[601]
          - U10*(I1[601] - I2[797])
          - U11*(I1[769] - I2[802])
          - U12*(I1[790] - I2[803])
          + (sevenzboz)*(I3[606] - AC1*I4[454]);
*(vp++) = U0*I0[602]
          - U10*(I1[602] - I2[798])
          - U11*(I1[770] - I2[803])
          - U12*(I1[791] - I2[804])
          + (sevenzboz)*(I3[607] - AC1*I4[455]);
*(vp++) = U0*I0[603]
          - U10*(I1[603] - I2[799])
          - U11*(I1[771] - I2[805])
          - U12*(I1[792] - I2[806])
          + (sevenzboz)*(I3[609] - AC1*I4[456]);
*(vp++) = U0*I0[604]
          - U10*(I1[604] - I2[800])
          - U11*(I1[772] - I2[806])
          - U12*(I1[793] - I2[807])
          + (sevenzboz)*(I3[610] - AC1*I4[457]);
*(vp++) = U0*I0[605]
          - U10*(I1[605] - I2[801])
          - U11*(I1[773] - I2[807])
          - U12*(I1[794] - I2[808])
          + (sevenzboz)*(I3[611] - AC1*I4[458]);
*(vp++) = U0*I0[606]
          - U10*(I1[606] - I2[802])
          - U11*(I1[774] - I2[808])
          - U12*(I1[795] - I2[809])
          + (sevenzboz)*(I3[612] - AC1*I4[459]);
*(vp++) = U0*I0[607]
          - U10*(I1[607] - I2[803])
          - U11*(I1[775] - I2[809])
          - U12*(I1[796] - I2[810])
          + (sevenzboz)*(I3[613] - AC1*I4[460]);
*(vp++) = U0*I0[608]
          - U10*(I1[608] - I2[804])
          - U11*(I1[776] - I2[810])
          - U12*(I1[797] - I2[811])
          + (sevenzboz)*(I3[614] - AC1*I4[461]);
*(vp++) = U0*I0[609]
          - U10*(I1[609] - I2[812])
          - U11*(I1[777] - I2[813])
          - U12*(I1[798] - I2[814])
          + (sixzboz)*(I3[617] - AC1*I4[462])
          + (onezboz)*(I3[590] - AC2*I4[441]);
*(vp++) = U0*I0[610]
          - U10*(I1[610] - I2[813])
          - U11*(I1[778] - I2[815])
          - U12*(I1[799] - I2[816])
          + (sixzboz)*(I3[619] - AC1*I4[463])
          + (onezboz)*(I3[592] - AC2*I4[442]);
*(vp++) = U0*I0[611]
          - U10*(I1[611] - I2[814])
          - U11*(I1[779] - I2[816])
          - U12*(I1[800] - I2[817])
          + (sixzboz)*(I3[620] - AC1*I4[464])
          + (onezboz)*(I3[593] - AC2*I4[443]);
*(vp++) = U0*I0[612]
          - U10*(I1[612] - I2[815])
          - U11*(I1[780] - I2[818])
          - U12*(I1[801] - I2[819])
          + (sixzboz)*(I3[622] - AC1*I4[465])
          + (onezboz)*(I3[595] - AC2*I4[444]);
*(vp++) = U0*I0[613]
          - U10*(I1[613] - I2[816])
          - U11*(I1[781] - I2[819])
          - U12*(I1[802] - I2[820])
          + (sixzboz)*(I3[623] - AC1*I4[466])
          + (onezboz)*(I3[596] - AC2*I4[445]);
*(vp++) = U0*I0[614]
          - U10*(I1[614] - I2[817])
          - U11*(I1[782] - I2[820])
          - U12*(I1[803] - I2[821])
          + (sixzboz)*(I3[624] - AC1*I4[467])
          + (onezboz)*(I3[597] - AC2*I4[446]);
*(vp++) = U0*I0[615]
          - U10*(I1[615] - I2[818])
          - U11*(I1[783] - I2[822])
          - U12*(I1[804] - I2[823])
          + (sixzboz)*(I3[626] - AC1*I4[468])
          + (onezboz)*(I3[599] - AC2*I4[447]);
*(vp++) = U0*I0[616]
          - U10*(I1[616] - I2[819])
          - U11*(I1[784] - I2[823])
          - U12*(I1[805] - I2[824])
          + (sixzboz)*(I3[627] - AC1*I4[469])
          + (onezboz)*(I3[600] - AC2*I4[448]);
*(vp++) = U0*I0[617]
          - U10*(I1[617] - I2[820])
          - U11*(I1[785] - I2[824])
          - U12*(I1[806] - I2[825])
          + (sixzboz)*(I3[628] - AC1*I4[470])
          + (onezboz)*(I3[601] - AC2*I4[449]);
*(vp++) = U0*I0[618]
          - U10*(I1[618] - I2[821])
          - U11*(I1[786] - I2[825])
          - U12*(I1[807] - I2[826])
          + (sixzboz)*(I3[629] - AC1*I4[471])
          + (onezboz)*(I3[602] - AC2*I4[450]);
*(vp++) = U0*I0[619]
          - U10*(I1[619] - I2[822])
          - U11*(I1[787] - I2[827])
          - U12*(I1[808] - I2[828])
          + (sixzboz)*(I3[631] - AC1*I4[472])
          + (onezboz)*(I3[604] - AC2*I4[451]);
*(vp++) = U0*I0[620]
          - U10*(I1[620] - I2[823])
          - U11*(I1[788] - I2[828])
          - U12*(I1[809] - I2[829])
          + (sixzboz)*(I3[632] - AC1*I4[473])
          + (onezboz)*(I3[605] - AC2*I4[452]);
*(vp++) = U0*I0[621]
          - U10*(I1[621] - I2[824])
          - U11*(I1[789] - I2[829])
          - U12*(I1[810] - I2[830])
          + (sixzboz)*(I3[633] - AC1*I4[474])
          + (onezboz)*(I3[606] - AC2*I4[453]);
*(vp++) = U0*I0[622]
          - U10*(I1[622] - I2[825])
          - U11*(I1[790] - I2[830])
          - U12*(I1[811] - I2[831])
          + (sixzboz)*(I3[634] - AC1*I4[475])
          + (onezboz)*(I3[607] - AC2*I4[454]);
*(vp++) = U0*I0[623]
          - U10*(I1[623] - I2[826])
          - U11*(I1[791] - I2[831])
          - U12*(I1[812] - I2[832])
          + (sixzboz)*(I3[635] - AC1*I4[476])
          + (onezboz)*(I3[608] - AC2*I4[455]);
*(vp++) = U0*I0[624]
          - U10*(I1[624] - I2[827])
          - U11*(I1[792] - I2[833])
          - U12*(I1[813] - I2[834])
          + (sixzboz)*(I3[637] - AC1*I4[477])
          + (onezboz)*(I3[610] - AC2*I4[456]);
*(vp++) = U0*I0[625]
          - U10*(I1[625] - I2[828])
          - U11*(I1[793] - I2[834])
          - U12*(I1[814] - I2[835])
          + (sixzboz)*(I3[638] - AC1*I4[478])
          + (onezboz)*(I3[611] - AC2*I4[457]);
*(vp++) = U0*I0[626]
          - U10*(I1[626] - I2[829])
          - U11*(I1[794] - I2[835])
          - U12*(I1[815] - I2[836])
          + (sixzboz)*(I3[639] - AC1*I4[479])
          + (onezboz)*(I3[612] - AC2*I4[458]);
*(vp++) = U0*I0[627]
          - U10*(I1[627] - I2[830])
          - U11*(I1[795] - I2[836])
          - U12*(I1[816] - I2[837])
          + (sixzboz)*(I3[640] - AC1*I4[480])
          + (onezboz)*(I3[613] - AC2*I4[459]);
*(vp++) = U0*I0[628]
          - U10*(I1[628] - I2[831])
          - U11*(I1[796] - I2[837])
          - U12*(I1[817] - I2[838])
          + (sixzboz)*(I3[641] - AC1*I4[481])
          + (onezboz)*(I3[614] - AC2*I4[460]);
*(vp++) = U0*I0[629]
          - U10*(I1[629] - I2[832])
          - U11*(I1[797] - I2[838])
          - U12*(I1[818] - I2[839])
          + (sixzboz)*(I3[642] - AC1*I4[482])
          + (onezboz)*(I3[615] - AC2*I4[461]);
*(vp++) = U0*I0[630]
          - U10*(I1[630] - I2[840])
          - U11*(I1[798] - I2[841])
          - U12*(I1[819] - I2[842])
          + (fivezboz)*(I3[645] - AC1*I4[483])
          + (twozboz)*(I3[618] - AC2*I4[462]);
*(vp++) = U0*I0[631]
          - U10*(I1[631] - I2[841])
          - U11*(I1[799] - I2[843])
          - U12*(I1[820] - I2[844])
          + (fivezboz)*(I3[647] - AC1*I4[484])
          + (twozboz)*(I3[620] - AC2*I4[463]);
*(vp++) = U0*I0[632]
          - U10*(I1[632] - I2[842])
          - U11*(I1[800] - I2[844])
          - U12*(I1[821] - I2[845])
          + (fivezboz)*(I3[648] - AC1*I4[485])
          + (twozboz)*(I3[621] - AC2*I4[464]);
*(vp++) = U0*I0[633]
          - U10*(I1[633] - I2[843])
          - U11*(I1[801] - I2[846])
          - U12*(I1[822] - I2[847])
          + (fivezboz)*(I3[650] - AC1*I4[486])
          + (twozboz)*(I3[623] - AC2*I4[465]);
*(vp++) = U0*I0[634]
          - U10*(I1[634] - I2[844])
          - U11*(I1[802] - I2[847])
          - U12*(I1[823] - I2[848])
          + (fivezboz)*(I3[651] - AC1*I4[487])
          + (twozboz)*(I3[624] - AC2*I4[466]);
*(vp++) = U0*I0[635]
          - U10*(I1[635] - I2[845])
          - U11*(I1[803] - I2[848])
          - U12*(I1[824] - I2[849])
          + (fivezboz)*(I3[652] - AC1*I4[488])
          + (twozboz)*(I3[625] - AC2*I4[467]);
*(vp++) = U0*I0[636]
          - U10*(I1[636] - I2[846])
          - U11*(I1[804] - I2[850])
          - U12*(I1[825] - I2[851])
          + (fivezboz)*(I3[654] - AC1*I4[489])
          + (twozboz)*(I3[627] - AC2*I4[468]);
*(vp++) = U0*I0[637]
          - U10*(I1[637] - I2[847])
          - U11*(I1[805] - I2[851])
          - U12*(I1[826] - I2[852])
          + (fivezboz)*(I3[655] - AC1*I4[490])
          + (twozboz)*(I3[628] - AC2*I4[469]);
*(vp++) = U0*I0[638]
          - U10*(I1[638] - I2[848])
          - U11*(I1[806] - I2[852])
          - U12*(I1[827] - I2[853])
          + (fivezboz)*(I3[656] - AC1*I4[491])
          + (twozboz)*(I3[629] - AC2*I4[470]);
*(vp++) = U0*I0[639]
          - U10*(I1[639] - I2[849])
          - U11*(I1[807] - I2[853])
          - U12*(I1[828] - I2[854])
          + (fivezboz)*(I3[657] - AC1*I4[492])
          + (twozboz)*(I3[630] - AC2*I4[471]);
*(vp++) = U0*I0[640]
          - U10*(I1[640] - I2[850])
          - U11*(I1[808] - I2[855])
          - U12*(I1[829] - I2[856])
          + (fivezboz)*(I3[659] - AC1*I4[493])
          + (twozboz)*(I3[632] - AC2*I4[472]);
*(vp++) = U0*I0[641]
          - U10*(I1[641] - I2[851])
          - U11*(I1[809] - I2[856])
          - U12*(I1[830] - I2[857])
          + (fivezboz)*(I3[660] - AC1*I4[494])
          + (twozboz)*(I3[633] - AC2*I4[473]);
*(vp++) = U0*I0[642]
          - U10*(I1[642] - I2[852])
          - U11*(I1[810] - I2[857])
          - U12*(I1[831] - I2[858])
          + (fivezboz)*(I3[661] - AC1*I4[495])
          + (twozboz)*(I3[634] - AC2*I4[474]);
*(vp++) = U0*I0[643]
          - U10*(I1[643] - I2[853])
          - U11*(I1[811] - I2[858])
          - U12*(I1[832] - I2[859])
          + (fivezboz)*(I3[662] - AC1*I4[496])
          + (twozboz)*(I3[635] - AC2*I4[475]);
*(vp++) = U0*I0[644]
          - U10*(I1[644] - I2[854])
          - U11*(I1[812] - I2[859])
          - U12*(I1[833] - I2[860])
          + (fivezboz)*(I3[663] - AC1*I4[497])
          + (twozboz)*(I3[636] - AC2*I4[476]);
*(vp++) = U0*I0[645]
          - U10*(I1[645] - I2[855])
          - U11*(I1[813] - I2[861])
          - U12*(I1[834] - I2[862])
          + (fivezboz)*(I3[665] - AC1*I4[498])
          + (twozboz)*(I3[638] - AC2*I4[477]);
*(vp++) = U0*I0[646]
          - U10*(I1[646] - I2[856])
          - U11*(I1[814] - I2[862])
          - U12*(I1[835] - I2[863])
          + (fivezboz)*(I3[666] - AC1*I4[499])
          + (twozboz)*(I3[639] - AC2*I4[478]);
*(vp++) = U0*I0[647]
          - U10*(I1[647] - I2[857])
          - U11*(I1[815] - I2[863])
          - U12*(I1[836] - I2[864])
          + (fivezboz)*(I3[667] - AC1*I4[500])
          + (twozboz)*(I3[640] - AC2*I4[479]);
*(vp++) = U0*I0[648]
          - U10*(I1[648] - I2[858])
          - U11*(I1[816] - I2[864])
          - U12*(I1[837] - I2[865])
          + (fivezboz)*(I3[668] - AC1*I4[501])
          + (twozboz)*(I3[641] - AC2*I4[480]);
*(vp++) = U0*I0[649]
          - U10*(I1[649] - I2[859])
          - U11*(I1[817] - I2[865])
          - U12*(I1[838] - I2[866])
          + (fivezboz)*(I3[669] - AC1*I4[502])
          + (twozboz)*(I3[642] - AC2*I4[481]);
*(vp++) = U0*I0[650]
          - U10*(I1[650] - I2[860])
          - U11*(I1[818] - I2[866])
          - U12*(I1[839] - I2[867])
          + (fivezboz)*(I3[670] - AC1*I4[503])
          + (twozboz)*(I3[643] - AC2*I4[482]);
*(vp++) = U0*I0[651]
          - U10*(I1[651] - I2[868])
          - U11*(I1[819] - I2[869])
          - U12*(I1[840] - I2[870])
          + (fourzboz)*(I3[673] - AC1*I4[504])
          + (threezboz)*(I3[646] - AC2*I4[483]);
*(vp++) = U0*I0[652]
          - U10*(I1[652] - I2[869])
          - U11*(I1[820] - I2[871])
          - U12*(I1[841] - I2[872])
          + (fourzboz)*(I3[675] - AC1*I4[505])
          + (threezboz)*(I3[648] - AC2*I4[484]);
*(vp++) = U0*I0[653]
          - U10*(I1[653] - I2[870])
          - U11*(I1[821] - I2[872])
          - U12*(I1[842] - I2[873])
          + (fourzboz)*(I3[676] - AC1*I4[506])
          + (threezboz)*(I3[649] - AC2*I4[485]);
*(vp++) = U0*I0[654]
          - U10*(I1[654] - I2[871])
          - U11*(I1[822] - I2[874])
          - U12*(I1[843] - I2[875])
          + (fourzboz)*(I3[678] - AC1*I4[507])
          + (threezboz)*(I3[651] - AC2*I4[486]);
*(vp++) = U0*I0[655]
          - U10*(I1[655] - I2[872])
          - U11*(I1[823] - I2[875])
          - U12*(I1[844] - I2[876])
          + (fourzboz)*(I3[679] - AC1*I4[508])
          + (threezboz)*(I3[652] - AC2*I4[487]);
*(vp++) = U0*I0[656]
          - U10*(I1[656] - I2[873])
          - U11*(I1[824] - I2[876])
          - U12*(I1[845] - I2[877])
          + (fourzboz)*(I3[680] - AC1*I4[509])
          + (threezboz)*(I3[653] - AC2*I4[488]);
*(vp++) = U0*I0[657]
          - U10*(I1[657] - I2[874])
          - U11*(I1[825] - I2[878])
          - U12*(I1[846] - I2[879])
          + (fourzboz)*(I3[682] - AC1*I4[510])
          + (threezboz)*(I3[655] - AC2*I4[489]);
*(vp++) = U0*I0[658]
          - U10*(I1[658] - I2[875])
          - U11*(I1[826] - I2[879])
          - U12*(I1[847] - I2[880])
          + (fourzboz)*(I3[683] - AC1*I4[511])
          + (threezboz)*(I3[656] - AC2*I4[490]);
*(vp++) = U0*I0[659]
          - U10*(I1[659] - I2[876])
          - U11*(I1[827] - I2[880])
          - U12*(I1[848] - I2[881])
          + (fourzboz)*(I3[684] - AC1*I4[512])
          + (threezboz)*(I3[657] - AC2*I4[491]);
*(vp++) = U0*I0[660]
          - U10*(I1[660] - I2[877])
          - U11*(I1[828] - I2[881])
          - U12*(I1[849] - I2[882])
          + (fourzboz)*(I3[685] - AC1*I4[513])
          + (threezboz)*(I3[658] - AC2*I4[492]);
*(vp++) = U0*I0[661]
          - U10*(I1[661] - I2[878])
          - U11*(I1[829] - I2[883])
          - U12*(I1[850] - I2[884])
          + (fourzboz)*(I3[687] - AC1*I4[514])
          + (threezboz)*(I3[660] - AC2*I4[493]);
*(vp++) = U0*I0[662]
          - U10*(I1[662] - I2[879])
          - U11*(I1[830] - I2[884])
          - U12*(I1[851] - I2[885])
          + (fourzboz)*(I3[688] - AC1*I4[515])
          + (threezboz)*(I3[661] - AC2*I4[494]);
*(vp++) = U0*I0[663]
          - U10*(I1[663] - I2[880])
          - U11*(I1[831] - I2[885])
          - U12*(I1[852] - I2[886])
          + (fourzboz)*(I3[689] - AC1*I4[516])
          + (threezboz)*(I3[662] - AC2*I4[495]);
*(vp++) = U0*I0[664]
          - U10*(I1[664] - I2[881])
          - U11*(I1[832] - I2[886])
          - U12*(I1[853] - I2[887])
          + (fourzboz)*(I3[690] - AC1*I4[517])
          + (threezboz)*(I3[663] - AC2*I4[496]);
*(vp++) = U0*I0[665]
          - U10*(I1[665] - I2[882])
          - U11*(I1[833] - I2[887])
          - U12*(I1[854] - I2[888])
          + (fourzboz)*(I3[691] - AC1*I4[518])
          + (threezboz)*(I3[664] - AC2*I4[497]);
*(vp++) = U0*I0[666]
          - U10*(I1[666] - I2[883])
          - U11*(I1[834] - I2[889])
          - U12*(I1[855] - I2[890])
          + (fourzboz)*(I3[693] - AC1*I4[519])
          + (threezboz)*(I3[666] - AC2*I4[498]);
*(vp++) = U0*I0[667]
          - U10*(I1[667] - I2[884])
          - U11*(I1[835] - I2[890])
          - U12*(I1[856] - I2[891])
          + (fourzboz)*(I3[694] - AC1*I4[520])
          + (threezboz)*(I3[667] - AC2*I4[499]);
*(vp++) = U0*I0[668]
          - U10*(I1[668] - I2[885])
          - U11*(I1[836] - I2[891])
          - U12*(I1[857] - I2[892])
          + (fourzboz)*(I3[695] - AC1*I4[521])
          + (threezboz)*(I3[668] - AC2*I4[500]);
*(vp++) = U0*I0[669]
          - U10*(I1[669] - I2[886])
          - U11*(I1[837] - I2[892])
          - U12*(I1[858] - I2[893])
          + (fourzboz)*(I3[696] - AC1*I4[522])
          + (threezboz)*(I3[669] - AC2*I4[501]);
*(vp++) = U0*I0[670]
          - U10*(I1[670] - I2[887])
          - U11*(I1[838] - I2[893])
          - U12*(I1[859] - I2[894])
          + (fourzboz)*(I3[697] - AC1*I4[523])
          + (threezboz)*(I3[670] - AC2*I4[502]);
*(vp++) = U0*I0[671]
          - U10*(I1[671] - I2[888])
          - U11*(I1[839] - I2[894])
          - U12*(I1[860] - I2[895])
          + (fourzboz)*(I3[698] - AC1*I4[524])
          + (threezboz)*(I3[671] - AC2*I4[503]);
*(vp++) = U0*I0[672]
          - U10*(I1[672] - I2[896])
          - U11*(I1[840] - I2[897])
          - U12*(I1[861] - I2[898])
          + (threezboz)*(I3[701] - AC1*I4[525])
          + (fourzboz)*(I3[674] - AC2*I4[504]);
*(vp++) = U0*I0[673]
          - U10*(I1[673] - I2[897])
          - U11*(I1[841] - I2[899])
          - U12*(I1[862] - I2[900])
          + (threezboz)*(I3[703] - AC1*I4[526])
          + (fourzboz)*(I3[676] - AC2*I4[505]);
*(vp++) = U0*I0[674]
          - U10*(I1[674] - I2[898])
          - U11*(I1[842] - I2[900])
          - U12*(I1[863] - I2[901])
          + (threezboz)*(I3[704] - AC1*I4[527])
          + (fourzboz)*(I3[677] - AC2*I4[506]);
*(vp++) = U0*I0[675]
          - U10*(I1[675] - I2[899])
          - U11*(I1[843] - I2[902])
          - U12*(I1[864] - I2[903])
          + (threezboz)*(I3[706] - AC1*I4[528])
          + (fourzboz)*(I3[679] - AC2*I4[507]);
*(vp++) = U0*I0[676]
          - U10*(I1[676] - I2[900])
          - U11*(I1[844] - I2[903])
          - U12*(I1[865] - I2[904])
          + (threezboz)*(I3[707] - AC1*I4[529])
          + (fourzboz)*(I3[680] - AC2*I4[508]);
*(vp++) = U0*I0[677]
          - U10*(I1[677] - I2[901])
          - U11*(I1[845] - I2[904])
          - U12*(I1[866] - I2[905])
          + (threezboz)*(I3[708] - AC1*I4[530])
          + (fourzboz)*(I3[681] - AC2*I4[509]);
*(vp++) = U0*I0[678]
          - U10*(I1[678] - I2[902])
          - U11*(I1[846] - I2[906])
          - U12*(I1[867] - I2[907])
          + (threezboz)*(I3[710] - AC1*I4[531])
          + (fourzboz)*(I3[683] - AC2*I4[510]);
*(vp++) = U0*I0[679]
          - U10*(I1[679] - I2[903])
          - U11*(I1[847] - I2[907])
          - U12*(I1[868] - I2[908])
          + (threezboz)*(I3[711] - AC1*I4[532])
          + (fourzboz)*(I3[684] - AC2*I4[511]);
*(vp++) = U0*I0[680]
          - U10*(I1[680] - I2[904])
          - U11*(I1[848] - I2[908])
          - U12*(I1[869] - I2[909])
          + (threezboz)*(I3[712] - AC1*I4[533])
          + (fourzboz)*(I3[685] - AC2*I4[512]);
*(vp++) = U0*I0[681]
          - U10*(I1[681] - I2[905])
          - U11*(I1[849] - I2[909])
          - U12*(I1[870] - I2[910])
          + (threezboz)*(I3[713] - AC1*I4[534])
          + (fourzboz)*(I3[686] - AC2*I4[513]);
*(vp++) = U0*I0[682]
          - U10*(I1[682] - I2[906])
          - U11*(I1[850] - I2[911])
          - U12*(I1[871] - I2[912])
          + (threezboz)*(I3[715] - AC1*I4[535])
          + (fourzboz)*(I3[688] - AC2*I4[514]);
*(vp++) = U0*I0[683]
          - U10*(I1[683] - I2[907])
          - U11*(I1[851] - I2[912])
          - U12*(I1[872] - I2[913])
          + (threezboz)*(I3[716] - AC1*I4[536])
          + (fourzboz)*(I3[689] - AC2*I4[515]);
*(vp++) = U0*I0[684]
          - U10*(I1[684] - I2[908])
          - U11*(I1[852] - I2[913])
          - U12*(I1[873] - I2[914])
          + (threezboz)*(I3[717] - AC1*I4[537])
          + (fourzboz)*(I3[690] - AC2*I4[516]);
*(vp++) = U0*I0[685]
          - U10*(I1[685] - I2[909])
          - U11*(I1[853] - I2[914])
          - U12*(I1[874] - I2[915])
          + (threezboz)*(I3[718] - AC1*I4[538])
          + (fourzboz)*(I3[691] - AC2*I4[517]);
*(vp++) = U0*I0[686]
          - U10*(I1[686] - I2[910])
          - U11*(I1[854] - I2[915])
          - U12*(I1[875] - I2[916])
          + (threezboz)*(I3[719] - AC1*I4[539])
          + (fourzboz)*(I3[692] - AC2*I4[518]);
*(vp++) = U0*I0[687]
          - U10*(I1[687] - I2[911])
          - U11*(I1[855] - I2[917])
          - U12*(I1[876] - I2[918])
          + (threezboz)*(I3[721] - AC1*I4[540])
          + (fourzboz)*(I3[694] - AC2*I4[519]);
*(vp++) = U0*I0[688]
          - U10*(I1[688] - I2[912])
          - U11*(I1[856] - I2[918])
          - U12*(I1[877] - I2[919])
          + (threezboz)*(I3[722] - AC1*I4[541])
          + (fourzboz)*(I3[695] - AC2*I4[520]);
*(vp++) = U0*I0[689]
          - U10*(I1[689] - I2[913])
          - U11*(I1[857] - I2[919])
          - U12*(I1[878] - I2[920])
          + (threezboz)*(I3[723] - AC1*I4[542])
          + (fourzboz)*(I3[696] - AC2*I4[521]);
*(vp++) = U0*I0[690]
          - U10*(I1[690] - I2[914])
          - U11*(I1[858] - I2[920])
          - U12*(I1[879] - I2[921])
          + (threezboz)*(I3[724] - AC1*I4[543])
          + (fourzboz)*(I3[697] - AC2*I4[522]);
*(vp++) = U0*I0[691]
          - U10*(I1[691] - I2[915])
          - U11*(I1[859] - I2[921])
          - U12*(I1[880] - I2[922])
          + (threezboz)*(I3[725] - AC1*I4[544])
          + (fourzboz)*(I3[698] - AC2*I4[523]);
*(vp++) = U0*I0[692]
          - U10*(I1[692] - I2[916])
          - U11*(I1[860] - I2[922])
          - U12*(I1[881] - I2[923])
          + (threezboz)*(I3[726] - AC1*I4[545])
          + (fourzboz)*(I3[699] - AC2*I4[524]);
*(vp++) = U0*I0[693]
          - U10*(I1[693] - I2[924])
          - U11*(I1[861] - I2[925])
          - U12*(I1[882] - I2[926])
          + (twozboz)*(I3[729] - AC1*I4[546])
          + (fivezboz)*(I3[702] - AC2*I4[525]);
*(vp++) = U0*I0[694]
          - U10*(I1[694] - I2[925])
          - U11*(I1[862] - I2[927])
          - U12*(I1[883] - I2[928])
          + (twozboz)*(I3[731] - AC1*I4[547])
          + (fivezboz)*(I3[704] - AC2*I4[526]);
*(vp++) = U0*I0[695]
          - U10*(I1[695] - I2[926])
          - U11*(I1[863] - I2[928])
          - U12*(I1[884] - I2[929])
          + (twozboz)*(I3[732] - AC1*I4[548])
          + (fivezboz)*(I3[705] - AC2*I4[527]);
*(vp++) = U0*I0[696]
          - U10*(I1[696] - I2[927])
          - U11*(I1[864] - I2[930])
          - U12*(I1[885] - I2[931])
          + (twozboz)*(I3[734] - AC1*I4[549])
          + (fivezboz)*(I3[707] - AC2*I4[528]);
*(vp++) = U0*I0[697]
          - U10*(I1[697] - I2[928])
          - U11*(I1[865] - I2[931])
          - U12*(I1[886] - I2[932])
          + (twozboz)*(I3[735] - AC1*I4[550])
          + (fivezboz)*(I3[708] - AC2*I4[529]);
*(vp++) = U0*I0[698]
          - U10*(I1[698] - I2[929])
          - U11*(I1[866] - I2[932])
          - U12*(I1[887] - I2[933])
          + (twozboz)*(I3[736] - AC1*I4[551])
          + (fivezboz)*(I3[709] - AC2*I4[530]);
*(vp++) = U0*I0[699]
          - U10*(I1[699] - I2[930])
          - U11*(I1[867] - I2[934])
          - U12*(I1[888] - I2[935])
          + (twozboz)*(I3[738] - AC1*I4[552])
          + (fivezboz)*(I3[711] - AC2*I4[531]);
*(vp++) = U0*I0[700]
          - U10*(I1[700] - I2[931])
          - U11*(I1[868] - I2[935])
          - U12*(I1[889] - I2[936])
          + (twozboz)*(I3[739] - AC1*I4[553])
          + (fivezboz)*(I3[712] - AC2*I4[532]);
*(vp++) = U0*I0[701]
          - U10*(I1[701] - I2[932])
          - U11*(I1[869] - I2[936])
          - U12*(I1[890] - I2[937])
          + (twozboz)*(I3[740] - AC1*I4[554])
          + (fivezboz)*(I3[713] - AC2*I4[533]);
*(vp++) = U0*I0[702]
          - U10*(I1[702] - I2[933])
          - U11*(I1[870] - I2[937])
          - U12*(I1[891] - I2[938])
          + (twozboz)*(I3[741] - AC1*I4[555])
          + (fivezboz)*(I3[714] - AC2*I4[534]);
*(vp++) = U0*I0[703]
          - U10*(I1[703] - I2[934])
          - U11*(I1[871] - I2[939])
          - U12*(I1[892] - I2[940])
          + (twozboz)*(I3[743] - AC1*I4[556])
          + (fivezboz)*(I3[716] - AC2*I4[535]);
*(vp++) = U0*I0[704]
          - U10*(I1[704] - I2[935])
          - U11*(I1[872] - I2[940])
          - U12*(I1[893] - I2[941])
          + (twozboz)*(I3[744] - AC1*I4[557])
          + (fivezboz)*(I3[717] - AC2*I4[536]);
*(vp++) = U0*I0[705]
          - U10*(I1[705] - I2[936])
          - U11*(I1[873] - I2[941])
          - U12*(I1[894] - I2[942])
          + (twozboz)*(I3[745] - AC1*I4[558])
          + (fivezboz)*(I3[718] - AC2*I4[537]);
*(vp++) = U0*I0[706]
          - U10*(I1[706] - I2[937])
          - U11*(I1[874] - I2[942])
          - U12*(I1[895] - I2[943])
          + (twozboz)*(I3[746] - AC1*I4[559])
          + (fivezboz)*(I3[719] - AC2*I4[538]);
*(vp++) = U0*I0[707]
          - U10*(I1[707] - I2[938])
          - U11*(I1[875] - I2[943])
          - U12*(I1[896] - I2[944])
          + (twozboz)*(I3[747] - AC1*I4[560])
          + (fivezboz)*(I3[720] - AC2*I4[539]);
*(vp++) = U0*I0[708]
          - U10*(I1[708] - I2[939])
          - U11*(I1[876] - I2[945])
          - U12*(I1[897] - I2[946])
          + (twozboz)*(I3[749] - AC1*I4[561])
          + (fivezboz)*(I3[722] - AC2*I4[540]);
*(vp++) = U0*I0[709]
          - U10*(I1[709] - I2[940])
          - U11*(I1[877] - I2[946])
          - U12*(I1[898] - I2[947])
          + (twozboz)*(I3[750] - AC1*I4[562])
          + (fivezboz)*(I3[723] - AC2*I4[541]);
*(vp++) = U0*I0[710]
          - U10*(I1[710] - I2[941])
          - U11*(I1[878] - I2[947])
          - U12*(I1[899] - I2[948])
          + (twozboz)*(I3[751] - AC1*I4[563])
          + (fivezboz)*(I3[724] - AC2*I4[542]);
*(vp++) = U0*I0[711]
          - U10*(I1[711] - I2[942])
          - U11*(I1[879] - I2[948])
          - U12*(I1[900] - I2[949])
          + (twozboz)*(I3[752] - AC1*I4[564])
          + (fivezboz)*(I3[725] - AC2*I4[543]);
*(vp++) = U0*I0[712]
          - U10*(I1[712] - I2[943])
          - U11*(I1[880] - I2[949])
          - U12*(I1[901] - I2[950])
          + (twozboz)*(I3[753] - AC1*I4[565])
          + (fivezboz)*(I3[726] - AC2*I4[544]);
*(vp++) = U0*I0[713]
          - U10*(I1[713] - I2[944])
          - U11*(I1[881] - I2[950])
          - U12*(I1[902] - I2[951])
          + (twozboz)*(I3[754] - AC1*I4[566])
          + (fivezboz)*(I3[727] - AC2*I4[545]);
*(vp++) = U0*I0[714]
          - U10*(I1[714] - I2[952])
          - U11*(I1[882] - I2[953])
          - U12*(I1[903] - I2[954])
          + (onezboz)*(I3[757] - AC1*I4[567])
          + (sixzboz)*(I3[730] - AC2*I4[546]);
*(vp++) = U0*I0[715]
          - U10*(I1[715] - I2[953])
          - U11*(I1[883] - I2[955])
          - U12*(I1[904] - I2[956])
          + (onezboz)*(I3[759] - AC1*I4[568])
          + (sixzboz)*(I3[732] - AC2*I4[547]);
*(vp++) = U0*I0[716]
          - U10*(I1[716] - I2[954])
          - U11*(I1[884] - I2[956])
          - U12*(I1[905] - I2[957])
          + (onezboz)*(I3[760] - AC1*I4[569])
          + (sixzboz)*(I3[733] - AC2*I4[548]);
*(vp++) = U0*I0[717]
          - U10*(I1[717] - I2[955])
          - U11*(I1[885] - I2[958])
          - U12*(I1[906] - I2[959])
          + (onezboz)*(I3[762] - AC1*I4[570])
          + (sixzboz)*(I3[735] - AC2*I4[549]);
*(vp++) = U0*I0[718]
          - U10*(I1[718] - I2[956])
          - U11*(I1[886] - I2[959])
          - U12*(I1[907] - I2[960])
          + (onezboz)*(I3[763] - AC1*I4[571])
          + (sixzboz)*(I3[736] - AC2*I4[550]);
*(vp++) = U0*I0[719]
          - U10*(I1[719] - I2[957])
          - U11*(I1[887] - I2[960])
          - U12*(I1[908] - I2[961])
          + (onezboz)*(I3[764] - AC1*I4[572])
          + (sixzboz)*(I3[737] - AC2*I4[551]);
*(vp++) = U0*I0[720]
          - U10*(I1[720] - I2[958])
          - U11*(I1[888] - I2[962])
          - U12*(I1[909] - I2[963])
          + (onezboz)*(I3[766] - AC1*I4[573])
          + (sixzboz)*(I3[739] - AC2*I4[552]);
*(vp++) = U0*I0[721]
          - U10*(I1[721] - I2[959])
          - U11*(I1[889] - I2[963])
          - U12*(I1[910] - I2[964])
          + (onezboz)*(I3[767] - AC1*I4[574])
          + (sixzboz)*(I3[740] - AC2*I4[553]);
*(vp++) = U0*I0[722]
          - U10*(I1[722] - I2[960])
          - U11*(I1[890] - I2[964])
          - U12*(I1[911] - I2[965])
          + (onezboz)*(I3[768] - AC1*I4[575])
          + (sixzboz)*(I3[741] - AC2*I4[554]);
*(vp++) = U0*I0[723]
          - U10*(I1[723] - I2[961])
          - U11*(I1[891] - I2[965])
          - U12*(I1[912] - I2[966])
          + (onezboz)*(I3[769] - AC1*I4[576])
          + (sixzboz)*(I3[742] - AC2*I4[555]);
*(vp++) = U0*I0[724]
          - U10*(I1[724] - I2[962])
          - U11*(I1[892] - I2[967])
          - U12*(I1[913] - I2[968])
          + (onezboz)*(I3[771] - AC1*I4[577])
          + (sixzboz)*(I3[744] - AC2*I4[556]);
*(vp++) = U0*I0[725]
          - U10*(I1[725] - I2[963])
          - U11*(I1[893] - I2[968])
          - U12*(I1[914] - I2[969])
          + (onezboz)*(I3[772] - AC1*I4[578])
          + (sixzboz)*(I3[745] - AC2*I4[557]);
*(vp++) = U0*I0[726]
          - U10*(I1[726] - I2[964])
          - U11*(I1[894] - I2[969])
          - U12*(I1[915] - I2[970])
          + (onezboz)*(I3[773] - AC1*I4[579])
          + (sixzboz)*(I3[746] - AC2*I4[558]);
*(vp++) = U0*I0[727]
          - U10*(I1[727] - I2[965])
          - U11*(I1[895] - I2[970])
          - U12*(I1[916] - I2[971])
          + (onezboz)*(I3[774] - AC1*I4[580])
          + (sixzboz)*(I3[747] - AC2*I4[559]);
*(vp++) = U0*I0[728]
          - U10*(I1[728] - I2[966])
          - U11*(I1[896] - I2[971])
          - U12*(I1[917] - I2[972])
          + (onezboz)*(I3[775] - AC1*I4[581])
          + (sixzboz)*(I3[748] - AC2*I4[560]);
*(vp++) = U0*I0[729]
          - U10*(I1[729] - I2[967])
          - U11*(I1[897] - I2[973])
          - U12*(I1[918] - I2[974])
          + (onezboz)*(I3[777] - AC1*I4[582])
          + (sixzboz)*(I3[750] - AC2*I4[561]);
*(vp++) = U0*I0[730]
          - U10*(I1[730] - I2[968])
          - U11*(I1[898] - I2[974])
          - U12*(I1[919] - I2[975])
          + (onezboz)*(I3[778] - AC1*I4[583])
          + (sixzboz)*(I3[751] - AC2*I4[562]);
*(vp++) = U0*I0[731]
          - U10*(I1[731] - I2[969])
          - U11*(I1[899] - I2[975])
          - U12*(I1[920] - I2[976])
          + (onezboz)*(I3[779] - AC1*I4[584])
          + (sixzboz)*(I3[752] - AC2*I4[563]);
*(vp++) = U0*I0[732]
          - U10*(I1[732] - I2[970])
          - U11*(I1[900] - I2[976])
          - U12*(I1[921] - I2[977])
          + (onezboz)*(I3[780] - AC1*I4[585])
          + (sixzboz)*(I3[753] - AC2*I4[564]);
*(vp++) = U0*I0[733]
          - U10*(I1[733] - I2[971])
          - U11*(I1[901] - I2[977])
          - U12*(I1[922] - I2[978])
          + (onezboz)*(I3[781] - AC1*I4[586])
          + (sixzboz)*(I3[754] - AC2*I4[565]);
*(vp++) = U0*I0[734]
          - U10*(I1[734] - I2[972])
          - U11*(I1[902] - I2[978])
          - U12*(I1[923] - I2[979])
          + (onezboz)*(I3[782] - AC1*I4[587])
          + (sixzboz)*(I3[755] - AC2*I4[566]);
*(vp++) = U0*I0[735]
          - U10*(I1[735] - I2[980])
          - U11*(I1[903] - I2[981])
          - U12*(I1[924] - I2[982])
          + (sevenzboz)*(I3[758] - AC2*I4[567]);
*(vp++) = U0*I0[736]
          - U10*(I1[736] - I2[981])
          - U11*(I1[904] - I2[983])
          - U12*(I1[925] - I2[984])
          + (sevenzboz)*(I3[760] - AC2*I4[568]);
*(vp++) = U0*I0[737]
          - U10*(I1[737] - I2[982])
          - U11*(I1[905] - I2[984])
          - U12*(I1[926] - I2[985])
          + (sevenzboz)*(I3[761] - AC2*I4[569]);
*(vp++) = U0*I0[738]
          - U10*(I1[738] - I2[983])
          - U11*(I1[906] - I2[986])
          - U12*(I1[927] - I2[987])
          + (sevenzboz)*(I3[763] - AC2*I4[570]);
*(vp++) = U0*I0[739]
          - U10*(I1[739] - I2[984])
          - U11*(I1[907] - I2[987])
          - U12*(I1[928] - I2[988])
          + (sevenzboz)*(I3[764] - AC2*I4[571]);
*(vp++) = U0*I0[740]
          - U10*(I1[740] - I2[985])
          - U11*(I1[908] - I2[988])
          - U12*(I1[929] - I2[989])
          + (sevenzboz)*(I3[765] - AC2*I4[572]);
*(vp++) = U0*I0[741]
          - U10*(I1[741] - I2[986])
          - U11*(I1[909] - I2[990])
          - U12*(I1[930] - I2[991])
          + (sevenzboz)*(I3[767] - AC2*I4[573]);
*(vp++) = U0*I0[742]
          - U10*(I1[742] - I2[987])
          - U11*(I1[910] - I2[991])
          - U12*(I1[931] - I2[992])
          + (sevenzboz)*(I3[768] - AC2*I4[574]);
*(vp++) = U0*I0[743]
          - U10*(I1[743] - I2[988])
          - U11*(I1[911] - I2[992])
          - U12*(I1[932] - I2[993])
          + (sevenzboz)*(I3[769] - AC2*I4[575]);
*(vp++) = U0*I0[744]
          - U10*(I1[744] - I2[989])
          - U11*(I1[912] - I2[993])
          - U12*(I1[933] - I2[994])
          + (sevenzboz)*(I3[770] - AC2*I4[576]);
*(vp++) = U0*I0[745]
          - U10*(I1[745] - I2[990])
          - U11*(I1[913] - I2[995])
          - U12*(I1[934] - I2[996])
          + (sevenzboz)*(I3[772] - AC2*I4[577]);
*(vp++) = U0*I0[746]
          - U10*(I1[746] - I2[991])
          - U11*(I1[914] - I2[996])
          - U12*(I1[935] - I2[997])
          + (sevenzboz)*(I3[773] - AC2*I4[578]);
*(vp++) = U0*I0[747]
          - U10*(I1[747] - I2[992])
          - U11*(I1[915] - I2[997])
          - U12*(I1[936] - I2[998])
          + (sevenzboz)*(I3[774] - AC2*I4[579]);
*(vp++) = U0*I0[748]
          - U10*(I1[748] - I2[993])
          - U11*(I1[916] - I2[998])
          - U12*(I1[937] - I2[999])
          + (sevenzboz)*(I3[775] - AC2*I4[580]);
*(vp++) = U0*I0[749]
          - U10*(I1[749] - I2[994])
          - U11*(I1[917] - I2[999])
          - U12*(I1[938] - I2[1000])
          + (sevenzboz)*(I3[776] - AC2*I4[581]);
*(vp++) = U0*I0[750]
          - U10*(I1[750] - I2[995])
          - U11*(I1[918] - I2[1001])
          - U12*(I1[939] - I2[1002])
          + (sevenzboz)*(I3[778] - AC2*I4[582]);
*(vp++) = U0*I0[751]
          - U10*(I1[751] - I2[996])
          - U11*(I1[919] - I2[1002])
          - U12*(I1[940] - I2[1003])
          + (sevenzboz)*(I3[779] - AC2*I4[583]);
*(vp++) = U0*I0[752]
          - U10*(I1[752] - I2[997])
          - U11*(I1[920] - I2[1003])
          - U12*(I1[941] - I2[1004])
          + (sevenzboz)*(I3[780] - AC2*I4[584]);
*(vp++) = U0*I0[753]
          - U10*(I1[753] - I2[998])
          - U11*(I1[921] - I2[1004])
          - U12*(I1[942] - I2[1005])
          + (sevenzboz)*(I3[781] - AC2*I4[585]);
*(vp++) = U0*I0[754]
          - U10*(I1[754] - I2[999])
          - U11*(I1[922] - I2[1005])
          - U12*(I1[943] - I2[1006])
          + (sevenzboz)*(I3[782] - AC2*I4[586]);
*(vp++) = U0*I0[755]
          - U10*(I1[755] - I2[1000])
          - U11*(I1[923] - I2[1006])
          - U12*(I1[944] - I2[1007])
          + (sevenzboz)*(I3[783] - AC2*I4[587]);
return vp;
}
